/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],le=function(V){for(var e=[],n=0,r=V.length;n<r;n++)e[n]=ce[V[n]];return e};define(ce[138],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=P,e.$hb=A,e.$ib=T,e.$jb=I,e.$kb=p,e.$mb=m,e.$nb=h,e.$ob=d,e.$pb=w,e.$qb=f;function n(g,v){const b=r(g,v);if(b!==-1)return g[b]}function r(g,v,b=g.length-1){for(let $=b;$>=0;$--){const k=g[$];if(v(k))return $}return-1}function P(g,v){const b=A(g,v);return b===-1?void 0:g[b]}function A(g,v,b=0,$=g.length){let k=b,E=$;for(;k<E;){const t=Math.floor((k+E)/2);v(g[t])?k=t+1:E=t}return k-1}function T(g,v){const b=I(g,v);return b===g.length?void 0:g[b]}function I(g,v,b=0,$=g.length){let k=b,E=$;for(;k<E;){const t=Math.floor((k+E)/2);v(g[t])?E=t:k=t+1}return k}function p(g,v,b=0,$=g.length){const k=I(g,v,b,$);return k===g.length?-1:k}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=A(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$lb=c;function m(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const k=g[$];v(k,b)>0&&(b=k)}return b}function h(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const k=g[$];v(k,b)>=0&&(b=k)}return b}function d(g,v){return m(g,(b,$)=>-v(b,$))}function w(g,v){if(g.length===0)return-1;let b=0;for(let $=1;$<g.length;$++){const k=g[$];v(k,g[b])>0&&(b=$)}return b}function f(g,v){for(const b of g){const $=v(b);if($!==void 0)return $}}}),define(ce[39],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ce[139],le([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=P,e.$e=A,e.$f=T;function r(p,c){const m=Object.create(null);for(const h of p){const d=c(h);let w=m[d];w||(w=m[d]=[]),w.push(h)}return m}function P(p,c){const m=[],h=[];for(const d of p)c.has(d)||m.push(d);for(const d of c)p.has(d)||h.push(d);return{removed:m,added:h}}function A(p,c){const m=[],h=[];for(const[d,w]of p)c.has(d)||m.push(w);for(const[d,w]of c)p.has(d)||h.push(w);return{removed:m,added:h}}function T(p,c){const m=new Set;for(const h of c)p.has(h)&&m.add(h);return m}class I{static{n=Symbol.toStringTag}constructor(c,m){this.b=m,this.a=new Map,this[n]="SetWithKey";for(const h of c)this.add(h)}get size(){return this.a.size}add(c){const m=this.b(c);return this.a.set(m,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,m){this.a.forEach(h=>c.call(m,h,h,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(ce[140],le([0,1,39]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.$lu=e.$ku=e.$ju=void 0;function r(p,c){const m=Math.pow(10,c);return Math.round(p*m)/m}class P{constructor(c,m,h,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.$ju=P;class A{constructor(c,m,h,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=c.a,f=Math.max(m,h,d),g=Math.min(m,h,d);let v=0,b=0;const $=(g+f)/2,k=f-g;if(k>0){switch(b=Math.min($<=.5?k/(2*$):k/(2-2*$),1),f){case m:v=(h-d)/k+(h<d?6:0);break;case h:v=(d-m)/k+2;break;case d:v=(m-h)/k+4;break}v*=60,v=Math.round(v)}return new A(v,b,$,w)}static i(c,m,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(m-c)*6*h:h<1/2?m:h<2/3?c+(m-c)*(2/3-h)*6:c}static toRGBA(c){const m=c.h/360,{s:h,l:d,a:w}=c;let f,g,v;if(h===0)f=g=v=d;else{const b=d<.5?d*(1+h):d+h-d*h,$=2*d-b;f=A.i($,b,m+1/3),g=A.i($,b,m),v=A.i($,b,m-1/3)}return new P(Math.round(f*255),Math.round(g*255),Math.round(v*255),w)}}e.$ku=A;class T{constructor(c,m,h,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,h=c.g/255,d=c.b/255,w=Math.max(m,h,d),f=Math.min(m,h,d),g=w-f,v=w===0?0:g/w;let b;return g===0?b=0:w===m?b=((h-d)/g%6+6)%6:w===h?b=(d-m)/g+2:b=(m-h)/g+4,new T(Math.round(b*60),v,w,c.a)}static toRGBA(c){const{h:m,s:h,v:d,a:w}=c,f=d*h,g=f*(1-Math.abs(m/60%2-1)),v=d-f;let[b,$,k]=[0,0,0];return m<60?(b=f,$=g):m<120?(b=g,$=f):m<180?($=f,k=g):m<240?($=g,k=f):m<300?(b=g,k=f):m<=360&&(b=f,k=g),b=Math.round((b+v)*255),$=Math.round(($+v)*255),k=Math.round((k+v)*255),new P(b,$,k,w)}}e.$lu=T;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this.i?this.i:A.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof P)this.rgba=c;else if(c instanceof A)this.i=c,this.rgba=A.toRGBA(c);else if(c instanceof T)this.j=c,this.rgba=T.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&P.equals(this.rgba,c.rgba)&&A.equals(this.hsla,c.hsla)&&T.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),m=I.k(this.rgba.g),h=I.k(this.rgba.b),d=.2126*c+.7152*m+.0722*h;return r(d,4)}static k(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h?(m+.05)/(h+.05):(h+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m>h}isDarkerThan(c){const m=this.getRelativeLuminance(),h=c.getRelativeLuminance();return m<h}lighten(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new P(m,h,d,w*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,h=this.rgba.a,d=m.a,w=h+d*(1-h);if(w<1e-6)return I.transparent;const f=this.rgba.r*h/w+m.r*d*(1-h)/w,g=this.rgba.g*h/w+m.g*d*(1-h)/w,v=this.rgba.b*h/w+m.b*d*(1-h)/w;return new I(new P(f,g,v,w))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:h,b:d,a:w}=this.rgba;return new I(new P(c.rgba.r-w*(c.rgba.r-m),c.rgba.g-w*(c.rgba.g-h),c.rgba.b-w*(c.rgba.b-d),1))}flatten(...c){const m=c.reduceRight((h,d)=>I.o(d,h));return I.o(this,m)}static o(c,m){const h=1-c.rgba.a;return new I(new P(h*m.rgba.r+c.rgba.a*c.rgba.r,h*m.rgba.g+c.rgba.a*c.rgba.g,h*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,m,h){if(c.isLighterThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(w-d)/w,c.lighten(h)}static getDarkerColor(c,m,h){if(c.isDarkerThan(m))return c;h=h||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return h=h*(d-w)/d,c.darken(h)}static{this.white=new I(new P(255,255,255,1))}static{this.black=new I(new P(0,0,0,1))}static{this.red=new I(new P(255,0,0,1))}static{this.blue=new I(new P(0,0,255,1))}static{this.green=new I(new P(0,255,0,1))}static{this.cyan=new I(new P(0,255,255,1))}static{this.lightgrey=new I(new P(211,211,211,1))}static{this.transparent=new I(new P(0,0,0,0))}}e.$mu=I,function(p){let c;(function(m){let h;(function(d){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}d.formatRGB=w;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}d.formatRGBA=f;function g(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}d.formatHSL=g;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}d.formatHSLA=v;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}d.formatHex=$;function k(i,o=!1){return o&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}d.formatHexA=k;function E(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}d.format=E;function t(i){const o=i.length;if(o===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new p(new P(s,a,l,1))}if(o===9){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),S=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new p(new P(s,a,l,S/255))}if(o===4){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3));return new p(new P(16*s+s,16*a+a,16*l+l))}if(o===5){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3)),S=u(i.charCodeAt(4));return new p(new P(16*s+s,16*a+a,16*l+l,(16*S+S)/255))}return null}d.parseHex=t;function u(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(h=m.CSS||(m.CSS={}))})(c=p.Format||(p.Format={}))}(I||(e.$mu=I={}))}),define(ce[54],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=r,e.$9h=P,e.$0h=A;function n(T){return(I,p,c)=>{let m=null,h=null;if(typeof c.value=="function"?(m="value",h=c.value):typeof c.get=="function"&&(m="get",h=c.get),!h)throw new Error("not supported");c[m]=T(h,p)}}function r(T,I,p){let c=null,m=null;if(typeof p.value=="function"?(c="value",m=p.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",m=p.get),!m)throw new Error("not supported");const h=`$memoize$${I}`;p[c]=function(...d){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[h]}}function P(T,I,p){return n((c,m)=>{const h=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...w){this[d]||(this[d]=p?p():void 0),clearTimeout(this[h]),I&&(this[d]=I(this[d],...w),w=[this[d]]),this[h]=setTimeout(()=>{c.apply(this,w),this[d]=p?p():void 0},T)}})}function A(T,I,p){return n((c,m)=>{const h=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,w=`$throttle$lastRun$${m}`,f=`$throttle$pending$${m}`;return function(...g){if(this[d]||(this[d]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...g)),this[f])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0):(this[f]=!0,this[h]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0},v-Date.now()))}})}}),define(ce[15],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=P,e.$Y=A,e.$Z=T,e.$1=I,e.$2=p,e.$3=m,e.$5=d,e.$6=w,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?E.isErrorNoTelemetry(i)?new E(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=n,e.$V=new n;function r(u){e.$V.setUnexpectedErrorHandler(u)}function P(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(u){m(u)||e.$V.onUnexpectedError(u)}function T(u){m(u)||e.$V.onUnexpectedExternalError(u)}function I(u){if(u instanceof Error){const{name:i,message:o}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:E.isErrorNoTelemetry(u)}}return u}function p(u){let i;return u.noTelemetry?i=new E:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const c="Canceled";function m(u){return u instanceof h?!0:u instanceof Error&&u.name===c&&u.message===c}class h extends Error{constructor(){super(c),this.name=this.message}}e.$4=h;function d(){const u=new Error(c);return u.name=u.message,u}function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=k;class E extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof E)return i;const o=new E;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=E;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(ce[21],le([0,1,15,138]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=P,e.$sb=A,e.$tb=T,e.$ub=I,e.$vb=p,e.$wb=c,e.$xb=m,e.$yb=h,e.$zb=d,e.$Ab=w,e.$Bb=f,e.$Cb=g,e.$Db=v,e.top=b,e.$Fb=$,e.$Gb=E,e.$Hb=t,e.$Ib=u,e.$Jb=i,e.$Kb=o,e.$Lb=s,e.$Mb=a,e.$Nb=l,e.$Ob=S,e.$Pb=y,e.$Qb=D,e.$Rb=L,e.$Sb=R,e.$Tb=O,e.$Ub=M,e.$Vb=x,e.$Wb=X,e.$Xb=K,e.$Yb=fe,e.$Zb=H,e.$1b=J,e.$2b=U,e.$3b=Z,e.$4b=B,e.$5b=Y,e.$6b=oe,e.$9b=re;function P(W,z=0){return W[W.length-(1+z)]}function A(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function T(W,z,te=(ee,q)=>ee===q){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let ee=0,q=W.length;ee<q;ee++)if(!te(W[ee],z[ee]))return!1;return!0}function I(W,z){const te=W.length-1;z<te&&(W[z]=W[te]),W.pop()}function p(W,z,te){return c(W.length,ee=>te(W[ee],z))}function c(W,z){let te=0,ee=W-1;for(;te<=ee;){const q=(te+ee)/2|0,ne=z(q);if(ne<0)te=q+1;else if(ne>0)ee=q-1;else return q}return-(te+1)}function m(W,z,te){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const ee=z[Math.floor(z.length*Math.random())],q=[],ne=[],de=[];for(const me of z){const we=te(me,ee);we<0?q.push(me):we>0?ne.push(me):de.push(me)}return W<q.length?m(W,q,te):W<q.length+de.length?de[0]:m(W-(q.length+de.length),ne,te)}function h(W,z){const te=[];let ee;for(const q of W.slice(0).sort(z))!ee||z(ee[0],q)!==0?(ee=[q],te.push(ee)):ee.push(q);return te}function*d(W,z){let te,ee;for(const q of W)ee!==void 0&&z(ee,q)?te.push(q):(te&&(yield te),te=[q]),ee=q;te&&(yield te)}function w(W,z){for(let te=0;te<=W.length;te++)z(te===0?void 0:W[te-1],te===W.length?void 0:W[te])}function f(W,z){for(let te=0;te<W.length;te++)z(te===0?void 0:W[te-1],W[te],te+1===W.length?void 0:W[te+1])}function g(W,z,te){const ee=[];function q(me,we,Ie){if(we===0&&Ie.length===0)return;const We=ee[ee.length-1];We&&We.start+We.deleteCount===me?(We.deleteCount+=we,We.toInsert.push(...Ie)):ee.push({start:me,deleteCount:we,toInsert:Ie})}let ne=0,de=0;for(;;){if(ne===W.length){q(ne,0,z.slice(de));break}if(de===z.length){q(ne,W.length-ne,[]);break}const me=W[ne],we=z[de],Ie=te(me,we);Ie===0?(ne+=1,de+=1):Ie<0?(q(ne,1,[]),ne+=1):Ie>0&&(q(ne,0,[we]),de+=1)}return ee}function v(W,z,te){const ee=g(W,z,te),q=[],ne=[];for(const de of ee)q.push(...W.slice(de.start,de.start+de.deleteCount)),ne.push(...de.toInsert);return{removed:q,added:ne}}function b(W,z,te){if(te===0)return[];const ee=W.slice(0,te).sort(z);return k(W,z,ee,te,W.length),ee}function $(W,z,te,ee,q){return te===0?Promise.resolve([]):new Promise((ne,de)=>{(async()=>{const me=W.length,we=W.slice(0,te).sort(z);for(let Ie=te,We=Math.min(te+ee,me);Ie<me;Ie=We,We=Math.min(We+ee,me)){if(Ie>te&&await new Promise(Oe=>setTimeout(Oe)),q&&q.isCancellationRequested)throw new n.$4;k(W,z,we,Ie,We)}return we})().then(ne,de)})}function k(W,z,te,ee,q){for(const ne=te.length;ee<q;ee++){const de=W[ee];if(z(de,te[ne-1])<0){te.pop();const me=(0,r.$jb)(te,we=>z(de,we)<0);te.splice(me,0,de)}}}function E(W){return W.filter(z=>!!z)}function t(W){let z=0;for(let te=0;te<W.length;te++)W[te]&&(W[z]=W[te],z+=1);W.length=z}function u(W,z,te){W.splice(te,0,W.splice(z,1)[0])}function i(W){return!Array.isArray(W)||W.length===0}function o(W){return Array.isArray(W)&&W.length>0}function s(W,z=te=>te){const te=new Set;return W.filter(ee=>{const q=z(ee);return te.has(q)?!1:(te.add(q),!0)})}function a(W){const z=new Set;return te=>{const ee=W(te);return z.has(ee)?!1:(z.add(ee),!0)}}function l(W,z){return W.length>0?W[0]:z}function S(W,z){return W.length>0?W[W.length-1]:z}function y(W,z,te=(ee,q)=>ee===q){let ee=0;for(let q=0,ne=Math.min(W.length,z.length);q<ne&&te(W[q],z[q]);q++)ee++;return ee}function D(W,z){let te=typeof z=="number"?W:0;typeof z=="number"?te=W:(te=0,z=W);const ee=[];if(te<=z)for(let q=te;q<z;q++)ee.push(q);else for(let q=te;q>z;q--)ee.push(q);return ee}function L(W,z,te){return W.reduce((ee,q)=>(ee[z(q)]=te?te(q):q,ee),Object.create(null))}function R(W,z){return W.push(z),()=>O(W,z)}function O(W,z){const te=W.indexOf(z);if(te>-1)return W.splice(te,1),z}function M(W,z,te){const ee=W.slice(0,z),q=W.slice(z);return ee.concat(te,q)}function x(W,z){let te;if(typeof z=="number"){let ee=z;te=()=>{const q=Math.sin(ee++)*179426549;return q-Math.floor(q)}}else te=Math.random;for(let ee=W.length-1;ee>0;ee-=1){const q=Math.floor(te()*(ee+1)),ne=W[ee];W[ee]=W[q],W[q]=ne}}function X(W,z){const te=W.indexOf(z);te>-1&&(W.splice(te,1),W.unshift(z))}function K(W,z){const te=W.indexOf(z);te>-1&&(W.splice(te,1),W.push(z))}function fe(W,z){for(const te of z)W.push(te)}function H(W,z){return Array.isArray(W)?W.map(z):z(W)}function J(W){return Array.isArray(W)?W:[W]}function U(W){return W[Math.floor(Math.random()*W.length)]}function Z(W,z,te){const ee=j(W,z),q=W.length,ne=te.length;W.length=q+ne;for(let de=q-1;de>=ee;de--)W[de+ne]=W[de];for(let de=0;de<ne;de++)W[de+ee]=te[de]}function B(W,z,te,ee){const q=j(W,z);let ne=W.splice(q,te);return ne===void 0&&(ne=[]),Z(W,q,ee),ne}function j(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var C;(function(W){function z(ne){return ne<0}W.isLessThan=z;function te(ne){return ne<=0}W.isLessThanOrEqual=te;function ee(ne){return ne>0}W.isGreaterThan=ee;function q(ne){return ne===0}W.isNeitherLessOrGreaterThan=q,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(C||(e.CompareResult=C={}));function Y(W,z){return(te,ee)=>z(W(te),W(ee))}function oe(...W){return(z,te)=>{for(const ee of W){const q=ee(z,te);if(!C.isNeitherLessOrGreaterThan(q))return q}return C.neitherLessOrGreaterThan}}const G=(W,z)=>W-z;e.$7b=G;const ue=(W,z)=>(0,e.$7b)(W?1:0,z?1:0);e.$8b=ue;function re(W){return(z,te)=>-W(z,te)}class Q{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let te=this.c;for(;te<this.g.length&&z(this.g[te]);)te++;const ee=te===this.c?null:this.g.slice(this.c,te);return this.c=te,ee}takeFromEndWhile(z){let te=this.d;for(;te>=0&&z(this.g[te]);)te--;const ee=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const te=this.g.slice(this.c,this.c+z);return this.c+=z,te}}e.$0b=Q;class F{static{this.empty=new F(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(te=>(z(te),!0))}toArray(){const z=[];return this.iterate(te=>(z.push(te),!0)),z}filter(z){return new F(te=>this.iterate(ee=>z(ee)?te(ee):!0))}map(z){return new F(te=>this.iterate(ee=>te(z(ee))))}some(z){let te=!1;return this.iterate(ee=>(te=z(ee),!te)),te}findFirst(z){let te;return this.iterate(ee=>z(ee)?(te=ee,!1):!0),te}findLast(z){let te;return this.iterate(ee=>(z(ee)&&(te=ee),!0)),te}findLastMaxBy(z){let te,ee=!0;return this.iterate(q=>((ee||C.isGreaterThan(z(q,te)))&&(ee=!1,te=q),!0)),te}}e.$$b=F;class N{constructor(z){this.c=z}static createSortPermutation(z,te){const ee=Array.from(z.keys()).sort((q,ne)=>te(z[q],z[ne]));return new N(ee)}apply(z){return z.map((te,ee)=>z[this.c[ee]])}inverse(){const z=this.c.slice();for(let te=0;te<this.c.length;te++)z[this.c[te]]=te;return new N(z)}}e.$_b=N}),define(ce[141],le([0,1,15]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$dd=P,e.$ed=A,e.$fd=T,e.$gd=I,e.$hd=p;function r(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function P(c,m="Unreachable"){throw new Error(m)}function A(c,m="unexpected state"){if(!c)throw new n.$bb(`Assertion Failed: ${m}`)}function T(c){c||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function p(c,m){let h=0;for(;h<c.length-1;){const d=c[h],w=c[h+1];if(!m(d,w))return!1;h++}return!0}}),define(ce[89],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,P){const A=this;let T=!1,I;return function(){if(T)return I;if(T=!0,P)try{I=r.apply(A,arguments)}finally{P()}else I=r.apply(A,arguments);return I}}}),define(ce[77],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function P(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=P;const A=Object.freeze([]);function T(){return A}r.empty=T;function*I(i){yield i}r.single=I;function p(i){return P(i)?i:I(i)}r.wrap=p;function c(i){return i||A}r.from=c;function*m(i){for(let o=i.length-1;o>=0;o--)yield i[o]}r.reverse=m;function h(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=h;function d(i){return i[Symbol.iterator]().next().value}r.first=d;function w(i,o){let s=0;for(const a of i)if(o(a,s++))return!0;return!1}r.some=w;function f(i,o){for(const s of i)if(o(s))return s}r.find=f;function*g(i,o){for(const s of i)o(s)&&(yield s)}r.filter=g;function*v(i,o){let s=0;for(const a of i)yield o(a,s++)}r.map=v;function*b(i,o){let s=0;for(const a of i)yield*o(a,s++)}r.flatMap=b;function*$(...i){for(const o of i)yield*o}r.concat=$;function k(i,o,s){let a=s;for(const l of i)a=o(a,l);return a}r.reduce=k;function*E(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}r.slice=E;function t(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const a=i[Symbol.iterator]();for(let l=0;l<o;l++){const S=a.next();if(S.done)return[s,r.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=t;async function u(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}r.asyncToArray=u})(n||(e.Iterable=n={}))}),define(ce[43],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Un=T,e.$Vn=h,e.$Wn=d,e.$Xn=w,e.$Yn=f,e.$Zn=g,e.$1n=v,e.$2n=b,e.$3n=$,e.$4n=k,e.$5n=E;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(t,u=!1){let i=0;const o=t.length;let s="",a=0,l=r.Unknown,S=n.None;function y(X){let K=0,fe=0;for(;K<X;){const H=t.charCodeAt(i);if(H>=m._0&&H<=m._9)fe=fe*16+H-m._0;else if(H>=m.A&&H<=m.F)fe=fe*16+H-m.A+10;else if(H>=m.a&&H<=m.f)fe=fe*16+H-m.a+10;else break;i++,K++}return K<X&&(fe=-1),fe}function D(X){i=X,s="",a=0,l=r.Unknown,S=n.None}function L(){const X=i;if(t.charCodeAt(i)===m._0)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===m.dot)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return S=n.UnexpectedEndOfNumber,t.substring(X,i);let K=i;if(i<t.length&&(t.charCodeAt(i)===m.E||t.charCodeAt(i)===m.e))if(i++,(i<t.length&&t.charCodeAt(i)===m.plus||t.charCodeAt(i)===m.minus)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;K=i}else S=n.UnexpectedEndOfNumber;return t.substring(X,K)}function R(){let X="",K=i;for(;;){if(i>=o){X+=t.substring(K,i),S=n.UnexpectedEndOfString;break}const fe=t.charCodeAt(i);if(fe===m.doubleQuote){X+=t.substring(K,i),i++;break}if(fe===m.backslash){if(X+=t.substring(K,i),i++,i>=o){S=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case m.doubleQuote:X+='"';break;case m.backslash:X+="\\";break;case m.slash:X+="/";break;case m.b:X+="\b";break;case m.f:X+="\f";break;case m.n:X+=`
`;break;case m.r:X+="\r";break;case m.t:X+="	";break;case m.u:{const J=y(4);J>=0?X+=String.fromCharCode(J):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}K=i;continue}if(fe>=0&&fe<=31)if(p(fe)){X+=t.substring(K,i),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;i++}return X}function O(){if(s="",S=n.None,a=i,i>=o)return a=o,l=r.EOF;let X=t.charCodeAt(i);if(I(X)){do i++,s+=String.fromCharCode(X),X=t.charCodeAt(i);while(I(X));return l=r.Trivia}if(p(X))return i++,s+=String.fromCharCode(X),X===m.carriageReturn&&t.charCodeAt(i)===m.lineFeed&&(i++,s+=`
`),l=r.LineBreakTrivia;switch(X){case m.openBrace:return i++,l=r.OpenBraceToken;case m.closeBrace:return i++,l=r.CloseBraceToken;case m.openBracket:return i++,l=r.OpenBracketToken;case m.closeBracket:return i++,l=r.CloseBracketToken;case m.colon:return i++,l=r.ColonToken;case m.comma:return i++,l=r.CommaToken;case m.doubleQuote:return i++,s=R(),l=r.StringLiteral;case m.slash:{const K=i-1;if(t.charCodeAt(i+1)===m.slash){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return s=t.substring(K,i),l=r.LineCommentTrivia}if(t.charCodeAt(i+1)===m.asterisk){i+=2;const fe=o-1;let H=!1;for(;i<fe;){if(t.charCodeAt(i)===m.asterisk&&t.charCodeAt(i+1)===m.slash){i+=2,H=!0;break}i++}return H||(i++,S=n.UnexpectedEndOfComment),s=t.substring(K,i),l=r.BlockCommentTrivia}return s+=String.fromCharCode(X),i++,l=r.Unknown}case m.minus:if(s+=String.fromCharCode(X),i++,i===o||!c(t.charCodeAt(i)))return l=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return s+=L(),l=r.NumericLiteral;default:for(;i<o&&M(X);)i++,X=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(X),i++,l=r.Unknown}}function M(X){if(I(X)||p(X))return!1;switch(X){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function x(){let X;do X=O();while(X>=r.LineCommentTrivia&&X<=r.Trivia);return X}return{setPosition:D,getPosition:()=>i,scan:u?x:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>S}}function I(t){return t===m.space||t===m.tab||t===m.verticalTab||t===m.formFeed||t===m.nonBreakingSpace||t===m.ogham||t>=m.enQuad&&t<=m.zeroWidthSpace||t===m.narrowNoBreakSpace||t===m.mathematicalSpace||t===m.ideographicSpace||t===m.byteOrderMark}function p(t){return t===m.lineFeed||t===m.carriageReturn||t===m.lineSeparator||t===m.paragraphSeparator}function c(t){return t>=m._0&&t<=m._9}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function h(t,u){const i=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(y,D,L,R){a.value=y,a.offset=D,a.length=L,a.type=R,a.colonOffset=void 0,s=a}try{k(t,{onObjectBegin:(y,D)=>{if(u<=y)throw o;s=void 0,l=u>y,i.push("")},onObjectProperty:(y,D,L)=>{if(u<D||(S(y,D,L,"property"),i[i.length-1]=y,u<=D+L))throw o},onObjectEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onArrayBegin:(y,D)=>{if(u<=y)throw o;s=void 0,i.push(0)},onArrayEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onLiteralValue:(y,D,L)=>{if(u<D||(S(y,D,L,E(y)),u<=D+L))throw o},onSeparator:(y,D,L)=>{if(u<=D)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=D,l=!1,s=void 0;else if(y===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let D=0;for(let L=0;D<y.length&&L<i.length;L++)if(y[D]===i[L]||y[D]==="*")D++;else if(y[D]!=="**")return!1;return D===y.length}}}function d(t,u=[],i=A.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return k(t,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i),s[0]}function w(t,u=[],i=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}k(t,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,D,L)=>{o=a({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:D,length:L,parent:o})},onObjectEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onArrayBegin:(y,D)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onLiteralValue:(y,D,L)=>{a({type:E(y),offset:D,length:L,parent:o,value:y}),s(D+L)},onSeparator:(y,D,L)=>{o.type==="property"&&(y===":"?o.colonOffset=D:y===","&&s(D))},onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i);const S=o.children[0];return S&&delete S.parent,S}function f(t,u){if(!t)return;let i=t;for(const o of u)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function g(t){if(!t.parent||!t.parent.children)return[];const u=g(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const u=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(u[i.children[0].value]=v(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}function $(t,u,i=!1){if(b(t,u,i)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=u;s++){const a=$(o[s],u,i);if(a)return a}return t}}function k(t,u,i=A.DEFAULT){const o=T(t,!1);function s(Y){return Y?()=>Y(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(Y){return Y?oe=>Y(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),S=a(u.onObjectProperty),y=s(u.onObjectEnd),D=s(u.onArrayBegin),L=s(u.onArrayEnd),R=a(u.onLiteralValue),O=a(u.onSeparator),M=s(u.onComment),x=a(u.onError),X=i&&i.disallowComments,K=i&&i.allowTrailingComma;function fe(){for(;;){const Y=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:H(P.InvalidUnicode);break;case n.InvalidEscapeCharacter:H(P.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:H(P.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:X||H(P.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:H(P.UnexpectedEndOfString);break;case n.InvalidCharacter:H(P.InvalidCharacter);break}switch(Y){case r.LineCommentTrivia:case r.BlockCommentTrivia:X?H(P.InvalidCommentToken):M();break;case r.Unknown:H(P.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return Y}}}function H(Y,oe=[],G=[]){if(x(Y),oe.length+G.length>0){let ue=o.getToken();for(;ue!==r.EOF;){if(oe.indexOf(ue)!==-1){fe();break}else if(G.indexOf(ue)!==-1)break;ue=fe()}}}function J(Y){const oe=o.getTokenValue();return Y?R(oe):S(oe),fe(),!0}function U(){switch(o.getToken()){case r.NumericLiteral:{let Y=0;try{Y=JSON.parse(o.getTokenValue()),typeof Y!="number"&&(H(P.InvalidNumberFormat),Y=0)}catch{H(P.InvalidNumberFormat)}R(Y);break}case r.NullKeyword:R(null);break;case r.TrueKeyword:R(!0);break;case r.FalseKeyword:R(!1);break;default:return!1}return fe(),!0}function Z(){return o.getToken()!==r.StringLiteral?(H(P.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(J(!1),o.getToken()===r.ColonToken?(O(":"),fe(),C()||H(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):H(P.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function B(){l(),fe();let Y=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(Y||H(P.ValueExpected,[],[]),O(","),fe(),o.getToken()===r.CloseBraceToken&&K)break}else Y&&H(P.CommaExpected,[],[]);Z()||H(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),Y=!0}return y(),o.getToken()!==r.CloseBraceToken?H(P.CloseBraceExpected,[r.CloseBraceToken],[]):fe(),!0}function j(){D(),fe();let Y=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(Y||H(P.ValueExpected,[],[]),O(","),fe(),o.getToken()===r.CloseBracketToken&&K)break}else Y&&H(P.CommaExpected,[],[]);C()||H(P.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),Y=!0}return L(),o.getToken()!==r.CloseBracketToken?H(P.CloseBracketExpected,[r.CloseBracketToken],[]):fe(),!0}function C(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return B();case r.StringLiteral:return J(!0);default:return U()}}return fe(),o.getToken()===r.EOF?i.allowEmptyContent?!0:(H(P.ValueExpected,[],[]),!1):C()?(o.getToken()!==r.EOF&&H(P.EndOfFileExpected,[],[]),!0):(H(P.ValueExpected,[],[]),!1)}function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,43]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=r,e.$7n=P,e.$8n=I,e.$9n=p;function r(c,m,h){let d,w,f,g,v;if(m){for(g=m.offset,v=g+m.length,f=g;f>0&&!p(c,f-1);)f--;let S=v;for(;S<c.length&&!p(c,S);)S++;w=c.substring(f,S),d=T(w,h)}else w=c,d=0,f=0,g=0,v=c.length;const b=I(h,c);let $=!1,k=0,E;h.insertSpaces?E=A(" ",h.tabSize||4):E="	";const t=(0,n.$Un)(w,!1);let u=!1;function i(){return b+A(E,d+k)}function o(){let S=t.scan();for($=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)$=$||S===n.SyntaxKind.LineBreakTrivia,S=t.scan();return u=S===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,S}const s=[];function a(S,y,D){!u&&y<v&&D>g&&c.substring(y,D)!==S&&s.push({offset:y,length:D-y,content:S})}let l=o();if(l!==n.SyntaxKind.EOF){const S=t.getTokenOffset()+f,y=A(E,d);a(y,f,S)}for(;l!==n.SyntaxKind.EOF;){let S=t.getTokenOffset()+t.getTokenLength()+f,y=o(),D="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const R=t.getTokenOffset()+f;a(" ",S,R),S=t.getTokenOffset()+t.getTokenLength()+f,D=y===n.SyntaxKind.LineCommentTrivia?i():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(k--,D=i());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(k--,D=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:k++,D=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:D=i();break;case n.SyntaxKind.BlockCommentTrivia:$?D=i():D=" ";break;case n.SyntaxKind.ColonToken:D=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){D="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?D=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(u=!0);break;case n.SyntaxKind.Unknown:u=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(D=i())}const L=t.getTokenOffset()+f;a(D,S,L),l=y}return s}function P(c,m){const h=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?h.replace(/\r\n|\r|\n/g,m.eol):h}function A(c,m){let h="";for(let d=0;d<m;d++)h+=c;return h}function T(c,m){let h=0,d=0;const w=m.tabSize||4;for(;h<c.length;){const f=c.charAt(h);if(f===" ")d++;else if(f==="	")d+=w;else break;h++}return Math.floor(d/w)}function I(c,m){for(let h=0;h<m.length;h++){const d=m.charAt(h);if(d==="\r")return h+1<m.length&&m.charAt(h+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return c&&c.eol||`
`}function p(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(ce[107],le([0,1,43,142]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=P,e.$$n=A,e.$_n=T,e.$ao=I,e.$bo=p;function P(c,m,h){return A(c,m,void 0,h)}function A(c,m,h,d,w){const f=m.slice(),g=[],v=(0,n.$Xn)(c,g);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$Yn)(v,f),b===void 0&&h!==void 0);)typeof $=="string"?h={[$]:h}:h=[h];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const k=(0,n.$Yn)(b,[$]);if(k!==void 0)if(h===void 0){if(!k.parent)throw new Error("Malformed AST");const E=b.children.indexOf(k.parent);let t,u=k.parent.offset+k.parent.length;if(E>0){const i=b.children[E-1];t=i.offset+i.length}else t=b.offset+1,b.children.length>1&&(u=b.children[1].offset);return T(c,{offset:t,length:u-t,content:""},d)}else return T(c,{offset:k.offset,length:k.length,content:JSON.stringify(h)},d);else{if(h===void 0)return[];const E=`${JSON.stringify($)}: ${JSON.stringify(h)}`,t=w?w(b.children.map(i=>i.children[0].value)):b.children.length;let u;if(t>0){const i=b.children[t-1];u={offset:i.offset+i.length,length:0,content:","+E}}else b.children.length===0?u={offset:b.offset+1,length:0,content:E}:u={offset:b.offset+1,length:0,content:E+","};return T(c,u,d)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(h!==void 0){const k=`${JSON.stringify(h)}`;let E;if(b.children.length===0||$===0)E={offset:b.offset+1,length:0,content:b.children.length===0?k:k+","};else{const t=$===-1||$>b.children.length?b.children.length:$,u=b.children[t-1];E={offset:u.offset+u.length,length:0,content:","+k}}return T(c,E,d)}else{const k=$,E=b.children[k];let t;if(b.children.length===1)t={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===k){const u=b.children[k-1],i=u.offset+u.length,o=b.offset+b.length;t={offset:i,length:o-2-i,content:""}}else t={offset:E.offset,length:b.children[k+1].offset-E.offset,content:""};return T(c,t,d)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return h===void 0?[]:T(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},d)}function T(c,m,h){let d=I(c,m),w=m.offset,f=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;w>0&&!(0,r.$9n)(d,w-1);)w--;for(;f<d.length&&!(0,r.$9n)(d,f);)f++}const g=(0,r.$6n)(d,{offset:w,length:f-w},h);for(let b=g.length-1;b>=0;b--){const $=g[b];d=I(d,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(d.length-f)-w;return[{offset:w,length:v,content:d.substring(w,f)}]}function I(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function p(c,m){const h=m.slice(0).sort((w,f)=>{const g=w.offset-f.offset;return g===0?w.length-f.length:g});let d=c.length;for(let w=h.length-1;w>=0;w--){const f=h[w];if(f.offset+f.length<=d)c=I(c,f);else throw new Error("Overlapping edit");d=f.offset}return c}}),define(ce[143],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=n;function n(A){let T=!1;const I=new Map,p=new Map;if(P(A,g=>{if(A===g)return!0;const v=JSON.stringify(g);if(v.length<30)return!0;const b=I.get(v);if(!b){const $={schemas:[g]};return I.set(v,$),p.set(g,$),!0}return b.schemas.push(g),p.set(g,b),T=!0,!1}),I.clear(),!T)return JSON.stringify(A);let m="$defs";for(;A.hasOwnProperty(m);)m+="_";const h=[];function d(g){return JSON.stringify(g,(v,b)=>{if(b!==g){const $=p.get(b);if($&&$.schemas.length>1)return $.id||($.id=`_${h.length}`,h.push($.schemas[0])),{$ref:`#/${m}/${$.id}`}}return b})}const w=d(A),f=[];for(let g=0;g<h.length;g++)f.push(`"_${g}":${d(h[g])}`);return f.length?`${w.substring(0,w.length-1)},"${m}":{${f.join(",")}}}`:w}function r(A){return typeof A=="object"&&A!==null}function P(A,T){if(!A||typeof A!="object")return;const I=(...w)=>{for(const f of w)r(f)&&h.push(f)},p=(...w)=>{for(const f of w)if(r(f))for(const g in f){const v=f[g];r(v)&&h.push(v)}},c=(...w)=>{for(const f of w)if(Array.isArray(f))for(const g of f)r(g)&&h.push(g)},m=w=>{if(Array.isArray(w))for(const f of w)r(f)&&h.push(f);else r(w)&&h.push(w)},h=[A];let d=h.pop();for(;d;)T(d)&&(I(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),p(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),c(d.anyOf,d.allOf,d.oneOf,d.prefixItems),m(d.items)),d=h.pop()}}),function(){function V(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(P){return P.replace(e,function(A,T,I,p,c,m){if(p)return"";if(c){const h=c.length;return c[h-1]===`
`?c[h-2]==="\r"?`\r
`:`
`:""}else return m?A.substring(1):A})}function r(P){const A=n(P);try{return JSON.parse(A)}catch{const I=A.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:n,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[65],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(ce[108],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(A){this.element=A,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let A=this.a;for(;A!==n.Undefined;){const T=A.next;A.prev=n.Undefined,A.next=n.Undefined,A=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const I=new n(A);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==n.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==n.Undefined&&A.next!==n.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===n.Undefined&&A.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):A.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):A.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==n.Undefined;)yield A.element,A=A.next}}e.$4c=r}),define(ce[31],le([0,1]),function(V,e){"use strict";var n,r,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=A,e.$xc=T,e.$yc=I,e.$Hc=E;function A(t,u,i){let o=t.get(u);return o===void 0&&(o=i,t.set(u,o)),o}function T(t){const u=[];return t.forEach((i,o)=>{u.push(`${o} => ${i}`)}),`Map(${t.size}) {${u.join(", ")}}`}function I(t){const u=[];return t.forEach(i=>{u.push(i)}),`Set(${t.size}) {${u.join(", ")}}`}class p{constructor(u,i){this.uri=u,this.value=i}}function c(t){return Array.isArray(t)}class m{static{this.c=u=>u.toString()}constructor(u,i){if(this[n]="ResourceMap",u instanceof m)this.d=new Map(u.d),this.e=i??m.c;else if(c(u)){this.d=new Map,this.e=i??m.c;for(const[o,s]of u)this.set(o,s)}else this.d=new Map,this.e=u??m.c}set(u,i){return this.d.set(this.e(u),new p(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[o,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=m;class h{constructor(u,i){this[r]="ResourceSet",!u||typeof u=="function"?this.c=new m(u):(this.c=new m(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((o,s)=>u.call(i,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=h;var d;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class w{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=d.None){const o=this.c.get(u);if(o)return i!==d.None&&this.m(o,i),o.value}set(u,i,o=d.None){let s=this.c.get(u);if(s)s.value=i,o!==d.None&&this.m(s,o);else{switch(s={key:u,value:i,next:void 0,previous:void 0},o){case d.None:this.k(s);break;case d.AsOld:this.j(s);break;case d.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const o=this.g;let s=this.d;for(;s;){if(i?u.bind(i)(s.value,s.key,this):u(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.next,o--;this.d=i,this.f=o,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.previous,o--;this.e=i,this.f=o,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,o=u.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this.d)return;const o=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===d.AsNew){if(u===this.e)return;const o=u.next,s=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,o)=>{u.push([o,i])}),u}fromJSON(u){this.clear();for(const[i,o]of u)this.set(i,o)}}e.$Bc=w;class f extends w{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends f{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=g;class v extends f{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=v;class b{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=b;class ${constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,o]of u)this.set(i,o)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((o,s)=>{u.call(i,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class k{constructor(){this.c=new Map}add(u,i){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(i)}delete(u,i){const o=this.c.get(u);o&&(o.delete(i),o.size===0&&this.c.delete(u))}forEach(u,i){const o=this.c.get(u);o&&o.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=k;function E(t,u){if(t===u)return!0;if(t.size!==u.size)return!1;for(const[i,o]of t)if(!u.has(i)||u.get(i)!==o)return!1;for(const[i]of u)if(!t.has(i))return!1;return!0}}),define(ce[2],le([0,1,21,139,31,89,77]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=m,e.$Kc=h,e.$Lc=d,e.$Mc=g,e.$Nc=v,e.$Oc=b,e.$Pc=$,e.$Qc=k,e.$Rc=E,e.$2c=D;const I=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(O){let M=this.b.get(O);return M||(M={parent:null,source:null,isSingleton:!1,value:O,idx:c.a++},this.b.set(O,M)),M}trackDisposable(O){const M=this.c(O);M.source||(M.source=new Error().stack)}setParent(O,M){const x=this.c(O);x.parent=M}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,M){const x=M.get(O);if(x)return x;const X=O.parent?this.f(this.c(O.parent),M):O;return M.set(O,X),X}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,O).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(O=10,M){let x;if(M)x=M;else{const J=new Map,U=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,J).isSingleton);if(U.length===0)return;const Z=new Set(U.map(B=>B.value));if(x=U.filter(B=>!(B.parent&&Z.has(B.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function X(J){function U(B,j){for(;B.length>0&&j.some(C=>typeof C=="string"?C===B[0]:B[0].match(C));)B.shift()}const Z=J.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return U(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const K=new P.$Gc;for(const J of x){const U=X(J);for(let Z=0;Z<=U.length;Z++)K.add(U.slice(0,Z).join(`
`),J)}x.sort((0,n.$5b)(J=>J.idx,n.$7b));let fe="",H=0;for(const J of x.slice(0,O)){H++;const U=X(J),Z=[];for(let B=0;B<U.length;B++){let j=U[B];j=`(shared with ${K.get(U.slice(0,B+1).join(`
`)).size}/${x.length} leaks) at ${j}`;const Y=K.get(U.slice(0,B).join(`
`)),oe=(0,r.$c)([...Y].map(G=>X(G)[B]),G=>G);delete oe[U[B]];for(const[G,ue]of Object.entries(oe))Z.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${G}`);Z.unshift(j)}fe+=`


==================== Leaking disposable ${H}/${x.length}: ${J.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return x.length>O&&(fe+=`


... and ${x.length-O} more leaking disposables

`),{leaks:x,details:fe}}}e.$Ic=c;function m(R){p=R}if(I){const R="__is_disposable_tracked__";m(new class{trackDisposable(O){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[R]||console.log(M)},3e3)}setParent(O,M){if(O&&O!==u.None)try{O[R]=!0}catch{}}markAsDisposed(O){if(O&&O!==u.None)try{O[R]=!0}catch{}}markAsSingleton(O){}})}function h(R){return p?.trackDisposable(R),R}function d(R){p?.markAsDisposed(R)}function w(R,O){p?.setParent(R,O)}function f(R,O){if(p)for(const M of R)p.setParent(M,O)}function g(R){return p?.markAsSingleton(R),R}function v(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function b(R){if(T.Iterable.is(R)){const O=[];for(const M of R)if(M)try{M.dispose()}catch(x){O.push(x)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function $(R){for(const O of R)v(O)&&O.dispose();return[]}function k(...R){const O=E(()=>b(R));return f(R,O),O}function E(R){const O=h({dispose:(0,A.$cb)(()=>{d(O),R()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Sc=t;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,h(this),w(this.q,this)}dispose(){d(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Tc=u;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Uc=i;class o{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(O){let M=O;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,d(this))},this}}e.$Xc=a;class l{constructor(){this.a=new Map}acquire(O,...M){let x=this.a.get(O);x||(x={counter:0,object:this.b(O,...M)},this.a.set(O,x));const{object:X}=x,K=(0,A.$cb)(()=>{--x.counter===0&&(this.c(O,x.object),this.a.delete(O))});return x.counter++,{object:X,dispose:K}}}e.$Yc=l;class S{constructor(O){this.a=O}async acquire(O,...M){const x=this.a.acquire(O,...M);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(X){throw x.dispose(),X}}}e.$Zc=S;class y{constructor(O){this.object=O}dispose(){}}e.$1c=y;function D(R){const O=new t;try{R(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,M,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(O)?.dispose(),this.a.set(O,M)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const M=this.a.get(O);return this.a.delete(O),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(ce[90],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ce[78],le([0,1,31]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=P,e.$mm=T;const r=new n.$Cc(1e4);function P(c){return p(c,"NFC",r)}const A=new n.$Cc(1e4);function T(c){return p(c,"NFD",A)}const I=/[^\u0000-\u0080]/;function p(c,m,h){if(!c)return c;const d=h.get(c);if(d)return d;let w;return I.test(c)?w=c.normalize(m):w=c,h.set(c,w),w}e.$nm=function(){const c=/[\u0300-\u036f]/g;return function(m){return T(m).replace(c,"")}}()}),define(ce[144],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=n,e.rot=r,e.$Om=I;function n(p,c,m){return Math.min(Math.max(p,c),m)}function r(p,c){return(c+p%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=P;class A{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=A;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const m=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=T;function I(p,c,m,h,d,w,f,g){const v=f-m,b=g-h,$=d-m,k=w-h,E=p-m,t=c-h,u=v*v+b*b,i=v*$+b*k,o=v*E+b*t,s=$*$+k*k,a=$*E+k*t,l=1/(u*s-i*i),S=(s*o-i*a)*l,y=(u*a-i*o)*l;return S>=0&&y>=0&&S+y<1}}),function(){function V(P){const A=[];typeof P=="number"&&A.push("code/timeOrigin",P);function T(p){A.push(p,Date.now())}function I(){const p=[];for(let c=0;c<A.length;c+=2)p.push({name:A[c],startTime:A[c+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(P+T.startTime)});return A}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(ce[3],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=S,e.$K=y,e.$h="en";let n=!1,r=!1,P=!1,A=!1,T=!1,I=!1,p=!1,c=!1,m=!1,h=!1,d,w=e.$h,f=e.$h,g,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const k=typeof $?.versions?.electron=="string",E=k&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",P=$.platform==="linux",A=P&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=k,m=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,w=e.$h;const D=$.env.VSCODE_NLS_CONFIG;if(D)try{const L=JSON.parse(D);d=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,g=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!E?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),f=d):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(D){switch(D){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:P&&(i=t.Linux),e.$j=n,e.$k=r,e.$l=P,e.$m=A,e.$n=T,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=c,e.$t=h,e.$u=m,e.$v=i,e.$w=v,e.$x=w;var o;(function(D){function L(){return e.$x}D.value=L;function R(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=R;function O(){return e.$x==="en"}D.isDefault=O})(o||(e.Language=o={})),e.$y=d,e.$z=f,e.$A=g,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const D=[];b.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let O=0,M=D.length;O<M;O++){const x=D[O];if(x.id===R.data.vscodeScheduleAsyncWork){D.splice(O,1),x.callback();return}}});let L=0;return R=>{const O=++L;D.push({id:O,callback:R}),b.postMessage({vscodeScheduleAsyncWork:O},"*")}}return D=>setTimeout(D)})();var s;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function S(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,a=new Uint16Array(D.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(D){return parseFloat(D)>=20}}),define(ce[36],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const A=P.process;r={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$cc=r.platform,e.$dc=r.arch});var At=this&&this.__createBinding||(Object.create?function(V,e,n,r){r===void 0&&(r=n);var P=Object.getOwnPropertyDescriptor(e,n);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(V,r,P)}:function(V,e,n,r){r===void 0&&(r=n),V[r]=e[n]}),Rt=this&&this.__setModuleDefault||(Object.create?function(V,e){Object.defineProperty(V,"default",{enumerable:!0,value:e})}:function(V,e){V.default=e}),Pe=this&&this.__importStar||function(V){if(V&&V.__esModule)return V;var e={};if(V!=null)for(var n in V)n!=="default"&&Object.prototype.hasOwnProperty.call(V,n)&&At(e,V,n);return Rt(e,V),e};define(ce[9],le([0,1,36]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,n=Pe(n);const r=65,P=97,A=90,T=122,I=46,p=47,c=92,m=58,h=63;class d extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const S=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${S} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(i,o){if(i===null||typeof i!="object")throw new d(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new d(o,"string",i)}const g=n.$cc==="win32";function v(i){return i===p||i===c}function b(i){return i===p}function $(i){return i>=r&&i<=A||i>=P&&i<=T}function k(i,o,s,a){let l="",S=0,y=-1,D=0,L=0;for(let R=0;R<=i.length;++R){if(R<i.length)L=i.charCodeAt(R);else{if(a(L))break;L=p}if(a(L)){if(!(y===R-1||D===1))if(D===2){if(l.length<2||S!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",S=0):(l=l.slice(0,O),S=l.length-1-l.lastIndexOf(s)),y=R,D=0;continue}else if(l.length!==0){l="",S=0,y=R,D=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",S=2)}else l.length>0?l+=`${s}${i.slice(y+1,R)}`:l=i.slice(y+1,R),S=R-y-1;y=R,D=0}else L===I&&D!==-1?++D:D=-1}return l}function E(i){return i?`${i[0]==="."?"":"."}${i}`:""}function t(i,o){w(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${E(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${i}${a}`:a}e.$ec={resolve(...i){let o="",s="",a=!1;for(let l=i.length-1;l>=-1;l--){let S;if(l>=0){if(S=i[l],f(S,`paths[${l}]`),S.length===0)continue}else o.length===0?S=n.cwd():(S=n.env[`=${o}`]||n.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==o.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${o}\\`));const y=S.length;let D=0,L="",R=!1;const O=S.charCodeAt(0);if(y===1)v(O)&&(D=1,R=!0);else if(v(O))if(R=!0,v(S.charCodeAt(1))){let M=2,x=M;for(;M<y&&!v(S.charCodeAt(M));)M++;if(M<y&&M!==x){const X=S.slice(x,M);for(x=M;M<y&&v(S.charCodeAt(M));)M++;if(M<y&&M!==x){for(x=M;M<y&&!v(S.charCodeAt(M));)M++;(M===y||M!==x)&&(L=`\\\\${X}\\${S.slice(x,M)}`,D=M)}}}else D=1;else $(O)&&S.charCodeAt(1)===m&&(L=S.slice(0,2),D=2,y>2&&v(S.charCodeAt(2))&&(R=!0,D=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${S.slice(D)}\\${s}`,a=R,R&&o.length>0)break}return s=k(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let s=0,a,l=!1;const S=i.charCodeAt(0);if(o===1)return b(S)?"\\":i;if(v(S))if(l=!0,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){const R=i.slice(L,D);for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return`\\\\${R}\\${i.slice(L)}\\`;D!==L&&(a=`\\\\${R}\\${i.slice(L,D)}`,s=D)}}}else s=1;else $(S)&&i.charCodeAt(1)===m&&(a=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(l=!0,s=3));let y=s<o?k(i.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(i.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&$(s)&&i.charCodeAt(1)===m&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let S=0;S<i.length;++S){const y=i[S];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const S=s.length;S>1&&v(s.charCodeAt(1))&&(++l,S>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$ec.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const s=e.$ec.resolve(i),a=e.$ec.resolve(o);if(s===a||(i=s.toLowerCase(),o=a.toLowerCase(),i===o))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===c;)l++;let S=i.length;for(;S-1>l&&i.charCodeAt(S-1)===c;)S--;const y=S-l;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let L=o.length;for(;L-1>D&&o.charCodeAt(L-1)===c;)L--;const R=L-D,O=y<R?y:R;let M=-1,x=0;for(;x<O;x++){const K=i.charCodeAt(l+x);if(K!==o.charCodeAt(D+x))break;K===c&&(M=x)}if(x!==O){if(M===-1)return a}else{if(R>O){if(o.charCodeAt(D+x)===c)return a.slice(D+x+1);if(x===2)return a.slice(D+x)}y>O&&(i.charCodeAt(l+x)===c?M=x:x===2&&(M=3)),M===-1&&(M=0)}let X="";for(x=l+M+1;x<=S;++x)(x===S||i.charCodeAt(x)===c)&&(X+=X.length===0?"..":"\\..");return D+=M,X.length>0?`${X}${a.slice(D,L)}`:(a.charCodeAt(D)===c&&++D,a.slice(D,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==h&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let s=-1,a=0;const l=i.charCodeAt(0);if(o===1)return v(l)?i:".";if(v(l)){if(s=a=1,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return i;D!==L&&(s=a=D+1)}}}}else $(l)&&i.charCodeAt(1)===m&&(s=o>2&&v(i.charCodeAt(2))?3:2,a=s);let S=-1,y=!0;for(let D=o-1;D>=a;--D)if(v(i.charCodeAt(D))){if(!y){S=D;break}}else y=!1;if(S===-1){if(s===-1)return".";S=s}return i.slice(0,S)},basename(i,o){o!==void 0&&f(o,"suffix"),f(i,"path");let s=0,a=-1,l=!0,S;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===m&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(S=i.length-1;S>=s;--S){const L=i.charCodeAt(S);if(v(L)){if(!l){s=S+1;break}}else D===-1&&(l=!1,D=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(S=i.length-1;S>=s;--S)if(v(i.charCodeAt(S))){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=0,s=-1,a=0,l=-1,S=!0,y=0;i.length>=2&&i.charCodeAt(1)===m&&$(i.charCodeAt(0))&&(o=a=2);for(let D=i.length-1;D>=o;--D){const L=i.charCodeAt(D);if(v(L)){if(!S){a=D+1;break}continue}l===-1&&(S=!1,l=D+1),L===I?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:t.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let a=0,l=i.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(l)){if(a=1,v(i.charCodeAt(1))){let M=2,x=M;for(;M<s&&!v(i.charCodeAt(M));)M++;if(M<s&&M!==x){for(x=M;M<s&&v(i.charCodeAt(M));)M++;if(M<s&&M!==x){for(x=M;M<s&&!v(i.charCodeAt(M));)M++;M===s?a=M:M!==x&&(a=M+1)}}}}else if($(l)&&i.charCodeAt(1)===m){if(s<=2)return o.root=o.dir=i,o;if(a=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;a=3}}a>0&&(o.root=i.slice(0,a));let S=-1,y=a,D=-1,L=!0,R=i.length-1,O=0;for(;R>=a;--R){if(l=i.charCodeAt(R),v(l)){if(!L){y=R+1;break}continue}D===-1&&(L=!1,D=R+1),l===I?S===-1?S=R:O!==1&&(O=1):S!==-1&&(O=-1)}return D!==-1&&(S===-1||O===0||O===1&&S===D-1&&S===y+1?o.base=o.name=i.slice(y,D):(o.name=i.slice(y,S),o.base=i.slice(y,D),o.ext=i.slice(S,D))),y>0&&y!==a?o.dir=i.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(g){const i=/\\/g;return()=>{const o=n.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$fc={resolve(...i){let o="",s=!1;for(let a=i.length-1;a>=-1&&!s;a--){const l=a>=0?i[a]:u();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=k(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p,s=i.charCodeAt(i.length-1)===p;return i=k(i,!o,"/",b),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const a=i[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const s=1,a=i.length,l=a-s,S=1,y=o.length-S,D=l<y?l:y;let L=-1,R=0;for(;R<D;R++){const M=i.charCodeAt(s+R);if(M!==o.charCodeAt(S+R))break;M===p&&(L=R)}if(R===D)if(y>D){if(o.charCodeAt(S+R)===p)return o.slice(S+R+1);if(R===0)return o.slice(S+R)}else l>D&&(i.charCodeAt(s+R)===p?L=R:R===0&&(L=0));let O="";for(R=s+L+1;R<=a;++R)(R===a||i.charCodeAt(R)===p)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(S+L)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p;let s=-1,a=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===p){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let s=0,a=-1,l=!0,S;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(S=i.length-1;S>=0;--S){const L=i.charCodeAt(S);if(L===p){if(!l){s=S+1;break}}else D===-1&&(l=!1,D=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(S=i.length-1;S>=0;--S)if(i.charCodeAt(S)===p){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=-1,s=0,a=-1,l=!0,S=0;for(let y=i.length-1;y>=0;--y){const D=i.charCodeAt(y);if(D===p){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),D===I?o===-1?o=y:S!==1&&(S=1):o!==-1&&(S=-1)}return o===-1||a===-1||S===0||S===1&&o===a-1&&o===s+1?"":i.slice(o,a)},format:t.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===p;let a;s?(o.root="/",a=1):a=0;let l=-1,S=0,y=-1,D=!0,L=i.length-1,R=0;for(;L>=a;--L){const O=i.charCodeAt(L);if(O===p){if(!D){S=L+1;break}continue}y===-1&&(D=!1,y=L+1),O===I?l===-1?l=L:R!==1&&(R=1):l!==-1&&(R=-1)}if(y!==-1){const O=S===0&&s?1:S;l===-1||R===0||R===1&&l===y-1&&l===S+1?o.base=o.name=i.slice(O,y):(o.name=i.slice(O,l),o.base=i.slice(O,y),o.ext=i.slice(l,y))}return S>0?o.dir=i.slice(0,S-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=g?e.$ec.normalize:e.$fc.normalize,e.$hc=g?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=g?e.$ec.join:e.$fc.join,e.$jc=g?e.$ec.resolve:e.$fc.resolve,e.$kc=g?e.$ec.relative:e.$fc.relative,e.$lc=g?e.$ec.dirname:e.$fc.dirname,e.$mc=g?e.$ec.basename:e.$fc.basename,e.$nc=g?e.$ec.extname:e.$fc.extname,e.$oc=g?e.$ec.format:e.$fc.format,e.$pc=g?e.$ec.parse:e.$fc.parse,e.$qc=g?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=g?e.$ec.sep:e.$fc.sep,e.$sc=g?e.$ec.delimiter:e.$fc.delimiter}),define(ce[79],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=A,e.$km=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function A(I,...p){const c=p.reduce((d,w)=>(d[w]=!0,d),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(d=>!c[d]).forEach(d=>{for(let w=0;w<m.length;w++)if(d.search(m[w])!==-1){delete I[d];break}})}function T(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:V)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function n(r){if(e[r])return e[r].exports;var P=e[r]={i:r,l:!1,exports:{}};return V[r].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=V,n.c=e,n.d=function(r,P,A){n.o(r,P)||Object.defineProperty(r,P,{enumerable:!0,get:A})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,P){if(1&P&&(r=n(r)),8&P||4&P&&typeof r=="object"&&r&&r.__esModule)return r;var A=Object.create(null);if(n.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:r}),2&P&&typeof r!="string")for(var T in r)n.d(A,T,function(I){return r[I]}.bind(null,T));return A},n.n=function(r){var P=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(P,"a",P),P},n.o=function(r,P){return Object.prototype.hasOwnProperty.call(r,P)},n.p="",n(n.s=0)}([function(V,e,n){(function(r){var P;e=V.exports=ue,P=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],c=0,m=c++;p[m]="0|[1-9]\\d*";var h=c++;p[h]="[0-9]+";var d=c++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;p[w]="("+p[m]+")\\.("+p[m]+")\\.("+p[m]+")";var f=c++;p[f]="("+p[h]+")\\.("+p[h]+")\\.("+p[h]+")";var g=c++;p[g]="(?:"+p[m]+"|"+p[d]+")";var v=c++;p[v]="(?:"+p[h]+"|"+p[d]+")";var b=c++;p[b]="(?:-("+p[g]+"(?:\\."+p[g]+")*))";var $=c++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var k=c++;p[k]="[0-9A-Za-z-]+";var E=c++;p[E]="(?:\\+("+p[k]+"(?:\\."+p[k]+")*))";var t=c++,u="v?"+p[w]+p[b]+"?"+p[E]+"?";p[t]="^"+u+"$";var i="[v=\\s]*"+p[f]+p[$]+"?"+p[E]+"?",o=c++;p[o]="^"+i+"$";var s=c++;p[s]="((?:<|>)?=?)";var a=c++;p[a]=p[h]+"|x|X|\\*";var l=c++;p[l]=p[m]+"|x|X|\\*";var S=c++;p[S]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[E]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[$]+")?"+p[E]+"?)?)?";var D=c++;p[D]="^"+p[s]+"\\s*"+p[S]+"$";var L=c++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var R=c++;p[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;p[O]="(?:~>?)";var M=c++;p[M]="(\\s*)"+p[O]+"\\s+",I[M]=new RegExp(p[M],"g");var x=c++;p[x]="^"+p[O]+p[S]+"$";var X=c++;p[X]="^"+p[O]+p[y]+"$";var K=c++;p[K]="(?:\\^)";var fe=c++;p[fe]="(\\s*)"+p[K]+"\\s+",I[fe]=new RegExp(p[fe],"g");var H=c++;p[H]="^"+p[K]+p[S]+"$";var J=c++;p[J]="^"+p[K]+p[y]+"$";var U=c++;p[U]="^"+p[s]+"\\s*("+i+")$|^$";var Z=c++;p[Z]="^"+p[s]+"\\s*("+u+")$|^$";var B=c++;p[B]="(\\s*)"+p[s]+"\\s*("+i+"|"+p[S]+")",I[B]=new RegExp(p[B],"g");var j=c++;p[j]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var C=c++;p[C]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var Y=c++;p[Y]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)P(oe,p[oe]),I[oe]||(I[oe]=new RegExp(p[oe]));function G(_,ae){if(_ instanceof ue)return _;if(typeof _!="string"||_.length>A||!(ae?I[o]:I[t]).test(_))return null;try{return new ue(_,ae)}catch{return null}}function ue(_,ae){if(_ instanceof ue){if(_.loose===ae)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ue))return new ue(_,ae);P("SemVer",_,ae),this.loose=ae;var he=_.trim().match(ae?I[o]:I[t]);if(!he)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var De=+be;if(De>=0&&De<T)return De}return be}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=G,e.valid=function(_,ae){var he=G(_,ae);return he?he.version:null},e.clean=function(_,ae){var he=G(_.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(_){return P("SemVer.compare",this.version,this.loose,_),_ instanceof ue||(_=new ue(_,this.loose)),this.compareMain(_)||this.comparePre(_)},ue.prototype.compareMain=function(_){return _ instanceof ue||(_=new ue(_,this.loose)),Q(this.major,_.major)||Q(this.minor,_.minor)||Q(this.patch,_.patch)},ue.prototype.comparePre=function(_){if(_ instanceof ue||(_=new ue(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],be=_.prerelease[ae];if(P("prerelease compare",ae,he,be),he===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(he===void 0)return-1;if(he!==be)return Q(he,be)}while(++ae)},ue.prototype.inc=function(_,ae){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ae,he,be){typeof he=="string"&&(be=he,he=void 0);try{return new ue(_,he).inc(ae,be).version}catch{return null}},e.diff=function(_,ae){if(z(_,ae))return null;var he=G(_),be=G(ae);if(he.prerelease.length||be.prerelease.length){for(var De in he)if((De==="major"||De==="minor"||De==="patch")&&he[De]!==be[De])return"pre"+De;return"prerelease"}for(var De in he)if((De==="major"||De==="minor"||De==="patch")&&he[De]!==be[De])return De},e.compareIdentifiers=Q;var re=/^[0-9]+$/;function Q(_,ae){var he=re.test(_),be=re.test(ae);return he&&be&&(_=+_,ae=+ae),he&&!be?-1:be&&!he?1:_<ae?-1:_>ae?1:0}function F(_,ae,he){return new ue(_,he).compare(new ue(ae,he))}function N(_,ae,he){return F(_,ae,he)>0}function W(_,ae,he){return F(_,ae,he)<0}function z(_,ae,he){return F(_,ae,he)===0}function te(_,ae,he){return F(_,ae,he)!==0}function ee(_,ae,he){return F(_,ae,he)>=0}function q(_,ae,he){return F(_,ae,he)<=0}function ne(_,ae,he,be){var De;switch(ae){case"===":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),De=_===he;break;case"!==":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),De=_!==he;break;case"":case"=":case"==":De=z(_,he,be);break;case"!=":De=te(_,he,be);break;case">":De=N(_,he,be);break;case">=":De=ee(_,he,be);break;case"<":De=W(_,he,be);break;case"<=":De=q(_,he,be);break;default:throw new TypeError("Invalid operator: "+ae)}return De}function de(_,ae){if(_ instanceof de){if(_.loose===ae)return _;_=_.value}if(!(this instanceof de))return new de(_,ae);P("comparator",_,ae),this.loose=ae,this.parse(_),this.semver===me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(_,ae){return Q(ae,_)},e.major=function(_,ae){return new ue(_,ae).major},e.minor=function(_,ae){return new ue(_,ae).minor},e.patch=function(_,ae){return new ue(_,ae).patch},e.compare=F,e.compareLoose=function(_,ae){return F(_,ae,!0)},e.rcompare=function(_,ae,he){return F(ae,_,he)},e.sort=function(_,ae){return _.sort(function(he,be){return e.compare(he,be,ae)})},e.rsort=function(_,ae){return _.sort(function(he,be){return e.rcompare(he,be,ae)})},e.gt=N,e.lt=W,e.eq=z,e.neq=te,e.gte=ee,e.lte=q,e.cmp=ne,e.Comparator=de;var me={};function we(_,ae){if(_ instanceof we)return _.loose===ae?_:new we(_.raw,ae);if(_ instanceof de)return new we(_.value,ae);if(!(this instanceof we))return new we(_,ae);if(this.loose=ae,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ie(_){return!_||_.toLowerCase()==="x"||_==="*"}function We(_,ae,he,be,De,Fe,Me,Ae,Be,Ge,Ze,qe,Ye){return((ae=Ie(he)?"":Ie(be)?">="+he+".0.0":Ie(De)?">="+he+"."+be+".0":">="+ae)+" "+(Ae=Ie(Be)?"":Ie(Ge)?"<"+(+Be+1)+".0.0":Ie(Ze)?"<"+Be+"."+(+Ge+1)+".0":qe?"<="+Be+"."+Ge+"."+Ze+"-"+qe:"<="+Ae)).trim()}function Oe(_,ae){for(var he=0;he<_.length;he++)if(!_[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<_.length;he++)if(P(_[he].semver),_[he].semver!==me&&_[he].semver.prerelease.length>0){var be=_[he].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function Ee(_,ae,he){try{ae=new we(ae,he)}catch{return!1}return ae.test(_)}function $e(_,ae,he,be){var De,Fe,Me,Ae,Be;switch(_=new ue(_,be),ae=new we(ae,be),he){case">":De=N,Fe=q,Me=W,Ae=">",Be=">=";break;case"<":De=W,Fe=ee,Me=N,Ae="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(_,ae,be))return!1;for(var Ge=0;Ge<ae.set.length;++Ge){var Ze=ae.set[Ge],qe=null,Ye=null;if(Ze.forEach(function(Qe){Qe.semver===me&&(Qe=new de(">=0.0.0")),qe=qe||Qe,Ye=Ye||Qe,De(Qe.semver,qe.semver,be)?qe=Qe:Me(Qe.semver,Ye.semver,be)&&(Ye=Qe)}),qe.operator===Ae||qe.operator===Be||(!Ye.operator||Ye.operator===Ae)&&Fe(_,Ye.semver)||Ye.operator===Be&&Me(_,Ye.semver))return!1}return!0}de.prototype.parse=function(_){var ae=this.loose?I[U]:I[Z],he=_.match(ae);if(!he)throw new TypeError("Invalid comparator: "+_);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ue(he[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(_){return P("Comparator.test",_,this.loose),this.semver===me||(typeof _=="string"&&(_=new ue(_,this.loose)),ne(_,this.operator,this.semver,this.loose))},de.prototype.intersects=function(_,ae){if(!(_ instanceof de))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new we(_.value,ae),Ee(this.value,he,ae);if(_.operator==="")return he=new we(this.value,ae),Ee(_.semver,he,ae);var be=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Fe=this.semver.version===_.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),Ae=ne(this.semver,"<",_.semver,ae)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Be=ne(this.semver,">",_.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return be||De||Fe&&Me||Ae||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(_){var ae=this.loose;_=_.trim(),P("range",_,ae);var he=ae?I[C]:I[j];_=_.replace(he,We),P("hyphen replace",_),_=_.replace(I[B],"$1$2$3"),P("comparator trim",_,I[B]),_=(_=(_=_.replace(I[M],"$1~")).replace(I[fe],"$1^")).split(/\s+/).join(" ");var be=ae?I[U]:I[Z],De=_.split(" ").map(function(Fe){return function(Me,Ae){return P("comp",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Ye){P("caret",qe,Ye);var Qe=Ye?I[J]:I[H];return qe.replace(Qe,function(Je,Ce,ie,ge,pe){var ye;return P("caret",qe,Je,Ce,ie,ge,pe),Ie(Ce)?ye="":Ie(ie)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=Ce==="0"?">="+Ce+"."+ie+".0 <"+Ce+"."+(+ie+1)+".0":">="+Ce+"."+ie+".0 <"+(+Ce+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ce==="0"?ie==="0"?">="+Ce+"."+ie+"."+ge+pe+" <"+Ce+"."+ie+"."+(+ge+1):">="+Ce+"."+ie+"."+ge+pe+" <"+Ce+"."+(+ie+1)+".0":">="+Ce+"."+ie+"."+ge+pe+" <"+(+Ce+1)+".0.0"):(P("no pr"),ye=Ce==="0"?ie==="0"?">="+Ce+"."+ie+"."+ge+" <"+Ce+"."+ie+"."+(+ge+1):">="+Ce+"."+ie+"."+ge+" <"+Ce+"."+(+ie+1)+".0":">="+Ce+"."+ie+"."+ge+" <"+(+Ce+1)+".0.0"),P("caret return",ye),ye})}(Ze,Ge)}).join(" ")}(Me,Ae),P("caret",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Ye){var Qe=Ye?I[X]:I[x];return qe.replace(Qe,function(Je,Ce,ie,ge,pe){var ye;return P("tilde",qe,Je,Ce,ie,ge,pe),Ie(Ce)?ye="":Ie(ie)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=">="+Ce+"."+ie+".0 <"+Ce+"."+(+ie+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ce+"."+ie+"."+ge+pe+" <"+Ce+"."+(+ie+1)+".0"):ye=">="+Ce+"."+ie+"."+ge+" <"+Ce+"."+(+ie+1)+".0",P("tilde return",ye),ye})}(Ze,Ge)}).join(" ")}(Me,Ae),P("tildes",Me),Me=function(Be,Ge){return P("replaceXRanges",Be,Ge),Be.split(/\s+/).map(function(Ze){return function(qe,Ye){qe=qe.trim();var Qe=Ye?I[L]:I[D];return qe.replace(Qe,function(Je,Ce,ie,ge,pe,ye){P("xRange",qe,Je,Ce,ie,ge,pe,ye);var je=Ie(ie),Ue=je||Ie(ge),_e=Ue||Ie(pe);return Ce==="="&&_e&&(Ce=""),je?Je=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&_e?(Ue&&(ge=0),_e&&(pe=0),Ce===">"?(Ce=">=",Ue?(ie=+ie+1,ge=0,pe=0):_e&&(ge=+ge+1,pe=0)):Ce==="<="&&(Ce="<",Ue?ie=+ie+1:ge=+ge+1),Je=Ce+ie+"."+ge+"."+pe):Ue?Je=">="+ie+".0.0 <"+(+ie+1)+".0.0":_e&&(Je=">="+ie+"."+ge+".0 <"+ie+"."+(+ge+1)+".0"),P("xRange return",Je),Je})}(Ze,Ge)}).join(" ")}(Me,Ae),P("xrange",Me),Me=function(Be,Ge){return P("replaceStars",Be,Ge),Be.trim().replace(I[Y],"")}(Me,Ae),P("stars",Me),Me}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Fe){return!!Fe.match(be)})),De=De.map(function(Fe){return new de(Fe,ae)})},we.prototype.intersects=function(_,ae){if(!(_ instanceof we))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(be){return _.set.some(function(De){return De.every(function(Fe){return be.intersects(Fe,ae)})})})})},e.toComparators=function(_,ae){return new we(_,ae).set.map(function(he){return he.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new ue(_,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Oe(this.set[ae],_))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(_,ae,he){var be=null,De=null;try{var Fe=new we(ae,he)}catch{return null}return _.forEach(function(Me){Fe.test(Me)&&(be&&De.compare(Me)!==-1||(De=new ue(be=Me,he)))}),be},e.minSatisfying=function(_,ae,he){var be=null,De=null;try{var Fe=new we(ae,he)}catch{return null}return _.forEach(function(Me){Fe.test(Me)&&(be&&De.compare(Me)!==1||(De=new ue(be=Me,he)))}),be},e.validRange=function(_,ae){try{return new we(_,ae).range||"*"}catch{return null}},e.ltr=function(_,ae,he){return $e(_,ae,"<",he)},e.gtr=function(_,ae,he){return $e(_,ae,">",he)},e.outside=$e,e.prerelease=function(_,ae){var he=G(_,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(_,ae,he){return _=new we(_,he),ae=new we(ae,he),_.intersects(ae)},e.coerce=function(_){if(_ instanceof ue)return _;if(typeof _!="string")return null;var ae=_.match(I[R]);return ae==null?null:G((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,n(1))},function(V,e){var n,r,P=V.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===A||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:A}catch{n=A}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var p,c=[],m=!1,h=-1;function d(){m&&p&&(m=!1,p.length?c=p.concat(c):h=-1,c.length&&w())}function w(){if(!m){var v=I(d);m=!0;for(var b=c.length;b;){for(p=c,c=[];++h<b;)p&&p[h].run();h=-1,b=c.length}p=null,m=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function g(){}P.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];c.push(new f(v,b)),c.length!==1||m||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(v){return[]},P.binding=function(v){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(v){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ce[145],le([0,1]),function(V,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class r{constructor(I,p,c){this.level=I,this.key=p,this.value=c,this.forward=[]}}const P=void 0;class A{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,P,P)}get size(){return this.f}clear(){this.e=new r(this.c,P,P),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,p){return A.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=A.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let c=this.e.forward[0];for(;c;)I.call(p,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,c){let m=I.e;for(let h=I.d-1;h>=0;h--)for(;m.forward[h]&&c(m.forward[h].key,p)<0;)m=m.forward[h];if(m=m.forward[0],m&&c(m.key,p)===0)return m}static h(I,p,c,m){const h=[];let d=I.e;for(let w=I.d-1;w>=0;w--){for(;d.forward[w]&&m(d.forward[w].key,p)<0;)d=d.forward[w];h[w]=d}if(d=d.forward[0],d&&m(d.key,p)===0)return d.value=c,!1;{const w=A.j(I);if(w>I.d){for(let f=I.d;f<w;f++)h[f]=I.e;I.d=w}d=new r(w,p,c);for(let f=0;f<w;f++)d.forward[f]=h[f].forward[f],h[f].forward[f]=d;return!0}}static j(I,p=.5){let c=1;for(;Math.random()<p&&c<I.c;)c+=1;return c}static k(I,p,c){const m=[];let h=I.e;for(let d=I.d-1;d>=0;d--){for(;h.forward[d]&&c(h.forward[d].key,p)<0;)h=h.forward[d];m[d]=h}if(h=h.forward[0],!h||c(h.key,p)!==0)return!1;for(let d=0;d<I.d&&m[d].forward[d]===h;d++)m[d].forward[d]=h.forward[d];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.$Rs=A}),define(ce[66],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(A){return new r(A)}constructor(A){this.c=n&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ee=r}),define(ce[4],le([0,1,15,89,2,108,66]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$ge=e.Event=void 0,e.$he=w;const I=!1,p=!1,c=!1;var m;(function(X){X.None=()=>P.$Tc.None;function K(Oe){if(c){const{onDidAddListener:Ee}=Oe,$e=g.create();let _=0;Oe.onDidAddListener=()=>{++_===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),Ee?.()}}}function fe(Oe,Ee){return G(Oe,()=>{},0,void 0,!0,void 0,Ee)}X.defer=fe;function H(Oe){return(Ee,$e=null,_)=>{let ae=!1,he;return he=Oe(be=>{if(!ae)return he?he.dispose():ae=!0,Ee.call($e,be)},null,_),ae&&he.dispose(),he}}X.once=H;function J(Oe,Ee,$e){return Y((_,ae=null,he)=>Oe(be=>_.call(ae,Ee(be)),null,he),$e)}X.map=J;function U(Oe,Ee,$e){return Y((_,ae=null,he)=>Oe(be=>{Ee(be),_.call(ae,be)},null,he),$e)}X.forEach=U;function Z(Oe,Ee,$e){return Y((_,ae=null,he)=>Oe(be=>Ee(be)&&_.call(ae,be),null,he),$e)}X.filter=Z;function B(Oe){return Oe}X.signal=B;function j(...Oe){return(Ee,$e=null,_)=>{const ae=(0,P.$Qc)(...Oe.map(he=>he(be=>Ee.call($e,be))));return oe(ae,_)}}X.any=j;function C(Oe,Ee,$e,_){let ae=$e;return J(Oe,he=>(ae=Ee(ae,he),ae),_)}X.reduce=C;function Y(Oe,Ee){let $e;const _={onWillAddFirstListener(){$e=Oe(ae.fire,ae)},onDidRemoveLastListener(){$e?.dispose()}};Ee||K(_);const ae=new i(_);return Ee?.add(ae),ae.event}function oe(Oe,Ee){return Ee instanceof Array?Ee.push(Oe):Ee&&Ee.add(Oe),Oe}function G(Oe,Ee,$e=100,_=!1,ae=!1,he,be){let De,Fe,Me,Ae=0,Be;const Ge={leakWarningThreshold:he,onWillAddFirstListener(){De=Oe(qe=>{Ae++,Fe=Ee(Fe,qe),_&&!Me&&(Ze.fire(Fe),Fe=void 0),Be=()=>{const Ye=Fe;Fe=void 0,Me=void 0,(!_||Ae>1)&&Ze.fire(Ye),Ae=0},typeof $e=="number"?(clearTimeout(Me),Me=setTimeout(Be,$e)):Me===void 0&&(Me=0,queueMicrotask(Be))})},onWillRemoveListener(){ae&&Ae>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,De.dispose()}};be||K(Ge);const Ze=new i(Ge);return be?.add(Ze),Ze.event}X.debounce=G;function ue(Oe,Ee=0,$e){return X.debounce(Oe,(_,ae)=>_?(_.push(ae),_):[ae],Ee,void 0,!0,void 0,$e)}X.accumulate=ue;function re(Oe,Ee=(_,ae)=>_===ae,$e){let _=!0,ae;return Z(Oe,he=>{const be=_||!Ee(he,ae);return _=!1,ae=he,be},$e)}X.latch=re;function Q(Oe,Ee,$e){return[X.filter(Oe,Ee,$e),X.filter(Oe,_=>!Ee(_),$e)]}X.split=Q;function F(Oe,Ee=!1,$e=[],_){let ae=$e.slice(),he=Oe(Fe=>{ae?ae.push(Fe):De.fire(Fe)});_&&_.add(he);const be=()=>{ae?.forEach(Fe=>De.fire(Fe)),ae=null},De=new i({onWillAddFirstListener(){he||(he=Oe(Fe=>De.fire(Fe)),_&&_.add(he))},onDidAddFirstListener(){ae&&(Ee?setTimeout(be):be())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return _&&_.add(De),De.event}X.buffer=F;function N(Oe,Ee){return(_,ae,he)=>{const be=Ee(new z);return Oe(function(De){const Fe=be.evaluate(De);Fe!==W&&_.call(ae,Fe)},void 0,he)}}X.chain=N;const W=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(Ee){return this.f.push(Ee),this}forEach(Ee){return this.f.push($e=>(Ee($e),$e)),this}filter(Ee){return this.f.push($e=>Ee($e)?$e:W),this}reduce(Ee,$e){let _=$e;return this.f.push(ae=>(_=Ee(_,ae),_)),this}latch(Ee=($e,_)=>$e===_){let $e=!0,_;return this.f.push(ae=>{const he=$e||!Ee(ae,_);return $e=!1,_=ae,he?ae:W}),this}evaluate(Ee){for(const $e of this.f)if(Ee=$e(Ee),Ee===W)break;return Ee}}function te(Oe,Ee,$e=_=>_){const _=(...De)=>be.fire($e(...De)),ae=()=>Oe.on(Ee,_),he=()=>Oe.removeListener(Ee,_),be=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return be.event}X.fromNodeEventEmitter=te;function ee(Oe,Ee,$e=_=>_){const _=(...De)=>be.fire($e(...De)),ae=()=>Oe.addEventListener(Ee,_),he=()=>Oe.removeEventListener(Ee,_),be=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return be.event}X.fromDOMEventEmitter=ee;function q(Oe){return new Promise(Ee=>H(Oe)(Ee))}X.toPromise=q;function ne(Oe){const Ee=new i;return Oe.then($e=>{Ee.fire($e)},()=>{Ee.fire(void 0)}).finally(()=>{Ee.dispose()}),Ee.event}X.fromPromise=ne;function de(Oe,Ee){return Oe($e=>Ee.fire($e))}X.forward=de;function me(Oe,Ee,$e){return Ee($e),Oe(_=>Ee(_))}X.runAndSubscribe=me;class we{constructor(Ee,$e){this._observable=Ee,this.f=0,this.g=!1;const _={onWillAddFirstListener:()=>{Ee.addObserver(this)},onDidRemoveLastListener:()=>{Ee.removeObserver(this)}};$e||K(_),this.emitter=new i(_),$e&&$e.add(this.emitter)}beginUpdate(Ee){this.f++}handlePossibleChange(Ee){}handleChange(Ee,$e){this.g=!0}endUpdate(Ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(Oe,Ee){return new we(Oe,Ee).emitter.event}X.fromObservable=Ie;function We(Oe){return(Ee,$e,_)=>{let ae=0,he=!1;const be={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(Oe.reportChanges(),he&&(he=!1,Ee.call($e)))},handlePossibleChange(){},handleChange(){he=!0}};Oe.addObserver(be),Oe.reportChanges();const De={dispose(){Oe.removeObserver(be)}};return _ instanceof P.$Sc?_.add(De):Array.isArray(_)&&_.push(De),De}}X.fromObservableLight=We})(m||(e.Event=m={}));class h{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${h.f++}`,h.all.add(this)}start(K){this.g=new T.$ee,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$ge=h;let d=-1;function w(X){const K=d;return d=X,{dispose(){d=K}}}class f{static{this.f=1}constructor(K,fe,H=(f.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=fe,this.name=H,this.h=0}dispose(){this.g?.clear()}check(K,fe){const H=this.threshold;if(H<=0||fe<H)return;this.g||(this.g=new Map);const J=this.g.get(K.value)||0;if(this.g.set(K.value,J+1),this.h-=1,this.h<=0){this.h=H*.5;const[U,Z]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${fe} listeners already. MOST frequent listener (${Z}):`;console.warn(B),console.warn(U);const j=new v(B,U);this.j(j)}return()=>{const U=this.g.get(K.value)||0;this.g.set(K.value,U-1)}}getMostFrequentStack(){if(!this.g)return;let K,fe=0;for(const[H,J]of this.g)(!K||fe<J)&&(K=[H,J],fe=J);return K}}class g{static create(){const K=new Error;return new g(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(K,fe){super(K),this.name="ListenerLeakError",this.stack=fe}}e.$ie=v;class b extends Error{constructor(K,fe){super(K),this.name="ListenerRefusalError",this.stack=fe}}e.$je=b;let $=0;class k{constructor(K){this.value=K,this.id=$++}}const E=2,t=(X,K)=>{if(X instanceof k)K(X);else for(let fe=0;fe<X.length;fe++){const H=X[fe];H&&K(H)}};let u;if(I){const X=[];setInterval(()=>{X.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(X.join(`
`)),X.length=0)},3e3),u=new FinalizationRegistry(K=>{typeof K=="string"&&X.push(K)})}class i{constructor(K){this.z=0,this.f=K,this.g=d>0||this.f?.leakWarningThreshold?new f(K?.onListenerError??n.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const K=this.u;queueMicrotask(()=>{t(K,fe=>fe.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,fe,H)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const C=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],Y=new b(`${j}. HINT: Stack shows most frequent listener (${C[1]}-times)`,C[0]);return(this.f?.onListenerError||n.$Y)(Y),P.$Tc.None}if(this.m)return P.$Tc.None;fe&&(K=K.bind(fe));const J=new k(K);let U,Z;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(J.stack=g.create(),U=this.g.check(J.stack,this.z+1)),p&&(J.stack=Z??g.create()),this.u?this.u instanceof k?(this.w??=new s,this.u=[this.u,J]):this.u.push(J):(this.f?.onWillAddFirstListener?.(this),this.u=J,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,P.$Rc)(()=>{u?.unregister(B),U?.(),this.A(J)});if(H instanceof P.$Sc?H.add(B):Array.isArray(H)&&H.push(B),u){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),C=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);u.register(B,C?.[2]??j,B)}return B},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const fe=this.u,H=fe.indexOf(K);if(H===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,fe[H]=void 0;const J=this.w.current===this;if(this.z*E<=fe.length){let U=0;for(let Z=0;Z<fe.length;Z++)fe[Z]?fe[U++]=fe[Z]:J&&(this.w.end--,U<this.w.i&&this.w.i--);fe.length=U}}B(K,fe){if(!K)return;const H=this.f?.onListenerError||n.$Y;if(!H){K.value(fe);return}try{K.value(fe)}catch(J){H(J)}}C(K){const fe=K.current.u;for(;K.i<K.end;)this.B(fe[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof k)this.B(this.u,K);else{const fe=this.w;fe.enqueue(this,K,this.u.length),this.C(fe)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ke=i;const o=()=>new s;e.$le=o;class s{constructor(){this.i=-1,this.end=0}enqueue(K,fe,H){this.i=0,this.end=H,this.current=K,this.value=fe}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends i{async fireAsync(K,fe,H){if(this.u)for(this.h||(this.h=new A.$4c),t(this.u,J=>this.h.push([J.value,K]));this.h.size>0&&!fe.isCancellationRequested;){const[J,U]=this.h.shift(),Z=[],B={...U,token:fe,waitUntil:j=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");H&&(j=H(j,J)),Z.push(j)}};try{J(B)}catch(j){(0,n.$Y)(j);continue}Object.freeze(Z),await Promise.allSettled(Z).then(j=>{for(const C of j)C.status==="rejected"&&(0,n.$Y)(C.reason)})}}}e.$me=a;class l extends i{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new A.$4c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$ne=l;class S extends l{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$oe=S;class y extends i{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(fe=>super.fire(fe)),this.h=[]}))}}e.$pe=y;class D{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const fe={event:K,listener:null};this.h.push(fe),this.g&&this.m(fe);const H=()=>{this.g&&this.o(fe);const J=this.h.indexOf(fe);this.h.splice(J,1)};return(0,P.$Rc)((0,r.$cb)(H))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(fe=>this.f.fire(fe))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$qe=D;class L{constructor(K,fe,H,J){this.f=new P.$Sc;const U=this.f.add(new D),Z=this.f.add(new P.$3c);function B(j){Z.set(j,U.add(J(j)))}for(const j of K)B(j);this.f.add(fe(j=>{B(j)})),this.f.add(H(j=>{Z.deleteAndDispose(j)})),this.event=U.event}dispose(){this.f.dispose()}}e.$re=L;class R{constructor(){this.f=[]}wrapEvent(K,fe,H){return(J,U,Z)=>K(B=>{const j=this.f[this.f.length-1];if(!fe){j?j.buffers.push(()=>J.call(U,B)):J.call(U,B);return}const C=j;if(!C){J.call(U,fe(H,B));return}C.items??=[],C.items.push(B),C.buffers.length===0&&j.buffers.push(()=>{C.reducedResult??=H?C.items.reduce(fe,H):C.items.reduce(fe),J.call(U,C.reducedResult)})},void 0,Z)}bufferEvents(K){const fe={buffers:new Array};this.f.push(fe);const H=K();return this.f.pop(),fe.buffers.forEach(J=>J()),H}}e.$se=R;class O{constructor(){this.f=!1,this.g=m.None,this.h=P.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$te=O;class M{static const(K){return new x(K)}constructor(K){this.g=K,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$ue=M;class x{constructor(K){this.value=K,this.onDidChange=m.None}}}),define(ce[22],le([0,1,4]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.CancellationToken=void 0,e.$we=I;const r=Object.freeze(function(p,c){const m=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(m)}}});var P;(function(p){function c(m){return m===p.None||m===p.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(P||(e.CancellationToken=P={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$ke),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=P.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=P.None}}e.$ve=T;function I(p){const c=new T;return p.add({dispose(){c.cancel()}}),c.token}}),define(ce[146],le([0,1,22]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$e=e.$0e=e.$8e=void 0,e.$9e=P;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$ve,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$8e=r;function P(I){return I}class A{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=P):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$0e=A;class T{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=P):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const m=this.c(p);return this.a.set(p,m),this.b.set(c,m),m}}e.$$e=T}),define(ce[67],le([0,1,15,2]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=P,e.$ye=A,e.$ze=T,e.$Ae=I,e.$Be=c,e.$Ce=m,e.$De=h,e.$Ee=d,e.$Fe=w,e.$Ge=f,e.$He=g,e.$Ie=v,e.$Je=b,e.$Ke=$,e.$Le=k;function P(E){const t=E;return t?typeof t.read=="function":!1}function A(E){const t=E;return t?[t.on,t.pause,t.resume,t.destroy].every(u=>typeof u=="function"):!1}function T(E){const t=E;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(E,t){return new p(E,t)}class p{constructor(t,u){this.e=t,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(u=>u(t))}h(t){this.c.error.length===0?(0,n.$Y)(t):this.c.error.slice(0).forEach(u=>u(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,u){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(t,u){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(u);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,t){const u=[];let i;for(;(i=E.read())!==null;)u.push(i);return t(u)}function m(E,t,u){const i=[];let o;for(;(o=E.read())!==null&&i.length<u;)i.push(o);return o===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return E.read()}}}function h(E,t){return new Promise((u,i)=>{const o=[];d(E,{onData:s=>{t&&o.push(s)},onError:s=>{t?i(s):u(void 0)},onEnd:()=>{u(t?t(o):void 0)}})})}function d(E,t,u){E.on("error",i=>{u?.isCancellationRequested||t.onError(i)}),E.on("end",()=>{u?.isCancellationRequested||t.onEnd()}),E.on("data",i=>{u?.isCancellationRequested||t.onData(i)})}function w(E,t){return new Promise((u,i)=>{const o=new r.$Sc,s=[],a=y=>{if(s.push(y),s.length>t)return o.dispose(),E.pause(),u({stream:E,buffer:s,ended:!1})},l=y=>(o.dispose(),i(y)),S=()=>(o.dispose(),u({stream:E,buffer:s,ended:!0}));o.add((0,r.$Rc)(()=>E.removeListener("error",l))),E.on("error",l),o.add((0,r.$Rc)(()=>E.removeListener("end",S))),E.on("end",S),o.add((0,r.$Rc)(()=>E.removeListener("data",a))),E.on("data",a)})}function f(E,t){const u=I(t);return u.end(E),u}function g(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}function v(E){let t=!1;return{read:()=>t?null:(t=!0,E)}}function b(E,t,u){const i=I(u);return d(E,{onData:o=>i.write(t.data(o)),onError:o=>i.error(t.error?t.error(o):o),onEnd:()=>i.end()}),i}function $(E,t,u){let i=!1;return{read:()=>{const o=t.read();return i?o:(i=!0,o!==null?u([E,o]):E)}}}function k(E,t,u){let i=!1;const o=I(u);return d(t,{onData:s=>i?o.write(s):(i=!0,o.write(u([E,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(E)),o.end()}}),o}}),define(ce[17],le([0,1,65,67]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=void 0,e.$Ne=c,e.$Oe=m,e.$Pe=h,e.$Qe=d,e.$Re=w,e.$Se=f,e.$Te=g,e.$Ue=v,e.$Ve=b,e.$We=$,e.$Xe=k,e.$Ye=E,e.$Ze=t,e.$1e=u,e.$2e=i,e.$3e=o,e.$4e=s,e.$5e=a,e.$6e=l,e.$7e=D,r=Pe(r);const P=typeof Buffer<"u",A=new n.$T(()=>new Uint8Array(256));let T,I;class p{static alloc(R){return P?new p(Buffer.allocUnsafe(R)):new p(new Uint8Array(R))}static wrap(R){return P&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new p(R)}static fromString(R,O){return!(O?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(R)):(T||(T=new TextEncoder),new p(T.encode(R)))}static fromByteArray(R){const O=p.alloc(R.length);for(let M=0,x=R.length;M<x;M++)O.buffer[M]=R[M];return O}static concat(R,O){if(typeof O>"u"){O=0;for(let X=0,K=R.length;X<K;X++)O+=R[X].byteLength}const M=p.alloc(O);let x=0;for(let X=0,K=R.length;X<K;X++){const fe=R[X];M.set(fe,x),x+=fe.byteLength}return M}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=p.alloc(this.byteLength);return R.set(this),R}toString(){return P?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(R,O){return new p(this.buffer.subarray(R,O))}set(R,O){if(R instanceof p)this.buffer.set(R.buffer,O);else if(R instanceof Uint8Array)this.buffer.set(R,O);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),O);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return d(this.buffer,R)}writeUInt32BE(R,O){w(this.buffer,R,O)}readUInt32LE(R){return f(this.buffer,R)}writeUInt32LE(R,O){g(this.buffer,R,O)}readUInt8(R){return v(this.buffer,R)}writeUInt8(R,O){b(this.buffer,R,O)}indexOf(R,O=0){return c(this.buffer,R instanceof p?R.buffer:R,O)}}e.$Me=p;function c(L,R,O=0){const M=R.byteLength,x=L.byteLength;if(M===0)return 0;if(M===1)return L.indexOf(R[0]);if(M>x-O)return-1;const X=A.value;X.fill(R.length);for(let J=0;J<R.length;J++)X[R[J]]=R.length-J-1;let K=O+R.length-1,fe=K,H=-1;for(;K<x;)if(L[K]===R[fe]){if(fe===0){H=K;break}K--,fe--}else K+=Math.max(R.length-fe,X[L[K]]),fe=R.length-1;return H}function m(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0}function h(L,R,O){L[O+0]=R&255,R=R>>>8,L[O+1]=R&255}function d(L,R){return L[R]*2**24+L[R+1]*2**16+L[R+2]*2**8+L[R+3]}function w(L,R,O){L[O+3]=R,R=R>>>8,L[O+2]=R,R=R>>>8,L[O+1]=R,R=R>>>8,L[O]=R}function f(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0|L[R+2]<<16>>>0|L[R+3]<<24>>>0}function g(L,R,O){L[O+0]=R&255,R=R>>>8,L[O+1]=R&255,R=R>>>8,L[O+2]=R&255,R=R>>>8,L[O+3]=R&255}function v(L,R){return L[R]}function b(L,R,O){L[O]=R}function $(L){return r.$Be(L,R=>p.concat(R))}function k(L){return r.$Ie(L)}function E(L){return r.$De(L,R=>p.concat(R))}async function t(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await E(L.stream)])}function u(L){return r.$Ge(L,R=>p.concat(R))}function i(L){return r.$Je(L,{data:R=>typeof R=="string"?p.fromString(R):p.wrap(R)},R=>p.concat(R))}function o(L){return r.$Ae(R=>p.concat(R),L)}function s(L,R){return r.$Ke(L,R,O=>p.concat(O))}function a(L,R){return r.$Le(L,R,O=>p.concat(O))}function l(L){let R=0,O=0,M=0;const x=new Uint8Array(Math.floor(L.length/4*3)),X=fe=>{switch(O){case 3:x[M++]=R|fe,O=0;break;case 2:x[M++]=R|fe>>>2,R=fe<<6,O=3;break;case 1:x[M++]=R|fe>>>4,R=fe<<4,O=2;break;default:R=fe<<2,O=1}};for(let fe=0;fe<L.length;fe++){const H=L.charCodeAt(fe);if(H>=65&&H<=90)X(H-65);else if(H>=97&&H<=122)X(H-97+26);else if(H>=48&&H<=57)X(H-48+52);else if(H===43||H===45)X(62);else if(H===47||H===95)X(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${L[fe]}`)}}const K=M;for(;O>0;)X(0);return p.wrap(x).slice(0,K)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:L},R=!0,O=!1){const M=O?y:S;let x="";const X=L.byteLength%3;let K=0;for(;K<L.byteLength-X;K+=3){const fe=L[K+0],H=L[K+1],J=L[K+2];x+=M[fe>>>2],x+=M[(fe<<4|H>>>4)&63],x+=M[(H<<2|J>>>6)&63],x+=M[J&63]}if(X===1){const fe=L[K+0];x+=M[fe>>>2],x+=M[fe<<4&63],R&&(x+="==")}else if(X===2){const fe=L[K+0],H=L[K+1];x+=M[fe>>>2],x+=M[(fe<<4|H>>>4)&63],x+=M[H<<2&63],R&&(x+="=")}return x}}),define(ce[147],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0,e.$fe=Symbol("MicrotaskDelay")}),define(ce[12],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=n,e.$eg=r,e.$fg=P,e.$gg=A,e.$hg=T,e.$ig=I,e.$jg=p,e.$kg=c,e.$lg=m,e.$mg=h,e.$ng=d,e.$og=w,e.$pg=f,e.$qg=v,e.$rg=b,e.$sg=$,e.$tg=k,e.$ug=E;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(u=>n(u))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function A(t){const u=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof u}function T(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function m(t){return!h(t)}function h(t){return c(t)||t===null}function d(t,u){if(!t)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function w(t){if(h(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function f(...t){const u=[];for(let i=0;i<t.length;i++){const o=t[i];if(h(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(o)}return u}const g=Object.prototype.hasOwnProperty;function v(t){if(!P(t))return!1;for(const u in t)if(g.call(t,u))return!1;return!0}function b(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(b)}function k(t,u){const i=Math.min(t.length,u.length);for(let o=0;o<i;o++)E(t[o],u[o])}function E(t,u){if(n(u)){if(typeof t!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(b(u)){try{if(t instanceof u)return}catch{}if(!h(t)&&t.constructor===u||u.length===1&&u.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[109],le([0,1,12]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=P,e.$Yj=A;const r=Object.create(null);function P(T,I){if((0,n.$dg)(I)){const p=r[I];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=p}return r[T]=I,{id:T}}function A(){return r}}),define(ce[148],le([0,1,109]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=void 0,e.$Zj={add:(0,n.$Xj)("add",6e4),plus:(0,n.$Xj)("plus",6e4),gistNew:(0,n.$Xj)("gist-new",6e4),repoCreate:(0,n.$Xj)("repo-create",6e4),lightbulb:(0,n.$Xj)("lightbulb",60001),lightBulb:(0,n.$Xj)("light-bulb",60001),repo:(0,n.$Xj)("repo",60002),repoDelete:(0,n.$Xj)("repo-delete",60002),gistFork:(0,n.$Xj)("gist-fork",60003),repoForked:(0,n.$Xj)("repo-forked",60003),gitPullRequest:(0,n.$Xj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Xj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Xj)("record-keys",60005),keyboard:(0,n.$Xj)("keyboard",60005),tag:(0,n.$Xj)("tag",60006),gitPullRequestLabel:(0,n.$Xj)("git-pull-request-label",60006),tagAdd:(0,n.$Xj)("tag-add",60006),tagRemove:(0,n.$Xj)("tag-remove",60006),person:(0,n.$Xj)("person",60007),personFollow:(0,n.$Xj)("person-follow",60007),personOutline:(0,n.$Xj)("person-outline",60007),personFilled:(0,n.$Xj)("person-filled",60007),gitBranch:(0,n.$Xj)("git-branch",60008),gitBranchCreate:(0,n.$Xj)("git-branch-create",60008),gitBranchDelete:(0,n.$Xj)("git-branch-delete",60008),sourceControl:(0,n.$Xj)("source-control",60008),mirror:(0,n.$Xj)("mirror",60009),mirrorPublic:(0,n.$Xj)("mirror-public",60009),star:(0,n.$Xj)("star",60010),starAdd:(0,n.$Xj)("star-add",60010),starDelete:(0,n.$Xj)("star-delete",60010),starEmpty:(0,n.$Xj)("star-empty",60010),comment:(0,n.$Xj)("comment",60011),commentAdd:(0,n.$Xj)("comment-add",60011),alert:(0,n.$Xj)("alert",60012),warning:(0,n.$Xj)("warning",60012),search:(0,n.$Xj)("search",60013),searchSave:(0,n.$Xj)("search-save",60013),logOut:(0,n.$Xj)("log-out",60014),signOut:(0,n.$Xj)("sign-out",60014),logIn:(0,n.$Xj)("log-in",60015),signIn:(0,n.$Xj)("sign-in",60015),eye:(0,n.$Xj)("eye",60016),eyeUnwatch:(0,n.$Xj)("eye-unwatch",60016),eyeWatch:(0,n.$Xj)("eye-watch",60016),circleFilled:(0,n.$Xj)("circle-filled",60017),primitiveDot:(0,n.$Xj)("primitive-dot",60017),closeDirty:(0,n.$Xj)("close-dirty",60017),debugBreakpoint:(0,n.$Xj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Xj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Xj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Xj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Xj)("primitive-square",60018),edit:(0,n.$Xj)("edit",60019),pencil:(0,n.$Xj)("pencil",60019),info:(0,n.$Xj)("info",60020),issueOpened:(0,n.$Xj)("issue-opened",60020),gistPrivate:(0,n.$Xj)("gist-private",60021),gitForkPrivate:(0,n.$Xj)("git-fork-private",60021),lock:(0,n.$Xj)("lock",60021),mirrorPrivate:(0,n.$Xj)("mirror-private",60021),close:(0,n.$Xj)("close",60022),removeClose:(0,n.$Xj)("remove-close",60022),x:(0,n.$Xj)("x",60022),repoSync:(0,n.$Xj)("repo-sync",60023),sync:(0,n.$Xj)("sync",60023),clone:(0,n.$Xj)("clone",60024),desktopDownload:(0,n.$Xj)("desktop-download",60024),beaker:(0,n.$Xj)("beaker",60025),microscope:(0,n.$Xj)("microscope",60025),vm:(0,n.$Xj)("vm",60026),deviceDesktop:(0,n.$Xj)("device-desktop",60026),file:(0,n.$Xj)("file",60027),fileText:(0,n.$Xj)("file-text",60027),more:(0,n.$Xj)("more",60028),ellipsis:(0,n.$Xj)("ellipsis",60028),kebabHorizontal:(0,n.$Xj)("kebab-horizontal",60028),mailReply:(0,n.$Xj)("mail-reply",60029),reply:(0,n.$Xj)("reply",60029),organization:(0,n.$Xj)("organization",60030),organizationFilled:(0,n.$Xj)("organization-filled",60030),organizationOutline:(0,n.$Xj)("organization-outline",60030),newFile:(0,n.$Xj)("new-file",60031),fileAdd:(0,n.$Xj)("file-add",60031),newFolder:(0,n.$Xj)("new-folder",60032),fileDirectoryCreate:(0,n.$Xj)("file-directory-create",60032),trash:(0,n.$Xj)("trash",60033),trashcan:(0,n.$Xj)("trashcan",60033),history:(0,n.$Xj)("history",60034),clock:(0,n.$Xj)("clock",60034),folder:(0,n.$Xj)("folder",60035),fileDirectory:(0,n.$Xj)("file-directory",60035),symbolFolder:(0,n.$Xj)("symbol-folder",60035),logoGithub:(0,n.$Xj)("logo-github",60036),markGithub:(0,n.$Xj)("mark-github",60036),github:(0,n.$Xj)("github",60036),terminal:(0,n.$Xj)("terminal",60037),console:(0,n.$Xj)("console",60037),repl:(0,n.$Xj)("repl",60037),zap:(0,n.$Xj)("zap",60038),symbolEvent:(0,n.$Xj)("symbol-event",60038),error:(0,n.$Xj)("error",60039),stop:(0,n.$Xj)("stop",60039),variable:(0,n.$Xj)("variable",60040),symbolVariable:(0,n.$Xj)("symbol-variable",60040),array:(0,n.$Xj)("array",60042),symbolArray:(0,n.$Xj)("symbol-array",60042),symbolModule:(0,n.$Xj)("symbol-module",60043),symbolPackage:(0,n.$Xj)("symbol-package",60043),symbolNamespace:(0,n.$Xj)("symbol-namespace",60043),symbolObject:(0,n.$Xj)("symbol-object",60043),symbolMethod:(0,n.$Xj)("symbol-method",60044),symbolFunction:(0,n.$Xj)("symbol-function",60044),symbolConstructor:(0,n.$Xj)("symbol-constructor",60044),symbolBoolean:(0,n.$Xj)("symbol-boolean",60047),symbolNull:(0,n.$Xj)("symbol-null",60047),symbolNumeric:(0,n.$Xj)("symbol-numeric",60048),symbolNumber:(0,n.$Xj)("symbol-number",60048),symbolStructure:(0,n.$Xj)("symbol-structure",60049),symbolStruct:(0,n.$Xj)("symbol-struct",60049),symbolParameter:(0,n.$Xj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Xj)("symbol-type-parameter",60050),symbolKey:(0,n.$Xj)("symbol-key",60051),symbolText:(0,n.$Xj)("symbol-text",60051),symbolReference:(0,n.$Xj)("symbol-reference",60052),goToFile:(0,n.$Xj)("go-to-file",60052),symbolEnum:(0,n.$Xj)("symbol-enum",60053),symbolValue:(0,n.$Xj)("symbol-value",60053),symbolRuler:(0,n.$Xj)("symbol-ruler",60054),symbolUnit:(0,n.$Xj)("symbol-unit",60054),activateBreakpoints:(0,n.$Xj)("activate-breakpoints",60055),archive:(0,n.$Xj)("archive",60056),arrowBoth:(0,n.$Xj)("arrow-both",60057),arrowDown:(0,n.$Xj)("arrow-down",60058),arrowLeft:(0,n.$Xj)("arrow-left",60059),arrowRight:(0,n.$Xj)("arrow-right",60060),arrowSmallDown:(0,n.$Xj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Xj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Xj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Xj)("arrow-small-up",60064),arrowUp:(0,n.$Xj)("arrow-up",60065),bell:(0,n.$Xj)("bell",60066),bold:(0,n.$Xj)("bold",60067),book:(0,n.$Xj)("book",60068),bookmark:(0,n.$Xj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Xj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Xj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Xj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Xj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Xj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Xj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Xj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Xj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Xj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Xj)("briefcase",60076),broadcast:(0,n.$Xj)("broadcast",60077),browser:(0,n.$Xj)("browser",60078),bug:(0,n.$Xj)("bug",60079),calendar:(0,n.$Xj)("calendar",60080),caseSensitive:(0,n.$Xj)("case-sensitive",60081),check:(0,n.$Xj)("check",60082),checklist:(0,n.$Xj)("checklist",60083),chevronDown:(0,n.$Xj)("chevron-down",60084),chevronLeft:(0,n.$Xj)("chevron-left",60085),chevronRight:(0,n.$Xj)("chevron-right",60086),chevronUp:(0,n.$Xj)("chevron-up",60087),chromeClose:(0,n.$Xj)("chrome-close",60088),chromeMaximize:(0,n.$Xj)("chrome-maximize",60089),chromeMinimize:(0,n.$Xj)("chrome-minimize",60090),chromeRestore:(0,n.$Xj)("chrome-restore",60091),circleOutline:(0,n.$Xj)("circle-outline",60092),circle:(0,n.$Xj)("circle",60092),debugBreakpointUnverified:(0,n.$Xj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Xj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Xj)("circle-slash",60093),circuitBoard:(0,n.$Xj)("circuit-board",60094),clearAll:(0,n.$Xj)("clear-all",60095),clippy:(0,n.$Xj)("clippy",60096),closeAll:(0,n.$Xj)("close-all",60097),cloudDownload:(0,n.$Xj)("cloud-download",60098),cloudUpload:(0,n.$Xj)("cloud-upload",60099),code:(0,n.$Xj)("code",60100),collapseAll:(0,n.$Xj)("collapse-all",60101),colorMode:(0,n.$Xj)("color-mode",60102),commentDiscussion:(0,n.$Xj)("comment-discussion",60103),creditCard:(0,n.$Xj)("credit-card",60105),dash:(0,n.$Xj)("dash",60108),dashboard:(0,n.$Xj)("dashboard",60109),database:(0,n.$Xj)("database",60110),debugContinue:(0,n.$Xj)("debug-continue",60111),debugDisconnect:(0,n.$Xj)("debug-disconnect",60112),debugPause:(0,n.$Xj)("debug-pause",60113),debugRestart:(0,n.$Xj)("debug-restart",60114),debugStart:(0,n.$Xj)("debug-start",60115),debugStepInto:(0,n.$Xj)("debug-step-into",60116),debugStepOut:(0,n.$Xj)("debug-step-out",60117),debugStepOver:(0,n.$Xj)("debug-step-over",60118),debugStop:(0,n.$Xj)("debug-stop",60119),debug:(0,n.$Xj)("debug",60120),deviceCameraVideo:(0,n.$Xj)("device-camera-video",60121),deviceCamera:(0,n.$Xj)("device-camera",60122),deviceMobile:(0,n.$Xj)("device-mobile",60123),diffAdded:(0,n.$Xj)("diff-added",60124),diffIgnored:(0,n.$Xj)("diff-ignored",60125),diffModified:(0,n.$Xj)("diff-modified",60126),diffRemoved:(0,n.$Xj)("diff-removed",60127),diffRenamed:(0,n.$Xj)("diff-renamed",60128),diff:(0,n.$Xj)("diff",60129),diffSidebyside:(0,n.$Xj)("diff-sidebyside",60129),discard:(0,n.$Xj)("discard",60130),editorLayout:(0,n.$Xj)("editor-layout",60131),emptyWindow:(0,n.$Xj)("empty-window",60132),exclude:(0,n.$Xj)("exclude",60133),extensions:(0,n.$Xj)("extensions",60134),eyeClosed:(0,n.$Xj)("eye-closed",60135),fileBinary:(0,n.$Xj)("file-binary",60136),fileCode:(0,n.$Xj)("file-code",60137),fileMedia:(0,n.$Xj)("file-media",60138),filePdf:(0,n.$Xj)("file-pdf",60139),fileSubmodule:(0,n.$Xj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Xj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Xj)("file-symlink-file",60142),fileZip:(0,n.$Xj)("file-zip",60143),files:(0,n.$Xj)("files",60144),filter:(0,n.$Xj)("filter",60145),flame:(0,n.$Xj)("flame",60146),foldDown:(0,n.$Xj)("fold-down",60147),foldUp:(0,n.$Xj)("fold-up",60148),fold:(0,n.$Xj)("fold",60149),folderActive:(0,n.$Xj)("folder-active",60150),folderOpened:(0,n.$Xj)("folder-opened",60151),gear:(0,n.$Xj)("gear",60152),gift:(0,n.$Xj)("gift",60153),gistSecret:(0,n.$Xj)("gist-secret",60154),gist:(0,n.$Xj)("gist",60155),gitCommit:(0,n.$Xj)("git-commit",60156),gitCompare:(0,n.$Xj)("git-compare",60157),compareChanges:(0,n.$Xj)("compare-changes",60157),gitMerge:(0,n.$Xj)("git-merge",60158),githubAction:(0,n.$Xj)("github-action",60159),githubAlt:(0,n.$Xj)("github-alt",60160),globe:(0,n.$Xj)("globe",60161),grabber:(0,n.$Xj)("grabber",60162),graph:(0,n.$Xj)("graph",60163),gripper:(0,n.$Xj)("gripper",60164),heart:(0,n.$Xj)("heart",60165),home:(0,n.$Xj)("home",60166),horizontalRule:(0,n.$Xj)("horizontal-rule",60167),hubot:(0,n.$Xj)("hubot",60168),inbox:(0,n.$Xj)("inbox",60169),issueReopened:(0,n.$Xj)("issue-reopened",60171),issues:(0,n.$Xj)("issues",60172),italic:(0,n.$Xj)("italic",60173),jersey:(0,n.$Xj)("jersey",60174),json:(0,n.$Xj)("json",60175),kebabVertical:(0,n.$Xj)("kebab-vertical",60176),key:(0,n.$Xj)("key",60177),law:(0,n.$Xj)("law",60178),lightbulbAutofix:(0,n.$Xj)("lightbulb-autofix",60179),linkExternal:(0,n.$Xj)("link-external",60180),link:(0,n.$Xj)("link",60181),listOrdered:(0,n.$Xj)("list-ordered",60182),listUnordered:(0,n.$Xj)("list-unordered",60183),liveShare:(0,n.$Xj)("live-share",60184),loading:(0,n.$Xj)("loading",60185),location:(0,n.$Xj)("location",60186),mailRead:(0,n.$Xj)("mail-read",60187),mail:(0,n.$Xj)("mail",60188),markdown:(0,n.$Xj)("markdown",60189),megaphone:(0,n.$Xj)("megaphone",60190),mention:(0,n.$Xj)("mention",60191),milestone:(0,n.$Xj)("milestone",60192),gitPullRequestMilestone:(0,n.$Xj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Xj)("mortar-board",60193),move:(0,n.$Xj)("move",60194),multipleWindows:(0,n.$Xj)("multiple-windows",60195),mute:(0,n.$Xj)("mute",60196),noNewline:(0,n.$Xj)("no-newline",60197),note:(0,n.$Xj)("note",60198),octoface:(0,n.$Xj)("octoface",60199),openPreview:(0,n.$Xj)("open-preview",60200),package:(0,n.$Xj)("package",60201),paintcan:(0,n.$Xj)("paintcan",60202),pin:(0,n.$Xj)("pin",60203),play:(0,n.$Xj)("play",60204),run:(0,n.$Xj)("run",60204),plug:(0,n.$Xj)("plug",60205),preserveCase:(0,n.$Xj)("preserve-case",60206),preview:(0,n.$Xj)("preview",60207),project:(0,n.$Xj)("project",60208),pulse:(0,n.$Xj)("pulse",60209),question:(0,n.$Xj)("question",60210),quote:(0,n.$Xj)("quote",60211),radioTower:(0,n.$Xj)("radio-tower",60212),reactions:(0,n.$Xj)("reactions",60213),references:(0,n.$Xj)("references",60214),refresh:(0,n.$Xj)("refresh",60215),regex:(0,n.$Xj)("regex",60216),remoteExplorer:(0,n.$Xj)("remote-explorer",60217),remote:(0,n.$Xj)("remote",60218),remove:(0,n.$Xj)("remove",60219),replaceAll:(0,n.$Xj)("replace-all",60220),replace:(0,n.$Xj)("replace",60221),repoClone:(0,n.$Xj)("repo-clone",60222),repoForcePush:(0,n.$Xj)("repo-force-push",60223),repoPull:(0,n.$Xj)("repo-pull",60224),repoPush:(0,n.$Xj)("repo-push",60225),report:(0,n.$Xj)("report",60226),requestChanges:(0,n.$Xj)("request-changes",60227),rocket:(0,n.$Xj)("rocket",60228),rootFolderOpened:(0,n.$Xj)("root-folder-opened",60229),rootFolder:(0,n.$Xj)("root-folder",60230),rss:(0,n.$Xj)("rss",60231),ruby:(0,n.$Xj)("ruby",60232),saveAll:(0,n.$Xj)("save-all",60233),saveAs:(0,n.$Xj)("save-as",60234),save:(0,n.$Xj)("save",60235),screenFull:(0,n.$Xj)("screen-full",60236),screenNormal:(0,n.$Xj)("screen-normal",60237),searchStop:(0,n.$Xj)("search-stop",60238),server:(0,n.$Xj)("server",60240),settingsGear:(0,n.$Xj)("settings-gear",60241),settings:(0,n.$Xj)("settings",60242),shield:(0,n.$Xj)("shield",60243),smiley:(0,n.$Xj)("smiley",60244),sortPrecedence:(0,n.$Xj)("sort-precedence",60245),splitHorizontal:(0,n.$Xj)("split-horizontal",60246),splitVertical:(0,n.$Xj)("split-vertical",60247),squirrel:(0,n.$Xj)("squirrel",60248),starFull:(0,n.$Xj)("star-full",60249),starHalf:(0,n.$Xj)("star-half",60250),symbolClass:(0,n.$Xj)("symbol-class",60251),symbolColor:(0,n.$Xj)("symbol-color",60252),symbolConstant:(0,n.$Xj)("symbol-constant",60253),symbolEnumMember:(0,n.$Xj)("symbol-enum-member",60254),symbolField:(0,n.$Xj)("symbol-field",60255),symbolFile:(0,n.$Xj)("symbol-file",60256),symbolInterface:(0,n.$Xj)("symbol-interface",60257),symbolKeyword:(0,n.$Xj)("symbol-keyword",60258),symbolMisc:(0,n.$Xj)("symbol-misc",60259),symbolOperator:(0,n.$Xj)("symbol-operator",60260),symbolProperty:(0,n.$Xj)("symbol-property",60261),wrench:(0,n.$Xj)("wrench",60261),wrenchSubaction:(0,n.$Xj)("wrench-subaction",60261),symbolSnippet:(0,n.$Xj)("symbol-snippet",60262),tasklist:(0,n.$Xj)("tasklist",60263),telescope:(0,n.$Xj)("telescope",60264),textSize:(0,n.$Xj)("text-size",60265),threeBars:(0,n.$Xj)("three-bars",60266),thumbsdown:(0,n.$Xj)("thumbsdown",60267),thumbsup:(0,n.$Xj)("thumbsup",60268),tools:(0,n.$Xj)("tools",60269),triangleDown:(0,n.$Xj)("triangle-down",60270),triangleLeft:(0,n.$Xj)("triangle-left",60271),triangleRight:(0,n.$Xj)("triangle-right",60272),triangleUp:(0,n.$Xj)("triangle-up",60273),twitter:(0,n.$Xj)("twitter",60274),unfold:(0,n.$Xj)("unfold",60275),unlock:(0,n.$Xj)("unlock",60276),unmute:(0,n.$Xj)("unmute",60277),unverified:(0,n.$Xj)("unverified",60278),verified:(0,n.$Xj)("verified",60279),versions:(0,n.$Xj)("versions",60280),vmActive:(0,n.$Xj)("vm-active",60281),vmOutline:(0,n.$Xj)("vm-outline",60282),vmRunning:(0,n.$Xj)("vm-running",60283),watch:(0,n.$Xj)("watch",60284),whitespace:(0,n.$Xj)("whitespace",60285),wholeWord:(0,n.$Xj)("whole-word",60286),window:(0,n.$Xj)("window",60287),wordWrap:(0,n.$Xj)("word-wrap",60288),zoomIn:(0,n.$Xj)("zoom-in",60289),zoomOut:(0,n.$Xj)("zoom-out",60290),listFilter:(0,n.$Xj)("list-filter",60291),listFlat:(0,n.$Xj)("list-flat",60292),listSelection:(0,n.$Xj)("list-selection",60293),selection:(0,n.$Xj)("selection",60293),listTree:(0,n.$Xj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Xj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Xj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Xj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Xj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Xj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Xj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Xj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Xj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Xj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Xj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Xj)("symbol-string",60301),debugReverseContinue:(0,n.$Xj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Xj)("debug-step-back",60303),debugRestartFrame:(0,n.$Xj)("debug-restart-frame",60304),debugAlt:(0,n.$Xj)("debug-alt",60305),callIncoming:(0,n.$Xj)("call-incoming",60306),callOutgoing:(0,n.$Xj)("call-outgoing",60307),menu:(0,n.$Xj)("menu",60308),expandAll:(0,n.$Xj)("expand-all",60309),feedback:(0,n.$Xj)("feedback",60310),gitPullRequestReviewer:(0,n.$Xj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Xj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Xj)("ungroup-by-ref-type",60312),account:(0,n.$Xj)("account",60313),gitPullRequestAssignee:(0,n.$Xj)("git-pull-request-assignee",60313),bellDot:(0,n.$Xj)("bell-dot",60314),debugConsole:(0,n.$Xj)("debug-console",60315),library:(0,n.$Xj)("library",60316),output:(0,n.$Xj)("output",60317),runAll:(0,n.$Xj)("run-all",60318),syncIgnored:(0,n.$Xj)("sync-ignored",60319),pinned:(0,n.$Xj)("pinned",60320),githubInverted:(0,n.$Xj)("github-inverted",60321),serverProcess:(0,n.$Xj)("server-process",60322),serverEnvironment:(0,n.$Xj)("server-environment",60323),pass:(0,n.$Xj)("pass",60324),issueClosed:(0,n.$Xj)("issue-closed",60324),stopCircle:(0,n.$Xj)("stop-circle",60325),playCircle:(0,n.$Xj)("play-circle",60326),record:(0,n.$Xj)("record",60327),debugAltSmall:(0,n.$Xj)("debug-alt-small",60328),vmConnect:(0,n.$Xj)("vm-connect",60329),cloud:(0,n.$Xj)("cloud",60330),merge:(0,n.$Xj)("merge",60331),export:(0,n.$Xj)("export",60332),graphLeft:(0,n.$Xj)("graph-left",60333),magnet:(0,n.$Xj)("magnet",60334),notebook:(0,n.$Xj)("notebook",60335),redo:(0,n.$Xj)("redo",60336),checkAll:(0,n.$Xj)("check-all",60337),pinnedDirty:(0,n.$Xj)("pinned-dirty",60338),passFilled:(0,n.$Xj)("pass-filled",60339),circleLargeFilled:(0,n.$Xj)("circle-large-filled",60340),circleLarge:(0,n.$Xj)("circle-large",60341),circleLargeOutline:(0,n.$Xj)("circle-large-outline",60341),combine:(0,n.$Xj)("combine",60342),gather:(0,n.$Xj)("gather",60342),table:(0,n.$Xj)("table",60343),variableGroup:(0,n.$Xj)("variable-group",60344),typeHierarchy:(0,n.$Xj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Xj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Xj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Xj)("git-pull-request-create",60348),runAbove:(0,n.$Xj)("run-above",60349),runBelow:(0,n.$Xj)("run-below",60350),notebookTemplate:(0,n.$Xj)("notebook-template",60351),debugRerun:(0,n.$Xj)("debug-rerun",60352),workspaceTrusted:(0,n.$Xj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Xj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Xj)("workspace-unknown",60355),terminalCmd:(0,n.$Xj)("terminal-cmd",60356),terminalDebian:(0,n.$Xj)("terminal-debian",60357),terminalLinux:(0,n.$Xj)("terminal-linux",60358),terminalPowershell:(0,n.$Xj)("terminal-powershell",60359),terminalTmux:(0,n.$Xj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Xj)("terminal-ubuntu",60361),terminalBash:(0,n.$Xj)("terminal-bash",60362),arrowSwap:(0,n.$Xj)("arrow-swap",60363),copy:(0,n.$Xj)("copy",60364),personAdd:(0,n.$Xj)("person-add",60365),filterFilled:(0,n.$Xj)("filter-filled",60366),wand:(0,n.$Xj)("wand",60367),debugLineByLine:(0,n.$Xj)("debug-line-by-line",60368),inspect:(0,n.$Xj)("inspect",60369),layers:(0,n.$Xj)("layers",60370),layersDot:(0,n.$Xj)("layers-dot",60371),layersActive:(0,n.$Xj)("layers-active",60372),compass:(0,n.$Xj)("compass",60373),compassDot:(0,n.$Xj)("compass-dot",60374),compassActive:(0,n.$Xj)("compass-active",60375),azure:(0,n.$Xj)("azure",60376),issueDraft:(0,n.$Xj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Xj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Xj)("git-pull-request-draft",60379),debugAll:(0,n.$Xj)("debug-all",60380),debugCoverage:(0,n.$Xj)("debug-coverage",60381),runErrors:(0,n.$Xj)("run-errors",60382),folderLibrary:(0,n.$Xj)("folder-library",60383),debugContinueSmall:(0,n.$Xj)("debug-continue-small",60384),beakerStop:(0,n.$Xj)("beaker-stop",60385),graphLine:(0,n.$Xj)("graph-line",60386),graphScatter:(0,n.$Xj)("graph-scatter",60387),pieChart:(0,n.$Xj)("pie-chart",60388),bracket:(0,n.$Xj)("bracket",60175),bracketDot:(0,n.$Xj)("bracket-dot",60389),bracketError:(0,n.$Xj)("bracket-error",60390),lockSmall:(0,n.$Xj)("lock-small",60391),azureDevops:(0,n.$Xj)("azure-devops",60392),verifiedFilled:(0,n.$Xj)("verified-filled",60393),newline:(0,n.$Xj)("newline",60394),layout:(0,n.$Xj)("layout",60395),layoutActivitybarLeft:(0,n.$Xj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Xj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Xj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Xj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Xj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Xj)("layout-panel-right",60401),layoutPanel:(0,n.$Xj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Xj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Xj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Xj)("layout-statusbar",60405),layoutMenubar:(0,n.$Xj)("layout-menubar",60406),layoutCentered:(0,n.$Xj)("layout-centered",60407),target:(0,n.$Xj)("target",60408),indent:(0,n.$Xj)("indent",60409),recordSmall:(0,n.$Xj)("record-small",60410),errorSmall:(0,n.$Xj)("error-small",60411),terminalDecorationError:(0,n.$Xj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Xj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Xj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Xj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Xj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Xj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Xj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Xj)("layout-sidebar-left-off",60418),blank:(0,n.$Xj)("blank",60419),heartFilled:(0,n.$Xj)("heart-filled",60420),map:(0,n.$Xj)("map",60421),mapHorizontal:(0,n.$Xj)("map-horizontal",60421),foldHorizontal:(0,n.$Xj)("fold-horizontal",60421),mapFilled:(0,n.$Xj)("map-filled",60422),mapHorizontalFilled:(0,n.$Xj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Xj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Xj)("circle-small",60423),bellSlash:(0,n.$Xj)("bell-slash",60424),bellSlashDot:(0,n.$Xj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Xj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Xj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Xj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Xj)("search-fuzzy",60429),commentDraft:(0,n.$Xj)("comment-draft",60430),send:(0,n.$Xj)("send",60431),sparkle:(0,n.$Xj)("sparkle",60432),insert:(0,n.$Xj)("insert",60433),mic:(0,n.$Xj)("mic",60434),thumbsdownFilled:(0,n.$Xj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Xj)("thumbsup-filled",60436),coffee:(0,n.$Xj)("coffee",60437),snake:(0,n.$Xj)("snake",60438),game:(0,n.$Xj)("game",60439),vr:(0,n.$Xj)("vr",60440),chip:(0,n.$Xj)("chip",60441),piano:(0,n.$Xj)("piano",60442),music:(0,n.$Xj)("music",60443),micFilled:(0,n.$Xj)("mic-filled",60444),repoFetch:(0,n.$Xj)("repo-fetch",60445),copilot:(0,n.$Xj)("copilot",60446),lightbulbSparkle:(0,n.$Xj)("lightbulb-sparkle",60447),robot:(0,n.$Xj)("robot",60448),sparkleFilled:(0,n.$Xj)("sparkle-filled",60449),diffSingle:(0,n.$Xj)("diff-single",60450),diffMultiple:(0,n.$Xj)("diff-multiple",60451),surroundWith:(0,n.$Xj)("surround-with",60452),share:(0,n.$Xj)("share",60453),gitStash:(0,n.$Xj)("git-stash",60454),gitStashApply:(0,n.$Xj)("git-stash-apply",60455),gitStashPop:(0,n.$Xj)("git-stash-pop",60456),vscode:(0,n.$Xj)("vscode",60457),vscodeInsiders:(0,n.$Xj)("vscode-insiders",60458),codeOss:(0,n.$Xj)("code-oss",60459),runCoverage:(0,n.$Xj)("run-coverage",60460),runAllCoverage:(0,n.$Xj)("run-all-coverage",60461),coverage:(0,n.$Xj)("coverage",60462),githubProject:(0,n.$Xj)("github-project",60463),mapVertical:(0,n.$Xj)("map-vertical",60464),foldVertical:(0,n.$Xj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Xj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Xj)("fold-vertical-filled",60465),goToSearch:(0,n.$Xj)("go-to-search",60466),percentage:(0,n.$Xj)("percentage",60467),sortPercentage:(0,n.$Xj)("sort-percentage",60467),attach:(0,n.$Xj)("attach",60468)}}),define(ce[80],le([0,1,109,148]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=void 0,e.$1j=P;function P(){return Object.values(e.$3j)}e.$2j={dialogError:(0,n.$Xj)("dialog-error","error"),dialogWarning:(0,n.$Xj)("dialog-warning","warning"),dialogInfo:(0,n.$Xj)("dialog-info","info"),dialogClose:(0,n.$Xj)("dialog-close","close"),treeItemExpanded:(0,n.$Xj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Xj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Xj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Xj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Xj)("tree-item-loading","loading"),menuSelection:(0,n.$Xj)("menu-selection","check"),menuSubmenu:(0,n.$Xj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Xj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Xj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Xj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Xj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Xj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Xj)("toolbar-more","more"),quickInputBack:(0,n.$Xj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Xj)("drop-down-button",60084),symbolCustomColor:(0,n.$Xj)("symbol-customcolor",60252),exportIcon:(0,n.$Xj)("export",60332),workspaceUnspecified:(0,n.$Xj)("workspace-unspecified",60355),newLine:(0,n.$Xj)("newline",60394),thumbsDownFilled:(0,n.$Xj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Xj)("thumbsup-filled",60436),gitFetch:(0,n.$Xj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Xj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Xj)("debug-breakpoint-pending",60377)},e.$3j={...r.$Zj,...e.$2j}}),define(ce[37],le([0,1,12]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=r,e.$do=P,e.$eo=T,e.$fo=p,e.$go=c,e.$ho=m,e.$io=h,e.$jo=d,e.$ko=w,e.$lo=f,e.$mo=g,e.$no=v,e.$oo=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const k=Array.isArray($)?[]:{};return Object.entries($).forEach(([E,t])=>{k[E]=t&&typeof t=="object"?r(t):t}),k}function P($){if(!$||typeof $!="object")return $;const k=[$];for(;k.length>0;){const E=k.shift();Object.freeze(E);for(const t in E)if(A.call(E,t)){const u=E[t];typeof u=="object"&&!Object.isFrozen(u)&&!(0,n.$gg)(u)&&k.push(u)}}return $}const A=Object.prototype.hasOwnProperty;function T($,k){return I($,k,new Set)}function I($,k,E){if((0,n.$mg)($))return $;const t=k($);if(typeof t<"u")return t;if(Array.isArray($)){const u=[];for(const i of $)u.push(I(i,k,E));return u}if((0,n.$fg)($)){if(E.has($))throw new Error("Cannot clone recursive data-structure");E.add($);const u={};for(const i in $)A.call($,i)&&(u[i]=I($[i],k,E));return E.delete($),u}return $}function p($,k,E=!0){return(0,n.$fg)($)?((0,n.$fg)(k)&&Object.keys(k).forEach(t=>{t in $?E&&((0,n.$fg)($[t])&&(0,n.$fg)(k[t])?p($[t],k[t],E):$[t]=k[t]):$[t]=k[t]}),$):k}function c($,k){if($===k)return!0;if($==null||k===null||k===void 0||typeof $!=typeof k||typeof $!="object"||Array.isArray($)!==Array.isArray(k))return!1;let E,t;if(Array.isArray($)){if($.length!==k.length)return!1;for(E=0;E<$.length;E++)if(!c($[E],k[E]))return!1}else{const u=[];for(t in $)u.push(t);u.sort();const i=[];for(t in k)i.push(t);if(i.sort(),!c(u,i))return!1;for(E=0;E<u.length;E++)if(!c($[u[E]],k[u[E]]))return!1}return!0}function m($){const k=new Set;return JSON.stringify($,(E,t)=>{if((0,n.$fg)(t)||Array.isArray(t)){if(k.has(t))return"[Circular]";k.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function h($,k){const E=Object.create(null);return!$||!k||Object.keys(k).forEach(u=>{const i=$[u],o=k[u];c(i,o)||(E[u]=o)}),E}function d($,k){const E=k.toLowerCase(),t=Object.keys($).find(u=>u.toLowerCase()===E);return t?$[t]:$[k]}function w($,k){const E=Object.create(null);for(const[t,u]of Object.entries($))k(t,u)&&(E[t]=u);return E}function f($){let k=[];for(;Object.prototype!==$;)k=k.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return k}function g($){const k=[];for(const E of f($))typeof $[E]=="function"&&k.push(E);return k}function v($,k){const E=u=>function(){const i=Array.prototype.slice.call(arguments,0);return k(u,i)},t={};for(const u of $)t[u]=E(u);return t}function b($,k){const E={};for(const[t,u]of Object.entries($))E[t]=k(u,t);return E}}),define(ce[110],le([0,1,80]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$4j=P;var r;(function(T){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function P(T){return{id:T}}var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p($){const k=I.exec($.id);if(!k)return p(n.$3j.error);const[,E,t]=k,u=["codicon","codicon-"+E];return t&&u.push("codicon-modifier-"+t.substring(1)),u}T.asClassNameArray=p;function c($){return p($).join(" ")}T.asClassName=c;function m($){return"."+p($).join(".")}T.asCSSSelector=m;function h($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=h;const d=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function w($){const k=d.exec($);if(!k)return;const[,E]=k;return{id:E}}T.fromString=w;function f($){return{id:$}}T.fromId=f;function g($,k){let E=$.id;const t=E.lastIndexOf("~");return t!==-1&&(E=E.substring(0,t)),k&&(E=`${E}~${k}`),{id:E}}T.modify=g;function v($){const k=$.id.lastIndexOf("~");if(k!==-1)return $.id.substring(k+1)}T.getModifier=v;function b($,k){return $.id===k.id&&$.color?.id===k.color?.id}T.isEqual=b})(A||(e.ThemeIcon=A={}))}),define(ce[149],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$_e=r,e.$af=P;var n;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(A){return A<0?0:A>n.MAX_UINT_8?n.MAX_UINT_8:A|0}function P(A){return A<0?0:A>n.MAX_UINT_32?n.MAX_UINT_32:A|0}}),define(ce[25],le([0,1,146,39,65,149]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.GraphemeBreakType=e.$3f=e.$Uf=e.$Nf=e.$Mf=void 0,e.$bf=T,e.$cf=p,e.$df=m,e.$ef=h,e.$ff=d,e.$gf=w,e.$hf=f,e.$if=g,e.$jf=v,e.$kf=b,e.$lf=$,e.$mf=k,e.$nf=E,e.$of=t,e.$pf=u,e.$qf=i,e.$rf=o,e.$sf=s,e.$tf=a,e.$uf=l,e.$vf=S,e.$wf=y,e.$xf=D,e.$yf=L,e.$zf=R,e.$Af=O,e.$Bf=M,e.$Cf=x,e.$Df=X,e.$Ef=K,e.$Ff=fe,e.$Gf=H,e.$Hf=J,e.$If=U,e.$Jf=Z,e.$Kf=B,e.$Lf=j,e.$Of=G,e.$Pf=ue,e.$Qf=re,e.$Rf=Q,e.$Sf=W,e.$Tf=te,e.$Vf=ee,e.$Wf=q,e.$Xf=ne,e.$Yf=de,e.$Zf=we,e.$1f=Ie,e.$2f=Oe,e.$4f=Ee,e.$5f=$e,e.$6f=_,e.$7f=ae,e.$8f=he,e.$9f=be,e.$0f=De,e.$$f=Fe,e.$_f=Ze;function T(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const I=/{(\d+)}/g;function p(ie,...ge){return ge.length===0?ie:ie.replace(I,function(pe,ye){const je=parseInt(ye,10);return isNaN(je)||je<0||je>=ge.length?pe:ge[je]})}const c=/{([^}]+)}/g;function m(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(c,(pe,ye)=>ge[ye]??pe)}function h(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function d(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ie,ge){let pe=0,ye=ie.indexOf(ge);for(;ye!==-1;)pe++,ye=ie.indexOf(ge,ye+ge.length);return pe}function g(ie,ge,pe="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${pe}`}function v(ie,ge,pe="\u2026"){if(ie.length<=ge)return ie;const ye=Math.ceil(ge/2)-pe.length/2,je=Math.floor(ge/2)-pe.length/2;return`${ie.substr(0,ye)}${pe}${ie.substr(ie.length-je)}`}function b(ie,ge=" "){const pe=$(ie,ge);return k(pe,ge)}function $(ie,ge){if(!ie||!ge)return ie;const pe=ge.length;if(pe===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(ge,ye)===ye;)ye=ye+pe;return ie.substring(ye)}function k(ie,ge){if(!ie||!ge)return ie;const pe=ge.length,ye=ie.length;if(pe===0||ye===0)return ie;let je=ye,Ue=-1;for(;Ue=ie.lastIndexOf(ge,je-1),!(Ue===-1||Ue+pe!==je);){if(Ue===0)return"";je=Ue}return ie.substring(0,je)}function E(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ie){return ie.replace(/\*/g,"")}function u(ie,ge,pe={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=w(ie)),pe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ie,ye)}function i(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function o(ie){return ie.split(/\r\n|\r|\n/)}function s(ie){const ge=[],pe=ie.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ie){for(let ge=0,pe=ie.length;ge<pe;ge++){const ye=ie.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ie,ge=0,pe=ie.length){for(let ye=ge;ye<pe;ye++){const je=ie.charCodeAt(ye);if(je!==r.CharCode.Space&&je!==r.CharCode.Tab)return ie.substring(ge,ye)}return ie.substring(ge,pe)}function S(ie,ge=ie.length-1){for(let pe=ge;pe>=0;pe--){const ye=ie.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ie,ge,pe){const ye=[];let je=0;for(const Ue of ie.matchAll(ge)){if(ye.push(ie.slice(je,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");je=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ie,Ue.groups))}return ye.push(ie.slice(je)),Promise.all(ye).then(Ue=>Ue.join(""))}function D(ie,ge){return ie<ge?-1:ie>ge?1:0}function L(ie,ge,pe=0,ye=ie.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){const rt=ie.charCodeAt(pe),at=ge.charCodeAt(je);if(rt<at)return-1;if(rt>at)return 1}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function R(ie,ge){return O(ie,ge,0,ie.length,0,ge.length)}function O(ie,ge,pe=0,ye=ie.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){let rt=ie.charCodeAt(pe),at=ge.charCodeAt(je);if(rt===at)continue;if(rt>=128||at>=128)return L(ie.toLowerCase(),ge.toLowerCase(),pe,ye,je,Ue);x(rt)&&(rt-=32),x(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function M(ie){return ie>=r.CharCode.Digit0&&ie<=r.CharCode.Digit9}function x(ie){return ie>=r.CharCode.a&&ie<=r.CharCode.z}function X(ie){return ie>=r.CharCode.A&&ie<=r.CharCode.Z}function K(ie,ge){return ie.length===ge.length&&O(ie,ge)===0}function fe(ie,ge){const pe=ge.length;return ge.length>ie.length?!1:O(ie,ge,0,pe)===0}function H(ie,ge){const pe=Math.min(ie.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ie.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function J(ie,ge){const pe=Math.min(ie.length,ge.length);let ye;const je=ie.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ie.charCodeAt(je-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function U(ie){return 55296<=ie&&ie<=56319}function Z(ie){return 56320<=ie&&ie<=57343}function B(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function j(ie,ge,pe){const ye=ie.charCodeAt(pe);if(U(ye)&&pe+1<ge){const je=ie.charCodeAt(pe+1);if(Z(je))return B(ye,je)}return ye}function C(ie,ge){const pe=ie.charCodeAt(ge-1);if(Z(pe)&&ge>1){const ye=ie.charCodeAt(ge-2);if(U(ye))return B(ye,pe)}return pe}class Y{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=C(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Mf=Y;class oe{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new Y(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(je,_e)){pe.setOffset(Ue);break}je=_e}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(_e,je)){pe.setOffset(Ue);break}je=_e}return ye-pe.offset}eol(){return this.c.eol()}}e.$Nf=oe;function G(ie,ge){return new oe(ie,ge).nextGraphemeLength()}function ue(ie,ge){return new oe(ie,ge).prevGraphemeLength()}function re(ie,ge){ge>0&&Z(ie.charCodeAt(ge))&&ge--;const pe=ge+G(ie,ge);return[pe-ue(ie,pe),pe]}function Q(ie){const ge=new oe(ie);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let F;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(ie){return F||(F=N()),F.test(ie)}const z=/^[\t\n\r\x20-\x7E]*$/;function te(ie){return z.test(ie)}e.$Uf=/[\u2028\u2029]/;function ee(ie){return e.$Uf.test(ie)}function q(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function ne(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function de(ie,ge,pe=""){const ye=ie.trimStart();if(ye.length<ge)return ye;const je=/\b/g;let Ue=0;for(;je.test(ye)&&!(ye.length-je.lastIndex<ge);)Ue=je.lastIndex,je.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ie){let ge=0;for(const pe of ie.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ie.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ie.length&&(yield{isCode:!1,str:ie.substring(ge)})}function Ie(ie){return ie&&(ie=ie.replace(me,"")),ie}const We=/\\\[.*?\\\]/g;function Oe(ie){return Ie(ie).replace(We,"")}e.$3f=String.fromCharCode(r.CharCode.UTF8_BOM);function Ee(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ie){return Ee(ie)?ie.substr(1):ie}function _(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const pe=ge.length,ye=ie.toLowerCase();let je=0,Ue=-1;for(;je<pe;){const _e=ye.indexOf(ge[je],Ue+1);if(_e<0)return!1;Ue=_e,je++}return!0}function ae(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function he(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function be(ie,ge=1){if(ge===0)return"";let pe=-1;do pe=ie.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ie:(ie[pe-1]==="\r"&&pe--,ie.substr(0,pe))}function De(ie){const ge=r.CharCode.Z-r.CharCode.A+1;return ie=ie%(2*ge),ie<ge?String.fromCharCode(r.CharCode.a+ie):String.fromCharCode(r.CharCode.A+ie-ge)}function Fe(ie){return Be.getInstance().getGraphemeBreakType(ie)}function Me(ie,ge){return ie===Ae.Other?ge!==Ae.Extend&&ge!==Ae.SpacingMark:ie===Ae.CR&&ge===Ae.LF?!1:ie===Ae.Control||ie===Ae.CR||ie===Ae.LF||ge===Ae.Control||ge===Ae.CR||ge===Ae.LF?!0:!(ie===Ae.L&&(ge===Ae.L||ge===Ae.V||ge===Ae.LV||ge===Ae.LVT)||(ie===Ae.LV||ie===Ae.V)&&(ge===Ae.V||ge===Ae.T)||(ie===Ae.LVT||ie===Ae.T)&&ge===Ae.T||ge===Ae.Extend||ge===Ae.ZWJ||ge===Ae.SpacingMark||ie===Ae.Prepend||ie===Ae.ZWJ&&ge===Ae.Extended_Pictographic||ie===Ae.Regional_Indicator&&ge===Ae.Regional_Indicator)}var Ae;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Ae.LF:ge===r.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(ge<127)return Ae.Other;const pe=this.d,ye=pe.length/3;let je=1;for(;je<=ye;)if(ge<pe[3*je])je=2*je;else if(ge>pe[3*je+1])je=2*je+1;else return pe[3*je+2];return Ae.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(ie,ge){if(ie===0)return 0;const pe=qe(ie,ge);if(pe!==void 0)return pe;const ye=new Y(ge,ie);return ye.prevCodePoint(),ye.offset}function qe(ie,ge){const pe=new Y(ge,ie);let ye=pe.prevCodePoint();for(;Ye(ye)||ye===Qe.emojiVariantSelector||ye===Qe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ne(ye))return;let je=pe.offset;return je>0&&pe.prevCodePoint()===Qe.zwj&&(je=pe.offset),je}function Ye(ie){return 127995<=ie&&ie<=127999}var Qe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$ag="\xA0";class Je{static{this.c=new P.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$0e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function je(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=pe(Ue[tt]);lt=je(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Je(at)})}static getInstance(ge){return Je.d.get(Array.from(ge))}static{this.e=new P.$T(()=>Object.keys(Je.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Je.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$bg=Je;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$cg=Ce}),define(ce[32],le([0,1,39,9,3,25,12]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=I,e.$wg=p,e.$xg=c,e.$yg=m,e.$zg=h,e.$Ag=g,e.$Bg=v,e.$Cg=b,e.$Dg=$,e.$Eg=k,e.$Fg=E,e.$Gg=t,e.$Hg=u,e.$Ig=i,e.$Jg=o,e.$Kg=s,e.$Lg=S;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$fc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function m(y,D=r.$fc.sep){if(!y)return"";const L=y.length,R=y.charCodeAt(0);if(I(R)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let M=3;const x=M;for(;M<L&&!I(y.charCodeAt(M));M++);if(x!==M&&!I(y.charCodeAt(M+1))){for(M+=1;M<L;M++)if(I(y.charCodeAt(M)))return y.slice(0,M+1).replace(/[\\/]/g,D)}}return D}else if($(R)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+D:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function h(y){if(!P.$j||!y||y.length<5)return!1;let D=y.charCodeAt(0);if(D!==n.CharCode.Backslash||(D=y.charCodeAt(1),D!==n.CharCode.Backslash))return!1;let L=2;const R=L;for(;L<y.length&&(D=y.charCodeAt(L),D!==n.CharCode.Backslash);L++);return!(R===L||(D=y.charCodeAt(L+1),isNaN(D)||D===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,D=P.$j){const L=D?d:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||D&&f.test(y)||y==="."||y===".."||D&&y[y.length-1]==="."||D&&y.length!==y.trim().length||y.length>255)}function v(y,D,L){const R=y===D;return!L||R?R:!y||!D?!1:(0,A.$Ef)(y,D)}function b(y,D,L,R=r.sep){if(y===D)return!0;if(!y||!D||D.length>y.length)return!1;if(L){if(!(0,A.$Ff)(y,D))return!1;if(D.length===y.length)return!0;let M=D.length;return D.charAt(D.length-1)===R&&M--,y.charAt(M)===R}return D.charAt(D.length-1)!==R&&(D+=R),y.indexOf(D)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function k(y,D){return P.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$hc)(y)||(y=(0,r.$ic)(D,y)),y=(0,r.$gc)(y),E(y)}function E(y){return P.$j?(y=(0,A.$mf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,A.$mf)(y,r.sep),y||(y=r.sep)),y}function t(y){const D=(0,r.$gc)(y);return P.$j?y.length>3?!1:u(D)&&(y.length===2||D.charCodeAt(2)===n.CharCode.Backslash):D===r.$fc.sep}function u(y,D=P.$j){return D?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,D=P.$j){return u(y,D)?y[0]:void 0}function o(y,D,L){return D.length>y.length?-1:y===D?0:(L&&(y=y.toLowerCase(),D=D.toLowerCase()),y.indexOf(D))}function s(y){const D=y.split(":");let L,R,O;for(const M of D){const x=Number(M);(0,T.$hg)(x)?R===void 0?R=x:O===void 0&&(O=x):L=L?[L,M].join(":"):M}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:R!==void 0?R:void 0,column:O!==void 0?O:R!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,D,L=8){let R="";for(let M=0;M<L;M++){let x;M===0&&P.$j&&!D&&(L===3||L===4)?x=l:x=a,R+=x.charAt(Math.floor(Math.random()*x.length))}let O;return D?O=`${D}-${R}`:O=R,y?(0,r.$ic)(y,O):O}}),define(ce[46],le([0,1,25]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$vj=void 0,e.$rj=r,e.$sj=P,e.$tj=A,e.$uj=I,e.$wj=g,n=Pe(n);function r(b){return P(b,0)}function P(b,$){switch(typeof b){case"object":return b===null?A(349,$):Array.isArray(b)?p(b,$):c(b,$);case"string":return I(b,$);case"boolean":return T(b,$);case"number":return A(b,$);case"undefined":return A(937,$);default:return A(617,$)}}function A(b,$){return($<<5)-$+b|0}function T(b,$){return A(b?433:863,$)}function I(b,$){$=A(149417,$);for(let k=0,E=b.length;k<E;k++)$=A(b.charCodeAt(k),$);return $}function p(b,$){return $=A(104579,$),b.reduce((k,E)=>P(E,k),$)}function c(b,$){return $=A(181387,$),Object.keys(b).sort().reduce((k,E)=>(k=I(E,k),P(b[E],k)),$)}class m{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=P($,this.g),this.g}}e.$vj=m;var h;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function d(b,$,k=32){const E=k-$,t=~((1<<E)-1);return(b<<$|(t&b)>>>E)>>>0}function w(b,$=0,k=b.byteLength,E=0){for(let t=0;t<k;t++)b[$+t]=E}function f(b,$,k="0"){for(;b.length<$;)b=k+b;return b}function g(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(k=>k.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const k=$.length;if(k===0)return;const E=this.p;let t=this.r,u=this.u,i,o;for(u!==0?(i=u,o=-1,u=0):(i=$.charCodeAt(0),o=0);;){let s=i;if(n.$If(i))if(o+1<k){const a=$.charCodeAt(o+1);n.$Jf(a)?(o++,s=n.$Kf(i,a)):s=h.UNICODE_REPLACEMENT}else{u=i;break}else n.$Jf(i)&&(s=h.UNICODE_REPLACEMENT);if(t=this.w(E,t,s),o++,o<k)i=$.charCodeAt(o);else break}this.r=t,this.u=u}w($,k,E){return E<128?$[k++]=E:E<2048?($[k++]=192|(E&1984)>>>6,$[k++]=128|(E&63)>>>0):E<65536?($[k++]=224|(E&61440)>>>12,$[k++]=128|(E&4032)>>>6,$[k++]=128|(E&63)>>>0):($[k++]=240|(E&1835008)>>>18,$[k++]=128|(E&258048)>>>12,$[k++]=128|(E&4032)>>>6,$[k++]=128|(E&63)>>>0),k>=h.BLOCK_SIZE&&(this.y(),k-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,$[0]=$[h.BLOCK_SIZE+0],$[1]=$[h.BLOCK_SIZE+1],$[2]=$[h.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,k=this.q;for(let S=0;S<64;S+=4)$.setUint32(S,k.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)$.setUint32(S,d($.getUint32(S-12,!1)^$.getUint32(S-32,!1)^$.getUint32(S-56,!1)^$.getUint32(S-64,!1),1),!1);let E=this.h,t=this.l,u=this.m,i=this.n,o=this.o,s,a,l;for(let S=0;S<80;S++)S<20?(s=t&u|~t&i,a=1518500249):S<40?(s=t^u^i,a=1859775393):S<60?(s=t&u|t&i|u&i,a=2400959708):(s=t^u^i,a=3395469782),l=d(E,5)+s+o+a+$.getUint32(S*4,!1)&4294967295,o=i,i=u,u=d(t,30),t=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+t&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$xj=v}),define(ce[81],le([0,1,25]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Pe(n);var r;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(r||(r={})),function(P){const A="error",T="warning",I="warn",p="info",c="ignore";function m(d){return d?n.$Ef(A,d)?P.Error:n.$Ef(T,d)||n.$Ef(I,d)?P.Warning:n.$Ef(p,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=m;function h(d){switch(d){case P.Error:return A;case P.Warning:return T;case P.Info:return p;default:return c}}P.toString=h}(r||(r={})),e.default=r}),define(ce[60],le([0,1,21,39,25]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class A{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return g-v}value(){return this.b[this.c]}}e.$Fi=A;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,P.$yf)(f,this.b,0,f.length,this.c,this.d):(0,P.$Af)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Gi=T;class I{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const v=this.b.charCodeAt(g);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===r.CharCode.Slash||this.f&&g===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,P.$yf)(f,this.b,0,f.length,this.d,this.e):(0,P.$Af)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Hi=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,P.$zf)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$zf)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,P.$xf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$xf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ii=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(h||(h={}));class d{static forUris(f=()=>!1,g=()=>!1){return new d(new c(f,g))}static forPaths(f=!1){return new d(new I(void 0,!f))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const v=g.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,g){const v=this.b.reset(f);let b;this.c||(this.c=new m,this.c.segment=v.value());const $=[];for(b=this.c;;){const E=v.cmp(b.segment);if(E>0)b.left||(b.left=new m,b.left.segment=v.value()),$.push([h.Left,b]),b=b.left;else if(E<0)b.right||(b.right=new m,b.right.segment=v.value()),$.push([h.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new m,b.mid.segment=v.value()),$.push([h.Mid,b]),b=b.mid;else break}const k=b.value;b.value=g,b.key=f;for(let E=$.length-1;E>=0;E--){const t=$[E][1];t.updateHeight();const u=t.balanceFactor();if(u<-1||u>1){const i=$[E][0],o=$[E+1][0];if(i===h.Right&&o===h.Right)$[E][1]=t.rotateLeft();else if(i===h.Left&&o===h.Left)$[E][1]=t.rotateRight();else if(i===h.Right&&o===h.Left)t.right=$[E+1][1]=$[E+1][1].rotateRight(),$[E][1]=t.rotateLeft();else if(i===h.Left&&o===h.Right)t.left=$[E+1][1]=$[E+1][1].rotateLeft(),$[E][1]=t.rotateRight();else throw new Error;if(E>0)switch($[E-1][0]){case h.Left:$[E-1][1].left=$[E][1];break;case h.Right:$[E-1][1].right=$[E][1];break;case h.Mid:$[E-1][1].mid=$[E][1];break}else this.c=$[0][1]}}return k}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let v=this.c;for(;v;){const b=g.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(g.hasNext())g.next(),v=v.mid;else break}return v}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const k=v.cmp($.segment);if(k>0)b.push([h.Left,$]),$=$.left;else if(k<0)b.push([h.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([h.Mid,$]),$=$.mid;else break}if($){if(g?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const k=this.f($.right);if(k.key){const{key:E,value:t,segment:u}=k;this.e(k.key,!1),$.key=E,$.value=t,$.segment=u}}else{const k=$.left??$.right;if(b.length>0){const[E,t]=b[b.length-1];switch(E){case h.Left:t.left=k;break;case h.Mid:t.mid=k;break;case h.Right:t.right=k;break}}else this.c=k}for(let k=b.length-1;k>=0;k--){const E=b[k][1];E.updateHeight();const t=E.balanceFactor();if(t>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),b[k][1]=E.rotateLeft()):t<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),b[k][1]=E.rotateRight()),k>0)switch(b[k-1][0]){case h.Left:b[k-1][1].left=b[k][1];break;case h.Right:b[k-1][1].right=b[k][1];break;case h.Mid:b[k-1][1].mid=b[k][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let v=this.c,b;for(;v;){const $=g.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(g.hasNext())g.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,g){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):g?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,v]of this)f(v,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){f&&(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const v=g.balanceFactor();return v<-1||v>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.$Ji=d}),define(ce[7],le([0,1,39,90,9,3]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=v,e.$vc=u,P=Pe(P);const T=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function c(l,S){if(!l.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,S){return!l&&!S?"file":l}function h(l,S){switch(l){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const d="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(S){return S instanceof g?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,y,D,L,R,O=!1){typeof S=="object"?(this.scheme=S.scheme||d,this.authority=S.authority||d,this.path=S.path||d,this.query=S.query||d,this.fragment=S.fragment||d):(this.scheme=m(S,O),this.authority=y||d,this.path=h(this.scheme,D||d),this.query=L||d,this.fragment=R||d,c(this,O))}get fsPath(){return u(this,!1)}with(S){if(!S)return this;let{scheme:y,authority:D,path:L,query:R,fragment:O}=S;return y===void 0?y=this.scheme:y===null&&(y=d),D===void 0?D=this.authority:D===null&&(D=d),L===void 0?L=this.path:L===null&&(L=d),R===void 0?R=this.query:R===null&&(R=d),O===void 0?O=this.fragment:O===null&&(O=d),y===this.scheme&&D===this.authority&&L===this.path&&R===this.query&&O===this.fragment?this:new $(y,D,L,R,O)}static parse(S,y=!1){const D=f.exec(S);return D?new $(D[2]||d,a(D[4]||d),a(D[5]||d),a(D[7]||d),a(D[9]||d),y):new $(d,d,d,d,d)}static file(S){let y=d;if(A.$j&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const D=S.indexOf(w,2);D===-1?(y=S.substring(2),S=w):(y=S.substring(2,D),S=S.substring(D)||w)}return new $("file",y,S,d,d)}static from(S,y){return new $(S.scheme,S.authority,S.path,S.query,S.fragment,y)}static joinPath(S,...y){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return A.$j&&S.scheme==="file"?D=g.file(P.$ec.join(u(S,!0),...y)).path:D=P.$fc.join(S.path,...y),S.with({path:D})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof g)return S;{const y=new $(S);return y._formatted=S.external??null,y._fsPath=S._sep===b?S.fsPath??null:null,y}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=A.$j?1:void 0;class $ extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:r.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=b),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const k={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function E(l,S,y){let D,L=-1;for(let R=0;R<l.length;R++){const O=l.charCodeAt(R);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||S&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(D+=encodeURIComponent(l.substring(L,R)),L=-1),D!==void 0&&(D+=l.charAt(R));else{D===void 0&&(D=l.substr(0,R));const M=k[O];M!==void 0?(L!==-1&&(D+=encodeURIComponent(l.substring(L,R)),L=-1),D+=M):L===-1&&(L=R)}}return L!==-1&&(D+=encodeURIComponent(l.substring(L))),D!==void 0?D:l}function t(l){let S;for(let y=0;y<l.length;y++){const D=l.charCodeAt(y);D===n.CharCode.Hash||D===n.CharCode.QuestionMark?(S===void 0&&(S=l.substr(0,y)),S+=k[D]):S!==void 0&&(S+=l[y])}return S!==void 0?S:l}function u(l,S){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?S?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,A.$j&&(y=y.replace(/\//g,"\\")),y}function i(l,S){const y=S?t:E;let D="",{scheme:L,authority:R,path:O,query:M,fragment:x}=l;if(L&&(D+=L,D+=":"),(R||L==="file")&&(D+=w,D+=w),R){let X=R.indexOf("@");if(X!==-1){const K=R.substr(0,X);R=R.substr(X+1),X=K.lastIndexOf(":"),X===-1?D+=y(K,!1,!1):(D+=y(K.substr(0,X),!1,!1),D+=":",D+=y(K.substr(X+1),!1,!0)),D+="@"}R=R.toLowerCase(),X=R.lastIndexOf(":"),X===-1?D+=y(R,!1,!0):(D+=y(R.substr(0,X),!1,!0),D+=R.substr(X))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const X=O.charCodeAt(1);X>=n.CharCode.A&&X<=n.CharCode.Z&&(O=`/${String.fromCharCode(X+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const X=O.charCodeAt(0);X>=n.CharCode.A&&X<=n.CharCode.Z&&(O=`${String.fromCharCode(X+32)}:${O.substr(2)}`)}D+=y(O,!0,!1)}return M&&(D+="?",D+=y(M,!1,!1)),x&&(D+="#",D+=S?x:E(x,!1,!1)),D}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,S=>o(S)):l}}),define(ce[150],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=r,e.$cr=P,e.$dr=A,e.log=I;function r(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function P(c){const m=[];let h;try{const d=JSON.parse(c.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),h=w.__$stack),m.push(...d)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:h}}function A(c){if(typeof c!="string")return A(P(c).stack);const m=c;if(m){const h=T(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(d&&d.length===4)return{uri:n.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function T(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:h,stack:d}=P(c),w=typeof h[0]=="string"&&h.length===1;let f=T(d);f&&(f=`(${f.trim()})`);let g=[];if(typeof h[0]=="string"?f&&w?g=[`%c[${m}] %c${h[0]} %c${f}`,p("blue"),p(""),p("grey")]:g=[`%c[${m}] %c${h[0]}`,p("blue"),p(""),...h.slice(1)]:g=[`%c[${m}]%`,p("blue"),...h],f&&!w&&g.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function p(c){return`color: ${c}`}}),define(ce[82],le([0,1,17,7,90]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=A,e.$_h=T,e.$ai=p;function A(c){return JSON.stringify(c,I)}function T(c){let m=JSON.parse(c);return m=p(m),m}function I(c,m){return m instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function p(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return r.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Me||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let h=0;h<c.length;++h)c[h]=p(c[h],m+1);else for(const h in c)Object.hasOwnProperty.call(c,h)&&(c[h]=p(c[h],m+1))}return c}}),define(ce[11],le([0,1,15,3,25,7,9]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Qg=e.$Pg=e.$Og=e.Schemas=void 0,e.$Mg=p,e.$Ng=c,e.$Rg=h,n=Pe(n),r=Pe(r),T=Pe(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,g){return A.URI.isUri(f)?(0,P.$Ef)(f.scheme,g):(0,P.$Ff)(f,g+":")}function c(f,...g){return g.some(v=>p(f,v))}e.$Og="vscode-tkn",e.$Pg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,v){this.f=h(g,v)}getServerRootPath(){return this.f}get g(){return T.$fc.join(this.f,I.vscodeRemoteResource)}set(g,v,b){this.a[g]=v,this.b[g]=b}setConnectionToken(g,v){this.c[g]=v}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(t){return n.$Y(t),g}const v=g.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],k=this.c[v];let E=`path=${encodeURIComponent(g.path)}`;return typeof k=="string"&&(E+=`&${e.$Pg}=${encodeURIComponent(k)}`),A.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:E})}}e.$Qg=new m;function h(f,g){return T.$fc.join(g??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Sg="vs/../../extensions",e.$Tg="vs/../../node_modules",e.$Ug="vs/../../node_modules.asar",e.$Vg="vs/../../node_modules.asar.unpacked",e.$Wg="vscode-app";class d{static{this.a=e.$Wg}asBrowserUri(g){const v=this.b(g,V);return this.uriToBrowserUri(v)}uriToBrowserUri(g){return g.scheme===I.vscodeRemote?e.$Qg.rewrite(g):g.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${d.a}`)?g.with({scheme:I.vscodeFileResource,authority:g.authority||d.a,query:null,fragment:null}):g}asFileUri(g){const v=this.b(g,V);return this.uriToFileUri(v)}uriToFileUri(g){return g.scheme===I.vscodeFileResource?g.with({scheme:I.file,authority:g.authority!==d.a?g.authority:null,query:null,fragment:null}):g}b(g,v){return A.URI.isUri(g)?g:A.URI.parse(v.toUrl(g))}}e.$Xg=new d;var w;(function(f){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(g.get("3"));const v="vscode-coi";function b(k){let E;typeof k=="string"?E=new URL(k).searchParams:k instanceof URL?E=k.searchParams:A.URI.isUri(k)&&(E=new URL(k.toString(!0)).searchParams);const t=E?.get(v);if(t)return g.get(t)}f.getHeadersFromQuery=b;function $(k,E,t){if(!globalThis.crossOriginIsolated)return;const u=E&&t?"3":t?"2":"1";k instanceof URLSearchParams?k.set(v,u):k[v]=u}f.addSearchParam=$})(w||(e.COI=w={}))}),define(ce[18],le([0,1,39,32,11,9,3,25,7]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=void 0,e.$5g=c,e.$nh=h,e.$oh=w,r=Pe(r),A=Pe(A);function c(f){return(0,p.$vc)(f,!0)}class m{constructor(g){this.a=g}compare(g,v,b=!1){return g===v?0:(0,I.$xf)(this.getComparisonKey(g,b),this.getComparisonKey(v,b))}isEqual(g,v,b=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,b)===this.getComparisonKey(v,b)}getComparisonKey(g,v=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,v,b=!1){if(g.scheme===v.scheme){if(g.scheme===P.Schemas.file)return r.$Cg(c(g),c(v),this.a(g))&&g.query===v.query&&(b||g.fragment===v.fragment);if((0,e.$jh)(g.authority,v.authority))return r.$Cg(g.path,v.path,this.a(g),"/")&&g.query===v.query&&(b||g.fragment===v.fragment)}return!1}joinPath(g,...v){return p.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.$bh)(g)||g.authority}basename(g){return A.$fc.basename(g.path)}extname(g){return A.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===P.Schemas.file?v=p.URI.file(A.$lc(c(g))).path:(v=A.$fc.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===P.Schemas.file?v=p.URI.file(A.$gc(c(g))).path:v=A.$fc.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.$jh)(g.authority,v.authority))return;if(g.scheme===P.Schemas.file){const k=A.$kc(c(g),c(v));return T.$j?r.$wg(k):k}let b=g.path||"/";const $=v.path||"/";if(this.a(g)){let k=0;for(const E=Math.min(b.length,$.length);k<E&&!(b.charCodeAt(k)!==$.charCodeAt(k)&&b.charAt(k).toLowerCase()!==$.charAt(k).toLowerCase());k++);b=$.substr(0,k)+b.substr(k)}return A.$fc.relative(b,$)}resolvePath(g,v){if(g.scheme===P.Schemas.file){const b=p.URI.file(A.$jc(c(g),v));return g.with({authority:b.authority,path:b.path})}return v=r.$xg(v),g.with({path:A.$fc.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,I.$Ef)(g,v)}hasTrailingPathSeparator(g,v=A.sep){if(g.scheme===P.Schemas.file){const b=c(g);return b.length>r.$yg(b).length&&b[b.length-1]===v}else{const b=g.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=A.sep){return(0,e.$kh)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=A.sep){let b=!1;if(g.scheme===P.Schemas.file){const $=c(g);b=$!==void 0&&$.length===r.$yg($).length&&$[$.length-1]===v}else{v="/";const $=g.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$kh)(g,v)?g.with({path:g.path+"/"}):g}}e.$6g=m,e.$7g=new m(()=>!1),e.$8g=new m(f=>f.scheme===P.Schemas.file?!T.$l:!0),e.$9g=new m(f=>!0),e.$0g=e.$7g.isEqual.bind(e.$7g),e.$$g=e.$7g.isEqualOrParent.bind(e.$7g),e.$_g=e.$7g.getComparisonKey.bind(e.$7g),e.$ah=e.$7g.basenameOrAuthority.bind(e.$7g),e.$bh=e.$7g.basename.bind(e.$7g),e.$ch=e.$7g.extname.bind(e.$7g),e.$dh=e.$7g.dirname.bind(e.$7g),e.$eh=e.$7g.joinPath.bind(e.$7g),e.$fh=e.$7g.normalizePath.bind(e.$7g),e.$gh=e.$7g.relativePath.bind(e.$7g),e.$hh=e.$7g.resolvePath.bind(e.$7g),e.$ih=e.$7g.isAbsolutePath.bind(e.$7g),e.$jh=e.$7g.isEqualAuthority.bind(e.$7g),e.$kh=e.$7g.hasTrailingPathSeparator.bind(e.$7g),e.$lh=e.$7g.removeTrailingPathSeparator.bind(e.$7g),e.$mh=e.$7g.addTrailingPathSeparator.bind(e.$7g);function h(f,g){const v=[];for(let b=0;b<f.length;b++){const $=g(f[b]);f.some((k,E)=>E===b?!1:(0,e.$$g)($,g(k)))||v.push(f[b])}return v}var d;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(E=>{const[t,u]=E.split(":");t&&u&&b.set(t,u)});const k=v.path.substring(0,v.path.indexOf(";"));return k&&b.set(f.META_DATA_MIME,k),b}f.parseMetaData=g})(d||(e.DataUri=d={}));function w(f,g,v){if(g){let b=f.path;return b&&b[0]!==A.$fc.sep&&(b=A.$fc.sep+b),f.with({scheme:v,authority:g,path:b})}return f.with({scheme:v})}}),define(ce[8],le([0,1,22,15,4,2,18,3,147,65]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$5h=e.$4h=e.$3h=e.$2h=e.Promises=e.$1h=e.$Zh=e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0,e.$ph=m,e.$qh=h,e.$rh=d,e.$sh=w,e.$th=f,e.$uh=g,e.$vh=v,e.$wh=b,e.$Eh=l,e.$Fh=S,e.$Gh=y,e.$Hh=D,e.$Ih=L,e.$Xh=j,e.$6h=z;function m(ee){return!!ee&&typeof ee.then=="function"}function h(ee){const q=new n.$ve,ne=ee(q.token),de=new Promise((me,we)=>{const Ie=q.token.onCancellationRequested(()=>{Ie.dispose(),we(new r.$4)});Promise.resolve(ne).then(We=>{Ie.dispose(),q.dispose(),me(We)},We=>{Ie.dispose(),q.dispose(),we(We)})});return new class{cancel(){q.cancel(),q.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function d(ee,q,ne){return new Promise((de,me)=>{const we=q.onCancellationRequested(()=>{we.dispose(),de(ne)});ee.then(de,me).finally(()=>we.dispose())})}function w(ee,q){return new Promise((ne,de)=>{const me=q.onCancellationRequested(()=>{me.dispose(),de(new r.$4)});ee.then(ne,de).finally(()=>me.dispose())})}async function f(ee){let q=-1;const ne=ee.map((de,me)=>de.then(we=>(q=me,we)));try{return await Promise.race(ne)}finally{ee.forEach((de,me)=>{me!==q&&de.cancel()})}}function g(ee,q,ne){let de;const me=setTimeout(()=>{de?.(void 0),ne?.()},q);return Promise.race([ee.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function v(ee){return new Promise((q,ne)=>{const de=ee();m(de)?de.then(q,ne):q(de)})}function b(){let ee,q;return{promise:new Promise((de,me)=>{ee=de,q=me}),resolve:ee,reject:q}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const ne=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ne,ne).then(de)})}return new Promise((ne,de)=>{this.b.then(ne,de)})}return this.a=q(),new Promise((ne,de)=>{this.a.then(me=>{this.a=null,ne(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$xh=$;class k{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$yh=k;class E{constructor(){this.a=new Map}queue(q,ne){const me=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(q)===me&&this.a.delete(q)});return this.a.set(q,me),me}}e.$zh=E;const t=(ee,q)=>{let ne=!0;const de=setTimeout(()=>{ne=!1,q()},ee);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(de),ne=!1}}},u=ee=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,ee())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class i{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ne=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ne===p.$fe?u(de):t(ne,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ah=i;class o{constructor(q){this.a=new i(q),this.b=new $}trigger(q,ne){return this.a.trigger(()=>this.b.queue(q),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Bh=o;class s{constructor(){this.a=!1,this.b=new Promise((q,ne)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Ch=s;class a extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Dh=a;function l(ee,q){return q?new Promise((ne,de)=>{const me=setTimeout(()=>{we.dispose(),ne()},ee),we=q.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new r.$4)})}):h(ne=>l(ee,ne))}function S(ee,q=0,ne){const de=setTimeout(()=>{ee(),ne&&me.dispose()},q),me=(0,A.$Rc)(()=>{clearTimeout(de),ne?.deleteAndLeak(me)});return ne?.add(me),me}function y(ee){const q=[];let ne=0;const de=ee.length;function me(){return ne<de?ee[ne++]():null}function we(Ie){Ie!=null&&q.push(Ie);const We=me();return We?We.then(we):Promise.resolve(q)}return Promise.resolve(null).then(we)}function D(ee,q=de=>!!de,ne=null){let de=0;const me=ee.length,we=()=>{if(de>=me)return Promise.resolve(ne);const Ie=ee[de++];return Promise.resolve(Ie()).then(Oe=>q(Oe)?Promise.resolve(Oe):we())};return we()}function L(ee,q=de=>!!de,ne=null){if(ee.length===0)return Promise.resolve(ne);let de=ee.length;const me=()=>{de=-1;for(const we of ee)we.cancel?.()};return new Promise((we,Ie)=>{for(const We of ee)We.then(Oe=>{--de>=0&&q(Oe)?(me(),we(Oe)):de===0&&we(ne)}).catch(Oe=>{--de>=0&&(me(),Ie(Oe))})})}class R{constructor(q){this.a=0,this.b=!1,this.f=q,this.g=[],this.d=0,this.h=new P.$ke}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,de)=>{this.g.push({factory:q,c:ne,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const q=this.g.shift();this.d++;const ne=q.factory();ne.then(q.c,q.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Jh=R;class O extends R{constructor(){super(1)}}e.$Kh=O;class M{constructor(){this.a=new C,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Lh=M;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new G;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueSize(q,ne=T.$7g){const de=ne.getComparisonKey(q);return this.a.get(de)?.size??0}queueFor(q,ne,de=T.$7g){const me=de.getComparisonKey(q);let we=this.a.get(me);if(!we){we=new O;const Ie=this.f++,We=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Ie,We),this.a.set(me,we)}return we.queue(ne)}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Mh=x;class X{constructor(q,ne){this.b=!1,this.a=-1,typeof q=="function"&&typeof ne=="number"&&this.setIfNotSet(q,ne)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ne){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ne)}setIfNotSet(q,ne){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ne))}}e.$Nh=X;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,ne,de=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{q()},ne);this.d=(0,A.$Rc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Oh=K;class fe{constructor(q,ne){this.b=-1,this.a=q,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ph=fe;class H{constructor(q,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=q,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Qh=H;class J extends fe{constructor(q,ne){super(q,ne),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Rh=J;class U extends A.$Tc{constructor(q,ne){super(),this.g=q,this.h=ne,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of q)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new fe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Sh=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Uh=(ee,q)=>{(0,I.$C)(()=>{if(ne)return;const de=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Uh=(ee,q,ne)=>{const de=ee.requestIdleCallback(q,typeof ne=="number"?{timeout:ne}:void 0);let me=!1;return{dispose(){me||(me=!0,ee.cancelIdleCallback(de))}}},e.$Th=ee=>(0,e.$Uh)(globalThis,ee)}();class Z{constructor(q,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Uh)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Vh=Z;class B extends Z{constructor(q){super(globalThis,q)}}e.$Wh=B;async function j(ee,q,ne){let de;for(let me=0;me<ne;me++)try{return await ee()}catch(we){de=we,await l(q)}throw de}class C{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,ne,de){return this.a={taskId:q,cancel:()=>de?.(),promise:ne},ne.then(()=>this.d(q),()=>this.d(q)),ne}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{const{promise:ne,resolve:de,reject:me}=b();this.b={run:q,promise:ne,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yh=C;class Y{constructor(q,ne=()=>Date.now()){this.d=q,this.f=ne,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Zh=Y;var oe;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(oe||(oe={}));class G{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((q,ne)=>{this.a=q,this.b=ne})}complete(q){return new Promise(ne=>{this.a(q),this.d={outcome:oe.Resolved,value:q},ne()})}error(q){return new Promise(ne=>{this.b(q),this.d={outcome:oe.Rejected,value:q},ne()})}cancel(){return this.error(new r.$4)}}e.$1h=G;var ue;(function(ee){async function q(de){let me;const we=await Promise.all(de.map(Ie=>Ie.then(We=>We,We=>{me||(me=We)})));if(typeof me<"u")throw me;return we}ee.settled=q;function ne(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Ie){we(Ie)}})}ee.withAsyncBody=ne})(ue||(e.Promises=ue={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$2h=re;class Q{constructor(q){this.b=q,this.a=new c.$T(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$3h=Q;var F;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(q){return new N(ne=>{ne.emitMany(q)})}static fromPromise(q){return new N(async ne=>{ne.emitMany(await q)})}static fromPromises(q){return new N(async ne=>{await Promise.all(q.map(async de=>ne.emitOne(await de)))})}static merge(q){return new N(async ne=>{await Promise.all(q.map(async de=>{for await(const me of de)ne.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(q,ne){this.a=F.Initial,this.b=[],this.d=null,this.f=ne,this.g=new P.$ke,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(q(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(q,ne){return new N(async de=>{for await(const me of q)de.emitOne(ne(me))})}map(q){return N.map(this,q)}static filter(q,ne){return new N(async de=>{for await(const me of q)ne(me)&&de.emitOne(me)})}filter(q){return N.filter(this,q)}static coalesce(q){return N.filter(q,ne=>!!ne)}coalesce(){return N.coalesce(this)}static async toPromise(q){const ne=[];for await(const de of q)ne.push(de);return ne}toPromise(){return N.toPromise(this)}h(q){this.a===F.Initial&&(this.b.push(q),this.g.fire())}j(q){this.a===F.Initial&&(this.b=this.b.concat(q),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(q){this.a===F.Initial&&(this.a=F.DoneError,this.d=q,this.g.fire())}}e.$4h=N;class W extends N{constructor(q,ne){super(ne),this.m=q}cancel(){this.m.cancel()}}e.$5h=W;function z(ee){const q=new n.$ve,ne=ee(q.token);return new W(q,async de=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),de.reject(new r.$4)});try{for await(const we of ne){if(q.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),q.dispose()}catch(we){me.dispose(),q.dispose(),de.reject(we)}})}class te{constructor(q){this.a=new G,this.b=new N(me=>{if(ne){me.reject(ne);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},q);let ne,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ne||(ne=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$7h=te}),define(ce[111],le([0,1,21,8,39,32,31,9,3,25]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=m,e.$wk=g,e.$xk=M,e.$yk=x,e.$zk=X,e.$Ak=K,e.$Bk=fe,e.$Ck=Z;function m(){return Object.create(null)}e.$uk="**",e.$vk="/";const h="[/\\\\]",d="[^/\\\\]",w=/\//g;function f(B,j){switch(B){case 0:return"";case 1:return`${d}*?`;default:return`(?:${h}|${d}+${h}${j?`|${h}${d}+`:""})*?`}}function g(B,j){if(!B)return[];const C=[];let Y=!1,oe=!1,G="";for(const ue of B){switch(ue){case j:if(!Y&&!oe){C.push(G),G="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}G+=ue}return G&&C.push(G),C}function v(B){if(!B)return"";let j="";const C=g(B,e.$vk);if(C.every(Y=>Y===e.$uk))j=".*";else{let Y=!1;C.forEach((oe,G)=>{if(oe===e.$uk){if(Y)return;j+=f(2,G===C.length-1)}else{let ue=!1,re="",Q=!1,F="";for(const N of oe){if(N!=="}"&&ue){re+=N;continue}if(Q&&(N!=="]"||!F)){let W;N==="-"?W=N:(N==="^"||N==="!")&&!F?W="^":N===e.$vk?W="":W=(0,c.$gf)(N),F+=W;continue}switch(N){case"{":ue=!0;continue;case"[":Q=!0;continue;case"}":{const z=`(?:${g(re,",").map(te=>v(te)).join("|")})`;j+=z,ue=!1,re="";break}case"]":{j+="["+F+"]",Q=!1,F="";break}case"?":j+=d;continue;case"*":j+=f(1);continue;default:j+=(0,c.$gf)(N)}}G<C.length-1&&(C[G+1]!==e.$uk||G+2<C.length)&&(j+=h)}Y=oe===e.$uk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Cc(1e4),o=function(){return!1},s=function(){return null};function a(B,j){if(!B)return s;let C;typeof B!="string"?C=B.pattern:C=B,C=C.trim();const Y=`${C}_${!!j.trimForExclusions}`;let oe=i.get(Y);if(oe)return l(oe,B);let G;return b.test(C)?oe=y(C.substr(4),C):(G=$.exec(S(C,j)))?oe=D(G[1],C):(j.trimForExclusions?E:k).test(C)?oe=L(C,j):(G=t.exec(S(C,j)))?oe=R(G[1].substr(1),C,!0):(G=u.exec(S(C,j)))?oe=R(G[1],C,!1):oe=O(C),i.set(Y,oe),l(oe,B)}function l(B,j){if(typeof j=="string")return B;const C=function(Y,oe){return(0,A.$Cg)(Y,j.base,!p.$l)?B((0,c.$lf)(Y.substr(j.base.length),I.sep),oe):null};return C.allBasenames=B.allBasenames,C.allPaths=B.allPaths,C.basenames=B.basenames,C.patterns=B.patterns,C}function S(B,j){return j.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,j){return function(C,Y){return typeof C=="string"&&C.endsWith(B)?j:null}}function D(B,j){const C=`/${B}`,Y=`\\${B}`,oe=function(ue,re){return typeof ue!="string"?null:re?re===B?j:null:ue===B||ue.endsWith(C)||ue.endsWith(Y)?j:null},G=[B];return oe.basenames=G,oe.patterns=[j],oe.allBasenames=G,oe}function L(B,j){const C=U(B.slice(1,-1).split(",").map(re=>a(re,j)).filter(re=>re!==s),B),Y=C.length;if(!Y)return s;if(Y===1)return C[0];const oe=function(re,Q){for(let F=0,N=C.length;F<N;F++)if(C[F](re,Q))return B;return null},G=C.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const ue=C.reduce((re,Q)=>Q.allPaths?re.concat(Q.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function R(B,j,C){const Y=I.sep===I.$fc.sep,oe=Y?B:B.replace(w,I.sep),G=I.sep+oe,ue=I.$fc.sep+B;let re;return C?re=function(Q,F){return typeof Q=="string"&&(Q===oe||Q.endsWith(G)||!Y&&(Q===B||Q.endsWith(ue)))?j:null}:re=function(Q,F){return typeof Q=="string"&&(Q===oe||!Y&&Q===B)?j:null},re.allPaths=[(C?"*/":"./")+B],re}function O(B){try{const j=new RegExp(`^${v(B)}$`);return function(C){return j.lastIndex=0,typeof C=="string"&&j.test(C)?B:null}}catch{return s}}function M(B,j,C){return!B||typeof j!="string"?!1:x(B)(j,void 0,C)}function x(B,j={}){if(!B)return o;if(typeof B=="string"||X(B)){const C=a(B,j);if(C===s)return o;const Y=function(oe,G){return!!C(oe,G)};return C.allBasenames&&(Y.allBasenames=C.allBasenames),C.allPaths&&(Y.allPaths=C.allPaths),Y}return H(B,j)}function X(B){const j=B;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function K(B){return B.allBasenames||[]}function fe(B){return B.allPaths||[]}function H(B,j){const C=U(Object.getOwnPropertyNames(B).map(re=>J(re,B[re],j)).filter(re=>re!==s)),Y=C.length;if(!Y)return s;if(!C.some(re=>!!re.requiresSiblings)){if(Y===1)return C[0];const re=function(N,W){let z;for(let te=0,ee=C.length;te<ee;te++){const q=C[te](N,W);if(typeof q=="string")return q;(0,r.$ph)(q)&&(z||(z=[]),z.push(q))}return z?(async()=>{for(const te of z){const ee=await te;if(typeof ee=="string")return ee}return null})():null},Q=C.find(N=>!!N.allBasenames);Q&&(re.allBasenames=Q.allBasenames);const F=C.reduce((N,W)=>W.allPaths?N.concat(W.allPaths):N,[]);return F.length&&(re.allPaths=F),re}const oe=function(re,Q,F){let N,W;for(let z=0,te=C.length;z<te;z++){const ee=C[z];ee.requiresSiblings&&F&&(Q||(Q=(0,I.$mc)(re)),N||(N=Q.substr(0,Q.length-(0,I.$nc)(re).length)));const q=ee(re,Q,N,F);if(typeof q=="string")return q;(0,r.$ph)(q)&&(W||(W=[]),W.push(q))}return W?(async()=>{for(const z of W){const te=await z;if(typeof te=="string")return te}return null})():null},G=C.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const ue=C.reduce((re,Q)=>Q.allPaths?re.concat(Q.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function J(B,j,C){if(j===!1)return s;const Y=a(B,C);if(Y===s)return s;if(typeof j=="boolean")return Y;if(j){const oe=j.when;if(typeof oe=="string"){const G=(ue,re,Q,F)=>{if(!F||!Y(ue,re))return null;const N=oe.replace("$(basename)",()=>Q),W=F(N);return(0,r.$ph)(W)?W.then(z=>z?B:null):W?B:null};return G.requiresSiblings=!0,G}}return Y}function U(B,j){const C=B.filter(re=>!!re.basenames);if(C.length<2)return B;const Y=C.reduce((re,Q)=>{const F=Q.basenames;return F?re.concat(F):re},[]);let oe;if(j){oe=[];for(let re=0,Q=Y.length;re<Q;re++)oe.push(j)}else oe=C.reduce((re,Q)=>{const F=Q.patterns;return F?re.concat(F):re},[]);const G=function(re,Q){if(typeof re!="string")return null;if(!Q){let N;for(N=re.length;N>0;N--){const W=re.charCodeAt(N-1);if(W===P.CharCode.Slash||W===P.CharCode.Backslash)break}Q=re.substr(N)}const F=Y.indexOf(Q);return F!==-1?oe[F]:null};G.basenames=Y,G.patterns=oe,G.allBasenames=Y;const ue=B.filter(re=>!re.basenames);return ue.push(G),ue}function Z(B,j){return(0,n.$tb)(B,j,(C,Y)=>typeof C=="string"&&typeof Y=="string"?C===Y:typeof C!="string"&&typeof Y!="string"?C.base===Y.base&&C.pattern===Y.pattern:!1)}}),define(ce[47],le([0,1,21,32,9,3,18,25]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=p,e.$Yw=m,e.$Zw=d,e.$1w=w,e.$2w=b,e.$3w=k,e.$4w=E,e.$5w=t,e.$6w=u,e.$7w=i;function p(s,a){const{os:l,tildify:S,relative:y}=a;if(y){const R=c(s,y,l);if(typeof R=="string")return R}let D=s.fsPath;if(l===A.OperatingSystem.Windows&&!A.$j?D=D.replace(/\//g,"\\"):l!==A.OperatingSystem.Windows&&A.$j&&(D=D.replace(/\\/g,"/")),l!==A.OperatingSystem.Windows&&S?.userHome){const R=S.userHome.fsPath;let O;s.scheme!==S.userHome.scheme&&s.path[0]===P.$fc.sep&&s.path[1]!==P.$fc.sep?O=S.userHome.with({path:s.path}).fsPath:O=D,D=d(O,R,l)}return(l===A.OperatingSystem.Windows?P.$ec:P.$fc).normalize(m(D,l===A.OperatingSystem.Windows))}function c(s,a,l){const S=l===A.OperatingSystem.Windows?P.$ec:P.$fc,y=l===A.OperatingSystem.Linux?T.$7g:T.$9g,D=a.getWorkspace(),L=(0,n.$Nb)(D.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===P.$fc.sep&&s.path[1]!==P.$fc.sep&&(s=L.uri.with({path:s.path}));const R=a.getWorkspaceFolder(s);if(!R)return;let O;if(y.isEqual(R.uri,s)?O="":O=y.relativePath(R.uri,s)??"",O&&(O=S.normalize(O)),D.folders.length>1&&!a.noPrefix){const M=R.name?R.name:y.basenameOrAuthority(R.uri);O=O?`${M} \u2022 ${O}`:M}return O}function m(s,a=A.$j){return(0,r.$Hg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let h=Object.create(null);function d(s,a,l=A.OS){if(l===A.OperatingSystem.Windows||!s||!a)return s;let S=h.original===a?h.normalized:void 0;S||(S=a,A.$j&&(S=(0,r.$wg)(S)),S=`${(0,I.$mf)(S,P.$fc.sep)}${P.$fc.sep}`,h={original:a,normalized:S});let y=s;return A.$j&&(y=(0,r.$wg)(y)),(l===A.OperatingSystem.Linux?y.startsWith(S):(0,I.$Ff)(y,S))?`~/${y.substr(S.length)}`:s}function w(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",g="\\\\",v="~";function b(s,a=P.sep){const l=new Array(s.length);let S=!1;for(let y=0;y<s.length;y++){const D=s[y];if(D===""){l[y]=`.${a}`;continue}if(!D){l[y]=D;continue}S=!0;let L="",R=D;R.indexOf(g)===0?(L=R.substr(0,R.indexOf(g)+g.length),R=R.substr(R.indexOf(g)+g.length)):R.indexOf(a)===0?(L=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const O=R.split(a);for(let M=1;S&&M<=O.length;M++)for(let x=O.length-M;S&&x>=0;x--){S=!1;let X=O.slice(x,x+M).join(a);for(let K=0;!S&&K<s.length;K++)if(K!==y&&s[K]&&s[K].indexOf(X)>-1){const fe=x+M===O.length,H=x>0&&s[K].indexOf(a)>-1?a+X:X,J=s[K].endsWith(H);S=!fe||J}if(!S){let K="";(O[0].endsWith(":")||L!=="")&&(x===1&&(x=0,M++,X=O[0]+a+X),x>0&&(K=O[0]+a),K=L+K),x>0&&(K=K+f+a),K=K+X,x+M<O.length&&(K=K+a+f),l[y]=K}}S&&(l[y]=D)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function k(s,a=Object.create(null)){const l=[];let S=!1,y="";for(const D of s)if(D==="$"||S&&D==="{")y&&l.push({value:y,type:$.TEXT}),y="",S=!0;else if(D==="}"&&S){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const R=l[l.length-1];(!R||R.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",S=!1}else y+=D;return y&&!S&&l.push({value:y,type:$.TEXT}),l.filter((D,L)=>{if(D.type===$.SEPARATOR){const R=l[L-1],O=l[L+1];return[R,O].every(M=>M&&(M.type===$.VARIABLE||M.type===$.TEXT)&&M.value.length>0)}return!0}).map(D=>D.value).join("")}function E(s,a){return A.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,a){return A.$k||a?s.replace(/\(&&\w\)|&&/g,""):A.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function u(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),S=s.substring(a);return{name:l.name+S,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?P.$fc:P.$ec,l=a.basename(s),S=a.dirname(s);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(ce[151],le([0,1,17,90,7]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=void 0,e.$Mn=p,e.$Nn=m,e.$On=h;function A(d){return d.toJSON()}class T{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:A(P.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:A(P.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:P.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Kn=T,e.$Ln=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function I(d,w,f){if(!d||f>200)return null;if(typeof d=="object"){if(d instanceof P.URI)return w.transformOutgoing(d);for(const g in d)if(Object.hasOwnProperty.call(d,g)){const v=I(d[g],w,f+1);v!==null&&(d[g]=v)}}return null}function p(d,w){const f=I(d,w,0);return f===null?d:f}function c(d,w,f,g){if(!d||g>200)return null;if(typeof d=="object"){if(d.$mid===r.MarshalledId.Uri)return f?P.URI.revive(w.transformIncoming(d)):w.transformIncoming(d);if(d instanceof n.$Me)return null;for(const v in d)if(Object.hasOwnProperty.call(d,v)){const b=c(d[v],w,f,g+1);b!==null&&(d[v]=b)}}return null}function m(d,w){const f=c(d,w,!1,0);return f===null?d:f}function h(d,w){const f=c(d,w,!0,0);return f===null?d:f}}),define(ce[33],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(P){return n.test(P)}e.$Zg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){P(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,c="";return c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c+="-",c+=T[A[p++]],c+=T[A[p++]],c+="-",c+=T[A[p++]],c+=T[A[p++]],c+="-",c+=T[A[p++]],c+=T[A[p++]],c+="-",c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c+=T[A[p++]],c}}()}),define(ce[152],le([0,1,91,26,89]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=A,n=Pe(n),r=Pe(r);async function A(T,I){if(await new Promise((m,h)=>{const d=r.createReadStream(T),w=n.createHash("sha256");d.pipe(w);const f=(0,P.$cb)((g,v)=>{d.removeAllListeners(),w.removeAllListeners(),g?h(g):m(v)});d.once("error",f),d.once("end",f),w.once("error",f),w.once("data",g=>f(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(ce[153],le([0,1,27]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=A;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function A(){const T=(0,n.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:c}of p)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[92],le([0,1,27,60,33,153,3]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0,e.$Rn=p,e.$Sn=h,e.$Tn=d,P=Pe(P),e.$Qn=new class{c(w){return this.a||(this.a=r.$Ji.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const g=(0,n.networkInterfaces)();for(const v in g){const b=g[v];if(b)for(const{mac:$,internal:k}of b)k||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await c(w)||P.$Zg())()),I}async function c(w){try{const f=await new Promise((v,b)=>{V(["crypto"],v,b)}).then(Pe),g=(0,A.$Pn)();return f.createHash("sha256").update(g,"utf8").digest("hex")}catch(f){w(f);return}}const m="Software\\Microsoft\\SQMClient";async function h(w){if(T.$j){const f=await new Promise((g,v)=>{V(["@vscode/windows-registry"],g,v)}).then(Pe);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(g){return w(g),""}}return""}async function d(w){try{return await(await new Promise((v,b)=>{V(["@vscode/deviceid"],v,b)}).then(Pe)).getDeviceId()}catch(f){return w(f),""}}}),define(ce[23],le([0,1,26,27,154,8,32,78,9,3,18,7]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=k,e.whenDeleted=u,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Pe(n);var d;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function w(H,J=d.UNLINK,U){if((0,T.$Gg)(H))throw new Error("rimraf - will refuse to recursively delete root");return J===d.UNLINK?g(H):f(H,U)}async function f(H,J=(0,T.$Lg)((0,r.tmpdir)())){try{try{await n.promises.rename(H,J)}catch(U){return U.code==="ENOENT"?void 0:g(H)}g(J).catch(U=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function g(H){return n.promises.rm(H,{recursive:!0,force:!0,maxRetries:3})}function v(H){if((0,T.$Gg)(H))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function b(H,J){return E(await(J?$(H):n.promises.readdir(H)))}async function $(H){try{return await n.promises.readdir(H,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const J=[],U=await b(H);for(const Z of U){let B=!1,j=!1,C=!1;try{const Y=await n.promises.lstat((0,p.$ic)(H,Z));B=Y.isFile(),j=Y.isDirectory(),C=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}J.push({name:Z,isFile:()=>B,isDirectory:()=>j,isSymbolicLink:()=>C})}return J}function k(H){return E(n.readdirSync(H))}function E(H){return H.map(J=>typeof J=="string"?c.$k?(0,I.$lm)(J):J:(J.name=c.$k?(0,I.$lm)(J.name):J.name,J))}async function t(H){const J=await b(H),U=[];for(const Z of J)await i.existsDirectory((0,p.$ic)(H,Z))&&U.push(Z);return U}function u(H,J=1e3){return new Promise(U=>{let Z=!1;const B=setInterval(()=>{Z||(Z=!0,n.access(H,j=>{Z=!1,j&&(clearInterval(B),U(void 0))}))},J)})}var i;(function(H){async function J(B){let j;try{if(j=await n.promises.lstat(B),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(B),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&C.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw Y}throw C}}H.stat=J;async function U(B){try{const{stat:j,symbolicLink:C}=await H.stat(B);return j.isFile()&&C?.dangling!==!0}catch{}return!1}H.existsFile=U;async function Z(B){try{const{stat:j,symbolicLink:C}=await H.stat(B);return j.isDirectory()&&C?.dangling!==!0}catch{}return!1}H.existsDirectory=Z})(i||(e.SymlinkSupport=i={}));const o=new A.$Mh;function s(H,J,U){return o.queueFor(h.URI.file(H),()=>{const Z=D(U);return new Promise((B,j)=>S(H,J,Z,C=>C?j(C):B()))},m.$8g)}let a=!0;function l(H){a=H}function S(H,J,U,Z){if(!a)return n.writeFile(H,J,{mode:U.mode,flag:U.flag},Z);n.open(H,U.flag,U.mode,(B,j)=>{if(B)return Z(B);n.writeFile(j,J,C=>{if(C)return n.close(j,()=>Z(C));n.fdatasync(j,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),l(!1)),n.close(j,oe=>Z(oe))))})})}function y(H,J,U){const Z=D(U);if(!a)return n.writeFileSync(H,J,{mode:Z.mode,flag:Z.flag});const B=n.openSync(H,Z.flag,Z.mode);try{n.writeFileSync(B,J);try{n.fdatasyncSync(B)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(B)}}function D(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function L(H,J,U=6e4){if(H!==J)try{c.$j&&typeof U=="number"?await R(H,J,Date.now(),U):await n.promises.rename(H,J)}catch(Z){if(H.toLowerCase()!==J.toLowerCase()&&Z.code==="EXDEV"||H.endsWith("."))await O(H,J,{preserveSymlinks:!1}),await w(H,d.MOVE);else throw Z}}async function R(H,J,U,Z,B=0){try{return await n.promises.rename(H,J)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-U>=Z)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${j}`),j;if(B===0){let C=!1;try{const{stat:Y}=await i.stat(J);Y.isFile()||(C=!0)}catch{}if(C)throw j}return await(0,A.$Eh)(Math.min(100,B*10)),R(H,J,U,Z,B+1)}}async function O(H,J,U){return x(H,J,{root:{source:H,target:J},options:U,handledSourcePaths:new Set})}const M=511;async function x(H,J,U){if(U.handledSourcePaths.has(H))return;U.handledSourcePaths.add(H);const{stat:Z,symbolicLink:B}=await i.stat(H);if(B){if(U.options.preserveSymlinks)try{return await fe(H,J,U)}catch{}if(B.dangling)return}return Z.isDirectory()?X(H,J,Z.mode&M,U):K(H,J,Z.mode&M)}async function X(H,J,U,Z){await n.promises.mkdir(J,{recursive:!0,mode:U});const B=await b(H);for(const j of B)await x((0,p.$ic)(H,j),(0,p.$ic)(J,j),Z)}async function K(H,J,U){await n.promises.copyFile(H,J),await n.promises.chmod(J,U)}async function fe(H,J,U){let Z=await n.promises.readlink(H);(0,T.$Cg)(Z,U.root.source,!c.$l)&&(Z=(0,p.$ic)(U.root.target,Z.substr(U.root.source.length+1))),await n.promises.symlink(Z,J)}e.Promises=new class{get read(){return(H,J,U,Z,B)=>new Promise((j,C)=>{n.read(H,J,U,Z,B,(Y,oe,G)=>Y?C(Y):j({bytesRead:oe,buffer:G}))})}get write(){return(H,J,U,Z,B)=>new Promise((j,C)=>{n.write(H,J,U,Z,B,(Y,oe,G)=>Y?C(Y):j({bytesWritten:oe,buffer:G}))})}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(H){try{return await n.promises.access(H),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return O}}}),define(ce[112],le([0,1,26,9,3,25,23]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=I,e.$kr=p,e.$lr=c,e.$mr=m,n=Pe(n);function I(d){if(P.$l)return d;const w=(0,r.$lc)(d);if(d===w)return d;const f=((0,r.$mc)(d)||d).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$ic)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$ic)($,v[b])}}}catch{}return null}async function p(d,w){if(P.$l)return d;const f=(0,r.$lc)(d);if(d===f)return d;const g=((0,r.$mc)(d)||d).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===g);if(b.length===1){const $=await p(f,w);if($)return(0,r.$ic)($,b[0])}else if(b.length>1){const $=b.indexOf(g);if($>=0){const k=await p(f,w);if(k)return(0,r.$ic)(k,b[$])}}}catch{}return null}async function c(d){try{return await T.Promises.realpath(d)}catch{const f=h(d);return await n.promises.access(f,n.constants.R_OK),f}}function m(d){try{return n.realpathSync(d)}catch{const f=h(d);return n.accessSync(f,n.constants.R_OK),f}}function h(d){return(0,A.$mf)((0,r.$gc)(d),r.sep)}}),define(ce[113],le([0,1,93]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=r,e.$4g=A,n=Pe(n);function r(I,p,c,m=1){let h=!1;return new Promise(d=>{const w=setTimeout(()=>{if(!h)return h=!0,d(0)},c);P(I,p,m,f=>{if(!h)return h=!0,clearTimeout(w),d(f)})})}function P(I,p,c,m){if(p===0)return m(0);const h=new n.Socket;h.once("connect",()=>(T(h),P(I+c,p-1,c,m))),h.once("data",()=>{}),h.once("error",d=>(T(h),d.code!=="ECONNREFUSED"?P(I+c,p-1,c,m):m(I))),h.connect(I,"127.0.0.1")}e.$3g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,p,c,m="127.0.0.1"){let h=!1,d,w=1;const f=n.createServer({pauseOnConnect:!0});function g(v,b){h||(h=!0,f.removeAllListeners(),f.close(),d&&clearTimeout(d),b(v))}return new Promise(v=>{d=setTimeout(()=>{g(0,v)},c),f.on("listening",()=>{g(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,m)):g(0,v)}),f.on("close",()=>{g(0,v)}),f.listen(I,m)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(ce[114],le([0,1,27,9,23]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=$,e.$vm=k,n=Pe(n),r=Pe(r),P=Pe(P);const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=p.x86:m=p.x64;class h{constructor(t,u,i){this.exePath=t,this.displayName=u,this.a=i}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:E=!1}={}){return E?c===p.x64?process.env["ProgramFiles(x86)"]||null:m===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:E=!1,findPreview:t=!1}={}){const u=d({useAlternateBitness:E});if(!u)return null;const i=r.$ic(u,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const S of await P.Promises.readdir(i)){let y=-1;if(t){const L=S.indexOf("-");if(L<0)continue;const R=S.substring(0,L);if(!A.test(R)||S.substring(L+1)!=="preview")continue;y=parseInt(R,10)}else{if(!A.test(S))continue;y=parseInt(S,10)}if(y<=o)continue;const D=r.$ic(i,S,"pwsh.exe");await P.SymlinkSupport.existsFile(D)&&(s=D,o=y)}if(!s)return null;const a=u.includes("x86")?" (x86)":"",l=t?" Preview":"";return new h(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:u,pwshMsixName:i}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await P.Promises.readdir(t))if(u.test(o)){const s=r.$ic(t,o,"pwsh.exe");return new h(s,i)}return null}function g(){const E=r.$ic(n.homedir(),".dotnet","tools","pwsh.exe");return new h(E,".NET Core PowerShell Global Tool")}function v(){const E=r.$ic(process.env.windir,c===p.x86&&m!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(E,"Windows PowerShell",!0)}async function*b(){let E=await w();E&&(yield E),E=await w({useAlternateBitness:!0}),E&&(yield E),E=await f(),E&&(yield E),E=g(),E&&(yield E),E=await w({findPreview:!0}),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await w({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=v(),E&&(yield E)}async function*$(){for await(const E of b())await E.exists()&&(yield E)}async function k(){for await(const E of $())return E;return null}}),define(ce[94],le([0,1,26,9,3,36,79,12,23]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=c,e.$xm=m,r=Pe(r),P=Pe(P),A=Pe(A),I=Pe(I),p=Pe(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(d=A.env){return d.comspec||"cmd.exe"}function m(d){let w=[],f=!1;const g=function(v){if(f){w.push(v);return}(!d.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const k=w.slice(0);w=[],k.forEach(E=>g(E))}})||P.$j)&&(f=!0)};return{send:g}}var h;(function(d){async function w(f,g,v){if(r.$hc(f))return f;if(g===void 0&&(g=A.cwd()),r.$lc(f)!=="."||(v===void 0&&I.$dg(A.env.PATH)&&(v=A.env.PATH.split(r.$sc)),v===void 0||v.length===0))return r.$ic(g,f);async function $(k){if(await p.Promises.exists(k)){let E;try{E=await n.promises.stat(k)}catch(t){t.message.startsWith("EACCES")&&(E=await n.promises.lstat(k))}return E?!E.isDirectory():!1}return!1}for(const k of v){let E;if(r.$hc(k)?E=r.$ic(k,f):E=r.$ic(g,k,f),await $(E))return E;let t=E+".com";if(await $(t)||(t=E+".exe",await $(t)))return t}return r.$ic(g,f)}d.findExecutable=w})(h||(e.win32=h={}))}),define(ce[115],le([0,1,48,11]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=P;function P(T){return new Promise((I,p)=>{let c;const m=new Map;function h(w,f,g,v,b){const $=m.get(f);if(w===T||$){const k={name:d(g),cmd:g,pid:w,ppid:f,load:v,mem:b};m.set(w,k),w===T&&(c=k),$&&($.children||($.children=[]),$.children.push(k),$.children.length>1&&($.children=$.children.sort((E,t)=>E.pid-t.pid)))}}function d(w){const f=/--utility-sub-type=network/i,g=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let k=$.exec(w);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const E=/[a-zA-Z-]+\.js/g;let t="";do k=E.exec(w),k&&(t+=k+" ");while(k);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,g)=>{V(["@vscode/windows-process-tree"],f,g)}).then(Pe).then(f=>{f.getProcessList(T,g=>{if(!g){p(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(g,v=>{const b=new Map;v.forEach($=>{const k=w($.commandLine||"");b.set($.pid,{name:d(k),cmd:k,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=b.get(T),c?(b.forEach($=>{const k=b.get($.ppid);k&&(k.children||(k.children=[]),k.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((k,E)=>k.pid-E.pid))}),I(c)):p(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[c];const g=[];for(;f.length;){const b=f.shift();b&&(g.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$Xg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,n.exec)(v,{},(b,$,k)=>{if(b||k)p(b||new Error(k.toString()));else{const E=$.toString().split(`
`);for(let t=0;t<g.length;t++){const u=m.get(g[t]);u.load=parseFloat(E[t])}if(!c){p(new Error(`Root process ${T} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,g,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$Xg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,k,E)=>{$||E?p($||new Error(E.toString())):(A(k,h),w())})}else{const b=g.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,E,t)=>{k||t&&!t.includes("screen size is bogus")?p(k||new Error(t.toString())):(A(E,h),process.platform==="linux"?w():c?I(c):p(new Error(`Root process ${T} not found`)))})}})}})}function A(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=T.toString().split(`
`);for(const m of c){const h=p.exec(m.trim());h&&h.length===6&&I(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(ce[116],le([0,1,27,3,114,94]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=T,r=Pe(r),A=Pe(A);async function T(h,d){return h===r.OperatingSystem.Windows?r.$j?m():A.$wm(d):p(h,d)}let I=null;function p(h,d){if(r.$l&&h===r.OperatingSystem.Macintosh||r.$k&&h===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function m(){return c||(c=(await(0,P.$vm)()).exePath),c}}),function(){function V(){function e(){return process.uncHostAllowlist}function n(p){const c=new Set;if(Array.isArray(p))for(const m of p)typeof m=="string"&&c.add(m);return Array.from(c)}function r(){const p=e();return p?Array.from(p):[]}function P(p){if(process.platform!=="win32")return;const c=e();if(c)if(typeof p=="string")c.add(p.toLowerCase());else for(const m of n(p))P(m)}function A(p){if(typeof p!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const h of c){if(p.indexOf(h)!==0)continue;const w=p.indexOf("\\",h.length);if(w===-1)continue;const f=p.substring(h.length,w);if(f){m=f;break}}return m}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:P,getUNCHost:A,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[155],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PX=e.$OX=void 0,e.$OX="vscode:contextmenu",e.$PX="vscode:onCloseContextMenu"});var Se=this&&this.__decorate||function(V,e,n,r){var P=arguments.length,A=P<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(V,e,n,r);else for(var I=V.length-1;I>=0;I--)(T=V[I])&&(A=(P<3?T(A):P>3?T(e,n,A):T(e,n))||A);return P>3&&A&&Object.defineProperty(e,n,A),A};define(ce[44],le([0,1,21,8,17,22,54,15,4,2,82,25,12]),function(V,e,n,r,P,A,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.ProxyChannel=e.$li=e.$ii=e.$hi=e.$gi=e.RequestInitiator=e.$fi=e.$ci=e.$bi=void 0,e.$di=l,e.$ei=S,e.$ji=M,e.$ki=x,h=Pe(h);var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function f(B){switch(B){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g||(g={}));function v(B){switch(B){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var b;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(b||(b={}));function $(B){let j=0;for(let C=0;;C+=7){const Y=B.read(1);if(j|=(Y.buffer[0]&127)<<C,!(Y.buffer[0]&128))return j}}const k=o(0);function E(B,j){if(j===0){B.write(k);return}let C=0;for(let oe=j;oe!==0;oe=oe>>>7)C++;const Y=P.$Me.alloc(C);for(let oe=0;j!==0;oe++)Y.buffer[oe]=j&127,j=j>>>7,j>0&&(Y.buffer[oe]|=128);B.write(Y)}class t{constructor(j){this.b=j,this.a=0}read(j){const C=this.b.slice(this.a,this.a+j);return this.a+=C.byteLength,C}}e.$bi=t;class u{constructor(){this.a=[]}get buffer(){return P.$Me.concat(this.a)}write(j){this.a.push(j)}}e.$ci=u;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function o(B){const j=P.$Me.alloc(1);return j.writeUInt8(B,0),j}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},a=typeof Buffer<"u";function l(B,j){if(typeof j>"u")B.write(s.Undefined);else if(typeof j=="string"){const C=P.$Me.fromString(j);B.write(s.String),E(B,C.byteLength),B.write(C)}else if(a&&Buffer.isBuffer(j)){const C=P.$Me.wrap(j);B.write(s.Buffer),E(B,C.byteLength),B.write(C)}else if(j instanceof P.$Me)B.write(s.VSBuffer),E(B,j.byteLength),B.write(j);else if(Array.isArray(j)){B.write(s.Array),E(B,j.length);for(const C of j)l(B,C)}else if(typeof j=="number"&&(j|0)===j)B.write(s.Uint),E(B,j);else{const C=P.$Me.fromString(JSON.stringify(j));B.write(s.Object),E(B,C.byteLength),B.write(C)}}function S(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read($(B)).toString();case i.Buffer:return B.read($(B)).buffer;case i.VSBuffer:return B.read($(B));case i.Array:{const C=$(B),Y=[];for(let oe=0;oe<C;oe++)Y.push(S(B));return Y}case i.Object:return JSON.parse(B.read($(B)).toString());case i.Int:return $(B)}}class y{constructor(j,C,Y=null,oe=1e3){this.h=j,this.j=C,this.k=Y,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:g.Initialize})}registerChannel(j,C){this.b.set(j,C),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case g.Initialize:{const C=this.o([j.type]);this.k?.logOutgoing(C,0,D.OtherSide,v(j.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const C=this.o([j.type,j.id],j.data);this.k?.logOutgoing(C,j.id,D.OtherSide,v(j.type),j.data);return}}}o(j,C=void 0){const Y=new u;return l(Y,j),l(Y,C),this.p(Y.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const C=new t(j),Y=S(C),oe=S(C),G=Y[0];switch(G){case w.Promise:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(G)}: ${Y[2]}.${Y[3]}`,oe),this.s({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:oe});case w.EventListen:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(G)}: ${Y[2]}.${Y[3]}`,oe),this.t({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:oe});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(G)}`),this.u({type:G,id:Y[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(G)}`),this.u({type:G,id:Y[1]})}}s(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const Y=new A.$ve;let oe;try{oe=C.call(this.j,j.name,j.arg,Y.token)}catch(re){oe=Promise.reject(re)}const G=j.id;oe.then(re=>{this.m({id:G,data:re,type:g.PromiseSuccess})},re=>{re instanceof Error?this.m({id:G,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:G,data:re,type:g.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.d.delete(j.id)});const ue=(0,c.$Rc)(()=>Y.cancel());this.d.set(j.id,ue)}t(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const Y=j.id,G=C.listen(this.j,j.name,j.arg)(ue=>this.m({id:Y,data:ue,type:g.EventFire}));this.d.set(j.id,G)}u(j){const C=this.d.get(j.id);C&&(C.dispose(),this.d.delete(j.id))}v(j){let C=this.g.get(j.channelName);C||(C=[],this.g.set(j.channelName,C));const Y=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);C.push({request:j,timeoutTimer:Y})}w(j){const C=this.g.get(j);if(C){for(const Y of C)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case w.Promise:this.s(Y.request);break;case w.EventListen:this.t(Y.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$fi=y;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class L{constructor(j,C=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$ke,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=C}getChannel(j){const C=this;return{call(Y,oe,G){return C.a?Promise.reject(new I.$4):C.m(j,Y,oe,G)},listen(Y,oe){return C.a?p.Event.None:C.o(j,Y,oe)}}}m(j,C,Y,oe=A.CancellationToken.None){const G=this.g++,ue=w.Promise,re={id:G,type:ue,channelName:j,name:C,arg:Y};if(oe.isCancellationRequested)return Promise.reject(new I.$4);let Q;return new Promise((N,W)=>{if(oe.isCancellationRequested)return W(new I.$4);const z=()=>{const ne=de=>{switch(de.type){case g.PromiseSuccess:this.f.delete(G),N(de.data);break;case g.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case g.PromiseErrorObj:this.f.delete(G),W(de.data);break}};this.f.set(G,ne),this.p(re)};let te=null;this.b===b.Idle?z():(te=(0,r.$qh)(ne=>this.u()),te.then(()=>{te=null,z()}));const ee=()=>{te?(te.cancel(),te=null):this.p({id:G,type:w.PromiseCancel}),W(new I.$4)},q=oe.onCancellationRequested(ee);Q=(0,c.$Qc)((0,c.$Rc)(ee),q),this.d.add(Q)}).finally(()=>{Q.dispose(),this.d.delete(Q)})}o(j,C,Y){const oe=this.g++,G=w.EventListen,ue={id:oe,type:G,channelName:j,name:C,arg:Y};let re=null;const Q=new p.$ke({onWillAddFirstListener:()=>{re=(0,r.$qh)(N=>this.u()),re.then(()=>{re=null,this.d.add(Q),this.p(ue)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(Q),this.p({id:oe,type:w.EventDispose}))}}),F=N=>Q.fire(N.data);return this.f.set(oe,F),Q.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const C=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(C,j.id,D.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const C=this.q([j.type,j.id]);this.j?.logOutgoing(C,j.id,D.LocalSide,f(j.type));return}}}q(j,C=void 0){const Y=new u;return l(Y,j),l(Y,C),this.r(Y.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const C=new t(j),Y=S(C),oe=S(C),G=Y[0];switch(G){case g.Initialize:return this.j?.logIncoming(j.byteLength,0,D.LocalSide,v(G)),this.t({type:Y[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,Y[1],D.LocalSide,v(G),oe),this.t({type:Y[0],id:Y[1],data:oe})}}t(j){if(j.type===g.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$gi=L,Se([T.$8h],L.prototype,"onDidInitializePromise",null);class R{get connections(){const j=[];return this.f.forEach(C=>j.push(C)),j}constructor(j,C,Y){this.a=new Map,this.f=new Set,this.g=new p.$ke,this.onDidAddConnection=this.g.event,this.h=new p.$ke,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(j(({protocol:oe,onDidClientDisconnect:G})=>{const ue=p.Event.once(oe.onMessage);this.j.add(ue(re=>{const Q=new t(re),F=S(Q),N=new y(oe,F,C,Y),W=new L(oe,C);this.a.forEach((te,ee)=>N.registerChannel(ee,te));const z={channelServer:N,channelClient:W,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{N.dispose(),W.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,C){const Y=this;return{call(oe,G,ue){let re;if((0,d.$rg)(C)){const F=(0,n.$2b)(Y.connections.filter(C));re=F?Promise.resolve(F):p.Event.toPromise(p.Event.filter(Y.onDidAddConnection,C))}else re=C.routeCall(Y,oe,G);const Q=re.then(F=>F.channelClient.getChannel(j));return M(Q).call(oe,G,ue)},listen(oe,G){if((0,d.$rg)(C))return Y.k(j,C,oe,G);const ue=C.routeEvent(Y,oe,G).then(re=>re.channelClient.getChannel(j));return M(ue).listen(oe,G)}}}k(j,C,Y,oe){const G=this;let ue;const re=new p.$ke({onWillAddFirstListener:()=>{ue=new c.$Sc;const Q=new p.$qe,F=new Map,N=z=>{const ee=z.channelClient.getChannel(j).listen(Y,oe),q=Q.add(ee);F.set(z,q)},W=z=>{const te=F.get(z);te&&(te.dispose(),F.delete(z))};G.connections.filter(C).forEach(N),p.Event.filter(G.onDidAddConnection,C)(N,void 0,ue),G.onDidRemoveConnection(W,void 0,ue),Q.event(re.fire,re,ue),ue.add(Q)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return re.event}registerChannel(j,C){this.a.set(j,C);for(const Y of this.f)Y.channelServer.registerChannel(j,C)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$hi=R;class O{constructor(j,C,Y=null){const oe=new u;l(oe,C),j.send(oe.buffer),this.a=new L(j,Y),this.d=new y(j,C,Y)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,C){this.d.registerChannel(j,C)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ii=O;function M(B){return{call(j,C,Y){return B.then(oe=>oe.call(j,C,Y))},listen(j,C){const Y=new p.$te;return B.then(oe=>Y.input=oe.listen(j,C)),Y.event}}}function x(B){let j=!1;return{call(C,Y,oe){return j?B.call(C,Y,oe):(0,r.$Eh)(0).then(()=>j=!0).then(()=>B.call(C,Y,oe))},listen(C,Y){if(j)return B.listen(C,Y);const oe=new p.$te;return(0,r.$Eh)(0).then(()=>j=!0).then(()=>oe.input=B.listen(C,Y)),oe.event}}}class X{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const C of j.connections)if(await Promise.resolve(this.a(C.ctx)))return Promise.resolve(C);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$li=X;var K;(function(B){function j(G,ue,re){const Q=G,F=re&&re.disableMarshalling,N=new Map;for(const W in Q)Y(W)&&N.set(W,p.Event.buffer(Q[W],!0,void 0,ue));return new class{listen(W,z,te){const ee=N.get(z);if(ee)return ee;const q=Q[z];if(typeof q=="function"){if(oe(z))return q.call(Q,te);if(Y(z))return N.set(z,p.Event.buffer(Q[z],!0,void 0,ue)),N.get(z)}throw new I.$ab(`Event not found: ${z}`)}call(W,z,te){const ee=Q[z];if(typeof ee=="function"){if(!F&&Array.isArray(te))for(let ne=0;ne<te.length;ne++)te[ne]=(0,m.$ai)(te[ne]);let q=ee.apply(Q,te);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new I.$ab(`Method not found: ${z}`)}}}B.fromService=j;function C(G,ue){const re=ue&&ue.disableMarshalling;return new Proxy({},{get(Q,F){if(typeof F=="string")return ue?.properties?.has(F)?ue.properties.get(F):oe(F)?function(N){return G.listen(F,N)}:Y(F)?G.listen(F):async function(...N){let W;ue&&!(0,d.$mg)(ue.context)?W=[ue.context,...N]:W=N;const z=await G.call(F,W);return re?z:(0,m.$ai)(z)};throw new I.$ab(`Property not found: ${String(F)}`)}})}B.toService=C;function Y(G){return G[0]==="o"&&G[1]==="n"&&h.$Df(G.charCodeAt(2))}function oe(G){return/^onDynamic/.test(G)&&h.$Df(G.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const j=B.toString();if(j!=="[object Object]")return j}return B}function J(B){return Array.isArray(B)?B.map(H):H(B)}function U(B,j,C,Y,oe,G,ue){ue=J(ue);const re=fe[oe],Q=re[Y%re.length];let F=[`%c[${B}]%c[${String(j).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(G)?(F=F.concat(ue),F.push(")")):F.push(ue),console.log.apply(console,F)}class Z{constructor(j,C){this.d=j,this.f=C,this.a=0,this.b=0}logOutgoing(j,C,Y,oe,G){this.b+=j,U(this.d,this.b,j,C,Y,oe,G)}logIncoming(j,C,Y,oe,G){this.a+=j,U(this.f,this.a,j,C,Y,oe,G)}}e.$mi=Z}),define(ce[156],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WX=void 0;class n{constructor(P,A){this.a=P,this.onMessage=A}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$WX=n}),define(ce[157],le([0,1,17,4,44]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UX=e.$TX=void 0;class A{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Me.wrap(c.data):n.$Me.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$TX=A;class T extends P.$ii{constructor(p,c){const m=new A(p);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$UX=T}),define(ce[117],le([0,1,17,4,2,44]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.ProtocolConstants=e.$ni=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function S(D,L){if(!a.has(D)){const R=String(++l);a.set(D,R)}return a.get(D)}function y(D,L,R,O){if(!s.enableDiagnostics)return;const M=S(D,L);if(O instanceof n.$Me||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const x=n.$Me.alloc(O.byteLength);x.set(O),s.records.push({timestamp:Date.now(),id:M,label:L,type:R,buff:x})}else s.records.push({timestamp:Date.now(),id:M,label:L,type:R,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function m(){return c||(c=n.$Me.alloc(0)),c}class h{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return m();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const S=n.$Me.alloc(a);let y=0,D=0;for(;a>0;){const L=this.a[D];if(L.byteLength>a){const R=L.slice(0,a);S.set(R,y),y+=a,l&&(this.a[D]=L.slice(a),this.b-=a),a-=a}else S.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):D++,a-=L.byteLength}return S}}e.$ni=h;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function w(s){switch(s){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class g{constructor(a,l,S,y){this.type=a,this.id=l,this.ack=S,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends P.$Tc{constructor(a){super(),this.f=this.B(new r.$ke),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:d.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new h,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new g(S,y,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Me.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const S=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,S}h(){const a=n.$Me.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends P.$Tc{constructor(a){super(),this.f=new r.$ke,this.onMessage=this.f.event,this.g=new r.$ke,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===d.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(d.Regular,0,0,a))}}e.$oi=$;class k extends A.$ii{static fromSocket(a,l){return new k(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,S=null){super(a,l,S),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$pi=k;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$ke({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$qi=E;class t{constructor(a){this.data=a,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,S=this.a;for(;S;)a[l++]=S.data,S=S.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new t(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<i.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+i.a)*1e3;let S=0;for(let y=0;y<i.a;y++)a-this.c[y]<=l&&S++;return 1-S/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new E,this.onControlMessage=this.v.event,this.w=new E,this.onMessage=this.w.event,this.x=new E,this.onDidDispose=this.x.event,this.y=new E,this.onSocketClose=this.y.event,this.z=new E,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??i.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new P.$Sc,this.p=a.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new g(d.Disconnect,0,0,m());this.q.write(a),this.q.flush()}}sendPause(){const a=new g(d.Pause,0,0,m());this.q.write(a)}sendResume(){const a=new g(d.Resume,0,0,m());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new P.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a);const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case d.None:break;case d.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new g(d.ReplayRequest,0,0,m())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case d.Control:{this.v.fire(a.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const S=new g(d.Regular,l,this.j,a);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(a){const l=new g(d.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,S=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&S>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const D=Math.max(f.TimeoutTime-l,f.TimeoutTime-S,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a)}E(){this.j=this.h;const a=new g(d.KeepAlive,0,this.j,m());this.q.write(a)}}e.$ri=o});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[35],le([0,1,13,15,11]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QX=void 0,n=Ve(n);class A{constructor(){this.a=new WeakMap}on(I,p){const c=(m,...h)=>{this.b(I,m)&&p(m,...h)};return this.a.set(p,c),n.default.ipcMain.on(I,c),this}once(I,p){return n.default.ipcMain.once(I,(c,...m)=>{this.b(I,c)&&p(c,...m)}),this}handle(I,p){return n.default.ipcMain.handle(I,(c,...m)=>this.b(I,c)?p(c,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.default.ipcMain.removeHandler(I),this}removeListener(I,p){const c=this.a.get(p);return c&&(n.default.ipcMain.removeListener(I,c),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=p.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let h="unknown";try{h=new URL(m).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return h!==P.$Wg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${h}'.`),!1):c.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${h}' is not a main frame.`),!1):!0}}e.$QX=new A}),define(ce[158],le([0,1,13,35,155]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RX=A;function A(){r.$QX.on(P.$OX,(I,p,c,m,h)=>{const d=T(I,m,c);d.popup({x:h?h.x:void 0,y:h?h.y:void 0,positioningItem:h?h.positioningItem:void 0,callback:()=>{d&&I.sender.send(P.$PX,p)}})})}function T(I,p,c){const m=new n.Menu;return c.forEach(h=>{let d;h.type==="separator"?d=new n.MenuItem({type:h.type}):Array.isArray(h.submenu)?d=new n.MenuItem({submenu:T(I,p,h.submenu),label:h.label}):d=new n.MenuItem({label:h.label,type:h.type,accelerator:h.accelerator,checked:h.checked,enabled:h.enabled,visible:h.visible,click:(w,f,g)=>I.sender.send(p,h.id,g)}),m.append(d)}),m}}),define(ce[159],le([0,1,35,17,4,2,44,156]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XX=void 0;function p(m,h){const d=P.Event.fromNodeEventEmitter(n.$QX,h,(f,g)=>({event:f,message:g})),w=P.Event.filter(d,({event:f})=>f.sender.id===m);return P.Event.map(w,({message:f})=>f&&r.$Me.wrap(f))}class c extends T.$hi{static{this.b=new Map}static d(){const h=P.Event.fromNodeEventEmitter(n.$QX,"vscode:hello",({sender:d})=>d);return P.Event.map(h,d=>{const w=d.id;c.b.get(w)?.dispose();const g=new P.$ke;c.b.set(w,(0,A.$Rc)(()=>g.fire()));const v=p(w,"vscode:message"),b=P.Event.any(P.Event.signal(p(w,"vscode:disconnect")),g.event);return{protocol:new I.$WX(d,v),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$XX=c}),define(ce[118],le([0,1,35,4,33,157]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YX=void 0,e.$ZX=I;class T extends A.$UX{constructor(c,m){super({addEventListener:(h,d)=>c.addListener(h,d),removeEventListener:(h,d)=>c.removeListener(h,d),postMessage:h=>c.postMessage(h),start:()=>c.start(),close:()=>c.close()},m)}}e.$YX=T;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Zg)();p.webContents.send("vscode:createMessageChannel",c);const m=r.Event.fromNodeEventEmitter(n.$QX,"vscode:createMessageChannelResult",(d,w)=>({nonce:w,port:d.ports[0]})),{port:h}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,d=>d.nonce===c)));return h}}),define(ce[160],le([0,1,48,8,17,22,150,15,4,2,37,94,79,44]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,I=Pe(I);class f extends w.$fi{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>P.$Me.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$fr=f;class g{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$ke,this.onDidProcessExit=this.h.event;const k=$&&$.timeout?$.timeout:6e4;this.b=new r.$Ah(k),this.d=null,this.f=null}getChannel(b){const $=this;return{call(k,E,t){return $.k(b,k,E,t)},listen(k,E){return $.l(b,k,E)}}}k(b,$,k,E=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const t=this.n(b),u=(0,r.$qh)(s=>t.call($,k,s)),i=E.onCancellationRequested(()=>u.cancel()),o=(0,c.$Rc)(()=>u.cancel());return this.c.add(o),u.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(b,$,k){if(!this.b)return p.Event.None;this.b.cancel();let E;const t=new p.$ke({onWillAddFirstListener:()=>{E=this.n(b).listen($,k)(t.fire,t),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,m.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,d.$km)($.env),this.d=(0,n.fork)(this.i,b,$);const k=new p.$ke,t=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$br)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}k.fire(P.$Me.wrap(Buffer.from(l,"base64")))}),u=this.j.useQueue?(0,h.$xm)(this.d):this.d,i=l=>this.d&&this.d.connected&&u.send(l.buffer.toString("base64")),o=k.event,s={send:i,onMessage:o};this.f=new w.$gi(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,S)=>{process.removeListener("exit",a),t.dispose(),this.c.forEach(y=>(0,c.$Oc)(y)),this.c.clear(),l!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:S})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=g}),define(ce[119],le([0,1,8,4,2,82,12]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=p;var I;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(d){const w=d;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends P.$Tc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$ne),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Bh(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,g)=>this.w(g,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===c.Closed)return;let g=!1;(0,T.$mg)(f)?g=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),g=!0),g&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const g=this.f.get(w);return(0,T.$mg)(g)?f:g}getBoolean(w,f){const g=this.get(w);return(0,T.$mg)(g)?f:g==="true"}getNumber(w,f){const g=this.get(w);return(0,T.$mg)(g)?f:parseInt(g,10)}getObject(w,f){const g=this.get(w);return(0,T.$mg)(g)?f:(0,A.$_h)(g)}async set(w,f,g=!1){if(this.c===c.Closed)return;if((0,T.$mg)(f))return this.delete(w,g);const v=(0,T.$fg)(f)||Array.isArray(f)?(0,A.$$h)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:g}),this.D()}async delete(w,f=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$cq=m;class h{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,g)=>this.a.set(g,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$dq=h}),define(ce[161],le([0,1,26,8,4,31,9,23]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jY=void 0,n=Pe(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return P.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,d=Object.create(null)){this.g=h,this.h=d,this.c=(0,T.$mc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,d=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(f=>d.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(h){const d=await this.f;return this.j(d,h)}j(h,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,A.$xc)(d.insert):"0"}), delete(${d.delete?(0,A.$yc)(d.delete):"0"})`),this.t(h,()=>{const w=d.insert,f=d.delete;if(w&&w.size>0){const g=[];g.push([]);let v=0;w.forEach((b,$)=>{let k=g[v];k.length>p.b&&(v++,k=[],g.push(k)),k.push($,b)}),g.forEach(b=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let k=0;return w.forEach((E,t)=>{$.push(t),k+=E.length}),`Keys: ${$.join(", ")} Length: ${k}`})})}if(f&&f.size){const g=[];g.push([]);let v=0;f.forEach(b=>{let $=g[v];$.length>p.b&&(v++,$=[],g.push($)),$.push(b)}),g.forEach(b=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(k=>{$.push(k)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,h)}k(h,d){return new Promise((w,f)=>{h.db.close(g=>(g&&this.o(h,`[storage ${this.c}] close(): ${g}`),this.g===p.IN_MEMORY_PATH?w():!h.isErroneous&&!h.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof d=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:d()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(g||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return I.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const d=await this.f,w=await this.r(d,h?"PRAGMA integrity_check":"PRAGMA quick_check"),f=h?w.integrity_check:w.quick_check;return d.isErroneous?`${f} (last error: ${d.lastError})`:d.isInMemory?`${f} (in-memory!)`:f}async n(h,d=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${d})`);try{return await this.p(h)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&d)return await(0,r.$Eh)(p.a),this.n(h,!1);try{await n.promises.unlink(h);try{await I.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(h,d){h.isErroneous=!0,h.lastError=d,this.d.error(d)}p(h){return new Promise((d,w)=>{new Promise((f,g)=>{V(["@vscode/sqlite3"],f,g)}).then(Pe).then(f=>{const g=this.d.isTracing?f.verbose().Database:f.Database,v={db:new g(h,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>w(b)):w(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),$=>v.db.close(()=>w($)))),isInMemory:h===p.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},w)})}q(h,d){return new Promise((w,f)=>{h.db.exec(d,g=>g?(this.o(h,`[storage ${this.c}] exec(): ${g}`),f(g)):w())})}r(h,d){return new Promise((w,f)=>{h.db.get(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] get(): ${g}`),f(g)):w(v))})}s(h,d){return new Promise((w,f)=>{h.db.all(d,(g,v)=>g?(this.o(h,`[storage ${this.c}] all(): ${g}`),f(g)):w(v))})}t(h,d){return new Promise((w,f)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),d(),h.db.run("END TRANSACTION",g=>g?(this.o(h,`[storage ${this.c}] transaction(): ${g}`),f(g)):w())})})}u(h,d,w,f){const g=h.db.prepare(d),v=b=>{this.o(h,`[storage ${this.c}] prepare(): ${b} (${d}). Details: ${f()}`)};g.on("error",v),w(g),g.finalize(b=>{b&&v(b),g.removeListener("error",v)})}}e.$jY=p;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[c.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(ce[10],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=P,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let c;return p.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(m,h)=>{const d=h[0],w=p[d];let f=m;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function P(I,p,...c){return r(typeof I=="number"?A(I,p):p,c)}function A(I,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function T(I,p,...c){let m;typeof I=="number"?m=A(I,p):m=p;const h=r(m,c);return{value:h,original:p===m?h:r(p,c)}}}),define(ce[162],le([0,1,10]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=c,e.$1m=m,e.$2m=h;const r=60,P=r*60,A=P*24,T=A*7,I=A*30,p=A*365;function c(d,w,f,g){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,n.localize)(12929,null,c(new Date().getTime()+v*1e3,!1));if(!g&&v<30)return(0,n.localize)(12930,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(12931,null,b):(0,n.localize)(12932,null,b):f?(0,n.localize)(12933,null,b):(0,n.localize)(12934,null,b):b===1?f?(0,n.localize)(12935,null,b):(0,n.localize)(12936,null,b):f?(0,n.localize)(12937,null,b):(0,n.localize)(12938,null,b)):v<P?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(12939,null,b):(0,n.localize)(12940,null,b):f?(0,n.localize)(12941,null,b):(0,n.localize)(12942,null,b):b===1?f?(0,n.localize)(12943,null,b):(0,n.localize)(12944,null,b):f?(0,n.localize)(12945,null,b):(0,n.localize)(12946,null,b)):v<A?(b=Math.floor(v/P),w?b===1?f?(0,n.localize)(12947,null,b):(0,n.localize)(12948,null,b):f?(0,n.localize)(12949,null,b):(0,n.localize)(12950,null,b):b===1?f?(0,n.localize)(12951,null,b):(0,n.localize)(12952,null,b):f?(0,n.localize)(12953,null,b):(0,n.localize)(12954,null,b)):v<T?(b=Math.floor(v/A),w?b===1?(0,n.localize)(12955,null,b):(0,n.localize)(12956,null,b):b===1?(0,n.localize)(12957,null,b):(0,n.localize)(12958,null,b)):v<I?(b=Math.floor(v/T),w?b===1?f?(0,n.localize)(12959,null,b):(0,n.localize)(12960,null,b):f?(0,n.localize)(12961,null,b):(0,n.localize)(12962,null,b):b===1?f?(0,n.localize)(12963,null,b):(0,n.localize)(12964,null,b):f?(0,n.localize)(12965,null,b):(0,n.localize)(12966,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(12967,null,b):(0,n.localize)(12968,null,b):f?(0,n.localize)(12969,null,b):(0,n.localize)(12970,null,b):b===1?f?(0,n.localize)(12971,null,b):(0,n.localize)(12972,null,b):f?(0,n.localize)(12973,null,b):(0,n.localize)(12974,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(12975,null,b):(0,n.localize)(12976,null,b):f?(0,n.localize)(12977,null,b):(0,n.localize)(12978,null,b):b===1?f?(0,n.localize)(12979,null,b):(0,n.localize)(12980,null,b):f?(0,n.localize)(12981,null,b):(0,n.localize)(12982,null,b))}function m(d,w){const f=Math.abs(d/1e3);return f<1?w?(0,n.localize)(12983,null,d):(0,n.localize)(12984,null,d):f<r?w?(0,n.localize)(12985,null,Math.round(d)/1e3):(0,n.localize)(12986,null,Math.round(d)/1e3):f<P?w?(0,n.localize)(12987,null,Math.round(d/(1e3*r))):(0,n.localize)(12988,null,Math.round(d/(1e3*r))):f<A?w?(0,n.localize)(12989,null,Math.round(d/(1e3*P))):(0,n.localize)(12990,null,Math.round(d/(1e3*P))):(0,n.localize)(12991,null,Math.round(d/(1e3*A)))}function h(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[55],le([0,1,21,12,10]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=p,e.$pj=c,e.$qj=m,n=Pe(n),r=Pe(r),P=Pe(P);function A(h,d){return d&&(h.stack||h.stacktrace)?P.localize(12923,null,I(h),T(h.stack)||T(h.stacktrace)):I(h)}function T(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?P.localize(12924,null,h.message):h.message||P.localize(12925,null)}function p(h=null,d=!1){if(!h)return P.localize(12926,null);if(Array.isArray(h)){const w=n.$Gb(h),f=p(w[0],d);return w.length>1?P.localize(12927,null,f,w.length):f}if(r.$dg(h))return h;if(h.detail){const w=h.detail;if(w.error)return A(w.error,d);if(w.exception)return A(w.exception,d)}return h.stack?A(h,d):h.message?h.message:P.localize(12928,null)}function c(h){const d=h;return d instanceof Error&&Array.isArray(d.actions)}function m(h,d){let w;return typeof h=="string"?w=new Error(h):w=h,w.actions=d,w}}),define(ce[163],le([0,1,10,43]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=P;function P(A){switch(A){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12914,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12915,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12916,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12917,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12918,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12919,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12920,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12921,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12922,null);default:return""}}}),define(ce[164],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hb=n,e.$9hb=r;function n(P){return P&&P.hasOwnProperty("folderUri")}function r(P){return P&&P.hasOwnProperty("workspace")}}),define(ce[165],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=r,e.$vfc=P,e.$wfc=A;function r(T){return typeof T?.backupFolder=="string"}function P(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function A(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(ce[166],le([0,1,39,15,10]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.TokenType=void 0;var A;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...m){switch(m.length){case 1:return(0,P.localize)(11530,null,m[0]);case 2:return(0,P.localize)(11531,null,m[0],m[1]);case 3:return(0,P.localize)(11532,null,m[0],m[1],m[2]);default:return}}const I=(0,P.localize)(11533,null),p=(0,P.localize)(11534,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return h.isTripleEq?"===":"==";case A.NotEq:return h.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return h.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return h.lexeme;case A.QuotedStr:return h.lexeme;case A.Error:return h.lexeme;case A.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(A.LParen);break;case n.CharCode.CloseParen:this.k(A.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:d})}else this.k(A.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:d})}else this.h(n.CharCode.Tilde)?this.k(A.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?A.LtEq:A.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?A.GtEq:A.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(A.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(A.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const d=this.d,w=this.c.substring(this.d,this.e),f={type:A.Error,offset:this.d,lexeme:w};this.g.push({offset:d,lexeme:w,additionalInfo:h}),this.f.push(f)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const d=this.c.substring(this.d,this.e),w=c.b.get(d);w?this.k(w):this.f.push({type:A.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,d=!1,w=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(p);return}const g=this.c.charCodeAt(h);if(d)d=!1;else if(g===n.CharCode.Slash&&!w){h++;break}else g===n.CharCode.OpenSquareBracket?w=!0:g===n.CharCode.Backslash?d=!0:g===n.CharCode.CloseSquareBracket&&(w=!1);h++}for(;h<this.c.length&&c.a.has(this.c.charCodeAt(h));)h++;this.e=h;const f=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$yj=c}),define(ce[167],le([0,1,4,2]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;class P{constructor(){this.a=new n.$ke,this.b=new n.$ke,this.c=new n.$ke,this.d=new n.$ke}static{this.ChannelName="extensionhostdebugservice"}call(I,p,c){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,p,c){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Xo=P;class A extends r.$Tc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,c){this.b.call("attach",[I,p,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$Yo=A}),define(ce[168],le([0,1,162,54,11,9,36,18,7]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$5m=m,e.$6m=h,e.$3m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,A.$lc)(P.$Xg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$eh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$eh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$eh)(p.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$eh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$eh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$eh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,A.$ic)(w,"argv.json")):(0,I.$eh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,A.$jc)(w):(0,A.$gc)((0,A.$ic)(P.$Xg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,A.$jc)(w)):p.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,A.$jc)(w);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const g=T.env.VSCODE_PORTABLE;return g?(0,A.$ic)(g,"extensions"):(0,I.$eh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,A.$gc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,A.$gc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$3m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const g=e.$3m.exec(f);g&&g[1]&&g[2]&&w.push([g[1],g[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$eh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,A.$ic)(w,"policy.json")):(0,I.$eh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,g){this.a=w,this.b=f,this.c=g,this.editSessionId=this.args.editSessionId}}e.$4m=c,Se([r.$8h],c.prototype,"appRoot",null),Se([r.$8h],c.prototype,"userHome",null),Se([r.$8h],c.prototype,"userDataPath",null),Se([r.$8h],c.prototype,"appSettingsHome",null),Se([r.$8h],c.prototype,"tmpDir",null),Se([r.$8h],c.prototype,"cacheHome",null),Se([r.$8h],c.prototype,"stateResource",null),Se([r.$8h],c.prototype,"userRoamingDataHome",null),Se([r.$8h],c.prototype,"userDataSyncHome",null),Se([r.$8h],c.prototype,"sync",null),Se([r.$8h],c.prototype,"machineSettingsResource",null),Se([r.$8h],c.prototype,"workspaceStorageHome",null),Se([r.$8h],c.prototype,"localHistoryHome",null),Se([r.$8h],c.prototype,"keyboardLayoutResource",null),Se([r.$8h],c.prototype,"argvResource",null),Se([r.$8h],c.prototype,"isExtensionDevelopment",null),Se([r.$8h],c.prototype,"untitledWorkspacesHome",null),Se([r.$8h],c.prototype,"builtinExtensionsPath",null),Se([r.$8h],c.prototype,"extensionsPath",null),Se([r.$8h],c.prototype,"extensionDevelopmentLocationURI",null),Se([r.$8h],c.prototype,"extensionDevelopmentKind",null),Se([r.$8h],c.prototype,"extensionTestsLocationURI",null),Se([r.$8h],c.prototype,"debugExtensionHost",null),Se([r.$8h],c.prototype,"logLevel",null),Se([r.$8h],c.prototype,"extensionLogLevel",null),Se([r.$8h],c.prototype,"serviceMachineIdResource",null),Se([r.$8h],c.prototype,"disableTelemetry",null),Se([r.$8h],c.prototype,"disableWorkspaceTrust",null),Se([r.$8h],c.prototype,"useInMemorySecretStorage",null),Se([r.$8h],c.prototype,"policyFile",null);function m(d,w){return h(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}function h(d,w,f,g,v,b){const k=Number(w||d)||(g?null:f),E=k?!!w:!1;let t;if(b)try{t=JSON.parse(b)}catch{}return{port:k,break:E,debugId:v,env:t}}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[120],le([0,1,280,3,10]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$Bm=I,e.$Cm=c,e.$Dm=w,e.$Em=f,n=Ve(n);const A={o:(0,P.localize)(11467,null),e:(0,P.localize)(11468,null),t:(0,P.localize)(11469,null)};e.$zm=["tunnel","serve-web"],e.$Am={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11470,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11471,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(11472,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(11473,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(11474,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(11475,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(11476,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(11477,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11478,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11479,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(11480,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(11481,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11482,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(11483,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11484,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(11485,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(11486,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(11487,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(11488,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(11489,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11490,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(11491,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(11492,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(11493,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(11494,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(11495,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(11496,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(11497,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(11498,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(11499,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11500,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11501,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,P.localize)(11502,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(11503,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(11504,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(11505,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(g,v,b=T){const $=g.find(l=>l.length>0&&l[0]!=="-"),k={},E=["_"],t=[],u={};let i;for(const l in v){const S=v[l];S.type==="subcommand"?l===$&&(i=S):(S.alias&&(k[l]=S.alias),S.type==="string"||S.type==="string[]"?(E.push(l),S.deprecates&&E.push(...S.deprecates)):S.type==="boolean"&&(t.push(l),S.deprecates&&t.push(...S.deprecates)),S.global&&(u[l]=S))}if(i&&$){const l=u;for(const L in i.options)l[L]=i.options[L];const S=g.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,D=I(S,l,y);return{[$]:D,_:[]}}const o=(0,n.default)(g,{string:E,boolean:t,alias:k}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const S=v[l];if(S.type==="subcommand")continue;S.alias&&delete a[S.alias];let y=a[l];if(S.deprecates)for(const D of S.deprecates)a.hasOwnProperty(D)&&(y||(y=a[D],y&&b.onDeprecatedOption(D,S.deprecationMessage||(0,P.localize)(11506,null,l))),delete a[D]);if(typeof y<"u"){if(S.type==="string[]"){if(Array.isArray(y)||(y=[y]),!S.allowEmptyValue){const D=y.filter(L=>L.length>0);D.length!==y.length&&(b.onEmptyValue(l),y=D.length>0?D:void 0)}}else S.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!S.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,S.deprecationMessage&&b.onDeprecatedOption(l,S.deprecationMessage)}delete a[l]}for(const l in a)b.onUnknownOption(l);return s}function p(g,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${g}${b}`:`--${g}${b}`}function c(g,v){const b=[];for(const $ in g){const k=g[$],E=p($,k);b.push([E,k.description])}return m(b,v)}function m(g,v){const $=g.reduce((t,u)=>Math.max(t,u[0].length),12)+2+1;if(v-$<25)return g.reduce((t,u)=>t.concat([`  ${u[0]}`,`      ${u[1]}`]),[]);const k=v-$-1,E=[];for(const t of g){const u=t[0],i=d(t[1],k),o=h($-u.length-2);E.push("  "+u+o+i[0]);for(let s=1;s<i.length;s++)E.push(h($)+i[s])}return E}function h(g){return" ".repeat(g)}function d(g,v){const b=[];for(;g.length;){const $=g.length<v?g.length:g.lastIndexOf(" ",v),k=g.slice(0,$).trim();g=g.slice($),b.push(k)}return b}function w(g,v,b,$,k){const E=process.stdout.isTTY&&process.stdout.columns||80,t=k?.noInputFiles!==!0?`[${(0,P.localize)(11507,null)}...]`:"",u=[`${g} ${b}`];u.push(""),u.push(`${(0,P.localize)(11508,null)}: ${v} [${(0,P.localize)(11509,null)}]${t}`),u.push(""),k?.noPipe!==!0&&(r.$j?u.push((0,P.localize)(11510,null,v)):u.push((0,P.localize)(11511,null,v)),u.push(""));const i={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=i[a.cat];l||(i[a.cat]=l={}),l[s]=a}}for(const s in i){const a=s,l=i[a];l&&(u.push(A[a]),u.push(...c(l,E)),u.push(""))}return o.length&&(u.push((0,P.localize)(11512,null)),u.push(...m(o.map(s=>[s.command,s.description]),E)),u.push("")),u.join(`
`)}function f(g,v){return`${g||(0,P.localize)(11513,null)}
${v||(0,P.localize)(11514,null)}
${process.arch}`}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[68],le([0,1,281,10,120]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=I,e.$Gm=p,e.$Hm=c,e.$Im=m,n=Ve(n);function A(h,d){const w=(k,E)=>{console.warn((0,r.localize)(11461,null,k,E))},f=k=>{console.warn((0,r.localize)(11462,null,k))},g=(k,E)=>{console.warn((0,r.localize)(11463,null,k,E))},v=k=>({onUnknownOption:E=>{P.$zm.includes(k)||console.warn((0,r.localize)(11464,null,E,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:P.$zm.includes(k)?v:void 0}),b={onUnknownOption:k=>{console.warn((0,r.localize)(11465,null,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:v},$=(0,P.$Bm)(h,P.$Am,d?b:void 0);return $.goto&&$._.forEach(k=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(k),(0,r.localize)(11466,null))),$}function T(h){const d=h.findIndex(w=>!/^-/.test(w));if(d>-1)return[...h.slice(0,d),...h.slice(d+1)]}function I(h){let[,...d]=h;process.env.VSCODE_DEV&&(d=T(d)||[]);const w=!m(process.env);return A(d,w)}function p(h){let[,,...d]=h;return process.env.VSCODE_DEV&&(d=T(d)||[]),A(d,!0)}function c(h,...d){const w=h.indexOf("--");return w===-1?h.push(...d):h.splice(w,0,...d),h}function m(h){return h.VSCODE_CLI==="1"}}),function(){function V(e,n,r){function P(T,I){const p=A(T,I),c=[p];return e.isAbsolute(p)||c.unshift(r),e.resolve(...c)}function A(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=T["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(h,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:P}}if(typeof define=="function")define(ce[169],le([121,27,36]),function(e,n,r){return V(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=V(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,168,169]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$8m=T,e.$9m=I;class A extends r.$4m{constructor(c,m){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,m.nameShort)},m)}}e.$7m=A;function T(p,c){return(0,r.$6m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function I(p,c){return(0,r.$6m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(ce[170],le([0,1,26,27,32]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=A;function A(T){const I=(0,P.$Lg)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){T&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(ce[171],le([0,1,12,10]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=P;function P(T,I,p,c){try{A(T,I,p,c)}catch(m){T.error(m?.message??m)}return I}function A(T,I,p,c){const m=(h,d,w)=>{const f=h[d];if((0,n.$dg)(f)){const g=f,v=g.length;if(v>1&&g[0]==="%"&&g[v-1]==="%"){const b=g.substr(1,v-2);let $=p[b];$===void 0&&c&&($=c[b]);const k=typeof $=="string"?$:$?.message,E=c?.[b],t=typeof E=="string"?E:E?.message;if(!k){t||T.warn(`[${I.name}]: ${(0,r.localize)(11413,null,b)}`);return}if(w&&(d==="title"||d==="category")&&t&&t!==k){const u={value:k,original:t};h[d]=u}else h[d]=k}}else if((0,n.$fg)(f))for(const g in f)f.hasOwnProperty(g)&&(g==="commands"?m(f,g,!0):m(f,g,w));else if(Array.isArray(f))for(let g=0;g<f.length;g++)m(f,g,w)};for(const h in I)I.hasOwnProperty(h)&&m(I,h)}}),define(ce[172],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ce[83],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class n{constructor(P,A=[],T=!1){this.ctor=P,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.$Ai=n}),define(ce[173],le([0,1,83]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=A,e.$Qs=T;const r=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function A(I,p,c){p instanceof n.$Ai||(p=new n.$Ai(p,[],!!c)),r.push([I,p])}function T(){return r}}),define(ce[174],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class n{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$sr=n;class r{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const I=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let I=this.a.get(T);return I||(I=new n(T,A),this.a.set(T,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,I]of this.a)A.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const I=new Set([A]),p=this.c(T,I);if(p)return p}}c(A,T){for(const[I,p]of A.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const c=this.c(p,T);if(c)return c;T.delete(I)}}}e.$tr=r}),define(ce[6],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e._util=void 0,e.$Di=P,e.$Ei=A;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Ci=P("instantiationService");function r(T,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:p}):(I[n.DI_DEPENDENCIES]=[{id:T,index:p}],I[n.DI_TARGET]=I)}function P(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(p,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,m)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function A(T){return T}}),define(ce[84],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0,e.$pgc=(0,n.$Di)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0,e.$xfc=(0,n.$Di)("backupMainService")}),define(ce[16],le([0,1,12,7,6]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$0i=void 0,e.$$i=A,e.$_i=T,e.$aj=p,e.$bj=c,e.$cj=m,e.$dj=h,e.$ej=d,e.$fj=f,e.$gj=g,e.$hj=v,n=Pe(n),e.$0i=(0,P.$Di)("configurationService");function A(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function T(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function m(b,$){const k=Object.create(null);for(const E in b)h(k,E,b[E],$);return k}function h(b,$,k,E){const t=$.split("."),u=t.pop();let i=b;for(let o=0;o<t.length;o++){const s=t[o];let a=i[s];switch(typeof a){case"undefined":a=i[s]=Object.create(null);break;case"object":if(a===null){E(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is null`);return}break;default:E(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}i=a}if(typeof i=="object"&&i!==null)try{i[u]=k}catch{E(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}else E(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}function d(b,$){const k=$.split(".");w(b,k)}function w(b,$){const k=$.shift();if($.length===0){delete b[k];return}if(Object.keys(b).indexOf(k)!==-1){const E=b[k];typeof E=="object"&&!Array.isArray(E)&&(w(E,$),Object.keys(E).length===0&&delete b[k])}}function f(b,$,k){function E(i,o){let s=i;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const t=$.split("."),u=E(b,t);return typeof u>"u"?k:u}function g(b,$,k){Object.keys($).forEach(E=>{E!=="__proto__"&&(E in b?n.$fg(b[E])&&n.$fg($[E])?g(b[E],$[E],k):k&&(b[E]=$[E]):b[E]=$[E])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(ce[122],le([0,1,39,3,25,166,6,10,15]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Bj=e.$Aj=e.ContextKeyExprType=void 0,e.$zj=m,e.$Cj=o,e.$Dj=s,e.$Wj=G;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function m(Q,F){if(c.get(Q)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Q,F)}const h=Object.prototype.hasOwnProperty;var d;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11544,null),g=(0,I.localize)(11545,null),v=(0,I.localize)(11546,null),b=(0,I.localize)(11547,null),$=(0,I.localize)(11548,null),k=(0,I.localize)(11549,null),E=(0,I.localize)(11550,null),t=(0,I.localize)(11551,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=w){this.k=F,this.d=new A.$yj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const W=this.D(),z=W.type===A.TokenType.Str?k:void 0;throw this.h.push({message:$,offset:W.offset,lexeme:A.$yj.getLexeme(W),additionalInfo:z}),u.c}return N}catch(N){if(N!==u.c)throw N;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(A.TokenType.Or);){const N=this.o();F.push(N)}return F.length===1?F[0]:i.or(...F)}o(){const F=[this.s()];for(;this.y(A.TokenType.And);){const N=this.s();F.push(N)}return F.length===1?F[0]:i.and(...F)}s(){if(this.y(A.TokenType.Neg)){const F=this.D();switch(F.type){case A.TokenType.True:return this.z(),l.INSTANCE;case A.TokenType.False:return this.z(),S.INSTANCE;case A.TokenType.LParen:{this.z();const N=this.l();return this.A(A.TokenType.RParen,b),N?.negate()}case A.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const N=this.l();return this.A(A.TokenType.RParen,b),N}case A.TokenType.Str:{const N=F.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==A.TokenType.RegexStr)throw this.B("REGEX",z);const te=z.lexeme,ee=te.lastIndexOf("/"),q=ee===te.length-1?void 0:this.w(te.substring(ee+1));let ne;try{ne=new RegExp(te.substring(1,ee),q)}catch{throw this.B("REGEX",z)}return J.create(N,ne)}switch(z.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const te=[z.lexeme];this.z();let ee=this.D(),q=0;for(let Ie=0;Ie<z.lexeme.length;Ie++)z.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&q--;for(;!this.E()&&ee.type!==A.TokenType.And&&ee.type!==A.TokenType.Or;){switch(ee.type){case A.TokenType.LParen:q++;break;case A.TokenType.RParen:q--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ie=0;Ie<ee.lexeme.length;Ie++)ee.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&q--}if(q<0)break;te.push(A.$yj.getLexeme(ee)),this.z(),ee=this.D()}const ne=te.join(""),de=ne.lastIndexOf("/"),me=de===ne.length-1?void 0:this.w(ne.substring(de+1));let we;try{we=new RegExp(ne.substring(1,de),me)}catch{throw this.B("REGEX",z)}return i.regex(N,we)}case A.TokenType.QuotedStr:{const te=z.lexeme;this.z();let ee=null;if(!(0,P.$bf)(te)){const q=te.indexOf("/"),ne=te.lastIndexOf("/");if(q!==ne&&q>=0){const de=te.slice(q+1,ne),me=te[ne+1]==="i"?"i":"";try{ee=new RegExp(de,me)}catch{throw this.B("REGEX",z)}}}if(ee===null)throw this.B("REGEX",z);return J.create(N,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,v);const z=this.u();return i.notIn(N,z)}switch(this.D().type){case A.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(N,z);switch(z){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,z)}}case A.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(N,z);switch(z){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,z)}}case A.TokenType.Lt:return this.z(),fe.create(N,this.u());case A.TokenType.LtEq:return this.z(),H.create(N,this.u());case A.TokenType.Gt:return this.z(),X.create(N,this.u());case A.TokenType.GtEq:return this.z(),K.create(N,this.u());case A.TokenType.In:return this.z(),i.in(N,this.u());default:return i.has(N)}}case A.TokenType.EOF:throw this.h.push({message:E,offset:F.offset,lexeme:"",additionalInfo:t}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),F.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,N){if(this.C(F))return this.z();throw this.B(N,this.D())}B(F,N,W){const z=(0,I.localize)(11552,null,F,A.$yj.getLexeme(N)),te=N.offset,ee=A.$yj.getLexeme(N);return this.h.push({message:z,offset:te,lexeme:ee,additionalInfo:W}),u.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Aj=u;class i{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(F){return y.create(F)}static equals(F,N){return D.create(F,N)}static notEquals(F,N){return O.create(F,N)}static regex(F,N){return J.create(F,N)}static in(F,N){return L.create(F,N)}static notIn(F,N){return R.create(F,N)}static not(F){return M.create(F)}static and(...F){return B.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,N){return X.create(F,N)}static greaterEquals(F,N){return K.create(F,N)}static smaller(F,N){return fe.create(F,N)}static smallerEquals(F,N){return H.create(F,N)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Bj=i;function o(Q){const F=new u({regexParsingWithErrorRecovery:!1});return Q.map(N=>(F.parse(N),F.lexingErrors.length>0?F.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,I.localize)(11553,null,W.additionalInfo):(0,I.localize)(11554,null),offset:W.offset,length:W.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(Q,F){const N=Q?Q.substituteConstants():void 0,W=F?F.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}function a(Q,F){return Q.cmp(F)}class l{static{this.INSTANCE=new l}constructor(){this.type=d.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}e.$Ej=l;class S{static{this.INSTANCE=new S}constructor(){this.type=d.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.$Fj=S;class y{static create(F,N=null){const W=c.get(F);return typeof W=="boolean"?W?S.INSTANCE:l.INSTANCE:new y(F,N)}constructor(F,N){this.key=F,this.c=N,this.type=d.Defined}cmp(F){return F.type!==this.type?this.type-F.type:Y(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=c.get(this.key);return typeof F=="boolean"?F?S.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Gj=y;class D{static create(F,N,W=null){if(typeof N=="boolean")return N?y.create(F,W):M.create(F,W);const z=c.get(F);return typeof z=="boolean"?N===(z?"true":"false")?S.INSTANCE:l.INSTANCE:new D(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.Equals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?S.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Hj=D;class L{static create(F,N){return new L(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.f),W=F.getValue(this.d);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?h.call(N,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$Ij=L;class R{static create(F,N){return new R(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.NotIn,this.c=L.create(F,N)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Jj=R;class O{static create(F,N,W=null){if(typeof N=="boolean")return N?M.create(F,W):y.create(F,W);const z=c.get(F);return typeof z=="boolean"?N===(z?"true":"false")?l.INSTANCE:S.INSTANCE:new O(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?l.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Kj=O;class M{static create(F,N=null){const W=c.get(F);return typeof W=="boolean"?W?l.INSTANCE:S.INSTANCE:new M(F,N)}constructor(F,N){this.c=F,this.d=N,this.type=d.Not}cmp(F){return F.type!==this.type?this.type-F.type:Y(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=c.get(this.c);return typeof F=="boolean"?F?l.INSTANCE:S.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Lj=M;function x(Q,F){if(typeof Q=="string"){const N=parseFloat(Q);isNaN(N)||(Q=N)}return typeof Q=="string"||typeof Q=="number"?F(Q):l.INSTANCE}class X{static create(F,N,W=null){return x(N,z=>new X(F,z,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.Greater}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Mj=X;class K{static create(F,N,W=null){return x(N,z=>new K(F,z,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=fe.create(this.c,this.d,this)),this.f}}e.$Nj=K;class fe{static create(F,N,W=null){return x(N,z=>new fe(F,z,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Oj=fe;class H{static create(F,N,W=null){return x(N,z=>new H(F,z,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=d.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Pj=H;class J{static create(F,N){return new J(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return N<W?-1:N>W?1:0}equals(F){if(F.type===this.type){const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return this.d===F.d&&N===W}return!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Qj=J;class U{static create(F){return new U(F)}constructor(F){this.c=F,this.type=d.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new U(this.c.map(F))}negate(){return this.c}}e.$Rj=U;function Z(Q){let F=null;for(let N=0,W=Q.length;N<W;N++){const z=Q[N].substituteConstants();if(Q[N]!==z&&F===null){F=[];for(let te=0;te<N;te++)F[te]=Q[te]}F!==null&&(F[N]=z)}return F===null?Q:F}class B{static create(F,N,W){return B.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=d.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const z=a(this.expr[N],F.expr[N]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=Z(this.expr);return F===this.expr?this:B.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(F))return!1;return!0}static d(F,N,W){const z=[];let te=!1;for(const ee of F)if(ee){if(ee.type===d.True){te=!0;continue}if(ee.type===d.False)return l.INSTANCE;if(ee.type===d.And){z.push(...ee.expr);continue}z.push(ee)}if(z.length===0&&te)return S.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let ee=1;ee<z.length;ee++)z[ee-1].equals(z[ee])&&(z.splice(ee,1),ee--);if(z.length===1)return z[0];for(;z.length>1;){const ee=z[z.length-1];if(ee.type!==d.Or)break;z.pop();const q=z.pop(),ne=z.length===0,de=j.create(ee.expr.map(me=>B.create([me,q],null,W)),null,ne);de&&(z.push(de),z.sort(a))}if(z.length===1)return z[0];if(W){for(let ee=0;ee<z.length;ee++)for(let q=ee+1;q<z.length;q++)if(z[ee].negate().equals(z[q]))return l.INSTANCE;if(z.length===1)return z[0]}return new B(z,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new B(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Sj=B;class j{static create(F,N,W){return j.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=d.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const z=a(this.expr[N],F.expr[N]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=Z(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(F))return!0;return!1}static d(F,N,W){let z=[],te=!1;if(F){for(let ee=0,q=F.length;ee<q;ee++){const ne=F[ee];if(ne){if(ne.type===d.False){te=!0;continue}if(ne.type===d.True)return S.INSTANCE;if(ne.type===d.Or){z=z.concat(ne.expr);continue}z.push(ne)}}if(z.length===0&&te)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let ee=1;ee<z.length;ee++)z[ee-1].equals(z[ee])&&(z.splice(ee,1),ee--);if(z.length===1)return z[0];if(W){for(let ee=0;ee<z.length;ee++)for(let q=ee+1;q<z.length;q++)if(z[ee].negate().equals(z[q]))return S.INSTANCE;if(z.length===1)return z[0]}return new j(z,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new j(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());for(;F.length>1;){const N=F.shift(),W=F.shift(),z=[];for(const te of re(N))for(const ee of re(W))z.push(B.create([te,ee],null,!1));F.unshift(j.create(z,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Tj=j;class C extends y{static{this.d=[]}static all(){return C.d.values()}constructor(F,N,W){super(F,null),this.f=N,typeof W=="object"?C.d.push({...W,key:F}):W!==!0&&C.d.push({key:F,description:W,type:N!=null?typeof N:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return D.create(this.key,F)}notEqualsTo(F){return O.create(this.key,F)}}e.$Uj=C,e.$Vj=(0,T.$Di)("contextKeyService");function Y(Q,F){return Q<F?-1:Q>F?1:0}function oe(Q,F,N,W){return Q<N?-1:Q>N?1:F<W?-1:F>W?1:0}function G(Q,F){if(Q.type===d.False||F.type===d.True)return!0;if(Q.type===d.Or)return F.type===d.Or?ue(Q.expr,F.expr):!1;if(F.type===d.Or){for(const N of F.expr)if(G(Q,N))return!0;return!1}if(Q.type===d.And){if(F.type===d.And)return ue(F.expr,Q.expr);for(const N of Q.expr)if(G(N,F))return!0;return!1}return Q.equals(F)}function ue(Q,F){let N=0,W=0;for(;N<Q.length&&W<F.length;){const z=Q[N].cmp(F[W]);if(z<0)return!1;z===0&&N++,W++}return N===Q.length}function re(Q){return Q.type===d.Or?Q.expr:[Q]}}),define(ce[96],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Rm=e.ID=void 0,e.$Sm=r,e.ID="diagnosticsService",e.$Rm=(0,n.$Di)(e.ID);function r(A){return!!A.hostName&&!!A.errorMessage}class P{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Tm=P});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[123],le([0,1,18,81,10,6,47,3,37]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$0w=e.$9w=e.$8w=void 0,e.$$w=w,e.$_w=f,r=Ve(r),e.$8w=(0,A.$Di)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class m{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,b){const $=[];switch(b){case c.Confirmation:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11521,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11522,null));break}case c.Prompt:{const k=v;Array.isArray(k.buttons)&&k.buttons.length>0&&$.push(...k.buttons.map(E=>E.label)),k.cancelButton&&(k.cancelButton===!0?$.push((0,P.localize)(11523,null)):typeof k.cancelButton=="string"?$.push(k.cancelButton):k.cancelButton.label?$.push(k.cancelButton.label):$.push((0,P.localize)(11524,null))),$.length===0&&$.push((0,P.localize)(11525,null));break}case c.Input:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11526,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11527,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const k=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&k.push(v.cancelButton);let E=k[b]?.run({checkboxChecked:$});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:$}}}e.$9w=m,e.$0w=(0,A.$Di)("fileDialogService");var h;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(h||(e.ConfirmResult=h={}));const d=10;function w(g){const v=[];return v.push(...g.slice(0,d).map(b=>typeof b=="string"?b:(0,n.$bh)(b))),g.length>d&&(g.length-d===1?v.push((0,P.localize)(11528,null)):v.push((0,P.localize)(11529,null,g.length-d))),v.push(""),v.join(`
`)}function f(g,v){const b=(0,p.$co)(g);let $=(b.buttons??[]).map(u=>(0,T.$5w)(u)),k=(g.buttons||[]).map((u,i)=>i),E=0,t=b.cancelId??$.length-1;if($.length>1){const u=typeof t=="number"?$[t]:void 0;if(I.$l||I.$k){if(typeof u=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,u);const i=k[t];k.splice(t,1),k.splice(1,0,i),t=1}I.$l&&$.length>1&&($=$.reverse(),k=k.reverse(),E=$.length-1,typeof u=="string"&&(t=E-1))}else if(I.$j&&typeof u=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(u);const i=k[t];k.splice(t,1),k.push(i),t=$.length-1}}return b.buttons=$,b.defaultId=E,b.cancelId=t,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:k}}}),define(ce[97],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$zY=e.$yY=void 0,e.$AY=A,e.$BY=T,e.$yY=(0,n.$Di)("encryptionService"),e.$zY=(0,n.$Di)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var P;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function A(I){return I===P.kwallet||I===P.kwallet5||I===P.kwallet6}function T(I){return I===P.gnomeAny||I===P.gnomeLibsecret||I===P.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=void 0,e.$Ki=(0,n.$Di)("environmentService"),e.$Li=(0,n.$Ei)(e.$Ki)}),define(ce[175],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0,e.$egc=(0,n.$Di)("extensionHostStarter"),e.$fgc="extensionHostStarter"}),define(ce[176],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=e.$t0b=void 0,e.$t0b=(0,n.$Di)("externalTerminal"),e.$u0b="Terminal.app"}),define(ce[177],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0,e.$hgc=(0,n.$Di)("externalTerminal")}),define(ce[178],le([0,1,48,54,11,9,3,79,23,94,10,176]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=e.$igc=void 0,n=Pe(n),A=Pe(A),T=Pe(T),p=Pe(p),c=Pe(c),m=Pe(m);const d=m.localize(11371,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(t,u){return this.spawnTerminal(n,t,c.$wm(),u)}spawnTerminal(t,u,i,o){const s=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=A.$mc(s,".exe").toLowerCase();if(a==="cmder")return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push(s),l.push(s),a==="wt"&&l.push("-d ."),new Promise((S,y)=>{const D=b(process),L=t.spawn(i,l,{cwd:o,env:D,detached:!0});L.on("error",y),L.on("exit",()=>S())})}async runInTerminal(t,u,i,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((S,y)=>{const D=`"${u} - ${d}"`,L=`"${i.join('" "')}" & pause`,R=Object.assign({},b(process),o);Object.keys(R).filter(K=>R[K]===null).forEach(K=>delete R[K]);const O={cwd:u,env:R,windowsVerbatimArguments:!0};let M,x;A.$mc(a,".exe")==="wt"?(M=a,x=["-d",".",f.b,"/c",L]):l?(M=l,x=["-d",".",a,"/c",L]):(M=f.b,x=["/c","start",D,"/wait",a,"/c",`"${L}"`]),n.spawn(M,x,O).on("error",K=>{y($(K))}),S(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$igc=f,Se([r.$8h],f,"f",null);class g extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.osxExec||h.$u0b;return new Promise((l,S)=>{if(a===h.$u0b||a==="iTerm.app"){const y=a===h.$u0b?"TerminalHelper":"iTermHelper",L=[P.$Xg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||d,"-w",u];for(const M of i)L.push("-a"),L.push(M);if(o){const M=Object.assign({},b(process),o);for(const x in M){const X=M[x];X===null?(L.push("-u"),L.push(x)):(L.push("-e"),L.push(`${x}=${X}`))}}let R="";const O=n.spawn(g.b,L);O.on("error",M=>{S($(M))}),O.stderr.on("data",M=>{R+=M.toString()}),O.on("exit",M=>{if(M===0)l(void 0);else if(R){const x=R.split(`
`,1);S(new Error(x[0]))}else S(new Error(m.localize(11372,null,y,M)))})}else S(new Error(m.localize(11373,null,a)))})}spawnTerminal(t,u,i){const o=u.osxExec||h.$u0b;return new Promise((s,a)=>{const l=["-a",o];i&&l.push(i);const S=b(process),y=t.spawn("/usr/bin/open",l,{cwd:i,env:S});y.on("error",a),y.on("exit",()=>s())})}}e.$jgc=g;class v extends w{static{this.b=m.localize(11374,null)}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,S)=>{const y=[];a.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${k(i)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const R=Object.assign({},b(process),o);Object.keys(R).filter(X=>R[X]===null).forEach(X=>delete R[X]);const O={cwd:u,env:R};let M="";const x=n.spawn(D,y,O);x.on("error",X=>{S($(X))}),x.stderr.on("data",X=>{M+=X.toString()}),x.on("exit",X=>{if(X===0)l(void 0);else if(M){const K=M.split(`
`,1);S(new Error(K[0]))}else S(new Error(m.localize(11375,null,D,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");v.d=new Promise(u=>{t?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v.d}spawnTerminal(t,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const S=b(process),y=t.spawn(l,[],{cwd:i,env:S});y.on("error",a),y.on("exit",()=>s())})})}}e.$kgc=v;function b(E){const t={...E.env};return(0,I.$jm)(t),t}function $(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(m.localize(11376,null,E.path)):E}function k(E){let t="";for(const u of E)u.indexOf(" ")>=0?t+='"'+u+'"':t+=u,t+=" ";return t}}),define(ce[14],le([0,1,60,9,25,12,7,10,6,3,11,65]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=d,e.$al=v,e.$bl=$,e.$cl=k,e.$dl=E,e.$el=t,e.$fl=u,e.$gl=i,e.$hl=o,e.$il=s,e.$jl=a,e.$ll=y,e.$ml=D,e.$nl=L,e.$ol=R,e.$pl=O,e.$sl=fe,e.$El=j,e.$Fl=C,e.$Hl=oe,e.$$k=(0,p.$Di)("fileService");function d(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var g;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function v(G){const ue=G;return!!ue&&typeof ue.onDidChange=="function"}var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(G){return!!(G.capabilities&b.FileReadWrite)}function k(G){return!!(G.capabilities&b.FileFolderCopy)}function E(G){return!!(G.capabilities&b.FileClone)}function t(G){return!!(G.capabilities&b.FileOpenReadWriteClose)}function u(G){return!!(G.capabilities&b.FileReadStream)}function i(G){return $(G)?!!(G.capabilities&b.FileAtomicRead):!1}function o(G){return $(G)?!!(G.capabilities&b.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&b.FileAtomicDelete)}function a(G){return!!(G.capabilities&b.Readonly)}var l;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(ue,re){const Q=new S(ue.toString(),re);return L(Q,re),Q}constructor(ue,re){super(ue),this.code=re}}e.$kl=S;function y(G,ue){return S.create(G,ue)}function D(G){return G||y((0,I.localize)(11330,null),l.Unknown)}function L(G,ue){return G.name=ue?`${ue} (FileSystemError)`:"FileSystemError",G}function R(G){if(!G)return l.Unknown;if(G instanceof S)return G.code;const ue=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!ue)return l.Unknown;switch(ue[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(G){if(G instanceof H)return G.fileOperationResult;switch(R(G)){case l.FileNotFound:return Z.FILE_NOT_FOUND;case l.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case l.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case l.NoPermissions:return Z.FILE_PERMISSION_DENIED;case l.FileExists:return Z.FILE_MOVE_CONFLICT;case l.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var M;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class x{constructor(ue,re,Q){this.resource=ue,this.operation=re,this.target=Q}isOperation(ue){return this.operation===ue}}e.$ql=x;var X;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class K{static{this.a=null}constructor(ue,re){this.c=re,this.b=void 0,this.d=new h.$T(()=>{const Q=n.$Ji.forUris(()=>this.c);return Q.fill(this.rawAdded.map(F=>[F,!0])),Q}),this.f=new h.$T(()=>{const Q=n.$Ji.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(F=>[F,!0])),Q}),this.g=new h.$T(()=>{const Q=n.$Ji.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(F=>[F,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of ue){switch(Q.type){case X.ADDED:this.rawAdded.push(Q.resource);break;case X.UPDATED:this.rawUpdated.push(Q.resource);break;case X.DELETED:this.rawDeleted.push(Q.resource);break}this.b!==K.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(ue,...re){return this.h(ue,{includeChildren:!1},...re)}affects(ue,...re){return this.h(ue,{includeChildren:!0},...re)}h(ue,re,...Q){if(!ue)return!1;const F=Q.length>0;return!!((!F||Q.includes(X.ADDED))&&(this.d.value.get(ue)||re.includeChildren&&this.d.value.findSuperstr(ue))||(!F||Q.includes(X.UPDATED))&&(this.f.value.get(ue)||re.includeChildren&&this.f.value.findSuperstr(ue))||(!F||Q.includes(X.DELETED))&&(this.g.value.findSubstr(ue)||re.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$rl=K;function fe(G,ue,re){return!G||!ue||G===ue||ue.length>G.length?!1:(ue.charAt(ue.length-1)!==r.sep&&(ue+=r.sep),re?(0,P.$Ff)(G,ue):G.indexOf(ue)===0)}class H extends Error{constructor(ue,re,Q){super(ue),this.fileOperationResult=re,this.options=Q}}e.$tl=H;class J extends H{constructor(ue,re,Q,F){super(ue,re,F),this.fileOperationResult=re,this.size=Q}}e.$ul=J;class U extends H{constructor(ue,re,Q){super(ue,Z.FILE_NOT_MODIFIED_SINCE,Q),this.stat=re}}e.$vl=U;var Z;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var B;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Dl="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function C(G,ue){if(!ue.hasProvider(T.URI.from({scheme:G.scheme})))return new Promise(re=>{const Q=ue.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===G.scheme&&F.added&&(Q.dispose(),re())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(ue){return(0,A.$hg)(ue)||(ue=0),ue<Y.KB?(0,I.localize)(11331,null,ue.toFixed(0)):ue<Y.MB?(0,I.localize)(11332,null,(ue/Y.KB).toFixed(2)):ue<Y.GB?(0,I.localize)(11333,null,(ue/Y.MB).toFixed(2)):ue<Y.TB?(0,I.localize)(11334,null,(ue/Y.GB).toFixed(2)):(0,I.localize)(11335,null,(ue/Y.TB).toFixed(2))}}e.$Gl=Y;function oe(G){const ue=typeof G=="string"||G?.scheme===m.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===m.Schemas.file?1024*Y.MB:ue?10*Y.MB:c.$p?50*Y.MB:1024*Y.MB}}),define(ce[124],le([0,1,17,15,10,14]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=T;async function T(m,h,d,w,f,g){let v;try{await I(m,h,d,w,f,g)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}async function I(m,h,d,w,f,g){p(g);const v=await m.open(h,{create:!1});try{p(g);let b=0,$=0,k=f&&typeof f.length=="number"?f.length:void 0,E=n.$Me.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,u=0;do $=await m.read(v,t,E.buffer,u,E.byteLength-u),t+=$,u+=$,b+=$,typeof k=="number"&&(k-=$),u===E.byteLength&&(await d.write(w(E)),E=n.$Me.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),u=0);while($>0&&(typeof k!="number"||k>0)&&p(g)&&c(b,f));if(u>0){let i=u;typeof k=="number"&&(i=Math.min(u,k)),d.write(w(E.slice(0,i)))}}catch(b){throw(0,A.$ml)(b)}finally{await m.close(v)}}function p(m){if(m.isCancellationRequested)throw(0,r.$5)();return!0}function c(m,h){if(typeof h?.limits?.size=="number"&&m>h.limits.size)throw(0,A.$ll)((0,P.localize)(11329,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[61],le([0,1,111,2,9,3,7,14]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=p,e.$3q=c,e.$7q=w,e.$8q=f,e.$9q=g,e.$0q=v,e.$$q=$,e.$_q=k;function p(E){return typeof E.correlationId=="number"}function c(E){return E.recursive===!0}class m extends r.$Tc{static{this.a=5}constructor(t,u,i,o){super(),this.h=t,this.j=u,this.m=i,this.n=o,this.c=this.B(new r.$Uc),this.f=void 0,this.g=0}s(){const t=new r.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(u=>this.h(u))),t.add(this.b.onDidLogMessage(u=>this.j(u))),t.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(t,u){this.u(t,u)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,u){return!(!this.n.restartOnError||u||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=m;class h extends m{constructor(t,u,i){super(t,u,i,{type:"node.js",restartOnError:!1})}}e.$5q=h;class d extends m{constructor(t,u,i){super(t,u,i,{type:"universal",restartOnError:!0})}}e.$6q=d;function w(E){return E.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function f(E){const t=new b;for(const u of E)t.processEvent(u);return t.coalesce()}function g(E,t){return typeof t=="string"&&!t.startsWith(n.$uk)&&!(0,P.$hc)(t)?{base:E,pattern:t}:t}function v(E,t){const u=[];for(const i of t)u.push((0,n.$yk)(g(E,i)));return u}class b{constructor(){this.a=new Set,this.b=new Map}c(t){return A.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const u=this.b.get(this.c(t));let i=!1;if(u){const o=u.type,s=t.type;u.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(u)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?u.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(u.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],u=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,o)=>i.resource.fsPath.length-o.resource.fsPath.length).filter(i=>u.some(o=>(0,I.$sl)(i.resource.fsPath,o,!A.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(t)}}function $(E,t){if(typeof t=="number")switch(E.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function k(E){if(typeof E=="number"){const t=[];return E&I.FileChangeFilter.ADDED&&t.push("Added"),E&I.FileChangeFilter.DELETED&&t.push("Deleted"),E&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ce[179],le([0,1,17,55,15,4,2,67,33,14,61]),function(V,e,n,r,P,A,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=e.$mR=void 0,e.$mR="localFilesystem";class h extends T.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$ke),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$ke),this.onDidWatchError=this.g.event,this.h=(0,p.$Zg)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:g}=await this.a.call("readFile",[w,f]);return g}readFileStream(w,f,g){const v=(0,I.$Ae)($=>n.$Me.concat($.map(k=>n.$Me.wrap(k))).buffer),b=new T.$Sc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Me)v.write($.buffer);else{if($==="end")v.end();else{let k;if($ instanceof Error)k=$;else{const E=$;k=(0,c.$ll)(E.message??(0,r.$oj)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}v.error(k),v.end()}b.dispose()}})),b.add(g.onCancellationRequested(()=>{v.error((0,P.$5)()),v.end(),b.dispose()})),v}writeFile(w,f,g){return this.a.call("writeFile",[w,n.$Me.wrap(f),g])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,g,v,b){const[$,k]=await this.a.call("read",[w,f,b]);return g.set($.buffer.slice(0,k),v),k}write(w,f,g,v,b){return this.a.call("write",[w,f,n.$Me.wrap(g),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,g){return this.a.call("rename",[w,f,g])}copy(w,f,g){return this.a.call("copy",[w,f,g])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,m.$7q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const g=(0,p.$Zg)();return this.a.call("watch",[this.h,g,w,f]),(0,T.$Rc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$nR=h}),define(ce[180],le([0,1,26,2,61,4,14,7,8]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class c extends r.$Tc{constructor(){super(),this.a=this.B(new A.$ke),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$ke),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$ke),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$3c),this.m=new Set,this.n=this.B(new p.$Bh(this.y())),this.r=5007,this.s=new p.$1h,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,P.$2q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new p.$1h;try{this.h.clear(),this.g.clear();for(const d of h)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const d=new r.$Sc;this.j.set(h.correlationId,d),await this.s.p,!d.isDisposed&&(this.D(h,d),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,d){this.F(h,d)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,d),this.m.add(h.correlationId))}F(h,d){const w=this.O?.subscribe(h.path,(f,g)=>{d.isDisposed||(f?this.D(h,d):g?.type===T.FileChangeType.ADDED&&this.H(h))});return w?(d.add(w),!0):!1}G(h,d){let w=!1;const f=(g,v)=>{if(d.isDisposed)return;const b=this.I(g),$=this.I(v),k=w;w=b,!b&&($||k)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.watchFile)(h.path,{persistent:!1,interval:this.r},f)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}d.add((0,r.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.unwatchFile)(h.path,f)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const d={resource:I.URI.file(h.path),type:T.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([d]),this.J(d,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,d){if(this.R){const w=` >> normalized ${h.type===T.FileChangeType.ADDED?"[ADDED]":h.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(w,d)}}L(h,d){this.R&&this.P(`${h}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,P.$_q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$ir=c}),define(ce[181],le([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=b;class v extends T.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(k,E,t,u,i,o){super(),this.s=k,this.t=E,this.u=t,this.w=u,this.y=i,this.z=o,this.c=this.B(new r.$Sh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Rh(s=>this.M(s),v.b)),this.g=(0,g.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,g.$2q)(this.s)?this.s.filter:void 0,this.m=new P.$ve,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const k=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const E=await n.promises.stat(k);if(this.m.token.isCancellationRequested)return;this.B(await this.G(k,E.isDirectory()))}catch(k){k.code!=="ENOENT"?this.O(k):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${k})`),this.D()}}D(){this.r=!0,this.w?.()}async F(k){let E=k.path;try{E=await w.Promises.realpath(k.path),k.path===E&&(E=await(0,d.$kr)(k.path,this.m.token)??k.path),k.path!==E&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${k.path}, real: ${E})`)}catch{}return E}async G(k,E){const t=new T.$Sc;return this.H(k,E,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(k,E,t)),t}H(k,E,t){if(E)return!1;const u=h.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,s)=>{if(!t.isDisposed)if(o){const a=await this.G(k,E);t.isDisposed?a.dispose():t.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(k,E,t){if(c.$k&&(0,A.$Cg)(k,"/Volumes/",!0)){this.O(`Refusing to watch ${k} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new P.$ve(this.m.token);t.add((0,T.$Rc)(()=>u.dispose(!0)));const i=new T.$Sc;t.add(i);try{const o=h.URI.file(this.s.path),s=(0,p.$mc)(k),a=(0,n.watch)(k);i.add((0,T.$Rc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${k}'`);const l=new Set;if(E)try{for(const y of await w.Promises.readdir(k))l.add(y)}catch(y){this.O(y)}if(u.token.isCancellationRequested)return;const S=new Map;i.add((0,T.$Rc)(()=>{for(const[,y]of S)y.dispose();S.clear()})),a.on("error",(y,D)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${k} for changes using fs.watch() (${y}, ${D})`),this.D())}),a.on("change",(y,D)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${D}`);let L="";if(D&&(L=D.toString(),c.$k&&(L=(0,I.$lm)(L))),!(!L||y!=="change"&&y!=="rename"))if(E)if(y==="rename"){S.get(L)?.dispose();const R=setTimeout(async()=>{if(S.delete(L),L===s&&!await w.Promises.exists(k)){this.J(o);return}if(u.token.isCancellationRequested)return;const O=await this.N((0,p.$ic)(k,L));if(u.token.isCancellationRequested)return;let M;O?l.has(L)?M=f.FileChangeType.UPDATED:(M=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),M=f.FileChangeType.DELETED),this.L({resource:(0,m.$eh)(o,L),type:M,cId:this.s.correlationId})},v.a);S.set(L,(0,T.$Rc)(()=>clearTimeout(R)))}else{let R;l.has(L)?R=f.FileChangeType.UPDATED:(R=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,m.$eh)(o,L),type:R,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const R=setTimeout(async()=>{const O=await w.Promises.exists(k);u.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(k,!1))):this.J(o))},v.a);i.clear(),i.add((0,T.$Rc)(()=>clearTimeout(R)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){u.token.isCancellationRequested||this.O(`Failed to watch ${k} for changes using fs.watch() (${o.toString()})`),this.D()}}J(k){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:k,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(k,E=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${k.type===f.FileChangeType.ADDED?"[ADDED]":k.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`),!E&&this.g.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${k.resource.fsPath}`):!E&&this.h&&this.h.length>0&&!this.h.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${k.resource.fsPath}`):this.f.work(k))}M(k){const E=(0,g.$8q)(k),t=[];for(const i of E){if((0,g.$$q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===f.FileChangeType.ADDED?"[ADDED]":i.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(k){if(c.$l)return w.Promises.exists(k);try{const E=(0,p.$mc)(k);return(await w.Promises.readdir((0,p.$lc)(k))).some(u=>u===E)}catch(E){return this.Q(E),!1}}setVerboseLogging(k){this.z=k}O(k){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${k}`})}P(k){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${k}`})}Q(k){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${k}`})}R(k){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${k}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=v;async function b($,k,E,t,u=512){const i=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(u),s=new P.$ve(t);let a,l=!1;const S={path:$,excludes:[],recursive:!1},y=new v(S,void 0,D=>{(async()=>{for(const{type:L}of D)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:R}=await w.Promises.read(i,o,0,u,null);if(!R||s.token.isCancellationRequested)break;k(o.slice(0,R))}}catch(R){a=new Error(R),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,E(),new Promise((D,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(i)}catch(R){a=new Error(R)}a?L(a):D()})})}}),define(ce[182],le([0,1,4,111,180,3,181,32]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class p extends P.$ir{constructor(m){super(),this.O=m,this.onDidError=n.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const h=[],d=new Set(Array.from(this.watchers));for(const w of m){const f=this.W(w);f&&(0,r.$Ck)(f.request.excludes,w.excludes)&&(0,r.$Ck)(f.request.includes,w.includes)?d.delete(f):h.push(w)}h.length&&this.P(`Request to start watching: ${h.map(w=>this.M(w)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(w=>this.M(w.request)).join(",")}`);for(const w of d)this.Y(w);for(const w of h)this.X(w)}W(m){for(const h of this.watchers)if(typeof m.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===m.correlationId)return h}else if((0,I.$Bg)(h.request.path,m.path,!A.$l))return h}X(m){const h=new T.$nr(m,this.O,w=>this.a.fire(w),()=>this.c.fire(m),w=>this.b.fire(w),this.R),d={request:m,instance:h};this.watchers.add(d)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const h=new Map;for(const d of m){const w=A.$l?d.path:d.path.toLowerCase();let f=h.get(d.correlationId);f||(f=new Map,h.set(d.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),f.set(w,d)}return Array.from(h.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const h of this.watchers)h.instance.setVerboseLogging(m)}P(m,h){this.R&&this.b.fire({type:"trace",message:this.bb(m,h)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,h){return h?`[File Watcher (node.js)] ${m} (${this.M(h.request)})`:`[File Watcher (node.js)] ${m}`}}e.$pr=p}),define(ce[183],le([0,1,61,182]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class P extends n.$5q{constructor(T,I,p){super(T,I,p),this.s()}r(T){return T.add(new r.$pr(void 0))}}e.$qr=P}),define(ce[184],le([0,1,11,44,160,61]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class T extends A.$6q{constructor(p,c,m){super(p,c,m),this.s()}r(p){const c=p.add(new P.$gr(n.$Xg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:m,signal:h})=>this.t(`terminated by itself with code ${m}, signal: ${h} (ETERM)`))),r.ProxyChannel.toService((0,r.$ki)(c.getChannel("watcher")))}}e.$hr=T}),define(ce[98],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class n{constructor(...P){this.a=new Map;for(const[A,T]of P)this.set(A,T)}set(P,A){const T=this.a.get(P);return this.a.set(P,A),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Bi=n}),define(ce[185],le([0,1,8,15,2,83,174,6,98,108]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const m=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new p.$Bi,b=!1,$,k=m){this.i=v,this.j=b,this.k=$,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ci,this),this._globalGraph=k?$?._globalGraph??new T.$tr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Oc)(this.h),this.h.clear();for(const v of this.g)(0,P.$Nc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,k=new class extends d{dispose(){$.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),b?.add(k),k}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let k=!1;try{return v({get:t=>{if(k)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(t,$);if(!u)throw new Error(`[invokeFunction] unknown service '${t}'`);return u}},...b)}finally{k=!0,$.stop()}}createInstance(v,...b){this.m();let $,k;return v instanceof A.$Ai?($=f.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),k=this.o(v,b,$)),$.stop(),k}o(v,b=[],$){const k=I._util.getServiceDependencies(v).sort((u,i)=>u.index-i.index),E=[];for(const u of k){const i=this.s(u.id,$);i||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${u.id}.`,!1),E.push(i)}const t=k.length>0?k[0].index:b.length;if(b.length!==t){console.trace(`[createInstance] First service dependency of ${v.name} at position ${t+1} conflicts with ${b.length} static arguments`);const u=t-b.length;u>0?b=b.concat(new Array(u)):b=b.slice(0,t)}return Reflect.construct(v,b.concat(E))}q(v,b){if(this.i.get(v)instanceof A.$Ai)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof A.$Ai?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const k=new T.$tr(i=>i.id.toString());let E=0;const t=[{id:v,desc:b,_trace:$}],u=new Set;for(;t.length;){const i=t.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),k.lookupOrInsertNode(i),E++>1e3)throw new h(k);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof A.$Ai){const a={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};k.insertEdge(i,a),t.push(a)}}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new h(k);break}for(const{data:o}of i){if(this.r(o.id)instanceof A.$Ai){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}k.removeNode(o)}}return this.r(v)}w(v,b,$=[],k,E){if(this.i.get(v)instanceof A.$Ai)return this.x(v,b,$,k,E,this.g);if(this.k)return this.k.w(v,b,$,k,E);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],k,E,t){if(k){const u=new d(void 0,this.j,this,this.l);u.c=String(v);const i=new Map,o=new n.$Wh(()=>{const s=u.o(b,$,E);for(const[a,l]of i){const S=s[a];if(typeof S=="function")for(const y of l)y.disposable=S.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=i.get(a);return y||(y=new c.$4c,i.set(a,y)),(L,R,O)=>{if(o.isInitialized)return o.value[a](L,R,O);{const M={listener:[L,R,O],disposable:void 0},x=y.push(M);return(0,P.$Rc)(()=>{x(),M.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let S=l[a];return typeof S!="function"||(S=S.bind(l),s[a]=S),S},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const u=this.o(b,$,E);return t.add(u),u}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$ur=d;var w;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(E,t){const u=[],i=new Array(E+1).join("	");for(const[o,s,a]of t.h)if(s&&a){b=!0,u.push(`${i}CREATES -> ${o}`);const l=$(E+1,a);l&&u.push(l)}else u.push(`${i}uses -> ${o}`);return u.join(`
`)}const k=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(k.join(`
`))}}e.$vr=f}),define(ce[186],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=e.IssueSource=e.IssueType=void 0;var r;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var P;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$Z_b=(0,n.$Di)("issueService"),e.$1_b=(0,n.$Di)("processService")}),define(ce[5],le([0,1,10,55,4,46,2,31,3,18,12,7,122,6]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=g,e.log=b,e.$mk=S,e.$nk=y,e.$ok=D,e.$pk=L,n=Pe(n),e.$$j=(0,w.$Di)("logService"),e.$_j=(0,w.$Di)("loggerService");function f(){return new Date().toISOString()}function g(R){return(0,m.$hg)(R)}var v;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$bk=v.Info;function b(R,O,M){switch(O){case v.Trace:R.trace(M);break;case v.Debug:R.debug(M);break;case v.Info:R.info(M);break;case v.Warning:R.warn(M);break;case v.Error:R.error(M);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(R,O=!1){let M="";for(let x=0;x<R.length;x++){let X=R[x];if(X instanceof Error&&(X=(0,r.$oj)(X,O)),typeof X=="object")try{X=JSON.stringify(X)}catch{}M+=(x>0?" ":"")+X}return M}class k extends T.$Tc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new P.$ke),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$dk=k;class E extends k{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...M){this.f(v.Trace)&&this.g(v.Trace,$([O,...M],!0))}debug(O,...M){this.f(v.Debug)&&this.g(v.Debug,$([O,...M]))}info(O,...M){this.f(v.Info)&&this.g(v.Info,$([O,...M]))}warn(O,...M){this.f(v.Warning)&&this.g(v.Warning,$([O,...M]))}error(O,...M){if(this.f(v.Error))if(O instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=O.stack,this.g(v.Error,$(x))}else this.g(v.Error,$([O,...M]))}flush(){}}e.$ek=E;class t extends k{constructor(O=e.$bk){super(),this.setLevel(O),this.g=!p.$j}trace(O,...M){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...M):console.warn(`[main ${f()}]`,O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...M):console.error(`[main ${f()}]`,O,...M))}flush(){}}e.$fk=t;class u extends k{constructor(O=e.$bk,M=!0){super(),this.g=M,this.setLevel(O)}trace(O,...M){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...M):console.log(O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...M):console.log(O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...M):console.log(O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...M):console.log(O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...M):console.error(O,...M))}flush(){}}e.$gk=u;class i extends k{constructor(O,M=e.$bk){super(),this.g=O,this.setLevel(M)}trace(O,...M){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...M])}debug(O,...M){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...M])}info(O,...M){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...M])}warn(O,...M){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...M])}error(O,...M){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...M])}h(O){return typeof O=="string"?O:(0,r.$oj)(O,this.f(v.Trace))}flush(){}}e.$hk=i;class o extends k{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const M of this.g)M.setLevel(O);super.setLevel(O)}trace(O,...M){for(const x of this.g)x.trace(O,...M)}debug(O,...M){for(const x of this.g)x.debug(O,...M)}info(O,...M){for(const x of this.g)x.info(O,...M)}warn(O,...M){for(const x of this.g)x.warn(O,...M)}error(O,...M){for(const x of this.g)x.error(O,...M)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$ik=o;class s extends T.$Tc{constructor(O,M,x){if(super(),this.h=O,this.j=M,this.b=new I.$zc,this.c=this.B(new P.$ke),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$ke),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$ke),this.onDidChangeVisibility=this.g.event,x)for(const X of x)this.b.set(X.resource,{logger:void 0,info:X})}m(O){return(0,m.$dg)(O)?[...this.b.values()].find(M=>M.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,M){const x=this.n(O),X=(0,m.$dg)(O)?O:M?.id??(0,A.$rj)(x.toString()).toString(16);let K=this.b.get(x)?.logger;const fe=M?.logLevel==="always"?v.Trace:M?.logLevel;K||(K=this.s(x,fe??this.getLogLevel(x)??this.h,{...M,id:X}));const H={logger:K,info:{resource:x,id:X,logLevel:fe,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(H.info),this.b.set(x,H),K}n(O){return(0,m.$dg)(O)?(0,c.$eh)(this.j,`${O}.log`):O}setLogLevel(O,M){if(h.URI.isUri(O)){const x=O,X=M,K=this.b.get(x);K&&X!==K.info.logLevel&&(K.info.logLevel=X===this.h?void 0:X,K.logger?.setLevel(X),this.b.set(K.info.resource,K),this.f.fire([x,X]))}else{this.h=O;for(const[x,X]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,M){const x=this.m(O);x&&M!==!x.info.hidden&&(x.info.hidden=!M,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,M]))}getLogLevel(O){let M;return O&&(M=this.b.get(O)?.info.logLevel),M??this.h}registerLogger(O){const M=this.b.get(O.resource);M?M.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const M=this.b.get(O);M&&(M.logger&&M.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=s;class a{constructor(){this.onDidChangeLogLevel=new P.$ke().event}setLevel(O){}getLevel(){return v.Info}trace(O,...M){}debug(O,...M){}info(O,...M){}warn(O,...M){}error(O,...M){}critical(O,...M){}dispose(){}flush(){}}e.$kk=a;class l extends a{}e.$lk=l;function S(R){if(R.verbose)return v.Trace;if(typeof R.logLevel=="string"){const O=L(R.logLevel.toLowerCase());if(O!==void 0)return O}return e.$bk}function y(R){switch(R){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function D(R){switch(R){case v.Trace:return{original:"Trace",value:n.localize(11263,null)};case v.Debug:return{original:"Debug",value:n.localize(11264,null)};case v.Info:return{original:"Info",value:n.localize(11265,null)};case v.Warning:return{original:"Warning",value:n.localize(11266,null)};case v.Error:return{original:"Error",value:n.localize(11267,null)};case v.Off:return{original:"Off",value:n.localize(11268,null)}}}function L(R){switch(R){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$qk=new d.$Uj("logLevel",y(v.Info))});var se=this&&this.__param||function(V,e){return function(n,r){e(n,r,V)}};define(ce[187],le([0,1,13,3,97,5]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;const T=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===P.PasswordStoreCLIOption.basic&&T.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const m=JSON.stringify(T.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const h=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value.");const d=T.decryptString(h);return this.a.trace("[EncryptionMainService] Decrypted value."),d}catch(h){throw this.a.error(h),h}}isEncryptionAvailable(){return Promise.resolve(T.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$j)return Promise.resolve(P.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(P.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{const c=T.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(P.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");T.setUsePlainTextEncryption(!0)}};e.$dgc=I,e.$dgc=I=Se([se(0,A.$$j)],I)}),define(ce[188],le([0,1,21,8,15,4,32,2,9,61,5]),function(V,e,n,r,P,A,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class h extends I.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new A.$ke),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ke),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Bh(0)),this.w=[],this.y=this.B(new r.$Bh(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,g);return this.r(),(0,I.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,P.$Y)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$7q)(f)),f=>this.G(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,c.$3q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,c.$3q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,g);return this.C(),(0,I.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,P.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$7q)(w)),w=>this.G(w),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$gc)(w.fsPath)}J(w){const f=this.I(w);return(0,T.$Fg)(f)}}e.$ar=h}),define(ce[189],le([0,1,21,8,17,22,4,46,77,2,60,11,70,18,67,10,14,124,5,15]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let t=class extends c.$Tc{static{E=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$ke),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$ke),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$ke),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$ke),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$ke),this.Y=this.B(new T.$ke),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$ke),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Mh)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const s=new c.$Sc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$rl(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,c.$Oc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await r.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,w.$ih)(i))throw new v.$tl((0,g.localize)(11336,null,this.sb(i)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new k.$ab;throw s.message=(0,g.localize)(11337,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,v.$el)(o)||(0,v.$bl)(o)||(0,v.$fl)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,v.$el)(o)||(0,v.$bl)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,v.$ol)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$tl((0,g.localize)(11338,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ml)(s)}}async s(i,o){const s=await this.j(i),a=this.S(s),l=o?.resolveTo,S=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,D=await s.stat(i);let L;return this.t(s,i,D,void 0,!!y,(R,O)=>(L||(L=m.$Ji.forUris(()=>!a),L.set(i,!0),l&&L.fill(!0,l)),L.get(R.resource)||L.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&S?O===1:!1))}async t(i,o,s,a,l,S){const{providerExtUri:y}=this.R(i),D={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(i.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$El)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&S(D,a)){try{const L=await i.readdir(o),R=await r.Promises.settled(L.map(async([O,M])=>{try{const x=y.joinPath(o,O),X=l?await i.stat(x):{type:M};return await this.t(i,x,X,L.length,l,S)}catch(x){return this.b.trace(x),null}}));D.children=(0,n.$Gb)(R)}catch(L){this.b.trace(L),D.children=[]}return D}return D}async resolveAll(i){return r.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new v.$tl((0,g.localize)(11339,null,this.sb(i)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(i,o=P.$Me.fromString(""),s){await this.u(i,s);const a=await this.writeFile(i,o);return this.r.fire(new v.$ql(i,v.FileOperation.CREATE,a)),a}async writeFile(i,o,s){const a=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(a);let S=s;if((0,v.$hl)(a)&&!S?.atomic){const y=a.enforceAtomicWriteFile?.(i);y&&(S={...s,atomic:y})}try{await this.w(a,i,S)||await this.U(a,l.dirname(i));let D;if((0,v.$bl)(a)&&!(o instanceof P.$Me))if((0,f.$ye)(o)){const L=await(0,f.$Fe)(o,3);L.ended?D=P.$Me.concat(L.buffer):D=L}else D=(0,f.$Ce)(o,L=>P.$Me.concat(L),3);else D=o;!(0,v.$el)(a)||(0,v.$bl)(a)&&D instanceof P.$Me||(0,v.$bl)(a)&&(0,v.$hl)(a)&&S?.atomic?await this.hb(a,i,S,D):await this.db(a,i,S,D instanceof P.$Me?(0,P.$Xe)(D):D),this.r.fire(new v.$ql(i,v.FileOperation.WRITE))}catch(y){throw new v.$tl((0,g.localize)(11340,null,this.sb(i),(0,v.$ml)(y).toString()),(0,v.$pl)(y),S)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const a=!!s?.unlock;if(a&&!(i.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(11341,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(11342,null,this.sb(o)));if(!(i.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(11343,null,this.sb(o)));if(a)throw new Error((0,g.localize)(11344,null,this.sb(o)))}let S;try{S=await i.stat(o)}catch{return}if(S.type&v.FileType.Directory)throw new v.$tl((0,g.localize)(11345,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Dl&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,v.$El)({mtime:s.mtime,size:S.size}))throw new v.$tl((0,g.localize)(11346,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(i,o,s){const a=await this.m(i);return o?.atomic?this.z(a,i,o,s):this.C(a,i,o,s)}async z(i,o,s,a){return new Promise((l,S)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(i,o,s,a);l(y)}catch(y){S(y)}},this.R(i).providerExtUri)})}async C(i,o,s,a){const l=await this.D(i,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,P.$Ye)(l.value)}}async readFileStream(i,o,s){const a=await this.m(i);return this.D(a,i,o,s)}async D(i,o,s,a){const l=new A.$ve(a);let S=s;(0,v.$gl)(i)&&i.enforceAtomicReadFile?.(o)&&(S={...s,atomic:!0});const y=this.J(o,S).then(L=>L,L=>{throw l.dispose(!0),L});let D;try{return typeof S?.etag=="string"&&S.etag!==v.$Dl&&await y,S?.atomic&&(0,v.$gl)(i)||!((0,v.$el)(i)||(0,v.$fl)(i))||(0,v.$bl)(i)&&S?.preferUnbuffered?D=this.I(i,o,S):(0,v.$fl)(i)?D=this.G(i,o,l.token,S):D=this.H(i,o,l.token,S),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await y,value:D}}catch(L){throw D&&await(0,f.$De)(D),this.F(L,o,S)}}F(i,o,s){const a=(0,g.localize)(11347,null,this.sb(o),(0,v.$ml)(i).toString());return i instanceof v.$vl?new v.$vl(a,i.stat,s):i instanceof v.$ul?new v.$ul(a,i.fileOperationResult,i.size,i.options):new v.$tl(a,(0,v.$pl)(i),s)}G(i,o,s,a=Object.create(null)){const l=i.readFileStream(o,a,s);return(0,f.$Je)(l,{data:S=>S instanceof P.$Me?S:P.$Me.wrap(S),error:S=>this.F(S,o,a)},S=>P.$Me.concat(S))}H(i,o,s,a=Object.create(null)){const l=(0,P.$3e)();return(0,b.$Zq)(i,o,l,S=>S,{...a,bufferSize:this.a,errorTransformer:S=>this.F(S,o,a)},s),l}I(i,o,s){const a=(0,f.$Ae)(l=>P.$Me.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$gl)(i)?l=await i.readFile(o,{atomic:!0}):l=await i.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(P.$Me.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new v.$tl((0,g.localize)(11348,null,this.sb(i)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Dl&&o.etag===s.etag)throw new v.$vl((0,g.localize)(11349,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$ul((0,g.localize)(11350,null,this.sb(i)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,a){if(i.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),S=this.qb(await this.n(o),o);await this.Q(l,i,S,o,s,a)}catch(l){return l}return!0}async move(i,o,s){const a=this.qb(await this.n(i),i),l=this.qb(await this.n(o),o),S=await this.N(a,i,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$ql(i,S==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(i,o,s){const a=await this.m(i),l=this.qb(await this.n(o),o),S=await this.N(a,i,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$ql(i,S==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(i,o,s,a,l,S){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:D}=await this.Q(i,o,s,a,l,S);if(y&&!D&&S&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(i===s&&(0,v.$cl)(i))await i.copy(o,a,{overwrite:S});else{const L=await this.resolve(o);L.isDirectory?await this.P(i,L,s,a):await this.O(i,o,s,a)}return l}else return i===s?(await i.rename(o,a,{overwrite:S}),l):(await this.N(i,o,s,a,"copy",S),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,a){if((0,v.$el)(i)&&(0,v.$el)(s))return this.jb(i,o,s,a);if((0,v.$el)(i)&&(0,v.$bl)(s))return this.pb(i,o,s,a);if((0,v.$bl)(i)&&(0,v.$el)(s))return this.nb(i,o,s,a);if((0,v.$bl)(i)&&(0,v.$bl)(s))return this.lb(i,o,s,a)}async P(i,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const S=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,S):this.O(i,l.resource,s,S)}))}async Q(i,o,s,a,l,S){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:R}=this.R(i);if(R||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,g.localize)(11351,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,g.localize)(11352,null,this.sb(o),this.sb(a)))}const D=await this.exists(a);if(D&&!y){if(!S)throw new v.$tl((0,g.localize)(11353,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(o,a))throw new Error((0,g.localize)(11354,null,this.sb(o),this.sb(a)))}}return{exists:D,isSameResourceWithDifferentPathCase:y}}R(i){const o=this.S(i);return{providerExtUri:o?w.$7g:w.$9g,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new v.$ql(i,v.FileOperation.CREATE,s)),s}async U(i,o){const s=[],{providerExtUri:a}=this.R(i);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await i.stat(o)).type&v.FileType.Directory))throw new Error((0,g.localize)(11355,null,this.sb(o)));break}catch(l){if((0,v.$ol)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await i.mkdir(o)}catch(S){if((0,v.$ol)(S)!==v.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(11356,null,this.sb(i)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(11357,null,this.sb(i)));if(a&&l)throw new Error((0,g.localize)(11358,null,this.sb(i)));let S;try{S=await s.stat(i)}catch{}if(S)this.rb(i,S);else throw new v.$tl((0,g.localize)(11359,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const D=await this.resolve(i);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,g.localize)(11360,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let a=o;if((0,v.$il)(s)&&!a?.atomic){const D=s.enforceAtomicDelete?.(i);D&&(a={...o,atomic:D})}const l=!!a?.useTrash,S=!!a?.recursive,y=a?.atomic??!1;await s.delete(i,{recursive:S,useTrash:l,atomic:y}),this.r.fire(new v.$ql(i,v.FileOperation.DELETE))}async cloneFile(i,o){const s=await this.j(i),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(i,o)))return s===a&&(0,v.$dl)(s)?s.cloneFile(i,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$cl)(s)?this.cb.queueFor(i,()=>s.copy(i,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:E.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new c.$Sc;let a=!1,l=()=>{a=!0};s.add((0,c.$Rc)(()=>l())),(async()=>{try{const y=await this.bb(i,o);a?(0,c.$Oc)(y):l=()=>(0,c.$Oc)(y)}catch(y){this.b.error(y)}})();const S=o.correlationId;if(typeof S=="number"){const y=s.add(new T.$ke);return s.add(this.X.event(L=>{L.correlates(S)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),a=(0,I.$rj)([this.R(s).providerExtUri.getComparisonKey(i),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(i,o)},this.$.set(a,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,c.$Oc)(i.disposable);this.$.clear()}async db(i,o,s,a){return this.cb.queueFor(o,async()=>{const l=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$ye)(a)||(0,f.$ze)(a)?await this.eb(i,l,a):await this.fb(i,l,a)}catch(S){throw(0,v.$ml)(S)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,o,s){let a=0,l;if((0,f.$ze)(s)){if(s.buffer.length>0){const S=P.$Me.concat(s.buffer);await this.gb(i,o,S,S.byteLength,a,0),a+=S.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((S,y)=>{(0,f.$Ee)(l,{onData:async D=>{l.pause();try{await this.gb(i,o,D,D.byteLength,a,0)}catch(L){return y(L)}a+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>y(D),onEnd:()=>S()})})}async fb(i,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(i,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(i,o,s,a,l,S){let y=0;for(;y<a;){const D=await i.write(o,l+y,s.buffer,S+y,a-y);y+=D}}async hb(i,o,s,a){return this.cb.queueFor(o,()=>this.ib(i,o,s,a),this.R(i).providerExtUri)}async ib(i,o,s,a){let l;a instanceof P.$Me?l=a:(0,f.$ye)(a)?l=await(0,P.$Ye)(a):(0,f.$ze)(a)?l=await(0,P.$Ze)(a):l=(0,P.$We)(a),await i.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,a){return this.cb.queueFor(a,()=>this.kb(i,o,s,a),this.R(s).providerExtUri)}async kb(i,o,s,a){let l,S;try{l=await i.open(o,{create:!1}),S=await s.open(a,{create:!0,unlock:!1});const y=P.$Me.alloc(this.a);let D=0,L=0,R=0;do R=await i.read(l,D,y.buffer,L,y.byteLength-L),await this.gb(s,S,y,R,D,L),D+=R,L+=R,L===y.byteLength&&(L=0);while(R>0)}catch(y){throw(0,v.$ml)(y)}finally{await r.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(i,o,s,a){return this.cb.queueFor(a,()=>this.mb(i,o,s,a),this.R(s).providerExtUri)}async mb(i,o,s,a){return s.writeFile(a,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,a){return this.cb.queueFor(a,()=>this.ob(i,o,s,a),this.R(s).providerExtUri)}async ob(i,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const S=await i.readFile(o);await this.gb(s,l,P.$Me.wrap(S),S.byteLength,0,0)}catch(S){throw(0,v.$ml)(S)}finally{await s.close(l)}}async pb(i,o,s,a){const l=await(0,P.$Ye)(this.H(i,o,A.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(i,o){if(i.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$tl((0,g.localize)(11361,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$tl((0,g.localize)(11362,null,this.sb(i)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}};e.$1q=t,e.$1q=t=E=Se([se(0,$.$$j)],t)}),define(ce[99],le([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,188,184,183]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class E extends b.$ar{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=T.Event.None,this.P=new P.$zc(o=>h.$8g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,m.$l&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(u));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await w.Promises.readdir(this.I(u),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,h.$eh)(u,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(i){throw this.hb(i)}}O(u,i){let o;return i?.dangling?o=g.FileType.Unknown:u.isFile()?o=g.FileType.File:u.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,i&&(o|=g.FileType.SymbolicLink),o}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const s=new r.$Ch;return this.P.set(u,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(u,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),o=await this.Q(u));const s=this.I(u);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(u){E.L&&this.a.trace(u)}readFileStream(u,i,o){const s=(0,d.$Ae)(a=>A.$Me.concat(a.map(l=>A.$Me.wrap(l))).buffer);return(0,v.$Zq)(this,u,s,a=>a.buffer,{...i,bufferSize:256*1024},o),s}async writeFile(u,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(u)?this.U(u,(0,h.$eh)((0,h.$dh)(u),`${(0,h.$bh)(u)}${o.atomic.postfix}`),i,o):this.W(u,i,o)}async S(u){try{const i=this.I(u),{symbolicLink:o}=await w.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(u,i,o,s){const a=new p.$Sc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),await this.W(i,o,s,!0);try{await this.rename(i,u,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(u,i,o,s){let a;try{const l=this.I(u);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,g.$ll)((0,f.localize)(11320,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$ll)((0,f.localize)(11321,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(u,{create:!0,unlock:o.unlock},s),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.ib(u,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(u){E.$=u}async open(u,i,o){const s=this.I(u);let a;(0,g.$_k)(i)&&!o&&(a=await this.Q(u));let l;try{if((0,g.$_k)(i)&&i.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let S;if((0,g.$_k)(i)){if(m.$j)try{await n.promises.truncate(s,0),S="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}S||(S="w")}else S="r";l=await w.Promises.open(s,S)}catch(S){throw a?.dispose(),(0,g.$_k)(i)?await this.ib(u,S):this.hb(S)}if(this.X.set(l,0),(0,g.$_k)(i)&&this.Z.set(l,u),a){const S=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),S.dispose())}return l}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&E.$)try{await w.Promises.fdatasync(u)}catch(o){E.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(u)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,o,s,a){const l=this.ab(u,i);let S=null;try{S=(await w.Promises.read(u,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(u,l,S)}return S}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,o){const s=this.X.get(u);typeof s=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(u,s+o):this.X.delete(u)))}async write(u,i,o,s,a){return(0,r.$Xh)(()=>this.cb(u,i,o,s,a),100,3)}async cb(u,i,o,s,a){const l=this.ab(u,i);let S=null;try{S=(await w.Promises.write(u,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(u),y)}finally{this.bb(u,l,S)}return S}async mkdir(u){try{await n.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const o=this.I(u);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,c.$ic)((0,c.$lc)(o),`${(0,c.$mc)(o)}${i.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:S}=await w.SymlinkSupport.stat(o);a=l.isDirectory()&&!S}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"move",o.overwrite),await w.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11322,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async copy(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"copy",o.overwrite),await w.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11323,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async db(u,i,o,s){const a=this.I(u),l=this.I(i);let S=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,I.$Bg)(a,l,!0)),S){if(o==="copy")throw(0,g.$ll)((0,f.localize)(11324,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const D=await this.N(u);if(!D)throw(0,g.$ll)((0,f.localize)(11325,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!s)throw(0,g.$ll)((0,f.localize)(11326,null),g.FileSystemProviderErrorCode.FileExists);D.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,o){const s=this.I(u),a=this.I(i),l=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Bg)(s,a,!l))return;const S=new p.$Sc;try{S.add(await this.Q(u)),S.add(await this.Q(i)),o&&await n.promises.mkdir((0,c.$lc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(u,i,!0);throw this.hb(y)}finally{S.dispose()}}t(u,i,o){return new $.$hr(s=>u(s),s=>i(s),o)}F(u,i,o){return new k.$qr(s=>u(s),s=>i(s),o)}hb(u){if(u instanceof g.$kl)return u;let i=u,o;switch(u.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$ll)(i,o)}async ib(u,i){let o=this.hb(i);if(u&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(u));s.mode&128||(o=(0,g.$ll)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$rr=E}),define(ce[190],le([0,1,4,99,2,17,67,22]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;class p extends P.$Tc{constructor(h,d){super(),this.a=h,this.b=d,this.F=new Map,this.G=new Map}call(h,d,w){const f=this.c(h);switch(d){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${d} not found`)}listen(h,d,w){const f=this.c(h);switch(d){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${d}`)}g(h,d){const w=this.f(h,d,!0);return this.a.stat(w)}h(h,d){const w=this.f(h,d);return this.a.readdir(w)}async j(h,d,w){const f=this.f(h,d,!0),g=await this.a.readFile(f,w);return A.$Me.wrap(g)}m(h,d,w){const f=this.f(h,d,!0),g=new I.$ve,v=new n.$ke({onDidRemoveLastListener:()=>{g.cancel()}}),b=this.a.readFileStream(f,w,g.token);return(0,T.$Ee)(b,{onData:$=>v.fire(A.$Me.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),g.dispose()}}),v.event}n(h,d,w,f){const g=this.f(h,d);return this.a.writeFile(g,w.buffer,f)}r(h,d,w){const f=this.f(h,d,!0);return this.a.open(f,w)}s(h){return this.a.close(h)}async t(h,d,w){const f=A.$Me.alloc(w),v=await this.a.read(h,d,f.buffer,0,w);return[f,v]}u(h,d,w,f,g){return this.a.write(h,d,w.buffer,f,g)}w(h,d){const w=this.f(h,d);return this.a.mkdir(w)}y(h,d,w){const f=this.f(h,d);return this.a.delete(f,w)}z(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.rename(g,v,f)}C(h,d,w,f){const g=this.f(h,d),v=this.f(h,w);return this.a.copy(g,v,f)}D(h,d,w){const f=this.f(h,d),g=this.f(h,w);return this.a.cloneFile(f,g)}H(h,d){const w=new n.$ke({onWillAddFirstListener:()=>{this.F.set(d,this.L(h,w))},onDidRemoveLastListener:()=>{(0,P.$Oc)(this.F.get(d)),this.F.delete(d)}});return w.event}async I(h,d,w,f,g){const v=this.F.get(d);if(v){const b=this.f(h,f),$=v.watch(w,b,g);this.G.set(d+w,$)}}async J(h,d){const w=h+d,f=this.G.get(w);f&&((0,P.$Oc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,h]of this.G)h.dispose();this.G.clear();for(const[,h]of this.F)h.dispose();this.F.clear()}}e.$2s=p;class c extends P.$Tc{constructor(h,d,w,f){super(),this.c=h,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$rr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(d)}h(h){const d=this.B(new n.$ke);this.B(d.event(w=>{h.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>d.fire(w))),this.B(this.b.onDidWatchError(w=>h.fire(w)))}j(h){}m(h){}watch(h,d,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(h,this.b.watch(d,w)),(0,P.$Rc)(()=>{(0,P.$Oc)(this.a.get(h)),this.a.delete(h)})}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),super.dispose()}}e.$3s=c}),define(ce[191],le([0,1,13,10,3,7,14,9,190,151,55]),function(V,e,n,r,P,A,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class h extends p.$2s{constructor(f,g,v){super(f,g),this.M=v}c(f){return c.$Ln}f(f,g){return A.URI.revive(g)}async y(f,g,v){if(!v.useTrash)return super.y(f,g,v);const b=this.f(f,g),$=(0,I.$gc)(b.fsPath);try{await n.shell.trashItem($)}catch(k){throw(0,T.$ll)(P.$j?(0,r.localize)(11327,null,(0,I.$mc)($),(0,m.$oj)(k)):(0,r.localize)(11328,null,(0,I.$mc)($),(0,m.$oj)(k)),T.FileSystemProviderErrorCode.Unknown)}}L(f,g){return new d(f,g,this.b,this.M)}}e.$lgc=h;class d extends p.$3s{watch(f,g,v){if(v.recursive)throw(0,T.$ll)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,g,v)}}}),define(ce[192],le([0,1,5]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class r extends n.$ek{constructor(A=n.$bk){super(),this.m=[],this.n=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(A){this.n=A;for(const{level:T,message:I}of this.m)(0,n.log)(A,T,I);this.m=[]}g(A,T){this.n?(0,n.log)(this.n,A,T):this.getLevel()<=A&&this.m.push({level:A,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$4cc=r}),define(ce[193],le([0,1,7,4,5,2]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=void 0;class T extends P.$jk{constructor(h,d,w,f,g){super(d,w,f),this.r=h,this.t=g,this.B(g.listen("onDidChangeLogLevel",h)(v=>{(0,P.$ak)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(g.listen("onDidChangeVisibility",h)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(g.listen("onDidChangeLoggers",h)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new P.$hk({log:(h,d)=>{this.t.call("consoleLog",[h,d])}})}registerLogger(h){super.registerLogger(h),this.t.call("registerLogger",[h,this.r])}deregisterLogger(h){super.deregisterLogger(h),this.t.call("deregisterLogger",[h,this.r])}setLogLevel(h,d){super.setLogLevel(h,d),this.t.call("setLogLevel",[h,d])}setVisibility(h,d){super.setVisibility(h,d),this.t.call("setVisibility",[this.n(h),d])}s(h,d,w){return new I(this.t,h,d,w,this.r)}static setLogLevel(h,d,w){return h.call("setLogLevel",[d,w])}}e.$rs=T;class I extends P.$ek{constructor(h,d,w,f,g){super(f?.logLevel==="always"),this.r=h,this.s=d,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[d,f,g]).then(()=>{this.u(this.n),this.m=!0})}g(h,d){const w=[[h,d]];this.m?this.u(w):this.n.push(...w)}u(h){this.r.call("log",[this.s,h])}}class p{constructor(h,d){this.a=h,this.b=d}listen(h,d){const w=this.b(h);switch(d){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(g=>this.c(g,w)),removed:[...f.removed].map(g=>this.c(g,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,P.$ak)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${d}`)}async call(h,d,w){const f=this.b(h);switch(d){case"setLogLevel":return(0,P.$ak)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,f)))}throw new Error(`Call not found: ${d}`)}c(h,d){return{...h,resource:d.transformOutgoingURI(h.resource)}}}e.$ss=p;class c extends A.$Tc{constructor(h,d){super(),d.call("setLogLevel",[h.getLogLevel()]),this.B(h.onDidChangeLogLevel(w=>d.call("setLogLevel",[w]))),d.call("getRegisteredLoggers").then(w=>{for(const f of w)h.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(d.listen("onDidChangeVisibility")(([w,f])=>h.setVisibility(n.URI.revive(w),f))),this.B(d.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const g of w)h.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of f)h.deregisterLogger(g.resource)}))}}e.$ts=c}),define(ce[194],le([0,1,2,5]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class P extends n.$Tc{constructor(T,I=[]){super(),this.a=new r.$ik([T,...I]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$ER=P}),define(ce[195],le([0,1,31,7,5]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class A{constructor(I){this.b=I,this.a=new n.$zc}listen(I,p,c){switch(p){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,c){switch(p){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$ak)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,c){this.a.set(I,this.b.createLogger(I,p,c))}d(I,p){let c=console.log;switch(I){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...p)}e(I,p){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[m,h]of p)(0,P.log)(c,m,h)}}e.$jhc=A}),define(ce[196],le([0,1,14,5]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function A(c,m,h,d,w){try{const f=await new Promise((v,b)=>{V(["@vscode/spdlog"],v,b)}).then(Pe);f.setFlushOn(P.Trace);const g=await f.createAsyncRotatingLogger(c,m,h,d);return w?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(f){console.error(f)}return null}function T(c,m,h){switch(m){case r.LogLevel.Trace:c.trace(h);break;case r.LogLevel.Debug:c.debug(h);break;case r.LogLevel.Info:c.info(h);break;case r.LogLevel.Warning:c.warn(h);break;case r.LogLevel.Error:c.error(h);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case r.LogLevel.Trace:c.setLevel(P.Trace);break;case r.LogLevel.Debug:c.setLevel(P.Debug);break;case r.LogLevel.Info:c.setLevel(P.Info);break;case r.LogLevel.Warning:c.setLevel(P.Warning);break;case r.LogLevel.Error:c.setLevel(P.Error);break;case r.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class p extends r.$ek{constructor(m,h,d,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(m,h,d,w),this.B(this.onDidChangeLogLevel(g=>{this.r&&I(this.r,g)}))}async s(m,h,d,w){const f=d?6:1,g=30/f*n.$Gl.MB,v=await A(m,h,g,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)T(this.r,b,$);this.m=[]}}g(m,h){this.r?T(this.r,m,h):this.getLevel()<=m&&this.m.push({level:m,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$tR=p}),define(ce[197],le([0,1,33,5,196]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;class A extends r.$jk{s(I,p,c){return new P.$tR((0,n.$Zg)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}e.$uR=A}),define(ce[71],le([0,1,31,4,6,5,197]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,P.$Ei)(A.$_j);class I extends T.$uR{constructor(){super(...arguments),this.u=new n.$zc}createLogger(c,m,h){h!==void 0&&this.u.set(this.n(c),h);try{return super.createLogger(c,m)}catch(d){throw this.u.delete(this.n(c)),d}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const h of super.getRegisteredLoggers())c===this.u.get(h.resource)&&m.push(h);return m}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,A.$ak)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(d=>this.w(d.resource,c)),removed:[...m.removed].filter(d=>this.w(d.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,h]of this.u)h===c&&this.deregisterLogger(m)}w(c,m){const h=this.u.get(c);return h===void 0||h===m}dispose(){super.dispose(),this.u.clear()}}e.$Sfc=I}),define(ce[198],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=n,e.$Agc=r,e.$Bgc=P,e.$Cgc=A;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function P(T){return T.uri!==void 0}function A(T){return!n(T)&&!r(T)&&!P(T)}}),define(ce[40],le([0,1,4,77,2,6]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=void 0,e.$ro=(0,A.$Di)("policy");class T extends P.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ke),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(h,[d,w])=>({...h,[d]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[m,h])=>({...c,[m]:{definition:h,value:this.g.get(m)}}),{})}}e.$so=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$to=I}),define(ce[199],le([0,1,8,4,77,12,14,5,40]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;function c(h,d){const w=[];for(const f of new Set(P.Iterable.concat(h.keys(),d.keys())))h.get(f)!==d.get(f)&&w.push(f);return w}let m=class extends p.$so{constructor(d,w,f){super(),this.m=d,this.n=w,this.s=f,this.c=this.B(new n.$Bh(500));const g=r.Event.filter(w.onDidFilesChange,v=>v.affects(d));this.B(w.watch(d)),this.B(g(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,A.$fg)(f))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(f))this.f[g]&&d.set(g,f[g])}catch(w){w.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return d}async w(){const d=await this.u(),w=c(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};e.$Chc=m,e.$Chc=m=Se([se(1,T.$$k),se(2,I.$$j)],m)}),define(ce[200],le([0,1,4,2,40]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;class A{constructor(p){this.b=p,this.a=new r.$Sc}listen(p,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,m=>m.reduce((h,d)=>({...h,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(p,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$$gc=A;class T extends P.$so{constructor(p,c){super(),this.a=c;for(const m in p){const{definition:h,value:d}=p[m];this.f[m]=h,d!==void 0&&this.g.set(m,d)}this.a.listen("onDidChange")(m=>{for(const h in m){const d=m[h];d===null?this.g.delete(h):this.g.set(h,d)}this.h.fire(Object.keys(m))})}async j(p){const c=await this.a.call("updatePolicyDefinitions",p);for(const m in c)this.g.set(m,c[m])}}e.$_gc=T}),define(ce[201],le([0,1,40,8,2,5]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;let T=class extends n.$so{constructor(p,c){super(),this.m=p,this.n=c,this.a=new r.$xh,this.b=this.B(new P.$Uc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((m,h)=>{V(["@vscode/policy-watcher"],m,h)}).then(Pe);await this.a.queue(()=>new Promise((m,h)=>{try{this.b.value=c(this.n,p,d=>{this.t(d),m()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),h(d)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const m=p[c];m===void 0?this.g.delete(c):this.g.set(c,m)}this.h.fire(Object.keys(p))}};e.$Bhc=T,e.$Bhc=T=Se([se(0,A.$$j)],T)}),define(ce[72],le([0,1,36]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const A=P.context.configuration();if(A)r=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:A.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ce[28],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,n.$Di)("productService"),e.$sk="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,8,5]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;let P=class{constructor(T,I,p){this.a=T,this.b=I,this.c=p}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Eh)(T);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$ogc=P,e.$ogc=P=Se([se(2,r.$$j)],P)}),define(ce[73],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0,e.$Afc=(0,n.$Di)("protocolMainService")}),define(ce[45],le([0,1,141,12]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,n=Pe(n),r=Pe(r);class P{constructor(){this.a=new Map}add(T,I){n.ok(r.$dg(T)),n.ok(r.$fg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$po=new P}),define(ce[203],le([0,1,4,143,45]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,P=Pe(P),e.$qo={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new n.$ke,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,m){this.a[A(c)]=m,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const m=this.a[c];return m?(0,r.$6j)(m):void 0}hasSchemaContent(c){return!!this.a[c]}}const I=new T;P.$po.add(e.$qo.JSONContribution,I)}),define(ce[56],le([0,1,21,4,12,10,16,203,45]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=g,e.$Go=v,e.$Ho=b,e.$Io=k,e.$Jo=E,e.$Ko=t,e.$Lo=u,P=Pe(P),A=Pe(A);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$uo={Configuration:"base.contributions.configuration"};var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const h=p.$po.as(I.$qo.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new r.$ke,this.onDidSchemaChange=this.j.event,this.k=new r.$ke,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(11556,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},h.registerSchema(e.$Bo,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),h.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),h.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),h.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:S}of o)for(const y in l){s.add(y);const D=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(D.configurationDefaultOverrides.push({value:L,source:S}),e.$Eo.test(y)){const R=this.o(y,L,S,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R,this.n(y,R,S),a.push(...g(y))}else{const R=this.p(y,L,S,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R;const O=this.e[y];O&&(this.A(y,O),this.w(y,O))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const S in a){const y=this.b.get(S);if(!y)continue;const D=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[S]);if(D!==-1){if(y.configurationDefaultOverrides.splice(D,1),y.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Eo.test(S)){let L;for(const R of y.configurationDefaultOverrides)L=this.o(S,R.value,R.source,L);L&&!P.$qg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(S,L,l)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let L;for(const O of y.configurationDefaultOverrides)L=this.p(S,O.value,O.source,L);y.configurationDefaultOverrideValue=L;const R=this.e[S];R&&(this.A(S,R),this.w(S,R))}s.add(S)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:A.localize(11557,null,(0,T.$hj)(o)),$ref:e.$Bo,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const S=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(s)){const L=s[D];if(P.$fg(L)&&(P.$kg(S[D])||P.$fg(S[D]))){if(S[D]={...S[D]??{},...L},a)for(const O in L)y.set(`${D}.${O}`,a)}else S[D]=L,a?y.set(D,a):y.delete(D)}return{value:S,source:y}}p(o,s,a,l){const S=this.e[o],y=l?.value??S?.defaultDefaultValue;let D=a;if(P.$fg(s)&&(S!==void 0&&S.type==="object"||S===void 0&&(P.$kg(y)||P.$fg(y)))){if(D=l?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const R in s)a&&D.set(`${o}.${R}`,a);s={...P.$fg(y)?y:{},...s}}return{value:s,source:D}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const S in l.properties){s.add(S);const y=this.e[S];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[S],this.x(S,l.properties[S])}l.allOf?.forEach(S=>a(S))};for(const l of o){a(l);const S=this.d.indexOf(l);S!==-1&&this.d.splice(S,1)}}u(o,s=!0,a,l,S=m.WINDOW,y){S=P.$mg(o.scope)?S:o.scope;const D=o.properties;if(D)for(const R in D){const O=D[R];if(s&&k(R,O)){delete D[R];continue}if(O.source=a,O.defaultDefaultValue=D[R].default,this.A(R,O),e.$Eo.test(R)?O.scope=void 0:(O.scope=P.$mg(O.scope)?S:O.scope,O.restricted=P.$mg(O.restricted)?!!l?.includes(R):O.restricted),D[R].hasOwnProperty("included")&&!D[R].included){this.g[R]=D[R],delete D[R];continue}else this.e[R]=D[R],D[R].policy?.name&&this.f.set(D[R].policy.name,R);!D[R].deprecationMessage&&D[R].markdownDeprecationMessage&&(D[R].deprecationMessage=D[R].markdownDeprecationMessage),y.add(R)}const L=o.allOf;if(L)for(const R of L)this.u(R,s,a,l,S,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$vo.properties[o]=s,s.scope){case m.APPLICATION:e.$wo.properties[o]=s;break;case m.MACHINE:e.$xo.properties[o]=s;break;case m.MACHINE_OVERRIDABLE:e.$yo.properties[o]=s;break;case m.WINDOW:e.$zo.properties[o]=s;break;case m.RESOURCE:e.$Ao.properties[o]=s;break;case m.LANGUAGE_OVERRIDABLE:e.$Ao.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$vo.properties[o],s.scope){case m.APPLICATION:delete e.$wo.properties[o];break;case m.MACHINE:delete e.$xo.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$yo.properties[o];break;case m.WINDOW:delete e.$zo.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:A.localize(11558,null),errorMessage:A.localize(11559,null),$ref:e.$Bo};this.A(s,a),e.$vo.properties[s]=a,e.$wo.properties[s]=a,e.$xo.properties[s]=a,e.$yo.properties[s]=a,e.$zo.properties[s]=a,e.$Ao.properties[s]=a}}z(){const o={type:"object",description:A.localize(11560,null),errorMessage:A.localize(11561,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=o,e.$wo.patternProperties[e.$Do]=o,e.$xo.patternProperties[e.$Do]=o,e.$yo.patternProperties[e.$Do]=o,e.$zo.patternProperties[e.$Do]=o,e.$Ao.patternProperties[e.$Do]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,S;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,S=a.source),P.$kg(l)&&(l=s.defaultDefaultValue,S=void 0),P.$kg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=S}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Do=`^(${w})+$`,e.$Eo=new RegExp(e.$Do);function g(i){const o=[];if(e.$Eo.test(i)){let s=f.exec(i);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(i)}}return(0,n.$Lb)(o)}function v(i){return i.reduce((o,s)=>`${o}[${s}]`,"")}function b(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new d;p.$po.add(e.$uo.Configuration,$);function k(i,o){return i.trim()?e.$Eo.test(i)?A.localize(11563,null,i):$.getConfigurationProperties()[i]!==void 0?A.localize(11564,null,i):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(11565,null,i,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(11562,null)}function E(){const i=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))i.push([s,o[s].scope]);return i.push(["launch",m.RESOURCE]),i.push(["task",m.RESOURCE]),i}function t(i){const o={};for(const s of i){const a=s.properties;if(P.$fg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,t(s.allOf))}return o}function u(i){switch(i){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(ce[125],le([0,1,21,4,43,2,31,37,12,7,16,56,14,45]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=E,n=Pe(n),P=Pe(P),I=Pe(I),p=Pe(p);function f(o){return Object.isFrozen(o)?o:I.$do(o)}class g{static createEmptyModel(s){return new g({},[],[],void 0,s)}constructor(s,a,l,S,y){this.b=s,this.c=a,this.d=l,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof g)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,m.$fj)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:y,identifiers:D,keys:L}of l.rawConfiguration.overrides){const R=new g(y,L,[],void 0,l.f).getValue(s);R!==void 0&&S.push({identifiers:D,value:R})}return S.length?f(S):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,m.$fj)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Lb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Lb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$co(this.contents),l=I.$co(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const D of s)if(y.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(a,D.contents);for(const L of D.overrides){const[R]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));R?(this.i(R.contents,L.contents),R.keys.push(...L.keys),R.keys=n.$Lb(R.keys)):l.push(I.$co(L))}for(const L of D.keys)S.indexOf(L)===-1&&S.push(L)}return new g(a,S,l,y.every(D=>D instanceof g)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const S of n.$Lb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[S];const D=a[S];D&&(typeof y=="object"&&typeof D=="object"?(y=I.$co(y),this.i(y,D)):y=D),l[S]=y}return new g(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&p.$fg(s[l])&&p.$fg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$co(a[l])}}j(s){let a=null,l=null;const S=y=>{y&&(l?this.i(l,y):l=I.$co(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&S(y.contents);return S(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,m.$ej)(this.contents,s),h.$Eo.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,h.$Fo)(s))),1))}k(s,a,l){if((0,m.$dj)(this.contents,s,a,S=>this.f.error(S)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),h.$Eo.test(s)){const S=(0,h.$Fo)(s),y={identifiers:S,keys:Object.keys(this.contents[s]),contents:(0,m.$cj)(this.contents[s],L=>this.f.error(L))},D=this.overrides.findIndex(L=>n.$tb(L.identifiers,S));D!==-1?this.overrides[D]=y:this.overrides.push(y)}}}e.$Mo=g;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!p.$mg(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:S,overrides:y,restricted:D,hasExcludedProperties:L}=this.i(s,a);this.b=new g(l,S,y,L?[s]:void 0,this.g),this.c=D||[]}h(s){let a={},l=null,S=[];const y=[],D=[];function L(O){Array.isArray(S)?S.push(O):l!==null&&(S[l]=O)}const R={onObjectBegin:()=>{const O={};L(O),y.push(S),S=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(S),S=O,l=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:L,onError:(O,M,x)=>{D.push({error:O,offset:M,length:x})}};if(s)try{P.$4n(s,R),a=S[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}i(s,a){const l=w.$po.as(h.$uo.Configuration).getConfigurationProperties(),S=this.j(s,l,!0,a);s=S.raw;const y=(0,m.$cj)(s,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`)),D=Object.keys(s),L=this.l(s,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:y,keys:D,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,a,l,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const D={},L=[];for(const R in s)if(h.$Eo.test(R)&&l){const O=this.j(s[R],a,!1,S);D[R]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=a[R],M=O?typeof O.scope<"u"?O.scope:h.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(R),!S.exclude?.includes(R)&&(S.include?.includes(R)||(M===void 0||S.scopes===void 0||S.scopes.includes(M))&&!(S.skipRestricted&&O?.restricted))?D[R]=s[R]:y=!0}return{raw:D,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const S of Object.keys(s))if(h.$Eo.test(S)){const y={};for(const D in s[S])y[D]=s[S][D];l.push({identifiers:(0,h.$Fo)(S),keys:Object.keys(y),contents:(0,m.$cj)(y,a)})}return l}}e.$No=v;class b extends A.$Tc{constructor(s,a,l,S,y){super(),this.c=s,this.f=a,this.g=S,this.h=y,this.b=this.B(new r.$ke),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(d.FileOperation.CREATE)||D.isOperation(d.FileOperation.COPY)||D.isOperation(d.FileOperation.DELETE)||D.isOperation(d.FileOperation.WRITE))&&l.isEqual(D.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=b;class ${constructor(s,a,l,S,y,D,L,R,O,M,x,X,K){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=S,this.d=y,this.f=D,this.g=L,this.h=R,this.i=O,this.j=M,this.k=x,this.l=X,this.m=K}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(s,a,l,S,y,D,L,R,O,M){this.j=s,this.l=a,this.m=l,this.n=S,this.p=y,this.q=D,this.r=L,this.s=R,this.t=O,this.u=M,this.h=null,this.i=new T.$zc,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=g.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,a===void 0?S.removeValue(s):S.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const S=this.w(s,a,l),y=this.A(a.resource,l),D=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const R of S.overrides)for(const O of R.identifiers)S.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,a,S.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,D)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:S,updated:y,removed:D}=u(this.j,s);a=[...S,...y,...D]}for(const S of a)for(const y of(0,h.$Fo)(S)){const D=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),R=[...L.filter(O=>D.indexOf(O)===-1),...D.filter(O=>L.indexOf(O)===-1),...D.filter(O=>!I.$go(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,R])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:S}=u(this.l,s),y=[...a,...l,...S];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.applicationConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.localUserConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.remoteUserConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=u(this.workspaceConfiguration,s),D=[...a,...l,...S];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:S,updated:y,removed:D,overrides:L}=u(l,a),R=[...S,...y,...D];return(R.length||!l)&&this.updateFolderConfiguration(s,a),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:S,removed:y,overrides:D}=u(a,void 0);return{keys:[...l,...S,...y],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let S=this.x(a,l);return a.overrideIdentifier&&(S=S.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},a){let l=this.y();if(a&&s){const S=a.getFolder(s);S&&(l=this.z(S.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),S=this.r.get(s);S?(a=l.merge(S),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:S,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:S,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(S=>a.add(S))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),S=this.E(s.policy,a),y=this.E(s.application,a),D=this.E(s.user,a),L=this.E(s.workspace,a),R=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],a)),O),new T.$zc);return new k(l,S,y,D,g.createEmptyModel(a),L,R,g.createEmptyModel(a),new T.$zc,a)}static E(s,a){return new g(s.contents,s.keys,s.overrides,void 0,a)}}e.$Po=k;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const S of o)S.keys.forEach(y=>s.add(y)),S.overrides.forEach(([y,D])=>{const L=(0,T.$wc)(a,y,new Set);D.forEach(R=>L.add(R))});const l=[];return a.forEach((S,y)=>l.push([y,[...S.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,a,l,S,y){this.change=s,this.f=a,this.g=l,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of s.keys)this.affectedKeys.add(D);for(const[,D]of s.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,S=this.d.indexOf(l);if(S<0)return!1;const y=S+l.length;if(y>=this.d.length)return!1;const D=this.d.charCodeAt(y);if(D!==this.b&&D!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,R=this.g.getValue(s,a,this.h);return!I.$go(L,R)}return!0}}e.$Ro=t;function u(o,s){const{added:a,removed:l,updated:S}=i(s?.rawConfiguration,o?.rawConfiguration),y=[],D=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const R=L.filter(O=>!D.includes(O));for(const O of R)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const R=D.filter(O=>!L.includes(O));for(const O of R)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const R of D)if(L.includes(R)){const O=i({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:s.getOverrideValue(void 0,R)||{},keys:s.getKeysForOverrideIdentifier(R)});y.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:l,updated:S,overrides:y}}function i(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],S=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const D=(0,m.$fj)(s.contents,y),L=(0,m.$fj)(o.contents,y);I.$go(D,L)||S.push(y)}}return{added:a,removed:l,updated:S}}}),define(ce[204],le([0,1,21,4,2,37,12,125,56,5,40,45]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class d extends P.$Tc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$ke),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$po.as(p.$uo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,h.$po.as(p.$uo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Mo.createEmptyModel(this.c);const v=h.$po.as(p.$uo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const k of v){const E=$[k],t=b[k];E!==void 0?this.b.setValue(k,E):t?this.b.setValue(k,t.default):this.b.removeValue(k)}}}e.$So=d;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Mo.createEmptyModel(new c.$lk)}async initialize(){return this.configurationModel}}e.$To=w;let f=class extends P.$Tc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$ke),this.onDidChangeConfiguration=this.a.event,this.b=I.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],k=h.$po.as(p.$uo.Configuration).getConfigurationProperties();for(const E of v){const t=k[E];if(!t){$.push(E);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}$.push(E),b[t.policy.name]={type:t.type}}}return(0,T.$qg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=h.$po.as(p.$uo.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(k=>b.get(k)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=h.$po.as(p.$uo.Configuration).getConfigurationProperties(),k=[],E=this.b.isEmpty();for(const t of v){const u=$[t]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(E?i!==void 0:!(0,A.$go)(this.b.getValue(t),i))&&k.push([t,i])}else this.b.getValue(t)!==void 0&&k.push([t,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const t=this.b;this.b=I.$Mo.createEmptyModel(this.g);for(const u of t.keys)this.b.setValue(u,t.getValue(u));for(const[u,i]of k)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);b&&this.a.fire(this.b)}}};e.$Uo=f,e.$Uo=f=Se([se(1,m.$ro),se(2,c.$$j)],f)}),define(ce[205],le([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,56,204,14,40]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class k extends p.$Tc{constructor(u,i,o,s){super(),this.m=u,this.n=s,this.h=this.B(new A.$ke),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$So(s)),this.c=o instanceof $.$to?new v.$To:this.B(new v.$Uo(this.b,o,s)),this.f=this.B(new f.$Oo(this.m,{},d.$8g,i,s)),this.a=new f.$Po(this.b.configurationModel,this.c.configurationModel,f.$Mo.createEmptyModel(s),f.$Mo.createEmptyModel(s),f.$Mo.createEmptyModel(s),f.$Mo.createEmptyModel(s),new c.$zc,f.$Mo.createEmptyModel(s),new c.$zc,s),this.j=new E(u,i,this),this.g=this.B(new r.$Ph(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Po(u,i,f.$Mo.createEmptyModel(this.n),o,f.$Mo.createEmptyModel(this.n),f.$Mo.createEmptyModel(this.n),new c.$zc,f.$Mo.createEmptyModel(this.n),new c.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const o=typeof u=="string"?u:void 0,s=(0,w.$$i)(u)?u:(0,w.$$i)(i)?i:{};return this.a.getValue(o,s,void 0)}async updateValue(u,i,o,s,a){const l=(0,w.$_i)(o)?o:(0,w.$$i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,S=l?s:o;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${S}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(u,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,m.$go)(i,y.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));R&&(l.overrideIdentifiers=R.identifiers)}const D=l?.overrideIdentifiers?.length?[(0,g.$Go)(l.overrideIdentifiers),u]:[u];await this.j.write(D,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(o,i,w.ConfigurationTarget.USER)}s(u,i){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(u);this.u(o,i,w.ConfigurationTarget.DEFAULT)}u(u,i,o){const s=new f.$Ro(u,{data:i},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Vo=k;class E{constructor(u,i,o){this.b=u,this.c=i,this.d=o,this.a=new r.$Kh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Wn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,u,i);o=(0,I.$bo)(o,a),await this.c.writeFile(this.b,P.$Me.fromString(o))}f(u,i,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!i.length){const S=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,I.$$n)(u,i,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let u=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[206],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=e.$ohc=void 0,e.$ohc="request",e.$phc="remoteResourceHandler";class n{async routeCall(P,A,T){if(A!==e.$ohc)throw new Error(`Call not found: ${A}`);const I=T[0];if(I?.authority){const p=P.connections.find(c=>c.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(P,A){throw new Error(`Event not found: ${A}`)}}e.$qhc=n}),define(ce[207],le([0,1,15,6]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=c,e.$Pl=(0,r.$Di)("remoteAuthorityResolverService");var P;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class A{constructor(h){this.id=h,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=A;class T{constructor(h,d){this.host=h,this.port=d,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=T;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$ab{static isNotAvailable(h){return h instanceof p&&h._code===I.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof p&&h._code===I.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof p&&h._code===I.NoResolverFound}static isInvalidAuthority(h){return h instanceof p&&h._code===I.InvalidAuthority}static isHandled(h){return h instanceof p&&h.isHandled}constructor(h,d=I.Unknown,w){super(h),this._message=h,this._code=d,this._detail=w,this.isHandled=d===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Sl=p;function c(m){const h=m.indexOf("+");return h===-1?m:m.substring(0,h)}}),define(ce[208],le([0,1,8,17,22,15,4,2,11,70,66,33,117,207]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Yl=y,e.$Zl=D,e.$1l=R,c=Pe(c);const f=30*1e3;var g;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function v(re){switch(re){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function b(re){const Q=new P.$ve;return setTimeout(()=>Q.cancel(),re),Q.token}function $(re,Q){if(re.isCancellationRequested||Q.isCancellationRequested)return P.CancellationToken.Cancelled;const F=new P.$ve;return re.onCancellationRequested(()=>F.cancel()),Q.onCancellationRequested(()=>F.cancel()),F.token}class k{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new I.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$wh)(),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function E(re,Q){const F=new k(Q);return F.registerDisposable(re.onControlMessage(N=>{const W=JSON.parse(N.toString()),z=j(W);z?F.reject(z):F.resolve(W)})),F.promise}function t(re,Q,F,N,W,z,te,ee){const q=new k(ee),ne=m.$ee.create(!1);return re.info(`Creating a socket (${te})...`),c.mark(`code/willCreateSocket/${z}`),Q.connect(F,N,W,te).then(de=>{q.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${te}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),re.info(`Creating a socket (${te}) was successful after ${ne.elapsed()} ms.`),q.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${te}) returned an error after ${ne.elapsed()} ms.`),re.error(de),q.reject(de)}),q.promise}function u(re,Q){const F=new k(Q);return re.then(N=>{F.didTimeout||F.resolve(N)},N=>{F.didTimeout||F.reject(N)}),F.promise}async function i(re,Q,F,N){const W=G(re,Q);re.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let z;try{z=await t(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$Qg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,v(Q),`renderer-${v(Q)}-${re.reconnectionToken}`,N)}catch(de){throw re.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),re.logService.error(de),de}re.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let te,ee;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(z,null),te=re.reconnectionProtocol,ee=!1):(te=new d.$ri({socket:z}),ee=!0),re.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const q=await u(re.signService.createNewMessage((0,h.$Zg)()),N),ne={type:"auth",auth:re.connectionToken||"00000000000000000000",data:q.data};te.sendControl(r.$Me.fromString(JSON.stringify(ne)));try{const de=await E(te,$(N,b(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const We=new Error("Unexpected handshake message");throw We.code="VSCODE_CONNECTION_ERROR",We}if(re.logService.trace(`${W} 4/6. received SignRequest control message.`),!await u(re.signService.validate(q,de.signedData),N)){const We=new Error("Refused to connect to unsupported server");throw We.code="VSCODE_CONNECTION_ERROR",We}const we=await u(re.signService.sign(de.data),N),Ie={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:Q};return F&&(Ie.args=F),re.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(r.$Me.fromString(JSON.stringify(Ie))),{protocol:te,ownsProtocol:ee}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(re.logService.error(`${W} the handshake timed out. Error:`),re.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${W} received error control message when negotiating connection. Error:`),re.logService.error(de)),ee&&B(te),de}}async function o(re,Q,F,N){const W=Date.now(),z=G(re,Q),{protocol:te,ownsProtocol:ee}=await i(re,Q,F,N),q=new k(N);return q.registerDisposable(te.onControlMessage(ne=>{const de=JSON.parse(ne.toString()),me=j(de);me?(re.logService.error(`${z} received error control message when negotiating connection. Error:`),re.logService.error(me),ee&&B(te),q.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ue(W)}!`),q.resolve({protocol:te,firstMessage:de}))})),q.promise}async function s(re,Q){const{protocol:F}=await o(re,g.Management,void 0,Q);return{protocol:F}}async function a(re,Q,F){const{protocol:N,firstMessage:W}=await o(re,g.ExtensionHost,Q,F),z=W&&W.debugPort;return{protocol:N,debugPort:z}}async function l(re,Q,F){const N=Date.now(),W=G(re,g.Tunnel),{protocol:z}=await i(re,g.Tunnel,Q,F);return re.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${ue(N)}!`),z}async function S(re,Q,F){const{connectTo:N,connectionToken:W}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:N,connectionToken:W,reconnectionToken:Q,reconnectionProtocol:F,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function y(re,Q,F){return L(re,async N=>{const{protocol:W}=await s(N,P.CancellationToken.None);return new U(re,Q,F,N.reconnectionToken,W)})}async function D(re,Q){return L(re,async F=>{const{protocol:N,debugPort:W}=await a(F,Q,P.CancellationToken.None);return new Z(re,Q,F.reconnectionToken,N,W)})}async function L(re,Q){for(let N=1;;N++)try{const W=(0,h.$Zg)(),z=await S(re,W,null);return await Q(z)}catch(W){if(N<5)re.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(W);else throw re.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(W),J.triggerPermanentFailure(0,0,w.$Sl.isHandled(W)),W}}async function R(re,Q,F){const N=await S(re,(0,h.$Zg)(),null);return await l(N,{host:Q,port:F},P.CancellationToken.None)}function O(re){return(0,n.$qh)(Q=>new Promise((F,N)=>{const W=setTimeout(F,re*1e3);Q.onCancellationRequested(()=>{clearTimeout(W),F()})}))}var M;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class x{constructor(Q,F){this.reconnectionToken=Q,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$2l=x;class X{constructor(Q,F,N,W){this.reconnectionToken=Q,this.millisSinceLastIncomingData=F,this.durationSeconds=N,this.c=W,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$3l=X;class K{constructor(Q,F,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ReconnectionRunning}}e.$4l=K;class fe{constructor(Q,F,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ConnectionGain}}e.$5l=fe;class H{constructor(Q,F,N,W){this.reconnectionToken=Q,this.millisSinceLastIncomingData=F,this.attempt=N,this.handled=W,this.type=M.ReconnectionPermanentFailure}}e.$6l=H;class J extends I.$Tc{static triggerPermanentFailure(Q,F,N){this._permanentFailure=!0,this.f=Q,this.g=F,this.h=N,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Q=>Q.y())}static debugPauseSocketWriting(){this.j.forEach(Q=>Q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||J._permanentFailure}constructor(Q,F,N,W,z){super(),this.t=Q,this.u=F,this.reconnectionToken=N,this.protocol=W,this.w=z,this.m=this.B(new T.$ke),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new fe(this.reconnectionToken,0,0)),this.B(W.onSocketClose(te=>{const ee=oe(this.t,this.reconnectionToken,!0);te?te.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ee} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(te=>{const ee=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),J.j.push(this),this.B((0,I.$Rc)(()=>{const te=J.j.indexOf(this);te>=0&&J.j.splice(te,1)})),this.n&&this.D(J.f,J.g,J.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Q=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<F.length?F[N]:F[F.length-1];try{if(W>0){const te=O(W);this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,te)),this.u.logService.info(`${Q} waiting for ${W} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${Q} resolving connection...`);const z=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Q} connecting to ${z.connectTo}...`),await this.G(z,b(f)),this.u.logService.info(`${Q} reconnected!`),this.m.fire(new fe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(w.$Sl.isTemporarilyNotAvailable(z)){this.u.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,A.$3)(z)){this.u.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof w.$Sl){this.u.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,w.$Sl.isHandled(z));break}this.u.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(Q,F,N){this.w?J.triggerPermanentFailure(Q,F,N):this.D(Q,F,N)}D(Q,F,N){this.m.fire(new H(this.reconnectionToken,Q,F,N)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7l=J;class U extends J{constructor(Q,F,N,W,z){super(g.Management,Q,W,z,!0),this.client=this.B(new d.$pi(z,{remoteAuthority:F,clientId:N},Q.ipcLogger))}async G(Q,F){await s(Q,F)}}e.$8l=U;class Z extends J{constructor(Q,F,N,W,z){super(g.ExtensionHost,Q,N,W,!1),this.H=F,this.debugPort=z}async G(Q,F){await a(Q,this.H,F)}}e.$9l=Z;function B(re){try{re.acceptDisconnect();const Q=re.getSocket();re.dispose(),Q.dispose()}catch(Q){(0,A.$Y)(Q)}}function j(re){if(re&&re.type==="error"){const Q=new Error(`Connection error: ${re.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function C(re,Q){for(;re.length<Q;)re+=" ";return re}function Y(re,Q){return`[remote-connection][${C(v(re),13)}][${Q.substr(0,5)}\u2026]`}function oe(re,Q,F){return`${Y(re,Q)}[${F?"reconnect":"initial"}]`}function G(re,Q){return`${oe(Q,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ue(re){return`${Date.now()-re} ms`}}),define(ce[74],le([0,1,11]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=r,e.$gn=P,e.$hn=A,e.$in=T;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function A(p){const{host:c,port:m}=I(p);if(typeof m>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function T(p,c){let{host:m,port:h}=I(p);return typeof h>"u"&&(h=c),{host:m,port:h}}function I(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=p.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const h=p.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:p,port:void 0}}}),define(ce[85],le([0,1,25,6,74]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=A,e.$sn=h,e.$tn=d,e.$un=w,e.$vn=f,e.$wn=g,e.$xn=v,n=Pe(n),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$on=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,k){if(typeof $>"u"||$===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof $=="string"||typeof k=="string"){const E=typeof $=="string"?$:$.value,t=typeof k=="string"?k:k.value;return n.$Ef(E,t)}return $._lower===k._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$pn=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const k of $)this.add(k)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$qn=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,k){this.c.set(p.toKey($),k)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=m;function h(b){return d(b)}function d(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const k=`onResolveRemoteAuthority:${(0,P.$gn)($)}`;return!!b.activationEvents?.includes(k)}return!1}function g(b){return b.map($=>{const[k,E]=$.split("@");return{proposalName:k,version:E?parseInt(E):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$yn=(0,r.$Di)("IBuiltinExtensionsScannerService")}),define(ce[126],le([0,1,3,10,85,6]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=I,e.$ep=p,e.$fp=c,e.$gp=m,e.$hp=h,e.$ip=d,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(t,u){switch(t){case n.Platform.Windows:return u==="x64"?P.TargetPlatform.WIN32_X64:u==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Linux:return u==="x64"?P.TargetPlatform.LINUX_X64:u==="arm64"?P.TargetPlatform.LINUX_ARM64:u==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?P.TargetPlatform.ALPINE_X64:u==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Mac:return u==="x64"?P.TargetPlatform.DARWIN_X64:u==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Web:return P.TargetPlatform.WEB}}function m(t,u){return u===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function h(t,u,i){return m(u,i)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===i}function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var g;(function(t){t.Install="install",t.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$jp=(0,A.$Di)("extensionGalleryService");var b;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$kp=$;var k;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));class E extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$lp=E,e.$mp=(0,A.$Di)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,A.$Di)("IGlobalExtensionEnablementService"),e.$qp=(0,A.$Di)("IExtensionTipsService"),e.$rp=(0,r.localize2)(11446,"Extensions"),e.$sp=(0,r.localize2)(11447,"Preferences")});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[209],le([0,1,18,81,10,210,85,172]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=m,e.$Yp=h,e.$Zp=d,e.$1p=w,e.$2p=f,e.$3p=g,e.$4p=v,e.$5p=b,r=Ve(r),P=Pe(P),A=Pe(A);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(E){return E=E.trim(),E==="*"||p.test(E)}function h(E){if(!m(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=E.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function d(E){if(!E)return null;const t=E.majorBase,u=E.majorMustEqual,i=E.minorBase;let o=E.minorMustEqual;const s=E.patchBase;let a=E.patchMustEqual;E.hasCaret&&(t===0||(o=!1),a=!1);let l=0;if(E.preRelease){const S=c.exec(E.preRelease);if(S){const[,y,D,L]=S;l=Date.UTC(Number(y),Number(D)-1,Number(L))}}return{majorBase:t,majorMustEqual:u,minorBase:i,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:E.hasGreaterEquals,notBefore:l}}function w(E,t,u){let i;typeof E=="string"?i=d(h(E)):i=E;let o;t instanceof Date?o=t.getTime():typeof t=="string"&&(o=new Date(t).getTime());let s;if(typeof u=="string"?s=d(h(u)):s=u,!i||!s)return!1;const a=i.majorBase,l=i.minorBase,S=i.patchBase;let y=s.majorBase,D=s.minorBase,L=s.patchBase;const R=s.notBefore;let O=s.majorMustEqual,M=s.minorMustEqual,x=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>D?!0:l<D||o&&o<R?!1:S>=L:(a===1&&y===0&&(!O||!M||!x)&&(y=1,D=0,L=0,O=!0,M=!1,x=!1),a<y?!1:a>y?!O:l<D?!1:l>D?!M:S<L?!1:S>L?!x:!(o&&o<R))}function f(E,t,u,i,o,s){const a=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return a.push([r.default.Error,P.localize(11377,null)]),a;if(typeof i.name!="string")return a.push([r.default.Error,P.localize(11378,null,"name")]),a;if(typeof i.version!="string")return a.push([r.default.Error,P.localize(11379,null,"version")]),a;if(!i.engines)return a.push([r.default.Error,P.localize(11380,null,"engines")]),a;if(typeof i.engines.vscode!="string")return a.push([r.default.Error,P.localize(11381,null,"engines.vscode")]),a;if(typeof i.extensionDependencies<"u"&&!k(i.extensionDependencies))return a.push([r.default.Error,P.localize(11382,null,"extensionDependencies")]),a;if(typeof i.activationEvents<"u"){if(!k(i.activationEvents))return a.push([r.default.Error,P.localize(11383,null,"activationEvents")]),a;if(typeof i.main>"u"&&typeof i.browser>"u")return a.push([r.default.Error,P.localize(11384,null,"activationEvents","main","browser")]),a}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&a.push([r.default.Warning,P.localize(11385,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return a.push([r.default.Error,P.localize(11386,null,"main")]),a;{const y=(0,n.$eh)(u,i.main);(0,n.$$g)(y,u)||a.push([r.default.Warning,P.localize(11387,null,y.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return a.push([r.default.Error,P.localize(11388,null,"browser")]),a;{const y=(0,n.$eh)(u,i.browser);(0,n.$$g)(y,u)||a.push([r.default.Warning,P.localize(11389,null,y.path,u.path)])}}if(!A.valid(i.version))return a.push([r.default.Error,P.localize(11390,null)]),a;const l=[];if(!g(E,t,i,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&i.enabledApiProposals?.length){const y=[];if(!b([...i.enabledApiProposals],y))for(const D of y)a.push([r.default.Error,D])}return a}function g(E,t,u,i,o){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:$(E,t,u.engines.vscode,o)}function v(E,t,u){return E==="*"||$(t,u,E)}function b(E,t){if(E.length===0)return!0;const u=Array.isArray(t)?t:void 0,i=(u?void 0:t)??I.allApiProposals,o=[],s=(0,T.$wn)(E);for(const{proposalName:a,version:l}of s){const S=i[a];S&&l&&S.version!==l&&o.push(P.localize(11391,null,a))}return u?.push(...o),o.length===0}function $(E,t,u,i=[]){const o=d(h(u));if(!o)return i.push(P.localize(11392,null,u)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return i.push(P.localize(11393,null,u)),!1}else if(!o.majorMustEqual)return i.push(P.localize(11394,null,u)),!1;return w(E,t,o)?!0:(i.push(P.localize(11395,null,E,u)),!1)}function k(E){if(!Array.isArray(E))return!1;for(let t=0,u=E.length;t<u;t++)if(typeof E[t]!="string")return!1;return!0}}),define(ce[211],le([0,1,2,6]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul=(0,r.$Di)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Rc)(()=>{const p=this.a[T]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,I,p,c){const m=this.b(T);if(!m)throw new Error(`No socket factory found for ${T}`);return m.connect(T,I,p,c)}}e.$Vl=P}),define(ce[212],le([0,1,26,27,48,121]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=I,n=Pe(n),r=Pe(r),P=Pe(P),A=Pe(A);let T;async function I(w=!1){return(T===void 0||w)&&(T=p()),T}async function p(){const w=c();if(w===void 0)return!1;if(w>=22e3){const f=h();if(f)return new Promise(g=>{P.execFile(f,["--status"],v=>g(!v))})}else{const f=d();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function m(w){const f=process.env.SystemRoot;if(f){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(f,g?"Sysnative":"System32",w)}}function h(){return m("wsl.exe")}function d(){return m("lxss\\LxssManager.dll")}}),define(ce[49],le([0,1,17,15,2,10,56,6,5,45]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=d,e.$9p=w,e.$0p=f,e.$$p=g,e.$_p=v,e.$aq=b,e.$6p=(0,I.$Di)("requestService");class m{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?t[u]="*****":t[u]=this.b[u];this.a=t}return this.a}}class h extends P.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,A.localize)(11164,null),when:p.$qk.isEqualTo((0,p.$nk)(p.LogLevel.Trace)).serialize()})}async c(t,u,i){const o=`${t} #${++this.b}: ${u.url}`;this.a.trace(`${o} - begin`,u.type,new m(u.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,u.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,u.type,(0,r.$9)(s)),s}}}e.$7p=h;function d(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function w(E){return E.res.statusCode===204}async function f(E){return w(E)?null:(await(0,n.$Ye)(E.stream)).toString()}async function g(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}async function v(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);if(w(E))return null;const u=(await(0,n.$Ye)(E.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function b(E){k(E)}let $;function k(E){const t=c.$po.as(T.$uo.Configuration),u=$;$={id:"http",order:15,title:(0,A.localize)(11165,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(11166,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(11167,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(11168,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(11169,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(11170,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(11171,null),(0,A.localize)(11172,null),(0,A.localize)(11173,null),(0,A.localize)(11174,null)],default:"override",description:(0,A.localize)(11175,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11176,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(11177,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:u?[u]:[]})}k(T.ConfigurationScope.APPLICATION)}),define(ce[213],le([0,1,17,22]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class P{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,c,m=r.CancellationToken.None){switch(p){case"request":return this.a.request(c[0],m).then(async({res:h,stream:d})=>{const w=await(0,n.$Ye)(d);return[{statusCode:h.statusCode,headers:h.headers},w]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$as=P;class A{constructor(I){this.a=I}async request(I,p){const[c,m]=await this.a.call("request",[I],p);return{res:c,stream:(0,n.$1e)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$bs=A}),define(ce[214],le([0,1,215,12]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=A;function P(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(T,I,p={}){const c=(0,n.parse)(T),m=p.proxyUrl||P(c,I);if(!m)return null;const h=(0,n.parse)(m);if(!/^https?:$/.test(h.protocol||""))return null;const d={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,r.$jg)(p.strictSSL)?p.strictSSL:!0};if(c.protocol==="http:"){const w=await new Promise((f,g)=>{V(["http-proxy-agent"],f,g)}).then(Pe);return new w.HttpProxyAgent(m,d)}else{const w=await new Promise((f,g)=>{V(["https-proxy-agent"],f,g)}).then(Pe);return new w.HttpsProxyAgent(m,d)}}}),define(ce[216],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=void 0,e.$Igc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Jgc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Kgc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[100],le([0,1,48,9,10,22,55,15,3,33,116,68,8,144]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=g;let f;async function g(b,$,k,E){return k["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Im)(E)&&!k["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Im)(E)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=d.Promises.withAsyncBody(async(t,u)=>{const i=new A.$ve;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Jm)(s,1,120)*1e3);const a=setTimeout(()=>{i.dispose(!0),u(new Error((0,P.localize)(11161,null)))},o);try{t(await v($,i.token))}catch(l){!(0,I.$3)(l)&&!i.token.isCancellationRequested?u(new Error((0,P.localize)(11162,null,(0,T.$oj)(l)))):t({})}finally{clearTimeout(a),i.dispose()}})),f)}async function v(b,$){const k=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",k);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",E);const t=(0,c.$Zg)().replace(/-/g,"").substr(0,12),u=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",i);const o=await(0,m.$ym)(p.OS,i);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$4);const l=(0,r.$mc)(o);let S,y;const D="";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${D} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):l==="xonsh"?(S=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(S=`'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),S);const L=(0,n.spawn)(o,[...y,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});$.onCancellationRequested(()=>(L.kill(),a(new I.$4))),L.on("error",M=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,T.$oj)(M)),a(M)});const R=[];L.stdout.on("data",M=>R.push(M));const O=[];L.stderr.on("data",M=>O.push(M)),L.on("close",(M,x)=>{const X=Buffer.concat(R).toString("utf8");b.trace("getUnixShellEnvironment#raw",X);const K=Buffer.concat(O).toString("utf8");if(K.trim()&&b.trace("getUnixShellEnvironment#stderr",K),M||x)return a(new Error((0,P.localize)(11163,null,M,x)));const fe=u.exec(X),H=fe?fe[1]:"{}";try{const J=JSON.parse(H);k?J.ELECTRON_RUN_AS_NODE=k:delete J.ELECTRON_RUN_AS_NODE,E?J.ELECTRON_NO_ATTACH_CONSOLE=E:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",J),s(J)}catch(J){b.error("getUnixShellEnvironment#errorCaught",(0,T.$oj)(J)),a(J)}})})}}),define(ce[217],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const A=await this.c();if(A){const T=String(n.a++);return this.b.set(T,A),{id:T,data:A.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,A){if(!P.id)return!0;const T=this.b.get(P.id);if(!T)return!1;this.b.delete(P.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$tcc=n}),define(ce[101],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl="signService",e.$Xl=(0,n.$Di)(e.$Wl)}),define(ce[218],le([0,1,217]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class r extends n.$tcc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(T=>new T.signer().sign(A))}h(){return new Promise((A,T)=>V(["vsda"],A,T))}}e.$Ahc=r}),define(ce[34],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=e.$vR=void 0,e.$vR=(0,n.$Di)("stateReadService"),e.$wR=(0,n.$Di)("stateService")}),define(ce[127],le([0,1,8,17,2,12,38,14,5]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=e.$yR=e.$xR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends P.$Tc{constructor(f,g,v,b){super(),this.h=f,this.j=g,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Bh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,g){const v=this.a[f];return(0,A.$mg)(v)?g:v}setItem(f,g){this.setItems([{key:f,data:g}])}setItems(f){let g=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,A.$mg)(b)?(0,A.$kg)(this.a[v])||(this.a[v]=void 0,g=!0):(this.a[v]=b,g=!0));g&&this.s()}removeItem(f){(0,A.$kg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Me.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(g){this.m.error(g)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$xR=m;let h=class extends P.$Tc{constructor(f,g,v,b){super(),this.a=this.B(new m(g.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,g){return this.a.getItem(f,g)}};e.$yR=h,e.$yR=h=Se([se(1,T.$Ki),se(2,p.$$j),se(3,I.$$k)],h);class d extends h{setItem(f,g){this.a.setItem(f,g)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$zR=d}),define(ce[128],le([0,1,3,36,33]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=T,e.$up=I;function A(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,c,m,h,d,w,f,g,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=g,$.sessionID=(0,P.$Zg)()+Date.now(),$.commitHash=h,$.version=d,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$cc,$["common.nodeArch"]=m,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let k=0;const E=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const t=A(c);return t&&($["common.platformDetail"]=t),$}function I(p){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return p.some(h=>m===h)}}),define(ce[24],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,n.$Di)("telemetryService"),e.$$l=(0,n.$Di)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var r;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var P;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ce[219],le([0,1,26,27,8,43,11,9,3,66,7,92,23,115,96,14,28,24]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Ws=k,e.$Xs=t,e.$Ys=u,n=Pe(n),r=Pe(r);const $=new Map;async function k(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const S=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,D=new Map,L=2e4;function R(M,x,X,K){const fe=x.substring(M.length+1);return P.Promises.withAsyncBody(async H=>{let J;K.readdirCount++;try{J=await d.Promises.readdir(x,{withFileTypes:!0})}catch{H();return}if(K.count>=L){K.count+=J.length,K.maxReached=!0,H();return}let U=J.length;if(U===0){H();return}let Z=J;K.count+J.length>L&&(K.maxReached=!0,U=L-K.count,Z=J.slice(0,U)),K.count+=J.length;for(const B of Z)if(B.isDirectory()){if(X.includes(B.name)||await R(M,(0,I.$ic)(x,B.name),X,K),--U===0){H();return}}else{const j=B.name.lastIndexOf(".");if(j>=0){const C=B.name.substring(j+1);C&&y.set(C,(y.get(C)??0)+1)}for(const C of S)C.relativePathPattern?.test(fe)!==!1&&C.filePattern.test(B.name)&&D.set(C.tag,(D.get(C.tag)??0)+1);if(--U===0){H();return}}})}const O=P.Promises.withAsyncBody(async M=>{const x={count:0,maxReached:!1,readdirCount:0},X=new c.$ee(!0);await R(o,o,s,x);const K=await u(o);M({configFiles:E(D),fileTypes:E(y),fileCount:x.count,maxFilesReached:x.maxReached,launchConfigFiles:K,totalScanTime:X.elapsed(),totalReaddirCount:x.readdirCount})});return $.set(a,O),O}function E(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function t(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/g.$Gl.GB).toFixed(2)}GB (${(r.freemem()/g.$Gl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Qn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function u(o){try{const s=new Map,a=(0,I.$ic)(o,".vscode","launch.json"),l=await n.promises.readFile(a),S=[],y=(0,A.$Wn)(l.toString(),S);if(S.length)return console.log(`Unable to parse ${a}`),[];if((0,A.$5n)(y)==="object"&&y.configurations)for(const D of y.configurations){const L=D.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return E(s)}catch{return[]}}let i=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/g.$Gl.GB).toFixed(2)}GB (${(r.freemem()/g.$Gl.GB).toFixed(2)}GB free)`),p.$j||a.push(`Load (avg):       ${r.loadavg().map(S=>Math.round(S)).join(", ")}`),a.push(`VM:               ${Math.round(h.$Qn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,w.$Vs)(s.mainPID),this.k(s)]).then(async l=>{let[S,y]=l,D=this.m(s,S);return a.forEach(L=>{if((0,f.$Sm)(L))D+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(D+=`

Remote: ${L.hostName}`,L.processes&&(D+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const R of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[R];let M=`${O.fileCount} files`;O.maxFilesReached&&(M=`more than ${M}`),y+=`|    Folder (${R}): ${M}`,y+=this.h(O)}}}),{processInfo:D,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:S,os:y,cpus:D}=t(),L={os:y,memory:l,cpus:D,vmHint:S,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return p.$j||(L.load=`${r.loadavg().map(R=>Math.round(R)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,w.$Vs)(s.mainPID).then(async S=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,S)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Sm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const D of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[D];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),l.push(`Folder (${D}): ${R}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let S=0;const y=(O,M)=>{const x=` ${O}(${M})`;S+x.length>60?(a.push(D),D="|                 ",S=D.length):S+=x.length,D+=x};let D="|      File types:";const L=10,R=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<R;O++){const M=s.fileTypes[O];y(M.name,M.count)}if(a.push(D),s.configFiles.length>=0&&(D="|      Conf files:",S=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),a.push(D)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(M=>{const x=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;O+=x}),a.push(O)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(S=>{S.folderURIs.length===0||S.remoteAuthority||(a.push(`|  Window (${S.title})`),S.folderURIs.forEach(y=>{const D=m.URI.revive(y);if(D.scheme===T.Schemas.file){const L=D.fsPath;l.push(k(L,["node_modules",".git"]).then(R=>{let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.$mc)(L)}): ${O}`),a.push(this.h(R))}).catch(R=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${R.toString()})`)}))}else a.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(S=>a.join(`
`)).catch(S=>`Unable to collect workspace stats: ${S}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:D})=>l.set(y,D));const S=[];return S.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,S,a,0),S.join(`
`)}n(s,a,l,S,y){const D=y===0;let L;D?L=S.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(S.pid)?L=a.get(S.pid):L=`${"  ".repeat(y)} ${S.name}`;const R=process.platform==="win32"?S.mem:r.totalmem()*(S.mem/100);l.push(`${S.load.toFixed(0).padStart(5," ")}	${(R/g.$Gl.MB).toFixed(0).padStart(6," ")}	${S.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(S.children)&&S.children.forEach(O=>this.n(s,a,l,O,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const S=m.URI.revive(l);if(S.scheme!==T.Schemas.file)continue;const y=S.fsPath;try{(await k(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=m.URI.revive(a);if(l.scheme!==T.Schemas.file)continue;const S=l.fsPath;try{const y=await k(S,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$Zs=i,e.$Zs=i=Se([se(0,b.$0l),se(1,v.$rk)],i)}),define(ce[220],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class n{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:I,data:p}){return this.b.forEach(c=>c.log(I,p)),Promise.resolve(null)}}e.$Ngc=n;class r{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Ogc=r}),define(ce[57],le([0,1,37,12,74,128,24]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=m,e.$Dp=h,e.$Ep=d,e.$Fp=w,e.$Gp=g,e.$Hp=b,e.$Ip=$,e.$Jp=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$vp=I;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=p,e.$xp=new p;class c{async publicLog(i,o,s){}async publicLogError(i,o,s){}}e.$yp=c,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function h(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(T.$gm),o=u.getValue(T.$hm);if(u.getValue(T.$im)===!1||o===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function w(u){const i={},o={},s={};v(u,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),i[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[a]=l)}return{properties:i,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(u){if(!u)return"none";const i=(0,P.$gn)(u);return f.has(i)?i:"other"}function v(u,i,o=0,s){if(u)for(const a of Object.getOwnPropertyNames(u)){const l=u[a],S=s?s+a:a;Array.isArray(l)?i[S]=(0,n.$ho)(l):l instanceof Date?i[S]=l.toISOString():(0,r.$fg)(l)?o<2?v(l,i,o+1,S+"."):i[S]=(0,n.$ho)(l):i[S]=l}}function b(u,i){const o=u.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,A.$up)(o)||s}function $(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function k(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const s=[];for(const y of i)for(;;){const D=y.exec(u);if(!D)break;s.push([D.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(o="";;){const y=l.exec(u);if(!y)break;const D=s.some(([L,R])=>y.index<R&&L<l.lastIndex);!a.test(y[0])&&!D&&(o+=u.substring(S,y.index)+"<REDACTED: user-file-path>",S=l.lastIndex)}return S<u.length&&(o+=u.substr(S)),o}function E(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of i)if(o.regex.test(u))return`<REDACTED: ${o.label}>`;return u}function t(u,i){return(0,n.$eo)(u,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=k(s,i);for(const a of i)s=s.replace(a,"");return s=E(s),s}})}}),define(ce[129],le([0,1,25,126,85,3,7,15,36,57]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=m,e.$Mp=f,e.$Np=g,e.$Op=v,e.$Pp=b,e.$Qp=$,e.$Rp=k,e.$Sp=E,e.$Up=t,e.$Vp=i;function m(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$zf)(o.id,s.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,a,l)}static parse(s){const a=h.exec(s);return a&&a[1]&&a[2]?new d({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=P.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?m(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Lp=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function g(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(g(o??P.$ln,s))}function $(o,s){const a=[],l=S=>{for(const y of a)if(y.some(D=>m(s(D),s(S))))return y;return null};for(const S of o){const y=l(S);y?y.push(S):a.push([S])}return a}function k(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function E(o){return{id:new c.$vp(o.identifier.id),name:new c.$vp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Tp=new P.$pn("pprice.better-merge");function t(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&a.every(y=>!m(y.identifier,{id:S}))){const y=o.filter(D=>m(D.identifier,{id:S}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function u(o,s){if(!A.$l)return!1;let a;try{a=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,I.$9)(S))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const a=await u(o,s),l=(0,r.$fp)(a?"alpine":A.$v,p.$dc);return s.debug("ComputeTargetPlatform:",l),l}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[221],le([0,1,2,37,3,25,10,16,56,72,28,45,24,57]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,c=Ve(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,k){this.k=$,this.l=k,this.d={},this.i=new n.$Sc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,A.$gf)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$gf)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(d.$gm)||E.affectsConfiguration(d.$im)||E.affectsConfiguration(d.$hm))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Ep)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const k=$.usage?d.TelemetryLevel.USAGE:$.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;b=Math.min(b,k)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,k){this.g<$||(k=(0,r.$fo)(k,this.d),k=(0,w.$Jp)(k,this.j),k=(0,r.$fo)(k,this.c),this.b.forEach(E=>E.log(b,k)))}publicLog(b,$){this.n(b,d.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,d.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$fs=f,e.$fs=f=Se([se(1,I.$0i),se(2,m.$rk)],f);function g(){const v=(0,T.localize)(11142,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,T.localize)(11144,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(11143,null,"https://aka.ms/vscode-telemetry"),$=P.$p?"":(0,T.localize)(11145,null),k=(0,T.localize)(11146,null),E=(0,T.localize)(11147,null),t=(0,T.localize)(11148,null),u=(0,T.localize)(11149,null),i=`
|       | ${k} | ${E} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11150,null);return`
${v} ${b} ${$}

&nbsp;

${u}
${i}

&nbsp;

${o}
`}h.$po.as(p.$uo.Configuration).registerConfiguration({id:d.$fm,order:1,type:"object",title:(0,T.localize)(11151,null),properties:{[d.$gm]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11152,null),(0,T.localize)(11153,null),(0,T.localize)(11154,null),(0,T.localize)(11155,null)],markdownDescription:g(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$po.as(p.$uo.Configuration).registerConfiguration({id:d.$fm,order:110,type:"object",title:(0,T.localize)(11156,null),properties:{[d.$im]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(11158,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(11157,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11159,null,`\`#${d.$gm}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[222],le([0,1,3,92,24]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=A,e.$ehc=T,e.$fhc=I;async function A(p,c){let m=p.getItem(P.$cm);return(typeof m!="string"||n.$k&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Rn)(c.error.bind(c))),m}async function T(p,c){let m=p.getItem(P.$dm);return typeof m!="string"&&(m=await(0,r.$Sn)(c.error.bind(c))),m}async function I(p,c){let m=p.getItem(P.$em);return typeof m!="string"&&(m=await(0,r.$Tn)(c.error.bind(c))),m}}),define(ce[223],le([0,1,24,222]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=P,e.$hhc=A,e.$ihc=T;async function P(I,p){const c=await(0,r.$dhc)(I,p);return I.setItem(n.$cm,c),c}async function A(I,p){const c=await(0,r.$ehc)(I,p);return I.setItem(n.$dm,c),c}async function T(I,p){const c=await(0,r.$fhc)(I,p);return I.setItem(n.$em,c),c}}),define(ce[130],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ce[224],le([0,1,3,130]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;const P=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((h,d)=>{this.d(h,d);const w=h.map.entries();let f=w.next();for(;!f.done;){const g=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:d,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(m,h,d){let w;n.$j&&(w={},Object.keys(m).forEach(f=>w[f.toLowerCase()]=f));for(const[f,g]of this.getVariableMap(h)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of g){const $=d?await d(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:m[v]=(m[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:m[v]=$+(m[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const k=`VSCODE_ENV_${P.get(b.type)}`;m[k]=(m[k]?m[k]+":":"")+f+"="+this.c($)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,h){const d=new Map,w=new Map,f=new Map;if(m.getVariableMap(h).forEach((g,v)=>{const b=this.getVariableMap(h).get(v),$=I(g,b);$&&d.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=I(g,b);$&&f.set(v,$)}),this.getVariableMap(h).forEach((g,v)=>{const b=m.getVariableMap(h).get(v),$=p(g,b);$&&w.set(v,$)}),!(d.size===0&&w.size===0&&f.size===0))return{added:d,changed:w,removed:f}}getVariableMap(m){const h=new Map;for(const d of this.a.values()){const w=d.filter(f=>T(f,m));w.length>0&&h.set(w[0].variable,w)}return h}getDescriptionMap(m){const h=new Map;for(const d of this.b.values()){const w=d.filter(f=>T(f,m,!0));for(const f of w)h.set(f.extensionIdentifier,f.description)}return h}d(m,h){if(!m.descriptionMap)return;const d=m.descriptionMap.entries();let w=d.next();for(;!w.done;){const f=w.value[1],g=w.value[0];let v=this.b.get(g);v||(v=[],this.b.set(g,v));const b={extensionIdentifier:h,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=d.next()}}}e.$Js=A;function T(c,m,h=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):h?m===c.scope:!0}function I(c,m){if(!m)return c;const h=new Set;m.forEach(w=>h.add(w.extensionIdentifier));const d=[];return c.forEach(w=>{h.has(w.extensionIdentifier)||d.push(w)}),d.length===0?void 0:d}function p(c,m){if(!m)return;const h=new Map;m.forEach(w=>h.set(w.extensionIdentifier,w));const d=[];return c.forEach(w=>{const f=h.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&d.push(f)}),d.length===0?void 0:d}}),define(ce[225],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=n,e.$Es=r,e.$Fs=P,e.$Gs=A,e.$Hs=T,e.$Is=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function A(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(p){return new Map(p.map(c=>[c[0],{map:P(c[1]),descriptionMap:A(c[2])}]))}}),define(ce[226],le([0,1,8,22,4,2,5]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;let I=class extends A.$Tc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$ke),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,A.$Rc)(()=>{for(const h of this.f.values())(0,A.$Oc)(h)}))}createRequest(c){return new Promise((m,h)=>{const d=++this.a;this.c.set(d,m),this.g.fire({requestId:d,...c});const w=new r.$ve;(0,n.$Eh)(this.b,w.token).then(()=>h(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,A.$Rc)(()=>w.cancel())])})}acceptReply(c,m){const h=this.c.get(c);h?(this.c.delete(c),(0,A.$Oc)(this.f.get(c)||[]),this.f.delete(c),h(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$us=I,e.$us=I=Se([se(1,T.$$j)],I)}),define(ce[75],le([0,1,6,122,45]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new r.$Uj("terminalTabFocusMode",!1,!0);var A;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var h;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$ns=(0,n.$Di)("ptyService");var d;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var g;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var v;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var k;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(u){const i=this.b(u.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,u)}getTerminalBackend(u){return this.a.get(this.b(u))}b(u){return u?.toLowerCase()??""}}P.$po.add(e.$os.Backend,new E),e.$ps=(0,n.$Di)("localPtyService"),e.$qs=(0,n.$Di)("terminalLogService")}),define(ce[227],le([0,1,80,7,10,110]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=T,e.$ws=c,e.$xs=m,e.$ys=h;function T(d,w){const f=[{name:null,description:(0,P.localize)(11109,null)}];return f.push(...d.map(g=>({name:g.profileName,description:I(g)}))),w&&f.push(...w.map(g=>({name:g.title,description:p(g)}))),{values:f.map(g=>g.name),markdownDescriptions:f.map(g=>g.description)}}function I(d){let w=`$(${A.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$3j.terminal.id}) ${d.profileName}
- path: ${d.path}`;return d.args&&(typeof d.args=="string"?w+=`
- args: "${d.args}"`:w+=`
- args: [${d.args.length===0?"":`'${d.args.join("','")}'`}]`),d.overrideName!==void 0&&(w+=`
- overrideName: ${d.overrideName}`),d.color&&(w+=`
- color: ${d.color}`),d.env&&(w+=`
- env: ${JSON.stringify(d.env)}`),w}function p(d){return`$(${A.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$3j.terminal.id}) ${d.title}
- extensionIdentifier: ${d.extensionIdentifier}`}function c(d,w){if(!d&&!w)return!0;if(typeof d=="string"&&typeof w=="string")return d===w;if(Array.isArray(d)&&Array.isArray(w)){if(d.length!==w.length)return!1;for(let f=0;f<d.length;f++)if(d[f]!==w[f])return!1;return!0}return!1}function m(d,w){if(!d&&!w)return!0;if(!d||!w)return!1;if(A.ThemeIcon.isThemeIcon(d)&&A.ThemeIcon.isThemeIcon(w))return d.id===w.id&&d.color===w.color;if(typeof d=="object"&&"light"in d&&"dark"in d&&typeof w=="object"&&"light"in w&&"dark"in w){const f=d,g=w;if((r.URI.isUri(f.light)||h(f.light))&&(r.URI.isUri(f.dark)||h(f.dark))&&(r.URI.isUri(g.light)||h(g.light))&&(r.URI.isUri(g.dark)||h(g.dark)))return f.light.path===g.light.path&&f.dark.path===g.dark.path}if(r.URI.isUri(d)&&r.URI.isUri(w)||h(d)||h(w)){const f=d,g=w;return f.path===g.path&&f.scheme===g.scheme}return!1}function h(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(ce[228],le([0,1,80,3,10,56,45,75,227]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=void 0,e.$Bs=f,e.$Cs=v,e.$zs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$As={type:"string",enum:Array.from((0,n.$1j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$1j)(),b=>`$(${b.id})`)};const c={args:{description:(0,P.localize)(11110,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(11111,null),type:"boolean"},icon:{description:(0,P.localize)(11112,null),...e.$As},color:{description:(0,P.localize)(11113,null),...e.$zs},env:{markdownDescription:(0,P.localize)(11114,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11115,null),type:["string","array"],items:{type:"string"}},...c}},h={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11116,null),type:["string"],items:{type:"string"}},...c}};function d(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,P.localize)(11117,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,P.localize)(11118,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11119,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11120,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11121,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:d(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(11122,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11123,null),type:"string"},id:{description:(0,P.localize)(11124,null),type:"string"},title:{description:(0,P.localize)(11125,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:d(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11126,null),type:"string"},id:{description:(0,P.localize)(11127,null),type:"string"},title:{description:(0,P.localize)(11128,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:d(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11129,null),type:"string"},id:{description:(0,P.localize)(11130,null),type:"string"},title:{description:(0,P.localize)(11131,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,P.localize)(11132,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:A.ConfigurationScope.APPLICATION,description:(0,P.localize)(11133,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:A.ConfigurationScope.APPLICATION,markdownDescription:(0,P.localize)(11134,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:A.ConfigurationScope.APPLICATION,description:(0,P.localize)(11135,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,P.localize)(11136,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$po.as(A.$uo.Configuration).registerConfiguration(w),v()}let g;function v(b,$){const k=T.$po.as(A.$uo.Configuration);let E;b&&(E=(0,p.$vs)(b?.profiles,$));const t=g;g={id:"terminal",order:100,title:(0,P.localize)(11137,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11138,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11139,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11140,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?E?.markdownDescriptions:void 0}}},k.updateConfigurations({add:[g],remove:t?[t]:[]})}}),define(ce[229],le([0,1,27,11,37,9,3,36,25,12,23,130,225,224]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=f,e.$Ls=g,e.$Ms=v,n=Pe(n),A=Pe(A),I=Pe(I),m=Pe(m);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return l&&l.length===4&&(S=parseInt(l[3])),S}async function g(l,S,y,D=I.env,L=m.Promises.exists){if(A.$hc(l))return await L(l)?l:void 0;if(S===void 0&&(S=I.cwd()),A.$lc(l)!=="."){const x=A.$ic(S,l);return await L(x)?x:void 0}const O=(0,P.$jo)(D,"PATH");if(y===void 0&&(0,c.$dg)(O)&&(y=O.split(A.$sc)),y===void 0||y.length===0){const x=A.$ic(S,l);return await L(x)?x:void 0}for(const x of y){let X;if(A.$hc(x)?X=A.$ic(x,l):X=A.$ic(S,x,l),await L(X))return X;if(T.$j){let K=X+".com";if(await L(K)||(K=X+".exe",await L(K)))return K}}const M=A.$ic(S,l);return await L(M)?M:void 0}function v(l,S,y,D,L){const R=T.$j&&(!S.windowsEnableConpty||f()<18309);if(!S.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||R)return;const O=l.args,M=I.$cc==="win32"?A.$mc(l.executable).toLowerCase():A.$mc(l.executable),x=A.$lc(r.$Xg.asFileUri("").fsPath);let X;const K={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(K.VSCODE_NONCE=S.shellIntegration.nonce),T.$j){if(M==="pwsh.exe"||M==="powershell.exe")return!O||s(O)?X=k.get($.WindowsPwsh):o(O)&&(X=k.get($.WindowsPwshLogin)),X?(X=[...X],X[X.length-1]=(0,p.$cf)(X[X.length-1],x,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),{newArgs:X,envMixin:K}):void 0;if(M==="bash.exe")return!O||O.length===0?X=k.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(S,K),X=k.get($.Bash)),X?(X=[...X],X[X.length-1]=(0,p.$cf)(X[X.length-1],x),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:X,envMixin:K}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(M){case"bash":return!O||O.length===0?X=k.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(S,K),X=k.get($.Bash)),X?(X=[...X],X[X.length-1]=(0,p.$cf)(X[X.length-1],x),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:X,envMixin:K}):void 0;case"fish":{const fe=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",H=A.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return K.XDG_DATA_DIRS=`${fe}:${H}`,b(S,K),{newArgs:void 0,envMixin:K}}case"pwsh":return!O||s(O)?X=k.get($.Pwsh):o(O)&&(X=k.get($.PwshLogin)),X?(S.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),X=[...X],X[X.length-1]=(0,p.$cf)(X[X.length-1],x,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:X,envMixin:K}):void 0;case"zsh":{if(!O||O.length===0?X=k.get($.Zsh):a(O)?(X=k.get($.ZshLogin),b(S,K)):(O===k.get($.Zsh)||O===k.get($.ZshLogin))&&(X=O),!X)return;X=[...X],X[X.length-1]=(0,p.$cf)(X[X.length-1],x);let fe;try{fe=n.userInfo().username}catch{fe="unknown"}const H=A.$ic(n.tmpdir(),`${fe}-${L.applicationName}-zsh`);K.ZDOTDIR=H;const J=y?.ZDOTDIR??n.homedir()??"~";K.USER_ZDOTDIR=J;const U=[];return U.push({source:A.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$ic(H,".zshrc")}),U.push({source:A.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$ic(H,".zprofile")}),U.push({source:A.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$ic(H,".zshenv")}),U.push({source:A.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$ic(H,".zlogin")}),{newArgs:X,envMixin:K,filesToCopy:U}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,S){if(T.$k&&l.environmentVariableCollections){const y=(0,d.$Is)(l.environmentVariableCollections),L=new w.$Js(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),R=[];if(L)for(const O of L)O.type===h.EnvironmentVariableMutatorType.Prepend&&R.push(O.value);R.length>0&&(S.VSCODE_PATH_PREFIX=R.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const k=new Map;k.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),k.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),k.set($.Zsh,["-i"]),k.set($.ZshLogin,["-il"]),k.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],t=["--login","-l"],u=["-i","--interactive"],i=["-nol","-nologo"];function o(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(S=>!u.includes(S.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(ce[230],le([0,1,26,48,80,9,3,12,23,114,75,229,121]),function(V,e,n,r,P,A,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=v,n=Pe(n),r=Pe(r),p=Pe(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,g=!0;function v(y,D,L,R,O=process.env,M,x,X,K){return M=M||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?b(L,M,O,x,R.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:R.getValue(m.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:R.getValue(m.TerminalSettingId.DefaultProfileWindows),K,X):a(M,x,L,y&&typeof y=="object"?{...y}:R.getValue(T.$l?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:R.getValue(T.$l?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),K,X,O)}async function b(y,D,L,R,O,M,x,X,K){const fe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),H=`${process.env.windir}\\${fe?"Sysnative":"System32"}`;let J=!1;(0,h.$Ks)()>=16299&&(J=!0),await t(X);const U=new Map;if(y){U.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:P.$3j.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${H}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.$3j.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),U.set("Command Prompt",{path:`${H}\\cmd.exe`,icon:P.$3j.terminalCmd,isAutoDetected:!0}),U.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),U.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:P.$3j.terminalBash,isAutoDetected:!0});const B=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;U.set("Cmder",{path:`${H}\\cmd.exe`,args:["/K",B],requiresPath:process.env.CMDER_ROOT?B:{path:B,isUnsafe:!0},isAutoDetected:!0})}l(M,U);const Z=await $(U.entries(),x,D,L,R,K);if(y&&O)try{const B=await o(`${H}\\${J?"wsl":"bash"}.exe`,x);for(const j of B)(!M||!(j.profileName in M))&&Z.push(j)}catch{g&&(R?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return Z}async function $(y,D,L,R=process.env,O,M){const x=[];for(const[X,K]of y)x.push(k(X,K,D,L,R,O,M));return(await Promise.all(x)).filter(X=>!!X)}async function k(y,D,L,R,O=process.env,M,x){if(D===null)return;let X,K,fe;if("source"in D&&!("path"in D)){const Z=f?.get(D.source);if(!Z)return;X=Z.paths,K=D.args||Z.args,D.icon?fe=E(D.icon):Z.icon&&(fe=Z.icon)}else X=Array.isArray(D.path)?D.path:[D.path],K=T.$j||Array.isArray(D.args)?D.args:void 0,fe=E(D.icon);let H;if(x){const Z=X.map(j=>typeof j=="string"?j:j.path),B=await x(Z);H=new Array(X.length);for(let j=0;j<X.length;j++)typeof X[j]=="string"?H[j]=B[j]:H[j]={path:B[j],isUnsafe:!0}}else H=X.slice();let J;if(D.requiresPath){let Z;if((0,I.$dg)(D.requiresPath)?Z=D.requiresPath:(Z=D.requiresPath.path,D.requiresPath.isUnsafe&&(J=Z)),!await R.existsFile(Z))return}const U=await S(y,L,H,R,O,K,D.env,D.overrideName,D.isAutoDetected,J);if(!U){M?.debug("Terminal profile not validated",y,X);return}return U.isAutoDetected=D.isAutoDetected,U.icon=fe,U.color=D.color,U}function E(y){return typeof y=="string"?{id:y}:y}async function t(y){if(f&&!y)return;const[D,L]=await Promise.all([u(),y||i()]);f=new Map,f.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),f.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:P.$3j.terminalPowershell})}async function u(){const y=new Set,D=await(0,h.$Ls)("git.exe");if(D){const O=(0,d.dirname)(D);y.add((0,d.resolve)(O,"../.."))}function L(O,M){M&&O.add(M)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const R=[];for(const O of y)R.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function i(){const y=[];for await(const D of(0,c.$um)())y.push(D.exePath);return y}async function o(y,D){const L=[],R=await new Promise((x,X)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(K,fe)=>{if(K)return X("Problem occurred when getting wsl distros");x(fe)})});if(!R)return[];const O=new RegExp(/[\r?\n]/),M=R.split(O).filter(x=>x.trim().length>0&&x!=="");for(const x of M){if(x===""||x.startsWith("docker-desktop"))continue;const X=`${x} (WSL)`,K={profileName:X,path:y,args:["-d",`${x}`],isDefault:X===D,icon:s(x),isAutoDetected:!1};L.push(K)}return L}function s(y){return y.includes("Ubuntu")?P.$3j.terminalUbuntu:y.includes("Debian")?P.$3j.terminalDebian:P.$3j.terminalLinux}async function a(y,D,L,R,O,M,x,X){const K=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const fe=(await y.readFile(w.UnixShellsPath)).toString(),H=(M||fe.split(`
`)).map(U=>{const Z=U.indexOf("#");return Z===-1?U:U.substring(0,Z)}).filter(U=>U.trim().length>0),J=new Map;for(const U of H){let Z=(0,A.$mc)(U),B=J.get(Z)||0;B++,B>1&&(Z=`${Z} (${B})`),J.set(Z,B),K.set(Z,{path:U,isAutoDetected:!0})}}return l(R,K),await $(K.entries(),O,y,X,D,x)}function l(y,D){if(y)for(const[L,R]of Object.entries(y))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?D.delete(L):(R.icon=R.icon||D.get(L)?.icon,D.set(L,R))}async function S(y,D,L,R,O,M,x,X,K,fe){if(L.length===0)return Promise.resolve(void 0);const H=L.shift();if(H==="")return S(y,D,L,R,O,M,x,X,K);const J=typeof H!="string"&&H.isUnsafe,U=typeof H=="string"?H:H.path,Z={profileName:y,path:U,args:M,env:x,overrideName:X,isAutoDetected:K,isDefault:y===D,isUnsafePath:J,requiresUnsafePath:fe};if((0,A.$mc)(U)===U){const j=O.PATH?O.PATH.split(A.$sc):void 0,C=await(0,h.$Ls)(U,void 0,j,void 0,R.existsFile);return C?(Z.path=C,Z.isFromPath=!0,Z):S(y,D,L,R,O,M)}return await R.existsFile((0,A.$gc)(U))?Z:S(y,D,L,R,O,M,x,X,K)}}),define(ce[231],le([0,1,4,2,3,44,16,5,193,100,226,75,228,230,116,66]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(k,E,t,u){super(),this.M=k,this.N=E,this.O=t,this.P=u,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ke),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ke),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ke),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ke),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ke),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ke),this.onProcessData=this.D.event,this.F=this.B(new n.$ke),this.onProcessReady=this.F.event,this.G=this.B(new n.$ke),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ke),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ke),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ke),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ke),this.onProcessExit=this.L.event,(0,d.$Bs)(),this.B(this.M),this.B((0,r.$Rc)(()=>this.W())),this.j=this.B(new m.$us(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(h.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$j)return process.env;try{return await(0,c.$Pm)(this.N,this.O,{_:[]},process.env)}catch(k){return this.O.error("ptyHost was unable to resolve shell environment",k),{}}}U(){const k=this.M.start(),E=k.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(E.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(k.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const u=A.ProxyChannel.toService(E.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(u.onProcessData(i=>this.D.fire(i))),this.B(u.onProcessReady(i=>this.F.fire(i))),this.B(u.onProcessExit(i=>this.L.fire(i))),this.B(u.onDidChangeProperty(i=>this.J.fire(i))),this.B(u.onProcessReplay(i=>this.G.fire(i))),this.B(u.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(u.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$ts(this.P,E.getChannel(h.TerminalIpcChannels.Logger))),this.a=k,this.b=u,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(h.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[k,u]}async createProcess(k,E,t,u,i,o,s,a,l,S,y){const D=setTimeout(()=>this.$(),h.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(k,E,t,u,i,o,s,a,l,S,y);return clearTimeout(D),L}updateTitle(k,E,t){return this.f.updateTitle(k,E,t)}updateIcon(k,E,t,u){return this.f.updateIcon(k,E,t,u)}attachToProcess(k){return this.f.attachToProcess(k)}detachFromProcess(k,E){return this.f.detachFromProcess(k,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(k){return this.f.start(k)}shutdown(k,E){return this.f.shutdown(k,E)}input(k,E){return this.f.input(k,E)}processBinary(k,E){return this.f.processBinary(k,E)}resize(k,E,t){return this.f.resize(k,E,t)}clearBuffer(k){return this.f.clearBuffer(k)}acknowledgeDataEvent(k,E){return this.f.acknowledgeDataEvent(k,E)}setUnicodeVersion(k,E){return this.f.setUnicodeVersion(k,E)}getInitialCwd(k){return this.f.getInitialCwd(k)}getCwd(k){return this.f.getCwd(k)}async getLatency(){const k=new g.$ee,E=await this.f.getLatency();return k.stop(),[{label:"ptyhostservice<->ptyhost",latency:k.elapsed()},...E]}orphanQuestionReply(k){return this.f.orphanQuestionReply(k)}installAutoReply(k,E){return this.f.installAutoReply(k,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(k){return this.f.uninstallAutoReply(k)}getDefaultSystemShell(k){return this.g?.getDefaultSystemShell(k)??(0,f.$ym)(k??P.OS,process.env)}async getProfiles(k,E,t,u=!1){const i=await this.S();return(0,w.$Ns)(E,t,u,this.N,i,void 0,this.O,this.bb.bind(this,k))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(k,E){return this.f.getWslPath(k,E)}getRevivedPtyNewId(k,E){return this.f.getRevivedPtyNewId(k,E)}setTerminalLayoutInfo(k){return this.f.setTerminalLayoutInfo(k)}async getTerminalLayoutInfo(k){return this.g?.getTerminalLayoutInfo(k)}async requestDetachInstance(k,E){return this.f.requestDetachInstance(k,E)}async acceptDetachInstanceReply(k,E){return this.f.acceptDetachInstanceReply(k,E)}async freePortKillProcess(k){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(k)}async serializeTerminalState(k){return this.f.serializeTerminalState(k)}async reviveTerminalProcesses(k,E,t){return this.f.reviveTerminalProcesses(k,E,t)}async refreshProperty(k,E){return this.f.refreshProperty(k,E)}async updateProperty(k,E,t){return this.f.updateProperty(k,E,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(k){this.ab(),this.s=setTimeout(()=>this.Y(),k?h.HeartbeatConstants.ConnectingBeatInterval:h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(k,E){return this.j.createRequest({workspaceId:k,originalText:E})}async acceptPtyHostResolvedVariables(k,E){this.j.acceptReply(k,E)}};e.$Os=b,e.$Os=b=Se([se(1,T.$0i),se(2,I.$$j),se(3,I.$_j)],b)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[76],le([0,1,13,4,2,3,16,6,34]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0,n=Ve(n);const c="#FFFFFF",m="#1E1E1E",h="#000000",d="#FFFFFF",w="theme",f="themeBackground",g="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Bfc=(0,I.$Di)("themeMainService");let b=class extends P.$Tc{constructor(k,E){super(),this.b=k,this.c=E,this.a=this.B(new r.$ke),this.onDidChangeColorScheme=this.a.event,A.$l||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(v.SYSTEM_COLOR_THEME)||t.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(A.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.$j){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.$k){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.$l&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const k=this.getColorScheme();if(k.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return k.dark?h:d;let E=this.b.getItem(f,null);if(!E)switch(this.g()){case"vs":E=c;break;case"hc-black":E=h;break;case"hc-light":E=d;break;default:E=m}return A.$k&&E.toUpperCase()===m&&(E="#171717"),E}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(k,E){this.b.setItems([{key:w,data:E.baseTheme},{key:f,data:E.colorInfo.background},{key:g,data:E}]),typeof k=="number"&&this.h(k,E),this.f()}h(k,E){for(const t of n.default.BrowserWindow.getAllWindows())if(t.id===k){t.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};e.$Cfc=b,e.$Cfc=b=Se([se(0,p.$wR),se(1,T.$0i)],b)}),define(ce[131],le([0,1,4,2,3,7,16,6,5]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Jw=e.$Hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dw=e.$Cw=void 0,e.$Ew=h,e.$Fw=w,e.$Gw=f,e.$Iw=g,e.$Kw=v,e.$Lw=b,e.$Cw=(0,I.$Di)("tunnelService"),e.$Dw=(0,I.$Di)("sharedTunnelsService");var c;(function(E){E.Http="http",E.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(m||(e.TunnelPrivacyId=m={}));function h(E){return!!E.forwardPort}var d;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function w(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(t)return{address:t[1],port:+t[2]}}function f(E){if(E.scheme!=="http"&&E.scheme!=="https"||!E.query)return;const t=E.query.split("&");for(const u of t){const i=u.split("=")[1];if(/^https?:/.exec(i)){const o=w(A.URI.parse(i));if(o)return o}}}e.$Hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(E){return e.$Hw.indexOf(E)>=0}e.$Jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(E){return e.$Jw.indexOf(E)>=0}function b(E,t,u,i){if(u===P.OperatingSystem.Windows)return!1;if(u===P.OperatingSystem.Macintosh&&v(t)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(o?.length===4&&parseInt(o[1])>=18)return!1}return E<1024}class ${constructor(t,u,i){this.remoteAddress=t,this.localAddress=u,this.b=i,this.a=new n.$ke,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mw=$;let k=class extends r.$Tc{constructor(t,u){super(),this.r=t,this.s=u,this.a=new n.$ke,this.onTunnelOpened=this.a.event,this.b=new n.$ke,this.onTunnelClosed=this.b.event,this.c=new n.$ke,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],u=Array.from(this.f.values());for(const i of u){const o=Array.from(i.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:u}of t.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,u,i,o,s){this.z(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:i,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(v(t)||g(t))&&(t=e.$Hw[0]);const i=this.D(t,u);if(i)return++i.refcount,i.value}openTunnel(t,u,i,o,s,a=!1,l,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(u||(u="localhost"),o||(o=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(y,u,i,o,s,a,l,S);return D?D.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const R=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(R),R}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.f.get(t.tunnelRemoteHost);if(u){const i=u.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const o=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(u),o}}async closeTunnel(t,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const i=this.f.get(t);if(i&&i.has(u)){const o=i.get(u);o.refcount=0,await this.y(t,u,o)}}z(t,u,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(u,{refcount:1,value:i})}async C(t,u){const i=this.f.get(t);if(i){const o=i.get(u),s=o?await o.value:void 0;(!s||typeof s=="string")&&i.delete(u),i.size===0&&this.f.delete(t)}}D(t,u){const i=[t];g(t)?(i.push(...e.$Hw),i.push(...e.$Jw)):v(t)&&i.push(...e.$Jw);const o=i.map(s=>this.f.get(s));for(const s of o){const a=s?.get(u);if(a)return a}}canTunnel(t){return!!w(t)}G(t,u,i,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${o}.`);const S=i;this.n.add(S);const y=o===void 0?i:o,D={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:u,port:i},localAddressPort:o,privacy:a,public:a?a!==m.Private:void 0,protocol:l},R=t.forwardPort(L,D);return R?(this.z(u,i,R),R.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),R}};e.$Nw=k,e.$Nw=k=Se([se(0,p.$$j),se(1,T.$0i)],k)}),define(ce[50],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PY=e.$OY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var P;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var A;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.$OY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$PY=(0,n.$Di)("updateService")}),define(ce[232],le([0,1,3,10,56,45]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.$po.as(P.$uo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(11023,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11024,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(11025,null),(0,r.localize)(11026,null),(0,r.localize)(11027,null),(0,r.localize)(11028,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11029,null),deprecationMessage:(0,r.localize)(11030,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,title:(0,r.localize)(11031,null),description:(0,r.localize)(11032,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(11033,null),tags:["usesOnlineServices"]}}})}),define(ce[233],le([0,1,4,50]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class P{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${p}`)}}e.$Pgc=P;class A{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$ke,this.onStateChange=this.a.event,this.b=r.$OY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$Qgc=A}),define(ce[41],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,n.$Di)("IUriIdentityService")}),define(ce[234],le([0,1,41,173,14,18,145,4,2]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(d){this.g=d,this.c=new p.$Sc,this.f=2**16;const w=new Map,f=g=>{let v=w.get(g.scheme);return v===void 0&&(v=d.hasProvider(g)&&!this.g.hasCapability(g,P.FileSystemProviderCapabilities.PathCaseSensitive),w.set(g.scheme,v)),v};this.c.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new A.$6g(f),this.d=new T.$Rs((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$fh)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((f,g)=>f[1].time<g[1].time?1:f[1].time>g[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(d[f][0],d[f][1].touch())}};e.$Ss=m,e.$Ss=m=Se([se(0,P.$$k)],m),(0,r.$Ps)(n.$Il,m,r.InstantiationType.Delayed)}),define(ce[132],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FY=void 0,e.$FY=(0,n.$Di)("urlService")}),define(ce[235],le([0,1,7]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=e.$Xgc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${p}`)}}e.$Xgc=r;class P{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$Ygc=P;class A{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,c,m){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(c)&&c.length>0){const h=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",h.toString(!0)),h.query){const d=/\bwindowId=(\d+)/.exec(h.query);if(d){const w=d[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,h.toString(!0));const f=new RegExp(`window:${w}`),g=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(g)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",h.toString(!0)),g;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",h.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",h.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,c,m)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$Zgc=A}),define(ce[236],le([0,1,8,2,7,28]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HY=e.$GY=void 0;class T extends r.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,m){const h=[...this.a.values()];return(0,n.$Hh)(h.map(d=>()=>d.handleURL(c,m)),void 0,!1).then(d=>d||!1)}registerHandler(c){return this.a.add(c),(0,r.$Rc)(()=>this.a.delete(c))}}e.$GY=T;let I=class extends T{constructor(c){super(),this.b=c}create(c){let{authority:m,path:h,query:d,fragment:w}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&h&&h.indexOf("/")!==0&&(h=`/${h}`),P.URI.from({scheme:this.b.urlProtocol,authority:m,path:h,query:d,fragment:w})}};e.$HY=I,e.$HY=I=Se([se(0,A.$rk)],I)}),define(ce[237],le([0,1,13,8,4,2,3,7]),function(V,e,n,r,P,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class p extends A.$Tc{constructor(m,h,d,w,f,g){if(super(),this.c=h,this.f=g,this.a=[],this.b=0,m&&(g.trace("ElectronURLListener initialUrisToHandle:",m.map($=>$.originalUrl)),this.a=m),T.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",($,k)=>({event:$,url:k})),({event:$,url:k})=>($.preventDefault(),k));this.B(v($=>{const k=this.g($);k&&this.c.open(k,{originalUrl:$})})),d.getWindows().filter($=>$.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(d.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const h of this.a)await this.c.open(h.uri,{originalUrl:h.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",h.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",h.originalUrl),m.push(h));m.length!==0&&(this.a=m,(0,r.$Fh)(()=>this.h(),500,this.q))}}e.$1gc=p}),define(ce[238],le([0,1,4,2,14,60,31]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class I extends r.$Tc{constructor(c,m,h,d,w,f){super(),this.f=c,this.g=m,this.h=h,this.j=d,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$ke),this.onDidChangeFile=this.a.event,this.b=A.$Ji.forUris(()=>!(this.capabilities&P.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ac(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,h,d,w){return this.g.read(c,m,h,d,w)}write(c,m,h,d,w){return this.g.write(c,m,h,d,w)}watch(c,m){this.b.set(c,c);const h=this.g.watch(this.t(c),m);return(0,r.$Rc)(()=>{this.b.delete(c),h.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,h){return this.g.rename(this.t(c),this.t(m),h)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,h){return this.g.readFileStream(this.t(c),m,h)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,h){return this.g.writeFile(this.t(c),m,h)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,h){if((0,P.$cl)(this.g))return this.g.copy(this.t(c),this.t(m),h);throw new Error("copy not supported")}cloneFile(c,m){if((0,P.$dl)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const h of c){if(h.resource.scheme!==this.f)continue;const d=this.u(h.resource);this.b.findSubstr(d)&&m.push({resource:d,type:h.type,cId:h.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Dhc=I}),define(ce[239],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0,e.$khc="utilityProcessWorker"}),define(ce[240],le([0,1,6]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0,e.$2gc=(0,n.$Di)("webviewManagerService")}),define(ce[241],le([0,1,13,2,11,7]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class T extends r.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,p)}b(p,c){try{const m=A.URI.parse(p.url),h=T.a.get(m.path);if(typeof h=="string"){const d=`vs/workbench/contrib/webview/browser/pre/${h}`,w=P.$Xg.asFileUri(d);return c({path:w.fsPath,headers:{...P.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$3gc=T}),define(ce[51],le([0,1,3]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$6D=void 0,e.$7D=r,e.$8D=P,e.$9D=A,e.$0D=T,e.$$D=I,e.$_D=h,e.$aE=d,e.$bE=w,e.$dE=f,e.$eE=g,e.$fE=v,e.$6D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function P(b){return!!b.workspaceUri}function A(b){return!!b.folderUri}function T(b){return!!b.fileUri}function I(b){const $=d(b),k=b.getValue("window.menuBarVisibility");return k==="default"||$&&k==="compact"||n.$k&&n.$n?"classic":k}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function h(b,$){return!0}function d(b,$){return $||($=w(b)),$===c.NATIVE}function w(b){if(n.$p)return c.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const t=$.titleBarStyle;if(t===c.NATIVE||t===c.CUSTOM)return t}return n.$l?c.NATIVE:c.CUSTOM}e.$cE=35;function f(b){return!(!n.$j||n.$p||d(b))}function g(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[52],le([0,1,13]),function(V,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$tfc=e.$sfc=e.UnloadReason=e.LoadReason=void 0,n=Ve(n);var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const A=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$sfc=A;const T=function(){const h=n.default.screen.getPrimaryDisplay().workArea,d=Math.max(h.x+h.width/2-800/2,0),w=Math.max(h.y+h.height/2-600/2,0);return{x:d,y:w,width:800,height:600,mode:I.Normal}};e.$tfc=T;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var p;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(ce[242],le([0,1,8,4,2]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class A extends P.$Tc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:c}){super(),this.a=this.B(new P.$Sc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$qh)(()=>c()),(async()=>{try{const h=await this.b;this.c=typeof this.c=="number"?this.c:h}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$9gc=A}),define(ce[30],le([0,1,10,9,60,18,7,6,11]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Xi=e.$Wi=e.WorkbenchState=e.$Qi=e.$Pi=e.$Mi=void 0,e.$Ni=c,e.$Oi=m,e.$Ri=h,e.$Si=d,e.$Ti=w,e.$Ui=g,e.$Vi=v,e.$Yi=k,e.$4i=E,e.$5i=t,e.$7i=u,e.$8i=i,e.$9i=o,e.$Mi=(0,I.$Di)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.uri)}function m(s){return typeof s?.id=="string"&&!c(s)&&!d(s)}e.$Pi={id:"ext-dev"},e.$Qi={id:"empty-window"};function h(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$mc)(s)}:a?e.$Pi:e.$Qi;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function d(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.configPath)}function w(s){const a=s;if(a?.uri)return{id:a.id,uri:T.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function g(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&T.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class b{constructor(a,l,S,y,D){this.h=a,this.j=S,this.k=y,this.l=D,this.c=P.$Ji.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=P.$Ji.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Wi=b;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$eh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Xi=$;function k(s){return new $({uri:s,index:0,name:(0,A.$ah)(s)},{uri:s.toString()})}e.$Zi="code-workspace",e.$1i=`.${e.$Zi}`,e.$2i=[{name:(0,n.localize)(10975,null),extensions:[e.$Zi]}],e.$3i="workspace.json";function E(s,a){return A.$8g.isEqualOrParent(s,a.untitledWorkspacesHome)}function t(s){let a;return T.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$6i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(s){return s.id===e.$6i}function i(s,a){return!E(s,a)&&!t(s)}function o(s){return(typeof s=="string"?(0,r.$nc)(s):(0,A.$ch)(s))===e.$1i}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[53],le([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0,n=Ve(n),e.$yfc=(0,d.$Di)("dialogMainService");let v=class{constructor($,k){this.d=$,this.e=k,this.a=new Map,this.b=new Map,this.c=new r.$Kh}pickFileFolder($,k){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(11516,null)},k)}pickFolder($,k){return this.f({...$,pickFolders:!0,title:(0,m.localize)(11517,null)},k)}pickFile($,k){return this.f({...$,pickFiles:!0,title:(0,m.localize)(11518,null)},k)}pickWorkspace($,k){const E=(0,m.localize)(11519,null),t=(0,A.$5w)((0,m.localize)(11520,null)),u=g.$2i;return this.f({...$,pickFiles:!0,title:E,filters:u,buttonLabel:t},k)}async f($,k){const E={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(E.properties=void 0,$.pickFiles&&$.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&E.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(E,(k||n.default.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g($){if($){let k=this.b.get($.id);return k||(k=new r.$Kh,this.b.set($.id,k)),k}else return this.c}showMessageBox($,k){return this.g(k).queue(async()=>{const{options:E,buttonIndeces:t}=(0,h.$_w)($,this.e);let u;return k?u=await n.default.dialog.showMessageBox(k,E):u=await n.default.dialog.showMessageBox(E),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog($,k){const E=this.j($,k);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.default.dialog.showSaveDialog(k,$):t=await n.default.dialog.showSaveDialog($),t.filePath=this.h(t.filePath),t})}finally{(0,T.$Oc)(E)}}h($){return $&&p.$k&&($=(0,I.$lm)($)),$}i($){return $.map(k=>this.h(k))}async showOpenDialog($,k){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const E=this.j($,k);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.default.dialog.showOpenDialog(k,$):t=await n.default.dialog.showOpenDialog($),t.filePaths=this.i(t.filePaths),t})}finally{(0,T.$Oc)(E)}}j($,k){if(!k)return T.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let E=this.a.get(k.id);E||(E=new Set,this.a.set(k.id,E));const t=(0,P.$rj)($);if(!E.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",$),E.add(t),(0,T.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),E?.delete(t),E?.size===0&&this.a.delete(k.id)})}};e.$zfc=v,e.$zfc=v=Se([se(0,w.$$j),se(1,f.$rk)],v)}),define(ce[243],le([0,1,4,2,82,30]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class T extends r.$Tc{static{this.a=100}constructor(p,c){super(),this.f=p,this.g=c,this.b=this.B(new n.$ke),this.c=new Map,this.h(c.applicationStorage,this.b)}h(p,c){this.B(n.Event.debounce(p.onDidChangeStorage,(m,h)=>(m?m.push(h):m=[h],m),T.a)(m=>{m.length&&c.fire(this.j(m,p))}))}j(p,c){const m=new Map,h=new Set;return p.forEach(d=>{const w=c.get(d.key);typeof w=="string"?m.set(d.key,w):h.add(d.key)}),{changed:Array.from(m.entries()),deleted:Array.from(h.values())}}listen(p,c,m){switch(c){case"onDidChangeStorage":{const h=m.profile?(0,P.$ai)(m.profile):void 0;if(!h)return this.b.event;let d=this.c.get(h.id);return d||(d=this.B(new n.$ke),this.h(this.g.profileStorage(h),d),this.c.set(h.id,d)),d.event}}throw new Error(`Event not found: ${c}`)}async call(p,c,m){const h=m.profile?(0,P.$ai)(m.profile):void 0,d=(0,A.$Ti)(m.workspace),w=await this.m(h,d);switch(c){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=m;if(f.insert)for(const[g,v]of f.insert)w.set(g,v);f.delete?.forEach(g=>w.delete(g));break}case"optimize":return w.optimize();case"isUsed":{const f=m.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(p,c){let m;c?m=this.g.workspaceStorage(c):p?m=this.g.profileStorage(p):m=this.g.applicationStorage;try{await m.init()}catch(h){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":p?"profile":"application"} storage due to ${h}`)}return m}}e.$Mgc=T}),define(ce[42],le([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,12]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=E,e.$Ll=t,e.$Ml=u;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function E(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&T.URI.isUri(a.location)&&T.URI.isUri(a.globalStorageHome)&&T.URI.isUri(a.settingsResource)&&T.URI.isUri(a.keybindingsResource)&&T.URI.isUri(a.tasksResource)&&T.URI.isUri(a.snippetsHome)&&T.URI.isUri(a.extensionsResource))}e.$Kl=(0,m.$Di)("IUserDataProfilesService");function t(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:a}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function u(s,a,l,S,y,D){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:D&&y?.useDefaultFlags?.globalState?D.globalStorageHome:(0,A.$eh)(l,"globalStorage"),settingsResource:D&&y?.useDefaultFlags?.settings?D.settingsResource:(0,A.$eh)(l,"settings.json"),keybindingsResource:D&&y?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,A.$eh)(l,"keybindings.json"),tasksResource:D&&y?.useDefaultFlags?.tasks?D.tasksResource:(0,A.$eh)(l,"tasks.json"),snippetsHome:D&&y?.useDefaultFlags?.snippets?D.snippetsHome:(0,A.$eh)(l,"snippets"),extensionsResource:D&&y?.useDefaultFlags?.extensions?D.extensionsResource:(0,A.$eh)(l,"extensions.json"),cacheHome:(0,A.$eh)(S,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,S,y){super(),this.t=a,this.u=l,this.w=S,this.y=y,this.f=!0,this.h=this.B(new r.$ke),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$ke),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$ke),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$ke),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$zc,workspaces:new w.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$eh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$eh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,$.$dg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(u((0,A.$bh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},a))}}catch(D){this.y.error(D)}const S=new w.$zc,y=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[L,R]of Object.entries(D.workspaces)){const O=T.URI.parse(L),M=l.find(x=>x.id===R);M&&S.set(O,M)}if(D.emptyWindows)for(const[L,R]of Object.entries(D.emptyWindows)){const O=l.find(M=>M.id===R);O&&y.set(L,O)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:S,emptyWindows:y}}return this.z}D(){const a=u("__default__profile__",(0,I.localize)(11022,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",S=new RegExp(`${(0,b.$gf)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const R=S.exec(L.name),O=R?parseInt(R[1]):0;y=O>y?O:y}const D=`${l} ${y+1}`;return this.createProfile((0,n.$rj)((0,v.$Zg)()).toString(16),D,{transient:!0},a)}async createNamedProfile(a,l,S){return this.createProfile((0,n.$rj)((0,v.$Zg)()).toString(16),a,l,S)}async createProfile(a,l,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(a,l,S);return y&&await this.setProfileForWorkspace(y,D),D}async F(a,l,S){if(!(0,$.$dg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===a))throw new Error(`Profile with ${l} name already exists`);const L=u(a,l,(0,A.$eh)(this.profilesHome,a),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const R=[];return this.j.fire({profile:L,join(O){R.push(O)}}),await g.Promises.settled(R),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===a.id);if(!S)throw new Error(`Profile '${a.name}' does not exist`);return S=u(S.id,l.name??S.name,S.location,this.g,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const S=[];this.m.fire({profile:l,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$pl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,S)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),S=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return S||((0,d.$Ni)(a)?this.s.folders.get(a.uri):(0,d.$Si)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,d.$Ni)(a)?a.uri:(0,d.$Si)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,S){const y=[...this.profiles,...a],D=[],L=this.s.profiles;this.s.profiles=[];for(let R of y){if(R.isDefault||l.some(M=>R.id===M.id))continue;R=S.find(M=>R.id===M.id)??R;const O=L.find(M=>R.id===M.id);if(R.isTransient)this.s.profiles.push(R);else{if(O){for(const[M,x]of this.s.emptyWindows.entries())if(R.id===x.id){this.L({id:M},R);break}for(const[M,x]of this.s.workspaces.entries())if(R.id===x.id){this.L({id:"",configPath:M},R);break}for(const[M,x]of this.s.folders.entries())if(R.id===x.id){this.L({id:"",uri:M},R);break}}D.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(a,l,S)}J(a,l,S){this.h.fire({added:a,removed:l,updated:S,all:this.profiles})}L(a,l,S){if(S=l?.isTransient?!0:S,S)(0,d.$Ni)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,d.$Si)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[S,y]of this.C.workspaces.entries())a[S.toString()]=y.id;const l={};for(const[S,y]of this.C.emptyWindows.entries())l[S.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},S=this.D();if(a.workspaces)for(const[D,L]of Object.entries(a.workspaces)){const R=T.URI.parse(L);l[D]=this.w.extUri.isEqual(R,S.location)?S.id:this.w.extUri.basename(R)}const y={};if(a.emptyWindows)for(const[D,L]of Object.entries(a.emptyWindows)){const R=T.URI.parse(L);y[D]=this.w.extUri.isEqual(R,S.location)?S.id:this.w.extUri.basename(R)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Nl=i,e.$Nl=i=Se([se(0,p.$Ki),se(1,c.$$k),se(2,f.$Il),se(3,h.$$j)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Ol=o}),define(ce[86],le([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,12,15,24]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class k extends Error{constructor(o,s){super(o),this.code=s}}e.$Gq=k,e.$Hq=(0,h.$Di)("IExtensionsProfileScannerService");let E=class extends P.$Tc{constructor(o,s,a,l,S,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=S,this.t=y,this.b=this.B(new A.$ke),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ke),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ke),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ke),this.onDidRemoveExtensions=this.g.event,this.h=new T.$zc}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],S=[];try{return await this.u(s,y=>{const D=[];if(a)D.push(...y);else for(const L of y)o.some(([R])=>(0,c.$Kp)(R.identifier,L.identifier)&&R.manifest.version!==L.version)?l.push(L):D.push(L);for(const[L,R]of o){const O=D.findIndex(x=>(0,c.$Kp)(x.identifier,L.identifier)&&x.version===L.manifest.version),M={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:R};O===-1?(S.push(M),D.push(M)):D.splice(O,1,M)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),D}),S.length&&this.c.fire({extensions:S,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),S}catch(y){throw S.length&&this.c.fire({extensions:S,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const S=[];for(const y of l){const D=o.find(([L])=>(0,c.$Kp)(L.identifier,y.identifier)&&L.manifest.version===y.version);D&&(y.metadata={...y.metadata,...D[1]},a.push(y)),S.push(y)}return S}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const S=[];for(const y of l)(0,c.$Kp)(y.identifier,o.identifier)?a.push(y):S.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),S}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],S;try{const y=await this.m.readFile(o);S=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,m.$pl)(y)!==m.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&a?.bailOutWhenFileNotFound)throw new k((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(o);let y=!1;for(const D of S){t(D)||this.w(o);let L;if((0,g.$dg)(D.relativeLocation)&&D.relativeLocation)L=this.z(D.relativeLocation);else if((0,g.$dg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{L=I.URI.revive(D.location);const R=this.y(L);R&&(y=!0,D.relativeLocation=R)}(0,g.$kg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(y=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:L,version:D.version,metadata:D.metadata})}y&&await this.m.writeFile(o,r.$Me.fromString(JSON.stringify(S)))}if(s){l=s(l);const y=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,r.$Me.fromString(JSON.stringify(y)))}return l})}w(o){const s=new k(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(S){if((0,m.$pl)(S)===m.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const S=JSON.parse(a);Array.isArray(S)&&S.every(y=>t(y))?l=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Me.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,m.$pl)(S)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(o)}catch(S){(0,m.$pl)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,m.$pl)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Kh,this.h.set(o,s)),s}};e.$Iq=E,e.$Iq=E=Se([se(1,m.$$k),se(2,w.$Kl),se(3,f.$Il),se(4,b.$0l),se(5,d.$$j)],E);function t(i){return(0,g.$fg)(i)&&(0,p.$ip)(i.identifier)&&(u(i.location)||(0,g.$dg)(i.location)&&i.location)&&((0,g.$kg)(i.relativeLocation)||(0,g.$dg)(i.relativeLocation))&&i.version&&(0,g.$dg)(i.version)}function u(i){return i?(0,g.$dg)(i.path)&&(0,g.$dg)(i.scheme):!1}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[133],le([0,1,21,8,37,17,15,43,163,2,11,9,3,18,210,81,12,7,10,38,129,85,209,14,6,5,28,4,82,86,42,41,171]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=fe,P=Pe(P),h=Pe(h),d=Pe(d),f=Pe(f),g=Ve(g);var O;(function(J){function U(Z,B){if(Z===B)return!0;const j=Object.keys(Z),C=new Set;for(const Y of Object.keys(B))C.add(Y);if(j.length!==C.size)return!1;for(const Y of j){if(Z[Y]!==B[Y])return!1;C.delete(Y)}return C.size===0}J.equals=U})(O||(e.Translations=O={})),e.$Lq=(0,o.$Di)("IExtensionsScannerService");let M=class extends c.$Tc{constructor(U,Z,B,j,C,Y,oe,G,ue,re,Q,F){super(),this.systemExtensionsLocation=U,this.userExtensionsLocation=Z,this.r=B,this.s=j,this.t=C,this.u=Y,this.w=oe,this.y=G,this.z=ue,this.C=re,this.D=Q,this.F=F,this.g=this.B(new l.$ke),this.onDidChangeCache=this.g.event,this.h=(0,w.$eh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(X,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(U,Z,B){const[j,C]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(Z)]),Y=B?await this.scanExtensionsUnderDevelopment(U,[...j,...C]):[];return this.L(j,C,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const Z=[];Z.push(this.M(!!U.useCache,U.language)),Z.push(this.N(U.language,!!U.checkControlFile));const[B,j]=await Promise.all(Z);return this.J([...B,...j],t.ExtensionType.System,U,!1)}async scanUserExtensions(U){const Z=U.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(U.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(Z,!!U.profileLocation,t.ExtensionType.User,!U.includeUninstalled,U.language,!0,B,U.productVersion??this.R()),C=U.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let Y;try{Y=await C.scanExtensions(j)}catch(oe){if(oe instanceof y.$Gq&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Y=await C.scanExtensions(j);else throw oe}return Y=await this.J(Y,t.ExtensionType.User,U,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(U,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===m.Schemas.file).map(async j=>{const C=await this.P(j,!1,t.ExtensionType.User,!0,U.language,!1,void 0,U.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(C)).map(oe=>(oe.type=Z.find(G=>(0,E.$Kp)(G.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,C)))}))).flat();return this.J(B,"development",U,!0)}return[]}async scanExistingExtension(U,Z,B){const j=await this.P(U,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),C=await this.n.scanExtension(j);return!C||!B.includeInvalid&&!C.isValid?null:C}async scanOneOrMultipleExtensions(U,Z,B){const j=await this.P(U,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),C=await this.n.scanOneOrMultipleExtensions(j);return this.J(C,Z,B,!0)}async scanMultipleExtensions(U,Z,B){const j=[];return await Promise.all(U.map(async C=>{const Y=await this.scanOneOrMultipleExtensions(C,Z,B);j.push(...Y)})),this.J(j,Z,B,!0)}async scanMetadata(U){const Z=(0,w.$eh)(U,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(U,Z){const B=(0,w.$eh)(U,"package.json"),j=(await this.w.readFile(B)).value.toString(),C=JSON.parse(j);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,C.__metadata={...C.__metadata,...Z},await this.w.writeFile((0,w.$eh)(U,"package.json"),A.$Me.fromString(JSON.stringify(C,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(U){if(U instanceof y.$Gq&&U.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw U}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const U=await this.scanUserExtensions({includeInvalid:!0});if(U.length)await this.u.addExtensionsToProfile(U.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Me.fromString(JSON.stringify([])))}catch(Z){(0,i.$pl)(Z)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(U){this.y.error(U)}finally{this.H=void 0}})()),this.H}async J(U,Z,B,j){return B.includeAllVersions||(U=this.L(Z===t.ExtensionType.System?U:void 0,Z===t.ExtensionType.User?U:void 0,Z==="development"?U:void 0,await this.getTargetPlatform(),j)),B.includeInvalid||(U=U.filter(C=>C.isValid)),U.sort((C,Y)=>{const oe=h.$mc(C.location.fsPath),G=h.$mc(Y.location.fsPath);return oe<G?-1:oe>G?1:0})}L(U,Z,B,j,C){const Y=(G,ue,re)=>{if(G.isValid&&!ue.isValid)return!1;if(G.isValid===ue.isValid){if(C&&f.gt(G.manifest.version,ue.manifest.version))return this.y.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(f.eq(G.manifest.version,ue.manifest.version)){if(G.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${ue.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return re?this.y.warn(`Overwriting user extension ${G.location.path} with ${ue.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${ue.location.path}.`),!0},oe=new t.$rn;return U?.forEach(G=>{const ue=oe.get(G.identifier.id);(!ue||Y(ue,G,!1))&&oe.set(G.identifier.id,G)}),Z?.forEach(G=>{const ue=oe.get(G.identifier.id);if(!ue&&U&&G.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!ue||Y(ue,G,!1))&&oe.set(G.identifier.id,G)}),B?.forEach(G=>{const ue=oe.get(G.identifier.id);(!ue||Y(ue,G,!0))&&oe.set(G.identifier.id,G),oe.set(G.identifier.id,G)}),[...oe.values()]}async M(U,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,Z,!0,void 0,this.R()),C=await(U&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",C.length),C}async N(U,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const j=Z?await this.O():{},C=[],Y=b.URI.file(h.$gc(h.$ic(m.$Xg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of B){const ue=j[G.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":C.push((0,w.$eh)(Y,G.name));break;default:C.push(b.URI.file(ue));break}}const oe=await Promise.all(C.map(async G=>this.n.scanExtension(await this.P(G,!1,t.ExtensionType.System,!0,U,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Gb)(oe)}async O(){try{const U=await this.w.readFile(this.r);return JSON.parse(U.value.toString())}catch{return{}}}async P(U,Z,B,j,C,Y,oe,G){const ue=await this.f(C??d.$x),re=await this.Q(U),Q=Z&&!this.D.extUri.isEqual(U,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=Q?await this.Q(Q):void 0;return new x(U,re,Q,F,Z,oe,B,j,Y,G.version,G.date,this.C.commit,!this.z.isBuilt,C,ue)}async Q(U){try{const Z=await this.w.stat(U);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=M,e.$Mq=M=Se([se(4,D.$Kl),se(5,y.$Hq),se(6,i.$$k),se(7,s.$$j),se(8,k.$Ki),se(9,a.$rk),se(10,L.$Il),se(11,o.$Ci)],M);class x{constructor(U,Z,B,j,C,Y,oe,G,ue,re,Q,F,N,W,z){this.location=U,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=j,this.profile=C,this.profileScanOptions=Y,this.type=oe,this.excludeObsolete=G,this.validate=ue,this.productVersion=re,this.productDate=Q,this.productCommit=F,this.devMode=N,this.language=W,this.translations=z}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,Z){return(0,w.$0g)(U.location,Z.location)&&U.mtime===Z.mtime&&(0,w.$0g)(U.applicationExtensionslocation,Z.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&U.profile===Z.profile&&P.$go(U.profileScanOptions,Z.profileScanOptions)&&U.type===Z.type&&U.excludeObsolete===Z.excludeObsolete&&U.validate===Z.validate&&U.productVersion===Z.productVersion&&U.productDate===Z.productDate&&U.productCommit===Z.productCommit&&U.devMode===Z.devMode&&U.language===Z.language&&O.equals(U.translations,Z.translations)}}e.$Nq=x;let X=class extends c.$Tc{constructor(U,Z,B,j,C,Y,oe){super(),this.g=U,this.h=Z,this.j=B,this.m=j,this.n=Y,this.r=oe,this.f=C.extensionsEnabledWithApiProposalVersion?.map(G=>G.toLowerCase())??[]}async scanExtensions(U){const Z=U.profile?await this.t(U):await this.s(U);let B={};if(U.excludeObsolete&&U.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(j)}catch{}return(0,v.$qg)(B)?Z:Z.filter(j=>!B[E.$Lp.create(j).toString()])}async s(U){const Z=await this.m.resolve(U.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async j=>{if(!j.isDirectory||U.type===t.ExtensionType.User&&(0,w.$bh)(j.resource).indexOf(".")===0)return null;const C=new x(j.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(C)}));return(0,n.$Gb)(B).sort((j,C)=>j.location.path<C.location.path?-1:1)}async t(U){let Z=await this.u(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.j.extUri.isEqual(U.location,U.applicationExtensionslocation)){Z=Z.filter(j=>!j.metadata?.isApplicationScoped);const B=await this.u(U.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,U);Z.push(...B)}return Z}async u(U,Z,B){const j=await this.h.scanProfileExtensions(U,B.profileScanOptions);if(!j.length)return[];const C=await Promise.all(j.map(async Y=>{if(Z(Y)){const oe=new x(Y.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(oe,Y.metadata)}return null}));return(0,n.$Gb)(C)}async scanOneOrMultipleExtensions(U){try{if(await this.m.exists((0,w.$eh)(U.location,"package.json"))){const Z=await this.scanExtension(U);return Z?[Z]:[]}else return await this.scanExtensions(U)}catch(Z){return this.r.error(`Error scanning extensions at ${U.location.path}:`,(0,T.$9)(Z)),[]}}async scanExtension(U,Z){try{let B=await this.w(U.location);if(B){B.publisher||(B.publisher=t.$ln),Z=Z??B.__metadata,delete B.__metadata;const j=(0,E.$Pp)(B.publisher,B.name),C=Z?.id?{id:j,uuid:Z.id}:{id:j},Y=Z?.isSystem?t.ExtensionType.System:U.type,oe=Y===t.ExtensionType.System||!!Z?.isBuiltin;B=await this.y(U.location,B,x.createNlsConfiguration(U));let G={type:Y,identifier:C,manifest:B,location:U.location,isBuiltin:oe,targetPlatform:Z?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return U.validate&&(G=this.validate(G,U)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,t.$xn)([...B.enabledApiProposals])),G}}catch(B){U.type!==t.ExtensionType.System&&this.r.error(B)}return null}validate(U,Z){let B=!0;const j=this.n.isBuilt&&this.f.includes(U.identifier.id.toLowerCase()),C=(0,u.$2p)(Z.productVersion,Z.productDate,Z.location,U.manifest,U.isBuiltin,j);for(const[Y,oe]of C)Y===g.default.Error&&(B=!1,this.r.error(this.F(Z.location,oe)));return U.isValid=B,U.validations=C,U}async w(U){const Z=(0,w.$eh)(U,"package.json");let B;try{B=(await this.m.readFile(Z)).value.toString()}catch(C){return(0,i.$pl)(C)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(U,(0,$.localize)(11406,null,Z.path,C.message))),null}let j;try{j=JSON.parse(B)}catch{const Y=[];(0,I.$Wn)(B,Y);for(const oe of Y)this.r.error(this.F(U,(0,$.localize)(11407,null,Z.path,oe.offset,oe.length,(0,p.$Jq)(oe.error))));return null}return(0,I.$5n)(j)!=="object"?(this.r.error(this.F(U,(0,$.localize)(11408,null,Z.path))),null):j}async y(U,Z,B){const j=await this.z(U,Z,B);if(j)try{const C=[],Y=await this.C(j.default,C);if(C.length>0)return C.forEach(G=>{this.r.error(this.F(U,(0,$.localize)(11409,null,j.default?.path,(0,p.$Jq)(G.error))))}),Z;if((0,I.$5n)(j)!=="object")return this.r.error(this.F(U,(0,$.localize)(11410,null,j.default?.path))),Z;const oe=j.values||Object.create(null);return(0,R.$Kq)(this.r,Z,oe,Y)}catch{}return Z}async z(U,Z,B){const j=(0,w.$eh)(U,"package.nls.json"),C=(ue,re)=>{re.forEach(Q=>{this.r.error(this.F(U,(0,$.localize)(11411,null,ue?.path,(0,p.$Jq)(Q.error))))})},Y=ue=>{this.r.error(this.F(U,(0,$.localize)(11412,null,ue?.path)))},oe=`${Z.publisher}.${Z.name}`,G=B.translations[oe];if(G)try{const ue=b.URI.file(G),re=(await this.m.readFile(ue)).value.toString(),Q=[],F=(0,I.$Wn)(re,Q);return Q.length>0?(C(ue,Q),{values:void 0,default:j}):(0,I.$5n)(F)!=="object"?(Y(ue),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let re;try{re=await this.D(U,B)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const Q=(await this.m.readFile(re.localized)).value.toString(),F=[],N=(0,I.$Wn)(Q,F);return F.length>0?(C(re.localized,F),{values:void 0,default:re.original}):(0,I.$5n)(N)!=="object"?(Y(re.localized),{values:void 0,default:re.original}):{values:N,default:re.original}}catch{return{values:void 0,default:re.original}}}}async C(U,Z){if(U)try{const B=(await this.m.readFile(U)).value.toString();return(0,I.$Wn)(B,Z)}catch{}}D(U,Z){return new Promise((B,j)=>{const C=Y=>{const oe=(0,w.$eh)(U,`package.nls.${Y}.json`);this.m.exists(oe).then(G=>{G&&B({localized:oe,original:(0,w.$eh)(U,"package.nls.json")});const ue=Y.lastIndexOf("-");ue===-1?B({localized:(0,w.$eh)(U,"package.nls.json"),original:null}):(Y=Y.substring(0,ue),C(Y))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,w.$eh)(U,"package.nls.json"),original:null});C(Z.language)})}F(U,Z){return`[${U.path}]: ${Z}`}};X=Se([se(1,y.$Hq),se(2,L.$Il),se(3,i.$$k),se(4,a.$rk),se(5,k.$Ki),se(6,s.$$j)],X);let K=class extends X{constructor(U,Z,B,j,C,Y,oe,G,ue){super(Z,j,C,Y,oe,G,ue),this.J=U,this.L=B,this.H=this.B(new r.$Bh(3e3)),this.I=this.B(new l.$ke),this.onDidChangeCache=this.I.event}async scanExtensions(U){const Z=this.P(U),B=await this.M(Z);if(this.G=U,B&&B.input&&x.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",U.type===t.ExtensionType.System?"system":"user",U.location.toString()),this.H.trigger(()=>this.O()),B.result.map(C=>(C.location=b.URI.revive(C.location),C));const j=await super.scanExtensions(U);return await this.N(Z,{input:U,result:j}),j}async M(U){try{const Z=await this.m.readFile(U),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,S.$ai)(B.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",U.path,(0,T.$9)(Z))}return null}async N(U,Z){try{await this.m.writeFile(U,A.$Me.fromString(JSON.stringify(Z)))}catch(B){this.r.debug("Error while writing the extension cache file:",U.path,(0,T.$9)(B))}}async O(){if(!this.G)return;const U=this.P(this.G),Z=await this.M(U);if(!Z)return;const B=Z.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!P.$go(j,B))try{this.r.info("Invalidating Cache",B,j),await this.m.del(U),this.I.fire()}catch(C){this.r.error(C)}}P(U){const Z=this.Q(U);return this.j.extUri.joinPath(Z.cacheHome,U.type===t.ExtensionType.System?t.$kn:t.$jn)}Q(U){return U.type===t.ExtensionType.System?this.L.defaultProfile:U.profile?this.j.extUri.isEqual(U.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(U.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};K=Se([se(2,D.$Kl),se(3,y.$Hq),se(4,L.$Il),se(5,i.$$k),se(6,a.$rk),se(7,k.$Ki),se(8,s.$$j)],K);function fe(J,U){const Z=(0,E.$Np)(J.manifest.publisher,J.manifest.name);return{id:Z,identifier:new t.$pn(Z),isBuiltin:J.type===t.ExtensionType.System,isUserBuiltin:J.type===t.ExtensionType.User&&J.isBuiltin,isUnderDevelopment:U,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,publisherDisplayName:J.publisherDisplayName,...J.manifest}}class H extends M{constructor(U,Z,B,j,C,Y,oe,G,ue,re,Q,F){super(U,Z,(0,w.$eh)(B,".vscode-oss-dev","extensions","control.json"),j,C,Y,oe,G,ue,re,Q,F),this.S=(async()=>{if(d.$A)try{const N=await this.w.readFile(b.URI.file(d.$A));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(U){return this.S}}e.$Pq=H}),define(ce[244],le([0,1,5,42,41,24,86,14,38,7]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let m=class extends T.$Iq{constructor(d,w,f,g,v,b){super(c.URI.file(d.extensionsPath),w,f,g,v,b)}};e.$DR=m,e.$DR=m=Se([se(0,p.$Li),se(1,I.$$k),se(2,r.$Kl),se(3,P.$Il),se(4,A.$0l),se(5,n.$$j)],m)}),define(ce[245],le([0,1,7,38,86,133,14,6,5,28,41,42]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let d=class extends A.$Pq{constructor(f,g,v,b,$,k,E,t){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,g,v,b,$,k,E,t)}};e.$ahc=d,e.$ahc=d=Se([se(0,h.$Kl),se(1,P.$Hq),se(2,T.$$k),se(3,p.$$j),se(4,r.$Li),se(5,c.$rk),se(6,m.$Il),se(7,I.$Ci)],d)}),define(ce[246],le([0,1,13,2,11,9,3,60,7,33,35,38,5,42]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;let f=class extends r.$Tc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Ji.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(P.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Rc)(()=>{v.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(v){const b=(0,A.$gc)(v);return this.a.get(b)?r.$Tc.None:(this.a.set(b,!0),(0,r.$Rc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${P.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let k;return this.c.crossOriginIsolated&&((0,A.$mc)($)==="workbench.html"||(0,A.$mc)($)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:k}):this.b.has((0,A.$nc)($).toLowerCase())?b({path:$}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=P.$Xg.uriToFileUri(b);return(0,A.$gc)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,c.$Zg)()}),$=b.toString(),k=async()=>v;return m.$QX.handle($,k),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:E=>v=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),m.$QX.removeHandler($)}}}};e.$uhc=f,e.$uhc=f=Se([se(0,h.$Li),se(1,w.$Kl),se(2,d.$$j)],f)}),define(ce[62],le([0,1,8,4,2,70,12,119,6,42]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=w,e.$jq=g,e.$lq=b,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,p.$Di)("storageService");var m;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var h;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function w($){const k=$.get(e.$fq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class f extends P.$Tc{static{this.a=60*1e3}constructor(k={flushInterval:f.a}){super(),this.m=k,this.b=this.B(new r.$ne),this.c=this.B(new r.$ne),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$ke),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Ph(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,E,t){return r.Event.filter(this.b.event,u=>u.scope===k&&(E===void 0||u.key===E),t)}n(){this.j.value=(0,n.$Th)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,E){const{key:t,external:u}=E;if(t===e.$fq){switch(k){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:t,target:this.J(k)[t],external:u})}w(k){this.f.fire({reason:k})}get(k,E,t){return this.P(E)?.get(k,t)}getBoolean(k,E,t){return this.P(E)?.getBoolean(k,t)}getNumber(k,E,t){return this.P(E)?.getNumber(k,t)}getObject(k,E,t){return this.P(E)?.getObject(k,t)}storeAll(k,E){this.y(()=>{for(const t of k)this.store(t.key,t.value,t.scope,t.target,E)})}store(k,E,t,u,i=!1){if((0,T.$mg)(E)){this.remove(k,t,i);return}this.y(()=>{this.z(k,t,u),this.P(t)?.set(k,E,i)})}remove(k,E,t=!1){this.y(()=>{this.z(k,E,void 0),this.P(E)?.delete(k,t)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,E){const t=[],u=this.J(k);for(const i of Object.keys(u))u[i]===E&&t.push(i);return t}z(k,E,t,u=!1){const i=this.J(E);typeof t=="number"?i[k]!==t&&(i[k]=t,this.P(E)?.set(e.$fq,JSON.stringify(i),u)):typeof i[k]=="number"&&(delete i[k],this.P(E)?.set(e.$fq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(k){switch(k){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(k){const E=this.P(k);return E?w(E):Object.create(null)}isNew(k){return this.getBoolean(e.$eq,k)===!0}async flush(k=m.NONE){this.f.fire({reason:k});const E=this.P(h.APPLICATION),t=this.P(h.PROFILE),u=this.P(h.WORKSPACE);switch(k){case m.NONE:await n.Promises.settled([E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await n.Promises.settled([E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(h.APPLICATION)?.items??new Map,E=this.P(h.PROFILE)?.items??new Map,t=this.P(h.WORKSPACE)?.items??new Map;return b(k,E,t,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,E){return this.w(m.NONE),(0,c.$Jl)(k)?this.R(k,E):this.S(k,E)}M(k,E){return!(k.id===E.id||g(E)&&g(k))}N(k,E,t){this.y(()=>{const u=new Set;for(const[i,o]of k)u.add(i),E.get(i)!==o&&this.u(t,{key:i,external:!0});for(const[i]of E.items)u.has(i)||this.u(t,{key:i,external:!0})})}}e.$iq=f;function g($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$cq(new I.$dq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(h.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(h.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(h.APPLICATION,k)))}P(k){switch(k){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$kq=v;async function b($,k,E,t,u,i){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,a=new Map;$.forEach((O,M)=>{s.set(M,O),a.set(M,o(O))});const l=new Map,S=new Map;k.forEach((O,M)=>{l.set(M,O),S.set(M,o(O))});const y=new Map,D=new Map;E.forEach((O,M)=>{y.set(M,O),D.set(M,o(O))}),console.group(t!==u?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((O,M)=>{L.push({key:M,value:O})}),console.table(L),console.groupEnd(),console.log(a),t!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const O=[];l.forEach((M,x)=>{O.push({key:x,value:M})}),console.table(O),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${i})`);const R=[];y.forEach((O,M)=>{R.push({key:M,value:O})}),console.table(R),console.groupEnd(),console.log(D)}}),define(ce[247],le([0,1,17,33,62]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=A;async function A(T,I,p){let c=p&&p.get("storage.serviceMachineId",P.StorageScope.APPLICATION)||null;if(c)return c;try{const h=(await I.readFile(T.serviceMachineIdResource)).value.toString();c=(0,r.$Yg)(h)?h:null}catch{c=null}if(!c){c=(0,r.$Zg)();try{await I.writeFile(T.serviceMachineIdResource,n.$Me.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),c}}),define(ce[248],le([0,1,247,24,57]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=A;async function A(T,I,p,c,m,h,d){const w={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,P.$Cp)(I,p)&&(0,P.$Ep)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$mq)(p,m,h);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=d.machineId||f}return w}}),define(ce[249],le([0,1,26,21,8,4,2,9,66,7,23,119,161,5,62,24,30,11]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=void 0,n=Pe(n);class $ extends T.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new A.$ke),this.onDidChangeStorage=this.b.event,this.c=this.B(new A.$ke),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$cq(new h.$dq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new P.$1h,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$eq);a===void 0?s.set(f.$eq,!0):a&&s.set(f.$eq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$ee(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([S,y])=>({key:S,length:y.length})),(S,y)=>y.length-S.length,5).map(S=>`${S.key}:${S.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class k extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$ic)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,k.y)}constructor(s,a,l,S){super(l,S),this.z=s,this.C=a}async t(){return new h.$cq(new d.$jY(this.path??d.$jY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class E extends k{constructor(s,a,l,S){super(s,a,l,S)}}e.$Yfc=E;class t extends k{constructor(s,a,l,S){super(a.defaultProfile,s,l,S)}async s(s){await super.s(s),this.G(s)}G(s){s.get(g.$am,void 0)===void 0&&s.set(g.$am,new Date().toUTCString());const l=s.get(g.$_l,void 0),S=new Date().toUTCString();s.set(g.$bm,typeof l>"u"?null:l),s.set(g.$_l,S)}}e.$Zfc=t;class u extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,u.y)}constructor(s,a,l,S,y){super(l,y),this.C=s,this.D=a,this.F=S}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new h.$cq(new d.$jY(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:a?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$jY.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),a=(0,I.$ic)(s,u.y);return await m.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Ni)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Si)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$ic)(s,u.z);await m.Promises.exists(l)||await m.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$1fc=u;class i extends ${get path(){}async t(){return new h.$cq(new h.$dq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$2fc=i}),define(ce[250],le([0,1,4,2,62]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class A extends r.$Tc{constructor(I,p,c){super(),this.b=I,this.c=p,this.f=c;const m=this.B(new r.$Uc);this.a=this.B(new n.$ke({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Sc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,c)=>(p?p.push(c.key):p=[c.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,c)=>{p||(p=new Map);let m=p.get(c.profile.id);return m||p.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(P.$fq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(m=>m!==P.$fq),I.length){const m=(0,P.$hq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(h=>({key:h,scope:P.StorageScope.PROFILE,target:m[h]}))})}this.m(p,c)}j(I){const p=[],c=new Map;for(const[m,h]of I.entries()){h.keys.includes(P.$fq)&&p.push(h.profile);const d=h.keys.filter(w=>w!==P.$fq);if(d.length){const w=(0,P.$hq)(h.storage.storage);c.set(m,{profile:h.profile,changes:d.map(f=>({key:f,scope:P.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...c.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,c){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$chc=A}),define(ce[251],le([0,1,7,38,14,5,34,41,42,12,127]),function(V,e,n,r,P,A,T,I,p,c,m){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=e.$AR=void 0;let w=class extends p.$Nl{static{h=this}static{this.a="profileAssociationsMigration"}constructor(b,$,k,E,t){super(k,E,$,t),this.U=b,this.W=k}O(){return this.U.getItem(h.b,[]).map($=>({...$,location:(0,c.$dg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$AR=w,e.$AR=w=h=Se([se(0,T.$vR),se(1,I.$Il),se(2,r.$Li),se(3,P.$$k),se(4,A.$$j)],w);let f=d=class extends w{constructor(b,$,k,E,t){super(b,$,k,E,t),this.$=b}P(b){b.length?this.$.setItem(d.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(d.c,b):this.$.removeItem(d.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const E=$.reduce((t,{workspace:u,profile:i})=>(t[n.URI.revive(u).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(d.c,{workspaces:E})}const k=super.Q();return this.$.getItem(d.a,!1)||(this.R(k),this.$.setItem(d.a,!0)),k}};e.$BR=f,e.$BR=f=d=Se([se(0,T.$wR),se(1,I.$Il),se(2,r.$Li),se(3,P.$$k),se(4,A.$$j)],f);let g=class extends f{constructor(b,$,k,E){super(new m.$zR(m.SaveStrategy.IMMEDIATE,$,E,k),b,$,k,E)}async init(){return await this.$.init(),super.init()}};e.$CR=g,e.$CR=g=Se([se(0,I.$Il),se(1,r.$Li),se(2,P.$$k),se(3,A.$$j)],g)}),define(ce[58],le([0,1,38,14,6,5,41,42,251,34]),function(V,e,n,r,P,A,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,P.$Ei)(I.$Kl);let m=class extends p.$BR{constructor(d,w,f,g,v){super(d,w,f,g,v)}getAssociatedEmptyWindows(){const d=[];for(const w of this.C.emptyWindows.keys())d.push({id:w});return d}};e.$Hfc=m,e.$Hfc=m=Se([se(0,c.$wR),se(1,T.$Il),se(2,n.$Li),se(3,r.$$k),se(4,A.$$j)],m)}),define(ce[134],le([0,1,18,7,30]),function(V,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=A,e.$Jfc=T,e.$Kfc=I;async function A(p,c,m){for(const d of p){const w=d.openedWorkspace;if((0,P.$Si)(w)){const f=await m(w);if(f){if(f.folders.some(g=>n.$8g.isEqualOrParent(c,g.uri)))return d}else if(n.$8g.isEqualOrParent(c,w.configPath))return d}}const h=p.filter(d=>(0,P.$Ni)(d.openedWorkspace)&&n.$8g.isEqualOrParent(c,d.openedWorkspace.uri));if(h.length)return h.sort((d,w)=>-(d.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function T(p,c){for(const m of p)if((0,P.$Si)(m.openedWorkspace)&&n.$8g.isEqual(m.openedWorkspace.configPath,c)||(0,P.$Ni)(m.openedWorkspace)&&n.$8g.isEqual(m.openedWorkspace.uri,c))return m}function I(p,c){const m=h=>c.some(d=>n.$8g.isEqual(r.URI.file(d),r.URI.file(h)));for(const h of p)if(h.config?.extensionDevelopmentPath?.some(d=>m(d)))return h}}),define(ce[102],le([0,1,32,43,107,47,11,9,3,18,7,6,74,30]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hb=void 0,e.$$hb=f,e.$_hb=g,e.$aib=v,e.$bib=b,e.$cib=E,e.$dib=u,e.$eib=i,e.$fib=S,e.$gib=y,r=Pe(r),P=Pe(P),e.$0hb=(0,h.$Di)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function g(D){return D.hasOwnProperty("folderUri")}function v(D){return D.hasOwnProperty("fileUri")}function b(D){return $(D)||k(D)}function $(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(D,L,R,O,M){if(D.scheme!==O.scheme)return{name:R,uri:D.toString(!0)};let x=L?void 0:M.relativePath(O,D);if(x!==void 0)x.length===0?x=".":p.$j&&(x=t(x));else if(D.scheme===T.Schemas.file)x=D.fsPath,p.$j&&(x=t(x));else if(M.isEqualAuthority(D.authority,O.authority))x=D.path;else return{name:R,uri:D.toString(!0)};return{name:R,path:x}}function t(D){return D=(0,A.$Yw)(D),(0,n.$zg)(D)||(D=(0,n.$wg)(D)),D}function u(D,L,R){const O=[],M=new Set,x=R.dirname(L);for(const X of D){let K;if($(X))X.path&&(K=R.resolvePath(x,X.path));else if(k(X))try{K=m.URI.parse(X.uri),K.path[0]!==I.$fc.sep&&(K=K.with({path:I.$fc.sep+K.path}))}catch(fe){console.warn(fe)}if(K){const fe=R.getComparisonKey(K);if(!M.has(fe)){M.add(fe);const H=X.name||R.basenameOrAuthority(K);O.push(new w.$Xi({uri:K,name:H,index:O.length},X))}}}return O}function i(D,L,R,O,M){const x=o(L,D),X=M.dirname(L),K=M.dirname(O),fe=[];for(const Z of x.folders){const B=$(Z)?M.resolvePath(X,Z.path):m.URI.parse(Z.uri);let j;R?j=!1:j=!$(Z)||(0,I.$hc)(Z.path),fe.push(E(B,j,Z.name,K,M))}const H={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},J=P.$$n(D,["folders"],fe,H);let U=P.$bo(D,J);return(0,c.$jh)(x.remoteAuthority,(0,d.$fn)(O))&&(U=P.$bo(U,P.$0n(U,["remoteAuthority"],H))),U}function o(D,L){const R=r.$Wn(L);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(O=>b(O));else throw new Error(`${D} looks like an invalid workspace file.`);return R}function s(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function S(D,L){const R={workspaces:[],files:[]};if(D){const O=function(x,X){for(let K=0;K<x.length;K++)try{X(x[K],K)}catch(fe){L.warn(`Error restoring recent entry ${JSON.stringify(x[K])}: ${fe.toString()}. Skip entry.`)}},M=D;Array.isArray(M.entries)&&O(M.entries,x=>{const X=x.label,K=x.remoteAuthority;s(x)?R.workspaces.push({label:X,remoteAuthority:K,workspace:{id:x.workspace.id,configPath:m.URI.parse(x.workspace.configPath)}}):a(x)?R.workspaces.push({label:X,remoteAuthority:K,folderUri:m.URI.parse(x.folderUri)}):l(x)&&R.files.push({label:X,remoteAuthority:K,fileUri:m.URI.parse(x.fileUri)})})}return R}function y(D){const L={entries:[]};for(const R of D.workspaces)g(R)?L.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):L.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of D.files)L.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return L}}),define(ce[103],le([0,1,91,11,3,18]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0,e.$Mfc=T,e.$Nfc=I,e.$Ofc=p,e.$Lfc=128/4;function T(c){function m(){let h=c.scheme===r.Schemas.file?(0,A.$5g)(c):c.toString();return P.$l||(h=h.toLowerCase()),(0,n.createHash)("md5").update(h).digest("hex")}return{id:m(),configPath:c}}function I(c,m){function h(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let w;return P.$l?w=m.ino:P.$k?w=m.birthtime.getTime():P.$j&&(typeof m.birthtimeMs=="number"?w=Math.floor(m.birthtimeMs):w=m.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(w?String(w):"").digest("hex")}const d=h();if(typeof d=="string")return{id:d,uri:c}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[104],le([0,1,91,93,27,252,17,15,4,2,9,3,33,44,117]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$ui=e.$ti=e.$si=void 0,e.$vi=s,e.$wi=a,e.$yi=y,e.$zi=D;const g=3e4;class v{traceSocketEvent(R,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,O)}constructor(R,O=""){this.f=!0,this.debugLabel=O,this.socket=R,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=x=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:x?.code,message:x?.message}),x){if(x.code==="EPIPE")return;(0,I.$Y)(x)}},this.socket.on("error",this.a);let M;this.b=x=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:x}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>R.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(R){const O=M=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,M),R(T.$Me.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(R){const O=M=>{R({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(R){const O=()=>{R()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(R){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,R),this.socket.write(R.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((R,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),R();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),R()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$si=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class k extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(R,O){this.socket.traceSocketEvent(R,O)}constructor(R,O,M,x){super(),this.f=this.B(new p.$ke),this.g=this.B(new p.$ke),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=R,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new E(this,O,M,x,this.f,(X,K)=>this.m(X,K))),this.B(this.a.onError(X=>{console.error(X),(0,I.$Y)(X),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:X})})),this.b=new f.$ni,this.B(this.socket.onData(X=>this.n(X))),this.B(this.socket.onClose(async X=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(X)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this.f.event(R)}onClose(R){return this.g.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){let O=0;for(;O<R.byteLength;)this.a.writeMessage(R.slice(O,Math.min(O+b.MaxWebSocketMessageLength,R.byteLength)),{compressed:!0,opcode:2}),O+=b.MaxWebSocketMessageLength}m(R,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,R);let x=b.MinHeaderByteSize;R.byteLength<126?x+=0:R.byteLength<2**16?x+=2:x+=8;const X=T.$Me.alloc(x),K=O?64:0,fe=M&15;if(X.writeUInt8(128|K|fe,0),R.byteLength<126)X.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){X.writeUInt8(126,1);let H=1;X.writeUInt8(R.byteLength>>>8&255,++H),X.writeUInt8(R.byteLength>>>0&255,++H)}else{X.writeUInt8(127,1);let H=1;X.writeUInt8(0,++H),X.writeUInt8(0,++H),X.writeUInt8(0,++H),X.writeUInt8(0,++H),X.writeUInt8(R.byteLength>>>24&255,++H),X.writeUInt8(R.byteLength>>>16&255,++H),X.writeUInt8(R.byteLength>>>8&255,++H),X.writeUInt8(R.byteLength>>>0&255,++H)}this.socket.write(T.$Me.concat([X,R]))}end(){this.h=!0,this.socket.end()}n(R){if(R.byteLength!==0){for(this.b.acceptChunk(R);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),x=(M&128)>>>7,X=(M&64)>>>6,K=M&15,fe=O.readUInt8(1),H=(fe&128)>>>7,J=fe&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(H?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!X),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.j.opcode=K,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),x=(M&128)>>>7;let X=M&127,K=1;X===126?X=O.readUInt8(++K)*2**8+O.readUInt8(++K):X===127&&(X=O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K));let fe=0;x&&(fe=O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K)),this.j.state=$.ReadBody,this.j.readLen=X,this.j.mask=fe,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ti=k;class E extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Me.alloc(0)}constructor(R,O,M,x,X,K){super(),this.n=R,this.r=X,this.s=K,this.a=this.B(new p.$ke),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$ke),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$ke),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,x,M,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(fe=>this.a.fire(fe))),this.B(this.f.onError(fe=>this.a.fire(fe)))):(this.b=null,this.f=null)}writeMessage(R,O){this.g.push({data:R,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:R,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,R);this.s(M,O)}else this.s(R,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(R,O){return new Promise((M,x)=>{R.write(O),R.flush(X=>M(X))})}acceptFrame(R,O,M){this.h.push({data:R,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const R=this.h.shift();if(this.b&&R.isCompressed){const O=await this.C(this.b,R.data,R.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(R.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(R,O,M){return new Promise((x,X)=>{R.write(O),M&&R.write(T.$Me.fromByteArray([0,0,255,255])),R.flush(K=>x(K))})}}class t extends c.$Tc{get recordedInflateBytes(){return this.j?T.$Me.concat(this.f):T.$Me.alloc(0)}constructor(R,O,M,x){super(),this.h=R,this.j=O,this.a=this.B(new p.$ke),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(x),this.b.on("error",X=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:X?.message,code:X?.code}),this.a.fire(X)}),this.b.on("data",X=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,X),this.g.push(T.$Me.wrap(X))}),M&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(R){this.j&&this.f.push(R.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,R),this.b.write(R.buffer)}flush(R){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Me.concat(this.g);this.g.length=0,R(O)})}}class u extends c.$Tc{constructor(R,O){super(),this.g=R,this.a=this.B(new p.$ke),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(T.$Me.wrap(M))})}write(R){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,R.buffer),this.b.write(R.buffer)}flush(R){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Me.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),R(O)})}}function i(L,R){if(R===0)return;const O=L.byteLength>>>2;for(let H=0;H<O;H++){const J=L.readUInt32BE(H*4);L.writeUInt32BE(J^R,H*4)}const M=O*4,x=L.byteLength-M,X=R>>>24&255,K=R>>>16&255,fe=R>>>8&255;x>=1&&L.writeUInt8(L.readUInt8(M)^X,M),x>=2&&L.writeUInt8(L.readUInt8(M+1)^K,M+1),x>=3&&L.writeUInt8(L.readUInt8(M+2)^fe,M+2)}e.$ui=process.env.XDG_RUNTIME_DIR;const o={[h.Platform.Linux]:107,[h.Platform.Mac]:103};function s(){const L=(0,d.$Zg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const R=process.platform!=="darwin"&&e.$ui?e.$ui:(0,P.tmpdir)(),O=(0,m.$ic)(R,`vscode-ipc-${L}.sock`);return l(O),O}function a(L,R,O){const x=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${x}-${O}-${R}-sock`;const X=O.substr(0,4),K=R.substr(0,6);let fe;return process.platform!=="darwin"&&e.$ui&&!process.env.VSCODE_PORTABLE?fe=(0,m.$ic)(e.$ui,`vscode-${x}-${X}-${K}.sock`):fe=(0,m.$ic)(L,`${X}-${K}.sock`),l(fe),fe}function l(L){const R=o[h.$v];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class S extends w.$hi{static b(R){const O=p.Event.fromNodeEventEmitter(R,"connection");return p.Event.map(O,M=>({protocol:new f.$oi(new v(M,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(M,"close"))}))}constructor(R){super(S.b(R)),this.d=R}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$xi=S;function y(L){return new Promise((R,O)=>{const M=(0,r.createServer)();M.on("error",O),M.listen(L,()=>{M.removeListener("error",O),R(new S(M))})})}function D(L,R){return new Promise((O,M)=>{const x=(0,r.createConnection)(L,()=>{x.removeListener("error",M),O(f.$pi.fromSocket(new v(x,`ipc-client${R}`),R))});x.once("error",M)})}}),define(ce[20],le([0,1,54,9,3,104,38,95,6]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0,e.$qfc=(0,p.$Ei)(T.$Ki);class c extends I.$7m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.$wi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$l){for(const h in process.env)if(h.endsWith("_VSCODE_SNAP_ORIG")){const d=h.slice(0,-17);if(this.d[d])continue;process.env[d]&&(this.d[d]=process.env[d]),process.env[h]?process.env[d]=process.env[h]:delete process.env[d]}}}restoreSnapExportedVariables(){if(P.$l)for(const h in this.d)process.env[h]=this.d[h],delete this.d[h]}}e.$rfc=c,Se([n.$8h],c.prototype,"backupHome",null),Se([n.$8h],c.prototype,"mainIPCHandle",null),Se([n.$8h],c.prototype,"mainLockfile",null),Se([n.$8h],c.prototype,"disableUpdates",null),Se([n.$8h],c.prototype,"crossOriginIsolated",null),Se([n.$8h],c.prototype,"codeCachePath",null),Se([n.$8h],c.prototype,"useCodeCache",null)}),define(ce[253],le([0,1,91,32,11,9,3,18,23,165,16,20,34,14,5,164,30,103]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let k=class{static{$=this}static{this.a="backupWorkspaces"}constructor(t,u,i,o){this.j=t,this.k=u,this.l=i,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$8g,this.i={isEqual:(s,a)=>(0,r.$Bg)(s,a,!T.$l)}}async initialize(){const t=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,c.$vfc)(t)),this.e=await this.v((0,c.$wfc)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$xl.OFF}q(){return this.s()===w.$xl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$xl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,u){this.d.some(o=>t.workspace.id===o.workspace.id)||(this.d.push(t),this.C());const i=(0,A.$ic)(this.c,t.workspace.id);return u?this.t(i,u).then(()=>i):i}async t(t,u){if(await p.Promises.exists(t)&&await this.z(t),await p.Promises.exists(u))try{await p.Promises.rename(u,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(u=>this.h.isEqual(t.folderUri,u.folderUri))||(this.e.push(t),this.C()),(0,A.$ic)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,A.$ic)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const u=new Set,i=[];for(const o of t){const s=o.workspace;if(!(0,v.$Si)(s))return[];if(!u.has(s.id)){u.add(s.id);const a=(0,A.$ic)(this.c,s.id);await this.B(a)?s.configPath.scheme!==P.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?i.push(o):await this.z(a):await this.x(a)}}return i}async v(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!i.has(a)){i.add(a);const l=(0,A.$ic)(this.c,this.D(o));await this.B(l)?s.scheme!==P.Schemas.file||await p.Promises.exists(s.fsPath)?u.push(o):await this.z(l):await this.x(l)}}return u}async w(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const a=(0,A.$ic)(this.c,s);await this.B(a)?u.push(o):await this.x(a)}}return u}async x(t){try{await p.Promises.rm(t,p.RimRafMode.MOVE)}catch(u){this.l.error(`Backup: Could not delete stale backup: ${u.toString()}`)}}y(){let t=(0,b.$Ofc)();for(;this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.id));)t=(0,b.$Ofc)();return{backupFolder:t.id}}async z(t){const u=this.y(),i=(0,A.$ic)(this.c,u.backupFolder);try{await p.Promises.rename(t,i,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(u),!0}async getDirtyWorkspaces(){const t=[];for(const u of this.d)await this.A(u)&&t.push(u);for(const u of this.e)await this.A(u)&&t.push(u);return t}A(t){let u;return(0,c.$ufc)(t)?u=(0,A.$ic)(this.c,t.backupFolder):(0,g.$8hb)(t)?u=(0,A.$ic)(this.c,this.D(t)):u=(0,A.$ic)(this.c,t.workspace.id),this.B(u)}async B(t){try{const u=await p.Promises.readdir(t);for(const i of u)try{if((await p.Promises.readdir((0,A.$ic)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:u,remoteAuthority:i})=>{const o={id:u.id,configURIPath:u.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.e.map(({folderUri:u,remoteAuthority:i})=>{const o={folderUri:u.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.g.map(({backupFolder:u,remoteAuthority:i})=>{const o={backupFolder:u};return i&&(o.remoteAuthority=i),o})};this.m.setItem($.a,t)}D(t){const u=t.folderUri;let i;return u.scheme===P.Schemas.file?i=T.$l?u.fsPath:u.fsPath.toLowerCase():i=u.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$9fc=k,e.$9fc=k=$=Se([se(0,h.$qfc),se(1,m.$0i),se(2,f.$$j),se(3,d.$wR)],k)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[19],le([0,1,13,35,8,4,2,3,36,12,6,5,34,52,20]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.LifecycleMainPhase=e.ShutdownReason=e.$Wfc=void 0,n=Ve(n),e.$Wfc=(0,m.$Di)("lifecycleMainService");var v;(function(k){k[k.QUIT=1]="QUIT",k[k.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(k){k[k.Starting=1]="Starting",k[k.Ready=2]="Ready",k[k.AfterWindowOpen=3]="AfterWindowOpen",k[k.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends T.$Tc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(E,t,u){super(),this.F=E,this.G=t,this.H=u,this.c=this.B(new A.$ke),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.$ke),this.onWillShutdown=this.f.event,this.g=this.B(new A.$ke),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.$ke),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const E=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.default.app.addListener("before-quit",E);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",t),n.default.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.default.app.removeListener("before-quit",E),n.default.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}L(E){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:E,join(i,o){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===E)return;this.S(`lifecycle (main): phase changed (value: ${E})`),this.n=E;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(E){if(E<=this.n)return;let t=this.C.get(E);t||(t=new P.$Ch,this.C.set(E,t)),await t.wait()}registerWindow(E){const t=new T.$Sc;this.t++,t.add(E.onWillLoad(i=>this.g.fire({window:E,workspace:i.workspace,reason:i.reason})));const u=(0,c.$og)(E.win);t.add(A.Event.fromNodeEventEmitter(u,"close")(i=>{const o=E.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${E.id}`),i.preventDefault(),this.unload(E,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(E),E.close()})})),t.add(A.Event.fromNodeEventEmitter(u,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.t--,t.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(E){const t=(0,c.$og)(E.win),u=new T.$Sc;u.add(A.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${E.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),u.add(A.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${E.id}`),u.dispose()}))}async reload(E,t){await this.unload(E,w.UnloadReason.RELOAD)||E.reload(t)}unload(E,t){const u=this.z.get(E.id);if(u)return u;const i=this.M(E,t).finally(()=>{this.z.delete(E.id)});return this.z.set(E.id,i),i}async M(E,t){if(!E.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${E.id}`);const u=this.j?w.UnloadReason.QUIT:t,i=await this.P(E,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.N(i)):(await this.Q(E,u),!1)}N(E){return E?(this.O(!0),this.j=!1,!0):!1}O(E){this.w&&(this.w(E),this.w=void 0,this.u=void 0)}P(E,t){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$QX.once(o,()=>{u(!1)}),r.$QX.once(s,()=>{u(!0)}),E.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:t})})}Q(E,t){return new Promise(u=>{const o=`vscode:reply${this.s++}`;r.$QX.once(o,()=>u()),E.send("vscode:onWillUnload",{replyChannel:o,reason:t})})}quit(E){return this.R(E).then(t=>{if(!t&&E)try{if(I.$j){const u=(0,p.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return t})}R(E){return this.S(`Lifecycle#quit() - begin (willRestart: ${E})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(E&&this.G.setItem(g.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.u)}S(E){this.H.args["enable-smoke-test-driver"]?this.F.info(E):this.F.trace(E)}setRelaunchHandler(E){this.D=E}async relaunch(E){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(E?.addArgs&&t.push(...E.addArgs),E?.removeArgs)for(const o of E.removeArgs){const s=t.indexOf(o);s>=0&&t.splice(s,1)}const u=()=>{this.D?.handleRelaunch(E)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:t}))};n.default.app.once("quit",u),await this.quit(!0)&&n.default.app.removeListener("quit",u)}async kill(E){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,P.$Eh)(1e3),(async()=>{for(const t of n.default.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let u;t.webContents&&!t.webContents.isDestroyed()?u=new Promise(i=>t.once("closed",i)):u=Promise.resolve(),t.destroy(),await u}})()]),n.default.app.exit(E)}};e.$Xfc=$,e.$Xfc=$=g=Se([se(0,h.$$j),se(1,d.$wR),se(2,f.$qfc)],$)}),define(ce[254],le([0,1,3,4,2,6,19]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,n=Pe(n),e.$ugc=(0,A.$Di)("keyboardLayoutMainService");let I=class extends P.$Tc{constructor(m){super(),this.a=this.B(new r.$ke),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((h,d)=>{V(["native-keymap"],h,d)}).then(Pe);this.c=p(m),n.$u||m.onDidChangeKeyboardLayout(()=>{this.c=p(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$vgc=I,e.$vgc=I=Se([se(0,T.$Wfc)],I);function p(c){const m=c.getKeyMap(),h=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:h}}}),define(ce[255],le([0,1,215,8,17,15,12,16,38,100,5,49,214,252]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$es=v;let f=class extends h.$7p{constructor($,k,E,t){super(t),this.m=$,this.n=k,this.r=E,this.s(),this.B($.onDidChangeConfiguration(u=>{u.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,k){const{f:E,g:t}=this;let u;try{u=await(0,c.$Pm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(s)))}const i={...process.env,...u},o=$.agent?$.agent:await(0,d.$cs)($.url||"",i,{proxyUrl:E,strictSSL:t});return $.agent=o,$.strictSSL=t,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,k))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const k=await new Promise((o,s)=>{V(["kerberos"],o,s)}).then(Pe),E=new URL($),t=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${t}`),"Negotiate "+await(await k.initializeClient(t)).step("")}catch(k){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",k);return}}async loadCertificates(){return(await new Promise((k,E)=>{V(["@vscode/proxy-agent"],k,E)}).then(Pe)).loadSystemCertificates({log:this.r})}};e.$ds=f,e.$ds=f=Se([se(0,I.$0i),se(1,p.$Li),se(2,m.$$j),se(3,m.$_j)],f);async function g(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((E,t)=>{V(["https"],E,t)}).then(Pe):await new Promise((E,t)=>{V(["http"],E,t)}).then(Pe)).request}async function v(b,$){return r.Promises.withAsyncBody(async(k,E)=>{const t=(0,n.parse)(b.url),u=b.getRawRequest?b.getRawRequest(b):await g(b),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,T.$jg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=u(i,s=>{const a=(0,T.$hg)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:a-1},$).then(k,E);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),k({res:s,stream:(0,P.$2e)(l)})}});o.on("error",E),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),E(new A.$4)})})}}),define(ce[256],le([0,1,13,255]),function(V,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;function P(T){return n.net.request}class A extends r.$ds{request(I,p){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},p)}}e.$zhc=A}),define(ce[87],le([0,1,7,4,2,38,14,6,19,5,62,249,42,58,41,11]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=e.$4fc=e.$3fc=void 0,e.$3fc=(0,I.$Di)("storageMainService");let v=class extends P.$Tc{constructor(k,E,t,u,i,o){super(),this.c=k,this.f=E,this.g=t,this.h=u,this.j=i,this.m=o,this.a=void 0,this.b=this.B(new r.$ke),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)k.join("profileStorage",E.close());for(const[,E]of this.w)k.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.j.exists(k.profile.globalStorageHome)||await this.j.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const E=this.t.get(k.profile.id);E&&k.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const k=new h.$Zfc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),k}profileStorage(k){if((0,m.$jq)(k))return this.applicationStorage;let E=this.t.get(k.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),E=this.B(this.u(k)),this.t.set(k.id,E);const t=this.B(E.onDidChangeStorage(u=>this.b.fire({...u,storage:E,profile:k})));this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.t.delete(k.id),t.dispose()}))}return E}u(k){return this.a===p.ShutdownReason.KILL?new h.$2fc(this.c,this.j):new h.$Yfc(k,this.n(),this.c,this.j)}workspaceStorage(k){let E=this.w.get(k.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),E=this.B(this.y(k)),this.w.set(k.id,E),this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.w.delete(k.id)}))),E}y(k){return this.a===p.ShutdownReason.KILL?new h.$2fc(this.c,this.j):new h.$1fc(k,this.n(),this.c,this.f,this.j)}isUsed(k){const E=n.URI.file(k);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),E))return!0;return!1}};e.$4fc=v,e.$4fc=v=Se([se(0,c.$$j),se(1,A.$Ki),se(2,w.$Gfc),se(3,p.$Wfc),se(4,T.$$k),se(5,f.$Il)],v),e.$5fc=(0,I.$Di)("applicationStorageMainService");let b=class extends m.$iq{constructor(k,E){super(),this.s=k,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(k){if(k===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(k){if(k===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$6fc=b,e.$6fc=b=Se([se(0,d.$Kl),se(1,e.$3fc)],b)}),define(ce[257],le([0,1,93,27,113,104,8,2,3,16,5,28,208,211,101,131,17]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.$whc=e.$vhc=void 0,n=Pe(n),r=Pe(r);async function b(u,i,o,s,a){let l;for(let S=3;S&&(l?.dispose(),l=await new $(u,i,o,s,a).waitForReady(),!(a&&P.$3g[a]||!P.$3g[l.tunnelLocalPort]));S--);return l}class $ extends I.$Tc{constructor(i,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new T.$Ch,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,o=(0,g.$Kw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,P.$4g)(i,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(i){i.pause();const o=(0,g.$Iw)(this.tunnelRemoteHost)||(0,g.$Kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,d.$1l)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),a.end()}),i.on("close",()=>a.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),a instanceof A.$si?a.socket.destroy():a.end()}),a instanceof A.$si?this.t(i,a):this.s(i,a),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),a.end()})}s(i,o){o.onClose(()=>i.destroy()),o.onEnd(()=>i.end()),o.onData(s=>i.write(s.buffer)),i.on("data",s=>o.write(v.$Me.wrap(s))),i.resume()}t(i,o){const s=o.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$vhc=$;let k=class extends g.$Nw{constructor(i,o,s,a,l){super(o,l),this.H=i,this.I=s,this.J=a}isPortPrivileged(i){return(0,g.$Lw)(i,this.t,p.OS,r.release())}F(i,o,s,a,l,S,y,D){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,g.$Ew)(i))return this.G(i,o,s,l,S,y,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const R={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=b(R,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$whc=k,e.$whc=k=Se([se(0,w.$Ul),se(1,m.$$j),se(2,f.$Xl),se(3,h.$rk),se(4,c.$0i)],k);let E=class extends k{constructor(i,o,s,a,l){super(i,o,s,a,l)}};e.$xhc=E,e.$xhc=E=Se([se(0,w.$Ul),se(1,m.$$j),se(2,f.$Xl),se(3,h.$rk),se(4,c.$0i)],E);let t=class extends I.$Tc{constructor(i,o,s,a,l){super(),this.b=i,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(i,o,s,a,l,S,y,D,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${S}.`),!this.a.has(i)){const R=new E(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(i,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(o,s,a,l,S,y,D,L)}};e.$yhc=t,e.$yhc=t=Se([se(0,w.$Ul),se(1,m.$$j),se(2,h.$rk),se(3,f.$Xl),se(4,c.$0i)],t)}),define(ce[105],le([0,1,8,22,4,16,20,19,5,28,49,50]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0,e.$Rgc=d;function d(f,g,v){return`${v.updateUrl}/api/update/${f}/${g}/${v.commit}`}let w=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,v,b,$,k,E){this.f=g,this.g=v,this.h=b,this.i=$,this.j=k,this.k=E,this.b=h.$OY.Uninitialized,this.c=new P.$ke,this.onStateChange=this.c.event,g.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(h.$OY.Disabled(h.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(h.$OY.Disabled(h.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(h.$OY.Disabled(h.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.g.getValue("update.mode"),v=this.m(g);if(!v){this.d(h.$OY.Disabled(h.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(h.$OY.Disabled(h.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(h.$OY.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,n.$Eh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(g){}q(){return h.UpdateType.Archive}r(){}};e.$Sgc=w,e.$Sgc=w=Se([se(0,I.$Wfc),se(1,A.$0i),se(2,T.$qfc),se(3,m.$6p),se(4,p.$$j),se(5,c.$rk)],w)}),define(ce[258],le([0,1,13,54,4,46,2,16,20,19,5,28,49,24,50,105]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0,n=Pe(n);let v=class extends g.$Sgc{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,k)=>k)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,k,E,t)=>({version:E,productVersion:E,timestamp:t}))}constructor($,k,E,t,u,i,o){super($,k,t,u,i,o),this.z=E,this.u=new T.$Sc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,A.$rj)(String($)))}),this.j.error("UpdateService error:",$);const k=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$OY.Idle(f.UpdateType.Archive,k))}s($){let k;this.k.darwinUniversalAssetId?k=this.k.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,g.$Rgc)(k,$,this.k);try{n.autoUpdater.setFeedURL({url:E})}catch(t){this.j.error("Failed to set update feed URL",t);return}return E}t($){this.d(f.$OY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$OY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$OY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$OY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$OY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Tgc=v,Se([r.$8h],v.prototype,"v",null),Se([r.$8h],v.prototype,"w",null),Se([r.$8h],v.prototype,"x",null),Se([r.$8h],v.prototype,"y",null),e.$Tgc=v=Se([se(0,c.$Wfc),se(1,I.$0i),se(2,w.$0l),se(3,p.$qfc),se(4,d.$6p),se(5,m.$$j),se(6,h.$rk)],v)}),define(ce[259],le([0,1,48,26,8,4,9,20,19,5,24,50]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0,T=Pe(T);let d=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,v,b){if(this.f=g,this.g=b,this.a=h.$OY.Uninitialized,this.b=new A.$ke,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(h.$OY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(g=60*60*1e3){return(0,P.$Eh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return h.UpdateType.Snap}l(){}async _applySpecificUpdate(g){}};d=Se([se(0,p.$Wfc),se(1,I.$qfc),se(2,c.$$j)],d);let w=class extends d{constructor(g,v,b,$,k,E){super(b,$,k),this.o=g,this.p=v,this.q=E;const t=(0,r.watch)(T.$lc(this.o)),u=A.Event.fromNodeEventEmitter(t,"change",(a,l)=>l),i=A.Event.filter(u,a=>a==="current"),s=A.Event.debounce(i,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(h.$OY.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(h.$OY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$OY.Idle(h.UpdateType.Snap)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$OY.Idle(h.UpdateType.Snap,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((b,$)=>(0,r.realpath)(`${T.$lc(this.o)}/current`,(k,E)=>k?$(k):b(E))),v=T.$mc(g);return this.p!==v}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Vgc=w,e.$Vgc=w=Se([se(2,p.$Wfc),se(3,I.$qfc),se(4,c.$$j),se(5,m.$0l)],w)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[29],le([0,1,13,3,6,52,51,76,28,16,20,9,140]),function(V,e,n,r,P,A,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Dfc=void 0,e.$Efc=f,e.$Ffc=g,n=Ve(n),e.$Dfc=(0,P.$Di)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,k){const E=b.get(I.$Bfc),t=b.get(p.$rk),u=b.get(c.$0i),i=b.get(m.$qfc),o=u.getValue("window"),s={backgroundColor:E.getBackgroundColor(),minWidth:T.$6D.WIDTH,minHeight:T.$6D.HEIGHT,title:t.nameLong,show:$.mode!==A.WindowMode.Maximized&&$.mode!==A.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...k,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,T.$fE)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$l?s.icon=(0,h.$ic)(i.appRoot,"resources/linux/code.png"):r.$j&&!i.isBuilt&&(s.icon=(0,h.$ic)(i.appRoot,"resources/win32/code_150x150.png")),r.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$k&&!(0,T.$eE)(u)&&(s.fullscreenable=!1),r.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,T.$aE)(u)&&(s.titleBarStyle="hidden",r.$k||(s.frame=!1),(0,T.$dE)(u))){const S=E.getWindowSplash()?.colorInfo.titleBarBackground??E.getBackgroundColor(),y=d.$mu.fromHex(S).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:S,symbolColor:y}}return s}function g(b){let $,k=Number.MIN_VALUE;for(const E of b)E.lastFocusTime>k&&(k=E.lastFocusTime,$=E);return $}var v;(function(b){function $(E,t,u=n.default.screen.getAllDisplays()){if(E.trace(`window#validateWindowState: validating window state on ${u.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){E.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){E.trace("window#validateWindowState: unexpected negative values");return}if(u.length===1){const s=k(u[0]);if(E.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};a(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),a()}return t}if(t.display&&t.mode===A.WindowMode.Fullscreen){const s=u.find(a=>a.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){E.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,A.$sfc)(A.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let i,o;try{i=n.default.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),o=k(i),E.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){E.error("window#validateWindowState: error finding display for window state",s)}if(i&&o&&t.x+t.width>o.x&&t.y+t.height>o.y&&t.x<o.x+o.width&&t.y<o.y+o.height)return t;E.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function k(E){if(E.workArea.width>0&&E.workArea.height>0)return E.workArea;if(E.bounds.width>0&&E.bounds.height>0)return E.bounds}})(v||(e.WindowStateValidator=v={}))}),define(ce[260],le([0,1,93,167,120,29]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class T extends r.$Xo{constructor(p){super(),this.f=p}call(p,c,m){return c==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(p,c,m)}async g(p,c){const m=(0,P.$Bm)(p,P.$Am);m.debugRenderer=c;const h=m.extensionDevelopmentPath;if(!h)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow(h,{context:A.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const w=d.win;if(!w)return{success:!0};const f=w.webContents.debugger;let g=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{g++===0&&f.attach();let $=!1;const k=u=>{$||b.write(JSON.stringify(u)+"\0")},E=(u,i,o,s)=>k({method:i,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",E),b.end(),$=!0}),f.addListener("message",E);let t=Buffer.alloc(0);b.on("data",u=>{t=Buffer.concat([t,u]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let o;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>k({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>k({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{$=!0,--g===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$0fc=T}),define(ce[261],le([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(V,e,n,r,P,A,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=e.ID=void 0,e.ID="launchMainService",e.$xgc=(0,c.$Di)(e.ID);let w=class{constructor(g,v,b,$){this.a=g,this.b=v,this.c=b,this.d=$}async start(g,v){this.a.trace("Received data from other instance: ",g,v),P.$k&&n.app.focus({steal:!0});const b=this.e(g);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,r.$Nb)(await this.b.openEmptyWindow({context:d.OpenContext.DESKTOP}));k&&($=k.ready())}$.then(()=>{for(const{uri:k,originalUrl:E}of b)this.c.open(k,{originalUrl:E})})}else return this.f(g,v)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,r.$Gb)(g._urls.map(v=>{try{return{uri:A.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(g,v){const b=(0,p.$Im)(v)?d.OpenContext.CLI:d.OpenContext.DESKTOP;let $=[];const k=g.wait&&g.waitMarkerFilePath?A.URI.file(g.waitMarkerFilePath):void 0,E=g.remote||void 0,t={context:b,cli:g,userEnv:g["preserve-env"]||b===d.OpenContext.CLI?v:void 0,waitMarkerFileURI:k,remoteAuthority:E,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,t);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let u=!1;if(g["new-window"]||t.forceProfile||t.forceTempProfile)u=!0;else if(g["reuse-window"])u=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!P.$k}if(u)$=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),$=[i]):$=await this.b.open({...t,forceEmpty:!0})}}else $=await this.b.open({...t,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(k&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$ygc=w,e.$ygc=w=Se([se(0,m.$$j),se(1,d.$Dfc),se(2,h.$FY),se(3,I.$0i)],w)}),define(ce[135],le([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0,e.$7fc=(0,d.$Di)("proxyAuthService");let b=class extends T.$Tc{constructor(k,E,t,u,i,o){super(),this.h=k,this.m=E,this.n=t,this.r=u,this.s=i,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const k=P.Event.fromNodeEventEmitter(n.app,"login",(E,t,u,i,o)=>({event:E,authInfo:{...i,attempt:u.firstAuthAttempt?1:2},callback:o}));this.B(k(this.w,this))}async lookupAuthorization(k){return this.w({authInfo:k})}async w({event:k,authInfo:E,callback:t}){if(!E.isProxy)return;k?.preventDefault();const u=String((0,A.$rj)({scheme:E.scheme,host:E.host,port:E.port}));let i,o=this.b.get(u);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),i=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(E,u),this.b.set(u,o);try{i=await o}finally{this.b.delete(u)}}return t?.(i?.username,i?.password),i}async y(k,E){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const t=await this.z(k,E);if(t)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),t;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(k,E){if(this.h.trace("auth#doResolveProxyCredentials - enter",k),this.t.extensionTestsLocationURI){const a=this.s.getValue("integration-test.http.proxyAuth");if(a){const l=a.indexOf(":");return l!==-1?{username:a.substring(0,l),password:a.substring(l+1)}:{username:a,password:""}}return}const t=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(t?.indexOf("@")!==-1){const a=I.URI.parse(t),l=a.authority.indexOf("@");if(l!==-1){if(k.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const S=a.authority.substring(0,l),y=S.indexOf(":");return y!==-1?{username:S.substring(0,y),password:S.substring(y+1)}:{username:S,password:""}}}if(k.attempt===1&&this.g.has(E)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:a,password:l}=this.g.get(E);return{username:a,password:l}}let u,i;try{const a=this.r.get(this.a+E,f.StorageScope.APPLICATION);if(a){const l=JSON.parse(await this.n.decrypt(a));u=l.username,i=l.password}}catch(a){this.h.error(a)}if(k.attempt===1&&typeof u=="string"&&typeof i=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(E,{username:u,password:i}),{username:u,password:i};const o=this.c,s=this.c=(async()=>{await o;const a=await this.C(k,E,u,i);return this.c===s&&(this.c=void 0),a})();return s}async C(k,E,t,u){if(this.f.has(E)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const i=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!i){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${i.id} to handle proxy login`);const o=this.g.get(E),s={authInfo:k,username:o?.username??t,password:o?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,p.$Zg)()}`};i.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,s);const a=await new Promise(l=>{const S=async(y,D,L)=>{if(D===s.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${i.id}`),i.win?.webContents.off("ipc-message",S),L){const R={username:L.username,password:L.password};try{if(L.remember){const O=await this.n.encrypt(JSON.stringify(R));this.r.store(this.a+E,O,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+E,f.StorageScope.APPLICATION)}catch(O){this.h.error(O)}l({username:R.username,password:R.password})}else this.f.add(E),l(void 0)};i.win?.webContents.on("ipc-message",S)});return this.g.set(E,a),a}};e.$8fc=b,e.$8fc=b=Se([se(0,w.$$j),se(1,v.$Dfc),se(2,m.$zY),se(3,g.$5fc),se(4,c.$0i),se(5,h.$qfc)],b)}),define(ce[262],le([0,1,2,19,52,58,30,8,29]),function(V,e,n,r,P,A,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let c=class extends n.$Tc{constructor(h,d,w){super(),this.a=d,this.b=w,this.B(h.onWillLoadWindow(f=>{f.reason===P.LoadReason.LOAD&&this.c(f.window)})),this.B(h.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Ph(()=>this.g(),30*1e3)).schedule()}async c(h){const d=this.f(h),w=this.a.getProfileForWorkspace(d);w?.isTransient&&(this.a.unsetWorkspace(d,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(h){return h.openedWorkspace??(0,T.$Ri)(h.backupPath,h.isExtensionDevelopmentHost)}g(){const h=this.a.getAssociatedEmptyWindows();if(h.length===0)return;const d=this.b.getWindows().map(w=>this.f(w));for(const w of h)d.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$bhc=c,e.$bhc=c=Se([se(0,r.$Wfc),se(1,A.$Gfc),se(2,p.$Dfc)],c)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[63],le([0,1,13,2,4,5,282,8,11,29,81,24,19,79,37,3,106]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0,m=Ve(m);function $(t){return typeof t.responseWindowId=="number"}let k=class extends r.$Tc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(u,i,o){super(),this.w=u,this.y=i,this.z=o,this.c=String(++b.a),this.f=this.B(new P.$ke),this.onStdout=this.f.event,this.g=this.B(new P.$ke),this.onStderr=this.g.event,this.h=this.B(new P.$ke),this.onMessage=this.h.event,this.j=this.B(new P.$ke),this.onSpawn=this.j.event,this.m=this.B(new P.$ke),this.onExit=this.m.event,this.n=this.B(new P.$ke),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(u,i){let o;switch(this.t?.correlationId?o=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`:o=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`,i){case m.default.Error:this.w.error(o);break;case m.default.Warning:this.w.warn(o);break;case m.default.Info:this.w.trace(o);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(u){const i=this.F(u);return i&&u.payload&&this.postMessage(u.payload)&&this.C("payload sent via postMessage()",m.default.Info),i}F(u){if(!this.D())return!1;this.t=u;const i=`${this.t.type}-${this.c}`,o=p.$Xg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],a=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,S=this.t.forceAllocationsToV8Sandbox,y=this.t.respondToAuthRequestsFromMainProcess,D="pipe",L=this.G(u);return this.C("creating new...",m.default.Info),this.r=n.utilityProcess.fork(o,s,{serviceName:i,env:L,execArgv:a,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:S,respondToAuthRequestsFromMainProcess:y,stdio:D}),this.H(this.r,this.t,i),!0}G(u){const i=u.env?{...u.env}:{...(0,f.$co)(process.env)};i.VSCODE_AMD_ENTRYPOINT=u.entryPoint,typeof u.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(u.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=u.type,g.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$km)(i);for(const o of Object.keys(i))i[o]=String(i[o]);return i}H(u,i,o){if(u.stdout){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stdout,"data")(a=>this.f.fire(typeof a=="string"?a:s.write(a))))}if(u.stderr){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stderr,"data")(a=>this.g.fire(typeof a=="string"?a:s.write(a))))}this.B(P.Event.fromNodeEventEmitter(u,"message")(s=>this.h.fire(s))),this.B(P.Event.fromNodeEventEmitter(u,"spawn")(()=>{this.s=u.pid,typeof u.pid=="number"&&b.b.set(u.pid,{pid:u.pid,name:$(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",m.default.Info),this.j.fire(u.pid)})),this.B(P.Event.fromNodeEventEmitter(u,"exit")(s=>{const a=this.I(s)?0:s;this.C(`received exit event with code ${a}`,m.default.Info),this.m.fire({pid:this.s,code:a,signal:"unknown"}),this.J()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,a)=>({event:s,details:a}))(({details:s})=>{s.type==="Utility"&&s.name===o&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(u,i){const o=this.B(this.h.event(s=>{s===u&&(o.dispose(),i())}))}postMessage(u,i){return this.r?(this.r.postMessage(u,i),!0):!1}connect(u){const{port1:i,port2:o}=new n.MessageChannelMain;return this.postMessage(u,[o]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const u=process;return typeof u._debugProcess=="function"?(u._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(u){return u===0?!0:this.u&&u===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(u){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.$Eh)(u)]),this.r&&(this.C(`did not exit within ${u}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$$fc=k,e.$$fc=k=b=Se([se(0,A.$$j),se(1,h.$0l),se(2,d.$Wfc)],k);let E=class extends k{constructor(u,i,o,s){super(u,o,s),this.L=i}start(u){const i=this.L.getWindowById(u.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(u))return!1;this.M(i.win,u);const s=this.connect(u.payload);return i.win.webContents.postMessage(u.responseChannel,u.responseNonce,[s]),!0}M(u,i){i.windowLifecycleBound&&(this.B(P.Event.filter(this.z.onWillLoadWindow,o=>o.window.win===u)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(u,"closed")(()=>this.kill())))}};e.$_fc=E,e.$_fc=E=Se([se(0,A.$$j),se(1,c.$Dfc),se(2,h.$0l),se(3,d.$Wfc)],E)}),define(ce[263],le([0,1,8,15,4,2,19,5,24,63,29]),function(V,e,n,r,P,A,T,I,p,c,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;let d=class extends A.$Tc{static{h=this}static{this.a=0}constructor(f,g,v,b){super(),this.f=f,this.g=g,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const g=this.b.get(f);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++h.a),g=new c.$_fc(this.f,this.h,this.j,this.g);this.b.set(f,g);const v=g.onExit(({pid:b,code:$,signal:k})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${k}.`),setTimeout(()=>{g.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,g){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await P.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);return g?g.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);g&&g.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const g=[];for(const[,v]of this.b)g.push(v.waitForExit(f));return n.Promises.settled(g).then(()=>{})}};e.$ggc=d,e.$ggc=d=h=Se([se(0,I.$$j),se(1,T.$Wfc),se(2,m.$Dfc),se(3,p.$0l)],d)}),define(ce[264],le([0,1,35,8,2,20,19,5,42,40,71,63,57,95,12,216,4]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let b=class extends P.$Tc{constructor(k,E,t,u,i,o,s,a,l){super(),this.g=k,this.h=E,this.j=t,this.m=u,this.n=i,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Ch,this.b=void 0,this.c=void 0,this.f=this.B(new v.$ke),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$QX.on(g.$Jgc.request,(k,E)=>this.y(k,E,g.$Jgc.response)),n.$QX.on(g.$Kgc.request,(k,E)=>this.y(k,E,g.$Kgc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(k,E,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(t);if(k.sender.isDestroyed())return u.close();k.sender.postMessage(t,E,[u])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(g.$Igc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const k=new r.$1h;this.b?.once(g.$Igc.initDone,()=>k.complete()),await k.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const k=new r.$1h;this.b?.once(g.$Igc.ipcReady,()=>k.complete()),await k.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new h.$$fc(this.s,d.$xp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const k=(0,w.$9m)(this.m.args,this.m.isBuilt);let E;k.port&&(E=["--nolazy"],k.break?E.push(`--inspect-brk=${k.port}`):E.push(`--inspect=${k.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:E}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(k){return await this.F,(0,f.$og)(this.b).connect(k)}};e.$Lgc=b,e.$Lgc=b=Se([se(3,A.$qfc),se(4,p.$Kl),se(5,T.$Wfc),se(6,I.$$j),se(7,m.$Rfc),se(8,c.$ro)],b)}),define(ce[265],le([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,11]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;let v=class extends h.$Tc{constructor($,k,E,t,u){super(),this.f=$,this.g=k,this.h=E,this.j=t,this.m=u,this.a=void 0,this.b=new d.$ke,this.onRequestConnection=this.b.event,this.c=new d.$ke,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$QX.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,h.$Rc)(()=>{m.$QX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$$fc(this.m,T.$xp,this.j);const $=(0,r.$8m)(this.h.args,this.h.isBuilt),k=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:k,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const E=this.a.connect(),t=new c.$YX(E,"ptyHost"),u=new h.$Sc;return u.add(t),u.add((0,h.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$co)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);k&&typeof k=="number"&&($.VSCODE_LATENCY=String(k));const E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return E&&typeof E=="number"&&($.VSCODE_STARTUP_DELAY=String(E)),this.h.restoreSnapExportedVariables(),$}r($,k){this.b.fire();const E=this.a.connect();if($.sender.isDestroyed()){E.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",k,[E])}};e.$nhc=v,e.$nhc=v=Se([se(1,f.$0i),se(2,n.$qfc),se(3,P.$Wfc),se(4,A.$$j)],v)}),define(ce[266],le([0,1,2,6,5,29,63,24,46,4,8,19]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0,e.$lhc=(0,r.$Di)("utilityProcessWorker");let d=class extends n.$Tc{constructor(g,v,b,$){super(),this.b=g,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(g);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(g));const $=new w(this.b,this.c,this.f,this.g,g);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const k=new m.$1h;return c.Event.once($.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(b),k.complete({reason:E})}),k.p}h(g){return(0,p.$rj)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const v=this.h(g),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$mhc=d,e.$mhc=d=Se([se(0,P.$$j),se(1,A.$Dfc),se(2,I.$0l),se(3,h.$Wfc)],d);let w=class extends n.$Tc{constructor(g,v,b,$,k){super(),this.c=g,this.f=v,this.g=b,this.h=$,this.j=k,this.a=this.B(new c.$ke),this.onDidTerminate=this.a.event,this.b=this.B(new T.$_fc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(g=>this.a.fire({code:g.code,signal:g.signal}))),this.B(this.b.onCrash(g=>this.a.fire({code:g.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Se([se(0,P.$$j),se(1,A.$Dfc),se(2,I.$0l),se(3,h.$Wfc)],w)}),define(ce[267],le([0,1,13,4,2,241,29]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;let I=class extends P.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new r.$ke),this.onFoundInFrame=this.a.event,this.B(new A.$3gc)}async setIgnoreMenuShortcuts(c,m){let h;if(typeof c.windowId=="number"){const{windowId:d}=c,w=this.b.getWindowById(d);if(!w?.win)throw new Error(`Invalid windowId: ${d}`);h=w.win.webContents}else{const{webContentsId:d}=c;if(h=n.webContents.fromId(d),!h)throw new Error(`Invalid webContentsId: ${d}`)}h.isDestroyed()||h.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,h,d){const f=this.c(c,m);if(typeof f.findInFrame=="function"){f.findInFrame(h,{findNext:d.findNext,forward:d.forward});const g=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",g))};f.on("found-in-frame",g)}}async stopFindInFrame(c,m,h){const w=this.c(c,m);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(h.keepSelection?"keepSelection":"clearSelection")}c(c,m){const h=this.b.getWindowById(c.windowId);if(!h?.win)throw new Error(`Invalid windowId: ${c}`);const d=h.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===m);if(!d)throw new Error(`Unknown frame: ${m}`);return d}};e.$4gc=I,e.$4gc=I=Se([se(0,T.$Dfc)],I)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[268],le([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0,e.$6gc=v,e.$7gc=$,n=Ve(n);let g=class extends r.$Tc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,u,i,o,s){super(),this.g=t,this.h=u,this.j=i,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,u={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!u.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.w(s),u.lastActiveWindow.uiState.mode===d.WindowMode.Fullscreen&&t.add(u.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(u.lastPluginDevelopmentHostWindow=this.w(i),u.lastPluginDevelopmentHostWindow.uiState.mode===d.WindowMode.Fullscreen&&(t.has(u.lastPluginDevelopmentHostWindow.uiState.display)?P.$k&&!i.win?.isSimpleFullScreen()&&(u.lastPluginDevelopmentHostWindow.uiState.mode=d.WindowMode.Normal):t.add(u.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(u.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===d.WindowMode.Fullscreen&&(t.has(a.uiState.display)?P.$k&&a.windowId!==u.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=d.WindowMode.Normal):t.add(a.uiState.display)),a}));const o=$(u);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(t){if(this.j.quitRequested)return;const u=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=u:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const o=(0,w.$Si)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Ni)(t.openedWorkspace)&&i.folderUri&&A.$8g.isEqual(i.folderUri,t.openedWorkspace.uri);(o||s)&&(i.uiState=u.uiState)}),this.g.getWindowCount()===1&&(this.c=u)}w(t){return{windowId:t.id,workspace:(0,w.$Si)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Ni)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const u=this.z(t),i=this.n.getValue("window");if(u.mode===d.WindowMode.Fullscreen){let o;u.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||i?.restoreFullscreen),o||(u.mode=d.WindowMode.Normal)}return u}z(t){const u=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=t.workspace;if((0,w.$Si)(S)){const D=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===S.id).map(L=>L.uiState);if(D.length)return D[0]}if((0,w.$Ni)(S)){const D=this.state.openedWindows.filter(L=>L.folderUri&&A.$8g.isEqual(L.folderUri,S.uri)).map(L=>L.uiState);if(D.length)return D[0]}else if(t.backupPath){const D=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(D.length)return D[0]}const y=this.c||this.state.lastActiveWindow;if(!u&&y)return y.uiState}let i;const o=n.default.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(P.$k){const S=n.default.screen.getCursorScreenPoint();i=n.default.screen.getDisplayNearestPoint(S)}!i&&u&&(i=n.default.screen.getDisplayMatching(u.getBounds())),i||(i=n.default.screen.getPrimaryDisplay()||o[0])}let s=(0,d.$sfc)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=d.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=d.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&u){const S=u.serializeWindowState();S.mode===d.WindowMode.Fullscreen?s.mode=d.WindowMode.Fullscreen:s={...S,zoomLevel:void 0},l=s.mode!==d.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const u=this.g.getWindows().map(i=>i.getBounds());for(;u.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$5gc=g,e.$5gc=g=f=Se([se(0,h.$Dfc),se(1,m.$wR),se(2,p.$Wfc),se(3,c.$$j),se(4,I.$0i)],g);function v(E){const t={openedWindows:[]},u=E||{openedWindows:[]};return u.lastActiveWindow&&(t.lastActiveWindow=b(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=b(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(t.openedWindows=u.openedWindows.map(i=>b(i))),t}function b(E){const t={uiState:E.uiState};return E.backupPath&&(t.backupPath=E.backupPath),E.remoteAuthority&&(t.remoteAuthority=E.remoteAuthority),E.folder&&(t.folderUri=T.URI.parse(E.folder)),E.workspaceIdentifier&&(t.workspace={id:E.workspaceIdentifier.id,configPath:T.URI.parse(E.workspaceIdentifier.configURIPath)}),t}function $(E){return{lastActiveWindow:E.lastActiveWindow&&k(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&k(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(t=>k(t))}}function k(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[59],le([0,1,26,13,4,43,2,11,9,18,23,10,69,53,20,6,5,58,134,30,102,103]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0,n=Pe(n),r=Ve(r),e.$Pfc=(0,g.$Di)("workspacesManagementMainService");let u=class extends T.$Tc{constructor(o,s,a,l,S){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=S,this.a=this.B(new P.$ke),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new P.$ke),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$eh)(this.c,s,k.$3i));for(const s of o){const a=(0,t.$Mfc)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,k.$4i)(o,this.g)||(0,k.$9i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,t.$Mfc)(o);return{id:l.id,configPath:l.configPath,folders:(0,E.$dib)(a.folders,l.configPath,c.$8g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,A.$Wn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,E.$bib)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),S=a.configPath.fsPath;return await n.promises.mkdir((0,p.$lc)(S),{recursive:!0}),await m.Promises.writeFile(S,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$eh)(this.c,a),S=(0,c.$eh)(l,k.$3i),y=[];for(const D of o)y.push((0,E.$cib)(D.uri,!0,D.name,l,c.$8g));return{workspace:(0,t.$Mfc)(S),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,t.$Mfc)(o)}isUntitledWorkspace(o){return(0,k.$4i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$5g)(o.configPath);try{await m.Promises.rm((0,p.$lc)(s));const a=(0,p.$ic)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(a)&&await m.Promises.writeFile((0,p.$ic)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const S=await this.C(o,(0,t.$Mfc)(a));if(S)return this.b.fire({window:o,workspace:S.workspace}),S}async z(o,s,a){return a?(0,k.$Si)(o.openedWorkspace)&&c.$8g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$Jfc)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(10962,null)],message:(0,h.localize)(10963,null,(0,c.$bh)(a)),detail:(0,h.localize)(10964,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,k.$Si)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$Qfc=u,e.$Qfc=u=Se([se(0,f.$qfc),se(1,v.$$j),se(2,b.$Gfc),se(3,d.$xfc),se(4,w.$yfc)],u)}),define(ce[136],le([0,1,13,35,22,6,29,30,59,12,5,63]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.ID=void 0,e.ID="diagnosticsMainService",e.$bgc=(0,A.$Di)(e.ID);let d=class{constructor(f,g,v){this.a=f,this.b=g,this.c=v}async getRemoteDiagnostics(f){const g=this.a.getWindows();return(await Promise.all(g.map(async b=>{const $=b.remoteAuthority;if(!$)return;const k=`vscode:getDiagnosticInfoResponse${b.id}`,E={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(t=>{b.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:k,args:E}),r.$QX.once(k,(u,i)=>{i||t({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),t(i)}),setTimeout(()=>{t({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const g=[];for(const{pid:v,name:b}of h.$$fc.getAll())g.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:g,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const g=await this.f(f),v=(0,c.$og)(f.win);return this.e(v,g,f.remoteAuthority)}e(f,g=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:g,remoteAuthority:v}}async f(f){const g=[],v=f.openedWorkspace;if((0,I.$Ni)(v))g.push(v.uri);else if((0,I.$Si)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(k=>{g.push(k.uri)})}return g}};e.$cgc=d,e.$cgc=d=Se([se(0,T.$Dfc),se(1,p.$Pfc),se(2,m.$$j)],d)}),define(ce[64],le([0,1,26,48,13,27,154,54,4,2,11,9,3,7,112,92,23,113,10,53,20,6,19,5,28,76,29,30,59,17,212,202,84,15,16,135,49]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R,O,M,x,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=void 0,n=Pe(n),e.$qgc=(0,t.$Di)("nativeHostMainService");let K=class extends c.$Tc{constructor(H,J,U,Z,B,j,C,Y,oe,G,ue,re){super(),this.a=H,this.b=J,this.c=U,this.f=Z,this.g=B,this.h=j,this.j=C,this.m=Y,this.n=oe,this.r=G,this.s=ue,this.t=re,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,Q=>Q.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Q,x:F,y:N})=>({windowId:Q.id,x:F,y:N})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:Q,x:F,y:N})=>({windowId:Q.id,x:F,y:N}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,Q=>Q.id),p.Event.map(this.b.onDidMaximizeWindow,Q=>Q.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,Q=>Q.id),p.Event.map(this.b.onDidUnmaximizeWindow,Q=>Q.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,Q=>({windowId:Q.window.id,fullscreen:Q.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,Q=>({windowId:Q.window.id,fullscreen:Q.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(Q,F)=>F.id),Q=>!!this.a.getWindowById(Q)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Q=>!!Q),Q=>Q.id),p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(Q,F)=>F.id),Q=>!!this.a.getWindowById(Q))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(Q,F)=>this.b.getWindowByWebContents(F.webContents)),Q=>!!Q),Q=>Q.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(Q,F)=>this.b.getWindowByWebContents(F.webContents)),Q=>!!Q),Q=>Q.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(P.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new p.$ke),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(P.screen,"display-metrics-changed",(Q,F,N)=>N),Q=>!(Array.isArray(Q)&&Q.length===1&&Q[0]==="workArea")),p.Event.fromNodeEventEmitter(P.screen,"display-added"),p.Event.fromNodeEventEmitter(P.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(H,J){const U=this.a.getWindows().map(B=>({id:B.id,workspace:B.openedWorkspace??(0,l.$Ri)(B.backupPath,B.isExtensionDevelopmentHost),title:B.win?.getTitle()??"",filename:B.getRepresentedFilename(),dirty:B.isDocumentEdited()})),Z=[];return J.includeAuxiliaryWindows&&Z.push(...this.b.getWindows().map(B=>({id:B.id,parentId:B.parentId,title:B.win?.getTitle()??"",filename:B.getRepresentedFilename()}))),[...U,...Z]}async getWindowCount(H){return this.a.getWindowCount()}async getActiveWindowId(H){const J=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(J)return J.id}openWindow(H,J,U){return Array.isArray(J)?this.w(H,J,U):this.z(H,J)}async w(H,J,U=Object.create(null)){J.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:H,urisToOpen:J,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async z(H,J){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:H},J)}async isFullScreen(H,J){return this.H(J?.targetWindowId,H)?.isFullScreen??!1}async toggleFullScreen(H,J){this.H(J?.targetWindowId,H)?.toggleFullScreen()}async handleTitleDoubleClick(H,J){this.H(J?.targetWindowId,H)?.handleTitleDoubleClick()}async getCursorScreenPoint(H){const J=P.screen.getCursorScreenPoint(),U=P.screen.getDisplayNearestPoint(J);return{point:J,display:U.bounds}}async isMaximized(H,J){return this.H(J?.targetWindowId,H)?.win?.isMaximized()??!1}async maximizeWindow(H,J){this.H(J?.targetWindowId,H)?.win?.maximize()}async unmaximizeWindow(H,J){this.H(J?.targetWindowId,H)?.win?.unmaximize()}async minimizeWindow(H,J){this.H(J?.targetWindowId,H)?.win?.minimize()}async moveWindowTop(H,J){this.H(J?.targetWindowId,H)?.win?.moveTop()}async positionWindow(H,J,U){const Z=this.H(U?.targetWindowId,H);if(Z?.win){if(Z.win.isFullScreen()){const B=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(Z.win,"leave-full-screen")));Z.win.setFullScreen(!1),await B}Z.win.setBounds(J)}}async updateWindowControls(H,J){this.H(J?.targetWindowId,H)?.updateWindowControls(J)}async focusWindow(H,J){this.H(J?.targetWindowId,H)?.focus({force:J?.force??!1})}async setMinimumSize(H,J,U){const Z=this.I(H);if(Z?.win){const[B,j]=Z.win.getSize(),[C,Y]=Z.win.getMinimumSize(),[oe,G]=[J??C,U??Y],[ue,re]=[Math.max(B,oe),Math.max(j,G)];(C!==oe||Y!==G)&&Z.win.setMinimumSize(oe,G),(B!==ue||j!==re)&&Z.win.setSize(ue,re)}}async saveWindowSplash(H,J){this.m.saveWindowSplash(H,J)}async installShellCommand(H){const{source:J,target:U}=await this.C();try{const{symbolicLink:Z}=await v.SymlinkSupport.stat(J);if(Z&&!Z.dangling){const B=await(0,f.$lr)(J);if(U===B)return}await n.promises.unlink(J)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await n.promises.symlink(U,J)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:B}=await this.showMessageBox(H,{type:"info",message:(0,$.localize)(11215,null,this.j.nameShort),buttons:[(0,$.localize)(11216,null),(0,$.localize)(11217,null)]});if(B===1)throw new O.$4;try{const j=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${J}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(j)}catch{throw new Error((0,$.localize)(11218,null,J))}}}async uninstallShellCommand(H){const{source:J}=await this.C();try{await n.promises.unlink(J)}catch(U){switch(U.code){case"EACCES":{const{response:Z}=await this.showMessageBox(H,{type:"info",message:(0,$.localize)(11219,null,this.j.nameShort),buttons:[(0,$.localize)(11220,null),(0,$.localize)(11221,null)]});if(Z===1)throw new O.$4;try{const B=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(B)}catch{throw new Error((0,$.localize)(11222,null,J))}break}case"ENOENT":break;default:throw U}}}async C(){const H=(0,h.$jc)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(H))throw new Error((0,$.localize)(11223,null,H));return{source:J,target:H}}async showMessageBox(H,J){const U=this.H(J?.targetWindowId,H);return this.c.showMessageBox(J,U?.win??void 0)}async showSaveDialog(H,J){const U=this.H(J?.targetWindowId,H);return this.c.showSaveDialog(J,U?.win??void 0)}async showOpenDialog(H,J){const U=this.H(J?.targetWindowId,H);return this.c.showOpenDialog(J,U?.win??void 0)}async pickFileFolderAndOpen(H,J){const U=await this.c.pickFileFolder(J);U&&await this.D(await Promise.all(U.map(async Z=>await v.SymlinkSupport.existsDirectory(Z)?{folderUri:w.URI.file(Z)}:{fileUri:w.URI.file(Z)})),J,H)}async pickFolderAndOpen(H,J){const U=await this.c.pickFolder(J);U&&await this.D(U.map(Z=>({folderUri:w.URI.file(Z)})),J,H)}async pickFileAndOpen(H,J){const U=await this.c.pickFile(J);U&&await this.D(U.map(Z=>({fileUri:w.URI.file(Z)})),J,H)}async pickWorkspaceAndOpen(H,J){const U=await this.c.pickWorkspace(J);U&&await this.D(U.map(Z=>({workspaceUri:w.URI.file(Z)})),J,H)}async D(H,J,U){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:U,cli:this.g.args,urisToOpen:H,forceNewWindow:J.forceNewWindow})}async showItemInFolder(H,J){P.shell.showItemInFolder(J)}async setRepresentedFilename(H,J,U){this.H(U?.targetWindowId,H)?.setRepresentedFilename(J)}async setDocumentEdited(H,J,U){this.H(U?.targetWindowId,H)?.setDocumentEdited(J)}async openExternal(H,J,U){this.g.unsetSnapExportedVariables();try{(0,m.$Ng)(J,m.Schemas.http,m.Schemas.https)?this.F(J,U):P.shell.openExternal(J)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(H,J){const U=J??this.r.getValue("workbench.externalBrowser");if(!U)return P.shell.openExternal(H);if((U.includes(h.$fc.sep)||U.includes(h.$ec.sep))&&!await v.Promises.exists(U))return this.h.error(`Configured external browser path does not exist: ${U}`),P.shell.openExternal(H);try{const{default:Z}=await new Promise((B,j)=>{V(["open"],B,j)}).then(Pe);await Z(H,{app:{name:Object.hasOwn(Z.apps,U)?Z.apps[U]:U}})}catch(Z){return this.h.error(`Unable to open external URL '${H}' using browser '${U}' due to ${Z}.`),P.shell.openExternal(H)}}moveItemToTrash(H,J){return P.shell.trashItem(J)}async isAdmin(){let H;return d.$j?H=(await new Promise((J,U)=>{V(["native-is-elevated"],J,U)}).then(Pe)).default():H=process.getuid?.()===0,H}async writeElevated(H,J,U,Z){const B=await new Promise((j,C)=>{V(["@vscode/sudo-prompt"],j,C)}).then(Pe);return new Promise((j,C)=>{const Y=[`"${this.G}"`];Z?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${J.fsPath}"`,`"${U.fsPath}"`);const oe={name:this.j.nameLong.replace("-",""),icns:d.$k&&this.g.isBuilt?(0,h.$ic)((0,h.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};B.exec(Y.join(" "),oe,(G,ue,re)=>{ue&&this.h.trace(`[sudo-prompt] received stdout: ${ue}`),re&&this.h.trace(`[sudo-prompt] received stderr: ${re}`),G?C(G):j(void 0)})})}async isRunningUnderARM64Translation(){return d.$l||d.$j?!1:P.app.runningUnderARM64Translation}get G(){return d.$j?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.bat"):d.$l?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$ic)(this.g.appRoot,"bin","code"):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,A.totalmem)(),freemem:(0,A.freemem)(),loadavg:(0,A.loadavg)()}}async getOSProperties(){return{arch:(0,A.arch)(),platform:(0,A.platform)(),release:(0,A.release)(),type:(0,A.type)(),cpus:(0,A.cpus)()}}async getOSVirtualMachineHint(){return g.$Qn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$j&&(0,D.$ngc)()}async getProcessId(H){return this.H(void 0,H)?.win?.webContents.getOSProcessId()}async killProcess(H,J,U){process.kill(J,U)}async readClipboardText(H,J){return P.clipboard.readText(J)}async writeClipboardText(H,J,U){return P.clipboard.writeText(J,U)}async readClipboardFindText(H){return P.clipboard.readFindText()}async writeClipboardFindText(H,J){return P.clipboard.writeFindText(J)}async writeClipboardBuffer(H,J,U,Z){return P.clipboard.writeBuffer(J,Buffer.from(U.buffer),Z)}async readClipboardBuffer(H,J){return y.$Me.wrap(P.clipboard.readBuffer(J))}async hasClipboard(H,J,U){return P.clipboard.has(J,U)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){P.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){P.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){P.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){P.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){P.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(H,J){this.I(H)?.updateTouchBar(J)}async notifyReady(H){this.I(H)?.setReady()}async relaunch(H,J){return this.f.relaunch(J)}async reload(H,J){const U=this.I(H);if(U){if((0,l.$Si)(U.openedWorkspace)){const Z=U.openedWorkspace.configPath;if(Z.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(Z))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(H,J){return this.H(J?.targetWindowId,H)?.win?.close()}async quit(H){const J=this.a.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(H,J){await this.f.kill(J)}async resolveProxy(H,J){if(this.g.extensionTestsLocationURI){const B=this.r.getValue("integration-test.http.proxy");if(B)return B}return this.I(H)?.win?.webContents?.session?.resolveProxy(J)}async lookupAuthorization(H,J){return this.t.lookupAuthorization(J)}async lookupKerberosAuthorization(H,J){return this.s.lookupKerberosAuthorization(J)}async loadCertificates(H){return this.s.loadCertificates()}findFreePort(H,J,U,Z,B=1){return(0,b.$2g)(J,U,Z,B)}async openDevTools(H,J){this.H(J?.targetWindowId,H)?.win?.webContents.openDevTools(J?.mode?{mode:J.mode,activate:J.activate}:void 0)}async toggleDevTools(H,J){this.H(J?.targetWindowId,H)?.win?.webContents.toggleDevTools()}async profileRenderer(H,J,U){const Z=this.I(H);if(!Z||!Z.win)throw new Error;return await new L.$ogc(Z.win,J,this.h).inspect(U)}async windowsGetStringRegKey(H,J,U,Z){if(!d.$j)return;const B=await new Promise((j,C)=>{V(["@vscode/windows-registry"],j,C)}).then(Pe);try{return B.GetStringRegKey(J,U,Z)}catch{return}}H(H,J){return this.I(H)??this.J(H)??this.I(J)}I(H){if(typeof H=="number")return this.a.getWindowById(H)}J(H){if(typeof H!="number")return;const J=P.webContents.fromId(H);if(J)return this.b.getWindowByWebContents(J)}};e.$rgc=K,Se([I.$8h],K.prototype,"G",null),e.$rgc=K=Se([se(0,a.$Dfc),se(1,R.$pgc),se(2,k.$yfc),se(3,u.$Wfc),se(4,E.$qfc),se(5,i.$$j),se(6,o.$rk),se(7,s.$Bfc),se(8,S.$Pfc),se(9,M.$0i),se(10,X.$6p),se(11,x.$7fc)],K)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[269],le([0,1,13,27,8,22,2,11,3,35,10,53,20,5,64,72,73,51,29]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0,g=Ve(g);let E=class{static{k=this}static{this.a="#1E1E1E"}constructor(u,i,o,s,a,l,S){this.d=u,this.e=i,this.f=o,this.g=s,this.h=a,this.i=l,this.j=S,this.b=null,this.c=null}async openReporter(u){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new T.$Sc,o=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:u.styles.backgroundColor,title:(0,m.localize)(11312,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:u,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Xg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(u){this.f.error(u)}}async $showConfirmCloseDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11313,null),buttons:[(0,m.localize)(11314,null),(0,m.localize)(11315,null)]},this.b);u===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11316,null),buttons:[(0,m.localize)(11317,null),(0,m.localize)(11318,null)]},this.b);return u===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const u=this.j.getWindowById(this.c.id);if(!u)throw new Error("Window not found");return u}async $sendReporterMenu(u,i){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new A.$ve;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:u,extensionName:i}),await(0,P.$uh)(new Promise(S=>c.$QX.once(`vscode:triggerReporterMenuResponse:${u}`,(y,D)=>S(D))),5e3,()=>{this.f.error(`Error: Extension ${u} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(u){u.isMinimized()&&u.restore(),u.focus()}l(u,i,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:o.title,backgroundColor:o.backgroundColor||k.a,webPreferences:{preload:I.$Xg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$fE)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(u,i,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&u&&(s=n.screen.getDisplayMatching(u.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,S={width:i,height:o,x:l.x+l.width/2-i/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(S.x<l.x&&(S.x=l.x),S.y<l.y&&(S.y=l.y),S.x>l.x+l.width&&(S.x=l.x),S.y>l.y+l.height&&(S.y=l.y),S.width>l.width&&(S.width=l.width),S.height>l.height&&(S.height=l.height)),S}};e.$sgc=E,e.$sgc=E=k=Se([se(1,d.$qfc),se(2,w.$$j),se(3,h.$yfc),se(4,f.$qgc),se(5,v.$Afc),se(6,$.$Dfc)],E)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[270],le([0,1,13,32,2,11,3,115,35,10,96,136,53,20,5,64,72,28,73,34,63,51]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0,v=Ve(v);const i="issue.processExplorerWindowState";let o=class{static{u=this}static{this.a="#1E1E1E"}constructor(l,S,y,D,L,R,O,M,x,X){this.d=l,this.f=S,this.g=y,this.h=D,this.i=L,this.j=R,this.k=O,this.l=M,this.m=x,this.n=X,this.b=null,this.c=null,this.o()}o(){p.$QX.on("vscode:listProcesses",async l=>{const S=[];try{S.push({name:(0,c.localize)(11307,null),rootProcess:await(0,I.$Vs)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(D=>{(0,m.$Sm)(D)?S.push({name:D.hostName,rootProcess:D}):D.processes&&S.push({name:D.hostName,rootProcess:D.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",S)}),p.$QX.on("vscode:workbenchCommand",(l,S)=>{const{id:y,from:D,args:L}=S;let R;switch(D){case"processExplorer":R=this.c;break;default:throw new Error(`Unexpected command source: ${D}`)}R?.webContents.send("vscode:runAction",{id:y,from:D,args:L})}),p.$QX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$QX.on("vscode:pidToNameRequest",async l=>{const S=await this.i.getMainDiagnostics(),y=[];for(const D of S.windows)y.push([D.pid,`window [${D.id}] (${D.title})`]);for(const{pid:D,name:L}of E.$$fc.getAll())y.push([D,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const S=new P.$Sc,y=S.add(this.l.createIPCObjectUrl()),D=this.n.getItem(i,void 0),L=s(D)?D:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11308,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(A.$Xg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())});const R=()=>{if(!this.b)return;const O=this.b.getSize(),M=this.b.getPosition();if(!O||!M)return;const x={width:O[0],height:O[1],x:M[0],y:M[1]};this.n.setItem(i,x)};this.b.on("moved",R),this.b.on("resized",R)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,S,y){let D;const L=n.screen.getAllDisplays();if(L.length===1)D=L[0];else{if(T.$k){const M=n.screen.getCursorScreenPoint();D=n.screen.getDisplayNearestPoint(M)}!D&&l&&(D=n.screen.getDisplayMatching(l.getBounds())),D||(D=n.screen.getPrimaryDisplay()||L[0])}const R=D.bounds,O={width:S,height:y,x:R.x+R.width/2-S/2,y:R.y+R.height/2-y/2};return R.width>0&&R.height>0&&(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y),O.x>R.x+R.width&&(O.x=R.x),O.y>R.y+R.height&&(O.y=R.y),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Lg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(11309,null),detail:(0,c.localize)(11310,null,l),buttons:[(0,c.localize)(11311,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,S)}async $getSystemInfo(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,S)}async $getPerformanceInfo(){try{const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,S)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,S,y,D){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||u.a,webPreferences:{preload:A.$Xg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$fE)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,S,...y){l.sender.isDestroyed()||l.sender.send(S,...y)}async closeProcessExplorer(){this.b?.close()}};e.$tgc=o,e.$tgc=o=u=Se([se(1,w.$qfc),se(2,f.$$j),se(3,m.$Rm),se(4,h.$bgc),se(5,d.$yfc),se(6,g.$qgc),se(7,$.$Afc),se(8,b.$rk),se(9,k.$wR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ce[271],le([0,1,22,16,20,19,5,64,28,49,24,50,105]),function(V,e,n,r,P,A,T,I,p,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;let w=class extends d.$Sgc{constructor(g,v,b,$,k,E,t,u){super(g,v,$,k,E,u),this.e=b,this.u=t}s(g){return(0,d.$Rgc)(`linux-${process.arch}`,g,this.k)}t(g){this.a&&(this.d(h.$OY.CheckingForUpdates(g)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$_p).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(h.$OY.Idle(h.UpdateType.Archive))):this.d(h.$OY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=g?v.message||v:void 0;this.d(h.$OY.Idle(h.UpdateType.Archive,b))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(h.$OY.Idle(h.UpdateType.Archive))}};e.$Ugc=w,e.$Ugc=w=Se([se(0,A.$Wfc),se(1,r.$0i),se(2,m.$0l),se(3,P.$qfc),se(4,c.$6p),se(5,T.$$j),se(6,I.$qgc),se(7,p.$rk)],w)}),define(ce[272],le([0,1,48,26,27,8,22,54,46,9,7,152,23,16,20,14,19,5,64,28,49,24,50,105]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0,r=Pe(r),c=Pe(c),d=Pe(d);async function o(S,y=1e3){for(;!S();)await(0,A.$Eh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$ic(c.$lc(process.execPath),"unins000.exe"))?u.UpdateType.Setup:u.UpdateType.Archive),s}let l=class extends i.$Sgc{get cachePath(){const y=c.$ic((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,D,L,R,O,M,x,X,K){super(y,D,R,O,M,K),this.u=L,this.v=x,this.w=X,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==u.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$OY.Disabled(u.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let D=`win32-${process.arch}`;return a()===u.UpdateType.Archive?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,i.$Rgc)(D,y,this.k)}t(y){this.a&&(this.d(u.$OY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(E.$_p).then(D=>{const L=a();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(u.$OY.Idle(L)),Promise.resolve(null)):L===u.UpdateType.Archive?(this.d(u.$OY.AvailableForDownload(D)),Promise.resolve(null)):(this.d(u.$OY.Downloading),this.C(D.version).then(()=>this.B(D.version).then(R=>d.Promises.exists(R).then(O=>{if(O)return Promise.resolve(R);const M=`${R}.tmp`;return this.i.request({url:D.url},T.CancellationToken.None).then(x=>this.v.writeFile(m.URI.file(M),x.stream)).then(D.sha256hash?()=>(0,h.$JX)(M,D.sha256hash):()=>{}).then(()=>d.Promises.rename(M,R,!1)).then(()=>R)})).then(R=>{this.e={packagePath:R},this.d(u.$OY.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(u.$OY.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$rj)(String(D)))}),this.j.error(D);const L=y?D.message||D:void 0;this.d(u.$OY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(u.$OY.Idle(a()))}async B(y){const D=await this.cachePath;return c.$ic(D,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const D=y?M=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(M):()=>!0,L=await this.cachePath,O=(await d.Promises.readdir(L)).filter(D).map(async M=>{try{await r.promises.unlink(c.$ic(L,M))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==u.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(u.$OY.Updating(y));const D=await this.cachePath;this.e.updateFilePath=c.$ic(D,`CodeSetup-${this.k.quality}-${y.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$OY.Idle(a()))});const R=`${this.k.win32MutexName}-ready`,O=await new Promise((M,x)=>{V(["@vscode/windows-mutex"],M,x)}).then(Pe);o(()=>O.isActive(R)).then(()=>this.d(u.$OY.Ready(y)))}r(){this.state.type!==u.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==u.StateType.Idle)return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(u.$OY.Downloading),this.e={packagePath:y},this.d(u.$OY.Downloaded(L)),D?this.k.target==="user"&&this.p():this.d(u.$OY.Ready(L))}};e.$Wgc=l,Se([I.$8h],l.prototype,"cachePath",null),e.$Wgc=l=Se([se(0,v.$Wfc),se(1,w.$0i),se(2,t.$0l),se(3,f.$qfc),se(4,E.$6p),se(5,b.$$j),se(6,g.$$k),se(7,$.$qgc),se(8,k.$rk)],l)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[137],le([0,1,13,8,22,55,4,2,11,70,3,7,10,27,69,16,53,20,68,14,19,5,28,73,248,87,24,110,76,51,29,30,59,52,40,34,58,71,21,6]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R,O,M,x,X,K,fe,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0,n=Ve(n);var J;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(J||(J={}));class U extends I.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const C=!(0,y.$aE)(this.r);if(m.$k&&C&&j.setSheetOffset((0,m.$K)((0,w.release)())?28:22),C&&(m.$j&&(0,y.$dE)(this.r)||m.$k)){const Y=this.s.getItem(U.D);Y?this.updateWindowControls({height:Y}):this.updateWindowControls({height:y.$cE})}m.$j&&C&&j.hookWindowMessage(278,()=>{const[oe,G]=j.getPosition(),ue=n.default.screen.getCursorScreenPoint(),re=ue.x-oe,Q=ue.y-G;return!(re>30&&Q>=0&&Q<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:re,y:Q})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),m.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,C,Y,oe){super(),this.r=j,this.s=C,this.t=Y,this.u=oe,this.a=this.B(new T.$ke),this.onDidClose=this.a.event,this.b=this.B(new T.$ke),this.onDidMaximize=this.b.event,this.c=this.B(new T.$ke),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$ke),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$ke),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$ke),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$dE)(this.r),this.G=void 0,this.H=void 0}w(j,C=n.default.screen.getAllDisplays().length>0){const Y=this.r.getValue("window"),oe=m.$k&&Y?.nativeTabs===!0;(m.$k||m.$j)&&C&&(!oe||n.default.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){m.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return m.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){m.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return m.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){m.$k&&j?.force&&n.default.app.focus({steal:!0});const C=this.win;C&&(C.isMinimized()&&C.restore(),C.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(m.$k)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const C=this.win;if(C){if(j.height&&this.s.setItem(Z.D,j.height),m.$j&&this.F)C.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(m.$k&&j.height!==void 0){const Y=(j.height-15)/2;Y?C.setWindowButtonPosition({x:Y,y:Y}):C.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,C){(0,y.$eE)(this.r)?this.J(j,C):this.M(j)}get isFullScreen(){if(m.$k&&typeof this.G=="boolean")return this.G;const j=this.win,C=j?.isFullScreen(),Y=j?.isSimpleFullScreen();return!!(C||Y)}J(j,C){const Y=this.win;Y?.isSimpleFullScreen()&&Y?.setSimpleFullScreen(!1),this.L(j,C)}L(j,C){if(m.$k){this.G=j;const oe=this.H=new r.$1h;(async()=>{const G=await Promise.race([oe.p,(0,r.$Eh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!G&&j&&C&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const C=this.win;C?.isFullScreen()&&this.L(!1,!1),C?.setSimpleFullScreen(j),C?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Tfc=U;let Z=class extends U{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(C=>C.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Ri)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,C,Y,oe,G,ue,re,Q,F,N,W,z,te,ee,q,ne,de,me,we,Ie,We){super(N,Ie,oe,C),this.fb=Y,this.gb=G,this.hb=ue,this.ib=re,this.jb=Q,this.kb=F,this.lb=W,this.mb=z,this.nb=te,this.ob=ee,this.pb=q,this.qb=ne,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new T.$ke),this.onWillLoad=this.N.event,this.O=this.B(new T.$ke),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$ke),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=J.NONE;{const[Oe,Ee]=this.Eb(j.state);this.U=Oe,this.u.trace("window#ctor: using window state",Oe);const $e=We.invokeFunction(D.$Efc,this.U,{preload:p.$Xg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.default.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Ee),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=J.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===J.READY}get whenClosedOrLoaded(){return new Promise(j=>{function C(){Y.dispose(),oe.dispose(),j()}const Y=this.onDidClose(()=>C()),oe=this.onWillLoad(()=>C())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(C,Y)=>Y)(C=>this.yb(O.WindowError.PROCESS_GONE,{...C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(C,Y,oe)=>({exitCode:Y,reason:oe}))(({exitCode:C,reason:Y})=>this.yb(O.WindowError.LOAD,{reason:Y,exitCode:C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(C=>C.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(C=>this.Bb(C))),this.B(this.mb.onDidDeleteUntitledWorkspace(C=>this.Ab(C)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(C,Y)=>{const oe=await this.xb();Y({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,o.$nq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,C){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:C?.reason,code:C?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:Y,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,d.localize)(10987,null),(0,d.localize)(10988,null),(0,d.localize)(10989,null)],message:(0,d.localize)(10990,null),detail:(0,d.localize)(10991,null),checkboxLabel:this.S?.workspace?(0,d.localize)(10992,null):void 0},this.m);if(Y!==2){const G=Y===0;await this.zb(G,oe)}}else if(j===O.WindowError.PROCESS_GONE){let Y;C?Y=(0,d.localize)(10994,null,C.reason,C.exitCode??"<unknown>"):Y=(0,d.localize)(10993,null);const{response:oe,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,d.localize)(10995,null):(0,d.localize)(10996,null),(0,d.localize)(10997,null)],message:Y,detail:this.S?.workspace?(0,d.localize)(10998,null):(0,d.localize)(10999,null),checkboxLabel:this.S?.workspace?(0,d.localize)(11e3,null):void 0},this.m),ue=oe===0;await this.zb(ue,G)}break}}async zb(j,C){const Y=this.S?.workspace;if(C&&Y)try{const oe=this.kb.workspaceStorage(Y);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(j&&this.S){let oe,G;(0,L.$Ni)(Y)?oe={folderUri:Y.uri}:(0,L.$Si)(Y)?oe={workspaceUri:Y.configPath}:G=!0,(0,fe.$Nb)(await this.tb.open({context:D.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const C=this.Gb();C!==this.W&&(this.W=C,this.Hb(C))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let C=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(C?.indexOf("@")!==-1){const oe=h.URI.parse(C),G=oe.authority.indexOf("@");G!==-1&&(C=oe.with({authority:oe.authority.substring(G+1)}).toString())}C?.endsWith("/")&&(C=C.substr(0,C.length-1));const Y=(this.r.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((C||"").indexOf("@")===-1&&(C!==this.Z||Y!==this.$)){this.Z=C,this.$=Y;const oe=C||"",G=Y?`${Y},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""}),n.default.app.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){m.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,C=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!C.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),C.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,C),this.ub===J.NONE?this.S=j:this.db=j,this.ub=J.NAVIGATING,this.m.loadURL(p.$Xg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const Y=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Ph(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:C.isReload?O.LoadReason.RELOAD:Y?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,C){const Y=(this.S??this.db)?.userEnv;if(Y){const oe=(0,$.$Im)(Y)&&!(0,$.$Im)(j.userEnv),G=this.isExtensionDevelopmentHost;(oe||G)&&(j.userEnv={...Y,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),C.disableExtensions!==void 0&&(j["disable-extensions"]=C.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const C=Object.assign({},this.S);C.workspace=await this.Db(C),delete C.filesToOpenOrCreate,delete C.filesToDiff,delete C.filesToMerge,delete C.filesToWait,this.isExtensionDevelopmentHost&&j&&(C.verbose=j.verbose,C.debugId=j.debugId,C.extensionEnvironment=j.extensionEnvironment,C["inspect-extensions"]=j["inspect-extensions"],C["inspect-brk-extensions"]=j["inspect-brk-extensions"],C["extensions-dir"]=j["extensions-dir"]),C.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),C.isInitialStartup=!1,C.policiesData=this.gb.serialize(),C.continueOn=this.t.continueOn,C.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},C.logLevel=this.fb.getLogLevel(),C.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(C,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Si)(j.workspace)){const C=j.workspace.configPath;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}else if((0,L.$Ni)(j.workspace)){const C=j.workspace.uri;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$sfc)();if(this.isFullScreen){let Y;try{Y=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,O.$sfc)();return{mode:O.WindowMode.Fullscreen,display:Y?Y.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let C;if(!m.$k&&this.m.isMaximized()?C=O.WindowMode.Maximized:C=O.WindowMode.Normal,C===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,C===O.WindowMode.Normal||C===O.WindowMode.Maximized){let Y;C===O.WindowMode.Normal?Y=this.getBounds():Y=this.m.getNormalBounds(),j.x=Y.x,j.y=Y.y,j.width=Y.width,j.height=Y.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let C=!1;if(j){this.ab=j.zoomLevel;try{const Y=n.default.screen.getAllDisplays();C=Y.length>1,j=D.WindowStateValidator.validateWindowState(this.u,j,Y)}catch(Y){this.u.warn(`Unexpected error validating window state: ${Y}
${Y.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$sfc)(),C]}getBounds(){const[j,C]=this.m.getPosition(),[Y,oe]=this.m.getSize();return{x:j,y:C,width:Y,height:oe}}I(j,C){super.I(j,C),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$$D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,C=!0){m.$k||(j==="toggle"&&C&&this.send("vscode:showInfoMessage",(0,d.localize)(11001,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const C=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!C),this.m.autoHideMenuBar=C;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,C,...Y){this.isReady?this.send(j,...Y):this.ready().then(()=>{C.isCancellationRequested||this.send(j,...Y)})}send(j,...C){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...C)}catch(Y){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,A.$oj)(Y)}`)}}}updateTouchBar(j){m.$k&&this.Y.forEach((C,Y)=>{const oe=j[Y];C.segments=this.Mb(oe)})}Kb(){if(m.$k){for(let j=0;j<10;j++){const C=this.Lb();this.Y.push(C)}this.m.setTouchBar(new n.default.TouchBar({items:this.Y}))}}Lb(j=[]){const C=this.Mb(j),Y=new n.default.TouchBar.TouchBarSegmentedControl({segments:C,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:Y.segments[oe].id,from:"touchbar"})}});return Y}Mb(j=[]){return j.map(Y=>{let oe;Y.icon&&!l.ThemeIcon.isThemeIcon(Y.icon)&&Y.icon?.dark?.scheme===p.Schemas.file&&(oe=n.default.nativeImage.createFromPath(h.URI.revive(Y.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let G;return typeof Y.title=="string"?G=Y.title:G=Y.title.value,{id:Y.id,label:oe?void 0:G,icon:oe}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Ufc=Z,e.$Ufc=Z=Se([se(1,t.$$j),se(2,K.$Rfc),se(3,b.$qfc),se(4,M.$ro),se(5,X.$Gfc),se(6,k.$$k),se(7,s.$5fc),se(8,s.$3fc),se(9,g.$0i),se(10,S.$Bfc),se(11,R.$Pfc),se(12,f.$xfc),se(13,a.$0l),se(14,v.$yfc),se(15,E.$Wfc),se(16,u.$rk),se(17,i.$Afc),se(18,D.$Dfc),se(19,x.$wR),se(20,H.$Ci)],Z)}),define(ce[273],le([0,1,13,3,16,20,19,5,34,51,52,137]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;let d=class extends h.$Tfc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,g,v,b,$,k){super(b,$,g,v),this.O=f,this.P=k,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,c.$aE)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$Vfc=d,e.$Vfc=d=Se([se(1,A.$qfc),se(2,I.$$j),se(3,P.$0i),se(4,p.$wR),se(5,T.$Wfc)],d)}),define(ce[274],le([0,1,13,4,2,11,35,273,6,5,52,29]),function(V,e,n,r,P,A,T,I,p,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;let d=class extends P.$Tc{constructor(f,g){super(),this.h=f,this.j=g,this.a=this.B(new r.$ke),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$ke),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$ke),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$ke),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,g)=>{const v=this.getWindowByWebContents(g.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new P.$Sc;b.add(r.Event.fromNodeEventEmitter(g.webContents,"did-create-window",($,k)=>({browserWindow:$,details:k}))(({browserWindow:$,details:k})=>{const E=this.getWindowByWebContents($.webContents);E&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),E.tryClaimWindow(k.options))})),b.add(r.Event.fromNodeEventEmitter(g,"closed")(()=>b.dispose()))}}),T.$QX.handle("vscode:registerAuxiliaryWindow",async(f,g)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=g),f.sender.id})}createWindow(f){return this.h.invokeFunction(h.$Efc,this.n(f),{preload:A.$Xg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const g={},v=f.features.split(",");for(const $ of v){const[k,E]=$.split("=");switch(k){case"width":g.width=parseInt(E,10);break;case"height":g.height=parseInt(E,10);break;case"left":g.x=parseInt(E,10);break;case"top":g.y=parseInt(E,10);break;case"window-maximized":g.mode=m.WindowMode.Maximized;break;case"window-fullscreen":g.mode=m.WindowMode.Fullscreen;break}}const b=h.WindowStateValidator.validateWindowState(this.j,g)??(0,m.$tfc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const g=new P.$Sc,v=this.h.createInstance(I.$Vfc,f);this.g.set(v.id,v),g.add((0,P.$Rc)(()=>this.g.delete(v.id))),g.add(v.onDidMaximize(()=>this.a.fire(v))),g.add(v.onDidUnmaximize(()=>this.b.fire(v))),g.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),g.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),g.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>g.dispose())}getWindowByWebContents(f){const g=this.g.get(f.id);return g?.matches(f)?g:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,h.$Ffc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$rhc=d,e.$rhc=d=Se([se(0,p.$Ci),se(1,c.$$j)],d)}),define(ce[88],le([0,1,13,21,8,4,47,2,11,3,18,7,23,10,6,19,5,62,87,102,30,59,31,53]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0,e.$Dgc=(0,f.$Di)("workspacesHistoryMainService");let s=class extends I.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,S,y,D,L){super(),this.f=l,this.g=S,this.h=y,this.j=D,this.m=L,this.c=this.B(new A.$ke),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$Bh(800)),this.n()}n(){this.h.when(g.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let S=[],y=[];for(const L of l)if((0,k.$$hb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(S,L.workspace)&&S.push(L);else if((0,k.$_hb)(L))this.y(S,L.folderUri)||S.push(L);else{const R=this.z(y,L.fileUri),O=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,m.$bh)(L.fileUri))>=0;!R&&!O&&(y.push(L),c.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const D=await this.r({workspaces:S,files:y});S=D.workspaces,y=D.files,S.length>o.a&&(S.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:S,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const S=R=>{const O=this.u(R);for(const M of l)if(m.$8g.isEqual(M,O))return!1;return!0},y=await this.getRecentlyOpened(),D=y.workspaces.filter(S),L=y.files.filter(S);(D.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:D}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:S}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(10965,null),(0,w.localize)(10966,null)],message:(0,w.localize)(10967,null),detail:(0,w.localize)(10968,null),cancelId:1});if(S!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const S=new u.$zc(L=>m.$8g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)S.set(this.u(L),L);const y=new u.$zc(L=>m.$8g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const D=await this.s();for(const L of D.workspaces){const R=S.get(this.u(L));R?R.label=R.label??L.label:S.set(this.u(L),L)}for(const L of D.files){const R=y.get(this.u(L));R?R.label=R.label??L.label:y.set(this.u(L),L)}return{workspaces:[...S.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const S=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof S=="string")try{l=JSON.parse(S)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,k.$fib)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,k.$gib)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,k.$_hb)(l)?l.folderUri:(0,k.$aib)(l)?l.fileUri:l.workspace.configPath}w(l,S){return!!l.find(y=>(0,k.$$hb)(y)&&y.workspace.id===S.id)}y(l,S){return!!l.find(y=>(0,k.$_hb)(y)&&m.$8g.isEqual(y.folderUri,S))}z(l,S){return!!l.find(y=>m.$8g.isEqual(y.fileUri,S))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(10969,null),description:(0,w.localize)(10970,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const L of n.app.getJumpListSettings().removedItems){const R=L.args;if(R){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);O&&S.push(h.URI.parse(O[2]))}}await this.removeRecentlyOpened(S);let y=!1;const D=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const R=(0,k.$$hb)(L)?L.workspace:L.folderUri,{title:O,description:M}=this.L(R,L.label);let x;return h.URI.isUri(R)?x=`--folder-uri "${R.toString()}"`:(y=!0,x=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:x,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&l.push({type:"custom",name:y?(0,w.localize)(10971,null):(0,w.localize)(10972,null),items:D})}l.push({type:"recent"});try{const S=n.app.setJumpList(l);S&&S!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.f.warn("updateWindowsJumpList#setJumpList",S)}}L(l,S){if(S)return{title:(0,T.$7w)(S).name,description:S};if(h.URI.isUri(l))return{title:(0,m.$bh)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(10973,null),description:""};let y=(0,m.$bh)(l.configPath);return y.endsWith(E.$Zi)&&(y=y.substr(0,y.length-E.$Zi.length-1)),{title:(0,w.localize)(10974,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$Yw)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),S=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const R=this.u(l.workspaces[L]);if(R.scheme===p.Schemas.file){const O=(0,m.$5g)(R);await d.Promises.exists(O)&&(S.push(O),y++)}}const D=[];for(let L=0;L<l.files.length&&y<o.D;L++){const R=this.u(l.files[L]);if(R.scheme===p.Schemas.file){const O=(0,m.$5g)(R);if(o.G.includes((0,m.$bh)(R))||S.includes(O))continue;await d.Promises.exists(O)&&(D.push(O),y++)}}D.reverse().forEach(L=>n.app.addRecentDocument(L)),S.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$Egc=s,e.$Egc=s=o=Se([se(0,v.$$j),se(1,t.$Pfc),se(2,g.$Wfc),se(3,$.$5fc),se(4,i.$yfc)],s)}),define(ce[275],le([0,1,13,8,22,47,3,7,10,84,16,20,19,5,198,64,28,34,24,50,51,29,88,2]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0,p=Pe(p);const s="menu";let a=class extends i.$Tc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,D,L,R,O,M,x,X,K,fe,H,J){super(),this.t=y,this.u=D,this.w=L,this.y=R,this.z=O,this.C=M,this.D=x,this.F=X,this.G=K,this.H=fe,this.I=H,this.J=J,this.s=Object.create(null),this.h=new r.$Ph(()=>this.R(),0),this.j=new r.$Ph(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,E.$aE)(D))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,x,X)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id})},this.s["workbench.action.newWindow"]=(M,x,X)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id}),this.s["workbench.action.files.openFileFolder"]=(M,x,X)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(X),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,x,X)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(X),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,x,X)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(X),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const D=this.I.requestFeatureUrl;D&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(D,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const R=this.I.licenseUrl;R&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const M=R.indexOf("?")>0?"&":"?";this.ob(`${R}${M}lang=${T.$x}`,"openLicenseUrl")}else this.ob(R,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&R&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,D){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const D=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),D.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(p.localize(11224,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11225,null)),submenu:O});this.bb(O,"File"),D.append(M)}if(this.$("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11226,null)),submenu:O});this.bb(O,"Edit"),D.append(M)}if(this.$("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11227,null)),submenu:O});this.bb(O,"Selection"),D.append(M)}if(this.$("View")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11228,null)),submenu:O});this.bb(O,"View"),D.append(M)}if(this.$("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11229,null)),submenu:O});this.bb(O,"Go"),D.append(M)}if(this.$("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11230,null)),submenu:O});this.bb(O,"Run"),D.append(M)}if(this.$("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11231,null)),submenu:O});this.bb(O,"Terminal"),D.append(M)}let R;if(this.$("Window")){const O=new n.Menu;R=new n.MenuItem({label:this.qb(p.localize(11232,null)),submenu:O,role:"window"}),this.hb(O)}if(R&&D.append(R),this.$("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11233,null)),submenu:O,role:"help"});this.bb(O,"Help"),D.append(M)}D.items&&D.items.length>0?this.X(D):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const D of this.J.getWindows())D.win?.setMenu(null)}Y(y){const D=this.jb(p.localize(11234,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let R;if(this.$("Preferences")){const J=new n.Menu;this.bb(J,"Preferences"),R=new n.MenuItem({label:this.qb(p.localize(11235,null)),submenu:J})}const O=new n.Menu,M=new n.MenuItem({label:p.localize(11236,null),role:"services",submenu:O}),x=new n.MenuItem({label:p.localize(11237,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),X=new n.MenuItem({label:p.localize(11238,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new n.MenuItem({label:p.localize(11239,null),role:"unhide"}),fe=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(11240,null,this.I.nameLong),click:async(J,U,Z)=>{const B=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||B?.win?.isMinimized())&&await this.Z(Z)&&this.H.quit(void 0)}})),H=[D];H.push(...L),R&&H.push(l(),R),H.push(l(),M,l(),x,X,K,l(),fe),H.forEach(J=>y.append(J))}async Z(y){if(this.w.getWindowCount()===0)return!0;const D=this.u.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(11241,null),p.localize(11242,null)],message:p.localize(11243,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,E.$aE)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,D){D.forEach(L=>{if((0,f.$Agc)(L))y.append(l());else if((0,f.$zgc)(L)){const R=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:R});this.ab(R,L.submenu.items),y.append(O)}else(0,f.$Bgc)(L)?y.append(this.db(L)):(0,f.$Cgc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,D){this.n&&this.n[D]&&this.ab(y,this.n[D].items)}cb(y){const D=this.ib();D.length&&(D.forEach(L=>y.append(L)),y.append(l()))}db(y){const D=I.URI.revive(y.uri),L=y.id,R=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,M,x)=>{const X=this.eb(x);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[R],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([D])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,D,L){const R={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(D,R))}hb(y){const D=new n.MenuItem({label:p.localize(11244,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(11245,null),role:"zoom",enabled:this.w.getWindowCount()>0}),R=new n.MenuItem({label:p.localize(11246,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(p.localize(11247,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(l()),M.push(this.jb(p.localize(11248,null),"workbench.action.newWindowTab")),M.push(this.gb(p.localize(11249,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(p.localize(11250,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(p.localize(11251,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(p.localize(11252,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,l(),O,...M,l(),R].forEach(x=>y.append(x))}ib(){switch(this.t.state.type){case k.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(11253,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case k.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(11254,null),enabled:!1})];case k.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(11255,null)),click:()=>{this.t.downloadUpdate()}})];case k.StateType.Downloading:return[new n.MenuItem({label:p.localize(11256,null),enabled:!1})];case k.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(p.localize(11257,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case k.StateType.Updating:return[new n.MenuItem({label:p.localize(11258,null),enabled:!1})];case k.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(11259,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,D,L,R){const O=this.qb(y),M=typeof D=="function"?D:(H,J,U)=>{const Z=H?H.userSettingsLabel:null;let B=D;Array.isArray(D)&&(B=this.eb(U)?D[1]:D[0]),Z&&U.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:Z}):this.lb({type:"commandId",commandId:B})},x=typeof L=="boolean"?L:this.w.getWindowCount()>0,X=typeof R=="boolean"?R:!1,K={label:O,click:M,enabled:x};X&&(K.type="checkbox",K.checked=X);let fe;return typeof D=="string"?fe=D:Array.isArray(D)&&(fe=D[0]),T.$k&&(fe==="editor.action.clipboardCutAction"?K.role="cut":fe==="editor.action.clipboardCopyAction"?K.role="copy":fe==="editor.action.clipboardPasteAction"&&(K.role="paste"),fe==="undo"?K.click=this.kb(M,{inDevTools:H=>H.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):fe==="redo"?K.click=this.kb(M,{inDevTools:H=>H.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):fe==="editor.action.selectAll"&&(K.click=this.kb(M,{inDevTools:H=>H.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(fe,K))}kb(y,D){return(L,R,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return D.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return D.inDevTools(M.webContents.devToolsWebContents);y(L,R||M,O)}}lb(y){let D=n.BrowserWindow.getFocusedWindow();if(D){const R=this.J.getWindowByWebContents(D.webContents);R&&(D=this.w.getWindowById(R.parentId)?.win??null)}if(!D){const R=this.w.getLastActiveWindow();R?.win?.isMinimized()&&(D=R.win)}const L=D?this.w.getWindowById(D.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const R={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",P.CancellationToken.None,R)}else{const R={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,R)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,D){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const R=D.label.indexOf("[");R>=0?D.label=`${D.label.substr(0,R)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}nb(y,D,L=!D.accelerator){L&&(D=this.mb(y,D));const R=D.click;return D.click=(O,M,x)=>{this.pb(y),R?.(O,M,x)},D}ob(y,D){this.H.openExternal(void 0,y),this.pb(D)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,A.$4w)(y,!this.O)}};e.$Fgc=a,e.$Fgc=a=o=Se([se(0,k.$PY),se(1,m.$0i),se(2,t.$Dfc),se(3,h.$qfc),se(4,$.$0l),se(5,u.$Dgc),se(6,b.$wR),se(7,d.$Wfc),se(8,w.$$j),se(9,g.$qgc),se(10,v.$rk),se(11,c.$pgc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(ce[276],le([0,1,6,19,5,275,2]),function(V,e,n,r,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,n.$Di)("menubarMainService");let I=class extends T.$Tc{constructor(c,m,h){super(),this.b=c,this.c=m,this.f=h,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(A.$Fgc))}async updateMenubar(c,m){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(m,c)}};e.$Hgc=I,e.$Hgc=I=Se([se(0,n.$Ci),se(1,r.$Wfc),se(2,P.$$j)],I)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[277],le([0,1,26,13,106,27,21,22,39,4,32,47,2,11,9,70,3,36,18,12,7,10,69,16,53,20,14,6,19,5,72,73,74,34,51,137,29,134,268,30,103,88,59,52,76,40,58,71,84]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R,O,M,x,X,K,fe,H,J,U,Z,B,j,C,Y,oe,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0,n=Pe(n),D=Ve(D);function ue(F){return(0,H.$Si)(F?.workspace)}function re(F){return(0,H.$Ni)(F?.workspace)}let Q=class extends d.$Tc{constructor(N,W,z,te,ee,q,ne,de,me,we,Ie,We,Oe,Ee,$e,_,ae,he,be,De,Fe){super(),this.s=N,this.t=W,this.u=z,this.w=te,this.z=ee,this.C=q,this.D=ne,this.F=de,this.G=me,this.H=we,this.I=Ie,this.J=We,this.L=Oe,this.M=Ee,this.N=$e,this.O=_,this.P=ae,this.Q=he,this.R=be,this.S=De,this.U=Fe,this.a=this.B(new c.$ke),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$ke),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$ke),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$ke),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$ke),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$ke),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$ke),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$ke),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new fe.$5gc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const W=new d.$Sc;if(W.add(c.Event.any(N.onDidClose,N.onDidDestroy)(()=>W.dispose())),N.config.extensionDevelopmentPath)for(const z of N.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(z));N.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,W){const z=this.G.args,te=W?.remoteAuthority||void 0,ee=!0,q=W?.forceReuseWindow,ne=!q;return this.open({...N,cli:z,forceEmpty:ee,forceNewWindow:ne,forceReuseWindow:q,remoteAuthority:te,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(N,W){N.focus(),this.X(W,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const W=[],z=[],te=[],ee=[],q=[];let ne,de=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const Ee of me)re(Ee)?N.addMode?W.push(Ee):z.push(Ee):ue(Ee)?te.push(Ee):Ee.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ee.remoteAuthority}),ne.filesToOpenOrCreate.push(Ee)):Ee.backupPath?q.push({backupFolder:(0,f.$mc)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):de++;N.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),N.mergeMode&&ne&&ne.filesToOpenOrCreate.length===4&&(ne.filesToMerge=ne.filesToOpenOrCreate.slice(0,4),ne.filesToOpenOrCreate=[],ne.filesToDiff=[]),ne&&N.waitMarkerFileURI&&(ne.filesToWait={paths:(0,T.$Gb)([...ne.filesToDiff,ne.filesToMerge[3],...ne.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(ee.push(...this.N.getUntitledWorkspaces()),te.push(...ee),q.push(...this.J.getEmptyWindowBackups())):q.length=0;const{windows:we,filesOpenedInWindow:Ie}=await this.Y(N,te,z,q,de,ne,W);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${te.length}, foldersToOpen: ${z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${de})`),we.length>1)if(Ie)Ie.focus();else{const Ee=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,_=!0;if(Ee){const ae=we.filter(he=>this.r.state.lastActiveWindow&&he.backupPath===this.r.state.lastActiveWindow.backupPath);ae.length&&(ae[0].focus(),$e=!1,_=!1)}if($e)for(let ae=we.length-1;ae>=0;ae--){const he=we[ae];if(!(he.openedWorkspace&&ee.some(be=>he.openedWorkspace&&be.workspace.id===he.openedWorkspace.id)||he.backupPath&&q.some(be=>he.backupPath&&be.backupFolder===(0,f.$mc)(he.backupPath)))){he.focus(),_=!1;break}}_&&we[we.length-1].focus()}const We=ne&&ne.filesToDiff.length>0,Oe=ne&&ne.filesToMerge.length>0;if(!we.some(Ee=>Ee.isExtensionDevelopmentHost)&&!We&&!Oe&&!N.noRecentEntry){const Ee=[];for(const $e of me)ue($e)&&!$e.transient?Ee.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):re($e)?Ee.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Ee.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Ee)}return this.X(N,we),we}X(N,W){const z=N.waitMarkerFileURI;N.context===X.OpenContext.CLI&&z&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(N,W,z,te,ee,q,ne){const de=[];let me;function we(ae,he){de.push(ae),he&&(me=ae,q=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:We}=this.pb(N);if(!N.initialStartup&&ne.length>0){const ae=ne[0].remoteAuthority,he=this.vb(ae);he&&we(this.ab(he,ne.map(be=>be.workspace.uri)))}const Oe=z.length+W.length+te.length;if(q&&Oe===0){const ae=q.filesToOpenOrCreate[0]||q.filesToDiff[0]||q.filesToMerge[3],he=this.getWindows().filter(De=>q&&(0,$.$jh)(De.remoteAuthority,q.remoteAuthority));let be;ae?.fileUri&&!We&&((N.context===X.OpenContext.DESKTOP||N.context===X.OpenContext.CLI||N.context===X.OpenContext.DOCK)&&(be=await(0,K.$Ifc)(he,ae.fileUri,async De=>De.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(De.configPath):void 0)),be||(be=this.wb(he))),be?(0,H.$Si)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,H.$Ni)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(N,be,q),!0):we(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const Ee=(0,T.$Lb)(W,ae=>ae.workspace.id);if(Ee.length>0){const ae=(0,T.$Gb)(Ee.map(he=>(0,K.$Jfc)(this.getWindows(),he.workspace.configPath)));if(ae.length>0){const he=ae[0],be=(0,$.$jh)(q?.remoteAuthority,he.remoteAuthority)?q:void 0;we(this.Z(N,he,be),!!be),Ie=!0}for(const he of Ee){if(ae.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===he.workspace.id))continue;const be=he.remoteAuthority,De=(0,$.$jh)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(N,he,Ie,De),!!De),Ie=!0}}const $e=(0,T.$Lb)(z,ae=>$.$8g.getComparisonKey(ae.workspace.uri));if($e.length>0){const ae=(0,T.$Gb)($e.map(he=>(0,K.$Jfc)(this.getWindows(),he.workspace.uri)));if(ae.length>0){const he=ae[0],be=(0,$.$jh)(q?.remoteAuthority,he.remoteAuthority)?q:void 0;we(this.Z(N,he,be),!!be),Ie=!0}for(const he of $e){if(ae.some(Fe=>(0,H.$Ni)(Fe.openedWorkspace)&&$.$8g.isEqual(Fe.openedWorkspace.uri,he.workspace.uri)))continue;const be=he.remoteAuthority,De=(0,$.$jh)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(N,he,Ie,De),!!De),Ie=!0}}const _=(0,T.$Lb)(te,ae=>ae.backupFolder);if(_.length>0)for(const ae of _){const he=ae.remoteAuthority,be=(0,$.$jh)(q?.remoteAuthority,he)?q:void 0;we(await this.bb(N,!0,he,be,ae),!!be),Ie=!0}if(de.length===0||q){q&&!ee&&ee++;const ae=q?q.remoteAuthority:N.remoteAuthority;for(let he=0;he<ee;he++)we(await this.bb(N,Ie,ae,q),!!q),Ie=!0}return{windows:(0,T.$Lb)(de),filesOpenedInWindow:me}}Z(N,W,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(W);const te={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",I.CancellationToken.None,te),W}$(N){let W=N;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==N.id){const te=this.U.getWindowByWebContents(z.webContents);te&&te.parentId===N.id&&(W=te)}W.focus()}ab(N,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),N.focus();const z={foldersToAdd:W};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),N}bb(N,W,z,te,ee){this.z.trace("windowsManager#doOpenEmpty",{restore:!!ee,remoteAuthority:z,filesToOpen:te,forceNewWindow:W});let q;return!W&&typeof N.contextWindowId=="number"&&(q=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:z,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:te,windowToUse:q,emptyWindowBackupInfo:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,W,z,te,ee){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:te}),!z&&!ee&&typeof N.contextWindowId=="number"&&(ee=this.getWindowById(N.contextWindowId)),this.qb({workspace:W.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:te,windowToUse:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let W,z=!1,te=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(W=await this.eb(N),z=!0):N.forceEmpty?W=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(W=await this.fb(N.cli),W.length===0&&W.push(Object.create(null)),z=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),te=!0),!N.addMode&&z){const ee=W.filter(q=>re(q));if(ee.length>1){const q=ee[0].remoteAuthority;if(ee.every(ne=>(0,$.$jh)(ne.remoteAuthority,q))){const ne=await this.N.createUntitledWorkspace(ee.map(de=>({uri:de.workspace.uri})));W.push({workspace:ne,remoteAuthority:q}),W=W.filter(de=>!re(de))}}}if(N.initialStartup&&!te&&this.L.getValue("window")?.restoreWindows==="preserve"){const ee=await this.hb();W.unshift(...ee.filter(q=>ue(q)||re(q)||q.backupPath))}return W}async eb(N){const W={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},z=await Promise.all((0,T.$Gb)(N.urisToOpen||[]).map(async te=>{const ee=await this.jb(te,W);if(ee)return ee.label=te.label,ee;const q=this.lb(te);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(10976,null)],message:q.scheme===w.Schemas.file?(0,t.localize)(10977,null):(0,t.localize)(10978,null),detail:q.scheme===w.Schemas.file?(0,t.localize)(10979,null,(0,h.$Xw)(q,{os:v.OS,tildify:this.G})):(0,t.localize)(10980,null,q.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(z)}async fb(N){const W=[],z={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},te=N["folder-uri"];if(te){const ne=await Promise.all(te.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},z)}));W.push(...(0,T.$Gb)(ne))}const ee=N["file-uri"];if(ee){const ne=await Promise.all(ee.map(de=>{const me=this.gb(de);if(me)return this.jb((0,H.$9i)(de)?{workspaceUri:me}:{fileUri:me},z)}));W.push(...(0,T.$Gb)(ne))}const q=await Promise.all(N._.map(ne=>z.remoteAuthority?this.ob(ne,z):this.mb(ne,z)));return W.push(...(0,T.$Gb)(q)),W}gb(N){try{const W=E.URI.parse(N);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${N}, ${W.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];N!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const z=await Promise.all(W.map(async te=>{if(te.workspace){const ee=await this.jb({workspaceUri:te.workspace.configPath},{remoteAuthority:te.remoteAuthority,rejectTransientWorkspaces:!0});if(ue(ee))return ee}else if(te.folderUri){const ee=await this.jb({folderUri:te.folderUri},{remoteAuthority:te.remoteAuthority});if(re(ee))return ee}else if(N!=="folders"&&te.backupPath)return{backupPath:te.backupPath,remoteAuthority:te.remoteAuthority}}));return(0,T.$Gb)(z)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,W=Object.create(null)){const z=this.lb(N);return z.scheme===w.Schemas.file?((0,M.$0D)(N)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,W)):this.kb(N,W)}kb(N,W){let z=this.lb(N);const te=(0,R.$fn)(z)||W.remoteAuthority;if(z=(0,$.$lh)((0,$.$fh)(z)),(0,M.$0D)(N)){if(W.gotoLineMode){const{path:ee,line:q,column:ne}=(0,m.$Kg)(z.path);return{fileUri:z.with({path:ee}),options:{selection:q?{startLineNumber:q,startColumn:ne||1}:void 0},remoteAuthority:te}}return{fileUri:z,remoteAuthority:te}}else if((0,M.$8D)(N))return{workspace:(0,J.$Mfc)(z),remoteAuthority:te};return{workspace:(0,J.$Nfc)(z),remoteAuthority:te}}lb(N){return(0,M.$8D)(N)?N.workspaceUri:(0,M.$9D)(N)?N.folderUri:N.fileUri}async mb(N,W,z){let te,ee;W.gotoLineMode&&({path:N,line:te,column:ee}=(0,m.$Kg)(N)),N=(0,m.$Eg)((0,f.$gc)(N),(0,b.cwd)());try{const q=await n.promises.stat(N);if(q.isFile()){if(!W.forceOpenWorkspaceAsFile){const ne=await this.N.resolveLocalWorkspace(E.URI.file(N));if(ne)return ne.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:a.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:E.URI.file(N),type:a.FileType.File,exists:!0,options:{selection:te?{startLineNumber:te,startColumn:ee||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,J.$Nfc)(E.URI.file(N),q),type:a.FileType.Directory,exists:!0};if(!v.$j&&N==="/dev/null")return{fileUri:E.URI.file(N),type:a.FileType.File,exists:!0}}}catch(q){if(q.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(N,W);const ne=E.URI.file(N);if(this.M.removeRecentlyOpened([ne]),W.ignoreFileNotFound)return{fileUri:ne,type:a.FileType.File,exists:!1}}}async nb(N,W){const z=E.URI.file(N),{response:te,checkboxChecked:ee}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(10981,null),(0,t.localize)(10982,null),(0,t.localize)(10983,null)],message:(0,t.localize)(10984,null,z.authority),detail:(0,t.localize)(10985,null,(0,h.$Xw)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10986,null,z.authority),cancelId:1});if(te===0){if((0,P.addUNCHostToAllowlist)(z.authority),ee){const q={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(q.channel,q.args),this.sendToOpeningWindow(q.channel,q.args)}return this.mb(N,W,!0)}if(te===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,W)}ob(N,W){const z=N.charCodeAt(0),te=W.remoteAuthority;let ee,q;W.gotoLineMode&&({path:N,line:ee,column:q}=(0,m.$Kg)(N)),z!==p.CharCode.Slash&&((0,m.$Dg)(z)&&N.charCodeAt(N.charCodeAt(1))===p.CharCode.Colon&&(N=(0,m.$wg)(N)),N=`/${N}`);const ne=E.URI.from({scheme:w.Schemas.vscodeRemote,authority:te,path:N});if(N.charCodeAt(N.length-1)!==p.CharCode.Slash){if((0,H.$9i)(N))return W.forceOpenWorkspaceAsFile?{fileUri:ne,options:{selection:ee?{startLineNumber:ee,startColumn:q||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,J.$Mfc)(ne),remoteAuthority:te};if(W.gotoLineMode||f.$fc.basename(N).indexOf(".")!==-1)return{fileUri:ne,options:{selection:ee?{startLineNumber:ee,startColumn:q||1}:void 0},remoteAuthority:te}}return{workspace:(0,J.$Nfc)(ne),remoteAuthority:te}}pb(N){const W=this.L.getValue("window"),z=W?.openFoldersInNewWindow||"default",te=W?.openFilesInNewWindow||"off";let ee=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(z==="on"||z==="off")&&(ee=z==="on");let q=!1;return N.forceNewWindow||N.forceReuseWindow?q=!!N.forceNewWindow&&!N.forceReuseWindow:(v.$k?N.context===X.OpenContext.DOCK&&(q=!0):N.context!==X.OpenContext.DIALOG&&N.context!==X.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!N.cli.extensionDevelopmentPath&&(te==="on"||te==="off")&&(q=te==="on")),{openFolderInNewWindow:!!ee,openFilesInNewWindow:q}}async openExtensionDevelopmentHostWindow(N,W){const z=(0,K.$Kfc)(this.getWindows(),N);if(z)return this.I.reload(z,W.cli),z.focus(),[z];let te=W.cli["folder-uri"]||[],ee=W.cli["file-uri"]||[],q=W.cli._;if(!q.length&&!te.length&&!ee.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(E.URI.isUri(we)?we.scheme===w.Schemas.file?q=[we.fsPath]:te=[we.toString()]:we.configPath.scheme===w.Schemas.file?q=[(0,$.$5g)(we.configPath)]:ee=[we.configPath.toString()])}let ne=W.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=E.URI.parse(me),Ie=(0,R.$fn)(we);Ie&&(ne?(0,$.$jh)(Ie,ne)||this.z.error("more than one extension development path authority"):ne=Ie)}q=q.filter(me=>{const we=E.URI.file(me);return(0,K.$Jfc)(this.getWindows(),we)?!1:(0,$.$jh)((0,R.$fn)(we),ne)}),te=te.filter(me=>{const we=this.gb(me);return we&&(0,K.$Jfc)(this.getWindows(),we)?!1:we?(0,$.$jh)((0,R.$fn)(we),ne):!1}),ee=ee.filter(me=>{const we=this.gb(me);return we&&(0,K.$Jfc)(this.getWindows(),we)?!1:we?(0,$.$jh)((0,R.$fn)(we),ne):!1}),W.cli._=q,W.cli["folder-uri"]=te,W.cli["file-uri"]=ee;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!q.length&&!te.length&&!ee.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ne,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(N){const W=this.L.getValue("window"),z=this.getLastActiveWindow(),ee=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let q;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(q=N.windowToUse||z,q&&q.focus());const ne={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,f.$ic)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:ee},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:D.default,isInitialStartup:N.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(q){const de=q.config;!ne.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=de.extensionDevelopmentPath,ne.extensionDevelopmentKind=de.extensionDevelopmentKind,ne["enable-proposed-api"]=de["enable-proposed-api"],ne.verbose=de.verbose,ne["inspect-extensions"]=de["inspect-extensions"],ne["inspect-brk-extensions"]=de["inspect-brk-extensions"],ne.debugId=de.debugId,ne.extensionEnvironment=de.extensionEnvironment,ne["extensions-dir"]=de["extensions-dir"],ne["disable-extensions"]=de["disable-extensions"]),ne.loggers={global:ne.loggers.global,window:de?.loggers.window??ne.loggers.window}}else{const de=this.r.getNewWindowState(ne);(0,g.mark)("code/willCreateCodeWindow");const me=q=this.O.createInstance(x.$Ufc,{state:de,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new d.$Sc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:We,y:Oe})=>this.m.fire({window:me,x:We,y:Oe})));const Ie=(0,k.$og)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ne.windowId=q.id,q.isReady?this.I.unload(q,B.UnloadReason.LOAD).then(async de=>{de||await this.rb(q,ne,N,ee)}):await this.rb(q,ne,N,ee),q}async rb(N,W,z,te){if(W.extensionDevelopmentPath||((0,H.$Si)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,H.$Ni)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,J.$Ofc)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const ee=W.workspace??(0,H.$Ri)(W.backupPath,!1),q=this.sb(z,ee,te),ne=q instanceof Promise?await q:q;W.profiles.profile=ne,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(ee,ne)}N.load(W)}sb(N,W,z){return N.forceProfile?this.H.profiles.find(te=>te.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??z}tb(N,W){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=r.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(W=>(0,$.$jh)(W.remoteAuthority,N)))}wb(N){return(0,X.$Ffc)(N)}sendToFocused(N,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,...W)}sendToOpeningWindow(N,...W){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(N,I.CancellationToken.None,...W)}))}sendToAll(N,W,z){for(const te of this.getWindows())z&&z.indexOf(te.id)>=0||te.sendWhenReady(N,I.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const W=r.BrowserWindow.fromWebContents(N);if(!W)return;const z=this.getWindowById(W.id);return z?.matches(N)?z:void 0}};e.$8gc=Q,e.$8gc=Q=Se([se(4,y.$$j),se(5,oe.$Rfc),se(6,O.$wR),se(7,C.$ro),se(8,s.$qfc),se(9,Y.$Gfc),se(10,S.$Wfc),se(11,u.$xfc),se(12,i.$0i),se(13,U.$Dgc),se(14,Z.$Pfc),se(15,l.$Ci),se(16,o.$yfc),se(17,a.$$k),se(18,L.$Afc),se(19,j.$Bfc),se(20,G.$pgc)],Q)}),define(ce[278],le([0,1,69,29,88,59]),function(V,e,n,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;let T=class{constructor(p,c,m,h){this.a=p,this.b=c,this.c=m,this.d=h,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,c){const m=this.b.getWindowById(p);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(p,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(p,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(p,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(p,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$0gc=T,e.$0gc=T=Se([se(0,A.$Pfc),se(1,r.$Dfc),se(2,P.$Dgc),se(3,n.$xfc)],T)}),define(ce[279],le([0,1,13,106,35,27,17,55,15,4,283,47,2,11,9,3,12,7,33,158,44,159,118,135,10,69,253,16,260,96,136,53,97,187,20,68,100,175,263,177,178,179,14,191,99,83,6,98,186,269,270,254,261,19,5,276,64,28,74,264,101,34,243,87,128,24,220,221,57,50,233,258,271,259,272,132,235,236,237,240,267,51,29,277,242,30,102,88,278,59,40,200,58,213,49,86,133,245,262,250,8,223,244,195,71,266,239,21,75,265,231,206,65,84,274,78]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R,O,M,x,X,K,fe,H,J,U,Z,B,j,C,Y,oe,G,ue,re,Q,F,N,W,z,te,ee,q,ne,de,me,we,Ie,We,Oe,Ee,$e,_,ae,he,be,De,Fe,Me,Ae,Be,Ge,Ze,qe,Ye,Qe,Je,Ce,ie,ge,pe,ye,je,Ue,_e,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Mt,Et,dt,Ft,Nt,wt,Ct,St,Wt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let yt=class extends d.$Tc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Re,Te,Le,ve,ke,Xe,xe,Ke,Ne,He,ze,et){super(),this.g=Re,this.h=Te,this.j=Le,this.m=ve,this.n=ke,this.s=Xe,this.t=xe,this.u=Ke,this.w=Ne,this.y=He,this.z=ze,this.C=et,this.D(),this.F()}D(){const Re=Ne=>Ne?.startsWith(`${w.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ne,He,ze,et)=>Re(et.requestingUrl)?ze(Te.has(He)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ne,He,ze,et)=>Re(et.requestingUrl)?Te.has(He):!1);const Le=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ne=>{for(let He=Ne;He;He=He.parent)if(He.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},ke=Ne=>Ne.resourceType==="xhr"||ve(Ne.frame),Xe=Ne=>{const He=Ne.frame;if(!He||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},xe=(Ne,He)=>{if(Ne.path!=="/index.html")return!0;const ze=He.frame;if(!ze||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ne,He)=>{const ze=b.URI.parse(Ne.url);return ze.scheme===w.Schemas.vscodeWebview&&!xe(ze,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),He({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!Xe(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),He({cancel:!0})):ze.path.endsWith(".svg")&&!Le.has(ze.scheme)?He({cancel:!ke(Ne)}):He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{const ze=Ne.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!ke(Ne)})}return He({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ne.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:ze})}return He({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,f.$ic)(this.s.codeCachePath,"chrome")),g.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,p.$X)(Le)||(0,p.$Y)(Le)}),process.on("unhandledRejection",Le=>(0,p.$Y)(Le)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$RX)(),n.app.on("accessibility-support-changed",(Le,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(Le,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Je.OpenContext.DOCK})}),n.app.on("web-contents-created",(Le,ve)=>{ve?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Wg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",ke=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),ve.setWindowOpenHandler(ke=>ke.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(ke)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${ke.url}}`),this.f?.openExternal(void 0,ke.url),{action:"deny"}))});let Re=[],Te;n.app.on("open-file",(Le,ve)=>{ve=(0,kt.$lm)(ve),this.m.trace("app#open-file: ",ve),Le.preventDefault(),Re.push((0,ge.$9i)(ve)?{workspaceUri:b.URI.file(ve)}:{fileUri:b.URI.file(ve)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Je.OpenContext.DOCK,cli:this.s.args,urisToOpen:Re,gotoLineMode:!1,preferNewWindow:!0}),Re=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Je.OpenContext.DESKTOP})}),P.$QX.handle("vscode:fetchShellEnv",Le=>{const ve=this.b?.getWindowByWebContents(Le.sender);let ke,Xe;return ve?.config?(ke=ve.config,Xe={...process.env,...ve.config.userEnv}):(ke=this.s.args,Xe=process.env),this.W(ke,Xe,!1)}),P.$QX.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),P.$QX.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),P.$QX.on("vscode:reloadWindow",Le=>Le.sender.reload()),P.$QX.handle("vscode:notifyZoomLevel",async(Le,ve)=>{const ke=this.b?.getWindowByWebContents(Le.sender);ke&&ke.notifyZoomLevel(ve)})}G(Re){if(Re){const Te={message:`[uncaught exception in main]: ${Re.message}`,stack:Re.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Re}`),Re.stack&&this.m.error(Re.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Re=this.z.win32AppUserModelId;g.$j&&Re&&n.app.setAppUserModelId(Re);try{g.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new t.$XX;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===N.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,ve,ke]=await Promise.all([(0,$t.$ghc)(this.w,this.m),(0,$t.$hhc)(this.w,this.m),(0,$t.$ihc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:Xe,sharedProcessClient:xe}=this.O(Le,ve,ke),Ke=await this.P(Le,ve,ke,Xe);Ke.invokeFunction(ze=>ze.get(i.$7fc)),this.B(Ke.createInstance(gt.$bhc)),Ke.invokeFunction(ze=>this.Q(ze,Te,xe));const Ne=await Ke.invokeFunction(ze=>this.H(ze,Te));this.I(Te),this.t.phase=N.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.R(ze,Ne)),this.t.phase=N.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Ph(()=>{this.B((0,mt.$Th)(()=>this.t.phase=N.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Re,Te){const Le=this.b=Re.get(Je.$Dfc),ve=Re.get(Ae.$FY),ke=this.f=Re.get(te.$qgc),Xe=Re.get(L.$yfc),xe=this;ve.registerHandler({async handleURL(it,ot){return xe.N(Le,Xe,ve,it,ot)}});const Ke=this.B(new ie.$9gc({onDidOpenMainWindow:ke.onDidOpenMainWindow,onDidFocusMainWindow:ke.onDidFocusMainWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ne=new E.$li(it=>Ke.getActiveClientId().then(ot=>it===ot)),He=new Be.$Zgc(Ne,this.m),ze=Te.getChannel("urlHandler",He);ve.registerHandler(new Be.$Ygc(ze));const et=await this.J(Le,Xe);return this.B(new Ze.$1gc(et?.urls,ve,Le,this.s,this.z,this.m)),et}I(Re){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Ct.$T(()=>Re.getChannel(wt.$phc,new wt.$qhc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(ve,ke)=>{const Xe=b.URI.parse(ve.url);if(!Xe.authority.startsWith("window:"))return ke(Te());Le.value.call(wt.$ohc,[Xe]).then(xe=>ke({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),ke({statusCode:500,data:String(xe)})})})}async J(Re,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),Le.length+ve.length===0)return;const ke=[...Le,...ve].map(Ke=>{try{return{uri:b.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Xe=[],xe=[];for(const Ke of ke){if(!Ke)continue;const Ne=this.M(Ke.uri);if(Ne)if(await this.L(Ne,Re,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ne),Xe.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),xe.push(Ke)}return{urls:xe,openables:Xe}}async L(Re,Te,Le){let ve,ke;if((0,Qe.$8D)(Re)?(ve=Re.workspaceUri,ke=(0,o.localize)(12886,null,ve.scheme===w.Schemas.file?(0,h.$Xw)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Qe.$9D)(Re)?(ve=Re.folderUri,ke=(0,o.localize)(12887,null,ve.scheme===w.Schemas.file?(0,h.$Xw)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Re.fileUri,ke=(0,o.localize)(12888,null,ve.scheme===w.Schemas.file?(0,h.$Xw)(ve,{os:g.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==w.Schemas.file&&ve.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ke}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(12889,null),(0,o.localize)(12890,null)],message:ke,detail:(0,o.localize)(12891,null),checkboxLabel:ve.scheme===w.Schemas.file?(0,o.localize)(12892,null):(0,o.localize)(12893,null),cancelId:1});if(xe!==0)return!0;if(Ke){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===w.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}M(Re){if(Re.path){if(Re.authority===w.Schemas.file){const Te=b.URI.file(Re.fsPath);return(0,ge.$9i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Re.authority===w.Schemas.vscodeRemote){const Te=Re.path.indexOf(f.$fc.sep,1);if(Te!==-1){const Le=Re.path.substring(1,Te),ve=Re.path.substring(Te);let ke=Re.query;const Xe=new URLSearchParams(Re.query);Xe.get("windowId")==="_blank"&&(Xe.delete("windowId"),ke=Xe.toString());const xe=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:Le,path:ve,query:ke,fragment:Re.fragment});return(0,ge.$9i)(ve)?{workspaceUri:xe}:/:[\d]+$/.test(ve)?{fileUri:xe}:{folderUri:xe}}}}}async N(Re,Te,Le,ve,ke){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),ke),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:b.URI.parse(ve.query).path,query:""}));let Xe=!1;const xe=new URLSearchParams(ve.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),xe.delete("windowId"),ve=ve.with({query:xe.toString()}),Xe=!0):g.$k&&Re.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Xe=!0);const Ke=xe.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),xe.delete("continueOn"),ve=ve.with({query:xe.toString()}),this.s.continueOn=Ke??void 0);const Ne=this.M(ve);return Ne?await this.L(Ne,Re,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,ve.toString(!0)),(0,Et.$Nb)(await Re.open({context:Je.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:Xe,gotoLineMode:!0}))?.focus(),!0):Xe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Nb)(await Re.open({context:Je.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,q.$fn)(ve)}))?.ready(),Le.open(ve,ke)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),ke),!1)}O(Re,Te,Le){const ve=this.B(this.j.createInstance(ne.$Lgc,Re,Te,Le));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const ke=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new u.$YX(xe,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),ke))(),sharedProcessClient:ke}}async P(Re,Te,Le,ve){const ke=new oe.$Bi;switch(process.platform){case"win32":ke.set(ae.$PY,new C.$Ai(Me.$Wgc));break;case"linux":g.$m?ke.set(ae.$PY,new C.$Ai(Fe.$Vgc,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(ae.$PY,new C.$Ai(De.$Ugc));break;case"darwin":ke.set(ae.$PY,new C.$Ai(be.$Tgc));break}ke.set(Je.$Dfc,new C.$Ai(Ce.$8gc,[Re,Te,Le,this.h],!1)),ke.set(St.$pgc,new C.$Ai(Wt.$rhc,void 0,!1));const Xe=new L.$zfc(this.m,this.z);ke.set(L.$yfc,Xe),ke.set(F.$xgc,new C.$Ai(F.$ygc,void 0,!1)),ke.set(D.$bgc,new C.$Ai(D.$cgc,void 0,!1)),ke.set(y.$Rm,E.ProxyChannel.toService((0,E.$ji)(ve.then(ze=>ze.getChannel("diagnostics"))))),ke.set(G.$Z_b,new C.$Ai(ue.$sgc,[this.h])),ke.set(G.$1_b,new C.$Ai(re.$tgc,[this.h])),ke.set(R.$zY,new C.$Ai(O.$dgc)),ke.set(Q.$ugc,new C.$Ai(Q.$vgc)),ke.set(te.$qgc,new C.$Ai(te.$rgc,void 0,!1)),ke.set(qe.$2gc,new C.$Ai(Ye.$4gc)),ke.set(z.$Ggc,new C.$Ai(z.$Hgc)),ke.set(K.$egc,new C.$Ai(fe.$ggc)),ke.set(Ie.$3fc,new C.$Ai(Ie.$4fc)),ke.set(Ie.$5fc,new C.$Ai(Ie.$6fc));const xe=new Ft.$nhc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Nt.$Os(xe,this.u,this.m,this.n);ke.set(dt.$ps,Ke),g.$j?ke.set(H.$hgc,new C.$Ai(J.$igc)):g.$k?ke.set(H.$hgc,new C.$Ai(J.$jgc)):g.$l&&ke.set(H.$hgc,new C.$Ai(J.$kgc));const Ne=new a.$9fc(this.s,this.u,this.m,this.w);ke.set(s.$xfc,Ne);const He=new Ue.$Qfc(this.s,this.m,this.C,Ne,Xe);if(ke.set(Ue.$Pfc,He),ke.set(pe.$0hb,new C.$Ai(je.$0gc,void 0,!1)),ke.set(ye.$Dgc,new C.$Ai(ye.$Egc,void 0,!1)),ke.set(Ae.$FY,new C.$Ai(Ge.$HY,void 0,!1)),(0,_.$Cp)(this.z,this.s)){const ze=(0,_.$Hp)(this.z,this.u),et=(0,E.$ji)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new Ee.$Ogc(et),ot=(0,We.$tp)((0,A.release)(),(0,A.hostname)(),process.arch,this.z.commit,this.z.version,Re,Te,Le,ze),nt=(0,_.$Ip)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};ke.set(Oe.$0l,new C.$Ai($e.$fs,[ht],!1))}else ke.set(Oe.$0l,_.$xp);return ke.set(ut.$Hq,new C.$Ai(Tt.$DR,void 0,!0)),ke.set(ct.$Lq,new C.$Ai(ft.$ahc,void 0,!0)),ke.set(pt.$lhc,new C.$Ai(pt.$mhc,void 0,!0)),ke.set(i.$7fc,new C.$Ai(i.$8fc)),await mt.Promises.settled([Ne.initialize(),He.initialize()]),this.j.createChild(ke)}Q(Re,Te,Le){const ve=this.B(new d.$Sc),ke=E.ProxyChannel.fromService(Re.get(F.$xgc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",ke);const Xe=E.ProxyChannel.fromService(Re.get(D.$bgc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Xe);const xe=ve.add(new lt.$$gc(Re.get(_e.$ro)));Te.registerChannel("policy",xe),Le.then(st=>st.registerChannel("policy",xe));const Ke=this.y.getProvider(w.Schemas.file);(0,v.$ng)(Ke instanceof j.$rr);const Ne=ve.add(new B.$lgc(Ke,this.m,this.s));Te.registerChannel(U.$mR,Ne),Le.then(st=>st.registerChannel(U.$mR,Ne));const He=E.ProxyChannel.fromService(Re.get(rt.$Gfc),ve);Te.registerChannel("userDataProfiles",He),Le.then(st=>st.registerChannel("userDataProfiles",He));const ze=new at.$as(Re.get(tt.$6p));Le.then(st=>st.registerChannel("request",ze));const et=new he.$Pgc(Re.get(ae.$PY));Te.registerChannel("update",et);const it=E.ProxyChannel.fromService(Re.get(G.$Z_b),ve);Te.registerChannel("issue",it);const ot=E.ProxyChannel.fromService(Re.get(G.$1_b),ve);Te.registerChannel("process",ot);const nt=E.ProxyChannel.fromService(Re.get(R.$zY),ve);Te.registerChannel("encryption",nt);const ht=E.ProxyChannel.fromService(Re.get(de.$Xl),ve);Te.registerChannel("sign",ht);const vt=E.ProxyChannel.fromService(Re.get(Q.$ugc),ve);Te.registerChannel("keyboardLayout",vt),this.f=Re.get(te.$qgc);const Pt=E.ProxyChannel.fromService(this.f,ve);Te.registerChannel("nativeHost",Pt),Le.then(st=>st.registerChannel("nativeHost",Pt));const Bt=E.ProxyChannel.fromService(Re.get(pe.$0hb),ve);Te.registerChannel("workspaces",Bt);const Ut=E.ProxyChannel.fromService(Re.get(z.$Ggc),ve);Te.registerChannel("menubar",Ut);const zt=E.ProxyChannel.fromService(Re.get(Ae.$FY),ve);Te.registerChannel("url",zt);const qt=E.ProxyChannel.fromService(Re.get(qe.$2gc),ve);Te.registerChannel("webview",qt);const It=ve.add(new we.$Mgc(this.m,Re.get(Ie.$3fc)));Te.registerChannel("storage",It),Le.then(st=>st.registerChannel("storage",It));const Xt=ve.add(new Ot.$chc(Re.get(Ie.$3fc),Re.get(rt.$Gfc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",Xt));const Ht=E.ProxyChannel.fromService(Re.get(dt.$ps),ve);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Ht);const xt=E.ProxyChannel.fromService(Re.get(H.$hgc),ve);Te.registerChannel("externalTerminal",xt);const Dt=new Lt.$jhc(Re.get(jt.$Rfc));Te.registerChannel("logger",Dt),Le.then(st=>st.registerChannel("logger",Dt));const Vt=new S.$0fc(Re.get(Je.$Dfc));Te.registerChannel("extensionhostdebugservice",Vt);const Gt=E.ProxyChannel.fromService(Re.get(K.$egc),ve);Te.registerChannel(K.$fgc,Gt);const Kt=E.ProxyChannel.fromService(Re.get(pt.$lhc),ve);Te.registerChannel(Mt.$khc,Kt)}async R(Re,Te){const Le=this.b=Re.get(Je.$Dfc);this.c=Re.get(St.$pgc);const ve=(0,x.$Im)(process.env)?Je.OpenContext.CLI:Je.OpenContext.DESKTOP,ke=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:ve,cli:ke,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:ve,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Xe=global.macOpenFiles,xe=ke._.length,Ke=!!ke["folder-uri"],Ne=!!ke["file-uri"],He=ke["skip-add-to-recently-opened"]===!0,ze=ke.wait&&ke.waitMarkerFilePath?b.URI.file(ke.waitMarkerFilePath):void 0,et=ke.remote||void 0,it=ke.profile,ot=ke["profile-temp"];if(!xe&&!Ke&&!Ne){if(ke["new-window"]||it||ot)return Le.open({context:ve,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(Xe.length)return Le.open({context:Je.OpenContext.DOCK,cli:ke,urisToOpen:Xe.map(nt=>(nt=(0,kt.$lm)(nt),(0,ge.$9i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:ze,initialStartup:!0})}return Le.open({context:ve,cli:ke,forceNewWindow:ke["new-window"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:He,waitMarkerFileURI:ze,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Re,Te)=>{Te({url:Re.url.replace(/^vscode-remote-resource:/,"http:"),method:Re.method})}),this.W(this.s.args,process.env,!0),this.X(),g.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Re=this.z.win32MutexName;if(g.$j&&Re)try{const Te=await new Promise((ve,ke)=>{V(["@vscode/windows-mutex"],ve,ke)}).then(Pe),Le=new Te.Mutex(Re);c.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(Re,Te,Le){try{return await(0,X.$Pm)(this.u,this.m,Re,Te)}catch(ve){const ke=(0,I.$oj)(ve);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",ke):this.m.error(ke)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,m.parse)(Te),ke=(0,_.$Ep)(this.u)>=Oe.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$Zg)()}"`,"}"],xe=Te.substring(0,Te.length-2).concat(`,
`,Xe.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Me.fromString(xe))}else{const Xe=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Xe!==Te&&await this.y.writeFile(this.s.argvResource,T.$Me.fromString(Xe))}}catch(Re){this.m.error(Re),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$shc=yt,e.$shc=yt=bt=Se([se(2,Y.$Ci),se(3,W.$$j),se(4,W.$_j),se(5,M.$qfc),se(6,N.$Wfc),se(7,l.$0i),se(8,me.$wR),se(9,Z.$$k),se(10,ee.$rk),se(11,rt.$Gfc)],yt)});var Ve=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[284],le([0,1,13,26,7,21,8,55,15,32,4,47,11,9,70,3,36,25,23,44,104,279,10,16,205,219,20,68,170,14,189,99,83,185,98,19,192,5,72,28,73,246,131,257,49,256,101,218,34,57,76,58,40,201,199,2,41,234,71,194,123,127,238,106,232]),function(V,e,n,r,P,A,T,I,p,c,m,h,d,w,f,g,v,b,$,k,E,t,u,i,o,s,a,l,S,y,D,L,R,O,M,x,X,K,fe,H,J,U,Z,B,j,C,Y,oe,G,ue,re,Q,F,N,W,z,te,ee,q,ne,de,me,we,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),fe=Ve(fe);class We{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[$e,_,ae,he,be,De,Fe,Me]=this.b();try{try{await this.d(ae,Me,he,be,Fe)}catch(Ae){throw this.g(ae,Fe,Ae),Ae}await $e.invokeFunction(async Ae=>{const Be=Ae.get(K.$$j),Ge=Ae.get(x.$Wfc),Ze=Ae.get(y.$$k),qe=Ae.get(K.$_j),Ye=await this.f(Be,ae,Ge,$e,Fe,!0);return $.Promises.writeFile(ae.mainLockfile,String(process.pid)).catch(Qe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),De.logger=qe.createLogger("main",{name:(0,u.localize)(12877,null)}),m.Event.once(Ge.onWillShutdown)(Qe=>{Ze.dispose(),he.dispose(),Qe.join("instanceLockfile",r.promises.unlink(ae.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$shc,Ye,_).startup()})}catch(Ae){$e.invokeFunction(this.j,Ae)}}b(){const $e=new M.$Bi,_=new z.$Sc;process.once("exit",()=>_.dispose());const ae={_serviceBrand:void 0,...fe.default};$e.set(H.$rk,ae);const he=new a.$rfc(this.k(),ae),be=this.c(he);$e.set(a.$qfc,he);const De=new q.$Sfc((0,K.$mk)(he),he.logsHome);$e.set(q.$Rfc,De);const Fe=new X.$4cc(De.getLogLevel()),Me=_.add(new ne.$ER(Fe,[new K.$fk(De.getLogLevel())]));$e.set(K.$$j,Me);const Ae=new D.$1q(Me);$e.set(y.$$k,Ae);const Be=new L.$rr(Me);Ae.registerProvider(d.Schemas.file,Be);const Ge=new ee.$Ss(Ae);$e.set(te.$Il,Ge);const Ze=new me.$zR(me.SaveStrategy.DELAYED,he,Me,Ae);$e.set(G.$vR,Ze),$e.set(G.$wR,Ze);const qe=new Q.$Hfc(Ze,Ge,he,Ae,Me);$e.set(Q.$Gfc,qe),Ae.registerProvider(d.Schemas.vscodeUserData,new we.$Dhc(d.Schemas.file,Be,d.Schemas.vscodeUserData,qe,Ge,Me));const Ye=g.$j&&ae.win32RegValueName?_.add(new N.$Bhc(Me,ae.win32RegValueName)):he.policyFile?_.add(new W.$Chc(he.policyFile,Ae,Me)):new F.$to;$e.set(F.$ro,Ye);const Qe=new o.$Vo(qe.defaultProfile.settingsResource,Ae,Ye,Me);return $e.set(i.$0i,Qe),$e.set(x.$Wfc,new R.$Ai(x.$Xfc,void 0,!1)),$e.set(j.$6p,new R.$Ai(C.$zhc,void 0,!0)),$e.set(re.$Bfc,new R.$Ai(re.$Cfc)),$e.set(Y.$Xl,new R.$Ai(oe.$Ahc,void 0,!1)),$e.set(Z.$Cw,new R.$Ai(B.$xhc)),$e.set(J.$Afc,new U.$uhc(he,qe,Me)),[new O.$ur($e,!0),be,he,Qe,Ze,Fe,ae,qe]}c($e){const _={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const he=process.env[ae];typeof he=="string"&&(_[ae]=he)}),Object.assign(process.env,_),_}async d($e,_,ae,he,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:d.Schemas.file}).fsPath,_.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:d.Schemas.file}).fsPath,$e.backupHome].map(De=>De?r.promises.mkdir(De,{recursive:!0}):void 0)),he.init(),ae.initialize()]),_.init()}e($e){if(g.$j){const _=(0,Ie.getUNCHost)($e);_&&(0,Ie.addUNCHostToAllowlist)(_)}return $e}async f($e,_,ae,he,be,De){let Fe;try{(0,f.mark)("code/willStartMainServer"),Fe=await(0,E.$yi)(_.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),m.Event.once(ae.onWillShutdown)(()=>Fe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(_,be,Me),Me;let Ae;try{Ae=await(0,E.$zi)(_.mainIPCHandle,"main")}catch(qe){if(!De||g.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,u.localize)(12878,null,be.nameShort),(0,u.localize)(12879,null),be),qe;try{(0,r.unlinkSync)(_.mainIPCHandle)}catch(Ye){throw $e.warn("Could not delete obsolete instance handle",Ye),Ye}return this.f($e,_,ae,he,be,!1)}if(_.extensionTestsLocationURI&&!_.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Ae.dispose(),new Error(qe)}let Be;!_.args.wait&&!_.args.status&&(Be=setTimeout(()=>{this.h((0,u.localize)(12880,null,be.nameShort),(0,u.localize)(12881,null),be)},1e4));const Ge=k.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ze=k.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(_.args.status)return he.invokeFunction(async()=>{const qe=new s.$Zs(ue.$xp,be),Ye=await Ze.getMainDiagnostics(),Qe=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Je=await qe.getDiagnostics(Ye,Qe);throw console.log(Je),new p.$_});throw g.$j&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(_.args,process.env),Ae.dispose(),Be&&clearTimeout(Be),new p.$_("Sent env to running instance. Terminating...")}if(_.args.status)throw console.log((0,u.localize)(12882,null,be.nameShort)),new p.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Fe}g($e,_,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const he=(0,A.$Gb)([$e.userDataPath,$e.extensionsPath,E.$ui]).map(be=>(0,h.$Xw)(P.URI.file(be),{os:g.OS,tildify:$e}));this.h((0,u.localize)(12883,null),(0,u.localize)(12884,null,(0,I.$oj)(ae),he.join(`
`)),_)}}h($e,_,ae){n.dialog.showMessageBoxSync((0,de.$_w)({type:"warning",buttons:[(0,u.localize)(12885,null)],message:$e,detail:_},ae).options)}async i($e,_){if(g.$j){const ae=await $e.getMainProcessId();_.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((he,be)=>{V(["windows-foreground-love"],he,be)}).then(Pe)).allowSetForegroundWindow(ae)}catch(he){_.error(he)}}}j($e,_){const ae=$e.get(K.$$j),he=$e.get(x.$Wfc);let be=0;_&&(_.isExpected?_.message&&ae.trace(_.message):(be=1,_.stack?ae.error(_.stack):ae.error(`Startup error: ${_.toString()}`))),he.kill(be)}k(){const $e=this.l((0,l.$Fm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const _=(0,S.$thc)($e.verbose);_&&((0,l.$Hm)(process.argv,"--waitMarkerFilePath",_),$e.waitMarkerFilePath=_)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const _=this.m($e._,$e.goto);$e._=_}return $e}m($e,_){const ae=(0,v.cwd)(),he=$e.map(Fe=>{let Me=String(Fe),Ae;_&&(Ae=(0,c.$Kg)(Me),Me=Ae.path),Me&&(Me=this.n(ae,Me));const Be=(0,c.$Eg)(Me,ae),Ge=(0,w.$mc)(Be);return Ge&&!(0,c.$Ag)(Ge)?null:_&&Ae?(Ae.path=Be,this.o(Ae)):Be}),be=g.$j||g.$k,De=(0,A.$Lb)(he,Fe=>Fe&&be?Fe.toLowerCase():Fe||"");return(0,A.$Gb)(De)}n($e,_){return g.$j&&(_=(0,b.$mf)(_,'"')),_=(0,b.$kf)((0,b.$kf)(_," "),"	"),g.$j&&(_=(0,w.$jc)($e,_),_=(0,b.$mf)(_,".")),_}o($e){const _=[$e.path];return typeof $e.line=="number"&&_.push(String($e.line)),typeof $e.column=="number"&&_.push(String($e.column)),_.join(":")}}new We().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/89690b9d76a88fab676d26651134a1ffa4562732/core/vs/code/electron-main/main.js.map
