/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/browser/mouseEvent","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/path","vs/base/browser/event","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/common/actions","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/browser/canIUse","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/parts/ipc/common/ipc","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/common/keybindings","vs/base/common/process","vs/base/common/mime","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/extpath","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],De=function(le){for(var t=[],i=0,n=le.length;i<n;i++)t[i]=we[le[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Xt,setPrototypeOf:Ht,isFrozen:ui,getPrototypeOf:hi,getOwnPropertyDescriptor:ci}=Object;let{freeze:ht,seal:$t,create:fi}=Object,{apply:Mt,construct:Bt}=typeof Reflect<"u"&&Reflect;Mt||(Mt=function(t,i,n){return t.apply(i,n)}),ht||(ht=function(t){return t}),$t||($t=function(t){return t}),Bt||(Bt=function(t,i){return new t(...i)});const di=mt(Array.prototype.forEach),xt=mt(Array.prototype.pop),St=mt(Array.prototype.push),Lt=mt(String.prototype.toLowerCase),Pt=mt(String.prototype.toString),gi=mt(String.prototype.match),pt=mt(String.prototype.replace),mi=mt(String.prototype.indexOf),bi=mt(String.prototype.trim),gt=mt(RegExp.prototype.test),Tt=$i(TypeError);function mt(le){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),B=1;B<i;B++)n[B-1]=arguments[B];return Mt(le,t,n)}}function $i(le){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Bt(le,i)}}function Ke(le,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Lt,Ht&&Ht(le,null);let B=t.length;for(;B--;){let N=t[B];if(typeof N=="string"){const k=i(N);k!==N&&(ui(t)||(t[B]=k),N=k)}le[N]=!0}return le}function vt(le){const t=fi(null);for(const[i,n]of Xt(le))t[i]=n;return t}function Ft(le,t){for(;le!==null;){const n=ci(le,t);if(n){if(n.get)return mt(n.get);if(typeof n.value=="function")return mt(n.value)}le=hi(le)}function i(n){return console.warn("fallback value for",n),null}return i}const Wt=ht(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),jt=ht(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=ht(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),pi=ht(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),_t=ht(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),wi=ht(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),zt=ht(["#text"]),Vt=ht(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ut=ht(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Kt=ht(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),It=ht(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),Di=$t(/\{\{[\w\W]*|[\w\W]*\}\}/gm),vi=$t(/<%[\w\W]*|[\w\W]*%>/gm),Ei=$t(/\${[\w\W]*}/gm),yi=$t(/^data-[\-\w.\u00B7-\uFFFF]/),Ai=$t(/^aria-[\-\w]+$/),qt=$t(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Si=$t(/^(?:\w+script|data):/i),Ti=$t(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=$t(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:Di,ERB_EXPR:vi,TMPLIT_EXPR:Ei,DATA_ATTR:yi,ARIA_ATTR:Ai,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:Si,ATTR_WHITESPACE:Ti,DOCTYPE_NAME:Gt});const ki=()=>typeof window>"u"?null:window,Ni=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const B="data-tt-policy-suffix";i&&i.hasAttribute(B)&&(n=i.getAttribute(B));const N="dompurify"+(n?"#"+n:"");try{return t.createPolicy(N,{createHTML(k){return k},createScriptURL(k){return k}})}catch{return console.warn("TrustedTypes policy "+N+" could not be created."),null}};function Zt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ki();const t=Xe=>Zt(Xe);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const i=le.document,n=i.currentScript;let{document:B}=le;const{DocumentFragment:N,HTMLTemplateElement:k,Node:w,Element:v,NodeFilter:c,NamedNodeMap:p=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:y,DOMParser:$,trustedTypes:g}=le,e=v.prototype,s=Ft(e,"cloneNode"),r=Ft(e,"nextSibling"),h=Ft(e,"childNodes"),l=Ft(e,"parentNode");if(typeof k=="function"){const Xe=B.createElement("template");Xe.content&&Xe.content.ownerDocument&&(B=Xe.content.ownerDocument)}let D,T="";const{implementation:A,createNodeIterator:d,createDocumentFragment:f,getElementsByTagName:m}=B,{importNode:S}=i;let H={};t.isSupported=typeof Xt=="function"&&typeof l=="function"&&A&&A.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:U,ERB_EXPR:C,TMPLIT_EXPR:E,DATA_ATTR:R,ARIA_ATTR:x,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:_}=Yt;let{IS_ALLOWED_URI:V}=Yt,J=null;const q=Ke({},[...Wt,...jt,...Ct,..._t,...zt]);let z=null;const Q=Ke({},[...Vt,...Ut,...Kt,...It]);let ue=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),be=null,Ae=null,Fe=!0,ne=!0,ee=!1,fe=!0,ae=!1,Ne=!1,te=!1,$e=!1,Te=!1,Oe=!1,Re=!1,_e=!0,oe=!1;const K="user-content-";let j=!0,a=!1,o={},b=null;const M=Ke({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const u=Ke({},["audio","video","img","source","image","track"]);let L=null;const O=Ke({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),P="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",Y="http://www.w3.org/1999/xhtml";let ie=Y,re=!1,ce=null;const Ee=Ke({},[P,X,Y],Pt);let ve;const ye=["application/xhtml+xml","text/html"],Le="text/html";let de,Ie=null;const Ve=B.createElement("form"),Ge=function(ge){return ge instanceof RegExp||ge instanceof Function},tt=function(ge){if(!(Ie&&Ie===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=vt(ge),ve=ye.indexOf(ge.PARSER_MEDIA_TYPE)===-1?ve=Le:ve=ge.PARSER_MEDIA_TYPE,de=ve==="application/xhtml+xml"?Pt:Lt,J="ALLOWED_TAGS"in ge?Ke({},ge.ALLOWED_TAGS,de):q,z="ALLOWED_ATTR"in ge?Ke({},ge.ALLOWED_ATTR,de):Q,ce="ALLOWED_NAMESPACES"in ge?Ke({},ge.ALLOWED_NAMESPACES,Pt):Ee,L="ADD_URI_SAFE_ATTR"in ge?Ke(vt(O),ge.ADD_URI_SAFE_ATTR,de):O,F="ADD_DATA_URI_TAGS"in ge?Ke(vt(u),ge.ADD_DATA_URI_TAGS,de):u,b="FORBID_CONTENTS"in ge?Ke({},ge.FORBID_CONTENTS,de):M,be="FORBID_TAGS"in ge?Ke({},ge.FORBID_TAGS,de):{},Ae="FORBID_ATTR"in ge?Ke({},ge.FORBID_ATTR,de):{},o="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Fe=ge.ALLOW_ARIA_ATTR!==!1,ne=ge.ALLOW_DATA_ATTR!==!1,ee=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=ge.SAFE_FOR_TEMPLATES||!1,Ne=ge.WHOLE_DOCUMENT||!1,Te=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Re=ge.RETURN_TRUSTED_TYPE||!1,$e=ge.FORCE_BODY||!1,_e=ge.SANITIZE_DOM!==!1,oe=ge.SANITIZE_NAMED_PROPS||!1,j=ge.KEEP_CONTENT!==!1,a=ge.IN_PLACE||!1,V=ge.ALLOWED_URI_REGEXP||qt,ie=ge.NAMESPACE||Y,ue=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Ge(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ue.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Ge(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ue.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ue.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(ne=!1),Oe&&(Te=!0),o&&(J=Ke({},[...zt]),z=[],o.html===!0&&(Ke(J,Wt),Ke(z,Vt)),o.svg===!0&&(Ke(J,jt),Ke(z,Ut),Ke(z,It)),o.svgFilters===!0&&(Ke(J,Ct),Ke(z,Ut),Ke(z,It)),o.mathMl===!0&&(Ke(J,_t),Ke(z,Kt),Ke(z,It))),ge.ADD_TAGS&&(J===q&&(J=vt(J)),Ke(J,ge.ADD_TAGS,de)),ge.ADD_ATTR&&(z===Q&&(z=vt(z)),Ke(z,ge.ADD_ATTR,de)),ge.ADD_URI_SAFE_ATTR&&Ke(L,ge.ADD_URI_SAFE_ATTR,de),ge.FORBID_CONTENTS&&(b===M&&(b=vt(b)),Ke(b,ge.FORBID_CONTENTS,de)),j&&(J["#text"]=!0),Ne&&Ke(J,["html","head","body"]),J.table&&(Ke(J,["tbody"]),delete be.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');D=ge.TRUSTED_TYPES_POLICY,T=D.createHTML("")}else D===void 0&&(D=Ni(g,n)),D!==null&&typeof T=="string"&&(T=D.createHTML(""));ht&&ht(ge),Ie=ge}},lt=Ke({},["mi","mo","mn","ms","mtext"]),st=Ke({},["foreignobject","desc","title","annotation-xml"]),qe=Ke({},["title","style","font","a","script"]),Ze=Ke({},jt);Ke(Ze,Ct),Ke(Ze,pi);const Z=Ke({},_t);Ke(Z,wi);const he=function(ge){let Me=l(ge);(!Me||!Me.tagName)&&(Me={namespaceURI:ie,tagName:"template"});const je=Lt(ge.tagName),Ye=Lt(Me.tagName);return ce[ge.namespaceURI]?ge.namespaceURI===X?Me.namespaceURI===Y?je==="svg":Me.namespaceURI===P?je==="svg"&&(Ye==="annotation-xml"||lt[Ye]):!!Ze[je]:ge.namespaceURI===P?Me.namespaceURI===Y?je==="math":Me.namespaceURI===X?je==="math"&&st[Ye]:!!Z[je]:ge.namespaceURI===Y?Me.namespaceURI===X&&!st[Ye]||Me.namespaceURI===P&&!lt[Ye]?!1:!Z[je]&&(qe[je]||!Ze[je]):!!(ve==="application/xhtml+xml"&&ce[ge.namespaceURI]):!1},pe=function(ge){St(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},ke=function(ge,Me){try{St(t.removed,{attribute:Me.getAttributeNode(ge),from:Me})}catch{St(t.removed,{attribute:null,from:Me})}if(Me.removeAttribute(ge),ge==="is"&&!z[ge])if(Te||Oe)try{pe(Me)}catch{}else try{Me.setAttribute(ge,"")}catch{}},Pe=function(ge){let Me,je;if($e)ge="<remove></remove>"+ge;else{const ut=gi(ge,/^[\r\n\t ]+/);je=ut&&ut[0]}ve==="application/xhtml+xml"&&ie===Y&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ye=D?D.createHTML(ge):ge;if(ie===Y)try{Me=new $().parseFromString(Ye,ve)}catch{}if(!Me||!Me.documentElement){Me=A.createDocument(ie,"template",null);try{Me.documentElement.innerHTML=re?T:Ye}catch{}}const ot=Me.body||Me.documentElement;return ge&&je&&ot.insertBefore(B.createTextNode(je),ot.childNodes[0]||null),ie===Y?m.call(Me,Ne?"html":"body")[0]:Ne?Me.documentElement:ot},xe=function(ge){return d.call(ge.ownerDocument||ge,ge,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},Je=function(ge){return ge instanceof y&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof p)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},rt=function(ge){return typeof w=="object"?ge instanceof w:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},it=function(ge,Me,je){H[ge]&&di(H[ge],Ye=>{Ye.call(t,Me,je,Ie)})},ct=function(ge){let Me;if(it("beforeSanitizeElements",ge,null),Je(ge))return pe(ge),!0;const je=de(ge.nodeName);if(it("uponSanitizeElement",ge,{tagName:je,allowedTags:J}),ge.hasChildNodes()&&!rt(ge.firstElementChild)&&(!rt(ge.content)||!rt(ge.content.firstElementChild))&&gt(/<[/\w]/g,ge.innerHTML)&&gt(/<[/\w]/g,ge.textContent))return pe(ge),!0;if(!J[je]||be[je]){if(!be[je]&&dt(je)&&(ue.tagNameCheck instanceof RegExp&&gt(ue.tagNameCheck,je)||ue.tagNameCheck instanceof Function&&ue.tagNameCheck(je)))return!1;if(j&&!b[je]){const Ye=l(ge)||ge.parentNode,ot=h(ge)||ge.childNodes;if(ot&&Ye){const ut=ot.length;for(let Qe=ut-1;Qe>=0;--Qe)Ye.insertBefore(s(ot[Qe],!0),r(ge))}}return pe(ge),!0}return ge instanceof v&&!he(ge)||(je==="noscript"||je==="noembed"||je==="noframes")&&gt(/<\/no(script|embed|frames)/i,ge.innerHTML)?(pe(ge),!0):(ae&&ge.nodeType===3&&(Me=ge.textContent,Me=pt(Me,U," "),Me=pt(Me,C," "),Me=pt(Me,E," "),ge.textContent!==Me&&(St(t.removed,{element:ge.cloneNode()}),ge.textContent=Me)),it("afterSanitizeElements",ge,null),!1)},nt=function(ge,Me,je){if(_e&&(Me==="id"||Me==="name")&&(je in B||je in Ve))return!1;if(!(ne&&!Ae[Me]&&gt(R,Me))){if(!(Fe&&gt(x,Me))){if(!z[Me]||Ae[Me]){if(!(dt(ge)&&(ue.tagNameCheck instanceof RegExp&&gt(ue.tagNameCheck,ge)||ue.tagNameCheck instanceof Function&&ue.tagNameCheck(ge))&&(ue.attributeNameCheck instanceof RegExp&&gt(ue.attributeNameCheck,Me)||ue.attributeNameCheck instanceof Function&&ue.attributeNameCheck(Me))||Me==="is"&&ue.allowCustomizedBuiltInElements&&(ue.tagNameCheck instanceof RegExp&&gt(ue.tagNameCheck,je)||ue.tagNameCheck instanceof Function&&ue.tagNameCheck(je))))return!1}else if(!L[Me]){if(!gt(V,pt(je,_,""))){if(!((Me==="src"||Me==="xlink:href"||Me==="href")&&ge!=="script"&&mi(je,"data:")===0&&F[ge])){if(!(ee&&!gt(I,pt(je,_,"")))){if(je)return!1}}}}}}return!0},dt=function(ge){return ge.indexOf("-")>0},ft=function(ge){let Me,je,Ye,ot;it("beforeSanitizeAttributes",ge,null);const{attributes:ut}=ge;if(!ut)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:z};for(ot=ut.length;ot--;){Me=ut[ot];const{name:bt,namespaceURI:Et}=Me;if(je=bt==="value"?Me.value:bi(Me.value),Ye=de(bt),Qe.attrName=Ye,Qe.attrValue=je,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,it("uponSanitizeAttribute",ge,Qe),je=Qe.attrValue,Qe.forceKeepAttr||(ke(bt,ge),!Qe.keepAttr))continue;if(!fe&&gt(/\/>/i,je)){ke(bt,ge);continue}ae&&(je=pt(je,U," "),je=pt(je,C," "),je=pt(je,E," "));const Rt=de(ge.nodeName);if(nt(Rt,Ye,je)){if(oe&&(Ye==="id"||Ye==="name")&&(ke(bt,ge),je=K+je),D&&typeof g=="object"&&typeof g.getAttributeType=="function"&&!Et)switch(g.getAttributeType(Rt,Ye)){case"TrustedHTML":{je=D.createHTML(je);break}case"TrustedScriptURL":{je=D.createScriptURL(je);break}}try{Et?ge.setAttributeNS(Et,bt,je):ge.setAttribute(bt,je),xt(t.removed)}catch{}}}it("afterSanitizeAttributes",ge,null)},wt=function Xe(ge){let Me;const je=xe(ge);for(it("beforeSanitizeShadowDOM",ge,null);Me=je.nextNode();)it("uponSanitizeShadowNode",Me,null),!ct(Me)&&(Me.content instanceof N&&Xe(Me.content),ft(Me));it("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(Xe){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Me,je,Ye,ot;if(re=!Xe,re&&(Xe="<!-->"),typeof Xe!="string"&&!rt(Xe))if(typeof Xe.toString=="function"){if(Xe=Xe.toString(),typeof Xe!="string")throw Tt("dirty is not a string, aborting")}else throw Tt("toString is not a function");if(!t.isSupported)return Xe;if(te||tt(ge),t.removed=[],typeof Xe=="string"&&(a=!1),a){if(Xe.nodeName){const bt=de(Xe.nodeName);if(!J[bt]||be[bt])throw Tt("root node is forbidden and cannot be sanitized in-place")}}else if(Xe instanceof w)Me=Pe("<!---->"),je=Me.ownerDocument.importNode(Xe,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Me=je:Me.appendChild(je);else{if(!Te&&!ae&&!Ne&&Xe.indexOf("<")===-1)return D&&Re?D.createHTML(Xe):Xe;if(Me=Pe(Xe),!Me)return Te?null:Re?T:""}Me&&$e&&pe(Me.firstChild);const ut=xe(a?Xe:Me);for(;Ye=ut.nextNode();)ct(Ye)||(Ye.content instanceof N&&wt(Ye.content),ft(Ye));if(a)return Xe;if(Te){if(Oe)for(ot=f.call(Me.ownerDocument);Me.firstChild;)ot.appendChild(Me.firstChild);else ot=Me;return(z.shadowroot||z.shadowrootmode)&&(ot=S.call(i,ot,!0)),ot}let Qe=Ne?Me.outerHTML:Me.innerHTML;return Ne&&J["!doctype"]&&Me.ownerDocument&&Me.ownerDocument.doctype&&Me.ownerDocument.doctype.name&&gt(Gt,Me.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Me.ownerDocument.doctype.name+`>
`+Qe),ae&&(Qe=pt(Qe,U," "),Qe=pt(Qe,C," "),Qe=pt(Qe,E," ")),D&&Re?D.createHTML(Qe):Qe},t.setConfig=function(Xe){tt(Xe),te=!0},t.clearConfig=function(){Ie=null,te=!1},t.isValidAttribute=function(Xe,ge,Me){Ie||tt({});const je=de(Xe),Ye=de(ge);return nt(je,Ye,Me)},t.addHook=function(Xe,ge){typeof ge=="function"&&(H[Xe]=H[Xe]||[],St(H[Xe],ge))},t.removeHook=function(Xe){if(H[Xe])return xt(H[Xe])},t.removeHooks=function(Xe){H[Xe]&&(H[Xe]=[])},t.removeAllHooks=function(){H={}},t}var Li=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Li}),define(we[55],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iU=void 0,t.$jU=B;class i{constructor(k){this.domNode=k,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(k){const w=n(k);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(k){const w=n(k);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(k){const w=n(k);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(k){const w=n(k);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(k){const w=n(k);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(k){const w=n(k);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(k){const w=n(k);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(k){const w=n(k);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(k){const w=n(k);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(k){const w=n(k);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(k){const w=n(k);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(k){this.l!==k&&(this.l=k,this.domNode.style.fontFamily=this.l)}setFontWeight(k){this.m!==k&&(this.m=k,this.domNode.style.fontWeight=this.m)}setFontSize(k){const w=n(k);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(k){this.o!==k&&(this.o=k,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(k){this.p!==k&&(this.p=k,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(k){this.q!==k&&(this.q=k,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(k){this.r!==k&&(this.r=k,this.domNode.style.textDecoration=this.r)}setLineHeight(k){const w=n(k);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(k){const w=n(k);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(k){this.u!==k&&(this.u=k,this.domNode.className=this.u)}toggleClassName(k,w){this.domNode.classList.toggle(k,w),this.u=this.domNode.className}setDisplay(k){this.v!==k&&(this.v=k,this.domNode.style.display=this.v)}setPosition(k){this.w!==k&&(this.w=k,this.domNode.style.position=this.w)}setVisibility(k){this.x!==k&&(this.x=k,this.domNode.style.visibility=this.x)}setColor(k){this.y!==k&&(this.y=k,this.domNode.style.color=this.y)}setBackgroundColor(k){this.z!==k&&(this.z=k,this.domNode.style.backgroundColor=this.z)}setLayerHinting(k){this.A!==k&&(this.A=k,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(k){this.C!==k&&(this.C=k,this.domNode.style.boxShadow=k)}setContain(k){this.B!==k&&(this.B=k,this.domNode.style.contain=this.B)}setAttribute(k,w){this.domNode.setAttribute(k,w)}removeAttribute(k){this.domNode.removeAttribute(k)}appendChild(k){this.domNode.appendChild(k.domNode)}removeChild(k){this.domNode.removeChild(k.domNode)}}t.$iU=i;function n(N){return typeof N=="number"?`${N}px`:N}function B(N){return new i(N)}}),define(we[85],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qS=void 0,t.$rS=N;const i=new WeakMap;function n(w){if(!w.parent||w.parent===w)return null;try{const v=w.location,c=w.parent.location;if(v.origin!=="null"&&c.origin!=="null"&&v.origin!==c.origin)return null}catch{return null}return w.parent}class B{static a(v){let c=i.get(v);if(!c){c=[],i.set(v,c);let p=v,y;do y=n(p),y?c.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):c.push({window:new WeakRef(p),iframeElement:null}),p=y;while(p)}return c.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(v,c){if(!c||v===c)return{top:0,left:0};let p=0,y=0;const $=this.a(v);for(const g of $){const e=g.window.deref();if(p+=e?.scrollY??0,y+=e?.scrollX??0,e===c||!g.iframeElement)break;const s=g.iframeElement.getBoundingClientRect();p+=s.top,y+=s.left}return{top:p,left:y}}}t.$qS=B;async function N(w,v){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const c=JSON.stringify({parentOrigin:w,salt:v}),y=new TextEncoder().encode(c),$=await crypto.subtle.digest("sha-256",y);return k($)}function k(w){const c=Array.from(new Uint8Array(w)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${c}`).toString(32).padStart(52,"0")}}),define(we[33],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pV=n,t.$qV=B;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(N){i=N}function B(){return i}}),define(we[41],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5U=t.$4U=t.$3U=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(k){k[k.Copy=0]="Copy",k[k.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(k){k.Over="drop-target",k.Before="drop-target-before",k.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$3U={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(w,v){super(`ListError [${w}] ${v}`)}}t.$4U=B;class N{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,v){v>0&&this.c.set(w,v)}}t.$5U=N}),define(we[86],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SU=void 0;class i{constructor(B){this.a=B}splice(B,N,k){this.a.forEach(w=>w.splice(B,N,k))}}t.$SU=i}),define(we[56],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oU=void 0;const i=20;class n{constructor(N,k,w,v,c,p){this.a=Math.round(k),this.b=Math.round(w),this.c=Math.round(N),this.d=v,this.e=c,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(N){const k=Math.round(N);return this.d!==k?(this.d=k,this.m(),!0):!1}setScrollSize(N){const k=Math.round(N);return this.e!==k?(this.e=k,this.m(),!0):!1}setScrollPosition(N){const k=Math.round(N);return this.f!==k?(this.f=k,this.m(),!0):!1}setScrollbarSize(N){this.a=Math.round(N)}setOppositeScrollbarSize(N){this.b=Math.round(N)}static l(N,k,w,v,c){const p=Math.max(0,w-N),y=Math.max(0,p-2*k),$=v>0&&v>w;if(!$)return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(y),computedSliderRatio:0,computedSliderPosition:0};const g=Math.round(Math.max(i,Math.floor(w*y/v))),e=(y-g)/(v-w),s=c*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(g),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const N=n.l(this.b,this.c,this.d,this.e,this.f);this.g=N.computedAvailableSize,this.h=N.computedIsNeeded,this.i=N.computedSliderSize,this.j=N.computedSliderRatio,this.k=N.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(N){if(!this.h)return 0;const k=N-this.c-this.i/2;return Math.round(k/this.j)}getDesiredScrollPositionFromOffsetPaged(N){if(!this.h)return 0;const k=N-this.c;let w=this.f;return k<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(N){if(!this.h)return 0;const k=this.k+N;return Math.round(k/this.j)}}t.$oU=n}),define(we[34],De([1,0,41]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4W=t.$3W=t.$2W=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var B;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(B||(t.ObjectTreeElementCollapseState=B={}));var N;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(N||(t.TreeMouseEventTarget=N={}));var k;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(k||(t.TreeDragOverBubble=k={})),t.$2W={acceptBubbleUp(){return{accept:!0,bubble:k.Up}},acceptBubbleDown(c=!1){return{accept:!0,bubble:k.Down,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:k.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:k.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:c}}};class w extends Error{constructor(p,y){super(`TreeError [${p}] ${y}`)}}t.$3W=w;class v{constructor(p){this.a=p,this.b=new WeakMap}map(p){let y=this.b.get(p);return y||(y=this.a(p),this.b.set(p,y)),y}}t.$4W=v}),define(we[24],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6R=void 0,t.$5R=i,t.$7R=n;function i(B,N){const k=B;typeof k.vscodeWindowId!="number"&&Object.defineProperty(k,"vscodeWindowId",{get:()=>N})}t.$6R=window;function n(B){return B===t.$6R?!1:typeof B?.vscodeWindowId=="number"}}),define(we[87],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lb=void 0,t.$eb=i,t.$fb=n,t.$gb=B,t.$hb=N,t.$ib=k,t.$jb=w,t.$kb=v,t.$mb=p,t.$nb=y,t.$ob=$,t.$pb=g,t.$qb=e;function i(s,r){const h=n(s,r);if(h!==-1)return s[h]}function n(s,r,h=s.length-1){for(let l=h;l>=0;l--){const D=s[l];if(r(D))return l}return-1}function B(s,r){const h=N(s,r);return h===-1?void 0:s[h]}function N(s,r,h=0,l=s.length){let D=h,T=l;for(;D<T;){const A=Math.floor((D+T)/2);r(s[A])?D=A+1:T=A}return D-1}function k(s,r){const h=w(s,r);return h===s.length?void 0:s[h]}function w(s,r,h=0,l=s.length){let D=h,T=l;for(;D<T;){const A=Math.floor((D+T)/2);r(s[A])?T=A:D=A+1}return D}function v(s,r,h=0,l=s.length){const D=w(s,r,h,l);return D===s.length?-1:D}class c{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(c.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!r(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=N(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$lb=c;function p(s,r){if(s.length===0)return;let h=s[0];for(let l=1;l<s.length;l++){const D=s[l];r(D,h)>0&&(h=D)}return h}function y(s,r){if(s.length===0)return;let h=s[0];for(let l=1;l<s.length;l++){const D=s[l];r(D,h)>=0&&(h=D)}return h}function $(s,r){return p(s,(h,l)=>-r(h,l))}function g(s,r){if(s.length===0)return-1;let h=0;for(let l=1;l<s.length;l++){const D=s[l];r(D,s[h])>0&&(h=l)}return h}function e(s,r){for(const h of s){const l=r(h);if(l!==void 0)return l}}}),define(we[17],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(we[57],De([1,0]),function(le,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=n,t.$d=B,t.$e=N,t.$f=k;function n(v,c){const p=Object.create(null);for(const y of v){const $=c(y);let g=p[$];g||(g=p[$]=[]),g.push(y)}return p}function B(v,c){const p=[],y=[];for(const $ of v)c.has($)||p.push($);for(const $ of c)v.has($)||y.push($);return{removed:p,added:y}}function N(v,c){const p=[],y=[];for(const[$,g]of v)c.has($)||p.push(g);for(const[$,g]of c)v.has($)||y.push(g);return{removed:p,added:y}}function k(v,c){const p=new Set;for(const y of c)v.has(y)&&p.add(y);return p}class w{static{i=Symbol.toStringTag}constructor(c,p){this.b=p,this.a=new Map,this[i]="SetWithKey";for(const y of c)this.add(y)}get size(){return this.a.size}add(c){const p=this.b(c);return this.a.set(p,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,p){this.a.forEach(y=>c.call(p,y,y,this))}[Symbol.iterator](){return this.values()}}t.$g=w}),define(we[88],De([1,0,17]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mu=t.$lu=t.$ku=t.$ju=void 0;function n(v,c){const p=Math.pow(10,c);return Math.round(v*p)/p}class B{constructor(c,p,y,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.r===p.r&&c.g===p.g&&c.b===p.b&&c.a===p.a}}t.$ju=B;class N{constructor(c,p,y,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.h===p.h&&c.s===p.s&&c.l===p.l&&c.a===p.a}static fromRGBA(c){const p=c.r/255,y=c.g/255,$=c.b/255,g=c.a,e=Math.max(p,y,$),s=Math.min(p,y,$);let r=0,h=0;const l=(s+e)/2,D=e-s;if(D>0){switch(h=Math.min(l<=.5?D/(2*l):D/(2-2*l),1),e){case p:r=(y-$)/D+(y<$?6:0);break;case y:r=($-p)/D+2;break;case $:r=(p-y)/D+4;break}r*=60,r=Math.round(r)}return new N(r,h,l,g)}static i(c,p,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?c+(p-c)*6*y:y<1/2?p:y<2/3?c+(p-c)*(2/3-y)*6:c}static toRGBA(c){const p=c.h/360,{s:y,l:$,a:g}=c;let e,s,r;if(y===0)e=s=r=$;else{const h=$<.5?$*(1+y):$+y-$*y,l=2*$-h;e=N.i(l,h,p+1/3),s=N.i(l,h,p),r=N.i(l,h,p-1/3)}return new B(Math.round(e*255),Math.round(s*255),Math.round(r*255),g)}}t.$ku=N;class k{constructor(c,p,y,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.h===p.h&&c.s===p.s&&c.v===p.v&&c.a===p.a}static fromRGBA(c){const p=c.r/255,y=c.g/255,$=c.b/255,g=Math.max(p,y,$),e=Math.min(p,y,$),s=g-e,r=g===0?0:s/g;let h;return s===0?h=0:g===p?h=((y-$)/s%6+6)%6:g===y?h=($-p)/s+2:h=(p-y)/s+4,new k(Math.round(h*60),r,g,c.a)}static toRGBA(c){const{h:p,s:y,v:$,a:g}=c,e=$*y,s=e*(1-Math.abs(p/60%2-1)),r=$-e;let[h,l,D]=[0,0,0];return p<60?(h=e,l=s):p<120?(h=s,l=e):p<180?(l=e,D=s):p<240?(l=s,D=e):p<300?(h=s,D=e):p<=360&&(h=e,D=s),h=Math.round((h+r)*255),l=Math.round((l+r)*255),D=Math.round((D+r)*255),new B(h,l,D,g)}}t.$lu=k;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,p){return!c&&!p?!0:!c||!p?!1:c.equals(p)}get hsla(){return this.i?this.i:N.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:k.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof B)this.rgba=c;else if(c instanceof N)this.i=c,this.rgba=N.toRGBA(c);else if(c instanceof k)this.j=c,this.rgba=k.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&B.equals(this.rgba,c.rgba)&&N.equals(this.hsla,c.hsla)&&k.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w.k(this.rgba.r),p=w.k(this.rgba.g),y=w.k(this.rgba.b),$=.2126*c+.7152*p+.0722*y;return n($,4)}static k(c){const p=c/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p>y?(p+.05)/(y+.05):(y+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p>y}isDarkerThan(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p<y}lighten(c){return new w(new N(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new N(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:p,g:y,b:$,a:g}=this.rgba;return new w(new B(p,y,$,g*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new B(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const p=c.rgba,y=this.rgba.a,$=p.a,g=y+$*(1-y);if(g<1e-6)return w.transparent;const e=this.rgba.r*y/g+p.r*$*(1-y)/g,s=this.rgba.g*y/g+p.g*$*(1-y)/g,r=this.rgba.b*y/g+p.b*$*(1-y)/g;return new w(new B(e,s,r,g))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:p,g:y,b:$,a:g}=this.rgba;return new w(new B(c.rgba.r-g*(c.rgba.r-p),c.rgba.g-g*(c.rgba.g-y),c.rgba.b-g*(c.rgba.b-$),1))}flatten(...c){const p=c.reduceRight((y,$)=>w.o($,y));return w.o(this,p)}static o(c,p){const y=1-c.rgba.a;return new w(new B(y*p.rgba.r+c.rgba.a*c.rgba.r,y*p.rgba.g+c.rgba.a*c.rgba.g,y*p.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(c,p,y){if(c.isLighterThan(p))return c;y=y||.5;const $=c.getRelativeLuminance(),g=p.getRelativeLuminance();return y=y*(g-$)/g,c.lighten(y)}static getDarkerColor(c,p,y){if(c.isDarkerThan(p))return c;y=y||.5;const $=c.getRelativeLuminance(),g=p.getRelativeLuminance();return y=y*($-g)/$,c.darken(y)}static{this.white=new w(new B(255,255,255,1))}static{this.black=new w(new B(0,0,0,1))}static{this.red=new w(new B(255,0,0,1))}static{this.blue=new w(new B(0,0,255,1))}static{this.green=new w(new B(0,255,0,1))}static{this.cyan=new w(new B(0,255,255,1))}static{this.lightgrey=new w(new B(211,211,211,1))}static{this.transparent=new w(new B(0,0,0,0))}}t.$mu=w,function(v){let c;(function(p){let y;(function($){function g(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:v.Format.CSS.formatRGBA(f)}$.formatRGB=g;function e(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}$.formatRGBA=e;function s(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(f)}$.formatHSL=s;function r(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}$.formatHSLA=r;function h(f){const m=f.toString(16);return m.length!==2?"0"+m:m}function l(f){return`#${h(f.rgba.r)}${h(f.rgba.g)}${h(f.rgba.b)}`}$.formatHex=l;function D(f,m=!1){return m&&f.rgba.a===1?v.Format.CSS.formatHex(f):`#${h(f.rgba.r)}${h(f.rgba.g)}${h(f.rgba.b)}${h(Math.round(f.rgba.a*255))}`}$.formatHexA=D;function T(f){return f.isOpaque()?v.Format.CSS.formatHex(f):v.Format.CSS.formatRGBA(f)}$.format=T;function A(f){const m=f.length;if(m===0||f.charCodeAt(0)!==i.CharCode.Hash)return null;if(m===7){const S=16*d(f.charCodeAt(1))+d(f.charCodeAt(2)),H=16*d(f.charCodeAt(3))+d(f.charCodeAt(4)),U=16*d(f.charCodeAt(5))+d(f.charCodeAt(6));return new v(new B(S,H,U,1))}if(m===9){const S=16*d(f.charCodeAt(1))+d(f.charCodeAt(2)),H=16*d(f.charCodeAt(3))+d(f.charCodeAt(4)),U=16*d(f.charCodeAt(5))+d(f.charCodeAt(6)),C=16*d(f.charCodeAt(7))+d(f.charCodeAt(8));return new v(new B(S,H,U,C/255))}if(m===4){const S=d(f.charCodeAt(1)),H=d(f.charCodeAt(2)),U=d(f.charCodeAt(3));return new v(new B(16*S+S,16*H+H,16*U+U))}if(m===5){const S=d(f.charCodeAt(1)),H=d(f.charCodeAt(2)),U=d(f.charCodeAt(3)),C=d(f.charCodeAt(4));return new v(new B(16*S+S,16*H+H,16*U+U,(16*C+C)/255))}return null}$.parseHex=A;function d(f){switch(f){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(y=p.CSS||(p.CSS={}))})(c=v.Format||(v.Format={}))}(w||(t.$mu=w={}))}),define(we[35],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8h=n,t.$9h=B,t.$0h=N;function i(k){return(w,v,c)=>{let p=null,y=null;if(typeof c.value=="function"?(p="value",y=c.value):typeof c.get=="function"&&(p="get",y=c.get),!y)throw new Error("not supported");c[p]=k(y,v)}}function n(k,w,v){let c=null,p=null;if(typeof v.value=="function"?(c="value",p=v.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(c="get",p=v.get),!p)throw new Error("not supported");const y=`$memoize$${w}`;v[c]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,$)}),this[y]}}function B(k,w,v){return i((c,p)=>{const y=`$debounce$${p}`,$=`$debounce$result$${p}`;return function(...g){this[$]||(this[$]=v?v():void 0),clearTimeout(this[y]),w&&(this[$]=w(this[$],...g),g=[this[$]]),this[y]=setTimeout(()=>{c.apply(this,g),this[$]=v?v():void 0},k)}})}function N(k,w,v){return i((c,p)=>{const y=`$throttle$timer$${p}`,$=`$throttle$result$${p}`,g=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...s){if(this[$]||(this[$]=v?v():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),w&&(this[$]=w(this[$],...s)),this[e])return;const r=this[g]+k;r<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[$]]),this[$]=v?v():void 0):(this[e]=!0,this[y]=setTimeout(()=>{this[e]=!1,this[g]=Date.now(),c.apply(this,[this[$]]),this[$]=v?v():void 0},r-Date.now()))}})}}),define(we[89],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pt=void 0;class i{constructor(B,N,k,w){this.originalStart=B,this.originalLength=N,this.modifiedStart=k,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Pt=i}),define(we[6],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$8=t.$4=t.$V=t.$U=void 0,t.setUnexpectedErrorHandler=n,t.$X=B,t.$Y=N,t.$Z=k,t.$1=w,t.$2=v,t.$3=p,t.$5=$,t.$6=g,t.$7=e,t.$9=r;class i{constructor(){this.b=[],this.a=function(f){setTimeout(()=>{throw f.stack?T.isErrorNoTelemetry(f)?new T(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.b.push(f),()=>{this.d(f)}}c(f){this.b.forEach(m=>{m(f)})}d(f){this.b.splice(this.b.indexOf(f),1)}setUnexpectedErrorHandler(f){this.a=f}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(f){this.a(f),this.c(f)}onUnexpectedExternalError(f){this.a(f)}}t.$U=i,t.$V=new i;function n(d){t.$V.setUnexpectedErrorHandler(d)}function B(d){if(!d||typeof d!="object")return!1;const f=d;return f.code==="EPIPE"&&f.syscall?.toUpperCase()==="WRITE"}function N(d){p(d)||t.$V.onUnexpectedError(d)}function k(d){p(d)||t.$V.onUnexpectedExternalError(d)}function w(d){if(d instanceof Error){const{name:f,message:m}=d,S=d.stacktrace||d.stack;return{$isError:!0,name:f,message:m,stack:S,noTelemetry:T.isErrorNoTelemetry(d)}}return d}function v(d){let f;return d.noTelemetry?f=new T:(f=new Error,f.name=d.name),f.message=d.message,f.stack=d.stack,f}const c="Canceled";function p(d){return d instanceof y?!0:d instanceof Error&&d.name===c&&d.message===c}class y extends Error{constructor(){super(c),this.name=this.message}}t.$4=y;function $(){const d=new Error(c);return d.name=d.message,d}function g(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function e(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class s extends TypeError{constructor(f){super(f?`${f} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=s;function r(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class h extends Error{constructor(f){super("NotImplemented"),f&&(this.message=f)}}t.$0=h;class l extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}t.$$=l;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=D;class T extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof T)return f;const m=new T;return m.message=f.message,m.stack=f.stack,m}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}t.$ab=T;class A extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype)}}t.$bb=A}),define(we[9],De([1,0,6,87]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$8b=t.$7b=t.CompareResult=void 0,t.$rb=B,t.$sb=N,t.$tb=k,t.$ub=w,t.$vb=v,t.$wb=c,t.$xb=p,t.$yb=y,t.$zb=$,t.$Ab=g,t.$Bb=e,t.$Cb=s,t.$Db=r,t.top=h,t.$Fb=l,t.$Gb=T,t.$Hb=A,t.$Ib=d,t.$Jb=f,t.$Kb=m,t.$Lb=S,t.$Mb=H,t.$Nb=U,t.$Ob=C,t.$Pb=E,t.$Qb=R,t.$Rb=x,t.$Sb=I,t.$Tb=_,t.$Ub=V,t.$Vb=J,t.$Wb=q,t.$Xb=z,t.$Yb=Q,t.$Zb=ue,t.$1b=be,t.$2b=Ae,t.$3b=Fe,t.$4b=ne,t.$5b=ae,t.$6b=Ne,t.$9b=Te;function B(oe,K=0){return oe[oe.length-(1+K)]}function N(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function k(oe,K,j=(a,o)=>a===o){if(oe===K)return!0;if(!oe||!K||oe.length!==K.length)return!1;for(let a=0,o=oe.length;a<o;a++)if(!j(oe[a],K[a]))return!1;return!0}function w(oe,K){const j=oe.length-1;K<j&&(oe[K]=oe[j]),oe.pop()}function v(oe,K,j){return c(oe.length,a=>j(oe[a],K))}function c(oe,K){let j=0,a=oe-1;for(;j<=a;){const o=(j+a)/2|0,b=K(o);if(b<0)j=o+1;else if(b>0)a=o-1;else return o}return-(j+1)}function p(oe,K,j){if(oe=oe|0,oe>=K.length)throw new TypeError("invalid index");const a=K[Math.floor(K.length*Math.random())],o=[],b=[],M=[];for(const F of K){const u=j(F,a);u<0?o.push(F):u>0?b.push(F):M.push(F)}return oe<o.length?p(oe,o,j):oe<o.length+M.length?M[0]:p(oe-(o.length+M.length),b,j)}function y(oe,K){const j=[];let a;for(const o of oe.slice(0).sort(K))!a||K(a[0],o)!==0?(a=[o],j.push(a)):a.push(o);return j}function*$(oe,K){let j,a;for(const o of oe)a!==void 0&&K(a,o)?j.push(o):(j&&(yield j),j=[o]),a=o;j&&(yield j)}function g(oe,K){for(let j=0;j<=oe.length;j++)K(j===0?void 0:oe[j-1],j===oe.length?void 0:oe[j])}function e(oe,K){for(let j=0;j<oe.length;j++)K(j===0?void 0:oe[j-1],oe[j],j+1===oe.length?void 0:oe[j+1])}function s(oe,K,j){const a=[];function o(F,u,L){if(u===0&&L.length===0)return;const O=a[a.length-1];O&&O.start+O.deleteCount===F?(O.deleteCount+=u,O.toInsert.push(...L)):a.push({start:F,deleteCount:u,toInsert:L})}let b=0,M=0;for(;;){if(b===oe.length){o(b,0,K.slice(M));break}if(M===K.length){o(b,oe.length-b,[]);break}const F=oe[b],u=K[M],L=j(F,u);L===0?(b+=1,M+=1):L<0?(o(b,1,[]),b+=1):L>0&&(o(b,0,[u]),M+=1)}return a}function r(oe,K,j){const a=s(oe,K,j),o=[],b=[];for(const M of a)o.push(...oe.slice(M.start,M.start+M.deleteCount)),b.push(...M.toInsert);return{removed:o,added:b}}function h(oe,K,j){if(j===0)return[];const a=oe.slice(0,j).sort(K);return D(oe,K,a,j,oe.length),a}function l(oe,K,j,a,o){return j===0?Promise.resolve([]):new Promise((b,M)=>{(async()=>{const F=oe.length,u=oe.slice(0,j).sort(K);for(let L=j,O=Math.min(j+a,F);L<F;L=O,O=Math.min(O+a,F)){if(L>j&&await new Promise(P=>setTimeout(P)),o&&o.isCancellationRequested)throw new i.$4;D(oe,K,u,L,O)}return u})().then(b,M)})}function D(oe,K,j,a,o){for(const b=j.length;a<o;a++){const M=oe[a];if(K(M,j[b-1])<0){j.pop();const F=(0,n.$jb)(j,u=>K(M,u)<0);j.splice(F,0,M)}}}function T(oe){return oe.filter(K=>!!K)}function A(oe){let K=0;for(let j=0;j<oe.length;j++)oe[j]&&(oe[K]=oe[j],K+=1);oe.length=K}function d(oe,K,j){oe.splice(j,0,oe.splice(K,1)[0])}function f(oe){return!Array.isArray(oe)||oe.length===0}function m(oe){return Array.isArray(oe)&&oe.length>0}function S(oe,K=j=>j){const j=new Set;return oe.filter(a=>{const o=K(a);return j.has(o)?!1:(j.add(o),!0)})}function H(oe){const K=new Set;return j=>{const a=oe(j);return K.has(a)?!1:(K.add(a),!0)}}function U(oe,K){return oe.length>0?oe[0]:K}function C(oe,K){return oe.length>0?oe[oe.length-1]:K}function E(oe,K,j=(a,o)=>a===o){let a=0;for(let o=0,b=Math.min(oe.length,K.length);o<b&&j(oe[o],K[o]);o++)a++;return a}function R(oe,K){let j=typeof K=="number"?oe:0;typeof K=="number"?j=oe:(j=0,K=oe);const a=[];if(j<=K)for(let o=j;o<K;o++)a.push(o);else for(let o=j;o>K;o--)a.push(o);return a}function x(oe,K,j){return oe.reduce((a,o)=>(a[K(o)]=j?j(o):o,a),Object.create(null))}function I(oe,K){return oe.push(K),()=>_(oe,K)}function _(oe,K){const j=oe.indexOf(K);if(j>-1)return oe.splice(j,1),K}function V(oe,K,j){const a=oe.slice(0,K),o=oe.slice(K);return a.concat(j,o)}function J(oe,K){let j;if(typeof K=="number"){let a=K;j=()=>{const o=Math.sin(a++)*179426549;return o-Math.floor(o)}}else j=Math.random;for(let a=oe.length-1;a>0;a-=1){const o=Math.floor(j()*(a+1)),b=oe[a];oe[a]=oe[o],oe[o]=b}}function q(oe,K){const j=oe.indexOf(K);j>-1&&(oe.splice(j,1),oe.unshift(K))}function z(oe,K){const j=oe.indexOf(K);j>-1&&(oe.splice(j,1),oe.push(K))}function Q(oe,K){for(const j of K)oe.push(j)}function ue(oe,K){return Array.isArray(oe)?oe.map(K):K(oe)}function be(oe){return Array.isArray(oe)?oe:[oe]}function Ae(oe){return oe[Math.floor(Math.random()*oe.length)]}function Fe(oe,K,j){const a=ee(oe,K),o=oe.length,b=j.length;oe.length=o+b;for(let M=o-1;M>=a;M--)oe[M+b]=oe[M];for(let M=0;M<b;M++)oe[M+a]=j[M]}function ne(oe,K,j,a){const o=ee(oe,K);let b=oe.splice(o,j);return b===void 0&&(b=[]),Fe(oe,o,a),b}function ee(oe,K){return K<0?Math.max(K+oe.length,0):Math.min(K,oe.length)}var fe;(function(oe){function K(b){return b<0}oe.isLessThan=K;function j(b){return b<=0}oe.isLessThanOrEqual=j;function a(b){return b>0}oe.isGreaterThan=a;function o(b){return b===0}oe.isNeitherLessOrGreaterThan=o,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(fe||(t.CompareResult=fe={}));function ae(oe,K){return(j,a)=>K(oe(j),oe(a))}function Ne(...oe){return(K,j)=>{for(const a of oe){const o=a(K,j);if(!fe.isNeitherLessOrGreaterThan(o))return o}return fe.neitherLessOrGreaterThan}}const te=(oe,K)=>oe-K;t.$7b=te;const $e=(oe,K)=>(0,t.$7b)(oe?1:0,K?1:0);t.$8b=$e;function Te(oe){return(K,j)=>-oe(K,j)}class Oe{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let j=this.c;for(;j<this.g.length&&K(this.g[j]);)j++;const a=j===this.c?null:this.g.slice(this.c,j);return this.c=j,a}takeFromEndWhile(K){let j=this.d;for(;j>=0&&K(this.g[j]);)j--;const a=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const j=this.g.slice(this.c,this.c+K);return this.c+=K,j}}t.$0b=Oe;class Re{static{this.empty=new Re(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(j=>(K(j),!0))}toArray(){const K=[];return this.iterate(j=>(K.push(j),!0)),K}filter(K){return new Re(j=>this.iterate(a=>K(a)?j(a):!0))}map(K){return new Re(j=>this.iterate(a=>j(K(a))))}some(K){let j=!1;return this.iterate(a=>(j=K(a),!j)),j}findFirst(K){let j;return this.iterate(a=>K(a)?(j=a,!1):!0),j}findLast(K){let j;return this.iterate(a=>(K(a)&&(j=a),!0)),j}findLastMaxBy(K){let j,a=!0;return this.iterate(o=>((a||fe.isGreaterThan(K(o,j)))&&(a=!1,j=o),!0)),j}}t.$$b=Re;class _e{constructor(K){this.c=K}static createSortPermutation(K,j){const a=Array.from(K.keys()).sort((o,b)=>j(K[o],K[b]));return new _e(a)}apply(K){return K.map((j,a)=>K[this.c[a]])}inverse(){const K=this.c.slice();for(let j=0;j<this.c.length;j++)K[this.c[j]]=j;return new _e(K)}}t.$_b=_e}),define(we[42],De([1,0,6]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$dd=B,t.$ed=N,t.$fd=k,t.$gd=w,t.$hd=v;function n(c,p){if(!c)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function B(c,p="Unreachable"){throw new Error(p)}function N(c,p="unexpected state"){if(!c)throw new i.$bb(`Assertion Failed: ${p}`)}function k(c){c||(0,i.$Y)(new i.$bb("Soft Assertion Failed"))}function w(c){if(!c()){debugger;c(),(0,i.$Y)(new i.$bb("Assertion Failed"))}}function v(c,p){let y=0;for(;y<c.length-1;){const $=c[y],g=c[y+1];if(!p($,g))return!1;y++}return!0}});var Fi=this&&this.__createBinding||(Object.create?function(le,t,i,n){n===void 0&&(n=i);var B=Object.getOwnPropertyDescriptor(t,i);(!B||("get"in B?!t.__esModule:B.writable||B.configurable))&&(B={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(le,n,B)}:function(le,t,i,n){n===void 0&&(n=i),le[n]=t[i]}),Ii=this&&this.__setModuleDefault||(Object.create?function(le,t){Object.defineProperty(le,"default",{enumerable:!0,value:t})}:function(le,t){le.default=t}),He=this&&this.__importStar||function(le){if(le&&le.__esModule)return le;var t={};if(le!=null)for(var i in le)i!=="default"&&Object.prototype.hasOwnProperty.call(le,i)&&Fi(t,le,i);return Ii(t,le),t};define(we[30],De([1,0,9]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0,t.$6c=B,t.$7c=N,t.$8c=k,t.$9c=w,t.$0c=v,t.$$c=c,i=He(i);const n=(g,e)=>g===e;t.$5c=n;function B(g=t.$5c){return(e,s)=>i.$tb(e,s,g)}function N(){return(g,e)=>JSON.stringify(g)===JSON.stringify(e)}function k(){return(g,e)=>g.equals(e)}function w(g,e,s){if(s!==void 0){const r=g;return r==null||e===void 0||e===null?e===r:s(r,e)}else{const r=g;return(h,l)=>h==null||l===void 0||l===null?l===h:r(h,l)}}function v(g,e){if(g===e)return!0;if(Array.isArray(g)&&Array.isArray(e)){if(g.length!==e.length)return!1;for(let s=0;s<g.length;s++)if(!v(g[s],e[s]))return!1;return!0}if(g&&typeof g=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(g)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=g,r=e,h=Object.keys(s),l=Object.keys(r),D=new Set(l);if(h.length!==l.length)return!1;for(const T of h)if(!D.has(T)||!v(s[T],r[T]))return!1;return!0}return!1}function c(g){return JSON.stringify($(g))}let p=0;const y=new WeakMap;function $(g){if(Array.isArray(g))return g.map($);if(g&&typeof g=="object")if(Object.getPrototypeOf(g)===Object.prototype){const e=g,s=Object.create(null);for(const r of Object.keys(e).sort())s[r]=$(e[r]);return s}else{let e=y.get(g);return e===void 0&&(e=p++,y.set(g,e)),e+"----2b76a038c20c4bcc"}return g}}),define(we[58],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=i;function i(n,B){const N=this;let k=!1,w;return function(){if(k)return w;if(k=!0,B)try{w=n.apply(N,arguments)}finally{B()}else w=n.apply(N,arguments);return w}}}),define(we[90],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=void 0;class i{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$jQ=i,t.$kQ=new i("id#")}),define(we[36],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function B(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}n.is=B;const N=Object.freeze([]);function k(){return N}n.empty=k;function*w(f){yield f}n.single=w;function v(f){return B(f)?f:w(f)}n.wrap=v;function c(f){return f||N}n.from=c;function*p(f){for(let m=f.length-1;m>=0;m--)yield f[m]}n.reverse=p;function y(f){return!f||f[Symbol.iterator]().next().done===!0}n.isEmpty=y;function $(f){return f[Symbol.iterator]().next().value}n.first=$;function g(f,m){let S=0;for(const H of f)if(m(H,S++))return!0;return!1}n.some=g;function e(f,m){for(const S of f)if(m(S))return S}n.find=e;function*s(f,m){for(const S of f)m(S)&&(yield S)}n.filter=s;function*r(f,m){let S=0;for(const H of f)yield m(H,S++)}n.map=r;function*h(f,m){let S=0;for(const H of f)yield*m(H,S++)}n.flatMap=h;function*l(...f){for(const m of f)yield*m}n.concat=l;function D(f,m,S){let H=S;for(const U of f)H=m(H,U);return H}n.reduce=D;function*T(f,m,S=f.length){for(m<0&&(m+=f.length),S<0?S+=f.length:S>f.length&&(S=f.length);m<S;m++)yield f[m]}n.slice=T;function A(f,m=Number.POSITIVE_INFINITY){const S=[];if(m===0)return[S,f];const H=f[Symbol.iterator]();for(let U=0;U<m;U++){const C=H.next();if(C.done)return[S,n.empty()];S.push(C.value)}return[S,{[Symbol.iterator](){return H}}]}n.consume=A;async function d(f){const m=[];for await(const S of f)m.push(S);return Promise.resolve(m)}n.asyncToArray=d})(i||(t.Iterable=i={}))}),define(we[91],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6j=i;function i(N){let k=!1;const w=new Map,v=new Map;if(B(N,s=>{if(N===s)return!0;const r=JSON.stringify(s);if(r.length<30)return!0;const h=w.get(r);if(!h){const l={schemas:[s]};return w.set(r,l),v.set(s,l),!0}return h.schemas.push(s),v.set(s,h),k=!0,!1}),w.clear(),!k)return JSON.stringify(N);let p="$defs";for(;N.hasOwnProperty(p);)p+="_";const y=[];function $(s){return JSON.stringify(s,(r,h)=>{if(h!==s){const l=v.get(h);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${p}/${l.id}`}}return h})}const g=$(N),e=[];for(let s=0;s<y.length;s++)e.push(`"_${s}":${$(y[s])}`);return e.length?`${g.substring(0,g.length-1)},"${p}":{${e.join(",")}}}`:g}function n(N){return typeof N=="object"&&N!==null}function B(N,k){if(!N||typeof N!="object")return;const w=(...g)=>{for(const e of g)n(e)&&y.push(e)},v=(...g)=>{for(const e of g)if(n(e))for(const s in e){const r=e[s];n(r)&&y.push(r)}},c=(...g)=>{for(const e of g)if(Array.isArray(e))for(const s of e)n(s)&&y.push(s)},p=g=>{if(Array.isArray(g))for(const e of g)n(e)&&y.push(e);else n(g)&&y.push(g)},y=[N];let $=y.pop();for(;$;)k($)&&(w($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),v($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),c($.anyOf,$.allOf,$.oneOf,$.prefixItems),p($.items)),$=y.pop()}}),define(we[8],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Vr=t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.ScanCode=t.KeyCode=void 0,t.$Wr=g;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const N=new B,k=new B,w=new B;t.$Rr=new Array(230),t.$Sr={};const v=[],c=Object.create(null),p=Object.create(null);t.$Tr={lowerCaseToEnum:e=>p[e]||n.None,toEnum:e=>c[e]||n.None,toString:e=>v[e]||"None"},t.$Ur=[],t.$Vr=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Ur[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Vr[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const l of s){const[D,T,A,d,f,m,S,H,U]=l;if(h[T]||(h[T]=!0,v[T]=A,c[A]=T,p[A.toLowerCase()]=T,D&&(t.$Ur[T]=d,d!==i.Unknown&&d!==i.Enter&&d!==i.Ctrl&&d!==i.Shift&&d!==i.Alt&&d!==i.Meta&&(t.$Vr[d]=T))),!r[d]){if(r[d]=!0,!f)throw new Error(`String representation missing for key code ${d} around scan code ${A}`);N.define(d,f),k.define(d,H||f),w.define(d,U||H||f)}m&&(t.$Rr[m]=d),S&&(t.$Sr[S]=d)}t.$Vr[i.Enter]=n.Enter})();var y;(function(e){function s(A){return N.keyCodeToStr(A)}e.toString=s;function r(A){return N.strToKeyCode(A)}e.fromString=r;function h(A){return k.keyCodeToStr(A)}e.toUserSettingsUS=h;function l(A){return w.keyCodeToStr(A)}e.toUserSettingsGeneral=l;function D(A){return k.strToKeyCode(A)||w.strToKeyCode(A)}e.fromUserSettings=D;function T(A){if(A>=i.Numpad0&&A<=i.NumpadDivide)return null;switch(A){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return N.keyCodeToStr(A)}e.toElectronAccelerator=T})(y||(t.KeyCodeUtils=y={}));var $;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})($||(t.KeyMod=$={}));function g(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}}),define(we[25],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class i{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=i}),define(we[14],De([1,0,25]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DU=w,t.$EU=v,t.$FU=c;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const N=new i.$T(()=>B("mouse",!1)),k=new i.$T(()=>B("element",!1));function w(p){B=p}function v(p){return p==="element"?k.value:N.value}function c(){return B("element",!0)}}),define(we[59],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(N){this.element=N,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let N=this.a;for(;N!==i.Undefined;){const k=N.next;N.prev=i.Undefined,N.next=i.Undefined,N=k}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(N){return this.d(N,!1)}push(N){return this.d(N,!0)}d(N,k){const w=new i(N);if(this.a===i.Undefined)this.a=w,this.b=w;else if(k){const c=this.b;this.b=w,w.prev=c,c.next=w}else{const c=this.a;this.a=w,w.next=c,c.prev=w}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(w))}}shift(){if(this.a!==i.Undefined){const N=this.a.element;return this.e(this.a),N}}pop(){if(this.b!==i.Undefined){const N=this.b.element;return this.e(this.b),N}}e(N){if(N.prev!==i.Undefined&&N.next!==i.Undefined){const k=N.prev;k.next=N.next,N.next.prev=k}else N.prev===i.Undefined&&N.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):N.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):N.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let N=this.a;for(;N!==i.Undefined;)yield N.element,N=N.next}}t.$4c=n}),define(we[43],De([1,0]),function(le,t){"use strict";var i,n,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=void 0,t.$wc=N,t.$xc=k,t.$yc=w,t.$Hc=T;function N(A,d,f){let m=A.get(d);return m===void 0&&(m=f,A.set(d,m)),m}function k(A){const d=[];return A.forEach((f,m)=>{d.push(`${m} => ${f}`)}),`Map(${A.size}) {${d.join(", ")}}`}function w(A){const d=[];return A.forEach(f=>{d.push(f)}),`Set(${A.size}) {${d.join(", ")}}`}class v{constructor(d,f){this.uri=d,this.value=f}}function c(A){return Array.isArray(A)}class p{static{this.c=d=>d.toString()}constructor(d,f){if(this[i]="ResourceMap",d instanceof p)this.d=new Map(d.d),this.e=f??p.c;else if(c(d)){this.d=new Map,this.e=f??p.c;for(const[m,S]of d)this.set(m,S)}else this.d=new Map,this.e=d??p.c}set(d,f){return this.d.set(this.e(d),new v(d,f)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,f){typeof f<"u"&&(d=d.bind(f));for(const[m,S]of this.d)d(S.value,S.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}t.$zc=p;class y{constructor(d,f){this[n]="ResourceSet",!d||typeof d=="function"?this.c=new p(d):(this.c=new p(f),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,f){this.c.forEach((m,S)=>d.call(f,S,S,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=y;var $;(function(A){A[A.None=0]="None",A[A.AsOld=1]="AsOld",A[A.AsNew=2]="AsNew"})($||(t.Touch=$={}));class g{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,f=$.None){const m=this.c.get(d);if(m)return f!==$.None&&this.m(m,f),m.value}set(d,f,m=$.None){let S=this.c.get(d);if(S)S.value=f,m!==$.None&&this.m(S,m);else{switch(S={key:d,value:f,next:void 0,previous:void 0},m){case $.None:this.k(S);break;case $.AsOld:this.j(S);break;case $.AsNew:this.k(S);break;default:this.k(S);break}this.c.set(d,S),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const f=this.c.get(d);if(f)return this.c.delete(d),this.l(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.l(d),this.f--,d.value}forEach(d,f){const m=this.g;let S=this.d;for(;S;){if(f?d.bind(f)(S.value,S.key,this):d(S.value,S.key,this),this.g!==m)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const d=this,f=this.g;let m=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(m){const H={value:m.key,done:!1};return m=m.next,H}else return{value:void 0,done:!0}}};return S}values(){const d=this,f=this.g;let m=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(m){const H={value:m.value,done:!1};return m=m.next,H}else return{value:void 0,done:!0}}};return S}entries(){const d=this,f=this.g;let m=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(m){const H={value:[m.key,m.value],done:!1};return m=m.next,H}else return{value:void 0,done:!0}}};return S}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let f=this.d,m=this.size;for(;f&&m>d;)this.c.delete(f.key),f=f.next,m--;this.d=f,this.f=m,f&&(f.previous=void 0),this.g++}i(d){if(d>=this.size)return;if(d===0){this.clear();return}let f=this.e,m=this.size;for(;f&&m>d;)this.c.delete(f.key),f=f.previous,m--;this.e=f,this.f=m,f&&(f.next=void 0),this.g++}j(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}k(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}l(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const f=d.next,m=d.previous;if(!f||!m)throw new Error("Invalid list");f.previous=m,m.next=f}d.next=void 0,d.previous=void 0,this.g++}m(d,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==$.AsOld&&f!==$.AsNew)){if(f===$.AsOld){if(d===this.d)return;const m=d.next,S=d.previous;d===this.e?(S.next=void 0,this.e=S):(m.previous=S,S.next=m),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(f===$.AsNew){if(d===this.e)return;const m=d.next,S=d.previous;d===this.d?(m.previous=void 0,this.d=m):(m.previous=S,S.next=m),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((f,m)=>{d.push([m,f])}),d}fromJSON(d){this.clear();for(const[f,m]of d)this.set(f,m)}}t.$Bc=g;class e extends g{constructor(d,f=1){super(),this.n=d,this.o=Math.min(Math.max(0,f),1)}get limit(){return this.n}set limit(d){this.n=d,this.p()}get ratio(){return this.o}set ratio(d){this.o=Math.min(Math.max(0,d),1),this.p()}get(d,f=$.AsNew){return super.get(d,f)}peek(d){return super.get(d,$.None)}set(d,f){return super.set(d,f,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(d,f=1){super(d,f)}q(d){this.h(d)}set(d,f){return super.set(d,f),this.p(),this}}t.$Cc=s;class r extends e{constructor(d,f=1){super(d,f)}q(d){this.i(d)}set(d,f){return this.n<=this.size&&!this.has(d)&&this.q(Math.round(this.n*this.o)-1),super.set(d,f),this}}t.$Dc=r;class h{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let f=this.c.get(d)||0;return f===0?!1:(f--,f===0?this.c.delete(d):this.c.set(d,f),!0)}has(d){return this.c.has(d)}}t.$Ec=h;class l{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[f,m]of d)this.set(f,m)}clear(){this.c.clear(),this.d.clear()}set(d,f){this.c.set(d,f),this.d.set(f,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const f=this.c.get(d);return f===void 0?!1:(this.c.delete(d),this.d.delete(f),!0)}forEach(d,f){this.c.forEach((m,S)=>{d.call(f,m,S,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=l;class D{constructor(){this.c=new Map}add(d,f){let m=this.c.get(d);m||(m=new Set,this.c.set(d,m)),m.add(f)}delete(d,f){const m=this.c.get(d);m&&(m.delete(f),m.size===0&&this.c.delete(d))}forEach(d,f){const m=this.c.get(d);m&&m.forEach(f)}get(d){const f=this.c.get(d);return f||new Set}}t.$Gc=D;function T(A,d){if(A===d)return!0;if(A.size!==d.size)return!1;for(const[f,m]of A)if(!d.has(f)||d.get(f)!==m)return!1;for(const[f]of d)if(!A.has(f))return!1;return!0}}),define(we[2],De([1,0,9,57,43,58,36]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Ic=void 0,t.$Jc=p,t.$Kc=y,t.$Lc=$,t.$Mc=s,t.$Nc=r,t.$Oc=h,t.$Pc=l,t.$Qc=D,t.$Rc=T,t.$2c=R;const w=!1;let v=null;class c{constructor(){this.b=new Map}static{this.a=0}c(_){let V=this.b.get(_);return V||(V={parent:null,source:null,isSingleton:!1,value:_,idx:c.a++},this.b.set(_,V)),V}trackDisposable(_){const V=this.c(_);V.source||(V.source=new Error().stack)}setParent(_,V){const J=this.c(_);J.parent=V}markAsDisposed(_){this.b.delete(_)}markAsSingleton(_){this.c(_).isSingleton=!0}f(_,V){const J=V.get(_);if(J)return J;const q=_.parent?this.f(this.c(_.parent),V):_;return V.set(_,q),q}getTrackedDisposables(){const _=new Map;return[...this.b.entries()].filter(([,J])=>J.source!==null&&!this.f(J,_).isSingleton).flatMap(([J])=>J)}computeLeakingDisposables(_=10,V){let J;if(V)J=V;else{const be=new Map,Ae=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,be).isSingleton);if(Ae.length===0)return;const Fe=new Set(Ae.map(ne=>ne.value));if(J=Ae.filter(ne=>!(ne.parent&&Fe.has(ne.parent))),J.length===0)throw new Error("There are cyclic diposable chains!")}if(!J)return;function q(be){function Ae(ne,ee){for(;ne.length>0&&ee.some(fe=>typeof fe=="string"?fe===ne[0]:ne[0].match(fe));)ne.shift()}const Fe=be.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return Ae(Fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Fe.reverse()}const z=new B.$Gc;for(const be of J){const Ae=q(be);for(let Fe=0;Fe<=Ae.length;Fe++)z.add(Ae.slice(0,Fe).join(`
`),be)}J.sort((0,i.$5b)(be=>be.idx,i.$7b));let Q="",ue=0;for(const be of J.slice(0,_)){ue++;const Ae=q(be),Fe=[];for(let ne=0;ne<Ae.length;ne++){let ee=Ae[ne];ee=`(shared with ${z.get(Ae.slice(0,ne+1).join(`
`)).size}/${J.length} leaks) at ${ee}`;const ae=z.get(Ae.slice(0,ne).join(`
`)),Ne=(0,n.$c)([...ae].map(te=>q(te)[ne]),te=>te);delete Ne[Ae[ne]];for(const[te,$e]of Object.entries(Ne))Fe.unshift(`    - stacktraces of ${$e.length} other leaks continue with ${te}`);Fe.unshift(ee)}Q+=`


==================== Leaking disposable ${ue}/${J.length}: ${be.value.constructor.name} ====================
${Fe.join(`
`)}
============================================================

`}return J.length>_&&(Q+=`


... and ${J.length-_} more leaking disposables

`),{leaks:J,details:Q}}}t.$Ic=c;function p(I){v=I}if(w){const I="__is_disposable_tracked__";p(new class{trackDisposable(_){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[I]||console.log(V)},3e3)}setParent(_,V){if(_&&_!==d.None)try{_[I]=!0}catch{}}markAsDisposed(_){if(_&&_!==d.None)try{_[I]=!0}catch{}}markAsSingleton(_){}})}function y(I){return v?.trackDisposable(I),I}function $(I){v?.markAsDisposed(I)}function g(I,_){v?.setParent(I,_)}function e(I,_){if(v)for(const V of I)v.setParent(V,_)}function s(I){return v?.markAsSingleton(I),I}function r(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function h(I){if(k.Iterable.is(I)){const _=[];for(const V of I)if(V)try{V.dispose()}catch(J){_.push(J)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function l(I){for(const _ of I)r(_)&&_.dispose();return[]}function D(...I){const _=T(()=>h(I));return e(I,_),_}function T(I){const _=y({dispose:(0,N.$cb)(()=>{$(_),I()})});return _}class A{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return g(_,this),this.g?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(_),_.dispose()}}deleteAndLeak(_){_&&this.f.has(_)&&(this.f.delete(_),g(_,null))}}t.$Sc=A;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new A,y(this),g(this.q,this)}dispose(){$(this),this.q.dispose()}B(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(_)}}t.$Tc=d;class f{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(_){this.b||_===this.a||(this.a?.dispose(),_&&g(_,this),this.a=_)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const _=this.a;return this.a=void 0,_&&g(_,null),_}}t.$Uc=f;class m{constructor(_){this.a=new f,this.b=!1,this.a.value=_}get value(){return this.a.value}set value(_){this.b||_===this.a.value||(this.a.value=_)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=m;class S{constructor(_){this.b=_,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=S;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(_){let V=_;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,$(this))},this}}t.$Xc=H;class U{constructor(){this.a=new Map}acquire(_,...V){let J=this.a.get(_);J||(J={counter:0,object:this.b(_,...V)},this.a.set(_,J));const{object:q}=J,z=(0,N.$cb)(()=>{--J.counter===0&&(this.c(_,J.object),this.a.delete(_))});return J.counter++,{object:q,dispose:z}}}t.$Yc=U;class C{constructor(_){this.a=_}async acquire(_,...V){const J=this.a.acquire(_,...V);try{return{object:await J.object,dispose:()=>J.dispose()}}catch(q){throw J.dispose(),q}}}t.$Zc=C;class E{constructor(_){this.object=_}dispose(){}}t.$1c=E;function R(I){const _=new A;try{I(_)}finally{_.dispose()}}class x{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(_){return this.a.has(_)}get size(){return this.a.size}get(_){return this.a.get(_)}set(_,V,J=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),J||this.a.get(_)?.dispose(),this.a.set(_,V)}deleteAndDispose(_){this.a.get(_)?.dispose(),this.a.delete(_)}deleteAndLeak(_){const V=this.a.get(_);return this.a.delete(_),V}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=x}),function(le,t){typeof define=="function"&&define.amd?define(we[92],De([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t(K,j){for(var a=0;a<j.length;a++){var o=j[a];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(K,o.key,o)}}function i(K,j,a){return j&&t(K.prototype,j),a&&t(K,a),Object.defineProperty(K,"prototype",{writable:!1}),K}function n(K,j){if(K){if(typeof K=="string")return B(K,j);var a=Object.prototype.toString.call(K).slice(8,-1);if(a==="Object"&&K.constructor&&(a=K.constructor.name),a==="Map"||a==="Set")return Array.from(K);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return B(K,j)}}function B(K,j){(j==null||j>K.length)&&(j=K.length);for(var a=0,o=new Array(j);a<j;a++)o[a]=K[a];return o}function N(K,j){var a=typeof Symbol<"u"&&K[Symbol.iterator]||K["@@iterator"];if(a)return(a=a.call(K)).next.bind(a);if(Array.isArray(K)||(a=n(K))||j&&K&&typeof K.length=="number"){a&&(K=a);var o=0;return function(){return o>=K.length?{done:!0}:{done:!1,value:K[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=k();function w(K){le.defaults=K}var v=/[&<>"']/,c=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(j){return $[j]};function e(K,j){if(j){if(v.test(K))return K.replace(c,g)}else if(p.test(K))return K.replace(y,g);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(K){return K.replace(s,function(j,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var h=/(^|[^\[])\^/g;function l(K,j){K=typeof K=="string"?K:K.source,j=j||"";var a={replace:function(b,M){return M=M.source||M,M=M.replace(h,"$1"),K=K.replace(b,M),a},getRegex:function(){return new RegExp(K,j)}};return a}var D=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(K,j,a){if(K){var o;try{o=decodeURIComponent(r(a)).replace(D,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}j&&!T.test(a)&&(a=H(j,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var d={},f=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,S=/^([^:]+:\/*[^/]*)[\s\S]*$/;function H(K,j){d[" "+K]||(f.test(K)?d[" "+K]=K+"/":d[" "+K]=R(K,"/",!0)),K=d[" "+K];var a=K.indexOf(":")===-1;return j.substring(0,2)==="//"?a?j:K.replace(m,"$1")+j:j.charAt(0)==="/"?a?j:K.replace(S,"$1")+j:K+j}var U={exec:function(){}};function C(K){for(var j=1,a,o;j<arguments.length;j++){a=arguments[j];for(o in a)Object.prototype.hasOwnProperty.call(a,o)&&(K[o]=a[o])}return K}function E(K,j){var a=K.replace(/\|/g,function(M,F,u){for(var L=!1,O=F;--O>=0&&u[O]==="\\";)L=!L;return L?"|":" |"}),o=a.split(/ \|/),b=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>j)o.splice(j);else for(;o.length<j;)o.push("");for(;b<o.length;b++)o[b]=o[b].trim().replace(/\\\|/g,"|");return o}function R(K,j,a){var o=K.length;if(o===0)return"";for(var b=0;b<o;){var M=K.charAt(o-b-1);if(M===j&&!a)b++;else if(M!==j&&a)b++;else break}return K.slice(0,o-b)}function x(K,j){if(K.indexOf(j[1])===-1)return-1;for(var a=K.length,o=0,b=0;b<a;b++)if(K[b]==="\\")b++;else if(K[b]===j[0])o++;else if(K[b]===j[1]&&(o--,o<0))return b;return-1}function I(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function _(K,j){if(j<1)return"";for(var a="";j>1;)j&1&&(a+=K),j>>=1,K+=K;return a+K}function V(K,j,a,o){var b=j.href,M=j.title?e(j.title):null,F=K[1].replace(/\\([\[\]])/g,"$1");if(K[0].charAt(0)!=="!"){o.state.inLink=!0;var u={type:"link",raw:a,href:b,title:M,text:F,tokens:o.inlineTokens(F)};return o.state.inLink=!1,u}return{type:"image",raw:a,href:b,title:M,text:e(F)}}function J(K,j){var a=K.match(/^(\s+)(?:```)/);if(a===null)return j;var o=a[1];return j.split(`
`).map(function(b){var M=b.match(/^\s+/);if(M===null)return b;var F=M[0];return F.length>=o.length?b.slice(o.length):b}).join(`
`)}var q=function(){function K(a){this.options=a||le.defaults}var j=K.prototype;return j.space=function(o){var b=this.rules.block.newline.exec(o);if(b&&b[0].length>0)return{type:"space",raw:b[0]}},j.code=function(o){var b=this.rules.block.code.exec(o);if(b){var M=b[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:b[0],codeBlockStyle:"indented",text:this.options.pedantic?M:R(M,`
`)}}},j.fences=function(o){var b=this.rules.block.fences.exec(o);if(b){var M=b[0],F=J(M,b[3]||"");return{type:"code",raw:M,lang:b[2]?b[2].trim():b[2],text:F}}},j.heading=function(o){var b=this.rules.block.heading.exec(o);if(b){var M=b[2].trim();if(/#$/.test(M)){var F=R(M,"#");(this.options.pedantic||!F||/ $/.test(F))&&(M=F.trim())}return{type:"heading",raw:b[0],depth:b[1].length,text:M,tokens:this.lexer.inline(M)}}},j.hr=function(o){var b=this.rules.block.hr.exec(o);if(b)return{type:"hr",raw:b[0]}},j.blockquote=function(o){var b=this.rules.block.blockquote.exec(o);if(b){var M=b[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:b[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},j.list=function(o){var b=this.rules.block.list.exec(o);if(b){var M,F,u,L,O,P,X,Y,ie,re,ce,Ee,ve=b[1].trim(),ye=ve.length>1,Le={type:"list",raw:"",ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]};ve=ye?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=ye?ve:"[*+-]");for(var de=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(Ee=!1,!(!(b=de.exec(o))||this.rules.block.hr.test(o)));){if(M=b[0],o=o.substring(M.length),Y=b[2].split(`
`,1)[0],ie=o.split(`
`,1)[0],this.options.pedantic?(L=2,ce=Y.trimLeft()):(L=b[2].search(/[^ ]/),L=L>4?1:L,ce=Y.slice(L),L+=b[1].length),P=!1,!Y&&/^ *$/.test(ie)&&(M+=ie+`
`,o=o.substring(ie.length+1),Ee=!0),!Ee)for(var Ie=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ve=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");o&&(re=o.split(`
`,1)[0],Y=re,this.options.pedantic&&(Y=Y.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(Y)||tt.test(Y)||Ie.test(Y)||Ve.test(o)));){if(Y.search(/[^ ]/)>=L||!Y.trim())ce+=`
`+Y.slice(L);else if(!P)ce+=`
`+Y;else break;!P&&!Y.trim()&&(P=!0),M+=re+`
`,o=o.substring(re.length+1)}Le.loose||(X?Le.loose=!0:/\n *\n *$/.test(M)&&(X=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(ce),F&&(u=F[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Le.items.push({type:"list_item",raw:M,task:!!F,checked:u,loose:!1,text:ce}),Le.raw+=M}Le.items[Le.items.length-1].raw=M.trimRight(),Le.items[Le.items.length-1].text=ce.trimRight(),Le.raw=Le.raw.trimRight();var lt=Le.items.length;for(O=0;O<lt;O++){this.lexer.state.top=!1,Le.items[O].tokens=this.lexer.blockTokens(Le.items[O].text,[]);var st=Le.items[O].tokens.filter(function(Ze){return Ze.type==="space"}),qe=st.every(function(Ze){for(var Z=Ze.raw.split(""),he=0,pe=N(Z),ke;!(ke=pe()).done;){var Pe=ke.value;if(Pe===`
`&&(he+=1),he>1)return!0}return!1});!Le.loose&&st.length&&qe&&(Le.loose=!0,Le.items[O].loose=!0)}return Le}},j.html=function(o){var b=this.rules.block.html.exec(o);if(b){var M={type:"html",raw:b[0],pre:!this.options.sanitizer&&(b[1]==="pre"||b[1]==="script"||b[1]==="style"),text:b[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(b[0]):e(b[0]);M.type="paragraph",M.text=F,M.tokens=this.lexer.inline(F)}return M}},j.def=function(o){var b=this.rules.block.def.exec(o);if(b){b[3]&&(b[3]=b[3].substring(1,b[3].length-1));var M=b[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:b[0],href:b[2],title:b[3]}}},j.table=function(o){var b=this.rules.block.table.exec(o);if(b){var M={type:"table",header:E(b[1]).map(function(X){return{text:X}}),align:b[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:b[3]&&b[3].trim()?b[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=b[0];var F=M.align.length,u,L,O,P;for(u=0;u<F;u++)/^ *-+: *$/.test(M.align[u])?M.align[u]="right":/^ *:-+: *$/.test(M.align[u])?M.align[u]="center":/^ *:-+ *$/.test(M.align[u])?M.align[u]="left":M.align[u]=null;for(F=M.rows.length,u=0;u<F;u++)M.rows[u]=E(M.rows[u],M.header.length).map(function(X){return{text:X}});for(F=M.header.length,L=0;L<F;L++)M.header[L].tokens=this.lexer.inline(M.header[L].text);for(F=M.rows.length,L=0;L<F;L++)for(P=M.rows[L],O=0;O<P.length;O++)P[O].tokens=this.lexer.inline(P[O].text);return M}}},j.lheading=function(o){var b=this.rules.block.lheading.exec(o);if(b)return{type:"heading",raw:b[0],depth:b[2].charAt(0)==="="?1:2,text:b[1],tokens:this.lexer.inline(b[1])}},j.paragraph=function(o){var b=this.rules.block.paragraph.exec(o);if(b){var M=b[1].charAt(b[1].length-1)===`
`?b[1].slice(0,-1):b[1];return{type:"paragraph",raw:b[0],text:M,tokens:this.lexer.inline(M)}}},j.text=function(o){var b=this.rules.block.text.exec(o);if(b)return{type:"text",raw:b[0],text:b[0],tokens:this.lexer.inline(b[0])}},j.escape=function(o){var b=this.rules.inline.escape.exec(o);if(b)return{type:"escape",raw:b[0],text:e(b[1])}},j.tag=function(o){var b=this.rules.inline.tag.exec(o);if(b)return!this.lexer.state.inLink&&/^<a /i.test(b[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(b[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(b[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(b[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:b[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(b[0]):e(b[0]):b[0]}},j.link=function(o){var b=this.rules.inline.link.exec(o);if(b){var M=b[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var F=R(M.slice(0,-1),"\\");if((M.length-F.length)%2===0)return}else{var u=x(b[2],"()");if(u>-1){var L=b[0].indexOf("!")===0?5:4,O=L+b[1].length+u;b[2]=b[2].substring(0,u),b[0]=b[0].substring(0,O).trim(),b[3]=""}}var P=b[2],X="";if(this.options.pedantic){var Y=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(P);Y&&(P=Y[1],X=Y[3])}else X=b[3]?b[3].slice(1,-1):"";return P=P.trim(),/^</.test(P)&&(this.options.pedantic&&!/>$/.test(M)?P=P.slice(1):P=P.slice(1,-1)),V(b,{href:P&&P.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},b[0],this.lexer)}},j.reflink=function(o,b){var M;if((M=this.rules.inline.reflink.exec(o))||(M=this.rules.inline.nolink.exec(o))){var F=(M[2]||M[1]).replace(/\s+/g," ");if(F=b[F.toLowerCase()],!F||!F.href){var u=M[0].charAt(0);return{type:"text",raw:u,text:u}}return V(M,F,M[0],this.lexer)}},j.emStrong=function(o,b,M){M===void 0&&(M="");var F=this.rules.inline.emStrong.lDelim.exec(o);if(F&&!(F[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=F[1]||F[2]||"";if(!u||u&&(M===""||this.rules.inline.punctuation.exec(M))){var L=F[0].length-1,O,P,X=L,Y=0,ie=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,b=b.slice(-1*o.length+L);(F=ie.exec(b))!=null;)if(O=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!O){if(P=O.length,F[3]||F[4]){X+=P;continue}else if((F[5]||F[6])&&L%3&&!((L+P)%3)){Y+=P;continue}if(X-=P,!(X>0)){if(P=Math.min(P,P+X+Y),Math.min(L,P)%2){var re=o.slice(1,L+F.index+P);return{type:"em",raw:o.slice(0,L+F.index+P+1),text:re,tokens:this.lexer.inlineTokens(re)}}var ce=o.slice(2,L+F.index+P-1);return{type:"strong",raw:o.slice(0,L+F.index+P+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},j.codespan=function(o){var b=this.rules.inline.code.exec(o);if(b){var M=b[2].replace(/\n/g," "),F=/[^ ]/.test(M),u=/^ /.test(M)&&/ $/.test(M);return F&&u&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:b[0],text:M}}},j.br=function(o){var b=this.rules.inline.br.exec(o);if(b)return{type:"br",raw:b[0]}},j.del=function(o){var b=this.rules.inline.del.exec(o);if(b)return{type:"del",raw:b[0],text:b[2],tokens:this.lexer.inlineTokens(b[2])}},j.autolink=function(o,b){var M=this.rules.inline.autolink.exec(o);if(M){var F,u;return M[2]==="@"?(F=e(this.options.mangle?b(M[1]):M[1]),u="mailto:"+F):(F=e(M[1]),u=F),{type:"link",raw:M[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},j.url=function(o,b){var M;if(M=this.rules.inline.url.exec(o)){var F,u;if(M[2]==="@")F=e(this.options.mangle?b(M[0]):M[0]),u="mailto:"+F;else{var L;do L=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(L!==M[0]);F=e(M[0]),M[1]==="www."?u="http://"+F:u=F}return{type:"link",raw:M[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},j.inlineText=function(o,b){var M=this.rules.inline.text.exec(o);if(M){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:F=e(this.options.smartypants?b(M[0]):M[0]),{type:"text",raw:M[0],text:F}}},K}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=l(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=l(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=l(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=l(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=l(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=C({},z),z.gfm=C({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=l(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=C({},z.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:l(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=l(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=l(z._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=l(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=l(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=l(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=l(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=l(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=l(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=l(Q.reflink).replace("label",Q._label).replace("ref",z._label).getRegex(),Q.nolink=l(Q.nolink).replace("ref",z._label).getRegex(),Q.reflinkSearch=l(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=C({},Q),Q.pedantic=C({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=C({},Q.normal,{escape:l(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=l(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=C({},Q.gfm,{br:l(Q.br).replace("{2,}","*").getRegex(),text:l(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ue(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function be(K){var j="",a,o,b=K.length;for(a=0;a<b;a++)o=K.charCodeAt(a),Math.random()>.5&&(o="x"+o.toString(16)),j+="&#"+o+";";return j}var Ae=function(){function K(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||le.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:z.normal,inline:Q.normal};this.options.pedantic?(o.block=z.pedantic,o.inline=Q.pedantic):this.options.gfm&&(o.block=z.gfm,this.options.breaks?o.inline=Q.breaks:o.inline=Q.gfm),this.tokenizer.rules=o}K.lex=function(o,b){var M=new K(b);return M.lex(o)},K.lexInline=function(o,b){var M=new K(b);return M.inlineTokens(o)};var j=K.prototype;return j.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var b;b=this.inlineQueue.shift();)this.inlineTokens(b.src,b.tokens);return this.tokens},j.blockTokens=function(o,b){var M=this;b===void 0&&(b=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(X,Y,ie){return Y+"    ".repeat(ie.length)});for(var F,u,L,O;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(F=X.call({lexer:M},o,b))?(o=o.substring(F.raw.length),b.push(F),!0):!1}))){if(F=this.tokenizer.space(o)){o=o.substring(F.raw.length),F.raw.length===1&&b.length>0?b[b.length-1].raw+=`
`:b.push(F);continue}if(F=this.tokenizer.code(o)){o=o.substring(F.raw.length),u=b[b.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):b.push(F);continue}if(F=this.tokenizer.fences(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.heading(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.hr(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.blockquote(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.list(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.html(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.def(o)){o=o.substring(F.raw.length),u=b[b.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.lheading(o)){o=o.substring(F.raw.length),b.push(F);continue}if(L=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,Y=o.slice(1),ie=void 0;M.options.extensions.startBlock.forEach(function(re){ie=re.call({lexer:this},Y),typeof ie=="number"&&ie>=0&&(X=Math.min(X,ie))}),X<1/0&&X>=0&&(L=o.substring(0,X+1))}(),this.state.top&&(F=this.tokenizer.paragraph(L))){u=b[b.length-1],O&&u.type==="paragraph"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):b.push(F),O=L.length!==o.length,o=o.substring(F.raw.length);continue}if(F=this.tokenizer.text(o)){o=o.substring(F.raw.length),u=b[b.length-1],u&&u.type==="text"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):b.push(F);continue}if(o){var P="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(P);break}else throw new Error(P)}}return this.state.top=!0,b},j.inline=function(o,b){return b===void 0&&(b=[]),this.inlineQueue.push({src:o,tokens:b}),b},j.inlineTokens=function(o,b){var M=this;b===void 0&&(b=[]);var F,u,L,O=o,P,X,Y;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(P=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)ie.includes(P[0].slice(P[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,P.index)+"["+_("a",P[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(P=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,P.index)+"["+_("a",P[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(P=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,P.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(X||(Y=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(F=ce.call({lexer:M},o,b))?(o=o.substring(F.raw.length),b.push(F),!0):!1}))){if(F=this.tokenizer.escape(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.tag(o)){o=o.substring(F.raw.length),u=b[b.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):b.push(F);continue}if(F=this.tokenizer.link(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(F.raw.length),u=b[b.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):b.push(F);continue}if(F=this.tokenizer.emStrong(o,O,Y)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.codespan(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.br(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.del(o)){o=o.substring(F.raw.length),b.push(F);continue}if(F=this.tokenizer.autolink(o,be)){o=o.substring(F.raw.length),b.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(o,be))){o=o.substring(F.raw.length),b.push(F);continue}if(L=o,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ee=o.slice(1),ve=void 0;M.options.extensions.startInline.forEach(function(ye){ve=ye.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(ce=Math.min(ce,ve))}),ce<1/0&&ce>=0&&(L=o.substring(0,ce+1))}(),F=this.tokenizer.inlineText(L,ue)){o=o.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Y=F.raw.slice(-1)),X=!0,u=b[b.length-1],u&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):b.push(F);continue}if(o){var re="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return b},i(K,null,[{key:"rules",get:function(){return{block:z,inline:Q}}}]),K}(),Fe=function(){function K(a){this.options=a||le.defaults}var j=K.prototype;return j.code=function(o,b,M){var F=(b||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(o,F);u!=null&&u!==o&&(M=!0,o=u)}return o=o.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(M?o:e(o,!0))+`</code></pre>
`:"<pre><code>"+(M?o:e(o,!0))+`</code></pre>
`},j.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},j.html=function(o){return o},j.heading=function(o,b,M,F){if(this.options.headerIds){var u=this.options.headerPrefix+F.slug(M);return"<h"+b+' id="'+u+'">'+o+"</h"+b+`>
`}return"<h"+b+">"+o+"</h"+b+`>
`},j.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},j.list=function(o,b,M){var F=b?"ol":"ul",u=b&&M!==1?' start="'+M+'"':"";return"<"+F+u+`>
`+o+"</"+F+`>
`},j.listitem=function(o){return"<li>"+o+`</li>
`},j.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},j.paragraph=function(o){return"<p>"+o+`</p>
`},j.table=function(o,b){return b&&(b="<tbody>"+b+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+b+`</table>
`},j.tablerow=function(o){return`<tr>
`+o+`</tr>
`},j.tablecell=function(o,b){var M=b.header?"th":"td",F=b.align?"<"+M+' align="'+b.align+'">':"<"+M+">";return F+o+("</"+M+`>
`)},j.strong=function(o){return"<strong>"+o+"</strong>"},j.em=function(o){return"<em>"+o+"</em>"},j.codespan=function(o){return"<code>"+o+"</code>"},j.br=function(){return this.options.xhtml?"<br/>":"<br>"},j.del=function(o){return"<del>"+o+"</del>"},j.link=function(o,b,M){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var F='<a href="'+e(o)+'"';return b&&(F+=' title="'+b+'"'),F+=">"+M+"</a>",F},j.image=function(o,b,M){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var F='<img src="'+o+'" alt="'+M+'"';return b&&(F+=' title="'+b+'"'),F+=this.options.xhtml?"/>":">",F},j.text=function(o){return o},K}(),ne=function(){function K(){}var j=K.prototype;return j.strong=function(o){return o},j.em=function(o){return o},j.codespan=function(o){return o},j.del=function(o){return o},j.html=function(o){return o},j.text=function(o){return o},j.link=function(o,b,M){return""+M},j.image=function(o,b,M){return""+M},j.br=function(){return""},K}(),ee=function(){function K(){this.seen={}}var j=K.prototype;return j.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},j.getNextSafeSlug=function(o,b){var M=o,F=0;if(this.seen.hasOwnProperty(M)){F=this.seen[o];do F++,M=o+"-"+F;while(this.seen.hasOwnProperty(M))}return b||(this.seen[o]=F,this.seen[M]=0),M},j.slug=function(o,b){b===void 0&&(b={});var M=this.serialize(o);return this.getNextSafeSlug(M,b.dryrun)},K}(),fe=function(){function K(a){this.options=a||le.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new ee}K.parse=function(o,b){var M=new K(b);return M.parse(o)},K.parseInline=function(o,b){var M=new K(b);return M.parseInline(o)};var j=K.prototype;return j.parse=function(o,b){b===void 0&&(b=!0);var M="",F,u,L,O,P,X,Y,ie,re,ce,Ee,ve,ye,Le,de,Ie,Ve,Ge,tt,lt=o.length;for(F=0;F<lt;F++){if(ce=o[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){M+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,r(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(ie="",Y="",O=ce.header.length,u=0;u<O;u++)Y+=this.renderer.tablecell(this.parseInline(ce.header[u].tokens),{header:!0,align:ce.align[u]});for(ie+=this.renderer.tablerow(Y),re="",O=ce.rows.length,u=0;u<O;u++){for(X=ce.rows[u],Y="",P=X.length,L=0;L<P;L++)Y+=this.renderer.tablecell(this.parseInline(X[L].tokens),{header:!1,align:ce.align[L]});re+=this.renderer.tablerow(Y)}M+=this.renderer.table(ie,re);continue}case"blockquote":{re=this.parse(ce.tokens),M+=this.renderer.blockquote(re);continue}case"list":{for(Ee=ce.ordered,ve=ce.start,ye=ce.loose,O=ce.items.length,re="",u=0;u<O;u++)de=ce.items[u],Ie=de.checked,Ve=de.task,Le="",de.task&&(Ge=this.renderer.checkbox(Ie),ye?de.tokens.length>0&&de.tokens[0].type==="paragraph"?(de.tokens[0].text=Ge+" "+de.tokens[0].text,de.tokens[0].tokens&&de.tokens[0].tokens.length>0&&de.tokens[0].tokens[0].type==="text"&&(de.tokens[0].tokens[0].text=Ge+" "+de.tokens[0].tokens[0].text)):de.tokens.unshift({type:"text",text:Ge}):Le+=Ge),Le+=this.parse(de.tokens,ye),re+=this.renderer.listitem(Le,Ve,Ie);M+=this.renderer.list(re,Ee,ve);continue}case"html":{M+=this.renderer.html(ce.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(re=ce.tokens?this.parseInline(ce.tokens):ce.text;F+1<lt&&o[F+1].type==="text";)ce=o[++F],re+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);M+=b?this.renderer.paragraph(re):re;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return M},j.parseInline=function(o,b){b=b||this.renderer;var M="",F,u,L,O=o.length;for(F=0;F<O;F++){if(u=o[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(L=this.options.extensions.renderers[u.type].call({parser:this},u),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){M+=L||"";continue}switch(u.type){case"escape":{M+=b.text(u.text);break}case"html":{M+=b.html(u.text);break}case"link":{M+=b.link(u.href,u.title,this.parseInline(u.tokens,b));break}case"image":{M+=b.image(u.href,u.title,u.text);break}case"strong":{M+=b.strong(this.parseInline(u.tokens,b));break}case"em":{M+=b.em(this.parseInline(u.tokens,b));break}case"codespan":{M+=b.codespan(u.text);break}case"br":{M+=b.br();break}case"del":{M+=b.del(this.parseInline(u.tokens,b));break}case"text":{M+=b.text(u.text);break}default:{var P='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(P);return}else throw new Error(P)}}}return M},K}();function ae(K,j,a){if(typeof K>"u"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof j=="function"&&(a=j,j=null),j=C({},ae.defaults,j||{}),I(j),a){var o=j.highlight,b;try{b=Ae.lex(K,j)}catch(O){return a(O)}var M=function(P){var X;if(!P)try{j.walkTokens&&ae.walkTokens(b,j.walkTokens),X=fe.parse(b,j)}catch(Y){P=Y}return j.highlight=o,P?a(P):a(null,X)};if(!o||o.length<3||(delete j.highlight,!b.length))return M();var F=0;ae.walkTokens(b,function(O){O.type==="code"&&(F++,setTimeout(function(){o(O.text,O.lang,function(P,X){if(P)return M(P);X!=null&&X!==O.text&&(O.text=X,O.escaped=!0),F--,F===0&&M()})},0))}),F===0&&M();return}function u(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(O.message+"",!0)+"</pre>";throw O}try{var L=Ae.lex(K,j);if(j.walkTokens){if(j.async)return Promise.all(ae.walkTokens(L,j.walkTokens)).then(function(){return fe.parse(L,j)}).catch(u);ae.walkTokens(L,j.walkTokens)}return fe.parse(L,j)}catch(O){u(O)}}ae.options=ae.setOptions=function(K){return C(ae.defaults,K),w(ae.defaults),ae},ae.getDefaults=k,ae.defaults=le.defaults,ae.use=function(){for(var K=arguments.length,j=new Array(K),a=0;a<K;a++)j[a]=arguments[a];var o=C.apply(void 0,[{}].concat(j)),b=ae.defaults.extensions||{renderers:{},childTokens:{}},M;j.forEach(function(F){if(F.extensions&&(M=!0,F.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var O=b.renderers?b.renderers[L.name]:null;O?b.renderers[L.name]=function(){for(var P=arguments.length,X=new Array(P),Y=0;Y<P;Y++)X[Y]=arguments[Y];var ie=L.renderer.apply(this,X);return ie===!1&&(ie=O.apply(this,X)),ie}:b.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");b[L.level]?b[L.level].unshift(L.tokenizer):b[L.level]=[L.tokenizer],L.start&&(L.level==="block"?b.startBlock?b.startBlock.push(L.start):b.startBlock=[L.start]:L.level==="inline"&&(b.startInline?b.startInline.push(L.start):b.startInline=[L.start]))}L.childTokens&&(b.childTokens[L.name]=L.childTokens)})),F.renderer&&function(){var L=ae.defaults.renderer||new Fe,O=function(Y){var ie=L[Y];L[Y]=function(){for(var re=arguments.length,ce=new Array(re),Ee=0;Ee<re;Ee++)ce[Ee]=arguments[Ee];var ve=F.renderer[Y].apply(L,ce);return ve===!1&&(ve=ie.apply(L,ce)),ve}};for(var P in F.renderer)O(P);o.renderer=L}(),F.tokenizer&&function(){var L=ae.defaults.tokenizer||new q,O=function(Y){var ie=L[Y];L[Y]=function(){for(var re=arguments.length,ce=new Array(re),Ee=0;Ee<re;Ee++)ce[Ee]=arguments[Ee];var ve=F.tokenizer[Y].apply(L,ce);return ve===!1&&(ve=ie.apply(L,ce)),ve}};for(var P in F.tokenizer)O(P);o.tokenizer=L}(),F.walkTokens){var u=ae.defaults.walkTokens;o.walkTokens=function(L){var O=[];return O.push(F.walkTokens.call(this,L)),u&&(O=O.concat(u.call(this,L))),O}}M&&(o.extensions=b),ae.setOptions(o)})},ae.walkTokens=function(K,j){for(var a=[],o=function(){var u=M.value;switch(a=a.concat(j.call(ae,u)),u.type){case"table":{for(var L=N(u.header),O;!(O=L()).done;){var P=O.value;a=a.concat(ae.walkTokens(P.tokens,j))}for(var X=N(u.rows),Y;!(Y=X()).done;)for(var ie=Y.value,re=N(ie),ce;!(ce=re()).done;){var Ee=ce.value;a=a.concat(ae.walkTokens(Ee.tokens,j))}break}case"list":{a=a.concat(ae.walkTokens(u.items,j));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[u.type]?ae.defaults.extensions.childTokens[u.type].forEach(function(ve){a=a.concat(ae.walkTokens(u[ve],j))}):u.tokens&&(a=a.concat(ae.walkTokens(u.tokens,j)))}},b=N(K),M;!(M=b()).done;)o();return a},ae.parseInline=function(K,j){if(typeof K>"u"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");j=C({},ae.defaults,j||{}),I(j);try{var a=Ae.lexInline(K,j);return j.walkTokens&&ae.walkTokens(a,j.walkTokens),fe.parseInline(a,j)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(o.message+"",!0)+"</pre>";throw o}},ae.Parser=fe,ae.parser=fe.parse,ae.Renderer=Fe,ae.TextRenderer=ne,ae.Lexer=Ae,ae.lexer=Ae.lex,ae.Tokenizer=q,ae.Slugger=ee,ae.parse=ae;var Ne=ae.options,te=ae.setOptions,$e=ae.use,Te=ae.walkTokens,Oe=ae.parseInline,Re=ae,_e=fe.parse,oe=Ae.lex;le.Lexer=Ae,le.Parser=fe,le.Renderer=Fe,le.Slugger=ee,le.TextRenderer=ne,le.Tokenizer=q,le.getDefaults=k,le.lexer=oe,le.marked=ae,le.options=Ne,le.parse=Re,le.parseInline=Oe,le.parser=_e,le.setOptions=te,le.use=$e,le.walkTokens=Te,Object.defineProperty(le,"__esModule",{value:!0})}),define(we[60],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(we[93],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dk=i;function i(s){const r=N(s);if(r&&r.length>0)return new Uint32Array(r)}let n=0;const B=new Uint32Array(10);function N(s){if(n=0,k(s,y,v.InitialConsonant),n>0||(k(s,$,v.Vowel),n>0)||(k(s,g,v.FinalConsonant),n>0)||(k(s,e,v.CompatibilityJamo),n))return B.subarray(0,n);if(s>=44032&&s<=55203){const r=s-44032,h=r%588,l=Math.floor(r/588),D=Math.floor(h/28),T=h%28-1;if(l<y.length?k(l,y,0):v.InitialConsonant+l-v.CompatibilityJamo<e.length&&k(v.InitialConsonant+l,e,v.CompatibilityJamo),D<$.length?k(D,$,0):v.Vowel+D-v.CompatibilityJamo<e.length&&k(v.Vowel+D-v.CompatibilityJamo,e,v.CompatibilityJamo),T>=0&&(T<g.length?k(T,g,0):v.FinalConsonant+T-v.CompatibilityJamo<e.length&&k(v.FinalConsonant+T-v.CompatibilityJamo,e,v.CompatibilityJamo)),n>0)return B.subarray(0,n)}}function k(s,r,h){s>=h&&s<h+r.length&&w(r[s-h])}function w(s){s!==c.NUL&&(B[n++]=s&255,s>>8&&(B[n++]=s>>8&255),s>>16&&(B[n++]=s>>16&255))}var v;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var c;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(c||(c={}));var p;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(p||(p={}));const y=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),$=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,p.hk,p.ho,p.hl,c.y,c.n,p.nj,p.np,p.nl,c.b,c.m,p.ml,c.l]),g=new Uint16Array([c.r,c.R,p.rt,c.s,p.sw,p.sg,c.e,c.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,c.a,c.q,p.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),e=new Uint16Array([c.r,c.R,p.rt,c.s,p.sw,p.sg,c.e,c.E,c.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,c.a,c.q,c.Q,p.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,p.hk,p.ho,p.hl,c.y,c.n,p.nj,p.np,p.nl,c.b,c.m,p.ml,c.l])}),define(we[94],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mW=void 0;class i{constructor(B,N=0,k=B.length,w=N-1){this.a=B,this.b=N,this.c=k,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$mW=i}),define(we[95],De([1,0,57,94]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oW=t.$nW=void 0;class B{constructor(w=[],v=10){this.h(w),this.b=v,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new n.$mW(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const v of w)this.a.add(v)}get j(){const w=[];return this.a.forEach(v=>w.push(v)),w}}t.$nW=B;class N{get size(){return this.f}constructor(w,v=10,c=p=>p){if(this.g=v,this.h=c,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new i.$g([w[0]],c);for(let p=1;p<w.length;p++)this.add(w[p])}add(w){const v={value:w,previous:this.c,next:void 0};for(this.c.next=v,this.c=v,this.d=this.c,this.f++,this.a.has(w)?this.j(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.h(this.c.value)===this.h(w))return w;const v=this.c.value;return this.a.delete(v),this.c.value=w,this.a.has(w)?this.j(w):this.a.add(w),v}prepend(w){if(this.f===this.g||this.a.has(w))return;const v={value:w,previous:void 0,next:this.b};this.b.previous=v,this.b=v,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}j(w){let v=this.b;const c=this.h(w);for(;v!==this.c;)this.h(v.value)===c&&(v===this.b?(this.b=this.b.next,this.b.previous=void 0):(v.previous.next=v.next,v.next.previous=v.previous),this.f--),v=v.next}}t.$oW=N}),define(we[37],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nm=t.$Mm=t.$Lm=void 0,t.$Jm=i,t.rot=n,t.$Om=w;function i(v,c,p){return Math.min(Math.max(v,c),p)}function n(v,c){return(c+v%c)%c}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Lm=B;class N{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Mm=N;class k{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const p=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Nm=k;function w(v,c,p,y,$,g,e,s){const r=e-p,h=s-y,l=$-p,D=g-y,T=v-p,A=c-y,d=r*r+h*h,f=r*l+h*D,m=r*T+h*A,S=l*l+D*D,H=l*T+D*A,U=1/(d*S-f*f),C=(S*m-f*H)*U,E=(d*H-f*m)*U;return C>=0&&E>=0&&C+E<1}}),define(we[26],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_c=void 0,t.$ad=N,t.$bd=$;class i{constructor(e,s,r){this.owner=e,this.debugNameSource=s,this.referenceFn=r}getDebugName(e){return N(e,this)}}t.$_c=i;const n=new Map,B=new WeakMap;function N(g,e){const s=B.get(g);if(s)return s;const r=k(g,e);if(r){let h=n.get(r)??0;h++,n.set(r,h);const l=h===1?r:`${r}#${h}`;return B.set(g,l),l}}function k(g,e){const s=B.get(g);if(s)return s;const r=e.owner?p(e.owner)+".":"";let h;const l=e.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(h=l(),h!==void 0)return r+h}else return r+l;const D=e.referenceFn;if(D!==void 0&&(h=$(D),h!==void 0))return r+h;if(e.owner!==void 0){const T=w(e.owner,g);if(T!==void 0)return r+T}}function w(g,e){for(const s in g)if(g[s]===e)return s}const v=new Map,c=new WeakMap;function p(g){const e=c.get(g);if(e)return e;const s=y(g);let r=v.get(s)??0;r++,v.set(s,r);const h=r===1?s:`${s}#${r}`;return c.set(g,h),h}function y(g){const e=g.constructor;return e?e.name:"Object"}function $(g){const e=g.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(we[31],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ld=void 0,t.$Jd=n,t.$Kd=B;let i;function n(s){i=s}function B(){return i}class N{constructor(){this.a=0,this.d=new WeakMap}b(r){return k([w(g("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[w(" "),c(p(r.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),c(p(r.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),c(p(r.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([v("observable value changed"),c(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return c(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(l,D)=>(this.d.get(r).add(l),h.apply(r,[l,D]))}handleDerivedRecomputed(r,h){const l=this.d.get(r);console.log(...this.b([v("derived recomputed"),c(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(l),{data:[{fn:r._debugNameData.referenceFn??r._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([v("observable from event triggered"),c(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(l,D)=>(this.d.get(r).add(l),h.apply(r,[l,D]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([v("autorun"),c(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._debugNameData.referenceFn??r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([v("transaction"),c(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Ld=N;function k(s){const r=new Array,h=[];let l="";function D(A){if("length"in A)for(const d of A)d&&D(d);else"text"in A?(l+=`%c${A.text}`,r.push(A.style),A.data&&h.push(...A.data)):"data"in A&&h.push(...A.data)}D(s);const T=[l,...r];return T.push(...h),T}function w(s){return c(s,{color:"black"})}function v(s){return c(e(`${s}: `,10),{color:"black",bold:!0})}function c(s,r={color:"black"}){function h(D){return Object.entries(D).reduce((T,[A,d])=>`${T}${A}:${d};`,"")}const l={color:r.color};return r.strikeThrough&&(l["text-decoration"]="line-through"),r.bold&&(l["font-weight"]="bold"),{text:s,style:h(l)}}function p(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?y(s,r):$(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function y(s,r){let h="[ ",l=!0;for(const D of s){if(l||(h+=", "),h.length-5>r){h+="...";break}l=!1,h+=`${p(D,r-h.length)}`}return h+=" ]",h}function $(s,r){let h="{ ",l=!0;for(const[D,T]of Object.entries(s)){if(l||(h+=", "),h.length-5>r){h+="...";break}l=!1,h+=`${D}: ${p(T,r-h.length)}`}return h+=" }",h}function g(s,r){let h="";for(let l=1;l<=r;l++)h+=s;return h}function e(s,r){for(;s.length<r;)s+=" ";return s}}),define(we[44],De([1,0,42,2,26,31]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=void 0,t.$id=k,t.$jd=w,t.$kd=v,t.$ld=c,t.$md=p,t.$nd=y;function k(e){return new g(new B.$_c(void 0,void 0,e),e,void 0,void 0)}function w(e,s){return new g(new B.$_c(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function v(e,s){return new g(new B.$_c(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function c(e,s){const r=new n.$Sc,h=v({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(l,D)=>{r.clear(),s(l,D,r)});return(0,n.$Rc)(()=>{h.dispose(),r.dispose()})}function p(e){const s=new n.$Sc,r=w({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Rc)(()=>{r.dispose(),s.dispose()})}function y(e,s){let r;return w({debugReferenceFn:s},h=>{const l=e.read(h),D=r;r=l,s({lastValue:D,newValue:l})})}var $;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})($||($={}));class g{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,r,h,l){this._debugNameData=s,this._runFn=r,this.h=h,this.i=l,this.a=$.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.h?.(),(0,N.$Kd)()?.handleAutorunCreated(this),this.j(),(0,n.$Kc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Lc)(this)}j(){if(this.a===$.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=$.upToDate;const r=this.c;try{if(!r){(0,N.$Kd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.h?.(),this._runFn(this,h)}}finally{r||(0,N.$Kd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===$.upToDate&&(this.a=$.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===$.dependenciesMightHaveChanged){this.a=$.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===$.stale)break}this.j()}while(this.a!==$.upToDate);this.b--,(0,i.$gd)(()=>this.b>=0)}handlePossibleChange(s){this.a===$.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=$.dependenciesMightHaveChanged)}handleChange(s,r){this.e.has(s)&&!this.f.has(s)&&(!this.i||this.i({changedObservable:s,change:r,didChange:l=>l===s},this.g))&&(this.a=$.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const r=s.get();return this.e.add(s),this.f.delete(s),r}}t.$od=g,function(e){e.Observer=g}(k||(t.$id=k={}))}),define(we[27],De([1,0,30,26,31]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8d=t.$6d=t.$4d=t.$Yd=t.$Xd=void 0,t.$Ud=k,t.$Vd=v,t.$Wd=p,t.$Zd=g,t.$1d=s,t.$2d=r,t.$3d=h,t.$5d=D,t.$7d=A;let N;function k(f){N=f}let w;function v(f){w=f}let c;function p(f){c=f}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,S){const H=S===void 0?void 0:m,U=S===void 0?m:S;return c({owner:H,debugName:()=>{const C=(0,n.$bd)(U);if(C!==void 0)return C;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(U.toString());if(R)return`${this.debugName}.${R[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:U},C=>U(this.read(C),C))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,S){return m.add(N(this,S)),this}keepObserved(m){return m.add(w(this)),this}get a(){return this.get()}}t.$Xd=y;class $ extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const S=this.b.size;this.b.add(m),S===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Yd=$;function g(f,m){const S=new l(f,m);try{f(S)}finally{S.finish()}}let e;function s(f){if(e)f(e);else{const m=new l(f,void 0);e=m;try{f(m)}finally{m.finish(),e=void 0}}}async function r(f,m){const S=new l(f,m);try{await f(S)}finally{S.finish()}}function h(f,m,S){f?m(f):g(m,S)}class l{constructor(m,S){this._fn=m,this.b=S,this.a=[],(0,B.$Kd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$bd)(this._fn)}updateObserver(m,S){this.a.push({observer:m,observable:S}),m.beginUpdate(S)}finish(){const m=this.a;for(let S=0;S<m.length;S++){const{observer:H,observable:U}=m[S];H.endUpdate(U)}this.a=null,(0,B.$Kd)()?.handleEndTransaction()}}t.$4d=l;function D(f,m){let S;return typeof f=="string"?S=new n.$_c(void 0,f,void 0):S=new n.$_c(f,void 0,void 0),new T(S,m,i.$5c)}class T extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,S,H){super(),this.e=m,this.g=H,this.d=S}get(){return this.d}set(m,S,H){if(H===void 0&&this.g(this.d,m))return;let U;S||(S=U=new l(()=>{},()=>`Setting ${this.debugName}`));try{const C=this.d;this.h(m),(0,B.$Kd)()?.handleObservableChanged(this,{oldValue:C,newValue:m,change:H,didChange:!0,hadValue:!0});for(const E of this.b)S.updateObserver(E,this),E.handleChange(this,H)}finally{U&&U.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}t.$6d=T;function A(f,m){let S;return typeof f=="string"?S=new n.$_c(void 0,f,void 0):S=new n.$_c(f,void 0,void 0),new d(S,m,i.$5c)}class d extends T{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}t.$8d=d}),define(we[45],De([1,0,42,30,2,27,26,31]),function(le,t,i,n,B,N,k,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Td=t.$Sd=void 0,t.$Md=v,t.$Nd=c,t.$Od=p,t.$Pd=y,t.$Qd=$,t.$Rd=g;function v(h,l){return l!==void 0?new s(new k.$_c(h,void 0,l),l,void 0,void 0,void 0,n.$5c):new s(new k.$_c(void 0,void 0,h),h,void 0,void 0,void 0,n.$5c)}function c(h,l,D){return new r(new k.$_c(h,void 0,l),l,void 0,void 0,void 0,n.$5c,D)}function p(h,l){return new s(new k.$_c(h.owner,h.debugName,h.debugReferenceFn),l,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$5c)}(0,N.$Wd)(p);function y(h,l){return new s(new k.$_c(h.owner,h.debugName,void 0),l,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$5c)}function $(h,l){let D,T;l===void 0?(D=h,T=void 0):(T=h,D=l);const A=new B.$Sc;return new s(new k.$_c(T,void 0,D),d=>(A.clear(),D(d,A)),void 0,void 0,()=>A.dispose(),n.$5c)}function g(h,l){let D,T;l===void 0?(D=h,T=void 0):(T=h,D=l);let A;return new s(new k.$_c(T,void 0,D),d=>{A?A.clear():A=new B.$Sc;const f=D(d);return f&&A.add(f),f},void 0,void 0,()=>{A&&(A.dispose(),A=void 0)},n.$5c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends N.$Yd{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(l,D,T,A,d=void 0,f){super(),this._debugNameData=l,this._computeFn=D,this.m=T,this.n=A,this.p=d,this.q=f,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.m?.(),(0,w.$Kd)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const l of this.j)l.removeObserver(this);this.j.clear(),this.p?.()}get(){if(this.b.size===0){const l=this._computeFn(this,this.m?.());return this.f(),l}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const l of this.j)if(l.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.t()}while(this.e!==e.upToDate);return this.g}}t(){if(this.e===e.upToDate)return;const l=this.k;this.k=this.j,this.j=l;const D=this.e!==e.initial,T=this.g;this.e=e.upToDate;const A=this.l;this.l=this.m?.();try{this.g=this._computeFn(this,A)}finally{for(const f of this.k)f.removeObserver(this);this.k.clear()}const d=D&&!this.q(T,this.g);if((0,w.$Kd)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.g,change:void 0,didChange:d,hadValue:D}),d)for(const f of this.b)f.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(l){this.h++;const D=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!D))for(const T of this.b)T.handlePossibleChange(this);if(D)for(const T of this.b)T.beginUpdate(this)}endUpdate(l){if(this.h--,this.h===0){const D=[...this.b];for(const T of D)T.endUpdate(this)}(0,i.$gd)(()=>this.h>=0)}handlePossibleChange(l){if(this.e===e.upToDate&&this.j.has(l)&&!this.k.has(l)){this.e=e.dependenciesMightHaveChanged;for(const D of this.b)D.handlePossibleChange(this)}}handleChange(l,D){if(this.j.has(l)&&!this.k.has(l)){const T=this.n?this.n({changedObservable:l,change:D,didChange:d=>d===l},this.l):!0,A=this.e===e.upToDate;if(T&&(this.e===e.dependenciesMightHaveChanged||A)&&(this.e=e.stale,A))for(const d of this.b)d.handlePossibleChange(this)}}readObservable(l){l.addObserver(this);const D=l.get();return this.j.add(l),this.k.delete(l),D}addObserver(l){const D=!this.b.has(l)&&this.h>0;super.addObserver(l),D&&l.beginUpdate(this)}removeObserver(l){const D=this.b.has(l)&&this.h>0;super.removeObserver(l),D&&l.endUpdate(this)}}t.$Sd=s;class r extends s{constructor(l,D,T,A,d=void 0,f,m){super(l,D,T,A,d,f),this.set=m}}t.$Td=r}),define(we[96],De([1,0,27]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=void 0;class n extends i.$Yd{get debugName(){return this.h.getDebugName(this)??"LazyObservableValue"}constructor(N,k,w){super(),this.h=N,this.j=w,this.e=!0,this.g=[],this.l=0,this.d=k}get(){return this.k(),this.d}k(){if(!this.e)if(this.e=!0,this.g.length>0){for(const N of this.b)for(const k of this.g)N.handleChange(this,k);this.g.length=0}else for(const N of this.b)N.handleChange(this,void 0)}m(){if(this.l++,this.l===1)for(const N of this.b)N.beginUpdate(this)}n(){if(this.l--,this.l===0){this.k();const N=[...this.b];for(const k of N)k.endUpdate(this)}}addObserver(N){const k=!this.b.has(N)&&this.l>0;super.addObserver(N),k&&N.beginUpdate(this)}removeObserver(N){const k=this.b.has(N)&&this.l>0;super.removeObserver(N),k&&N.endUpdate(this)}set(N,k,w){if(w===void 0&&this.j(this.d,N))return;let v;k||(k=v=new i.$4d(()=>{},()=>`Setting ${this.debugName}`));try{if(this.e=!1,this.o(N),w!==void 0&&this.g.push(w),k.updateObserver({beginUpdate:()=>this.m(),endUpdate:()=>this.n(),handleChange:(c,p)=>{},handlePossibleChange:c=>{}},this),this.l>1)for(const c of this.b)c.handlePossibleChange(this)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}o(N){this.d=N}}t.$ce=n}),define(we[97],De([1,0,30,27,26,96]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=k;function k(w,v){return w.lazy?new N.$ce(new B.$_c(w.owner,w.debugName,void 0),v,w.equalsFn??i.$5c):new n.$6d(new B.$_c(w.owner,w.debugName,void 0),v,w.equalsFn??i.$5c)}}),define(we[5],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=d,t.$E=C,t.$K=E,t.$h="en";let i=!1,n=!1,B=!1,N=!1,k=!1,w=!1,v=!1,c=!1,p=!1,y=!1,$,g=t.$h,e=t.$h,s,r;const h=globalThis;let l;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?l=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const D=typeof l?.versions?.electron=="string",T=D&&l?.type==="renderer";if(typeof l=="object"){i=l.platform==="win32",n=l.platform==="darwin",B=l.platform==="linux",N=B&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,v=D,p=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=t.$h,g=t.$h;const R=l.env.VSCODE_NLS_CONFIG;if(R)try{const x=JSON.parse(R);$=x.userLocale,e=x.osLocale,g=x.resolvedLanguage||t.$h,s=x.languagePack?.translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!T?(r=navigator.userAgent,i=r.indexOf("Windows")>=0,n=r.indexOf("Macintosh")>=0,c=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,B=r.indexOf("Linux")>=0,y=r?.indexOf("Mobi")>=0,w=!0,g=globalThis._VSCODE_NLS_LANGUAGE||t.$h,$=navigator.language.toLowerCase(),e=$):console.error("Unable to resolve platform.");var A;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(A||(t.Platform=A={}));function d(R){switch(R){case A.Web:return"Web";case A.Mac:return"Mac";case A.Linux:return"Linux";case A.Windows:return"Windows"}}let f=A.Web;n?f=A.Mac:i?f=A.Windows:B&&(f=A.Linux),t.$j=i,t.$k=n,t.$l=B,t.$m=N,t.$n=k,t.$o=v,t.$p=w,t.$q=w&&typeof h.importScripts=="function",t.$r=t.$q?h.origin:void 0,t.$s=c,t.$t=y,t.$u=p,t.$v=f,t.$w=r,t.$x=g;var m;(function(R){function x(){return t.$x}R.value=x;function I(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}R.isDefaultVariant=I;function _(){return t.$x==="en"}R.isDefault=_})(m||(t.Language=m={})),t.$y=$,t.$z=e,t.$A=s,t.$B=typeof h.postMessage=="function"&&!h.importScripts,t.$C=(()=>{if(t.$B){const R=[];h.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let _=0,V=R.length;_<V;_++){const J=R[_];if(J.id===I.data.vscodeScheduleAsyncWork){R.splice(_,1),J.callback();return}}});let x=0;return I=>{const _=++x;R.push({id:_,callback:I}),h.postMessage({vscodeScheduleAsyncWork:_},"*")}}return R=>setTimeout(R)})();var S;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(S||(t.OperatingSystem=S={})),t.OS=n||c?S.Macintosh:i?S.Windows:S.Linux;let H=!0,U=!1;function C(){if(!U){U=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,H=new Uint16Array(R.buffer)[0]===513}return H}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function E(R){return parseFloat(R)>=20}}),define(we[98],De([1,0,6,8,5]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=t.$2r=t.$1r=t.$Zr=void 0,t.$Xr=k,t.$Yr=w;var N;(function(g){g[g.CtrlCmd=2048]="CtrlCmd",g[g.Shift=1024]="Shift",g[g.Alt=512]="Alt",g[g.WinCtrl=256]="WinCtrl",g[g.KeyCode=255]="KeyCode"})(N||(N={}));function k(g,e){if(typeof g=="number"){if(g===0)return null;const s=(g&65535)>>>0,r=(g&4294901760)>>>16;return r!==0?new p([w(s,e),w(r,e)]):new p([w(s,e)])}else{const s=[];for(let r=0;r<g.length;r++)s.push(w(g[r],e));return new p(s)}}function w(g,e){const s=!!(g&N.CtrlCmd),r=!!(g&N.WinCtrl),h=e===B.OperatingSystem.Macintosh?r:s,l=!!(g&N.Shift),D=!!(g&N.Alt),T=e===B.OperatingSystem.Macintosh?s:r,A=g&N.KeyCode;return new v(h,l,D,T,A)}class v{constructor(e,s,r,h,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyCode=l}equals(e){return e instanceof v&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${r}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new p([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$Zr=v;class c{constructor(e,s,r,h,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.scanCode=l}equals(e){return e instanceof c&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${r}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$1r=c;class p{constructor(e){if(e.length===0)throw(0,i.$6)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,r=this.chords.length;s<r;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$2r=p;class y{constructor(e,s,r,h,l,D){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=D}}t.$3r=y;class ${}t.$4r=$}),define(we[99],De([1,0,5]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let n;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const N=B.process;n={get platform(){return N.platform},get arch(){return N.arch},get env(){return N.env},cwd(){return N.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$j?"win32":i.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$cc=n.platform,t.$dc=n.arch}),define(we[28],De([1,0,99]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0,i=He(i);const n=65,B=97,N=90,k=122,w=46,v=47,c=92,p=58,y=63;class $ extends Error{constructor(m,S,H){let U;typeof S=="string"&&S.indexOf("not ")===0?(U="must not be",S=S.replace(/^not /,"")):U="must be";const C=m.indexOf(".")!==-1?"property":"argument";let E=`The "${m}" ${C} ${U} of type ${S}`;E+=`. Received type ${typeof H}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function g(f,m){if(f===null||typeof f!="object")throw new $(m,"Object",f)}function e(f,m){if(typeof f!="string")throw new $(m,"string",f)}const s=i.$cc==="win32";function r(f){return f===v||f===c}function h(f){return f===v}function l(f){return f>=n&&f<=N||f>=B&&f<=k}function D(f,m,S,H){let U="",C=0,E=-1,R=0,x=0;for(let I=0;I<=f.length;++I){if(I<f.length)x=f.charCodeAt(I);else{if(H(x))break;x=v}if(H(x)){if(!(E===I-1||R===1))if(R===2){if(U.length<2||C!==2||U.charCodeAt(U.length-1)!==w||U.charCodeAt(U.length-2)!==w){if(U.length>2){const _=U.lastIndexOf(S);_===-1?(U="",C=0):(U=U.slice(0,_),C=U.length-1-U.lastIndexOf(S)),E=I,R=0;continue}else if(U.length!==0){U="",C=0,E=I,R=0;continue}}m&&(U+=U.length>0?`${S}..`:"..",C=2)}else U.length>0?U+=`${S}${f.slice(E+1,I)}`:U=f.slice(E+1,I),C=I-E-1;E=I,R=0}else x===w&&R!==-1?++R:R=-1}return U}function T(f){return f?`${f[0]==="."?"":"."}${f}`:""}function A(f,m){g(m,"pathObject");const S=m.dir||m.root,H=m.base||`${m.name||""}${T(m.ext)}`;return S?S===m.root?`${S}${H}`:`${S}${f}${H}`:H}t.$ec={resolve(...f){let m="",S="",H=!1;for(let U=f.length-1;U>=-1;U--){let C;if(U>=0){if(C=f[U],e(C,`paths[${U}]`),C.length===0)continue}else m.length===0?C=i.cwd():(C=i.env[`=${m}`]||i.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==m.toLowerCase()&&C.charCodeAt(2)===c)&&(C=`${m}\\`));const E=C.length;let R=0,x="",I=!1;const _=C.charCodeAt(0);if(E===1)r(_)&&(R=1,I=!0);else if(r(_))if(I=!0,r(C.charCodeAt(1))){let V=2,J=V;for(;V<E&&!r(C.charCodeAt(V));)V++;if(V<E&&V!==J){const q=C.slice(J,V);for(J=V;V<E&&r(C.charCodeAt(V));)V++;if(V<E&&V!==J){for(J=V;V<E&&!r(C.charCodeAt(V));)V++;(V===E||V!==J)&&(x=`\\\\${q}\\${C.slice(J,V)}`,R=V)}}}else R=1;else l(_)&&C.charCodeAt(1)===p&&(x=C.slice(0,2),R=2,E>2&&r(C.charCodeAt(2))&&(I=!0,R=3));if(x.length>0)if(m.length>0){if(x.toLowerCase()!==m.toLowerCase())continue}else m=x;if(H){if(m.length>0)break}else if(S=`${C.slice(R)}\\${S}`,H=I,I&&m.length>0)break}return S=D(S,!H,"\\",r),H?`${m}\\${S}`:`${m}${S}`||"."},normalize(f){e(f,"path");const m=f.length;if(m===0)return".";let S=0,H,U=!1;const C=f.charCodeAt(0);if(m===1)return h(C)?"\\":f;if(r(C))if(U=!0,r(f.charCodeAt(1))){let R=2,x=R;for(;R<m&&!r(f.charCodeAt(R));)R++;if(R<m&&R!==x){const I=f.slice(x,R);for(x=R;R<m&&r(f.charCodeAt(R));)R++;if(R<m&&R!==x){for(x=R;R<m&&!r(f.charCodeAt(R));)R++;if(R===m)return`\\\\${I}\\${f.slice(x)}\\`;R!==x&&(H=`\\\\${I}\\${f.slice(x,R)}`,S=R)}}}else S=1;else l(C)&&f.charCodeAt(1)===p&&(H=f.slice(0,2),S=2,m>2&&r(f.charCodeAt(2))&&(U=!0,S=3));let E=S<m?D(f.slice(S),!U,"\\",r):"";return E.length===0&&!U&&(E="."),E.length>0&&r(f.charCodeAt(m-1))&&(E+="\\"),H===void 0?U?`\\${E}`:E:U?`${H}\\${E}`:`${H}${E}`},isAbsolute(f){e(f,"path");const m=f.length;if(m===0)return!1;const S=f.charCodeAt(0);return r(S)||m>2&&l(S)&&f.charCodeAt(1)===p&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let m,S;for(let C=0;C<f.length;++C){const E=f[C];e(E,"path"),E.length>0&&(m===void 0?m=S=E:m+=`\\${E}`)}if(m===void 0)return".";let H=!0,U=0;if(typeof S=="string"&&r(S.charCodeAt(0))){++U;const C=S.length;C>1&&r(S.charCodeAt(1))&&(++U,C>2&&(r(S.charCodeAt(2))?++U:H=!1))}if(H){for(;U<m.length&&r(m.charCodeAt(U));)U++;U>=2&&(m=`\\${m.slice(U)}`)}return t.$ec.normalize(m)},relative(f,m){if(e(f,"from"),e(m,"to"),f===m)return"";const S=t.$ec.resolve(f),H=t.$ec.resolve(m);if(S===H||(f=S.toLowerCase(),m=H.toLowerCase(),f===m))return"";let U=0;for(;U<f.length&&f.charCodeAt(U)===c;)U++;let C=f.length;for(;C-1>U&&f.charCodeAt(C-1)===c;)C--;const E=C-U;let R=0;for(;R<m.length&&m.charCodeAt(R)===c;)R++;let x=m.length;for(;x-1>R&&m.charCodeAt(x-1)===c;)x--;const I=x-R,_=E<I?E:I;let V=-1,J=0;for(;J<_;J++){const z=f.charCodeAt(U+J);if(z!==m.charCodeAt(R+J))break;z===c&&(V=J)}if(J!==_){if(V===-1)return H}else{if(I>_){if(m.charCodeAt(R+J)===c)return H.slice(R+J+1);if(J===2)return H.slice(R+J)}E>_&&(f.charCodeAt(U+J)===c?V=J:J===2&&(V=3)),V===-1&&(V=0)}let q="";for(J=U+V+1;J<=C;++J)(J===C||f.charCodeAt(J)===c)&&(q+=q.length===0?"..":"\\..");return R+=V,q.length>0?`${q}${H.slice(R,x)}`:(H.charCodeAt(R)===c&&++R,H.slice(R,x))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const m=t.$ec.resolve(f);if(m.length<=2)return f;if(m.charCodeAt(0)===c){if(m.charCodeAt(1)===c){const S=m.charCodeAt(2);if(S!==y&&S!==w)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(l(m.charCodeAt(0))&&m.charCodeAt(1)===p&&m.charCodeAt(2)===c)return`\\\\?\\${m}`;return f},dirname(f){e(f,"path");const m=f.length;if(m===0)return".";let S=-1,H=0;const U=f.charCodeAt(0);if(m===1)return r(U)?f:".";if(r(U)){if(S=H=1,r(f.charCodeAt(1))){let R=2,x=R;for(;R<m&&!r(f.charCodeAt(R));)R++;if(R<m&&R!==x){for(x=R;R<m&&r(f.charCodeAt(R));)R++;if(R<m&&R!==x){for(x=R;R<m&&!r(f.charCodeAt(R));)R++;if(R===m)return f;R!==x&&(S=H=R+1)}}}}else l(U)&&f.charCodeAt(1)===p&&(S=m>2&&r(f.charCodeAt(2))?3:2,H=S);let C=-1,E=!0;for(let R=m-1;R>=H;--R)if(r(f.charCodeAt(R))){if(!E){C=R;break}}else E=!1;if(C===-1){if(S===-1)return".";C=S}return f.slice(0,C)},basename(f,m){m!==void 0&&e(m,"suffix"),e(f,"path");let S=0,H=-1,U=!0,C;if(f.length>=2&&l(f.charCodeAt(0))&&f.charCodeAt(1)===p&&(S=2),m!==void 0&&m.length>0&&m.length<=f.length){if(m===f)return"";let E=m.length-1,R=-1;for(C=f.length-1;C>=S;--C){const x=f.charCodeAt(C);if(r(x)){if(!U){S=C+1;break}}else R===-1&&(U=!1,R=C+1),E>=0&&(x===m.charCodeAt(E)?--E===-1&&(H=C):(E=-1,H=R))}return S===H?H=R:H===-1&&(H=f.length),f.slice(S,H)}for(C=f.length-1;C>=S;--C)if(r(f.charCodeAt(C))){if(!U){S=C+1;break}}else H===-1&&(U=!1,H=C+1);return H===-1?"":f.slice(S,H)},extname(f){e(f,"path");let m=0,S=-1,H=0,U=-1,C=!0,E=0;f.length>=2&&f.charCodeAt(1)===p&&l(f.charCodeAt(0))&&(m=H=2);for(let R=f.length-1;R>=m;--R){const x=f.charCodeAt(R);if(r(x)){if(!C){H=R+1;break}continue}U===-1&&(C=!1,U=R+1),x===w?S===-1?S=R:E!==1&&(E=1):S!==-1&&(E=-1)}return S===-1||U===-1||E===0||E===1&&S===U-1&&S===H+1?"":f.slice(S,U)},format:A.bind(null,"\\"),parse(f){e(f,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return m;const S=f.length;let H=0,U=f.charCodeAt(0);if(S===1)return r(U)?(m.root=m.dir=f,m):(m.base=m.name=f,m);if(r(U)){if(H=1,r(f.charCodeAt(1))){let V=2,J=V;for(;V<S&&!r(f.charCodeAt(V));)V++;if(V<S&&V!==J){for(J=V;V<S&&r(f.charCodeAt(V));)V++;if(V<S&&V!==J){for(J=V;V<S&&!r(f.charCodeAt(V));)V++;V===S?H=V:V!==J&&(H=V+1)}}}}else if(l(U)&&f.charCodeAt(1)===p){if(S<=2)return m.root=m.dir=f,m;if(H=2,r(f.charCodeAt(2))){if(S===3)return m.root=m.dir=f,m;H=3}}H>0&&(m.root=f.slice(0,H));let C=-1,E=H,R=-1,x=!0,I=f.length-1,_=0;for(;I>=H;--I){if(U=f.charCodeAt(I),r(U)){if(!x){E=I+1;break}continue}R===-1&&(x=!1,R=I+1),U===w?C===-1?C=I:_!==1&&(_=1):C!==-1&&(_=-1)}return R!==-1&&(C===-1||_===0||_===1&&C===R-1&&C===E+1?m.base=m.name=f.slice(E,R):(m.name=f.slice(E,C),m.base=f.slice(E,R),m.ext=f.slice(C,R))),E>0&&E!==H?m.dir=f.slice(0,E-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(s){const f=/\\/g;return()=>{const m=i.cwd().replace(f,"/");return m.slice(m.indexOf("/"))}}return()=>i.cwd()})();t.$fc={resolve(...f){let m="",S=!1;for(let H=f.length-1;H>=-1&&!S;H--){const U=H>=0?f[H]:d();e(U,`paths[${H}]`),U.length!==0&&(m=`${U}/${m}`,S=U.charCodeAt(0)===v)}return m=D(m,!S,"/",h),S?`/${m}`:m.length>0?m:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const m=f.charCodeAt(0)===v,S=f.charCodeAt(f.length-1)===v;return f=D(f,!m,"/",h),f.length===0?m?"/":S?"./":".":(S&&(f+="/"),m?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===v},join(...f){if(f.length===0)return".";let m;for(let S=0;S<f.length;++S){const H=f[S];e(H,"path"),H.length>0&&(m===void 0?m=H:m+=`/${H}`)}return m===void 0?".":t.$fc.normalize(m)},relative(f,m){if(e(f,"from"),e(m,"to"),f===m||(f=t.$fc.resolve(f),m=t.$fc.resolve(m),f===m))return"";const S=1,H=f.length,U=H-S,C=1,E=m.length-C,R=U<E?U:E;let x=-1,I=0;for(;I<R;I++){const V=f.charCodeAt(S+I);if(V!==m.charCodeAt(C+I))break;V===v&&(x=I)}if(I===R)if(E>R){if(m.charCodeAt(C+I)===v)return m.slice(C+I+1);if(I===0)return m.slice(C+I)}else U>R&&(f.charCodeAt(S+I)===v?x=I:I===0&&(x=0));let _="";for(I=S+x+1;I<=H;++I)(I===H||f.charCodeAt(I)===v)&&(_+=_.length===0?"..":"/..");return`${_}${m.slice(C+x)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const m=f.charCodeAt(0)===v;let S=-1,H=!0;for(let U=f.length-1;U>=1;--U)if(f.charCodeAt(U)===v){if(!H){S=U;break}}else H=!1;return S===-1?m?"/":".":m&&S===1?"//":f.slice(0,S)},basename(f,m){m!==void 0&&e(m,"ext"),e(f,"path");let S=0,H=-1,U=!0,C;if(m!==void 0&&m.length>0&&m.length<=f.length){if(m===f)return"";let E=m.length-1,R=-1;for(C=f.length-1;C>=0;--C){const x=f.charCodeAt(C);if(x===v){if(!U){S=C+1;break}}else R===-1&&(U=!1,R=C+1),E>=0&&(x===m.charCodeAt(E)?--E===-1&&(H=C):(E=-1,H=R))}return S===H?H=R:H===-1&&(H=f.length),f.slice(S,H)}for(C=f.length-1;C>=0;--C)if(f.charCodeAt(C)===v){if(!U){S=C+1;break}}else H===-1&&(U=!1,H=C+1);return H===-1?"":f.slice(S,H)},extname(f){e(f,"path");let m=-1,S=0,H=-1,U=!0,C=0;for(let E=f.length-1;E>=0;--E){const R=f.charCodeAt(E);if(R===v){if(!U){S=E+1;break}continue}H===-1&&(U=!1,H=E+1),R===w?m===-1?m=E:C!==1&&(C=1):m!==-1&&(C=-1)}return m===-1||H===-1||C===0||C===1&&m===H-1&&m===S+1?"":f.slice(m,H)},format:A.bind(null,"/"),parse(f){e(f,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return m;const S=f.charCodeAt(0)===v;let H;S?(m.root="/",H=1):H=0;let U=-1,C=0,E=-1,R=!0,x=f.length-1,I=0;for(;x>=H;--x){const _=f.charCodeAt(x);if(_===v){if(!R){C=x+1;break}continue}E===-1&&(R=!1,E=x+1),_===w?U===-1?U=x:I!==1&&(I=1):U!==-1&&(I=-1)}if(E!==-1){const _=C===0&&S?1:C;U===-1||I===0||I===1&&U===E-1&&U===C+1?m.base=m.name=f.slice(_,E):(m.name=f.slice(_,U),m.base=f.slice(_,E),m.ext=f.slice(U,E))}return C>0?m.dir=f.slice(0,C-1):S&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=s?t.$ec.normalize:t.$fc.normalize,t.$hc=s?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=s?t.$ec.join:t.$fc.join,t.$jc=s?t.$ec.resolve:t.$fc.resolve,t.$kc=s?t.$ec.relative:t.$fc.relative,t.$lc=s?t.$ec.dirname:t.$fc.dirname,t.$mc=s?t.$ec.basename:t.$fc.basename,t.$nc=s?t.$ec.extname:t.$fc.extname,t.$oc=s?t.$ec.format:t.$fc.format,t.$pc=s?t.$ec.parse:t.$fc.parse,t.$qc=s?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=s?t.$ec.sep:t.$fc.sep,t.$sc=s?t.$ec.delimiter:t.$fc.delimiter}),define(we[100],De([1,0,28]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=void 0,t.$0s=N,t.$$s=k,t.$_s=w,t.$at=c,t.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(p){const y=(0,i.$nc)(p),$=n[y.toLowerCase()];return $!==void 0?$:k(p)}function k(p){const y=(0,i.$nc)(p);return B[y.toLowerCase()]}function w(p){for(const y in B)if(B[y]===p)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function c(p,y){const $=v.exec(p);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:p}}),define(we[46],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function B(v,c){if(v.start>=c.end||c.start>=v.end)return{start:0,end:0};const p=Math.max(v.start,c.start),y=Math.min(v.end,c.end);return y-p<=0?{start:0,end:0}:{start:p,end:y}}n.intersect=B;function N(v){return v.end-v.start<=0}n.isEmpty=N;function k(v,c){return!N(B(v,c))}n.intersects=k;function w(v,c){const p=[],y={start:v.start,end:Math.min(c.start,v.end)},$={start:Math.max(c.end,v.start),end:v.end};return N(y)||p.push(y),N($)||p.push($),p}n.relativeComplement=w})(i||(t.Range=i={}))}),define(we[101],De([1,0,46]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WU=void 0,t.$TU=n,t.$UU=B,t.$VU=N;function n(v,c){const p=[];for(const y of c){if(v.start>=y.range.end)continue;if(v.end<y.range.start)break;const $=i.Range.intersect(v,y.range);i.Range.isEmpty($)||p.push({range:$,size:y.size})}return p}function B({start:v,end:c},p){return{start:v+p,end:c+p}}function N(v){const c=[];let p=null;for(const y of v){const $=y.range.start,g=y.range.end,e=y.size;if(p&&e===p.size){p.range.end=g;continue}p={range:{start:$,end:g},size:e},c.push(p)}return c}function k(...v){return N(v.reduce((c,p)=>c.concat(p),[]))}class w{get paddingTop(){return this.c}set paddingTop(c){this.b=this.b+c-this.c,this.c=c}constructor(c){this.a=[],this.b=0,this.c=0,this.c=c??0,this.b=this.c}splice(c,p,y=[]){const $=y.length-p,g=n({start:0,end:c},this.a),e=n({start:c+p,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:B(r.range,$),size:r.size})),s=y.map((r,h)=>({range:{start:c+h,end:c+h+1},size:r.size}));this.a=k(g,s,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const c=this.a.length;return c?this.a[c-1].range.end:0}get size(){return this.b}indexAt(c){if(c<0)return-1;if(c<this.c)return 0;let p=0,y=this.c;for(const $ of this.a){const g=$.range.end-$.range.start,e=y+g*$.size;if(c<e)return p+Math.floor((c-y)/$.size);p+=g,y=e}return p}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let p=0,y=0;for(const $ of this.a){const g=$.range.end-$.range.start,e=y+g;if(c<e)return this.c+p+(c-y)*$.size;p+=g*$.size,y=e}return-1}}t.$WU=w}),define(we[102],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(N){return new n(N)}constructor(N){this.c=i&&N===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ee=n}),define(we[3],De([1,0,6,58,2,59,102]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$ge=t.Event=void 0,t.$he=g;const w=!1,v=!1,c=!1;var p;(function(q){q.None=()=>B.$Tc.None;function z(P){if(c){const{onDidAddListener:X}=P,Y=s.create();let ie=0;P.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),X?.()}}}function Q(P,X){return te(P,()=>{},0,void 0,!0,void 0,X)}q.defer=Q;function ue(P){return(X,Y=null,ie)=>{let re=!1,ce;return ce=P(Ee=>{if(!re)return ce?ce.dispose():re=!0,X.call(Y,Ee)},null,ie),re&&ce.dispose(),ce}}q.once=ue;function be(P,X,Y){return ae((ie,re=null,ce)=>P(Ee=>ie.call(re,X(Ee)),null,ce),Y)}q.map=be;function Ae(P,X,Y){return ae((ie,re=null,ce)=>P(Ee=>{X(Ee),ie.call(re,Ee)},null,ce),Y)}q.forEach=Ae;function Fe(P,X,Y){return ae((ie,re=null,ce)=>P(Ee=>X(Ee)&&ie.call(re,Ee),null,ce),Y)}q.filter=Fe;function ne(P){return P}q.signal=ne;function ee(...P){return(X,Y=null,ie)=>{const re=(0,B.$Qc)(...P.map(ce=>ce(Ee=>X.call(Y,Ee))));return Ne(re,ie)}}q.any=ee;function fe(P,X,Y,ie){let re=Y;return be(P,ce=>(re=X(re,ce),re),ie)}q.reduce=fe;function ae(P,X){let Y;const ie={onWillAddFirstListener(){Y=P(re.fire,re)},onDidRemoveLastListener(){Y?.dispose()}};X||z(ie);const re=new f(ie);return X?.add(re),re.event}function Ne(P,X){return X instanceof Array?X.push(P):X&&X.add(P),P}function te(P,X,Y=100,ie=!1,re=!1,ce,Ee){let ve,ye,Le,de=0,Ie;const Ve={leakWarningThreshold:ce,onWillAddFirstListener(){ve=P(tt=>{de++,ye=X(ye,tt),ie&&!Le&&(Ge.fire(ye),ye=void 0),Ie=()=>{const lt=ye;ye=void 0,Le=void 0,(!ie||de>1)&&Ge.fire(lt),de=0},typeof Y=="number"?(clearTimeout(Le),Le=setTimeout(Ie,Y)):Le===void 0&&(Le=0,queueMicrotask(Ie))})},onWillRemoveListener(){re&&de>0&&Ie?.()},onDidRemoveLastListener(){Ie=void 0,ve.dispose()}};Ee||z(Ve);const Ge=new f(Ve);return Ee?.add(Ge),Ge.event}q.debounce=te;function $e(P,X=0,Y){return q.debounce(P,(ie,re)=>ie?(ie.push(re),ie):[re],X,void 0,!0,void 0,Y)}q.accumulate=$e;function Te(P,X=(ie,re)=>ie===re,Y){let ie=!0,re;return Fe(P,ce=>{const Ee=ie||!X(ce,re);return ie=!1,re=ce,Ee},Y)}q.latch=Te;function Oe(P,X,Y){return[q.filter(P,X,Y),q.filter(P,ie=>!X(ie),Y)]}q.split=Oe;function Re(P,X=!1,Y=[],ie){let re=Y.slice(),ce=P(ye=>{re?re.push(ye):ve.fire(ye)});ie&&ie.add(ce);const Ee=()=>{re?.forEach(ye=>ve.fire(ye)),re=null},ve=new f({onWillAddFirstListener(){ce||(ce=P(ye=>ve.fire(ye)),ie&&ie.add(ce))},onDidAddFirstListener(){re&&(X?setTimeout(Ee):Ee())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ie&&ie.add(ve),ve.event}q.buffer=Re;function _e(P,X){return(ie,re,ce)=>{const Ee=X(new K);return P(function(ve){const ye=Ee.evaluate(ve);ye!==oe&&ie.call(re,ye)},void 0,ce)}}q.chain=_e;const oe=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(X){return this.f.push(X),this}forEach(X){return this.f.push(Y=>(X(Y),Y)),this}filter(X){return this.f.push(Y=>X(Y)?Y:oe),this}reduce(X,Y){let ie=Y;return this.f.push(re=>(ie=X(ie,re),ie)),this}latch(X=(Y,ie)=>Y===ie){let Y=!0,ie;return this.f.push(re=>{const ce=Y||!X(re,ie);return Y=!1,ie=re,ce?re:oe}),this}evaluate(X){for(const Y of this.f)if(X=Y(X),X===oe)break;return X}}function j(P,X,Y=ie=>ie){const ie=(...ve)=>Ee.fire(Y(...ve)),re=()=>P.on(X,ie),ce=()=>P.removeListener(X,ie),Ee=new f({onWillAddFirstListener:re,onDidRemoveLastListener:ce});return Ee.event}q.fromNodeEventEmitter=j;function a(P,X,Y=ie=>ie){const ie=(...ve)=>Ee.fire(Y(...ve)),re=()=>P.addEventListener(X,ie),ce=()=>P.removeEventListener(X,ie),Ee=new f({onWillAddFirstListener:re,onDidRemoveLastListener:ce});return Ee.event}q.fromDOMEventEmitter=a;function o(P){return new Promise(X=>ue(P)(X))}q.toPromise=o;function b(P){const X=new f;return P.then(Y=>{X.fire(Y)},()=>{X.fire(void 0)}).finally(()=>{X.dispose()}),X.event}q.fromPromise=b;function M(P,X){return P(Y=>X.fire(Y))}q.forward=M;function F(P,X,Y){return X(Y),P(ie=>X(ie))}q.runAndSubscribe=F;class u{constructor(X,Y){this._observable=X,this.f=0,this.g=!1;const ie={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};Y||z(ie),this.emitter=new f(ie),Y&&Y.add(this.emitter)}beginUpdate(X){this.f++}handlePossibleChange(X){}handleChange(X,Y){this.g=!0}endUpdate(X){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function L(P,X){return new u(P,X).emitter.event}q.fromObservable=L;function O(P){return(X,Y,ie)=>{let re=0,ce=!1;const Ee={beginUpdate(){re++},endUpdate(){re--,re===0&&(P.reportChanges(),ce&&(ce=!1,X.call(Y)))},handlePossibleChange(){},handleChange(){ce=!0}};P.addObserver(Ee),P.reportChanges();const ve={dispose(){P.removeObserver(Ee)}};return ie instanceof B.$Sc?ie.add(ve):Array.isArray(ie)&&ie.push(ve),ve}}q.fromObservableLight=O})(p||(t.Event=p={}));class y{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${y.f++}`,y.all.add(this)}start(z){this.g=new k.$ee,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}t.$ge=y;let $=-1;function g(q){const z=$;return $=q,{dispose(){$=z}}}class e{static{this.f=1}constructor(z,Q,ue=(e.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=Q,this.name=ue,this.h=0}dispose(){this.g?.clear()}check(z,Q){const ue=this.threshold;if(ue<=0||Q<ue)return;this.g||(this.g=new Map);const be=this.g.get(z.value)||0;if(this.g.set(z.value,be+1),this.h-=1,this.h<=0){this.h=ue*.5;const[Ae,Fe]=this.getMostFrequentStack(),ne=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${Fe}):`;console.warn(ne),console.warn(Ae);const ee=new r(ne,Ae);this.j(ee)}return()=>{const Ae=this.g.get(z.value)||0;this.g.set(z.value,Ae-1)}}getMostFrequentStack(){if(!this.g)return;let z,Q=0;for(const[ue,be]of this.g)(!z||Q<be)&&(z=[ue,be],Q=be);return z}}class s{static create(){const z=new Error;return new s(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r extends Error{constructor(z,Q){super(z),this.name="ListenerLeakError",this.stack=Q}}t.$ie=r;class h extends Error{constructor(z,Q){super(z),this.name="ListenerRefusalError",this.stack=Q}}t.$je=h;let l=0;class D{constructor(z){this.value=z,this.id=l++}}const T=2,A=(q,z)=>{if(q instanceof D)z(q);else for(let Q=0;Q<q.length;Q++){const ue=q[Q];ue&&z(ue)}};let d;if(w){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),d=new FinalizationRegistry(z=>{typeof z=="string"&&q.push(z)})}class f{constructor(z){this.z=0,this.f=z,this.g=$>0||this.f?.leakWarningThreshold?new e(z?.onListenerError??i.$Y,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(v){const z=this.u;queueMicrotask(()=>{A(z,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,Q,ue)=>{if(this.g&&this.z>this.g.threshold**2){const ee=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(ee);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new h(`${ee}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||i.$Y)(ae),B.$Tc.None}if(this.m)return B.$Tc.None;Q&&(z=z.bind(Q));const be=new D(z);let Ae,Fe;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(be.stack=s.create(),Ae=this.g.check(be.stack,this.z+1)),v&&(be.stack=Fe??s.create()),this.u?this.u instanceof D?(this.w??=new S,this.u=[this.u,be]):this.u.push(be):(this.f?.onWillAddFirstListener?.(this),this.u=be,this.f?.onDidAddFirstListener?.(this)),this.z++;const ne=(0,B.$Rc)(()=>{d?.unregister(ne),Ae?.(),this.A(be)});if(ue instanceof B.$Sc?ue.add(ne):Array.isArray(ue)&&ue.push(ne),d){const ee=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ee);d.register(ne,fe?.[2]??ee,ne)}return ne},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,ue=Q.indexOf(z);if(ue===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[ue]=void 0;const be=this.w.current===this;if(this.z*T<=Q.length){let Ae=0;for(let Fe=0;Fe<Q.length;Fe++)Q[Fe]?Q[Ae++]=Q[Fe]:be&&(this.w.end--,Ae<this.w.i&&this.w.i--);Q.length=Ae}}B(z,Q){if(!z)return;const ue=this.f?.onListenerError||i.$Y;if(!ue){z.value(Q);return}try{z.value(Q)}catch(be){ue(be)}}C(z){const Q=z.current.u;for(;z.i<z.end;)this.B(Q[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof D)this.B(this.u,z);else{const Q=this.w;Q.enqueue(this,z,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}t.$ke=f;const m=()=>new S;t.$le=m;class S{constructor(){this.i=-1,this.end=0}enqueue(z,Q,ue){this.i=0,this.end=ue,this.current=z,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class H extends f{async fireAsync(z,Q,ue){if(this.u)for(this.h||(this.h=new N.$4c),A(this.u,be=>this.h.push([be.value,z]));this.h.size>0&&!Q.isCancellationRequested;){const[be,Ae]=this.h.shift(),Fe=[],ne={...Ae,token:Q,waitUntil:ee=>{if(Object.isFrozen(Fe))throw new Error("waitUntil can NOT be called asynchronous");ue&&(ee=ue(ee,be)),Fe.push(ee)}};try{be(ne)}catch(ee){(0,i.$Y)(ee);continue}Object.freeze(Fe),await Promise.allSettled(Fe).then(ee=>{for(const fe of ee)fe.status==="rejected"&&(0,i.$Y)(fe.reason)})}}}t.$me=H;class U extends f{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new N.$4c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}t.$ne=U;class C extends U{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}t.$oe=C;class E extends f{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}t.$pe=E;class R{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const Q={event:z,listener:null};this.h.push(Q),this.g&&this.m(Q);const ue=()=>{this.g&&this.o(Q);const be=this.h.indexOf(Q);this.h.splice(be,1)};return(0,B.$Rc)((0,n.$cb)(ue))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(Q=>this.f.fire(Q))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}t.$qe=R;class x{constructor(z,Q,ue,be){this.f=new B.$Sc;const Ae=this.f.add(new R),Fe=this.f.add(new B.$3c);function ne(ee){Fe.set(ee,Ae.add(be(ee)))}for(const ee of z)ne(ee);this.f.add(Q(ee=>{ne(ee)})),this.f.add(ue(ee=>{Fe.deleteAndDispose(ee)})),this.event=Ae.event}dispose(){this.f.dispose()}}t.$re=x;class I{constructor(){this.f=[]}wrapEvent(z,Q,ue){return(be,Ae,Fe)=>z(ne=>{const ee=this.f[this.f.length-1];if(!Q){ee?ee.buffers.push(()=>be.call(Ae,ne)):be.call(Ae,ne);return}const fe=ee;if(!fe){be.call(Ae,Q(ue,ne));return}fe.items??=[],fe.items.push(ne),fe.buffers.length===0&&ee.buffers.push(()=>{fe.reducedResult??=ue?fe.items.reduce(Q,ue):fe.items.reduce(Q),be.call(Ae,fe.reducedResult)})},void 0,Fe)}bufferEvents(z){const Q={buffers:new Array};this.f.push(Q);const ue=z();return this.f.pop(),Q.buffers.forEach(be=>be()),ue}}t.$se=I;class _{constructor(){this.f=!1,this.g=p.None,this.h=B.$Tc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$te=_;class V{static const(z){return new J(z)}constructor(z){this.g=z,this.f=new f,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}t.$ue=V;class J{constructor(z){this.value=z,this.onDidChange=p.None}}}),define(we[18],De([1,0,24,3]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=t.$kS=t.$jS=t.$iS=t.$hS=t.$gS=t.$fS=t.$eS=t.$_R=void 0,t.$9R=N,t.$0R=k,t.$$R=w,t.$aS=v,t.$bS=c,t.$cS=p,t.$dS=y,t.$mS=e,t.$nS=s,t.$oS=r;class B{constructor(){this.a=new Map,this.b=new n.$ke,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$ke,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(l){return this.a.get(this.f(l))??0}setZoomLevel(l,D){if(this.getZoomLevel(D)===l)return;const T=this.f(D);this.a.set(T,l),this.b.fire(T)}getZoomFactor(l){return this.c.get(this.f(l))??1}setZoomFactor(l,D){this.c.set(this.f(D),l)}setFullscreen(l,D){if(this.isFullscreen(D)===l)return;const T=this.f(D);this.e.set(T,l),this.d.fire(T)}isFullscreen(l){return!!this.e.get(this.f(l))}f(l){return l.vscodeWindowId}}function N(h,l,D){typeof l=="string"&&(l=h.matchMedia(l)),l.addEventListener("change",D)}function k(h,l){B.INSTANCE.setZoomLevel(h,l)}function w(h){return B.INSTANCE.getZoomLevel(h)}t.$_R=B.INSTANCE.onDidChangeZoomLevel;function v(h){return B.INSTANCE.getZoomFactor(h)}function c(h,l){B.INSTANCE.setZoomFactor(h,l)}function p(h,l){B.INSTANCE.setFullscreen(h,l)}function y(h){return B.INSTANCE.isFullscreen(h)}t.$eS=B.INSTANCE.onDidChangeFullscreen;const $=navigator.userAgent;t.$fS=$.indexOf("Firefox")>=0,t.$gS=$.indexOf("AppleWebKit")>=0,t.$hS=$.indexOf("Chrome")>=0,t.$iS=!t.$hS&&$.indexOf("Safari")>=0,t.$jS=!t.$hS&&!t.$iS&&t.$gS,t.$kS=$.indexOf("Electron/")>=0,t.$lS=$.indexOf("Android")>=0;let g=!1;if(typeof i.$6R.matchMedia=="function"){const h=i.$6R.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.$6R.matchMedia("(display-mode: fullscreen)");g=h.matches,N(i.$6R,h,({matches:D})=>{g&&l.matches||(g=D)})}function e(){return g}function s(){return navigator?.windowControlsOverlay?.visible}function r(){return navigator?.windowControlsOverlay?.getTitlebarAreaRect()}}),define(we[61],De([1,0,18,24,5]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pS=t.KeyboardSupport=void 0,i=He(i),B=He(B);var N;(function(k){k[k.Always=0]="Always",k[k.FullScreen=1]="FullScreen",k[k.None=2]="None"})(N||(t.KeyboardSupport=N={})),t.$pS={clipboard:{writeText:B.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$n||i.$mS()?N.Always:navigator.keyboard||i.$iS?N.FullScreen:N.None,touch:"ontouchstart"in n.$6R||navigator.maxTouchPoints>0,pointerEvents:n.$6R.PointerEvent&&("ontouchstart"in n.$6R||navigator.maxTouchPoints>0)}}),define(we[29],De([1,0,3]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OU=void 0;class n{get event(){return this.a.event}constructor(N,k,w){const v=c=>this.a.fire(c);this.a=new i.$ke({onWillAddFirstListener:()=>N.addEventListener(k,v,w),onDidRemoveLastListener:()=>N.removeEventListener(k,v,w)})}dispose(){this.a.dispose()}}t.$OU=n}),define(we[15],De([1,0,18,8,98,5]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xS=void 0,t.$vS=y,t.$wS=$,i=He(i),N=He(N);function k(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$fS)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(N.$l)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(N.$k)return n.KeyCode.Meta;break}else if(i.$gS){if(N.$k&&s===93)return n.KeyCode.Meta;if(!N.$k&&s===92)return n.KeyCode.Meta}return n.$Rr[s]||n.KeyCode.Unknown}const w=N.$k?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,v=n.KeyMod.Alt,c=n.KeyMod.Shift,p=N.$k?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function y(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function $(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class g{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=k(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=w),this.altKey&&(r|=v),this.shiftKey&&(r|=c),this.metaKey&&(r|=p),r|=s,r}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new B.$Zr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$xS=g}),define(we[19],De([1,0,18,85,5]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uS=t.$tS=t.$sS=void 0,i=He(i),B=He(B);class N{constructor(c,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const y=n.$qS.getPositionOfChildWindowRelativeToAncestorWindow(c,p.view);this.posx-=y.left,this.posy-=y.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$sS=N;class k extends N{constructor(c,p){super(c,p),this.dataTransfer=p.dataTransfer}}t.$tS=k;class w{constructor(c,p=0,y=0){this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=y,this.deltaX=p;let $=!1;if(i.$hS){const g=navigator.userAgent.match(/Chrome\/(\d+)/);$=(g?parseInt(g[1]):123)<=122}if(c){const g=c,e=c,s=c.view?.devicePixelRatio||1;if(typeof g.wheelDeltaY<"u")$?this.deltaY=g.wheelDeltaY/(120*s):this.deltaY=g.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(c.type==="wheel"){const r=c;r.deltaMode===r.DOM_DELTA_LINE?i.$fS&&!B.$k?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof g.wheelDeltaX<"u")i.$iS&&B.$j?this.deltaX=-(g.wheelDeltaX/120):$?this.deltaX=g.wheelDeltaX/(120*s):this.deltaX=g.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const r=c;r.deltaMode===r.DOM_DELTA_LINE?i.$fS&&!B.$k?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&($?this.deltaY=c.wheelDelta/(120*s):this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$uS=w}),define(we[38],De([1,0,3]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.CancellationToken=void 0,t.$we=w;const n=Object.freeze(function(v,c){const p=setTimeout(v.bind(c),0);return{dispose(){clearTimeout(p)}}});var B;(function(v){function c(p){return p===v.None||p===v.Cancelled||p instanceof N?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}v.isCancellationToken=c,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(B||(t.CancellationToken=B={}));class N{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$ke),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new N),this.f}cancel(){this.f?this.f instanceof N&&this.f.cancel():this.f=B.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof N&&this.f.dispose():this.f=B.None}}t.$ve=k;function w(v){const c=new k;return v.add({dispose(){c.cancel()}}),c.token}}),define(we[103],De([1,0,38]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$e=t.$0e=t.$8e=void 0,t.$9e=B;class n{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new i.$ve,c=this.b(v.token);return this.a={promise:c,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}t.$8e=n;function B(w){return w}class N{constructor(v,c){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=B):(this.c=c,this.d=v.getCacheKey)}get(v){const c=this.d(v);return this.b!==c&&(this.b=c,this.a=this.c(v)),this.a}}t.$0e=N;class k{get cachedValues(){return this.a}constructor(v,c){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=B):(this.c=c,this.d=v.getCacheKey)}get(v){const c=this.d(v);if(this.b.has(c))return this.b.get(c);const p=this.c(v);return this.a.set(v,p),this.b.set(c,p),p}}t.$$e=k}),define(we[104],De([1,0,44,27,45,38,26,30,6]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_d=t.$$d=t.$0d=t.$9d=void 0,t.$ae=g,t.$be=e;class c{get cachedValue(){return this.a}constructor(r){this.b=r,this.a=(0,n.$5d)(this,void 0)}getValue(){let r=this.a.get();return r||(r=this.b(),this.a.set(r,void 0)),r}}t.$9d=c;class p{static fromFn(r){return new p(r())}constructor(r){this.a=(0,n.$5d)(this,void 0),this.promiseResult=this.a,this.promise=r.then(h=>((0,n.$Zd)(l=>{this.a.set(new y(h,void 0),l)}),h),h=>{throw(0,n.$Zd)(l=>{this.a.set(new y(void 0,h),l)}),h})}}t.$0d=p;class y{constructor(r,h){this.data=r,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$$d=y;class ${constructor(r){this.b=r,this.a=new c(()=>new p(this.b())),this.cachedPromiseResult=(0,B.$Md)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$_d=$;function g(s,r,h,l){return r||(r=D=>D!=null),new Promise((D,T)=>{let A=!0,d=!1;const f=s.map(S=>({isFinished:r(S),error:h?h(S):!1,state:S})),m=(0,i.$id)(S=>{const{isFinished:H,error:U,state:C}=f.read(S);(H||U)&&(A?d=!0:m.dispose(),U?T(U===!0?C:U):D(C))});if(l){const S=l.onCancellationRequested(()=>{m.dispose(),S.dispose(),T(new v.$4)});if(l.isCancellationRequested){m.dispose(),S.dispose(),T(new v.$4);return}}A=!1,d&&m.dispose()})}function e(s,r){let h,l;r===void 0?(h=s,l=void 0):(l=s,h=r);let D;return new B.$Sd(new k.$_c(l,void 0,h),T=>(D&&D.dispose(!0),D=new N.$ve,h(T,D.token)),void 0,void 0,()=>D?.dispose(),w.$5c)}}),define(we[105],De([1,0,3,2,44,27,26,45,31,6,30]),function(le,t,i,n,B,N,k,w,v,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fd=t.$Bd=t.$td=void 0,t.$pd=y,t.$qd=g,t.$rd=e,t.$sd=s,t.$ud=h,t.$vd=D,t.$wd=A,t.$xd=d,t.$yd=f,t.$zd=m,t.$Ad=S,t.$Cd=U,t.$Dd=C,t.$Ed=E,t.$Gd=I,t.$Hd=_,t.$Id=V;function y(J){return new $(J)}class $ extends N.$Xd{constructor(q){super(),this.b=q}get debugName(){return this.toString()}get(){return this.b}addObserver(q){}removeObserver(q){}toString(){return`Const: ${this.b}`}}function g(J){const q=(0,N.$5d)("promiseValue",{});return J.then(z=>{q.set({value:z},void 0)}),q}function e(...J){let q,z,Q;return J.length===3?[q,z,Q]=J:[z,Q]=J,new r(new k.$_c(q,void 0,Q),z,Q,()=>r.globalTransaction,p.$5c)}function s(J,q,z){return new r(new k.$_c(J.owner,J.debugName,J.debugReferenceFn??z),q,z,()=>r.globalTransaction,J.equalsFn??p.$5c)}class r extends N.$Yd{constructor(q,z,Q,ue,be){super(),this.j=q,this.k=z,this._getValue=Q,this.l=ue,this.n=be,this.g=!1,this.r=Ae=>{const Fe=this._getValue(Ae),ne=this.e,ee=!this.g||!this.n(ne,Fe);let fe=!1;ee&&(this.e=Fe,this.g&&(fe=!0,(0,N.$3d)(this.l(),ae=>{(0,v.$Kd)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Fe,change:void 0,didChange:ee,hadValue:this.g});for(const Ne of this.b)ae.updateObserver(Ne,this),Ne.handleChange(this,void 0)},()=>{const ae=this.p();return"Event fired"+(ae?`: ${ae}`:"")})),this.g=!0),fe||(0,v.$Kd)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Fe,change:void 0,didChange:ee,hadValue:this.g})}}p(){return this.j.getDebugName(this)}get debugName(){const q=this.p();return"From Event"+(q?`: ${q}`:"")}c(){this.h=this.k(this.r)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.r(void 0),this.e):this._getValue(void 0)}}t.$td=r,function(J){J.Observer=r;function q(z,Q){let ue=!1;r.globalTransaction===void 0&&(r.globalTransaction=z,ue=!0);try{Q()}finally{ue&&(r.globalTransaction=void 0)}}J.batchEventsGlobally=q}(e||(t.$rd=e={}));function h(J,q){return new l(J,q)}class l extends N.$Yd{constructor(q,z){super(),this.debugName=q,this.g=z,this.j=()=>{(0,N.$Zd)(Q=>{for(const ue of this.b)Q.updateObserver(ue,this),ue.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function D(J){return typeof J=="string"?new T(J):new T(void 0,J)}class T extends N.$Yd{get debugName(){return new k.$_c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(q,z){super(),this.e=q,this.g=z}trigger(q,z){if(!q){(0,N.$Zd)(Q=>{this.trigger(Q,z)},()=>`Trigger signal ${this.debugName}`);return}for(const Q of this.b)q.updateObserver(Q,this),Q.handleChange(this,z)}get(){}}function A(J,q,z){const Q=(0,N.$5d)("debounced",void 0);let ue;return z.add((0,B.$id)(be=>{const Ae=J.read(be);ue&&clearTimeout(ue),ue=setTimeout(()=>{(0,N.$Zd)(Fe=>{Q.set(Ae,Fe)})},q)})),Q}function d(J,q){let z=!1,Q,ue;return e(be=>{const Ae=(0,B.$id)(Fe=>{const ne=J.read(Fe);z?(ue&&clearTimeout(ue),ue=setTimeout(()=>{Q=ne,be()},q)):(z=!0,Q=ne)});return{dispose(){Ae.dispose(),z=!1,Q=void 0}}},()=>z?Q:J.get())}function f(J,q,z){const Q=(0,N.$5d)("triggeredRecently",!1);let ue;return z.add(J(()=>{Q.set(!0,void 0),ue&&clearTimeout(ue),ue=setTimeout(()=>{Q.set(!1,void 0)},q)})),Q}function m(J){const q=new H(!1,void 0);return J.addObserver(q),(0,n.$Rc)(()=>{J.removeObserver(q)})}(0,N.$Vd)(m);function S(J,q){const z=new H(!0,q);return J.addObserver(z),q?q(J.get()):J.reportChanges(),(0,n.$Rc)(()=>{J.removeObserver(z)})}(0,N.$Ud)(S);class H{constructor(q,z){this.b=q,this.c=z,this.a=0}beginUpdate(q){this.a++}endUpdate(q){this.a--,this.a===0&&this.b&&(this.c?this.c(q.get()):q.reportChanges())}handlePossibleChange(q){}handleChange(q,z){}}t.$Bd=H;function U(J,q){let z;return(0,w.$Od)({owner:J,debugReferenceFn:q},ue=>(z=q(ue,z),z))}function C(J,q){let z;const Q=D("derivedObservableWithWritableCache"),ue=(0,w.$Md)(J,be=>(Q.read(be),z=q(be,z),z));return Object.assign(ue,{clearCache:be=>{z=void 0,Q.trigger(be)},setCache:(be,Ae)=>{z=be,Q.trigger(Ae)}})}function E(J,q,z,Q){let ue=new R(z,Q);return(0,w.$Od)({debugReferenceFn:z,owner:J,onLastObserverRemoved:()=>{ue.dispose(),ue=new R(z)}},Ae=>(ue.setItems(q.read(Ae)),ue.getItems()))}class R{constructor(q,z){this.c=q,this.e=z,this.a=new Map,this.b=[]}dispose(){this.a.forEach(q=>q.store.dispose()),this.a.clear()}setItems(q){const z=[],Q=new Set(this.a.keys());for(const ue of q){const be=this.e?this.e(ue):ue;let Ae=this.a.get(be);if(Ae)Q.delete(be);else{const Fe=new n.$Sc;Ae={out:this.c(ue,Fe),store:Fe},this.a.set(be,Ae)}z.push(Ae.out)}for(const ue of Q)this.a.get(ue).store.dispose(),this.a.delete(ue);this.b=z}getItems(){return this.b}}class x{constructor(q){this.observable=q}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Fd=x;function I(J,q){return q instanceof x?q.observable:e(J,q.onDidChange,()=>q.value)}function _(J,q){if(q.length===0)throw new c.$bb;let z=!1,Q;const ue=e(J,be=>{const Ae=new n.$Sc;for(const Fe of q)Ae.add((0,B.$jd)({debugName:()=>(0,k.$ad)(ue,new k.$_c(J,void 0,void 0))+".updateLastChangedValue"},ne=>{z=!0,Q=Fe.read(ne),be()}));return Ae.add({dispose(){z=!1,Q=void 0}}),Ae},()=>z?Q:q[q.length-1].get());return ue}function V(J,q){return U(J,(z,Q)=>Q??q(z))}}),define(we[62],De([1,0,27,45,44,105,104,97,31]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$5d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$7d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Zd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$3d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Md}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Pd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Qd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$id}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$jd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return N.$pd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return N.$wd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return N.$Cd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return N.$Dd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return N.$zd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return N.$Ad}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return N.$rd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return N.$qd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return N.$vd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return N.$ud}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return N.$yd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return k.$9d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return k.$_d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return k.$0d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return k.$$d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return k.$ae}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return k.$be}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return w.$de}}),!1&&(0,v.$Jd)(new v.$Ld)}),define(we[20],De([1,0,3,2]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$dt=t.$ct=t.$bt=t.ScrollbarVisibility=void 0;var B;(function(g){g[g.Auto=1]="Auto",g[g.Hidden=2]="Hidden",g[g.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class N{constructor(e,s,r,h,l,D,T){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,r=r|0,h=h|0,l=l|0,D=D|0,T=T|0),this.rawScrollLeft=h,this.rawScrollTop=T,s<0&&(s=0),h+s>r&&(h=r-s),h<0&&(h=0),l<0&&(l=0),T+l>D&&(T=D-l),T<0&&(T=0),this.width=s,this.scrollWidth=r,this.scrollLeft=h,this.height=l,this.scrollHeight=D,this.scrollTop=T}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new N(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new N(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,l=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,T=this.scrollHeight!==e.scrollHeight,A=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:l,heightChanged:D,scrollHeightChanged:T,scrollTopChanged:A}}}t.$bt=N;class k extends n.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$ke),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new N(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const r=this.g.withScrollDimensions(e,s);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;s?h=new p(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=p.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,s)))}}t.$ct=k;class w{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.$dt=w;function v(g,e){const s=e-g;return function(r){return g+s*$(r)}}function c(g,e,s){return function(r){return r<s?g(r/s):e((r-s)/(1-s))}}class p{constructor(e,s,r,h){this.from=e,this.to=s,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,r){if(Math.abs(e-s)>2.5*r){let l,D;return e<s?(l=e+.75*r,D=s-.75*r):(l=e-.75*r,D=s+.75*r),c(v(e,l),v(D,s),.33)}return v(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.c(s),h=this.d(s);return new w(r,h,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return p.start(e,s,r)}static start(e,s,r){r=r+10;const h=Date.now()-10;return new p(e,s,h,r)}}t.$et=p;function y(g){return Math.pow(g,3)}function $(g){return 1-y(1-g)}}),define(we[106],De([1,0,6,2]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xe=B,t.$ye=N,t.$ze=k,t.$Ae=w,t.$Be=c,t.$Ce=p,t.$De=y,t.$Ee=$,t.$Fe=g,t.$Ge=e,t.$He=s,t.$Ie=r,t.$Je=h,t.$Ke=l,t.$Le=D;function B(T){const A=T;return A?typeof A.read=="function":!1}function N(T){const A=T;return A?[A.on,A.pause,A.resume,A.destroy].every(d=>typeof d=="function"):!1}function k(T){const A=T;return A?N(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}function w(T,A){return new v(T,A)}class v{constructor(A,d){this.e=A,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(d=>d(A))}h(A){this.c.error.length===0?(0,i.$Y)(A):this.c.error.slice(0).forEach(d=>d(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,d){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(A,d){if(this.a.destroyed)return;let f;switch(A){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const m=f.indexOf(d);m>=0&&f.splice(m,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(T,A){const d=[];let f;for(;(f=T.read())!==null;)d.push(f);return A(d)}function p(T,A,d){const f=[];let m;for(;(m=T.read())!==null&&f.length<d;)f.push(m);return m===null&&f.length>0?A(f):{read:()=>{if(f.length>0)return f.shift();if(typeof m<"u"){const S=m;return m=void 0,S}return T.read()}}}function y(T,A){return new Promise((d,f)=>{const m=[];$(T,{onData:S=>{A&&m.push(S)},onError:S=>{A?f(S):d(void 0)},onEnd:()=>{d(A?A(m):void 0)}})})}function $(T,A,d){T.on("error",f=>{d?.isCancellationRequested||A.onError(f)}),T.on("end",()=>{d?.isCancellationRequested||A.onEnd()}),T.on("data",f=>{d?.isCancellationRequested||A.onData(f)})}function g(T,A){return new Promise((d,f)=>{const m=new n.$Sc,S=[],H=E=>{if(S.push(E),S.length>A)return m.dispose(),T.pause(),d({stream:T,buffer:S,ended:!1})},U=E=>(m.dispose(),f(E)),C=()=>(m.dispose(),d({stream:T,buffer:S,ended:!0}));m.add((0,n.$Rc)(()=>T.removeListener("error",U))),T.on("error",U),m.add((0,n.$Rc)(()=>T.removeListener("end",C))),T.on("end",C),m.add((0,n.$Rc)(()=>T.removeListener("data",H))),T.on("data",H)})}function e(T,A){const d=w(A);return d.end(T),d}function s(){const T=w(()=>{throw new Error("not supported")});return T.end(),T}function r(T){let A=!1;return{read:()=>A?null:(A=!0,T)}}function h(T,A,d){const f=w(d);return $(T,{onData:m=>f.write(A.data(m)),onError:m=>f.error(A.error?A.error(m):m),onEnd:()=>f.end()}),f}function l(T,A,d){let f=!1;return{read:()=>{const m=A.read();return f?m:(f=!0,m!==null?d([T,m]):T)}}}function D(T,A,d){let f=!1;const m=w(d);return $(A,{onData:S=>f?m.write(S):(f=!0,m.write(d([T,S]))),onError:S=>m.error(S),onEnd:()=>{f||(f=!0,m.write(T)),m.end()}}),m}}),define(we[47],De([1,0,25,106]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Me=void 0,t.$Ne=c,t.$Oe=p,t.$Pe=y,t.$Qe=$,t.$Re=g,t.$Se=e,t.$Te=s,t.$Ue=r,t.$Ve=h,t.$We=l,t.$Xe=D,t.$Ye=T,t.$Ze=A,t.$1e=d,t.$2e=f,t.$3e=m,t.$4e=S,t.$5e=H,t.$6e=U,t.$7e=R,n=He(n);const B=typeof Buffer<"u",N=new i.$T(()=>new Uint8Array(256));let k,w;class v{static alloc(I){return B?new v(Buffer.allocUnsafe(I)):new v(new Uint8Array(I))}static wrap(I){return B&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new v(I)}static fromString(I,_){return!(_?.dontUseNodeBuffer||!1)&&B?new v(Buffer.from(I)):(k||(k=new TextEncoder),new v(k.encode(I)))}static fromByteArray(I){const _=v.alloc(I.length);for(let V=0,J=I.length;V<J;V++)_.buffer[V]=I[V];return _}static concat(I,_){if(typeof _>"u"){_=0;for(let q=0,z=I.length;q<z;q++)_+=I[q].byteLength}const V=v.alloc(_);let J=0;for(let q=0,z=I.length;q<z;q++){const Q=I[q];V.set(Q,J),J+=Q.byteLength}return V}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=v.alloc(this.byteLength);return I.set(this),I}toString(){return B?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(I,_){return new v(this.buffer.subarray(I,_))}set(I,_){if(I instanceof v)this.buffer.set(I.buffer,_);else if(I instanceof Uint8Array)this.buffer.set(I,_);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),_);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return $(this.buffer,I)}writeUInt32BE(I,_){g(this.buffer,I,_)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,_){s(this.buffer,I,_)}readUInt8(I){return r(this.buffer,I)}writeUInt8(I,_){h(this.buffer,I,_)}indexOf(I,_=0){return c(this.buffer,I instanceof v?I.buffer:I,_)}}t.$Me=v;function c(x,I,_=0){const V=I.byteLength,J=x.byteLength;if(V===0)return 0;if(V===1)return x.indexOf(I[0]);if(V>J-_)return-1;const q=N.value;q.fill(I.length);for(let be=0;be<I.length;be++)q[I[be]]=I.length-be-1;let z=_+I.length-1,Q=z,ue=-1;for(;z<J;)if(x[z]===I[Q]){if(Q===0){ue=z;break}z--,Q--}else z+=Math.max(I.length-Q,q[x[z]]),Q=I.length-1;return ue}function p(x,I){return x[I+0]<<0>>>0|x[I+1]<<8>>>0}function y(x,I,_){x[_+0]=I&255,I=I>>>8,x[_+1]=I&255}function $(x,I){return x[I]*2**24+x[I+1]*2**16+x[I+2]*2**8+x[I+3]}function g(x,I,_){x[_+3]=I,I=I>>>8,x[_+2]=I,I=I>>>8,x[_+1]=I,I=I>>>8,x[_]=I}function e(x,I){return x[I+0]<<0>>>0|x[I+1]<<8>>>0|x[I+2]<<16>>>0|x[I+3]<<24>>>0}function s(x,I,_){x[_+0]=I&255,I=I>>>8,x[_+1]=I&255,I=I>>>8,x[_+2]=I&255,I=I>>>8,x[_+3]=I&255}function r(x,I){return x[I]}function h(x,I,_){x[_]=I}function l(x){return n.$Be(x,I=>v.concat(I))}function D(x){return n.$Ie(x)}function T(x){return n.$De(x,I=>v.concat(I))}async function A(x){return x.ended?v.concat(x.buffer):v.concat([...x.buffer,await T(x.stream)])}function d(x){return n.$Ge(x,I=>v.concat(I))}function f(x){return n.$Je(x,{data:I=>typeof I=="string"?v.fromString(I):v.wrap(I)},I=>v.concat(I))}function m(x){return n.$Ae(I=>v.concat(I),x)}function S(x,I){return n.$Ke(x,I,_=>v.concat(_))}function H(x,I){return n.$Le(x,I,_=>v.concat(_))}function U(x){let I=0,_=0,V=0;const J=new Uint8Array(Math.floor(x.length/4*3)),q=Q=>{switch(_){case 3:J[V++]=I|Q,_=0;break;case 2:J[V++]=I|Q>>>2,I=Q<<6,_=3;break;case 1:J[V++]=I|Q>>>4,I=Q<<4,_=2;break;default:I=Q<<2,_=1}};for(let Q=0;Q<x.length;Q++){const ue=x.charCodeAt(Q);if(ue>=65&&ue<=90)q(ue-65);else if(ue>=97&&ue<=122)q(ue-97+26);else if(ue>=48&&ue<=57)q(ue-48+52);else if(ue===43||ue===45)q(62);else if(ue===47||ue===95)q(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${x[Q]}`)}}const z=V;for(;_>0;)q(0);return v.wrap(J).slice(0,z)}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:x},I=!0,_=!1){const V=_?E:C;let J="";const q=x.byteLength%3;let z=0;for(;z<x.byteLength-q;z+=3){const Q=x[z+0],ue=x[z+1],be=x[z+2];J+=V[Q>>>2],J+=V[(Q<<4|ue>>>4)&63],J+=V[(ue<<2|be>>>6)&63],J+=V[be&63]}if(q===1){const Q=x[z+0];J+=V[Q>>>2],J+=V[Q<<4&63],I&&(J+="==")}else if(q===2){const Q=x[z+0],ue=x[z+1];J+=V[Q>>>2],J+=V[(Q<<4|ue>>>4)&63],J+=V[ue<<2&63],I&&(J+="=")}return J}}),define(we[63],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=void 0,t.$fe=Symbol("MicrotaskDelay")}),define(we[10],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dg=i,t.$eg=n,t.$fg=B,t.$gg=N,t.$hg=k,t.$ig=w,t.$jg=v,t.$kg=c,t.$lg=p,t.$mg=y,t.$ng=$,t.$og=g,t.$pg=e,t.$qg=r,t.$rg=h,t.$sg=l,t.$tg=D,t.$ug=T;function i(A){return typeof A=="string"}function n(A){return Array.isArray(A)&&A.every(d=>i(d))}function B(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}function N(A){const d=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof d}function k(A){return typeof A=="number"&&!isNaN(A)}function w(A){return!!A&&typeof A[Symbol.iterator]=="function"}function v(A){return A===!0||A===!1}function c(A){return typeof A>"u"}function p(A){return!y(A)}function y(A){return c(A)||A===null}function $(A,d){if(!A)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}function g(A){if(y(A))throw new Error("Assertion Failed: argument is undefined or null");return A}function e(...A){const d=[];for(let f=0;f<A.length;f++){const m=A[f];if(y(m))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);d.push(m)}return d}const s=Object.prototype.hasOwnProperty;function r(A){if(!B(A))return!1;for(const d in A)if(s.call(A,d))return!1;return!0}function h(A){return typeof A=="function"}function l(...A){return A.length>0&&A.every(h)}function D(A,d){const f=Math.min(A.length,d.length);for(let m=0;m<f;m++)T(A[m],d[m])}function T(A,d){if(i(d)){if(typeof A!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(h(d)){try{if(A instanceof d)return}catch{}if(!y(A)&&A.constructor===d||d.length===1&&d.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(we[48],De([1,0,10]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=B,t.$Yj=N;const n=Object.create(null);function B(k,w){if((0,i.$dg)(w)){const v=n[w];if(v===void 0)throw new Error(`${k} references an unknown codicon: ${w}`);w=v}return n[k]=w,{id:k}}function N(){return n}}),define(we[107],De([1,0,48]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=void 0,t.$Zj={add:(0,i.$Xj)("add",6e4),plus:(0,i.$Xj)("plus",6e4),gistNew:(0,i.$Xj)("gist-new",6e4),repoCreate:(0,i.$Xj)("repo-create",6e4),lightbulb:(0,i.$Xj)("lightbulb",60001),lightBulb:(0,i.$Xj)("light-bulb",60001),repo:(0,i.$Xj)("repo",60002),repoDelete:(0,i.$Xj)("repo-delete",60002),gistFork:(0,i.$Xj)("gist-fork",60003),repoForked:(0,i.$Xj)("repo-forked",60003),gitPullRequest:(0,i.$Xj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Xj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Xj)("record-keys",60005),keyboard:(0,i.$Xj)("keyboard",60005),tag:(0,i.$Xj)("tag",60006),gitPullRequestLabel:(0,i.$Xj)("git-pull-request-label",60006),tagAdd:(0,i.$Xj)("tag-add",60006),tagRemove:(0,i.$Xj)("tag-remove",60006),person:(0,i.$Xj)("person",60007),personFollow:(0,i.$Xj)("person-follow",60007),personOutline:(0,i.$Xj)("person-outline",60007),personFilled:(0,i.$Xj)("person-filled",60007),gitBranch:(0,i.$Xj)("git-branch",60008),gitBranchCreate:(0,i.$Xj)("git-branch-create",60008),gitBranchDelete:(0,i.$Xj)("git-branch-delete",60008),sourceControl:(0,i.$Xj)("source-control",60008),mirror:(0,i.$Xj)("mirror",60009),mirrorPublic:(0,i.$Xj)("mirror-public",60009),star:(0,i.$Xj)("star",60010),starAdd:(0,i.$Xj)("star-add",60010),starDelete:(0,i.$Xj)("star-delete",60010),starEmpty:(0,i.$Xj)("star-empty",60010),comment:(0,i.$Xj)("comment",60011),commentAdd:(0,i.$Xj)("comment-add",60011),alert:(0,i.$Xj)("alert",60012),warning:(0,i.$Xj)("warning",60012),search:(0,i.$Xj)("search",60013),searchSave:(0,i.$Xj)("search-save",60013),logOut:(0,i.$Xj)("log-out",60014),signOut:(0,i.$Xj)("sign-out",60014),logIn:(0,i.$Xj)("log-in",60015),signIn:(0,i.$Xj)("sign-in",60015),eye:(0,i.$Xj)("eye",60016),eyeUnwatch:(0,i.$Xj)("eye-unwatch",60016),eyeWatch:(0,i.$Xj)("eye-watch",60016),circleFilled:(0,i.$Xj)("circle-filled",60017),primitiveDot:(0,i.$Xj)("primitive-dot",60017),closeDirty:(0,i.$Xj)("close-dirty",60017),debugBreakpoint:(0,i.$Xj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Xj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Xj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Xj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Xj)("primitive-square",60018),edit:(0,i.$Xj)("edit",60019),pencil:(0,i.$Xj)("pencil",60019),info:(0,i.$Xj)("info",60020),issueOpened:(0,i.$Xj)("issue-opened",60020),gistPrivate:(0,i.$Xj)("gist-private",60021),gitForkPrivate:(0,i.$Xj)("git-fork-private",60021),lock:(0,i.$Xj)("lock",60021),mirrorPrivate:(0,i.$Xj)("mirror-private",60021),close:(0,i.$Xj)("close",60022),removeClose:(0,i.$Xj)("remove-close",60022),x:(0,i.$Xj)("x",60022),repoSync:(0,i.$Xj)("repo-sync",60023),sync:(0,i.$Xj)("sync",60023),clone:(0,i.$Xj)("clone",60024),desktopDownload:(0,i.$Xj)("desktop-download",60024),beaker:(0,i.$Xj)("beaker",60025),microscope:(0,i.$Xj)("microscope",60025),vm:(0,i.$Xj)("vm",60026),deviceDesktop:(0,i.$Xj)("device-desktop",60026),file:(0,i.$Xj)("file",60027),fileText:(0,i.$Xj)("file-text",60027),more:(0,i.$Xj)("more",60028),ellipsis:(0,i.$Xj)("ellipsis",60028),kebabHorizontal:(0,i.$Xj)("kebab-horizontal",60028),mailReply:(0,i.$Xj)("mail-reply",60029),reply:(0,i.$Xj)("reply",60029),organization:(0,i.$Xj)("organization",60030),organizationFilled:(0,i.$Xj)("organization-filled",60030),organizationOutline:(0,i.$Xj)("organization-outline",60030),newFile:(0,i.$Xj)("new-file",60031),fileAdd:(0,i.$Xj)("file-add",60031),newFolder:(0,i.$Xj)("new-folder",60032),fileDirectoryCreate:(0,i.$Xj)("file-directory-create",60032),trash:(0,i.$Xj)("trash",60033),trashcan:(0,i.$Xj)("trashcan",60033),history:(0,i.$Xj)("history",60034),clock:(0,i.$Xj)("clock",60034),folder:(0,i.$Xj)("folder",60035),fileDirectory:(0,i.$Xj)("file-directory",60035),symbolFolder:(0,i.$Xj)("symbol-folder",60035),logoGithub:(0,i.$Xj)("logo-github",60036),markGithub:(0,i.$Xj)("mark-github",60036),github:(0,i.$Xj)("github",60036),terminal:(0,i.$Xj)("terminal",60037),console:(0,i.$Xj)("console",60037),repl:(0,i.$Xj)("repl",60037),zap:(0,i.$Xj)("zap",60038),symbolEvent:(0,i.$Xj)("symbol-event",60038),error:(0,i.$Xj)("error",60039),stop:(0,i.$Xj)("stop",60039),variable:(0,i.$Xj)("variable",60040),symbolVariable:(0,i.$Xj)("symbol-variable",60040),array:(0,i.$Xj)("array",60042),symbolArray:(0,i.$Xj)("symbol-array",60042),symbolModule:(0,i.$Xj)("symbol-module",60043),symbolPackage:(0,i.$Xj)("symbol-package",60043),symbolNamespace:(0,i.$Xj)("symbol-namespace",60043),symbolObject:(0,i.$Xj)("symbol-object",60043),symbolMethod:(0,i.$Xj)("symbol-method",60044),symbolFunction:(0,i.$Xj)("symbol-function",60044),symbolConstructor:(0,i.$Xj)("symbol-constructor",60044),symbolBoolean:(0,i.$Xj)("symbol-boolean",60047),symbolNull:(0,i.$Xj)("symbol-null",60047),symbolNumeric:(0,i.$Xj)("symbol-numeric",60048),symbolNumber:(0,i.$Xj)("symbol-number",60048),symbolStructure:(0,i.$Xj)("symbol-structure",60049),symbolStruct:(0,i.$Xj)("symbol-struct",60049),symbolParameter:(0,i.$Xj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Xj)("symbol-type-parameter",60050),symbolKey:(0,i.$Xj)("symbol-key",60051),symbolText:(0,i.$Xj)("symbol-text",60051),symbolReference:(0,i.$Xj)("symbol-reference",60052),goToFile:(0,i.$Xj)("go-to-file",60052),symbolEnum:(0,i.$Xj)("symbol-enum",60053),symbolValue:(0,i.$Xj)("symbol-value",60053),symbolRuler:(0,i.$Xj)("symbol-ruler",60054),symbolUnit:(0,i.$Xj)("symbol-unit",60054),activateBreakpoints:(0,i.$Xj)("activate-breakpoints",60055),archive:(0,i.$Xj)("archive",60056),arrowBoth:(0,i.$Xj)("arrow-both",60057),arrowDown:(0,i.$Xj)("arrow-down",60058),arrowLeft:(0,i.$Xj)("arrow-left",60059),arrowRight:(0,i.$Xj)("arrow-right",60060),arrowSmallDown:(0,i.$Xj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Xj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Xj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Xj)("arrow-small-up",60064),arrowUp:(0,i.$Xj)("arrow-up",60065),bell:(0,i.$Xj)("bell",60066),bold:(0,i.$Xj)("bold",60067),book:(0,i.$Xj)("book",60068),bookmark:(0,i.$Xj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Xj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Xj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Xj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Xj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Xj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Xj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Xj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Xj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Xj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Xj)("briefcase",60076),broadcast:(0,i.$Xj)("broadcast",60077),browser:(0,i.$Xj)("browser",60078),bug:(0,i.$Xj)("bug",60079),calendar:(0,i.$Xj)("calendar",60080),caseSensitive:(0,i.$Xj)("case-sensitive",60081),check:(0,i.$Xj)("check",60082),checklist:(0,i.$Xj)("checklist",60083),chevronDown:(0,i.$Xj)("chevron-down",60084),chevronLeft:(0,i.$Xj)("chevron-left",60085),chevronRight:(0,i.$Xj)("chevron-right",60086),chevronUp:(0,i.$Xj)("chevron-up",60087),chromeClose:(0,i.$Xj)("chrome-close",60088),chromeMaximize:(0,i.$Xj)("chrome-maximize",60089),chromeMinimize:(0,i.$Xj)("chrome-minimize",60090),chromeRestore:(0,i.$Xj)("chrome-restore",60091),circleOutline:(0,i.$Xj)("circle-outline",60092),circle:(0,i.$Xj)("circle",60092),debugBreakpointUnverified:(0,i.$Xj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Xj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Xj)("circle-slash",60093),circuitBoard:(0,i.$Xj)("circuit-board",60094),clearAll:(0,i.$Xj)("clear-all",60095),clippy:(0,i.$Xj)("clippy",60096),closeAll:(0,i.$Xj)("close-all",60097),cloudDownload:(0,i.$Xj)("cloud-download",60098),cloudUpload:(0,i.$Xj)("cloud-upload",60099),code:(0,i.$Xj)("code",60100),collapseAll:(0,i.$Xj)("collapse-all",60101),colorMode:(0,i.$Xj)("color-mode",60102),commentDiscussion:(0,i.$Xj)("comment-discussion",60103),creditCard:(0,i.$Xj)("credit-card",60105),dash:(0,i.$Xj)("dash",60108),dashboard:(0,i.$Xj)("dashboard",60109),database:(0,i.$Xj)("database",60110),debugContinue:(0,i.$Xj)("debug-continue",60111),debugDisconnect:(0,i.$Xj)("debug-disconnect",60112),debugPause:(0,i.$Xj)("debug-pause",60113),debugRestart:(0,i.$Xj)("debug-restart",60114),debugStart:(0,i.$Xj)("debug-start",60115),debugStepInto:(0,i.$Xj)("debug-step-into",60116),debugStepOut:(0,i.$Xj)("debug-step-out",60117),debugStepOver:(0,i.$Xj)("debug-step-over",60118),debugStop:(0,i.$Xj)("debug-stop",60119),debug:(0,i.$Xj)("debug",60120),deviceCameraVideo:(0,i.$Xj)("device-camera-video",60121),deviceCamera:(0,i.$Xj)("device-camera",60122),deviceMobile:(0,i.$Xj)("device-mobile",60123),diffAdded:(0,i.$Xj)("diff-added",60124),diffIgnored:(0,i.$Xj)("diff-ignored",60125),diffModified:(0,i.$Xj)("diff-modified",60126),diffRemoved:(0,i.$Xj)("diff-removed",60127),diffRenamed:(0,i.$Xj)("diff-renamed",60128),diff:(0,i.$Xj)("diff",60129),diffSidebyside:(0,i.$Xj)("diff-sidebyside",60129),discard:(0,i.$Xj)("discard",60130),editorLayout:(0,i.$Xj)("editor-layout",60131),emptyWindow:(0,i.$Xj)("empty-window",60132),exclude:(0,i.$Xj)("exclude",60133),extensions:(0,i.$Xj)("extensions",60134),eyeClosed:(0,i.$Xj)("eye-closed",60135),fileBinary:(0,i.$Xj)("file-binary",60136),fileCode:(0,i.$Xj)("file-code",60137),fileMedia:(0,i.$Xj)("file-media",60138),filePdf:(0,i.$Xj)("file-pdf",60139),fileSubmodule:(0,i.$Xj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Xj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Xj)("file-symlink-file",60142),fileZip:(0,i.$Xj)("file-zip",60143),files:(0,i.$Xj)("files",60144),filter:(0,i.$Xj)("filter",60145),flame:(0,i.$Xj)("flame",60146),foldDown:(0,i.$Xj)("fold-down",60147),foldUp:(0,i.$Xj)("fold-up",60148),fold:(0,i.$Xj)("fold",60149),folderActive:(0,i.$Xj)("folder-active",60150),folderOpened:(0,i.$Xj)("folder-opened",60151),gear:(0,i.$Xj)("gear",60152),gift:(0,i.$Xj)("gift",60153),gistSecret:(0,i.$Xj)("gist-secret",60154),gist:(0,i.$Xj)("gist",60155),gitCommit:(0,i.$Xj)("git-commit",60156),gitCompare:(0,i.$Xj)("git-compare",60157),compareChanges:(0,i.$Xj)("compare-changes",60157),gitMerge:(0,i.$Xj)("git-merge",60158),githubAction:(0,i.$Xj)("github-action",60159),githubAlt:(0,i.$Xj)("github-alt",60160),globe:(0,i.$Xj)("globe",60161),grabber:(0,i.$Xj)("grabber",60162),graph:(0,i.$Xj)("graph",60163),gripper:(0,i.$Xj)("gripper",60164),heart:(0,i.$Xj)("heart",60165),home:(0,i.$Xj)("home",60166),horizontalRule:(0,i.$Xj)("horizontal-rule",60167),hubot:(0,i.$Xj)("hubot",60168),inbox:(0,i.$Xj)("inbox",60169),issueReopened:(0,i.$Xj)("issue-reopened",60171),issues:(0,i.$Xj)("issues",60172),italic:(0,i.$Xj)("italic",60173),jersey:(0,i.$Xj)("jersey",60174),json:(0,i.$Xj)("json",60175),kebabVertical:(0,i.$Xj)("kebab-vertical",60176),key:(0,i.$Xj)("key",60177),law:(0,i.$Xj)("law",60178),lightbulbAutofix:(0,i.$Xj)("lightbulb-autofix",60179),linkExternal:(0,i.$Xj)("link-external",60180),link:(0,i.$Xj)("link",60181),listOrdered:(0,i.$Xj)("list-ordered",60182),listUnordered:(0,i.$Xj)("list-unordered",60183),liveShare:(0,i.$Xj)("live-share",60184),loading:(0,i.$Xj)("loading",60185),location:(0,i.$Xj)("location",60186),mailRead:(0,i.$Xj)("mail-read",60187),mail:(0,i.$Xj)("mail",60188),markdown:(0,i.$Xj)("markdown",60189),megaphone:(0,i.$Xj)("megaphone",60190),mention:(0,i.$Xj)("mention",60191),milestone:(0,i.$Xj)("milestone",60192),gitPullRequestMilestone:(0,i.$Xj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Xj)("mortar-board",60193),move:(0,i.$Xj)("move",60194),multipleWindows:(0,i.$Xj)("multiple-windows",60195),mute:(0,i.$Xj)("mute",60196),noNewline:(0,i.$Xj)("no-newline",60197),note:(0,i.$Xj)("note",60198),octoface:(0,i.$Xj)("octoface",60199),openPreview:(0,i.$Xj)("open-preview",60200),package:(0,i.$Xj)("package",60201),paintcan:(0,i.$Xj)("paintcan",60202),pin:(0,i.$Xj)("pin",60203),play:(0,i.$Xj)("play",60204),run:(0,i.$Xj)("run",60204),plug:(0,i.$Xj)("plug",60205),preserveCase:(0,i.$Xj)("preserve-case",60206),preview:(0,i.$Xj)("preview",60207),project:(0,i.$Xj)("project",60208),pulse:(0,i.$Xj)("pulse",60209),question:(0,i.$Xj)("question",60210),quote:(0,i.$Xj)("quote",60211),radioTower:(0,i.$Xj)("radio-tower",60212),reactions:(0,i.$Xj)("reactions",60213),references:(0,i.$Xj)("references",60214),refresh:(0,i.$Xj)("refresh",60215),regex:(0,i.$Xj)("regex",60216),remoteExplorer:(0,i.$Xj)("remote-explorer",60217),remote:(0,i.$Xj)("remote",60218),remove:(0,i.$Xj)("remove",60219),replaceAll:(0,i.$Xj)("replace-all",60220),replace:(0,i.$Xj)("replace",60221),repoClone:(0,i.$Xj)("repo-clone",60222),repoForcePush:(0,i.$Xj)("repo-force-push",60223),repoPull:(0,i.$Xj)("repo-pull",60224),repoPush:(0,i.$Xj)("repo-push",60225),report:(0,i.$Xj)("report",60226),requestChanges:(0,i.$Xj)("request-changes",60227),rocket:(0,i.$Xj)("rocket",60228),rootFolderOpened:(0,i.$Xj)("root-folder-opened",60229),rootFolder:(0,i.$Xj)("root-folder",60230),rss:(0,i.$Xj)("rss",60231),ruby:(0,i.$Xj)("ruby",60232),saveAll:(0,i.$Xj)("save-all",60233),saveAs:(0,i.$Xj)("save-as",60234),save:(0,i.$Xj)("save",60235),screenFull:(0,i.$Xj)("screen-full",60236),screenNormal:(0,i.$Xj)("screen-normal",60237),searchStop:(0,i.$Xj)("search-stop",60238),server:(0,i.$Xj)("server",60240),settingsGear:(0,i.$Xj)("settings-gear",60241),settings:(0,i.$Xj)("settings",60242),shield:(0,i.$Xj)("shield",60243),smiley:(0,i.$Xj)("smiley",60244),sortPrecedence:(0,i.$Xj)("sort-precedence",60245),splitHorizontal:(0,i.$Xj)("split-horizontal",60246),splitVertical:(0,i.$Xj)("split-vertical",60247),squirrel:(0,i.$Xj)("squirrel",60248),starFull:(0,i.$Xj)("star-full",60249),starHalf:(0,i.$Xj)("star-half",60250),symbolClass:(0,i.$Xj)("symbol-class",60251),symbolColor:(0,i.$Xj)("symbol-color",60252),symbolConstant:(0,i.$Xj)("symbol-constant",60253),symbolEnumMember:(0,i.$Xj)("symbol-enum-member",60254),symbolField:(0,i.$Xj)("symbol-field",60255),symbolFile:(0,i.$Xj)("symbol-file",60256),symbolInterface:(0,i.$Xj)("symbol-interface",60257),symbolKeyword:(0,i.$Xj)("symbol-keyword",60258),symbolMisc:(0,i.$Xj)("symbol-misc",60259),symbolOperator:(0,i.$Xj)("symbol-operator",60260),symbolProperty:(0,i.$Xj)("symbol-property",60261),wrench:(0,i.$Xj)("wrench",60261),wrenchSubaction:(0,i.$Xj)("wrench-subaction",60261),symbolSnippet:(0,i.$Xj)("symbol-snippet",60262),tasklist:(0,i.$Xj)("tasklist",60263),telescope:(0,i.$Xj)("telescope",60264),textSize:(0,i.$Xj)("text-size",60265),threeBars:(0,i.$Xj)("three-bars",60266),thumbsdown:(0,i.$Xj)("thumbsdown",60267),thumbsup:(0,i.$Xj)("thumbsup",60268),tools:(0,i.$Xj)("tools",60269),triangleDown:(0,i.$Xj)("triangle-down",60270),triangleLeft:(0,i.$Xj)("triangle-left",60271),triangleRight:(0,i.$Xj)("triangle-right",60272),triangleUp:(0,i.$Xj)("triangle-up",60273),twitter:(0,i.$Xj)("twitter",60274),unfold:(0,i.$Xj)("unfold",60275),unlock:(0,i.$Xj)("unlock",60276),unmute:(0,i.$Xj)("unmute",60277),unverified:(0,i.$Xj)("unverified",60278),verified:(0,i.$Xj)("verified",60279),versions:(0,i.$Xj)("versions",60280),vmActive:(0,i.$Xj)("vm-active",60281),vmOutline:(0,i.$Xj)("vm-outline",60282),vmRunning:(0,i.$Xj)("vm-running",60283),watch:(0,i.$Xj)("watch",60284),whitespace:(0,i.$Xj)("whitespace",60285),wholeWord:(0,i.$Xj)("whole-word",60286),window:(0,i.$Xj)("window",60287),wordWrap:(0,i.$Xj)("word-wrap",60288),zoomIn:(0,i.$Xj)("zoom-in",60289),zoomOut:(0,i.$Xj)("zoom-out",60290),listFilter:(0,i.$Xj)("list-filter",60291),listFlat:(0,i.$Xj)("list-flat",60292),listSelection:(0,i.$Xj)("list-selection",60293),selection:(0,i.$Xj)("selection",60293),listTree:(0,i.$Xj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Xj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Xj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Xj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Xj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Xj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Xj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Xj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Xj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Xj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Xj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Xj)("symbol-string",60301),debugReverseContinue:(0,i.$Xj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Xj)("debug-step-back",60303),debugRestartFrame:(0,i.$Xj)("debug-restart-frame",60304),debugAlt:(0,i.$Xj)("debug-alt",60305),callIncoming:(0,i.$Xj)("call-incoming",60306),callOutgoing:(0,i.$Xj)("call-outgoing",60307),menu:(0,i.$Xj)("menu",60308),expandAll:(0,i.$Xj)("expand-all",60309),feedback:(0,i.$Xj)("feedback",60310),gitPullRequestReviewer:(0,i.$Xj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Xj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Xj)("ungroup-by-ref-type",60312),account:(0,i.$Xj)("account",60313),gitPullRequestAssignee:(0,i.$Xj)("git-pull-request-assignee",60313),bellDot:(0,i.$Xj)("bell-dot",60314),debugConsole:(0,i.$Xj)("debug-console",60315),library:(0,i.$Xj)("library",60316),output:(0,i.$Xj)("output",60317),runAll:(0,i.$Xj)("run-all",60318),syncIgnored:(0,i.$Xj)("sync-ignored",60319),pinned:(0,i.$Xj)("pinned",60320),githubInverted:(0,i.$Xj)("github-inverted",60321),serverProcess:(0,i.$Xj)("server-process",60322),serverEnvironment:(0,i.$Xj)("server-environment",60323),pass:(0,i.$Xj)("pass",60324),issueClosed:(0,i.$Xj)("issue-closed",60324),stopCircle:(0,i.$Xj)("stop-circle",60325),playCircle:(0,i.$Xj)("play-circle",60326),record:(0,i.$Xj)("record",60327),debugAltSmall:(0,i.$Xj)("debug-alt-small",60328),vmConnect:(0,i.$Xj)("vm-connect",60329),cloud:(0,i.$Xj)("cloud",60330),merge:(0,i.$Xj)("merge",60331),export:(0,i.$Xj)("export",60332),graphLeft:(0,i.$Xj)("graph-left",60333),magnet:(0,i.$Xj)("magnet",60334),notebook:(0,i.$Xj)("notebook",60335),redo:(0,i.$Xj)("redo",60336),checkAll:(0,i.$Xj)("check-all",60337),pinnedDirty:(0,i.$Xj)("pinned-dirty",60338),passFilled:(0,i.$Xj)("pass-filled",60339),circleLargeFilled:(0,i.$Xj)("circle-large-filled",60340),circleLarge:(0,i.$Xj)("circle-large",60341),circleLargeOutline:(0,i.$Xj)("circle-large-outline",60341),combine:(0,i.$Xj)("combine",60342),gather:(0,i.$Xj)("gather",60342),table:(0,i.$Xj)("table",60343),variableGroup:(0,i.$Xj)("variable-group",60344),typeHierarchy:(0,i.$Xj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Xj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Xj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Xj)("git-pull-request-create",60348),runAbove:(0,i.$Xj)("run-above",60349),runBelow:(0,i.$Xj)("run-below",60350),notebookTemplate:(0,i.$Xj)("notebook-template",60351),debugRerun:(0,i.$Xj)("debug-rerun",60352),workspaceTrusted:(0,i.$Xj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Xj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Xj)("workspace-unknown",60355),terminalCmd:(0,i.$Xj)("terminal-cmd",60356),terminalDebian:(0,i.$Xj)("terminal-debian",60357),terminalLinux:(0,i.$Xj)("terminal-linux",60358),terminalPowershell:(0,i.$Xj)("terminal-powershell",60359),terminalTmux:(0,i.$Xj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Xj)("terminal-ubuntu",60361),terminalBash:(0,i.$Xj)("terminal-bash",60362),arrowSwap:(0,i.$Xj)("arrow-swap",60363),copy:(0,i.$Xj)("copy",60364),personAdd:(0,i.$Xj)("person-add",60365),filterFilled:(0,i.$Xj)("filter-filled",60366),wand:(0,i.$Xj)("wand",60367),debugLineByLine:(0,i.$Xj)("debug-line-by-line",60368),inspect:(0,i.$Xj)("inspect",60369),layers:(0,i.$Xj)("layers",60370),layersDot:(0,i.$Xj)("layers-dot",60371),layersActive:(0,i.$Xj)("layers-active",60372),compass:(0,i.$Xj)("compass",60373),compassDot:(0,i.$Xj)("compass-dot",60374),compassActive:(0,i.$Xj)("compass-active",60375),azure:(0,i.$Xj)("azure",60376),issueDraft:(0,i.$Xj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Xj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Xj)("git-pull-request-draft",60379),debugAll:(0,i.$Xj)("debug-all",60380),debugCoverage:(0,i.$Xj)("debug-coverage",60381),runErrors:(0,i.$Xj)("run-errors",60382),folderLibrary:(0,i.$Xj)("folder-library",60383),debugContinueSmall:(0,i.$Xj)("debug-continue-small",60384),beakerStop:(0,i.$Xj)("beaker-stop",60385),graphLine:(0,i.$Xj)("graph-line",60386),graphScatter:(0,i.$Xj)("graph-scatter",60387),pieChart:(0,i.$Xj)("pie-chart",60388),bracket:(0,i.$Xj)("bracket",60175),bracketDot:(0,i.$Xj)("bracket-dot",60389),bracketError:(0,i.$Xj)("bracket-error",60390),lockSmall:(0,i.$Xj)("lock-small",60391),azureDevops:(0,i.$Xj)("azure-devops",60392),verifiedFilled:(0,i.$Xj)("verified-filled",60393),newline:(0,i.$Xj)("newline",60394),layout:(0,i.$Xj)("layout",60395),layoutActivitybarLeft:(0,i.$Xj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Xj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Xj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Xj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Xj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Xj)("layout-panel-right",60401),layoutPanel:(0,i.$Xj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Xj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Xj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Xj)("layout-statusbar",60405),layoutMenubar:(0,i.$Xj)("layout-menubar",60406),layoutCentered:(0,i.$Xj)("layout-centered",60407),target:(0,i.$Xj)("target",60408),indent:(0,i.$Xj)("indent",60409),recordSmall:(0,i.$Xj)("record-small",60410),errorSmall:(0,i.$Xj)("error-small",60411),terminalDecorationError:(0,i.$Xj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Xj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Xj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Xj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Xj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Xj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Xj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Xj)("layout-sidebar-left-off",60418),blank:(0,i.$Xj)("blank",60419),heartFilled:(0,i.$Xj)("heart-filled",60420),map:(0,i.$Xj)("map",60421),mapHorizontal:(0,i.$Xj)("map-horizontal",60421),foldHorizontal:(0,i.$Xj)("fold-horizontal",60421),mapFilled:(0,i.$Xj)("map-filled",60422),mapHorizontalFilled:(0,i.$Xj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Xj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Xj)("circle-small",60423),bellSlash:(0,i.$Xj)("bell-slash",60424),bellSlashDot:(0,i.$Xj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Xj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Xj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Xj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Xj)("search-fuzzy",60429),commentDraft:(0,i.$Xj)("comment-draft",60430),send:(0,i.$Xj)("send",60431),sparkle:(0,i.$Xj)("sparkle",60432),insert:(0,i.$Xj)("insert",60433),mic:(0,i.$Xj)("mic",60434),thumbsdownFilled:(0,i.$Xj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Xj)("thumbsup-filled",60436),coffee:(0,i.$Xj)("coffee",60437),snake:(0,i.$Xj)("snake",60438),game:(0,i.$Xj)("game",60439),vr:(0,i.$Xj)("vr",60440),chip:(0,i.$Xj)("chip",60441),piano:(0,i.$Xj)("piano",60442),music:(0,i.$Xj)("music",60443),micFilled:(0,i.$Xj)("mic-filled",60444),repoFetch:(0,i.$Xj)("repo-fetch",60445),copilot:(0,i.$Xj)("copilot",60446),lightbulbSparkle:(0,i.$Xj)("lightbulb-sparkle",60447),robot:(0,i.$Xj)("robot",60448),sparkleFilled:(0,i.$Xj)("sparkle-filled",60449),diffSingle:(0,i.$Xj)("diff-single",60450),diffMultiple:(0,i.$Xj)("diff-multiple",60451),surroundWith:(0,i.$Xj)("surround-with",60452),share:(0,i.$Xj)("share",60453),gitStash:(0,i.$Xj)("git-stash",60454),gitStashApply:(0,i.$Xj)("git-stash-apply",60455),gitStashPop:(0,i.$Xj)("git-stash-pop",60456),vscode:(0,i.$Xj)("vscode",60457),vscodeInsiders:(0,i.$Xj)("vscode-insiders",60458),codeOss:(0,i.$Xj)("code-oss",60459),runCoverage:(0,i.$Xj)("run-coverage",60460),runAllCoverage:(0,i.$Xj)("run-all-coverage",60461),coverage:(0,i.$Xj)("coverage",60462),githubProject:(0,i.$Xj)("github-project",60463),mapVertical:(0,i.$Xj)("map-vertical",60464),foldVertical:(0,i.$Xj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Xj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Xj)("fold-vertical-filled",60465),goToSearch:(0,i.$Xj)("go-to-search",60466),percentage:(0,i.$Xj)("percentage",60467),sortPercentage:(0,i.$Xj)("sort-percentage",60467),attach:(0,i.$Xj)("attach",60468)}}),define(we[21],De([1,0,48,107]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=void 0,t.$1j=B;function B(){return Object.values(t.$3j)}t.$2j={dialogError:(0,i.$Xj)("dialog-error","error"),dialogWarning:(0,i.$Xj)("dialog-warning","warning"),dialogInfo:(0,i.$Xj)("dialog-info","info"),dialogClose:(0,i.$Xj)("dialog-close","close"),treeItemExpanded:(0,i.$Xj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Xj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Xj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Xj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Xj)("tree-item-loading","loading"),menuSelection:(0,i.$Xj)("menu-selection","check"),menuSubmenu:(0,i.$Xj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Xj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Xj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Xj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Xj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Xj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Xj)("toolbar-more","more"),quickInputBack:(0,i.$Xj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Xj)("drop-down-button",60084),symbolCustomColor:(0,i.$Xj)("symbol-customcolor",60252),exportIcon:(0,i.$Xj)("export",60332),workspaceUnspecified:(0,i.$Xj)("workspace-unspecified",60355),newLine:(0,i.$Xj)("newline",60394),thumbsDownFilled:(0,i.$Xj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Xj)("thumbsup-filled",60436),gitFetch:(0,i.$Xj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Xj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Xj)("debug-breakpoint-pending",60377)},t.$3j={...n.$Zj,...t.$2j}}),define(we[64],De([1,0,10]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$co=n,t.$do=B,t.$eo=k,t.$fo=v,t.$go=c,t.$ho=p,t.$io=y,t.$jo=$,t.$ko=g,t.$lo=e,t.$mo=s,t.$no=r,t.$oo=h;function n(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const D=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([T,A])=>{D[T]=A&&typeof A=="object"?n(A):A}),D}function B(l){if(!l||typeof l!="object")return l;const D=[l];for(;D.length>0;){const T=D.shift();Object.freeze(T);for(const A in T)if(N.call(T,A)){const d=T[A];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$gg)(d)&&D.push(d)}}return l}const N=Object.prototype.hasOwnProperty;function k(l,D){return w(l,D,new Set)}function w(l,D,T){if((0,i.$mg)(l))return l;const A=D(l);if(typeof A<"u")return A;if(Array.isArray(l)){const d=[];for(const f of l)d.push(w(f,D,T));return d}if((0,i.$fg)(l)){if(T.has(l))throw new Error("Cannot clone recursive data-structure");T.add(l);const d={};for(const f in l)N.call(l,f)&&(d[f]=w(l[f],D,T));return T.delete(l),d}return l}function v(l,D,T=!0){return(0,i.$fg)(l)?((0,i.$fg)(D)&&Object.keys(D).forEach(A=>{A in l?T&&((0,i.$fg)(l[A])&&(0,i.$fg)(D[A])?v(l[A],D[A],T):l[A]=D[A]):l[A]=D[A]}),l):D}function c(l,D){if(l===D)return!0;if(l==null||D===null||D===void 0||typeof l!=typeof D||typeof l!="object"||Array.isArray(l)!==Array.isArray(D))return!1;let T,A;if(Array.isArray(l)){if(l.length!==D.length)return!1;for(T=0;T<l.length;T++)if(!c(l[T],D[T]))return!1}else{const d=[];for(A in l)d.push(A);d.sort();const f=[];for(A in D)f.push(A);if(f.sort(),!c(d,f))return!1;for(T=0;T<d.length;T++)if(!c(l[d[T]],D[d[T]]))return!1}return!0}function p(l){const D=new Set;return JSON.stringify(l,(T,A)=>{if((0,i.$fg)(A)||Array.isArray(A)){if(D.has(A))return"[Circular]";D.add(A)}return typeof A=="bigint"?`[BigInt ${A.toString()}]`:A})}function y(l,D){const T=Object.create(null);return!l||!D||Object.keys(D).forEach(d=>{const f=l[d],m=D[d];c(f,m)||(T[d]=m)}),T}function $(l,D){const T=D.toLowerCase(),A=Object.keys(l).find(d=>d.toLowerCase()===T);return A?l[A]:l[D]}function g(l,D){const T=Object.create(null);for(const[A,d]of Object.entries(l))D(A,d)&&(T[A]=d);return T}function e(l){let D=[];for(;Object.prototype!==l;)D=D.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return D}function s(l){const D=[];for(const T of e(l))typeof l[T]=="function"&&D.push(T);return D}function r(l,D){const T=d=>function(){const f=Array.prototype.slice.call(arguments,0);return D(d,f)},A={};for(const d of l)A[d]=T(d);return A}function h(l,D){const T={};for(const[A,d]of Object.entries(l))T[A]=D(d,A);return T}}),define(we[22],De([1,0,21]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$4j=B;var n;(function(k){function w(v){return v&&typeof v=="object"&&typeof v.id=="string"}k.isThemeColor=w})(n||(t.ThemeColor=n={}));function B(k){return{id:k}}var N;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(l){const D=w.exec(l.id);if(!D)return v(i.$3j.error);const[,T,A]=D,d=["codicon","codicon-"+T];return A&&d.push("codicon-modifier-"+A.substring(1)),d}k.asClassNameArray=v;function c(l){return v(l).join(" ")}k.asClassName=c;function p(l){return"."+v(l).join(".")}k.asCSSSelector=p;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||n.isThemeColor(l.color))}k.isThemeIcon=y;const $=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function g(l){const D=$.exec(l);if(!D)return;const[,T]=D;return{id:T}}k.fromString=g;function e(l){return{id:l}}k.fromId=e;function s(l,D){let T=l.id;const A=T.lastIndexOf("~");return A!==-1&&(T=T.substring(0,A)),D&&(T=`${T}~${D}`),{id:T}}k.modify=s;function r(l){const D=l.id.lastIndexOf("~");if(D!==-1)return l.id.substring(D+1)}k.getModifier=r;function h(l,D){return l.id===D.id&&l.color?.id===D.color?.id}k.isEqual=h})(N||(t.ThemeIcon=N={}))}),define(we[65],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$_e=n,t.$af=B;var i;(function(N){N[N.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",N[N.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",N[N.MAX_UINT_8=255]="MAX_UINT_8",N[N.MAX_UINT_16=65535]="MAX_UINT_16",N[N.MAX_UINT_32=4294967295]="MAX_UINT_32",N[N.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(N){return N<0?0:N>i.MAX_UINT_8?i.MAX_UINT_8:N|0}function B(N){return N<0?0:N>i.MAX_UINT_32?i.MAX_UINT_32:N|0}}),define(we[11],De([1,0,103,17,25,65]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cg=t.$bg=t.$ag=t.GraphemeBreakType=t.$3f=t.$Uf=t.$Nf=t.$Mf=void 0,t.$bf=k,t.$cf=v,t.$df=p,t.$ef=y,t.$ff=$,t.$gf=g,t.$hf=e,t.$if=s,t.$jf=r,t.$kf=h,t.$lf=l,t.$mf=D,t.$nf=T,t.$of=A,t.$pf=d,t.$qf=f,t.$rf=m,t.$sf=S,t.$tf=H,t.$uf=U,t.$vf=C,t.$wf=E,t.$xf=R,t.$yf=x,t.$zf=I,t.$Af=_,t.$Bf=V,t.$Cf=J,t.$Df=q,t.$Ef=z,t.$Ff=Q,t.$Gf=ue,t.$Hf=be,t.$If=Ae,t.$Jf=Fe,t.$Kf=ne,t.$Lf=ee,t.$Of=te,t.$Pf=$e,t.$Qf=Te,t.$Rf=Oe,t.$Sf=oe,t.$Tf=j,t.$Vf=a,t.$Wf=o,t.$Xf=b,t.$Yf=M,t.$Zf=u,t.$1f=L,t.$2f=P,t.$4f=X,t.$5f=Y,t.$6f=ie,t.$7f=re,t.$8f=ce,t.$9f=Ee,t.$0f=ve,t.$$f=ye,t.$_f=Ge;function k(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const w=/{(\d+)}/g;function v(Z,...he){return he.length===0?Z:Z.replace(w,function(pe,ke){const Pe=parseInt(ke,10);return isNaN(Pe)||Pe<0||Pe>=he.length?pe:he[Pe]})}const c=/{([^}]+)}/g;function p(Z,he){return Object.keys(he).length===0?Z:Z.replace(c,(pe,ke)=>he[ke]??pe)}function y(Z){return Z.replace(/[<>"'&]/g,he=>{switch(he){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return he})}function $(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}function g(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(Z,he){let pe=0,ke=Z.indexOf(he);for(;ke!==-1;)pe++,ke=Z.indexOf(he,ke+he.length);return pe}function s(Z,he,pe="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${pe}`}function r(Z,he,pe="\u2026"){if(Z.length<=he)return Z;const ke=Math.ceil(he/2)-pe.length/2,Pe=Math.floor(he/2)-pe.length/2;return`${Z.substr(0,ke)}${pe}${Z.substr(Z.length-Pe)}`}function h(Z,he=" "){const pe=l(Z,he);return D(pe,he)}function l(Z,he){if(!Z||!he)return Z;const pe=he.length;if(pe===0||Z.length===0)return Z;let ke=0;for(;Z.indexOf(he,ke)===ke;)ke=ke+pe;return Z.substring(ke)}function D(Z,he){if(!Z||!he)return Z;const pe=he.length,ke=Z.length;if(pe===0||ke===0)return Z;let Pe=ke,xe=-1;for(;xe=Z.lastIndexOf(he,Pe-1),!(xe===-1||xe+pe!==Pe);){if(xe===0)return"";Pe=xe}return Z.substring(0,Pe)}function T(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function A(Z){return Z.replace(/\*/g,"")}function d(Z,he,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=g(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ke="";return pe.global&&(ke+="g"),pe.matchCase||(ke+="i"),pe.multiline&&(ke+="m"),pe.unicode&&(ke+="u"),new RegExp(Z,ke)}function f(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function m(Z){return Z.split(/\r\n|\r|\n/)}function S(Z){const he=[],pe=Z.split(/(\r\n|\r|\n)/);for(let ke=0;ke<Math.ceil(pe.length/2);ke++)he.push(pe[2*ke]+(pe[2*ke+1]??""));return he}function H(Z){for(let he=0,pe=Z.length;he<pe;he++){const ke=Z.charCodeAt(he);if(ke!==n.CharCode.Space&&ke!==n.CharCode.Tab)return he}return-1}function U(Z,he=0,pe=Z.length){for(let ke=he;ke<pe;ke++){const Pe=Z.charCodeAt(ke);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return Z.substring(he,ke)}return Z.substring(he,pe)}function C(Z,he=Z.length-1){for(let pe=he;pe>=0;pe--){const ke=Z.charCodeAt(pe);if(ke!==n.CharCode.Space&&ke!==n.CharCode.Tab)return pe}return-1}function E(Z,he,pe){const ke=[];let Pe=0;for(const xe of Z.matchAll(he)){if(ke.push(Z.slice(Pe,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Pe=xe.index+xe[0].length,ke.push(pe(xe[0],...xe.slice(1),xe.index,Z,xe.groups))}return ke.push(Z.slice(Pe)),Promise.all(ke).then(xe=>xe.join(""))}function R(Z,he){return Z<he?-1:Z>he?1:0}function x(Z,he,pe=0,ke=Z.length,Pe=0,xe=he.length){for(;pe<ke&&Pe<xe;pe++,Pe++){const it=Z.charCodeAt(pe),ct=he.charCodeAt(Pe);if(it<ct)return-1;if(it>ct)return 1}const Je=ke-pe,rt=xe-Pe;return Je<rt?-1:Je>rt?1:0}function I(Z,he){return _(Z,he,0,Z.length,0,he.length)}function _(Z,he,pe=0,ke=Z.length,Pe=0,xe=he.length){for(;pe<ke&&Pe<xe;pe++,Pe++){let it=Z.charCodeAt(pe),ct=he.charCodeAt(Pe);if(it===ct)continue;if(it>=128||ct>=128)return x(Z.toLowerCase(),he.toLowerCase(),pe,ke,Pe,xe);J(it)&&(it-=32),J(ct)&&(ct-=32);const nt=it-ct;if(nt!==0)return nt}const Je=ke-pe,rt=xe-Pe;return Je<rt?-1:Je>rt?1:0}function V(Z){return Z>=n.CharCode.Digit0&&Z<=n.CharCode.Digit9}function J(Z){return Z>=n.CharCode.a&&Z<=n.CharCode.z}function q(Z){return Z>=n.CharCode.A&&Z<=n.CharCode.Z}function z(Z,he){return Z.length===he.length&&_(Z,he)===0}function Q(Z,he){const pe=he.length;return he.length>Z.length?!1:_(Z,he,0,pe)===0}function ue(Z,he){const pe=Math.min(Z.length,he.length);let ke;for(ke=0;ke<pe;ke++)if(Z.charCodeAt(ke)!==he.charCodeAt(ke))return ke;return pe}function be(Z,he){const pe=Math.min(Z.length,he.length);let ke;const Pe=Z.length-1,xe=he.length-1;for(ke=0;ke<pe;ke++)if(Z.charCodeAt(Pe-ke)!==he.charCodeAt(xe-ke))return ke;return pe}function Ae(Z){return 55296<=Z&&Z<=56319}function Fe(Z){return 56320<=Z&&Z<=57343}function ne(Z,he){return(Z-55296<<10)+(he-56320)+65536}function ee(Z,he,pe){const ke=Z.charCodeAt(pe);if(Ae(ke)&&pe+1<he){const Pe=Z.charCodeAt(pe+1);if(Fe(Pe))return ne(ke,Pe)}return ke}function fe(Z,he){const pe=Z.charCodeAt(he-1);if(Fe(pe)&&he>1){const ke=Z.charCodeAt(he-2);if(Ae(ke))return ne(ke,pe)}return pe}class ae{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=fe(this.c,this.e);return this.e-=he>=N.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,he}nextCodePoint(){const he=ee(this.c,this.d,this.e);return this.e+=he>=N.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,he}eol(){return this.e>=this.d}}t.$Mf=ae;class Ne{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new ae(he,pe)}nextGraphemeLength(){const he=Ie.getInstance(),pe=this.c,ke=pe.offset;let Pe=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const xe=pe.offset,Je=he.getGraphemeBreakType(pe.nextCodePoint());if(Le(Pe,Je)){pe.setOffset(xe);break}Pe=Je}return pe.offset-ke}prevGraphemeLength(){const he=Ie.getInstance(),pe=this.c,ke=pe.offset;let Pe=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const xe=pe.offset,Je=he.getGraphemeBreakType(pe.prevCodePoint());if(Le(Je,Pe)){pe.setOffset(xe);break}Pe=Je}return ke-pe.offset}eol(){return this.c.eol()}}t.$Nf=Ne;function te(Z,he){return new Ne(Z,he).nextGraphemeLength()}function $e(Z,he){return new Ne(Z,he).prevGraphemeLength()}function Te(Z,he){he>0&&Fe(Z.charCodeAt(he))&&he--;const pe=he+te(Z,he);return[pe-$e(Z,pe),pe]}function Oe(Z){const he=new Ne(Z);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}let Re;function _e(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Z){return Re||(Re=_e()),Re.test(Z)}const K=/^[\t\n\r\x20-\x7E]*$/;function j(Z){return K.test(Z)}t.$Uf=/[\u2028\u2029]/;function a(Z){return t.$Uf.test(Z)}function o(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function b(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function M(Z,he,pe=""){const ke=Z.trimStart();if(ke.length<he)return ke;const Pe=/\b/g;let xe=0;for(;Pe.test(ke)&&!(ke.length-Pe.lastIndex<he);)xe=Pe.lastIndex,Pe.lastIndex+=1;return xe===0?ke:pe+ke.substring(xe).trimStart()}const F=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(Z){let he=0;for(const pe of Z.matchAll(F))he!==pe.index&&(yield{isCode:!1,str:Z.substring(he,pe.index)}),yield{isCode:!0,str:pe[0]},he=pe.index+pe[0].length;he!==Z.length&&(yield{isCode:!1,str:Z.substring(he)})}function L(Z){return Z&&(Z=Z.replace(F,"")),Z}const O=/\\\[.*?\\\]/g;function P(Z){return L(Z).replace(O,"")}t.$3f=String.fromCharCode(n.CharCode.UTF8_BOM);function X(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===n.CharCode.UTF8_BOM)}function Y(Z){return X(Z)?Z.substr(1):Z}function ie(Z,he){if(!Z||!he||Z.length<he.length)return!1;const pe=he.length,ke=Z.toLowerCase();let Pe=0,xe=-1;for(;Pe<pe;){const Je=ke.indexOf(he[Pe],xe+1);if(Je<0)return!1;xe=Je,Pe++}return!0}function re(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function ce(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function Ee(Z,he=1){if(he===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}function ve(Z){const he=n.CharCode.Z-n.CharCode.A+1;return Z=Z%(2*he),Z<he?String.fromCharCode(n.CharCode.a+Z):String.fromCharCode(n.CharCode.A+Z-he)}function ye(Z){return Ie.getInstance().getGraphemeBreakType(Z)}function Le(Z,he){return Z===de.Other?he!==de.Extend&&he!==de.SpacingMark:Z===de.CR&&he===de.LF?!1:Z===de.Control||Z===de.CR||Z===de.LF||he===de.Control||he===de.CR||he===de.LF?!0:!(Z===de.L&&(he===de.L||he===de.V||he===de.LV||he===de.LVT)||(Z===de.LV||Z===de.V)&&(he===de.V||he===de.T)||(Z===de.LVT||Z===de.T)&&he===de.T||he===de.Extend||he===de.ZWJ||he===de.SpacingMark||Z===de.Prepend||Z===de.ZWJ&&he===de.Extended_Pictographic||Z===de.Regional_Indicator&&he===de.Regional_Indicator)}var de;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(de||(t.GraphemeBreakType=de={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Ve()}getGraphemeBreakType(he){if(he<32)return he===n.CharCode.LineFeed?de.LF:he===n.CharCode.CarriageReturn?de.CR:de.Control;if(he<127)return de.Other;const pe=this.d,ke=pe.length/3;let Pe=1;for(;Pe<=ke;)if(he<pe[3*Pe])Pe=2*Pe;else if(he>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return de.Other}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(Z,he){if(Z===0)return 0;const pe=tt(Z,he);if(pe!==void 0)return pe;const ke=new ae(he,Z);return ke.prevCodePoint(),ke.offset}function tt(Z,he){const pe=new ae(he,Z);let ke=pe.prevCodePoint();for(;lt(ke)||ke===st.emojiVariantSelector||ke===st.enclosingKeyCap;){if(pe.offset===0)return;ke=pe.prevCodePoint()}if(!b(ke))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===st.zwj&&(Pe=pe.offset),Pe}function lt(Z){return 127995<=Z&&Z<=127999}var st;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),t.$ag="\xA0";class qe{static{this.c=new B.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$0e({getCacheKey:JSON.stringify},he=>{function pe(nt){const dt=new Map;for(let ft=0;ft<nt.length;ft+=2)dt.set(nt[ft],nt[ft+1]);return dt}function ke(nt,dt){const ft=new Map(nt);for(const[wt,Xe]of dt)ft.set(wt,Xe);return ft}function Pe(nt,dt){if(!nt)return dt;const ft=new Map;for(const[wt,Xe]of nt)dt.has(wt)&&ft.set(wt,Xe);return ft}const xe=this.c.value;let Je=he.filter(nt=>!nt.startsWith("_")&&nt in xe);Je.length===0&&(Je=["_default"]);let rt;for(const nt of Je){const dt=pe(xe[nt]);rt=Pe(rt,dt)}const it=pe(xe._common),ct=ke(it,rt);return new qe(ct)})}static getInstance(he){return qe.d.get(Array.from(he))}static{this.e=new B.$T(()=>Object.keys(qe.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return qe.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}containsAmbiguousCharacter(he){for(let pe=0;pe<he.length;pe++){const ke=he.codePointAt(pe);if(typeof ke=="number"&&this.isAmbiguous(ke))return!0}return!1}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$bg=qe;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(he){return Ze.e().has(he)}static containsInvisibleCharacter(he){for(let pe=0;pe<he.length;pe++){const ke=he.codePointAt(pe);if(typeof ke=="number"&&Ze.isInvisibleCharacter(ke))return!0}return!1}static get codePoints(){return Ze.e()}}t.$cg=Ze}),define(we[108],De([1,0,17,28,5,11,10]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vg=w,t.$wg=v,t.$xg=c,t.$yg=p,t.$zg=y,t.$Ag=s,t.$Bg=r,t.$Cg=h,t.$Dg=l,t.$Eg=D,t.$Fg=T,t.$Gg=A,t.$Hg=d,t.$Ig=f,t.$Jg=m,t.$Kg=S,t.$Lg=C;function w(E){return E===i.CharCode.Slash||E===i.CharCode.Backslash}function v(E){return E.replace(/[\\/]/g,n.$fc.sep)}function c(E){return E.indexOf("/")===-1&&(E=v(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function p(E,R=n.$fc.sep){if(!E)return"";const x=E.length,I=E.charCodeAt(0);if(w(I)){if(w(E.charCodeAt(1))&&!w(E.charCodeAt(2))){let V=3;const J=V;for(;V<x&&!w(E.charCodeAt(V));V++);if(J!==V&&!w(E.charCodeAt(V+1))){for(V+=1;V<x;V++)if(w(E.charCodeAt(V)))return E.slice(0,V+1).replace(/[\\/]/g,R)}}return R}else if(l(I)&&E.charCodeAt(1)===i.CharCode.Colon)return w(E.charCodeAt(2))?E.slice(0,2)+R:E.slice(0,2);let _=E.indexOf("://");if(_!==-1){for(_+=3;_<x;_++)if(w(E.charCodeAt(_)))return E.slice(0,_+1)}return""}function y(E){if(!B.$j||!E||E.length<5)return!1;let R=E.charCodeAt(0);if(R!==i.CharCode.Backslash||(R=E.charCodeAt(1),R!==i.CharCode.Backslash))return!1;let x=2;const I=x;for(;x<E.length&&(R=E.charCodeAt(x),R!==i.CharCode.Backslash);x++);return!(I===x||(R=E.charCodeAt(x+1),isNaN(R)||R===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,g=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(E,R=B.$j){const x=R?$:g;return!(!E||E.length===0||/^\s+$/.test(E)||(x.lastIndex=0,x.test(E))||R&&e.test(E)||E==="."||E===".."||R&&E[E.length-1]==="."||R&&E.length!==E.trim().length||E.length>255)}function r(E,R,x){const I=E===R;return!x||I?I:!E||!R?!1:(0,N.$Ef)(E,R)}function h(E,R,x,I=n.sep){if(E===R)return!0;if(!E||!R||R.length>E.length)return!1;if(x){if(!(0,N.$Ff)(E,R))return!1;if(R.length===E.length)return!0;let V=R.length;return R.charAt(R.length-1)===I&&V--,E.charAt(V)===I}return R.charAt(R.length-1)!==I&&(R+=I),E.indexOf(R)===0}function l(E){return E>=i.CharCode.A&&E<=i.CharCode.Z||E>=i.CharCode.a&&E<=i.CharCode.z}function D(E,R){return B.$j&&E.endsWith(":")&&(E+=n.sep),(0,n.$hc)(E)||(E=(0,n.$ic)(R,E)),E=(0,n.$gc)(E),T(E)}function T(E){return B.$j?(E=(0,N.$mf)(E,n.sep),E.endsWith(":")&&(E+=n.sep)):(E=(0,N.$mf)(E,n.sep),E||(E=n.sep)),E}function A(E){const R=(0,n.$gc)(E);return B.$j?E.length>3?!1:d(R)&&(E.length===2||R.charCodeAt(2)===i.CharCode.Backslash):R===n.$fc.sep}function d(E,R=B.$j){return R?l(E.charCodeAt(0))&&E.charCodeAt(1)===i.CharCode.Colon:!1}function f(E,R=B.$j){return d(E,R)?E[0]:void 0}function m(E,R,x){return R.length>E.length?-1:E===R?0:(x&&(E=E.toLowerCase(),R=R.toLowerCase()),E.indexOf(R))}function S(E){const R=E.split(":");let x,I,_;for(const V of R){const J=Number(V);(0,k.$hg)(J)?I===void 0?I=J:_===void 0&&(_=J):x=x?[x,V].join(":"):V}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:I!==void 0?I:void 0,column:_!==void 0?_:I!==void 0?1:void 0}}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",U="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(E,R,x=8){let I="";for(let V=0;V<x;V++){let J;V===0&&B.$j&&!R&&(x===3||x===4)?J=U:J=H,I+=J.charAt(Math.floor(Math.random()*J.length))}let _;return R?_=`${R}-${I}`:_=I,E?(0,n.$ic)(E,_):_}}),define(we[49],De([1,0,17,43,93,11]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rk=t.FuzzyScore=t.$Gk=t.$Fk=void 0,t.or=k,t.$Hk=v,t.$Ik=c,t.$Jk=$,t.$Kk=C,t.$Lk=E,t.$Mk=J,t.$Nk=q,t.$Ok=z,t.$Pk=Q,t.$Qk=_e,t.$Sk=a,t.$Tk=M,t.$Uk=F,N=He(N);function k(...O){return function(P,X){for(let Y=0,ie=O.length;Y<ie;Y++){const re=O[Y](P,X);if(re)return re}return null}}t.$Fk=w.bind(void 0,!1),t.$Gk=w.bind(void 0,!0);function w(O,P,X){if(!X||X.length<P.length)return null;let Y;return O?Y=N.$Ff(X,P):Y=X.indexOf(P)===0,Y?P.length>0?[{start:0,end:P.length}]:[]:null}function v(O,P){const X=P.toLowerCase().indexOf(O.toLowerCase());return X===-1?null:[{start:X,end:X+O.length}]}function c(O,P){return p(O.toLowerCase(),P.toLowerCase(),0,0)}function p(O,P,X,Y){if(X===O.length)return[];if(Y===P.length)return null;if(O[X]===P[Y]){let ie=null;return(ie=p(O,P,X+1,Y+1))?A({start:Y,end:Y+1},ie):null}return p(O,P,X,Y+1)}function y(O){return i.CharCode.a<=O&&O<=i.CharCode.z}function $(O){return i.CharCode.A<=O&&O<=i.CharCode.Z}function g(O){return i.CharCode.Digit0<=O&&O<=i.CharCode.Digit9}function e(O){return O===i.CharCode.Space||O===i.CharCode.Tab||O===i.CharCode.LineFeed||O===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(O=>s.add(O.charCodeAt(0)));function r(O){return e(O)||s.has(O)}function h(O,P){return O===P||r(O)&&r(P)}const l=new Map;function D(O){if(l.has(O))return l.get(O);let P;const X=(0,B.$Dk)(O);return X&&(P=X),l.set(O,P),P}function T(O){return y(O)||$(O)||g(O)}function A(O,P){return P.length===0?P=[O]:O.end===P[0].start?P[0].start=O.start:P.unshift(O),P}function d(O,P){for(let X=P;X<O.length;X++){const Y=O.charCodeAt(X);if($(Y)||g(Y)||X>0&&!T(O.charCodeAt(X-1)))return X}return O.length}function f(O,P,X,Y){if(X===O.length)return[];if(Y===P.length)return null;if(O[X]!==P[Y].toLowerCase())return null;{let ie=null,re=Y+1;for(ie=f(O,P,X+1,Y+1);!ie&&(re=d(P,re))<P.length;)ie=f(O,P,X+1,re),re++;return ie===null?null:A({start:Y,end:Y+1},ie)}}function m(O){let P=0,X=0,Y=0,ie=0,re=0;for(let Le=0;Le<O.length;Le++)re=O.charCodeAt(Le),$(re)&&P++,y(re)&&X++,T(re)&&Y++,g(re)&&ie++;const ce=P/O.length,Ee=X/O.length,ve=Y/O.length,ye=ie/O.length;return{upperPercent:ce,lowerPercent:Ee,alphaPercent:ve,numericPercent:ye}}function S(O){const{upperPercent:P,lowerPercent:X}=O;return X===0&&P>.6}function H(O){const{upperPercent:P,lowerPercent:X,alphaPercent:Y,numericPercent:ie}=O;return X>.2&&P<.8&&Y>.6&&ie<.2}function U(O){let P=0,X=0,Y=0,ie=0;for(let re=0;re<O.length;re++)Y=O.charCodeAt(re),$(Y)&&P++,y(Y)&&X++,e(Y)&&ie++;return(P===0||X===0)&&ie===0?O.length<=30:P<=5}function C(O,P){if(!P||(P=P.trim(),P.length===0)||!U(O))return null;P.length>60&&(P=P.substring(0,60));const X=m(P);if(!H(X)){if(!S(X))return null;P=P.toLowerCase()}let Y=null,ie=0;for(O=O.toLowerCase();ie<P.length&&(Y=f(O,P,0,ie))===null;)ie=d(P,ie+1);return Y}function E(O,P,X=!1){if(!P||P.length===0)return null;let Y=null,ie=0;for(O=O.toLowerCase(),P=P.toLowerCase();ie<P.length&&(Y=R(O,P,0,ie,X),Y===null);)ie=x(P,ie+1);return Y}function R(O,P,X,Y,ie){let re=0;if(X===O.length)return[];if(Y===P.length)return null;if(!h(O.charCodeAt(X),P.charCodeAt(Y))){const ve=D(O.charCodeAt(X));if(!ve)return null;for(let ye=0;ye<ve.length;ye++)if(!h(ve[ye],P.charCodeAt(Y+ye)))return null;re+=ve.length-1}let ce=null,Ee=Y+re+1;if(ce=R(O,P,X+1,Ee,ie),!ie)for(;!ce&&(Ee=x(P,Ee))<P.length;)ce=R(O,P,X+1,Ee,ie),Ee++;if(!ce)return null;if(O.charCodeAt(X)!==P.charCodeAt(Y)){const ve=D(O.charCodeAt(X));if(!ve)return ce;for(let ye=0;ye<ve.length;ye++)if(ve[ye]!==P.charCodeAt(Y+ye))return ce}return A({start:Y,end:Y+re+1},ce)}function x(O,P){for(let X=P;X<O.length;X++)if(r(O.charCodeAt(X))||X>0&&r(O.charCodeAt(X-1)))return X;return O.length}const I=k(t.$Gk,C,v),_=k(t.$Gk,C,c),V=new n.$Cc(1e4);function J(O,P,X=!1){if(typeof O!="string"||typeof P!="string")return null;let Y=V.get(O);Y||(Y=new RegExp(N.$nf(O),"i"),V.set(O,Y));const ie=Y.exec(P);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:X?_(O,P):I(O,P)}function q(O,P){const X=a(O,O.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?Q(X):null}function z(O,P,X,Y,ie,re){const ce=Math.min(13,O.length);for(;X<ce;X++){const Ee=a(O,P,X,Y,ie,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,re]}function Q(O){if(typeof O>"u")return[];const P=[],X=O[1];for(let Y=O.length-1;Y>1;Y--){const ie=O[Y]+X,re=P[P.length-1];re&&re.end===ie?re.end=ie+1:P.push({start:ie,end:ie+1})}return P}const ue=128;function be(){const O=[],P=[];for(let X=0;X<=ue;X++)P[X]=0;for(let X=0;X<=ue;X++)O.push(P.slice(0));return O}function Ae(O){const P=[];for(let X=0;X<=O;X++)P[X]=0;return P}const Fe=Ae(2*ue),ne=Ae(2*ue),ee=be(),fe=be(),ae=be(),Ne=!1;function te(O,P,X,Y,ie){function re(Ee,ve,ye=" "){for(;Ee.length<ve;)Ee=ye+Ee;return Ee}let ce=` |   |${Y.split("").map(Ee=>re(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=X;Ee++)Ee===0?ce+=" |":ce+=`${P[Ee-1]}|`,ce+=O[Ee].slice(0,ie+1).map(ve=>re(ve.toString(),3)).join("|")+`
`;return ce}function $e(O,P,X,Y){O=O.substr(P),X=X.substr(Y),console.log(te(fe,O,O.length,X,X.length)),console.log(te(ae,O,O.length,X,X.length)),console.log(te(ee,O,O.length,X,X.length))}function Te(O,P){if(P<0||P>=O.length)return!1;const X=O.codePointAt(P);switch(X){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$Xf(X)}}function Oe(O,P){if(P<0||P>=O.length)return!1;switch(O.charCodeAt(P)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Re(O,P,X){return P[O]!==X[O]}function _e(O,P,X,Y,ie,re,ce=!1){for(;P<X&&ie<re;)O[P]===Y[ie]&&(ce&&(Fe[P]=ie),P+=1),ie+=1;return P===X}var oe;(function(O){O[O.Diag=1]="Diag",O[O.Left=2]="Left",O[O.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var K;(function(O){O.Default=[-100,0];function P(X){return!X||X.length===2&&X[0]===-100&&X[1]===0}O.isDefault=P})(K||(t.FuzzyScore=K={}));class j{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,X){this.firstMatchCanBeWeak=P,this.boostFullMatch=X}}t.$Rk=j;function a(O,P,X,Y,ie,re,ce=j.default){const Ee=O.length>ue?ue:O.length,ve=Y.length>ue?ue:Y.length;if(X>=Ee||re>=ve||Ee-X>ve-re||!_e(P,X,Ee,ie,re,ve,!0))return;o(Ee,ve,X,re,P,ie);let ye=1,Le=1,de=X,Ie=re;const Ve=[!1];for(ye=1,de=X;de<Ee;ye++,de++){const qe=Fe[de],Ze=ne[de],Z=de+1<Ee?ne[de+1]:ve;for(Le=qe-re+1,Ie=qe;Ie<Z;Le++,Ie++){let he=Number.MIN_SAFE_INTEGER,pe=!1;Ie<=Ze&&(he=b(O,P,de,X,Y,ie,Ie,ve,re,ee[ye-1][Le-1]===0,Ve));let ke=0;he!==Number.MAX_SAFE_INTEGER&&(pe=!0,ke=he+fe[ye-1][Le-1]);const Pe=Ie>qe,xe=Pe?fe[ye][Le-1]+(ee[ye][Le-1]>0?-5:0):0,Je=Ie>qe+1&&ee[ye][Le-1]>0,rt=Je?fe[ye][Le-2]+(ee[ye][Le-2]>0?-5:0):0;if(Je&&(!Pe||rt>=xe)&&(!pe||rt>=ke))fe[ye][Le]=rt,ae[ye][Le]=oe.LeftLeft,ee[ye][Le]=0;else if(Pe&&(!pe||xe>=ke))fe[ye][Le]=xe,ae[ye][Le]=oe.Left,ee[ye][Le]=0;else if(pe)fe[ye][Le]=ke,ae[ye][Le]=oe.Diag,ee[ye][Le]=ee[ye-1][Le-1]+1;else throw new Error("not possible")}}if(Ne&&$e(O,X,Y,re),!Ve[0]&&!ce.firstMatchCanBeWeak)return;ye--,Le--;const Ge=[fe[ye][Le],re];let tt=0,lt=0;for(;ye>=1;){let qe=Le;do{const Ze=ae[ye][qe];if(Ze===oe.LeftLeft)qe=qe-2;else if(Ze===oe.Left)qe=qe-1;else break}while(qe>=1);tt>1&&P[X+ye-1]===ie[re+Le-1]&&!Re(qe+re-1,Y,ie)&&tt+1>ee[ye][qe]&&(qe=Le),qe===Le?tt++:tt=1,lt||(lt=qe),ye--,Le=qe-1,Ge.push(Le)}ve-re===Ee&&ce.boostFullMatch&&(Ge[0]+=2);const st=lt-Ee;return Ge[0]-=st,Ge}function o(O,P,X,Y,ie,re){let ce=O-1,Ee=P-1;for(;ce>=X&&Ee>=Y;)ie[ce]===re[Ee]&&(ne[ce]=Ee,ce--),Ee--}function b(O,P,X,Y,ie,re,ce,Ee,ve,ye,Le){if(P[X]!==re[ce])return Number.MIN_SAFE_INTEGER;let de=1,Ie=!1;return ce===X-Y?de=O[X]===ie[ce]?7:5:Re(ce,ie,re)&&(ce===0||!Re(ce-1,ie,re))?(de=O[X]===ie[ce]?7:5,Ie=!0):Te(re,ce)&&(ce===0||!Te(re,ce-1))?de=5:(Te(re,ce-1)||Oe(re,ce-1))&&(de=5,Ie=!0),de>1&&X===Y&&(Le[0]=!0),Ie||(Ie=Re(ce,ie,re)||Te(re,ce-1)||Oe(re,ce-1)),X===Y?ce>ve&&(de-=Ie?3:5):ye?de+=Ie?2:0:de+=Ie?0:1,ce+1===Ee&&(de-=Ie?3:5),de}function M(O,P,X,Y,ie,re,ce){return u(O,P,X,Y,ie,re,!0,ce)}function F(O,P,X,Y,ie,re,ce){return u(O,P,X,Y,ie,re,!1,ce)}function u(O,P,X,Y,ie,re,ce,Ee){let ve=a(O,P,X,Y,ie,re,Ee);if(ve&&!ce)return ve;if(O.length>=3){const ye=Math.min(7,O.length-1);for(let Le=X+1;Le<ye;Le++){const de=L(O,Le);if(de){const Ie=a(de,de.toLowerCase(),X,Y,ie,re,Ee);Ie&&(Ie[0]-=3,(!ve||Ie[0]>ve[0])&&(ve=Ie))}}}return ve}function L(O,P){if(P+1>=O.length)return;const X=O[P],Y=O[P+1];if(X!==Y)return O.slice(0,P)+Y+X+O.slice(P+2)}}),define(we[66],De([1,0,11]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xj=t.$vj=void 0,t.$rj=n,t.$sj=B,t.$tj=N,t.$uj=w,t.$wj=s,i=He(i);function n(h){return B(h,0)}function B(h,l){switch(typeof h){case"object":return h===null?N(349,l):Array.isArray(h)?v(h,l):c(h,l);case"string":return w(h,l);case"boolean":return k(h,l);case"number":return N(h,l);case"undefined":return N(937,l);default:return N(617,l)}}function N(h,l){return(l<<5)-l+h|0}function k(h,l){return N(h?433:863,l)}function w(h,l){l=N(149417,l);for(let D=0,T=h.length;D<T;D++)l=N(h.charCodeAt(D),l);return l}function v(h,l){return l=N(104579,l),h.reduce((D,T)=>B(T,D),l)}function c(h,l){return l=N(181387,l),Object.keys(h).sort().reduce((D,T)=>(D=w(T,D),B(h[T],D)),l)}class p{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=B(l,this.g),this.g}}t.$vj=p;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(h,l,D=32){const T=D-l,A=~((1<<T)-1);return(h<<l|(A&h)>>>T)>>>0}function g(h,l=0,D=h.byteLength,T=0){for(let A=0;A<D;A++)h[l+A]=T}function e(h,l,D="0"){for(;h.length<l;)h=D+h;return h}function s(h,l=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),l/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const D=l.length;if(D===0)return;const T=this.p;let A=this.r,d=this.u,f,m;for(d!==0?(f=d,m=-1,d=0):(f=l.charCodeAt(0),m=0);;){let S=f;if(i.$If(f))if(m+1<D){const H=l.charCodeAt(m+1);i.$Jf(H)?(m++,S=i.$Kf(f,H)):S=y.UNICODE_REPLACEMENT}else{d=f;break}else i.$Jf(f)&&(S=y.UNICODE_REPLACEMENT);if(A=this.w(T,A,S),m++,m<D)f=l.charCodeAt(m);else break}this.r=A,this.u=d}w(l,D,T){return T<128?l[D++]=T:T<2048?(l[D++]=192|(T&1984)>>>6,l[D++]=128|(T&63)>>>0):T<65536?(l[D++]=224|(T&61440)>>>12,l[D++]=128|(T&4032)>>>6,l[D++]=128|(T&63)>>>0):(l[D++]=240|(T&1835008)>>>18,l[D++]=128|(T&258048)>>>12,l[D++]=128|(T&4032)>>>6,l[D++]=128|(T&63)>>>0),D>=y.BLOCK_SIZE&&(this.y(),D-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,l[0]=l[y.BLOCK_SIZE+0],l[1]=l[y.BLOCK_SIZE+1],l[2]=l[y.BLOCK_SIZE+2]),D}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=r.g,D=this.q;for(let C=0;C<64;C+=4)l.setUint32(C,D.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)l.setUint32(C,$(l.getUint32(C-12,!1)^l.getUint32(C-32,!1)^l.getUint32(C-56,!1)^l.getUint32(C-64,!1),1),!1);let T=this.h,A=this.l,d=this.m,f=this.n,m=this.o,S,H,U;for(let C=0;C<80;C++)C<20?(S=A&d|~A&f,H=1518500249):C<40?(S=A^d^f,H=1859775393):C<60?(S=A&d|A&f|d&f,H=2400959708):(S=A^d^f,H=3395469782),U=$(T,5)+S+m+H+l.getUint32(C*4,!1)&4294967295,m=f,f=d,d=$(A,30),A=T,T=U;this.h=this.h+T&4294967295,this.l=this.l+A&4294967295,this.m=this.m+d&4294967295,this.n=this.n+f&4294967295,this.o=this.o+m&4294967295}}t.$xj=r}),define(we[109],De([1,0,89,66,65]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$St=t.$Qt=void 0,t.$Rt=k;class N{constructor(g){this.a=g}getElements(){const g=this.a,e=new Int32Array(g.length);for(let s=0,r=g.length;s<r;s++)e[s]=g.charCodeAt(s);return e}}t.$Qt=N;function k($,g,e){return new y(new N($),new N(g)).ComputeDiff(e).changes}class w{static Assert(g,e){if(!g)throw new Error(e)}}class v{static Copy(g,e,s,r,h){for(let l=0;l<h;l++)s[r+l]=g[e+l]}static Copy2(g,e,s,r,h){for(let l=0;l<h;l++)s[r+l]=g[e+l]}}var c;(function($){$[$.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class p{constructor(){this.a=[],this.b=B.Constants.MAX_SAFE_SMALL_INTEGER,this.c=B.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Pt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=B.Constants.MAX_SAFE_SMALL_INTEGER,this.c=B.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(g,e){this.b=Math.min(this.b,g),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(g,e){this.b=Math.min(this.b,g),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(g,e,s=null){this.a=s,this.b=g,this.c=e;const[r,h,l]=y.o(g),[D,T,A]=y.o(e);this.d=l&&A,this.e=r,this.f=h,this.g=D,this.h=T,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const e=g.getElements();if(y.n(e)){const s=new Int32Array(e.length);for(let r=0,h=e.length;r<h;r++)s[r]=(0,n.$uj)(e[r],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(g,e){return this.f[g]!==this.h[e]?!1:this.d?this.e[g]===this.g[e]:!0}q(g,e){if(!this.p(g,e))return!1;const s=y.r(this.b,g),r=y.r(this.c,e);return s===r}static r(g,e){return typeof g.getStrictElement=="function"?g.getStrictElement(e):null}s(g,e){return this.f[g]!==this.f[e]?!1:this.d?this.e[g]===this.e[e]:!0}u(g,e){return this.h[g]!==this.h[e]?!1:this.d?this.g[g]===this.g[e]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,e,s,r,h){const l=[!1];let D=this.w(g,e,s,r,l);return h&&(D=this.z(D)),{quitEarly:l[0],changes:D}}w(g,e,s,r,h){for(h[0]=!1;g<=e&&s<=r&&this.p(g,s);)g++,s++;for(;e>=g&&r>=s&&this.p(e,r);)e--,r--;if(g>e||s>r){let f;return s<=r?(w.Assert(g===e+1,"originalStart should only be one more than originalEnd"),f=[new i.$Pt(g,0,s,r-s+1)]):g<=e?(w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),f=[new i.$Pt(g,e-g+1,s,0)]):(w.Assert(g===e+1,"originalStart should only be one more than originalEnd"),w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const l=[0],D=[0],T=this.y(g,e,s,r,l,D,h),A=l[0],d=D[0];if(T!==null)return T;if(!h[0]){const f=this.w(g,A,s,d,h);let m=[];return h[0]?m=[new i.$Pt(A+1,e-(A+1)+1,d+1,r-(d+1)+1)]:m=this.w(A+1,e,d+1,r,h),this.H(f,m)}return[new i.$Pt(g,e-g+1,s,r-s+1)]}x(g,e,s,r,h,l,D,T,A,d,f,m,S,H,U,C,E,R){let x=null,I=null,_=new p,V=e,J=s,q=S[0]-C[0]-r,z=B.Constants.MIN_SAFE_SMALL_INTEGER,Q=this.k.length-1;do{const ue=q+g;ue===V||ue<J&&A[ue-1]<A[ue+1]?(f=A[ue+1],H=f-q-r,f<z&&_.MarkNextChange(),z=f,_.AddModifiedElement(f+1,H),q=ue+1-g):(f=A[ue-1]+1,H=f-q-r,f<z&&_.MarkNextChange(),z=f-1,_.AddOriginalElement(f,H+1),q=ue-1-g),Q>=0&&(A=this.k[Q],g=A[0],V=1,J=A.length-1)}while(--Q>=-1);if(x=_.getReverseChanges(),R[0]){let ue=S[0]+1,be=C[0]+1;if(x!==null&&x.length>0){const Ae=x[x.length-1];ue=Math.max(ue,Ae.getOriginalEnd()),be=Math.max(be,Ae.getModifiedEnd())}I=[new i.$Pt(ue,m-ue+1,be,U-be+1)]}else{_=new p,V=l,J=D,q=S[0]-C[0]-T,z=B.Constants.MAX_SAFE_SMALL_INTEGER,Q=E?this.m.length-1:this.m.length-2;do{const ue=q+h;ue===V||ue<J&&d[ue-1]>=d[ue+1]?(f=d[ue+1]-1,H=f-q-T,f>z&&_.MarkNextChange(),z=f+1,_.AddOriginalElement(f+1,H+1),q=ue+1-h):(f=d[ue-1],H=f-q-T,f>z&&_.MarkNextChange(),z=f,_.AddModifiedElement(f+1,H+1),q=ue-1-h),Q>=0&&(d=this.m[Q],h=d[0],V=1,J=d.length-1)}while(--Q>=-1);I=_.getChanges()}return this.H(x,I)}y(g,e,s,r,h,l,D){let T=0,A=0,d=0,f=0,m=0,S=0;g--,s--,h[0]=0,l[0]=0,this.k=[],this.m=[];const H=e-g+(r-s),U=H+1,C=new Int32Array(U),E=new Int32Array(U),R=r-s,x=e-g,I=g-s,_=e-r,J=(x-R)%2===0;C[R]=g,E[x]=e,D[0]=!1;for(let q=1;q<=H/2+1;q++){let z=0,Q=0;d=this.J(R-q,q,R,U),f=this.J(R+q,q,R,U);for(let be=d;be<=f;be+=2){be===d||be<f&&C[be-1]<C[be+1]?T=C[be+1]:T=C[be-1]+1,A=T-(be-R)-I;const Ae=T;for(;T<e&&A<r&&this.p(T+1,A+1);)T++,A++;if(C[be]=T,T+A>z+Q&&(z=T,Q=A),!J&&Math.abs(be-x)<=q-1&&T>=E[be])return h[0]=T,l[0]=A,Ae<=E[be]&&c.MaxDifferencesHistory>0&&q<=c.MaxDifferencesHistory+1?this.x(R,d,f,I,x,m,S,_,C,E,T,e,h,A,r,l,J,D):null}const ue=(z-g+(Q-s)-q)/2;if(this.a!==null&&!this.a(z,ue))return D[0]=!0,h[0]=z,l[0]=Q,ue>0&&c.MaxDifferencesHistory>0&&q<=c.MaxDifferencesHistory+1?this.x(R,d,f,I,x,m,S,_,C,E,T,e,h,A,r,l,J,D):(g++,s++,[new i.$Pt(g,e-g+1,s,r-s+1)]);m=this.J(x-q,q,x,U),S=this.J(x+q,q,x,U);for(let be=m;be<=S;be+=2){be===m||be<S&&E[be-1]>=E[be+1]?T=E[be+1]-1:T=E[be-1],A=T-(be-x)-_;const Ae=T;for(;T>g&&A>s&&this.p(T,A);)T--,A--;if(E[be]=T,J&&Math.abs(be-R)<=q&&T<=C[be])return h[0]=T,l[0]=A,Ae>=C[be]&&c.MaxDifferencesHistory>0&&q<=c.MaxDifferencesHistory+1?this.x(R,d,f,I,x,m,S,_,C,E,T,e,h,A,r,l,J,D):null}if(q<=c.MaxDifferencesHistory){let be=new Int32Array(f-d+2);be[0]=R-d+1,v.Copy2(C,d,be,1,f-d+1),this.k.push(be),be=new Int32Array(S-m+2),be[0]=x-m+1,v.Copy2(E,m,be,1,S-m+1),this.m.push(be)}}return this.x(R,d,f,I,x,m,S,_,C,E,T,e,h,A,r,l,J,D)}z(g){for(let e=0;e<g.length;e++){const s=g[e],r=e<g.length-1?g[e+1].originalStart:this.f.length,h=e<g.length-1?g[e+1].modifiedStart:this.h.length,l=s.originalLength>0,D=s.modifiedLength>0;for(;s.originalStart+s.originalLength<r&&s.modifiedStart+s.modifiedLength<h&&(!l||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!D||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const A=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!A)break;s.originalStart++,s.modifiedStart++}const T=[null];if(e<g.length-1&&this.I(g[e],g[e+1],T)){g[e]=T[0],g.splice(e+1,1),e--;continue}}for(let e=g.length-1;e>=0;e--){const s=g[e];let r=0,h=0;if(e>0){const f=g[e-1];r=f.originalStart+f.originalLength,h=f.modifiedStart+f.modifiedLength}const l=s.originalLength>0,D=s.modifiedLength>0;let T=0,A=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let f=1;;f++){const m=s.originalStart-f,S=s.modifiedStart-f;if(m<r||S<h||l&&!this.s(m,m+s.originalLength)||D&&!this.u(S,S+s.modifiedLength))break;const U=(m===r&&S===h?5:0)+this.G(m,s.originalLength,S,s.modifiedLength);U>A&&(A=U,T=f)}s.originalStart-=T,s.modifiedStart-=T;const d=[null];if(e>0&&this.I(g[e-1],g[e],d)){g[e-1]=d[0],g.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=g.length;e<s;e++){const r=g[e-1],h=g[e],l=h.originalStart-r.originalStart-r.originalLength,D=r.originalStart,T=h.originalStart+h.originalLength,A=T-D,d=r.modifiedStart,f=h.modifiedStart+h.modifiedLength,m=f-d;if(l<5&&A<20&&m<20){const S=this.A(D,A,d,m,l);if(S){const[H,U]=S;(H!==r.originalStart+r.originalLength||U!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=H-r.originalStart,r.modifiedLength=U-r.modifiedStart,h.originalStart=H+l,h.modifiedStart=U+l,h.originalLength=T-h.originalStart,h.modifiedLength=f-h.modifiedStart)}}}return g}A(g,e,s,r,h){if(e<h||r<h)return null;const l=g+e-h+1,D=s+r-h+1;let T=0,A=0,d=0;for(let f=g;f<l;f++)for(let m=s;m<D;m++){const S=this.B(f,m,h);S>0&&S>T&&(T=S,A=f,d=m)}return T>0?[A,d]:null}B(g,e,s){let r=0;for(let h=0;h<s;h++){if(!this.p(g+h,e+h))return 0;r+=this.e[g+h].length}return r}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,e){if(this.C(g)||this.C(g-1))return!0;if(e>0){const s=g+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,e){if(this.E(g)||this.E(g-1))return!0;if(e>0){const s=g+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(g,e,s,r){const h=this.D(g,e)?1:0,l=this.F(s,r)?1:0;return h+l}H(g,e){const s=[];if(g.length===0||e.length===0)return e.length>0?e:g;if(this.I(g[g.length-1],e[0],s)){const r=new Array(g.length+e.length-1);return v.Copy(g,0,r,0,g.length-1),r[g.length-1]=s[0],v.Copy(e,1,r,g.length,e.length-1),r}else{const r=new Array(g.length+e.length);return v.Copy(g,0,r,0,g.length),v.Copy(e,0,r,g.length,e.length),r}}I(g,e,s){if(w.Assert(g.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),w.Assert(g.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=e.originalStart||g.modifiedStart+g.modifiedLength>=e.modifiedStart){const r=g.originalStart;let h=g.originalLength;const l=g.modifiedStart;let D=g.modifiedLength;return g.originalStart+g.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=e.modifiedStart&&(D=e.modifiedStart+e.modifiedLength-g.modifiedStart),s[0]=new i.$Pt(r,h,l,D),!0}else return s[0]=null,!1}J(g,e,s,r){if(g>=0&&g<r)return g;const h=s,l=r-s-1,D=e%2===0;if(g<0){const T=h%2===0;return D===T?0:1}else{const T=l%2===0;return D===T?r-1:r-2}}}t.$St=y}),define(we[67],De([1,0,49,11,22]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vk=v,t.$Wk=p,t.$Xk=$,t.$Yk=g,t.$Zk=s,t.$1k=r;const N="$(",k=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${k.source}`,"g");function v(h){return h.replace(w,(l,D)=>D?l:`\\${l}`)}const c=new RegExp(`\\\\${k.source}`,"g");function p(h){return h.replace(c,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function $(h){return h.indexOf(N)===-1?h:h.replace(y,(l,D,T,A)=>T?l:D||A||"")}function g(h){return h?h.replace(/\$\((.*?)\)/g,(l,D)=>` ${D} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let l="";const D=[];let T=0;for(;;){const A=e.lastIndex,d=e.exec(h),f=h.substring(A,d?.index);if(f.length>0){l+=f;for(let m=0;m<f.length;m++)D.push(T)}if(!d)break;T+=d[0].length}return{text:l,iconOffsets:D}}function r(h,l,D=!1){const{text:T,iconOffsets:A}=l;if(!A||A.length===0)return(0,i.$Mk)(h,T,D);const d=(0,n.$lf)(T," "),f=T.length-d.length,m=(0,i.$Mk)(h,d,D);if(m)for(const S of m){const H=A[S.start+f]+f;S.start+=H,S.end+=H}return m}}),define(we[110],De([1,0,9,17,11]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=void 0;class N{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),r=this.b.charCodeAt(this.c);return s-r}value(){return this.b[this.c]}}t.$Fi=N;class k{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,B.$yf)(e,this.b,0,e.length,this.c,this.d):(0,B.$Af)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Gi=k;class w{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const r=this.b.charCodeAt(s);if(!(r===n.CharCode.Slash||this.f&&r===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,B.$yf)(e,this.b,0,e.length,this.d,this.e):(0,B.$Af)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Hi=w;var v;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(v||(v={}));class c{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new w(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(v.Path)),this.g(e)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===v.Scheme)return(0,B.$zf)(e,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,B.$zf)(e,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(e);if(this.d[this.e]===v.Query)return(0,B.$xf)(e,this.c.query);if(this.d[this.e]===v.Fragment)return(0,B.$xf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}t.$Ii=c;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(y||(y={}));class ${static forUris(e=()=>!1,s=()=>!1){return new $(new c(e,s))}static forPaths(e=!1){return new $(new w(void 0,!e))}static forStrings(){return new $(new N)}static forConfigKeys(){return new $(new k)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const r=s.slice(0);(0,i.$Vb)(r);for(const h of r)this.set(h,e)}else{const r=e.slice(0);(0,i.$Vb)(r);for(const h of r)this.set(h[0],h[1])}}set(e,s){const r=this.b.reset(e);let h;this.c||(this.c=new p,this.c.segment=r.value());const l=[];for(h=this.c;;){const T=r.cmp(h.segment);if(T>0)h.left||(h.left=new p,h.left.segment=r.value()),l.push([y.Left,h]),h=h.left;else if(T<0)h.right||(h.right=new p,h.right.segment=r.value()),l.push([y.Right,h]),h=h.right;else if(r.hasNext())r.next(),h.mid||(h.mid=new p,h.mid.segment=r.value()),l.push([y.Mid,h]),h=h.mid;else break}const D=h.value;h.value=s,h.key=e;for(let T=l.length-1;T>=0;T--){const A=l[T][1];A.updateHeight();const d=A.balanceFactor();if(d<-1||d>1){const f=l[T][0],m=l[T+1][0];if(f===y.Right&&m===y.Right)l[T][1]=A.rotateLeft();else if(f===y.Left&&m===y.Left)l[T][1]=A.rotateRight();else if(f===y.Right&&m===y.Left)A.right=l[T+1][1]=l[T+1][1].rotateRight(),l[T][1]=A.rotateLeft();else if(f===y.Left&&m===y.Right)A.left=l[T+1][1]=l[T+1][1].rotateLeft(),l[T][1]=A.rotateRight();else throw new Error;if(T>0)switch(l[T-1][0]){case y.Left:l[T-1][1].left=l[T][1];break;case y.Right:l[T-1][1].right=l[T][1];break;case y.Mid:l[T-1][1].mid=l[T][1];break}else this.c=l[0][1]}}return D}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let r=this.c;for(;r;){const h=s.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const r=this.b.reset(e),h=[];let l=this.c;for(;l;){const D=r.cmp(l.segment);if(D>0)h.push([y.Left,l]),l=l.left;else if(D<0)h.push([y.Right,l]),l=l.right;else if(r.hasNext())r.next(),h.push([y.Mid,l]),l=l.mid;else break}if(l){if(s?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const D=this.f(l.right);if(D.key){const{key:T,value:A,segment:d}=D;this.e(D.key,!1),l.key=T,l.value=A,l.segment=d}}else{const D=l.left??l.right;if(h.length>0){const[T,A]=h[h.length-1];switch(T){case y.Left:A.left=D;break;case y.Mid:A.mid=D;break;case y.Right:A.right=D;break}}else this.c=D}for(let D=h.length-1;D>=0;D--){const T=h[D][1];T.updateHeight();const A=T.balanceFactor();if(A>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),h[D][1]=T.rotateLeft()):A<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),h[D][1]=T.rotateRight()),D>0)switch(h[D-1][0]){case y.Left:h[D-1][1].left=h[D][1];break;case y.Right:h[D-1][1].right=h[D][1];break;case y.Mid:h[D-1][1].mid=h[D][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let r=this.c,h;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),h=r.value||h,r=r.mid;else break}return r&&r.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const r=this.b.reset(e);let h=this.c;for(;h;){const l=r.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(r.hasNext())r.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Ji=$}),define(we[16],De([1,0,17,60,28,5]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$uc=r,t.$vc=d,B=He(B);const k=/^\w[\w\d+.-]*$/,w=/^\//,v=/^\/\//;function c(U,C){if(!U.scheme&&C)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${U.authority}", path: "${U.path}", query: "${U.query}", fragment: "${U.fragment}"}`);if(U.scheme&&!k.test(U.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(U.path){if(U.authority){if(!w.test(U.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(U.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(U,C){return!U&&!C?"file":U}function y(U,C){switch(U){case"https":case"http":case"file":C?C[0]!==g&&(C=g+C):C=g;break}return C}const $="",g="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(C){return C instanceof s?!0:C?typeof C.authority=="string"&&typeof C.fragment=="string"&&typeof C.path=="string"&&typeof C.query=="string"&&typeof C.scheme=="string"&&typeof C.fsPath=="string"&&typeof C.with=="function"&&typeof C.toString=="function":!1}constructor(C,E,R,x,I,_=!1){typeof C=="object"?(this.scheme=C.scheme||$,this.authority=C.authority||$,this.path=C.path||$,this.query=C.query||$,this.fragment=C.fragment||$):(this.scheme=p(C,_),this.authority=E||$,this.path=y(this.scheme,R||$),this.query=x||$,this.fragment=I||$,c(this,_))}get fsPath(){return d(this,!1)}with(C){if(!C)return this;let{scheme:E,authority:R,path:x,query:I,fragment:_}=C;return E===void 0?E=this.scheme:E===null&&(E=$),R===void 0?R=this.authority:R===null&&(R=$),x===void 0?x=this.path:x===null&&(x=$),I===void 0?I=this.query:I===null&&(I=$),_===void 0?_=this.fragment:_===null&&(_=$),E===this.scheme&&R===this.authority&&x===this.path&&I===this.query&&_===this.fragment?this:new l(E,R,x,I,_)}static parse(C,E=!1){const R=e.exec(C);return R?new l(R[2]||$,H(R[4]||$),H(R[5]||$),H(R[7]||$),H(R[9]||$),E):new l($,$,$,$,$)}static file(C){let E=$;if(N.$j&&(C=C.replace(/\\/g,g)),C[0]===g&&C[1]===g){const R=C.indexOf(g,2);R===-1?(E=C.substring(2),C=g):(E=C.substring(2,R),C=C.substring(R)||g)}return new l("file",E,C,$,$)}static from(C,E){return new l(C.scheme,C.authority,C.path,C.query,C.fragment,E)}static joinPath(C,...E){if(!C.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return N.$j&&C.scheme==="file"?R=s.file(B.$ec.join(d(C,!0),...E)).path:R=B.$fc.join(C.path,...E),C.with({path:R})}toString(C=!1){return f(this,C)}toJSON(){return this}static revive(C){if(C){if(C instanceof s)return C;{const E=new l(C);return E._formatted=C.external??null,E._fsPath=C._sep===h?C.fsPath??null:null,E}}else return C}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=s;function r(U){return!U||typeof U!="object"?!1:typeof U.scheme=="string"&&(typeof U.authority=="string"||typeof U.authority>"u")&&(typeof U.path=="string"||typeof U.path>"u")&&(typeof U.query=="string"||typeof U.query>"u")&&(typeof U.fragment=="string"||typeof U.fragment>"u")}const h=N.$j?1:void 0;class l extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(C=!1){return C?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const C={$mid:n.MarshalledId.Uri};return this._fsPath&&(C.fsPath=this._fsPath,C._sep=h),this._formatted&&(C.external=this._formatted),this.path&&(C.path=this.path),this.scheme&&(C.scheme=this.scheme),this.authority&&(C.authority=this.authority),this.query&&(C.query=this.query),this.fragment&&(C.fragment=this.fragment),C}}const D={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function T(U,C,E){let R,x=-1;for(let I=0;I<U.length;I++){const _=U.charCodeAt(I);if(_>=i.CharCode.a&&_<=i.CharCode.z||_>=i.CharCode.A&&_<=i.CharCode.Z||_>=i.CharCode.Digit0&&_<=i.CharCode.Digit9||_===i.CharCode.Dash||_===i.CharCode.Period||_===i.CharCode.Underline||_===i.CharCode.Tilde||C&&_===i.CharCode.Slash||E&&_===i.CharCode.OpenSquareBracket||E&&_===i.CharCode.CloseSquareBracket||E&&_===i.CharCode.Colon)x!==-1&&(R+=encodeURIComponent(U.substring(x,I)),x=-1),R!==void 0&&(R+=U.charAt(I));else{R===void 0&&(R=U.substr(0,I));const V=D[_];V!==void 0?(x!==-1&&(R+=encodeURIComponent(U.substring(x,I)),x=-1),R+=V):x===-1&&(x=I)}}return x!==-1&&(R+=encodeURIComponent(U.substring(x))),R!==void 0?R:U}function A(U){let C;for(let E=0;E<U.length;E++){const R=U.charCodeAt(E);R===i.CharCode.Hash||R===i.CharCode.QuestionMark?(C===void 0&&(C=U.substr(0,E)),C+=D[R]):C!==void 0&&(C+=U[E])}return C!==void 0?C:U}function d(U,C){let E;return U.authority&&U.path.length>1&&U.scheme==="file"?E=`//${U.authority}${U.path}`:U.path.charCodeAt(0)===i.CharCode.Slash&&(U.path.charCodeAt(1)>=i.CharCode.A&&U.path.charCodeAt(1)<=i.CharCode.Z||U.path.charCodeAt(1)>=i.CharCode.a&&U.path.charCodeAt(1)<=i.CharCode.z)&&U.path.charCodeAt(2)===i.CharCode.Colon?C?E=U.path.substr(1):E=U.path[1].toLowerCase()+U.path.substr(2):E=U.path,N.$j&&(E=E.replace(/\//g,"\\")),E}function f(U,C){const E=C?A:T;let R="",{scheme:x,authority:I,path:_,query:V,fragment:J}=U;if(x&&(R+=x,R+=":"),(I||x==="file")&&(R+=g,R+=g),I){let q=I.indexOf("@");if(q!==-1){const z=I.substr(0,q);I=I.substr(q+1),q=z.lastIndexOf(":"),q===-1?R+=E(z,!1,!1):(R+=E(z.substr(0,q),!1,!1),R+=":",R+=E(z.substr(q+1),!1,!0)),R+="@"}I=I.toLowerCase(),q=I.lastIndexOf(":"),q===-1?R+=E(I,!1,!0):(R+=E(I.substr(0,q),!1,!0),R+=I.substr(q))}if(_){if(_.length>=3&&_.charCodeAt(0)===i.CharCode.Slash&&_.charCodeAt(2)===i.CharCode.Colon){const q=_.charCodeAt(1);q>=i.CharCode.A&&q<=i.CharCode.Z&&(_=`/${String.fromCharCode(q+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===i.CharCode.Colon){const q=_.charCodeAt(0);q>=i.CharCode.A&&q<=i.CharCode.Z&&(_=`${String.fromCharCode(q+32)}:${_.substr(2)}`)}R+=E(_,!0,!1)}return V&&(R+="?",R+=E(V,!1,!1)),J&&(R+="#",R+=C?J:T(J,!1,!1)),R}function m(U){try{return decodeURIComponent(U)}catch{return U.length>3?U.substr(0,3)+m(U.substr(3)):U}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function H(U){return U.match(S)?U.replace(S,C=>m(C)):U}}),define(we[68],De([1,0,47,16,60]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$h=N,t.$_h=k,t.$ai=v;function N(c){return JSON.stringify(c,w)}function k(c){let p=JSON.parse(c);return p=v(p),p}function w(c,p){return p instanceof RegExp?{$mid:B.MarshalledId.Regexp,source:p.source,flags:p.flags}:p}function v(c,p=0){if(!c||p>200)return c;if(typeof c=="object"){switch(c.$mid){case B.MarshalledId.Uri:return n.URI.revive(c);case B.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case B.MarshalledId.Date:return new Date(c.source)}if(c instanceof i.$Me||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=v(c[y],p+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=v(c[y],p+1))}return c}}),define(we[39],De([1,0,6,5,11,16,28]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Qg=t.$Pg=t.$Og=t.Schemas=void 0,t.$Mg=v,t.$Ng=c,t.$Rg=y,i=He(i),n=He(n),k=He(k);var w;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(w||(t.Schemas=w={}));function v(e,s){return N.URI.isUri(e)?(0,B.$Ef)(e.scheme,s):(0,B.$Ff)(e,s+":")}function c(e,...s){return s.some(r=>v(e,r))}t.$Og="vscode-tkn",t.$Pg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=y(s,r)}getServerRootPath(){return this.f}get g(){return k.$fc.join(this.f,w.vscodeRemoteResource)}set(s,r,h){this.a[s]=r,this.b[s]=h}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(A){return i.$Y(A),s}const r=s.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const l=this.b[r],D=this.c[r];let T=`path=${encodeURIComponent(s.path)}`;return typeof D=="string"&&(T+=`&${t.$Pg}=${encodeURIComponent(D)}`),N.URI.from({scheme:n.$p?this.d:w.vscodeRemoteResource,authority:`${h}:${l}`,path:this.g,query:T})}}t.$Qg=new p;function y(e,s){return k.$fc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Sg="vs/../../extensions",t.$Tg="vs/../../node_modules",t.$Ug="vs/../../node_modules.asar",t.$Vg="vs/../../node_modules.asar.unpacked",t.$Wg="vscode-app";class ${static{this.a=t.$Wg}asBrowserUri(s){const r=this.b(s,le);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===w.vscodeRemote?t.$Qg.rewrite(s):s.scheme===w.file&&(n.$n||n.$r===`${w.vscodeFileResource}://${$.a}`)?s.with({scheme:w.vscodeFileResource,authority:s.authority||$.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,le);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===w.vscodeFileResource?s.with({scheme:w.file,authority:s.authority!==$.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return N.URI.isUri(s)?s:N.URI.parse(r.toUrl(s))}}t.$Xg=new $;var g;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function h(D){let T;typeof D=="string"?T=new URL(D).searchParams:D instanceof URL?T=D.searchParams:N.URI.isUri(D)&&(T=new URL(D.toString(!0)).searchParams);const A=T?.get(r);if(A)return s.get(A)}e.getHeadersFromQuery=h;function l(D,T,A){if(!globalThis.crossOriginIsolated)return;const d=T&&A?"3":A?"2":"1";D instanceof URLSearchParams?D.set(r,d):D[r]=d}e.addSearchParam=l})(g||(t.COI=g={}))}),define(we[50],De([1,0,17,108,39,28,5,11,16]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=void 0,t.$5g=c,t.$nh=y,t.$oh=g,n=He(n),N=He(N);function c(e){return(0,v.$vc)(e,!0)}class p{constructor(s){this.a=s}compare(s,r,h=!1){return s===r?0:(0,w.$xf)(this.getComparisonKey(s,h),this.getComparisonKey(r,h))}isEqual(s,r,h=!1){return s===r?!0:!s||!r?!1:this.getComparisonKey(s,h)===this.getComparisonKey(r,h)}getComparisonKey(s,r=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,r,h=!1){if(s.scheme===r.scheme){if(s.scheme===B.Schemas.file)return n.$Cg(c(s),c(r),this.a(s))&&s.query===r.query&&(h||s.fragment===r.fragment);if((0,t.$jh)(s.authority,r.authority))return n.$Cg(s.path,r.path,this.a(s),"/")&&s.query===r.query&&(h||s.fragment===r.fragment)}return!1}joinPath(s,...r){return v.URI.joinPath(s,...r)}basenameOrAuthority(s){return(0,t.$bh)(s)||s.authority}basename(s){return N.$fc.basename(s.path)}extname(s){return N.$fc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let r;return s.scheme===B.Schemas.file?r=v.URI.file(N.$lc(c(s))).path:(r=N.$fc.dirname(s.path),s.authority&&r.length&&r.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),r="/")),s.with({path:r})}normalizePath(s){if(!s.path.length)return s;let r;return s.scheme===B.Schemas.file?r=v.URI.file(N.$gc(c(s))).path:r=N.$fc.normalize(s.path),s.with({path:r})}relativePath(s,r){if(s.scheme!==r.scheme||!(0,t.$jh)(s.authority,r.authority))return;if(s.scheme===B.Schemas.file){const D=N.$kc(c(s),c(r));return k.$j?n.$wg(D):D}let h=s.path||"/";const l=r.path||"/";if(this.a(s)){let D=0;for(const T=Math.min(h.length,l.length);D<T&&!(h.charCodeAt(D)!==l.charCodeAt(D)&&h.charAt(D).toLowerCase()!==l.charAt(D).toLowerCase());D++);h=l.substr(0,D)+h.substr(D)}return N.$fc.relative(h,l)}resolvePath(s,r){if(s.scheme===B.Schemas.file){const h=v.URI.file(N.$jc(c(s),r));return s.with({authority:h.authority,path:h.path})}return r=n.$xg(r),s.with({path:N.$fc.resolve(s.path,r)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,r){return s===r||s!==void 0&&r!==void 0&&(0,w.$Ef)(s,r)}hasTrailingPathSeparator(s,r=N.sep){if(s.scheme===B.Schemas.file){const h=c(s);return h.length>n.$yg(h).length&&h[h.length-1]===r}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,r=N.sep){return(0,t.$kh)(s,r)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,r=N.sep){let h=!1;if(s.scheme===B.Schemas.file){const l=c(s);h=l!==void 0&&l.length===n.$yg(l).length&&l[l.length-1]===r}else{r="/";const l=s.path;h=l.length===1&&l.charCodeAt(l.length-1)===i.CharCode.Slash}return!h&&!(0,t.$kh)(s,r)?s.with({path:s.path+"/"}):s}}t.$6g=p,t.$7g=new p(()=>!1),t.$8g=new p(e=>e.scheme===B.Schemas.file?!k.$l:!0),t.$9g=new p(e=>!0),t.$0g=t.$7g.isEqual.bind(t.$7g),t.$$g=t.$7g.isEqualOrParent.bind(t.$7g),t.$_g=t.$7g.getComparisonKey.bind(t.$7g),t.$ah=t.$7g.basenameOrAuthority.bind(t.$7g),t.$bh=t.$7g.basename.bind(t.$7g),t.$ch=t.$7g.extname.bind(t.$7g),t.$dh=t.$7g.dirname.bind(t.$7g),t.$eh=t.$7g.joinPath.bind(t.$7g),t.$fh=t.$7g.normalizePath.bind(t.$7g),t.$gh=t.$7g.relativePath.bind(t.$7g),t.$hh=t.$7g.resolvePath.bind(t.$7g),t.$ih=t.$7g.isAbsolutePath.bind(t.$7g),t.$jh=t.$7g.isEqualAuthority.bind(t.$7g),t.$kh=t.$7g.hasTrailingPathSeparator.bind(t.$7g),t.$lh=t.$7g.removeTrailingPathSeparator.bind(t.$7g),t.$mh=t.$7g.addTrailingPathSeparator.bind(t.$7g);function y(e,s){const r=[];for(let h=0;h<e.length;h++){const l=s(e[h]);e.some((D,T)=>T===h?!1:(0,t.$$g)(l,s(D)))||r.push(e[h])}return r}var $;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(r){const h=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(T=>{const[A,d]=T.split(":");A&&d&&h.set(A,d)});const D=r.path.substring(0,r.path.indexOf(";"));return D&&h.set(e.META_DATA_MIME,D),h}e.parseMetaData=s})($||(t.DataUri=$={}));function g(e,s,r){if(s){let h=e.path;return h&&h[0]!==N.$fc.sep&&(h=N.$fc.sep+h),e.with({scheme:r,authority:s,path:h})}return e.with({scheme:r})}}),define(we[12],De([1,0,38,6,3,2,50,5,63,25]),function(le,t,i,n,B,N,k,w,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=t.$5h=t.$4h=t.$3h=t.$2h=t.Promises=t.$1h=t.$Zh=t.$Yh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=void 0,t.$ph=p,t.$qh=y,t.$rh=$,t.$sh=g,t.$th=e,t.$uh=s,t.$vh=r,t.$wh=h,t.$Eh=U,t.$Fh=C,t.$Gh=E,t.$Hh=R,t.$Ih=x,t.$Xh=ee,t.$6h=K;function p(a){return!!a&&typeof a.then=="function"}function y(a){const o=new i.$ve,b=a(o.token),M=new Promise((F,u)=>{const L=o.token.onCancellationRequested(()=>{L.dispose(),u(new n.$4)});Promise.resolve(b).then(O=>{L.dispose(),o.dispose(),F(O)},O=>{L.dispose(),o.dispose(),u(O)})});return new class{cancel(){o.cancel(),o.dispose()}then(F,u){return M.then(F,u)}catch(F){return this.then(void 0,F)}finally(F){return M.finally(F)}}}function $(a,o,b){return new Promise((M,F)=>{const u=o.onCancellationRequested(()=>{u.dispose(),M(b)});a.then(M,F).finally(()=>u.dispose())})}function g(a,o){return new Promise((b,M)=>{const F=o.onCancellationRequested(()=>{F.dispose(),M(new n.$4)});a.then(b,M).finally(()=>F.dispose())})}async function e(a){let o=-1;const b=a.map((M,F)=>M.then(u=>(o=F,u)));try{return await Promise.race(b)}finally{a.forEach((M,F)=>{F!==o&&M.cancel()})}}function s(a,o,b){let M;const F=setTimeout(()=>{M?.(void 0),b?.()},o);return Promise.race([a.finally(()=>clearTimeout(F)),new Promise(u=>M=u)])}function r(a){return new Promise((o,b)=>{const M=a();p(M)?M.then(o,b):o(M)})}function h(){let a,o;return{promise:new Promise((M,F)=>{a=M,o=F}),resolve:a,reject:o}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const b=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(b,b).then(M)})}return new Promise((b,M)=>{this.b.then(b,M)})}return this.a=o(),new Promise((b,M)=>{this.a.then(F=>{this.a=null,b(F)},F=>{this.a=null,M(F)})})}dispose(){this.f=!0}}t.$xh=l;class D{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}t.$yh=D;class T{constructor(){this.a=new Map}queue(o,b){const F=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(b).finally(()=>{this.a.get(o)===F&&this.a.delete(o)});return this.a.set(o,F),F}}t.$zh=T;const A=(a,o)=>{let b=!0;const M=setTimeout(()=>{b=!1,o()},a);return{isTriggered:()=>b,dispose:()=>{clearTimeout(M),b=!1}}},d=a=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,a())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class f{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,b=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((F,u)=>{this.d=F,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=b===v.$fe?d(M):A(b,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Ah=f;class m{constructor(o){this.a=new f(o),this.b=new l}trigger(o,b){return this.a.trigger(()=>this.b.queue(o),b)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Bh=m;class S{constructor(){this.a=!1,this.b=new Promise((o,b)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Ch=S;class H extends S{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}t.$Dh=H;function U(a,o){return o?new Promise((b,M)=>{const F=setTimeout(()=>{u.dispose(),b()},a),u=o.onCancellationRequested(()=>{clearTimeout(F),u.dispose(),M(new n.$4)})}):y(b=>U(a,b))}function C(a,o=0,b){const M=setTimeout(()=>{a(),b&&F.dispose()},o),F=(0,N.$Rc)(()=>{clearTimeout(M),b?.deleteAndLeak(F)});return b?.add(F),F}function E(a){const o=[];let b=0;const M=a.length;function F(){return b<M?a[b++]():null}function u(L){L!=null&&o.push(L);const O=F();return O?O.then(u):Promise.resolve(o)}return Promise.resolve(null).then(u)}function R(a,o=M=>!!M,b=null){let M=0;const F=a.length,u=()=>{if(M>=F)return Promise.resolve(b);const L=a[M++];return Promise.resolve(L()).then(P=>o(P)?Promise.resolve(P):u())};return u()}function x(a,o=M=>!!M,b=null){if(a.length===0)return Promise.resolve(b);let M=a.length;const F=()=>{M=-1;for(const u of a)u.cancel?.()};return new Promise((u,L)=>{for(const O of a)O.then(P=>{--M>=0&&o(P)?(F(),u(P)):M===0&&u(b)}).catch(P=>{--M>=0&&(F(),L(P))})})}class I{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new B.$ke}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((b,M)=>{this.g.push({factory:o,c:b,e:M}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const b=o.factory();b.then(o.c,o.e),b.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Jh=I;class _ extends I{constructor(){super(1)}}t.$Kh=_;class V{constructor(){this.a=new fe,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}t.$Lh=V;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new te;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,b=k.$7g){const M=b.getComparisonKey(o);return this.a.get(M)?.size??0}queueFor(o,b,M=k.$7g){const F=M.getComparisonKey(o);let u=this.a.get(F);if(!u){u=new _;const L=this.f++,O=B.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(L),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(L,O),this.a.set(F,u)}return u.queue(b)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Mh=J;class q{constructor(o,b){this.b=!1,this.a=-1,typeof o=="function"&&typeof b=="number"&&this.setIfNotSet(o,b)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,b){if(this.b)throw new n.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},b)}setIfNotSet(o,b){if(this.b)throw new n.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},b))}}t.$Nh=q;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,b,M=globalThis){if(this.f)throw new n.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const F=M.setInterval(()=>{o()},b);this.d=(0,N.$Rc)(()=>{M.clearInterval(F),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Oh=z;class Q{constructor(o,b){this.b=-1,this.a=o,this.d=b,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Ph=Q;class ue{constructor(o,b){b%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${b}ms is not a multiple of 1000ms.`),this.a=o,this.b=b,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Qh=ue;class be extends Q{constructor(o,b){super(o,b),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}t.$Rh=be;class Ae extends N.$Tc{constructor(o,b){super(),this.g=o,this.h=b,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const b of o)this.a.push(b);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Sh=Ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Uh=(a,o)=>{(0,w.$C)(()=>{if(b)return;const M=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let b=!1;return{dispose(){b||(b=!0)}}}:t.$Uh=(a,o,b)=>{const M=a.requestIdleCallback(o,typeof b=="number"?{timeout:b}:void 0);let F=!1;return{dispose(){F||(F=!0,a.cancelIdleCallback(M))}}},t.$Th=a=>(0,t.$Uh)(globalThis,a)}();class Fe{constructor(o,b){this.g=!1,this.d=()=>{try{this.j=b()}catch(M){this.l=M}finally{this.g=!0}},this.f=(0,t.$Uh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Vh=Fe;class ne extends Fe{constructor(o){super(globalThis,o)}}t.$Wh=ne;async function ee(a,o,b){let M;for(let F=0;F<b;F++)try{return await a()}catch(u){M=u,await U(o)}throw M}class fe{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,b,M){return this.a={taskId:o,cancel:()=>M?.(),promise:b},b.then(()=>this.d(o),()=>this.d(o)),b}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:b,resolve:M,reject:F}=h();this.b={run:o,promise:b,promiseResolve:M,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Yh=fe;class ae{constructor(o,b=()=>Date.now()){this.d=o,this.f=b,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}t.$Zh=ae;var Ne;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(Ne||(Ne={}));class te{get isRejected(){return this.d?.outcome===Ne.Rejected}get isResolved(){return this.d?.outcome===Ne.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Ne.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((o,b)=>{this.a=o,this.b=b})}complete(o){return new Promise(b=>{this.a(o),this.d={outcome:Ne.Resolved,value:o},b()})}error(o){return new Promise(b=>{this.b(o),this.d={outcome:Ne.Rejected,value:o},b()})}cancel(){return this.error(new n.$4)}}t.$1h=te;var $e;(function(a){async function o(M){let F;const u=await Promise.all(M.map(L=>L.then(O=>O,O=>{F||(F=O)})));if(typeof F<"u")throw F;return u}a.settled=o;function b(M){return new Promise(async(F,u)=>{try{await M(F,u)}catch(L){u(L)}})}a.withAsyncBody=b})($e||(t.Promises=$e={}));class Te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(b=>(this.a=b,this.d=!0,b),b=>{throw this.b=b,this.d=!0,b})}requireValue(){if(!this.d)throw new n.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$2h=Te;class Oe{constructor(o){this.b=o,this.a=new c.$T(()=>new Te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$3h=Oe;var Re;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Re||(Re={}));class _e{static fromArray(o){return new _e(b=>{b.emitMany(o)})}static fromPromise(o){return new _e(async b=>{b.emitMany(await o)})}static fromPromises(o){return new _e(async b=>{await Promise.all(o.map(async M=>b.emitOne(await M)))})}static merge(o){return new _e(async b=>{await Promise.all(o.map(async M=>{for await(const F of M)b.emitOne(F)}))})}static{this.EMPTY=_e.fromArray([])}constructor(o,b){this.a=Re.Initial,this.b=[],this.d=null,this.f=b,this.g=new B.$ke,queueMicrotask(async()=>{const M={emitOne:F=>this.h(F),emitMany:F=>this.j(F),reject:F=>this.l(F)};try{await Promise.resolve(o(M)),this.k()}catch(F){this.l(F)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===Re.DoneError)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===Re.DoneOK)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(o,b){return new _e(async M=>{for await(const F of o)M.emitOne(b(F))})}map(o){return _e.map(this,o)}static filter(o,b){return new _e(async M=>{for await(const F of o)b(F)&&M.emitOne(F)})}filter(o){return _e.filter(this,o)}static coalesce(o){return _e.filter(o,b=>!!b)}coalesce(){return _e.coalesce(this)}static async toPromise(o){const b=[];for await(const M of o)b.push(M);return b}toPromise(){return _e.toPromise(this)}h(o){this.a===Re.Initial&&(this.b.push(o),this.g.fire())}j(o){this.a===Re.Initial&&(this.b=this.b.concat(o),this.g.fire())}k(){this.a===Re.Initial&&(this.a=Re.DoneOK,this.g.fire())}l(o){this.a===Re.Initial&&(this.a=Re.DoneError,this.d=o,this.g.fire())}}t.$4h=_e;class oe extends _e{constructor(o,b){super(b),this.m=o}cancel(){this.m.cancel()}}t.$5h=oe;function K(a){const o=new i.$ve,b=a(o.token);return new oe(o,async M=>{const F=o.token.onCancellationRequested(()=>{F.dispose(),o.dispose(),M.reject(new n.$4)});try{for await(const u of b){if(o.token.isCancellationRequested)return;M.emitOne(u)}F.dispose(),o.dispose()}catch(u){F.dispose(),o.dispose(),M.reject(u)}})}class j{constructor(o){this.a=new te,this.b=new _e(F=>{if(b){F.reject(b);return}return M&&F.emitMany(M),this.d=u=>F.reject(u),this.f=u=>F.emitOne(u),this.a.p},o);let b,M;this.f=F=>{M||(M=[]),M.push(F)},this.d=F=>{b||(b=F)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}t.$7h=j}),define(we[4],De([1,0,18,61,15,19,12,6,3,111,8,2,39,5,16,66,24,37]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$dU=t.$$T=t.$9T=t.$6T=t.DetectedFullscreenMode=t.Namespace=t.$DT=t.$BT=t.$kT=t.$SS=t.$MS=t.$KS=t.$JS=t.$IS=t.$DS=t.$CS=t.$BS=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$zS=D,t.$AS=A,t.$ES=U,t.$FS=C,t.$GS=E,t.$HS=R,t.$LS=I,t.$NS=J,t.$OS=q,t.$PS=be,t.$QS=Ae,t.$RS=Fe,t.$TS=fe,t.$US=ae,t.$VS=Ne,t.$WS=te,t.$XS=$e,t.$YS=Te,t.$ZS=Oe,t.$1S=Re,t.$2S=_e,t.$3S=oe,t.$4S=j,t.$5S=a,t.$6S=b,t.$7S=F,t.$8S=u,t.$9S=L,t.$0S=O,t.$$S=P,t.$_S=X,t.$aT=Y,t.$bT=ie,t.$cT=re,t.$dT=ce,t.$eT=Ee,t.$fT=ve,t.$gT=Le,t.$hT=de,t.$iT=Ve,t.$jT=Ge,t.$lT=lt,t.$mT=st,t.$nT=pe,t.$oT=ke,t.$pT=xe,t.$qT=Je,t.$rT=rt,t.$sT=it,t.$tT=ct,t.$uT=nt,t.$vT=dt,t.$wT=ft,t.$xT=wt,t.$yT=Xe,t.$zT=ge,t.$AT=Me,t.$CT=je,t.$ET=Ye,t.$FT=ot,t.$GT=Qe,t.$HT=bt,t.$IT=Et,t.$JT=Rt,t.$KT=Jt,t.$=ei,t.$MT=Mi,t.$NT=Bi,t.$OT=ti,t.$PT=ii,t.$QT=ji,t.$RT=Ci,t.$ST=_i,t.$TT=Ui,t.$UT=Xi,t.$VT=Hi,t.$WT=xi,t.$XT=Wi,t.$YT=zi,t.$ZT=Vi,t.$1T=ri,t.$2T=Ki,t.$3T=qi,t.$4T=Gi,t.$5T=oi,t.$7T=Ji,t.$8T=en,t.$0T=tn,t.h=sn,t.$aU=rn,t.$bU=ai,t.$cU=ln,i=He(i),v=He(v),c=He(c),g=He(g),l=function(){const W=new Map;(0,r.$5R)(r.$6R,1);const G={window:r.$6R,disposables:new y.$Sc};W.set(r.$6R.vscodeWindowId,G);const se=new v.$ke,me=new v.$ke,Se=new v.$ke;function Ce(Be,ze){return(typeof Be=="number"?W.get(Be):void 0)??(ze?G:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:me.event,registerWindow(Be){if(W.has(Be.vscodeWindowId))return y.$Tc.None;const ze=new y.$Sc,We={window:Be,disposables:ze.add(new y.$Sc)};return W.set(Be.vscodeWindowId,We),ze.add((0,y.$Rc)(()=>{W.delete(Be.vscodeWindowId),me.fire(Be)})),ze.add(A(Be,t.$BT.BEFORE_UNLOAD,()=>{Se.fire(Be)})),se.fire(We),ze},getWindows(){return W.values()},getWindowsCount(){return W.size},getWindowId(Be){return Be.vscodeWindowId},hasWindow(Be){return W.has(Be)},getWindowById:Ce,getWindow(Be){const ze=Be;if(ze?.ownerDocument?.defaultView)return ze.ownerDocument.defaultView.window;const We=Be;return We?.view?We.view.window:r.$6R},getDocument(Be){const ze=Be;return(0,t.getWindow)(ze).document}}}(),t.registerWindow=l.registerWindow,t.getWindow=l.getWindow,t.getDocument=l.getDocument,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.getWindowById=l.getWindowById,t.hasWindow=l.hasWindow,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function D(W){for(;W.firstChild;)W.firstChild.remove()}class T{constructor(G,se,me,Se){this.f=G,this.g=se,this.d=me,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function A(W,G,se,me){return new T(W,G,se,me)}function d(W,G){return function(se){return G(new N.$sS(W,se))}}function f(W){return function(G){return W(new B.$xS(G))}}const m=function(G,se,me,Se){let Ce=me;return se==="click"||se==="mousedown"||se==="contextmenu"?Ce=d((0,t.getWindow)(G),me):(se==="keydown"||se==="keypress"||se==="keyup")&&(Ce=f(me)),A(G,se,Ce,Se)};t.$BS=m;const S=function(G,se,me){const Se=d((0,t.getWindow)(G),se);return U(G,Se,me)};t.$CS=S;const H=function(G,se,me){const Se=d((0,t.getWindow)(G),se);return E(G,Se,me)};t.$DS=H;function U(W,G,se){return A(W,g.$s&&n.$pS.pointerEvents?t.$BT.POINTER_DOWN:t.$BT.MOUSE_DOWN,G,se)}function C(W,G,se){return A(W,g.$s&&n.$pS.pointerEvents?t.$BT.POINTER_MOVE:t.$BT.MOUSE_MOVE,G,se)}function E(W,G,se){return A(W,g.$s&&n.$pS.pointerEvents?t.$BT.POINTER_UP:t.$BT.MOUSE_UP,G,se)}function R(W,G,se){return(0,k.$Uh)(W,G,se)}class x extends k.$Vh{constructor(G,se){super(G,se)}}t.$IS=x;function I(W,G,se,me){let Se=0;const Ce=W.setInterval(()=>{Se++,(typeof me=="number"&&Se>=me||G()===!0)&&Be.dispose()},se),Be=(0,y.$Rc)(()=>{W.clearInterval(Ce)});return Be}class _ extends k.$Oh{constructor(G){super(),this.g=G&&(0,t.getWindow)(G)}cancelAndSet(G,se,me){return super.cancelAndSet(G,se,me??this.g)}}t.$MS=_;class V{constructor(G,se=0){this.d=G,this.priority=se,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,w.$Y)(G)}}static sort(G,se){return se.priority-G.priority}}(function(){const W=new Map,G=new Map,se=new Map,me=new Map,Se=Ce=>{se.set(Ce,!1);const Be=W.get(Ce)??[];for(G.set(Ce,Be),W.set(Ce,[]),me.set(Ce,!0);Be.length>0;)Be.sort(V.sort),Be.shift().execute();me.set(Ce,!1)};t.$KS=(Ce,Be,ze=0)=>{const We=(0,t.getWindowId)(Ce),Ue=new V(Be,ze);let at=W.get(We);return at||(at=[],W.set(We,at)),at.push(Ue),se.get(We)||(se.set(We,!0),Ce.requestAnimationFrame(()=>Se(We))),Ue},t.$JS=(Ce,Be,ze)=>{const We=(0,t.getWindowId)(Ce);if(me.get(We)){const Ue=new V(Be,ze);let at=G.get(We);return at||(at=[],G.set(We,at)),at.push(Ue),Ue}else return(0,t.$KS)(Ce,Be,ze)}})();function J(W,G){return(0,t.$KS)(W,G,1e4)}function q(W,G){return(0,t.$KS)(W,G,-1e4)}const z=8,Q=function(W,G){return G};class ue extends y.$Tc{constructor(G,se,me,Se=Q,Ce=z){super();let Be=null,ze=0;const We=this.B(new k.$Nh),Ue=()=>{ze=new Date().getTime(),me(Be),Be=null};this.B(A(G,se,at=>{Be=Se(Be,at);const At=new Date().getTime()-ze;At>=Ce?(We.cancel(),Ue()):We.setIfNotSet(Ue,Ce-At)}))}}function be(W,G,se,me,Se){return new ue(W,G,se,me,Se)}function Ae(W){return(0,t.getWindow)(W).getComputedStyle(W,null)}function Fe(W,G){const se=(0,t.getWindow)(W),me=se.document;if(W!==me.body)return new ee(W.clientWidth,W.clientHeight);if(g.$s&&se?.visualViewport)return new ee(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ee(se.innerWidth,se.innerHeight);if(me.body&&me.body.clientWidth&&me.body.clientHeight)return new ee(me.body.clientWidth,me.body.clientHeight);if(me.documentElement&&me.documentElement.clientWidth&&me.documentElement.clientHeight)return new ee(me.documentElement.clientWidth,me.documentElement.clientHeight);if(G)return Fe(G);throw new Error("Unable to figure out browser width and height")}class ne{static d(G,se){return parseFloat(se)||0}static f(G,se,me){const Se=Ae(G),Ce=Se?Se.getPropertyValue(se):"0";return ne.d(G,Ce)}static getBorderLeftWidth(G){return ne.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ne.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ne.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ne.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ne.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ne.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return ne.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ne.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ne.f(G,"margin-left","marginLeft")}static getMarginTop(G){return ne.f(G,"margin-top","marginTop")}static getMarginRight(G){return ne.f(G,"margin-right","marginRight")}static getMarginBottom(G){return ne.f(G,"margin-bottom","marginBottom")}}class ee{static{this.None=new ee(0,0)}constructor(G,se){this.width=G,this.height=se}with(G=this.width,se=this.height){return G!==this.width||se!==this.height?new ee(G,se):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ee?G:new ee(G.width,G.height)}static equals(G,se){return G===se?!0:!G||!se?!1:G.width===se.width&&G.height===se.height}}t.$SS=ee;function fe(W){let G=W.offsetParent,se=W.offsetTop,me=W.offsetLeft;for(;(W=W.parentNode)!==null&&W!==W.ownerDocument.body&&W!==W.ownerDocument.documentElement;){se-=W.scrollTop;const Se=O(W)?null:Ae(W);Se&&(me-=Se.direction!=="rtl"?W.scrollLeft:-W.scrollLeft),W===G&&(me+=ne.getBorderLeftWidth(W),se+=ne.getBorderTopWidth(W),se+=W.offsetTop,me+=W.offsetLeft,G=W.offsetParent)}return{left:me,top:se}}function ae(W,G,se){typeof G=="number"&&(W.style.width=`${G}px`),typeof se=="number"&&(W.style.height=`${se}px`)}function Ne(W,G,se,me,Se,Ce="absolute"){typeof G=="number"&&(W.style.top=`${G}px`),typeof se=="number"&&(W.style.right=`${se}px`),typeof me=="number"&&(W.style.bottom=`${me}px`),typeof Se=="number"&&(W.style.left=`${Se}px`),W.style.position=Ce}function te(W){const G=W.getBoundingClientRect(),se=(0,t.getWindow)(W);return{left:G.left+se.scrollX,top:G.top+se.scrollY,width:G.width,height:G.height}}function $e(W){let G=W,se=1;do{const me=Ae(G).zoom;me!=null&&me!=="1"&&(se*=me),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return se}function Te(W){const G=ne.getMarginLeft(W)+ne.getMarginRight(W);return W.offsetWidth+G}function Oe(W){const G=ne.getBorderLeftWidth(W)+ne.getBorderRightWidth(W),se=ne.getPaddingLeft(W)+ne.getPaddingRight(W);return W.offsetWidth-G-se}function Re(W){const G=ne.getMarginLeft(W)+ne.getMarginRight(W);return W.scrollWidth+G}function _e(W){const G=ne.getBorderTopWidth(W)+ne.getBorderBottomWidth(W),se=ne.getPaddingTop(W)+ne.getPaddingBottom(W);return W.offsetHeight-G-se}function oe(W){const G=ne.getMarginTop(W)+ne.getMarginBottom(W);return W.offsetHeight+G}function K(W,G){if(W===null)return 0;const se=fe(W),me=fe(G);return se.left-me.left}function j(W,G){const se=G.map(Se=>Math.max(Re(Se),Te(Se))+K(Se,W)||0);return Math.max(...se)}function a(W,G){return!!G?.contains(W)}const o="parentFlowToElementId";function b(W,G){W.dataset[o]=G.id}function M(W){const G=W.dataset[o];return typeof G=="string"?W.ownerDocument.getElementById(G):null}function F(W,G){let se=W;for(;se;){if(se===G)return!0;if(xe(se)){const me=M(se);if(me){se=me;continue}}se=se.parentNode}return!1}function u(W,G,se){for(;W&&W.nodeType===W.ELEMENT_NODE;){if(W.classList.contains(G))return W;if(se){if(typeof se=="string"){if(W.classList.contains(se))return null}else if(W===se)return null}W=W.parentNode}return null}function L(W,G,se){return!!u(W,G,se)}function O(W){return W&&!!W.host&&!!W.mode}function P(W){return!!X(W)}function X(W){for(;W.parentNode;){if(W===W.ownerDocument?.body)return null;W=W.parentNode}return O(W)?W:null}function Y(){let W=Ee().activeElement;for(;W?.shadowRoot;)W=W.shadowRoot.activeElement;return W}function ie(W){return Y()===W}function re(W){return a(Y(),W)}function ce(W){return W.ownerDocument===Ee()}function Ee(){return(0,t.getWindowsCount)()<=1?r.$6R.document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??r.$6R.document}function ve(){return Ee().defaultView?.window??r.$6R}const ye=new Map;function Le(W){return ye.has(W)}function de(){return new Ie}class Ie{constructor(){this.d="",this.f=void 0}setStyle(G){G!==this.d&&(this.d=G,this.f?this.f.innerText=G:this.f=Ve(r.$6R.document.head,se=>se.innerText=G))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ve(W=r.$6R.document.head,G,se){const me=document.createElement("style");if(me.type="text/css",me.media="screen",G?.(me),W.appendChild(me),se&&se.add((0,y.$Rc)(()=>me.remove())),W===r.$6R.document.head){const Se=new Set;ye.set(me,Se);for(const{window:Ce,disposables:Be}of(0,t.getWindows)()){if(Ce===r.$6R)continue;const ze=Be.add(tt(me,Se,Ce));se?.add(ze)}}return me}function Ge(W){const G=new y.$Sc;for(const[se,me]of ye)G.add(tt(se,me,W));return G}function tt(W,G,se){const me=new y.$Sc,Se=W.cloneNode(!0);se.document.head.appendChild(Se),me.add((0,y.$Rc)(()=>Se.remove()));for(const Ce of he(W))Se.sheet?.insertRule(Ce.cssText,Se.sheet?.cssRules.length);return me.add(t.$kT.observe(W,me,{childList:!0})(()=>{Se.textContent=W.textContent})),G.add(Se),me.add((0,y.$Rc)(()=>G.delete(Se))),me}t.$kT=new class{constructor(){this.mutationObservers=new Map}observe(W,G,se){let me=this.mutationObservers.get(W);me||(me=new Map,this.mutationObservers.set(W,me));const Se=(0,s.$rj)(se);let Ce=me.get(Se);if(Ce)Ce.users+=1;else{const Be=new v.$ke,ze=new MutationObserver(Ue=>Be.fire(Ue));ze.observe(W,se);const We=Ce={users:1,observer:ze,onDidMutate:Be.event};G.add((0,y.$Rc)(()=>{We.users-=1,We.users===0&&(Be.dispose(),ze.disconnect(),me?.delete(Se),me?.size===0&&this.mutationObservers.delete(W))})),me.set(Se,Ce)}return Ce.onDidMutate}};function lt(W=r.$6R.document.head){return qe("meta",W)}function st(W=r.$6R.document.head){return qe("link",W)}function qe(W,G=r.$6R.document.head){const se=document.createElement(W);return G.appendChild(se),se}let Ze=null;function Z(){return Ze||(Ze=Ve()),Ze}function he(W){return W?.sheet?.rules?W.sheet.rules:W?.sheet?.cssRules?W.sheet.cssRules:[]}function pe(W,G,se=Z()){if(!(!se||!G)){se.sheet?.insertRule(`${W} {${G}}`,0);for(const me of ye.get(se)??[])pe(W,G,me)}}function ke(W,G=Z()){if(!G)return;const se=he(G),me=[];for(let Se=0;Se<se.length;Se++){const Ce=se[Se];Pe(Ce)&&Ce.selectorText.indexOf(W)!==-1&&me.push(Se)}for(let Se=me.length-1;Se>=0;Se--)G.sheet?.deleteRule(me[Se]);for(const Se of ye.get(G)??[])ke(W,Se)}function Pe(W){return typeof W.selectorText=="string"}function xe(W){return W instanceof HTMLElement||W instanceof(0,t.getWindow)(W).HTMLElement}function Je(W){return W instanceof HTMLAnchorElement||W instanceof(0,t.getWindow)(W).HTMLAnchorElement}function rt(W){return W instanceof HTMLSpanElement||W instanceof(0,t.getWindow)(W).HTMLSpanElement}function it(W){return W instanceof HTMLTextAreaElement||W instanceof(0,t.getWindow)(W).HTMLTextAreaElement}function ct(W){return W instanceof HTMLInputElement||W instanceof(0,t.getWindow)(W).HTMLInputElement}function nt(W){return W instanceof HTMLButtonElement||W instanceof(0,t.getWindow)(W).HTMLButtonElement}function dt(W){return W instanceof HTMLDivElement||W instanceof(0,t.getWindow)(W).HTMLDivElement}function ft(W){return W instanceof SVGElement||W instanceof(0,t.getWindow)(W).SVGElement}function wt(W){return W instanceof MouseEvent||W instanceof(0,t.getWindow)(W).MouseEvent}function Xe(W){return W instanceof KeyboardEvent||W instanceof(0,t.getWindow)(W).KeyboardEvent}function ge(W){return W instanceof PointerEvent||W instanceof(0,t.getWindow)(W).PointerEvent}function Me(W){return W instanceof DragEvent||W instanceof(0,t.getWindow)(W).DragEvent}t.$BT={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$gS?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$gS?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$gS?"webkitAnimationIteration":"animationiteration"};function je(W){const G=W;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$DT={stop:(W,G)=>(W.preventDefault(),G&&W.stopPropagation(),W)};function Ye(W){const G=[];for(let se=0;W&&W.nodeType===W.ELEMENT_NODE;se++)G[se]=W.scrollTop,W=W.parentNode;return G}function ot(W,G){for(let se=0;W&&W.nodeType===W.ELEMENT_NODE;se++)W.scrollTop!==G[se]&&(W.scrollTop=G[se]),W=W.parentNode}class ut extends y.$Tc{static m(G){if(xe(G)){const se=X(G),me=se?se.activeElement:G.ownerDocument.activeElement;return a(me,G)}else{const se=G;return a(se.document.activeElement,se.document)}}constructor(G){super(),this.f=this.B(new v.$ke),this.onDidFocus=this.f.event,this.g=this.B(new v.$ke),this.onDidBlur=this.g.event;let se=ut.m(G),me=!1;const Se=()=>{me=!1,se||(se=!0,this.f.fire())},Ce=()=>{se&&(me=!0,(xe(G)?(0,t.getWindow)(G):G).setTimeout(()=>{me&&(me=!1,se=!1,this.g.fire())},0))};this.j=()=>{ut.m(G)!==se&&(se?Ce():Se())},this.B(A(G,t.$BT.FOCUS,Se,!0)),this.B(A(G,t.$BT.BLUR,Ce,!0)),xe(G)&&(this.B(A(G,t.$BT.FOCUS_IN,()=>this.j())),this.B(A(G,t.$BT.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Qe(W){return new ut(W)}function bt(W,G){return W.after(G),G}function Et(W,...G){if(W.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}function Rt(W,G){return W.insertBefore(G,W.firstChild),G}function Jt(W,...G){W.innerText="",Et(W,...G)}const Oi=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var kt;(function(W){W.HTML="http://www.w3.org/1999/xhtml",W.SVG="http://www.w3.org/2000/svg"})(kt||(t.Namespace=kt={}));function Qt(W,G,se,...me){const Se=Oi.exec(G);if(!Se)throw new Error("Bad use of emmet");const Ce=Se[1]||"div";let Be;return W!==kt.HTML?Be=document.createElementNS(W,Ce):Be=document.createElement(Ce),Se[3]&&(Be.id=Se[3]),Se[4]&&(Be.className=Se[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([ze,We])=>{typeof We>"u"||(/^on\w+$/.test(ze)?Be[ze]=We:ze==="selected"?We&&Be.setAttribute(ze,"true"):Be.setAttribute(ze,We))}),Be.append(...me),Be}function ei(W,G,...se){return Qt(kt.HTML,W,G,...se)}ei.SVG=function(W,G,...se){return Qt(kt.SVG,W,G,...se)};function Mi(W,G){const se=[];return W.forEach((me,Se)=>{Se>0&&(G instanceof Node?se.push(G.cloneNode()):se.push(document.createTextNode(G))),se.push(me)}),se}function Bi(W,...G){W?ti(...G):ii(...G)}function ti(...W){for(const G of W)G.style.display="",G.removeAttribute("aria-hidden")}function ii(...W){for(const G of W)G.style.display="none",G.setAttribute("aria-hidden","true")}function Pi(W,G){for(;W&&W.nodeType===W.ELEMENT_NODE;){if(xe(W)&&W.hasAttribute(G))return W;W=W.parentNode}return null}function ji(W){!W||!W.hasAttribute("tabIndex")||(W.ownerDocument.activeElement===W&&Pi(W.parentElement,"tabIndex")?.focus(),W.removeAttribute("tabindex"))}function Ci(W){return G=>{G.preventDefault(),G.stopPropagation(),W(G)}}function _i(W){return new Promise(G=>{if(W.document.readyState==="complete"||W.document&&W.document.body!==null)G(void 0);else{const me=()=>{W.window.removeEventListener("DOMContentLoaded",me,!1),G()};W.window.addEventListener("DOMContentLoaded",me,!1)}})}function Ui(W,G){const se=W.devicePixelRatio*G;return Math.max(1,Math.floor(se))/W.devicePixelRatio}function Xi(W){r.$6R.open(W,"_blank","noopener")}const ni=780,si=640;function Hi(W){const G=Math.floor(r.$6R.screenLeft+r.$6R.innerWidth/2-ni/2),se=Math.floor(r.$6R.screenTop+r.$6R.innerHeight/2-si/2);r.$6R.open(W,"_blank",`width=${ni},height=${si},top=${se},left=${G}`)}function xi(W,G=!0){const se=r.$6R.open();return se?(G&&(se.opener=null),se.location.href=W,!0):!1}function Wi(W,G){const se=()=>{G(),me=(0,t.$KS)(W,se)};let me=(0,t.$KS)(W,se);return(0,y.$Rc)(()=>me.dispose())}$.$Qg.setPreferredWebSchema(/^https:/.test(r.$6R.location.href)?"https":"http");function zi(W){return W?`url('${$.$Xg.uriToBrowserUri(W).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Vi(W){return`'${W.replace(/'/g,"%27")}'`}function ri(W,G){if(W!==void 0){const se=W.match(/^\s*var\((.+)\)$/);if(se){const me=se[1].split(",",2);return me.length===2&&(G=ri(me[1].trim(),G)),`var(${me[0]}, ${G})`}return W}return G}function Ki(W,G){let se;if(e.URI.isUri(W))se=W.toString(!0);else{const Ce=new Blob([W]);se=URL.createObjectURL(Ce),setTimeout(()=>URL.revokeObjectURL(se))}const me=ve(),Se=document.createElement("a");me.document.body.appendChild(Se),Se.download=G,Se.href=se,Se.click(),setTimeout(()=>Se.remove())}function qi(){return new Promise(W=>{const G=ve(),se=document.createElement("input");G.document.body.appendChild(se),se.type="file",se.multiple=!0,v.Event.once(v.Event.fromDOMEventEmitter(se,"input"))(()=>{W(se.files??void 0)}),se.click(),setTimeout(()=>se.remove())})}var Nt;(function(W){W[W.DOCUMENT=1]="DOCUMENT",W[W.BROWSER=2]="BROWSER"})(Nt||(t.DetectedFullscreenMode=Nt={}));function Gi(W){return W.document.fullscreenElement||W.document.webkitFullscreenElement||W.document.webkitIsFullScreen?{mode:Nt.DOCUMENT,guess:!1}:W.innerHeight===W.screen.height?{mode:Nt.BROWSER,guess:!1}:(g.$k||g.$l)&&W.outerHeight===W.screen.height&&W.outerWidth===W.screen.width?{mode:Nt.BROWSER,guess:!0}:null}function oi(W,G=!1){const se=document.createElement("a");return c.addHook("afterSanitizeAttributes",me=>{for(const Se of["href","src"])if(me.hasAttribute(Se)){const Ce=me.getAttribute(Se);if(Se==="href"&&Ce.startsWith("#"))continue;if(se.href=Ce,!W.includes(se.protocol.replace(/:$/,""))){if(G&&Se==="src"&&se.href.startsWith("data:"))continue;me.removeAttribute(Se)}}}),(0,y.$Rc)(()=>{c.removeHook("afterSanitizeAttributes")})}const Yi=[$.Schemas.http,$.Schemas.https,$.Schemas.command];t.$6T=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ji(W,G){const se=oi(Yi);try{const me=c.sanitize(G,Zi);W.innerHTML=me}finally{se.dispose()}}function Qi(W){const G=new Uint16Array(W.length);for(let Se=0;Se<G.length;Se++)G[Se]=W.charCodeAt(Se);let se="";const me=new Uint8Array(G.buffer);for(let Se=0;Se<me.length;Se++)se+=String.fromCharCode(me[Se]);return se}function en(W){return btoa(Qi(W))}class yt extends v.$ke{constructor(){super(),this.o=new y.$Sc,this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(v.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:se})=>this.G(G,se),{window:r.$6R,disposables:this.o}))}G(G,se){se.add(A(G,"keydown",me=>{if(me.defaultPrevented)return;const Se=new B.$xS(me);if(!(Se.keyCode===p.KeyCode.Alt&&me.repeat)){if(me.altKey&&!this.D.altKey)this.D.lastKeyPressed="alt";else if(me.ctrlKey&&!this.D.ctrlKey)this.D.lastKeyPressed="ctrl";else if(me.metaKey&&!this.D.metaKey)this.D.lastKeyPressed="meta";else if(me.shiftKey&&!this.D.shiftKey)this.D.lastKeyPressed="shift";else if(Se.keyCode!==p.KeyCode.Alt)this.D.lastKeyPressed=void 0;else return;this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyPressed&&(this.D.event=me,this.fire(this.D))}},!0)),se.add(A(G,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.D.altKey?this.D.lastKeyReleased="alt":!me.ctrlKey&&this.D.ctrlKey?this.D.lastKeyReleased="ctrl":!me.metaKey&&this.D.metaKey?this.D.lastKeyReleased="meta":!me.shiftKey&&this.D.shiftKey?this.D.lastKeyReleased="shift":this.D.lastKeyReleased=void 0,this.D.lastKeyPressed!==this.D.lastKeyReleased&&(this.D.lastKeyPressed=void 0),this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyReleased&&(this.D.event=me,this.fire(this.D)))},!0)),se.add(A(G.document.body,"mousedown",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(A(G.document.body,"mouseup",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(A(G.document.body,"mousemove",me=>{me.buttons&&(this.D.lastKeyPressed=void 0)},!0)),se.add(A(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.D}get isModifierPressed(){return this.D.altKey||this.D.ctrlKey||this.D.metaKey||this.D.shiftKey}resetKeyStatus(){this.H(),this.fire(this.D)}H(){this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return yt.F||(yt.F=new yt),yt.F}dispose(){super.dispose(),this.o.dispose()}}t.$9T=yt;function tn(W){const G=document.cookie.match("(^|[^;]+)\\s*"+W+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}class nn extends y.$Tc{constructor(G,se){super(),this.j=G,this.m=se,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(A(this.j,t.$BT.DRAG_START,G=>{this.m.onDragStart?.(G)})),this.m.onDrag&&this.B(A(this.j,t.$BT.DRAG,G=>{this.m.onDrag?.(G)})),this.B(A(this.j,t.$BT.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter?.(G)})),this.B(A(this.j,t.$BT.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(A(this.j,t.$BT.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(G))})),this.B(A(this.j,t.$BT.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd?.(G)})),this.B(A(this.j,t.$BT.DROP,G=>{this.f=0,this.g=0,this.m.onDrop?.(G)}))}}t.$$T=nn;const li=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function sn(W,...G){let se,me;Array.isArray(G[0])?(se={},me=G[0]):(se=G[0]||{},me=G[1]);const Se=li.exec(W);if(!Se||!Se.groups)throw new Error("Bad use of h");const Ce=Se.groups.tag||"div",Be=document.createElement(Ce);Se.groups.id&&(Be.id=Se.groups.id);const ze=[];if(Se.groups.class)for(const Ue of Se.groups.class.split("."))Ue!==""&&ze.push(Ue);if(se.className!==void 0)for(const Ue of se.className.split("."))Ue!==""&&ze.push(Ue);ze.length>0&&(Be.className=ze.join(" "));const We={};if(Se.groups.name&&(We[Se.groups.name]=Be),me)for(const Ue of me)xe(Ue)?Be.appendChild(Ue):typeof Ue=="string"?Be.append(Ue):"root"in Ue&&(Object.assign(We,Ue),Be.appendChild(Ue.root));for(const[Ue,at]of Object.entries(se))if(Ue!=="className")if(Ue==="style")for(const[At,Dt]of Object.entries(at))Be.style.setProperty(Ot(At),typeof Dt=="number"?Dt+"px":""+Dt);else Ue==="tabIndex"?Be.tabIndex=at:Be.setAttribute(Ot(Ue),at.toString());return We.root=Be,We}function rn(W,...G){let se,me;Array.isArray(G[0])?(se={},me=G[0]):(se=G[0]||{},me=G[1]);const Se=li.exec(W);if(!Se||!Se.groups)throw new Error("Bad use of h");const Ce=Se.groups.tag||"div",Be=document.createElementNS("http://www.w3.org/2000/svg",Ce);Se.groups.id&&(Be.id=Se.groups.id);const ze=[];if(Se.groups.class)for(const Ue of Se.groups.class.split("."))Ue!==""&&ze.push(Ue);if(se.className!==void 0)for(const Ue of se.className.split("."))Ue!==""&&ze.push(Ue);ze.length>0&&(Be.className=ze.join(" "));const We={};if(Se.groups.name&&(We[Se.groups.name]=Be),me)for(const Ue of me)xe(Ue)?Be.appendChild(Ue):typeof Ue=="string"?Be.append(Ue):"root"in Ue&&(Object.assign(We,Ue),Be.appendChild(Ue.root));for(const[Ue,at]of Object.entries(se))if(Ue!=="className")if(Ue==="style")for(const[At,Dt]of Object.entries(at))Be.style.setProperty(Ot(At),typeof Dt=="number"?Dt+"px":""+Dt);else Ue==="tabIndex"?Be.tabIndex=at:Be.setAttribute(Ot(Ue),at.toString());return We.root=Be,We}function Ot(W){return W.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ai(W,G,se){for(const{name:me,value:Se}of W.attributes)(!se||se.includes(me))&&G.setAttribute(me,Se)}function on(W,G,se){const me=W.getAttribute(se);me?G.setAttribute(se,me):G.removeAttribute(se)}function ln(W,G,se){ai(W,G,se);const me=new y.$Sc;return me.add(t.$kT.observe(W,me,{attributes:!0,attributeFilter:se})(Se=>{for(const Ce of Se)Ce.type==="attributes"&&Ce.attributeName&&on(W,G,Ce.attributeName)})),me}class an{constructor(G,se,me){this.f=G,this.g=se,this.d=[];const{top:Se,left:Ce,right:Be,bottom:ze}=me.getBoundingClientRect(),We=this.d;let Ue=0;We[Ue++]=Ce,We[Ue++]=Se,We[Ue++]=Be,We[Ue++]=Se,We[Ue++]=Ce,We[Ue++]=Se,We[Ue++]=Ce,We[Ue++]=ze,We[Ue++]=Be,We[Ue++]=Se,We[Ue++]=Be,We[Ue++]=ze,We[Ue++]=Ce,We[Ue++]=ze,We[Ue++]=Be,We[Ue++]=ze}contains(G,se){const{d:me,f:Se,g:Ce}=this;for(let Be=0;Be<4;Be++)if((0,h.$Om)(G,se,Se,Ce,me[2*Be],me[2*Be+1],me[2*Be+2],me[2*Be+3]))return!0;return!1}}t.$dU=an}),define(we[69],De([1,0,4,2,100]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=t.$eU=void 0,t.$gU=k;class N extends n.$Tc{constructor(v,c){super(),this.B((0,i.$AS)(v,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{c(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$AS)(v,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$eU=N,t.$fU={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$9s.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function k(w,v,c,p,y){const $=document.createElement("div");$.className=c,$.textContent=v,y&&($.style.color=y),p&&($.style.background=p),w.dataTransfer&&((0,i.getWindow)(w).document.body.appendChild($),w.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>$.remove(),0))}}),define(we[70],De([1,0,4]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LU=n,t.$MU=B,t.$NU=N,i=He(i);function n($,g={}){const e=N(g);return e.textContent=$,e}function B($,g={}){const e=N(g);return v(e,c($,!!g.renderCodeSegments),g.actionHandler,g.renderCodeSegments),e}function N($){const g=$.inline?"span":"div",e=document.createElement(g);return $.className&&(e.className=$.className),e}class k{constructor(g){this.b=g,this.c=0}eos(){return this.c>=this.b.length}next(){const g=this.peek();return this.advance(),g}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function($){$[$.Invalid=0]="Invalid",$[$.Root=1]="Root",$[$.Text=2]="Text",$[$.Bold=3]="Bold",$[$.Italics=4]="Italics",$[$.Action=5]="Action",$[$.ActionClose=6]="ActionClose",$[$.Code=7]="Code",$[$.NewLine=8]="NewLine"})(w||(w={}));function v($,g,e,s){let r;if(g.type===w.Text)r=document.createTextNode(g.content||"");else if(g.type===w.Bold)r=document.createElement("b");else if(g.type===w.Italics)r=document.createElement("i");else if(g.type===w.Code&&s)r=document.createElement("code");else if(g.type===w.Action&&e){const h=document.createElement("a");e.disposables.add(i.$BS(h,"click",l=>{e.callback(String(g.index),l)})),r=h}else g.type===w.NewLine?r=document.createElement("br"):g.type===w.Root&&(r=$);r&&$!==r&&$.appendChild(r),r&&Array.isArray(g.children)&&g.children.forEach(h=>{v(r,h,e,s)})}function c($,g){const e={type:w.Root,children:[]};let s=0,r=e;const h=[],l=new k($);for(;!l.eos();){let D=l.next();const T=D==="\\"&&y(l.peek(),g)!==w.Invalid;if(T&&(D=l.next()),!T&&p(D,g)&&D===l.peek()){l.advance(),r.type===w.Text&&(r=h.pop());const A=y(D,g);if(r.type===A||r.type===w.Action&&A===w.ActionClose)r=h.pop();else{const d={type:A,children:[]};A===w.Action&&(d.index=s,s++),r.children.push(d),h.push(r),r=d}}else if(D===`
`)r.type===w.Text&&(r=h.pop()),r.children.push({type:w.NewLine});else if(r.type!==w.Text){const A={type:w.Text,content:D};r.children.push(A),h.push(r),r=A}else r.content+=D}return r.type===w.Text&&(r=h.pop()),h.length,e}function p($,g){return y($,g)!==w.Invalid}function y($,g){switch($){case"*":return w.Bold;case"_":return w.Italics;case"[":return w.Action;case"]":return w.ActionClose;case"`":return g?w.Code:w.Invalid;default:return w.Invalid}}}),define(we[71],De([1,0,4,2]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kU=void 0,i=He(i);class B{constructor(){this.a=new n.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(k,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const v=this.c;this.c=null,k&&v&&v(w)}isMonitoring(){return!!this.b}startMonitoring(k,w,v,c,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=c,this.c=p;let y=k;try{k.setPointerCapture(w),this.a.add((0,n.$Rc)(()=>{try{k.releasePointerCapture(w)}catch{}}))}catch{y=i.getWindow(k)}this.a.add(i.$AS(y,i.$BT.POINTER_MOVE,$=>{if($.buttons!==v){this.stopMonitoring(!0);return}$.preventDefault(),this.b($)})),this.a.add(i.$AS(y,i.$BT.POINTER_UP,$=>this.stopMonitoring(!0)))}}t.$kU=B});var et=this&&this.__decorate||function(le,t,i,n){var B=arguments.length,N=B<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(le,t,i,n);else for(var w=le.length-1;w>=0;w--)(k=le[w])&&(N=(B<3?k(N):B>3?k(t,i,N):k(t,i))||N);return B>3&&N&&Object.defineProperty(t,i,N),N};define(we[32],De([1,0,4,24,9,35,3,2,59]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hU=t.EventType=void 0,i=He(i),B=He(B);var c;(function(y){y.Tap="-monaco-gesturetap",y.Change="-monaco-gesturechange",y.Start="-monaco-gesturestart",y.End="-monaco-gesturesend",y.Contextmenu="-monaco-gesturecontextmenu"})(c||(t.EventType=c={}));class p extends w.$Tc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new v.$4c,this.m=new v.$4c,this.r={},this.n=null,this.s=0,this.B(k.Event.runAndSubscribe(i.onDidRegisterWindow,({window:$,disposables:g})=>{g.add(i.$AS($.document,"touchstart",e=>this.w(e),{passive:!1})),g.add(i.$AS($.document,"touchend",e=>this.z($,e))),g.add(i.$AS($.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$6R,disposables:this.q}))}static addTarget($){if(!p.isTouchDevice())return w.$Tc.None;p.f||(p.f=(0,w.$Mc)(new p));const g=p.f.j.push($);return(0,w.$Rc)(g)}static ignoreTarget($){if(!p.isTouchDevice())return w.$Tc.None;p.f||(p.f=(0,w.$Mc)(new p));const g=p.f.m.push($);return(0,w.$Rc)(g)}static isTouchDevice(){return"ontouchstart"in n.$6R||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w($){const g=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=$.targetTouches.length;e<s;e++){const r=$.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:g,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[g],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(c.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}z($,g){const e=Date.now(),s=Object.keys(this.r).length;for(let r=0,h=g.changedTouches.length;r<h;r++){const l=g.changedTouches.item(r);if(!this.r.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const D=this.r[l.identifier],T=Date.now()-D.initialTimeStamp;if(T<p.g&&Math.abs(D.initialPageX-B.$rb(D.rollingPageX))<30&&Math.abs(D.initialPageY-B.$rb(D.rollingPageY))<30){const A=this.C(c.Tap,D.initialTarget);A.pageX=B.$rb(D.rollingPageX),A.pageY=B.$rb(D.rollingPageY),this.D(A)}else if(T>=p.g&&Math.abs(D.initialPageX-B.$rb(D.rollingPageX))<30&&Math.abs(D.initialPageY-B.$rb(D.rollingPageY))<30){const A=this.C(c.Contextmenu,D.initialTarget);A.pageX=B.$rb(D.rollingPageX),A.pageY=B.$rb(D.rollingPageY),this.D(A)}else if(s===1){const A=B.$rb(D.rollingPageX),d=B.$rb(D.rollingPageY),f=B.$rb(D.rollingTimestamps)-D.rollingTimestamps[0],m=A-D.rollingPageX[0],S=d-D.rollingPageY[0],H=[...this.j].filter(U=>D.initialTarget instanceof Node&&U.contains(D.initialTarget));this.F($,H,e,Math.abs(m)/f,m>0?1:-1,A,Math.abs(S)/f,S>0?1:-1,d)}this.D(this.C(c.End,D.initialTarget)),delete this.r[l.identifier]}this.h&&(g.preventDefault(),g.stopPropagation(),this.h=!1)}C($,g){const e=document.createEvent("CustomEvent");return e.initEvent($,!1,!0),e.initialTarget=g,e.tapCount=0,e}D($){if($.type===c.Tap){const g=new Date().getTime();let e=0;g-this.s>p.u?e=1:e=2,this.s=g,$.tapCount=e}else($.type===c.Change||$.type===c.Contextmenu)&&(this.s=0);if($.initialTarget instanceof Node){for(const e of this.m)if(e.contains($.initialTarget))return;const g=[];for(const e of this.j)if(e.contains($.initialTarget)){let s=0,r=$.initialTarget;for(;r&&r!==e;)s++,r=r.parentElement;g.push([s,e])}g.sort((e,s)=>e[0]-s[0]);for(const[e,s]of g)s.dispatchEvent($),this.h=!0}}F($,g,e,s,r,h,l,D,T){this.n=i.$KS($,()=>{const A=Date.now(),d=A-e;let f=0,m=0,S=!0;s+=p.c*d,l+=p.c*d,s>0&&(S=!1,f=r*s*d),l>0&&(S=!1,m=D*l*d);const H=this.C(c.Change);H.translationX=f,H.translationY=m,g.forEach(U=>U.dispatchEvent(H)),S||this.F($,g,A,s,r,h+f,l,D,T+m)})}G($){const g=Date.now();for(let e=0,s=$.changedTouches.length;e<s;e++){const r=$.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],l=this.C(c.Change,h.initialTarget);l.translationX=r.pageX-B.$rb(h.rollingPageX),l.translationY=r.pageY-B.$rb(h.rollingPageY),l.pageX=r.pageX,l.pageY=r.pageY,this.D(l),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(g)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}}t.$hU=p,et([N.$8h],p,"isTouchDevice",null)}),define(we[112],De([1,0,4,22]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iV=N,t.$jV=k,i=He(i);const B=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function N(w){const v=new Array;let c,p=0,y=0;for(;(c=B.exec(w))!==null;){y=c.index||0,p<y&&v.push(w.substring(p,y)),p=(c.index||0)+c[0].length;const[,$,g]=c;v.push($?`$(${g})`:k({id:g}))}return p<w.length&&v.push(w.substring(p)),v}function k(w){const v=i.$("span");return v.classList.add(...n.ThemeIcon.asClassNameArray(w)),v}}),define(we[113],De([1,0,4]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XU=void 0;class n{constructor(N){this.d=N,this.a=new Map,this.b=new Set,this.c=!1}alloc(N){let k=this.g(N).pop(),w=!1;if(k)w=this.b.has(k.domNode),w&&this.b.delete(k.domNode);else{const v=(0,i.$)(".monaco-list-row"),p=this.h(N).renderTemplate(v);k={domNode:v,templateId:N,templateData:p}}return{row:k,isReusingConnectedDomNode:w}}release(N){N&&this.e(N)}transact(N){if(this.c)throw new Error("Already in transaction");this.c=!0;try{N()}finally{for(const k of this.b)this.f(k);this.b.clear(),this.c=!1}}e(N){const{domNode:k,templateId:w}=N;k&&(this.c?this.b.add(k):this.f(k)),this.g(w).push(N)}f(N){N.classList.remove("scrolling"),N.remove()}g(N){let k=this.a.get(N);return k||(k=[],this.a.set(N,k)),k}dispose(){this.a.forEach((N,k)=>{for(const w of N)this.h(k).disposeTemplate(w.templateData),w.templateData=null}),this.a.clear(),this.b.clear()}h(N){const k=this.d.get(N);if(!k)throw new Error(`No renderer found for ${N}`);return k}}t.$XU=n}),define(we[114],De([1,0,12,2,20]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=void 0;class N extends n.$Tc{constructor(w,v,c){super(),this.a=w,this.b=v,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Nh)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===B.ScrollbarVisibility.Hidden?!1:this.a===B.ScrollbarVisibility.Visible?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$pU=N}),define(we[115],De([1,0,4,32,9,3,8,2,5]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sV=void 0,i=He(i),B=He(B);class c extends w.$Tc{constructor(y,$,g,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new N.$ke),this.h=g,this.j(),this.setOptions(y,$)}j(){this.B(n.$hU.addTarget(this.a)),[n.EventType.Tap].forEach(y=>{this.B(i.$AS(this.a,y,$=>{this.a.focus()}))}),this.B(i.$BS(this.a,"click",y=>{i.$DT.stop(y,!0)})),this.B(i.$BS(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(i.$BS(this.a,"keydown",y=>{let $=!1;v.$k?(y.keyCode===k.KeyCode.DownArrow||y.keyCode===k.KeyCode.UpArrow||y.keyCode===k.KeyCode.Space)&&($=!0):(y.keyCode===k.KeyCode.DownArrow&&y.altKey||y.keyCode===k.KeyCode.Space||y.keyCode===k.KeyCode.Enter)&&($=!0),$&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,$){(!this.c||!B.$tb(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((g,e)=>{this.a.add(this.m(g.text,e,g.isDisabled))})),$!==void 0&&this.select($)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(y){this.a.disabled=!y}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,$,g){const e=document.createElement("option");return e.value=y,e.text=y,e.disabled=!!g,e}}t.$sV=c}),define(we[72],De([1,0,34,9,12,63,109,3,36]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7W=void 0,t.$5W=c,t.$6W=p;function c(g){return typeof g=="object"&&"visibility"in g&&"data"in g}function p(g){switch(g){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return g}}function y(g){return typeof g.collapsible=="boolean"}class ${constructor(e,s,r,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new w.$se,this.f=new w.$ke,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new w.$ke,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new w.$ke,this.onDidSplice=this.m.event,this.o=new B.$Ah(N.$fe),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,r=v.Iterable.empty(),h={}){if(e.length===0)throw new i.$3W(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,r,h):this.t(e,s,r,h)}s(e,s,r,h=v.Iterable.empty(),l,D=l.diffDepth??0){const{parentNode:T}=this.H(s);if(!T.lastDiffIds)return this.t(s,r,h,l);const A=[...h],d=s[s.length-1],f=new k.$St({getElements:()=>T.lastDiffIds},{getElements:()=>[...T.children.slice(0,d),...A,...T.children.slice(d+r)].map(C=>e.getId(C.element).toString())}).ComputeDiff(!1);if(f.quitEarly)return T.lastDiffIds=void 0,this.t(s,r,A,l);const m=s.slice(0,-1),S=(C,E,R)=>{if(D>0)for(let x=0;x<R;x++)C--,E--,this.s(e,[...m,C,0],Number.MAX_SAFE_INTEGER,A[E].children,l,D-1)};let H=Math.min(T.children.length,d+r),U=A.length;for(const C of f.changes.sort((E,R)=>R.originalStart-E.originalStart))S(H,U,H-(C.originalStart+C.originalLength)),H=C.originalStart,U=C.modifiedStart-d,this.t([...m,H],C.originalLength,v.Iterable.slice(A,U,U+C.modifiedLength),l);S(H,U,H)}t(e,s,r=v.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:l,diffIdentityProvider:D}){const{parentNode:T,listIndex:A,revealed:d,visible:f}=this.H(e),m=[],S=v.Iterable.map(r,V=>this.x(V,T,T.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,d,m,h)),H=e[e.length-1];let U=0;for(let V=H;V>=0&&V<T.children.length;V--){const J=T.children[V];if(J.visible){U=J.visibleChildIndex;break}}const C=[];let E=0,R=0;for(const V of S)C.push(V),R+=V.renderNodeCount,V.visible&&(V.visibleChildIndex=U+E++);const x=(0,n.$4b)(T.children,H,s,C);D?T.lastDiffIds?(0,n.$4b)(T.lastDiffIds,H,s,C.map(V=>D.getId(V.element).toString())):T.lastDiffIds=T.children.map(V=>D.getId(V.element).toString()):T.lastDiffIds=void 0;let I=0;for(const V of x)V.visible&&I++;if(I!==0)for(let V=H+C.length;V<T.children.length;V++){const J=T.children[V];J.visible&&(J.visibleChildIndex-=I)}if(T.visibleChildrenCount+=E-I,d&&f){const V=x.reduce((J,q)=>J+(q.visible?q.renderNodeCount:0),0);this.C(T,R-V),this.q.splice(A,V,m)}if(x.length>0&&l){const V=J=>{l(J),J.children.forEach(V)};x.forEach(V)}this.m.fire({insertedNodes:C,deletedNodes:x});let _=T;for(;_;){if(_.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}_=_.parent}}rerender(e){if(e.length===0)throw new i.$3W(this.p,"Invalid tree location");const{node:s,listIndex:r,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(r,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$3W(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:r,revealed:h}=this.G(e);return r&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const r=this.F(e);typeof s>"u"&&(s=!r.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,r){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const l={collapsed:s,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,l))}u(e,s){const{node:r,listIndex:h,revealed:l}=this.G(e),D=this.v(r,h,l,s);if(r!==this.c&&this.l&&D&&!y(s)&&r.collapsible&&!r.collapsed&&!s.recursive){let T=-1;for(let A=0;A<r.children.length;A++)if(r.children[A].visible)if(T>-1){T=-1;break}else T=A;T>-1&&this.u([...e,T],s)}return D}v(e,s,r,h){const l=this.w(e,h,!1);if(!r||!e.visible||!l)return l;const D=e.renderNodeCount,T=this.y(e),A=D-(s===-1?0:1);return this.q.splice(s+1,A,T.slice(1)),l}w(e,s,r){let h;if(e===this.c?h=!1:(y(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!y(s)&&s.recursive)for(const l of e.children)h=this.w(l,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,r,h,l,D){const T={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},A=this.D(T,r);T.visibility=A,h&&l.push(T);const d=e.children||v.Iterable.empty(),f=h&&A!==i.TreeVisibility.Hidden&&!T.collapsed;let m=0,S=1;for(const H of d){const U=this.x(H,T,A,f,l,D);T.children.push(U),S+=U.renderNodeCount,U.visible&&(U.visibleChildIndex=m++)}return this.j||(T.collapsible=T.collapsible||T.children.length>0),T.visibleChildrenCount=m,T.visible=A===i.TreeVisibility.Recurse?m>0:A===i.TreeVisibility.Visible,T.visible?T.collapsed||(T.renderNodeCount=S):(T.renderNodeCount=0,h&&l.pop()),D?.(T),T}y(e){const s=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-s),r}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,r=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r),this.C(e.parent,r.length-s),r}B(e,s,r,h=!0){let l;if(e!==this.c){if(l=this.D(e,s),l===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const D=r.length;e.renderNodeCount=e===this.c?0:1;let T=!1;if(!e.collapsed||l!==i.TreeVisibility.Hidden){let A=0;for(const d of e.children)T=this.B(d,l,r,h&&!e.collapsed)||T,d.visible&&(d.visibleChildIndex=A++);e.visibleChildrenCount=A}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=l===i.TreeVisibility.Recurse?T:l===i.TreeVisibility.Visible,e.visibility=l),e.visible?e.collapsed||(e.renderNodeCount+=r.length-D):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const r=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof r=="boolean"?(e.filterData=void 0,r?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):c(r)?(e.filterData=r.data,p(r.visibility)):(e.filterData=void 0,p(r))}E(e,s=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>s.children.length?!1:this.E(h,s.children[r])}F(e,s=this.c){if(!e||e.length===0)return s;const[r,...h]=e;if(r<0||r>s.children.length)throw new i.$3W(this.p,"Invalid tree location");return this.F(h,s.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:r,revealed:h,visible:l}=this.H(e),D=e[e.length-1];if(D<0||D>s.children.length)throw new i.$3W(this.p,"Invalid tree location");const T=s.children[D];return{node:T,listIndex:r,revealed:h,visible:l&&T.visible}}H(e,s=this.c,r=0,h=!0,l=!0){const[D,...T]=e;if(D<0||D>s.children.length)throw new i.$3W(this.p,"Invalid tree location");for(let A=0;A<D;A++)r+=s.children[A].renderNodeCount;return h=h&&!s.collapsed,l=l&&s.visible,T.length===0?{parentNode:s,listIndex:r,revealed:h,visible:l}:this.H(T,s.children[D],r+1,h,l)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let r=e;for(;r.parent;)s.push(r.parent.children.indexOf(r)),r=r.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$sb)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$7W=$}),define(we[116],De([1,0,72,34,36]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bX=void 0;class N{get size(){return this.d.size}constructor(w,v,c={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$7W(w,v,null,c),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,c.sorter&&(this.j={compare(p,y){return c.sorter.compare(p.element,y.element)}}),this.h=c.identityProvider}setChildren(w,v=B.Iterable.empty(),c={}){const p=this.o(w);this.l(p,this.m(v),c)}l(w,v=B.Iterable.empty(),c){const p=new Set,y=new Set,$=e=>{if(e.element===null)return;const s=e;if(p.add(s.element),this.d.set(s.element,s),this.h){const r=this.h.getId(s.element).toString();y.add(r),this.f.set(r,s)}c.onDidCreateNode?.(s)},g=e=>{if(e.element===null)return;const s=e;if(p.has(s.element)||this.d.delete(s.element),this.h){const r=this.h.getId(s.element).toString();y.has(r)||this.f.delete(r)}c.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,v,{...c,onDidCreateNode:$,onDidDeleteNode:g})}m(w=B.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),B.Iterable.map(w,v=>{let c=this.d.get(v.element);if(!c&&this.h){const $=this.h.getId(v.element).toString();c=this.f.get($)}if(!c){let $;return typeof v.collapsed>"u"?$=void 0:v.collapsed===n.ObjectTreeElementCollapseState.Collapsed||v.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?$=!0:v.collapsed===n.ObjectTreeElementCollapseState.Expanded||v.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?$=!1:$=!!v.collapsed,{...v,children:this.m(v.children),collapsed:$}}const p=typeof v.collapsible=="boolean"?v.collapsible:c.collapsible;let y;return typeof v.collapsed>"u"||v.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||v.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?y=c.collapsed:v.collapsed===n.ObjectTreeElementCollapseState.Collapsed?y=!0:v.collapsed===n.ObjectTreeElementCollapseState.Expanded?y=!1:y=!!v.collapsed,{...v,collapsible:p,collapsed:y,children:this.m(v.children)}})}rerender(w){const v=this.o(w);this.c.rerender(v)}updateElementHeight(w,v){const c=this.o(w);this.c.updateElementHeight(c,v)}resort(w=null,v=!0){if(!this.j)return;const c=this.o(w),p=this.c.getNode(c);this.l(c,this.n(p,v),{})}n(w,v,c=!0){let p=[...w.children];return(v||c)&&(p=p.sort(this.j.compare.bind(this.j))),B.Iterable.map(p,y=>({element:y.element,collapsible:y.collapsible,collapsed:y.collapsed,children:this.n(y,v,!1)}))}getFirstElementChild(w=null){const v=this.o(w);return this.c.getFirstElementChild(v)}getLastElementAncestor(w=null){const v=this.o(w);return this.c.getLastElementAncestor(v)}has(w){return this.d.has(w)}getListIndex(w){const v=this.o(w);return this.c.getListIndex(v)}getListRenderCount(w){const v=this.o(w);return this.c.getListRenderCount(v)}isCollapsible(w){const v=this.o(w);return this.c.isCollapsible(v)}setCollapsible(w,v){const c=this.o(w);return this.c.setCollapsible(c,v)}isCollapsed(w){const v=this.o(w);return this.c.isCollapsed(v)}setCollapsed(w,v,c){const p=this.o(w);return this.c.setCollapsed(p,v,c)}expandTo(w){const v=this.o(w);this.c.expandTo(v)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const v=this.d.get(w);if(!v)throw new n.$3W(this.k,`Tree element not found: ${w}`);return v}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new n.$3W(this.k,"Invalid getParentNodeLocation call");const v=this.d.get(w);if(!v)throw new n.$3W(this.k,`Tree element not found: ${w}`);const c=this.c.getNodeLocation(v),p=this.c.getParentNodeLocation(c);return this.c.getNode(p).element}o(w){if(w===null)return[];const v=this.d.get(w);if(!v)throw new n.$3W(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(v)}}t.$bX=N}),define(we[23],De([1,0,4,15,19,32,2]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lU=void 0,i=He(i);class w extends k.$Tc{f(c,p){this.B(i.$AS(c,i.$BT.CLICK,y=>p(new B.$sS(i.getWindow(c),y))))}j(c,p){this.B(i.$AS(c,i.$BT.MOUSE_DOWN,y=>p(new B.$sS(i.getWindow(c),y))))}m(c,p){this.B(i.$AS(c,i.$BT.MOUSE_OVER,y=>p(new B.$sS(i.getWindow(c),y))))}u(c,p){this.B(i.$AS(c,i.$BT.MOUSE_LEAVE,y=>p(new B.$sS(i.getWindow(c),y))))}z(c,p){this.B(i.$AS(c,i.$BT.KEY_DOWN,y=>p(new n.$xS(y))))}C(c,p){this.B(i.$AS(c,i.$BT.KEY_UP,y=>p(new n.$xS(y))))}D(c,p){this.B(i.$AS(c,i.$BT.INPUT,p))}F(c,p){this.B(i.$AS(c,i.$BT.BLUR,p))}G(c,p){this.B(i.$AS(c,i.$BT.FOCUS,p))}H(c,p){this.B(i.$AS(c,i.$BT.CHANGE,p))}I(c){return N.$hU.ignoreTarget(c)}}t.$lU=w}),define(we[51],De([1,0,71,23,12,22,4]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=t.$mU=void 0,k=He(k),t.$mU=11;class w extends n.$lU{constructor(c){super(),this.a=c.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=c.bgWidth+"px",this.bgDomNode.style.height=c.bgHeight+"px",typeof c.top<"u"&&(this.bgDomNode.style.top="0px"),typeof c.left<"u"&&(this.bgDomNode.style.left="0px"),typeof c.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof c.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=c.className,this.domNode.classList.add(...N.ThemeIcon.asClassNameArray(c.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$mU+"px",this.domNode.style.height=t.$mU+"px",typeof c.top<"u"&&(this.domNode.style.top=c.top+"px"),typeof c.left<"u"&&(this.domNode.style.left=c.left+"px"),typeof c.bottom<"u"&&(this.domNode.style.bottom=c.bottom+"px"),typeof c.right<"u"&&(this.domNode.style.right=c.right+"px"),this.g=this.B(new i.$kU),this.B(k.$BS(this.bgDomNode,k.$BT.POINTER_DOWN,p=>this.h(p))),this.B(k.$BS(this.domNode,k.$BT.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new k.$MS),this.c=this.B(new B.$Nh)}h(c){if(!c.target||!(c.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,k.getWindow(c))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(c.target,c.pointerId,c.buttons,y=>{},()=>{this.b.cancel(),this.c.cancel()}),c.preventDefault()}}t.$nU=w}),define(we[73],De([1,0,4,55,71,51,114,23,5]),function(le,t,i,n,B,N,k,w,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=void 0,i=He(i),v=He(v);const c=140;class p extends w.$lU{constructor($){super(),this.g=$.lazyRender,this.a=$.host,this.b=$.scrollable,this.c=$.scrollByPage,this.h=$.scrollbarState,this.n=this.B(new k.$pU($.visibility,"visible scrollbar "+$.extraScrollbarClassName,"invisible scrollbar "+$.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$kU),this.s=!0,this.domNode=(0,n.$jU)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$AS(this.domNode.domNode,i.$BT.POINTER_DOWN,g=>this.M(g)))}t($){const g=this.B(new N.$nU($));this.domNode.domNode.appendChild(g.bgDomNode),this.domNode.domNode.appendChild(g.domNode)}w($,g,e,s){this.slider=(0,n.$jU)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop($),this.slider.setLeft(g),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$AS(this.slider.domNode,i.$BT.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y($){return this.h.setVisibleSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J($){return this.h.setScrollSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L($){return this.h.setScrollPosition($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M($){$.target===this.domNode.domNode&&this.N($)}delegatePointerDown($){const g=this.domNode.domNode.getClientRects()[0].top,e=g+this.h.getSliderPosition(),s=g+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U($);e<=r&&r<=s?$.button===0&&($.preventDefault(),this.O($)):this.N($)}N($){let g,e;if($.target===this.domNode.domNode&&typeof $.offsetX=="number"&&typeof $.offsetY=="number")g=$.offsetX,e=$.offsetY;else{const r=i.$WS(this.domNode.domNode);g=$.pageX-r.left,e=$.pageY-r.top}const s=this.S(g,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),$.button===0&&($.preventDefault(),this.O($))}O($){if(!$.target||!($.target instanceof Element))return;const g=this.U($),e=this.W($),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring($.target,$.pointerId,$.buttons,r=>{const h=this.W(r),l=Math.abs(h-e);if(v.$j&&l>c){this.P(s.getScrollPosition());return}const T=this.U(r)-g;this.P(s.getDesiredScrollPositionFromDelta(T))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P($){const g={};this.writeScrollPosition(g,$),this.b.setScrollPositionNow(g)}updateScrollbarSize($){this.X($),this.h.setScrollbarSize($),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$qU=p}),define(we[117],De([1,0,19,73,51,56,21,20]),function(le,t,i,n,B,N,k,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=void 0;class v extends n.$qU{constructor(p,y,$){const g=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new N.$oU(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===w.ScrollbarVisibility.Hidden?0:y.horizontalScrollbarSize,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,g.width,g.scrollWidth,e.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const s=(y.arrowSize-B.$mU)/2,r=(y.horizontalScrollbarSize-B.$mU)/2;this.t({className:"scra",icon:k.$3j.scrollbarButtonLeft,top:r,left:s,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$uS(null,1,0))}),this.t({className:"scra",icon:k.$3j.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:s,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$uS(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(p,y){this.slider.setWidth(p),this.slider.setLeft(y)}Q(p,y){this.domNode.setWidth(p),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,y){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,y){p.scrollLeft=y}updateOptions(p){this.updateScrollbarSize(p.horizontal===w.ScrollbarVisibility.Hidden?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$rU=v}),define(we[118],De([1,0,19,73,51,56,21,20]),function(le,t,i,n,B,N,k,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=void 0;class v extends n.$qU{constructor(p,y,$){const g=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new N.$oU(y.verticalHasArrows?y.arrowSize:0,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,0,g.height,g.scrollHeight,e.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const s=(y.arrowSize-B.$mU)/2,r=(y.verticalScrollbarSize-B.$mU)/2;this.t({className:"scra",icon:k.$3j.scrollbarButtonUp,top:s,left:r,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$uS(null,0,1))}),this.t({className:"scra",icon:k.$3j.scrollbarButtonDown,top:void 0,left:r,bottom:s,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$uS(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(p,y){this.slider.setHeight(p),this.slider.setTop(y)}Q(p,y){this.domNode.setWidth(y),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,y){return y}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,y){p.scrollTop=y}updateOptions(p){this.updateScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$sU=v}),define(we[119],De([1,0,6,67,50,11,16]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2k=t.MarkdownStringTextNewlineStyle=void 0,t.$3k=c,t.$4k=p,t.$5k=y,t.$6k=$,t.$7k=g,t.$8k=e,t.$9k=s,t.$0k=r;var w;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class v{constructor(l="",D=!1){if(this.value=l,typeof this.value!="string")throw(0,i.$6)("value");typeof D=="boolean"?(this.isTrusted=D,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=D.isTrusted??void 0,this.supportThemeIcons=D.supportThemeIcons??!1,this.supportHtml=D.supportHtml??!1)}appendText(l,D=w.Paragraph){return this.value+=$(this.supportThemeIcons?(0,n.$Vk)(l):l).replace(/([ \t]+)/g,(T,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,D===w.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,D){return this.value+=`
${g(D,l)}
`,this}appendLink(l,D,T){return this.value+="[",this.value+=this.c(D,"]"),this.value+="](",this.value+=this.c(String(l),")"),T&&(this.value+=` "${this.c(this.c(T,'"'),")")}"`),this.value+=")",this}c(l,D){const T=new RegExp((0,N.$gf)(D),"g");return l.replace(T,(A,d)=>l.charAt(d-1)!=="\\"?`\\${A}`:A)}}t.$2k=v;function c(h){return p(h)?!h.value:Array.isArray(h)?h.every(c):!0}function p(h){return h instanceof v?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function y(h,l){return h===l?!0:!h||!l?!1:h.value===l.value&&h.isTrusted===l.isTrusted&&h.supportThemeIcons===l.supportThemeIcons&&h.supportHtml===l.supportHtml&&(h.baseUri===l.baseUri||!!h.baseUri&&!!l.baseUri&&(0,B.$0g)(k.URI.from(h.baseUri),k.URI.from(l.baseUri)))}function $(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function g(h,l){const D=h.match(/^`+/gm)?.reduce((A,d)=>A.length>d.length?A:d).length??0,T=D>=3?D+1:3;return[`${"`".repeat(T)}${l}`,h,`${"`".repeat(T)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const l=[],D=h.split("|").map(A=>A.trim());h=D[0];const T=D[1];if(T){const A=/height=(\d+)/.exec(T),d=/width=(\d+)/.exec(T),f=A?A[1]:"",m=d?d[1]:"",S=isFinite(parseInt(m)),H=isFinite(parseInt(f));S&&l.push(`width="${m}"`),H&&l.push(`height="${f}"`)}return{href:h,dimensions:l}}}),define(we[120],De([1,0,4,111,29,70,15,19,112,6,3,119,67,90,8,25,2,92,68,39,64,50,11,16]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r,h,l,D,T,A,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lV=void 0,t.$kV=S,t.$mV=x,t.$nV=I,t.$oV=ne,i=He(i),n=He(n);const m=Object.freeze({image:(a,o,b)=>{let M=[],F=[];return a&&({href:a,dimensions:M}=(0,y.$0k)(a),F.push(`src="${(0,y.$8k)(a)}"`)),b&&F.push(`alt="${(0,y.$8k)(b)}"`),o&&F.push(`title="${(0,y.$8k)(o)}"`),M.length&&(F=F.concat(M)),"<img "+F.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,o,b)=>typeof a!="string"?"":(a===b&&(b=(0,y.$9k)(b)),o=typeof o=="string"?(0,y.$8k)((0,y.$9k)(o)):"",a=(0,y.$9k)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${o||a}" draggable="false">${b}</a>`)});function S(a,o={},b={}){const M=new r.$Sc;let F=!1;const u=(0,N.$NU)(o),L=function(ve){let ye;try{ye=(0,l.$_h)(decodeURIComponent(ve))}catch{}return ye?(ye=(0,T.$eo)(ye,Le=>{if(a.uris&&a.uris[Le])return f.URI.revive(a.uris[Le])}),encodeURIComponent(JSON.stringify(ye))):ve},O=function(ve,ye){const Le=a.uris&&a.uris[ve];let de=f.URI.revive(Le);return ye?ve.startsWith(D.Schemas.data+":")?ve:(de||(de=f.URI.parse(ve)),D.$Xg.uriToBrowserUri(de).toString(!0)):!de||f.URI.parse(ve).toString()===de.toString()?ve:(de.query&&(de=de.with({query:L(de.query)})),de.toString())},P=new h.marked.Renderer;P.image=m.image,P.link=m.link,P.paragraph=m.paragraph;const X=[],Y=[];if(o.codeBlockRendererSync?P.code=(ve,ye)=>{const Le=g.$kQ.nextId(),de=o.codeBlockRendererSync(H(ye),ve);return Y.push([Le,de]),`<div class="code" data-code="${Le}">${(0,d.$ff)(ve)}</div>`}:o.codeBlockRenderer&&(P.code=(ve,ye)=>{const Le=g.$kQ.nextId(),de=o.codeBlockRenderer(H(ye),ve);return X.push(de.then(Ie=>[Le,Ie])),`<div class="code" data-code="${Le}">${(0,d.$ff)(ve)}</div>`}),o.actionHandler){const ve=function(de){let Ie=de.target;if(!(Ie.tagName!=="A"&&(Ie=Ie.parentElement,!Ie||Ie.tagName!=="A")))try{let Ve=Ie.dataset.href;Ve&&(a.baseUri&&(Ve=U(f.URI.from(a.baseUri),Ve)),o.actionHandler.callback(Ve,de))}catch(Ve){(0,c.$Y)(Ve)}finally{de.preventDefault()}},ye=o.actionHandler.disposables.add(new B.$OU(u,"click")),Le=o.actionHandler.disposables.add(new B.$OU(u,"auxclick"));o.actionHandler.disposables.add(p.Event.any(ye.event,Le.event)(de=>{const Ie=new w.$sS(i.getWindow(u),de);!Ie.leftButton&&!Ie.middleButton||ve(Ie)})),o.actionHandler.disposables.add(i.$AS(u,"keydown",de=>{const Ie=new k.$xS(de);!Ie.equals(e.KeyCode.Space)&&!Ie.equals(e.KeyCode.Enter)||ve(Ie)}))}a.supportHtml||(b.sanitizer=ve=>o.sanitizerOptions?.replaceWithPlaintext?(0,d.$ff)(ve):(a.isTrusted?ve.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ve:"",b.sanitize=!0,b.silent=!0),b.renderer=P;let ie=a.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ie=(0,$.$Wk)(ie));let re;if(o.fillInIncompleteTokens){const ve={...h.marked.defaults,...b},ye=h.marked.lexer(ie,ve),Le=ne(ye);re=h.marked.parser(Le,ve)}else re=h.marked.parse(ie,b);a.supportThemeIcons&&(re=(0,v.$iV)(re).map(ye=>typeof ye=="string"?ye:ye.outerHTML).join(""));const Ee=new DOMParser().parseFromString(E({isTrusted:a.isTrusted,...o.sanitizerOptions},re),"text/html");if(Ee.body.querySelectorAll("img, audio, video, source").forEach(ve=>{const ye=ve.getAttribute("src");if(ye){let Le=ye;try{a.baseUri&&(Le=U(f.URI.from(a.baseUri),Le))}catch{}if(ve.setAttribute("src",O(Le,!0)),o.remoteImageIsAllowed){const de=f.URI.parse(Le);de.scheme!==D.Schemas.file&&de.scheme!==D.Schemas.data&&!o.remoteImageIsAllowed(de)&&ve.replaceWith(i.$("",void 0,ve.outerHTML))}}}),Ee.body.querySelectorAll("a").forEach(ve=>{const ye=ve.getAttribute("href");if(ve.setAttribute("href",""),!ye||/^data:|javascript:/i.test(ye)||/^command:/i.test(ye)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(ye))ve.replaceWith(...ve.childNodes);else{let Le=O(ye,!1);a.baseUri&&(Le=U(f.URI.from(a.baseUri),ye)),ve.dataset.href=Le}}),u.innerHTML=E({isTrusted:a.isTrusted,...o.sanitizerOptions},Ee.body.innerHTML),X.length>0)Promise.all(X).then(ve=>{if(F)return;const ye=new Map(ve),Le=u.querySelectorAll("div[data-code]");for(const de of Le){const Ie=ye.get(de.dataset.code??"");Ie&&i.$KT(de,Ie)}o.asyncRenderCallback?.()});else if(Y.length>0){const ve=new Map(Y),ye=u.querySelectorAll("div[data-code]");for(const Le of ye){const de=ve.get(Le.dataset.code??"");de&&i.$KT(Le,de)}}if(o.asyncRenderCallback)for(const ve of u.getElementsByTagName("img")){const ye=M.add(i.$AS(ve,"load",()=>{ye.dispose(),o.asyncRenderCallback()}))}return{element:u,dispose:()=>{F=!0,M.dispose()}}}function H(a){if(!a)return"";const o=a.split(/[\s+|:|,|\{|\?]/,1);return o.length?o[0]:a}function U(a,o){return/^\w[\w\d+.-]*:/.test(o)?o:a.path.endsWith("/")?(0,A.$hh)(a,o).toString():(0,A.$hh)((0,A.$dh)(a),o).toString()}const C=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function E(a,o){const{config:b,allowedSchemes:M}=R(a),F=new r.$Sc;F.add(j("uponSanitizeAttribute",(u,L)=>{if(L.attrName==="style"||L.attrName==="class"){if(u.tagName==="SPAN"){if(L.attrName==="style"){L.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(L.attrValue);return}else if(L.attrName==="class"){L.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(L.attrValue);return}}L.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(L.attrName==="type"&&L.attrValue==="checkbox"||L.attrName==="disabled"||L.attrName==="checked"){L.keepAttr=!0;return}L.keepAttr=!1}})),F.add(j("uponSanitizeElement",(u,L)=>{if(L.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.remove()),a.replaceWithPlaintext&&!L.allowedTags[L.tagName]&&L.tagName!=="body"&&u.parentElement){let O,P;if(L.tagName==="#comment")O=`<!--${u.textContent}-->`;else{const re=C.includes(L.tagName),ce=u.attributes.length?" "+Array.from(u.attributes).map(Ee=>`${Ee.name}="${Ee.value}"`).join(" "):"";O=`<${L.tagName}${ce}>`,re||(P=`</${L.tagName}>`)}const X=document.createDocumentFragment(),Y=u.parentElement.ownerDocument.createTextNode(O);X.appendChild(Y);const ie=P?u.parentElement.ownerDocument.createTextNode(P):void 0;for(;u.firstChild;)X.appendChild(u.firstChild);ie&&X.appendChild(ie),u.parentElement.replaceChild(X,u)}})),F.add(i.$5T(M));try{return n.sanitize(o,{...b,RETURN_TRUSTED_TYPE:!0})}finally{F.dispose()}}t.$lV=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function R(a){const o=[D.Schemas.http,D.Schemas.https,D.Schemas.mailto,D.Schemas.data,D.Schemas.file,D.Schemas.vscodeFileResource,D.Schemas.vscodeRemote,D.Schemas.vscodeRemoteResource];return a.isTrusted&&o.push(D.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.$6T],ALLOWED_ATTR:t.$lV,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:o}}function x(a){return typeof a=="string"?a:I(a)}function I(a,o){let b=a.value??"";b.length>1e5&&(b=`${b.substr(0,1e5)}\u2026`);const M=h.marked.parse(b,{renderer:o?q.value:J.value}).replace(/&(#\d+|[a-zA-Z]+);/g,F=>_.get(F)??F);return E({isTrusted:!1},M).toString()}const _=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function V(){const a=new h.marked.Renderer;return a.code=o=>o,a.blockquote=o=>o,a.html=o=>"",a.heading=(o,b,M)=>o+`
`,a.hr=()=>"",a.list=(o,b)=>o,a.listitem=o=>o+`
`,a.paragraph=o=>o+`
`,a.table=(o,b)=>o+b+`
`,a.tablerow=o=>o,a.tablecell=(o,b)=>o+" ",a.strong=o=>o,a.em=o=>o,a.codespan=o=>o,a.br=()=>`
`,a.del=o=>o,a.image=(o,b,M)=>"",a.text=o=>o,a.link=(o,b,M)=>M,a}const J=new s.$T(a=>V()),q=new s.$T(()=>{const a=V();return a.code=o=>`
\`\`\`
${o}
\`\`\`
`,a});function z(a){let o="";return a.forEach(b=>{o+=b.raw}),o}function Q(a){if(a.tokens)for(let o=a.tokens.length-1;o>=0;o--){const b=a.tokens[o];if(b.type==="text"){const M=b.raw.split(`
`),F=M[M.length-1];if(F.includes("`"))return ae(a);if(F.includes("**"))return Re(a);if(F.match(/\*\w/))return Ne(a);if(F.match(/(^|\s)__\w/))return _e(a);if(F.match(/(^|\s)_\w/))return te(a);if(ue(F)||be(F)&&a.tokens.slice(0,o).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(o+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||F.match(/^[^"]* +"[^"]*$/)?Te(a):$e(a)}else if(F.match(/(^|\s)\[\w*/))return Oe(a)}}}function ue(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function be(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function Ae(a){const o=a.items[a.items.length-1],b=o.tokens?o.tokens[o.tokens.length-1]:void 0;let M;if(b?.type==="text"&&!("inRawBlock"in o)&&(M=Q(b)),!M||M.type!=="paragraph")return;const F=z(a.items.slice(0,-1)),u=o.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!u)return;const L=u+z(o.tokens.slice(0,-1))+M.raw,O=h.marked.lexer(F+L)[0];if(O.type==="list")return O}const Fe=3;function ne(a){for(let o=0;o<Fe;o++){const b=ee(a);if(b)a=b;else break}return a}function ee(a){let o,b;for(o=0;o<a.length;o++){const M=a[o];let F;if(M.type==="paragraph"&&(F=M.raw.match(/(\n|^)(````*)/))){const u=F[2];b=fe(a.slice(o),u);break}if(M.type==="paragraph"&&M.raw.match(/(\n|^)\|/)){b=K(a.slice(o));break}if(o===a.length-1&&M.type==="list"){const u=Ae(M);if(u){b=[u];break}}if(o===a.length-1&&M.type==="paragraph"){const u=Q(M);if(u){b=[u];break}}}if(b){const M=[...a.slice(0,o),...b];return M.links=a.links,M}return null}function fe(a,o){const b=z(a);return h.marked.lexer(b+`
${o}`)}function ae(a){return oe(a,"`")}function Ne(a){return oe(a,"*")}function te(a){return oe(a,"_")}function $e(a){return oe(a,")")}function Te(a){return oe(a,'")')}function Oe(a){return oe(a,"](https://microsoft.com)")}function Re(a){return oe(a,"**")}function _e(a){return oe(a,"__")}function oe(a,o){const b=z(Array.isArray(a)?a:[a]);return h.marked.lexer(b+o)[0]}function K(a){const o=z(a),b=o.split(`
`);let M,F=!1;for(let u=0;u<b.length;u++){const L=b[u].trim();if(typeof M>"u"&&L.match(/^\s*\|/)){const O=L.match(/(\|[^\|]+)(?=\||$)/g);O&&(M=O.length)}else if(typeof M=="number")if(L.match(/^\s*\|/)){if(u!==b.length-1)return;F=!0}else return}if(typeof M=="number"&&M>0){const u=F?b.slice(0,-1).join(`
`):o,L=!!u.match(/\|\s*$/),O=u+(L?"":"|")+`
|${" --- |".repeat(M)}`;return h.marked.lexer(O)}}function j(a,o){return n.addHook(a,o),(0,r.$Rc)(()=>n.removeHook(a))}}),define(we[121],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PX=t.$OX=void 0,t.$OX="vscode:contextmenu",t.$PX="vscode:onCloseContextMenu"}),define(we[74],De([1,0,9,12,47,38,35,6,3,2,68,11,10]),function(le,t,i,n,B,N,k,w,v,c,p,y,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mi=t.ProxyChannel=t.$li=t.$ii=t.$hi=t.$gi=t.RequestInitiator=t.$fi=t.$ci=t.$bi=void 0,t.$di=U,t.$ei=C,t.$ji=V,t.$ki=J,y=He(y);var g;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(g||(g={}));function e(ne){switch(ne){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var s;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(s||(s={}));function r(ne){switch(ne){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(h||(h={}));function l(ne){let ee=0;for(let fe=0;;fe+=7){const ae=ne.read(1);if(ee|=(ae.buffer[0]&127)<<fe,!(ae.buffer[0]&128))return ee}}const D=m(0);function T(ne,ee){if(ee===0){ne.write(D);return}let fe=0;for(let Ne=ee;Ne!==0;Ne=Ne>>>7)fe++;const ae=B.$Me.alloc(fe);for(let Ne=0;ee!==0;Ne++)ae.buffer[Ne]=ee&127,ee=ee>>>7,ee>0&&(ae.buffer[Ne]|=128);ne.write(ae)}class A{constructor(ee){this.b=ee,this.a=0}read(ee){const fe=this.b.slice(this.a,this.a+ee);return this.a+=fe.byteLength,fe}}t.$bi=A;class d{constructor(){this.a=[]}get buffer(){return B.$Me.concat(this.a)}write(ee){this.a.push(ee)}}t.$ci=d;var f;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object",ne[ne.Int=6]="Int"})(f||(f={}));function m(ne){const ee=B.$Me.alloc(1);return ee.writeUInt8(ne,0),ee}const S={Undefined:m(f.Undefined),String:m(f.String),Buffer:m(f.Buffer),VSBuffer:m(f.VSBuffer),Array:m(f.Array),Object:m(f.Object),Uint:m(f.Int)},H=typeof Buffer<"u";function U(ne,ee){if(typeof ee>"u")ne.write(S.Undefined);else if(typeof ee=="string"){const fe=B.$Me.fromString(ee);ne.write(S.String),T(ne,fe.byteLength),ne.write(fe)}else if(H&&Buffer.isBuffer(ee)){const fe=B.$Me.wrap(ee);ne.write(S.Buffer),T(ne,fe.byteLength),ne.write(fe)}else if(ee instanceof B.$Me)ne.write(S.VSBuffer),T(ne,ee.byteLength),ne.write(ee);else if(Array.isArray(ee)){ne.write(S.Array),T(ne,ee.length);for(const fe of ee)U(ne,fe)}else if(typeof ee=="number"&&(ee|0)===ee)ne.write(S.Uint),T(ne,ee);else{const fe=B.$Me.fromString(JSON.stringify(ee));ne.write(S.Object),T(ne,fe.byteLength),ne.write(fe)}}function C(ne){switch(ne.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return ne.read(l(ne)).toString();case f.Buffer:return ne.read(l(ne)).buffer;case f.VSBuffer:return ne.read(l(ne));case f.Array:{const fe=l(ne),ae=[];for(let Ne=0;Ne<fe;Ne++)ae.push(C(ne));return ae}case f.Object:return JSON.parse(ne.read(l(ne)).toString());case f.Int:return l(ne)}}class E{constructor(ee,fe,ae=null,Ne=1e3){this.h=ee,this.j=fe,this.k=ae,this.l=Ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:s.Initialize})}registerChannel(ee,fe){this.b.set(ee,fe),setTimeout(()=>this.w(ee),0)}m(ee){switch(ee.type){case s.Initialize:{const fe=this.o([ee.type]);this.k?.logOutgoing(fe,0,R.OtherSide,r(ee.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const fe=this.o([ee.type,ee.id],ee.data);this.k?.logOutgoing(fe,ee.id,R.OtherSide,r(ee.type),ee.data);return}}}o(ee,fe=void 0){const ae=new d;return U(ae,ee),U(ae,fe),this.p(ae.buffer)}p(ee){try{return this.h.send(ee),ee.byteLength}catch{return 0}}q(ee){const fe=new A(ee),ae=C(fe),Ne=C(fe),te=ae[0];switch(te){case g.Promise:return this.k?.logIncoming(ee.byteLength,ae[1],R.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Ne),this.s({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Ne});case g.EventListen:return this.k?.logIncoming(ee.byteLength,ae[1],R.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Ne),this.t({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Ne});case g.PromiseCancel:return this.k?.logIncoming(ee.byteLength,ae[1],R.OtherSide,`${e(te)}`),this.u({type:te,id:ae[1]});case g.EventDispose:return this.k?.logIncoming(ee.byteLength,ae[1],R.OtherSide,`${e(te)}`),this.u({type:te,id:ae[1]})}}s(ee){const fe=this.b.get(ee.channelName);if(!fe){this.v(ee);return}const ae=new N.$ve;let Ne;try{Ne=fe.call(this.j,ee.name,ee.arg,ae.token)}catch(Te){Ne=Promise.reject(Te)}const te=ee.id;Ne.then(Te=>{this.m({id:te,data:Te,type:s.PromiseSuccess})},Te=>{Te instanceof Error?this.m({id:te,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:te,data:Te,type:s.PromiseErrorObj})}).finally(()=>{$e.dispose(),this.d.delete(ee.id)});const $e=(0,c.$Rc)(()=>ae.cancel());this.d.set(ee.id,$e)}t(ee){const fe=this.b.get(ee.channelName);if(!fe){this.v(ee);return}const ae=ee.id,te=fe.listen(this.j,ee.name,ee.arg)($e=>this.m({id:ae,data:$e,type:s.EventFire}));this.d.set(ee.id,te)}u(ee){const fe=this.d.get(ee.id);fe&&(fe.dispose(),this.d.delete(ee.id))}v(ee){let fe=this.g.get(ee.channelName);fe||(fe=[],this.g.set(ee.channelName,fe));const ae=setTimeout(()=>{console.error(`Unknown channel: ${ee.channelName}`),ee.type===g.Promise&&this.m({id:ee.id,data:{name:"Unknown channel",message:`Channel name '${ee.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);fe.push({request:ee,timeoutTimer:ae})}w(ee){const fe=this.g.get(ee);if(fe){for(const ae of fe)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case g.Promise:this.s(ae.request);break;case g.EventListen:this.t(ae.request);break}this.g.delete(ee)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}t.$fi=E;var R;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(R||(t.RequestInitiator=R={}));class x{constructor(ee,fe=null){this.l=ee,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$ke,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=fe}getChannel(ee){const fe=this;return{call(ae,Ne,te){return fe.a?Promise.reject(new w.$4):fe.m(ee,ae,Ne,te)},listen(ae,Ne){return fe.a?v.Event.None:fe.o(ee,ae,Ne)}}}m(ee,fe,ae,Ne=N.CancellationToken.None){const te=this.g++,$e=g.Promise,Te={id:te,type:$e,channelName:ee,name:fe,arg:ae};if(Ne.isCancellationRequested)return Promise.reject(new w.$4);let Oe;return new Promise((_e,oe)=>{if(Ne.isCancellationRequested)return oe(new w.$4);const K=()=>{const b=M=>{switch(M.type){case s.PromiseSuccess:this.f.delete(te),_e(M.data);break;case s.PromiseError:{this.f.delete(te);const F=new Error(M.data.message);F.stack=Array.isArray(M.data.stack)?M.data.stack.join(`
`):M.data.stack,F.name=M.data.name,oe(F);break}case s.PromiseErrorObj:this.f.delete(te),oe(M.data);break}};this.f.set(te,b),this.p(Te)};let j=null;this.b===h.Idle?K():(j=(0,n.$qh)(b=>this.u()),j.then(()=>{j=null,K()}));const a=()=>{j?(j.cancel(),j=null):this.p({id:te,type:g.PromiseCancel}),oe(new w.$4)},o=Ne.onCancellationRequested(a);Oe=(0,c.$Qc)((0,c.$Rc)(a),o),this.d.add(Oe)}).finally(()=>{Oe.dispose(),this.d.delete(Oe)})}o(ee,fe,ae){const Ne=this.g++,te=g.EventListen,$e={id:Ne,type:te,channelName:ee,name:fe,arg:ae};let Te=null;const Oe=new v.$ke({onWillAddFirstListener:()=>{Te=(0,n.$qh)(_e=>this.u()),Te.then(()=>{Te=null,this.d.add(Oe),this.p($e)})},onDidRemoveLastListener:()=>{Te?(Te.cancel(),Te=null):(this.d.delete(Oe),this.p({id:Ne,type:g.EventDispose}))}}),Re=_e=>Oe.fire(_e.data);return this.f.set(Ne,Re),Oe.event}p(ee){switch(ee.type){case g.Promise:case g.EventListen:{const fe=this.q([ee.type,ee.id,ee.channelName,ee.name],ee.arg);this.j?.logOutgoing(fe,ee.id,R.LocalSide,`${e(ee.type)}: ${ee.channelName}.${ee.name}`,ee.arg);return}case g.PromiseCancel:case g.EventDispose:{const fe=this.q([ee.type,ee.id]);this.j?.logOutgoing(fe,ee.id,R.LocalSide,e(ee.type));return}}}q(ee,fe=void 0){const ae=new d;return U(ae,ee),U(ae,fe),this.r(ae.buffer)}r(ee){try{return this.l.send(ee),ee.byteLength}catch{return 0}}s(ee){const fe=new A(ee),ae=C(fe),Ne=C(fe),te=ae[0];switch(te){case s.Initialize:return this.j?.logIncoming(ee.byteLength,0,R.LocalSide,r(te)),this.t({type:ae[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(ee.byteLength,ae[1],R.LocalSide,r(te),Ne),this.t({type:ae[0],id:ae[1],data:Ne})}}t(ee){if(ee.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(ee.id)?.(ee)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}t.$gi=x,et([k.$8h],x.prototype,"onDidInitializePromise",null);class I{get connections(){const ee=[];return this.f.forEach(fe=>ee.push(fe)),ee}constructor(ee,fe,ae){this.a=new Map,this.f=new Set,this.g=new v.$ke,this.onDidAddConnection=this.g.event,this.h=new v.$ke,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(ee(({protocol:Ne,onDidClientDisconnect:te})=>{const $e=v.Event.once(Ne.onMessage);this.j.add($e(Te=>{const Oe=new A(Te),Re=C(Oe),_e=new E(Ne,Re,fe,ae),oe=new x(Ne,fe);this.a.forEach((j,a)=>_e.registerChannel(a,j));const K={channelServer:_e,channelClient:oe,ctx:Re};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{_e.dispose(),oe.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(ee,fe){const ae=this;return{call(Ne,te,$e){let Te;if((0,$.$rg)(fe)){const Re=(0,i.$2b)(ae.connections.filter(fe));Te=Re?Promise.resolve(Re):v.Event.toPromise(v.Event.filter(ae.onDidAddConnection,fe))}else Te=fe.routeCall(ae,Ne,te);const Oe=Te.then(Re=>Re.channelClient.getChannel(ee));return V(Oe).call(Ne,te,$e)},listen(Ne,te){if((0,$.$rg)(fe))return ae.k(ee,fe,Ne,te);const $e=fe.routeEvent(ae,Ne,te).then(Te=>Te.channelClient.getChannel(ee));return V($e).listen(Ne,te)}}}k(ee,fe,ae,Ne){const te=this;let $e;const Te=new v.$ke({onWillAddFirstListener:()=>{$e=new c.$Sc;const Oe=new v.$qe,Re=new Map,_e=K=>{const a=K.channelClient.getChannel(ee).listen(ae,Ne),o=Oe.add(a);Re.set(K,o)},oe=K=>{const j=Re.get(K);j&&(j.dispose(),Re.delete(K))};te.connections.filter(fe).forEach(_e),v.Event.filter(te.onDidAddConnection,fe)(_e,void 0,$e),te.onDidRemoveConnection(oe,void 0,$e),Oe.event(Te.fire,Te,$e),$e.add(Oe)},onDidRemoveLastListener:()=>{$e?.dispose(),$e=void 0}});return Te.event}registerChannel(ee,fe){this.a.set(ee,fe);for(const ae of this.f)ae.channelServer.registerChannel(ee,fe)}dispose(){this.j.dispose();for(const ee of this.f)ee.channelClient.dispose(),ee.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$hi=I;class _{constructor(ee,fe,ae=null){const Ne=new d;U(Ne,fe),ee.send(Ne.buffer),this.a=new x(ee,ae),this.d=new E(ee,fe,ae)}getChannel(ee){return this.a.getChannel(ee)}registerChannel(ee,fe){this.d.registerChannel(ee,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$ii=_;function V(ne){return{call(ee,fe,ae){return ne.then(Ne=>Ne.call(ee,fe,ae))},listen(ee,fe){const ae=new v.$te;return ne.then(Ne=>ae.input=Ne.listen(ee,fe)),ae.event}}}function J(ne){let ee=!1;return{call(fe,ae,Ne){return ee?ne.call(fe,ae,Ne):(0,n.$Eh)(0).then(()=>ee=!0).then(()=>ne.call(fe,ae,Ne))},listen(fe,ae){if(ee)return ne.listen(fe,ae);const Ne=new v.$te;return(0,n.$Eh)(0).then(()=>ee=!0).then(()=>Ne.input=ne.listen(fe,ae)),Ne.event}}}class q{constructor(ee){this.a=ee}routeCall(ee){return this.b(ee)}routeEvent(ee){return this.b(ee)}async b(ee){for(const fe of ee.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await v.Event.toPromise(ee.onDidAddConnection),await this.b(ee)}}t.$li=q;var z;(function(ne){function ee(te,$e,Te){const Oe=te,Re=Te&&Te.disableMarshalling,_e=new Map;for(const oe in Oe)ae(oe)&&_e.set(oe,v.Event.buffer(Oe[oe],!0,void 0,$e));return new class{listen(oe,K,j){const a=_e.get(K);if(a)return a;const o=Oe[K];if(typeof o=="function"){if(Ne(K))return o.call(Oe,j);if(ae(K))return _e.set(K,v.Event.buffer(Oe[K],!0,void 0,$e)),_e.get(K)}throw new w.$ab(`Event not found: ${K}`)}call(oe,K,j){const a=Oe[K];if(typeof a=="function"){if(!Re&&Array.isArray(j))for(let b=0;b<j.length;b++)j[b]=(0,p.$ai)(j[b]);let o=a.apply(Oe,j);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new w.$ab(`Method not found: ${K}`)}}}ne.fromService=ee;function fe(te,$e){const Te=$e&&$e.disableMarshalling;return new Proxy({},{get(Oe,Re){if(typeof Re=="string")return $e?.properties?.has(Re)?$e.properties.get(Re):Ne(Re)?function(_e){return te.listen(Re,_e)}:ae(Re)?te.listen(Re):async function(..._e){let oe;$e&&!(0,$.$mg)($e.context)?oe=[$e.context,..._e]:oe=_e;const K=await te.call(Re,oe);return Te?K:(0,p.$ai)(K)};throw new w.$ab(`Property not found: ${String(Re)}`)}})}ne.toService=fe;function ae(te){return te[0]==="o"&&te[1]==="n"&&y.$Df(te.charCodeAt(2))}function Ne(te){return/^onDynamic/.test(te)&&y.$Df(te.charCodeAt(9))}})(z||(t.ProxyChannel=z={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const ee=ne.toString();if(ee!=="[object Object]")return ee}return ne}function be(ne){return Array.isArray(ne)?ne.map(ue):ue(ne)}function Ae(ne,ee,fe,ae,Ne,te,$e){$e=be($e);const Te=Q[Ne],Oe=Te[ae%Te.length];let Re=[`%c[${ne}]%c[${String(ee).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(te)?(Re=Re.concat($e),Re.push(")")):Re.push($e),console.log.apply(console,Re)}class Fe{constructor(ee,fe){this.d=ee,this.f=fe,this.a=0,this.b=0}logOutgoing(ee,fe,ae,Ne,te){this.b+=ee,Ae(this.d,this.b,ee,fe,ae,Ne,te)}logIncoming(ee,fe,ae,Ne,te){this.a+=ee,Ae(this.f,this.a,ee,fe,ae,Ne,te)}}t.$mi=Fe}),define(we[122],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WX=void 0;class i{constructor(B,N){this.a=B,this.onMessage=N}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$WX=i}),define(we[40],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=t.$L=void 0;const i=globalThis.vscode;t.$L=i.ipcRenderer,t.$M=i.ipcMessagePort,t.$N=i.webFrame,t.$O=i.process,t.$P=i.context,t.$Q=i.webUtils}),define(we[123],De([1,0,121,40]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SX=N;let B=0;function N(w,v,c){const p=[],y=B++,$=`vscode:onContextMenu${y}`,g=(e,s,r)=>{p[s].click?.(r)};n.$L.once($,g),n.$L.once(i.$PX,(e,s)=>{s===y&&(n.$L.removeListener($,g),c?.())}),n.$L.send(i.$OX,y,w.map(e=>k(e,p)),$,v)}function k(w,v){const c={id:v.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return v.push(w),Array.isArray(w.submenu)&&(c.submenu=w.submenu.map(p=>k(p,v))),c}}),define(we[124],De([1,0,47,3,74,122,40]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1X=void 0;class w extends B.$ii{static f(){const c=n.Event.fromNodeEventEmitter(k.$L,"vscode:message",(p,y)=>i.$Me.wrap(y));return k.$L.send("vscode:hello"),new N.$WX(k.$L,c)}constructor(c){const p=w.f();super(p,c),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$1X=w}),define(we[75],De([7]),{}),define(we[125],De([7]),{}),define(we[76],De([1,0,4,125]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PU=c,t.$QU=p,t.$RU=y,i=He(i);const n=2e4;let B,N,k,w,v;function c(g){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),B.appendChild(r),r};N=e(),k=e();const s=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),B.appendChild(r),r};w=s(),v=s(),g.appendChild(B)}function p(g){B&&(N.textContent!==g?(i.$zS(k),$(N,g)):(i.$zS(N),$(k,g)))}function y(g){B&&(w.textContent!==g?(i.$zS(v),$(w,g)):(i.$zS(w),$(v,g)))}function $(g,e){i.$zS(g),e.length>n&&(e=e.substr(0,n)),g.textContent=e,g.style.visibility="hidden",g.style.visibility="visible"}}),define(we[126],De([7]),{}),define(we[127],De([7]),{}),define(we[128],De([1,0,126,127]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(we[129],De([7]),{}),define(we[77],De([1,0,61,4,2,5,46,129]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KU=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$IU=v,t.$JU=e,n=He(n),N=He(N);var w;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(w||(t.ContextViewDOMPosition=w={}));function v(h){const l=h;return!!l&&typeof l.x=="number"&&typeof l.y=="number"}var c;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(c||(t.AnchorAlignment=c={}));var p;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})(p||(t.AnchorPosition=p={}));var y;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(y||(t.AnchorAxisAlignment=y={}));var $;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})($||(t.LayoutAnchorPosition=$={}));var g;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(g||(t.LayoutAnchorMode=g={}));function e(h,l,D){const T=D.mode===g.ALIGN?D.offset:D.offset+D.size,A=D.mode===g.ALIGN?D.offset+D.size:D.offset;return D.position===$.Before?l<=h-T?T:l<=A?A-l:Math.max(h-l,0):l<=A?A-l:l<=h-T?T:0}class s extends B.$Tc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(l,D){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=B.$Tc.None,this.n=B.$Tc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$PT(this.f),this.setContainer(l,D),this.B((0,B.$Rc)(()=>this.setContainer(null,w.ABSOLUTE)))}setContainer(l,D){this.g=D!==w.ABSOLUTE;const T=this.h;if(this.h=D===w.FIXED_SHADOW,!(l===this.c&&T===this.h)&&(this.c&&(this.n.dispose(),this.f.remove(),this.r&&(this.r=null,this.s?.remove(),this.s=null),this.c=null),l)){if(this.c=l,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const d=document.createElement("style");d.textContent=r,this.r.appendChild(d),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const A=new B.$Sc;s.a.forEach(d=>{A.add(n.$BS(this.c,d,f=>{this.w(f,!1)}))}),s.b.forEach(d=>{A.add(n.$BS(this.c,d,f=>{this.w(f,!0)},!0))}),this.n=A}}show(l){this.u()&&this.hide(),n.$zS(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(l.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$OT(this.f),this.m=l.render(this.f)||B.$Tc.None,this.j=l,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(N.$s&&i.$pS.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const l=this.j.getAnchor();let D;if(n.$pT(l)){const E=n.$WS(l),R=n.$XS(l);D={top:E.top*R,left:E.left*R,width:E.width*R,height:E.height*R}}else v(l)?D={top:l.y,left:l.x,width:l.width||1,height:l.height||2}:D={top:l.posy,left:l.posx,width:2,height:2};const T=n.$YS(this.f),A=n.$3S(this.f),d=this.j.anchorPosition||p.BELOW,f=this.j.anchorAlignment||c.LEFT,m=this.j.anchorAxisAlignment||y.VERTICAL;let S,H;const U=n.$fT();if(m===y.VERTICAL){const E={offset:D.top-U.pageYOffset,size:D.height,position:d===p.BELOW?$.Before:$.After},R={offset:D.left,size:D.width,position:f===c.LEFT?$.Before:$.After,mode:g.ALIGN};S=e(U.innerHeight,A,E)+U.pageYOffset,k.Range.intersects({start:S,end:S+A},{start:E.offset,end:E.offset+E.size})&&(R.mode=g.AVOID),H=e(U.innerWidth,T,R)}else{const E={offset:D.left,size:D.width,position:f===c.LEFT?$.Before:$.After},R={offset:D.top,size:D.height,position:d===p.BELOW?$.Before:$.After,mode:g.ALIGN};H=e(U.innerWidth,T,E),k.Range.intersects({start:H,end:H+T},{start:E.offset,end:E.offset+E.size})&&(R.mode=g.AVOID),S=e(U.innerHeight,A,R)+U.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(d===p.BELOW?"bottom":"top"),this.f.classList.add(f===c.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const C=n.$WS(this.c);this.f.style.top=`${S-(this.g?n.$WS(this.f).top:C.top)}px`,this.f.style.left=`${H-(this.g?n.$WS(this.f).left:C.left)}px`,this.f.style.width="initial"}hide(l){const D=this.j;this.j=null,D?.onHide&&D.onHide(l),this.m.dispose(),n.$PT(this.f)}u(){return!!this.j}w(l,D){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(l,n.getWindow(l).document.activeElement):D&&!n.$5S(l.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$KU=s;const r=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(we[130],De([7]),{}),define(we[131],De([7]),{}),define(we[132],De([7]),{}),define(we[133],De([7]),{}),define(we[78],De([1,0,18,4,55,19,117,118,23,12,3,2,5,20,133]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=t.$vU=t.$uU=t.$tU=void 0,n=He(n),$=He($);const e=500,s=50,r=!0;class h{constructor(S,H,U){this.timestamp=S,this.deltaX=H,this.deltaY=U,this.score=0}}class l{static{this.INSTANCE=new l}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let S=1,H=0,U=1,C=this.d;do{const E=C===this.c?S:Math.pow(2,-U);if(S-=E,H+=this.b[C].score*E,C===this.c)break;C=(this.a+C-1)%this.a,U++}while(!0);return H<=.5}acceptStandardWheelEvent(S){if(i.$hS){const H=n.getWindow(S.browserEvent),U=(0,i.$aS)(H);this.accept(Date.now(),S.deltaX*U,S.deltaY*U)}else this.accept(Date.now(),S.deltaX,S.deltaY)}accept(S,H,U){let C=null;const E=new h(S,H,U);this.c===-1&&this.d===-1?(this.b[0]=E,this.c=0,this.d=0):(C=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=E),E.score=this.f(E,C)}f(S,H){if(Math.abs(S.deltaX)>0&&Math.abs(S.deltaY)>0)return 1;let U=.5;if((!this.g(S.deltaX)||!this.g(S.deltaY))&&(U+=.25),H){const C=Math.abs(S.deltaX),E=Math.abs(S.deltaY),R=Math.abs(H.deltaX),x=Math.abs(H.deltaY),I=Math.max(Math.min(C,R),1),_=Math.max(Math.min(E,x),1),V=Math.max(C,R),J=Math.max(E,x);V%I===0&&J%_===0&&(U-=.5)}return Math.min(Math.max(U,0),1)}g(S){return Math.abs(Math.round(S)-S)<.01}}t.$tU=l;class D extends v.$lU{get options(){return this.a}constructor(S,H,U){super(),this.O=this.B(new p.$ke),this.onScroll=this.O.event,this.P=this.B(new p.$ke),this.onWillScroll=this.P.event,S.style.overflow="hidden",this.a=f(H),this.b=U,this.B(this.b.onScroll(E=>{this.P.fire(E),this.S(E),this.O.fire(E)}));const C={onMouseWheel:E=>this.R(E),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new w.$sU(this.b,this.a,C)),this.g=this.B(new k.$rU(this.b,this.a,C)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(S),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$jU)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$jU)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$jU)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,E=>this.Z(E)),this.u(this.t,E=>this.Y(E)),this.L=this.B(new c.$Nh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,y.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(S){this.c.delegatePointerDown(S)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(S){this.b.setScrollDimensions(S,!1)}updateClassName(S){this.a.className=S,$.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(S){typeof S.handleMouseWheel<"u"&&(this.a.handleMouseWheel=S.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof S.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=S.mouseWheelScrollSensitivity),typeof S.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=S.fastScrollSensitivity),typeof S.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=S.scrollPredominantAxis),typeof S.horizontal<"u"&&(this.a.horizontal=S.horizontal),typeof S.vertical<"u"&&(this.a.vertical=S.vertical),typeof S.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=S.horizontalScrollbarSize),typeof S.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=S.verticalScrollbarSize),typeof S.scrollByPage<"u"&&(this.a.scrollByPage=S.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(S){this.N=S}delegateScrollFromMouseWheelEvent(S){this.R(new N.$uS(S))}Q(S){if(this.w.length>0!==S&&(this.w=(0,y.$Oc)(this.w),S)){const U=C=>{this.R(new N.$uS(C))};this.w.push(n.$AS(this.t,n.$BT.MOUSE_WHEEL,U,{passive:!1}))}}R(S){if(S.browserEvent?.defaultPrevented)return;const H=l.INSTANCE;r&&H.acceptStandardWheelEvent(S);let U=!1;if(S.deltaY||S.deltaX){let E=S.deltaY*this.a.mouseWheelScrollSensitivity,R=S.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&R+E===0?R=E=0:Math.abs(E)>=Math.abs(R)?R=0:E=0),this.a.flipAxes&&([E,R]=[R,E]);const x=!$.$k&&S.browserEvent&&S.browserEvent.shiftKey;(this.a.scrollYToX||x)&&!R&&(R=E,E=0),S.browserEvent&&S.browserEvent.altKey&&(R=R*this.a.fastScrollSensitivity,E=E*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let _={};if(E){const V=s*E,J=I.scrollTop-(V<0?Math.floor(V):Math.ceil(V));this.c.writeScrollPosition(_,J)}if(R){const V=s*R,J=I.scrollLeft-(V<0?Math.floor(V):Math.ceil(V));this.g.writeScrollPosition(_,J)}_=this.b.validateScrollPosition(_),(I.scrollLeft!==_.scrollLeft||I.scrollTop!==_.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(_):this.b.setScrollPositionNow(_),U=!0)}let C=U;!C&&this.a.alwaysConsumeMouseWheel&&(C=!0),!C&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(C=!0),C&&(S.preventDefault(),S.stopPropagation())}S(S){this.M=this.g.onDidScroll(S)||this.M,this.M=this.c.onDidScroll(S)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const S=this.b.getCurrentScrollPosition(),H=S.scrollTop>0,U=S.scrollLeft>0,C=U?" left":"",E=H?" top":"",R=U||H?" top-left-corner":"";this.n.setClassName(`shadow${C}`),this.r.setClassName(`shadow${E}`),this.s.setClassName(`shadow${R}${E}${C}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(S){this.J=!1,this.ab()}Z(S){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$uU=D;class T extends D{constructor(S,H){H=H||{},H.mouseWheelSmoothScroll=!1;const U=new g.$ct({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>n.$KS(n.getWindow(S),C)});super(S,H,U),this.B(U)}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$vU=T;class A extends D{constructor(S,H,U){super(S,H,U)}setScrollPosition(S){S.reuseAnimation?this.b.setScrollPositionSmooth(S,S.reuseAnimation):this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$wU=A;class d extends D{constructor(S,H){H=H||{},H.mouseWheelSmoothScroll=!1;const U=new g.$ct({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>n.$KS(n.getWindow(S),C)});super(S,H,U),this.B(U),this.cb=S,this.B(this.onScroll(C=>{C.scrollTopChanged&&(this.cb.scrollTop=C.scrollTop),C.scrollLeftChanged&&(this.cb.scrollLeft=C.scrollLeft)})),this.scanDomNode()}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$xU=d;function f(m){const S={lazyRender:typeof m.lazyRender<"u"?m.lazyRender:!1,className:typeof m.className<"u"?m.className:"",useShadows:typeof m.useShadows<"u"?m.useShadows:!0,handleMouseWheel:typeof m.handleMouseWheel<"u"?m.handleMouseWheel:!0,flipAxes:typeof m.flipAxes<"u"?m.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof m.consumeMouseWheelIfScrollbarIsNeeded<"u"?m.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof m.alwaysConsumeMouseWheel<"u"?m.alwaysConsumeMouseWheel:!1,scrollYToX:typeof m.scrollYToX<"u"?m.scrollYToX:!1,mouseWheelScrollSensitivity:typeof m.mouseWheelScrollSensitivity<"u"?m.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof m.fastScrollSensitivity<"u"?m.fastScrollSensitivity:5,scrollPredominantAxis:typeof m.scrollPredominantAxis<"u"?m.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof m.mouseWheelSmoothScroll<"u"?m.mouseWheelSmoothScroll:!0,arrowSize:typeof m.arrowSize<"u"?m.arrowSize:11,listenOnDomNode:typeof m.listenOnDomNode<"u"?m.listenOnDomNode:null,horizontal:typeof m.horizontal<"u"?m.horizontal:g.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof m.horizontalScrollbarSize<"u"?m.horizontalScrollbarSize:10,horizontalSliderSize:typeof m.horizontalSliderSize<"u"?m.horizontalSliderSize:0,horizontalHasArrows:typeof m.horizontalHasArrows<"u"?m.horizontalHasArrows:!1,vertical:typeof m.vertical<"u"?m.vertical:g.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof m.verticalScrollbarSize<"u"?m.verticalScrollbarSize:10,verticalHasArrows:typeof m.verticalHasArrows<"u"?m.verticalHasArrows:!1,verticalSliderSize:typeof m.verticalSliderSize<"u"?m.verticalSliderSize:0,scrollByPage:typeof m.scrollByPage<"u"?m.scrollByPage:!1};return S.horizontalSliderSize=typeof m.horizontalSliderSize<"u"?m.horizontalSliderSize:S.horizontalScrollbarSize,S.verticalSliderSize=typeof m.verticalSliderSize<"u"?m.verticalSliderSize:S.verticalScrollbarSize,$.$k&&(S.className+=" mac"),S}}),define(we[79],De([1,0,69,4,29,32,78,9,12,35,3,2,46,20,41,101,113,6,37]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2U=t.$1U=t.$ZU=t.$YU=t.ListViewTargetSector=void 0;const D={CurrentDragAndDropData:void 0};var T;(function(C){C[C.TOP=0]="TOP",C[C.CENTER_TOP=1]="CENTER_TOP",C[C.CENTER_BOTTOM=2]="CENTER_BOTTOM",C[C.BOTTOM=3]="BOTTOM"})(T||(t.ListViewTargetSector=T={}));const A={useShadows:!0,verticalScrollMode:g.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(C){return[C]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$YU=d;class f{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$ZU=f;class m{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let R=0;R<E.files.length;R++){const x=E.files.item(R);x&&(x.size||x.type)&&this.files.push(x)}}}getData(){return{types:this.types,files:this.files}}}t.$1U=m;function S(C,E){return Array.isArray(C)&&Array.isArray(E)?(0,w.$tb)(C,E):C===E}class H{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(R,x,I)=>I,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(R,x)=>x+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=R=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=R=>{}}}class U{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const R of this.d)this.ab(R);this.X(),this.q.setScrollDimensions({width:(0,n.$ZS)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,R,x,I=A){if(this.R=R,this.domId=`list_id_${++U.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new v.$Ah(50),this.v=!1,this.x=y.$Tc.None,this.y=0,this.G=!1,this.K=y.$Tc.None,this.L=y.$Tc.None,this.M=new y.$Sc,this.N=new p.$ke,this.O=new p.$ke,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,I.horizontalScrolling&&I.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(I.paddingTop??0);for(const V of x)this.j.set(V.templateId,V);this.h=this.M.add(new r.$XU(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof I.mouseSupport=="boolean"?I.mouseSupport:!0),this.P=I.horizontalScrolling??A.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof I.paddingBottom>"u"?0:I.paddingBottom,this.D=new H(I.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(I.transformOptimization??A.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(N.$hU.addTarget(this.o)),this.p=this.M.add(new g.$ct({forceIntegerValues:!0,smoothScrollDuration:I.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,n.$KS)((0,n.getWindow)(this.domNode),V)})),this.q=this.M.add(new k.$wU(this.o,{alwaysConsumeMouseWheel:I.alwaysConsumeMouseWheel??A.alwaysConsumeMouseWheel,horizontal:g.ScrollbarVisibility.Auto,vertical:I.verticalScrollMode??A.verticalScrollMode,useShadows:I.useShadows??A.useShadows,mouseWheelScrollSensitivity:I.mouseWheelScrollSensitivity,fastScrollSensitivity:I.fastScrollSensitivity,scrollByPage:I.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$AS)(this.o,N.EventType.Change,V=>this.jb(V))),this.M.add((0,n.$AS)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.M.add((0,n.$AS)(this.domNode,"dragover",V=>this.lb(this.hb(V)))),this.M.add((0,n.$AS)(this.domNode,"drop",V=>this.nb(this.hb(V)))),this.M.add((0,n.$AS)(this.domNode,"dragleave",V=>this.mb(this.hb(V)))),this.M.add((0,n.$AS)(this.domNode,"dragend",V=>this.ob(V))),this.z=I.setRowLineHeight??A.setRowLineHeight,this.A=I.setRowHeight??A.setRowHeight,this.B=I.supportDynamicHeights??A.supportDynamicHeights,this.F=I.dnd??this.M.add(A.dnd),this.layout(I.initialSize?.height,I.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let R;if(E.scrollByPage!==void 0&&(R={...R??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(R={...R??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(R={...R??{},fastScrollSensitivity:E.fastScrollSensitivity}),R&&this.q.updateOptions(R),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const x=this.vb(this.k,this.m),I=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(x,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,R,x){if(E<0||E>=this.d.length)return;const I=this.d[E].size;if(typeof R>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,R=I+this.xb(E)}if(I===R)return;const _=this.vb(this.k,this.m);let V=0;E<_.start||x!==null&&x>E&&x<_.end?V=R-I:V=0,this.g.splice(E,1,[{size:R}]),this.d[E].size=R,this.Y(_,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new s.$WU(E)}splice(E,R,x=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,R,x)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,R,x=[]){const I=this.vb(this.k,this.m),_={start:E,end:E+R},V=$.Range.intersect(I,_),J=new Map;for(let $e=V.end-1;$e>=V.start;$e--){const Te=this.d[$e];if(Te.dragStartDisposable.dispose(),Te.checkedDisposable.dispose(),Te.row){let Oe=J.get(Te.templateId);Oe||(Oe=[],J.set(Te.templateId,Oe));const Re=this.j.get(Te.templateId);Re&&Re.disposeElement&&Re.disposeElement(Te.element,$e,Te.row.templateData,Te.size),Oe.unshift(Te.row)}Te.row=null,Te.stale=!0}const q={start:E+R,end:this.d.length},z=$.Range.intersect(q,I),Q=$.Range.relativeComplement(q,I),ue=x.map($e=>({id:String(this.f++),element:$e,templateId:this.R.getTemplateId($e),size:this.R.getHeight($e),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight($e),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:y.$Tc.None,checkedDisposable:y.$Tc.None,stale:!1}));let be;E===0&&R>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ue),be=this.d,this.d=ue):(this.g.splice(E,R,ue),be=this.d.splice(E,R,...ue));const Ae=x.length-R,Fe=this.vb(this.k,this.m),ne=(0,s.$UU)(z,Ae),ee=$.Range.intersect(Fe,ne);for(let $e=ee.start;$e<ee.end;$e++)this.bb(this.d[$e],$e);const fe=$.Range.relativeComplement(ne,Fe);for(const $e of fe)for(let Te=$e.start;Te<$e.end;Te++)this.db(Te);const ae=Q.map($e=>(0,s.$UU)($e,Ae)),te=[{start:E,end:E+x.length},...ae].map($e=>$.Range.intersect(Fe,$e)).reverse();for(const $e of te)for(let Te=$e.end-1;Te>=$e.start;Te--){const Oe=this.d[Te],_e=J.get(Oe.templateId)?.pop();this.Z(Te,_e)}for(const $e of J.values())for(const Te of $e)this.h.release(Te);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),be.map($e=>$e.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$KS)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const R of this.d)typeof R.width<"u"&&(E=Math.max(E,R.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const R=this.d[E];this.ab(R),typeof R.width<"u"&&R.width>this.E&&(this.E=R.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,R=this.g.positionAt(E),x=this.g.positionAt(E+1);return x!==-1&&(x-R)/2+R<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(R=>R.element===E)}domElement(E){const R=this.d[E].row;return R&&R.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,R){const x={height:typeof E=="number"?E:(0,n.$2S)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,x.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(x),typeof R<"u"&&(this.n=R,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof R=="number"?R:(0,n.$ZS)(this.domNode)})}Y(E,R,x,I,_,V=!1){const J=this.vb(R,x),q=$.Range.relativeComplement(J,E).reverse(),z=$.Range.relativeComplement(E,J);if(V){const Q=$.Range.intersect(E,J);for(let ue=Q.start;ue<Q.end;ue++)this.bb(this.d[ue],ue)}this.h.transact(()=>{for(const Q of z)for(let ue=Q.start;ue<Q.end;ue++)this.db(ue);for(const Q of q)for(let ue=Q.end-1;ue>=Q.start;ue--)this.Z(ue)}),I!==void 0&&(this.o.style.left=`-${I}px`),this.o.style.top=`-${R}px`,this.Q&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=R,this.m=x}Z(E,R){const x=this.d[E];if(!x.row)if(R)x.row=R,x.stale=!0;else{const q=this.h.alloc(x.templateId);x.row=q.row,x.stale||=q.isReusingConnectedDomNode}const I=this.D.getRole(x.element)||"listitem";x.row.domNode.setAttribute("role",I);const _=this.D.isChecked(x.element);if(typeof _=="boolean")x.row.domNode.setAttribute("aria-checked",String(!!_));else if(_){const q=z=>x.row.domNode.setAttribute("aria-checked",String(!!z));q(_.value),x.checkedDisposable=_.onDidChange(()=>q(_.value))}if(x.stale||!x.row.domNode.parentElement){const q=this.d.at(E+1)?.row?.domNode??null;(x.row.domNode.parentElement!==this.o||x.row.domNode.nextElementSibling!==q)&&this.o.insertBefore(x.row.domNode,q),x.stale=!1}this.bb(x,E);const V=this.j.get(x.templateId);if(!V)throw new Error(`No renderer found for template id ${x.templateId}`);V?.renderElement(x.element,E,x.row.templateData,x.size);const J=this.F.getDragURI(x.element);x.dragStartDisposable.dispose(),x.row.domNode.draggable=!!J,J&&(x.dragStartDisposable=(0,n.$AS)(x.row.domNode,"dragstart",q=>this.kb(x.element,J,q))),this.Q&&(this.ab(x),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,n.$ZS)(E.row.domNode);const R=(0,n.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);R.paddingLeft&&(E.width+=parseFloat(R.paddingLeft)),R.paddingRight&&(E.width+=parseFloat(R.paddingRight)),E.row.domNode.style.width=""}bb(E,R){E.row.domNode.style.top=`${this.elementTop(R)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${R}`),E.row.domNode.setAttribute("data-last-element",R===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",R%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,R,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,R))),E.row.domNode.setAttribute("id",this.getElementDomId(R)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const R=this.d[E];if(R.dragStartDisposable.dispose(),R.checkedDisposable.dispose(),R.row){const x=this.j.get(R.templateId);x&&x.disposeElement&&x.disposeElement(R.element,E,R.row.templateData,R.size),this.h.release(R.row),R.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,R){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:R})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new B.$OU(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new B.$OU(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new B.$OU(this.domNode,N.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new B.$OU(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new B.$OU(this.o,N.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const R=this.ub(E.target||null),x=typeof R>"u"?void 0:this.d[R],I=x&&x.element;return{browserEvent:E,index:R,element:I}}fb(E){const R=this.ub(E.target||null),x=typeof R>"u"?void 0:this.d[R],I=x&&x.element;return{browserEvent:E,index:R,element:I}}gb(E){const R=this.ub(E.initialTarget||null),x=typeof R>"u"?void 0:this.d[R],I=x&&x.element;return{browserEvent:E,index:R,element:I}}hb(E){const R=this.ub(E.target||null),x=typeof R>"u"?void 0:this.d[R],I=x&&x.element,_=this.tb(E,R);return{browserEvent:E,index:R,element:I,sector:_}}ib(E){try{const R=this.vb(this.k,this.m);this.Y(R,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(R){throw console.error("Got bad scroll event:",E),R}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,R,x){if(!x.dataTransfer)return;const I=this.F.getDragElements(E);if(x.dataTransfer.effectAllowed="copyMove",x.dataTransfer.setData(i.$fU.TEXT,R),x.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(I,x)),typeof _>"u"&&(_=String(I.length));const V=(0,n.$)(".monaco-drag-image");V.textContent=_,(z=>{for(;z&&!z.classList.contains("monaco-workbench");)z=z.parentElement;return z||this.domNode.ownerDocument})(this.domNode).appendChild(V),x.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>V.remove(),0)}this.domNode.classList.add("dragging"),this.H=new d(I),D.CurrentDragAndDropData=new f(I),this.F.onDragStart?.(this.H,x)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),D.CurrentDragAndDropData&&D.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(D.CurrentDragAndDropData)this.H=D.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new m}const R=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof R=="boolean"?R:R.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof R!="boolean"&&R.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let x;typeof R!="boolean"&&R.feedback?x=R.feedback:typeof E.index>"u"?x=[-1]:x=[E.index],x=(0,w.$Lb)(x).filter(_=>_>=-1&&_<this.length).sort((_,V)=>_-V),x=x[0]===-1?[-1]:x;let I=typeof R!="boolean"&&R.effect&&R.effect.position?R.effect.position:e.ListDragOverEffectPosition.Over;if(S(this.I,x)&&this.J===I)return!0;if(this.I=x,this.J=I,this.K.dispose(),x[0]===-1)this.domNode.classList.add(I),this.o.classList.add(I),this.K=(0,y.$Rc)(()=>{this.domNode.classList.remove(I),this.o.classList.remove(I)});else{if(x.length>1&&I!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");I===e.ListDragOverEffectPosition.After&&x[0]<this.length-1&&(x[0]+=1,I=e.ListDragOverEffectPosition.Before);for(const _ of x){const V=this.d[_];V.dropTarget=!0,V.row?.domNode.classList.add(I)}this.K=(0,y.$Rc)(()=>{for(const _ of x){const V=this.d[_];V.dropTarget=!1,V.row?.domNode.classList.remove(I)}})}return!0}mb(E){this.L.dispose(),this.L=(0,v.$Fh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const R=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,D.CurrentDragAndDropData=void 0,!(!R||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),R.update(E.browserEvent.dataTransfer),this.F.drop(R,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,D.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=y.$Tc.None}qb(E){if(!this.w){const R=(0,n.$TS)(this.domNode).top;this.w=(0,n.$XT)((0,n.getWindow)(this.domNode),this.rb.bind(this,R))}this.x.dispose(),this.x=(0,v.$Fh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const R=this.y-E,x=this.renderHeight-35;R<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(R-35))):R>x&&(this.scrollTop+=Math.min(14,Math.floor(.3*(R-x))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,R){if(R===void 0)return;const x=E.offsetY/this.d[R].size,I=Math.floor(x/.25);return(0,l.$Jm)(I,0,3)}ub(E){const R=this.q.getDomNode();let x=E;for(;((0,n.$pT)(x)||(0,n.$wT)(x))&&x!==this.o&&R.contains(x);){const I=x.getAttribute("data-index");if(I){const _=Number(I);if(!isNaN(_))return _}x=x.parentElement}}vb(E,R){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+R-1)}}wb(E,R,x){const I=this.vb(E,R);let _,V;E===this.elementTop(I.start)?(_=I.start,V=0):I.end-I.start>1&&(_=I.start+1,V=this.elementTop(_)-E);let J=0;for(;;){const q=this.vb(E,R);let z=!1;for(let Q=q.start;Q<q.end;Q++){const ue=this.xb(Q);ue!==0&&this.g.splice(Q,1,[this.d[Q]]),J+=ue,z=z||ue!==0}if(!z){J!==0&&this.V();const Q=$.Range.relativeComplement(I,q);for(const be of Q)for(let Ae=be.start;Ae<be.end;Ae++)this.d[Ae].row&&this.db(Ae);const ue=$.Range.relativeComplement(q,I).reverse();for(const be of ue)for(let Ae=be.end-1;Ae>=be.start;Ae--)this.Z(Ae);for(let be=q.start;be<q.end;be++)this.d[be].row&&this.bb(this.d[be],be);if(typeof _=="number"){const be=this.p.getFutureScrollPosition().scrollTop-E,Ae=this.elementTop(_)-V+be;this.setScrollTop(Ae,x)}this.N.fire(this.contentHeight);return}}}xb(E){const R=this.d[E];if(this.R.getDynamicHeight){const V=this.R.getDynamicHeight(R.element);if(V!==null){const J=R.size;return R.size=V,R.lastDynamicHeightWidth=this.n,V-J}}if(!R.hasDynamicHeight||R.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(R.element))return 0;const x=R.size;if(R.row)return R.row.domNode.style.height="",R.size=R.row.domNode.offsetHeight,R.size===0&&!(0,n.$5S)(R.row.domNode,(0,n.getWindow)(R.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),R.lastDynamicHeightWidth=this.n,R.size-x;const{row:I}=this.h.alloc(R.templateId);I.domNode.style.height="",this.o.appendChild(I.domNode);const _=this.j.get(R.templateId);if(!_)throw new h.$bb("Missing renderer for templateId: "+R.templateId);return _.renderElement(R.element,E,I.templateData,void 0),R.size=I.domNode.offsetHeight,_.disposeElement?.(R.element,E,I.templateData,void 0),this.R.setDynamicHeight?.(R.element,R.size),R.lastDynamicHeightWidth=this.n,I.domNode.remove(),this.h.release(I),R.size-x}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const R=this.j.get(E.row.templateId);R&&(R.disposeElement?.(E.element,-1,E.row.templateData,void 0),R.disposeTemplate(E.row.templateData))}this.d=[],this.domNode?.remove(),this.w?.dispose(),this.M.dispose()}}t.$2U=U,et([c.$8h],U.prototype,"onMouseClick",null),et([c.$8h],U.prototype,"onMouseDblClick",null),et([c.$8h],U.prototype,"onMouseMiddleClick",null),et([c.$8h],U.prototype,"onMouseUp",null),et([c.$8h],U.prototype,"onMouseDown",null),et([c.$8h],U.prototype,"onMouseOver",null),et([c.$8h],U.prototype,"onMouseMove",null),et([c.$8h],U.prototype,"onMouseOut",null),et([c.$8h],U.prototype,"onContextMenu",null),et([c.$8h],U.prototype,"onTouchStart",null),et([c.$8h],U.prototype,"onTap",null)}),define(we[52],De([1,0,4,29,15,32,76,86,9,12,88,35,3,49,8,2,37,5,10,41,79,19,62,132]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r,h,l,D,T,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=t.$gV=t.$fV=t.$eV=t.$bV=t.TypeNavigationMode=void 0,t.$6U=U,t.$7U=E,t.$8U=R,t.$9U=x,t.$0U=I,t.$$U=_,t.$_U=V,t.$aV=J,t.$cV=Ae,t.$dV=Fe,h=He(h);class f{constructor(a){this.d=a,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(a){return a}renderElement(a,o,b){const M=this.c.findIndex(F=>F.templateData===b);if(M>=0){const F=this.c[M];this.d.unrender(b),F.index=o}else{const F={index:o,templateData:b};this.c.push(F)}this.d.renderIndex(o,b)}splice(a,o,b){const M=[];for(const F of this.c)F.index<a?M.push(F):F.index>=a+o&&M.push({index:F.index+b-o,templateData:F.templateData});this.c=M}renderIndexes(a){for(const{index:o,templateData:b}of this.c)a.indexOf(o)>-1&&this.d.renderIndex(o,b)}disposeTemplate(a){const o=this.c.findIndex(b=>b.templateData===a);o<0||this.c.splice(o,1)}}class m{get name(){return this.g}get renderer(){return new f(this)}constructor(a){this.g=a,this.c=[],this.d=[],this.f=new $.$ke,this.onChange=this.f.event}splice(a,o,b){const M=b.length-o,F=a+o,u=[];let L=0;for(;L<this.d.length&&this.d[L]<a;)u.push(this.d[L++]);for(let O=0;O<b.length;O++)b[O]&&u.push(O+a);for(;L<this.d.length&&this.d[L]>=F;)u.push(this.d[L++]+M);this.renderer.splice(a,o,b.length),this.h(u,u)}renderIndex(a,o){o.classList.toggle(this.g,this.contains(a))}unrender(a){a.classList.remove(this.g)}set(a,o){return this.h(a,[...a].sort(Oe),o)}h(a,o,b){const M=this.c,F=this.d;this.c=a,this.d=o;const u=$e(F,a);return this.renderer.renderIndexes(u),this.f.fire({indexes:a,browserEvent:b}),M}get(){return this.c}contains(a){return(0,v.$vb)(this.d,a,Oe)>=0}dispose(){(0,s.$Oc)(this.f)}}et([y.$8h],m.prototype,"renderer",null);class S extends m{constructor(a){super("selected"),this.k=a}renderIndex(a,o){super.renderIndex(a,o),this.k&&(this.contains(a)?o.setAttribute("aria-selected","true"):o.setAttribute("aria-selected","false"))}}class H{constructor(a,o,b){this.c=a,this.d=o,this.f=b}splice(a,o,b){if(!this.f)return this.c.splice(a,o,new Array(b.length).fill(!1));const M=this.c.get().map(L=>this.f.getId(this.d.element(L)).toString());if(M.length===0)return this.c.splice(a,o,new Array(b.length).fill(!1));const F=new Set(M),u=b.map(L=>F.has(this.f.getId(L).toString()));this.c.splice(a,o,u)}}function U(j){return j.tagName==="INPUT"||j.tagName==="TEXTAREA"}function C(j,a){return j.classList.contains(a)?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:C(j.parentElement,a)}function E(j){return C(j,"monaco-editor")}function R(j){return C(j,"monaco-custom-toggle")}function x(j){return C(j,"action-item")}function I(j){return C(j,"monaco-tl-twistie")}function _(j){return C(j,"monaco-tree-sticky-row")}function V(j){return j.classList.contains("monaco-tree-sticky-container")}function J(j){return j.tagName==="A"&&j.classList.contains("monaco-button")||j.tagName==="DIV"&&j.classList.contains("monaco-button-dropdown")?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:J(j.parentElement)}class q{get g(){return $.Event.chain(this.c.add(new n.$OU(this.k.domNode,"keydown")).event,a=>a.filter(o=>!U(o.target)).map(o=>new B.$xS(o)))}constructor(a,o,b){this.h=a,this.k=o,this.c=new s.$Sc,this.d=new s.$Sc,this.f=b.multipleSelectionSupport,this.c.add(this.g(M=>{switch(M.keyCode){case e.KeyCode.Enter:return this.l(M);case e.KeyCode.UpArrow:return this.o(M);case e.KeyCode.DownArrow:return this.p(M);case e.KeyCode.PageUp:return this.q(M);case e.KeyCode.PageDown:return this.s(M);case e.KeyCode.Escape:return this.u(M);case e.KeyCode.KeyA:this.f&&(h.$k?M.metaKey:M.ctrlKey)&&this.t(M)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.f=a.multipleSelectionSupport)}l(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection(this.h.getFocus(),a.browserEvent)}o(a){a.preventDefault(),a.stopPropagation(),this.h.focusPrevious(1,!1,a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}p(a){a.preventDefault(),a.stopPropagation(),this.h.focusNext(1,!1,a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}q(a){a.preventDefault(),a.stopPropagation(),this.h.focusPreviousPage(a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}s(a){a.preventDefault(),a.stopPropagation(),this.h.focusNextPage(a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}t(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection((0,v.$Qb)(this.h.length),a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(a){this.h.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.h.setSelection([],a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}et([y.$8h],q.prototype,"g",null);var z;(function(j){j[j.Automatic=0]="Automatic",j[j.Trigger=1]="Trigger"})(z||(t.TypeNavigationMode=z={}));var Q;(function(j){j[j.Idle=0]="Idle",j[j.Typing=1]="Typing"})(Q||(Q={})),t.$bV=new class{mightProducePrintableCharacter(j){return j.ctrlKey||j.metaKey||j.altKey?!1:j.keyCode>=e.KeyCode.KeyA&&j.keyCode<=e.KeyCode.KeyZ||j.keyCode>=e.KeyCode.Digit0&&j.keyCode<=e.KeyCode.Digit9||j.keyCode>=e.KeyCode.Numpad0&&j.keyCode<=e.KeyCode.Numpad9||j.keyCode>=e.KeyCode.Semicolon&&j.keyCode<=e.KeyCode.Quote}};class ue{constructor(a,o,b,M,F){this.o=a,this.p=o,this.q=b,this.s=M,this.t=F,this.c=!1,this.d=Q.Idle,this.f=z.Automatic,this.g=!1,this.h=-1,this.k=new s.$Sc,this.l=new s.$Sc,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.u():this.v(),this.f=a.typeNavigationMode??z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let a=!1;const o=$.Event.chain(this.k.add(new n.$OU(this.p.domNode,"keydown")).event,F=>F.filter(u=>!U(u.target)).filter(()=>this.f===z.Automatic||this.g).map(u=>new B.$xS(u)).filter(u=>a||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$DT.stop(u,!0)).map(u=>u.browserEvent.key)),b=$.Event.debounce(o,()=>null,800,void 0,void 0,void 0,this.k);$.Event.reduce($.Event.any(o,b),(F,u)=>u===null?null:(F||"")+u,void 0,this.k)(this.x,this,this.k),b(this.w,this,this.k),o(()=>a=!0,void 0,this.k),b(()=>a=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const a=this.o.getFocus();if(a.length>0&&a[0]===this.h){const o=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(a[0]));typeof o=="string"?(0,k.$QU)(o):o&&(0,k.$QU)(o.get())}this.h=-1}x(a){if(!a){this.d=Q.Idle,this.g=!1;return}const o=this.o.getFocus(),b=o.length>0?o[0]:0,M=this.d===Q.Idle?1:0;this.d=Q.Typing;for(let F=0;F<this.o.length;F++){const u=(b+F+M)%this.o.length,L=this.q.getKeyboardNavigationLabel(this.p.element(u)),O=L&&L.toString();if(this.o.options.typeNavigationEnabled){if(typeof O<"u"){if((0,g.$Gk)(a,O)){this.h=b,this.o.setFocus([u]),this.o.reveal(u);return}const P=(0,g.$Nk)(a,O);if(P&&P[0].end-P[0].start>1&&P.length===1){this.h=b,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof O>"u"||(0,g.$Gk)(a,O)){this.h=b,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class be{constructor(a,o){this.d=a,this.f=o,this.c=new s.$Sc;const b=$.Event.chain(this.c.add(new n.$OU(o.domNode,"keydown")).event,F=>F.filter(u=>!U(u.target)).map(u=>new B.$xS(u)));$.Event.chain(b,F=>F.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(a){if(a.target!==this.f.domNode)return;const o=this.d.getFocus();if(o.length===0)return;const b=this.f.domElement(o[0]);if(!b)return;const M=b.querySelector("[tabIndex]");if(!M||!(0,i.$pT)(M)||M.tabIndex===-1)return;const F=(0,i.getWindow)(M).getComputedStyle(M);F.visibility==="hidden"||F.display==="none"||(a.preventDefault(),a.stopPropagation(),M.focus())}dispose(){this.c.dispose()}}function Ae(j){return h.$k?j.browserEvent.metaKey:j.browserEvent.ctrlKey}function Fe(j){return j.browserEvent.shiftKey}function ne(j){return(0,i.$xT)(j)&&j.button===2}const ee={isSelectionSingleChangeEvent:Ae,isSelectionRangeChangeEvent:Fe};class fe{constructor(a){this.k=a,this.f=new s.$Sc,this.g=new $.$ke,this.onPointer=this.g.event,a.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ee),this.d=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.d&&(a.onMouseDown(this.s,this,this.f),a.onContextMenu(this.t,this,this.f),a.onMouseDblClick(this.v,this,this.f),a.onTouchStart(this.s,this,this.f),this.f.add(N.$hU.addTarget(a.getHTMLElement()))),$.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.u,this,this.f)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.c=void 0,a.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ee))}o(a){return this.c?this.c.isSelectionSingleChangeEvent(a):!1}p(a){return this.c?this.c.isSelectionRangeChangeEvent(a):!1}q(a){return this.o(a)||this.p(a)}s(a){E(a.browserEvent.target)||(0,i.$aT)()!==a.browserEvent.target&&this.k.domFocus()}t(a){if(U(a.browserEvent.target)||E(a.browserEvent.target))return;const o=typeof a.index>"u"?[]:[a.index];this.k.setFocus(o,a.browserEvent)}u(a){if(!this.d||U(a.browserEvent.target)||E(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=a.index;if(typeof o>"u"){this.k.setFocus([],a.browserEvent),this.k.setSelection([],a.browserEvent),this.k.setAnchor(void 0);return}if(this.q(a))return this.w(a);this.k.setFocus([o],a.browserEvent),this.k.setAnchor(o),ne(a.browserEvent)||this.k.setSelection([o],a.browserEvent),this.g.fire(a)}v(a){if(U(a.browserEvent.target)||E(a.browserEvent.target)||this.q(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=this.k.getFocus();this.k.setSelection(o,a.browserEvent)}w(a){const o=a.index;let b=this.k.getAnchor();if(this.p(a)){typeof b>"u"&&(b=this.k.getFocus()[0]??o,this.k.setAnchor(b));const M=Math.min(b,o),F=Math.max(b,o),u=(0,v.$Qb)(M,F+1),L=this.k.getSelection(),O=te($e(L,[b]),b);if(O.length===0)return;const P=$e(u,Te(L,O));this.k.setSelection(P,a.browserEvent),this.k.setFocus([o],a.browserEvent)}else if(this.o(a)){const M=this.k.getSelection(),F=M.filter(u=>u!==o);this.k.setFocus([o]),this.k.setAnchor(o),M.length===F.length?this.k.setSelection([...F,o],a.browserEvent):this.k.setSelection(F,a.browserEvent)}}dispose(){this.f.dispose()}}t.$eV=fe;class ae{constructor(a,o){this.c=a,this.d=o}style(a){const o=this.d&&`.${this.d}`,b=[];a.listBackground&&b.push(`.monaco-list${o} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(b.push(`.monaco-list${o}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),b.push(`.monaco-list${o}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&b.push(`.monaco-list${o}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(b.push(`.monaco-list${o}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),b.push(`.monaco-list${o}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&b.push(`.monaco-list${o}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&b.push(`.monaco-list${o}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&b.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&b.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(b.push(`.monaco-list${o} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),b.push(`.monaco-list${o} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&b.push(`.monaco-list${o} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(b.push(`.monaco-list${o} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),b.push(`.monaco-list${o} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(b.push(`.monaco-list${o} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),b.push(`.monaco-list${o} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&b.push(`.monaco-list${o} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&b.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&b.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const M=(0,i.$1T)(a.listFocusAndSelectionOutline,(0,i.$1T)(a.listSelectionOutline,a.listFocusOutline??""));M&&b.push(`.monaco-list${o}:focus .monaco-list-row.focused.selected { outline: 1px solid ${M}; outline-offset: -1px;}`),a.listFocusOutline&&b.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.$1T)(a.listSelectionOutline,a.listInactiveFocusOutline??"");F&&b.push(`.monaco-list${o} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),a.listSelectionOutline&&b.push(`.monaco-list${o} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&b.push(`.monaco-list${o} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&b.push(`.monaco-list${o} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&b.push(`
				.monaco-list${o}.drop-target,
				.monaco-list${o} .monaco-list-rows.drop-target,
				.monaco-list${o} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(b.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${o} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),b.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${o} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&b.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&b.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=b.join(`
`)}}t.$fV=ae,t.$gV={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$mu.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$mu.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$mu.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Ne={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(j,a){const o=j.indexOf(a);if(o===-1)return[];const b=[];let M=o-1;for(;M>=0&&j[M]===a-(o-M);)b.push(j[M--]);for(b.reverse(),M=o;M<j.length&&j[M]===a+(M-o);)b.push(j[M++]);return b}function $e(j,a){const o=[];let b=0,M=0;for(;b<j.length||M<a.length;)if(b>=j.length)o.push(a[M++]);else if(M>=a.length)o.push(j[b++]);else if(j[b]===a[M]){o.push(j[b]),b++,M++;continue}else j[b]<a[M]?o.push(j[b++]):o.push(a[M++]);return o}function Te(j,a){const o=[];let b=0,M=0;for(;b<j.length||M<a.length;)if(b>=j.length)o.push(a[M++]);else if(M>=a.length)o.push(j[b++]);else if(j[b]===a[M]){b++,M++;continue}else j[b]<a[M]?o.push(j[b++]):M++;return o}const Oe=(j,a)=>j-a;class Re{constructor(a,o){this.c=a,this.d=o}get templateId(){return this.c}renderTemplate(a){return this.d.map(o=>o.renderTemplate(a))}renderElement(a,o,b,M){let F=0;for(const u of this.d)u.renderElement(a,o,b[F++],M)}disposeElement(a,o,b,M){let F=0;for(const u of this.d)u.disposeElement?.(a,o,b[F],M),F+=1}disposeTemplate(a){let o=0;for(const b of this.d)b.disposeTemplate(a[o++])}}class _e{constructor(a){this.c=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.$Sc}}renderElement(a,o,b){const M=this.c.getAriaLabel(a),F=M&&typeof M!="string"?M:(0,d.constObservable)(M);b.disposables.add((0,d.autorun)(L=>{this.d(L.readObservable(F),b.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(a);typeof u=="number"?b.container.setAttribute("aria-level",`${u}`):b.container.removeAttribute("aria-level")}d(a,o){a?o.setAttribute("aria-label",a):o.removeAttribute("aria-label")}disposeElement(a,o,b,M){b.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class oe{constructor(a,o){this.c=a,this.d=o}getDragElements(a){const o=this.c.getSelectedElements();return o.indexOf(a)>-1?o:[a]}getDragURI(a){return this.d.getDragURI(a)}getDragLabel(a,o){if(this.d.getDragLabel)return this.d.getDragLabel(a,o)}onDragStart(a,o){this.d.onDragStart?.(a,o)}onDragOver(a,o,b,M,F){return this.d.onDragOver(a,o,b,M,F)}onDragLeave(a,o,b,M){this.d.onDragLeave?.(a,o,b,M)}onDragEnd(a){this.d.onDragEnd?.(a)}drop(a,o,b,M,F){this.d.drop(a,o,b,M,F)}dispose(){this.d.dispose()}}class K{get onDidChangeFocus(){return $.Event.map(this.g.wrapEvent(this.c.onChange),a=>this.G(a),this.y)}get onDidChangeSelection(){return $.Event.map(this.g.wrapEvent(this.d.onChange),a=>this.G(a),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let a=!1;const o=$.Event.chain(this.y.add(new n.$OU(this.k.domNode,"keydown")).event,F=>F.map(u=>new B.$xS(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$DT.stop(u,!0)).filter(()=>!1)),b=$.Event.chain(this.y.add(new n.$OU(this.k.domNode,"keyup")).event,F=>F.forEach(()=>a=!1).map(u=>new B.$xS(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$DT.stop(u,!0)).map(({browserEvent:u})=>{const L=this.getFocus(),O=L.length?L[0]:void 0,P=typeof O<"u"?this.k.element(O):void 0,X=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:P,anchor:X,browserEvent:u}})),M=$.Event.chain(this.k.onContextMenu,F=>F.filter(u=>!a).map(({element:u,index:L,browserEvent:O})=>({element:u,index:L,anchor:new A.$sS((0,i.getWindow)(this.k.domNode),O),browserEvent:O})));return $.Event.any(o,b,M)}get onKeyDown(){return this.y.add(new n.$OU(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$OU(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$OU(this.k.domNode,"keypress")).event}get onDidFocus(){return $.Event.signal(this.y.add(new n.$OU(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return $.Event.signal(this.y.add(new n.$OU(this.k.domNode,"blur",!0)).event)}constructor(a,o,b,M,F=Ne){this.A=a,this.B=F,this.c=new m("focused"),this.f=new m("anchor"),this.g=new $.$se,this.x="",this.y=new s.$Sc,this.z=new $.$ke,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new S(u!=="listbox");const L=[this.c.renderer,this.d.renderer];this.u=F.accessibilityProvider,this.u&&(L.push(new _e(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),M=M.map(P=>new Re(P.templateId,[...L,P]));const O={...F,dnd:F.dnd&&new oe(this,F.dnd)};if(this.k=this.C(o,b,M,O),this.k.domNode.setAttribute("role",u),F.styleController)this.q=F.styleController(this.k.domId);else{const P=(0,i.$iT)(this.k.domNode);this.q=new ae(P,this.k.domId)}if(this.o=new w.$SU([new H(this.c,this.k,F.identityProvider),new H(this.d,this.k,F.identityProvider),new H(this.f,this.k,F.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new be(this,this.k)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.v=new q(this,this.k,F),this.y.add(this.v)),F.keyboardNavigationLabelProvider){const P=F.keyboardNavigationDelegate||t.$bV;this.t=new ue(this,this.k,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),P),this.y.add(this.t)}this.w=this.D(F),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(a,o,b,M){return new T.$2U(a,o,b,M)}D(a){return new fe(this)}updateOptions(a={}){this.B={...this.B,...a},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(a),this.v?.updateOptions(a),this.k.updateOptions(a)}get options(){return this.B}splice(a,o,b=[]){if(a<0||a>this.k.length)throw new D.$4U(this.A,`Invalid start index: ${a}`);if(o<0)throw new D.$4U(this.A,`Invalid delete count: ${o}`);o===0&&b.length===0||this.g.bufferEvents(()=>this.o.splice(a,o,b))}updateWidth(a){this.k.updateWidth(a)}updateElementHeight(a,o){this.k.updateElementHeight(a,o,null)}rerender(){this.k.rerender()}element(a){return this.k.element(a)}indexOf(a){return this.k.indexOf(a)}indexAt(a){return this.k.indexAt(a)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(a){this.k.setScrollTop(a)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(a){this.k.setScrollLeft(a)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(a){this.x=a,this.k.domNode.setAttribute("aria-label",a)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(a,o){this.k.layout(a,o)}triggerTypeNavigation(){this.t?.trigger()}setSelection(a,o){for(const b of a)if(b<0||b>=this.length)throw new D.$4U(this.A,`Invalid index ${b}`);this.d.set(a,o)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(a=>this.k.element(a))}setAnchor(a){if(typeof a>"u"){this.f.set([]);return}if(a<0||a>=this.length)throw new D.$4U(this.A,`Invalid index ${a}`);this.f.set([a])}getAnchor(){return(0,v.$Nb)(this.f.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,o){for(const b of a)if(b<0||b>=this.length)throw new D.$4U(this.A,`Invalid index ${b}`);this.c.set(a,o)}focusNext(a=1,o=!1,b,M){if(this.length===0)return;const F=this.c.get(),u=this.E(F.length>0?F[0]+a:0,o,M);u>-1&&this.setFocus([u],b)}focusPrevious(a=1,o=!1,b,M){if(this.length===0)return;const F=this.c.get(),u=this.F(F.length>0?F[0]-a:0,o,M);u>-1&&this.setFocus([u],b)}async focusNextPage(a,o){let b=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);b=b===0?0:b-1;const M=this.getFocus()[0];if(M!==b&&(M===void 0||b>M)){const F=this.F(b,!1,o);F>-1&&M!==F?this.setFocus([F],a):this.setFocus([b],a)}else{const F=this.k.getScrollTop();let u=F+this.k.renderHeight;b>M&&(u-=this.k.elementHeight(b)),this.k.setScrollTop(u),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,c.$Eh)(0),await this.focusNextPage(a,o))}}async focusPreviousPage(a,o,b=()=>0){let M;const F=b(),u=this.k.getScrollTop()+F;u===0?M=this.k.indexAt(u):M=this.k.indexAfter(u-1);const L=this.getFocus()[0];if(L!==M&&(L===void 0||L>=M)){const O=this.E(M,!1,o);O>-1&&L!==O?this.setFocus([O],a):this.setFocus([M],a)}else{const O=u;this.k.setScrollTop(u-this.k.renderHeight-F),this.k.getScrollTop()+b()!==O&&(this.setFocus([]),await(0,c.$Eh)(0),await this.focusPreviousPage(a,o,b))}}focusLast(a,o){if(this.length===0)return;const b=this.F(this.length-1,!1,o);b>-1&&this.setFocus([b],a)}focusFirst(a,o){this.focusNth(0,a,o)}focusNth(a,o,b){if(this.length===0)return;const M=this.E(a,!1,b);M>-1&&this.setFocus([M],o)}E(a,o=!1,b){for(let M=0;M<this.length;M++){if(a>=this.length&&!o)return-1;if(a=a%this.length,!b||b(this.element(a)))return a;a++}return-1}F(a,o=!1,b){for(let M=0;M<this.length;M++){if(a<0&&!o)return-1;if(a=(this.length+a%this.length)%this.length,!b||b(this.element(a)))return a;a--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(a=>this.k.element(a))}reveal(a,o,b=0){if(a<0||a>=this.length)throw new D.$4U(this.A,`Invalid index ${a}`);const M=this.k.getScrollTop(),F=this.k.elementTop(a),u=this.k.elementHeight(a);if((0,l.$hg)(o)){const L=u-this.k.renderHeight+b;this.k.setScrollTop(L*(0,r.$Jm)(o,0,1)+F-b)}else{const L=F+u,O=M+this.k.renderHeight;F<M+b&&L>=O||(F<M+b||L>=O&&u>=this.k.renderHeight?this.k.setScrollTop(F-b):L>=O&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(a,o=0){if(a<0||a>=this.length)throw new D.$4U(this.A,`Invalid index ${a}`);const b=this.k.getScrollTop(),M=this.k.elementTop(a),F=this.k.elementHeight(a);if(M<b+o||M+F>b+this.k.renderHeight)return null;const u=F-this.k.renderHeight+o;return Math.abs((b+o-M)/u)}isDOMFocused(){return(0,i.$bT)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(a){return this.k.getElementDomId(a)}getElementTop(a){return this.k.elementTop(a)}style(a){this.q.style(a)}G({indexes:a,browserEvent:o}){return{indexes:a,elements:a.map(b=>this.k.element(b)),browserEvent:o}}H(){const a=this.c.get();this.k.domNode.classList.toggle("element-focused",a.length>0),this.I()}I(){const a=this.c.get();if(a.length>0){let o;this.u?.getActiveDescendantId&&(o=this.u.getActiveDescendantId(this.k.element(a[0]))),this.k.domNode.setAttribute("aria-activedescendant",o||this.k.getElementDomId(a[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const a=this.d.get();this.k.domNode.classList.toggle("selection-none",a.length===0),this.k.domNode.classList.toggle("selection-single",a.length===1),this.k.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$hV=K,et([y.$8h],K.prototype,"onDidChangeFocus",null),et([y.$8h],K.prototype,"onDidChangeSelection",null),et([y.$8h],K.prototype,"onContextMenu",null),et([y.$8h],K.prototype,"onKeyDown",null),et([y.$8h],K.prototype,"onKeyUp",null),et([y.$8h],K.prototype,"onKeyPress",null),et([y.$8h],K.prototype,"onDidFocus",null),et([y.$8h],K.prototype,"onDidBlur",null)}),define(we[134],De([7]),{}),define(we[135],De([7]),{}),define(we[136],De([7]),{}),define(we[137],De([7]),{}),define(we[138],De([7]),{}),define(we[13],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=B,t.localize2=k;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(w,v){let c;return v.length===0?c=w:c=w.replace(/\{(\d+)\}/g,(p,y)=>{const $=y[0],g=v[$];let e=p;return typeof g=="string"?e=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(e=String(g)),e}),i&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function B(w,v,...c){return n(typeof w=="number"?N(w,v):v,c)}function N(w,v){const c=globalThis._VSCODE_NLS_MESSAGES?.[w];if(typeof c!="string"){if(typeof v=="string")return v;throw new Error(`!!! NLS MISSING: ${w} !!!`)}return c}function k(w,v,...c){let p;typeof w=="number"?p=N(w,v):p=v;const y=n(p,c);return{value:y,original:v===p?y:n(v,c)}}}),define(we[139],De([1,0,4,29,15,120,77,33,14,52,9,3,8,2,5,20,13,135]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rV=void 0,i=He(i),p=He(p);const h=i.$,l="selectOption.entry.template";class D{get templateId(){return l}renderTemplate(d){const f=Object.create(null);return f.root=d,f.text=i.$IT(d,h(".option-text")),f.detail=i.$IT(d,h(".option-detail")),f.decoratorRight=i.$IT(d,h(".option-decorator-right")),f}renderElement(d,f,m){const S=m,H=d.text,U=d.detail,C=d.decoratorRight,E=d.isDisabled;S.text.textContent=H,S.detail.textContent=U||"",S.decoratorRight.innerText=C||"",E?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(d){}}class T extends g.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(d,f,m,S,H){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=S,this.g=H||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=T.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new y.$ke,this.B(this.r),this.Q(),this.P(m),this.n=f||0,d&&this.setOptions(d,f),this.S()}O(d){!this.M&&d?this.M=this.B((0,w.$qV)().setupManagedHover((0,v.$EU)("mouse"),this.h,d)):this.M&&this.M.update(d)}getHeight(){return 22}getTemplateId(){return l}P(d){this.u=d,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$IT(this.w,h(".select-box-details-pane"));const f=i.$IT(this.w,h(".select-box-dropdown-container-width-control")),m=i.$IT(f,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$IT(m,this.D),this.G=k.AnchorPosition.BELOW,this.y=i.$iT(this.w),this.w.setAttribute("draggable","true"),this.B(i.$AS(this.w,i.$BT.DRAG_START,S=>{i.$DT.stop(S,!0)}))}Q(){this.B(i.$BS(this.h,"change",f=>{this.n=f.target.selectedIndex,this.r.fire({index:f.target.selectedIndex,selected:f.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$AS(this.h,i.$BT.CLICK,f=>{i.$DT.stop(f),this.f?this.Z(!0):this.Y()})),this.B(i.$AS(this.h,i.$BT.MOUSE_DOWN,f=>{i.$DT.stop(f)}));let d;this.B(i.$AS(this.h,"touchstart",f=>{d=this.f})),this.B(i.$AS(this.h,"touchend",f=>{i.$DT.stop(f),d?this.Z(!0):this.Y()})),this.B(i.$AS(this.h,i.$BT.KEY_DOWN,f=>{const m=new B.$xS(f);let S=!1;e.$k?(m.keyCode===$.KeyCode.DownArrow||m.keyCode===$.KeyCode.UpArrow||m.keyCode===$.KeyCode.Space||m.keyCode===$.KeyCode.Enter)&&(S=!0):(m.keyCode===$.KeyCode.DownArrow&&m.altKey||m.keyCode===$.KeyCode.UpArrow&&m.altKey||m.keyCode===$.KeyCode.Space||m.keyCode===$.KeyCode.Enter)&&(S=!0),S&&(this.Y(),i.$DT.stop(f,!0))}))}get onDidSelect(){return this.r.event}setOptions(d,f){p.$tb(this.m,d)||(this.m=d,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((m,S)=>{this.h.add(this.X(m.text,S,m.isDisabled)),typeof m.description=="string"&&(this.H=!0)})),f!==void 0&&(this.select(f),this.F=this.n)}setEnabled(d){this.h.disabled=!d}R(){this.z?.splice(0,this.z.length,this.m)}select(d){d>=0&&d<this.m.length?this.n=d:d>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(d){this.g.ariaLabel=d,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(d){this.h.tabIndex=d?0:-1}render(d){this.j=d,d.classList.add("select-container"),d.appendChild(this.h),this.U()}S(){const d=[];this.s.listFocusBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(d.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=d.join(`
`)}U(){const d=this.s.selectBackground??"",f=this.s.selectForeground??"",m=this.s.selectBorder??"";this.h.style.backgroundColor=d,this.h.style.color=f,this.h.style.borderColor=m}W(){const d=this.s.selectBackground??"",f=i.$1T(this.s.selectListBackground,d);this.C.style.backgroundColor=f,this.I.style.backgroundColor=f;const m=this.s.focusBorder??"";this.w.style.outlineColor=m,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(d,f,m){const S=document.createElement("option");return S.value=d,S.text=d,S.disabled=!!m,S}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(d){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),d&&this.h.focus(),this.u.hideContextView())}ab(d,f){return d.appendChild(this.w),this.cb(f),{dispose:()=>{this.w.remove()}}}bb(){let d=0;return this.m.forEach((f,m)=>{this.jb(m),this.I.offsetHeight>d&&(d=this.I.offsetHeight)}),d}cb(d){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const f=i.getWindow(this.h),m=i.$WS(this.h),S=i.getWindow(this.h).getComputedStyle(this.h),H=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),U=f.innerHeight-m.top-m.height-(this.g.minBottomMargin||0),C=m.top-T.b,E=this.h.offsetWidth,R=this.db(this.D),x=Math.max(R,Math.round(E)).toString()+"px";this.w.style.width=x,this.z.getHTMLElement().style.height="",this.z.layout();let I=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const _=this.H?this.L:0,V=I+H+_,J=Math.floor((U-H-_)/this.getHeight()),q=Math.floor((C-H-_)/this.getHeight());if(d)return m.top+m.height>f.innerHeight-22||m.top<T.b||J<1&&q<1?!1:(J<T.c&&q>J&&this.m.length>J?(this.G=k.AnchorPosition.ABOVE,this.C.remove(),this.I.remove(),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=k.AnchorPosition.BELOW,this.C.remove(),this.I.remove(),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(m.top+m.height>f.innerHeight-22||m.top<T.b||this.G===k.AnchorPosition.BELOW&&J<1||this.G===k.AnchorPosition.ABOVE&&q<1)return this.Z(!0),!1;if(this.G===k.AnchorPosition.BELOW){if(this.f&&J+q<1)return this.Z(!0),!1;V>U&&(I=J*this.getHeight())}else V>C&&(I=q*this.getHeight());return this.z.layout(I),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=I+H+"px",this.w.style.height=""):this.w.style.height=I+H+"px",this.jb(this.n),this.w.style.width=x,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(d){let f=0;if(d){let m=0,S=0;this.m.forEach((H,U)=>{const C=H.detail?H.detail.length:0,E=H.decoratorRight?H.decoratorRight.length:0,R=H.text.length+C+E;R>S&&(m=U,S=R)}),d.textContent=this.m[m].text+(this.m[m].decoratorRight?this.m[m].decoratorRight+" ":""),f=i.$YS(d)}return f}eb(d){if(this.z)return;this.C=i.$IT(d,h(".select-box-dropdown-list-container")),this.t=new D,this.z=this.B(new c.$hV("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let H=S.text;return S.detail&&(H+=`. ${S.detail}`),S.decoratorRight&&(H+=`. ${S.decoratorRight}`),S.description&&(H+=`. ${S.description}`),H},getWidgetAriaLabel:()=>(0,r.localize)(10403,null),getRole:()=>e.$k?"":"option",getWidgetRole:()=>"listbox"}})),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const f=this.B(new n.$OU(this.C,"keydown")),m=y.Event.chain(f.event,S=>S.filter(()=>this.z.length>0).map(H=>new B.$xS(H)));this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.Enter))(this.lb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.Tab))(this.lb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.Escape))(this.kb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.UpArrow))(this.nb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.DownArrow))(this.mb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.PageDown))(this.pb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.PageUp))(this.ob,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.Home))(this.qb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode===$.KeyCode.End))(this.rb,this)),this.B(y.Event.chain(m,S=>S.filter(H=>H.keyCode>=$.KeyCode.Digit0&&H.keyCode<=$.KeyCode.KeyZ||H.keyCode>=$.KeyCode.Semicolon&&H.keyCode<=$.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$AS(this.z.getHTMLElement(),i.$BT.POINTER_UP,S=>this.fb(S))),this.B(this.z.onMouseOver(S=>typeof S.index<"u"&&this.z.setFocus([S.index]))),this.B(this.z.onDidChangeFocus(S=>this.ib(S))),this.B(i.$AS(this.w,i.$BT.FOCUS_OUT,S=>{!this.f||i.$5S(S.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(d){if(!this.z.length)return;i.$DT.stop(d);const f=d.target;if(!f||f.classList.contains("slider"))return;const m=f.closest(".monaco-list-row");if(!m)return;const S=Number(m.getAttribute("data-index")),H=m.classList.contains("option-disabled");S>=0&&S<this.m.length&&!H&&(this.n=S,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(d,f){const m=H=>{for(let U=0;U<H.childNodes.length;U++){const C=H.childNodes.item(U);(C.tagName&&C.tagName.toLowerCase())==="img"?C.remove():m(C)}},S=(0,N.$kV)({value:d,supportThemeIcons:!0},{actionHandler:f});return S.element.classList.add("select-box-description-markdown"),m(S.element),S.element}ib(d){!this.f||!this.H||this.jb(d.indexes[0])}jb(d){this.I.innerText="";const f=this.m[d],m=f?.description??"",S=f?.descriptionIsMarkdown??!1;if(m){if(S){const H=f.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(m,H))}else this.I.innerText=m;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(d){i.$DT.stop(d),this.select(this.F),this.Z(!0)}lb(d){i.$DT.stop(d),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(d){if(this.n<this.m.length-1){i.$DT.stop(d,!0);const f=this.m[this.n+1].isDisabled;if(f&&this.m.length>this.n+2)this.n+=2;else{if(f)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(d){this.n>0&&(i.$DT.stop(d,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(d){i.$DT.stop(d),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(d){i.$DT.stop(d),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(d){i.$DT.stop(d),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(d){i.$DT.stop(d),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(d){const f=$.KeyCodeUtils.toString(d.keyCode);let m=-1;for(let S=0;S<this.m.length-1;S++)if(m=(S+this.n+1)%this.m.length,this.m[m].text.charAt(0).toUpperCase()===f&&!this.m[m].isDisabled){this.select(m),this.z.setFocus([m]),this.z.reveal(this.z.getFocus()[0]),i.$DT.stop(d);break}}dispose(){this.Z(!1),super.dispose()}}t.$rV=T}),define(we[140],De([1,0,52,139,115,23,5,134]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uV=t.$tV=void 0,t.$tV={...i.$gV,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends N.$lU{constructor(c,p,y,$,g){super(),k.$k&&!g?.useCustomDrawn?this.a=new B.$sV(c,p,$,g):this.a=new n.$rV(c,p,y,$,g),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(c,p){this.a.setOptions(c,p)}select(c){this.a.select(c)}setAriaLabel(c){this.a.setAriaLabel(c)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(c){this.a.setFocusable(c)}setEnabled(c){this.a.setEnabled(c)}render(c){this.a.render(c)}}t.$uV=w}),define(we[53],De([1,0,3,2,13]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mj=t.$lj=t.$kj=t.$jj=t.$ij=void 0,t.$nj=p,B=He(B);class N extends n.$Tc{constructor($,g="",e="",s=!0,r){super(),this.j=this.B(new i.$ke),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=g,this.w=e,this.z=s,this.D=r}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,g){this.D&&await this.D($)}}t.$ij=N;class k extends n.$Tc{constructor(){super(...arguments),this.f=this.B(new i.$ke),this.onWillRun=this.f.event,this.m=this.B(new i.$ke),this.onDidRun=this.m.event}async run($,g){if(!$.enabled)return;this.f.fire({action:$});let e;try{await this.u($,g)}catch(s){e=s}this.m.fire({action:$,error:e})}async u($,g){await $.run(g)}}t.$jj=k;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let g=[];for(const e of $)e.length&&(g.length?g=[...g,new w,...e]:g=e);return g}static{this.ID="vs.actions.separator"}async run(){}}t.$kj=w;class v{get actions(){return this.a}constructor($,g,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=g,this.class=s,this.a=e}async run(){}}t.$lj=v;class c extends N{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,B.localize(12992,null),void 0,!1)}}t.$mj=c;function p(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...$)=>y.run(...$)}}}),define(we[80],De([1,0,18,69,4,32,14,140,53,2,5,10,13,33,75]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CV=t.$BV=t.$AV=void 0,p=He(p),y=He(y),$=He($);class e extends c.$Tc{get action(){return this._action}constructor(l,D,T={}){super(),this.m=T,this._context=l||this,this._action=D,D instanceof v.$ij&&this.B(D.onDidChange(A=>{this.element&&this.t(A)}))}t(l){l.enabled!==void 0&&this.u(),l.checked!==void 0&&this.H(),l.class!==void 0&&this.G(),l.label!==void 0&&(this.w(),this.D()),l.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new v.$jj)),this.j}set actionRunner(l){this.j=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const D=this.element=l;this.B(N.$hU.addTarget(l));const T=this.m&&this.m.draggable;T&&(l.draggable=!0,i.$fS&&this.B((0,B.$AS)(l,B.$BT.DRAG_START,A=>A.dataTransfer?.setData(n.$fU.TEXT,this._action.label)))),this.B((0,B.$AS)(D,N.EventType.Tap,A=>this.onClick(A,!0))),this.B((0,B.$AS)(D,B.$BT.MOUSE_DOWN,A=>{T||B.$DT.stop(A,!0),this._action.enabled&&A.button===0&&D.classList.add("active")})),p.$k&&this.B((0,B.$AS)(D,B.$BT.CONTEXT_MENU,A=>{A.button===0&&A.ctrlKey===!0&&this.onClick(A)})),this.B((0,B.$AS)(D,B.$BT.CLICK,A=>{B.$DT.stop(A,!0),this.m&&this.m.isMenu||this.onClick(A)})),this.B((0,B.$AS)(D,B.$BT.DBLCLICK,A=>{B.$DT.stop(A,!0)})),[B.$BT.MOUSE_UP,B.$BT.MOUSE_OUT].forEach(A=>{this.B((0,B.$AS)(D,A,d=>{B.$DT.stop(d),D.classList.remove("active")}))})}onClick(l,D=!1){B.$DT.stop(l,!0);const T=y.$mg(this._context)?this.m?.useEventAsContext?l:{preserveFocus:D}:this._context;this.actionRunner.run(this._action,T)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const l=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=l;else if(!this.f&&l!==""){const D=this.m.hoverDelegate??(0,k.$EU)("element");this.f=this.q.add((0,g.$qV)().setupManagedHover(D,this.element,l))}else this.f&&this.f.update(l)}F(){if(this.element){const l=this.C()??"";this.element.setAttribute("aria-label",l)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$AV=e;class s extends e{constructor(l,D,T){super(l,D,T),this.m=T,this.m.icon=T.icon!==void 0?T.icon:!1,this.m.label=T.label!==void 0?T.label:!0,this.L=""}render(l){super.render(l),y.$ng(this.element);const D=document.createElement("a");if(D.classList.add("action-label"),D.setAttribute("role",this.M()),this.I=D,this.element.appendChild(D),this.m.label&&this.m.keybinding){const T=document.createElement("span");T.classList.add("keybinding"),T.textContent=this.m.keybinding,this.element.appendChild(T)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===v.$kj.ID?"presentation":this.m.isMenu?"menuitem":this.m.isTabList?"tab":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(l){this.I&&(this.I.tabIndex=l?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(l=this.action.label,this.m.keybinding&&(l=$.localize(10431,null,l,this.m.keybinding))),l??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const l=this.C()??"";this.I.setAttribute("aria-label",l)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.m.isTabList?this.I.setAttribute("aria-selected",this.action.checked?"true":"false"):(this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox"))):(this.I.classList.remove("checked"),this.I.removeAttribute(this.m.isTabList?"aria-selected":"aria-checked"),this.I.setAttribute("role",this.M())))}}t.$BV=s;class r extends e{constructor(l,D,T,A,d,f,m){super(l,D),this.b=new w.$uV(T,A,d,f,m),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(l,D){this.b.setOptions(l,D)}select(l){this.b.select(l)}g(){this.B(this.b.onDidSelect(l=>this.n(l.selected,l.index)))}n(l,D){this.actionRunner.run(this._action,this.r(l,D))}r(l,D){return l}setFocusable(l){this.b.setFocusable(l)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(l){this.b.render(l)}}t.$CV=r}),define(we[81],De([1,0,4,15,80,14,53,3,8,2,10,75]),function(le,t,i,n,B,N,k,w,v,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GU=t.ActionsOrientation=void 0,t.$HU=g,i=He(i),p=He(p);var y;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(y||(t.ActionsOrientation=y={}));class $ extends c.$Tc{constructor(s,r={}){super(),this.j=this.B(new c.$Sc),this.s=this.B(new c.$3c),this.y=!1,this.z=!0,this.D=this.B(new w.$ke),this.onDidBlur=this.D.event,this.F=this.B(new w.$ke({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new w.$ke),this.onDidRun=this.H.event,this.I=this.B(new w.$ke),this.onWillRun=this.I.event,this.b=r,this.m=r.context??null,this.n=this.b.orientation??y.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[v.KeyCode.Enter,v.KeyCode.Space]},this.f=r.hoverDelegate??this.B((0,N.$FU)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new k.$jj,this.j.add(this.g)),this.j.add(this.g.onDidRun(D=>this.H.fire(D))),this.j.add(this.g.onWillRun(D=>this.I.fire(D))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,l;switch(this.n){case y.HORIZONTAL:h=[v.KeyCode.LeftArrow],l=[v.KeyCode.RightArrow];break;case y.VERTICAL:h=[v.KeyCode.UpArrow],l=[v.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$AS(this.domNode,i.$BT.KEY_DOWN,D=>{const T=new n.$xS(D);let A=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(T.equals(h[0])||T.equals(h[1]))?A=this.Q():l&&(T.equals(l[0])||T.equals(l[1]))?A=this.P():T.equals(v.KeyCode.Escape)&&this.G?this.F.fire():T.equals(v.KeyCode.Home)?A=this.N():T.equals(v.KeyCode.End)?A=this.O():T.equals(v.KeyCode.Tab)&&d instanceof B.$AV&&d.trapsArrowNavigation?A=this.P():this.L(T)?this.r.keyDown?this.S(T):this.y=!0:A=!1,A&&(T.preventDefault(),T.stopPropagation())})),this.B(i.$AS(this.domNode,i.$BT.KEY_UP,D=>{const T=new n.$xS(D);this.L(T)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(T)),T.preventDefault(),T.stopPropagation()):(T.equals(v.KeyCode.Tab)||T.equals(v.KeyMod.Shift|v.KeyCode.Tab)||T.equals(v.KeyCode.UpArrow)||T.equals(v.KeyCode.DownArrow)||T.equals(v.KeyCode.LeftArrow)||T.equals(v.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$GT(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$aT()===this.domNode||!i.$5S(i.$aT(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const r=this.viewItems.find(h=>h instanceof B.$AV&&h.isEnabled());r instanceof B.$AV&&r.setFocusable(!0)}else this.viewItems.forEach(r=>{r instanceof B.$AV&&r.setFocusable(!1)})}L(s){let r=!1;return this.r.keys.forEach(h=>{r=r||s.equals(h)}),r}M(){for(let s=0;s<this.C.children.length;s++){const r=this.C.children[s];if(i.$5S(i.$aT(),r)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(r=>r.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(r=>this.H.fire(r))),this.j.add(this.g.onWillRun(r=>this.I.fire(r))),this.viewItems.forEach(r=>r.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(r=>r.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.$pT(s)){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let r=0;r<this.C.childNodes.length;r++)if(this.C.childNodes[r]===s)return this.viewItems[r].action}}push(s,r={}){const h=Array.isArray(s)?s:[s];let l=p.$hg(r.index)?r.index:null;h.forEach(D=>{const T=document.createElement("li");T.className="action-item",T.setAttribute("role","presentation");let A;const d={hoverDelegate:this.f,...r,isTabList:this.b.ariaRole==="tablist"};this.b.actionViewItemProvider&&(A=this.b.actionViewItemProvider(D,d)),A||(A=new B.$BV(this.context,D,d)),this.b.allowContextMenu||this.s.set(A,i.$AS(T,i.$BT.CONTEXT_MENU,f=>{i.$DT.stop(f,!0)})),A.actionRunner=this.g,A.setActionContext(this.context),A.render(T),this.z&&A instanceof B.$AV&&this.viewItems.length===0&&A.setFocusable(!0),l===null||l<0||l>=this.C.children.length?(this.C.appendChild(T),this.viewItems.push(A)):(this.C.insertBefore(T,this.C.children[l]),this.viewItems.splice(l,0,A),l++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.childNodes[s].remove(),this.s.deleteAndDispose(this.viewItems[s]),(0,c.$Oc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,c.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),i.$zS(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let r=!1,h;if(s===void 0?r=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(r=s),r&&typeof this.u>"u"){const l=this.viewItems.findIndex(D=>D.isEnabled());this.u=l===-1?void 0:l,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const r=this.u;let h;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=r,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==r&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===k.$kj.ID));return this.R(),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const r=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=r,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==r&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===k.$kj.ID));return this.R(!0),!0}R(s,r,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:r}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const l=this.u!==void 0?this.viewItems[this.u]:void 0;if(l){let D=!0;p.$rg(l.focus)||(D=!1),this.b.focusOnlyEnabledItems&&p.$rg(l.isEnabled)&&!l.isEnabled()&&(D=!1),l.action.id===k.$kj.ID&&(D=!1),D?(h||this.t!==this.u)&&(l.focus(s),this.t=this.u):(this.C.focus({preventScroll:r}),this.t=void 0),D&&l.showHover?.()}}S(s){if(typeof this.u>"u")return;const r=this.viewItems[this.u];if(r instanceof B.$AV){const h=r._context===null||r._context===void 0?s:r._context;this.run(r._action,h)}}async run(s,r){await this.g.run(s,r)}dispose(){this.m=void 0,this.viewItems=(0,c.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$GU=$;function g(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==k.$kj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===k.$kj.ID;h--)e.splice(h,1);let r=!1;for(let h=e.length-1;h>=0;h--){const l=e[h].id===k.$kj.ID;l&&!r?e.splice(h,1):l?l&&(r=!1):r=!0}return e}}),define(we[82],De([1,0,4,29,70,81,76,77,33,14,78,23,3,95,64,20,13,131]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rW=t.$qW=t.$pW=t.MessageType=void 0,i=He(i),k=He(k),r=He(r);const h=i.$;var l;(function(A){A[A.INFO=1]="INFO",A[A.WARNING=2]="WARNING",A[A.ERROR=3]="ERROR"})(l||(t.MessageType=l={})),t.$pW={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class D extends y.$lU{constructor(d,f,m){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new $.$ke),this.onDidChange=this.P.event,this.Q=this.B(new $.$ke),this.onDidHeightChange=this.Q.event,this.a=f,this.g=m,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$IT(d,h(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",H=i.$IT(this.element,h(".ibwrapper"));if(this.b=i.$IT(H,h(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$IT(H,h("div.mirror")),this.y.innerText="\xA0",this.N=new p.$vU(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$IT(d,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(E=>this.b.scrollTop=E.scrollTop));const U=this.B(new n.$OU(d.ownerDocument,"selectionchange")),C=$.Event.filter(U.event,()=>d.ownerDocument.getSelection()?.anchorNode===H);this.B(C(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new N.$GU(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(d){this.n=d,this.b.setAttribute("placeholder",d)}setTooltip(d){this.r=d,this.O?this.O.update(d):this.O=this.B((0,v.$qV)().setupManagedHover((0,c.$EU)("mouse"),this.b,d))}setAriaLabel(d){this.s=d,d?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(d){this.b.value!==d&&(this.b.value=d,this.Z())}get step(){return this.b.step}set step(d){this.b.step=d}get height(){return typeof this.J=="number"?this.J:i.$3S(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$bT(this.b)}select(d=null){this.b.select(),d&&(this.b.setSelectionRange(d.start,d.end),d.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const d=this.b.selectionStart;if(d===null)return null;const f=this.b.selectionEnd??d;return{start:d,end:f}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(d){d?this.enable():this.disable()}get width(){return i.$YS(this.b)}set width(d){if(this.g.flexibleHeight&&this.g.flexibleWidth){let f=0;if(this.y){const m=parseFloat(this.y.style.paddingLeft||"")||0,S=parseFloat(this.y.style.paddingRight||"")||0;f=m+S}this.b.style.width=d-f+"px"}else this.b.style.width=d+"px";this.y&&(this.y.style.width=d+"px")}set paddingRight(d){this.b.style.width=`calc(100% - ${d}px)`,this.y&&(this.y.style.paddingRight=d+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const d=this.L,f=this.J,m=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:d,height:f}),this.N.setScrollPosition({scrollTop:m})}showMessage(d,f){if(this.w==="open"&&(0,e.$go)(this.h,d))return;this.h=d,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(d.type));const m=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$1T(m.border,"transparent")}`,this.h.content&&(this.hasFocus()||f)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let d=null;return this.t&&(d=this.t(this.value),d?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(d)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),d?.type}stylesForType(d){const f=this.g.inputBoxStyles;switch(d){case l.INFO:return{border:f.inputValidationInfoBorder,background:f.inputValidationInfoBackground,foreground:f.inputValidationInfoForeground};case l.WARNING:return{border:f.inputValidationWarningBorder,background:f.inputValidationWarningBackground,foreground:f.inputValidationWarningForeground};default:return{border:f.inputValidationErrorBorder,background:f.inputValidationErrorBackground,foreground:f.inputValidationErrorForeground}}}W(d){switch(d){case l.INFO:return"info";case l.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let d;const f=()=>d.style.width=i.$YS(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:w.AnchorAlignment.RIGHT,render:S=>{if(!this.h)return null;d=i.$IT(S,h(".monaco-inputbox-container")),f();const H={inline:!0,className:"monaco-inputbox-message"},U=this.h.formatContent?(0,B.$MU)(this.h.content,H):(0,B.$LU)(this.h.content,H);U.classList.add(this.W(this.h.type));const C=this.stylesForType(this.h.type);return U.style.backgroundColor=C.background??"",U.style.color=C.foreground??"",U.style.border=C.border?`1px solid ${C.border}`:"",i.$IT(d,U),null},onHide:()=>{this.w="closed"},layout:f});let m;this.h.type===l.ERROR?m=r.localize(10407,null,this.h.content):this.h.type===l.WARNING?m=r.localize(10408,null,this.h.content):m=r.localize(10409,null,this.h.content),k.$QU(m),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const d=this.value,m=d.charCodeAt(d.length-1)===10?" ":"";(d+m).replace(/\u000c/g,"")?this.y.textContent=d+m:this.y.innerText="\xA0",this.layout()}bb(){const d=this.g.inputBoxStyles,f=d.inputBackground??"",m=d.inputForeground??"",S=d.inputBorder??"";this.element.style.backgroundColor=f,this.element.style.color=m,this.b.style.backgroundColor="inherit",this.b.style.color=m,this.element.style.border=`1px solid ${i.$1T(S,"transparent")}`}layout(){if(!this.y)return;const d=this.L;this.L=i.$3S(this.y),d!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(d){const f=this.inputElement,m=f.selectionStart,S=f.selectionEnd,H=f.value;m!==null&&S!==null&&(this.value=H.substr(0,m)+d+H.substr(S),f.setSelectionRange(m+1,m+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$qW=D;class T extends D{constructor(d,f,m){const S=r.localize(10410,null,"\u21C5"),H=r.localize(10411,null,"\u21C5");super(d,f,m),this.eb=this.B(new $.$ke),this.onDidFocus=this.eb.event,this.fb=this.B(new $.$ke),this.onDidBlur=this.fb.event,this.cb=new g.$nW(m.history,100);const U=()=>{if(m.showHistoryHint&&m.showHistoryHint()&&!this.n.endsWith(S)&&!this.n.endsWith(H)&&this.cb.getHistory().length){const C=this.n.endsWith(")")?S:H,E=this.n+C;m.showPlaceholderOnFocus&&!i.$bT(this.b)?this.n=E:this.setPlaceHolder(E)}};this.db=new MutationObserver((C,E)=>{C.forEach(R=>{R.target.textContent||U()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>U()),this.F(this.b,()=>{const C=E=>{if(this.n.endsWith(E)){const R=this.n.slice(0,this.n.length-E.length);return m.showPlaceholderOnFocus?this.n=R:this.setPlaceHolder(R),!0}else return!1};C(H)||C(S)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(d){this.value&&(d||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(d){const f=this.getHistory();this.clearHistory(),d.forEach(m=>{this.cb.add(m)}),f.forEach(m=>{this.cb.add(m)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let d=this.kb();d&&(d=d===this.value?this.kb():d),this.value=d??"",k.$RU(this.value?this.value:r.localize(10412,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let d=this.jb();d&&(d=d===this.value?this.jb():d),d&&(this.value=d,k.$RU(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(d){super.setPlaceHolder(d),this.setTooltip(d)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let d=this.cb.current();return d||(d=this.cb.last(),this.cb.next()),d}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$rW=T}),define(we[83],De([1,0,80,23,21,22,3,8,4,14,33,136]),function(le,t,i,n,B,N,k,w,v,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zV=t.$yV=t.$xV=t.$wV=t.$vV=void 0,t.$vV={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends i.$AV{constructor(r,h,l){super(r,h,l),this.a=this.B(new $({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(r){this.element=r,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$wV=y;class $ extends n.$lU{constructor(r){super(),this.a=this.B(new k.$ke),this.onChange=this.a.event,this.b=this.B(new k.$ke),this.onKeyDown=this.b.event,this.c=r,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...N.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,p.$qV)().setupManagedHover(r.hoverDelegate??(0,c.$EU)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,l=>{if(l.keyCode===w.KeyCode.Space||l.keyCode===w.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(r){this.s=r,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(r){this.g&&this.domNode.classList.remove(...N.ThemeIcon.asClassNameArray(this.g)),this.g=r,this.g&&this.domNode.classList.add(...N.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this.t.update(r),this.domNode.setAttribute("aria-label",r)}set visible(r){this.domNode.style.display=r?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$xV=$;class g extends n.$lU{static{this.CLASS_NAME="monaco-checkbox"}constructor(r,h,l){super(),this.g=r,this.h=h,this.a=this.B(new k.$ke),this.onChange=this.a.event,this.b=this.B(new $({title:this.g,isChecked:this.h,icon:B.$3j.check,actionClassName:g.CLASS_NAME,...t.$vV})),this.domNode=this.b.domNode,this.c=l,this.n(),this.B(this.b.onChange(D=>{this.n(),this.a.fire(D)}))}get checked(){return this.b.checked}set checked(r){this.b.checked=r,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,v.$bT)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$yV=g;class e extends i.$AV{constructor(r,h,l){super(r,h,l),this.a=this.B(new g(this._action.label,!!this._action.checked,l.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(r){if(this.element=r,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,v.$)("span.checkbox-label",void 0,this._action.label));this.B((0,v.$AS)(h,v.$BT.CLICK,l=>{this.a.checked=!this.a.checked,l.stopPropagation(),l.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$zV=e}),define(we[141],De([1,0,14,83,21,13]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xW=t.$wW=t.$vW=void 0,N=He(N);const k=N.localize(10419,null),w=N.localize(10420,null),v=N.localize(10421,null);class c extends n.$xV{constructor(g){super({icon:B.$3j.caseSensitive,title:k+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$EU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$vW=c;class p extends n.$xV{constructor(g){super({icon:B.$3j.wholeWord,title:w+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$EU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$wW=p;class y extends n.$xV{constructor(g){super({icon:B.$3j.regex,title:v+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$EU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$xW=y}),define(we[142],De([1,0,4,141,82,23,3,8,13,2,14,130]),function(le,t,i,n,B,N,k,w,v,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yW=void 0,i=He(i),v=He(v);const y=v.localize(10422,null);class $ extends N.$lU{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,r){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Uc),this.N=[],this.O=this.B(new k.$ke),this.onDidOptionChange=this.O.event,this.P=this.B(new k.$ke),this.onKeyDown=this.P.event,this.Q=this.B(new k.$ke),this.onMouseDown=this.Q.event,this.R=this.B(new k.$ke),this.onInput=this.R.event,this.S=this.B(new k.$ke),this.onKeyUp=this.S.event,this.U=this.B(new k.$ke),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new k.$ke),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=r.placeholder||"",this.b=r.validation,this.c=r.label||y,this.h=!!r.showCommonFindToggles;const h=r.appendCaseSensitiveLabel||"",l=r.appendWholeWordsLabel||"",D=r.appendRegexLabel||"",T=r.history||[],A=!!r.flexibleHeight,d=!!r.flexibleWidth,f=r.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$rW(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:T,showHistoryHint:r.showHistoryHint,flexibleHeight:A,flexibleWidth:d,flexibleMaxHeight:f,inputBoxStyles:r.inputBoxStyles}));const m=this.B((0,p.$FU)());if(this.h){this.J=this.B(new n.$xW({appendTitle:D,isChecked:!1,hoverDelegate:m,...r.toggleStyles})),this.B(this.J.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(H=>{this.W.fire(H)})),this.L=this.B(new n.$wW({appendTitle:l,isChecked:!1,hoverDelegate:m,...r.toggleStyles})),this.B(this.L.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$vW({appendTitle:h,isChecked:!1,hoverDelegate:m,...r.toggleStyles})),this.B(this.M.onChange(H=>{this.O.fire(H),!H&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(H=>{this.U.fire(H)}));const S=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,H=>{if(H.equals(w.KeyCode.LeftArrow)||H.equals(w.KeyCode.RightArrow)||H.equals(w.KeyCode.Escape)){const U=S.indexOf(this.domNode.ownerDocument.activeElement);if(U>=0){let C=-1;H.equals(w.KeyCode.RightArrow)?C=(U+1)%S.length:H.equals(w.KeyCode.LeftArrow)&&(U===0?C=S.length-1:C=U-1),H.equals(w.KeyCode.Escape)?(S[U].blur(),this.inputBox.focus()):C>=0&&S[C].focus(),i.$DT.stop(H,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(r?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$AS(this.inputBox.inputElement,"compositionstart",S=>{this.s=!0})),this.B(i.$AS(this.inputBox.inputElement,"compositionend",S=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,S=>this.P.fire(S)),this.C(this.inputBox.inputElement,S=>this.S.fire(S)),this.D(this.inputBox.inputElement,S=>this.R.fire()),this.j(this.inputBox.inputElement,S=>this.Q.fire(S))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new c.$Sc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(r=>{this.O.fire(r),!r&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,r)=>s+r.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$yW=$}),define(we[143],De([1,0,4,29,15,81,142,82,79,52,83,72,34,53,9,12,21,22,43,3,49,8,2,37,10,13,14,62,137]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r,h,l,D,T,A,d,f,m,S,H,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aX=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$_W=t.$$W=t.$0W=t.RenderIndentGuides=t.$9W=t.$8W=void 0;class C extends v.$YU{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(L=>L.element)),this.c=u}}function E(F){return F instanceof v.$YU?new C(F):F}class R{constructor(u,L){this.d=u,this.f=L,this.b=d.$Tc.None,this.c=new d.$Sc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,L){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(O=>O.element),L)}onDragStart(u,L){this.f.onDragStart?.(E(u),L)}onDragOver(u,L,O,P,X,Y=!0){const ie=this.f.onDragOver(E(u),L&&L.element,O,P,X),re=this.a!==L;if(re&&(this.b.dispose(),this.a=L),typeof L>"u")return ie;if(re&&typeof ie!="boolean"&&ie.autoExpand&&(this.b=(0,s.$Fh)(()=>{const Le=this.d(),de=Le.getNodeLocation(L);Le.isCollapsed(de)&&Le.setCollapsed(de,!1),this.a=void 0},500,this.c)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!Y){const Le=typeof ie=="boolean"?ie:ie.accept,de=typeof ie=="boolean"?void 0:ie.effect;return{accept:Le,effect:de,feedback:[O]}}return ie}if(ie.bubble===$.TreeDragOverBubble.Up){const Le=this.d(),de=Le.getNodeLocation(L),Ie=Le.getParentNodeLocation(de),Ve=Le.getNode(Ie),Ge=Ie&&Le.getListIndex(Ie);return this.onDragOver(u,Ve,Ge,P,X,!1)}const ce=this.d(),Ee=ce.getNodeLocation(L),ve=ce.getListIndex(Ee),ye=ce.getListRenderCount(Ee);return{...ie,feedback:(0,e.$Qb)(ve,ve+ye)}}drop(u,L,O,P,X){this.b.dispose(),this.a=void 0,this.f.drop(E(u),L&&L.element,O,P,X)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function x(F,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(L){return u.identityProvider.getId(L.element)}},dnd:u.dnd&&new R(F,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(L){return u.multipleSelectionController.isSelectionSingleChangeEvent({...L,element:L.element})},isSelectionRangeChangeEvent(L){return u.multipleSelectionController.isSelectionRangeChangeEvent({...L,element:L.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(L){const O=F(),P=O.getNodeLocation(L),X=O.getParentNodeLocation(P);return O.getNode(X).visibleChildrenCount},getPosInSet(L){return L.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?L=>u.accessibilityProvider.isChecked(L.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?L=>u.accessibilityProvider.getRole(L.element):()=>"treeitem",getAriaLabel(L){return u.accessibilityProvider.getAriaLabel(L.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?L=>u.accessibilityProvider.getAriaLevel(L.element):L=>L.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(L=>u.accessibilityProvider.getActiveDescendantId(L.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(L){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L.element)}}}}class I{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,L){this.a.setDynamicHeight?.(u.element,L)}}t.$8W=I;class _{static lift(u){return u instanceof _?u:new _(u)}static empty(u=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const L of u.expanded)this.expanded[L]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$9W=_;var V;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(V||(t.RenderIndentGuides=V={}));class J{get elements(){return this.b}constructor(u,L=[]){this.b=L,this.a=new d.$Sc,this.onDidChange=D.Event.forEach(u,O=>this.b=O,this.a)}dispose(){this.a.dispose()}}class q{static{this.a=8}constructor(u,L,O,P,X,Y={}){this.o=u,this.p=L,this.q=P,this.s=X,this.b=new Map,this.c=new Map,this.d=q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Tc.None,this.m=new d.$Sc,this.templateId=u.templateId,this.updateOptions(Y),D.Event.map(O,ie=>ie.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const L=(0,f.$Jm)(u.indent,0,40);if(L!==this.d){this.d=L;for(const[O,P]of this.c)this.v(O,P)}}if(typeof u.renderIndentGuides<"u"){const L=u.renderIndentGuides!==V.None;if(L!==this.g){this.g=L;for(const[O,P]of this.c)this.w(O,P);if(this.k.dispose(),L){const O=new d.$Sc;this.q.onDidChange(this.x,this,O),this.k=O,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const L=(0,i.$IT)(u,(0,i.$)(".monaco-tl-row")),O=(0,i.$IT)(L,(0,i.$)(".monaco-tl-indent")),P=(0,i.$IT)(L,(0,i.$)(".monaco-tl-twistie")),X=(0,i.$IT)(L,(0,i.$)(".monaco-tl-contents")),Y=this.o.renderTemplate(X);return{container:u,indent:O,twistie:P,indentGuidesDisposable:d.$Tc.None,templateData:Y}}renderElement(u,L,O,P){this.c.set(u,O),this.b.set(u.element,u),this.v(u,O),this.o.renderElement(u,L,O.templateData,P)}disposeElement(u,L,O,P){O.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,L,O.templateData,P),typeof P=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const L=this.b.get(u);L&&this.u(L)}u(u){const L=this.c.get(u);L&&(this.x(this.q.elements),this.v(u,L))}v(u,L){const O=q.a+(u.depth-1)*this.d;L.twistie.style.paddingLeft=`${O}px`,L.indent.style.width=`${O+this.d-16}px`,u.collapsible?L.container.setAttribute("aria-expanded",String(!u.collapsed)):L.container.removeAttribute("aria-expanded"),L.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$3j.treeItemExpanded));let P=!1;this.o.renderTwistie&&(P=this.o.renderTwistie(u.element,L.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(P||L.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$3j.treeItemExpanded)),L.twistie.classList.add("collapsible"),L.twistie.classList.toggle("collapsed",u.collapsed)):L.twistie.classList.remove("collapsible","collapsed"),this.w(u,L)}w(u,L){if((0,i.$zS)(L.indent),L.indentGuidesDisposable.dispose(),!this.g)return;const O=new d.$Sc,P=this.p();for(;;){const X=P.getNodeLocation(u),Y=P.getParentNodeLocation(X);if(!Y)break;const ie=P.getNode(Y),re=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ie)&&re.classList.add("active"),L.indent.childElementCount===0?L.indent.appendChild(re):L.indent.insertBefore(re,L.indent.firstElementChild),this.s.add(ie,re),O.add((0,d.$Rc)(()=>this.s.delete(ie,re))),u=ie}L.indentGuidesDisposable=O}x(u){if(!this.g)return;const L=new Set,O=this.p();u.forEach(P=>{const X=O.getNodeLocation(P);try{const Y=O.getParentNodeLocation(X);P.collapsible&&P.children.length>0&&!P.collapsed?L.add(P):Y&&L.add(O.getNode(Y))}catch{}}),this.j.forEach(P=>{L.has(P)||this.s.forEach(P,X=>X.classList.remove("active"))}),L.forEach(P=>{this.j.has(P)||this.s.forEach(P,X=>X.classList.add("active"))}),this.j=L}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Oc)(this.m)}}t.$0W=q;class z{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,L,O){this.g=u,this.j=L,this.k=O,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Sc,u.onWillRefilter(this.m,this,this.f)}filter(u,L){let O=$.TreeVisibility.Visible;if(this.k){const Y=this.k.filter(u,L);if(typeof Y=="boolean"?O=Y?$.TreeVisibility.Visible:$.TreeVisibility.Hidden:(0,y.$5W)(Y)?O=(0,y.$6W)(Y.visibility):O=Y,O===$.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:T.FuzzyScore.Default,visibility:O};const P=this.j.getKeyboardNavigationLabel(u),X=Array.isArray(P)?P:[P];for(const Y of X){const ie=Y&&Y.toString();if(typeof ie>"u")return{data:T.FuzzyScore.Default,visibility:O};let re;if(this.g.findMatchType===Fe.Contiguous){const ce=ie.toLowerCase().indexOf(this.d);if(ce>-1){re=[Number.MAX_SAFE_INTEGER,0];for(let Ee=this.d.length;Ee>0;Ee--)re.push(ce+Ee-1)}}else re=(0,T.$Sk)(this.c,this.d,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return this.b++,X.length===1?{data:re,visibility:O}:{data:{label:ie,score:re},visibility:O}}return this.g.findMode===Ae.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):$.TreeVisibility.Recurse:{data:T.FuzzyScore.Default,visibility:O}}m(){this.a=0,this.b=0}dispose(){(0,d.$Oc)(this.f)}}class Q extends p.$xV{constructor(u){super({icon:r.$3j.listFilter,title:(0,S.localize)(10394,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.$EU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$$W=Q;class ue extends p.$xV{constructor(u){super({icon:r.$3j.searchFuzzy,title:(0,S.localize)(10395,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,H.$EU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$_W=ue;const be={inputBoxStyles:w.$pW,toggleStyles:p.$vV,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Ae;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Ae||(t.TreeFindMode=Ae={}));var Fe;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class ne extends d.$Tc{set mode(u){this.b.checked=u===Ae.Filter,this.f.inputBox.setPlaceHolder(u===Ae.Filter?(0,S.localize)(10396,null):(0,S.localize)(10397,null))}set matchType(u){this.c.checked=u===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,L,O,P,X,Y){super(),this.t=L,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new D.$ke,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,d.$Rc)(()=>this.a.root.remove()));const ie=Y?.styles??be;ie.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const re=this.B((0,H.$FU)());this.b=this.B(new Q({...ie.toggleStyles,isChecked:P===Ae.Filter,hoverDelegate:re})),this.c=this.B(new ue({...ie.toggleStyles,isChecked:X===Fe.Fuzzy,hoverDelegate:re})),this.onDidChangeMode=D.Event.map(this.b.onChange,()=>this.b.checked?Ae.Filter:Ae.Highlight,this.q),this.onDidChangeMatchType=D.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new k.$yW(this.a.findInput,O,{label:(0,S.localize)(10398,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:Y?.history})),this.g=this.B(new N.$GU(this.a.actionbar)),this.mode=P;const ce=this.B(new n.$OU(this.f.inputBox.inputElement,"keydown")),Ee=D.Event.chain(ce.event,de=>de.map(Ie=>new B.$xS(Ie)));this.B(Ee(de=>{if(de.equals(A.KeyCode.Enter)){de.preventDefault(),de.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(de.equals(A.KeyCode.DownArrow)){de.preventDefault(),de.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(de.equals(A.KeyCode.UpArrow)){de.preventDefault(),de.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ve=this.B(new g.$ij("close",(0,S.localize)(10399,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ve,{icon:!0,label:!1});const ye=this.B(new n.$OU(this.a.grab,"mousedown"));this.B(ye.event(de=>{const Ie=new d.$Sc,Ve=Ie.add(new n.$OU((0,i.getWindow)(de),"mousemove")),Ge=Ie.add(new n.$OU((0,i.getWindow)(de),"mouseup")),tt=this.m,lt=de.pageX,st=this.s,qe=de.pageY;this.a.grab.classList.add("grabbing");const Ze=this.a.root.style.transition;this.a.root.style.transition="unset";const Z=he=>{const pe=he.pageX-lt;this.m=tt-pe;const ke=he.pageY-qe;this.s=st+ke,this.layout()};Ie.add(Ve.event(Z)),Ie.add(Ge.event(he=>{Z(he),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ze,Ie.dispose()}))}));const Le=D.Event.chain(this.B(new n.$OU(this.a.grab,"keydown")).event,de=>de.map(Ie=>new B.$xS(Ie)));this.B(Le(de=>{let Ie,Ve;if(de.keyCode===A.KeyCode.LeftArrow?Ie=Number.POSITIVE_INFINITY:de.keyCode===A.KeyCode.RightArrow?Ie=0:de.keyCode===A.KeyCode.Space&&(Ie=this.m===0?Number.POSITIVE_INFINITY:0),de.keyCode===A.KeyCode.UpArrow?Ve=0:de.keyCode===A.KeyCode.DownArrow&&(Ve=Number.POSITIVE_INFINITY),Ie!==void 0&&(de.preventDefault(),de.stopPropagation(),this.m=Ie,this.layout()),Ve!==void 0){de.preventDefault(),de.stopPropagation(),this.s=Ve;const Ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,f.$Jm)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,f.$Jm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Eh)(300),super.dispose()}}class ee{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,L,O,P,X,Y={}){this.t=u,this.u=O,this.v=P,this.w=X,this.x=Y,this.b="",this.c="",this.j=0,this.k=new D.$ke,this.onDidChangeMode=this.k.event,this.m=new D.$ke,this.onDidChangeMatchType=this.m.event,this.o=new D.$ke,this.onDidChangePattern=this.o.event,this.p=new D.$ke,this.onDidChangeOpenState=this.p.event,this.q=new d.$Sc,this.s=new d.$Sc,this.d=u.options.defaultFindMode??Ae.Highlight,this.f=u.options.defaultFindMatchType??Fe.Fuzzy,L.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ne(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,O=>!T.FuzzyScore.isDefault(O.filterData));const L=this.t.getFocus();if(L.length>0){const O=L[0];this.t.getRelativeTop(O)===null&&this.t.reveal(O,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:w.MessageType.WARNING,content:(0,S.localize)(10400,null)}):this.g?.showMessage({type:w.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!T.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function fe(F,u){return F.position===u.position&&ae(F,u)}function ae(F,u){return F.node.element===u.node.element&&F.startIndex===u.startIndex&&F.height===u.height&&F.endIndex===u.endIndex}class Ne{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$tb)(this.stickyNodes,u.stickyNodes,fe)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const L=this.stickyNodes[this.count-2];return L.position+L.height!==u.position}animationStateChanged(u){if(!(0,e.$tb)(this.stickyNodes,u.stickyNodes,ae)||this.count===0)return!1;const L=this.stickyNodes[this.count-1],O=u.stickyNodes[u.count-1];return L.position!==O.position}}class te{constrainStickyScrollNodes(u,L,O){for(let P=0;P<u.length;P++){const X=u[P];if(X.position+X.height>O||P>=L)return u.slice(0,P)}return u}}class $e extends d.$Tc{constructor(u,L,O,P,X,Y={}){super(),this.g=u,this.j=L,this.m=O,this.s=X,this.c=.4;const ie=this.validateStickySettings(Y);this.b=ie.stickyScrollMaxItemCount,this.a=Y.stickyScrollDelegate??new te,this.f=this.B(new Te(O.getScrollableElement(),O,u,P,X,Y.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(O.onDidScroll(()=>this.u())),this.B(O.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let L;if(u===0?L=this.m.firstVisibleIndex:L=this.m.indexAt(u+this.m.scrollTop),!(L<0||L>=this.m.length))return this.m.element(L)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const L=this.w(u);this.f.setState(L)}w(u){const L=[];let O=u,P=0,X=this.z(O,void 0,P);for(;X&&(L.push(X),P+=X.height,!(L.length<=this.b&&(O=this.y(X),!O)));)X=this.z(O,X.node,P);const Y=this.H(L);return Y.length?new Ne(Y):void 0}y(u){return this.t(u.position+u.height)}z(u,L,O){const P=this.F(u,L);if(P&&!(P===u&&(!this.J(u)||this.C(u,O))))return this.D(P,O)}C(u,L){const O=this.L(u),P=this.m.getElementTop(O),X=L;return this.m.scrollTop===P-X}D(u,L){const O=this.s.getHeight(u),{startIndex:P,endIndex:X}=this.M(u),Y=this.G(X,L,O);return{node:u,position:Y,height:O,startIndex:P,endIndex:X}}F(u,L=void 0){let O=u,P=this.I(O);for(;P;){if(P===L)return O;O=P,P=this.I(O)}if(L===void 0)return O}G(u,L,O){let P=this.m.getRelativeTop(u);if(P===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const ce=this.s.getHeight(this.m.element(u)),Ee=this.m.getRelativeTop(u+1);P=Ee?Ee-ce/this.m.renderHeight:null}if(P===null)return L;const X=this.m.element(u),Y=this.s.getHeight(X),re=P*this.m.renderHeight+Y;return L+O>re&&L<=re?re-O:L}H(u){if(u.length===0)return[];const L=this.m.renderHeight*this.c,O=u[u.length-1];if(u.length<=this.b&&O.position+O.height<=L)return u;const P=this.a.constrainStickyScrollNodes(u,this.b,L);if(!P.length)return[];const X=P[P.length-1];if(P.length>this.b||X.position+X.height>L)throw new Error("stickyScrollDelegate violates constraints");return P}I(u){const L=this.j.getNodeLocation(u),O=this.j.getParentNodeLocation(L);return O?this.j.getNode(O):void 0}J(u){const L=this.j.getNodeLocation(u);return this.j.getListRenderCount(L)>1}L(u){const L=this.j.getNodeLocation(u);return this.j.getListIndex(L)}M(u){const L=this.j.getNodeLocation(u),O=this.j.getListIndex(L);if(O<0)throw new Error("Node not found in tree");const P=this.j.getListRenderCount(L),X=O+P-1;return{startIndex:O,endIndex:X}}nodePositionTopBelowWidget(u){const L=[];let O=this.I(u);for(;O;)L.push(O),O=this.I(O);let P=0;for(let X=0;X<L.length&&X<this.b;X++)P+=this.s.getHeight(L[X]);return P}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const L=this.validateStickySettings(u);this.b!==L.stickyScrollMaxItemCount&&(this.b=L.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let L=7;return typeof u.stickyScrollMaxItemCount=="number"&&(L=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:L}}}class Te{constructor(u,L,O,P,X,Y){this.g=L,this.j=O,this.k=P,this.m=X,this.o=Y,this.c=[],this.d=new d.$Sc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ie),this.f=new Oe(this.a,L),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(L=>L.node===u)}setState(u){const L=!!this.b&&this.b.count>0,O=!!u&&u.count>0;if(!L&&!O||L&&O&&this.b.equal(u))return;if(L!==O&&this.s(O),!O){this.b=void 0,this.c=[],this.d.clear();return}const P=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${P.position}px`;else{this.d.clear();const X=Array(u.count);for(let Y=u.count-1;Y>=0;Y--){const ie=u.stickyNodes[Y],{element:re,disposable:ce}=this.p(ie,Y,u.count);X[Y]=re,this.a.appendChild(re),this.d.add(ce)}this.f.updateElements(X,u),this.c=X}this.b=u,this.a.style.height=`${P.position+P.height}px`}p(u,L,O){const P=u.startIndex,X=document.createElement("div");X.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(X.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(X.style.lineHeight=`${u.height}px`),X.classList.add("monaco-tree-sticky-row"),X.classList.add("monaco-list-row"),X.setAttribute("data-index",`${P}`),X.setAttribute("data-parity",P%2===0?"even":"odd"),X.setAttribute("id",this.g.getElementID(P));const Y=this.q(X,u.node.element,L,O),ie=this.m.getTemplateId(u.node),re=this.k.find(ye=>ye.templateId===ie);if(!re)throw new Error(`No renderer found for template id ${ie}`);let ce=u.node;ce===this.j.getNode(this.j.getNodeLocation(u.node))&&(ce=new Proxy(u.node,{}));const Ee=re.renderTemplate(X);re.renderElement(ce,u.startIndex,Ee,u.height);const ve=(0,d.$Rc)(()=>{Y.dispose(),re.disposeElement(ce,u.startIndex,Ee,u.height),re.disposeTemplate(Ee),X.remove()});return{element:X,disposable:ve}}q(u,L,O,P){if(!this.o)return d.$Tc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(L,O,P))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(L,O))),this.o.getRole&&u.setAttribute("role",this.o.getRole(L)??"treeitem");const X=this.o.getAriaLabel(L),Y=X&&typeof X!="string"?X:(0,U.constObservable)(X),ie=(0,U.autorun)(ce=>{const Ee=ce.readObservable(Y);Ee?u.setAttribute("aria-label",Ee):u.removeAttribute("aria-label")});typeof X=="string"||X&&u.setAttribute("aria-label",X.get());const re=this.o.getAriaLevel&&this.o.getAriaLevel(L);return typeof re=="number"&&u.setAttribute("aria-level",`${re}`),u.setAttribute("aria-selected",String(!1)),ie}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Oe extends d.$Tc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,L){super(),this.s=u,this.t=L,this.a=-1,this.b=[],this.f=new D.$ke,this.onDidChangeHasFocus=this.f.event,this.g=new D.$ke,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(O=>this.w(O))),this.B(this.t.onMouseDown(O=>this.y(O))),this.B(this.t.onContextMenu(O=>this.u(O)))}u(u){const L=u.browserEvent.target;if(!(0,c.$_U)(L)&&!(0,c.$$U)(L)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$yT)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.c.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(Y);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const P=this.c.stickyNodes[this.a].node.element,X=this.b[this.a];this.g.fire({element:P,anchor:X,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const L=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([L]),this.C(L,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const L=u.browserEvent.target;!(0,c.$_U)(L)&&!(0,c.$$U)(L)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,L){if(L&&L.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(L&&L.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const O=this.a;if(this.D(),this.b=u,this.c=L,L){const P=(0,f.$Jm)(O,0,L.count-1);this.F(P)}else this.m&&this.t.domFocus();this.s.tabIndex=L?0:-1}z(u){const L=this.c;if(!L)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<L.count-1)&&L.lastNodePartiallyVisible()){const O=L.stickyNodes[u];this.C(O.endIndex+1,L)}}C(u,L){const O=L.stickyNodes[L.count-1],P=L.count>1?L.stickyNodes[L.count-2]:void 0,X=this.t.getElementTop(u),Y=P?P.position+P.height+O.height:O.height;this.t.scrollTop=X-Y}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const L=this.a;L>=0&&this.G(this.b[L],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,L){this.I(u,L&&this.m),this.J(u,L)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,L){u.classList.toggle("focused",L)}J(u,L){u.classList.toggle("passive-focused",L)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Re(F){let u=$.TreeMouseEventTarget.Unknown;return(0,i.$9S)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=$.TreeMouseEventTarget.Twistie:(0,i.$9S)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=$.TreeMouseEventTarget.Element:(0,i.$9S)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=$.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:u}}function _e(F){const u=(0,c.$_U)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:u}}function oe(F,u){u(F),F.children.forEach(L=>oe(L,u))}class K{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,L){this.g=u,this.j=L,this.a=[],this.c=new D.$ke,this.onDidChange=this.c.event}set(u,L){!L?.__forceEvent&&(0,e.$tb)(this.a,u)||this.k(u,!1,L)}k(u,L,O){if(this.a=[...u],this.b=void 0,this.d=void 0,!L){const P=this;this.c.fire({get elements(){return P.get()},browserEvent:O})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:L}){if(!this.j){const re=this.m(),ce=Ee=>re.delete(Ee);L.forEach(Ee=>oe(Ee,ce)),this.set([...re.values()]);return}const O=new Set,P=re=>O.add(this.j.getId(re.element).toString());L.forEach(re=>oe(re,P));const X=new Map,Y=re=>X.set(this.j.getId(re.element).toString(),re);u.forEach(re=>oe(re,Y));const ie=[];for(const re of this.a){const ce=this.j.getId(re.element).toString();if(!O.has(ce))ie.push(re);else{const ve=X.get(ce);ve&&ve.visible&&ie.push(ve)}}if(this.a.length>0&&ie.length===0){const re=this.g();re&&ie.push(re)}this.k(ie,!0)}m(){const u=new Set;for(const L of this.a)u.add(L);return u}}class j extends c.$eV{constructor(u,L,O){super(u),this.x=L,this.y=O}u(u){if((0,c.$aV)(u.browserEvent.target)||(0,c.$6U)(u.browserEvent.target)||(0,c.$7U)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const L=u.element;if(!L)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const O=u.browserEvent.target,P=O.classList.contains("monaco-tl-twistie")||O.classList.contains("monaco-icon-label")&&O.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,X=(0,c.$$U)(u.browserEvent.target);let Y=!1;if(X?Y=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?Y=this.x.expandOnlyOnTwistieClick(L.element):Y=!!this.x.expandOnlyOnTwistieClick,X)this.A(u,L);else{if(Y&&!P&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(L.collapsible&&(!X||P)){const ie=this.x.getNodeLocation(L),re=u.browserEvent.altKey;if(this.x.setFocus([ie]),this.x.toggleCollapsed(ie,re),P){u.browserEvent.isHandledByList=!0;return}}X||super.u(u)}A(u,L){if((0,c.$8U)(u.browserEvent.target)||(0,c.$9U)(u.browserEvent.target))return;const O=this.y();if(!O)throw new Error("Sticky scroll controller not found");const P=this.k.indexOf(L),X=this.k.getElementTop(P),Y=O.nodePositionTopBelowWidget(L);this.x.scrollTop=X-Y,this.k.domFocus(),this.k.setFocus([P]),this.k.setSelection([P])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const L=u.browserEvent.target;if(!(0,c.$_U)(L)&&!(0,c.$$U)(L)){super.s(u);return}}t(u){const L=u.browserEvent.target;if(!(0,c.$_U)(L)&&!(0,c.$$U)(L)){super.t(u);return}}}class a extends c.$hV{constructor(u,L,O,P,X,Y,ie,re){super(u,L,O,P,re),this.p=X,this.s=Y,this.K=ie}D(u){return new j(this,u.tree,u.stickyScrollProvider)}splice(u,L,O=[]){if(super.splice(u,L,O),O.length===0)return;const P=[],X=[];let Y;O.forEach((ie,re)=>{this.p.has(ie)&&P.push(u+re),this.s.has(ie)&&X.push(u+re),this.K.has(ie)&&(Y=u+re)}),P.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...P])),X.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...X])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(u,L,O=!1){super.setFocus(u,L),O||this.p.set(u.map(P=>this.element(P)),L)}setSelection(u,L,O=!1){super.setSelection(u,L),O||this.s.set(u.map(P=>this.element(P)),L)}setAnchor(u,L=!1){super.setAnchor(u),L||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var o;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(o||(t.AbstractTreePart=o={}));class b{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return D.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.j.onMouseDblClick,Re),u=>u.target!==$.TreeMouseEventTarget.Filter)}get onMouseOver(){return D.Event.map(this.j.onMouseOver,Re)}get onMouseOut(){return D.Event.map(this.j.onMouseOut,Re)}get onContextMenu(){return D.Event.any(D.Event.filter(D.Event.map(this.j.onContextMenu,_e),u=>!u.isStickyScroll),this.B?.onContextMenu??D.Event.None)}get onTap(){return D.Event.map(this.j.onTap,Re)}get onPointer(){return D.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??Ae.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,L,O,P,X={}){this.G=u,this.H=X,this.y=new D.$se,this.onDidChangeFindOpenState=D.Event.None,this.onDidChangeStickyScrollFocused=D.Event.None,this.D=new d.$Sc,this.E=new D.$ke,this.onWillRefilter=this.E.event,this.F=new D.$ke,this.onDidUpdateOptions=this.F.event,this.p=new I(O);const Y=new D.$te,ie=new D.$te,re=this.D.add(new J(ie.event)),ce=new l.$Gc;this.k=P.map(de=>new q(de,()=>this.o,Y.event,re,ce,X));for(const de of this.k)this.D.add(de);let Ee;X.keyboardNavigationLabelProvider&&(Ee=new z(this,X.keyboardNavigationLabelProvider,X.filter),X={...X,filter:Ee},this.D.add(Ee)),this.q=new K(()=>this.j.getFocusedElements()[0],X.identityProvider),this.w=new K(()=>this.j.getSelectedElements()[0],X.identityProvider),this.x=new K(()=>this.j.getAnchorElement(),X.identityProvider),this.j=new a(u,L,this.p,this.k,this.q,this.w,this.x,{...x(()=>this.o,X),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,X),Y.input=this.o.onDidChangeCollapseState;const ve=D.Event.forEach(this.o.onDidSplice,de=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(de),this.w.onDidModelSplice(de)})},this.D);ve(()=>null,null,this.D);const ye=this.D.add(new D.$ke),Le=this.D.add(new s.$Ah(0));if(this.D.add(D.Event.any(ve,this.q.onDidChange,this.w.onDidChange)(()=>{Le.trigger(()=>{const de=new Set;for(const Ie of this.q.getNodes())de.add(Ie);for(const Ie of this.w.getNodes())de.add(Ie);ye.fire([...de.values()])})})),ie.input=ye.event,X.keyboardSupport!==!1){const de=D.Event.chain(this.j.onKeyDown,Ie=>Ie.filter(Ve=>!(0,c.$6U)(Ve.target)).map(Ve=>new B.$xS(Ve)));D.Event.chain(de,Ie=>Ie.filter(Ve=>Ve.keyCode===A.KeyCode.LeftArrow))(this.J,this,this.D),D.Event.chain(de,Ie=>Ie.filter(Ve=>Ve.keyCode===A.KeyCode.RightArrow))(this.K,this,this.D),D.Event.chain(de,Ie=>Ie.filter(Ve=>Ve.keyCode===A.KeyCode.Space))(this.L,this,this.D)}if((X.findWidgetEnabled??!0)&&X.keyboardNavigationLabelProvider&&X.contextViewProvider){const de=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new ee(this,this.o,this.j,Ee,X.contextViewProvider,de),this.A=Ie=>this.z.shouldAllowFocus(Ie),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;X.enableStickyScroll&&(this.B=new $e(this,this.o,this.j,this.k,this.p,X),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$iT)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===V.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const L of this.k)L.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===V.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new $e(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=D.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const L=this.o.getListIndex(u);L!==-1&&this.j.updateWidth(L)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$bT)(this.getHTMLElement())}layout(u,L){this.j.layout(u,L),(0,m.$hg)(L)&&this.z?.layout(L)}style(u){const L=`.${this.j.domId}`,O=[];u.treeIndentGuidesStroke&&(O.push(`.monaco-list${L}:hover .monaco-tl-indent > .indent-guide, .monaco-list${L}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),O.push(`.monaco-list${L} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const P=u.treeStickyScrollBackground??u.listBackground;P&&(O.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${P}; }`),O.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${P}; }`)),u.treeStickyScrollBorder&&O.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&O.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(O.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),O.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const X=(0,i.$1T)(u.listFocusAndSelectionOutline,(0,i.$1T)(u.listSelectionOutline,u.listFocusOutline??""));X&&(O.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${X}; outline-offset: -1px;}`),O.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(O.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),O.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),O.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),O.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),O.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=O.join(`
`),this.j.style(u)}getParentElement(u){const L=this.o.getParentNodeLocation(u);return this.o.getNode(L).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,L=!1){return this.o.setCollapsed(u,!0,L)}expand(u,L=!1){return this.o.setCollapsed(u,!1,L)}toggleCollapsed(u,L=!1){return this.o.setCollapsed(u,void 0,L)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,L){return this.o.setCollapsible(u,L)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const L=this.o.getNode(u);this.x.set([L]);const O=this.o.getListIndex(u);O>-1&&this.j.setAnchor(O,!0)})}getAnchor(){return(0,e.$Nb)(this.x.get(),void 0)}setSelection(u,L){this.y.bufferEvents(()=>{const O=u.map(X=>this.o.getNode(X));this.w.set(O,L);const P=u.map(X=>this.o.getListIndex(X)).filter(X=>X>-1);this.j.setSelection(P,L,!0)})}getSelection(){return this.w.get()}setFocus(u,L){this.y.bufferEvents(()=>{const O=u.map(X=>this.o.getNode(X));this.q.set(O,L);const P=u.map(X=>this.o.getListIndex(X)).filter(X=>X>-1);this.j.setFocus(P,L,!0)})}focusNext(u=1,L=!1,O,P=(0,i.$yT)(O)&&O.altKey?void 0:this.A){this.j.focusNext(u,L,O,P)}focusPrevious(u=1,L=!1,O,P=(0,i.$yT)(O)&&O.altKey?void 0:this.A){this.j.focusPrevious(u,L,O,P)}focusNextPage(u,L=(0,i.$yT)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,L)}focusPreviousPage(u,L=(0,i.$yT)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,L,()=>this.B?.height??0)}focusLast(u,L=(0,i.$yT)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,L)}focusFirst(u,L=(0,i.$yT)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,L)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?o.StickyScroll:o.Tree}reveal(u,L){this.o.expandTo(u);const O=this.o.getListIndex(u);if(O!==-1)if(!this.B)this.j.reveal(O,L);else{const P=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(O,L,P)}}getRelativeTop(u){const L=this.o.getListIndex(u);if(L===-1)return null;const O=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(L,O?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new $.$3W(this.G,"Can't get tree view state without an identity provider");const L=Y=>u.getId(Y).toString(),O=_.empty(this.scrollTop);for(const Y of this.getFocus())O.focus.add(L(Y));for(const Y of this.getSelection())O.selection.add(L(Y));const P=this.o.getNode(),X=[P];for(;X.length>0;){const Y=X.shift();Y!==P&&Y.collapsible&&(O.expanded[L(Y.element)]=Y.collapsed?0:1),X.push(...Y.children)}return O}J(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const O=L[0],P=this.o.getNodeLocation(O);if(!this.o.setCollapsed(P,!0)){const Y=this.o.getParentNodeLocation(P);if(!Y)return;const ie=this.o.getListIndex(Y);this.j.reveal(ie),this.j.setFocus([ie])}}K(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const O=L[0],P=this.o.getNodeLocation(O);if(!this.o.setCollapsed(P,!1)){if(!O.children.some(re=>re.visible))return;const[Y]=this.j.getFocus(),ie=Y+1;this.j.reveal(ie),this.j.setFocus([ie])}}L(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const O=L[0],P=this.o.getNodeLocation(O),X=u.browserEvent.altKey;this.o.setCollapsed(P,void 0,X)}navigate(u){return new M(this.j,this.o,u)}dispose(){(0,d.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$aX=b;class M{constructor(u,L,O){this.b=u,this.c=L,O?this.a=this.c.getListIndex(O):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(we[144],De([1,0,143,116,34,36]),function(le,t,i,n,B,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lX=void 0;class k extends i.$aX{constructor(v,c,p,y,$,g={}){super(v,c,p,y,g),this.f=v,this.g=$,this.d=new Map,this.c=g.identityProvider}getInput(){return this.b}setInput(v,c){if(c&&!this.c)throw new B.$3W(this.f,"Can't restore tree view state without an identity provider");if(this.b=v,!v){this.d.clear(),this.o.setChildren(null,N.Iterable.empty());return}if(!c){this.m(v);return}const p=[],y=[],$=e=>{const s=this.c.getId(e).toString();return!c.expanded[s]},g=e=>{const s=this.c.getId(e.element).toString();c.focus.has(s)&&p.push(e.element),c.selection.has(s)&&y.push(e.element)};this.m(v,$,g),this.setFocus(p),this.setSelection(y),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(v=this.b){if(typeof this.b>"u")throw new B.$3W(this.f,"Tree input not set");let c;this.c&&(c=p=>{const y=this.c.getId(p).toString(),$=this.d.get(y);if($)return $.collapsed}),this.m(v,c)}resort(v=this.b,c=!0){this.o.resort(v===this.b?null:v,c)}refresh(v){if(v===void 0){this.j.rerender();return}this.o.rerender(v)}m(v,c,p){let y;if(this.c){const $=new Set,g=p;p=e=>{const s=this.c.getId(e.element).toString();$.add(s),this.d.set(s,e),g?.(e)},y=e=>{const s=this.c.getId(e.element).toString();$.has(s)||this.d.delete(s)}}this.o.setChildren(v===this.b?null:v,this.s(v,c).elements,{onDidCreateNode:p,onDidDeleteNode:y})}s(v,c){const p=[...this.g.getChildren(v)];return{elements:N.Iterable.map(p,$=>{const{elements:g,size:e}=this.s($,c),s=this.g.hasChildren?this.g.hasChildren($):void 0,r=e===0?void 0:c&&c($);return{element:$,children:g,collapsible:s,collapsed:r}}),size:p.length}}M(v,c,p){return new n.$bX(v,c,p)}}t.$lX=k}),define(we[54],De([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=t._util=void 0,t.$Di=B,t.$Ei=N;var i;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function w(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=w})(i||(t._util=i={})),t.$Ci=B("instantiationService");function n(k,w,v){w[i.DI_TARGET]===w?w[i.DI_DEPENDENCIES].push({id:k,index:v}):(w[i.DI_DEPENDENCIES]=[{id:k,index:v}],w[i.DI_TARGET]=w)}function B(k){if(i.serviceIds.has(k))return i.serviceIds.get(k);const w=function(v,c,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(w,v,p)};return w.toString=()=>k,i.serviceIds.set(k,w),w}function N(k){return k}}),define(we[145],De([1,0,54]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tm=t.$Rm=t.ID=void 0,t.$Sm=n,t.ID="diagnosticsService",t.$Rm=(0,i.$Di)(t.ID);function n(N){return!!N.hostName&&!!N.errorMessage}class B{async getPerformanceInfo(k,w){return{}}async getSystemInfo(k,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,w){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}t.$Tm=B}),define(we[146],De([1,0,110,28,11,10,16,13,54,5,39,25]),function(le,t,i,n,B,N,k,w,v,c,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gl=t.$Dl=t.FileKind=t.$Cl=t.$Bl=t.$Al=t.$zl=t.$yl=t.$xl=t.$wl=t.FileOperationResult=t.$vl=t.$ul=t.$tl=t.$rl=t.FileChangeType=t.$ql=t.FileOperation=t.$kl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$$k=void 0,t.$_k=$,t.$al=r,t.$bl=l,t.$cl=D,t.$dl=T,t.$el=A,t.$fl=d,t.$gl=f,t.$hl=m,t.$il=S,t.$jl=H,t.$ll=E,t.$ml=R,t.$nl=x,t.$ol=I,t.$pl=_,t.$sl=Q,t.$El=ee,t.$Fl=fe,t.$Hl=Ne,t.$$k=(0,v.$Di)("fileService");function $(te){return te.create===!0}var g;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(g||(t.FileType=g={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function r(te){const $e=te;return!!$e&&typeof $e.onDidChange=="function"}var h;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function l(te){return!!(te.capabilities&h.FileReadWrite)}function D(te){return!!(te.capabilities&h.FileFolderCopy)}function T(te){return!!(te.capabilities&h.FileClone)}function A(te){return!!(te.capabilities&h.FileOpenReadWriteClose)}function d(te){return!!(te.capabilities&h.FileReadStream)}function f(te){return l(te)?!!(te.capabilities&h.FileAtomicRead):!1}function m(te){return l(te)?!!(te.capabilities&h.FileAtomicWrite):!1}function S(te){return!!(te.capabilities&h.FileAtomicDelete)}function H(te){return!!(te.capabilities&h.Readonly)}var U;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(U||(t.FileSystemProviderErrorCode=U={}));class C extends Error{static create($e,Te){const Oe=new C($e.toString(),Te);return x(Oe,Te),Oe}constructor($e,Te){super($e),this.code=Te}}t.$kl=C;function E(te,$e){return C.create(te,$e)}function R(te){return te||E((0,w.localize)(11330,null),U.Unknown)}function x(te,$e){return te.name=$e?`${$e} (FileSystemError)`:"FileSystemError",te}function I(te){if(!te)return U.Unknown;if(te instanceof C)return te.code;const $e=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!$e)return U.Unknown;switch($e[1]){case U.FileExists:return U.FileExists;case U.FileIsADirectory:return U.FileIsADirectory;case U.FileNotADirectory:return U.FileNotADirectory;case U.FileNotFound:return U.FileNotFound;case U.FileTooLarge:return U.FileTooLarge;case U.FileWriteLocked:return U.FileWriteLocked;case U.NoPermissions:return U.NoPermissions;case U.Unavailable:return U.Unavailable}return U.Unknown}function _(te){if(te instanceof ue)return te.fileOperationResult;switch(I(te)){case U.FileNotFound:return Fe.FILE_NOT_FOUND;case U.FileIsADirectory:return Fe.FILE_IS_DIRECTORY;case U.FileNotADirectory:return Fe.FILE_NOT_DIRECTORY;case U.FileWriteLocked:return Fe.FILE_WRITE_LOCKED;case U.NoPermissions:return Fe.FILE_PERMISSION_DENIED;case U.FileExists:return Fe.FILE_MOVE_CONFLICT;case U.FileTooLarge:return Fe.FILE_TOO_LARGE;default:return Fe.FILE_OTHER_ERROR}}var V;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(V||(t.FileOperation=V={}));class J{constructor($e,Te,Oe){this.resource=$e,this.operation=Te,this.target=Oe}isOperation($e){return this.operation===$e}}t.$ql=J;var q;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(q||(t.FileChangeType=q={}));class z{static{this.a=null}constructor($e,Te){this.c=Te,this.b=void 0,this.d=new y.$T(()=>{const Oe=i.$Ji.forUris(()=>this.c);return Oe.fill(this.rawAdded.map(Re=>[Re,!0])),Oe}),this.f=new y.$T(()=>{const Oe=i.$Ji.forUris(()=>this.c);return Oe.fill(this.rawUpdated.map(Re=>[Re,!0])),Oe}),this.g=new y.$T(()=>{const Oe=i.$Ji.forUris(()=>this.c);return Oe.fill(this.rawDeleted.map(Re=>[Re,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of $e){switch(Oe.type){case q.ADDED:this.rawAdded.push(Oe.resource);break;case q.UPDATED:this.rawUpdated.push(Oe.resource);break;case q.DELETED:this.rawDeleted.push(Oe.resource);break}this.b!==z.a&&(typeof Oe.cId=="number"?this.b===void 0?this.b=Oe.cId:this.b!==Oe.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains($e,...Te){return this.h($e,{includeChildren:!1},...Te)}affects($e,...Te){return this.h($e,{includeChildren:!0},...Te)}h($e,Te,...Oe){if(!$e)return!1;const Re=Oe.length>0;return!!((!Re||Oe.includes(q.ADDED))&&(this.d.value.get($e)||Te.includeChildren&&this.d.value.findSuperstr($e))||(!Re||Oe.includes(q.UPDATED))&&(this.f.value.get($e)||Te.includeChildren&&this.f.value.findSuperstr($e))||(!Re||Oe.includes(q.DELETED))&&(this.g.value.findSubstr($e)||Te.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}t.$rl=z;function Q(te,$e,Te){return!te||!$e||te===$e||$e.length>te.length?!1:($e.charAt($e.length-1)!==n.sep&&($e+=n.sep),Te?(0,B.$Ff)(te,$e):te.indexOf($e)===0)}class ue extends Error{constructor($e,Te,Oe){super($e),this.fileOperationResult=Te,this.options=Oe}}t.$tl=ue;class be extends ue{constructor($e,Te,Oe,Re){super($e,Te,Re),this.fileOperationResult=Te,this.size=Oe}}t.$ul=be;class Ae extends ue{constructor($e,Te,Oe){super($e,Fe.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=Te}}t.$vl=Ae;var Fe;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$yl="files.associations",t.$zl="files.exclude",t.$Al="files.readonlyInclude",t.$Bl="files.readonlyExclude",t.$Cl="files.readonlyFromPermissions";var ne;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(t.FileKind=ne={})),t.$Dl="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function fe(te,$e){if(!$e.hasProvider(k.URI.from({scheme:te.scheme})))return new Promise(Te=>{const Oe=$e.onDidChangeFileSystemProviderRegistrations(Re=>{Re.scheme===te.scheme&&Re.added&&(Oe.dispose(),Te())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize($e){return(0,N.$hg)($e)||($e=0),$e<ae.KB?(0,w.localize)(11331,null,$e.toFixed(0)):$e<ae.MB?(0,w.localize)(11332,null,($e/ae.KB).toFixed(2)):$e<ae.GB?(0,w.localize)(11333,null,($e/ae.MB).toFixed(2)):$e<ae.TB?(0,w.localize)(11334,null,($e/ae.GB).toFixed(2)):(0,w.localize)(11335,null,($e/ae.TB).toFixed(2))}}t.$Gl=ae;function Ne(te){const $e=typeof te=="string"||te?.scheme===p.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===p.Schemas.file?1024*ae.MB:$e?10*ae.MB:c.$p?50*ae.MB:1024*ae.MB}}),define(we[147],De([1,0,54]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fhc=t.$Ehc=void 0,t.$Ehc=(0,i.$Di)("mainProcessService");class n{constructor(N,k){this.a=N,this.b=k}getChannel(N){return this.a.getChannel(N,this.b)}registerChannel(N,k){this.a.registerChannel(N,k)}}t.$Fhc=n}),define(we[148],De([1,0,2,124]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ghc=void 0;class B extends i.$Tc{constructor(k){super(),this.a=this.B(new n.$1X(`window:${k}`))}getChannel(k){return this.a.getChannel(k)}registerChannel(k,w){this.a.registerChannel(k,w)}}t.$Ghc=B});var Ri=this&&this.__param||function(le,t){return function(i,n){t(i,n,le)}};define(we[149],De([1,0,74,147]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hhc=void 0;let B=class{constructor(k,w){return this.windowId=k,i.ProxyChannel.toService(w.getChannel("nativeHost"),{context:k,properties:(()=>{const v=new Map;return v.set("windowId",k),v})()})}};t.$Hhc=B,t.$Hhc=B=et([Ri(1,n.$Ehc)],B)}),define(we[84],De([1,0,42,10]),function(le,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$po=void 0,i=He(i),n=He(n);class B{constructor(){this.a=new Map}add(k,w){i.ok(n.$dg(k)),i.ok(n.$fg(w)),i.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,w)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}t.$po=new B}),define(we[150],De([1,0,3,91,84]),function(le,t,i,n,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qo=void 0,B=He(B),t.$qo={JSONContribution:"base.contributions.json"};function N(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class k{constructor(){this.b=new i.$ke,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,p){this.a[N(c)]=p,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const p=this.a[c];return p?(0,n.$6j)(p):void 0}hasSchemaContent(c){return!!this.a[c]}}const w=new k;B.$po.add(t.$qo.JSONContribution,w)}),define(we[151],De([1,0,12,21,48,22,3,10,16,13,150,84]),function(le,t,i,n,B,N,k,w,v,c,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gx=t.$Fx=t.$Ex=t.$Dx=t.$Cx=t.$Bx=t.IconFontDefinition=t.IconContribution=t.$yx=void 0,t.$zx=r,t.$Ax=h,y=He(y),t.$yx={IconContribution:"base.contributions.icons"};var $;(function(A){function d(f,m){let S=f.defaults;for(;N.ThemeIcon.isThemeIcon(S);){const H=s.getIcon(S.id);if(!H)return;S=H.defaults}return S}A.getDefinition=d})($||(t.IconContribution=$={}));var g;(function(A){function d(m){return{weight:m.weight,style:m.style,src:m.src.map(S=>({format:S.format,location:S.location.toString()}))}}A.toJSONObject=d;function f(m){const S=H=>(0,w.$dg)(H)?H:void 0;if(m&&Array.isArray(m.src)&&m.src.every(H=>(0,w.$dg)(H.format)&&(0,w.$dg)(H.location)))return{weight:S(m.weight),style:S(m.style),src:m.src.map(H=>({format:H.format,location:v.URI.parse(H.location)}))}}A.fromJSONObject=f})(g||(t.IconFontDefinition=g={}));class e{constructor(){this.a=new k.$ke,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(11096,null)},fontCharacter:{type:"string",description:(0,c.localize)(11097,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,f,m,S){const H=this.b[d];if(H){if(m&&!H.description){H.description=m,this.d.properties[d].markdownDescription=`${m} $(${d})`;const E=this.e.enum.indexOf(d);E!==-1&&(this.e.enumDescriptions[E]=m),this.a.fire()}return H}const U={id:d,description:m,defaults:f,deprecationMessage:S};this.b[d]=U;const C={$ref:"#/definitions/icons"};return S&&(C.deprecationMessage=S),m&&(C.markdownDescription=`${m}: $(${d})`),this.d.properties[d]=C,this.e.enum.push(d),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const f=this.e.enum.indexOf(d);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,f){const m=this.f[d];return m||(this.f[d]=f,this.a.fire(),f)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(H,U)=>H.id.localeCompare(U.id),f=H=>{for(;N.ThemeIcon.isThemeIcon(H.defaults);)H=this.b[H.defaults.id];return`codicon codicon-${H?H.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const S=Object.keys(this.b).map(H=>this.b[H]);for(const H of S.filter(U=>!!U.description).sort(d))m.push(`|<i class="${f(H)}"></i>|${H.id}|${N.ThemeIcon.isThemeIcon(H.defaults)?H.defaults.id:H.id}|${H.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const H of S.filter(U=>!N.ThemeIcon.isThemeIcon(U.defaults)).sort(d))m.push(`|<i class="${f(H)}"></i>|${H.id}|`);return m.join(`
`)}}const s=new e;y.$po.add(t.$yx.IconContribution,s);function r(A,d,f,m){return s.registerIcon(A,d,f,m)}function h(){return s}function l(){const A=(0,B.$Yj)();for(const d in A){const f="\\"+A[d].toString(16);s.registerIcon(d,{fontCharacter:f})}}l(),t.$Bx="vscode://schemas/icons";const D=y.$po.as(p.$qo.JSONContribution);D.registerSchema(t.$Bx,s.getIconSchema());const T=new i.$Ph(()=>D.notifySchemaChanged(t.$Bx),200);s.onDidChange(()=>{T.isScheduled()||T.schedule()}),t.$Cx=r("widget-close",n.$3j.close,(0,c.localize)(11098,null)),t.$Dx=r("goto-previous-location",n.$3j.arrowUp,(0,c.localize)(11099,null)),t.$Ex=r("goto-next-location",n.$3j.arrowDown,(0,c.localize)(11100,null)),t.$Fx=N.ThemeIcon.modify(n.$3j.sync,"spin"),t.$Gx=N.ThemeIcon.modify(n.$3j.loading,"spin")}),define(we[152],De([1,0,4,3,2,22,151]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oMb=void 0,t.$nMb=w;function w(c){const p=new B.$Sc,y=p.add(new n.$ke),$=(0,k.$Ax)();return p.add($.onDidChange(()=>y.fire())),c&&p.add(c.onDidProductIconThemeChange(()=>y.fire())),{dispose:()=>p.dispose(),onDidChange:y.event,getCSS(){const g=c?c.getProductIconTheme():new v,e={},s=[],r=[];for(const h of $.getIcons()){const l=g.getIcon(h);if(!l)continue;const D=l.font,T=`--vscode-icon-${h.id}-font-family`,A=`--vscode-icon-${h.id}-content`;D?(e[D.id]=D.definition,r.push(`${T}: ${(0,i.$ZT)(D.id)};`,`${A}: '${l.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,i.$ZT)(D.id)}; }`)):(r.push(`${A}: '${l.fontCharacter}'; ${T}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${l.fontCharacter}'; }`))}for(const h in e){const l=e[h],D=l.weight?`font-weight: ${l.weight};`:"",T=l.style?`font-style: ${l.style};`:"",A=l.src.map(d=>`${(0,i.$YT)(d.location)} format('${d.format}')`).join(", ");s.push(`@font-face { src: ${A}; font-family: ${(0,i.$ZT)(h)};${D}${T} font-display: block; }`)}return s.push(`:root { ${r.join(" ")} }`),s.join(`
`)}}}class v{getIcon(p){const y=(0,k.$Ax)();let $=p.defaults;for(;N.ThemeIcon.isThemeIcon($);){const g=y.getIcon($.id);if(!g)return;$=g.defaults}return $}}t.$oMb=v}),define(we[153],De([1,0,5]),function(le,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cE=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$6D=void 0,t.$7D=n,t.$8D=B,t.$9D=N,t.$0D=k,t.$$D=w,t.$_D=y,t.$aE=$,t.$bE=g,t.$dE=e,t.$eE=s,t.$fE=r,t.$6D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function B(h){return!!h.workspaceUri}function N(h){return!!h.folderUri}function k(h){return!!h.fileUri}function w(h){const l=$(h),D=h.getValue("window.menuBarVisibility");return D==="default"||l&&D==="compact"||i.$k&&i.$n?"classic":D}var v;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(v||(t.TitleBarSetting=v={}));var c;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(c||(t.TitlebarStyle=c={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function y(h,l){return!0}function $(h,l){return l||(l=g(h)),l===c.NATIVE}function g(h){if(i.$p)return c.CUSTOM;const l=h.getValue("window");if(l){if(i.$k&&l.nativeTabs===!0||i.$k&&l.nativeFullScreen===!1)return c.NATIVE;const A=l.titleBarStyle;if(A===c.NATIVE||A===c.CUSTOM)return A}return i.$l?c.NATIVE:c.CUSTOM}t.$cE=35;function e(h){return!(!i.$j||i.$p||$(h))}function s(h){const l=h.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(we[154],De([1,0,18,4,24,40,153]),function(le,t,i,n,B,N,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jhc=t.$Ihc=t.ApplyZoomTarget=void 0,t.$Khc=v,t.$Lhc=p,t.$Mhc=y;var w;(function($){$[$.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",$[$.ALL_WINDOWS=2]="ALL_WINDOWS"})(w||(t.ApplyZoomTarget=w={})),t.$Ihc=8,t.$Jhc=-8;function v($,g){$=Math.min(Math.max($,t.$Jhc),t.$Ihc);const e=[];g===w.ACTIVE_WINDOW?e.push((0,n.$fT)()):g===w.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(g);for(const s of e)c(s)?.webFrame?.setZoomLevel($),(0,i.$bS)((0,k.$fE)($),s),(0,i.$0R)($,s)}function c($){if($===B.$6R)return{ipcRenderer:N.$L,webFrame:N.$N};{const g=$;if(g?.vscode?.ipcRenderer&&g?.vscode?.webFrame)return g.vscode}}function p($){v((0,i.$$R)(typeof $=="number"?(0,n.$fT)():$)+1,$)}function y($){v((0,i.$$R)(typeof $=="number"?(0,n.$fT)():$)-1,$)}}),define(we[155],De([1,0,13,4,144,12,123,40,145,146,148,149,152,154,15,8,24,138,128]),function(le,t,i,n,B,N,k,w,v,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=R;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class D{getHeight(I){return 22}getTemplateId(I){return U(I)?"process":S(I)?"machine":(0,v.$Sm)(I)?"error":H(I)?"header":""}}class T{hasChildren(I){return(0,v.$Sm)(I)?!1:U(I)?!!I.children?.length:!0}getChildren(I){return U(I)?I.children?I.children:[]:(0,v.$Sm)(I)?[]:H(I)?I.processRoots.length>1?I.processRoots:[I.processRoots[0].rootProcess]:S(I)?[I.rootProcess]:[I.processes]}}class A{constructor(){this.templateId="header"}renderTemplate(I){const _=(0,n.$IT)(I,(0,n.$)(".row")),V=(0,n.$IT)(_,(0,n.$)(".nameLabel")),J=(0,n.$IT)(_,(0,n.$)(".cpu")),q=(0,n.$IT)(_,(0,n.$)(".memory")),z=(0,n.$IT)(_,(0,n.$)(".pid"));return{name:V,CPU:J,memory:q,PID:z}}renderElement(I,_,V,J){V.name.textContent=(0,i.localize)(12143,null),V.CPU.textContent=(0,i.localize)(12144,null),V.PID.textContent=(0,i.localize)(12145,null),V.memory.textContent=(0,i.localize)(12146,null)}disposeTemplate(I){}}class d{constructor(){this.templateId="machine"}renderTemplate(I){const _=Object.create(null),V=(0,n.$IT)(I,(0,n.$)(".row"));return _.name=(0,n.$IT)(V,(0,n.$)(".nameLabel")),_}renderElement(I,_,V,J){V.name.textContent=I.element.name}disposeTemplate(I){}}class f{constructor(){this.templateId="error"}renderTemplate(I){const _=Object.create(null),V=(0,n.$IT)(I,(0,n.$)(".row"));return _.name=(0,n.$IT)(V,(0,n.$)(".nameLabel")),_}renderElement(I,_,V,J){V.name.textContent=I.element.errorMessage}disposeTemplate(I){}}class m{constructor(I,_,V){this.a=I,this.b=_,this.c=V,this.templateId="process"}renderTemplate(I){const _=(0,n.$IT)(I,(0,n.$)(".row")),V=(0,n.$IT)(_,(0,n.$)(".nameLabel")),J=(0,n.$IT)(_,(0,n.$)(".cpu")),q=(0,n.$IT)(_,(0,n.$)(".memory")),z=(0,n.$IT)(_,(0,n.$)(".pid"));return{name:V,CPU:J,PID:z,memory:q}}renderElement(I,_,V,J){const{element:q}=I,z=q.pid.toFixed(0);let Q=q.name;this.c.has(q.pid)&&(Q=this.c.get(q.pid)),V.name.textContent=Q,V.name.title=q.cmd,V.CPU.textContent=q.load.toFixed(0),V.PID.textContent=z,V.PID.parentElement.id=`pid-${z}`;const ue=this.a==="win32"?q.mem:this.b*(q.mem/100);V.memory.textContent=(ue/c.$Gl.MB).toFixed(0)}disposeTemplate(I){}}function S(x){return!!x.name&&!!x.rootProcess}function H(x){return!!x.processRoots}function U(x){return!!x.pid}class C{constructor(I,_){this.f=_,this.b=new Map;const V=new p.$Ghc(I);this.c=new y.$Hhc(I,V),this.k(_.styles),this.g(_),w.$L.on("vscode:pidToNameResponse",(J,q)=>{this.b.clear();for(const[z,Q]of q)this.b.set(z,Q)}),w.$L.on("vscode:listProcessesResponse",async(J,q)=>{q.forEach((z,Q)=>{U(z.rootProcess)&&(z.rootProcess.name=Q===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:q}}),this.d.layout(r.$6R.innerHeight,r.$6R.innerWidth)):await this.h(q),this.m(0)}),this.a=Date.now(),w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")}g(I){r.$6R.document.onkeydown=_=>{const V=I.platform==="darwin"?_.metaKey:_.ctrlKey;V&&_.keyCode===87&&(_.stopPropagation(),_.preventDefault(),w.$L.send("vscode:closeProcessExplorer")),V&&_.keyCode===187&&(0,g.$Lhc)(r.$6R),V&&_.keyCode===189&&(0,g.$Mhc)(r.$6R)}}async h(I){const _=r.$6R.document.getElementById("process-list");if(!_)return;const{totalmem:V}=await this.c.getOSStatistics(),J=[new m(this.f.platform,V,this.b),new A,new d,new f];this.d=new B.$lX("processExplorer",_,new D,J,new T,{identityProvider:{getId:q=>U(q)?q.pid.toString():(0,v.$Sm)(q)?q.hostName:H(q)?"processes":S(q)?q.name:"header"}}),this.d.setInput({processes:{processRoots:I}}),this.d.layout(r.$6R.innerHeight,r.$6R.innerWidth),this.d.onKeyDown(q=>{const z=new e.$xS(q);if(z.keyCode===s.KeyCode.KeyE&&z.altKey){const Q=this.n();Promise.all(Q.map(ue=>this.c.killProcess(ue,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(q=>{U(q.element)&&this.l(q.element,!0)}),_.style.height=`${r.$6R.innerHeight}px`,r.$6R.addEventListener("resize",()=>{_.style.height=`${r.$6R.innerHeight}px`,this.d?.layout(r.$6R.innerHeight,r.$6R.innerWidth)})}i(I){const _=h.exec(I);return _&&_.groups.port!=="0"||I.indexOf("node ")>=0||I.indexOf("node.exe")>=0}j(I){const _={type:"node",request:"attach",name:`process ${I.pid}`};let V=h.exec(I.cmd);V?_.port=Number(V.groups.port):_.processId=String(I.pid),V=l.exec(I.cmd),V&&(_.port=Number(V.groups.port)),w.$L.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[_]})}k(I){const _=(0,n.$iT)(),V=[];I.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${I.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${I.listFocusBackground}; }`)),I.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${I.listFocusForeground}; }`),I.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${I.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${I.listActiveSelectionBackground}; }`)),I.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${I.listActiveSelectionForeground}; }`),I.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${I.listHoverBackground}; }`),I.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${I.listHoverForeground}; }`),I.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${I.listFocusOutline}; outline-offset: -1px; }`),I.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${I.listHoverOutline}; outline-offset: -1px; }`),I.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${I.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),I.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${I.scrollbarSliderBackgroundColor};
				}
			`),I.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${I.scrollbarSliderHoverBackgroundColor};
				}
			`),I.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${I.scrollbarSliderActiveBackgroundColor};
				}
			`),_.textContent=V.join(`
`),I.color&&(r.$6R.document.body.style.color=I.color)}l(I,_){const V=[],J=Number(I.pid);_&&(V.push({accelerator:"Alt+E",label:(0,i.localize)(12147,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),V.push({label:(0,i.localize)(12148,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,i.localize)(12149,null),click:()=>{const q=this.n();q?.includes(J)||(q.length=0,q.push(J));const z=q?.map(Q=>r.$6R.document.getElementById(`pid-${Q}`)).filter(Q=>!!Q);if(z){const Q=z.map(ue=>ue.innerText).filter(ue=>!!ue);this.c.writeClipboardText(Q.join(`
`))}}}),V.push({label:(0,i.localize)(12150,null),click:()=>{const q=r.$6R.document.getElementById("process-list");q&&this.c.writeClipboardText(q.innerText)}}),I&&_&&this.i(I.cmd)&&(V.push({type:"separator"}),V.push({label:(0,i.localize)(12151,null),click:()=>{this.j(I)}})),(0,k.$SX)(V)}m(I){setTimeout(()=>{const _=Date.now(),V=I+_-this.a;this.a=_,V>1e3?(w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")):this.m(V)},200)}n(){return this.d?.getSelection()?.map(I=>{if(!(!I||!("pid"in I)))return I.pid}).filter(I=>!!I)}}function E(){const x=(0,n.$iT)();x.id="codiconStyles";const I=(0,$.$nMb)(void 0);function _(){x.textContent=I.getCSS()}const V=new N.$Ph(_,0);I.onDidChange(()=>V.schedule()),V.schedule()}function R(x){const I=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";r.$6R.document.body.classList.add(I),E(),(0,g.$Khc)(x.data.zoomLevel,r.$6R),new C(x.windowId,x.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/89690b9d76a88fab676d26651134a1ffa4562732/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
