/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(ae){for(var e=[],I=0,c=ae.length;I<c;I++)e[I]=he[ae[I]];return e};define(he[128],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var I;(function(T){T[T.LoaderAvailable=1]="LoaderAvailable",T[T.BeginLoadingScript=10]="BeginLoadingScript",T[T.EndLoadingScriptOK=11]="EndLoadingScriptOK",T[T.EndLoadingScriptError=12]="EndLoadingScriptError",T[T.BeginInvokeFactory=21]="BeginInvokeFactory",T[T.EndInvokeFactory=22]="EndInvokeFactory",T[T.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",T[T.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",T[T.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",T[T.NodeEndNativeRequire=34]="NodeEndNativeRequire",T[T.CachedDataFound=60]="CachedDataFound",T[T.CachedDataMissed=61]="CachedDataMissed",T[T.CachedDataRejected=62]="CachedDataRejected",T[T.CachedDataCreated=63]="CachedDataCreated"})(I||(e.LoaderEventType=I={}));class c{static get(){const A=new Map,N=new Map,O=new Map,k=new Map;function b(l,m){l.has(m.detail)||l.set(m.detail,-m.timestamp)}function R(l,m){const E=l.get(m.detail);E&&(E>=0||l.set(m.detail,E+m.timestamp))}let $=[];typeof ae=="function"&&typeof ae.getStats=="function"&&($=ae.getStats().slice(0).sort((l,m)=>l.timestamp-m.timestamp));for(const l of $)switch(l.type){case I.BeginLoadingScript:b(A,l);break;case I.EndLoadingScriptOK:case I.EndLoadingScriptError:R(A,l);break;case I.BeginInvokeFactory:b(N,l);break;case I.EndInvokeFactory:R(N,l);break;case I.NodeBeginNativeRequire:b(O,l);break;case I.NodeEndNativeRequire:R(O,l);break;case I.NodeBeginEvaluatingScript:b(k,l);break;case I.NodeEndEvaluatingScript:R(k,l);break}let d=0;O.forEach(l=>d+=l);function g(l){const m=[];return l.forEach((E,f)=>m.push([f,E])),m}return{amdLoad:g(A),amdInvoke:g(N),nodeRequire:g(O),nodeEval:g(k),nodeRequireTotal:d}}static toMarkdownTable(A,N){let O="";const k=[];return A.forEach((b,R)=>{k[R]=b.length}),N.forEach(b=>{b.forEach((R,$)=>{typeof R>"u"&&(R=b[$]="-");const d=R.toString().length;k[$]=Math.max(d,k[$])})}),A.forEach((b,R)=>{O+=`| ${b+" ".repeat(k[R]-b.toString().length)} `}),O+=`|
`,A.forEach((b,R)=>{O+=`| ${"-".repeat(k[R])} `}),O+=`|
`,N.forEach(b=>{b.forEach((R,$)=>{typeof R<"u"&&(O+=`| ${R+" ".repeat(k[$]-R.toString().length)} `)}),O+=`|
`}),O}}e.$S=c}),define(he[129],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=I,e.$fb=c,e.$gb=T,e.$hb=A,e.$ib=N,e.$jb=O,e.$kb=k,e.$mb=R,e.$nb=$,e.$ob=d,e.$pb=g,e.$qb=l;function I(m,E){const f=c(m,E);if(f!==-1)return m[f]}function c(m,E,f=m.length-1){for(let w=f;w>=0;w--){const P=m[w];if(E(P))return w}return-1}function T(m,E){const f=A(m,E);return f===-1?void 0:m[f]}function A(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const o=Math.floor((P+p)/2);E(m[o])?P=o+1:p=o}return P-1}function N(m,E){const f=O(m,E);return f===m.length?void 0:m[f]}function O(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const o=Math.floor((P+p)/2);E(m[o])?p=o:P=o+1}return P}function k(m,E,f=0,w=m.length){const P=O(m,E,f,w);return P===m.length?-1:P}class b{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(b.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const f=A(this.e,E,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=b;function R(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>0&&(f=P)}return f}function $(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>=0&&(f=P)}return f}function d(m,E){return R(m,(f,w)=>-E(f,w))}function g(m,E){if(m.length===0)return-1;let f=0;for(let w=1;w<m.length;w++){const P=m[w];E(P,m[f])>0&&(f=w)}return f}function l(m,E){for(const f of m){const w=E(f);if(w!==void 0)return w}}}),define(he[39],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var I;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(I||(e.CharCode=I={}))}),define(he[130],ue([0,1]),function(ae,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=c,e.$d=T,e.$e=A,e.$f=N;function c(k,b){const R=Object.create(null);for(const $ of k){const d=b($);let g=R[d];g||(g=R[d]=[]),g.push($)}return R}function T(k,b){const R=[],$=[];for(const d of k)b.has(d)||R.push(d);for(const d of b)k.has(d)||$.push(d);return{removed:R,added:$}}function A(k,b){const R=[],$=[];for(const[d,g]of k)b.has(d)||R.push(g);for(const[d,g]of b)k.has(d)||$.push(g);return{removed:R,added:$}}function N(k,b){const R=new Set;for(const $ of b)k.has($)&&R.add($);return R}class O{static{I=Symbol.toStringTag}constructor(b,R){this.b=R,this.a=new Map,this[I]="SetWithKey";for(const $ of b)this.add($)}get size(){return this.a.size}add(b){const R=this.b(b);return this.a.set(R,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,R){this.a.forEach($=>b.call(R,$,$,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(he[87],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=c,e.$9h=T,e.$0h=A;function I(N){return(O,k,b)=>{let R=null,$=null;if(typeof b.value=="function"?(R="value",$=b.value):typeof b.get=="function"&&(R="get",$=b.get),!$)throw new Error("not supported");b[R]=N($,k)}}function c(N,O,k){let b=null,R=null;if(typeof k.value=="function"?(b="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(b="get",R=k.get),!R)throw new Error("not supported");const $=`$memoize$${O}`;k[b]=function(...d){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,d)}),this[$]}}function T(N,O,k){return I((b,R)=>{const $=`$debounce$${R}`,d=`$debounce$result$${R}`;return function(...g){this[d]||(this[d]=k?k():void 0),clearTimeout(this[$]),O&&(this[d]=O(this[d],...g),g=[this[d]]),this[$]=setTimeout(()=>{b.apply(this,g),this[d]=k?k():void 0},N)}})}function A(N,O,k){return I((b,R)=>{const $=`$throttle$timer$${R}`,d=`$throttle$result$${R}`,g=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...m){if(this[d]||(this[d]=k?k():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),O&&(this[d]=O(this[d],...m)),this[l])return;const E=this[g]+N;E<=Date.now()?(this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=k?k():void 0):(this[l]=!0,this[$]=setTimeout(()=>{this[l]=!1,this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=k?k():void 0},E-Date.now()))}})}}),define(he[8],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=c,e.$X=T,e.$Y=A,e.$Z=N,e.$1=O,e.$2=k,e.$3=R,e.$5=d,e.$6=g,e.$7=l,e.$9=E;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=I,e.$V=new I;function c(u){e.$V.setUnexpectedErrorHandler(u)}function T(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(u){R(u)||e.$V.onUnexpectedError(u)}function N(u){R(u)||e.$V.onUnexpectedExternalError(u)}function O(u){if(u instanceof Error){const{name:i,message:n}=u,t=u.stacktrace||u.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:p.isErrorNoTelemetry(u)}}return u}function k(u){let i;return u.noTelemetry?i=new p:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const b="Canceled";function R(u){return u instanceof $?!0:u instanceof Error&&u.name===b&&u.message===b}class $ extends Error{constructor(){super(b),this.name=this.message}}e.$4=$;function d(){const u=new Error(b);return u.name=u.message,u}function g(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function l(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class m extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=m;function E(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=f;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const n=new p;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=p;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(he[17],ue([0,1,8,129]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=T,e.$sb=A,e.$tb=N,e.$ub=O,e.$vb=k,e.$wb=b,e.$xb=R,e.$yb=$,e.$zb=d,e.$Ab=g,e.$Bb=l,e.$Cb=m,e.$Db=E,e.top=f,e.$Fb=w,e.$Gb=p,e.$Hb=o,e.$Ib=u,e.$Jb=i,e.$Kb=n,e.$Lb=t,e.$Mb=s,e.$Nb=r,e.$Ob=a,e.$Pb=h,e.$Qb=y,e.$Rb=L,e.$Sb=S,e.$Tb=v,e.$Ub=C,e.$Vb=U,e.$Wb=F,e.$Xb=M,e.$Yb=G,e.$Zb=V,e.$1b=_,e.$2b=H,e.$3b=ie,e.$4b=B,e.$5b=ne,e.$6b=le,e.$9b=K;function T(J,j=0){return J[J.length-(1+j)]}function A(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function N(J,j,W=(Y,Z)=>Y===Z){if(J===j)return!0;if(!J||!j||J.length!==j.length)return!1;for(let Y=0,Z=J.length;Y<Z;Y++)if(!W(J[Y],j[Y]))return!1;return!0}function O(J,j){const W=J.length-1;j<W&&(J[j]=J[W]),J.pop()}function k(J,j,W){return b(J.length,Y=>W(J[Y],j))}function b(J,j){let W=0,Y=J-1;for(;W<=Y;){const Z=(W+Y)/2|0,se=j(Z);if(se<0)W=Z+1;else if(se>0)Y=Z-1;else return Z}return-(W+1)}function R(J,j,W){if(J=J|0,J>=j.length)throw new TypeError("invalid index");const Y=j[Math.floor(j.length*Math.random())],Z=[],se=[],ce=[];for(const me of j){const pe=W(me,Y);pe<0?Z.push(me):pe>0?se.push(me):ce.push(me)}return J<Z.length?R(J,Z,W):J<Z.length+ce.length?ce[0]:R(J-(Z.length+ce.length),se,W)}function $(J,j){const W=[];let Y;for(const Z of J.slice(0).sort(j))!Y||j(Y[0],Z)!==0?(Y=[Z],W.push(Y)):Y.push(Z);return W}function*d(J,j){let W,Y;for(const Z of J)Y!==void 0&&j(Y,Z)?W.push(Z):(W&&(yield W),W=[Z]),Y=Z;W&&(yield W)}function g(J,j){for(let W=0;W<=J.length;W++)j(W===0?void 0:J[W-1],W===J.length?void 0:J[W])}function l(J,j){for(let W=0;W<J.length;W++)j(W===0?void 0:J[W-1],J[W],W+1===J.length?void 0:J[W+1])}function m(J,j,W){const Y=[];function Z(me,pe,Ee){if(pe===0&&Ee.length===0)return;const ke=Y[Y.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=pe,ke.toInsert.push(...Ee)):Y.push({start:me,deleteCount:pe,toInsert:Ee})}let se=0,ce=0;for(;;){if(se===J.length){Z(se,0,j.slice(ce));break}if(ce===j.length){Z(se,J.length-se,[]);break}const me=J[se],pe=j[ce],Ee=W(me,pe);Ee===0?(se+=1,ce+=1):Ee<0?(Z(se,1,[]),se+=1):Ee>0&&(Z(se,0,[pe]),ce+=1)}return Y}function E(J,j,W){const Y=m(J,j,W),Z=[],se=[];for(const ce of Y)Z.push(...J.slice(ce.start,ce.start+ce.deleteCount)),se.push(...ce.toInsert);return{removed:Z,added:se}}function f(J,j,W){if(W===0)return[];const Y=J.slice(0,W).sort(j);return P(J,j,Y,W,J.length),Y}function w(J,j,W,Y,Z){return W===0?Promise.resolve([]):new Promise((se,ce)=>{(async()=>{const me=J.length,pe=J.slice(0,W).sort(j);for(let Ee=W,ke=Math.min(W+Y,me);Ee<me;Ee=ke,ke=Math.min(ke+Y,me)){if(Ee>W&&await new Promise(be=>setTimeout(be)),Z&&Z.isCancellationRequested)throw new I.$4;P(J,j,pe,Ee,ke)}return pe})().then(se,ce)})}function P(J,j,W,Y,Z){for(const se=W.length;Y<Z;Y++){const ce=J[Y];if(j(ce,W[se-1])<0){W.pop();const me=(0,c.$jb)(W,pe=>j(ce,pe)<0);W.splice(me,0,ce)}}}function p(J){return J.filter(j=>!!j)}function o(J){let j=0;for(let W=0;W<J.length;W++)J[W]&&(J[j]=J[W],j+=1);J.length=j}function u(J,j,W){J.splice(W,0,J.splice(j,1)[0])}function i(J){return!Array.isArray(J)||J.length===0}function n(J){return Array.isArray(J)&&J.length>0}function t(J,j=W=>W){const W=new Set;return J.filter(Y=>{const Z=j(Y);return W.has(Z)?!1:(W.add(Z),!0)})}function s(J){const j=new Set;return W=>{const Y=J(W);return j.has(Y)?!1:(j.add(Y),!0)}}function r(J,j){return J.length>0?J[0]:j}function a(J,j){return J.length>0?J[J.length-1]:j}function h(J,j,W=(Y,Z)=>Y===Z){let Y=0;for(let Z=0,se=Math.min(J.length,j.length);Z<se&&W(J[Z],j[Z]);Z++)Y++;return Y}function y(J,j){let W=typeof j=="number"?J:0;typeof j=="number"?W=J:(W=0,j=J);const Y=[];if(W<=j)for(let Z=W;Z<j;Z++)Y.push(Z);else for(let Z=W;Z>j;Z--)Y.push(Z);return Y}function L(J,j,W){return J.reduce((Y,Z)=>(Y[j(Z)]=W?W(Z):Z,Y),Object.create(null))}function S(J,j){return J.push(j),()=>v(J,j)}function v(J,j){const W=J.indexOf(j);if(W>-1)return J.splice(W,1),j}function C(J,j,W){const Y=J.slice(0,j),Z=J.slice(j);return Y.concat(W,Z)}function U(J,j){let W;if(typeof j=="number"){let Y=j;W=()=>{const Z=Math.sin(Y++)*179426549;return Z-Math.floor(Z)}}else W=Math.random;for(let Y=J.length-1;Y>0;Y-=1){const Z=Math.floor(W()*(Y+1)),se=J[Y];J[Y]=J[Z],J[Z]=se}}function F(J,j){const W=J.indexOf(j);W>-1&&(J.splice(W,1),J.unshift(j))}function M(J,j){const W=J.indexOf(j);W>-1&&(J.splice(W,1),J.push(j))}function G(J,j){for(const W of j)J.push(W)}function V(J,j){return Array.isArray(J)?J.map(j):j(J)}function _(J){return Array.isArray(J)?J:[J]}function H(J){return J[Math.floor(Math.random()*J.length)]}function ie(J,j,W){const Y=z(J,j),Z=J.length,se=W.length;J.length=Z+se;for(let ce=Z-1;ce>=Y;ce--)J[ce+se]=J[ce];for(let ce=0;ce<se;ce++)J[ce+Y]=W[ce]}function B(J,j,W,Y){const Z=z(J,j);let se=J.splice(Z,W);return se===void 0&&(se=[]),ie(J,Z,Y),se}function z(J,j){return j<0?Math.max(j+J.length,0):Math.min(j,J.length)}var ee;(function(J){function j(se){return se<0}J.isLessThan=j;function W(se){return se<=0}J.isLessThanOrEqual=W;function Y(se){return se>0}J.isGreaterThan=Y;function Z(se){return se===0}J.isNeitherLessOrGreaterThan=Z,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(J,j){return(W,Y)=>j(J(W),J(Y))}function le(...J){return(j,W)=>{for(const Y of J){const Z=Y(j,W);if(!ee.isNeitherLessOrGreaterThan(Z))return Z}return ee.neitherLessOrGreaterThan}}const te=(J,j)=>J-j;e.$7b=te;const Q=(J,j)=>(0,e.$7b)(J?1:0,j?1:0);e.$8b=Q;function K(J){return(j,W)=>-J(j,W)}class q{constructor(j){this.g=j,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(j){let W=this.c;for(;W<this.g.length&&j(this.g[W]);)W++;const Y=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Y}takeFromEndWhile(j){let W=this.d;for(;W>=0&&j(this.g[W]);)W--;const Y=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const j=this.g[this.c];return this.c++,j}removeLast(){const j=this.g[this.d];return this.d--,j}takeCount(j){const W=this.g.slice(this.c,this.c+j);return this.c+=j,W}}e.$0b=q;class D{static{this.empty=new D(j=>{})}constructor(j){this.iterate=j}forEach(j){this.iterate(W=>(j(W),!0))}toArray(){const j=[];return this.iterate(W=>(j.push(W),!0)),j}filter(j){return new D(W=>this.iterate(Y=>j(Y)?W(Y):!0))}map(j){return new D(W=>this.iterate(Y=>W(j(Y))))}some(j){let W=!1;return this.iterate(Y=>(W=j(Y),!W)),W}findFirst(j){let W;return this.iterate(Y=>j(Y)?(W=Y,!1):!0),W}findLast(j){let W;return this.iterate(Y=>(j(Y)&&(W=Y),!0)),W}findLastMaxBy(j){let W,Y=!0;return this.iterate(Z=>((Y||ee.isGreaterThan(j(Z,W)))&&(Y=!1,W=Z),!0)),W}}e.$$b=D;class X{constructor(j){this.c=j}static createSortPermutation(j,W){const Y=Array.from(j.keys()).sort((Z,se)=>W(j[Z],j[se]));return new X(Y)}apply(j){return j.map((W,Y)=>j[this.c[Y]])}inverse(){const j=this.c.slice();for(let W=0;W<this.c.length;W++)j[this.c[W]]=W;return new X(j)}}e.$_b=X}),define(he[131],ue([0,1,8]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$dd=T,e.$ed=A,e.$fd=N,e.$gd=O,e.$hd=k;function c(b,R){if(!b)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function T(b,R="Unreachable"){throw new Error(R)}function A(b,R="unexpected state"){if(!b)throw new I.$bb(`Assertion Failed: ${R}`)}function N(b){b||(0,I.$Y)(new I.$bb("Soft Assertion Failed"))}function O(b){if(!b()){debugger;b(),(0,I.$Y)(new I.$bb("Assertion Failed"))}}function k(b,R){let $=0;for(;$<b.length-1;){const d=b[$],g=b[$+1];if(!R(d,g))return!1;$++}return!0}}),define(he[88],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=I;function I(c,T){const A=this;let N=!1,O;return function(){if(N)return O;if(N=!0,T)try{O=c.apply(A,arguments)}finally{T()}else O=c.apply(A,arguments);return O}}}),define(he[63],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(c){function T(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}c.is=T;const A=Object.freeze([]);function N(){return A}c.empty=N;function*O(i){yield i}c.single=O;function k(i){return T(i)?i:O(i)}c.wrap=k;function b(i){return i||A}c.from=b;function*R(i){for(let n=i.length-1;n>=0;n--)yield i[n]}c.reverse=R;function $(i){return!i||i[Symbol.iterator]().next().done===!0}c.isEmpty=$;function d(i){return i[Symbol.iterator]().next().value}c.first=d;function g(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}c.some=g;function l(i,n){for(const t of i)if(n(t))return t}c.find=l;function*m(i,n){for(const t of i)n(t)&&(yield t)}c.filter=m;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}c.map=E;function*f(i,n){let t=0;for(const s of i)yield*n(s,t++)}c.flatMap=f;function*w(...i){for(const n of i)yield*n}c.concat=w;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}c.reduce=P;function*p(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}c.slice=p;function o(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const a=s.next();if(a.done)return[t,c.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return s}}]}c.consume=o;async function u(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}c.asyncToArray=u})(I||(e.Iterable=I={}))}),define(he[36],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Un=N,e.$Vn=$,e.$Wn=d,e.$Xn=g,e.$Yn=l,e.$Zn=m,e.$1n=E,e.$2n=f,e.$3n=w,e.$4n=P,e.$5n=p;var I;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var c;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var T;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(o,u=!1){let i=0;const n=o.length;let t="",s=0,r=c.Unknown,a=I.None;function h(F){let M=0,G=0;for(;M<F;){const V=o.charCodeAt(i);if(V>=R._0&&V<=R._9)G=G*16+V-R._0;else if(V>=R.A&&V<=R.F)G=G*16+V-R.A+10;else if(V>=R.a&&V<=R.f)G=G*16+V-R.a+10;else break;i++,M++}return M<F&&(G=-1),G}function y(F){i=F,t="",s=0,r=c.Unknown,a=I.None}function L(){const F=i;if(o.charCodeAt(i)===R._0)i++;else for(i++;i<o.length&&b(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===R.dot)if(i++,i<o.length&&b(o.charCodeAt(i)))for(i++;i<o.length&&b(o.charCodeAt(i));)i++;else return a=I.UnexpectedEndOfNumber,o.substring(F,i);let M=i;if(i<o.length&&(o.charCodeAt(i)===R.E||o.charCodeAt(i)===R.e))if(i++,(i<o.length&&o.charCodeAt(i)===R.plus||o.charCodeAt(i)===R.minus)&&i++,i<o.length&&b(o.charCodeAt(i))){for(i++;i<o.length&&b(o.charCodeAt(i));)i++;M=i}else a=I.UnexpectedEndOfNumber;return o.substring(F,M)}function S(){let F="",M=i;for(;;){if(i>=n){F+=o.substring(M,i),a=I.UnexpectedEndOfString;break}const G=o.charCodeAt(i);if(G===R.doubleQuote){F+=o.substring(M,i),i++;break}if(G===R.backslash){if(F+=o.substring(M,i),i++,i>=n){a=I.UnexpectedEndOfString;break}switch(o.charCodeAt(i++)){case R.doubleQuote:F+='"';break;case R.backslash:F+="\\";break;case R.slash:F+="/";break;case R.b:F+="\b";break;case R.f:F+="\f";break;case R.n:F+=`
`;break;case R.r:F+="\r";break;case R.t:F+="	";break;case R.u:{const _=h(4);_>=0?F+=String.fromCharCode(_):a=I.InvalidUnicode;break}default:a=I.InvalidEscapeCharacter}M=i;continue}if(G>=0&&G<=31)if(k(G)){F+=o.substring(M,i),a=I.UnexpectedEndOfString;break}else a=I.InvalidCharacter;i++}return F}function v(){if(t="",a=I.None,s=i,i>=n)return s=n,r=c.EOF;let F=o.charCodeAt(i);if(O(F)){do i++,t+=String.fromCharCode(F),F=o.charCodeAt(i);while(O(F));return r=c.Trivia}if(k(F))return i++,t+=String.fromCharCode(F),F===R.carriageReturn&&o.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=c.LineBreakTrivia;switch(F){case R.openBrace:return i++,r=c.OpenBraceToken;case R.closeBrace:return i++,r=c.CloseBraceToken;case R.openBracket:return i++,r=c.OpenBracketToken;case R.closeBracket:return i++,r=c.CloseBracketToken;case R.colon:return i++,r=c.ColonToken;case R.comma:return i++,r=c.CommaToken;case R.doubleQuote:return i++,t=S(),r=c.StringLiteral;case R.slash:{const M=i-1;if(o.charCodeAt(i+1)===R.slash){for(i+=2;i<n&&!k(o.charCodeAt(i));)i++;return t=o.substring(M,i),r=c.LineCommentTrivia}if(o.charCodeAt(i+1)===R.asterisk){i+=2;const G=n-1;let V=!1;for(;i<G;){if(o.charCodeAt(i)===R.asterisk&&o.charCodeAt(i+1)===R.slash){i+=2,V=!0;break}i++}return V||(i++,a=I.UnexpectedEndOfComment),t=o.substring(M,i),r=c.BlockCommentTrivia}return t+=String.fromCharCode(F),i++,r=c.Unknown}case R.minus:if(t+=String.fromCharCode(F),i++,i===n||!b(o.charCodeAt(i)))return r=c.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=L(),r=c.NumericLiteral;default:for(;i<n&&C(F);)i++,F=o.charCodeAt(i);if(s!==i){switch(t=o.substring(s,i),t){case"true":return r=c.TrueKeyword;case"false":return r=c.FalseKeyword;case"null":return r=c.NullKeyword}return r=c.Unknown}return t+=String.fromCharCode(F),i++,r=c.Unknown}}function C(F){if(O(F)||k(F))return!1;switch(F){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function U(){let F;do F=v();while(F>=c.LineCommentTrivia&&F<=c.Trivia);return F}return{setPosition:y,getPosition:()=>i,scan:u?U:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>a}}function O(o){return o===R.space||o===R.tab||o===R.verticalTab||o===R.formFeed||o===R.nonBreakingSpace||o===R.ogham||o>=R.enQuad&&o<=R.zeroWidthSpace||o===R.narrowNoBreakSpace||o===R.mathematicalSpace||o===R.ideographicSpace||o===R.byteOrderMark}function k(o){return o===R.lineFeed||o===R.carriageReturn||o===R.lineSeparator||o===R.paragraphSeparator}function b(o){return o>=R._0&&o<=R._9}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function $(o,u){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function a(h,y,L,S){s.value=h,s.offset=y,s.length=L,s.type=S,s.colonOffset=void 0,t=s}try{P(o,{onObjectBegin:(h,y)=>{if(u<=h)throw n;t=void 0,r=u>h,i.push("")},onObjectProperty:(h,y,L)=>{if(u<y||(a(h,y,L,"property"),i[i.length-1]=h,u<=y+L))throw n},onObjectEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onArrayBegin:(h,y)=>{if(u<=h)throw n;t=void 0,i.push(0)},onArrayEnd:(h,y)=>{if(u<=h)throw n;t=void 0,i.pop()},onLiteralValue:(h,y,L)=>{if(u<y||(a(h,y,L,p(h)),u<=y+L))throw n},onSeparator:(h,y,L)=>{if(u<=y)throw n;if(h===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(h===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:t,isAtPropertyKey:r,matches:h=>{let y=0;for(let L=0;y<h.length&&L<i.length;L++)if(h[y]===i[L]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}function d(o,u=[],i=A.DEFAULT){let n=null,t=[];const s=[];function r(h){Array.isArray(t)?t.push(h):n!==null&&(t[n]=h)}return P(o,{onObjectBegin:()=>{const h={};r(h),s.push(t),t=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const h=[];r(h),s.push(t),t=h,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(h,y,L)=>{u.push({error:h,offset:y,length:L})}},i),t[0]}function g(o,u=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function s(h){return n.children.push(h),h}P(o,{onObjectBegin:h=>{n=s({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,y,L)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:y,length:L,parent:n})},onObjectEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onArrayBegin:(h,y)=>{n=s({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,y)=>{n.length=h+y-n.offset,n=n.parent,t(h+y)},onLiteralValue:(h,y,L)=>{s({type:p(h),offset:y,length:L,parent:n,value:h}),t(y+L)},onSeparator:(h,y,L)=>{n.type==="property"&&(h===":"?n.colonOffset=y:h===","&&t(y))},onError:(h,y,L)=>{u.push({error:h,offset:y,length:L})}},i);const a=n.children[0];return a&&delete a.parent,a}function l(o,u){if(!o)return;let i=o;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function m(o){if(!o.parent||!o.parent.children)return[];const u=m(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;u.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&u.push(i)}return u}function E(o){switch(o.type){case"array":return o.children.map(E);case"object":{const u=Object.create(null);for(const i of o.children){const n=i.children[1];n&&(u[i.children[0].value]=E(n))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function f(o,u,i=!1){return u>=o.offset&&u<o.offset+o.length||i&&u===o.offset+o.length}function w(o,u,i=!1){if(f(o,u,i)){const n=o.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=u;t++){const s=w(n[t],u,i);if(s)return s}return o}}function P(o,u,i=A.DEFAULT){const n=N(o,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(u.onObjectBegin),a=s(u.onObjectProperty),h=t(u.onObjectEnd),y=t(u.onArrayBegin),L=t(u.onArrayEnd),S=s(u.onLiteralValue),v=s(u.onSeparator),C=t(u.onComment),U=s(u.onError),F=i&&i.disallowComments,M=i&&i.allowTrailingComma;function G(){for(;;){const ne=n.scan();switch(n.getTokenError()){case I.InvalidUnicode:V(T.InvalidUnicode);break;case I.InvalidEscapeCharacter:V(T.InvalidEscapeCharacter);break;case I.UnexpectedEndOfNumber:V(T.UnexpectedEndOfNumber);break;case I.UnexpectedEndOfComment:F||V(T.UnexpectedEndOfComment);break;case I.UnexpectedEndOfString:V(T.UnexpectedEndOfString);break;case I.InvalidCharacter:V(T.InvalidCharacter);break}switch(ne){case c.LineCommentTrivia:case c.BlockCommentTrivia:F?V(T.InvalidCommentToken):C();break;case c.Unknown:V(T.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return ne}}}function V(ne,le=[],te=[]){if(U(ne),le.length+te.length>0){let Q=n.getToken();for(;Q!==c.EOF;){if(le.indexOf(Q)!==-1){G();break}else if(te.indexOf(Q)!==-1)break;Q=G()}}}function _(ne){const le=n.getTokenValue();return ne?S(le):a(le),G(),!0}function H(){switch(n.getToken()){case c.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(V(T.InvalidNumberFormat),ne=0)}catch{V(T.InvalidNumberFormat)}S(ne);break}case c.NullKeyword:S(null);break;case c.TrueKeyword:S(!0);break;case c.FalseKeyword:S(!1);break;default:return!1}return G(),!0}function ie(){return n.getToken()!==c.StringLiteral?(V(T.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(_(!1),n.getToken()===c.ColonToken?(v(":"),G(),ee()||V(T.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):V(T.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function B(){r(),G();let ne=!1;for(;n.getToken()!==c.CloseBraceToken&&n.getToken()!==c.EOF;){if(n.getToken()===c.CommaToken){if(ne||V(T.ValueExpected,[],[]),v(","),G(),n.getToken()===c.CloseBraceToken&&M)break}else ne&&V(T.CommaExpected,[],[]);ie()||V(T.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),ne=!0}return h(),n.getToken()!==c.CloseBraceToken?V(T.CloseBraceExpected,[c.CloseBraceToken],[]):G(),!0}function z(){y(),G();let ne=!1;for(;n.getToken()!==c.CloseBracketToken&&n.getToken()!==c.EOF;){if(n.getToken()===c.CommaToken){if(ne||V(T.ValueExpected,[],[]),v(","),G(),n.getToken()===c.CloseBracketToken&&M)break}else ne&&V(T.CommaExpected,[],[]);ee()||V(T.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),ne=!0}return L(),n.getToken()!==c.CloseBracketToken?V(T.CloseBracketExpected,[c.CloseBracketToken],[]):G(),!0}function ee(){switch(n.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return B();case c.StringLiteral:return _(!0);default:return H()}}return G(),n.getToken()===c.EOF?i.allowEmptyContent?!0:(V(T.ValueExpected,[],[]),!1):ee()?(n.getToken()!==c.EOF&&V(T.EndOfFileExpected,[],[]),!0):(V(T.ValueExpected,[],[]),!1)}function p(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],ue([0,1,36]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=c,e.$7n=T,e.$8n=O,e.$9n=k;function c(b,R,$){let d,g,l,m,E;if(R){for(m=R.offset,E=m+R.length,l=m;l>0&&!k(b,l-1);)l--;let a=E;for(;a<b.length&&!k(b,a);)a++;g=b.substring(l,a),d=N(g,$)}else g=b,d=0,l=0,m=0,E=b.length;const f=O($,b);let w=!1,P=0,p;$.insertSpaces?p=A(" ",$.tabSize||4):p="	";const o=(0,I.$Un)(g,!1);let u=!1;function i(){return f+A(p,d+P)}function n(){let a=o.scan();for(w=!1;a===I.SyntaxKind.Trivia||a===I.SyntaxKind.LineBreakTrivia;)w=w||a===I.SyntaxKind.LineBreakTrivia,a=o.scan();return u=a===I.SyntaxKind.Unknown||o.getTokenError()!==I.ScanError.None,a}const t=[];function s(a,h,y){!u&&h<E&&y>m&&b.substring(h,y)!==a&&t.push({offset:h,length:y-h,content:a})}let r=n();if(r!==I.SyntaxKind.EOF){const a=o.getTokenOffset()+l,h=A(p,d);s(h,l,a)}for(;r!==I.SyntaxKind.EOF;){let a=o.getTokenOffset()+o.getTokenLength()+l,h=n(),y="";for(;!w&&(h===I.SyntaxKind.LineCommentTrivia||h===I.SyntaxKind.BlockCommentTrivia);){const S=o.getTokenOffset()+l;s(" ",a,S),a=o.getTokenOffset()+o.getTokenLength()+l,y=h===I.SyntaxKind.LineCommentTrivia?i():"",h=n()}if(h===I.SyntaxKind.CloseBraceToken)r!==I.SyntaxKind.OpenBraceToken&&(P--,y=i());else if(h===I.SyntaxKind.CloseBracketToken)r!==I.SyntaxKind.OpenBracketToken&&(P--,y=i());else{switch(r){case I.SyntaxKind.OpenBracketToken:case I.SyntaxKind.OpenBraceToken:P++,y=i();break;case I.SyntaxKind.CommaToken:case I.SyntaxKind.LineCommentTrivia:y=i();break;case I.SyntaxKind.BlockCommentTrivia:w?y=i():y=" ";break;case I.SyntaxKind.ColonToken:y=" ";break;case I.SyntaxKind.StringLiteral:if(h===I.SyntaxKind.ColonToken){y="";break}case I.SyntaxKind.NullKeyword:case I.SyntaxKind.TrueKeyword:case I.SyntaxKind.FalseKeyword:case I.SyntaxKind.NumericLiteral:case I.SyntaxKind.CloseBraceToken:case I.SyntaxKind.CloseBracketToken:h===I.SyntaxKind.LineCommentTrivia||h===I.SyntaxKind.BlockCommentTrivia?y=" ":h!==I.SyntaxKind.CommaToken&&h!==I.SyntaxKind.EOF&&(u=!0);break;case I.SyntaxKind.Unknown:u=!0;break}w&&(h===I.SyntaxKind.LineCommentTrivia||h===I.SyntaxKind.BlockCommentTrivia)&&(y=i())}const L=o.getTokenOffset()+l;s(y,a,L),r=h}return t}function T(b,R){const $=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?$.replace(/\r\n|\r|\n/g,R.eol):$}function A(b,R){let $="";for(let d=0;d<R;d++)$+=b;return $}function N(b,R){let $=0,d=0;const g=R.tabSize||4;for(;$<b.length;){const l=b.charAt($);if(l===" ")d++;else if(l==="	")d+=g;else break;$++}return Math.floor(d/g)}function O(b,R){for(let $=0;$<R.length;$++){const d=R.charAt($);if(d==="\r")return $+1<R.length&&R.charAt($+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return b&&b.eol||`
`}function k(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}}),define(he[64],ue([0,1,36,45]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=T,e.$$n=A,e.$_n=N,e.$ao=O,e.$bo=k;function T(b,R,$){return A(b,R,void 0,$)}function A(b,R,$,d,g){const l=R.slice(),m=[],E=(0,I.$Xn)(b,m);let f,w;for(;l.length>0&&(w=l.pop(),f=(0,I.$Yn)(E,l),f===void 0&&$!==void 0);)typeof w=="string"?$={[w]:$}:$=[$];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const P=(0,I.$Yn)(f,[w]);if(P!==void 0)if($===void 0){if(!P.parent)throw new Error("Malformed AST");const p=f.children.indexOf(P.parent);let o,u=P.parent.offset+P.parent.length;if(p>0){const i=f.children[p-1];o=i.offset+i.length}else o=f.offset+1,f.children.length>1&&(u=f.children[1].offset);return N(b,{offset:o,length:u-o,content:""},d)}else return N(b,{offset:P.offset,length:P.length,content:JSON.stringify($)},d);else{if($===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify($)}`,o=g?g(f.children.map(i=>i.children[0].value)):f.children.length;let u;if(o>0){const i=f.children[o-1];u={offset:i.offset+i.length,length:0,content:","+p}}else f.children.length===0?u={offset:f.offset+1,length:0,content:p}:u={offset:f.offset+1,length:0,content:p+","};return N(b,u,d)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if($!==void 0){const P=`${JSON.stringify($)}`;let p;if(f.children.length===0||w===0)p={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const o=w===-1||w>f.children.length?f.children.length:w,u=f.children[o-1];p={offset:u.offset+u.length,length:0,content:","+P}}return N(b,p,d)}else{const P=w,p=f.children[P];let o;if(f.children.length===1)o={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const u=f.children[P-1],i=u.offset+u.length,n=f.offset+f.length;o={offset:i,length:n-2-i,content:""}}else o={offset:p.offset,length:f.children[P+1].offset-p.offset,content:""};return N(b,o,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else return $===void 0?[]:N(b,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify($)},d)}function N(b,R,$){let d=O(b,R),g=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,c.$9n)(d,g-1);)g--;for(;l<d.length&&!(0,c.$9n)(d,l);)l++}const m=(0,c.$6n)(d,{offset:g,length:l-g},$);for(let f=m.length-1;f>=0;f--){const w=m[f];d=O(d,w),g=Math.min(g,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const E=b.length-(d.length-l)-g;return[{offset:g,length:E,content:d.substring(g,l)}]}function O(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}function k(b,R){const $=R.slice(0).sort((g,l)=>{const m=g.offset-l.offset;return m===0?g.length-l.length:m});let d=b.length;for(let g=$.length-1;g>=0;g--){const l=$[g];if(l.offset+l.length<=d)b=O(b,l);else throw new Error("Overlapping edit");d=l.offset}return b}}),define(he[132],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=I;function I(A){let N=!1;const O=new Map,k=new Map;if(T(A,m=>{if(A===m)return!0;const E=JSON.stringify(m);if(E.length<30)return!0;const f=O.get(E);if(!f){const w={schemas:[m]};return O.set(E,w),k.set(m,w),!0}return f.schemas.push(m),k.set(m,f),N=!0,!1}),O.clear(),!N)return JSON.stringify(A);let R="$defs";for(;A.hasOwnProperty(R);)R+="_";const $=[];function d(m){return JSON.stringify(m,(E,f)=>{if(f!==m){const w=k.get(f);if(w&&w.schemas.length>1)return w.id||(w.id=`_${$.length}`,$.push(w.schemas[0])),{$ref:`#/${R}/${w.id}`}}return f})}const g=d(A),l=[];for(let m=0;m<$.length;m++)l.push(`"_${m}":${d($[m])}`);return l.length?`${g.substring(0,g.length-1)},"${R}":{${l.join(",")}}}`:g}function c(A){return typeof A=="object"&&A!==null}function T(A,N){if(!A||typeof A!="object")return;const O=(...g)=>{for(const l of g)c(l)&&$.push(l)},k=(...g)=>{for(const l of g)if(c(l))for(const m in l){const E=l[m];c(E)&&$.push(E)}},b=(...g)=>{for(const l of g)if(Array.isArray(l))for(const m of l)c(m)&&$.push(m)},R=g=>{if(Array.isArray(g))for(const l of g)c(l)&&$.push(l);else c(g)&&$.push(g)},$=[A];let d=$.pop();for(;d;)N(d)&&(O(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),k(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),b(d.anyOf,d.allOf,d.oneOf,d.prefixItems),R(d.items)),d=$.pop()}}),define(he[53],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class I{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=I}),define(he[89],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class c{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const N=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=N}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,N){const O=new I(A);if(this.a===I.Undefined)this.a=O,this.b=O;else if(N){const b=this.b;this.b=O,O.prev=b,b.next=O}else{const b=this.a;this.a=O,O.next=b,b.prev=O}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(O))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const N=A.prev;N.next=A.next,A.next.prev=N}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$4c=c}),define(he[31],ue([0,1]),function(ae,e){"use strict";var I,c,T;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=A,e.$xc=N,e.$yc=O,e.$Hc=p;function A(o,u,i){let n=o.get(u);return n===void 0&&(n=i,o.set(u,n)),n}function N(o){const u=[];return o.forEach((i,n)=>{u.push(`${n} => ${i}`)}),`Map(${o.size}) {${u.join(", ")}}`}function O(o){const u=[];return o.forEach(i=>{u.push(i)}),`Set(${o.size}) {${u.join(", ")}}`}class k{constructor(u,i){this.uri=u,this.value=i}}function b(o){return Array.isArray(o)}class R{static{this.c=u=>u.toString()}constructor(u,i){if(this[I]="ResourceMap",u instanceof R)this.d=new Map(u.d),this.e=i??R.c;else if(b(u)){this.d=new Map,this.e=i??R.c;for(const[n,t]of u)this.set(n,t)}else this.d=new Map,this.e=u??R.c}set(u,i){return this.d.set(this.e(u),new k(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[n,t]of this.d)u(t.value,t.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=R;class ${constructor(u,i){this[c]="ResourceSet",!u||typeof u=="function"?this.c=new R(u):(this.c=new R(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((n,t)=>u.call(i,t,t,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=$;var d;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class g{constructor(){this[T]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=d.None){const n=this.c.get(u);if(n)return i!==d.None&&this.m(n,i),n.value}set(u,i,n=d.None){let t=this.c.get(u);if(t)t.value=i,n!==d.None&&this.m(t,n);else{switch(t={key:u,value:i,next:void 0,previous:void 0},n){case d.None:this.k(t);break;case d.AsOld:this.j(t);break;case d.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(u,t),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const n=this.g;let t=this.d;for(;t;){if(i?u.bind(i)(t.value,t.key,this):u(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const u=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>u;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>u;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,n=u.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(u===this.d)return;const n=u.next,t=u.previous;u===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===d.AsNew){if(u===this.e)return;const n=u.next,t=u.previous;u===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,n)=>{u.push([n,i])}),u}fromJSON(u){this.clear();for(const[i,n]of u)this.set(i,n)}}e.$Bc=g;class l extends g{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=d.AsNew){return super.get(u,i)}peek(u){return super.get(u,d.None)}set(u,i){return super.set(u,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends l{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=m;class E extends l{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=E;class f{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=f;class w{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,n]of u)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((n,t)=>{u.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class P{constructor(){this.c=new Map}add(u,i){let n=this.c.get(u);n||(n=new Set,this.c.set(u,n)),n.add(i)}delete(u,i){const n=this.c.get(u);n&&(n.delete(i),n.size===0&&this.c.delete(u))}forEach(u,i){const n=this.c.get(u);n&&n.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=P;function p(o,u){if(o===u)return!0;if(o.size!==u.size)return!1;for(const[i,n]of o)if(!u.has(i)||u.get(i)!==n)return!1;for(const[i]of u)if(!o.has(i))return!1;return!0}}),define(he[2],ue([0,1,17,130,31,88,63]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=R,e.$Kc=$,e.$Lc=d,e.$Mc=m,e.$Nc=E,e.$Oc=f,e.$Pc=w,e.$Qc=P,e.$Rc=p,e.$2c=y;const O=!1;let k=null;class b{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:b.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const U=this.c(v);U.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const U=C.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,C){let U;if(C)U=C;else{const _=new Map,H=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,_).isSingleton);if(H.length===0)return;const ie=new Set(H.map(B=>B.value));if(U=H.filter(B=>!(B.parent&&ie.has(B.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(_){function H(B,z){for(;B.length>0&&z.some(ee=>typeof ee=="string"?ee===B[0]:B[0].match(ee));)B.shift()}const ie=_.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return H(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new T.$Gc;for(const _ of U){const H=F(_);for(let ie=0;ie<=H.length;ie++)M.add(H.slice(0,ie).join(`
`),_)}U.sort((0,I.$5b)(_=>_.idx,I.$7b));let G="",V=0;for(const _ of U.slice(0,v)){V++;const H=F(_),ie=[];for(let B=0;B<H.length;B++){let z=H[B];z=`(shared with ${M.get(H.slice(0,B+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const ne=M.get(H.slice(0,B).join(`
`)),le=(0,c.$c)([...ne].map(te=>F(te)[B]),te=>te);delete le[H[B]];for(const[te,Q]of Object.entries(le))ie.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${te}`);ie.unshift(z)}G+=`


==================== Leaking disposable ${V}/${U.length}: ${_.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>v&&(G+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:G}}}e.$Ic=b;function R(S){k=S}if(O){const S="__is_disposable_tracked__";R(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==u.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==u.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function $(S){return k?.trackDisposable(S),S}function d(S){k?.markAsDisposed(S)}function g(S,v){k?.setParent(S,v)}function l(S,v){if(k)for(const C of S)k.setParent(C,v)}function m(S){return k?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function f(S){if(N.Iterable.is(S)){const v=[];for(const C of S)if(C)try{C.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function w(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=p(()=>f(S));return l(S,v),v}function p(S){const v=$({dispose:(0,A.$cb)(()=>{d(v),S()})});return v}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),g(v,null))}}e.$Sc=o;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,$(this),g(this.q,this)}dispose(){d(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Tc=u;class i{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&g(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&g(v,null),v}}e.$Uc=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,d(this))},this}}e.$Xc=s;class r{constructor(){this.a=new Map}acquire(v,...C){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...C)},this.a.set(v,U));const{object:F}=U,M=(0,A.$cb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:M}}}e.$Yc=r;class a{constructor(v){this.a=v}async acquire(v,...C){const U=this.a.acquire(v,...C);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$Zc=a;class h{constructor(v){this.object=v}dispose(){}}e.$1c=h;function y(S){const v=new o;try{S(v)}finally{v.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const C=this.a.get(v);return this.a.delete(v),C}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(he[65],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var I;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(I||(e.MarshalledId=I={}))}),define(he[90],ue([0,1,31]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=T,e.$mm=N;const c=new I.$Cc(1e4);function T(b){return k(b,"NFC",c)}const A=new I.$Cc(1e4);function N(b){return k(b,"NFD",A)}const O=/[^\u0000-\u0080]/;function k(b,R,$){if(!b)return b;const d=$.get(b);if(d)return d;let g;return O.test(b)?g=b.normalize(R):g=b,$.set(b,g),g}e.$nm=function(){const b=/[\u0300-\u036f]/g;return function(R){return N(R).replace(b,"")}}()}),function(){function ae(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function N(k){A.push(k,Date.now())}function O(){const k=[];for(let b=0;b<A.length;b+=2)k.push({name:A[b],startTime:A[b+1]});return k}return{mark:N,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(T+N.startTime)});return A}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function I(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=I(c))}(),define(he[5],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=a,e.$K=h,e.$h="en";let I=!1,c=!1,T=!1,A=!1,N=!1,O=!1,k=!1,b=!1,R=!1,$=!1,d,g=e.$h,l=e.$h,m,E;const f=globalThis;let w;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?w=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",p=P&&w?.type==="renderer";if(typeof w=="object"){I=w.platform==="win32",c=w.platform==="darwin",T=w.platform==="linux",A=T&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,k=P,R=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,g=e.$h;const y=w.env.VSCODE_NLS_CONFIG;if(y)try{const L=JSON.parse(y);d=L.userLocale,l=L.osLocale,g=L.resolvedLanguage||e.$h,m=L.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!p?(E=navigator.userAgent,I=E.indexOf("Windows")>=0,c=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=E.indexOf("Linux")>=0,$=E?.indexOf("Mobi")>=0,O=!0,g=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),l=d):console.error("Unable to resolve platform.");var o;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(o||(e.Platform=o={}));function u(y){switch(y){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;c?i=o.Mac:I?i=o.Windows:T&&(i=o.Linux),e.$j=I,e.$k=c,e.$l=T,e.$m=A,e.$n=N,e.$o=k,e.$p=O,e.$q=O&&typeof f.importScripts=="function",e.$r=e.$q?f.origin:void 0,e.$s=b,e.$t=$,e.$u=R,e.$v=i,e.$w=E,e.$x=g;var n;(function(y){function L(){return e.$x}y.value=L;function S(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}y.isDefaultVariant=S;function v(){return e.$x==="en"}y.isDefault=v})(n||(e.Language=n={})),e.$y=d,e.$z=l,e.$A=m,e.$B=typeof f.postMessage=="function"&&!f.importScripts,e.$C=(()=>{if(e.$B){const y=[];f.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let v=0,C=y.length;v<C;v++){const U=y[v];if(U.id===S.data.vscodeScheduleAsyncWork){y.splice(v,1),U.callback();return}}});let L=0;return S=>{const v=++L;y.push({id:v,callback:S}),f.postMessage({vscodeScheduleAsyncWork:v},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=c||b?t.Macintosh:I?t.Windows:t.Linux;let s=!0,r=!1;function a(){if(!r){r=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===513}return s}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function h(y){return parseFloat(y)>=20}}),define(he[37],ue([0,1,5]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let c;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const A=T.process;c={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$cc=c.platform,e.$dc=c.arch}),define(he[133],ue([0,1,37]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pX=N;var c;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(c||(c={}));const T="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function N(){const O=I.env[T];if(O){const b=O.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of b)switch(R){case"Unity":{const $=I.env.DESKTOP_SESSION;return $&&$.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const $=I.env[A];return $==="5"?c.KDE5:$==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const k=I.env.DESKTOP_SESSION;if(k)switch(k){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return A in I.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?c.GNOME:"KDE_FULL_SESSION"in I.env?A in I.env?c.KDE4:c.KDE3:c.UNKNOWN}});var Ot=this&&this.__createBinding||(Object.create?function(ae,e,I,c){c===void 0&&(c=I);var T=Object.getOwnPropertyDescriptor(e,I);(!T||("get"in T?!e.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return e[I]}}),Object.defineProperty(ae,c,T)}:function(ae,e,I,c){c===void 0&&(c=I),ae[c]=e[I]}),At=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Pe=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var I in ae)I!=="default"&&Object.prototype.hasOwnProperty.call(ae,I)&&Ot(e,ae,I);return At(e,ae),e};define(he[13],ue([0,1,37]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,I=Pe(I);const c=65,T=97,A=90,N=122,O=46,k=47,b=92,R=58,$=63;class d extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=n.indexOf(".")!==-1?"property":"argument";let h=`The "${n}" ${a} ${r} of type ${t}`;h+=`. Received type ${typeof s}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,n){if(i===null||typeof i!="object")throw new d(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new d(n,"string",i)}const m=I.$cc==="win32";function E(i){return i===k||i===b}function f(i){return i===k}function w(i){return i>=c&&i<=A||i>=T&&i<=N}function P(i,n,t,s){let r="",a=0,h=-1,y=0,L=0;for(let S=0;S<=i.length;++S){if(S<i.length)L=i.charCodeAt(S);else{if(s(L))break;L=k}if(s(L)){if(!(h===S-1||y===1))if(y===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==O||r.charCodeAt(r.length-2)!==O){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",a=0):(r=r.slice(0,v),a=r.length-1-r.lastIndexOf(t)),h=S,y=0;continue}else if(r.length!==0){r="",a=0,h=S,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${i.slice(h+1,S)}`:r=i.slice(h+1,S),a=S-h-1;h=S,y=0}else L===O&&y!==-1?++y:y=-1}return r}function p(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,n){g(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${p(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$ec={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let a;if(r>=0){if(a=i[r],l(a,`paths[${r}]`),a.length===0)continue}else n.length===0?a=I.cwd():(a=I.env[`=${n}`]||I.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==n.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${n}\\`));const h=a.length;let y=0,L="",S=!1;const v=a.charCodeAt(0);if(h===1)E(v)&&(y=1,S=!0);else if(E(v))if(S=!0,E(a.charCodeAt(1))){let C=2,U=C;for(;C<h&&!E(a.charCodeAt(C));)C++;if(C<h&&C!==U){const F=a.slice(U,C);for(U=C;C<h&&E(a.charCodeAt(C));)C++;if(C<h&&C!==U){for(U=C;C<h&&!E(a.charCodeAt(C));)C++;(C===h||C!==U)&&(L=`\\\\${F}\\${a.slice(U,C)}`,y=C)}}}else y=1;else w(v)&&a.charCodeAt(1)===R&&(L=a.slice(0,2),y=2,h>2&&E(a.charCodeAt(2))&&(S=!0,y=3));if(L.length>0)if(n.length>0){if(L.toLowerCase()!==n.toLowerCase())continue}else n=L;if(s){if(n.length>0)break}else if(t=`${a.slice(y)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const a=i.charCodeAt(0);if(n===1)return f(a)?"\\":i;if(E(a))if(r=!0,E(i.charCodeAt(1))){let y=2,L=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==L){const S=i.slice(L,y);for(L=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return`\\\\${S}\\${i.slice(L)}\\`;y!==L&&(s=`\\\\${S}\\${i.slice(L,y)}`,t=y)}}}else t=1;else w(a)&&i.charCodeAt(1)===R&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let h=t<n?P(i.slice(t),!r,"\\",E):"";return h.length===0&&!r&&(h="."),h.length>0&&E(i.charCodeAt(n-1))&&(h+="\\"),s===void 0?r?`\\${h}`:h:r?`${s}\\${h}`:`${s}${h}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&w(t)&&i.charCodeAt(1)===R&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let a=0;a<i.length;++a){const h=i[a];l(h,"path"),h.length>0&&(n===void 0?n=t=h:n+=`\\${h}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const a=t.length;a>1&&E(t.charCodeAt(1))&&(++r,a>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$ec.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$ec.resolve(i),s=e.$ec.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let a=i.length;for(;a-1>r&&i.charCodeAt(a-1)===b;)a--;const h=a-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===b;)y++;let L=n.length;for(;L-1>y&&n.charCodeAt(L-1)===b;)L--;const S=L-y,v=h<S?h:S;let C=-1,U=0;for(;U<v;U++){const M=i.charCodeAt(r+U);if(M!==n.charCodeAt(y+U))break;M===b&&(C=U)}if(U!==v){if(C===-1)return s}else{if(S>v){if(n.charCodeAt(y+U)===b)return s.slice(y+U+1);if(U===2)return s.slice(y+U)}h>v&&(i.charCodeAt(r+U)===b?C=U:U===2&&(C=3)),C===-1&&(C=0)}let F="";for(U=r+C+1;U<=a;++U)(U===a||i.charCodeAt(U)===b)&&(F+=F.length===0?"..":"\\..");return y+=C,F.length>0?`${F}${s.slice(y,L)}`:(s.charCodeAt(y)===b&&++y,s.slice(y,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$ec.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const t=n.charCodeAt(2);if(t!==$&&t!==O)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let y=2,L=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==L){for(L=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return i;y!==L&&(t=s=y+1)}}}}else w(r)&&i.charCodeAt(1)===R&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let a=-1,h=!0;for(let y=n-1;y>=s;--y)if(E(i.charCodeAt(y))){if(!h){a=y;break}}else h=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,a;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(a=i.length-1;a>=t;--a){const L=i.charCodeAt(a);if(E(L)){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),h>=0&&(L===n.charCodeAt(h)?--h===-1&&(s=a):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(a=i.length-1;a>=t;--a)if(E(i.charCodeAt(a))){if(!r){t=a+1;break}}else s===-1&&(r=!1,s=a+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,a=!0,h=0;i.length>=2&&i.charCodeAt(1)===R&&w(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const L=i.charCodeAt(y);if(E(L)){if(!a){s=y+1;break}continue}r===-1&&(a=!1,r=y+1),L===O?t===-1?t=y:h!==1&&(h=1):t!==-1&&(h=-1)}return t===-1||r===-1||h===0||h===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:o.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let C=2,U=C;for(;C<t&&!E(i.charCodeAt(C));)C++;if(C<t&&C!==U){for(U=C;C<t&&E(i.charCodeAt(C));)C++;if(C<t&&C!==U){for(U=C;C<t&&!E(i.charCodeAt(C));)C++;C===t?s=C:C!==U&&(s=C+1)}}}}else if(w(r)&&i.charCodeAt(1)===R){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let a=-1,h=s,y=-1,L=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!L){h=S+1;break}continue}y===-1&&(L=!1,y=S+1),r===O?a===-1?a=S:v!==1&&(v=1):a!==-1&&(v=-1)}return y!==-1&&(a===-1||v===0||v===1&&a===y-1&&a===h+1?n.base=n.name=i.slice(h,y):(n.name=i.slice(h,a),n.base=i.slice(h,y),n.ext=i.slice(a,y))),h>0&&h!==s?n.dir=i.slice(0,h-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(m){const i=/\\/g;return()=>{const n=I.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:u();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===k)}return n=P(n,!t,"/",f),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===k,t=i.charCodeAt(i.length-1)===k;return i=P(i,!n,"/",f),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$fc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$fc.resolve(i),n=e.$fc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,a=1,h=n.length-a,y=r<h?r:h;let L=-1,S=0;for(;S<y;S++){const C=i.charCodeAt(t+S);if(C!==n.charCodeAt(a+S))break;C===k&&(L=S)}if(S===y)if(h>y){if(n.charCodeAt(a+S)===k)return n.slice(a+S+1);if(S===0)return n.slice(a+S)}else r>y&&(i.charCodeAt(t+S)===k?L=S:S===0&&(L=0));let v="";for(S=t+L+1;S<=s;++S)(S===s||i.charCodeAt(S)===k)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(a+L)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===k;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===k){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,a;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let h=n.length-1,y=-1;for(a=i.length-1;a>=0;--a){const L=i.charCodeAt(a);if(L===k){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),h>=0&&(L===n.charCodeAt(h)?--h===-1&&(s=a):(h=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===k){if(!r){t=a+1;break}}else s===-1&&(r=!1,s=a+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,a=0;for(let h=i.length-1;h>=0;--h){const y=i.charCodeAt(h);if(y===k){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),y===O?n===-1?n=h:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||s===-1||a===0||a===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:o.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===k;let s;t?(n.root="/",s=1):s=0;let r=-1,a=0,h=-1,y=!0,L=i.length-1,S=0;for(;L>=s;--L){const v=i.charCodeAt(L);if(v===k){if(!y){a=L+1;break}continue}h===-1&&(y=!1,h=L+1),v===O?r===-1?r=L:S!==1&&(S=1):r!==-1&&(S=-1)}if(h!==-1){const v=a===0&&t?1:a;r===-1||S===0||S===1&&r===h-1&&r===a+1?n.base=n.name=i.slice(v,h):(n.name=i.slice(v,r),n.base=i.slice(v,h),n.ext=i.slice(r,h))}return a>0?n.dir=i.slice(0,a-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=m?e.$ec.normalize:e.$fc.normalize,e.$hc=m?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=m?e.$ec.join:e.$fc.join,e.$jc=m?e.$ec.resolve:e.$fc.resolve,e.$kc=m?e.$ec.relative:e.$fc.relative,e.$lc=m?e.$ec.dirname:e.$fc.dirname,e.$mc=m?e.$ec.basename:e.$fc.basename,e.$nc=m?e.$ec.extname:e.$fc.extname,e.$oc=m?e.$ec.format:e.$fc.format,e.$pc=m?e.$ec.parse:e.$fc.parse,e.$qc=m?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=m?e.$ec.sep:e.$fc.sep,e.$sc=m?e.$ec.delimiter:e.$fc.delimiter}),define(he[134],ue([0,1,13]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=A,e.$$s=N,e.$_s=O,e.$at=b,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const $=(0,I.$nc)(R),d=c[$.toLowerCase()];return d!==void 0?d:N(R)}function N(R){const $=(0,I.$nc)(R);return T[$.toLowerCase()]}function O(R){for(const $ in T)if(T[$]===R)return $}const k=/^(.+)\/(.+?)(;.+)?$/;function b(R,$){const d=k.exec(R);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:$?void 0:R}}),define(he[91],ue([0,1,5]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=A,e.$km=N;var c;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(c||(e.Source=c={}));var T;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function A(O,...k){const b=k.reduce((d,g)=>(d[g]=!0,d),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(d=>!b[d]).forEach(d=>{for(let g=0;g<R.length;g++)if(d.search(R[g])!==-1){delete O[d];break}})}function N(O){O&&(delete O.DEBUG,I.$l&&delete O.LD_PRELOAD)}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var c in I)(typeof exports=="object"?exports:ae)[c]=I[c]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function I(c){if(e[c])return e[c].exports;var T=e[c]={i:c,l:!1,exports:{}};return ae[c].call(T.exports,T,T.exports,I),T.l=!0,T.exports}return I.m=ae,I.c=e,I.d=function(c,T,A){I.o(c,T)||Object.defineProperty(c,T,{enumerable:!0,get:A})},I.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},I.t=function(c,T){if(1&T&&(c=I(c)),8&T||4&T&&typeof c=="object"&&c&&c.__esModule)return c;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:c}),2&T&&typeof c!="string")for(var N in c)I.d(A,N,function(O){return c[O]}.bind(null,N));return A},I.n=function(c){var T=c&&c.__esModule?function(){return c.default}:function(){return c};return I.d(T,"a",T),T},I.o=function(c,T){return Object.prototype.hasOwnProperty.call(c,T)},I.p="",I(I.s=0)}([function(ae,e,I){(function(c){var T;e=ae.exports=Q,T=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],k=e.src=[],b=0,R=b++;k[R]="0|[1-9]\\d*";var $=b++;k[$]="[0-9]+";var d=b++;k[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=b++;k[g]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var l=b++;k[l]="("+k[$]+")\\.("+k[$]+")\\.("+k[$]+")";var m=b++;k[m]="(?:"+k[R]+"|"+k[d]+")";var E=b++;k[E]="(?:"+k[$]+"|"+k[d]+")";var f=b++;k[f]="(?:-("+k[m]+"(?:\\."+k[m]+")*))";var w=b++;k[w]="(?:-?("+k[E]+"(?:\\."+k[E]+")*))";var P=b++;k[P]="[0-9A-Za-z-]+";var p=b++;k[p]="(?:\\+("+k[P]+"(?:\\."+k[P]+")*))";var o=b++,u="v?"+k[g]+k[f]+"?"+k[p]+"?";k[o]="^"+u+"$";var i="[v=\\s]*"+k[l]+k[w]+"?"+k[p]+"?",n=b++;k[n]="^"+i+"$";var t=b++;k[t]="((?:<|>)?=?)";var s=b++;k[s]=k[$]+"|x|X|\\*";var r=b++;k[r]=k[R]+"|x|X|\\*";var a=b++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[f]+")?"+k[p]+"?)?)?";var h=b++;k[h]="[v=\\s]*("+k[s]+")(?:\\.("+k[s]+")(?:\\.("+k[s]+")(?:"+k[w]+")?"+k[p]+"?)?)?";var y=b++;k[y]="^"+k[t]+"\\s*"+k[a]+"$";var L=b++;k[L]="^"+k[t]+"\\s*"+k[h]+"$";var S=b++;k[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=b++;k[v]="(?:~>?)";var C=b++;k[C]="(\\s*)"+k[v]+"\\s+",O[C]=new RegExp(k[C],"g");var U=b++;k[U]="^"+k[v]+k[a]+"$";var F=b++;k[F]="^"+k[v]+k[h]+"$";var M=b++;k[M]="(?:\\^)";var G=b++;k[G]="(\\s*)"+k[M]+"\\s+",O[G]=new RegExp(k[G],"g");var V=b++;k[V]="^"+k[M]+k[a]+"$";var _=b++;k[_]="^"+k[M]+k[h]+"$";var H=b++;k[H]="^"+k[t]+"\\s*("+i+")$|^$";var ie=b++;k[ie]="^"+k[t]+"\\s*("+u+")$|^$";var B=b++;k[B]="(\\s*)"+k[t]+"\\s*("+i+"|"+k[a]+")",O[B]=new RegExp(k[B],"g");var z=b++;k[z]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var ee=b++;k[ee]="^\\s*("+k[h]+")\\s+-\\s+("+k[h]+")\\s*$";var ne=b++;k[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)T(le,k[le]),O[le]||(O[le]=new RegExp(k[le]));function te(oe,de){if(oe instanceof Q)return oe;if(typeof oe!="string"||oe.length>A||!(de?O[n]:O[o]).test(oe))return null;try{return new Q(oe,de)}catch{return null}}function Q(oe,de){if(oe instanceof Q){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Q))return new Q(oe,de);T("SemVer",oe,de),this.loose=de;var ge=oe.trim().match(de?O[n]:O[o]);if(!ge)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Oe=+Ie;if(Oe>=0&&Oe<N)return Oe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(oe,de){var ge=te(oe,de);return ge?ge.version:null},e.clean=function(oe,de){var ge=te(oe.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(oe){return T("SemVer.compare",this.version,this.loose,oe),oe instanceof Q||(oe=new Q(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},Q.prototype.compareMain=function(oe){return oe instanceof Q||(oe=new Q(oe,this.loose)),q(this.major,oe.major)||q(this.minor,oe.minor)||q(this.patch,oe.patch)},Q.prototype.comparePre=function(oe){if(oe instanceof Q||(oe=new Q(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ie=oe.prerelease[de];if(T("prerelease compare",de,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return q(ge,Ie)}while(++de)},Q.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new Q(oe,ge).inc(de,Ie).version}catch{return null}},e.diff=function(oe,de){if(j(oe,de))return null;var ge=te(oe),Ie=te(de);if(ge.prerelease.length||Ie.prerelease.length){for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Ie[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Ie[Oe])return Oe},e.compareIdentifiers=q;var K=/^[0-9]+$/;function q(oe,de){var ge=K.test(oe),Ie=K.test(de);return ge&&Ie&&(oe=+oe,de=+de),ge&&!Ie?-1:Ie&&!ge?1:oe<de?-1:oe>de?1:0}function D(oe,de,ge){return new Q(oe,ge).compare(new Q(de,ge))}function X(oe,de,ge){return D(oe,de,ge)>0}function J(oe,de,ge){return D(oe,de,ge)<0}function j(oe,de,ge){return D(oe,de,ge)===0}function W(oe,de,ge){return D(oe,de,ge)!==0}function Y(oe,de,ge){return D(oe,de,ge)>=0}function Z(oe,de,ge){return D(oe,de,ge)<=0}function se(oe,de,ge,Ie){var Oe;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof ge=="object"&&(ge=ge.version),Oe=oe===ge;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ge=="object"&&(ge=ge.version),Oe=oe!==ge;break;case"":case"=":case"==":Oe=j(oe,ge,Ie);break;case"!=":Oe=W(oe,ge,Ie);break;case">":Oe=X(oe,ge,Ie);break;case">=":Oe=Y(oe,ge,Ie);break;case"<":Oe=J(oe,ge,Ie);break;case"<=":Oe=Z(oe,ge,Ie);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function ce(oe,de){if(oe instanceof ce){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ce))return new ce(oe,de);T("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===me?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(oe,de){return q(de,oe)},e.major=function(oe,de){return new Q(oe,de).major},e.minor=function(oe,de){return new Q(oe,de).minor},e.patch=function(oe,de){return new Q(oe,de).patch},e.compare=D,e.compareLoose=function(oe,de){return D(oe,de,!0)},e.rcompare=function(oe,de,ge){return D(de,oe,ge)},e.sort=function(oe,de){return oe.sort(function(ge,Ie){return e.compare(ge,Ie,de)})},e.rsort=function(oe,de){return oe.sort(function(ge,Ie){return e.rcompare(ge,Ie,de)})},e.gt=X,e.lt=J,e.eq=j,e.neq=W,e.gte=Y,e.lte=Z,e.cmp=se,e.Comparator=ce;var me={};function pe(oe,de){if(oe instanceof pe)return oe.loose===de?oe:new pe(oe.raw,de);if(oe instanceof ce)return new pe(oe.value,de);if(!(this instanceof pe))return new pe(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function ke(oe,de,ge,Ie,Oe,De,Ne,Le,Ue,Be,Ve,Me,qe){return((de=Ee(ge)?"":Ee(Ie)?">="+ge+".0.0":Ee(Oe)?">="+ge+"."+Ie+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(Be)?"<"+(+Ue+1)+".0.0":Ee(Ve)?"<"+Ue+"."+(+Be+1)+".0":Me?"<="+Ue+"."+Be+"."+Ve+"-"+Me:"<="+Le)).trim()}function be(oe,de){for(var ge=0;ge<oe.length;ge++)if(!oe[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<oe.length;ge++)if(T(oe[ge].semver),oe[ge].semver!==me&&oe[ge].semver.prerelease.length>0){var Ie=oe[ge].semver;if(Ie.major===de.major&&Ie.minor===de.minor&&Ie.patch===de.patch)return!0}return!1}return!0}function we(oe,de,ge){try{de=new pe(de,ge)}catch{return!1}return de.test(oe)}function Se(oe,de,ge,Ie){var Oe,De,Ne,Le,Ue;switch(oe=new Q(oe,Ie),de=new pe(de,Ie),ge){case">":Oe=X,De=Z,Ne=J,Le=">",Ue=">=";break;case"<":Oe=J,De=Y,Ne=X,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(oe,de,Ie))return!1;for(var Be=0;Be<de.set.length;++Be){var Ve=de.set[Be],Me=null,qe=null;if(Ve.forEach(function(ze){ze.semver===me&&(ze=new ce(">=0.0.0")),Me=Me||ze,qe=qe||ze,Oe(ze.semver,Me.semver,Ie)?Me=ze:Ne(ze.semver,qe.semver,Ie)&&(qe=ze)}),Me.operator===Le||Me.operator===Ue||(!qe.operator||qe.operator===Le)&&De(oe,qe.semver)||qe.operator===Ue&&Ne(oe,qe.semver))return!1}return!0}ce.prototype.parse=function(oe){var de=this.loose?O[H]:O[ie],ge=oe.match(de);if(!ge)throw new TypeError("Invalid comparator: "+oe);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new Q(ge[2],this.loose):this.semver=me},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(oe){return T("Comparator.test",oe,this.loose),this.semver===me||(typeof oe=="string"&&(oe=new Q(oe,this.loose)),se(oe,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(oe,de){if(!(oe instanceof ce))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new pe(oe.value,de),we(this.value,ge,de);if(oe.operator==="")return ge=new pe(this.value,de),we(oe.semver,ge,de);var Ie=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),De=this.semver.version===oe.semver.version,Ne=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Le=se(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ue=se(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ie||Oe||De&&Ne||Le||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),T("range",oe,de);var ge=de?O[ee]:O[z];oe=oe.replace(ge,ke),T("hyphen replace",oe),oe=oe.replace(O[B],"$1$2$3"),T("comparator trim",oe,O[B]),oe=(oe=(oe=oe.replace(O[C],"$1~")).replace(O[G],"$1^")).split(/\s+/).join(" ");var Ie=de?O[H]:O[ie],Oe=oe.split(" ").map(function(De){return function(Ne,Le){return T("comp",Ne),Ne=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Ve){return function(Me,qe){T("caret",Me,qe);var ze=qe?O[_]:O[V];return Me.replace(ze,function(We,Te,re,fe,$e){var ye;return T("caret",Me,We,Te,re,fe,$e),Ee(Te)?ye="":Ee(re)?ye=">="+Te+".0.0 <"+(+Te+1)+".0.0":Ee(fe)?ye=Te==="0"?">="+Te+"."+re+".0 <"+Te+"."+(+re+1)+".0":">="+Te+"."+re+".0 <"+(+Te+1)+".0.0":$e?(T("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Te==="0"?re==="0"?">="+Te+"."+re+"."+fe+$e+" <"+Te+"."+re+"."+(+fe+1):">="+Te+"."+re+"."+fe+$e+" <"+Te+"."+(+re+1)+".0":">="+Te+"."+re+"."+fe+$e+" <"+(+Te+1)+".0.0"):(T("no pr"),ye=Te==="0"?re==="0"?">="+Te+"."+re+"."+fe+" <"+Te+"."+re+"."+(+fe+1):">="+Te+"."+re+"."+fe+" <"+Te+"."+(+re+1)+".0":">="+Te+"."+re+"."+fe+" <"+(+Te+1)+".0.0"),T("caret return",ye),ye})}(Ve,Be)}).join(" ")}(Ne,Le),T("caret",Ne),Ne=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Ve){return function(Me,qe){var ze=qe?O[F]:O[U];return Me.replace(ze,function(We,Te,re,fe,$e){var ye;return T("tilde",Me,We,Te,re,fe,$e),Ee(Te)?ye="":Ee(re)?ye=">="+Te+".0.0 <"+(+Te+1)+".0.0":Ee(fe)?ye=">="+Te+"."+re+".0 <"+Te+"."+(+re+1)+".0":$e?(T("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Te+"."+re+"."+fe+$e+" <"+Te+"."+(+re+1)+".0"):ye=">="+Te+"."+re+"."+fe+" <"+Te+"."+(+re+1)+".0",T("tilde return",ye),ye})}(Ve,Be)}).join(" ")}(Ne,Le),T("tildes",Ne),Ne=function(Ue,Be){return T("replaceXRanges",Ue,Be),Ue.split(/\s+/).map(function(Ve){return function(Me,qe){Me=Me.trim();var ze=qe?O[L]:O[y];return Me.replace(ze,function(We,Te,re,fe,$e,ye){T("xRange",Me,We,Te,re,fe,$e,ye);var Ae=Ee(re),Ce=Ae||Ee(fe),je=Ce||Ee($e);return Te==="="&&je&&(Te=""),Ae?We=Te===">"||Te==="<"?"<0.0.0":"*":Te&&je?(Ce&&(fe=0),je&&($e=0),Te===">"?(Te=">=",Ce?(re=+re+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Te==="<="&&(Te="<",Ce?re=+re+1:fe=+fe+1),We=Te+re+"."+fe+"."+$e):Ce?We=">="+re+".0.0 <"+(+re+1)+".0.0":je&&(We=">="+re+"."+fe+".0 <"+re+"."+(+fe+1)+".0"),T("xRange return",We),We})}(Ve,Be)}).join(" ")}(Ne,Le),T("xrange",Ne),Ne=function(Ue,Be){return T("replaceStars",Ue,Be),Ue.trim().replace(O[ne],"")}(Ne,Le),T("stars",Ne),Ne}(De,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(De){return!!De.match(Ie)})),Oe=Oe.map(function(De){return new ce(De,de)})},pe.prototype.intersects=function(oe,de){if(!(oe instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return oe.set.some(function(Oe){return Oe.every(function(De){return Ie.intersects(De,de)})})})})},e.toComparators=function(oe,de){return new pe(oe,de).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new Q(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(oe,de,ge){var Ie=null,Oe=null;try{var De=new pe(de,ge)}catch{return null}return oe.forEach(function(Ne){De.test(Ne)&&(Ie&&Oe.compare(Ne)!==-1||(Oe=new Q(Ie=Ne,ge)))}),Ie},e.minSatisfying=function(oe,de,ge){var Ie=null,Oe=null;try{var De=new pe(de,ge)}catch{return null}return oe.forEach(function(Ne){De.test(Ne)&&(Ie&&Oe.compare(Ne)!==1||(Oe=new Q(Ie=Ne,ge)))}),Ie},e.validRange=function(oe,de){try{return new pe(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,ge){return Se(oe,de,"<",ge)},e.gtr=function(oe,de,ge){return Se(oe,de,">",ge)},e.outside=Se,e.prerelease=function(oe,de){var ge=te(oe,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(oe,de,ge){return oe=new pe(oe,ge),de=new pe(de,ge),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof Q)return oe;if(typeof oe!="string")return null;var de=oe.match(O[S]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,I(1))},function(ae,e){var I,c,T=ae.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function O(E){if(I===setTimeout)return setTimeout(E,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(E,0);try{return I(E,0)}catch{try{return I.call(null,E,0)}catch{return I.call(this,E,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{c=typeof clearTimeout=="function"?clearTimeout:N}catch{c=N}})();var k,b=[],R=!1,$=-1;function d(){R&&k&&(R=!1,k.length?b=k.concat(b):$=-1,b.length&&g())}function g(){if(!R){var E=O(d);R=!0;for(var f=b.length;f;){for(k=b,b=[];++$<f;)k&&k[$].run();$=-1,f=b.length}k=null,R=!1,function(w){if(c===clearTimeout)return clearTimeout(w);if((c===N||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(w);try{c(w)}catch{try{return c.call(null,w)}catch{return c.call(this,w)}}}(E)}}function l(E,f){this.fun=E,this.array=f}function m(){}T.nextTick=function(E){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];b.push(new l(E,f)),b.length!==1||R||O(g)},l.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=m,T.addListener=m,T.once=m,T.off=m,T.removeListener=m,T.removeAllListeners=m,T.emit=m,T.prependListener=m,T.prependOnceListener=m,T.listeners=function(E){return[]},T.binding=function(E){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(E){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(he[135],ue([0,1]),function(ae,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class c{constructor(O,k,b){this.level=O,this.key=k,this.value=b,this.forward=[]}}const T=void 0;class A{constructor(O,k=2**16){this.comparator=O,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new c(this.c,T,T)}get size(){return this.f}clear(){this.e=new c(this.c,T,T),this.f=0}has(O){return!!A.g(this,O,this.comparator)}get(O){return A.g(this,O,this.comparator)?.value}set(O,k){return A.h(this,O,k,this.comparator)&&(this.f+=1),this}delete(O){const k=A.k(this,O,this.comparator);return k&&(this.f-=1),k}forEach(O,k){let b=this.e.forward[0];for(;b;)O.call(k,b.value,b.key,this),b=b.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",k=this.e.forward[0];for(;k;)O+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return O}static g(O,k,b){let R=O.e;for(let $=O.d-1;$>=0;$--)for(;R.forward[$]&&b(R.forward[$].key,k)<0;)R=R.forward[$];if(R=R.forward[0],R&&b(R.key,k)===0)return R}static h(O,k,b,R){const $=[];let d=O.e;for(let g=O.d-1;g>=0;g--){for(;d.forward[g]&&R(d.forward[g].key,k)<0;)d=d.forward[g];$[g]=d}if(d=d.forward[0],d&&R(d.key,k)===0)return d.value=b,!1;{const g=A.j(O);if(g>O.d){for(let l=O.d;l<g;l++)$[l]=O.e;O.d=g}d=new c(g,k,b);for(let l=0;l<g;l++)d.forward[l]=$[l].forward[l],$[l].forward[l]=d;return!0}}static j(O,k=.5){let b=1;for(;Math.random()<k&&b<O.c;)b+=1;return b}static k(O,k,b){const R=[];let $=O.e;for(let d=O.d-1;d>=0;d--){for(;$.forward[d]&&b($.forward[d].key,k)<0;)$=$.forward[d];R[d]=$}if($=$.forward[0],!$||b($.key,k)!==0)return!1;for(let d=0;d<O.d&&R[d].forward[d]===$;d++)R[d].forward[d]=$.forward[d];for(;O.d>0&&O.e.forward[O.d-1]===T;)O.d-=1;return!0}}e.$Rs=A}),define(he[54],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(A){return new c(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ee=c}),define(he[3],ue([0,1,8,88,2,89,54]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$ge=e.Event=void 0,e.$he=g;const O=!1,k=!1,b=!1;var R;(function(F){F.None=()=>T.$Tc.None;function M(be){if(b){const{onDidAddListener:we}=be,Se=m.create();let oe=0;be.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),we?.()}}}function G(be,we){return te(be,()=>{},0,void 0,!0,void 0,we)}F.defer=G;function V(be){return(we,Se=null,oe)=>{let de=!1,ge;return ge=be(Ie=>{if(!de)return ge?ge.dispose():de=!0,we.call(Se,Ie)},null,oe),de&&ge.dispose(),ge}}F.once=V;function _(be,we,Se){return ne((oe,de=null,ge)=>be(Ie=>oe.call(de,we(Ie)),null,ge),Se)}F.map=_;function H(be,we,Se){return ne((oe,de=null,ge)=>be(Ie=>{we(Ie),oe.call(de,Ie)},null,ge),Se)}F.forEach=H;function ie(be,we,Se){return ne((oe,de=null,ge)=>be(Ie=>we(Ie)&&oe.call(de,Ie),null,ge),Se)}F.filter=ie;function B(be){return be}F.signal=B;function z(...be){return(we,Se=null,oe)=>{const de=(0,T.$Qc)(...be.map(ge=>ge(Ie=>we.call(Se,Ie))));return le(de,oe)}}F.any=z;function ee(be,we,Se,oe){let de=Se;return _(be,ge=>(de=we(de,ge),de),oe)}F.reduce=ee;function ne(be,we){let Se;const oe={onWillAddFirstListener(){Se=be(de.fire,de)},onDidRemoveLastListener(){Se?.dispose()}};we||M(oe);const de=new i(oe);return we?.add(de),de.event}function le(be,we){return we instanceof Array?we.push(be):we&&we.add(be),be}function te(be,we,Se=100,oe=!1,de=!1,ge,Ie){let Oe,De,Ne,Le=0,Ue;const Be={leakWarningThreshold:ge,onWillAddFirstListener(){Oe=be(Me=>{Le++,De=we(De,Me),oe&&!Ne&&(Ve.fire(De),De=void 0),Ue=()=>{const qe=De;De=void 0,Ne=void 0,(!oe||Le>1)&&Ve.fire(qe),Le=0},typeof Se=="number"?(clearTimeout(Ne),Ne=setTimeout(Ue,Se)):Ne===void 0&&(Ne=0,queueMicrotask(Ue))})},onWillRemoveListener(){de&&Le>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Oe.dispose()}};Ie||M(Be);const Ve=new i(Be);return Ie?.add(Ve),Ve.event}F.debounce=te;function Q(be,we=0,Se){return F.debounce(be,(oe,de)=>oe?(oe.push(de),oe):[de],we,void 0,!0,void 0,Se)}F.accumulate=Q;function K(be,we=(oe,de)=>oe===de,Se){let oe=!0,de;return ie(be,ge=>{const Ie=oe||!we(ge,de);return oe=!1,de=ge,Ie},Se)}F.latch=K;function q(be,we,Se){return[F.filter(be,we,Se),F.filter(be,oe=>!we(oe),Se)]}F.split=q;function D(be,we=!1,Se=[],oe){let de=Se.slice(),ge=be(De=>{de?de.push(De):Oe.fire(De)});oe&&oe.add(ge);const Ie=()=>{de?.forEach(De=>Oe.fire(De)),de=null},Oe=new i({onWillAddFirstListener(){ge||(ge=be(De=>Oe.fire(De)),oe&&oe.add(ge))},onDidAddFirstListener(){de&&(we?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ge&&ge.dispose(),ge=null}});return oe&&oe.add(Oe),Oe.event}F.buffer=D;function X(be,we){return(oe,de,ge)=>{const Ie=we(new j);return be(function(Oe){const De=Ie.evaluate(Oe);De!==J&&oe.call(de,De)},void 0,ge)}}F.chain=X;const J=Symbol("HaltChainable");class j{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Se=>(we(Se),Se)),this}filter(we){return this.f.push(Se=>we(Se)?Se:J),this}reduce(we,Se){let oe=Se;return this.f.push(de=>(oe=we(oe,de),oe)),this}latch(we=(Se,oe)=>Se===oe){let Se=!0,oe;return this.f.push(de=>{const ge=Se||!we(de,oe);return Se=!1,oe=de,ge?de:J}),this}evaluate(we){for(const Se of this.f)if(we=Se(we),we===J)break;return we}}function W(be,we,Se=oe=>oe){const oe=(...Oe)=>Ie.fire(Se(...Oe)),de=()=>be.on(we,oe),ge=()=>be.removeListener(we,oe),Ie=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ge});return Ie.event}F.fromNodeEventEmitter=W;function Y(be,we,Se=oe=>oe){const oe=(...Oe)=>Ie.fire(Se(...Oe)),de=()=>be.addEventListener(we,oe),ge=()=>be.removeEventListener(we,oe),Ie=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ge});return Ie.event}F.fromDOMEventEmitter=Y;function Z(be){return new Promise(we=>V(be)(we))}F.toPromise=Z;function se(be){const we=new i;return be.then(Se=>{we.fire(Se)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}F.fromPromise=se;function ce(be,we){return be(Se=>we.fire(Se))}F.forward=ce;function me(be,we,Se){return we(Se),be(oe=>we(oe))}F.runAndSubscribe=me;class pe{constructor(we,Se){this._observable=we,this.f=0,this.g=!1;const oe={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Se||M(oe),this.emitter=new i(oe),Se&&Se.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Se){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(be,we){return new pe(be,we).emitter.event}F.fromObservable=Ee;function ke(be){return(we,Se,oe)=>{let de=0,ge=!1;const Ie={beginUpdate(){de++},endUpdate(){de--,de===0&&(be.reportChanges(),ge&&(ge=!1,we.call(Se)))},handlePossibleChange(){},handleChange(){ge=!0}};be.addObserver(Ie),be.reportChanges();const Oe={dispose(){be.removeObserver(Ie)}};return oe instanceof T.$Sc?oe.add(Oe):Array.isArray(oe)&&oe.push(Oe),Oe}}F.fromObservableLight=ke})(R||(e.Event=R={}));class ${static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${$.f++}`,$.all.add(this)}start(M){this.g=new N.$ee,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ge=$;let d=-1;function g(F){const M=d;return d=F,{dispose(){d=M}}}class l{static{this.f=1}constructor(M,G,V=(l.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=G,this.name=V,this.h=0}dispose(){this.g?.clear()}check(M,G){const V=this.threshold;if(V<=0||G<V)return;this.g||(this.g=new Map);const _=this.g.get(M.value)||0;if(this.g.set(M.value,_+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,ie]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${ie}):`;console.warn(B),console.warn(H);const z=new E(B,H);this.j(z)}return()=>{const H=this.g.get(M.value)||0;this.g.set(M.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let M,G=0;for(const[V,_]of this.g)(!M||G<_)&&(M=[V,_],G=_);return M}}class m{static create(){const M=new Error;return new m(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(M,G){super(M),this.name="ListenerLeakError",this.stack=G}}e.$ie=E;class f extends Error{constructor(M,G){super(M),this.name="ListenerRefusalError",this.stack=G}}e.$je=f;let w=0;class P{constructor(M){this.value=M,this.id=w++}}const p=2,o=(F,M)=>{if(F instanceof P)M(F);else for(let G=0;G<F.length;G++){const V=F[G];V&&M(V)}};let u;if(O){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),u=new FinalizationRegistry(M=>{typeof M=="string"&&F.push(M)})}class i{constructor(M){this.z=0,this.f=M,this.g=d>0||this.f?.leakWarningThreshold?new l(M?.onListenerError??I.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(k){const M=this.u;queueMicrotask(()=>{o(M,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,G,V)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new f(`${z}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||I.$Y)(ne),T.$Tc.None}if(this.m)return T.$Tc.None;G&&(M=M.bind(G));const _=new P(M);let H,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(_.stack=m.create(),H=this.g.check(_.stack,this.z+1)),k&&(_.stack=ie??m.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,_]):this.u.push(_):(this.f?.onWillAddFirstListener?.(this),this.u=_,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,T.$Rc)(()=>{u?.unregister(B),H?.(),this.A(_)});if(V instanceof T.$Sc?V.add(B):Array.isArray(V)&&V.push(B),u){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);u.register(B,ee?.[2]??z,B)}return B},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,V=G.indexOf(M);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[V]=void 0;const _=this.w.current===this;if(this.z*p<=G.length){let H=0;for(let ie=0;ie<G.length;ie++)G[ie]?G[H++]=G[ie]:_&&(this.w.end--,H<this.w.i&&this.w.i--);G.length=H}}B(M,G){if(!M)return;const V=this.f?.onListenerError||I.$Y;if(!V){M.value(G);return}try{M.value(G)}catch(_){V(_)}}C(M){const G=M.current.u;for(;M.i<M.end;)this.B(G[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,M);else{const G=this.w;G.enqueue(this,M,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ke=i;const n=()=>new t;e.$le=n;class t{constructor(){this.i=-1,this.end=0}enqueue(M,G,V){this.i=0,this.end=V,this.current=M,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(M,G,V){if(this.u)for(this.h||(this.h=new A.$4c),o(this.u,_=>this.h.push([_.value,M]));this.h.size>0&&!G.isCancellationRequested;){const[_,H]=this.h.shift(),ie=[],B={...H,token:G,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");V&&(z=V(z,_)),ie.push(z)}};try{_(B)}catch(z){(0,I.$Y)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,I.$Y)(ee.reason)})}}}e.$me=s;class r extends i{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new A.$4c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$ne=r;class a extends r{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$oe=a;class h extends i{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}e.$pe=h;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const G={event:M,listener:null};this.h.push(G),this.g&&this.m(G);const V=()=>{this.g&&this.o(G);const _=this.h.indexOf(G);this.h.splice(_,1)};return(0,T.$Rc)((0,c.$cb)(V))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(G=>this.f.fire(G))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$qe=y;class L{constructor(M,G,V,_){this.f=new T.$Sc;const H=this.f.add(new y),ie=this.f.add(new T.$3c);function B(z){ie.set(z,H.add(_(z)))}for(const z of M)B(z);this.f.add(G(z=>{B(z)})),this.f.add(V(z=>{ie.deleteAndDispose(z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$re=L;class S{constructor(){this.f=[]}wrapEvent(M,G,V){return(_,H,ie)=>M(B=>{const z=this.f[this.f.length-1];if(!G){z?z.buffers.push(()=>_.call(H,B)):_.call(H,B);return}const ee=z;if(!ee){_.call(H,G(V,B));return}ee.items??=[],ee.items.push(B),ee.buffers.length===0&&z.buffers.push(()=>{ee.reducedResult??=V?ee.items.reduce(G,V):ee.items.reduce(G),_.call(H,ee.reducedResult)})},void 0,ie)}bufferEvents(M){const G={buffers:new Array};this.f.push(G);const V=M();return this.f.pop(),G.buffers.forEach(_=>_()),V}}e.$se=S;class v{constructor(){this.f=!1,this.g=R.None,this.h=T.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$te=v;class C{static const(M){return new U(M)}constructor(M){this.g=M,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$ue=C;class U{constructor(M){this.value=M,this.onDidChange=R.None}}}),define(he[25],ue([0,1,3]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.CancellationToken=void 0,e.$we=O;const c=Object.freeze(function(k,b){const R=setTimeout(k.bind(b),0);return{dispose(){clearTimeout(R)}}});var T;(function(k){function b(R){return R===k.None||R===k.Cancelled||R instanceof A?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(T||(e.CancellationToken=T={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new I.$ke),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=T.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=T.None}}e.$ve=N;function O(k){const b=new N;return k.add({dispose(){b.cancel()}}),b.token}}),define(he[136],ue([0,1,25]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$e=e.$0e=e.$8e=void 0,e.$9e=T;class c{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.$ve,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$8e=c;function T(O){return O}class A{constructor(k,b){this.a=void 0,this.b=void 0,typeof k=="function"?(this.c=k,this.d=T):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}e.$0e=A;class N{get cachedValues(){return this.a}constructor(k,b){this.a=new Map,this.b=new Map,typeof k=="function"?(this.c=k,this.d=T):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);if(this.b.has(b))return this.b.get(b);const R=this.c(k);return this.a.set(k,R),this.b.set(b,R),R}}e.$$e=N}),define(he[50],ue([0,1,8,2]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=T,e.$ye=A,e.$ze=N,e.$Ae=O,e.$Be=b,e.$Ce=R,e.$De=$,e.$Ee=d,e.$Fe=g,e.$Ge=l,e.$He=m,e.$Ie=E,e.$Je=f,e.$Ke=w,e.$Le=P;function T(p){const o=p;return o?typeof o.read=="function":!1}function A(p){const o=p;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}function N(p){const o=p;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function O(p,o){return new k(p,o)}class k{constructor(o,u){this.e=o,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(u=>u(o))}h(o){this.c.error.length===0?(0,I.$Y)(o):this.c.error.slice(0).forEach(u=>u(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,u){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(o,u){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(u);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,o){const u=[];let i;for(;(i=p.read())!==null;)u.push(i);return o(u)}function R(p,o,u){const i=[];let n;for(;(n=p.read())!==null&&i.length<u;)i.push(n);return n===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return p.read()}}}function $(p,o){return new Promise((u,i)=>{const n=[];d(p,{onData:t=>{o&&n.push(t)},onError:t=>{o?i(t):u(void 0)},onEnd:()=>{u(o?o(n):void 0)}})})}function d(p,o,u){p.on("error",i=>{u?.isCancellationRequested||o.onError(i)}),p.on("end",()=>{u?.isCancellationRequested||o.onEnd()}),p.on("data",i=>{u?.isCancellationRequested||o.onData(i)})}function g(p,o){return new Promise((u,i)=>{const n=new c.$Sc,t=[],s=h=>{if(t.push(h),t.length>o)return n.dispose(),p.pause(),u({stream:p,buffer:t,ended:!1})},r=h=>(n.dispose(),i(h)),a=()=>(n.dispose(),u({stream:p,buffer:t,ended:!0}));n.add((0,c.$Rc)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,c.$Rc)(()=>p.removeListener("end",a))),p.on("end",a),n.add((0,c.$Rc)(()=>p.removeListener("data",s))),p.on("data",s)})}function l(p,o){const u=O(o);return u.end(p),u}function m(){const p=O(()=>{throw new Error("not supported")});return p.end(),p}function E(p){let o=!1;return{read:()=>o?null:(o=!0,p)}}function f(p,o,u){const i=O(u);return d(p,{onData:n=>i.write(o.data(n)),onError:n=>i.error(o.error?o.error(n):n),onEnd:()=>i.end()}),i}function w(p,o,u){let i=!1;return{read:()=>{const n=o.read();return i?n:(i=!0,n!==null?u([p,n]):p)}}}function P(p,o,u){let i=!1;const n=O(u);return d(o,{onData:t=>i?n.write(t):(i=!0,n.write(u([p,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(p)),n.end()}}),n}}),define(he[14],ue([0,1,53,50]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=void 0,e.$Ne=b,e.$Oe=R,e.$Pe=$,e.$Qe=d,e.$Re=g,e.$Se=l,e.$Te=m,e.$Ue=E,e.$Ve=f,e.$We=w,e.$Xe=P,e.$Ye=p,e.$Ze=o,e.$1e=u,e.$2e=i,e.$3e=n,e.$4e=t,e.$5e=s,e.$6e=r,e.$7e=y,c=Pe(c);const T=typeof Buffer<"u",A=new I.$T(()=>new Uint8Array(256));let N,O;class k{static alloc(S){return T?new k(Buffer.allocUnsafe(S)):new k(new Uint8Array(S))}static wrap(S){return T&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new k(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&T?new k(Buffer.from(S)):(N||(N=new TextEncoder),new k(N.encode(S)))}static fromByteArray(S){const v=k.alloc(S.length);for(let C=0,U=S.length;C<U;C++)v.buffer[C]=S[C];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let F=0,M=S.length;F<M;F++)v+=S[F].byteLength}const C=k.alloc(v);let U=0;for(let F=0,M=S.length;F<M;F++){const G=S[F];C.set(G,U),U+=G.byteLength}return C}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=k.alloc(this.byteLength);return S.set(this),S}toString(){return T?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(S,v){return new k(this.buffer.subarray(S,v))}set(S,v){if(S instanceof k)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return d(this.buffer,S)}writeUInt32BE(S,v){g(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){m(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){f(this.buffer,S,v)}indexOf(S,v=0){return b(this.buffer,S instanceof k?S.buffer:S,v)}}e.$Me=k;function b(L,S,v=0){const C=S.byteLength,U=L.byteLength;if(C===0)return 0;if(C===1)return L.indexOf(S[0]);if(C>U-v)return-1;const F=A.value;F.fill(S.length);for(let _=0;_<S.length;_++)F[S[_]]=S.length-_-1;let M=v+S.length-1,G=M,V=-1;for(;M<U;)if(L[M]===S[G]){if(G===0){V=M;break}M--,G--}else M+=Math.max(S.length-G,F[L[M]]),G=S.length-1;return V}function R(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0}function $(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255}function d(L,S){return L[S]*2**24+L[S+1]*2**16+L[S+2]*2**8+L[S+3]}function g(L,S,v){L[v+3]=S,S=S>>>8,L[v+2]=S,S=S>>>8,L[v+1]=S,S=S>>>8,L[v]=S}function l(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0|L[S+2]<<16>>>0|L[S+3]<<24>>>0}function m(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255,S=S>>>8,L[v+2]=S&255,S=S>>>8,L[v+3]=S&255}function E(L,S){return L[S]}function f(L,S,v){L[v]=S}function w(L){return c.$Be(L,S=>k.concat(S))}function P(L){return c.$Ie(L)}function p(L){return c.$De(L,S=>k.concat(S))}async function o(L){return L.ended?k.concat(L.buffer):k.concat([...L.buffer,await p(L.stream)])}function u(L){return c.$Ge(L,S=>k.concat(S))}function i(L){return c.$Je(L,{data:S=>typeof S=="string"?k.fromString(S):k.wrap(S)},S=>k.concat(S))}function n(L){return c.$Ae(S=>k.concat(S),L)}function t(L,S){return c.$Ke(L,S,v=>k.concat(v))}function s(L,S){return c.$Le(L,S,v=>k.concat(v))}function r(L){let S=0,v=0,C=0;const U=new Uint8Array(Math.floor(L.length/4*3)),F=G=>{switch(v){case 3:U[C++]=S|G,v=0;break;case 2:U[C++]=S|G>>>2,S=G<<6,v=3;break;case 1:U[C++]=S|G>>>4,S=G<<4,v=2;break;default:S=G<<2,v=1}};for(let G=0;G<L.length;G++){const V=L.charCodeAt(G);if(V>=65&&V<=90)F(V-65);else if(V>=97&&V<=122)F(V-97+26);else if(V>=48&&V<=57)F(V-48+52);else if(V===43||V===45)F(62);else if(V===47||V===95)F(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${L[G]}`)}}const M=C;for(;v>0;)F(0);return k.wrap(U).slice(0,M)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:L},S=!0,v=!1){const C=v?h:a;let U="";const F=L.byteLength%3;let M=0;for(;M<L.byteLength-F;M+=3){const G=L[M+0],V=L[M+1],_=L[M+2];U+=C[G>>>2],U+=C[(G<<4|V>>>4)&63],U+=C[(V<<2|_>>>6)&63],U+=C[_&63]}if(F===1){const G=L[M+0];U+=C[G>>>2],U+=C[G<<4&63],S&&(U+="==")}else if(F===2){const G=L[M+0],V=L[M+1];U+=C[G>>>2],U+=C[(G<<4|V>>>4)&63],U+=C[V<<2&63],S&&(U+="=")}return U}}),define(he[137],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0,e.$fe=Symbol("MicrotaskDelay")}),define(he[12],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=I,e.$eg=c,e.$fg=T,e.$gg=A,e.$hg=N,e.$ig=O,e.$jg=k,e.$kg=b,e.$lg=R,e.$mg=$,e.$ng=d,e.$og=g,e.$pg=l,e.$qg=E,e.$rg=f,e.$sg=w,e.$tg=P,e.$ug=p;function I(o){return typeof o=="string"}function c(o){return Array.isArray(o)&&o.every(u=>I(u))}function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const u=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof u}function N(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function k(o){return o===!0||o===!1}function b(o){return typeof o>"u"}function R(o){return!$(o)}function $(o){return b(o)||o===null}function d(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function g(o){if($(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l(...o){const u=[];for(let i=0;i<o.length;i++){const n=o[i];if($(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(n)}return u}const m=Object.prototype.hasOwnProperty;function E(o){if(!T(o))return!1;for(const u in o)if(m.call(o,u))return!1;return!0}function f(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(f)}function P(o,u){const i=Math.min(o.length,u.length);for(let n=0;n<i;n++)p(o[n],u[n])}function p(o,u){if(I(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(f(u)){try{if(o instanceof u)return}catch{}if(!$(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[29],ue([0,1,12]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=c,e.$do=T,e.$eo=N,e.$fo=k,e.$go=b,e.$ho=R,e.$io=$,e.$jo=d,e.$ko=g,e.$lo=l,e.$mo=m,e.$no=E,e.$oo=f;function c(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([p,o])=>{P[p]=o&&typeof o=="object"?c(o):o}),P}function T(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const p=P.shift();Object.freeze(p);for(const o in p)if(A.call(p,o)){const u=p[o];typeof u=="object"&&!Object.isFrozen(u)&&!(0,I.$gg)(u)&&P.push(u)}}return w}const A=Object.prototype.hasOwnProperty;function N(w,P){return O(w,P,new Set)}function O(w,P,p){if((0,I.$mg)(w))return w;const o=P(w);if(typeof o<"u")return o;if(Array.isArray(w)){const u=[];for(const i of w)u.push(O(i,P,p));return u}if((0,I.$fg)(w)){if(p.has(w))throw new Error("Cannot clone recursive data-structure");p.add(w);const u={};for(const i in w)A.call(w,i)&&(u[i]=O(w[i],P,p));return p.delete(w),u}return w}function k(w,P,p=!0){return(0,I.$fg)(w)?((0,I.$fg)(P)&&Object.keys(P).forEach(o=>{o in w?p&&((0,I.$fg)(w[o])&&(0,I.$fg)(P[o])?k(w[o],P[o],p):w[o]=P[o]):w[o]=P[o]}),w):P}function b(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let p,o;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(p=0;p<w.length;p++)if(!b(w[p],P[p]))return!1}else{const u=[];for(o in w)u.push(o);u.sort();const i=[];for(o in P)i.push(o);if(i.sort(),!b(u,i))return!1;for(p=0;p<u.length;p++)if(!b(w[u[p]],P[u[p]]))return!1}return!0}function R(w){const P=new Set;return JSON.stringify(w,(p,o)=>{if((0,I.$fg)(o)||Array.isArray(o)){if(P.has(o))return"[Circular]";P.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function $(w,P){const p=Object.create(null);return!w||!P||Object.keys(P).forEach(u=>{const i=w[u],n=P[u];b(i,n)||(p[u]=n)}),p}function d(w,P){const p=P.toLowerCase(),o=Object.keys(w).find(u=>u.toLowerCase()===p);return o?w[o]:w[P]}function g(w,P){const p=Object.create(null);for(const[o,u]of Object.entries(w))P(o,u)&&(p[o]=u);return p}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function m(w){const P=[];for(const p of l(w))typeof w[p]=="function"&&P.push(p);return P}function E(w,P){const p=u=>function(){const i=Array.prototype.slice.call(arguments,0);return P(u,i)},o={};for(const u of w)o[u]=p(u);return o}function f(w,P){const p={};for(const[o,u]of Object.entries(w))p[o]=P(u,o);return p}}),define(he[138],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$_e=c,e.$af=T;var I;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function c(A){return A<0?0:A>I.MAX_UINT_8?I.MAX_UINT_8:A|0}function T(A){return A<0?0:A>I.MAX_UINT_32?I.MAX_UINT_32:A|0}}),define(he[26],ue([0,1,136,39,53,138]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.GraphemeBreakType=e.$3f=e.$Uf=e.$Nf=e.$Mf=void 0,e.$bf=N,e.$cf=k,e.$df=R,e.$ef=$,e.$ff=d,e.$gf=g,e.$hf=l,e.$if=m,e.$jf=E,e.$kf=f,e.$lf=w,e.$mf=P,e.$nf=p,e.$of=o,e.$pf=u,e.$qf=i,e.$rf=n,e.$sf=t,e.$tf=s,e.$uf=r,e.$vf=a,e.$wf=h,e.$xf=y,e.$yf=L,e.$zf=S,e.$Af=v,e.$Bf=C,e.$Cf=U,e.$Df=F,e.$Ef=M,e.$Ff=G,e.$Gf=V,e.$Hf=_,e.$If=H,e.$Jf=ie,e.$Kf=B,e.$Lf=z,e.$Of=te,e.$Pf=Q,e.$Qf=K,e.$Rf=q,e.$Sf=J,e.$Tf=W,e.$Vf=Y,e.$Wf=Z,e.$Xf=se,e.$Yf=ce,e.$Zf=pe,e.$1f=Ee,e.$2f=be,e.$4f=we,e.$5f=Se,e.$6f=oe,e.$7f=de,e.$8f=ge,e.$9f=Ie,e.$0f=Oe,e.$$f=De,e.$_f=Ve;function N(re){return!re||typeof re!="string"?!0:re.trim().length===0}const O=/{(\d+)}/g;function k(re,...fe){return fe.length===0?re:re.replace(O,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const b=/{([^}]+)}/g;function R(re,fe){return Object.keys(fe).length===0?re:re.replace(b,($e,ye)=>fe[ye]??$e)}function $(re){return re.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function d(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function g(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(re,fe){let $e=0,ye=re.indexOf(fe);for(;ye!==-1;)$e++,ye=re.indexOf(fe,ye+fe.length);return $e}function m(re,fe,$e="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${$e}`}function E(re,fe,$e="\u2026"){if(re.length<=fe)return re;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${re.substr(0,ye)}${$e}${re.substr(re.length-Ae)}`}function f(re,fe=" "){const $e=w(re,fe);return P($e,fe)}function w(re,fe){if(!re||!fe)return re;const $e=fe.length;if($e===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+$e;return re.substring(ye)}function P(re,fe){if(!re||!fe)return re;const $e=fe.length,ye=re.length;if($e===0||ye===0)return re;let Ae=ye,Ce=-1;for(;Ce=re.lastIndexOf(fe,Ae-1),!(Ce===-1||Ce+$e!==Ae);){if(Ce===0)return"";Ae=Ce}return re.substring(0,Ae)}function p(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(re){return re.replace(/\*/g,"")}function u(re,fe,$e={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=g(re)),$e.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(re,ye)}function i(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function n(re){return re.split(/\r\n|\r|\n/)}function t(re){const fe=[],$e=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function s(re){for(let fe=0,$e=re.length;fe<$e;fe++){const ye=re.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function r(re,fe=0,$e=re.length){for(let ye=fe;ye<$e;ye++){const Ae=re.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return re.substring(fe,ye)}return re.substring(fe,$e)}function a(re,fe=re.length-1){for(let $e=fe;$e>=0;$e--){const ye=re.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function h(re,fe,$e){const ye=[];let Ae=0;for(const Ce of re.matchAll(fe)){if(ye.push(re.slice(Ae,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ae=Ce.index+Ce[0].length,ye.push($e(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return ye.push(re.slice(Ae)),Promise.all(ye).then(Ce=>Ce.join(""))}function y(re,fe){return re<fe?-1:re>fe?1:0}function L(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){const Je=re.charCodeAt($e),Ze=fe.charCodeAt(Ae);if(Je<Ze)return-1;if(Je>Ze)return 1}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function S(re,fe){return v(re,fe,0,re.length,0,fe.length)}function v(re,fe,$e=0,ye=re.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){let Je=re.charCodeAt($e),Ze=fe.charCodeAt(Ae);if(Je===Ze)continue;if(Je>=128||Ze>=128)return L(re.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Ce);U(Je)&&(Je-=32),U(Ze)&&(Ze-=32);const He=Je-Ze;if(He!==0)return He}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function C(re){return re>=c.CharCode.Digit0&&re<=c.CharCode.Digit9}function U(re){return re>=c.CharCode.a&&re<=c.CharCode.z}function F(re){return re>=c.CharCode.A&&re<=c.CharCode.Z}function M(re,fe){return re.length===fe.length&&v(re,fe)===0}function G(re,fe){const $e=fe.length;return fe.length>re.length?!1:v(re,fe,0,$e)===0}function V(re,fe){const $e=Math.min(re.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function _(re,fe){const $e=Math.min(re.length,fe.length);let ye;const Ae=re.length-1,Ce=fe.length-1;for(ye=0;ye<$e;ye++)if(re.charCodeAt(Ae-ye)!==fe.charCodeAt(Ce-ye))return ye;return $e}function H(re){return 55296<=re&&re<=56319}function ie(re){return 56320<=re&&re<=57343}function B(re,fe){return(re-55296<<10)+(fe-56320)+65536}function z(re,fe,$e){const ye=re.charCodeAt($e);if(H(ye)&&$e+1<fe){const Ae=re.charCodeAt($e+1);if(ie(Ae))return B(ye,Ae)}return ye}function ee(re,fe){const $e=re.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=re.charCodeAt(fe-2);if(H(ye))return B(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Mf=ne;class le{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new ne(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Ne(Ae,je)){$e.setOffset(Ce);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Ne(je,Ae)){$e.setOffset(Ce);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Nf=le;function te(re,fe){return new le(re,fe).nextGraphemeLength()}function Q(re,fe){return new le(re,fe).prevGraphemeLength()}function K(re,fe){fe>0&&ie(re.charCodeAt(fe))&&fe--;const $e=fe+te(re,fe);return[$e-Q(re,$e),$e]}function q(re){const fe=new le(re);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function J(re){return D||(D=X()),D.test(re)}const j=/^[\t\n\r\x20-\x7E]*$/;function W(re){return j.test(re)}e.$Uf=/[\u2028\u2029]/;function Y(re){return e.$Uf.test(re)}function Z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function se(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function ce(re,fe,$e=""){const ye=re.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Ce=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Ce=Ae.lastIndex,Ae.lastIndex+=1;return Ce===0?ye:$e+ye.substring(Ce).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(re){let fe=0;for(const $e of re.matchAll(me))fe!==$e.index&&(yield{isCode:!1,str:re.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==re.length&&(yield{isCode:!1,str:re.substring(fe)})}function Ee(re){return re&&(re=re.replace(me,"")),re}const ke=/\\\[.*?\\\]/g;function be(re){return Ee(re).replace(ke,"")}e.$3f=String.fromCharCode(c.CharCode.UTF8_BOM);function we(re){return!!(re&&re.length>0&&re.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Se(re){return we(re)?re.substr(1):re}function oe(re,fe){if(!re||!fe||re.length<fe.length)return!1;const $e=fe.length,ye=re.toLowerCase();let Ae=0,Ce=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Ce+1);if(je<0)return!1;Ce=je,Ae++}return!0}function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function ge(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Ie(re,fe=1){if(fe===0)return"";let $e=-1;do $e=re.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?re:(re[$e-1]==="\r"&&$e--,re.substr(0,$e))}function Oe(re){const fe=c.CharCode.Z-c.CharCode.A+1;return re=re%(2*fe),re<fe?String.fromCharCode(c.CharCode.a+re):String.fromCharCode(c.CharCode.A+re-fe)}function De(re){return Ue.getInstance().getGraphemeBreakType(re)}function Ne(re,fe){return re===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:re===Le.CR&&fe===Le.LF?!1:re===Le.Control||re===Le.CR||re===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(re===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(re===Le.LV||re===Le.V)&&(fe===Le.V||fe===Le.T)||(re===Le.LVT||re===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||re===Le.Prepend||re===Le.ZWJ&&fe===Le.Extended_Pictographic||re===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Be()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Le.LF:fe===c.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(re,fe){if(re===0)return 0;const $e=Me(re,fe);if($e!==void 0)return $e;const ye=new ne(fe,re);return ye.prevCodePoint(),ye.offset}function Me(re,fe){const $e=new ne(fe,re);let ye=$e.prevCodePoint();for(;qe(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!se(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function qe(re){return 127995<=re&&re<=127999}var ze;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$ag="\xA0";class We{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$0e({getCacheKey:JSON.stringify},fe=>{function $e(He){const _e=new Map;for(let Ye=0;Ye<He.length;Ye+=2)_e.set(He[Ye],He[Ye+1]);return _e}function ye(He,_e){const Ye=new Map(He);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Ae(He,_e){if(!He)return _e;const Ye=new Map;for(const[nt,at]of He)_e.has(nt)&&Ye.set(nt,at);return Ye}const Ce=this.c.value;let je=fe.filter(He=>!He.startsWith("_")&&He in Ce);je.length===0&&(je=["_default"]);let xe;for(const He of je){const _e=$e(Ce[He]);xe=Ae(xe,_e)}const Je=$e(Ce._common),Ze=ye(Je,xe);return new We(Ze)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new T.$T(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$bg=We;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(fe){return Te.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Te.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Te.e()}}e.$cg=Te}),define(he[41],ue([0,1,39,13,5,26,12]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=O,e.$wg=k,e.$xg=b,e.$yg=R,e.$zg=$,e.$Ag=m,e.$Bg=E,e.$Cg=f,e.$Dg=w,e.$Eg=P,e.$Fg=p,e.$Gg=o,e.$Hg=u,e.$Ig=i,e.$Jg=n,e.$Kg=t,e.$Lg=a;function O(h){return h===I.CharCode.Slash||h===I.CharCode.Backslash}function k(h){return h.replace(/[\\/]/g,c.$fc.sep)}function b(h){return h.indexOf("/")===-1&&(h=k(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function R(h,y=c.$fc.sep){if(!h)return"";const L=h.length,S=h.charCodeAt(0);if(O(S)){if(O(h.charCodeAt(1))&&!O(h.charCodeAt(2))){let C=3;const U=C;for(;C<L&&!O(h.charCodeAt(C));C++);if(U!==C&&!O(h.charCodeAt(C+1))){for(C+=1;C<L;C++)if(O(h.charCodeAt(C)))return h.slice(0,C+1).replace(/[\\/]/g,y)}}return y}else if(w(S)&&h.charCodeAt(1)===I.CharCode.Colon)return O(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let v=h.indexOf("://");if(v!==-1){for(v+=3;v<L;v++)if(O(h.charCodeAt(v)))return h.slice(0,v+1)}return""}function $(h){if(!T.$j||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==I.CharCode.Backslash||(y=h.charCodeAt(1),y!==I.CharCode.Backslash))return!1;let L=2;const S=L;for(;L<h.length&&(y=h.charCodeAt(L),y!==I.CharCode.Backslash);L++);return!(S===L||(y=h.charCodeAt(L+1),isNaN(y)||y===I.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,g=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(h,y=T.$j){const L=y?d:g;return!(!h||h.length===0||/^\s+$/.test(h)||(L.lastIndex=0,L.test(h))||y&&l.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}function E(h,y,L){const S=h===y;return!L||S?S:!h||!y?!1:(0,A.$Ef)(h,y)}function f(h,y,L,S=c.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(L){if(!(0,A.$Ff)(h,y))return!1;if(y.length===h.length)return!0;let C=y.length;return y.charAt(y.length-1)===S&&C--,h.charAt(C)===S}return y.charAt(y.length-1)!==S&&(y+=S),h.indexOf(y)===0}function w(h){return h>=I.CharCode.A&&h<=I.CharCode.Z||h>=I.CharCode.a&&h<=I.CharCode.z}function P(h,y){return T.$j&&h.endsWith(":")&&(h+=c.sep),(0,c.$hc)(h)||(h=(0,c.$ic)(y,h)),h=(0,c.$gc)(h),p(h)}function p(h){return T.$j?(h=(0,A.$mf)(h,c.sep),h.endsWith(":")&&(h+=c.sep)):(h=(0,A.$mf)(h,c.sep),h||(h=c.sep)),h}function o(h){const y=(0,c.$gc)(h);return T.$j?h.length>3?!1:u(y)&&(h.length===2||y.charCodeAt(2)===I.CharCode.Backslash):y===c.$fc.sep}function u(h,y=T.$j){return y?w(h.charCodeAt(0))&&h.charCodeAt(1)===I.CharCode.Colon:!1}function i(h,y=T.$j){return u(h,y)?h[0]:void 0}function n(h,y,L){return y.length>h.length?-1:h===y?0:(L&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}function t(h){const y=h.split(":");let L,S,v;for(const C of y){const U=Number(C);(0,N.$hg)(U)?S===void 0?S=U:v===void 0&&(v=U):L=L?[L,C].join(":"):C}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,y,L=8){let S="";for(let C=0;C<L;C++){let U;C===0&&T.$j&&!y&&(L===3||L===4)?U=r:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let v;return y?v=`${y}-${S}`:v=S,h?(0,c.$ic)(h,v):v}}),define(he[55],ue([0,1,26]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$vj=void 0,e.$rj=c,e.$sj=T,e.$tj=A,e.$uj=O,e.$wj=m,I=Pe(I);function c(f){return T(f,0)}function T(f,w){switch(typeof f){case"object":return f===null?A(349,w):Array.isArray(f)?k(f,w):b(f,w);case"string":return O(f,w);case"boolean":return N(f,w);case"number":return A(f,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(f,w){return(w<<5)-w+f|0}function N(f,w){return A(f?433:863,w)}function O(f,w){w=A(149417,w);for(let P=0,p=f.length;P<p;P++)w=A(f.charCodeAt(P),w);return w}function k(f,w){return w=A(104579,w),f.reduce((P,p)=>T(p,P),w)}function b(f,w){return w=A(181387,w),Object.keys(f).sort().reduce((P,p)=>(P=O(p,P),T(f[p],P)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=T(w,this.g),this.g}}e.$vj=R;var $;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function d(f,w,P=32){const p=P-w,o=~((1<<p)-1);return(f<<w|(o&f)>>>p)>>>0}function g(f,w=0,P=f.byteLength,p=0){for(let o=0;o<P;o++)f[w+o]=p}function l(f,w,P="0"){for(;f.length<w;)f=P+f;return f}function m(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),w/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const p=this.p;let o=this.r,u=this.u,i,n;for(u!==0?(i=u,n=-1,u=0):(i=w.charCodeAt(0),n=0);;){let t=i;if(I.$If(i))if(n+1<P){const s=w.charCodeAt(n+1);I.$Jf(s)?(n++,t=I.$Kf(i,s)):t=$.UNICODE_REPLACEMENT}else{u=i;break}else I.$Jf(i)&&(t=$.UNICODE_REPLACEMENT);if(o=this.w(p,o,t),n++,n<P)i=w.charCodeAt(n);else break}this.r=o,this.u=u}w(w,P,p){return p<128?w[P++]=p:p<2048?(w[P++]=192|(p&1984)>>>6,w[P++]=128|(p&63)>>>0):p<65536?(w[P++]=224|(p&61440)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0):(w[P++]=240|(p&1835008)>>>18,w[P++]=128|(p&258048)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0),P>=$.BLOCK_SIZE&&(this.y(),P-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,w[0]=w[$.BLOCK_SIZE+0],w[1]=w[$.BLOCK_SIZE+1],w[2]=w[$.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=E.g,P=this.q;for(let a=0;a<64;a+=4)w.setUint32(a,P.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,d(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let p=this.h,o=this.l,u=this.m,i=this.n,n=this.o,t,s,r;for(let a=0;a<80;a++)a<20?(t=o&u|~o&i,s=1518500249):a<40?(t=o^u^i,s=1859775393):a<60?(t=o&u|o&i|u&i,s=2400959708):(t=o^u^i,s=3395469782),r=d(p,5)+t+n+s+w.getUint32(a*4,!1)&4294967295,n=i,i=u,u=d(o,30),o=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+o&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$xj=E}),define(he[92],ue([0,1,26]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),I=Pe(I);var c;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(c||(c={})),function(T){const A="error",N="warning",O="warn",k="info",b="ignore";function R(d){return d?I.$Ef(A,d)?T.Error:I.$Ef(N,d)||I.$Ef(O,d)?T.Warning:I.$Ef(k,d)?T.Info:T.Ignore:T.Ignore}T.fromValue=R;function $(d){switch(d){case T.Error:return A;case T.Warning:return N;case T.Info:return k;default:return b}}T.toString=$}(c||(c={})),e.default=c}),define(he[51],ue([0,1,17,39,26]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const m=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return m-E}value(){return this.b[this.c]}}e.$Fi=A;class N{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,T.$yf)(l,this.b,0,l.length,this.c,this.d):(0,T.$Af)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Gi=N;class O{constructor(l=!0,m=!0){this.f=l,this.g=m}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let m=l.length-1;m>=0;m--,this.c--){const E=this.b.charCodeAt(m);if(!(E===c.CharCode.Slash||this.f&&E===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===c.CharCode.Slash||this.f&&m===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,T.$yf)(l,this.b,0,l.length,this.d,this.e):(0,T.$Af)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Hi=O;var k;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(l,m){this.f=l,this.g=m,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(k.Scheme),this.c.authority&&this.d.push(k.Authority),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(k.Path)),this.g(l)||(this.c.query&&this.d.push(k.Query),this.c.fragment&&this.d.push(k.Fragment)),this.e=0,this}next(){return this.d[this.e]===k.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===k.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===k.Scheme)return(0,T.$zf)(l,this.c.scheme);if(this.d[this.e]===k.Authority)return(0,T.$zf)(l,this.c.authority);if(this.d[this.e]===k.Path)return this.b.cmp(l);if(this.d[this.e]===k.Query)return(0,T.$xf)(l,this.c.query);if(this.d[this.e]===k.Fragment)return(0,T.$xf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===k.Scheme)return this.c.scheme;if(this.d[this.e]===k.Authority)return this.c.authority;if(this.d[this.e]===k.Path)return this.b.value();if(this.d[this.e]===k.Query)return this.c.query;if(this.d[this.e]===k.Fragment)return this.c.fragment;throw new Error}}e.$Ii=b;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})($||($={}));class d{static forUris(l=()=>!1,m=()=>!1){return new d(new b(l,m))}static forPaths(l=!1){return new d(new O(void 0,!l))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new N)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,m){if(m){const E=m.slice(0);(0,I.$Vb)(E);for(const f of E)this.set(f,l)}else{const E=l.slice(0);(0,I.$Vb)(E);for(const f of E)this.set(f[0],f[1])}}set(l,m){const E=this.b.reset(l);let f;this.c||(this.c=new R,this.c.segment=E.value());const w=[];for(f=this.c;;){const p=E.cmp(f.segment);if(p>0)f.left||(f.left=new R,f.left.segment=E.value()),w.push([$.Left,f]),f=f.left;else if(p<0)f.right||(f.right=new R,f.right.segment=E.value()),w.push([$.Right,f]),f=f.right;else if(E.hasNext())E.next(),f.mid||(f.mid=new R,f.mid.segment=E.value()),w.push([$.Mid,f]),f=f.mid;else break}const P=f.value;f.value=m,f.key=l;for(let p=w.length-1;p>=0;p--){const o=w[p][1];o.updateHeight();const u=o.balanceFactor();if(u<-1||u>1){const i=w[p][0],n=w[p+1][0];if(i===$.Right&&n===$.Right)w[p][1]=o.rotateLeft();else if(i===$.Left&&n===$.Left)w[p][1]=o.rotateRight();else if(i===$.Right&&n===$.Left)o.right=w[p+1][1]=w[p+1][1].rotateRight(),w[p][1]=o.rotateLeft();else if(i===$.Left&&n===$.Right)o.left=w[p+1][1]=w[p+1][1].rotateLeft(),w[p][1]=o.rotateRight();else throw new Error;if(p>0)switch(w[p-1][0]){case $.Left:w[p-1][1].left=w[p][1];break;case $.Right:w[p-1][1].right=w[p][1];break;case $.Mid:w[p-1][1].mid=w[p][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const m=this.b.reset(l);let E=this.c;for(;E;){const f=m.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(l){const m=this.d(l);return!(m?.value===void 0&&m?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,m){const E=this.b.reset(l),f=[];let w=this.c;for(;w;){const P=E.cmp(w.segment);if(P>0)f.push([$.Left,w]),w=w.left;else if(P<0)f.push([$.Right,w]),w=w.right;else if(E.hasNext())E.next(),f.push([$.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:p,value:o,segment:u}=P;this.e(P.key,!1),w.key=p,w.value=o,w.segment=u}}else{const P=w.left??w.right;if(f.length>0){const[p,o]=f[f.length-1];switch(p){case $.Left:o.left=P;break;case $.Mid:o.mid=P;break;case $.Right:o.right=P;break}}else this.c=P}for(let P=f.length-1;P>=0;P--){const p=f[P][1];p.updateHeight();const o=p.balanceFactor();if(o>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[P][1]=p.rotateLeft()):o<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[P][1]=p.rotateRight()),P>0)switch(f[P-1][0]){case $.Left:f[P-1][1].left=f[P][1];break;case $.Right:f[P-1][1].right=f[P][1];break;case $.Mid:f[P-1][1].mid=f[P][1];break}else this.c=f[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const m=this.b.reset(l);let E=this.c,f;for(;E;){const w=m.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(m.hasNext())m.next(),f=E.value||f,E=E.mid;else break}return E&&E.value||f}findSuperstr(l){return this.g(l,!1)}g(l,m){const E=this.b.reset(l);let f=this.c;for(;f;){const w=E.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(E.hasNext())E.next(),f=f.mid;else return f.mid?this.h(f.mid):m?f.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[m,E]of this)l(E,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const m=[];return this.j(l,m),m[Symbol.iterator]()}j(l,m){l&&(l.left&&this.j(l.left,m),l.value&&m.push([l.key,l.value]),l.mid&&this.j(l.mid,m),l.right&&this.j(l.right,m))}_isBalanced(){const l=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:l(m.left)&&l(m.right)};return l(this.c)}}e.$Ji=d}),define(he[9],ue([0,1,39,65,13,5]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=E,e.$vc=u,T=Pe(T);const N=/^\w[\w\d+.-]*$/,O=/^\//,k=/^\/\//;function b(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!N.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!O.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,a){return!r&&!a?"file":r}function $(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==g&&(a=g+a):a=g;break}return a}const d="",g="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,y,L,S,v=!1){typeof a=="object"?(this.scheme=a.scheme||d,this.authority=a.authority||d,this.path=a.path||d,this.query=a.query||d,this.fragment=a.fragment||d):(this.scheme=R(a,v),this.authority=h||d,this.path=$(this.scheme,y||d),this.query=L||d,this.fragment=S||d,b(this,v))}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:y,path:L,query:S,fragment:v}=a;return h===void 0?h=this.scheme:h===null&&(h=d),y===void 0?y=this.authority:y===null&&(y=d),L===void 0?L=this.path:L===null&&(L=d),S===void 0?S=this.query:S===null&&(S=d),v===void 0?v=this.fragment:v===null&&(v=d),h===this.scheme&&y===this.authority&&L===this.path&&S===this.query&&v===this.fragment?this:new w(h,y,L,S,v)}static parse(a,h=!1){const y=l.exec(a);return y?new w(y[2]||d,s(y[4]||d),s(y[5]||d),s(y[7]||d),s(y[9]||d),h):new w(d,d,d,d,d)}static file(a){let h=d;if(A.$j&&(a=a.replace(/\\/g,g)),a[0]===g&&a[1]===g){const y=a.indexOf(g,2);y===-1?(h=a.substring(2),a=g):(h=a.substring(2,y),a=a.substring(y)||g)}return new w("file",h,a,d,d)}static from(a,h){return new w(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return A.$j&&a.scheme==="file"?y=m.file(T.$ec.join(u(a,!0),...h)).path:y=T.$fc.join(a.path,...h),a.with({path:y})}toString(a=!1){return i(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const h=new w(a);return h._formatted=a.external??null,h._fsPath=a._sep===f?a.fsPath??null:null,h}}else return a}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=m;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const f=A.$j?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const a={$mid:c.MarshalledId.Uri};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[I.CharCode.Colon]:"%3A",[I.CharCode.Slash]:"%2F",[I.CharCode.QuestionMark]:"%3F",[I.CharCode.Hash]:"%23",[I.CharCode.OpenSquareBracket]:"%5B",[I.CharCode.CloseSquareBracket]:"%5D",[I.CharCode.AtSign]:"%40",[I.CharCode.ExclamationMark]:"%21",[I.CharCode.DollarSign]:"%24",[I.CharCode.Ampersand]:"%26",[I.CharCode.SingleQuote]:"%27",[I.CharCode.OpenParen]:"%28",[I.CharCode.CloseParen]:"%29",[I.CharCode.Asterisk]:"%2A",[I.CharCode.Plus]:"%2B",[I.CharCode.Comma]:"%2C",[I.CharCode.Semicolon]:"%3B",[I.CharCode.Equals]:"%3D",[I.CharCode.Space]:"%20"};function p(r,a,h){let y,L=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=I.CharCode.a&&v<=I.CharCode.z||v>=I.CharCode.A&&v<=I.CharCode.Z||v>=I.CharCode.Digit0&&v<=I.CharCode.Digit9||v===I.CharCode.Dash||v===I.CharCode.Period||v===I.CharCode.Underline||v===I.CharCode.Tilde||a&&v===I.CharCode.Slash||h&&v===I.CharCode.OpenSquareBracket||h&&v===I.CharCode.CloseSquareBracket||h&&v===I.CharCode.Colon)L!==-1&&(y+=encodeURIComponent(r.substring(L,S)),L=-1),y!==void 0&&(y+=r.charAt(S));else{y===void 0&&(y=r.substr(0,S));const C=P[v];C!==void 0?(L!==-1&&(y+=encodeURIComponent(r.substring(L,S)),L=-1),y+=C):L===-1&&(L=S)}}return L!==-1&&(y+=encodeURIComponent(r.substring(L))),y!==void 0?y:r}function o(r){let a;for(let h=0;h<r.length;h++){const y=r.charCodeAt(h);y===I.CharCode.Hash||y===I.CharCode.QuestionMark?(a===void 0&&(a=r.substr(0,h)),a+=P[y]):a!==void 0&&(a+=r[h])}return a!==void 0?a:r}function u(r,a){let h;return r.authority&&r.path.length>1&&r.scheme==="file"?h=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===I.CharCode.Slash&&(r.path.charCodeAt(1)>=I.CharCode.A&&r.path.charCodeAt(1)<=I.CharCode.Z||r.path.charCodeAt(1)>=I.CharCode.a&&r.path.charCodeAt(1)<=I.CharCode.z)&&r.path.charCodeAt(2)===I.CharCode.Colon?a?h=r.path.substr(1):h=r.path[1].toLowerCase()+r.path.substr(2):h=r.path,A.$j&&(h=h.replace(/\//g,"\\")),h}function i(r,a){const h=a?o:p;let y="",{scheme:L,authority:S,path:v,query:C,fragment:U}=r;if(L&&(y+=L,y+=":"),(S||L==="file")&&(y+=g,y+=g),S){let F=S.indexOf("@");if(F!==-1){const M=S.substr(0,F);S=S.substr(F+1),F=M.lastIndexOf(":"),F===-1?y+=h(M,!1,!1):(y+=h(M.substr(0,F),!1,!1),y+=":",y+=h(M.substr(F+1),!1,!0)),y+="@"}S=S.toLowerCase(),F=S.lastIndexOf(":"),F===-1?y+=h(S,!1,!0):(y+=h(S.substr(0,F),!1,!0),y+=S.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===I.CharCode.Slash&&v.charCodeAt(2)===I.CharCode.Colon){const F=v.charCodeAt(1);F>=I.CharCode.A&&F<=I.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===I.CharCode.Colon){const F=v.charCodeAt(0);F>=I.CharCode.A&&F<=I.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}y+=h(v,!0,!1)}return C&&(y+="?",y+=h(C,!1,!1)),U&&(y+="#",y+=a?U:p(U,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>n(a)):r}}),define(he[139],ue([0,1,9]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=c,e.$cr=T,e.$dr=A,e.log=O;function c(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function T(b){const R=[];let $;try{const d=JSON.parse(b.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),$=g.__$stack),R.push(...d)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:$}}function A(b){if(typeof b!="string")return A(T(b).stack);const R=b;if(R){const $=N(R),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(d&&d.length===4)return{uri:I.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function N(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function O(b,R){const{args:$,stack:d}=T(b),g=typeof $[0]=="string"&&$.length===1;let l=N(d);l&&(l=`(${l.trim()})`);let m=[];if(typeof $[0]=="string"?l&&g?m=[`%c[${R}] %c${$[0]} %c${l}`,k("blue"),k(""),k("grey")]:m=[`%c[${R}] %c${$[0]}`,k("blue"),k(""),...$.slice(1)]:m=[`%c[${R}]%`,k("blue"),...$],l&&!g&&m.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}function k(b){return`color: ${b}`}}),define(he[66],ue([0,1,14,9,65]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=A,e.$_h=N,e.$ai=k;function A(b){return JSON.stringify(b,O)}function N(b){let R=JSON.parse(b);return R=k(R),R}function O(b,R){return R instanceof RegExp?{$mid:T.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function k(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case T.MarshalledId.Uri:return c.URI.revive(b);case T.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case T.MarshalledId.Date:return new Date(b.source)}if(b instanceof I.$Me||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let $=0;$<b.length;++$)b[$]=k(b[$],R+1);else for(const $ in b)Object.hasOwnProperty.call(b,$)&&(b[$]=k(b[$],R+1))}return b}}),define(he[22],ue([0,1,8,5,26,9,13]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Qg=e.$Pg=e.$Og=e.Schemas=void 0,e.$Mg=k,e.$Ng=b,e.$Rg=$,I=Pe(I),c=Pe(c),N=Pe(N);var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(O||(e.Schemas=O={}));function k(l,m){return A.URI.isUri(l)?(0,T.$Ef)(l.scheme,m):(0,T.$Ff)(l,m+":")}function b(l,...m){return m.some(E=>k(l,E))}e.$Og="vscode-tkn",e.$Pg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,E){this.f=$(m,E)}getServerRootPath(){return this.f}get g(){return N.$fc.join(this.f,O.vscodeRemoteResource)}set(m,E,f){this.a[m]=E,this.b[m]=f}setConnectionToken(m,E){this.c[m]=E}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(o){return I.$Y(o),m}const E=m.authority;let f=this.a[E];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const w=this.b[E],P=this.c[E];let p=`path=${encodeURIComponent(m.path)}`;return typeof P=="string"&&(p+=`&${e.$Pg}=${encodeURIComponent(P)}`),A.URI.from({scheme:c.$p?this.d:O.vscodeRemoteResource,authority:`${f}:${w}`,path:this.g,query:p})}}e.$Qg=new R;function $(l,m){return N.$fc.join(m??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Sg="vs/../../extensions",e.$Tg="vs/../../node_modules",e.$Ug="vs/../../node_modules.asar",e.$Vg="vs/../../node_modules.asar.unpacked",e.$Wg="vscode-app";class d{static{this.a=e.$Wg}asBrowserUri(m){const E=this.b(m,ae);return this.uriToBrowserUri(E)}uriToBrowserUri(m){return m.scheme===O.vscodeRemote?e.$Qg.rewrite(m):m.scheme===O.file&&(c.$n||c.$r===`${O.vscodeFileResource}://${d.a}`)?m.with({scheme:O.vscodeFileResource,authority:m.authority||d.a,query:null,fragment:null}):m}asFileUri(m){const E=this.b(m,ae);return this.uriToFileUri(E)}uriToFileUri(m){return m.scheme===O.vscodeFileResource?m.with({scheme:O.file,authority:m.authority!==d.a?m.authority:null,query:null,fragment:null}):m}b(m,E){return A.URI.isUri(m)?m:A.URI.parse(E.toUrl(m))}}e.$Xg=new d;var g;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const E="vscode-coi";function f(P){let p;typeof P=="string"?p=new URL(P).searchParams:P instanceof URL?p=P.searchParams:A.URI.isUri(P)&&(p=new URL(P.toString(!0)).searchParams);const o=p?.get(E);if(o)return m.get(o)}l.getHeadersFromQuery=f;function w(P,p,o){if(!globalThis.crossOriginIsolated)return;const u=p&&o?"3":o?"2":"1";P instanceof URLSearchParams?P.set(E,u):P[E]=u}l.addSearchParam=w})(g||(e.COI=g={}))}),define(he[140],ue([0,1,128,22,5,12,9]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=$,e.$BE=d,T=Pe(T);class O{constructor(l,m,E){this.id=l,this.dependencies=m,this.callback=E}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,m,E)=>{typeof l!="string"&&(E=m,m=l,l=null),(typeof m!="object"||!Array.isArray(m))&&(E=m,m=null),this.c.push(new O(l,m,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const m=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!m)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(l){return new Promise((m,E)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const w=()=>{f.removeEventListener("load",P),f.removeEventListener("error",p)},P=o=>{w(),m(this.c.pop())},p=o=>{w(),E(o)};f.addEventListener("load",P),f.addEventListener("error",p),this.f&&(l=this.f.createScriptURL(l)),f.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(l){return new Promise((m,E)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),m(this.c.pop())}catch(f){E(f)}})}async j(l){try{const m=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,w=N.URI.parse(l).fsPath,P=m.readFileSync(w).toString(),p=f.wrap(P.replace(/^#!.*/,""));return new E.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const b=new Map;let R={};typeof globalThis.require=="object"&&(R=globalThis.require.paths??{});async function $(g,l,m){if(I.$R){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),R[g]&&(g=R[g]);const E=l?`${g}/${l}`:g;if(b.has(E))return b.get(E);let f;if(/^\w[\w\d+.-]*:\/\//.test(E))f=E;else{const o=`${m&&!T.$p?c.$Ug:c.$Tg}/${E}`;f=c.$Xg.asBrowserUri(o).toString(!0)}const w=k.INSTANCE.load(f);return b.set(E,w),w}else return await new Promise((E,f)=>{ae([g],E,f)}).then(Pe)}function d(g,l){(0,A.$ng)(I.$R);const f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!T.$p,w=`${g}/${l}`,p=`${f?c.$Ug:c.$Tg}/${w}`;return c.$Xg.asBrowserUri(p).toString(!0)}}),define(he[20],ue([0,1,39,41,22,13,5,26,9]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=void 0,e.$5g=b,e.$nh=$,e.$oh=g,c=Pe(c),A=Pe(A);function b(l){return(0,k.$vc)(l,!0)}class R{constructor(m){this.a=m}compare(m,E,f=!1){return m===E?0:(0,O.$xf)(this.getComparisonKey(m,f),this.getComparisonKey(E,f))}isEqual(m,E,f=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,f)===this.getComparisonKey(E,f)}getComparisonKey(m,E=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,E,f=!1){if(m.scheme===E.scheme){if(m.scheme===T.Schemas.file)return c.$Cg(b(m),b(E),this.a(m))&&m.query===E.query&&(f||m.fragment===E.fragment);if((0,e.$jh)(m.authority,E.authority))return c.$Cg(m.path,E.path,this.a(m),"/")&&m.query===E.query&&(f||m.fragment===E.fragment)}return!1}joinPath(m,...E){return k.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.$bh)(m)||m.authority}basename(m){return A.$fc.basename(m.path)}extname(m){return A.$fc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===T.Schemas.file?E=k.URI.file(A.$lc(b(m))).path:(E=A.$fc.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==I.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===T.Schemas.file?E=k.URI.file(A.$gc(b(m))).path:E=A.$fc.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.$jh)(m.authority,E.authority))return;if(m.scheme===T.Schemas.file){const P=A.$kc(b(m),b(E));return N.$j?c.$wg(P):P}let f=m.path||"/";const w=E.path||"/";if(this.a(m)){let P=0;for(const p=Math.min(f.length,w.length);P<p&&!(f.charCodeAt(P)!==w.charCodeAt(P)&&f.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);f=w.substr(0,P)+f.substr(P)}return A.$fc.relative(f,w)}resolvePath(m,E){if(m.scheme===T.Schemas.file){const f=k.URI.file(A.$jc(b(m),E));return m.with({authority:f.authority,path:f.path})}return E=c.$xg(E),m.with({path:A.$fc.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,O.$Ef)(m,E)}hasTrailingPathSeparator(m,E=A.sep){if(m.scheme===T.Schemas.file){const f=b(m);return f.length>c.$yg(f).length&&f[f.length-1]===E}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===I.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=A.sep){return(0,e.$kh)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=A.sep){let f=!1;if(m.scheme===T.Schemas.file){const w=b(m);f=w!==void 0&&w.length===c.$yg(w).length&&w[w.length-1]===E}else{E="/";const w=m.path;f=w.length===1&&w.charCodeAt(w.length-1)===I.CharCode.Slash}return!f&&!(0,e.$kh)(m,E)?m.with({path:m.path+"/"}):m}}e.$6g=R,e.$7g=new R(()=>!1),e.$8g=new R(l=>l.scheme===T.Schemas.file?!N.$l:!0),e.$9g=new R(l=>!0),e.$0g=e.$7g.isEqual.bind(e.$7g),e.$$g=e.$7g.isEqualOrParent.bind(e.$7g),e.$_g=e.$7g.getComparisonKey.bind(e.$7g),e.$ah=e.$7g.basenameOrAuthority.bind(e.$7g),e.$bh=e.$7g.basename.bind(e.$7g),e.$ch=e.$7g.extname.bind(e.$7g),e.$dh=e.$7g.dirname.bind(e.$7g),e.$eh=e.$7g.joinPath.bind(e.$7g),e.$fh=e.$7g.normalizePath.bind(e.$7g),e.$gh=e.$7g.relativePath.bind(e.$7g),e.$hh=e.$7g.resolvePath.bind(e.$7g),e.$ih=e.$7g.isAbsolutePath.bind(e.$7g),e.$jh=e.$7g.isEqualAuthority.bind(e.$7g),e.$kh=e.$7g.hasTrailingPathSeparator.bind(e.$7g),e.$lh=e.$7g.removeTrailingPathSeparator.bind(e.$7g),e.$mh=e.$7g.addTrailingPathSeparator.bind(e.$7g);function $(l,m){const E=[];for(let f=0;f<l.length;f++){const w=m(l[f]);l.some((P,p)=>p===f?!1:(0,e.$$g)(w,m(P)))||E.push(l[f])}return E}var d;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function m(E){const f=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(p=>{const[o,u]=p.split(":");o&&u&&f.set(o,u)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&f.set(l.META_DATA_MIME,P),f}l.parseMetaData=m})(d||(e.DataUri=d={}));function g(l,m,E){if(m){let f=l.path;return f&&f[0]!==A.$fc.sep&&(f=A.$fc.sep+f),l.with({scheme:E,authority:m,path:f})}return l.with({scheme:E})}}),define(he[6],ue([0,1,25,8,3,2,20,5,137,53]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$5h=e.$4h=e.$3h=e.$2h=e.Promises=e.$1h=e.$Zh=e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0,e.$ph=R,e.$qh=$,e.$rh=d,e.$sh=g,e.$th=l,e.$uh=m,e.$vh=E,e.$wh=f,e.$Eh=r,e.$Fh=a,e.$Gh=h,e.$Hh=y,e.$Ih=L,e.$Xh=z,e.$6h=j;function R(Y){return!!Y&&typeof Y.then=="function"}function $(Y){const Z=new I.$ve,se=Y(Z.token),ce=new Promise((me,pe)=>{const Ee=Z.token.onCancellationRequested(()=>{Ee.dispose(),pe(new c.$4)});Promise.resolve(se).then(ke=>{Ee.dispose(),Z.dispose(),me(ke)},ke=>{Ee.dispose(),Z.dispose(),pe(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(me,pe){return ce.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return ce.finally(me)}}}function d(Y,Z,se){return new Promise((ce,me)=>{const pe=Z.onCancellationRequested(()=>{pe.dispose(),ce(se)});Y.then(ce,me).finally(()=>pe.dispose())})}function g(Y,Z){return new Promise((se,ce)=>{const me=Z.onCancellationRequested(()=>{me.dispose(),ce(new c.$4)});Y.then(se,ce).finally(()=>me.dispose())})}async function l(Y){let Z=-1;const se=Y.map((ce,me)=>ce.then(pe=>(Z=me,pe)));try{return await Promise.race(se)}finally{Y.forEach((ce,me)=>{me!==Z&&ce.cancel()})}}function m(Y,Z,se){let ce;const me=setTimeout(()=>{ce?.(void 0),se?.()},Z);return Promise.race([Y.finally(()=>clearTimeout(me)),new Promise(pe=>ce=pe)])}function E(Y){return new Promise((Z,se)=>{const ce=Y();R(ce)?ce.then(Z,se):Z(ce)})}function f(){let Y,Z;return{promise:new Promise((ce,me)=>{Y=ce,Z=me}),resolve:Y,reject:Z}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const se=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(se,se).then(ce)})}return new Promise((se,ce)=>{this.b.then(se,ce)})}return this.a=Z(),new Promise((se,ce)=>{this.a.then(me=>{this.a=null,se(me)},me=>{this.a=null,ce(me)})})}dispose(){this.f=!0}}e.$xh=w;class P{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$yh=P;class p{constructor(){this.a=new Map}queue(Z,se){const me=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Z)===me&&this.a.delete(Z)});return this.a.set(Z,me),me}}e.$zh=p;const o=(Y,Z)=>{let se=!0;const ce=setTimeout(()=>{se=!1,Z()},Y);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ce),se=!1}}},u=Y=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,Y())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class i{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,se=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=se===k.$fe?u(ce):o(se,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ah=i;class n{constructor(Z){this.a=new i(Z),this.b=new w}trigger(Z,se){return this.a.trigger(()=>this.b.queue(Z),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Bh=n;class t{constructor(){this.a=!1,this.b=new Promise((Z,se)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Ch=t;class s extends t{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Dh=s;function r(Y,Z){return Z?new Promise((se,ce)=>{const me=setTimeout(()=>{pe.dispose(),se()},Y),pe=Z.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),ce(new c.$4)})}):$(se=>r(Y,se))}function a(Y,Z=0,se){const ce=setTimeout(()=>{Y(),se&&me.dispose()},Z),me=(0,A.$Rc)(()=>{clearTimeout(ce),se?.deleteAndLeak(me)});return se?.add(me),me}function h(Y){const Z=[];let se=0;const ce=Y.length;function me(){return se<ce?Y[se++]():null}function pe(Ee){Ee!=null&&Z.push(Ee);const ke=me();return ke?ke.then(pe):Promise.resolve(Z)}return Promise.resolve(null).then(pe)}function y(Y,Z=ce=>!!ce,se=null){let ce=0;const me=Y.length,pe=()=>{if(ce>=me)return Promise.resolve(se);const Ee=Y[ce++];return Promise.resolve(Ee()).then(be=>Z(be)?Promise.resolve(be):pe())};return pe()}function L(Y,Z=ce=>!!ce,se=null){if(Y.length===0)return Promise.resolve(se);let ce=Y.length;const me=()=>{ce=-1;for(const pe of Y)pe.cancel?.()};return new Promise((pe,Ee)=>{for(const ke of Y)ke.then(be=>{--ce>=0&&Z(be)?(me(),pe(be)):ce===0&&pe(se)}).catch(be=>{--ce>=0&&(me(),Ee(be))})})}class S{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new T.$ke}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ce)=>{this.g.push({factory:Z,c:se,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const se=Z.factory();se.then(Z.c,Z.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Jh=S;class v extends S{constructor(){super(1)}}e.$Kh=v;class C{constructor(){this.a=new ee,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Lh=C;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new te;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,se=N.$7g){const ce=se.getComparisonKey(Z);return this.a.get(ce)?.size??0}queueFor(Z,se,ce=N.$7g){const me=ce.getComparisonKey(Z);let pe=this.a.get(me);if(!pe){pe=new v;const Ee=this.f++,ke=T.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Ee,ke),this.a.set(me,pe)}return pe.queue(se)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Mh=U;class F{constructor(Z,se){this.b=!1,this.a=-1,typeof Z=="function"&&typeof se=="number"&&this.setIfNotSet(Z,se)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,se){if(this.b)throw new c.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},se)}setIfNotSet(Z,se){if(this.b)throw new c.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},se))}}e.$Nh=F;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,se,ce=globalThis){if(this.f)throw new c.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=ce.setInterval(()=>{Z()},se);this.d=(0,A.$Rc)(()=>{ce.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Oh=M;class G{constructor(Z,se){this.b=-1,this.a=Z,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ph=G;class V{constructor(Z,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Z,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Qh=V;class _ extends G{constructor(Z,se){super(Z,se),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Rh=_;class H extends A.$Tc{constructor(Z,se){super(),this.g=Z,this.h=se,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Z)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Sh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Uh=(Y,Z)=>{(0,O.$C)(()=>{if(se)return;const ce=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Uh=(Y,Z,se)=>{const ce=Y.requestIdleCallback(Z,typeof se=="number"?{timeout:se}:void 0);let me=!1;return{dispose(){me||(me=!0,Y.cancelIdleCallback(ce))}}},e.$Th=Y=>(0,e.$Uh)(globalThis,Y)}();class ie{constructor(Z,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$Uh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Vh=ie;class B extends ie{constructor(Z){super(globalThis,Z)}}e.$Wh=B;async function z(Y,Z,se){let ce;for(let me=0;me<se;me++)try{return await Y()}catch(pe){ce=pe,await r(Z)}throw ce}class ee{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,se,ce){return this.a={taskId:Z,cancel:()=>ce?.(),promise:se},se.then(()=>this.d(Z),()=>this.d(Z)),se}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:se,resolve:ce,reject:me}=f();this.b={run:Z,promise:se,promiseResolve:ce,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yh=ee;class ne{constructor(Z,se=()=>Date.now()){this.d=Z,this.f=se,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Zh=ne;var le;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(le||(le={}));class te{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,se)=>{this.a=Z,this.b=se})}complete(Z){return new Promise(se=>{this.a(Z),this.d={outcome:le.Resolved,value:Z},se()})}error(Z){return new Promise(se=>{this.b(Z),this.d={outcome:le.Rejected,value:Z},se()})}cancel(){return this.error(new c.$4)}}e.$1h=te;var Q;(function(Y){async function Z(ce){let me;const pe=await Promise.all(ce.map(Ee=>Ee.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return pe}Y.settled=Z;function se(ce){return new Promise(async(me,pe)=>{try{await ce(me,pe)}catch(Ee){pe(Ee)}})}Y.withAsyncBody=se})(Q||(e.Promises=Q={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new c.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$2h=K;class q{constructor(Z){this.b=Z,this.a=new b.$T(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$3h=q;var D;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(D||(D={}));class X{static fromArray(Z){return new X(se=>{se.emitMany(Z)})}static fromPromise(Z){return new X(async se=>{se.emitMany(await Z)})}static fromPromises(Z){return new X(async se=>{await Promise.all(Z.map(async ce=>se.emitOne(await ce)))})}static merge(Z){return new X(async se=>{await Promise.all(Z.map(async ce=>{for await(const me of ce)se.emitOne(me)}))})}static{this.EMPTY=X.fromArray([])}constructor(Z,se){this.a=D.Initial,this.b=[],this.d=null,this.f=se,this.g=new T.$ke,queueMicrotask(async()=>{const ce={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(Z(ce)),this.k()}catch(me){this.l(me)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await T.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,se){return new X(async ce=>{for await(const me of Z)ce.emitOne(se(me))})}map(Z){return X.map(this,Z)}static filter(Z,se){return new X(async ce=>{for await(const me of Z)se(me)&&ce.emitOne(me)})}filter(Z){return X.filter(this,Z)}static coalesce(Z){return X.filter(Z,se=>!!se)}coalesce(){return X.coalesce(this)}static async toPromise(Z){const se=[];for await(const ce of Z)se.push(ce);return se}toPromise(){return X.toPromise(this)}h(Z){this.a===D.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===D.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Z){this.a===D.Initial&&(this.a=D.DoneError,this.d=Z,this.g.fire())}}e.$4h=X;class J extends X{constructor(Z,se){super(se),this.m=Z}cancel(){this.m.cancel()}}e.$5h=J;function j(Y){const Z=new I.$ve,se=Y(Z.token);return new J(Z,async ce=>{const me=Z.token.onCancellationRequested(()=>{me.dispose(),Z.dispose(),ce.reject(new c.$4)});try{for await(const pe of se){if(Z.token.isCancellationRequested)return;ce.emitOne(pe)}me.dispose(),Z.dispose()}catch(pe){me.dispose(),Z.dispose(),ce.reject(pe)}})}class W{constructor(Z){this.a=new te,this.b=new X(me=>{if(se){me.reject(se);return}return ce&&me.emitMany(ce),this.d=pe=>me.reject(pe),this.f=pe=>me.emitOne(pe),this.a.p},Z);let se,ce;this.f=me=>{ce||(ce=[]),ce.push(me)},this.d=me=>{se||(se=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$7h=W}),define(he[93],ue([0,1,17,6,39,41,31,13,5,26]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=R,e.$wk=m,e.$xk=C,e.$yk=U,e.$zk=F,e.$Ak=M,e.$Bk=G,e.$Ck=ie;function R(){return Object.create(null)}e.$uk="**",e.$vk="/";const $="[/\\\\]",d="[^/\\\\]",g=/\//g;function l(B,z){switch(B){case 0:return"";case 1:return`${d}*?`;default:return`(?:${$}|${d}+${$}${z?`|${$}${d}+`:""})*?`}}function m(B,z){if(!B)return[];const ee=[];let ne=!1,le=!1,te="";for(const Q of B){switch(Q){case z:if(!ne&&!le){ee.push(te),te="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}te+=Q}return te&&ee.push(te),ee}function E(B){if(!B)return"";let z="";const ee=m(B,e.$vk);if(ee.every(ne=>ne===e.$uk))z=".*";else{let ne=!1;ee.forEach((le,te)=>{if(le===e.$uk){if(ne)return;z+=l(2,te===ee.length-1)}else{let Q=!1,K="",q=!1,D="";for(const X of le){if(X!=="}"&&Q){K+=X;continue}if(q&&(X!=="]"||!D)){let J;X==="-"?J=X:(X==="^"||X==="!")&&!D?J="^":X===e.$vk?J="":J=(0,b.$gf)(X),D+=J;continue}switch(X){case"{":Q=!0;continue;case"[":q=!0;continue;case"}":{const j=`(?:${m(K,",").map(W=>E(W)).join("|")})`;z+=j,Q=!1,K="";break}case"]":{z+="["+D+"]",q=!1,D="";break}case"?":z+=d;continue;case"*":z+=l(1);continue;default:z+=(0,b.$gf)(X)}}te<ee.length-1&&(ee[te+1]!==e.$uk||te+2<ee.length)&&(z+=$)}ne=le===e.$uk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new N.$Cc(1e4),n=function(){return!1},t=function(){return null};function s(B,z){if(!B)return t;let ee;typeof B!="string"?ee=B.pattern:ee=B,ee=ee.trim();const ne=`${ee}_${!!z.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,B);let te;return f.test(ee)?le=h(ee.substr(4),ee):(te=w.exec(a(ee,z)))?le=y(te[1],ee):(z.trimForExclusions?p:P).test(ee)?le=L(ee,z):(te=o.exec(a(ee,z)))?le=S(te[1].substr(1),ee,!0):(te=u.exec(a(ee,z)))?le=S(te[1],ee,!1):le=v(ee),i.set(ne,le),r(le,B)}function r(B,z){if(typeof z=="string")return B;const ee=function(ne,le){return(0,A.$Cg)(ne,z.base,!k.$l)?B((0,b.$lf)(ne.substr(z.base.length),O.sep),le):null};return ee.allBasenames=B.allBasenames,ee.allPaths=B.allPaths,ee.basenames=B.basenames,ee.patterns=B.patterns,ee}function a(B,z){return z.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function h(B,z){return function(ee,ne){return typeof ee=="string"&&ee.endsWith(B)?z:null}}function y(B,z){const ee=`/${B}`,ne=`\\${B}`,le=function(Q,K){return typeof Q!="string"?null:K?K===B?z:null:Q===B||Q.endsWith(ee)||Q.endsWith(ne)?z:null},te=[B];return le.basenames=te,le.patterns=[z],le.allBasenames=te,le}function L(B,z){const ee=H(B.slice(1,-1).split(",").map(K=>s(K,z)).filter(K=>K!==t),B),ne=ee.length;if(!ne)return t;if(ne===1)return ee[0];const le=function(K,q){for(let D=0,X=ee.length;D<X;D++)if(ee[D](K,q))return B;return null},te=ee.find(K=>!!K.allBasenames);te&&(le.allBasenames=te.allBasenames);const Q=ee.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return Q.length&&(le.allPaths=Q),le}function S(B,z,ee){const ne=O.sep===O.$fc.sep,le=ne?B:B.replace(g,O.sep),te=O.sep+le,Q=O.$fc.sep+B;let K;return ee?K=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(te)||!ne&&(q===B||q.endsWith(Q)))?z:null}:K=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===B)?z:null},K.allPaths=[(ee?"*/":"./")+B],K}function v(B){try{const z=new RegExp(`^${E(B)}$`);return function(ee){return z.lastIndex=0,typeof ee=="string"&&z.test(ee)?B:null}}catch{return t}}function C(B,z,ee){return!B||typeof z!="string"?!1:U(B)(z,void 0,ee)}function U(B,z={}){if(!B)return n;if(typeof B=="string"||F(B)){const ee=s(B,z);if(ee===t)return n;const ne=function(le,te){return!!ee(le,te)};return ee.allBasenames&&(ne.allBasenames=ee.allBasenames),ee.allPaths&&(ne.allPaths=ee.allPaths),ne}return V(B,z)}function F(B){const z=B;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(B){return B.allBasenames||[]}function G(B){return B.allPaths||[]}function V(B,z){const ee=H(Object.getOwnPropertyNames(B).map(K=>_(K,B[K],z)).filter(K=>K!==t)),ne=ee.length;if(!ne)return t;if(!ee.some(K=>!!K.requiresSiblings)){if(ne===1)return ee[0];const K=function(X,J){let j;for(let W=0,Y=ee.length;W<Y;W++){const Z=ee[W](X,J);if(typeof Z=="string")return Z;(0,c.$ph)(Z)&&(j||(j=[]),j.push(Z))}return j?(async()=>{for(const W of j){const Y=await W;if(typeof Y=="string")return Y}return null})():null},q=ee.find(X=>!!X.allBasenames);q&&(K.allBasenames=q.allBasenames);const D=ee.reduce((X,J)=>J.allPaths?X.concat(J.allPaths):X,[]);return D.length&&(K.allPaths=D),K}const le=function(K,q,D){let X,J;for(let j=0,W=ee.length;j<W;j++){const Y=ee[j];Y.requiresSiblings&&D&&(q||(q=(0,O.$mc)(K)),X||(X=q.substr(0,q.length-(0,O.$nc)(K).length)));const Z=Y(K,q,X,D);if(typeof Z=="string")return Z;(0,c.$ph)(Z)&&(J||(J=[]),J.push(Z))}return J?(async()=>{for(const j of J){const W=await j;if(typeof W=="string")return W}return null})():null},te=ee.find(K=>!!K.allBasenames);te&&(le.allBasenames=te.allBasenames);const Q=ee.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return Q.length&&(le.allPaths=Q),le}function _(B,z,ee){if(z===!1)return t;const ne=s(B,ee);if(ne===t)return t;if(typeof z=="boolean")return ne;if(z){const le=z.when;if(typeof le=="string"){const te=(Q,K,q,D)=>{if(!D||!ne(Q,K))return null;const X=le.replace("$(basename)",()=>q),J=D(X);return(0,c.$ph)(J)?J.then(j=>j?B:null):J?B:null};return te.requiresSiblings=!0,te}}return ne}function H(B,z){const ee=B.filter(K=>!!K.basenames);if(ee.length<2)return B;const ne=ee.reduce((K,q)=>{const D=q.basenames;return D?K.concat(D):K},[]);let le;if(z){le=[];for(let K=0,q=ne.length;K<q;K++)le.push(z)}else le=ee.reduce((K,q)=>{const D=q.patterns;return D?K.concat(D):K},[]);const te=function(K,q){if(typeof K!="string")return null;if(!q){let X;for(X=K.length;X>0;X--){const J=K.charCodeAt(X-1);if(J===T.CharCode.Slash||J===T.CharCode.Backslash)break}q=K.substr(X)}const D=ne.indexOf(q);return D!==-1?le[D]:null};te.basenames=ne,te.patterns=le,te.allBasenames=ne;const Q=B.filter(K=>!K.basenames);return Q.push(te),Q}function ie(B,z){return(0,I.$tb)(B,z,(ee,ne)=>typeof ee=="string"&&typeof ne=="string"?ee===ne:typeof ee!="string"&&typeof ne!="string"?ee.base===ne.base&&ee.pattern===ne.pattern:!1)}}),define(he[94],ue([0,1,14,65,9]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=void 0,e.$Mn=k,e.$Nn=R,e.$On=$;function A(d){return d.toJSON()}class N{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:A(T.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:A(T.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:T.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Kn=N,e.$Ln=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function O(d,g,l){if(!d||l>200)return null;if(typeof d=="object"){if(d instanceof T.URI)return g.transformOutgoing(d);for(const m in d)if(Object.hasOwnProperty.call(d,m)){const E=O(d[m],g,l+1);E!==null&&(d[m]=E)}}return null}function k(d,g){const l=O(d,g,0);return l===null?d:l}function b(d,g,l,m){if(!d||m>200)return null;if(typeof d=="object"){if(d.$mid===c.MarshalledId.Uri)return l?T.URI.revive(g.transformIncoming(d)):g.transformIncoming(d);if(d instanceof I.$Me)return null;for(const E in d)if(Object.hasOwnProperty.call(d,E)){const f=b(d[E],g,l,m+1);f!==null&&(d[E]=f)}}return null}function R(d,g){const l=b(d,g,!1,0);return l===null?d:l}function $(d,g){const l=b(d,g,!0,0);return l===null?d:l}}),define(he[32],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=c;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(T){return I.test(T)}e.$Zg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(O){for(let k=0;k<O.length;k++)O[k]=Math.floor(Math.random()*256);return O};const A=new Uint8Array(16),N=[];for(let O=0;O<256;O++)N.push(O.toString(16).padStart(2,"0"));return function(){T(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,b="";return b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b}}()}),define(he[141],ue([0,1,38]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=A;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(N){const O=N.replace(/\-/g,":").toLowerCase();return!c.has(O)}function A(){const N=(0,I.networkInterfaces)();for(const O in N){const k=N[O];if(k){for(const{mac:b}of k)if(T(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[142],ue([0,1,38,51,32,141,5]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0,e.$Rn=k,e.$Sn=$,e.$Tn=d,T=Pe(T),e.$Qn=new class{c(g){return this.a||(this.a=c.$Ji.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,l=0;const m=(0,I.networkInterfaces)();for(const E in m){const f=m[E];if(f)for(const{mac:w,internal:P}of f)P||(l+=1,this.c(w.toUpperCase())&&(g+=1))}this.b=l>0?g/l:0}return this.b}};let O;async function k(g){return O||(O=(async()=>await b(g)||T.$Zg())()),O}async function b(g){try{const l=await new Promise((E,f)=>{ae(["crypto"],E,f)}).then(Pe),m=(0,A.$Pn)();return l.createHash("sha256").update(m,"utf8").digest("hex")}catch(l){g(l);return}}const R="Software\\Microsoft\\SQMClient";async function $(g){if(N.$j){const l=await new Promise((m,E)=>{ae(["@vscode/windows-registry"],m,E)}).then(Pe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(m){return g(m),""}}return""}async function d(g){try{return await(await new Promise((E,f)=>{ae(["@vscode/deviceid"],E,f)}).then(Pe)).getDeviceId()}catch(l){return g(l),""}}}),define(he[143],ue([0,1,240,14]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KX=void 0;class T extends I.Transform{constructor(N){if(super(),typeof N=="number")this.b=N,this.c=1;else{const O=Buffer.isBuffer(N)?N:Buffer.from(N);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(N,O,k){this.a?this.a=Buffer.concat([this.a,N]):this.a=N;let b=0;for(;b<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,c.$Ne)(this.a,this.b,b);if(R===-1)break;this.push(this.a.slice(b,R+this.c)),b=R+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),k()}_flush(N){this.a&&this.push(this.a),N()}}e.$KX=T}),define(he[144],ue([0,1,33,13,37]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LX=b,e.$MX=R;const A="XDG_SESSION_TYPE",N="WAYLAND_DISPLAY",O="XDG_RUNTIME_DIR";var k;(function($){$.Wayland="wayland",$.XWayland="xwayland",$.X11="x11",$.Unknown="unknown"})(k||(k={}));async function b($){const d=T.env[A];if(d)return d===k.Wayland||d===k.X11?d:k.Unknown;if(T.env[N]){const l=T.env[O];if(l){const m=(0,c.$ic)(l,"wayland-0");try{return await I.promises.access(m,I.constants.R_OK),k.Wayland}catch(E){return $(E),k.Unknown}}else return k.Unknown}else return k.X11}function R($,d){if(d)switch(d){case"auto":return $;case"x11":return $===k.Wayland?k.XWayland:k.X11;case"wayland":return k.Wayland;default:return k.Unknown}else return $===k.Wayland?k.XWayland:k.X11}}),define(he[145],ue([0,1,33,241,5]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=A,T=Pe(T);async function A(N){if(T.$k||T.$j)return;let O;for(const k of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{O=await I.promises.open(k,I.constants.R_OK);break}catch{}if(!O){N("Unable to retrieve release information from known identifier paths.");return}try{const k=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const R of(0,c.createInterface)({input:O.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const $=R.split("=")[0].toUpperCase().trim();if(k.has($)){const d=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();$==="ID"||$==="DISTRIB_ID"?b.id=d:$==="ID_LIKE"?b.id_like=d:($==="VERSION_ID"||$==="DISTRIB_RELEASE")&&(b.version_id=d)}}return b}catch(k){N(k)}}}),define(he[30],ue([0,1,33,38,242,6,41,90,13,5,20,9]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=u,e.configureFlushOnWrite=r,e.writeFileSync=h,I=Pe(I);var d;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function g(V,_=d.UNLINK,H){if((0,N.$Gg)(V))throw new Error("rimraf - will refuse to recursively delete root");return _===d.UNLINK?m(V):l(V,H)}async function l(V,_=(0,N.$Lg)((0,c.tmpdir)())){try{try{await I.promises.rename(V,_)}catch(H){return H.code==="ENOENT"?void 0:m(V)}m(_).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function m(V){return I.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function E(V){if((0,N.$Gg)(V))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function f(V,_){return p(await(_?w(V):I.promises.readdir(V)))}async function w(V){try{return await I.promises.readdir(V,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const _=[],H=await f(V);for(const ie of H){let B=!1,z=!1,ee=!1;try{const ne=await I.promises.lstat((0,k.$ic)(V,ie));B=ne.isFile(),z=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}_.push({name:ie,isFile:()=>B,isDirectory:()=>z,isSymbolicLink:()=>ee})}return _}function P(V){return p(I.readdirSync(V))}function p(V){return V.map(_=>typeof _=="string"?b.$k?(0,O.$lm)(_):_:(_.name=b.$k?(0,O.$lm)(_.name):_.name,_))}async function o(V){const _=await f(V),H=[];for(const ie of _)await i.existsDirectory((0,k.$ic)(V,ie))&&H.push(ie);return H}function u(V,_=1e3){return new Promise(H=>{let ie=!1;const B=setInterval(()=>{ie||(ie=!0,I.access(V,z=>{ie=!1,z&&(clearInterval(B),H(void 0))}))},_)})}var i;(function(V){async function _(B){let z;try{if(z=await I.promises.lstat(B),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await I.promises.stat(B),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.$j&&ee.code==="EACCES")try{return{stat:await I.promises.stat(await I.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ne}throw ee}}V.stat=_;async function H(B){try{const{stat:z,symbolicLink:ee}=await V.stat(B);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}V.existsFile=H;async function ie(B){try{const{stat:z,symbolicLink:ee}=await V.stat(B);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}V.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const n=new A.$Mh;function t(V,_,H){return n.queueFor($.URI.file(V),()=>{const ie=y(H);return new Promise((B,z)=>a(V,_,ie,ee=>ee?z(ee):B()))},R.$8g)}let s=!0;function r(V){s=V}function a(V,_,H,ie){if(!s)return I.writeFile(V,_,{mode:H.mode,flag:H.flag},ie);I.open(V,H.flag,H.mode,(B,z)=>{if(B)return ie(B);I.writeFile(z,_,ee=>{if(ee)return I.close(z,()=>ie(ee));I.fdatasync(z,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(z,le=>ie(le))))})})}function h(V,_,H){const ie=y(H);if(!s)return I.writeFileSync(V,_,{mode:ie.mode,flag:ie.flag});const B=I.openSync(V,ie.flag,ie.mode);try{I.writeFileSync(B,_);try{I.fdatasyncSync(B)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{I.closeSync(B)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,_,H=6e4){if(V!==_)try{b.$j&&typeof H=="number"?await S(V,_,Date.now(),H):await I.promises.rename(V,_)}catch(ie){if(V.toLowerCase()!==_.toLowerCase()&&ie.code==="EXDEV"||V.endsWith("."))await v(V,_,{preserveSymlinks:!1}),await g(V,d.MOVE);else throw ie}}async function S(V,_,H,ie,B=0){try{return await I.promises.rename(V,_)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-H>=ie)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${z}`),z;if(B===0){let ee=!1;try{const{stat:ne}=await i.stat(_);ne.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,A.$Eh)(Math.min(100,B*10)),S(V,_,H,ie,B+1)}}async function v(V,_,H){return U(V,_,{root:{source:V,target:_},options:H,handledSourcePaths:new Set})}const C=511;async function U(V,_,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:ie,symbolicLink:B}=await i.stat(V);if(B){if(H.options.preserveSymlinks)try{return await G(V,_,H)}catch{}if(B.dangling)return}return ie.isDirectory()?F(V,_,ie.mode&C,H):M(V,_,ie.mode&C)}async function F(V,_,H,ie){await I.promises.mkdir(_,{recursive:!0,mode:H});const B=await f(V);for(const z of B)await U((0,k.$ic)(V,z),(0,k.$ic)(_,z),ie)}async function M(V,_,H){await I.promises.copyFile(V,_),await I.promises.chmod(_,H)}async function G(V,_,H){let ie=await I.promises.readlink(V);(0,N.$Cg)(ie,H.root.source,!b.$l)&&(ie=(0,k.$ic)(H.root.target,ie.substr(H.root.source.length+1))),await I.promises.symlink(ie,_)}e.Promises=new class{get read(){return(V,_,H,ie,B)=>new Promise((z,ee)=>{I.read(V,_,H,ie,B,(ne,le,te)=>ne?ee(ne):z({bytesRead:le,buffer:te}))})}get write(){return(V,_,H,ie,B)=>new Promise((z,ee)=>{I.write(V,_,H,ie,B,(ne,le,te)=>ne?ee(ne):z({bytesWritten:le,buffer:te}))})}get fdatasync(){return(0,T.promisify)(I.fdatasync)}get open(){return(0,T.promisify)(I.open)}get close(){return(0,T.promisify)(I.close)}get realpath(){return(0,T.promisify)(I.realpath)}async exists(V){try{return await I.promises.access(V),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return o}get writeFile(){return t}get rm(){return g}get rename(){return L}get copy(){return v}}}),define(he[146],ue([0,1,33,13,5,26,30]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=O,e.$kr=k,e.$lr=b,e.$mr=R,I=Pe(I);function O(d){if(T.$l)return d;const g=(0,c.$lc)(d);if(d===g)return d;const l=((0,c.$mc)(d)||d).toLowerCase();try{const E=(0,N.readdirSync)(g).filter(f=>f.toLowerCase()===l);if(E.length===1){const f=O(g);if(f)return(0,c.$ic)(f,E[0])}else if(E.length>1){const f=E.indexOf(l);if(f>=0){const w=O(g);if(w)return(0,c.$ic)(w,E[f])}}}catch{}return null}async function k(d,g){if(T.$l)return d;const l=(0,c.$lc)(d);if(d===l)return d;const m=((0,c.$mc)(d)||d).toLowerCase();try{if(g?.isCancellationRequested)return null;const f=(await N.Promises.readdir(l)).filter(w=>w.toLowerCase()===m);if(f.length===1){const w=await k(l,g);if(w)return(0,c.$ic)(w,f[0])}else if(f.length>1){const w=f.indexOf(m);if(w>=0){const P=await k(l,g);if(P)return(0,c.$ic)(P,f[w])}}}catch{}return null}async function b(d){try{return await N.Promises.realpath(d)}catch{const l=$(d);return await I.promises.access(l,I.constants.R_OK),l}}function R(d){try{return I.realpathSync(d)}catch{const l=$(d);return I.accessSync(l,I.constants.R_OK),l}}function $(d){return(0,A.$mf)((0,c.$gc)(d),c.sep)}}),define(he[147],ue([0,1,67]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=c,e.$4g=A,I=Pe(I);function c(O,k,b,R=1){let $=!1;return new Promise(d=>{const g=setTimeout(()=>{if(!$)return $=!0,d(0)},b);T(O,k,R,l=>{if(!$)return $=!0,clearTimeout(g),d(l)})})}function T(O,k,b,R){if(k===0)return R(0);const $=new I.Socket;$.once("connect",()=>(N($),T(O+b,k-1,b,R))),$.once("data",()=>{}),$.once("error",d=>(N($),d.code!=="ECONNREFUSED"?T(O+b,k-1,b,R):R(O))),$.connect(O,"127.0.0.1")}e.$3g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(O,k,b,R="127.0.0.1"){let $=!1,d,g=1;const l=I.createServer({pauseOnConnect:!0});function m(E,f){$||($=!0,l.removeAllListeners(),l.close(),d&&clearTimeout(d),f(E))}return new Promise(E=>{d=setTimeout(()=>{m(0,E)},b),l.on("listening",()=>{m(O,E)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<k?(O++,g++,l.listen(O,R)):m(0,E)}),l.on("close",()=>{m(0,E)}),l.listen(O,R)})}function N(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(k){console.error(k)}}}),define(he[148],ue([0,1,33,13,5,37,91,12,30]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=b,e.$xm=R,c=Pe(c),T=Pe(T),A=Pe(A),O=Pe(O),k=Pe(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function b(d=A.env){return d.comspec||"cmd.exe"}function R(d){let g=[],l=!1;const m=function(E){if(l){g.push(E);return}(!d.send(E,w=>{if(w&&console.error(w),l=!1,g.length>0){const P=g.slice(0);g=[],P.forEach(p=>m(p))}})||T.$j)&&(l=!0)};return{send:m}}var $;(function(d){async function g(l,m,E){if(c.$hc(l))return l;if(m===void 0&&(m=A.cwd()),c.$lc(l)!=="."||(E===void 0&&O.$dg(A.env.PATH)&&(E=A.env.PATH.split(c.$sc)),E===void 0||E.length===0))return c.$ic(m,l);async function w(P){if(await k.Promises.exists(P)){let p;try{p=await I.promises.stat(P)}catch(o){o.message.startsWith("EACCES")&&(p=await I.promises.lstat(P))}return p?!p.isDirectory():!1}return!1}for(const P of E){let p;if(c.$hc(P)?p=c.$ic(P,l):p=c.$ic(m,P,l),await w(p))return p;let o=p+".com";if(await w(o)||(o=p+".exe",await w(o)))return o}return c.$ic(m,l)}d.findExecutable=g})($||(e.win32=$={}))}),define(he[149],ue([0,1,68,22]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=T;function T(N){return new Promise((O,k)=>{let b;const R=new Map;function $(g,l,m,E,f){const w=R.get(l);if(g===N||w){const P={name:d(m),cmd:m,pid:g,ppid:l,load:E,mem:f};R.set(g,P),g===N&&(b=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort((p,o)=>p.pid-o.pid)))}}function d(g){const l=/--utility-sub-type=network/i,m=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-agent";if(f.exec(g))return"conpty-agent";let P=w.exec(g);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(g)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const p=/[a-zA-Z-]+\.js/g;let o="";do P=p.exec(g),P&&(o+=P+" ");while(P);return o&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${o})`:g}if(process.platform==="win32"){const g=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,m)=>{ae(["@vscode/windows-process-tree"],l,m)}).then(Pe).then(l=>{l.getProcessList(N,m=>{if(!m){k(new Error(`Root process ${N} not found`));return}l.getProcessCpuUsage(m,E=>{const f=new Map;E.forEach(w=>{const P=g(w.commandLine||"");f.set(w.pid,{name:d(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=f.get(N),b?(f.forEach(w=>{const P=f.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((P,p)=>P.pid-p.pid))}),O(b)):k(new Error(`Root process ${N} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let g=function(){let l=[b];const m=[];for(;l.length;){const f=l.shift();f&&(m.push(f.pid),f.children&&(l=l.concat(f.children)))}let E=JSON.stringify(c.$Xg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+m.join(" "),(0,I.exec)(E,{},(f,w,P)=>{if(f||P)k(f||new Error(P.toString()));else{const p=w.toString().split(`
`);for(let o=0;o<m.length;o++){const u=R.get(m[o]);u.load=parseFloat(p[o])}if(!b){k(new Error(`Root process ${N} not found`));return}O(b)}})};(0,I.exec)("which ps",{},(l,m,E)=>{if(l||E)if(process.platform!=="linux")k(l||new Error(E.toString()));else{const f=JSON.stringify(c.$Xg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(f,{},(w,P,p)=>{w||p?k(w||new Error(p.toString())):(A(P,$),g())})}else{const f=m.toString().trim();(0,I.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,p,o)=>{P||o&&!o.includes("screen size is bogus")?k(P||new Error(o.toString())):(A(p,$),process.platform==="linux"?g():b?O(b):k(new Error(`Root process ${N} not found`)))})}})}})}function A(N,O){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=N.toString().split(`
`);for(const R of b){const $=k.exec(R.trim());$&&$.length===6&&O(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}});var ve=this&&this.__decorate||function(ae,e,I,c){var T=arguments.length,A=T<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,I):c,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ae,e,I,c);else for(var O=ae.length-1;O>=0;O--)(N=ae[O])&&(A=(T<3?N(A):T>3?N(e,I,A):N(e,I))||A);return T>3&&A&&Object.defineProperty(e,I,A),A};define(he[42],ue([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.ProxyChannel=e.$li=e.$ii=e.$hi=e.$gi=e.RequestInitiator=e.$fi=e.$ci=e.$bi=void 0,e.$di=r,e.$ei=a,e.$ji=C,e.$ki=U,$=Pe($);var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function l(B){switch(B){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var m;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(m||(m={}));function E(B){switch(B){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function w(B){let z=0;for(let ee=0;;ee+=7){const ne=B.read(1);if(z|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return z}}const P=n(0);function p(B,z){if(z===0){B.write(P);return}let ee=0;for(let le=z;le!==0;le=le>>>7)ee++;const ne=T.$Me.alloc(ee);for(let le=0;z!==0;le++)ne.buffer[le]=z&127,z=z>>>7,z>0&&(ne.buffer[le]|=128);B.write(ne)}class o{constructor(z){this.b=z,this.a=0}read(z){const ee=this.b.slice(this.a,this.a+z);return this.a+=ee.byteLength,ee}}e.$bi=o;class u{constructor(){this.a=[]}get buffer(){return T.$Me.concat(this.a)}write(z){this.a.push(z)}}e.$ci=u;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function n(B){const z=T.$Me.alloc(1);return z.writeUInt8(B,0),z}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(B,z){if(typeof z>"u")B.write(t.Undefined);else if(typeof z=="string"){const ee=T.$Me.fromString(z);B.write(t.String),p(B,ee.byteLength),B.write(ee)}else if(s&&Buffer.isBuffer(z)){const ee=T.$Me.wrap(z);B.write(t.Buffer),p(B,ee.byteLength),B.write(ee)}else if(z instanceof T.$Me)B.write(t.VSBuffer),p(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(t.Array),p(B,z.length);for(const ee of z)r(B,ee)}else if(typeof z=="number"&&(z|0)===z)B.write(t.Uint),p(B,z);else{const ee=T.$Me.fromString(JSON.stringify(z));B.write(t.Object),p(B,ee.byteLength),B.write(ee)}}function a(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read(w(B)).toString();case i.Buffer:return B.read(w(B)).buffer;case i.VSBuffer:return B.read(w(B));case i.Array:{const ee=w(B),ne=[];for(let le=0;le<ee;le++)ne.push(a(B));return ne}case i.Object:return JSON.parse(B.read(w(B)).toString());case i.Int:return w(B)}}class h{constructor(z,ee,ne=null,le=1e3){this.h=z,this.j=ee,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:m.Initialize})}registerChannel(z,ee){this.b.set(z,ee),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case m.Initialize:{const ee=this.o([z.type]);this.k?.logOutgoing(ee,0,y.OtherSide,E(z.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const ee=this.o([z.type,z.id],z.data);this.k?.logOutgoing(ee,z.id,y.OtherSide,E(z.type),z.data);return}}}o(z,ee=void 0){const ne=new u;return r(ne,z),r(ne,ee),this.p(ne.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const ee=new o(z),ne=a(ee),le=a(ee),te=ne[0];switch(te){case g.Promise:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,le),this.s({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.EventListen:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,le),this.t({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.PromiseCancel:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]});case g.EventDispose:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]})}}s(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const ne=new A.$ve;let le;try{le=ee.call(this.j,z.name,z.arg,ne.token)}catch(K){le=Promise.reject(K)}const te=z.id;le.then(K=>{this.m({id:te,data:K,type:m.PromiseSuccess})},K=>{K instanceof Error?this.m({id:te,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:te,data:K,type:m.PromiseErrorObj})}).finally(()=>{Q.dispose(),this.d.delete(z.id)});const Q=(0,b.$Rc)(()=>ne.cancel());this.d.set(z.id,Q)}t(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const ne=z.id,te=ee.listen(this.j,z.name,z.arg)(Q=>this.m({id:ne,data:Q,type:m.EventFire}));this.d.set(z.id,te)}u(z){const ee=this.d.get(z.id);ee&&(ee.dispose(),this.d.delete(z.id))}v(z){let ee=this.g.get(z.channelName);ee||(ee=[],this.g.set(z.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===g.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);ee.push({request:z,timeoutTimer:ne})}w(z){const ee=this.g.get(z);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case g.Promise:this.s(ne.request);break;case g.EventListen:this.t(ne.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$fi=h;var y;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class L{constructor(z,ee=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$ke,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(z){const ee=this;return{call(ne,le,te){return ee.a?Promise.reject(new O.$4):ee.m(z,ne,le,te)},listen(ne,le){return ee.a?k.Event.None:ee.o(z,ne,le)}}}m(z,ee,ne,le=A.CancellationToken.None){const te=this.g++,Q=g.Promise,K={id:te,type:Q,channelName:z,name:ee,arg:ne};if(le.isCancellationRequested)return Promise.reject(new O.$4);let q;return new Promise((X,J)=>{if(le.isCancellationRequested)return J(new O.$4);const j=()=>{const se=ce=>{switch(ce.type){case m.PromiseSuccess:this.f.delete(te),X(ce.data);break;case m.PromiseError:{this.f.delete(te);const me=new Error(ce.data.message);me.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,me.name=ce.data.name,J(me);break}case m.PromiseErrorObj:this.f.delete(te),J(ce.data);break}};this.f.set(te,se),this.p(K)};let W=null;this.b===f.Idle?j():(W=(0,c.$qh)(se=>this.u()),W.then(()=>{W=null,j()}));const Y=()=>{W?(W.cancel(),W=null):this.p({id:te,type:g.PromiseCancel}),J(new O.$4)},Z=le.onCancellationRequested(Y);q=(0,b.$Qc)((0,b.$Rc)(Y),Z),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(z,ee,ne){const le=this.g++,te=g.EventListen,Q={id:le,type:te,channelName:z,name:ee,arg:ne};let K=null;const q=new k.$ke({onWillAddFirstListener:()=>{K=(0,c.$qh)(X=>this.u()),K.then(()=>{K=null,this.d.add(q),this.p(Q)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(q),this.p({id:le,type:g.EventDispose}))}}),D=X=>q.fire(X.data);return this.f.set(le,D),q.event}p(z){switch(z.type){case g.Promise:case g.EventListen:{const ee=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(ee,z.id,y.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case g.PromiseCancel:case g.EventDispose:{const ee=this.q([z.type,z.id]);this.j?.logOutgoing(ee,z.id,y.LocalSide,l(z.type));return}}}q(z,ee=void 0){const ne=new u;return r(ne,z),r(ne,ee),this.r(ne.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const ee=new o(z),ne=a(ee),le=a(ee),te=ne[0];switch(te){case m.Initialize:return this.j?.logIncoming(z.byteLength,0,y.LocalSide,E(te)),this.t({type:ne[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,ne[1],y.LocalSide,E(te),le),this.t({type:ne[0],id:ne[1],data:le})}}t(z){if(z.type===m.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$gi=L,ve([N.$8h],L.prototype,"onDidInitializePromise",null);class S{get connections(){const z=[];return this.f.forEach(ee=>z.push(ee)),z}constructor(z,ee,ne){this.a=new Map,this.f=new Set,this.g=new k.$ke,this.onDidAddConnection=this.g.event,this.h=new k.$ke,this.onDidRemoveConnection=this.h.event,this.j=new b.$Sc,this.j.add(z(({protocol:le,onDidClientDisconnect:te})=>{const Q=k.Event.once(le.onMessage);this.j.add(Q(K=>{const q=new o(K),D=a(q),X=new h(le,D,ee,ne),J=new L(le,ee);this.a.forEach((W,Y)=>X.registerChannel(Y,W));const j={channelServer:X,channelClient:J,ctx:D};this.f.add(j),this.g.fire(j),this.j.add(te(()=>{X.dispose(),J.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(z,ee){const ne=this;return{call(le,te,Q){let K;if((0,d.$rg)(ee)){const D=(0,I.$2b)(ne.connections.filter(ee));K=D?Promise.resolve(D):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,ee))}else K=ee.routeCall(ne,le,te);const q=K.then(D=>D.channelClient.getChannel(z));return C(q).call(le,te,Q)},listen(le,te){if((0,d.$rg)(ee))return ne.k(z,ee,le,te);const Q=ee.routeEvent(ne,le,te).then(K=>K.channelClient.getChannel(z));return C(Q).listen(le,te)}}}k(z,ee,ne,le){const te=this;let Q;const K=new k.$ke({onWillAddFirstListener:()=>{Q=new b.$Sc;const q=new k.$qe,D=new Map,X=j=>{const Y=j.channelClient.getChannel(z).listen(ne,le),Z=q.add(Y);D.set(j,Z)},J=j=>{const W=D.get(j);W&&(W.dispose(),D.delete(j))};te.connections.filter(ee).forEach(X),k.Event.filter(te.onDidAddConnection,ee)(X,void 0,Q),te.onDidRemoveConnection(J,void 0,Q),q.event(K.fire,K,Q),Q.add(q)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return K.event}registerChannel(z,ee){this.a.set(z,ee);for(const ne of this.f)ne.channelServer.registerChannel(z,ee)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$hi=S;class v{constructor(z,ee,ne=null){const le=new u;r(le,ee),z.send(le.buffer),this.a=new L(z,ne),this.d=new h(z,ee,ne)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,ee){this.d.registerChannel(z,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ii=v;function C(B){return{call(z,ee,ne){return B.then(le=>le.call(z,ee,ne))},listen(z,ee){const ne=new k.$te;return B.then(le=>ne.input=le.listen(z,ee)),ne.event}}}function U(B){let z=!1;return{call(ee,ne,le){return z?B.call(ee,ne,le):(0,c.$Eh)(0).then(()=>z=!0).then(()=>B.call(ee,ne,le))},listen(ee,ne){if(z)return B.listen(ee,ne);const le=new k.$te;return(0,c.$Eh)(0).then(()=>z=!0).then(()=>le.input=B.listen(ee,ne)),le.event}}}class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const ee of z.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await k.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$li=F;var M;(function(B){function z(te,Q,K){const q=te,D=K&&K.disableMarshalling,X=new Map;for(const J in q)ne(J)&&X.set(J,k.Event.buffer(q[J],!0,void 0,Q));return new class{listen(J,j,W){const Y=X.get(j);if(Y)return Y;const Z=q[j];if(typeof Z=="function"){if(le(j))return Z.call(q,W);if(ne(j))return X.set(j,k.Event.buffer(q[j],!0,void 0,Q)),X.get(j)}throw new O.$ab(`Event not found: ${j}`)}call(J,j,W){const Y=q[j];if(typeof Y=="function"){if(!D&&Array.isArray(W))for(let se=0;se<W.length;se++)W[se]=(0,R.$ai)(W[se]);let Z=Y.apply(q,W);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new O.$ab(`Method not found: ${j}`)}}}B.fromService=z;function ee(te,Q){const K=Q&&Q.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return Q?.properties?.has(D)?Q.properties.get(D):le(D)?function(X){return te.listen(D,X)}:ne(D)?te.listen(D):async function(...X){let J;Q&&!(0,d.$mg)(Q.context)?J=[Q.context,...X]:J=X;const j=await te.call(D,J);return K?j:(0,R.$ai)(j)};throw new O.$ab(`Property not found: ${String(D)}`)}})}B.toService=ee;function ne(te){return te[0]==="o"&&te[1]==="n"&&$.$Df(te.charCodeAt(2))}function le(te){return/^onDynamic/.test(te)&&$.$Df(te.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function _(B){return Array.isArray(B)?B.map(V):V(B)}function H(B,z,ee,ne,le,te,Q){Q=_(Q);const K=G[le],q=K[ne%K.length];let D=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(te)?(D=D.concat(Q),D.push(")")):D.push(Q),console.log.apply(console,D)}class ie{constructor(z,ee){this.d=z,this.f=ee,this.a=0,this.b=0}logOutgoing(z,ee,ne,le,te){this.b+=z,H(this.d,this.b,z,ee,ne,le,te)}logIncoming(z,ee,ne,le,te){this.a+=z,H(this.f,this.a,z,ee,ne,le,te)}}e.$mi=ie}),define(he[69],ue([0,1,14,3,2,42]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.ProtocolConstants=e.$ni=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var O;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function a(y,L){if(!s.has(y)){const S=String(++r);s.set(y,S)}return s.get(y)}function h(y,L,S,v){if(!t.enableDiagnostics)return;const C=a(y,L);if(v instanceof I.$Me||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=I.$Me.alloc(v.byteLength);U.set(v),t.records.push({timestamp:Date.now(),id:C,label:L,type:S,buff:U})}else t.records.push({timestamp:Date.now(),id:C,label:L,type:S,data:v})}t.traceSocketEvent=h})(O||(e.SocketDiagnostics=O={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let b=null;function R(){return b||(b=I.$Me.alloc(0)),b}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const L=this.a[0];return r&&(this.a.shift(),this.b-=s),L}if(this.a[0].byteLength>s){const L=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),L}const a=I.$Me.alloc(s);let h=0,y=0;for(;s>0;){const L=this.a[y];if(L.byteLength>s){const S=L.slice(0,s);a.set(S,h),h+=s,r&&(this.a[y]=L.slice(s),this.b-=s),s-=s}else a.set(L,h),h+=L.byteLength,r?(this.a.shift(),this.b-=L.byteLength):y++,s-=L.byteLength}return a}}e.$ni=$;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(d||(d={}));function g(t){switch(t){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class m{constructor(s,r,a,h){this.type=s,this.id=r,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends T.$Tc{constructor(s){super(),this.f=this.B(new c.$ke),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:d.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new $,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,h=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,r),this.f.fire(new m(a,h,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Me.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const a=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,a}h(){const s=I.$Me.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class w extends T.$Tc{constructor(s){super(),this.f=new c.$ke,this.onMessage=this.f.event,this.g=new c.$ke,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new f(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===d.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new m(d.Regular,0,0,s))}}e.$oi=w;class P extends A.$ii{static fromSocket(s,r){return new P(new w(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,a=null){super(s,r,a),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$pi=P;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$ke({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$qi=p;class o{constructor(s){this.data=s,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,a=this.a;for(;a;)s[r++]=a.data,a=a.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new o(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let a=0;for(let h=0;h<i.a;h++)s-this.c[h]<=r&&a++;return 1-a/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new p,this.onControlMessage=this.v.event,this.w=new p,this.onMessage=this.w.event,this.x=new p,this.onDidDispose=this.x.event,this.y=new p,this.onSocketClose=this.y.event,this.z=new p,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new T.$Sc,this.p=s.socket,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new m(d.Disconnect,0,0,R());this.q.write(s),this.q.flush()}}sendPause(){const s=new m(d.Pause,0,0,R());this.q.write(s)}sendResume(){const s=new m(d.Resume,0,0,R());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new T.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(a=>this.A(a))),this.s.add(this.p.onClose(a=>this.y.fire(a))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new m(d.Ack,0,this.j,R());this.q.write(s);const r=this.c.toArray();for(let a=0,h=r.length;a<h;a++)this.q.write(r[a]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case d.None:break;case d.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new m(d.ReplayRequest,0,0,R())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case d.Control:{this.v.fire(s.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const r=this.c.toArray();for(let a=0,h=r.length;a<h;a++)this.q.write(r[a]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const a=new m(d.Regular,r,this.j,s);this.c.push(a),this.a||(this.q.write(a),this.C())}sendControl(s){const r=new m(d.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,a=Date.now()-this.r.lastReadTime,h=Date.now()-this.o;if(r>=l.TimeoutTime&&a>=l.TimeoutTime&&h>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-a,l.TimeoutTime-h,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new m(d.Ack,0,this.j,R());this.q.write(s)}E(){this.j=this.h;const s=new m(d.KeepAlive,0,this.j,R());this.q.write(s)}}e.$ri=n}),define(he[95],ue([0,1,68,6,14,25,139,8,3,2,29,148,91,42]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,O=Pe(O);class l extends g.$fi{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>T.$Me.wrap(Buffer.from(w,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$fr=l;class m{constructor(f,w){this.i=f,this.j=w,this.c=new Set,this.g=new Map,this.h=new k.$ke,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new c.$Ah(P),this.d=null,this.f=null}getChannel(f){const w=this;return{call(P,p,o){return w.k(f,P,p,o)},listen(P,p){return w.l(f,P,p)}}}k(f,w,P,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const o=this.n(f),u=(0,c.$qh)(t=>o.call(w,P,t)),i=p.onCancellationRequested(()=>u.cancel()),n=(0,b.$Rc)(()=>u.cancel());return this.c.add(n),u.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(f,w,P){if(!this.b)return k.Event.None;this.b.cancel();let p;const o=new k.$ke({onWillAddFirstListener:()=>{p=this.n(f).listen(w,P)(o.fire,o),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,R.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,d.$km)(w.env),this.d=(0,I.fork)(this.i,f,w);const P=new k.$ke,o=k.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.$br)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(T.$Me.wrap(Buffer.from(r,"base64")))}),u=this.j.useQueue?(0,$.$xm)(this.d):this.d,i=r=>this.d&&this.d.connected&&u.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new g.$gi(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(h=>(0,b.$Oc)(h)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(f){let w=this.g.get(f);return w||(w=this.m.getChannel(f),this.g.set(f,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=m}),define(he[150],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3X=I;function I(c){return!!c.parentPort}}),define(he[151],ue([0,1,150,14,42,3,12,17]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4X=void 0,e.$5X=R;class k{constructor(d){this.a=d,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",g=>g.data?c.$Me.wrap(g.data):c.$Me.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class b extends T.$hi{static b(d){(0,N.$ng)((0,I.$3X)(process),"Electron Utility Process");const g=new A.$ke;return process.parentPort.on("message",l=>{if(d?.handledClientConnection(l))return;const m=(0,O.$Nb)(l.ports);m&&g.fire(m)}),A.Event.map(g.event,l=>({protocol:new k(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor(d){super(b.b(d))}}e.$4X=b;function R($,d,g){const l=m=>{m.data===d&&($.removeListener("message",l),g())};$.on("message",l)}}),define(he[70],ue([0,1,6,3,2,66,12]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=k;var O;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function k(d){const g=d;return g?.changed instanceof Map||g?.deleted instanceof Set}var b;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(b||(e.StorageState=b={}));class R extends T.$Tc{static{this.a=100}constructor(g,l=Object.create(null)){super(),this.r=g,this.s=l,this.b=this.B(new c.$ne),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new I.$Bh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((l,m)=>this.w(m,l)),g.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(g,l){if(this.c===b.Closed)return;let m=!1;(0,N.$mg)(l)?m=this.f.delete(g):this.f.get(g)!==l&&(this.f.set(g,l),m=!0),m&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,l){const m=this.f.get(g);return(0,N.$mg)(m)?l:m}getBoolean(g,l){const m=this.get(g);return(0,N.$mg)(m)?l:m==="true"}getNumber(g,l){const m=this.get(g);return(0,N.$mg)(m)?l:parseInt(m,10)}getObject(g,l){const m=this.get(g);return(0,N.$mg)(m)?l:(0,A.$_h)(m)}async set(g,l,m=!1){if(this.c===b.Closed)return;if((0,N.$mg)(l))return this.delete(g,m);const E=(0,N.$fg)(l)||Array.isArray(l)?(0,A.$$h)(l):String(l);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire({key:g,external:m}),this.D()}async delete(g,l=!1){if(!(this.c===b.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===b.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$cq=R;class ${constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((l,m)=>this.a.set(m,l)),g.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$dq=$}),define(he[11],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=T,e.localize2=N;const I=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function c(O,k){let b;return k.length===0?b=O:b=O.replace(/\{(\d+)\}/g,(R,$)=>{const d=$[0],g=k[d];let l=R;return typeof g=="string"?l=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(l=String(g)),l}),I&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function T(O,k,...b){return c(typeof O=="number"?A(O,k):k,b)}function A(O,k){const b=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof b!="string"){if(typeof k=="string")return k;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return b}function N(O,k,...b){let R;typeof O=="number"?R=A(O,k):R=k;const $=c(R,b);return{value:$,original:k===R?$:c(k,b)}}}),define(he[71],ue([0,1,11]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=b,e.$1m=R,e.$2m=$;const c=60,T=c*60,A=T*24,N=A*7,O=A*30,k=A*365;function b(d,g,l,m){typeof d!="number"&&(d=d.getTime());const E=Math.round((new Date().getTime()-d)/1e3);if(E<-30)return(0,I.localize)(12929,null,b(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,I.localize)(12930,null);let f;return E<c?(f=E,g?f===1?l?(0,I.localize)(12931,null,f):(0,I.localize)(12932,null,f):l?(0,I.localize)(12933,null,f):(0,I.localize)(12934,null,f):f===1?l?(0,I.localize)(12935,null,f):(0,I.localize)(12936,null,f):l?(0,I.localize)(12937,null,f):(0,I.localize)(12938,null,f)):E<T?(f=Math.floor(E/c),g?f===1?l?(0,I.localize)(12939,null,f):(0,I.localize)(12940,null,f):l?(0,I.localize)(12941,null,f):(0,I.localize)(12942,null,f):f===1?l?(0,I.localize)(12943,null,f):(0,I.localize)(12944,null,f):l?(0,I.localize)(12945,null,f):(0,I.localize)(12946,null,f)):E<A?(f=Math.floor(E/T),g?f===1?l?(0,I.localize)(12947,null,f):(0,I.localize)(12948,null,f):l?(0,I.localize)(12949,null,f):(0,I.localize)(12950,null,f):f===1?l?(0,I.localize)(12951,null,f):(0,I.localize)(12952,null,f):l?(0,I.localize)(12953,null,f):(0,I.localize)(12954,null,f)):E<N?(f=Math.floor(E/A),g?f===1?(0,I.localize)(12955,null,f):(0,I.localize)(12956,null,f):f===1?(0,I.localize)(12957,null,f):(0,I.localize)(12958,null,f)):E<O?(f=Math.floor(E/N),g?f===1?l?(0,I.localize)(12959,null,f):(0,I.localize)(12960,null,f):l?(0,I.localize)(12961,null,f):(0,I.localize)(12962,null,f):f===1?l?(0,I.localize)(12963,null,f):(0,I.localize)(12964,null,f):l?(0,I.localize)(12965,null,f):(0,I.localize)(12966,null,f)):E<k?(f=Math.floor(E/O),g?f===1?l?(0,I.localize)(12967,null,f):(0,I.localize)(12968,null,f):l?(0,I.localize)(12969,null,f):(0,I.localize)(12970,null,f):f===1?l?(0,I.localize)(12971,null,f):(0,I.localize)(12972,null,f):l?(0,I.localize)(12973,null,f):(0,I.localize)(12974,null,f)):(f=Math.floor(E/k),g?f===1?l?(0,I.localize)(12975,null,f):(0,I.localize)(12976,null,f):l?(0,I.localize)(12977,null,f):(0,I.localize)(12978,null,f):f===1?l?(0,I.localize)(12979,null,f):(0,I.localize)(12980,null,f):l?(0,I.localize)(12981,null,f):(0,I.localize)(12982,null,f))}function R(d,g){const l=Math.abs(d/1e3);return l<1?g?(0,I.localize)(12983,null,d):(0,I.localize)(12984,null,d):l<c?g?(0,I.localize)(12985,null,Math.round(d)/1e3):(0,I.localize)(12986,null,Math.round(d)/1e3):l<T?g?(0,I.localize)(12987,null,Math.round(d/(1e3*c))):(0,I.localize)(12988,null,Math.round(d/(1e3*c))):l<A?g?(0,I.localize)(12989,null,Math.round(d/(1e3*T))):(0,I.localize)(12990,null,Math.round(d/(1e3*T))):(0,I.localize)(12991,null,Math.round(d/(1e3*A)))}function $(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[43],ue([0,1,17,12,11]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=k,e.$pj=b,e.$qj=R,I=Pe(I),c=Pe(c),T=Pe(T);function A($,d){return d&&($.stack||$.stacktrace)?T.localize(12923,null,O($),N($.stack)||N($.stacktrace)):O($)}function N($){return Array.isArray($)?$.join(`
`):$}function O($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?T.localize(12924,null,$.message):$.message||T.localize(12925,null)}function k($=null,d=!1){if(!$)return T.localize(12926,null);if(Array.isArray($)){const g=I.$Gb($),l=k(g[0],d);return g.length>1?T.localize(12927,null,l,g.length):l}if(c.$dg($))return $;if($.detail){const g=$.detail;if(g.error)return A(g.error,d);if(g.exception)return A(g.exception,d)}return $.stack?A($,d):$.message?$.message:T.localize(12928,null)}function b($){const d=$;return d instanceof Error&&Array.isArray(d.actions)}function R($,d){let g;return typeof $=="string"?g=new Error($):g=$,g.actions=d,g}}),define(he[152],ue([0,1,11,36]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=T;function T(A){switch(A){case c.ParseErrorCode.InvalidSymbol:return(0,I.localize)(12914,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,I.localize)(12915,null);case c.ParseErrorCode.PropertyNameExpected:return(0,I.localize)(12916,null);case c.ParseErrorCode.ValueExpected:return(0,I.localize)(12917,null);case c.ParseErrorCode.ColonExpected:return(0,I.localize)(12918,null);case c.ParseErrorCode.CommaExpected:return(0,I.localize)(12919,null);case c.ParseErrorCode.CloseBraceExpected:return(0,I.localize)(12920,null);case c.ParseErrorCode.CloseBracketExpected:return(0,I.localize)(12921,null);case c.ParseErrorCode.EndOfFileExpected:return(0,I.localize)(12922,null);default:return""}}}),define(he[72],ue([0,1,33,6,13,12,30,11]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0,e.zip=E,e.$Bq=f,e.$Cq=P,T=Pe(T),O=Pe(O),e.$yq="end of central directory record signature not found";const k=new RegExp(e.$yq);class b extends Error{constructor(o,u){let i=u.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=u}}e.$zq=b;function R(p){const o=p.externalFileAttributes>>16||33188;return[448,56,7].map(u=>o&u).reduce((u,i)=>u+i,o&61440)}function $(p){if(p instanceof b)return p;let o;return k.test(p.message)&&(o="CorruptZip"),new b(o,p)}function d(p,o,u,i,n,t){const s=T.$lc(o),r=T.$ic(i,s);if(!r.startsWith(i))return Promise.reject(new Error(O.localize(12993,null,o)));const a=T.$ic(i,o);let h;return t.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(I.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,L)=>{if(!t.isCancellationRequested)try{h=(0,I.createWriteStream)(a,{mode:u}),h.once("close",()=>y()),h.once("error",L),p.once("error",L),p.pipe(h)}catch(S){L(S)}}))}function g(p,o,u,i){let n=(0,c.$qh)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),p.close()});return new Promise((r,a)=>{const h=new c.$yh,y=L=>{L.isCancellationRequested||(t++,p.readEntry())};p.once("error",a),p.once("close",()=>n.then(()=>{i.isCancellationRequested||p.entryCount===t?r():a(new b("Incomplete",new Error(O.localize(12994,null,t,p.entryCount))))},a)),p.readEntry(),p.on("entry",L=>{if(i.isCancellationRequested)return;if(!u.sourcePathRegex.test(L.fileName)){y(i);return}const S=L.fileName.replace(u.sourcePathRegex,"");if(/\/$/.test(S)){const U=T.$ic(o,S);n=(0,c.$qh)(F=>I.promises.mkdir(U,{recursive:!0}).then(()=>y(F)).then(void 0,a));return}const v=m(p,L),C=R(L);n=(0,c.$qh)(U=>h.queue(()=>v.then(F=>d(F,S,C,o,u,U).then(()=>y(U)))).then(null,a))})}).finally(()=>s.dispose())}async function l(p,o=!1){const{open:u}=await new Promise((i,n)=>{ae(["yauzl"],i,n)}).then(Pe);return new Promise((i,n)=>{u(p,o?{lazyEntries:!0}:void 0,(t,s)=>{t?n($(t)):i((0,A.$og)(s))})})}function m(p,o){return new Promise((u,i)=>{p.openReadStream(o,(n,t)=>{n?i($(n)):u((0,A.$og)(t))})})}async function E(p,o){const{ZipFile:u}=await new Promise((i,n)=>{ae(["yazl"],i,n)}).then(Pe);return new Promise((i,n)=>{const t=new u;o.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,I.createWriteStream)(p);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(p))})}function f(p,o,u={},i){const n=new RegExp(u.sourcePath?`^${u.sourcePath}`:"");let t=l(p,!0);return u.overwrite&&(t=t.then(s=>N.Promises.rm(o).then(()=>s))),t.then(s=>g(s,o,{sourcePathRegex:n},i))}function w(p,o){return l(p).then(u=>new Promise((i,n)=>{u.on("entry",t=>{t.fileName===o&&m(u,t).then(s=>i(s),s=>n(s))}),u.once("close",()=>n(new Error(O.localize(12995,null,o))))}))}function P(p,o){return w(p,o).then(u=>new Promise((i,n)=>{const t=[];u.once("error",n),u.on("data",s=>t.push(s)),u.on("end",()=>i(Buffer.concat(t)))}))}}),define(he[153],ue([0,1,39,8,11]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.TokenType=void 0;var A;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...R){switch(R.length){case 1:return(0,T.localize)(11530,null,R[0]);case 2:return(0,T.localize)(11531,null,R[0],R[1]);case 3:return(0,T.localize)(11532,null,R[0],R[1],R[2]);default:return}}const O=(0,T.localize)(11533,null),k=(0,T.localize)(11534,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return $.isTripleEq?"===":"==";case A.NotEq:return $.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return $.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return $.lexeme;case A.QuotedStr:return $.lexeme;case A.Error:return $.lexeme;case A.EOF:return"EOF";default:throw(0,c.$7)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case I.CharCode.OpenParen:this.k(A.LParen);break;case I.CharCode.CloseParen:this.k(A.RParen);break;case I.CharCode.ExclamationMark:if(this.h(I.CharCode.Equals)){const d=this.h(I.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:d})}else this.k(A.Neg);break;case I.CharCode.SingleQuote:this.o();break;case I.CharCode.Slash:this.q();break;case I.CharCode.Equals:if(this.h(I.CharCode.Equals)){const d=this.h(I.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:d})}else this.h(I.CharCode.Tilde)?this.k(A.RegexOp):this.l(N("==","=~"));break;case I.CharCode.LessThan:this.k(this.h(I.CharCode.Equals)?A.LtEq:A.Lt);break;case I.CharCode.GreaterThan:this.k(this.h(I.CharCode.Equals)?A.GtEq:A.Gt);break;case I.CharCode.Ampersand:this.h(I.CharCode.Ampersand)?this.k(A.And):this.l(N("&&"));break;case I.CharCode.Pipe:this.h(I.CharCode.Pipe)?this.k(A.Or):this.l(N("||"));break;case I.CharCode.Space:case I.CharCode.CarriageReturn:case I.CharCode.Tab:case I.CharCode.LineFeed:case I.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?I.CharCode.Null:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const d=this.d,g=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:g};this.g.push({offset:d,lexeme:g,additionalInfo:$}),this.f.push(l)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const d=this.c.substring(this.d,this.e),g=b.b.get(d);g?this.k(g):this.f.push({type:A.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==I.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,d=!1,g=!1;for(;;){if($>=this.c.length){this.e=$,this.l(k);return}const m=this.c.charCodeAt($);if(d)d=!1;else if(m===I.CharCode.Slash&&!g){$++;break}else m===I.CharCode.OpenSquareBracket?g=!0:m===I.CharCode.Backslash?d=!0:m===I.CharCode.CloseSquareBracket&&(g=!1);$++}for(;$<this.c.length&&b.a.has(this.c.charCodeAt($));)$++;this.e=$;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$yj=b}),define(he[154],ue([0,1,71,87,22,13,37,20,9]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$5m=R,e.$6m=$,e.$3m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,A.$lc)(T.$Xg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,O.$eh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$eh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,I.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",g)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$eh)(k.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$eh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$eh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$eh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=N.env.VSCODE_PORTABLE;return g?k.URI.file((0,A.$ic)(g,"argv.json")):(0,O.$eh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.$jc)(g):(0,A.$gc)((0,A.$ic)(T.$Xg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?k.URI.file((0,A.$jc)(g)):k.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.$jc)(g);const l=N.env.VSCODE_EXTENSIONS;if(l)return l;const m=N.env.VSCODE_PORTABLE;return m?(0,A.$ic)(m,"extensions"):(0,O.$eh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,A.$gc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?k.URI.parse(g):k.URI.file((0,A.$gc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$3m.test(g))}get extensionLogLevel(){const g=[];for(const l of this.args.log||[]){const m=e.$3m.exec(l);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,O.$eh)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=N.env.VSCODE_PORTABLE;return g?k.URI.file((0,A.$ic)(g,"policy.json")):(0,O.$eh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,l,m){this.a=g,this.b=l,this.c=m,this.editSessionId=this.args.editSessionId}}e.$4m=b,ve([c.$8h],b.prototype,"appRoot",null),ve([c.$8h],b.prototype,"userHome",null),ve([c.$8h],b.prototype,"userDataPath",null),ve([c.$8h],b.prototype,"appSettingsHome",null),ve([c.$8h],b.prototype,"tmpDir",null),ve([c.$8h],b.prototype,"cacheHome",null),ve([c.$8h],b.prototype,"stateResource",null),ve([c.$8h],b.prototype,"userRoamingDataHome",null),ve([c.$8h],b.prototype,"userDataSyncHome",null),ve([c.$8h],b.prototype,"sync",null),ve([c.$8h],b.prototype,"machineSettingsResource",null),ve([c.$8h],b.prototype,"workspaceStorageHome",null),ve([c.$8h],b.prototype,"localHistoryHome",null),ve([c.$8h],b.prototype,"keyboardLayoutResource",null),ve([c.$8h],b.prototype,"argvResource",null),ve([c.$8h],b.prototype,"isExtensionDevelopment",null),ve([c.$8h],b.prototype,"untitledWorkspacesHome",null),ve([c.$8h],b.prototype,"builtinExtensionsPath",null),ve([c.$8h],b.prototype,"extensionsPath",null),ve([c.$8h],b.prototype,"extensionDevelopmentLocationURI",null),ve([c.$8h],b.prototype,"extensionDevelopmentKind",null),ve([c.$8h],b.prototype,"extensionTestsLocationURI",null),ve([c.$8h],b.prototype,"debugExtensionHost",null),ve([c.$8h],b.prototype,"logLevel",null),ve([c.$8h],b.prototype,"extensionLogLevel",null),ve([c.$8h],b.prototype,"serviceMachineIdResource",null),ve([c.$8h],b.prototype,"disableTelemetry",null),ve([c.$8h],b.prototype,"disableWorkspaceTrust",null),ve([c.$8h],b.prototype,"useInMemorySecretStorage",null),ve([c.$8h],b.prototype,"policyFile",null);function R(d,g){return $(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}function $(d,g,l,m,E,f){const P=Number(g||d)||(m?null:l),p=P?!!g:!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:P,break:p,debugId:E,env:o}}}),function(){function ae(e,I,c){function T(N,O){const k=A(N,O),b=[k];return e.isAbsolute(k)||b.unshift(c),e.resolve(...b)}function A(N,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,O);const R=N["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join($,"AppData","Roaming")}break;case"darwin":b=e.join(I.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,O)}return{getUserDataPath:T}}if(typeof define=="function")define(he[155],ue([243,38,37]),function(e,I,c){return ae(e,I,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=ae(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[156],ue([0,1,38,154,155]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$8m=N,e.$9m=O;class A extends c.$4m{constructor(b,R){super(b,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,T.getUserDataPath)(b,R.nameShort)},R)}}e.$7m=A;function N(k,b){return(0,c.$6m)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,b,k.extensionEnvironment)}function O(k,b){return(0,c.$6m)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,b,k.extensionEnvironment)}}),define(he[157],ue([0,1,12,11]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=T;function T(N,O,k,b){try{A(N,O,k,b)}catch(R){N.error(R?.message??R)}return O}function A(N,O,k,b){const R=($,d,g)=>{const l=$[d];if((0,I.$dg)(l)){const m=l,E=m.length;if(E>1&&m[0]==="%"&&m[E-1]==="%"){const f=m.substr(1,E-2);let w=k[f];w===void 0&&b&&(w=b[f]);const P=typeof w=="string"?w:w?.message,p=b?.[f],o=typeof p=="string"?p:p?.message;if(!P){o||N.warn(`[${O.name}]: ${(0,c.localize)(11413,null,f)}`);return}if(g&&(d==="title"||d==="category")&&o&&o!==P){const u={value:P,original:o};$[d]=u}else $[d]=P}}else if((0,I.$fg)(l))for(const m in l)l.hasOwnProperty(m)&&(m==="commands"?R(l,m,!0):R(l,m,g));else if(Array.isArray(l))for(let m=0;m<l.length;m++)R(l,m,g)};for(const $ in O)O.hasOwnProperty($)&&R(O,$)}}),define(he[158],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$oic=I;class c{constructor(A){this.a=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,O){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${N}`)}}e.$pic=c}),define(he[159],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const I={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(I)}),define(he[73],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class I{constructor(T,A=[],N=!1){this.ctor=T,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$Ai=I}),define(he[160],ue([0,1,73]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=A,e.$Qs=N;const c=[];var T;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function A(O,k,b){k instanceof I.$Ai||(k=new I.$Ai(k,[],!!b)),c.push([O,k])}function N(){return c}}),define(he[161],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class I{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$sr=I;class c{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const O=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(N);O.outgoing.set(k.key,k),k.incoming.set(O.key,O)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const O of this.a.values())O.outgoing.delete(N),O.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let O=this.a.get(N);return O||(O=new I(N,A),this.a.set(N,O)),O}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,O]of this.a)A.push(`${N}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const O=new Set([A]),k=this.c(N,O);if(k)return k}}c(A,N){for(const[O,k]of A.outgoing){if(N.has(O))return[...N,O].join(" -> ");N.add(O);const b=this.c(k,N);if(b)return b;N.delete(O)}}}e.$tr=c}),define(he[4],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e._util=void 0,e.$Di=T,e.$Ei=A;var I;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function O(k){return k[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=O})(I||(e._util=I={})),e.$Ci=T("instantiationService");function c(N,O,k){O[I.DI_TARGET]===O?O[I.DI_DEPENDENCIES].push({id:N,index:k}):(O[I.DI_DEPENDENCIES]=[{id:N,index:k}],O[I.DI_TARGET]=O)}function T(N){if(I.serviceIds.has(N))return I.serviceIds.get(N);const O=function(k,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(O,k,R)};return O.toString=()=>N,I.serviceIds.set(N,O),O}function A(N){return N}}),define(he[162],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0,e.$1hc=(0,I.$Di)("checksumService")}),define(he[21],ue([0,1,12,9,4]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$0i=void 0,e.$$i=A,e.$_i=N,e.$aj=k,e.$bj=b,e.$cj=R,e.$dj=$,e.$ej=d,e.$fj=l,e.$gj=m,e.$hj=E,I=Pe(I),e.$0i=(0,T.$Di)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof c.URI)}function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof c.URI)}var O;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function k(f){switch(f){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function b(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function R(f,w){const P=Object.create(null);for(const p in f)$(P,p,f[p],w);return P}function $(f,w,P,p){const o=w.split("."),u=o.pop();let i=f;for(let n=0;n<o.length;n++){const t=o[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${w} as ${o.slice(0,n+1).join(".")} is null`);return}break;default:p(`Ignoring ${w} as ${o.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[u]=P}catch{p(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}function d(f,w){const P=w.split(".");g(f,P)}function g(f,w){const P=w.shift();if(w.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const p=f[P];typeof p=="object"&&!Array.isArray(p)&&(g(p,w),Object.keys(p).length===0&&delete f[P])}}function l(f,w,P){function p(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const o=w.split("."),u=p(f,o);return typeof u>"u"?P:u}function m(f,w,P){Object.keys(w).forEach(p=>{p!=="__proto__"&&(p in f?I.$fg(f[p])&&I.$fg(w[p])?m(f[p],w[p],P):P&&(f[p]=w[p]):f[p]=w[p])})}function E(f){return f.replace(/[\[\]]/g,"")}}),define(he[96],ue([0,1,39,5,26,153,4,11,8]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Bj=e.$Aj=e.ContextKeyExprType=void 0,e.$zj=R,e.$Cj=n,e.$Dj=t,e.$Wj=te;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",c.$k),b.set("isLinux",c.$l),b.set("isWindows",c.$j),b.set("isWeb",c.$p),b.set("isMacNative",c.$k&&!c.$p),b.set("isEdge",c.$I),b.set("isFirefox",c.$G),b.set("isChrome",c.$F),b.set("isSafari",c.$H);function R(q,D){if(b.get(q)!==void 0)throw(0,k.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(q,D)}const $=Object.prototype.hasOwnProperty;var d;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const g={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(11544,null),m=(0,O.localize)(11545,null),E=(0,O.localize)(11546,null),f=(0,O.localize)(11547,null),w=(0,O.localize)(11548,null),P=(0,O.localize)(11549,null),p=(0,O.localize)(11550,null),o=(0,O.localize)(11551,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=g){this.k=D,this.d=new A.$yj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const J=this.D(),j=J.type===A.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:J.offset,lexeme:A.$yj.getLexeme(J),additionalInfo:j}),u.c}return X}catch(X){if(X!==u.c)throw X;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const X=this.o();D.push(X)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const X=this.s();D.push(X)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),a.INSTANCE;case A.TokenType.LParen:{this.z();const X=this.l();return this.A(A.TokenType.RParen,f),X?.negate()}case A.TokenType.Str:return this.z(),C.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const X=this.l();return this.A(A.TokenType.RParen,f),X}case A.TokenType.Str:{const X=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==A.TokenType.RegexStr)throw this.B("REGEX",j);const W=j.lexeme,Y=W.lastIndexOf("/"),Z=Y===W.length-1?void 0:this.w(W.substring(Y+1));let se;try{se=new RegExp(W.substring(1,Y),Z)}catch{throw this.B("REGEX",j)}return _.create(X,se)}switch(j.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const W=[j.lexeme];this.z();let Y=this.D(),Z=0;for(let Ee=0;Ee<j.lexeme.length;Ee++)j.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?Z++:j.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&Z--;for(;!this.E()&&Y.type!==A.TokenType.And&&Y.type!==A.TokenType.Or;){switch(Y.type){case A.TokenType.LParen:Z++;break;case A.TokenType.RParen:Z--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ee=0;Ee<Y.lexeme.length;Ee++)Y.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?Z++:j.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&Z--}if(Z<0)break;W.push(A.$yj.getLexeme(Y)),this.z(),Y=this.D()}const se=W.join(""),ce=se.lastIndexOf("/"),me=ce===se.length-1?void 0:this.w(se.substring(ce+1));let pe;try{pe=new RegExp(se.substring(1,ce),me)}catch{throw this.B("REGEX",j)}return i.regex(X,pe)}case A.TokenType.QuotedStr:{const W=j.lexeme;this.z();let Y=null;if(!(0,T.$bf)(W)){const Z=W.indexOf("/"),se=W.lastIndexOf("/");if(Z!==se&&Z>=0){const ce=W.slice(Z+1,se),me=W[se+1]==="i"?"i":"";try{Y=new RegExp(ce,me)}catch{throw this.B("REGEX",j)}}}if(Y===null)throw this.B("REGEX",j);return _.create(X,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,E);const j=this.u();return i.notIn(X,j)}switch(this.D().type){case A.TokenType.Eq:{this.z();const j=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(X,j);switch(j){case"true":return i.has(X);case"false":return i.not(X);default:return i.equals(X,j)}}case A.TokenType.NotEq:{this.z();const j=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(X,j);switch(j){case"true":return i.not(X);case"false":return i.has(X);default:return i.notEquals(X,j)}}case A.TokenType.Lt:return this.z(),G.create(X,this.u());case A.TokenType.LtEq:return this.z(),V.create(X,this.u());case A.TokenType.Gt:return this.z(),F.create(X,this.u());case A.TokenType.GtEq:return this.z(),M.create(X,this.u());case A.TokenType.In:return this.z(),i.in(X,this.u());default:return i.has(X)}}case A.TokenType.EOF:throw this.h.push({message:p,offset:D.offset,lexeme:"",additionalInfo:o}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,X){if(this.C(D))return this.z();throw this.B(X,this.D())}B(D,X,J){const j=(0,O.localize)(11552,null,D,A.$yj.getLexeme(X)),W=X.offset,Y=A.$yj.getLexeme(X);return this.h.push({message:j,offset:W,lexeme:Y,additionalInfo:J}),u.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Aj=u;class i{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(D){return h.create(D)}static equals(D,X){return y.create(D,X)}static notEquals(D,X){return v.create(D,X)}static regex(D,X){return _.create(D,X)}static in(D,X){return L.create(D,X)}static notIn(D,X){return S.create(D,X)}static not(D){return C.create(D)}static and(...D){return B.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,X){return F.create(D,X)}static greaterEquals(D,X){return M.create(D,X)}static smaller(D,X){return G.create(D,X)}static smallerEquals(D,X){return V.create(D,X)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Bj=i;function n(q){const D=new u({regexParsingWithErrorRecovery:!1});return q.map(X=>(D.parse(X),D.lexingErrors.length>0?D.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,O.localize)(11553,null,J.additionalInfo):(0,O.localize)(11554,null),offset:J.offset,length:J.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}function t(q,D){const X=q?q.substituteConstants():void 0,J=D?D.substituteConstants():void 0;return!X&&!J?!0:!X||!J?!1:X.equals(J)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=d.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return a.INSTANCE}}e.$Ej=r;class a{static{this.INSTANCE=new a}constructor(){this.type=d.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Fj=a;class h{static create(D,X=null){const J=b.get(D);return typeof J=="boolean"?J?a.INSTANCE:r.INSTANCE:new h(D,X)}constructor(D,X){this.key=D,this.c=X,this.type=d.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?a.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Gj=h;class y{static create(D,X,J=null){if(typeof X=="boolean")return X?h.create(D,J):C.create(D,J);const j=b.get(D);return typeof j=="boolean"?X===(j?"true":"false")?a.INSTANCE:r.INSTANCE:new y(D,X,J)}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const X=D?"true":"false";return this.d===X?a.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Hj=y;class L{static create(D,X){return new L(D,X)}constructor(D,X){this.d=D,this.f=X,this.type=d.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const X=D.getValue(this.f),J=D.getValue(this.d);return Array.isArray(X)?X.includes(J):typeof J=="string"&&typeof X=="object"&&X!==null?$.call(X,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Ij=L;class S{static create(D,X){return new S(D,X)}constructor(D,X){this.d=D,this.f=X,this.type=d.NotIn,this.c=L.create(D,X)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Jj=S;class v{static create(D,X,J=null){if(typeof X=="boolean")return X?C.create(D,J):h.create(D,J);const j=b.get(D);return typeof j=="boolean"?X===(j?"true":"false")?r.INSTANCE:a.INSTANCE:new v(D,X,J)}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const X=D?"true":"false";return this.d===X?r.INSTANCE:a.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Kj=v;class C{static create(D,X=null){const J=b.get(D);return typeof J=="boolean"?J?r.INSTANCE:a.INSTANCE:new C(D,X)}constructor(D,X){this.c=D,this.d=X,this.type=d.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:a.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Lj=C;function U(q,D){if(typeof q=="string"){const X=parseFloat(q);isNaN(X)||(q=X)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class F{static create(D,X,J=null){return U(X,j=>new F(D,j,J))}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Mj=F;class M{static create(D,X,J=null){return U(X,j=>new M(D,j,J))}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Nj=M;class G{static create(D,X,J=null){return U(X,j=>new G(D,j,J))}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Oj=G;class V{static create(D,X,J=null){return U(X,j=>new V(D,j,J))}constructor(D,X,J){this.c=D,this.d=X,this.f=J,this.type=d.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Pj=V;class _{static create(D,X){return new _(D,X)}constructor(D,X){this.d=D,this.f=X,this.type=d.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const X=this.f?this.f.source:"",J=D.f?D.f.source:"";return X<J?-1:X>J?1:0}equals(D){if(D.type===this.type){const X=this.f?this.f.source:"",J=D.f?D.f.source:"";return this.d===D.d&&X===J}return!1}substituteConstants(){return this}evaluate(D){const X=D.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Qj=_;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=d.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Rj=H;function ie(q){let D=null;for(let X=0,J=q.length;X<J;X++){const j=q[X].substituteConstants();if(q[X]!==j&&D===null){D=[];for(let W=0;W<X;W++)D[W]=q[W]}D!==null&&(D[X]=j)}return D===null?q:D}class B{static create(D,X,J){return B.d(D,X,J)}constructor(D,X){this.expr=D,this.c=X,this.type=d.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let X=0,J=this.expr.length;X<J;X++){const j=s(this.expr[X],D.expr[X]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let X=0,J=this.expr.length;X<J;X++)if(!this.expr[X].equals(D.expr[X]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:B.create(D,this.c,!1)}evaluate(D){for(let X=0,J=this.expr.length;X<J;X++)if(!this.expr[X].evaluate(D))return!1;return!0}static d(D,X,J){const j=[];let W=!1;for(const Y of D)if(Y){if(Y.type===d.True){W=!0;continue}if(Y.type===d.False)return r.INSTANCE;if(Y.type===d.And){j.push(...Y.expr);continue}j.push(Y)}if(j.length===0&&W)return a.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(s);for(let Y=1;Y<j.length;Y++)j[Y-1].equals(j[Y])&&(j.splice(Y,1),Y--);if(j.length===1)return j[0];for(;j.length>1;){const Y=j[j.length-1];if(Y.type!==d.Or)break;j.pop();const Z=j.pop(),se=j.length===0,ce=z.create(Y.expr.map(me=>B.create([me,Z],null,J)),null,se);ce&&(j.push(ce),j.sort(s))}if(j.length===1)return j[0];if(J){for(let Y=0;Y<j.length;Y++)for(let Z=Y+1;Z<j.length;Z++)if(j[Y].negate().equals(j[Z]))return r.INSTANCE;if(j.length===1)return j[0]}return new B(j,X)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const X of this.expr)D.push(...X.keys());return D}map(D){return new B(this.expr.map(X=>X.map(D)),null)}negate(){if(!this.c){const D=[];for(const X of this.expr)D.push(X.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Sj=B;class z{static create(D,X,J){return z.d(D,X,J)}constructor(D,X){this.expr=D,this.c=X,this.type=d.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let X=0,J=this.expr.length;X<J;X++){const j=s(this.expr[X],D.expr[X]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let X=0,J=this.expr.length;X<J;X++)if(!this.expr[X].equals(D.expr[X]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let X=0,J=this.expr.length;X<J;X++)if(this.expr[X].evaluate(D))return!0;return!1}static d(D,X,J){let j=[],W=!1;if(D){for(let Y=0,Z=D.length;Y<Z;Y++){const se=D[Y];if(se){if(se.type===d.False){W=!0;continue}if(se.type===d.True)return a.INSTANCE;if(se.type===d.Or){j=j.concat(se.expr);continue}j.push(se)}}if(j.length===0&&W)return r.INSTANCE;j.sort(s)}if(j.length!==0){if(j.length===1)return j[0];for(let Y=1;Y<j.length;Y++)j[Y-1].equals(j[Y])&&(j.splice(Y,1),Y--);if(j.length===1)return j[0];if(J){for(let Y=0;Y<j.length;Y++)for(let Z=Y+1;Z<j.length;Z++)if(j[Y].negate().equals(j[Z]))return a.INSTANCE;if(j.length===1)return j[0]}return new z(j,X)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const X of this.expr)D.push(...X.keys());return D}map(D){return new z(this.expr.map(X=>X.map(D)),null)}negate(){if(!this.c){const D=[];for(const X of this.expr)D.push(X.negate());for(;D.length>1;){const X=D.shift(),J=D.shift(),j=[];for(const W of K(X))for(const Y of K(J))j.push(B.create([W,Y],null,!1));D.unshift(z.create(j,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Tj=z;class ee extends h{static{this.d=[]}static all(){return ee.d.values()}constructor(D,X,J){super(D,null),this.f=X,typeof J=="object"?ee.d.push({...J,key:D}):J!==!0&&ee.d.push({key:D,description:J,type:X!=null?typeof X:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Uj=ee,e.$Vj=(0,N.$Di)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,X,J){return q<X?-1:q>X?1:D<J?-1:D>J?1:0}function te(q,D){if(q.type===d.False||D.type===d.True)return!0;if(q.type===d.Or)return D.type===d.Or?Q(q.expr,D.expr):!1;if(D.type===d.Or){for(const X of D.expr)if(te(q,X))return!0;return!1}if(q.type===d.And){if(D.type===d.And)return Q(D.expr,q.expr);for(const X of q.expr)if(te(X,D))return!0;return!1}return q.equals(D)}function Q(q,D){let X=0,J=0;for(;X<q.length&&J<D.length;){const j=q[X].cmp(D[J]);if(j<0)return!1;j===0&&X++,J++}return X===q.length}function K(q){return q.type===d.Or?q.expr:[q]}}),define(he[97],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Rm=e.ID=void 0,e.$Sm=c,e.ID="diagnosticsService",e.$Rm=(0,I.$Di)(e.ID);function c(A){return!!A.hostName&&!!A.errorMessage}class T{async getPerformanceInfo(N,O){return{}}async getSystemInfo(N,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,O){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.$Tm=T}),define(he[98],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0,e.$Zo=(0,I.$Di)("downloadService")}),define(he[15],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=void 0,e.$Ki=(0,I.$Di)("environmentService"),e.$Li=(0,I.$Ei)(e.$Ki)}),define(he[74],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$j7b=T;var c;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function T(N){switch(N){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var A;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$k7b=(0,I.$Di)("IExtensionRecommendationNotificationService")}),define(he[7],ue([0,1,51,13,26,12,9,11,4,5,22,53]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=d,e.$al=E,e.$bl=w,e.$cl=P,e.$dl=p,e.$el=o,e.$fl=u,e.$gl=i,e.$hl=n,e.$il=t,e.$jl=s,e.$ll=h,e.$ml=y,e.$nl=L,e.$ol=S,e.$pl=v,e.$sl=G,e.$El=z,e.$Fl=ee,e.$Hl=le,e.$$k=(0,k.$Di)("fileService");function d(te){return te.create===!0}var g;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var m;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function E(te){const Q=te;return!!Q&&typeof Q.onDidChange=="function"}var f;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(te){return!!(te.capabilities&f.FileReadWrite)}function P(te){return!!(te.capabilities&f.FileFolderCopy)}function p(te){return!!(te.capabilities&f.FileClone)}function o(te){return!!(te.capabilities&f.FileOpenReadWriteClose)}function u(te){return!!(te.capabilities&f.FileReadStream)}function i(te){return w(te)?!!(te.capabilities&f.FileAtomicRead):!1}function n(te){return w(te)?!!(te.capabilities&f.FileAtomicWrite):!1}function t(te){return!!(te.capabilities&f.FileAtomicDelete)}function s(te){return!!(te.capabilities&f.Readonly)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class a extends Error{static create(Q,K){const q=new a(Q.toString(),K);return L(q,K),q}constructor(Q,K){super(Q),this.code=K}}e.$kl=a;function h(te,Q){return a.create(te,Q)}function y(te){return te||h((0,O.localize)(11330,null),r.Unknown)}function L(te,Q){return te.name=Q?`${Q} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return r.Unknown;if(te instanceof a)return te.code;const Q=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Q)return r.Unknown;switch(Q[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(te){if(te instanceof V)return te.fileOperationResult;switch(S(te)){case r.FileNotFound:return ie.FILE_NOT_FOUND;case r.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case r.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case r.NoPermissions:return ie.FILE_PERMISSION_DENIED;case r.FileExists:return ie.FILE_MOVE_CONFLICT;case r.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var C;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class U{constructor(Q,K,q){this.resource=Q,this.operation=K,this.target=q}isOperation(Q){return this.operation===Q}}e.$ql=U;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(Q,K){this.c=K,this.b=void 0,this.d=new $.$T(()=>{const q=I.$Ji.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new $.$T(()=>{const q=I.$Ji.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new $.$T(()=>{const q=I.$Ji.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Q){switch(q.type){case F.ADDED:this.rawAdded.push(q.resource);break;case F.UPDATED:this.rawUpdated.push(q.resource);break;case F.DELETED:this.rawDeleted.push(q.resource);break}this.b!==M.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Q,...K){return this.h(Q,{includeChildren:!1},...K)}affects(Q,...K){return this.h(Q,{includeChildren:!0},...K)}h(Q,K,...q){if(!Q)return!1;const D=q.length>0;return!!((!D||q.includes(F.ADDED))&&(this.d.value.get(Q)||K.includeChildren&&this.d.value.findSuperstr(Q))||(!D||q.includes(F.UPDATED))&&(this.f.value.get(Q)||K.includeChildren&&this.f.value.findSuperstr(Q))||(!D||q.includes(F.DELETED))&&(this.g.value.findSubstr(Q)||K.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}e.$rl=M;function G(te,Q,K){return!te||!Q||te===Q||Q.length>te.length?!1:(Q.charAt(Q.length-1)!==c.sep&&(Q+=c.sep),K?(0,T.$Ff)(te,Q):te.indexOf(Q)===0)}class V extends Error{constructor(Q,K,q){super(Q),this.fileOperationResult=K,this.options=q}}e.$tl=V;class _ extends V{constructor(Q,K,q,D){super(Q,K,D),this.fileOperationResult=K,this.size=q}}e.$ul=_;class H extends V{constructor(Q,K,q){super(Q,ie.FILE_NOT_MODIFIED_SINCE,q),this.stat=K}}e.$vl=H;var ie;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var B;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Dl="";function z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ee(te,Q){if(!Q.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(K=>{const q=Q.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===te.scheme&&D.added&&(q.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Q){return(0,A.$hg)(Q)||(Q=0),Q<ne.KB?(0,O.localize)(11331,null,Q.toFixed(0)):Q<ne.MB?(0,O.localize)(11332,null,(Q/ne.KB).toFixed(2)):Q<ne.GB?(0,O.localize)(11333,null,(Q/ne.MB).toFixed(2)):Q<ne.TB?(0,O.localize)(11334,null,(Q/ne.GB).toFixed(2)):(0,O.localize)(11335,null,(Q/ne.TB).toFixed(2))}}e.$Gl=ne;function le(te){const Q=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*ne.MB:Q?10*ne.MB:b.$p?50*ne.MB:1024*ne.MB}});var x=this&&this.__param||function(ae,e){return function(I,c){e(I,c,ae)}};define(he[163],ue([0,1,75,50,7]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let A=class{constructor(O){this.a=O}async checksum(O){const k=(await this.a.readFileStream(O)).value;return new Promise((b,R)=>{const $=(0,I.createHash)("sha256");(0,c.$Ee)(k,{onData:d=>$.update(d.buffer),onError:d=>R(d),onEnd:()=>b($.digest("base64").replace(/=+$/,""))})})}};e.$2hc=A,e.$2hc=A=ve([x(0,T.$$k)],A)}),define(he[99],ue([0,1,14,8,11,7]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=N;async function N(R,$,d,g,l,m){let E;try{await O(R,$,d,g,l,m)}catch(f){E=f}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&d.error(E),d.end()}}async function O(R,$,d,g,l,m){k(m);const E=await R.open($,{create:!1});try{k(m);let f=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,p=I.$Me.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),o=l&&typeof l.position=="number"?l.position:0,u=0;do w=await R.read(E,o,p.buffer,u,p.byteLength-u),o+=w,u+=w,f+=w,typeof P=="number"&&(P-=w),u===p.byteLength&&(await d.write(g(p)),p=I.$Me.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),u=0);while(w>0&&(typeof P!="number"||P>0)&&k(m)&&b(f,l));if(u>0){let i=u;typeof P=="number"&&(i=Math.min(u,P)),d.write(g(p.slice(0,i)))}}catch(f){throw(0,A.$ml)(f)}finally{await R.close(E)}}function k(R){if(R.isCancellationRequested)throw(0,c.$5)();return!0}function b(R,$){if(typeof $?.limits?.size=="number"&&R>$.limits.size)throw(0,A.$ll)((0,T.localize)(11329,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],ue([0,1,93,2,13,5,9,7]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=void 0,e.$2q=k,e.$3q=b,e.$7q=g,e.$8q=l,e.$9q=m,e.$0q=E,e.$$q=w,e.$_q=P;function k(p){return typeof p.correlationId=="number"}function b(p){return p.recursive===!0}class R extends c.$Tc{static{this.a=5}constructor(o,u,i,n){super(),this.h=o,this.j=u,this.m=i,this.n=n,this.c=this.B(new c.$Uc),this.f=void 0,this.g=0}s(){const o=new c.$Sc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(u=>this.h(u))),o.add(this.b.onDidLogMessage(u=>this.j(u))),o.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(o,u){this.u(o,u)?this.g<R.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,u){return!(!this.n.restartOnError||u||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4q=R;class $ extends R{constructor(o,u,i){super(o,u,i,{type:"node.js",restartOnError:!1})}}e.$5q=$;class d extends R{constructor(o,u,i){super(o,u,i,{type:"universal",restartOnError:!0})}}e.$6q=d;function g(p){return p.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function l(p){const o=new f;for(const u of p)o.processEvent(u);return o.coalesce()}function m(p,o){return typeof o=="string"&&!o.startsWith(I.$uk)&&!(0,T.$hc)(o)?{base:p,pattern:o}:o}function E(p,o){const u=[];for(const i of o)u.push((0,I.$yk)(m(p,i)));return u}class f{constructor(){this.a=new Set,this.b=new Map}c(o){return A.$l?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const u=this.b.get(this.c(o));let i=!1;if(u){const n=u.type,t=o.type;u.resource.fsPath!==o.resource.fsPath&&(o.type===O.FileChangeType.DELETED||o.type===O.FileChangeType.ADDED)?i=!0:n===O.FileChangeType.ADDED&&t===O.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(u)):n===O.FileChangeType.DELETED&&t===O.FileChangeType.ADDED?u.type=O.FileChangeType.UPDATED:n===O.FileChangeType.ADDED&&t===O.FileChangeType.UPDATED||(u.type=t)}else i=!0;i&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],u=[];return Array.from(this.a).filter(i=>i.type!==O.FileChangeType.DELETED?(o.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>u.some(n=>(0,O.$sl)(i.resource.fsPath,n,!A.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(o)}}function w(p,o){if(typeof o=="number")switch(p.type){case O.FileChangeType.ADDED:return(o&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(o&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(o&O.FileChangeFilter.UPDATED)===0}return!1}function P(p){if(typeof p=="number"){const o=[];return p&O.FileChangeFilter.ADDED&&o.push("Added"),p&O.FileChangeFilter.DELETED&&o.push("Deleted"),p&O.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(he[164],ue([0,1,14,43,8,3,2,50,32,7,46]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=e.$mR=void 0,e.$mR="localFilesystem";class $ extends N.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$ke),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$ke),this.onDidWatchError=this.g.event,this.h=(0,k.$Zg)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,l){const{buffer:m}=await this.a.call("readFile",[g,l]);return m}readFileStream(g,l,m){const E=(0,O.$Ae)(w=>I.$Me.concat(w.map(P=>I.$Me.wrap(P))).buffer),f=new N.$Sc;return f.add(this.a.listen("readFileStream",[g,l])(w=>{if(w instanceof I.$Me)E.write(w.buffer);else{if(w==="end")E.end();else{let P;if(w instanceof Error)P=w;else{const p=w;P=(0,b.$ll)(p.message??(0,c.$oj)(p),p.code??b.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{E.error((0,T.$5)()),E.end(),f.dispose()})),E}writeFile(g,l,m){return this.a.call("writeFile",[g,I.$Me.wrap(l),m])}open(g,l){return this.a.call("open",[g,l])}close(g){return this.a.call("close",[g])}async read(g,l,m,E,f){const[w,P]=await this.a.call("read",[g,l,f]);return m.set(w.buffer.slice(0,P),E),P}write(g,l,m,E,f){return this.a.call("write",[g,l,I.$Me.wrap(m),E,f])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,l){return this.a.call("delete",[g,l])}rename(g,l,m){return this.a.call("rename",[g,l,m])}copy(g,l,m){return this.a.call("copy",[g,l,m])}cloneFile(g,l){return this.a.call("cloneFile",[g,l])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const l=g;this.f.fire((0,R.$7q)(l))}else{const l=g;this.g.fire(l)}}))}watch(g,l){const m=(0,k.$Zg)();return this.a.call("watch",[this.h,m,g,l]),(0,N.$Rc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$nR=$}),define(he[165],ue([0,1,33,2,46,3,7,9,6]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class b extends c.$Tc{constructor(){super(),this.a=this.B(new A.$ke),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$ke),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$ke),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$3c),this.m=new Set,this.n=this.B(new k.$Bh(this.y())),this.r=5007,this.s=new k.$1h,this.R=!1,this.B(this.f($=>this.t($)))}t($){this.u($)&&this.z($)}u($){return(0,T.$2q)($)}async watch($){this.s.isSettled||this.s.complete(),this.s=new k.$1h;try{this.h.clear(),this.g.clear();for(const d of $)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w($){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),$?this.y():0)}y(){return 800}isSuspended($){return typeof $.correlationId!="number"?!1:this.m.has($.correlationId)?"polling":this.j.has($.correlationId)}async z($){if(this.j.has($.correlationId))return;const d=new c.$Sc;this.j.set($.correlationId,d),await this.s.p,!d.isDisposed&&(this.D($,d),this.w(!0))}C($){this.j.deleteAndDispose($.correlationId),this.m.delete($.correlationId),this.w(!1)}D($,d){this.F($,d)?(this.P(`reusing an existing recursive watcher to monitor ${$.path}`),this.m.delete($.correlationId)):(this.G($,d),this.m.add($.correlationId))}F($,d){const g=this.O?.subscribe($.path,(l,m)=>{d.isDisposed||(l?this.D($,d):m?.type===N.FileChangeType.ADDED&&this.H($))});return g?(d.add(g),!0):!1}G($,d){let g=!1;const l=(m,E)=>{if(d.isDisposed)return;const f=this.I(m),w=this.I(E),P=g;g=f,!f&&(w||P)&&this.H($)};this.P(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,I.watchFile)($.path,{persistent:!1,interval:this.r},l)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}d.add((0,c.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,I.unwatchFile)($.path,l)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}H($){this.P(`detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const d={resource:O.URI.file($.path),type:N.FileChangeType.ADDED,cId:$.correlationId};this.a.fire([d]),this.J(d,$),this.C($)}I($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J($,d){if(this.R){const g=` >> normalized ${$.type===N.FileChangeType.ADDED?"[ADDED]":$.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.L(g,d)}}L($,d){this.R&&this.P(`${$}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, filter: ${(0,T.$_q)($.filter)}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}async setVerboseLogging($){this.R=$}}e.$ir=b}),define(he[166],ue([0,1,33,6,25,41,2,90,13,5,20,9,146,30,7,46]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0,e.$or=f;class E extends N.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,p,o,u,i,n){super(),this.s=P,this.t=p,this.u=o,this.w=u,this.y=i,this.z=n,this.c=this.B(new c.$Sh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new c.$Rh(t=>this.M(t),E.b)),this.g=(0,m.$0q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$0q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$2q)(this.s)?this.s.filter:void 0,this.m=new T.$ve,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const p=await I.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,p.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let p=P.path;try{p=await g.Promises.realpath(P.path),P.path===p&&(p=await(0,d.$kr)(P.path,this.m.token)??P.path),P.path!==p&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${p})`)}catch{}return p}async G(P,p){const o=new N.$Sc;return this.H(P,p,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,p,o)),o}H(P,p,o){if(p)return!1;const u=$.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!o.isDisposed)if(n){const s=await this.G(P,p);o.isDisposed?s.dispose():o.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:t.type,cId:this.s.correlationId},!0)});return i?(o.add(i),!0):!1}async I(P,p,o){if(b.$k&&(0,A.$Cg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new T.$ve(this.m.token);o.add((0,N.$Rc)(()=>u.dispose(!0)));const i=new N.$Sc;o.add(i);try{const n=$.URI.file(this.s.path),t=(0,k.$mc)(P),s=(0,I.watch)(P);i.add((0,N.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(p)try{for(const h of await g.Promises.readdir(P))r.add(h)}catch(h){this.O(h)}if(u.token.isCancellationRequested)return;const a=new Map;i.add((0,N.$Rc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),s.on("error",(h,y)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${h}, ${y})`),this.D())}),s.on("change",(h,y)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${h}"] ${y}`);let L="";if(y&&(L=y.toString(),b.$k&&(L=(0,O.$lm)(L))),!(!L||h!=="change"&&h!=="rename"))if(p)if(h==="rename"){a.get(L)?.dispose();const S=setTimeout(async()=>{if(a.delete(L),L===t&&!await g.Promises.exists(P)){this.J(n);return}if(u.token.isCancellationRequested)return;const v=await this.N((0,k.$ic)(P,L));if(u.token.isCancellationRequested)return;let C;v?r.has(L)?C=l.FileChangeType.UPDATED:(C=l.FileChangeType.ADDED,r.add(L)):(r.delete(L),C=l.FileChangeType.DELETED),this.L({resource:(0,R.$eh)(n,L),type:C,cId:this.s.correlationId})},E.a);a.set(L,(0,N.$Rc)(()=>clearTimeout(S)))}else{let S;r.has(L)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(L)),this.L({resource:(0,R.$eh)(n,L),type:S,cId:this.s.correlationId})}else if(h==="rename"||L!==t){const S=setTimeout(async()=>{const v=await g.Promises.exists(P);u.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,N.$Rc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){u.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,p=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!p&&this.g.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!p&&this.h&&this.h.length>0&&!this.h.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const p=(0,m.$8q)(P),o=[];for(const i of p){if((0,m.$$q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}o.push(i)}if(o.length===0)return;if(this.z)for(const i of o)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(b.$l)return g.Promises.exists(P);try{const p=(0,k.$mc)(P);return(await g.Promises.readdir((0,k.$lc)(P))).some(u=>u===p)}catch(p){return this.Q(p),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$nr=E;async function f(w,P,p,o,u=512){const i=await g.Promises.open(w,"r"),n=Buffer.allocUnsafe(u),t=new T.$ve(o);let s,r=!1;const a={path:w,excludes:[],recursive:!1},h=new E(a,void 0,y=>{(async()=>{for(const{type:L}of y)if(L===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await g.Promises.read(i,n,0,u,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await h.ready,p(),new Promise((y,L)=>{t.token.onCancellationRequested(async()=>{h.dispose();try{await g.Promises.close(i)}catch(S){s=new Error(S)}s?L(s):y()})})}}),define(he[167],ue([0,1,3,93,165,5,166,41]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class k extends T.$ir{constructor(R){super(),this.O=R,this.onDidError=I.Event.None,this.watchers=new Set}async N(R){R=this.Z(R);const $=[],d=new Set(Array.from(this.watchers));for(const g of R){const l=this.W(g);l&&(0,c.$Ck)(l.request.excludes,g.excludes)&&(0,c.$Ck)(l.request.includes,g.includes)?d.delete(l):$.push(g)}$.length&&this.P(`Request to start watching: ${$.map(g=>this.M(g)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(g=>this.M(g.request)).join(",")}`);for(const g of d)this.Y(g);for(const g of $)this.X(g)}W(R){for(const $ of this.watchers)if(typeof R.correlationId=="number"||typeof $.request.correlationId=="number"){if($.request.correlationId===R.correlationId)return $}else if((0,O.$Bg)($.request.path,R.path,!A.$l))return $}X(R){const $=new N.$nr(R,this.O,g=>this.a.fire(g),()=>this.c.fire(R),g=>this.b.fire(g),this.R),d={request:R,instance:$};this.watchers.add(d)}async stop(){await super.stop();for(const R of this.watchers)this.Y(R)}Y(R){this.P("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}Z(R){const $=new Map;for(const d of R){const g=A.$l?d.path:d.path.toLowerCase();let l=$.get(d.correlationId);l||(l=new Map,$.set(d.correlationId,l)),l.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),l.set(g,d)}return Array.from($.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const $ of this.watchers)$.instance.setVerboseLogging(R)}P(R,$){this.R&&this.b.fire({type:"trace",message:this.bb(R,$)})}Q(R){this.b.fire({type:"warn",message:this.bb(R)})}bb(R,$){return $?`[File Watcher (node.js)] ${R} (${this.M($.request)})`:`[File Watcher (node.js)] ${R}`}}e.$pr=k}),define(he[168],ue([0,1,46,167]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class T extends I.$5q{constructor(N,O,k){super(N,O,k),this.s()}r(N){return N.add(new c.$pr(void 0))}}e.$qr=T}),define(he[169],ue([0,1,22,42,95,46]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class N extends A.$6q{constructor(k,b,R){super(k,b,R),this.s()}r(k){const b=k.add(new T.$gr(I.$Xg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(b.onDidProcessExit(({code:R,signal:$})=>this.t(`terminated by itself with code ${R}, signal: ${$} (ETERM)`))),c.ProxyChannel.toService((0,c.$ki)(b.getChannel("watcher")))}}e.$hr=N}),define(he[76],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class I{constructor(...T){this.a=new Map;for(const[A,N]of T)this.set(A,N)}set(T,A){const N=this.a.get(T);return this.a.set(T,A),N}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.$Bi=I}),define(he[170],ue([0,1,6,8,2,73,161,4,76,89]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const R=!1;class $ extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class d{constructor(E=new k.$Bi,f=!1,w,P=R){this.i=E,this.j=f,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Ci,this),this._globalGraph=P?w?._globalGraph??new N.$tr(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,T.$Oc)(this.h),this.h.clear();for(const E of this.g)(0,T.$Nc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,f){this.m();const w=this,P=new class extends d{dispose(){w.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),f?.add(P),P}invokeFunction(E,...f){this.m();const w=l.traceInvocation(this.l,E);let P=!1;try{return E({get:o=>{if(P)throw(0,c.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(o,w);if(!u)throw new Error(`[invokeFunction] unknown service '${o}'`);return u}},...f)}finally{P=!0,w.stop()}}createInstance(E,...f){this.m();let w,P;return E instanceof A.$Ai?(w=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(f),w)):(w=l.traceCreation(this.l,E),P=this.o(E,f,w)),w.stop(),P}o(E,f=[],w){const P=O._util.getServiceDependencies(E).sort((u,i)=>u.index-i.index),p=[];for(const u of P){const i=this.s(u.id,w);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${u.id}.`,!1),p.push(i)}const o=P.length>0?P[0].index:f.length;if(f.length!==o){console.trace(`[createInstance] First service dependency of ${E.name} at position ${o+1} conflicts with ${f.length} static arguments`);const u=o-f.length;u>0?f=f.concat(new Array(u)):f=f.slice(0,o)}return Reflect.construct(E,f.concat(p))}q(E,f){if(this.i.get(E)instanceof A.$Ai)this.i.set(E,f);else if(this.k)this.k.q(E,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const f=this.i.get(E);return!f&&this.k?this.k.r(E):f}s(E,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const w=this.r(E);return w instanceof A.$Ai?this.u(E,w,f.branch(E,!0)):(f.branch(E,!1),w)}u(E,f,w){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,f,w)}finally{this.t.delete(E)}}v(E,f,w){const P=new N.$tr(i=>i.id.toString());let p=0;const o=[{id:E,desc:f,_trace:w}],u=new Set;for(;o.length;){const i=o.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),P.lookupOrInsertNode(i),p++>1e3)throw new $(P);for(const n of O._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof A.$Ai){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),o.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new $(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof A.$Ai){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,f,w=[],P,p){if(this.i.get(E)instanceof A.$Ai)return this.x(E,f,w,P,p,this.g);if(this.k)return this.k.w(E,f,w,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(E,f,w=[],P,p,o){if(P){const u=new d(void 0,this.j,this,this.l);u.c=String(E);const i=new Map,n=new I.$Wh(()=>{const t=u.o(f,w,p);for(const[s,r]of i){const a=t[s];if(typeof a=="function")for(const h of r)h.disposable=a.apply(t,h.listener)}return i.clear(),o.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=i.get(s);return h||(h=new b.$4c,i.set(s,h)),(L,S,v)=>{if(n.isInitialized)return n.value[s](L,S,v);{const C={listener:[L,S,v],disposable:void 0},U=h.push(C);return(0,T.$Rc)(()=>{U(),C.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let a=r[s];return typeof a!="function"||(a=a.bind(r),t[s]=a),a},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return f.prototype}})}else{const u=this.o(f,w,p);return o.add(u),u}}y(E,f){if(f&&console.warn(E),this.j)throw new Error(E)}}e.$ur=d;var g;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(g||(g={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,f){return E?new l(g.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,f){return E?new l(g.Creation,f.name):l.c}static{this.f=0}constructor(E,f){this.type=E,this.name=f,this.g=Date.now(),this.h=[]}branch(E,f){const w=new l(g.Branch,E.toString());return this.h.push([E,f,w]),w}stop(){const E=Date.now()-this.g;l.f+=E;let f=!1;function w(p,o){const u=[],i=new Array(p+1).join("	");for(const[n,t,s]of o.h)if(t&&s){f=!0,u.push(`${i}CREATES -> ${n}`);const r=w(p+1,s);r&&u.push(r)}else u.push(`${i}uses -> ${n}`);return u.join(`
`)}const P=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||f)&&l.all.add(P.join(`
`))}}e.$vr=l}),define(he[56],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0,e.$Ehc=(0,I.$Di)("mainProcessService");class c{constructor(A,N){this.a=A,this.b=N}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,N){this.a.registerChannel(A,N)}}e.$Fhc=c}),define(he[10],ue([0,1,11,43,3,55,2,31,5,20,12,9,96,4]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=m,e.log=f,e.$mk=a,e.$nk=h,e.$ok=y,e.$pk=L,I=Pe(I),e.$$j=(0,g.$Di)("logService"),e.$_j=(0,g.$Di)("loggerService");function l(){return new Date().toISOString()}function m(S){return(0,R.$hg)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$bk=E.Info;function f(S,v,C){switch(v){case E.Trace:S.trace(C);break;case E.Debug:S.debug(C);break;case E.Info:S.info(C);break;case E.Warning:S.warn(C);break;case E.Error:S.error(C);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function w(S,v=!1){let C="";for(let U=0;U<S.length;U++){let F=S[U];if(F instanceof Error&&(F=(0,c.$oj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}C+=(U>0?" ":"")+F}return C}class P extends N.$Tc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new T.$ke),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$dk=P;class p extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(E.Trace)&&this.g(E.Trace,w([v,...C],!0))}debug(v,...C){this.f(E.Debug)&&this.g(E.Debug,w([v,...C]))}info(v,...C){this.f(E.Info)&&this.g(E.Info,w([v,...C]))}warn(v,...C){this.f(E.Warning)&&this.g(E.Warning,w([v,...C]))}error(v,...C){if(this.f(E.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(E.Error,w(U))}else this.g(E.Error,w([v,...C]))}flush(){}}e.$ek=p;class o extends P{constructor(v=e.$bk){super(),this.setLevel(v),this.g=!k.$j}trace(v,...C){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}debug(v,...C){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}info(v,...C){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}warn(v,...C){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...C):console.warn(`[main ${l()}]`,v,...C))}error(v,...C){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...C):console.error(`[main ${l()}]`,v,...C))}flush(){}}e.$fk=o;class u extends P{constructor(v=e.$bk,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}flush(){}}e.$gk=u;class i extends P{constructor(v,C=e.$bk){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...C])}debug(v,...C){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...C])}info(v,...C){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...C])}warn(v,...C){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...C])}error(v,...C){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,c.$oj)(v,this.f(E.Trace))}flush(){}}e.$hk=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const U of this.g)U.trace(v,...C)}debug(v,...C){for(const U of this.g)U.debug(v,...C)}info(v,...C){for(const U of this.g)U.info(v,...C)}warn(v,...C){for(const U of this.g)U.warn(v,...C)}error(v,...C){for(const U of this.g)U.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$ik=n;class t extends N.$Tc{constructor(v,C,U){if(super(),this.h=v,this.j=C,this.b=new O.$zc,this.c=this.B(new T.$ke),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$ke),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$ke),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,R.$dg)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const U=this.n(v),F=(0,R.$dg)(v)?v:C?.id??(0,A.$rj)(U.toString()).toString(16);let M=this.b.get(U)?.logger;const G=C?.logLevel==="always"?E.Trace:C?.logLevel;M||(M=this.s(U,G??this.getLogLevel(U)??this.h,{...C,id:F}));const V={logger:M,info:{resource:U,id:F,logLevel:G,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(V.info),this.b.set(U,V),M}n(v){return(0,R.$dg)(v)?(0,b.$eh)(this.j,`${v}.log`):v}setLogLevel(v,C){if($.URI.isUri(v)){const U=v,F=C,M=this.b.get(U);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const U=this.m(v);U&&C!==!U.info.hidden&&(U.info.hidden=!C,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=t;class s{constructor(){this.onDidChangeLogLevel=new T.$ke().event}setLevel(v){}getLevel(){return E.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$kk=s;class r extends s{}e.$lk=r;function a(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=L(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$bk}function h(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function y(S){switch(S){case E.Trace:return{original:"Trace",value:I.localize(11263,null)};case E.Debug:return{original:"Debug",value:I.localize(11264,null)};case E.Info:return{original:"Info",value:I.localize(11265,null)};case E.Warning:return{original:"Warning",value:I.localize(11266,null)};case E.Error:return{original:"Error",value:I.localize(11267,null)};case E.Off:return{original:"Off",value:I.localize(11268,null)}}}function L(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$qk=new d.$Uj("logLevel",h(E.Info))}),define(he[171],ue([0,1,6,8,2,22,13,20,30,15,10]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let $=class extends T.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.B(new I.$Ph(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const g=(0,O.$bh)(this.a.logsHome),l=(0,O.$dh)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,f=(await k.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==g),w=f.slice(0,Math.max(0,f.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>k.Promises.rm((0,N.$ic)(l,P)))))}catch(g){(0,c.$Y)(g)}}};e.$Yhc=$,e.$Yhc=$=ve([x(0,b.$Ki),x(1,R.$$j)],$)}),define(he[172],ue([0,1,17,6,8,3,41,2,13,46,10]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class $ extends O.$Tc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new A.$ke),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ke),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Bh(0)),this.w=[],this.y=this.B(new c.$Bh(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,I.$Sb)(this.j,m);return this.r(),(0,O.$Rc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,T.$Y)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$7q)(l)),l=>this.G(l),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,b.$3q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,b.$3q)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,I.$Sb)(this.w,m);return this.C(),(0,O.$Rc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,T.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,b.$7q)(g)),g=>this.G(g),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,k.$gc)(g.fsPath)}J(g){const l=this.I(g);return(0,N.$Fg)(l)}}e.$ar=$}),define(he[173],ue([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let o=class extends b.$Tc{static{p=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new N.$ke),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$ke),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$ke),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$ke),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$ke),this.Y=this.B(new N.$ke),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$ke),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Mh)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const t=new b.$Sc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$rl(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,b.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,b.$Oc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await c.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,g.$ih)(i))throw new E.$tl((0,m.localize)(11336,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$ab;throw t.message=(0,m.localize)(11337,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$el)(n)||(0,E.$bl)(n)||(0,E.$fl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$el)(n)||(0,E.$bl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$ol)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$tl((0,m.localize)(11338,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$ml)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,y=await t.stat(i);let L;return this.t(t,i,y,void 0,!!h,(S,v)=>(L||(L=R.$Ji.forUris(()=>!s),L.set(i,!0),r&&L.fill(!0,r)),L.get(S.resource)||L.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?v===1:!1))}async t(i,n,t,s,r,a){const{providerExtUri:h}=this.R(i),y={resource:n,name:h.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$El)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&a(y,s)){try{const L=await i.readdir(n),S=await c.Promises.settled(L.map(async([v,C])=>{try{const U=h.joinPath(n,v),F=r?await i.stat(U):{type:C};return await this.t(i,U,F,L.length,r,a)}catch(U){return this.b.trace(U),null}}));y.children=(0,I.$Gb)(S)}catch(L){this.b.trace(L),y.children=[]}return y}return y}async resolveAll(i){return c.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$tl((0,m.localize)(11339,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=T.$Me.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$ql(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let a=t;if((0,E.$hl)(s)&&!a?.atomic){const h=s.enforceAtomicWriteFile?.(i);h&&(a={...t,atomic:h})}try{await this.w(s,i,a)||await this.U(s,r.dirname(i));let y;if((0,E.$bl)(s)&&!(n instanceof T.$Me))if((0,l.$ye)(n)){const L=await(0,l.$Fe)(n,3);L.ended?y=T.$Me.concat(L.buffer):y=L}else y=(0,l.$Ce)(n,L=>T.$Me.concat(L),3);else y=n;!(0,E.$el)(s)||(0,E.$bl)(s)&&y instanceof T.$Me||(0,E.$bl)(s)&&(0,E.$hl)(s)&&a?.atomic?await this.hb(s,i,a,y):await this.db(s,i,a,y instanceof T.$Me?(0,T.$Xe)(y):y),this.r.fire(new E.$ql(i,E.FileOperation.WRITE))}catch(h){throw new E.$tl((0,m.localize)(11340,null,this.sb(i),(0,E.$ml)(h).toString()),(0,E.$pl)(h),a)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(11341,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(11342,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(11343,null,this.sb(n)));if(s)throw new Error((0,m.localize)(11344,null,this.sb(n)))}let a;try{a=await i.stat(n)}catch{return}if(a.type&E.FileType.Directory)throw new E.$tl((0,m.localize)(11345,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,a),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Dl&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==(0,E.$El)({mtime:t.mtime,size:a.size}))throw new E.$tl((0,m.localize)(11346,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return a}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const h=await this.C(i,n,t,s);r(h)}catch(h){a(h)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,T.$Ye)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new A.$ve(s);let a=t;(0,E.$gl)(i)&&i.enforceAtomicReadFile?.(n)&&(a={...t,atomic:!0});const h=this.J(n,a).then(L=>L,L=>{throw r.dispose(!0),L});let y;try{return typeof a?.etag=="string"&&a.etag!==E.$Dl&&await h,a?.atomic&&(0,E.$gl)(i)||!((0,E.$el)(i)||(0,E.$fl)(i))||(0,E.$bl)(i)&&a?.preferUnbuffered?y=this.I(i,n,a):(0,E.$fl)(i)?y=this.G(i,n,r.token,a):y=this.H(i,n,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await h,value:y}}catch(L){throw y&&await(0,l.$De)(y),this.F(L,n,a)}}F(i,n,t){const s=(0,m.localize)(11347,null,this.sb(n),(0,E.$ml)(i).toString());return i instanceof E.$vl?new E.$vl(s,i.stat,t):i instanceof E.$ul?new E.$ul(s,i.fileOperationResult,i.size,i.options):new E.$tl(s,(0,E.$pl)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Je)(r,{data:a=>a instanceof T.$Me?a:T.$Me.wrap(a),error:a=>this.F(a,n,s)},a=>T.$Me.concat(a))}H(i,n,t,s=Object.create(null)){const r=(0,T.$3e)();return(0,f.$Zq)(i,n,r,a=>a,{...s,bufferSize:this.a,errorTransformer:a=>this.F(a,n,s)},t),r}I(i,n,t){const s=(0,l.$Ae)(r=>T.$Me.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$gl)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(T.$Me.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$tl((0,m.localize)(11348,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Dl&&n.etag===t.etag)throw new E.$vl((0,m.localize)(11349,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$ul((0,m.localize)(11350,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),a=this.qb(await this.n(n),n);await this.Q(r,i,a,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),a=await this.N(s,i,r,n,"move",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$ql(i,a==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,h)),h}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),a=await this.N(s,i,r,n,"copy",!!t),h=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$ql(i,a==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,h)),h}async N(i,n,t,s,r,a){if(n.toString()===s.toString())return r;const{exists:h,isSameResourceWithDifferentPathCase:y}=await this.Q(i,n,t,s,r,a);if(h&&!y&&a&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$cl)(i))await i.copy(n,s,{overwrite:a});else{const L=await this.resolve(n);L.isDirectory?await this.P(i,L,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:a}),r):(await this.N(i,n,t,s,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$el)(i)&&(0,E.$el)(t))return this.jb(i,n,t,s);if((0,E.$el)(i)&&(0,E.$bl)(t))return this.pb(i,n,t,s);if((0,E.$bl)(i)&&(0,E.$el)(t))return this.nb(i,n,t,s);if((0,E.$bl)(i)&&(0,E.$bl)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await c.Promises.settled(n.children.map(async r=>{const a=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,a):this.O(i,r.resource,t,a)}))}async Q(i,n,t,s,r,a){let h=!1;if(i===t){const{providerExtUri:L,isPathCaseSensitive:S}=this.R(i);if(S||(h=L.isEqual(n,s)),h&&r==="copy")throw new Error((0,m.localize)(11351,null,this.sb(n),this.sb(s)));if(!h&&L.isEqualOrParent(s,n))throw new Error((0,m.localize)(11352,null,this.sb(n),this.sb(s)))}const y=await this.exists(s);if(y&&!h){if(!a)throw new E.$tl((0,m.localize)(11353,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(n,s))throw new Error((0,m.localize)(11354,null,this.sb(n),this.sb(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:h}}R(i){const n=this.S(i);return{providerExtUri:n?g.$7g:g.$9g,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$ql(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,m.localize)(11355,null,this.sb(n)));break}catch(r){if((0,E.$ol)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(a){if((0,E.$ol)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(11356,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(11357,null,this.sb(i)));if(s&&r)throw new Error((0,m.localize)(11358,null,this.sb(i)));let a;try{a=await t.stat(i)}catch{}if(a)this.rb(i,a);else throw new E.$tl((0,m.localize)(11359,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,m.localize)(11360,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$il)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,a=!!s?.recursive,h=s?.atomic??!1;await t.delete(i,{recursive:a,useTrash:r,atomic:h}),this.r.fire(new E.$ql(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$dl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$cl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:p.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new b.$Sc;let s=!1,r=()=>{s=!0};t.add((0,b.$Rc)(()=>r())),(async()=>{try{const h=await this.bb(i,n);s?(0,b.$Oc)(h):r=()=>(0,b.$Oc)(h)}catch(h){this.b.error(h)}})();const a=n.correlationId;if(typeof a=="number"){const h=t.add(new N.$ke);return t.add(this.X.event(L=>{L.correlates(a)&&h.fire(L)})),{onDidChange:h.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,O.$rj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,b.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Oc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Oc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$ye)(s)||(0,l.$ze)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(a){throw(0,E.$ml)(a)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$ze)(t)){if(t.buffer.length>0){const a=T.$Me.concat(t.buffer);await this.gb(i,n,a,a.byteLength,s,0),s+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,h)=>{(0,l.$Ee)(r,{onData:async y=>{r.pause();try{await this.gb(i,n,y,y.byteLength,s,0)}catch(L){return h(L)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>h(y),onEnd:()=>a()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,a){let h=0;for(;h<s;){const y=await i.write(n,r+h,t.buffer,a+h,s-h);h+=y}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof T.$Me?r=s:(0,l.$ye)(s)?r=await(0,T.$Ye)(s):(0,l.$ze)(s)?r=await(0,T.$Ze)(s):r=(0,T.$We)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,a;try{r=await i.open(n,{create:!1}),a=await t.open(s,{create:!0,unlock:!1});const h=T.$Me.alloc(this.a);let y=0,L=0,S=0;do S=await i.read(r,y,h.buffer,L,h.byteLength-L),await this.gb(t,a,h,S,y,L),y+=S,L+=S,L===h.byteLength&&(L=0);while(S>0)}catch(h){throw(0,E.$ml)(h)}finally{await c.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const a=await i.readFile(n);await this.gb(t,r,T.$Me.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.$ml)(a)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,T.$Ye)(this.H(i,n,A.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$tl((0,m.localize)(11361,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$tl((0,m.localize)(11362,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}};e.$1q=o,e.$1q=o=p=ve([x(0,w.$$j)],o)}),define(he[174],ue([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,99,172,169,168]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class p extends f.$ar{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=N.Event.None,this.P=new T.$zc(n=>$.$8g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,R.$l&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(u));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await g.Promises.readdir(this.I(u),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,$.$eh)(u,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(u,i){let n;return i?.dangling?n=m.FileType.Unknown:u.isFile()?n=m.FileType.File:u.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new c.$Ch;return this.P.set(u,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,k.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(u,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),n=await this.Q(u));const t=this.I(u);return await I.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(u){p.L&&this.a.trace(u)}readFileStream(u,i,n){const t=(0,d.$Ae)(s=>A.$Me.concat(s.map(r=>A.$Me.wrap(r))).buffer);return(0,E.$Zq)(this,u,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(u,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(u)?this.U(u,(0,$.$eh)((0,$.$dh)(u),`${(0,$.$bh)(u)}${n.atomic.postfix}`),i,n):this.W(u,i,n)}async S(u){try{const i=this.I(u),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(u,i,n,t){const s=new k.$Sc;try{s.add(await this.Q(u)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,u,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(u,i,n,t){let s;try{const r=this.I(u);if(!n.create||!n.overwrite){if(await g.Promises.exists(r)){if(!n.overwrite)throw(0,m.$ll)((0,l.localize)(11320,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$ll)((0,l.localize)(11321,null),m.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(u,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(u,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(u){p.$=u}async open(u,i,n){const t=this.I(u);let s;(0,m.$_k)(i)&&!n&&(s=await this.Q(u));let r;try{if((0,m.$_k)(i)&&i.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(t);h.mode&128||await I.promises.chmod(t,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let a;if((0,m.$_k)(i)){if(R.$j)try{await I.promises.truncate(t,0),a="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}a||(a="w")}else a="r";r=await g.Promises.open(t,a)}catch(a){throw s?.dispose(),(0,m.$_k)(i)?await this.ib(u,a):this.hb(a)}if(this.X.set(r,0),(0,m.$_k)(i)&&this.Z.set(r,u),s){const a=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),a&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),a.dispose())}return r}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&p.$)try{await g.Promises.fdatasync(u)}catch(n){p.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(u)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,n,t,s){const r=this.ab(u,i);let a=null;try{a=(await g.Promises.read(u,n,t,s,r)).bytesRead}catch(h){throw this.hb(h)}finally{this.bb(u,r,a)}return a}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,n){const t=this.X.get(u);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(u,t+n):this.X.delete(u)))}async write(u,i,n,t,s){return(0,c.$Xh)(()=>this.cb(u,i,n,t,s),100,3)}async cb(u,i,n,t,s){const r=this.ab(u,i);let a=null;try{a=(await g.Promises.write(u,n,t,s,r)).bytesWritten}catch(h){throw await this.ib(this.Z.get(u),h)}finally{this.bb(u,r,a)}return a}async mkdir(u){try{await I.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const n=this.I(u);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$ic)((0,b.$lc)(n),`${(0,b.$mc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,t)}else try{await I.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:a}=await g.SymlinkSupport.stat(n);s=r.isDirectory()&&!a}catch{}if(s)await I.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(u,i,n){const t=this.I(u),s=this.I(i);if(t!==s)try{await this.db(u,i,"move",n.overwrite),await g.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11322,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(s)),r.toString()))),this.hb(r)}}async copy(u,i,n){const t=this.I(u),s=this.I(i);if(t!==s)try{await this.db(u,i,"copy",n.overwrite),await g.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11323,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(s)),r.toString()))),this.hb(r)}}async db(u,i,n,t){const s=this.I(u),r=this.I(i);let a=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(a=(0,O.$Bg)(s,r,!0)),a){if(n==="copy")throw(0,m.$ll)((0,l.localize)(11324,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.N(u);if(!y)throw(0,m.$ll)((0,l.localize)(11325,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!t)throw(0,m.$ll)((0,l.localize)(11326,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,n){const t=this.I(u),s=this.I(i),r=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Bg)(t,s,!r))return;const a=new k.$Sc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),n&&await I.promises.mkdir((0,b.$lc)(s),{recursive:!0}),await I.promises.copyFile(t,s)}catch(h){if(h.code==="ENOENT"&&!n)return this.eb(u,i,!0);throw this.hb(h)}finally{a.dispose()}}t(u,i,n){return new w.$hr(t=>u(t),t=>i(t),n)}F(u,i,n){return new P.$qr(t=>u(t),t=>i(t),n)}hb(u){if(u instanceof m.$kl)return u;let i=u,n;switch(u.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$ll)(i,n)}async ib(u,i){let n=this.hb(i);if(u&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await g.SymlinkSupport.stat(this.I(u));t.mode&128||(n=(0,m.$ll)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$rr=p}),define(he[101],ue([0,1,3,2,4,10]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=void 0,e.$lic=(0,T.$Di)("sharedProcessLifecycleService");let N=class extends c.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new I.$ke),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$mic=N,e.$mic=N=ve([x(0,A.$$j)],N)}),define(he[175],ue([0,1,9,3,10,2]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=void 0;class N extends T.$jk{constructor($,d,g,l,m){super(d,g,l),this.r=$,this.t=m,this.B(m.listen("onDidChangeLogLevel",$)(E=>{(0,T.$ak)(E)?super.setLogLevel(E):super.setLogLevel(I.URI.revive(E[0]),E[1])})),this.B(m.listen("onDidChangeVisibility",$)(([E,f])=>super.setVisibility(I.URI.revive(E),f))),this.B(m.listen("onDidChangeLoggers",$)(({added:E,removed:f})=>{for(const w of E)super.registerLogger({...w,resource:I.URI.revive(w.resource)});for(const w of f)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new T.$hk({log:($,d)=>{this.t.call("consoleLog",[$,d])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,d){super.setLogLevel($,d),this.t.call("setLogLevel",[$,d])}setVisibility($,d){super.setVisibility($,d),this.t.call("setVisibility",[this.n($),d])}s($,d,g){return new O(this.t,$,d,g,this.r)}static setLogLevel($,d,g){return $.call("setLogLevel",[d,g])}}e.$rs=N;class O extends T.$ek{constructor($,d,g,l,m){super(l?.logLevel==="always"),this.r=$,this.s=d,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[d,l,m]).then(()=>{this.u(this.n),this.m=!0})}g($,d){const g=[[$,d]];this.m?this.u(g):this.n.push(...g)}u($){this.r.call("log",[this.s,$])}}class k{constructor($,d){this.a=$,this.b=d}listen($,d){const g=this.b($);switch(d){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(m=>this.c(m,g)),removed:[...l.removed].map(m=>this.c(m,g))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[g.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,T.$ak)(l)?l:[g.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${d}`)}async call($,d,g){const l=this.b($);switch(d){case"setLogLevel":return(0,T.$ak)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(I.URI.revive(l.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,l)))}throw new Error(`Call not found: ${d}`)}c($,d){return{...$,resource:d.transformOutgoingURI($.resource)}}}e.$ss=k;class b extends A.$Tc{constructor($,d){super(),d.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(g=>d.call("setLogLevel",[g]))),d.call("getRegisteredLoggers").then(g=>{for(const l of g)$.registerLogger({...l,resource:I.URI.revive(l.resource)})}),this.B(d.listen("onDidChangeVisibility")(([g,l])=>$.setVisibility(I.URI.revive(g),l))),this.B(d.listen("onDidChangeLoggers")(({added:g,removed:l})=>{for(const m of g)$.registerLogger({...m,resource:I.URI.revive(m.resource)});for(const m of l)$.deregisterLogger(m.resource)}))}}e.$ts=b}),define(he[176],ue([0,1,2,10]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class T extends I.$Tc{constructor(N,O=[]){super(),this.a=new c.$ik([N,...O]),this.B(N.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...O){this.a.trace(N,...O)}debug(N,...O){this.a.debug(N,...O)}info(N,...O){this.a.info(N,...O)}warn(N,...O){this.a.warn(N,...O)}error(N,...O){this.a.error(N,...O)}flush(){this.a.flush()}}e.$ER=T}),define(he[57],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0,e.$mgc=(0,I.$Di)("nativeHostService")}),define(he[177],ue([0,1,42,56]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;let T=class{constructor(N,O){return this.windowId=N,I.ProxyChannel.toService(O.getChannel("nativeHost"),{context:N,properties:(()=>{const k=new Map;return k.set("windowId",N),k})()})}};e.$Hhc=T,e.$Hhc=T=ve([x(1,c.$Ehc)],T)}),define(he[58],ue([0,1,3,63,2,4]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=void 0,e.$ro=(0,A.$Di)("policy");class N extends T.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$ke),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const R=Object.keys(this.f).length;return this.f={...b,...this.f},R!==Object.keys(this.f).length&&await this.j(b),c.Iterable.reduce(this.g.entries(),($,[d,g])=>({...$,[d]:g}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(b,[R,$])=>({...b,[R]:{definition:$,value:this.g.get(R)}}),{})}}e.$so=N;class O{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$to=O}),define(he[178],ue([0,1,3,2,58]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;class A{constructor(k){this.b=k,this.a=new c.$Sc}listen(k,b){switch(b){case"onDidChange":return I.Event.map(this.b.onDidChange,R=>R.reduce(($,d)=>({...$,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(k,b,R){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$$gc=A;class N extends T.$so{constructor(k,b){super(),this.a=b;for(const R in k){const{definition:$,value:d}=k[R];this.f[R]=$,d!==void 0&&this.g.set(R,d)}this.a.listen("onDidChange")(R=>{for(const $ in R){const d=R[$];d===null?this.g.delete($):this.g.set($,d)}this.h.fire(Object.keys(R))})}async j(k){const b=await this.a.call("updatePolicyDefinitions",k);for(const R in b)this.g.set(R,b[R])}}e.$_gc=N}),define(he[102],ue([0,1,37]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.context<"u"){const A=T.context.configuration();if(A)c=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:A.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(he[23],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,I.$Di)("productService"),e.$sk="vscode://schemas/vscode-product"}),define(he[179],ue([0,1,33,6,8,2,13,30,10,23]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0,I=Pe(I);let R=class extends A.$Tc{constructor(d,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,d&&this.B(new c.$Ph(()=>{this.f(d)},3e4)).schedule()}async f(d){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,N.$lc)(d),m=(0,N.$mc)(d),E=await O.Promises.readdir(l);await Promise.all(E.map(async f=>{if(f===m)return;const w=(0,N.$ic)(l,f),P=await I.promises.stat(w);if(P.isDirectory()&&g-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),O.Promises.rm(w)}))}catch(g){(0,T.$Y)(g)}}};e.$Vhc=R,e.$Vhc=R=ve([x(1,b.$rk),x(2,k.$$j)],R)}),define(he[180],ue([0,1,33,6,8,2,13,30,15,10,23]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0,I=Pe(I);let $=class extends A.$Tc{constructor(g,l,m){super(),this.b=g,this.c=l,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new c.$Ph(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await I.promises.readFile((0,N.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const p=l[P];g[`${p.hash}.${P}`]=!0}const m=(0,N.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(m))return;const f=await O.Promises.readdir(m);for(const P of f){if(g[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await O.Promises.rm((0,N.$ic)(m,P))}const w=Date.now();for(const P of Object.keys(g)){const p=(0,N.$ic)(m,P),o=await O.Promises.readdir(p);for(const u of o){if(u==="tcf.json")continue;const i=(0,N.$ic)(p,u),n=await I.promises.stat(i);n.isDirectory()&&w-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.$ic)(P,u)}`),await O.Promises.rm(i))}}}catch(g){(0,T.$Y)(g)}}};e.$Whc=$,e.$Whc=$=ve([x(0,k.$Li),x(1,b.$$j),x(2,R.$rk)],$)}),define(he[181],ue([0,1,13,4]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$XG=void 0,e.$XG=(0,c.$Di)("IV8InspectProfilingService");var T;(function(A){function N(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=N;function O(k,b="noAbsolutePaths"){for(const R of k.nodes)R.callFrame&&R.callFrame.url&&((0,I.$hc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,I.$ic)(b,(0,I.$mc)(R.callFrame.url)));return k}A.rewriteAbsolutePaths=O})(T||(e.Utils=T={}))}),define(he[182],ue([0,1,32]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class c{constructor(){this.a=new Map}async startProfiling(A){const O=await(await new Promise((b,R)=>{ae(["v8-inspect-profiler"],b,R)}).then(Pe)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),k=(0,I.$Zg)();return this.a.set(k,O),k}async stopProfiling(A){const N=this.a.get(A);if(!N)throw new Error(`UNKNOWN session '${A}'`);const O=await N.stop();return this.a.delete(A),O.profile}}e.$bic=c}),define(he[44],ue([0,1,131,12]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,I=Pe(I),c=Pe(c);class T{constructor(){this.a=new Map}add(N,O){I.ok(c.$dg(N)),I.ok(c.$fg(O)),I.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,O)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$po=new T}),define(he[103],ue([0,1,3,132,44]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,T=Pe(T),e.$qo={JSONContribution:"base.contributions.json"};function A(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class N{constructor(){this.b=new I.$ke,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,R){this.a[A(b)]=R,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(b){const R=this.a[b];return R?(0,c.$6j)(R):void 0}hasSchemaContent(b){return!!this.a[b]}}const O=new N;T.$po.add(e.$qo.JSONContribution,O)}),define(he[47],ue([0,1,17,3,12,11,21,103,44]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=m,e.$Go=E,e.$Ho=f,e.$Io=P,e.$Jo=p,e.$Ko=o,e.$Lo=u,T=Pe(T),A=Pe(A);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$uo={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const $=k.$po.as(O.$qo.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new c.$ke,this.onDidSchemaChange=this.j.event,this.k=new c.$ke,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(11556,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},$.registerSchema(e.$Bo,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),$.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),$.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),$.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:a}of n)for(const h in r){t.add(h);const y=this.b.get(h)??this.b.set(h,{configurationDefaultOverrides:[]}).get(h),L=r[h];if(y.configurationDefaultOverrides.push({value:L,source:a}),e.$Eo.test(h)){const S=this.o(h,L,a,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S,this.n(h,S,a),s.push(...m(h))}else{const S=this.p(h,L,a,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S;const v=this.e[h];v&&(this.A(h,v),this.w(h,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const a in s){const h=this.b.get(a);if(!h)continue;const y=h.configurationDefaultOverrides.findIndex(L=>r?L.source?.id===r.id:L.value===s[a]);if(y!==-1){if(h.configurationDefaultOverrides.splice(y,1),h.configurationDefaultOverrides.length===0&&this.b.delete(a),e.$Eo.test(a)){let L;for(const S of h.configurationDefaultOverrides)L=this.o(a,S.value,S.source,L);L&&!T.$qg(L.value)?(h.configurationDefaultOverrideValue=L,this.n(a,L,r)):(this.b.delete(a),delete this.e[a],delete this.c.properties[a])}else{let L;for(const v of h.configurationDefaultOverrides)L=this.p(a,v.value,v.source,L);h.configurationDefaultOverrideValue=L;const S=this.e[a];S&&(this.A(a,S),this.w(a,S))}t.add(a)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:A.localize(11557,null,(0,N.$hj)(n)),$ref:e.$Bo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const a=r?.value||{},h=r?.source??new Map;if(!(h instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const L=t[y];if(T.$fg(L)&&(T.$kg(a[y])||T.$fg(a[y]))){if(a[y]={...a[y]??{},...L},s)for(const v in L)h.set(`${y}.${v}`,s)}else a[y]=L,s?h.set(y,s):h.delete(y)}return{value:a,source:h}}p(n,t,s,r){const a=this.e[n],h=r?.value??a?.defaultDefaultValue;let y=s;if(T.$fg(t)&&(a!==void 0&&a.type==="object"||a===void 0&&(T.$kg(h)||T.$fg(h)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&y.set(`${n}.${S}`,s);t={...T.$fg(h)?h:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const a in r.properties){t.add(a);const h=this.e[a];h?.policy?.name&&this.f.delete(h.policy.name),delete this.e[a],this.x(a,r.properties[a])}r.allOf?.forEach(a=>s(a))};for(const r of n){s(r);const a=this.d.indexOf(r);a!==-1&&this.d.splice(a,1)}}u(n,t=!0,s,r,a=R.WINDOW,h){a=T.$mg(n.scope)?a:n.scope;const y=n.properties;if(y)for(const S in y){const v=y[S];if(t&&P(S,v)){delete y[S];continue}if(v.source=s,v.defaultDefaultValue=y[S].default,this.A(S,v),e.$Eo.test(S)?v.scope=void 0:(v.scope=T.$mg(v.scope)?a:v.scope,v.restricted=T.$mg(v.restricted)?!!r?.includes(S):v.restricted),y[S].hasOwnProperty("included")&&!y[S].included){this.g[S]=y[S],delete y[S];continue}else this.e[S]=y[S],y[S].policy?.name&&this.f.set(y[S].policy.name,S);!y[S].deprecationMessage&&y[S].markdownDeprecationMessage&&(y[S].deprecationMessage=y[S].markdownDeprecationMessage),h.add(S)}const L=n.allOf;if(L)for(const S of L)this.u(S,t,s,r,a,h)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const h in r)this.w(h,r[h]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$vo.properties[n]=t,t.scope){case R.APPLICATION:e.$wo.properties[n]=t;break;case R.MACHINE:e.$xo.properties[n]=t;break;case R.MACHINE_OVERRIDABLE:e.$yo.properties[n]=t;break;case R.WINDOW:e.$zo.properties[n]=t;break;case R.RESOURCE:e.$Ao.properties[n]=t;break;case R.LANGUAGE_OVERRIDABLE:e.$Ao.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$vo.properties[n],t.scope){case R.APPLICATION:delete e.$wo.properties[n];break;case R.MACHINE:delete e.$xo.properties[n];break;case R.MACHINE_OVERRIDABLE:delete e.$yo.properties[n];break;case R.WINDOW:delete e.$zo.properties[n];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:A.localize(11558,null),errorMessage:A.localize(11559,null),$ref:e.$Bo};this.A(t,s),e.$vo.properties[t]=s,e.$wo.properties[t]=s,e.$xo.properties[t]=s,e.$yo.properties[t]=s,e.$zo.properties[t]=s,e.$Ao.properties[t]=s}}z(){const n={type:"object",description:A.localize(11560,null),errorMessage:A.localize(11561,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=n,e.$wo.patternProperties[e.$Do]=n,e.$xo.patternProperties[e.$Do]=n,e.$yo.patternProperties[e.$Do]=n,e.$zo.patternProperties[e.$Do]=n,e.$Ao.patternProperties[e.$Do]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,a;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,a=s.source),T.$kg(r)&&(r=t.defaultDefaultValue,a=void 0),T.$kg(r)&&(r=f(t.type)),t.default=r,t.defaultValueSource=a}}const g="\\[([^\\]]+)\\]",l=new RegExp(g,"g");e.$Do=`^(${g})+$`,e.$Eo=new RegExp(e.$Do);function m(i){const n=[];if(e.$Eo.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,I.$Lb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new d;k.$po.add(e.$uo.Configuration,w);function P(i,n){return i.trim()?e.$Eo.test(i)?A.localize(11563,null,i):w.getConfigurationProperties()[i]!==void 0?A.localize(11564,null,i):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(11565,null,i,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(11562,null)}function p(){const i=[],n=w.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function o(i){const n={};for(const t of i){const s=t.properties;if(T.$fg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,o(t.allOf))}return n}function u(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(he[77],ue([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=p,I=Pe(I),T=Pe(T),O=Pe(O),k=Pe(k);function l(n){return Object.isFrozen(n)?n:O.$do(n)}class m{static createEmptyModel(t){return new m({},[],[],void 0,t)}constructor(t,s,r,a,h){this.b=t,this.c=s,this.d=r,this.raw=a,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof m)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$fj)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const a=[];for(const{contents:h,identifiers:y,keys:L}of r.rawConfiguration.overrides){const S=new m(h,L,[],void 0,r.f).getValue(t);S!==void 0&&a.push({identifiers:y,value:S})}return a.length?l(a):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,R.$fj)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return I.$Lb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return I.$Lb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$co(this.contents),r=O.$co(this.overrides),a=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const y of t)if(h.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const L of y.overrides){const[S]=r.filter(v=>I.$tb(v.identifiers,L.identifiers));S?(this.i(S.contents,L.contents),S.keys.push(...L.keys),S.keys=I.$Lb(S.keys)):r.push(O.$co(L))}for(const L of y.keys)a.indexOf(L)===-1&&a.push(L)}return new m(s,a,r,h.every(y=>y instanceof m)?void 0:h,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const a of I.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[a];const y=s[a];y&&(typeof h=="object"&&typeof y=="object"?(h=O.$co(h),this.i(h,y)):h=y),r[a]=h}return new m(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&k.$fg(t[r])&&k.$fg(s[r])){this.i(t[r],s[r]);continue}t[r]=O.$co(s[r])}}j(t){let s=null,r=null;const a=h=>{h&&(r?this.i(r,h):r=O.$co(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?s=h.contents:h.identifiers.includes(t)&&a(h.contents);return a(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,R.$ej)(this.contents,t),$.$Eo.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>I.$tb(r.identifiers,(0,$.$Fo)(t))),1))}k(t,s,r){if((0,R.$dj)(this.contents,t,s,a=>this.f.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),$.$Eo.test(t)){const a=(0,$.$Fo)(t),h={identifiers:a,keys:Object.keys(this.contents[t]),contents:(0,R.$cj)(this.contents[t],L=>this.f.error(L))},y=this.overrides.findIndex(L=>I.$tb(L.identifiers,a));y!==-1?this.overrides[y]=h:this.overrides.push(h)}}}e.$Mo=m;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!k.$mg(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:a,overrides:h,restricted:y,hasExcludedProperties:L}=this.i(t,s);this.b=new m(r,a,h,L?[t]:void 0,this.g),this.c=y||[]}h(t){let s={},r=null,a=[];const h=[],y=[];function L(v){Array.isArray(a)?a.push(v):r!==null&&(a[r]=v)}const S={onObjectBegin:()=>{const v={};L(v),h.push(a),a=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const v=[];L(v),h.push(a),a=v,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:L,onError:(v,C,U)=>{y.push({error:v,offset:C,length:U})}};if(t)try{T.$4n(t,S),s=a[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=g.$po.as($.$uo.Configuration).getConfigurationProperties(),a=this.j(t,r,!0,s);t=a.raw;const h=(0,R.$cj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),y=Object.keys(t),L=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:h,keys:y,overrides:L,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(t,s,r,a){let h=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const y={},L=[];for(const S in t)if($.$Eo.test(S)&&r){const v=this.j(t[S],s,!1,a);y[S]=v.raw,h=h||v.hasExcludedProperties,L.push(...v.restricted)}else{const v=s[S],C=v?typeof v.scope<"u"?v.scope:$.ConfigurationScope.WINDOW:void 0;v?.restricted&&L.push(S),!a.exclude?.includes(S)&&(a.include?.includes(S)||(C===void 0||a.scopes===void 0||a.scopes.includes(C))&&!(a.skipRestricted&&v?.restricted))?y[S]=t[S]:h=!0}return{raw:y,restricted:L,hasExcludedProperties:h}}l(t,s){const r=[];for(const a of Object.keys(t))if($.$Eo.test(a)){const h={};for(const y in t[a])h[y]=t[a][y];r.push({identifiers:(0,$.$Fo)(a),keys:Object.keys(h),contents:(0,R.$cj)(h,s)})}return r}}e.$No=E;class f extends A.$Tc{constructor(t,s,r,a,h){super(),this.c=t,this.f=s,this.g=a,this.h=h,this.b=this.B(new c.$ke),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),h),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(d.FileOperation.CREATE)||y.isOperation(d.FileOperation.COPY)||y.isOperation(d.FileOperation.DELETE)||y.isOperation(d.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=f;class w{constructor(t,s,r,a,h,y,L,S,v,C,U,F,M){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=a,this.d=h,this.f=y,this.g=L,this.h=S,this.i=v,this.j=C,this.k=U,this.l=F,this.m=M}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,a,h,y,L,S,v,C){this.j=t,this.l=s,this.m=r,this.n=a,this.p=h,this.q=y,this.r=L,this.s=S,this.t=v,this.u=C,this.h=null,this.i=new N.$zc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let a;r.resource?(a=this.t.get(r.resource),a||(a=m.createEmptyModel(this.u),this.t.set(r.resource,a))):a=this.s,s===void 0?a.removeValue(t):a.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const a=this.w(t,s,r),h=this.A(s.resource,r),y=s.resource?this.t.get(s.resource)||this.s:this.s,L=new Set;for(const S of a.overrides)for(const v of S.identifiers)a.getOverrideValue(t,v)!==void 0&&L.add(v);return new w(t,s,a.getValue(t),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,h||void 0,y)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:a,updated:h,removed:y}=u(this.j,t);s=[...a,...h,...y]}for(const a of s)for(const h of(0,$.$Fo)(a)){const y=this.j.getKeysForOverrideIdentifier(h),L=t.getKeysForOverrideIdentifier(h),S=[...L.filter(v=>y.indexOf(v)===-1),...y.filter(v=>L.indexOf(v)===-1),...y.filter(v=>!O.$go(this.j.override(h).getValue(v),t.override(h).getValue(v)))];r.push([h,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:a}=u(this.l,t),h=[...s,...r,...a];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.applicationConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.localUserConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.remoteUserConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:a,overrides:h}=u(this.workspaceConfiguration,t),y=[...s,...r,...a];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:h}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:a,updated:h,removed:y,overrides:L}=u(r,s),S=[...a,...h,...y];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:L}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:h,overrides:y}=u(s,void 0);return{keys:[...r,...a,...h],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let a=this.x(s,r);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(a=a.merge(this.l)),a}x({resource:t},s){let r=this.y();if(s&&t){const a=s.getFolder(t);a&&(r=this.z(a.uri)||r);const h=this.t.get(t);h&&(r=r.merge(h))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),a=this.r.get(t);a?(s=r.merge(a),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:a,keys:h}=this.r.get(s);return t.push([s,{contents:r,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>s.add(a))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),a=this.E(t.policy,s),h=this.E(t.application,s),y=this.E(t.user,s),L=this.E(t.workspace,s),S=t.folders.reduce((v,C)=>(v.set(b.URI.revive(C[0]),this.E(C[1],s)),v),new N.$zc);return new P(r,a,h,y,m.createEmptyModel(s),L,S,m.createEmptyModel(s),new N.$zc,s)}static E(t,s){return new m(t.contents,t.keys,t.overrides,void 0,s)}}e.$Po=P;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const a of n)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,y])=>{const L=(0,N.$wc)(s,h,new Set);y.forEach(S=>L.add(S))});const r=[];return s.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...t.values()],overrides:r}}class o{constructor(t,s,r,a,h){this.change=t,this.f=s,this.g=r,this.h=a,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const L of y)this.affectedKeys.add(L);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,a=this.d.indexOf(r);if(a<0)return!1;const h=a+r.length;if(h>=this.d.length)return!1;const y=this.d.charCodeAt(h);if(y!==this.b&&y!==this.c)return!1;if(s){const L=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!O.$go(L,S)}return!0}}e.$Ro=o;function u(n,t){const{added:s,removed:r,updated:a}=i(t?.rawConfiguration,n?.rawConfiguration),h=[],y=n?.getAllOverrideIdentifiers()||[],L=t?.getAllOverrideIdentifiers()||[];if(t){const S=L.filter(v=>!y.includes(v));for(const v of S)h.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=y.filter(v=>!L.includes(v));for(const v of S)h.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of y)if(L.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});h.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:a,overrides:h}}function i(n,t){const s=n?t?n.keys.filter(h=>t.keys.indexOf(h)===-1):[...n.keys]:[],r=t?n?t.keys.filter(h=>n.keys.indexOf(h)===-1):[...t.keys]:[],a=[];if(n&&t){for(const h of t.keys)if(n.keys.indexOf(h)!==-1){const y=(0,R.$fj)(t.contents,h),L=(0,R.$fj)(n.contents,h);O.$go(y,L)||a.push(h)}}return{added:s,removed:r,updated:a}}}),define(he[183],ue([0,1,17,3,2,29,12,77,47,10,58,44]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class d extends T.$Tc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new c.$ke),this.onDidChangeConfiguration=this.a.event,this.b=O.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B($.$po.as(k.$uo.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:f})=>this.f(Array.from(E),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,f){this.j(E,$.$po.as(k.$uo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=O.$Mo.createEmptyModel(this.c);const E=$.$po.as(k.$uo.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,f){const w=this.g();for(const P of E){const p=w[P],o=f[P];p!==void 0?this.b.setValue(P,p):o?this.b.setValue(P,o.default):this.b.removeValue(P)}}}e.$So=d;class g{constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=O.$Mo.createEmptyModel(new b.$lk)}async initialize(){return this.configurationModel}}e.$To=g;let l=class extends T.$Tc{get configurationModel(){return this.b}constructor(E,f,w){super(),this.c=E,this.f=f,this.g=w,this.a=this.B(new c.$ke),this.onDidChangeConfiguration=this.a.event,this.b=O.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const f={},w=[],P=$.$po.as(k.$uo.Configuration).getConfigurationProperties();for(const p of E){const o=P[p];if(!o){w.push(p);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}w.push(p),f[o.policy.name]={type:o.type}}}return(0,N.$qg)(f)||await this.f.updatePolicyDefinitions(f),w}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const f=$.$po.as(k.$uo.Configuration).getPolicyConfigurations(),w=(0,I.$Gb)(E.map(P=>f.get(P)));this.m(w,!0)}m(E,f){this.g.trace("PolicyConfiguration#update",E);const w=$.$po.as(k.$uo.Configuration).getConfigurationProperties(),P=[],p=this.b.isEmpty();for(const o of E){const u=w[o]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(p?i!==void 0:!(0,A.$go)(this.b.getValue(o),i))&&P.push([o,i])}else this.b.getValue(o)!==void 0&&P.push([o,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const o=this.b;this.b=O.$Mo.createEmptyModel(this.g);for(const u of o.keys)this.b.setValue(u,o.getValue(u));for(const[u,i]of P)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);f&&this.a.fire(this.b)}}};e.$Uo=l,e.$Uo=l=ve([x(1,R.$ro),x(2,b.$$j)],l)}),define(he[184],ue([0,1,17,6,14,3,36,64,2,31,29,5,20,21,77,47,183,7,58]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class P extends k.$Tc{constructor(u,i,n,t){super(),this.m=u,this.n=t,this.h=this.B(new A.$ke),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$So(t)),this.c=n instanceof w.$to?new E.$To:this.B(new E.$Uo(this.b,n,t)),this.f=this.B(new l.$Oo(this.m,{},d.$8g,i,t)),this.a=new l.$Po(this.b.configurationModel,this.c.configurationModel,l.$Mo.createEmptyModel(t),l.$Mo.createEmptyModel(t),l.$Mo.createEmptyModel(t),l.$Mo.createEmptyModel(t),new b.$zc,l.$Mo.createEmptyModel(t),new b.$zc,t),this.j=new p(u,i,this),this.g=this.B(new c.$Ph(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Po(u,i,l.$Mo.createEmptyModel(this.n),n,l.$Mo.createEmptyModel(this.n),l.$Mo.createEmptyModel(this.n),new b.$zc,l.$Mo.createEmptyModel(this.n),new b.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const n=typeof u=="string"?u:void 0,t=(0,g.$$i)(u)?u:(0,g.$$i)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(u,i,n,t,s){const r=(0,g.$_i)(n)?n:(0,g.$$i)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,a=r?t:n;if(a!==void 0&&a!==g.ConfigurationTarget.USER_LOCAL&&a!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${a}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,I.$Lb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const h=this.inspect(u,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,R.$go)(i,h.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const L=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,I.$tb)([...v.identifiers].sort(),L));S&&(r.overrideIdentifiers=S.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,m.$Go)(r.overrideIdentifiers),u]:[u];await this.j.write(y,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(n,i,g.ConfigurationTarget.USER)}s(u,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(t,n,g.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(u);this.u(n,i,g.ConfigurationTarget.DEFAULT)}u(u,i,n){const t=new l.$Ro(u,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$Vo=P;class p{constructor(u,i,n){this.b=u,this.c=i,this.d=n,this.a=new c.$Kh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,N.$Wn)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,u,i);n=(0,O.$bo)(n,s),await this.c.writeFile(this.b,T.$Me.fromString(n))}f(u,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const a=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:a,length:a.length,offset:0}]}return(0,O.$$n)(u,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let u=$.OS===$.OperatingSystem.Linux||$.OS===$.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(he[185],ue([0,1,14,3,2,69]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wxb=e.$uxb=e.$txb=void 0,e.$vxb=O;const N=(b,R,$)=>{const d=new Uint8Array(16);for(let m=0;m<16;m++)d[m]=Math.round(Math.random()*256);const g=(0,I.$7e)(I.$Me.wrap(d));return[`GET ws://localhost${b}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`].join(`\r
`)+`\r
\r
`};e.$txb=N,e.$uxb=I.$Me.fromString(`\r
\r
`);async function O(b,R,$,d,g){b.write(I.$Me.fromString((0,e.$txb)(R,$,d)));const l=new T.$Sc;try{return await new Promise((m,E)=>{let f;l.add(b.onData(w=>{f?f=I.$Me.concat([f,w],f.byteLength+w.byteLength):f=w;const P=f.indexOf(e.$uxb);if(P===-1)return;m(b),b.pauseData();const p=f.slice(P+e.$uxb.byteLength);p.byteLength&&g.onData.fire(p)})),l.add(b.onClose(w=>E(w??new Error("socket closed")))),l.add(b.onEnd(()=>E(new Error("socket ended"))))})}catch(m){throw b.dispose(),m}finally{l.dispose()}}class k extends T.$Tc{constructor(R,$){super(),this.g=R,this.a=this.B(new c.$ne),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new c.$ke),this.onDidDispose=this.b.event,this.f=!1,this.B($.onData),this.B($.onData.event(d=>this.a.fire(d))),this.onClose=this.B($.onClose).event,this.onEnd=this.B($.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,$){A.SocketDiagnostics.traceSocketEvent(this,this.g,R,$)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$wxb=k}),define(he[104],ue([0,1,8,4]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=b,e.$Pl=(0,c.$Di)("remoteAuthorityResolverService");var T;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class A{constructor($){this.id=$,this.type=T.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=A;class N{constructor($,d){this.host=$,this.port=d,this.type=T.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=N;var O;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class k extends I.$ab{static isNotAvailable($){return $ instanceof k&&$._code===O.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof k&&$._code===O.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof k&&$._code===O.NoResolverFound}static isInvalidAuthority($){return $ instanceof k&&$._code===O.InvalidAuthority}static isHandled($){return $ instanceof k&&$.isHandled}constructor($,d=O.Unknown,g){super($),this._message=$,this._code=d,this._detail=g,this.isHandled=d===O.NotAvailable&&g===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Sl=k;function b(R){const $=R.indexOf("+");return $===-1?R:R.substring(0,$)}}),define(he[186],ue([0,1,6,14,25,8,3,2,22,100,54,32,69,104]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Yl=h,e.$Zl=y,e.$1l=S,b=Pe(b);const l=30*1e3;var m;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function E(K){switch(K){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function f(K){const q=new T.$ve;return setTimeout(()=>q.cancel(),K),q.token}function w(K,q){if(K.isCancellationRequested||q.isCancellationRequested)return T.CancellationToken.Cancelled;const D=new T.$ve;return K.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new O.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$wh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function p(K,q){const D=new P(q);return D.registerDisposable(K.onControlMessage(X=>{const J=JSON.parse(X.toString()),j=z(J);j?D.reject(j):D.resolve(J)})),D.promise}function o(K,q,D,X,J,j,W,Y){const Z=new P(Y),se=R.$ee.create(!1);return K.info(`Creating a socket (${W})...`),b.mark(`code/willCreateSocket/${j}`),q.connect(D,X,J,W).then(ce=>{Z.didTimeout?(b.mark(`code/didCreateSocketError/${j}`),K.info(`Creating a socket (${W}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(b.mark(`code/didCreateSocketOK/${j}`),K.info(`Creating a socket (${W}) was successful after ${se.elapsed()} ms.`),Z.resolve(ce))},ce=>{b.mark(`code/didCreateSocketError/${j}`),K.info(`Creating a socket (${W}) returned an error after ${se.elapsed()} ms.`),K.error(ce),Z.reject(ce)}),Z.promise}function u(K,q){const D=new P(q);return K.then(X=>{D.didTimeout||D.resolve(X)},X=>{D.didTimeout||D.reject(X)}),D.promise}async function i(K,q,D,X){const J=te(K,q);K.logService.trace(`${J} 1/6. invoking socketFactory.connect().`);let j;try{j=await o(K.logService,K.remoteSocketFactoryService,K.connectTo,k.$Qg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${K.reconnectionToken}`,X)}catch(ce){throw K.logService.error(`${J} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ce),ce}K.logService.trace(`${J} 2/6. socketFactory.connect() was successful.`);let W,Y;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(j,null),W=K.reconnectionProtocol,Y=!1):(W=new d.$ri({socket:j}),Y=!0),K.logService.trace(`${J} 3/6. sending AuthRequest control message.`);const Z=await u(K.signService.createNewMessage((0,$.$Zg)()),X),se={type:"auth",auth:K.connectionToken||"00000000000000000000",data:Z.data};W.sendControl(c.$Me.fromString(JSON.stringify(se)));try{const ce=await p(W,w(X,f(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(K.logService.trace(`${J} 4/6. received SignRequest control message.`),!await u(K.signService.validate(Z,ce.signedData),X)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const pe=await u(K.signService.sign(ce.data),X),Ee={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:q};return D&&(Ee.args=D),K.logService.trace(`${J} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(c.$Me.fromString(JSON.stringify(Ee))),{protocol:W,ownsProtocol:Y}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(K.logService.error(`${J} the handshake timed out. Error:`),K.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${J} received error control message when negotiating connection. Error:`),K.logService.error(ce)),Y&&B(W),ce}}async function n(K,q,D,X){const J=Date.now(),j=te(K,q),{protocol:W,ownsProtocol:Y}=await i(K,q,D,X),Z=new P(X);return Z.registerDisposable(W.onControlMessage(se=>{const ce=JSON.parse(se.toString()),me=z(ce);me?(K.logService.error(`${j} received error control message when negotiating connection. Error:`),K.logService.error(me),Y&&B(W),Z.reject(me)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Q(J)}!`),Z.resolve({protocol:W,firstMessage:ce}))})),Z.promise}async function t(K,q){const{protocol:D}=await n(K,m.Management,void 0,q);return{protocol:D}}async function s(K,q,D){const{protocol:X,firstMessage:J}=await n(K,m.ExtensionHost,q,D),j=J&&J.debugPort;return{protocol:X,debugPort:j}}async function r(K,q,D){const X=Date.now(),J=te(K,m.Tunnel),{protocol:j}=await i(K,m.Tunnel,q,D);return K.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${Q(X)}!`),j}async function a(K,q,D){const{connectTo:X,connectionToken:J}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:X,connectionToken:J,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function h(K,q,D){return L(K,async X=>{const{protocol:J}=await t(X,T.CancellationToken.None);return new H(K,q,D,X.reconnectionToken,J)})}async function y(K,q){return L(K,async D=>{const{protocol:X,debugPort:J}=await s(D,q,T.CancellationToken.None);return new ie(K,q,D.reconnectionToken,X,J)})}async function L(K,q){for(let X=1;;X++)try{const J=(0,$.$Zg)(),j=await a(K,J,null);return await q(j)}catch(J){if(X<5)K.logService.error(`[remote-connection][attempt ${X}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(J);else throw K.logService.error(`[remote-connection][attempt ${X}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(J),_.triggerPermanentFailure(0,0,g.$Sl.isHandled(J)),J}}async function S(K,q,D){const X=await a(K,(0,$.$Zg)(),null);return await r(X,{host:q,port:D},T.CancellationToken.None)}function v(K){return(0,I.$qh)(q=>new Promise((D,X)=>{const J=setTimeout(D,K*1e3);q.onCancellationRequested(()=>{clearTimeout(J),D()})}))}var C;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class U{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=C.ConnectionLost}}e.$2l=U;class F{constructor(q,D,X,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=X,this.c=J,this.type=C.ReconnectionWait}skipWait(){this.c.cancel()}}e.$3l=F;class M{constructor(q,D,X){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=X,this.type=C.ReconnectionRunning}}e.$4l=M;class G{constructor(q,D,X){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=X,this.type=C.ConnectionGain}}e.$5l=G;class V{constructor(q,D,X,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=X,this.handled=J,this.type=C.ReconnectionPermanentFailure}}e.$6l=V;class _ extends O.$Tc{static triggerPermanentFailure(q,D,X){this._permanentFailure=!0,this.f=q,this.g=D,this.h=X,this.j.forEach(J=>J.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||_._permanentFailure}constructor(q,D,X,J,j){super(),this.t=q,this.u=D,this.reconnectionToken=X,this.protocol=J,this.w=j,this.m=this.B(new N.$ke),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new G(this.reconnectionToken,0,0)),this.B(J.onSocketClose(W=>{const Y=le(this.t,this.reconnectionToken,!0);W?W.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Y} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${Y} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${Y} received socket close event.`),this.y()})),this.B(J.onSocketTimeout(W=>{const Y=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),_.j.push(this),this.B((0,O.$Rc)(()=>{const W=_.j.indexOf(this);W>=0&&_.j.splice(W,1)})),this.n&&this.D(_.f,_.g,_.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const J=X<D.length?D[X]:D[D.length-1];try{if(J>0){const W=v(J);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,W)),this.u.logService.info(`${q} waiting for ${J} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this.u.logService.info(`${q} resolving connection...`);const j=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${j.connectTo}...`),await this.G(j,f(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(g.$Sl.isTemporarilyNotAvailable(j)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((0,A.$3)(j)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if(j instanceof g.$Sl){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,g.$Sl.isHandled(j));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!this.n&&!this.s)}C(q,D,X){this.w?_.triggerPermanentFailure(q,D,X):this.D(q,D,X)}D(q,D,X){this.m.fire(new V(this.reconnectionToken,q,D,X)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7l=_;class H extends _{constructor(q,D,X,J,j){super(m.Management,q,J,j,!0),this.client=this.B(new d.$pi(j,{remoteAuthority:D,clientId:X},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$8l=H;class ie extends _{constructor(q,D,X,J,j){super(m.ExtensionHost,q,X,J,!1),this.H=D,this.debugPort=j}async G(q,D){await s(q,this.H,D)}}e.$9l=ie;function B(K){try{K.acceptDisconnect();const q=K.getSocket();K.dispose(),q.dispose()}catch(q){(0,A.$Y)(q)}}function z(K){if(K&&K.type==="error"){const q=new Error(`Connection error: ${K.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function ee(K,q){for(;K.length<q;)K+=" ";return K}function ne(K,q){return`[remote-connection][${ee(E(K),13)}][${q.substr(0,5)}\u2026]`}function le(K,q,D){return`${ne(K,q)}[${D?"reconnect":"initial"}]`}function te(K,q){return`${le(q,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function Q(K){return`${Date.now()-K} ms`}}),define(he[105],ue([0,1,22]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=c,e.$gn=T,e.$hn=A,e.$in=N;function c(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}function T(k){if(!k)return;const b=k.indexOf("+");return b<0?k:k.substr(0,b)}function A(k){const{host:b,port:R}=O(k);if(typeof R>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:R}}function N(k,b){let{host:R,port:$}=O(k);return typeof $>"u"&&($=b),{host:R,port:$}}function O(k){const b=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const R=k.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const $=k.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:k,port:void 0}}}),define(he[34],ue([0,1,26,4,105]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=A,e.$sn=$,e.$tn=d,e.$un=g,e.$vn=l,e.$wn=m,e.$xn=E,I=Pe(I),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$on=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(N||(e.ExtensionType=N={}));var O;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const p=typeof w=="string"?w:w.value,o=typeof P=="string"?P:P.value;return I.$Ef(p,o)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$pn=k;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$qn=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,P){this.c.set(k.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=R;function $(f){return d(f)}function d(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function g(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function l(f,w){if(w){const P=`onResolveRemoteAuthority:${(0,T.$gn)(w)}`;return!!f.activationEvents?.includes(P)}return!1}function m(f){return f.map(w=>{const[P,p]=w.split("@");return{proposalName:P,version:p?parseInt(p):void 0}})}function E(f){return f.map(w=>w.split("@")[0])}e.$yn=(0,c.$Di)("IBuiltinExtensionsScannerService")}),define(he[27],ue([0,1,5,11,34,4]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=O,e.$ep=k,e.$fp=b,e.$gp=R,e.$hp=$,e.$ip=d,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var N;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function O(o){switch(o){case T.TargetPlatform.WIN32_X64:return"Windows 64 bit";case T.TargetPlatform.WIN32_ARM64:return"Windows ARM";case T.TargetPlatform.LINUX_X64:return"Linux 64 bit";case T.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case T.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case T.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case T.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case T.TargetPlatform.DARWIN_X64:return"Mac";case T.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case T.TargetPlatform.WEB:return"Web";case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;case T.TargetPlatform.UNKNOWN:return T.TargetPlatform.UNKNOWN;case T.TargetPlatform.UNDEFINED:return T.TargetPlatform.UNDEFINED}}function k(o){switch(o){case T.TargetPlatform.WIN32_X64:return T.TargetPlatform.WIN32_X64;case T.TargetPlatform.WIN32_ARM64:return T.TargetPlatform.WIN32_ARM64;case T.TargetPlatform.LINUX_X64:return T.TargetPlatform.LINUX_X64;case T.TargetPlatform.LINUX_ARM64:return T.TargetPlatform.LINUX_ARM64;case T.TargetPlatform.LINUX_ARMHF:return T.TargetPlatform.LINUX_ARMHF;case T.TargetPlatform.ALPINE_X64:return T.TargetPlatform.ALPINE_X64;case T.TargetPlatform.ALPINE_ARM64:return T.TargetPlatform.ALPINE_ARM64;case T.TargetPlatform.DARWIN_X64:return T.TargetPlatform.DARWIN_X64;case T.TargetPlatform.DARWIN_ARM64:return T.TargetPlatform.DARWIN_ARM64;case T.TargetPlatform.WEB:return T.TargetPlatform.WEB;case T.TargetPlatform.UNIVERSAL:return T.TargetPlatform.UNIVERSAL;default:return T.TargetPlatform.UNKNOWN}}function b(o,u){switch(o){case I.Platform.Windows:return u==="x64"?T.TargetPlatform.WIN32_X64:u==="arm64"?T.TargetPlatform.WIN32_ARM64:T.TargetPlatform.UNKNOWN;case I.Platform.Linux:return u==="x64"?T.TargetPlatform.LINUX_X64:u==="arm64"?T.TargetPlatform.LINUX_ARM64:u==="arm"?T.TargetPlatform.LINUX_ARMHF:T.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?T.TargetPlatform.ALPINE_X64:u==="arm64"?T.TargetPlatform.ALPINE_ARM64:T.TargetPlatform.UNKNOWN;case I.Platform.Mac:return u==="x64"?T.TargetPlatform.DARWIN_X64:u==="arm64"?T.TargetPlatform.DARWIN_ARM64:T.TargetPlatform.UNKNOWN;case I.Platform.Web:return T.TargetPlatform.WEB}}function R(o,u){return u===T.TargetPlatform.WEB&&!o.includes(T.TargetPlatform.WEB)}function $(o,u,i){return R(u,i)?!1:o===T.TargetPlatform.UNDEFINED||o===T.TargetPlatform.UNIVERSAL?!0:o===T.TargetPlatform.UNKNOWN?!1:o===i}function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var g;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var l;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var E;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$jp=(0,A.$Di)("extensionGalleryService");var f;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class w extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$kp=w;var P;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class p extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$lp=p,e.$mp=(0,A.$Di)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,A.$Di)("IGlobalExtensionEnablementService"),e.$qp=(0,A.$Di)("IExtensionTipsService"),e.$rp=(0,c.localize2)(11446,"Extensions"),e.$sp=(0,c.localize2)(11447,"Preferences")}),define(he[187],ue([0,1,3,2,29,9,94,27]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0;function k(E,f){return E?A.URI.revive(f?f.transformIncoming(E):E):void 0}function b(E,f){return f?f.transformOutgoingURI(E):E}function R(E,f){f=f||N.$Ln;const w=E.manifest;return{...(0,N.$On)({...E,manifest:void 0},f),manifest:w}}function $(E,f){return E?.profileLocation?(0,N.$On)(E,f??N.$Ln):E}function d(E,f){return f?(0,T.$eo)(E,w=>w instanceof A.URI?f.transformOutgoingURI(w):void 0):E}class g{constructor(f,w){this.a=f,this.b=w,this.onInstallExtension=I.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,w){const P=this.b(f);switch(w){case"onInstallExtension":return I.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,p=>p.map(o=>({...o,local:o.local?d(o.local,P):o.local,profileLocation:o.profileLocation?b(o.profileLocation,P):o.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,p=>({local:d(p.local,P),profileLocation:b(p.profileLocation,P)}))}throw new Error("Invalid listen")}async call(f,w,P){const p=this.b(f);switch(w){case"zip":{const o=R(P[0],p),u=await this.a.zip(o);return b(u,p)}case"install":return this.a.install(k(P[0],p),$(P[1],p));case"installFromLocation":return this.a.installFromLocation(k(P[0],p),k(P[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],k(P[1],p),k(P[2],p));case"getManifest":return this.a.getManifest(k(P[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],$(P[1],p));case"installGalleryExtensions":{const o=P[0];return this.a.installGalleryExtensions(o.map(({extension:u,options:i})=>({extension:u,options:$(i,p)??{}})))}case"uninstall":return this.a.uninstall(R(P[0],p),$(P[1],p));case"uninstallExtensions":{const o=P[0];return this.a.uninstallExtensions(o.map(({extension:u,options:i})=>({extension:R(u,p),options:$(i,p)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(R(P[0],p));case"getInstalled":return(await this.a.getInstalled(P[0],k(P[1],p),P[2])).map(u=>d(u,p));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(R(P[0],p),k(P[1],p));return d(o,p)}case"copyExtensions":return this.a.copyExtensions(k(P[0],p),k(P[1],p));case"updateMetadata":{const o=await this.a.updateMetadata(R(P[0],p),P[1],k(P[2],p));return d(o,p)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$vq=g;class l extends c.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new I.$ke),this.f=this.B(new I.$ke),this.g=this.B(new I.$ke),this.h=this.B(new I.$ke),this.j=this.B(new I.$ke),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?A.URI.revive(w.source):w.source,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:A.URI.revive(w.profileLocation),local:R(w.local,null)})))}n(f,w){f.fire(w)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(P=>(0,O.$hp)(P,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(w=>A.URI.revive(w)))}install(f,w){return Promise.resolve(this.m.call("install",[f,w])).then(P=>R(P,null))}installFromLocation(f,w){return Promise.resolve(this.m.call("installFromLocation",[f,w])).then(P=>R(P,null))}async installExtensionsFromProfile(f,w,P){return(await this.m.call("installExtensionsFromProfile",[f,w,P])).map(o=>R(o,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.m.call("installFromGallery",[f,w])).then(P=>R(P,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(f,w){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,w]))}uninstallExtensions(f){if(f.some(w=>w.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[f]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(w=>R(w,null))}getInstalled(f=null,w,P){return Promise.resolve(this.m.call("getInstalled",[f,w,P])).then(p=>p.map(o=>R(o,null)))}updateMetadata(f,w,P){return Promise.resolve(this.m.call("updateMetadata",[f,w,P])).then(p=>R(p,null))}resetPinnedStateForAllUserExtensions(f){return this.m.call("resetPinnedStateForAllUserExtensions",[f])}toggleAppliationScope(f,w){return this.m.call("toggleAppliationScope",[f,w]).then(P=>R(P,null))}copyExtensions(f,w){return this.m.call("copyExtensions",[f,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,w,P){const p=await this.m.call("download",[f,w,P]);return A.URI.revive(p)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$wq=l;class m{constructor(f){this.a=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$xq=m}),define(he[188],ue([0,1,2,34,7]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class A extends I.$Tc{constructor(O,k,b,R,$){super(),this.a=O,this.b=k,this.c=b,this.f=$,this.B(R.onDidInstallExtensions(d=>this.g(d))),this.B(R.onDidUninstallExtension(d=>this.h(d)))}g(O){for(const k of O)k.local&&this.invalidate(k.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,O)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,c.$jn))}catch(k){(0,T.$pl)(k)!==T.FileOperationResult.FILE_NOT_FOUND&&this.f.error(k)}}}e.$Uq=A});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[59],ue([0,1,20,92,11,60,34,159]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=R,e.$Yp=$,e.$Zp=d,e.$1p=g,e.$2p=l,e.$3p=m,e.$4p=E,e.$5p=f,c=it(c),T=Pe(T),A=Pe(A);const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(p){return p=p.trim(),p==="*"||k.test(p)}function $(p){if(!R(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=p.match(k);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function d(p){if(!p)return null;const o=p.majorBase,u=p.majorMustEqual,i=p.minorBase;let n=p.minorMustEqual;const t=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(o===0||(n=!1),s=!1);let r=0;if(p.preRelease){const a=b.exec(p.preRelease);if(a){const[,h,y,L]=a;r=Date.UTC(Number(h),Number(y)-1,Number(L))}}return{majorBase:o,majorMustEqual:u,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:r}}function g(p,o,u){let i;typeof p=="string"?i=d($(p)):i=p;let n;o instanceof Date?n=o.getTime():typeof o=="string"&&(n=new Date(o).getTime());let t;if(typeof u=="string"?t=d($(u)):t=u,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,a=i.patchBase;let h=t.majorBase,y=t.minorBase,L=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,C=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?s>h?!0:s<h?!1:r>y?!0:r<y||n&&n<S?!1:a>=L:(s===1&&h===0&&(!v||!C||!U)&&(h=1,y=0,L=0,v=!0,C=!1,U=!1),s<h?!1:s>h?!v:r<y?!1:r>y?!C:a<L?!1:a>L?!U:!(n&&n<S))}function l(p,o,u,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([c.default.Error,T.localize(11377,null)]),s;if(typeof i.name!="string")return s.push([c.default.Error,T.localize(11378,null,"name")]),s;if(typeof i.version!="string")return s.push([c.default.Error,T.localize(11379,null,"version")]),s;if(!i.engines)return s.push([c.default.Error,T.localize(11380,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([c.default.Error,T.localize(11381,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([c.default.Error,T.localize(11382,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([c.default.Error,T.localize(11383,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([c.default.Error,T.localize(11384,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([c.default.Warning,T.localize(11385,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([c.default.Error,T.localize(11386,null,"main")]),s;{const h=(0,I.$eh)(u,i.main);(0,I.$$g)(h,u)||s.push([c.default.Warning,T.localize(11387,null,h.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([c.default.Error,T.localize(11388,null,"browser")]),s;{const h=(0,I.$eh)(u,i.browser);(0,I.$$g)(h,u)||s.push([c.default.Warning,T.localize(11389,null,h.path,u.path)])}}if(!A.valid(i.version))return s.push([c.default.Error,T.localize(11390,null)]),s;const r=[];if(!m(p,o,i,n,r))for(const h of r)s.push([c.default.Error,h]);if(t&&i.enabledApiProposals?.length){const h=[];if(!f([...i.enabledApiProposals],h))for(const y of h)s.push([c.default.Error,y])}return s}function m(p,o,u,i,n){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:w(p,o,u.engines.vscode,n)}function E(p,o,u){return p==="*"||w(o,u,p)}function f(p,o){if(p.length===0)return!0;const u=Array.isArray(o)?o:void 0,i=(u?void 0:o)??O.allApiProposals,n=[],t=(0,N.$wn)(p);for(const{proposalName:s,version:r}of t){const a=i[s];a&&r&&a.version!==r&&n.push(T.localize(11391,null,s))}return u?.push(...n),n.length===0}function w(p,o,u,i=[]){const n=d($(u));if(!n)return i.push(T.localize(11392,null,u)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(T.localize(11393,null,u)),!1}else if(!n.majorMustEqual)return i.push(T.localize(11394,null,u)),!1;return g(p,o,n)?!0:(i.push(T.localize(11395,null,p,u)),!1)}function P(p){if(!Array.isArray(p))return!1;for(let o=0,u=p.length;o<u;o++)if(typeof p[o]!="string")return!1;return!0}}),define(he[78],ue([0,1,25,2,5,11,27,4]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0,e.$9r=k;function k(R){return R.tags.find($=>$.startsWith("lp-"))?.split("lp-")[1]}e.$0r=(0,O.$Di)("languagePackService");let b=class extends c.$Tc{constructor($){super(),this.c=$}async getAvailableLanguages(){const $=new I.$ve;setTimeout(()=>$.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},$.token)}catch{return[]}const l=d.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(E=>E.startsWith("lp-"))).map(m=>{const E=m.properties.localizedLanguages?.[0],f=k(m);return{...this.f(f,E,m),extensionId:m.identifier.id,galleryExtension:m}});return l.push(this.f("en","English")),l}f($,d,g){const l=d??$;let m;if(l!==$&&(m=`(${$})`),$.toLowerCase()===T.$x.toLowerCase()&&(m??="",m+=(0,A.localize)(11299,null)),g?.installCount){m??="";const E=g.installCount;let f;E>1e6?f=`${Math.floor(E/1e5)/10}M`:E>1e3?f=`${Math.floor(E/1e3)}K`:f=String(E),m+=` $(cloud-download) ${f}`}return{id:$,label:l,description:m}}};e.$$r=b,e.$$r=b=ve([x(0,N.$jp)],b)}),define(he[189],ue([0,1,2,78]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;let T=class extends I.$Tc{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};e.$Xhc=T,e.$Xhc=T=ve([x(0,c.$0r)],T)}),define(he[106],ue([0,1,2,4]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul=(0,c.$Di)("remoteSocketFactoryService");class T{constructor(){this.a={}}register(N,O){return this.a[N]??=[],this.a[N].push(O),(0,I.$Rc)(()=>{const k=this.a[N]?.indexOf(O);typeof k=="number"&&k>=0&&this.a[N]?.splice(k,1)})}b(N){return(this.a[N.type]||[]).find(k=>k.supports(N))}connect(N,O,k,b){const R=this.b(N);if(!R)throw new Error(`No socket factory found for ${N}`);return R.connect(N,O,k,b)}}e.$Vl=T}),define(he[190],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=e.$$hc=void 0,e.$$hc=(0,I.$Di)("sharedProcessTunnelService"),e.$_hc="sharedProcessTunnel"}),define(he[107],ue([0,1,4,11]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=e.$gic=e.$fic=e.TunnelStates=e.$eic=e.$dic=void 0,e.$dic=(0,I.$Di)("IRemoteTunnelService"),e.$eic={active:!1};var T;(function(A){A.disconnected=N=>({type:"disconnected",onTokenFailed:N}),A.connected=(N,O)=>({type:"connected",info:N,serviceInstallFailed:O}),A.connecting=N=>({type:"connecting",progress:N}),A.uninitialized={type:"uninitialized"}})(T||(e.TunnelStates=T={})),e.$fic="remote.tunnels.access",e.$gic=e.$fic+".hostNameOverride",e.$hic=e.$fic+".preventSleep",e.$iic="remoteTunnelService",e.$jic=(0,c.localize)(11183,null)}),define(he[61],ue([0,1,14,8,2,11,47,4,10,44]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=d,e.$9p=g,e.$0p=l,e.$$p=m,e.$_p=E,e.$aq=f,e.$6p=(0,O.$Di)("requestService");class R{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?o[u]="*****":o[u]=this.b[u];this.a=o}return this.a}}class $ extends T.$Tc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,A.localize)(11164,null),when:k.$qk.isEqualTo((0,k.$nk)(k.LogLevel.Trace)).serialize()})}async c(o,u,i){const n=`${o} #${++this.b}: ${u.url}`;this.a.trace(`${n} - begin`,u.type,new R(u.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,u.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,u.type,(0,c.$9)(t)),t}}}e.$7p=$;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function g(p){return p.res.statusCode===204}async function l(p){return g(p)?null:(await(0,I.$Ye)(p.stream)).toString()}async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return l(p)}async function E(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const u=(await(0,I.$Ye)(p.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function f(p){P(p)}let w;function P(p){const o=b.$po.as(N.$uo.Configuration),u=w;w={id:"http",order:15,title:(0,A.localize)(11165,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(11166,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(11167,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(11168,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(11169,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(11170,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(11171,null),(0,A.localize)(11172,null),(0,A.localize)(11173,null),(0,A.localize)(11174,null)],default:"override",description:(0,A.localize)(11175,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11176,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(11177,null),restricted:!0}}},o.updateConfigurations({add:[w],remove:u?[u]:[]})}P(N.ConfigurationScope.APPLICATION)}),define(he[191],ue([0,1,25,22,7,61]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;let N=class{constructor(k,b){this.a=k,this.b=b}async download(k,b,R=I.CancellationToken.None){if(k.scheme===c.Schemas.file||k.scheme===c.Schemas.vscodeRemote){await this.b.copy(k,b);return}const $={type:"GET",url:k.toString(!0)},d=await this.a.request($,R);if(d.res.statusCode===200)await this.b.writeFile(b,d.stream);else{const g=await(0,A.$$p)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};e.$TR=N,e.$TR=N=ve([x(0,A.$6p),x(1,T.$$k)],N)}),define(he[192],ue([0,1,14,25]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class T{constructor(O){this.a=O}listen(O,k){throw new Error("Invalid listen")}call(O,k,b,R=c.CancellationToken.None){switch(k){case"request":return this.a.request(b[0],R).then(async({res:$,stream:d})=>{const g=await(0,I.$Ye)(d);return[{statusCode:$.statusCode,headers:$.headers},g]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$as=T;class A{constructor(O){this.a=O}async request(O,k){const[b,R]=await this.a.call("request",[O],k);return{res:b,stream:(0,I.$1e)(R)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async lookupAuthorization(O){return this.a.call("lookupAuthorization",[O])}async lookupKerberosAuthorization(O){return this.a.call("lookupKerberosAuthorization",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$bs=A}),define(he[193],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=void 0,e.$Igc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Jgc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Kgc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[194],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(T){try{const A=await this.c();if(A){const N=String(I.a++);return this.b.set(N,A),{id:N,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,A){if(!T.id)return!0;const N=this.b.get(T.id);if(!N)return!1;this.b.delete(T.id);try{return N.validate(A)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(T){try{return await this.d(T)}catch{}return T}}e.$tcc=I}),define(he[108],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl="signService",e.$Xl=(0,I.$Di)(e.$Wl)}),define(he[195],ue([0,1,194]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class c extends I.$tcc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(N=>new N.signer().sign(A))}h(){return new Promise((A,N)=>ae(["vsda"],A,N))}}e.$Ahc=c}),define(he[79],ue([0,1,3,2]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Mb=e.$4Mb=e.$3Mb=e.$2Mb=void 0;class T extends c.$Tc{constructor($,d,g){super(),this.a=$,this.b=d,this.c=g}async getItems(){const $={profile:this.b,workspace:this.c},d=await this.a.call("getItems",$);return new Map(d)}updateItems($){const d={profile:this.b,workspace:this.c};return $.insert&&(d.insert=Array.from($.insert.entries())),$.delete&&(d.delete=Array.from($.delete.values())),this.a.call("updateItems",d)}optimize(){const $={profile:this.b,workspace:this.c};return this.a.call("optimize",$)}}class A extends T{constructor($,d){super($,d,void 0),this.f=this.B(new I.$ke),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})($=>this.h($)))}h($){(Array.isArray($.changed)||Array.isArray($.deleted))&&this.f.fire({changed:$.changed?new Map($.changed):void 0,deleted:$.deleted?new Set($.deleted):void 0})}}class N extends A{constructor($){super($,void 0)}async close(){this.dispose()}}e.$2Mb=N;class O extends A{constructor($,d){super($,d)}async close(){this.dispose()}}e.$3Mb=O;class k extends T{constructor($,d){super($,void 0,d),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$4Mb=k;class b{constructor($){this.a=$}isUsed($){const d={payload:$,profile:void 0,workspace:void 0};return this.a.call("isUsed",d)}}e.$5Mb=b}),define(he[109],ue([0,1,5,37,32]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=N,e.$up=O;function A(k){if(I.$v===I.Platform.Linux&&/^penguin(\.|$)/i.test(k))return"chromebook"}function N(k,b,R,$,d,g,l,m,E,f){const w=Object.create(null);w["common.machineId"]=g,w["common.sqmId"]=l,w["common.devDeviceId"]=m,w.sessionID=(0,T.$Zg)()+Date.now(),w.commitHash=$,w.version=d,w["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,I.$i)(I.$v),w["common.nodePlatform"]=c.$cc,w["common.nodeArch"]=R,w["common.product"]=f||"desktop",E&&(w["common.msftInternal"]=E);let P=0;const p=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),I.$m&&(w["common.snap"]="true");const o=A(b);return o&&(w["common.platformDetail"]=o),w}function O(k){const b=c.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return k.some($=>R===$)}}),define(he[18],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,I.$Di)("telemetryService"),e.$$l=(0,I.$Di)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var c;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var T;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(he[196],ue([0,1,33,38,6,36,22,13,5,54,9,142,30,149,97,7,23,18]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$Ws=P,e.$Xs=o,e.$Ys=u,I=Pe(I),c=Pe(c);const w=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=w.get(s);if(r)return r;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,y=new Map,L=2e4;function S(C,U,F,M){const G=U.substring(C.length+1);return T.Promises.withAsyncBody(async V=>{let _;M.readdirCount++;try{_=await d.Promises.readdir(U,{withFileTypes:!0})}catch{V();return}if(M.count>=L){M.count+=_.length,M.maxReached=!0,V();return}let H=_.length;if(H===0){V();return}let ie=_;M.count+_.length>L&&(M.maxReached=!0,H=L-M.count,ie=_.slice(0,H)),M.count+=_.length;for(const B of ie)if(B.isDirectory()){if(F.includes(B.name)||await S(C,(0,O.$ic)(U,B.name),F,M),--H===0){V();return}}else{const z=B.name.lastIndexOf(".");if(z>=0){const ee=B.name.substring(z+1);ee&&h.set(ee,(h.get(ee)??0)+1)}for(const ee of a)ee.relativePathPattern?.test(G)!==!1&&ee.filePattern.test(B.name)&&y.set(ee.tag,(y.get(ee.tag)??0)+1);if(--H===0){V();return}}})}const v=T.Promises.withAsyncBody(async C=>{const U={count:0,maxReached:!1,readdirCount:0},F=new b.$ee(!0);await S(n,n,t,U);const M=await u(n);C({configFiles:p(y),fileTypes:p(h),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:M,totalScanTime:F.elapsed(),totalReaddirCount:U.readdirCount})});return w.set(s,v),v}function p(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function o(){const n={os:`${c.type()} ${c.arch()} ${c.release()}`,memory:`${(c.totalmem()/m.$Gl.GB).toFixed(2)}GB (${(c.freemem()/m.$Gl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Qn.value()*100)}%`},t=c.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function u(n){try{const t=new Map,s=(0,O.$ic)(n,".vscode","launch.json"),r=await I.promises.readFile(s),a=[],h=(0,A.$Wn)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$5n)(h)==="object"&&h.configurations)for(const y of h.configurations){const L=y.type;L&&(t.has(L)?t.set(L,t.get(L)+1):t.set(L,1))}return p(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${c.type()} ${c.arch()} ${c.release()}`);const r=c.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(c.totalmem()/m.$Gl.GB).toFixed(2)}GB (${(c.freemem()/m.$Gl.GB).toFixed(2)}GB free)`),k.$j||s.push(`Load (avg):       ${c.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round($.$Qn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,g.$Vs)(t.mainPID),this.k(t)]).then(async r=>{let[a,h]=r,y=this.m(t,a);return s.forEach(L=>{if((0,l.$Sm)(L))y+=`
${L.errorMessage}`,h+=`
${L.errorMessage}`;else if(y+=`

Remote: ${L.hostName}`,L.processes&&(y+=`
${this.m(t,L.processes)}`),L.workspaceMetadata){h+=`
|  Remote: ${L.hostName}`;for(const S of Object.keys(L.workspaceMetadata)){const v=L.workspaceMetadata[S];let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),h+=`|    Folder (${S}): ${C}`,h+=this.h(v)}}}),{processInfo:y,workspaceInfo:h}})}async getSystemInfo(t,s){const{memory:r,vmHint:a,os:h,cpus:y}=o(),L={os:h,memory:r,cpus:y,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return k.$j||(L.load=`${c.loadavg().map(S=>Math.round(S)).join(", ")}`),k.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(t,s){const r=[];return(0,g.$Vs)(t.mainPID).then(async a=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,a)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(h=>{if((0,l.$Sm)(h))r.push(`
${h.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${h.hostName}`),r.push(this.f(h.machineInfo)),h.processes&&r.push(this.m(t,h.processes)),h.workspaceMetadata)for(const y of Object.keys(h.workspaceMetadata)){const L=h.workspaceMetadata[y];let S=`${L.fileCount} files`;L.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${y}): ${S}`),r.push(this.h(L))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let a=0;const h=(v,C)=>{const U=` ${v}(${C})`;a+U.length>60?(s.push(y),y="|                 ",a=y.length):a+=U.length,y+=U};let y="|      File types:";const L=10,S=t.fileTypes.length>L?L:t.fileTypes.length;for(let v=0;v<S;v++){const C=t.fileTypes[v];h(C.name,C.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",a=0,t.configFiles.forEach(v=>{h(v.name,v.count)}),s.push(y)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(C=>{const U=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;v+=U}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(h=>{const y=R.URI.revive(h);if(y.scheme===N.Schemas.file){const L=y.fsPath;r.push(P(L,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,O.$mc)(L)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${L} (${S.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(t,s){const r=new Map;t.windows.forEach(h=>r.set(h.pid,`window [${h.id}] (${h.title})`)),t.pidToNames.forEach(({pid:h,name:y})=>r.set(h,y));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,a,s,0),a.join(`
`)}n(t,s,r,a,h){const y=h===0;let L;y?L=a.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(a.pid)?L=s.get(a.pid):L=`${"  ".repeat(h)} ${a.name}`;const S=process.platform==="win32"?a.mem:c.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(S/m.$Gl.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(a.children)&&a.children.forEach(v=>this.n(t,s,r,v,h+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const a=R.URI.revive(r);if(a.scheme!==N.Schemas.file)continue;const h=a.fsPath;try{(await P(h,["node_modules",".git"])).fileTypes.forEach(L=>s.add(L.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=R.URI.revive(s);if(r.scheme!==N.Schemas.file)continue;const a=r.fsPath;try{const h=await P(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),h.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:h.totalScanTime,reachedLimit:h.maxFilesReached,fileCount:h.fileCount,readdirCount:h.totalReaddirCount})}catch{}}}};e.$Zs=i,e.$Zs=i=ve([x(0,f.$0l),x(1,E.$rk)],i)}),define(he[110],ue([0,1,8,4,10,18]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.ExtensionSignatureVerificationCode=e.$rq=void 0,e.$rq=(0,c.$Di)("IExtensionSignatureVerificationService");var N;(function(b){b.Success="Success",b.RequiredArgumentMissing="RequiredArgumentMissing",b.InvalidArgument="InvalidArgument",b.PackageIsUnreadable="PackageIsUnreadable",b.UnhandledException="UnhandledException",b.SignatureManifestIsMissing="SignatureManifestIsMissing",b.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",b.SignatureIsMissing="SignatureIsMissing",b.SignatureIsUnreadable="SignatureIsUnreadable",b.CertificateIsUnreadable="CertificateIsUnreadable",b.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",b.FileAlreadyExists="FileAlreadyExists",b.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",b.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",b.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",b.SignatureIsInvalid="SignatureIsInvalid",b.SignatureManifestIsInvalid="SignatureManifestIsInvalid",b.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",b.EntryIsMissing="EntryIsMissing",b.EntryIsTampered="EntryIsTampered",b.Untrusted="Untrusted",b.CertificateRevoked="CertificateRevoked",b.SignatureIsNotValid="SignatureIsNotValid",b.UnknownError="UnknownError",b.PackageIsInvalidZip="PackageIsInvalidZip",b.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class O extends Error{constructor(R){super(R),this.code=R}}e.$sq=O;let k=class{constructor(R,$){this.b=R,this.c=$}d(){return this.a||(this.a=new Promise((R,$)=>ae(["@vscode/vsce-sign"],async d=>R(d),$))),this.a}async verify(R,$,d,g){let l;const m=R.identifier.id;try{l=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,I.$9)(P)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const E=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${m}...`),f=await l.verify($,d,this.b.getLevel()===T.LogLevel.Trace)}catch(P){f={code:N.UnknownError,didExecute:!1,output:(0,I.$9)(P)}}const w=new Date().getTime()-E;if(this.b.info(`Extension signature verification result for ${m}: ${f.code}. Executed: ${f.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:R.version,code:f.code,internalCode:f.internalCode,duration:w,didExecute:f.didExecute,clientTargetPlatform:g}),f.code===N.Success)return!0;throw new O(f.code)}};e.$tq=k,e.$tq=k=ve([x(0,T.$$j),x(1,A.$0l)],k)}),define(he[111],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class I{constructor(A){this.b=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,{eventName:O,data:k}){return this.b.forEach(b=>b.log(O,k)),Promise.resolve(null)}}e.$Ngc=I;class c{constructor(A){this.b=A}log(A,N){return this.b.call("log",{eventName:A,data:N}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Ogc=c}),define(he[48],ue([0,1,29,12,105,109,18]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=R,e.$Dp=$,e.$Ep=d,e.$Fp=g,e.$Gp=m,e.$Hp=f,e.$Ip=w,e.$Jp=o;class O{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$vp=O;class k{constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=k,e.$xp=new k;class b{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$yp=b,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function R(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function $(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function d(u){const i=u.getValue(N.$gm),n=u.getValue(N.$hm);if(u.getValue(N.$im)===!1||n===!1)return N.TelemetryLevel.NONE;switch(i??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function g(u){const i={},n={},t={};E(u,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(u){if(!u)return"none";const i=(0,T.$gn)(u);return l.has(i)?i:"other"}function E(u,i,n=0,t){if(u)for(const s of Object.getOwnPropertyNames(u)){const r=u[s],a=t?t+s:s;Array.isArray(r)?i[a]=(0,I.$ho)(r):r instanceof Date?i[a]=r.toISOString():(0,c.$fg)(r)?n<2?E(r,i,n+1,a+"."):i[a]=(0,I.$ho)(r):i[a]=r}}function f(u,i){const n=u.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$up)(n)||t}function w(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function P(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const t=[];for(const h of i)for(;;){const y=h.exec(u);if(!y)break;t.push([y.index,h.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const h=r.exec(u);if(!h)break;const y=t.some(([L,S])=>h.index<S&&L<r.lastIndex);!s.test(h[0])&&!y&&(n+=u.substring(a,h.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<u.length&&(n+=u.substr(a)),n}function p(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(u))return`<REDACTED: ${n.label}>`;return u}function o(u,i){return(0,I.$eo)(u,n=>{if(n instanceof O||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=p(t),t}})}}),define(he[35],ue([0,1,26,27,34,5,9,8,37,48]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=R,e.$Mp=l,e.$Np=m,e.$Op=E,e.$Pp=f,e.$Qp=w,e.$Rp=P,e.$Sp=p,e.$Up=o,e.$Vp=i;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,I.$zf)(n.id,t.id)===0}const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new d(t.identifier,s,r)}static parse(t){const s=$.exec(t);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=T.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==T.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof d?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Lp=d;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=g.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function m(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function f(n,t){return E(m(n??T.$ln,t))}function w(n,t){const s=[],r=a=>{for(const h of s)if(h.some(y=>R(t(y),t(a))))return h;return null};for(const a of n){const h=r(a);h?h.push(a):s.push([a])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function p(n){return{id:new b.$vp(n.identifier.id),name:new b.$vp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Tp=new T.$pn("pprice.better-merge");function o(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&s.every(h=>!R(h.identifier,{id:a}))){const h=n.filter(y=>R(y.identifier,{id:a}));h.length===1&&(s.push(h[0]),r.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function u(n,t){if(!A.$l)return!1;let s;try{s=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,O.$9)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await u(n,t),r=(0,c.$fp)(s?"alpine":A.$v,k.$dc);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[197],ue([0,1,25,27,35,34]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=N;async function N(O,k,b,R,$){try{const d=await O.getExtensionsControlManifest();if(!d.deprecated)return;const g=await O.getInstalled(A.ExtensionType.User);for(const[l,m]of Object.entries(d.deprecated)){if(!m?.extension)continue;const{id:E,autoMigrate:f,preRelease:w}=m.extension;if(!f)continue;const P=g.find(o=>(0,T.$Kp)(o.identifier,{id:l}));if(!P)continue;const p=(await k.getExtensions([{id:E,preRelease:w}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!p){$.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{$.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const o=!R.getDisabledExtensions().some(i=>(0,T.$Kp)(i,P.identifier));await O.uninstall(P),$.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let u=g.find(i=>(0,T.$Kp)(i.identifier,{id:E}));(!u||!u.isPreReleaseVersion&&o)&&(u=await O.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:c.InstallOperation.Migrate}),$.info(`Installed the pre-release extension '${u.identifier.id}'`),o||(await R.disableExtension(u.identifier),$.info(`Disabled the pre-release extension '${u.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),f.storage&&(b.addToMigrationList((0,T.$Np)(P.manifest.publisher,P.manifest.name),(0,T.$Np)(u.manifest.publisher,u.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(o){$.error(o)}}}catch(d){$.error(d)}}}),define(he[198],ue([0,1,8,3,2,31,35,34,7]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class b extends T.$Tc{constructor($,d,g,l,m,E,f){super(),this.f=$,this.g=d,this.h=g,this.j=l,this.m=m,this.n=E,this.r=f,this.a=this.B(new c.$ke),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new T.$3c),this.s().then(null,w=>f.error("Error while initializing Extensions Watcher",(0,I.$9)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(d=>(this.c.set(d.id,(0,T.$Qc)(this.n.watch(this.m.extUri.dirname(d.extensionsResource)),this.n.watch(d.extensionsResource))),this.G(d.extensionsResource))))}catch(d){throw this.r.error(d),d}}async w($){for(const d of $.extensions)this.I(this.L(d.identifier,d.version),$.profileLocation)}async y($){for(const d of $.extensions){const g=this.L(d.identifier,d.version);$.error?this.J(g,$.profileLocation):this.I(g,$.profileLocation)}}async z($){for(const d of $.extensions)this.J(this.L(d.identifier,d.version),$.profileLocation)}async C($){const d=[],g=[];for(const l of $.extensions){const m=this.L(l.identifier,l.version);$.error?this.I(m,$.profileLocation):(this.J(m,$.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),g.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?d.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(g),d.length&&await this.H(d)}catch(l){this.r.error(l)}}D($){for(const d of this.h.profiles)$.contains(d.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(d.extensionsResource)}async F($){const d=[],g=[],l=await this.j.scanProfileExtensions($),m=new Set,E=new Set;for(const[f,w]of this.b)w.has($)&&E.add(f);for(const f of l){const w=this.L(f.identifier,f.version);m.add(w),E.has(w)||(d.push(f.identifier),this.I(w,$))}for(const f of E)if(!m.has(f)){const w=this.M(f);w&&(g.push(w.identifier),this.J(f,$))}(d.length||g.length)&&this.a.fire({added:d.length?{extensions:d,profileLocation:$}:void 0,removed:g.length?{extensions:g,profileLocation:$}:void 0})}async G($){const d=await this.j.scanProfileExtensions($);for(const g of d)this.I(this.L(g.identifier,g.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,d){let g=this.b.get($);g||this.b.set($,g=new A.$Ac(l=>this.m.extUri.getComparisonKey(l))),g.add(d)}J($,d){const g=this.b.get($);g&&g.delete(d),g?.size||this.b.delete($)}L($,d){return`${O.$pn.toKey($.id)}@${d}`}M($){const[d,g]=(0,N.$Mp)($);return g?{identifier:{id:d},version:g}:void 0}}e.$Vq=b}),define(he[199],ue([0,1,33,75,17,6,2,22,13,30,15,27,35,10,78,9]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0,I=Pe(I);let E=class extends l.$$r{constructor(p,o,u,i){super(u),this.h=p,this.j=i,this.g=this.B(new f(o,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(p,o){const i=(await this.g.getLanguagePacks())[o];if(!i){this.j.warn(`No language pack found for ${o}`);return}const n=i.translations[p];return n?m.URI.file(n):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),o=Object.keys(p).map(u=>{const i=p[u];return{...this.f(u,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((u,i)=>u.label.localeCompare(i.label)),o}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const o=await this.g.getLanguagePacks();Object.keys(o).some(u=>o[u]&&o[u].extensions.some(i=>(0,d.$Kp)(i.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(o);return!(0,T.$tb)(Object.keys(p),Object.keys(u))}};e.$_r=E,e.$_r=E=ve([x(0,$.$mp),x(1,R.$Li),x(2,$.$jp),x(3,g.$$j)],E);let f=class extends N.$Tc{constructor(p,o){super(),this.j=o,this.c={},this.f=(0,k.$ic)(p.userDataPath,"languagepacks.json"),this.g=new A.$Kh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(o=>{Object.keys(o).forEach(u=>delete o[u]),this.m(o,...p)}).then(()=>this.c)}m(p,...o){for(const u of o)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(p,u);Object.keys(p).forEach(u=>this.r(p[u]))}n(p,o){const u=o.identifier,i=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of i)if(o.location.scheme===O.Schemas.file&&w(n)){let t=p[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},p[n.languageId]=t);const s=t.extensions.filter(r=>(0,d.$Kp)(r.extensionIdentifier,u))[0];s?s.version=o.manifest.version:t.extensions.push({extensionIdentifier:u,version:o.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,k.$ic)(o.location.fsPath,r.path)}}r(p){if(p){const o=(0,c.createHash)("md5");for(const u of p.extensions)o.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);p.hash=o.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let o=null;return I.promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(o=p(u),u)).then(u=>{for(const n of Object.keys(u))u[n]||delete u[n];this.c=u,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>o,u=>this.j.error(u))})}};f=ve([x(0,R.$Li),x(1,g.$$j)],f);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const p of P.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(he[200],ue([0,1,140,8,29,48]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function k(R,$,d){const g=await(0,I.$AE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,I.$AE)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new g.AppInsightsCore,E=new l.PostChannel,f={instrumentationKey:R,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(d){f.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};f.extensionConfig[E.identifier]=w}return m.initialize(f,[]),m.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),m}class b{constructor($,d,g,l,m){this.e=$,this.f=d,this.g=g,this.h=m,this.c=N,this.d=O,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(d=>{$(d)},d=>{(0,c.$Y)(d),console.error(d)})}}log($,d){if(!this.a)return;d=(0,T.$fo)(d,this.g),d=(0,A.$Fp)(d);const g=this.f+"/"+$;try{this.i(l=>{l.pluginVersionString=d?.properties.version??"Unknown",l.track({name:g,baseData:{name:g,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$rR=b}),define(he[112],ue([0,1,2,11,15,10,23,48]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let k=class extends I.$Tc{constructor(R,$,d,g,l=""){super(),this.b=l;const m=$.getLogger(O.$zp);if(m)this.a=this.B(m);else{const f=(0,O.$Dp)(g,d)?" (Not Sent)":"",w=()=>(0,O.$Cp)(g,d)&&R.getLevel()===A.LogLevel.Trace;this.a=this.B($.createLogger(O.$zp,{name:(0,c.localize)(11160,null,f),hidden:!w()})),this.B(R.onDidChangeLogLevel(()=>$.setVisibility(O.$zp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,$){this.a.trace(`${this.b}telemetry/${R}`,(0,O.$Fp)($))}};e.$3dc=k,e.$3dc=k=ve([x(0,A.$$j),x(1,A.$_j),x(2,T.$Ki),x(3,N.$rk)],k)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[113],ue([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,w,P){this.k=w,this.l=P,this.d={},this.i=new I.$Sc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$gf)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$gf)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$gm)||p.affectsConfiguration(d.$im)||p.affectsConfiguration(d.$hm))&&this.m()}))}setExperimentProperty(f,w){this.d[f]=w}m(){let f=(0,g.$Ep)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?d.TelemetryLevel.USAGE:w.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,w,P){this.g<w||(P=(0,c.$fo)(P,this.d),P=(0,g.$Jp)(P,this.j),P=(0,c.$fo)(P,this.c),this.b.forEach(p=>p.log(f,P)))}publicLog(f,w){this.n(f,d.TelemetryLevel.USAGE,w)}publicLog2(f,w){this.publicLog(f,w)}publicLogError(f,w){this.h&&this.n(f,d.TelemetryLevel.ERROR,w)}publicLogError2(f,w){this.publicLogError(f,w)}};e.$fs=l,e.$fs=l=ve([x(1,O.$0i),x(2,R.$rk)],l);function m(){const E=(0,N.localize)(11142,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,N.localize)(11144,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,N.localize)(11143,null,"https://aka.ms/vscode-telemetry"),w=T.$p?"":(0,N.localize)(11145,null),P=(0,N.localize)(11146,null),p=(0,N.localize)(11147,null),o=(0,N.localize)(11148,null),u=(0,N.localize)(11149,null),i=`
|       | ${P} | ${p} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,N.localize)(11150,null);return`
${E} ${f} ${w}

&nbsp;

${u}
${i}

&nbsp;

${n}
`}$.$po.as(k.$uo.Configuration).registerConfiguration({id:d.$fm,order:1,type:"object",title:(0,N.localize)(11151,null),properties:{[d.$gm]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,N.localize)(11152,null),(0,N.localize)(11153,null),(0,N.localize)(11154,null),(0,N.localize)(11155,null)],markdownDescription:m(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),$.$po.as(k.$uo.Configuration).registerConfiguration({id:d.$fm,order:110,type:"object",title:(0,N.localize)(11156,null),properties:{[d.$im]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,N.localize)(11158,null,b.default.nameLong,b.default.privacyStatementUrl):(0,N.localize)(11157,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(11159,null,`\`#${d.$gm}#\``),scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[201],ue([0,1,14,25,244,200]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=void 0,T=Pe(T);async function N(R,$){const d=await $.request(R,c.CancellationToken.None),g=(await(0,I.$Ye)(d.stream)).toString(),l=d.res.statusCode??200;return{headers:d.res.headers,statusCode:l,responseData:g}}async function O(R){const $={method:R.type,headers:R.headers};return new Promise((g,l)=>{const m=T.request(R.url??"",$,E=>{E.on("data",function(f){g({headers:E.headers,statusCode:E.statusCode??200,responseData:f.toString()})}),E.on("error",function(f){l(f)})});m.write(R.data,E=>{E&&l(E)}),m.end()})}async function k(R,$,d){const g=typeof $.data=="string"?$.data:new TextDecoder().decode($.data),l={type:"POST",headers:{...$.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength($.data).toString()},url:$.urlString,data:g};try{const m=R?await N(l,R):await O(l);d(m.statusCode,m.headers,m.responseData)}catch{d(0,{})}}class b extends A.$rR{constructor($,d,g,l,m){const E={sendPOST:(f,w)=>{k($,f,w)}};super(d,g,l,m,E)}}e.$sR=b}),define(he[202],ue([0,1,22,95,21,15,10,23,18,111,112,113]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let d=class{constructor(l,m,E,f,w,P){this.b=l,this.c=m,this.d=E,this.e=f,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const m=Object.create(null);m["common.vscodemachineid"]=this.c.machineId,m["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(m),l.aiKey],w=new c.$gr(I.$Xg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new b.$Ogc(w),new R.$3dc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new $.$fs({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,m,E){this.h(l).publicLog(m,E)}publicLogError(l,m,E){this.h(l).publicLogError(m,E)}};e.$3hc=d,e.$3hc=d=ve([x(0,T.$0i),x(1,k.$0l),x(2,N.$$j),x(3,N.$_j),x(4,A.$Ki),x(5,O.$rk)],d)}),define(he[80],ue([0,1,3,2,5,9,21,4,10]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Jw=e.$Hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dw=e.$Cw=void 0,e.$Ew=$,e.$Fw=g,e.$Gw=l,e.$Iw=m,e.$Kw=E,e.$Lw=f,e.$Cw=(0,O.$Di)("tunnelService"),e.$Dw=(0,O.$Di)("sharedTunnelsService");var b;(function(p){p.Http="http",p.Https="https"})(b||(e.TunnelProtocol=b={}));var R;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(R||(e.TunnelPrivacyId=R={}));function $(p){return!!p.forwardPort}var d;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(o)return{address:o[1],port:+o[2]}}function l(p){if(p.scheme!=="http"&&p.scheme!=="https"||!p.query)return;const o=p.query.split("&");for(const u of o){const i=u.split("=")[1];if(/^https?:/.exec(i)){const n=g(A.URI.parse(i));if(n)return n}}}e.$Hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(p){return e.$Hw.indexOf(p)>=0}e.$Jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(p){return e.$Jw.indexOf(p)>=0}function f(p,o,u,i){if(u===T.OperatingSystem.Windows)return!1;if(u===T.OperatingSystem.Macintosh&&E(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return p<1024}class w{constructor(o,u,i){this.remoteAddress=o,this.localAddress=u,this.b=i,this.a=new I.$ke,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mw=w;let P=class extends c.$Tc{constructor(o,u){super(),this.r=o,this.s=u,this.a=new I.$ke,this.onTunnelOpened=this.a.event,this.b=new I.$ke,this.onTunnelClosed=this.b.event,this.c=new I.$ke,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const o=this.s.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.g=o,o?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.h=o.elevation,this.m=o.privacyOptions,this.j=o.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const o=[],u=Array.from(this.f.values());for(const i of u){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&o.push(s)}}return o}async dispose(){super.dispose();for(const o of this.f.values()){for(const{value:u}of o.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);o.clear()}this.f.clear()}setEnvironmentTunnel(o,u,i,n,t){this.z(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(E(o)||m(o))&&(o=e.$Hw[0]);const i=this.D(o,u);if(i)return++i.refcount,i.value}openTunnel(o,u,i,n,t,s=!1,r,a){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${t}.`);const h=this.g??o;if(!h)return;if(u||(u="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(h,u,i,n,t,s,r,a);return y?y.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&L.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.f.get(o.tunnelRemoteHost);if(u){const i=u.get(o.tunnelRemotePort);i&&(i.refcount--,await this.y(o.tunnelRemoteHost,o.tunnelRemotePort,i))}}}}async y(o,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(o)&&this.f.get(o).delete(u),n}}async closeTunnel(o,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const i=this.f.get(o);if(i&&i.has(u)){const n=i.get(u);n.refcount=0,await this.y(o,u,n)}}z(o,u,i){this.f.has(o)||this.f.set(o,new Map),this.f.get(o).set(u,{refcount:1,value:i})}async C(o,u){const i=this.f.get(o);if(i){const n=i.get(u),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(u),i.size===0&&this.f.delete(o)}}D(o,u){const i=[o];m(o)?(i.push(...e.$Hw),i.push(...e.$Jw)):E(o)&&i.push(...e.$Jw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(u);if(s)return s}}canTunnel(o){return!!g(o)}G(o,u,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${n}.`);const a=i;this.n.add(a);const h=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(h):!1},L={remoteAddress:{host:u,port:i},localAddressPort:n,privacy:s,public:s?s!==R.Private:void 0,protocol:r},S=o.forwardPort(L,y);return S?(this.z(u,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(a)})):this.n.delete(a),S}};e.$Nw=P,e.$Nw=P=ve([x(0,k.$$j),x(1,N.$0i)],P)}),define(he[203],ue([0,1,10,80,2,8,6]),function(ae,e,I,c,T,A,N){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class k extends T.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.$1h),this.b.p)}setAddress($){this.a=$,this.b&&(this.b.complete($),this.b=null)}setTunnel($){this.B($)}}let b=class extends T.$Tc{static{O=this}static{this.a=0}constructor($,d){super(),this.f=$,this.g=d,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach($=>$.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel($,d,g,l,m,E,f){const w=new k,P=await Promise.resolve(this.f.openTunnel($,w,g,l,m,E,f));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(d))throw this.c.delete(d),w.dispose(),await P.dispose(),(0,A.$5)();return w.setTunnel(P),this.b.set(d,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${P.localAddress} (local) to ${g}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress($,d){const g=this.b.get($);g&&g.setAddress(d)}async destroyTunnel($){const d=this.b.get($);if(d){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${$}.`),this.b.delete($),await d.dispose();return}this.c.add($)}};e.$aic=b,e.$aic=b=O=ve([x(0,c.$Dw),x(1,I.$$j)],b)}),define(he[28],ue([0,1,4]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,I.$Di)("IUriIdentityService")}),define(he[204],ue([0,1,28,160,7,20,135,3,2]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class b{static{this._clock=0}constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let R=class{constructor(d){this.g=d,this.c=new k.$Sc,this.f=2**16;const g=new Map,l=m=>{let E=g.get(m.scheme);return E===void 0&&(E=d.hasProvider(m)&&!this.g.hasCapability(m,T.FileSystemProviderCapabilities.PathCaseSensitive),g.set(m.scheme,E)),E};this.c.add(O.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(m=>{g.delete(m.scheme)})),this.extUri=new A.$6g(l),this.d=new N.$Rs((m,E)=>this.extUri.compare(m,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$fh)(d));const g=this.d.get(d);return g?g.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new b(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((l,m)=>l[1].time<m[1].time?1:l[1].time>m[1].time?-1:0);b._clock=0,this.d.clear();const g=this.f*.5;for(let l=0;l<g;l++)this.d.set(d[l][0],d[l][1].touch())}};e.$Ss=R,e.$Ss=R=ve([x(0,T.$$k)],R),(0,c.$Ps)(I.$Il,R,c.InstantiationType.Delayed)}),define(he[205],ue([0,1,3,2,7,51,31]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class O extends c.$Tc{constructor(b,R,$,d,g,l){super(),this.f=b,this.g=R,this.h=$,this.j=d,this.m=g,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$ke),this.onDidChangeFile=this.a.event,this.b=A.$Ji.forUris(()=>!(this.capabilities&T.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new N.$Ac(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,R){return this.g.open(this.t(b),R)}close(b){return this.g.close(b)}read(b,R,$,d,g){return this.g.read(b,R,$,d,g)}write(b,R,$,d,g){return this.g.write(b,R,$,d,g)}watch(b,R){this.b.set(b,b);const $=this.g.watch(this.t(b),R);return(0,c.$Rc)(()=>{this.b.delete(b),$.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,R,$){return this.g.rename(this.t(b),this.t(R),$)}readFile(b,R){return this.g.readFile(this.t(b),R)}readFileStream(b,R,$){return this.g.readFileStream(this.t(b),R,$)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,R,$){return this.g.writeFile(this.t(b),R,$)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,R){return this.g.delete(this.t(b),R)}copy(b,R,$){if((0,T.$cl)(this.g))return this.g.copy(this.t(b),this.t(R),$);throw new Error("copy not supported")}cloneFile(b,R){if((0,T.$dl)(this.g))return this.g.cloneFile(this.t(b),this.t(R));throw new Error("clone not supported")}s(b){const R=[];for(const $ of b){if($.resource.scheme!==this.f)continue;const d=this.u($.resource);this.b.findSubstr(d)&&R.push({resource:d,type:$.type,cId:$.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$Dhc=O}),define(he[81],ue([0,1,64]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$HMb=T,e.$IMb=A;function c(N,O,k,b){const R=(0,I.$$n)(N,O,k,b)[0];return R&&(N=N.substring(0,R.offset)+R.content+N.substring(R.offset+R.length)),N}function T(N,O,k){let b=k;for(;b>=0;){if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1)return b+1;if(b--,O.length===2&&b>=0&&N.charAt(b)===O.charAt(0))return b+2}return 0}function A(N,O,k){let b=k;for(;b>=0;)if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1||(b++,O.length===2&&b>=0&&N.charAt(b)===O.charAt(1)))return b;return N.length-1}}),define(he[206],ue([0,1,29,60,12]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=A,c=Pe(c);function A(g,l,m,E,f,w){const P=[],p=[],o=[];if(!l){const M=g.filter(({identifier:G})=>f.every(V=>V.toLowerCase()!==G.id.toLowerCase()));return{local:{added:P,removed:p,updated:o},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}g=g.map($),l=l.map($),m=m?m.map($):null;const u=new Map,i=M=>{M.uuid&&u.set(M.id.toLowerCase(),M.uuid)};g.forEach(({identifier:M})=>i(M)),l.forEach(({identifier:M})=>i(M)),m?.forEach(({identifier:M})=>i(M)),E?.forEach(({identifier:M})=>i(M)),w?.forEach(M=>i(M));const n=M=>{const G=M.identifier.uuid||u.get(M.identifier.id.toLowerCase());return G?`uuid:${G}`:`id:${M.identifier.id.toLowerCase()}`},t=(M,G)=>(M.set(n(G),G),M),s=g.reduce(t,new Map),r=l.reduce(t,new Map),a=l.reduce((M,G)=>t(M,(0,I.$co)(G)),new Map),h=m?m.reduce(t,new Map):null,y=E.reduce(t,new Map),L=f.reduce((M,G)=>{const V=u.get(G.toLowerCase());return M.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)},new Set),S=w?w.reduce((M,{id:G,uuid:V})=>(V=V??u.get(G.toLowerCase()),M.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)),new Set):null,v=N(s,r,L,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=N(h,s,L,!1),G=N(h,r,L,!0),V=(_,H,ie,B)=>{let z,ee,ne;return H.installed?(z=B.pinned,ne=B.preRelease,z&&(ee=B.version)):(z=ie.pinned,ne=ie.preRelease,z&&(ee=ie.version)),z===void 0&&(z=H.pinned,z&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...B,installed:H.installed||ie.installed,pinned:z,preRelease:ne,version:ee??(ie.version&&(!H.installed||c.gt(ie.version,H.version))?ie.version:H.version),state:k(H,ie,h?.get(_))}};for(const _ of G.removed.values()){const H=s.get(_);if(!H)continue;const ie=(0,T.$og)(h?.get(_)),B=S&&!S.has(_)&&ie.installed;H.installed&&B?p.push(H.identifier):a.set(_,H)}for(const _ of G.added.values()){const H=(0,T.$og)(r.get(_)),ie=s.get(_);if(ie){if(v.updated.has(_)){const B=V(_,ie,H,H);O(ie,H,!1,!1)||o.push(d(B,_)),a.set(_,B)}}else H.installed&&P.push(d(H,_))}for(const _ of G.updated.values()){const H=(0,T.$og)(r.get(_)),ie=(0,T.$og)(h?.get(_)),B=s.get(_);if(B)if(S&&!S.has(_)&&ie.installed&&B.installed&&!H.installed)p.push(B.identifier);else{const ee=V(_,B,H,H);o.push(d(ee,_)),a.set(_,ee)}else H.installed&&P.push(d(H,_))}for(const _ of M.added.values())G.added.has(_)||a.set(_,(0,T.$og)(s.get(_)));for(const _ of M.updated.values()){if(G.removed.has(_)||G.updated.has(_))continue;const H=(0,T.$og)(s.get(_)),ie=(0,T.$og)(r.get(_));a.set(_,V(_,H,ie,H))}for(const _ of M.removed.values())G.updated.has(_)||G.removed.has(_)||y.has(_)||(0,T.$og)(r.get(_)).installed&&S&&(S.has(_)||!(0,T.$og)(h?.get(_)).installed||a.delete(_))}const C=[],U=N(r,a,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&a.forEach((M,G)=>C.push(d(M,G))),{local:{added:P,removed:p,updated:o},remote:F?{added:[...U.added].map(M=>a.get(M)),updated:[...U.updated].map(M=>a.get(M)),removed:[...U.removed].map(M=>r.get(M)),all:C}:null}}function N(g,l,m,E){const f=g?[...g.keys()].filter(u=>!m.has(u)):[],w=[...l.keys()].filter(u=>!m.has(u)),P=w.filter(u=>!f.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),p=f.filter(u=>!w.includes(u)).reduce((u,i)=>(u.add(i),u),new Set),o=new Set;for(const u of f){if(p.has(u))continue;const i=g.get(u),n=l.get(u);(!n||!O(i,n,E,!0))&&o.add(u)}return{added:P,removed:p,updated:o}}function O(g,l,m,E){return!(g.disabled!==l.disabled||!!g.isApplicationScoped!=!!l.isApplicationScoped||E&&g.installed!==l.installed||g.installed&&l.installed&&(g.preRelease!==l.preRelease||g.pinned!==l.pinned||l.pinned&&g.version!==l.version)||!R(g.state,l.state)||m&&g.version!==l.version)}function k(g,l,m){const E=g.state,f=l.state,w=m?.state;if(!l.version||E&&c.gt(g.version,l.version))return E;if(f&&c.gt(l.version,g.version)||!E)return f;if(!f)return E;const P=(0,I.$co)(E),p=w?b(w,f):{added:Object.keys(f).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set},o=w?b(w,E):{added:Object.keys(E).reduce((u,i)=>(u.add(i),u),new Set),removed:new Set,updated:new Set};for(const u of[...p.added.values(),...p.updated.values()])P[u]=f[u];for(const u of p.removed.values())o.updated.has(u)||delete P[u];return P}function b(g,l){const m=Object.keys(g),E=Object.keys(l),f=E.filter(p=>!m.includes(p)).reduce((p,o)=>(p.add(o),p),new Set),w=m.filter(p=>!E.includes(p)).reduce((p,o)=>(p.add(o),p),new Set),P=new Set;for(const p of m){if(w.has(p))continue;const o=g[p],u=l[p];(0,I.$go)(o,u)||P.add(p)}return{added:f,removed:w,updated:P}}function R(g={},l={}){const{added:m,removed:E,updated:f}=b(g,l);return m.size===0&&E.size===0&&f.size===0}function $(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function d(g,l){const m={...g,identifier:{id:g.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled||delete m.disabled,g.installed||delete m.installed,g.state||delete m.state,g.isApplicationScoped||delete m.isApplicationScoped,m}}),define(he[114],ue([0,1,17,21,4]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YOb=e.$XOb=void 0,e.$XOb=(0,T.$Di)("IIgnoredExtensionsManagementService");let A=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==O&&R!==`-${O}`),k&&b.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==O&&R!==`-${O}`),k&&b.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(O){const k=O.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.b().map(d=>d.toLowerCase()),R=[],$=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?$.push(d.substring(1)):R.push(d);return(0,I.$Lb)([...k,...R].filter(d=>!$.includes(d)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$YOb=A,e.$YOb=A=ve([x(0,c.$0i)],A)}),define(he[207],ue([0,1,17,36,29,96,81]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=k,T=Pe(T),N=Pe(N);function O(p){return(0,c.$Wn)(p)||[]}async function k(p,o,u,i,n){const t=O(p),s=O(o),r=u?O(u):null,a=[...t,...s,...r||[]].map(V=>V.key),h=await n.resolveUserBindings(a),y=R(t,s,r,h);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const L=d(t),S=d(s),v=r?d(r):null,C=l(L,S,h),U=v?l(v,L,h):{added:[...L.keys()].reduce((V,_)=>(V.add(_),V),new Set),removed:new Set,updated:new Set},F=v?l(v,S,h):{added:[...S.keys()].reduce((V,_)=>(V.add(_),V),new Set),removed:new Set,updated:new Set},M=b(C,U,F);let G=p;for(const V of M.removed.values())M.conflicts.has(V)||(G=w(G,V,i));for(const V of M.added.values()){if(M.conflicts.has(V))continue;const _=S.get(V);if(_.some(H=>H.command!==`-${V}`&&y.conflicts.has(h[H.key]))){M.conflicts.add(V);continue}G=f(G,_,i)}for(const V of M.updated.values()){if(M.conflicts.has(V))continue;const _=S.get(V);if(_.some(H=>H.command!==`-${V}`&&y.conflicts.has(h[H.key]))){M.conflicts.add(V);continue}G=P(G,V,_,i)}return{mergeContent:G,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function b(p,o,u){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of o.removed.values())u.updated.has(r)&&s.add(r);for(const r of u.removed.values())s.has(r)||(o.updated.has(r)?s.add(r):n.add(r));for(const r of o.added.values())s.has(r)||u.added.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.added.values())s.has(r)||(o.added.has(r)?p.updated.has(r)&&s.add(r):i.add(r));for(const r of o.updated.values())s.has(r)||u.updated.has(r)&&p.updated.has(r)&&s.add(r);for(const r of u.updated.values())s.has(r)||(o.updated.has(r)?p.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function R(p,o,u,i){const n=new Set,t=$(p,i),s=$(o,i),r=u?$(u,i):null,a=g(t,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=r?g(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?g(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:L,removed:S,updated:v,conflicts:C}=b(a,h,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:S,updated:v,conflicts:C}}function $(p,o){const u=new Map;for(const i of p){const n=o[i.key];let t=u.get(n);t||(t=[],u.set(n,t)),t.push(i)}return u}function d(p){const o=new Map;for(const u of p){const i=u.command[0]==="-"?u.command.substring(1):u.command;let n=o.get(i);n||(n=[],o.set(i,n)),n.push(u)}return o}function g(p,o){const u=[...p.keys()],i=[...o.keys()],n=i.filter(r=>!u.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=u.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=new Set;for(const r of u){if(t.has(r))continue;const a=p.get(r).map(y=>({...y,key:r})),h=o.get(r).map(y=>({...y,key:r}));(0,I.$tb)(a,h,(y,L)=>E(y,L))||s.add(r)}return{added:n,removed:t,updated:s}}function l(p,o,u){const i=[...p.keys()],n=[...o.keys()],t=n.filter(a=>!i.includes(a)).reduce((a,h)=>(a.add(h),a),new Set),s=i.filter(a=>!n.includes(a)).reduce((a,h)=>(a.add(h),a),new Set),r=new Set;for(const a of i){if(s.has(a))continue;const h=p.get(a).map(L=>({...L,key:u[L.key]})),y=o.get(a).map(L=>({...L,key:u[L.key]}));m(h,y)||r.add(a)}return{added:t,removed:s,updated:r}}function m(p,o){return!(!(0,I.$tb)(p.filter(({command:u})=>u[0]!=="-"),o.filter(({command:u})=>u[0]!=="-"),(u,i)=>E(u,i))||!(0,I.$tb)(p.filter(({command:u})=>u[0]==="-"),o.filter(({command:u})=>u[0]==="-"),(u,i)=>E(u,i)))}function E(p,o){if(p.command!==o.command||p.key!==o.key)return!1;const u=A.$Bj.deserialize(p.when),i=A.$Bj.deserialize(o.when);return!(u&&!i||!u&&i||u&&i&&!u.equals(i)||!T.$go(p.args,o.args))}function f(p,o,u){for(const i of o)p=N.edit(p,[-1],i,u);return p}function w(p,o,u){const i=O(p);for(let n=i.length-1;n>=0;n--)(i[n].command===o||i[n].command===`-${o}`)&&(p=N.edit(p,[n],void 0,u));return p}function P(p,o,u,i){const n=O(p),t=n.findIndex(s=>s.command===o||s.command===`-${o}`);for(let s=n.length-1;s>=0;s--)(n[s].command===o||n[s].command===`-${o}`)&&(p=N.edit(p,[s],void 0,i));for(let s=u.length-1;s>=0;s--)p=N.edit(p,[t],u[s],i);return p}}),define(he[208],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=I,e.$Ucc=T;function I(A,N,O){const k={},b={},R=new Set;if(!N)return{local:{added:k,updated:b,removed:[...R.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const $=c(A,N);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{local:{added:k,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=c(O,A),g=c(O,N),l={},m={},E=new Set,f=new Set;for(const w of d.removed.values())g.updated.has(w)?k[w]=N[w]:E.add(w);for(const w of g.removed.values())f.has(w)||(d.updated.has(w)?f.add(w):R.add(w));for(const w of d.updated.values())f.has(w)||(g.updated.has(w)?$.updated.has(w)&&f.add(w):m[w]=A[w]);for(const w of g.updated.values())f.has(w)||(d.updated.has(w)?$.updated.has(w)&&f.add(w):A[w]!==void 0&&(b[w]=N[w]));for(const w of d.added.values())f.has(w)||(g.added.has(w)?$.updated.has(w)&&f.add(w):l[w]=A[w]);for(const w of g.added.values())f.has(w)||(d.added.has(w)?$.updated.has(w)&&f.add(w):k[w]=N[w]);return{local:{added:k,removed:[...R.values()],updated:b},remote:{added:l,removed:[...E.values()],updated:m},conflicts:[...f.values()]}}function c(A,N){const O=A?Object.keys(A):[],k=N?Object.keys(N):[],b=k.filter(d=>!O.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),R=O.filter(d=>!k.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),$=new Set;for(const d of O){if(R.has(d))continue;const g=A[d],l=N[d];g!==l&&$.add(d)}return{added:b,removed:R,updated:$}}function T(A,N){const{added:O,removed:k,updated:b}=c(A,N);return O.size===0&&k.size===0&&b.size===0}}),define(he[209],ue([0,1,29]),function(ae,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=c;function c(A,N,O,k){const b={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!N){const d=A.filter(({id:g})=>!k.includes(g));return d.length?R.added=d:R=null,{local:b,remote:R}}const $=T(A,N,k);if($.added.length>0||$.removed.length>0||$.updated.length>0){const d=T(O,A,k),g=T(O,N,k);for(const l of g.removed){const m=A.find(E=>E.id===l);m&&b.removed.push(m)}for(const l of g.added){const m=N.find(E=>E.id===l);d.added.includes(l)?$.updated.includes(l)&&b.updated.push(m):b.added.push(m)}for(const l of g.updated)b.updated.push(N.find(m=>m.id===l));for(const l of d.added)g.added.includes(l)||R.added.push(A.find(m=>m.id===l));for(const l of d.updated)g.removed.includes(l)||g.updated.includes(l)||R.updated.push(A.find(m=>m.id===l));for(const l of d.removed){const m=N.find(E=>E.id===l);m&&R.removed.push(m)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:b,remote:R}}function T(A,N,O){A=A?A.filter(({id:g})=>!O.includes(g)):[],N=N.filter(({id:g})=>!O.includes(g));const k=A.map(({id:g})=>g),b=N.map(({id:g})=>g),R=b.filter(g=>!k.includes(g)),$=k.filter(g=>!b.includes(g)),d=[];for(const{id:g,name:l,shortName:m,icon:E,useDefaultFlags:f}of A){if($.includes(g))continue;const w=N.find(P=>P.id===g);(!w||w.name!==l||w.shortName!==m||w.icon!==E||!(0,I.$go)(w.useDefaultFlags,f))&&d.push(g)}return{added:R,removed:$,updated:d}}}),define(he[24],ue([0,1,17,12,11,47,27,4,103,44]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nb=e.$Znb=e.$Ynb=e.$Xnb=e.$Wnb=e.$Vnb=e.$Unb=e.$Tnb=e.$Snb=e.$Qnb=e.MergeState=e.Change=e.SyncStatus=e.$Pnb=e.$Onb=e.$Nnb=e.UserDataSyncErrorCode=e.$Lnb=e.$Knb=e.$Jnb=e.$Inb=e.$Hnb=e.$Enb=e.SyncResource=e.$Bnb=e.$Anb=void 0,e.$xnb=R,e.$ynb=$,e.$znb=d,e.$Cnb=l,e.$Dnb=m,e.$Fnb=f,e.$Gnb=w,e.$Mnb=P,e.$Rnb=r;function R(){const a=b.$po.as(A.$uo.Configuration).getConfigurationProperties();return Object.keys(a).filter(h=>!!a[h].disallowSyncIgnore)}function $(a=!1){const h=b.$po.as(A.$uo.Configuration).getConfigurationProperties(),y=g(h,a),L=R();return(0,I.$Lb)([...y,...L])}function d(a){if(!a.contributes?.configuration)return[];const h=Array.isArray(a.contributes.configuration)?a.contributes.configuration:[a.contributes.configuration];if(!h.length)return[];const y=(0,A.$Ko)(h);return g(y,!1)}function g(a,h){const y=new Set;for(const L in a){if(h&&a[L].source)continue;const S=(0,c.$dg)(a[L].scope)?(0,A.$Lo)(a[L].scope):a[L].scope;(a[L].ignoreSync||S===A.ConfigurationScope.MACHINE||S===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(L)}return[...y.values()]}e.$Anb="settingsSync",e.$Bnb="settingsSync.keybindingsPerPlatform";function l(){const a="vscode://schemas/ignoredSettings",h=b.$po.as(A.$uo.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(11005,null),type:"object",properties:{[e.$Bnb]:{type:"boolean",description:(0,T.localize)(11006,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(11007,null),items:[{type:"string",pattern:N.$9o,errorMessage:(0,T.localize)(11008,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(11009,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$po.as(k.$qo.JSONContribution),L=()=>{const S=R(),v=$(),C=Object.keys(A.$vo.properties).filter(M=>!v.includes(M)),U=v.filter(M=>!S.includes(M)),F={items:{type:"string",enum:[...C,...U.map(M=>`-${M}`)]}};y.registerSchema(a,F)};return h.onDidUpdateConfiguration(()=>L())}function m(a){return a&&(0,c.$fg)(a)&&(0,c.$dg)(a.id)&&Array.isArray(a.scopes)}var E;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState",a.Profiles="profiles",a.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$Enb=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function f(a,...h){return a?[a,...h]:h}function w(a,h,y,L){return L.joinPath(y.userDataSyncHome,...f(a,h,`lastSync${h}.json`))}e.$Hnb=(0,O.$Di)("IUserDataSyncStoreManagementService"),e.$Inb=(0,O.$Di)("IUserDataSyncStoreService"),e.$Jnb=(0,O.$Di)("IUserDataSyncLocalStoreService"),e.$Knb="x-operation-id",e.$Lnb="X-Execution-Id";function P(a){const h={};return h[e.$Lnb]=a,h}var p;(function(a){a.Unauthorized="Unauthorized",a.Forbidden="Forbidden",a.NotFound="NotFound",a.MethodNotFound="MethodNotFound",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoCollection="NoCollection",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyProfiles="LocalTooManyProfiles",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class o extends Error{constructor(h,y,L,S){super(h),this.code=y,this.resource=L,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Nnb=o;class u extends o{constructor(h,y,L,S,v){super(h,L,void 0,v),this.url=y,this.serverCode=S}}e.$Onb=u;class i extends o{constructor(h,y){super(h,y)}}e.$Pnb=i,function(a){function h(y){if(y instanceof a)return y;const L=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(L&&L[1]){const S=L[2]==="unknown"?void 0:L[2],v=L[3]==="unknown"?void 0:L[3];return new a(y.message,L[1],S,v)}return new a(y.message,p.Unknown)}a.toUserDataSyncError=h}(o||(e.$Nnb=o={}));var n;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Qnb="sync.store.url.type";function r(a){return`sync.enable.${a}`}e.$Snb=(0,O.$Di)("IUserDataSyncEnablementService"),e.$Tnb=(0,O.$Di)("IUserDataSyncService"),e.$Unb=(0,O.$Di)("IUserDataSyncResourceProviderService"),e.$Vnb=(0,O.$Di)("IUserDataAutoSyncService"),e.$Wnb=(0,O.$Di)("IUserDataSyncUtilService"),e.$Xnb=(0,O.$Di)("IUserDataSyncLogService"),e.$Ynb="userDataSync",e.$Znb="vscode-userdata-sync",e.$1nb="preview"}),define(he[210],ue([0,1,29,24]),function(ae,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dOb=T,I=Pe(I);function T(N,O,k,b,R){if(!O)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const $=A(N,O);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=k?A(k,O):{added:Object.keys(O).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},g=k?A(k,N):{added:Object.keys(N).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},m=I.$co(O),E=!k;for(const w of g.added.values())w!==c.$Qnb&&E&&d.added.has(w)||(m[w]=N[w]);for(const w of g.updated.values())m[w]=N[w];for(const w of g.removed.values())b.unregistered.includes(w)||delete m[w];for(const w of d.added.values()){const P=O[w];if(b.machine.includes(w)){R.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(k&&g.added.has(w))continue;const p=N[w];p&&p.value===P.value||w===c.$Qnb&&E&&g.added.has(w)||(p?l.updated[w]=P:l.added[w]=P)}for(const w of d.updated.values()){const P=O[w];if(b.machine.includes(w)){R.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(w)||g.removed.has(w))continue;const p=N[w];p&&p.value===P.value||(l.updated[w]=P)}for(const w of d.removed.values()){if(b.machine.includes(w)){R.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}g.updated.has(w)||g.removed.has(w)||l.removed.push(w)}const f=A(O,m);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:m}}}function A(N,O){const k=Object.keys(N),b=Object.keys(O),R=b.filter(g=>!k.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),$=k.filter(g=>!b.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),d=new Set;for(const g of k){if($.has(g))continue;const l=N[g],m=O[g];I.$go(l,m)||d.add(g)}return{added:R,removed:$,updated:d}}}),define(he[211],ue([0,1,17,36,64,45,29,81,24]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JMb=b,e.$KMb=d,e.$LMb=g,e.$MMb=l,e.$NMb=E,e.$OMb=w,N=Pe(N),O=Pe(O);function b(a,h,y){let L=[];y?L=$(y):L=R(h);const S=[],v=[...(0,k.$xnb)()];if(Array.isArray(L))for(const C of L)C.startsWith("-")?v.push(C.substring(1)):S.push(C);return(0,I.$Lb)([...a,...S].filter(C=>!v.includes(C)))}function R(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function $(a){const h=(0,c.$Wn)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function d(a,h){const y=(0,c.$Wn)(a)||{};let L="{}";for(const S of Object.keys(y)){const v=(0,T.$$n)(L,[S],y[S],h);L=(0,T.$bo)(L,v)}return L}function g(a,h,y,L){if(y.length){const S=r(h),v=(0,c.$Wn)(h)||{},C=(0,c.$Wn)(a);if(!C)return a;const U=[];for(const F of y){const M=v[F],G=C[F];M===void 0?a=O.edit(a,[F],void 0,L):G!==void 0?a=O.edit(a,[F],M,L):U.push(u(F,S))}U.sort((F,M)=>F.startOffset-M.startOffset),U.forEach(F=>a=w(F.setting.key,h,a,L))}return a}function l(a,h,y,L,S,v){const C=g(a,h,L,v),U=y!==C,F=y!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:C,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:g(h,a,L,v),remoteContent:null,hasConflicts:!1};if(y===null&&E(a)){const D=m(a,h,L)?null:g(h,a,L,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let M=a,G=h;const V=(0,c.$Wn)(a),_=(0,c.$Wn)(h),H=y?(0,c.$Wn)(y):null,ie=L.reduce((D,X)=>(D.add(X),D),new Set),B=f(V,_,ie),z=f(H,V,ie),ee=f(H,_,ie),ne=new Map,le=new Set,te=D=>{le.add(D);const X=S.filter(({key:J})=>J===D)[0];X?(M=O.edit(M,[D],X.value,v),G=O.edit(G,[D],X.value,v)):ne.set(D,{key:D,localValue:V[D],remoteValue:_[D]})};for(const D of z.removed.values())ee.updated.has(D)?te(D):G=O.edit(G,[D],void 0,v);for(const D of ee.removed.values())le.has(D)||(z.updated.has(D)?te(D):M=O.edit(M,[D],void 0,v));for(const D of z.updated.values())le.has(D)||(ee.updated.has(D)?B.updated.has(D)&&te(D):G=O.edit(G,[D],V[D],v));for(const D of ee.updated.values())le.has(D)||(z.updated.has(D)?B.updated.has(D)&&te(D):M=O.edit(M,[D],_[D],v));for(const D of z.added.values())le.has(D)||(ee.added.has(D)?B.updated.has(D)&&te(D):G=w(D,M,G,v));for(const D of ee.added.values())le.has(D)||(z.added.has(D)?B.updated.has(D)&&te(D):M=w(D,G,M,v));const Q=ne.size>0||!m(M,G,L),K=Q||!m(M,a,[]),q=Q||!m(G,h,[]);return{localContent:K?M:null,remoteContent:q?G:null,conflictsSettings:[...ne.values()],hasConflicts:Q}}function m(a,h,y){if(a===h)return!0;const L=(0,c.$Wn)(a),S=(0,c.$Wn)(h),v=y.reduce((F,M)=>(F.add(M),F),new Set),C=r(a).filter(F=>!(F.setting&&v.has(F.setting.key))),U=r(h).filter(F=>!(F.setting&&v.has(F.setting.key)));if(C.length!==U.length)return!1;for(let F=0;F<C.length;F++){const M=C[F],G=U[F];if(M.setting&&G.setting){if(M.setting.key!==G.setting.key||!N.$go(L[M.setting.key],S[M.setting.key]))return!1}else if(!M.setting&&!G.setting){if(M.value!==G.value)return!1}else return!1}return!0}function E(a){return a?r(a).length===0:!0}function f(a,h,y){const L=a?Object.keys(a).filter(F=>!y.has(F)):[],S=Object.keys(h).filter(F=>!y.has(F)),v=S.filter(F=>!L.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),C=L.filter(F=>!S.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),U=new Set;if(a)for(const F of L){if(C.has(F))continue;const M=a[F],G=h[F];N.$go(M,G)||U.add(F)}return{added:v,removed:C,updated:U}}function w(a,h,y,L){const S=(0,c.$Wn)(h),v=r(h),C=r(y),U=P(a,v,C);return p(y,a,S[a],U,C,L)}function P(a,h,y){const L=h.findIndex(v=>v.setting?.key===a),S=h[L-1];if(S){if(S.setting){const C=u(S.setting.key,y);if(C)return{index:y.indexOf(C),insertAfter:!0}}else{const C=i(L,h);if(C){const U=u(C.setting.key,y);if(U){const F=n(y.indexOf(U),y),M=t(h,C,h[L]);if(F){const G=t(y,U,F),V=s(M,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const G=t(y,U,y[y.length-1]),V=s(M,G);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const v=h[L+1];if(v)if(v.setting){const C=u(v.setting.key,y);if(C)return{index:y.indexOf(C),insertAfter:!1}}else{const C=n(L,h);if(C){const U=u(C.setting.key,y);if(U){const F=i(y.indexOf(U),y),M=t(h,h[L],C);if(F){const G=t(y,F,U),V=s(M.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const G=t(y,y[0],U),V=s(M.reverse(),G.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(a,h,y,L,S,v){let C;return L.index===-1?C=(0,T.$$n)(a,[h],y,v):C=o(a,h,y,L,S,v).map(U=>(0,T.$_n)(a,U,v)[0]),(0,T.$bo)(a,C)}function o(a,h,y,L,S,v){const C=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,U=(0,A.$8n)(v,a),F=S[L.index];if(L.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+C});else{const G=n(L.index,S),V=i(L.index,S),_=V?.setting?.commaOffset;V&&_===void 0&&M.push({offset:V.endOffset,length:0,content:","});const H=_!==void 0&&_>F.endOffset;M.push({offset:H?_+1:F.endOffset,length:0,content:G?U+C+",":U+C})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:C+","}];const M=(S[L.index-1]&&!S[L.index-1].setting?U:"")+C+(n(L.index,S)?",":"")+U;return[{offset:F.startOffset,length:0,content:M}]}}function u(a,h){return h.filter(y=>y.setting?.key===a)[0]}function i(a,h){for(let y=a-1;y>=0;y--)if(h[y].setting)return h[y]}function n(a,h){for(let y=a+1;y<h.length;y++)if(h[y].setting)return h[y]}function t(a,h,y){const L=a.indexOf(h),S=a.indexOf(y);return a.filter((v,C)=>L<C&&C<S)}function s(a,h){if(a.length&&h.length){let y=0;for(;y<h.length&&y<a.length;y++)if(a[y].value!==h[y].value)return h[y-1];return h[y-1]}}function r(a){const h=[];let y=-1,L,S;const v={onObjectBegin:C=>{y++},onObjectProperty:(C,U,F)=>{y===0&&(L=U,S=C)},onObjectEnd:(C,U)=>{y--,y===0&&h.push({startOffset:L,endOffset:C+U,value:a.substring(L,C+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(C,U)=>{y++},onArrayEnd:(C,U)=>{y--,y===0&&h.push({startOffset:L,endOffset:C+U,value:a.substring(L,C+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(C,U,F)=>{y===0&&h.push({startOffset:L,endOffset:U+F,value:a.substring(L,U+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(C,U,F)=>{if(y===0&&C===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const G=h[M];G&&h.splice(M,1,{startOffset:G.startOffset,endOffset:G.endOffset,value:G.value,setting:{key:G.setting.key,commaOffset:U}})}},onComment:(C,U)=>{y===0&&h.push({startOffset:C,endOffset:C+U,value:a.substring(C,C+U)})}};return(0,c.$4n)(a,v),h}}),define(he[82],ue([0,1,3,2,4,24]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uMb=e.$tMb=void 0,e.$tMb=(0,T.$Di)("IUserDataSyncAccountService");let N=class extends c.$Tc{get account(){return this.a}constructor(k,b){super(),this.g=k,this.h=b,this.b=this.B(new I.$ke),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$ke),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$uMb=N,e.$uMb=N=ve([x(0,A.$Inb),x(1,A.$Xnb)],N)}),define(he[212],ue([0,1,20,11,15,10,24]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZOb=void 0;let O=class extends A.$dk{constructor(b,R){super(),this.g=this.B(b.createLogger((0,I.$eh)(R.logsHome,`${N.$Ynb}.log`),{id:N.$Ynb,name:(0,c.localize)(11004,null)}))}trace(b,...R){this.g.trace(b,...R)}debug(b,...R){this.g.debug(b,...R)}info(b,...R){this.g.info(b,...R)}warn(b,...R){this.g.warn(b,...R)}error(b,...R){this.g.error(b,...R)}flush(){this.g.flush()}};e.$ZOb=O,e.$ZOb=O=ve([x(0,A.$_j),x(1,T.$Ki)],O)}),define(he[213],ue([0,1,6,3,2]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class A extends T.$Tc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:k,getActiveWindowId:b}){super(),this.a=this.B(new T.$Sc),c.Event.latch(c.Event.any(O,k))(this.f,this,this.a),this.b=(0,I.$qh)(()=>b()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$9gc=A}),define(he[115],ue([0,1,11,13,51,20,9,4,22]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Xi=e.$Wi=e.WorkbenchState=e.$Qi=e.$Pi=e.$Mi=void 0,e.$Ni=b,e.$Oi=R,e.$Ri=$,e.$Si=d,e.$Ti=g,e.$Ui=m,e.$Vi=E,e.$Yi=P,e.$4i=p,e.$5i=o,e.$7i=u,e.$8i=i,e.$9i=n,e.$Mi=(0,O.$Di)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function R(t){return typeof t?.id=="string"&&!b(t)&&!d(t)}e.$Pi={id:"ext-dev"},e.$Qi={id:"empty-window"};function $(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,c.$mc)(t)}:s?e.$Pi:e.$Qi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function d(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function g(t){const s=t;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class f{constructor(s,r,a,h,y){this.h=s,this.j=a,this.k=h,this.l=y,this.c=T.$Ji.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=T.$Ji.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Wi=f;class w{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$eh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Xi=w;function P(t){return new w({uri:t,index:0,name:(0,A.$ah)(t)},{uri:t.toString()})}e.$Zi="code-workspace",e.$1i=`.${e.$Zi}`,e.$2i=[{name:(0,I.localize)(10975,null),extensions:[e.$Zi]}],e.$3i="workspace.json";function p(t,s){return A.$8g.isEqualOrParent(t,s.untitledWorkspacesHome)}function o(t){let s;return N.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===k.Schemas.tmp}e.$6i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(t){return t.id===e.$6i}function i(t,s){return!p(t,s)&&!o(t)}function n(t){return(typeof t=="string"?(0,c.$nc)(t):(0,A.$ch)(t))===e.$1i}}),define(he[19],ue([0,1,55,3,2,20,9,11,15,7,4,10,115,31,28,6,32,26,12]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=p,e.$Ll=o,e.$Ml=u;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$Kl=(0,R.$Di)("IUserDataProfilesService");function o(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:N.URI.revive(t.location).with({scheme:s}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function u(t,s,r,a,h,y){return{id:t,name:s,location:r,isDefault:!1,shortName:h?.shortName,icon:h?.icon,globalStorageHome:y&&h?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$eh)(r,"globalStorage"),settingsResource:y&&h?.useDefaultFlags?.settings?y.settingsResource:(0,A.$eh)(r,"settings.json"),keybindingsResource:y&&h?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$eh)(r,"keybindings.json"),tasksResource:y&&h?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$eh)(r,"tasks.json"),snippetsHome:y&&h?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$eh)(r,"snippets"),extensionsResource:y&&h?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$eh)(r,"extensions.json"),cacheHome:(0,A.$eh)(a,t),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}let i=class extends T.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,a,h){super(),this.t=s,this.u=r,this.w=a,this.y=h,this.f=!0,this.h=this.B(new c.$ke),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$ke),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$ke),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$ke),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$zc,workspaces:new g.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$eh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$eh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,w.$dg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(u((0,A.$bh)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const a=new g.$zc,h=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[L,S]of Object.entries(y.workspaces)){const v=N.URI.parse(L),C=r.find(U=>U.id===S);C&&a.set(v,C)}if(y.emptyWindows)for(const[L,S]of Object.entries(y.emptyWindows)){const v=r.find(C=>C.id===S);v&&h.set(L,v)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:h}}return this.z}D(){const s=u("__default__profile__",(0,O.localize)(11022,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",a=new RegExp(`${(0,f.$gf)(r)}\\s(\\d+)`);let h=0;for(const L of this.profiles){const S=a.exec(L.name),v=S?parseInt(S[1]):0;h=v>h?v:h}const y=`${r} ${h+1}`;return this.createProfile((0,I.$rj)((0,E.$Zg)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,a){return this.createProfile((0,I.$rj)((0,E.$Zg)()).toString(16),s,r,a)}async createProfile(s,r,a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,a);return h&&await this.setProfileForWorkspace(h,y),y}async F(s,r,a){if(!(0,w.$dg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.r.get(r);return h||(h=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const L=u(s,r,(0,A.$eh)(this.profilesHome,s),this.g,a,this.defaultProfile);await this.u.createFolder(L.location);const S=[];return this.j.fire({profile:L,join(v){S.push(v)}}),await m.Promises.settled(S),this.I([L],[],[]),L}finally{this.r.delete(r)}})(),this.r.set(r,h)),h}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(h=>h.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);return a=u(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(h=>h.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const a=[];this.m.fire({profile:r,join(h){a.push(h)}});try{await Promise.allSettled(a)}catch(h){this.y.error(h)}for(const h of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(h)?.id&&this.C.emptyWindows.delete(h);for(const h of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(h)?.id&&this.C.workspaces.delete(h);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(h){(0,b.$pl)(h)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(h)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(h=>h.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,a)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),a=N.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return a||((0,d.$Ni)(s)?this.s.folders.get(s.uri):(0,d.$Si)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,d.$Ni)(s)?s.uri:(0,d.$Si)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,a){const h=[...this.profiles,...s],y=[],L=this.s.profiles;this.s.profiles=[];for(let S of h){if(S.isDefault||r.some(C=>S.id===C.id))continue;S=a.find(C=>S.id===C.id)??S;const v=L.find(C=>S.id===C.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[C,U]of this.s.emptyWindows.entries())if(S.id===U.id){this.L({id:C},S);break}for(const[C,U]of this.s.workspaces.entries())if(S.id===U.id){this.L({id:"",configPath:C},S);break}for(const[C,U]of this.s.folders.entries())if(S.id===U.id){this.L({id:"",uri:C},S);break}}y.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(s,r,a)}J(s,r,a){this.h.fire({added:s,removed:r,updated:a,all:this.profiles})}L(s,r,a){if(a=r?.isTransient?!0:a,a)(0,d.$Ni)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,d.$Si)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const h=this.G(s);N.URI.isUri(h)?(this.C.workspaces.delete(h),r&&this.C.workspaces.set(h,r)):(this.C.emptyWindows.delete(h),r&&this.C.emptyWindows.set(h,r)),this.M()}}M(){const s={};for(const[a,h]of this.C.workspaces.entries())s[a.toString()]=h.id;const r={};for(const[a,h]of this.C.emptyWindows.entries())r[a.toString()]=h.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},a=this.D();if(s.workspaces)for(const[y,L]of Object.entries(s.workspaces)){const S=N.URI.parse(L);r[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const h={};if(s.emptyWindows)for(const[y,L]of Object.entries(s.emptyWindows)){const S=N.URI.parse(L);h[y]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:h}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Nl=i,e.$Nl=i=ve([x(0,k.$Ki),x(1,b.$$k),x(2,l.$Il),x(3,$.$$j)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Ol=n}),define(he[214],ue([0,1,6,2,19]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;let A=class extends c.$Tc{constructor(O){super(),this.B(new I.$Ph(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$cic=A,e.$cic=A=ve([x(0,T.$Kl)],A)}),define(he[83],ue([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=void 0,e.$Eq=i,d=Pe(d);let u=class extends O.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,a,h,y,L,S){super(),this.z=r,this.C=a,this.D=h,this.F=y,this.G=L,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$ke),this.s=this.B(new N.$ke),this.t=this.B(new N.$ke),this.u=this.B(new N.$ke),this.w=this.B(new N.$ke),this.y=[],this.B((0,O.$Rc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const a=await this.getTargetPlatform();return r.allTargetPlatforms.some(h=>(0,g.$hp)(h,r.allTargetPlatforms,a))}async installFromGallery(r,a={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:a}])).find(({identifier:L})=>(0,l.$Kp)(L,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new g.$lp(`Unknown error while installing extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(h){throw i(h)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new g.$lp(d.localize(11448,null),g.ExtensionManagementErrorCode.NotAllowed);const a=[],h=[];return await Promise.allSettled(r.map(async({extension:y,options:L})=>{try{const S=await this.N(y,!!L?.installGivenVersion,!!L?.installPreReleaseVersion,L.productVersion??{version:this.G.version,date:this.G.date});h.push({...S,options:L})}catch(S){a.push({identifier:y.identifier,operation:g.InstallOperation.Install,source:y,error:S,profileLocation:L.profileLocation??this.W()})}})),h.length&&a.push(...await this.I(h)),a}async uninstall(r,a){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:a}])}async toggleAppliationScope(r,a){if((0,m.$sn)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let h=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(h=await this.Z(r,this.H.defaultProfile.extensionsResource,a));for(const y of this.H.profiles){const L=(await this.getInstalled(m.ExtensionType.User,y.extensionsResource)).find(S=>(0,l.$Kp)(S.identifier,r.identifier));L?this.w.fire({local:L,profileLocation:y.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return h}else{const h=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:h.identifier,operation:g.InstallOperation.Install,local:h,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),h}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async a=>{const h=await this.getInstalled(m.ExtensionType.User,a.extensionsResource);await this.L(h.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},a.extensionsResource)}))}))}catch(a){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$9)(a)),a}}async I(r){const a=new Map,h=new Map,y=[],L=(v,C)=>`${l.$Lp.create(v).toString()}-${C.toString()}`,S=(v,C,U,F)=>{const M=this.X(v,C,U),G=`${(0,l.$Pp)(v.publisher,v.name)}-${U.profileLocation.toString()}`;h.set(G,{task:M,root:F}),this.n.fire({identifier:M.identifier,source:C,profileLocation:U.profileLocation}),this.F.info("Installing extension:",M.identifier.id,U),$.URI.isUri(C)||this.j.set(L(C,U.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:v,extension:C,options:U}of r){const F=U.isApplicationScoped||U.isBuiltin||(0,m.$sn)(v),M={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!$.URI.isUri(C),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.W(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},G=$.URI.isUri(C)?void 0:this.j.get(L(C,M.profileLocation));G?(this.F.info("Extension is already requested to install",G.task.identifier.id,M.profileLocation.toString()),y.push(G.task.waitUntilTaskIsFinished())):S(v,C,M,void 0)}return await Promise.all([...h.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const C=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),U=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),F={...v.options,context:{...v.options.context,[g.$bp]:!0}};for(const{gallery:M,manifest:G}of(0,I.$Lb)(C,({gallery:V})=>V.identifier.id)){if(h.has(`${M.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const V=this.j.get(L(M,F.profileLocation));if(V){if(this.J(v,V.task)){const _=V.task.identifier;this.F.info("Waiting for already requested installing extension",_.id,v.identifier.id,F.profileLocation.toString()),V.waitingTasks.push(v),y.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,H=>H.some(ie=>(0,l.$Kp)(ie.identifier,_)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",_.id,v.identifier.id,F.profileLocation.toString()),!H.find(B=>(0,l.$Kp)(B.identifier,_))?.local)throw new Error(`Extension ${_.id} is not installed`)}))}}else U.some(({identifier:_})=>(0,l.$Kp)(_,M.identifier))||S(G,M,F,v)}}catch(C){if($.URI.isUri(v.source))(0,I.$Kb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,C.message),(0,I.$Kb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,C.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),C}})),await this.L([...h.entries()].map(async([v,{task:C}])=>{const U=new Date().getTime();let F;try{F=await C.run(),await this.L(this.y.map(M=>M.postInstall(F,C.source,C.options,T.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(M){const G=i(M);throw $.URI.isUri(C.source)||n(this.C,C.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Sp)(C.source),error:G,source:C.options.context?.[g.$ap]}),a.set(v,{error:G,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:C.options.isApplicationScoped}),this.F.error("Error while installing the extension",C.identifier.id,(0,A.$9)(G),C.options.profileLocation.toString()),G}if(!$.URI.isUri(C.source)){const M=C.operation===g.InstallOperation.Update,G=M?void 0:(new Date().getTime()-C.source.lastUpdated)/1e3;if(n(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Sp)(C.source),verificationStatus:C.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:G,source:C.options.context?.[g.$ap]}),b.$p&&C.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,g.StatisticType.Install)}catch{}}a.set(v,{local:F,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:F.isApplicationScoped})})),y.length&&await this.L(y),[...a.values()]}catch(v){const C=(M,G,V)=>{const _=[];M.manifest.extensionDependencies?.length&&_.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&_.push(...M.manifest.extensionPack);for(const H of _){if(V.includes(H.toLowerCase()))continue;V.push(H.toLowerCase());const ie=a.get(`${H.toLowerCase()}-${G.toString()}`);ie?.local&&(V=C(ie.local,G,V))}return V},U=M=>({identifier:M.identifier,operation:g.InstallOperation.Install,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,error:v}),F=[];for(const[M,{task:G,root:V}]of h){const _=a.get(M);_?_.local&&V&&!a.get(`${V.identifier.id.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local&&(F.push(this.Y(_.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),a.set(M,U(G))):(G.cancel(),a.set(M,U(G)))}for(const[M,{task:G}]of h){const V=a.get(M);if(!V?.local||G.options.donotIncludePackAndDependencies)continue;C(V.local,G.options.profileLocation,[V.local.identifier.id.toLowerCase()]).slice(1).some(H=>h.has(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)&&!a.get(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local)&&(F.push(this.Y(V.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),a.set(M,U(G)))}throw F.length&&await Promise.allSettled(F.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(G){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,A.$9)(G))}})),v}finally{for(const{task:v}of h.values())v.source&&!$.URI.isUri(v.source)&&this.j.delete(L(v.source,v.options.profileLocation));if(a.size){const v=[...a.values()];for(const C of v)C.local&&this.F.info("Extension installed successfully:",C.identifier.id,C.profileLocation.toString());this.s.fire(v)}}}J(r,a){for(const[,{task:h,waitingTasks:y}]of this.j.entries())if(h===r&&(y.includes(a)||y.some(L=>this.J(L,a)))||h===a&&y[0]&&!this.J(r,y[0]))return!1;return!0}async L(r,a){const h=[],y=[],L=await Promise.allSettled(r);for(const v of L)v.status==="fulfilled"?h.push(v.value):y.push(i(v.reason,a));if(!y.length)return h;if(y.length===1)throw y[0];let S=new g.$lp("",g.ExtensionManagementErrorCode.Unknown);for(const v of y)S=new g.$lp(S.message?`${S.message}, ${v.message}`:v.message,v.code!==g.ExtensionManagementErrorCode.Unknown&&v.code!==g.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,a,h,y,L,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,L,S),C=[],U=[],F=async(M,G)=>{C.push(M);const V=G.extensionDependencies||[],_=[...V];if(G.extensionPack){const H=h?v.find(ie=>(0,l.$Kp)(ie.identifier,M)):void 0;for(const ie of G.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(B=>(0,l.$Kp)({id:B},{id:ie}))||_.every(B=>!(0,l.$Kp)({id:B},{id:ie}))&&_.push(ie)}if(_.length){const H=_.filter(ie=>C.every(B=>!(0,l.$Kp)(B,{id:ie})));if(H.length){const ie=await this.z.getExtensions(H.map(B=>({id:B,preRelease:y})),T.CancellationToken.None);for(const B of ie){if(C.find(ne=>(0,l.$Kp)(ne,B.identifier)))continue;const z=V.some(ne=>(0,l.$Kp)({id:ne},B.identifier));let ee;try{ee=await this.N(B,!1,y,S)}catch(ne){if(z)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$9)(ne));continue}U.push({gallery:ee.extension,manifest:ee.manifest}),await F(ee.extension.identifier,ee.manifest)}}}};return await F(r,a),U}async N(r,a,h,y){let L;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,l.$Kp)(r.identifier,U)))throw new g.$lp(d.localize(11449,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},T.CancellationToken.None))[0],!L)throw new g.$lp(d.localize(11450,null,r.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const U=await this.getTargetPlatform();throw new g.$lp(d.localize(11451,null,r.identifier.id,this.G.nameLong,(0,g.$dp)(U)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.O(r,a,h,y),!L){const U=[];throw(0,E.$5p)(r.properties.enabledApiProposals??[],U)?!h&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],T.CancellationToken.None))[0]?new g.$lp(d.localize(11453,null,r.displayName??r.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$lp(d.localize(11454,null,r.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$lp(d.localize(11452,null,r.displayName??r.identifier.id,U[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",L.identifier.id);const C=await this.z.getManifest(L,T.CancellationToken.None);if(C===null)throw new g.$lp(`Missing manifest for extension ${L.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(C.version!==L.version)throw new g.$lp(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:C}}async O(r,a,h,y){const L=await this.getTargetPlatform();let S=null;return!a&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==h&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:h}],{targetPlatform:L,compatible:!0,productVersion:y},T.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,h,L,y)&&(S=r),S||(a?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:L,compatible:!0,productVersion:y},T.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,h,L,y)),S}async uninstallExtensions(r){const a=(U,F)=>`${U.identifier.id.toLowerCase()}${F.versionOnly?`-${U.manifest.version}`:""}@${F.profileLocation.toString()}`,h=(U,F)=>{const M=this.Y(U,F);return this.m.set(a(M.extension,F),M),this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),this.t.fire({identifier:U.identifier,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped}),M},y=(U,F,M)=>{M?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString(),M.message):this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Rp)(U),error:M}),this.u.fire({identifier:U.identifier,error:M?.code,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped})},L=[],S=[],v=[],C=new k.$zc;for(const{extension:U,options:F}of r){const M={...F,profileLocation:U.isApplicationScoped?this.H.defaultProfile.extensionsResource:F?.profileLocation??this.W()},G=this.m.get(a(U,M));G?(this.F.info("Extensions is already requested to uninstall",U.identifier.id),v.push(G.waitUntilTaskIsFinished())):L.push(h(U,M))}try{for(const U of L.slice(0)){let F=C.get(U.options.profileLocation);if(F||C.set(U.options.profileLocation,F=await this.getInstalled(m.ExtensionType.User,U.options.profileLocation)),U.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${U.extension.identifier.id}@${U.extension.manifest.version}`);else{const M=this.R(U.extension,F);for(const G of M)this.m.has(a(G,U.options))?this.F.info("Extensions is already requested to uninstall",G.identifier.id):L.push(h(G,U.options))}U.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${U.extension.identifier.id}@${U.extension.manifest.version}`):this.P(L.map(M=>M.extension),F,U.extension)}await this.L(L.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,U.options,T.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(F){const M=i(F);throw y(U.extension,U.options,M),M}finally{S.push(U)}})),v.length&&await this.L(v);for(const U of L)y(U.extension,U.options)}catch(U){const F=i(U);for(const M of L){try{M.cancel()}catch{}S.includes(M)||y(M.extension,M.options,F)}throw F}finally{for(const U of L)this.m.delete(a(U.extension,U.options))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}P(r,a,h){for(const y of r){const L=this.S(y,a);if(L.length){const S=L.filter(v=>!r.some(C=>(0,l.$Kp)(C.identifier,v.identifier)));if(S.length)throw new Error(this.Q(y,S,h))}}}Q(r,a,h){return h===r?a.length===1?d.localize(11455,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?d.localize(11456,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):d.localize(11457,null,h.manifest.displayName||h.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?d.localize(11458,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?d.localize(11459,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):d.localize(11460,null,h.manifest.displayName||h.manifest.name,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}R(r,a,h=[]){if(h.indexOf(r)!==-1)return[];h.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const L=a.filter(v=>!v.isBuiltin&&y.some(C=>(0,l.$Kp)({id:C},v.identifier))),S=[];for(const v of L)S.push(...this.R(v,a,h));return[...L,...S]}return[]}S(r,a){return a.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(y=>(0,l.$Kp)({id:y},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$9)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Dq=u,e.$Dq=u=ve([x(0,g.$jp),x(1,P.$0l),x(2,p.$Il),x(3,f.$$j),x(4,w.$rk),x(5,o.$Kl)],u);function i(s,r){if(s instanceof g.$lp)return s;let a;return s instanceof g.$kp?a=new g.$lp(s.message,s.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):a=new g.$lp(s.message,(0,A.$3)(s)?g.ExtensionManagementErrorCode.Cancelled:r??g.ExtensionManagementErrorCode.Internal),a.stack=s.stack,a}function n(s,r,{extensionData:a,verificationStatus:h,duration:y,error:L,source:S,durationSinceUpdate:v}){let C,U;(0,R.$lg)(h)&&(h===!0?h="Verified":(h===!1||(C=g.ExtensionManagementErrorCode.Signature,U=h),h="Unverified")),L&&(C=L.code,L.code===g.ExtensionManagementErrorCode.Signature&&(U=L.message)),s.publicLog(r,{...a,verificationStatus:h,success:!L,duration:y,errorcode:C,errorcodeDetail:U,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new c.$Ch}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$qh)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$qh)(r=>new Promise((a,h)=>{const y=r.onCancellationRequested(()=>{y.dispose(),h(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$Fq=t}),define(he[52],ue([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Gq=P,e.$Hq=(0,$.$Di)("IExtensionsProfileScannerService");let p=class extends T.$Tc{constructor(n,t,s,r,a,h){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=a,this.t=h,this.b=this.B(new A.$ke),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ke),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ke),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ke),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],a=[];try{return await this.u(t,h=>{const y=[];if(s)y.push(...h);else for(const L of h)n.some(([S])=>(0,b.$Kp)(S.identifier,L.identifier)&&S.manifest.version!==L.version)?r.push(L):y.push(L);for(const[L,S]of n){const v=y.findIndex(U=>(0,b.$Kp)(U.identifier,L.identifier)&&U.version===L.manifest.version),C={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:S};v===-1?(a.push(C),y.push(C)):y.splice(v,1,C)}return a.length&&this.b.fire({extensions:a,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),a.length&&this.c.fire({extensions:a,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),a}catch(h){throw a.length&&this.c.fire({extensions:a,error:h,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:h,profileLocation:t}),h}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const a=[];for(const h of r){const y=n.find(([L])=>(0,b.$Kp)(L.identifier,h.identifier)&&L.manifest.version===h.version);y&&(h.metadata={...h.metadata,...y[1]},s.push(h)),a.push(h)}return a}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const a=[];for(const h of r)(0,b.$Kp)(h.identifier,n.identifier)?s.push(h):a.push(h);return s.length&&this.f.fire({extensions:s,profileLocation:t}),a}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],a;try{const h=await this.m.readFile(n);a=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,R.$pl)(h)!==R.FileOperationResult.FILE_NOT_FOUND)throw h;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&s?.bailOutWhenFileNotFound)throw new P((0,E.$9)(h),w.ERROR_PROFILE_NOT_FOUND)}if(a){Array.isArray(a)||this.w(n);let h=!1;for(const y of a){o(y)||this.w(n);let L;if((0,m.$dg)(y.relativeLocation)&&y.relativeLocation)L=this.z(y.relativeLocation);else if((0,m.$dg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{L=O.URI.revive(y.location);const S=this.y(L);S&&(h=!0,y.relativeLocation=S)}(0,m.$kg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(h=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:L,version:y.version,metadata:y.metadata})}h&&await this.m.writeFile(n,c.$Me.fromString(JSON.stringify(a)))}if(t){r=t(r);const h=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,c.$Me.fromString(JSON.stringify(h)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(a){if((0,R.$pl)(a)===R.FileOperationResult.FILE_NOT_FOUND)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(s);Array.isArray(a)&&a.every(h=>o(h))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Me.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,R.$pl)(a)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,R.$pl)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}try{await this.m.del(t)}catch(a){(0,R.$pl)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new I.$Kh,this.h.set(n,t)),t}};e.$Iq=p,e.$Iq=p=ve([x(1,R.$$k),x(2,g.$Kl),x(3,l.$Il),x(4,f.$0l),x(5,d.$$j)],p);function o(i){return(0,m.$fg)(i)&&(0,k.$ip)(i.identifier)&&(u(i.location)||(0,m.$dg)(i.location)&&i.location)&&((0,m.$kg)(i.relativeLocation)||(0,m.$dg)(i.relativeLocation))&&i.version&&(0,m.$dg)(i.version)}function u(i){return i?(0,m.$dg)(i.path)&&(0,m.$dg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[84],ue([0,1,17,6,29,14,8,36,152,2,22,13,5,20,60,92,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,157]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=G,T=Pe(T),$=Pe($),d=Pe(d),l=Pe(l),m=it(m);var v;(function(_){function H(ie,B){if(ie===B)return!0;const z=Object.keys(ie),ee=new Set;for(const ne of Object.keys(B))ee.add(ne);if(z.length!==ee.size)return!1;for(const ne of z){if(ie[ne]!==B[ne])return!1;ee.delete(ne)}return ee.size===0}_.equals=H})(v||(e.Translations=v={})),e.$Lq=(0,n.$Di)("IExtensionsScannerService");let C=class extends b.$Tc{constructor(H,ie,B,z,ee,ne,le,te,Q,K,q,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=ie,this.r=B,this.s=z,this.t=ee,this.u=ne,this.w=le,this.y=te,this.z=Q,this.C=K,this.D=q,this.F=D,this.g=this.B(new r.$ke),this.onDidChangeCache=this.g.event,this.h=(0,g.$eh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(H,ie,B){const[z,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(ie)]),ne=B?await this.scanExtensionsUnderDevelopment(H,[...z,...ee]):[];return this.L(z,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const ie=[];ie.push(this.M(!!H.useCache,H.language)),ie.push(this.N(H.language,!!H.checkControlFile));const[B,z]=await Promise.all(ie);return this.J([...B,...z],o.ExtensionType.System,H,!1)}async scanUserExtensions(H){const ie=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!H.profileLocation,o.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),ee=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(z)}catch(le){if(le instanceof h.$Gq&&le.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await ee.scanExtensions(z);else throw le}return ne=await this.J(ne,o.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===R.Schemas.file).map(async z=>{const ee=await this.P(z,!1,o.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(le=>(le.type=ie.find(te=>(0,p.$Kp)(te.identifier,le.identifier))?.type??le.type,this.n.validate(le,ee)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,ie,B){const z=await this.P(H,!1,ie,!0,B.language,!0,void 0,B.productVersion??this.R()),ee=await this.n.scanExtension(z);return!ee||!B.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,ie,B){const z=await this.P(H,!1,ie,!0,B.language,!0,void 0,B.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(z);return this.J(ee,ie,B,!0)}async scanMultipleExtensions(H,ie,B){const z=[];return await Promise.all(H.map(async ee=>{const ne=await this.scanOneOrMultipleExtensions(ee,ie,B);z.push(...ne)})),this.J(z,ie,B,!0)}async scanMetadata(H){const ie=(0,g.$eh)(H,"package.json"),B=(await this.w.readFile(ie)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,ie){const B=(0,g.$eh)(H,"package.json"),z=(await this.w.readFile(B)).value.toString(),ee=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,g.$eh)(H,"package.json"),A.$Me.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof h.$Gq&&H.code===h.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Me.fromString(JSON.stringify([])))}catch(ie){(0,i.$pl)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,ie,B,z){return B.includeAllVersions||(H=this.L(ie===o.ExtensionType.System?H:void 0,ie===o.ExtensionType.User?H:void 0,ie==="development"?H:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const le=$.$mc(ee.location.fsPath),te=$.$mc(ne.location.fsPath);return le<te?-1:le>te?1:0})}L(H,ie,B,z,ee){const ne=(te,Q,K)=>{if(te.isValid&&!Q.isValid)return!1;if(te.isValid===Q.isValid){if(ee&&l.gt(te.manifest.version,Q.manifest.version))return this.y.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(l.eq(te.manifest.version,Q.manifest.version)){if(te.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${Q.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===z)return this.y.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${te.location.path} with ${Q.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${Q.location.path}.`),!0},le=new o.$rn;return H?.forEach(te=>{const Q=le.get(te.identifier.id);(!Q||ne(Q,te,!1))&&le.set(te.identifier.id,te)}),ie?.forEach(te=>{const Q=le.get(te.identifier.id);if(!Q&&H&&te.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!Q||ne(Q,te,!1))&&le.set(te.identifier.id,te)}),B?.forEach(te=>{const Q=le.get(te.identifier.id);(!Q||ne(Q,te,!0))&&le.set(te.identifier.id,te),le.set(te.identifier.id,te)}),[...le.values()]}async M(H,ie){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,ie){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},ee=[],ne=f.URI.file($.$gc($.$ic(R.$Xg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of B){const Q=z[te.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":ee.push((0,g.$eh)(ne,te.name));break;default:ee.push(f.URI.file(Q));break}}const le=await Promise.all(ee.map(async te=>this.n.scanExtension(await this.P(te,!1,o.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,I.$Gb)(le)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,ie,B,z,ee,ne,le,te){const Q=await this.f(ee??d.$x),K=await this.Q(H),q=ie&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new U(H,K,q,D,ie,le,B,z,ne,te.version,te.date,this.C.commit,!this.z.isBuilt,ee,Q)}async Q(H){try{const ie=await this.w.stat(H);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=C,e.$Mq=C=ve([x(4,y.$Kl),x(5,h.$Hq),x(6,i.$$k),x(7,t.$$j),x(8,P.$Ki),x(9,s.$rk),x(10,L.$Il),x(11,n.$Ci)],C);class U{constructor(H,ie,B,z,ee,ne,le,te,Q,K,q,D,X,J,j){this.location=H,this.mtime=ie,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=te,this.validate=Q,this.productVersion=K,this.productDate=q,this.productCommit=D,this.devMode=X,this.language=J,this.translations=j}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,ie){return(0,g.$0g)(H.location,ie.location)&&H.mtime===ie.mtime&&(0,g.$0g)(H.applicationExtensionslocation,ie.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&H.profile===ie.profile&&T.$go(H.profileScanOptions,ie.profileScanOptions)&&H.type===ie.type&&H.excludeObsolete===ie.excludeObsolete&&H.validate===ie.validate&&H.productVersion===ie.productVersion&&H.productDate===ie.productDate&&H.productCommit===ie.productCommit&&H.devMode===ie.devMode&&H.language===ie.language&&v.equals(H.translations,ie.translations)}}e.$Nq=U;let F=class extends b.$Tc{constructor(H,ie,B,z,ee,ne,le){super(),this.g=H,this.h=ie,this.j=B,this.m=z,this.n=ne,this.r=le,this.f=ee.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(H){const ie=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===o.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,E.$qg)(B)?ie:ie.filter(z=>!B[p.$Lp.create(z).toString()])}async s(H){const ie=await this.m.resolve(H.location);if(!ie.children?.length)return[];const B=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||H.type===o.ExtensionType.User&&(0,g.$bh)(z.resource).indexOf(".")===0)return null;const ee=new U(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,I.$Gb)(B).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async t(H){let ie=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);ie.push(...B)}return ie}async u(H,ie,B){const z=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async ne=>{if(ie(ne)){const le=new U(ne.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,I.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,g.$eh)(H.location,"package.json"))){const ie=await this.scanExtension(H);return ie?[ie]:[]}else return await this.scanExtensions(H)}catch(ie){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,N.$9)(ie)),[]}}async scanExtension(H,ie){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=o.$ln),ie=ie??B.__metadata,delete B.__metadata;const z=(0,p.$Pp)(B.publisher,B.name),ee=ie?.id?{id:z,uuid:ie.id}:{id:z},ne=ie?.isSystem?o.ExtensionType.System:H.type,le=ne===o.ExtensionType.System||!!ie?.isBuiltin;B=await this.y(H.location,B,U.createNlsConfiguration(H));let te={type:ne,identifier:ee,manifest:B,location:H.location,isBuiltin:le,targetPlatform:ie?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return H.validate&&(te=this.validate(te,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,o.$xn)([...B.enabledApiProposals])),te}}catch(B){H.type!==o.ExtensionType.System&&this.r.error(B)}return null}validate(H,ie){let B=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),ee=(0,u.$2p)(ie.productVersion,ie.productDate,ie.location,H.manifest,H.isBuiltin,z);for(const[ne,le]of ee)ne===m.default.Error&&(B=!1,this.r.error(this.F(ie.location,le)));return H.isValid=B,H.validations=ee,H}async w(H){const ie=(0,g.$eh)(H,"package.json");let B;try{B=(await this.m.readFile(ie)).value.toString()}catch(ee){return(0,i.$pl)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,w.localize)(11406,null,ie.path,ee.message))),null}let z;try{z=JSON.parse(B)}catch{const ne=[];(0,O.$Wn)(B,ne);for(const le of ne)this.r.error(this.F(H,(0,w.localize)(11407,null,ie.path,le.offset,le.length,(0,k.$Jq)(le.error))));return null}return(0,O.$5n)(z)!=="object"?(this.r.error(this.F(H,(0,w.localize)(11408,null,ie.path))),null):z}async y(H,ie,B){const z=await this.z(H,ie,B);if(z)try{const ee=[],ne=await this.C(z.default,ee);if(ee.length>0)return ee.forEach(te=>{this.r.error(this.F(H,(0,w.localize)(11409,null,z.default?.path,(0,k.$Jq)(te.error))))}),ie;if((0,O.$5n)(z)!=="object")return this.r.error(this.F(H,(0,w.localize)(11410,null,z.default?.path))),ie;const le=z.values||Object.create(null);return(0,S.$Kq)(this.r,ie,le,ne)}catch{}return ie}async z(H,ie,B){const z=(0,g.$eh)(H,"package.nls.json"),ee=(Q,K)=>{K.forEach(q=>{this.r.error(this.F(H,(0,w.localize)(11411,null,Q?.path,(0,k.$Jq)(q.error))))})},ne=Q=>{this.r.error(this.F(H,(0,w.localize)(11412,null,Q?.path)))},le=`${ie.publisher}.${ie.name}`,te=B.translations[le];if(te)try{const Q=f.URI.file(te),K=(await this.m.readFile(Q)).value.toString(),q=[],D=(0,O.$Wn)(K,q);return q.length>0?(ee(Q,q),{values:void 0,default:z}):(0,O.$5n)(D)!=="object"?(ne(Q),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let K;try{K=await this.D(H,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const q=(await this.m.readFile(K.localized)).value.toString(),D=[],X=(0,O.$Wn)(q,D);return D.length>0?(ee(K.localized,D),{values:void 0,default:K.original}):(0,O.$5n)(X)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:X,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(H,ie){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,O.$Wn)(B,ie)}catch{}}D(H,ie){return new Promise((B,z)=>{const ee=ne=>{const le=(0,g.$eh)(H,`package.nls.${ne}.json`);this.m.exists(le).then(te=>{te&&B({localized:le,original:(0,g.$eh)(H,"package.nls.json")});const Q=ne.lastIndexOf("-");Q===-1?B({localized:(0,g.$eh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Q),ee(ne))})};if(ie.devMode||ie.pseudo||!ie.language)return B({localized:(0,g.$eh)(H,"package.nls.json"),original:null});ee(ie.language)})}F(H,ie){return`[${H.path}]: ${ie}`}};F=ve([x(1,h.$Hq),x(2,L.$Il),x(3,i.$$k),x(4,s.$rk),x(5,P.$Ki),x(6,t.$$j)],F);let M=class extends F{constructor(H,ie,B,z,ee,ne,le,te,Q){super(ie,z,ee,ne,le,te,Q),this.J=H,this.L=B,this.H=this.B(new c.$Bh(3e3)),this.I=this.B(new r.$ke),this.onDidChangeCache=this.I.event}async scanExtensions(H){const ie=this.P(H),B=await this.M(ie);if(this.G=H,B&&B.input&&U.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===o.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const z=await super.scanExtensions(H);return await this.N(ie,{input:H,result:z}),z}async M(H){try{const ie=await this.m.readFile(H),B=JSON.parse(ie.value.toString());return{result:B.result,input:(0,a.$ai)(B.input)}}catch(ie){this.r.debug("Error while reading the extension cache file:",H.path,(0,N.$9)(ie))}return null}async N(H,ie){try{await this.m.writeFile(H,A.$Me.fromString(JSON.stringify(ie)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,N.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),ie=await this.M(H);if(!ie)return;const B=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!T.$go(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(H),this.I.fire()}catch(ee){this.r.error(ee)}}P(H){const ie=this.Q(H);return this.j.extUri.joinPath(ie.cacheHome,H.type===o.ExtensionType.System?o.$kn:o.$jn)}Q(H){return H.type===o.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(ie=>this.j.extUri.isEqual(H.location,ie.extensionsResource))??this.J:this.L.defaultProfile}};M=ve([x(2,y.$Kl),x(3,h.$Hq),x(4,L.$Il),x(5,i.$$k),x(6,s.$rk),x(7,P.$Ki),x(8,t.$$j)],M);function G(_,H){const ie=(0,p.$Np)(_.manifest.publisher,_.manifest.name);return{id:ie,identifier:new o.$pn(ie),isBuiltin:_.type===o.ExtensionType.System,isUserBuiltin:_.type===o.ExtensionType.User&&_.isBuiltin,isUnderDevelopment:H,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,publisherDisplayName:_.publisherDisplayName,..._.manifest}}class V extends C{constructor(H,ie,B,z,ee,ne,le,te,Q,K,q,D){super(H,ie,(0,g.$eh)(B,".vscode-oss-dev","extensions","control.json"),z,ee,ne,le,te,Q,K,q,D),this.S=(async()=>{if(d.$A)try{const X=await this.w.readFile(f.URI.file(d.$A));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Pq=V}),define(he[215],ue([0,1,68,6,43,3,2,22,13,30,10,19]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let d=class extends N.$Tc{constructor(l,m){super(),this.b=l,this.f=m,this.a=new c.$Jh(5)}async postUninstall(l){const m=this.g(l,"uninstall");m&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await b.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,m){const E=`vscode:${m}`;if(l.location.scheme===O.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const f=l.manifest.scripts[E].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,k.$ic)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(l,m,E,f,w){return new Promise((P,p)=>{const o=this.j(l,m,E,w);let u;const i=n=>{u&&(clearTimeout(u),u=null),n?p(n):P(void 0)};o.on("error",n=>{i((0,T.$oj)(n)||"Unknown")}),o.on("exit",(n,t)=>{i(n?`post-${m} process exited with code ${n}`:void 0)}),f&&(u=setTimeout(()=>{u=null,o.kill(),p("timed out")},5e3))})}j(l,m,E,f){const w={silent:!0,execArgv:void 0},P=(0,I.fork)(l,[`--type=extension-post-${m}`,...E],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(P.stdout,"data"),o=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B(p(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,n))),this.B(o(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,n)));const u=A.Event.any(A.Event.map(p,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(u,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,k.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Tq=d,e.$Tq=d=ve([x(0,$.$Kl),x(1,R.$$j)],d)}),define(he[116],ue([0,1,72,11,83,27]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=N,e.$Rq=O;function N(k){let b=A.ExtensionManagementErrorCode.Extract;return k instanceof I.$zq&&(k.type==="CorruptZip"?b=A.ExtensionManagementErrorCode.CorruptZip:k.type==="Incomplete"&&(b=A.ExtensionManagementErrorCode.IncompleteZip)),(0,T.$Eq)(k,b)}async function O(k){let b;try{b=await(0,I.$Cq)(k,"extension/package.json")}catch(R){throw N(R)}try{return JSON.parse(b.toString("utf8"))}catch{throw new A.$lp((0,c.localize)(11396,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(he[216],ue([0,1,6,8,2,22,20,60,12,32,30,72,21,15,83,27,35,116,110,7,10,18]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,O=Pe(O);let i=class extends T.$Tc{static{u=this}static{this.c=".sigzip"}constructor(t,s,r,a,h,y,L){super(),this.h=s,this.j=r,this.m=a,this.n=h,this.r=y,this.t=L,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,a){await this.g;const h=await this.w(t,s);let y=!1;if(r&&this.u(t)){let L;try{L=await this.y(t)}catch(S){try{await this.delete(h)}catch(v){this.t.error(v)}throw S}try{y=await this.n.verify(t,h.fsPath,L.fsPath,a)}catch(S){if(y=S.code,y===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(h)}catch(v){this.t.error(v)}throw new m.$lp($.$yq,m.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(S){this.t.error(S)}}}return{location:h,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,k.$jg)(s)?s:!0}async w(t,s){try{const r=(0,N.$eh)(this.extensionsDownloadDir,this.G(t)),a=await this.C(t,"vsix",async()=>{await this.z(t,r,h=>this.j.download(t,h,s));try{await this.D(r.fsPath,"extension/package.json")}catch(h){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,c.$9)(y))}throw h}},2);return a>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:a}),r}catch(r){throw(0,l.$Eq)(r,m.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,N.$eh)(this.extensionsDownloadDir,`.${(0,b.$Zg)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(a){try{await this.h.del(s)}catch(h){this.t.warn(`Error while deleting: ${s.path}`,(0,c.$9)(h))}throw a}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Eq)(s,m.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==A.Schemas.file){await r(s);return}const a=(0,N.$eh)(this.extensionsDownloadDir,`.${(0,b.$Zg)()}`);try{await r(a)}catch(h){try{await this.h.del(a)}catch{}throw h}try{await R.Promises.rename(a.fsPath,s.fsPath,2*60*1e3)}catch(h){try{await this.h.del(a)}catch{}let y=!1;try{y=await this.h.exists(s)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,c.$9)(h)}. Deleted the file from downloaded location`,a.path),h}}async C(t,s,r,a){let h=1;for(;;)try{return await r(),h}catch(y){if(h++>a)throw y;this.t.warn(`Failed downloading ${s}. ${(0,c.$9)(y)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,$.$Cq)(t,s)}catch(r){throw(0,f.$Qq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],a=[];for(const L of t.children)if(L.name.endsWith(u.c))a.push(L.resource);else{const S=E.$Lp.parse(L.name);S&&r.push([S,L])}const h=(0,E.$Qp)(r,([L])=>L),y=[];for(const L of h)L.sort((S,v)=>O.rcompare(S[0].version,v[0].version)),s.push(...L.slice(1).map(S=>S[1].resource)),y.push(L[0][1]);y.sort((L,S)=>L.mtime-S.mtime),s.push(...y.slice(0,Math.max(0,y.length-this.f)).map(L=>L.resource)),s.push(...a),await I.Promises.settled(s.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Lp.create(t).toString().toLowerCase():(0,b.$Zg)()}};e.$Sq=i,e.$Sq=i=u=ve([x(0,g.$Li),x(1,P.$$k),x(2,m.$jp),x(3,d.$0i),x(4,w.$rq),x(5,o.$0l),x(6,p.$$j)],i)}),define(he[117],ue([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,72,11,98,15,83,27,35,52,84,216,215,116,188,198,34,59,7,4,10,23,18,28,19]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S,v,C,U,F,M,G,V,_,H,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,I=Pe(I),g=Pe(g),m=Pe(m),P=Pe(P),o=Pe(o),e.$Wq=(0,M.$Ei)(t.$mp);const B=".vsctmp";let z=class extends n.$Dq{constructor(Q,K,q,D,X,J,j,W,Y,Z,se,ce){super(Q,K,se,q,Z,ce),this.db=X,this.eb=J,this.fb=j,this.gb=W,this.hb=Y,this.cb=new Map,this.sb=new $.$Ac;const me=this.B(W.createInstance(y.$Tq));this.$=this.B(W.createInstance(ee,Ee=>me.postUninstall(Ee))),this.ab=this.B(new S.$Uq(ce,Y,se,this,this.F)),this.bb=this.B(W.createInstance(h.$Sq));const pe=this.B(new v.$Vq(this,this.db,ce,J,se,Y,q));this.B(pe.onDidChangeExtensionsByAnotherSource(Ee=>this.rb(Ee))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Vp)(this.hb,this.F)),this.ib}async zip(Q){this.F.trace("ExtensionManagementService#zip",Q.identifier.id);const K=await this.qb(Q),q=await(0,p.zip)((0,l.$eh)(this.bb.extensionsDownloadDir,(0,w.$Zg)()).fsPath,K);return f.URI.file(q)}async getManifest(Q){const{location:K,cleanup:q}=await this.kb(Q),D=g.$jc(K.fsPath);try{return await(0,L.$Rq)(D)}finally{await q()}}getInstalled(Q,K=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(Q??null,K,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.$.scanUserExtensionAtLocation(Q)}async install(Q,K={}){this.F.trace("ExtensionManagementService#install",Q.toString());const{location:q,cleanup:D}=await this.kb(Q);try{const X=await(0,L.$Rq)(g.$jc(q.fsPath)),J=(0,s.$Pp)(X.publisher,X.name);if(X.engines&&X.engines.vscode&&!(0,U.$4p)(X.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(11397,null,J,this.G.version));const W=(await this.I([{manifest:X,extension:q,options:K}])).find(({identifier:Y})=>(0,s.$Kp)(Y,{id:J}));if(W?.local)return W.local;throw W?.error?W.error:(0,n.$Eq)(new Error(`Unknown error while installing extension ${J}`))}finally{await D()}}async installFromLocation(Q,K){this.F.trace("ExtensionManagementService#installFromLocation",Q.toString());const q=await this.$.scanUserExtensionAtLocation(Q);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.vb([[q,{source:"resource"}]],K),this.F.info("Successfully installed extension",q.identifier.id,K.toString()),q}async installExtensionsFromProfile(Q,K,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Q,K.toString(),q.toString());const D=(await this.getInstalled(C.ExtensionType.User,K)).filter(X=>Q.some(J=>(0,s.$Kp)(J,X.identifier)));if(D.length){const X=await Promise.all(D.map(J=>this.$.scanMetadata(J,K)));await this.vb(D.map((J,j)=>[J,X[j]]),q),this.F.info("Successfully installed extensions",D.map(J=>J.identifier.id),q.toString())}return D}async updateMetadata(Q,K,q){return this.F.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),Q=await this.$.updateMetadata(Q,K,q),this.ab.invalidate(q),this.w.fire({local:Q,profileLocation:q}),Q}async reinstallFromGallery(Q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.z.isEnabled())throw new Error(o.localize(11398,null));const K=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:K,compatible:!0},A.CancellationToken.None);if(!q)throw new Error(o.localize(11399,null));await this.$.setUninstalled(Q);try{await this.$.removeUninstalledExtension(Q)}catch(D){throw new Error(o.localize(11400,null,(0,N.$oj)(D)))}return this.installFromGallery(q)}Z(Q,K,q,D){return this.$.copyExtension(Q,K,q,D)}copyExtensions(Q,K){return this.$.copyExtensions(Q,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Q){return this.$.setUninstalled(...Q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(Q){this.F.error(Q)}}async download(Q,K,q){const{location:D}=await this.bb.download(Q,K,!q);return D}async kb(Q){if(Q.scheme===d.Schemas.file)return{location:Q,async cleanup(){}};this.F.trace("Downloading extension from",Q.toString());const K=(0,l.$eh)(this.bb.extensionsDownloadDir,(0,w.$Zg)());return await this.fb.download(Q,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(Q,K,q){const D=K instanceof f.URI?new s.$Lp({id:(0,s.$Pp)(Q.publisher,Q.name)},Q.version):s.$Lp.create(K);return this.gb.createInstance(ne,D,Q,K,q,(X,J)=>{if(K instanceof f.URI)return this.pb(D,K,q,J);let j=this.cb.get(D.toString());return j||(this.cb.set(D.toString(),j=this.ob(D,K,X,q,J)),j.finally(()=>this.cb.delete(D.toString()))),j},this.$)}Y(Q,K){return new le(Q,K,this.eb)}async ob(Q,K,q,D,X){const{verificationStatus:J,location:j}=await this.bb.download(K,q,!D.donotVerifySignature,D.context?.[t.$cp]);try{if(X.isCancellationRequested)throw new O.$4;const W=await(0,L.$Rq)(j.fsPath);if(!new s.$Lp(K.identifier,K.version).equals(new s.$Lp({id:(0,s.$Pp)(W.publisher,W.name)},W.version)))throw new t.$lp(o.localize(11401,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(Q,j.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$jg)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,X),verificationStatus:J}}catch(W){try{await this.bb.delete(j)}catch(Y){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,O.$9)(Y))}throw(0,n.$Eq)(W)}}async pb(Q,K,q,D){return{local:await this.$.extractUserExtension(Q,g.$jc(K.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(Q){const K=async D=>{let X=await P.Promises.readdir(D);X=X.map(W=>g.$ic(D,W));const J=await Promise.all(X.map(W=>I.promises.stat(W)));let j=Promise.resolve([]);return J.forEach((W,Y)=>{const Z=X[Y];W.isFile()&&(j=j.then(se=>[...se,Z])),W.isDirectory()&&(j=j.then(se=>K(Z).then(ce=>[...se,...ce])))}),j};return(await K(Q.location.fsPath)).map(D=>({path:`extension/${g.$kc(Q.location.fsPath,D)}`,localPath:D}))}async rb({added:Q,removed:K}){if(K){const q=Q&&this.D.extUri.isEqual(K.profileLocation,Q.profileLocation)?K.extensions.filter(D=>Q.extensions.every(X=>!(0,s.$Kp)(X,D))):K.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(Q){const D=(await this.getInstalled(C.ExtensionType.User,Q.profileLocation)).filter(X=>Q.extensions.some(J=>(0,s.$Kp)(J,X.identifier)));this.s.fire(D.map(X=>(this.F.info("Extensions added from another source",X.identifier.id,Q.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:Q.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const Q=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of Q.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(Q){if(!Q.affects(this.db.userExtensionsLocation,F.FileChangeType.ADDED))return;const K=[];for(const q of Q.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),K.push(D))}K.length&&(await this.vb(K.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(q=>q.identifier.id)))}async vb(Q,K){const q=Q.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(Q,K),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(Q){const K=await this.$.getUninstalledExtensions();for(const q of Q){const D=s.$Lp.create(q);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$Xq=z,e.$Xq=z=ve([x(0,t.$jp),x(1,_.$0l),x(2,G.$$j),x(3,i.$Li),x(4,a.$Lq),x(5,r.$Hq),x(6,u.$Zo),x(7,M.$Ci),x(8,F.$$k),x(9,V.$rk),x(10,H.$Il),x(11,ie.$Kl)],z);let ee=class extends R.$Tc{constructor(Q,K,q,D,X,J,j){super(),this.n=Q,this.s=K,this.t=q,this.u=D,this.w=X,this.y=J,this.z=j,this.h=this.B(new k.$ke),this.onExtract=this.h.event,this.j=new $.$zc,this.m=new $.$zc,this.c=(0,l.$eh)(this.t.userExtensionsLocation,".obsolete"),this.g=new c.$Kh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(Q,K,q){try{const D={includeInvalid:!0,profileLocation:K,productVersion:q};let X=[];if(Q===null||Q===C.ExtensionType.System){let J=this.j.get(K);J||(J=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,J)),X.push(...await J)}else if(Q===C.ExtensionType.User){let J=this.m.get(K);J||(J=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,J)),X.push(...await J)}return X=Q!==null?X.filter(J=>J.type===Q):X,await Promise.all(X.map(J=>this.H(J)))}catch(D){throw(0,n.$Eq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(Q){try{const K=await this.t.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return await Promise.all(K.map(q=>this.H(q)))}catch(K){throw(0,n.$Eq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(Q){try{const K=await this.t.scanExistingExtension(Q,C.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(Q,K,q,D,X){const J=Q.toString(),j=f.URI.file(g.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,w.$Zg)()}`)),W=f.URI.file(g.$ic(this.t.userExtensionsLocation.fsPath,J));if(await this.s.exists(W)){if(!D)try{return await this.scanLocalExtension(W,C.ExtensionType.User)}catch(Y){this.z.warn(`Error while scanning the existing extension at ${W.path}. Deleting the existing extension and extracting it.`,(0,O.$9)(Y))}try{await this.D(Q.id,W,"removeExisting")}catch{throw new t.$lp(o.localize(11402,null,W.fsPath,Q.id),t.ExtensionManagementErrorCode.Delete)}}try{if(X.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${K} to ${W.fsPath}`),await(0,p.$Bq)(K,j.fsPath,{sourcePath:"extension",overwrite:!0},X),this.z.info(`Extracted extension to ${W}:`,Q.id)}catch(Y){throw(0,L.$Qq)(Y)}try{await this.t.updateMetadata(j,q)}catch(Y){throw this.y.publicLog2("extension:extract",{extensionId:Q.id,code:`${(0,F.$pl)(Y)}`}),(0,n.$Eq)(Y,t.ExtensionManagementErrorCode.UpdateMetadata)}if(X.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${j.fsPath} to ${W.fsPath}`),await this.G(j.fsPath,W.fsPath),this.z.info("Renamed to",W.fsPath)}catch(Y){if(Y.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(Y)}. Deleted from extracted location`,j),Y}this.h.fire(W)}catch(Y){try{await this.s.del(j,{recursive:!0})}catch{}throw Y}return this.scanLocalExtension(W,C.ExtensionType.User)}async scanMetadata(Q,K){return K?(await this.C(Q,K))?.metadata:this.t.scanMetadata(Q.location)}async C(Q,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Kp)(D.identifier,Q.identifier))}async updateMetadata(Q,K,q){try{q?await this.u.updateMetadata([[Q,K]],q):await this.t.updateMetadata(Q.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:Q.identifier.id,code:`${(0,F.$pl)(D)}`,isProfile:!!q}),(0,n.$Eq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(Q.location,Q.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(Q){throw(0,n.$Eq)(Q,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...Q){const K=Q.map(q=>s.$Lp.create(q));await this.F(q=>K.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(Q){try{await this.F(K=>delete K[Q.toString()])}catch(K){throw(0,n.$Eq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(Q,K){if(this.w.extUri.isEqualOrParent(Q.location,this.t.userExtensionsLocation))return this.D(Q.identifier.id,Q.location,K)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.F(K=>delete K[s.$Lp.create(Q).toString()])}async copyExtension(Q,K,q,D){const X=await this.C(Q,K),J=await this.C(Q,q);if(D={...X?.metadata,...D},J)if(this.w.extUri.isEqual(J.location,Q.location))await this.u.updateMetadata([[Q,{...J.metadata,...D}]],q);else{const j=await this.scanLocalExtension(J.location,Q.type,q);await this.u.removeExtensionFromProfile(j,q),await this.u.addExtensionsToProfile([[Q,{...J.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[Q,D]],q);return this.scanLocalExtension(Q.location,Q.type,q)}async copyExtensions(Q,K,q){const D=await this.scanExtensions(C.ExtensionType.User,Q,q),X=await Promise.all(D.filter(J=>!J.isApplicationScoped).map(async J=>[J,await this.scanMetadata(J,Q)]));await this.u.addExtensionsToProfile(X,K)}async D(Q,K,q){this.z.trace(`Deleting ${q} extension from disk`,Q,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,b.$rj)((0,w.$Zg)()).toString(16)}${B}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,Q,K.fsPath)}F(Q){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,F.$pl)(D)!==F.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(K)try{q=JSON.parse(K)}catch{}return Q&&(Q(q),Object.keys(q).length?await this.s.writeFile(this.c,T.$Me.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(Q,K){try{await P.Promises.rename(Q,K,2*60*1e3)}catch(q){throw(0,n.$Eq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Q,K,q){try{if(q){const X=(await this.t.scanUserExtensions({profileLocation:q})).find(J=>this.w.extUri.isEqual(J.location,Q));if(X)return await this.H(X)}else{const D=await this.t.scanExistingExtension(Q,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$lp(o.localize(11403,null,Q.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Eq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(Q){const K=await this.s.resolve(Q.location);let q,D;return K.children&&(q=K.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,D=K.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:Q.metadata?.publisherDisplayName,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Q.metadata?.hasPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned,isWorkspaceScoped:!1,source:Q.metadata?.source??(Q.identifier.uuid?"gallery":"vsix")}}async I(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(Q));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const X of K)Q[s.$Lp.create(X).toString()]||q.add(X.identifier.id.toLowerCase());try{const X=(0,s.$Qp)(K,J=>J.identifier);await c.Promises.settled(X.map(async J=>{const j=J.sort((W,Y)=>m.rcompare(W.manifest.version,Y.manifest.version))[0];q.has(j.identifier.id.toLowerCase())||await this.n(await this.H(j))}))}catch(X){this.z.error(X)}const D=K.filter(X=>X.metadata&&Q[s.$Lp.create(X).toString()]);await Promise.allSettled(D.map(X=>this.removeUninstalledExtension(X)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let Q;try{Q=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,F.$pl)(K)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(Q?.children)try{await Promise.allSettled(Q.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(q){(0,F.$pl)(q)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$Yq=ee,e.$Yq=ee=ve([x(1,F.$$k),x(2,a.$Lq),x(3,r.$Hq),x(4,H.$Il),x(5,_.$0l),x(6,G.$$j)],ee);let ne=class extends n.$Fq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(Q,K,q,D,X,J,j,W,Y,Z,se,ce){super(),this.l=Q,this.manifest=K,this.source=q,this.options=D,this.m=X,this.n=J,this.o=j,this.p=W,this.q=Y,this.s=Z,this.t=se,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(Q){const q=(await this.n.scanExtensions(C.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,s.$Kp)(j.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof f.URI?"vsix":"gallery"};let X;if(this.source instanceof f.URI){if(q&&this.l.equals(new s.$Lp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(o.localize(11404,null,this.manifest.displayName||this.manifest.name))}const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(o.localize(11405,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$jg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==C.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);X=await this.w(this.l)}if(Q.isCancellationRequested)throw(0,n.$Eq)(new O.$4);if(!X){const j=await this.m(this.operation,Q);X=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,n.$Eq)(j,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(Q.isCancellationRequested)throw(0,n.$Eq)(new O.$4);try{await this.t.addExtensionsToProfile([[X,D]],this.options.profileLocation,!X.isValid)}catch(j){throw(0,n.$Eq)(j,t.ExtensionManagementErrorCode.AddToProfile)}const J=await this.n.scanLocalExtension(X.location,C.ExtensionType.User,this.options.profileLocation);if(!J)throw new t.$lp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof f.URI&&this.x(X,Q),J}async w(Q){return(await this.n.getUninstalledExtensions())[Q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",Q.id),await this.n.setInstalled(Q),this.u.info("Removed the extension from uninstalled list:",Q.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Lp.create(D).equals(Q))):void 0}async x(Q,K){try{let[q]=await this.p.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],K);if(q||([q]=await this.p.getExtensions([{id:Q.identifier.id}],K)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:Q.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(Q,D,this.options.profileLocation)}}catch{}}};ne=ve([x(6,H.$Il),x(7,t.$jp),x(8,ie.$Kl),x(9,a.$Lq),x(10,r.$Hq),x(11,G.$$j)],ne);class le extends n.$Fq{constructor(Q,K,q){super(),this.extension=Q,this.options=K,this.j=q}async h(Q){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(he[217],ue([0,1,10,19,28,18,52,7,15,9]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let R=class extends N.$Iq{constructor(d,g,l,m,E,f){super(b.URI.file(d.extensionsPath),g,l,m,E,f)}};e.$DR=R,e.$DR=R=ve([x(0,k.$Li),x(1,O.$$k),x(2,c.$Kl),x(3,T.$Il),x(4,A.$0l),x(5,I.$$j)],R)}),define(he[218],ue([0,1,9,15,52,84,7,4,10,23,28,19]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let d=class extends A.$Pq{constructor(l,m,E,f,w,P,p,o){super(I.URI.file(w.builtinExtensionsPath),I.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,m,E,f,w,P,p,o)}};e.$ahc=d,e.$ahc=d=ve([x(0,$.$Kl),x(1,T.$Hq),x(2,N.$$k),x(3,k.$$j),x(4,c.$Li),x(5,b.$rk),x(6,R.$Il),x(7,O.$Ci)],d)}),define(he[16],ue([0,1,6,3,2,100,12,70,4,19]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=g,e.$jq=m,e.$lq=f,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,k.$Di)("storageService");var R;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var $;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function g(w){const P=w.get(e.$fq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends T.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new c.$ne),this.c=this.B(new c.$ne),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$ke),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Ph(()=>this.n(),this.m.flushInterval)),this.j=this.B(new T.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,p,o){return c.Event.filter(this.b.event,u=>u.scope===P&&(p===void 0||u.key===p),o)}n(){this.j.value=(0,I.$Th)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,T.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,p){const{key:o,external:u}=p;if(o===e.$fq){switch(P){case $.APPLICATION:this.H=void 0;break;case $.PROFILE:this.F=void 0;break;case $.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:o,target:this.J(P)[o],external:u})}w(P){this.f.fire({reason:P})}get(P,p,o){return this.P(p)?.get(P,o)}getBoolean(P,p,o){return this.P(p)?.getBoolean(P,o)}getNumber(P,p,o){return this.P(p)?.getNumber(P,o)}getObject(P,p,o){return this.P(p)?.getObject(P,o)}storeAll(P,p){this.y(()=>{for(const o of P)this.store(o.key,o.value,o.scope,o.target,p)})}store(P,p,o,u,i=!1){if((0,N.$mg)(p)){this.remove(P,o,i);return}this.y(()=>{this.z(P,o,u),this.P(o)?.set(P,p,i)})}remove(P,p,o=!1){this.y(()=>{this.z(P,p,void 0),this.P(p)?.delete(P,o)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,p){const o=[],u=this.J(P);for(const i of Object.keys(u))u[i]===p&&o.push(i);return o}z(P,p,o,u=!1){const i=this.J(p);typeof o=="number"?i[P]!==o&&(i[P]=o,this.P(p)?.set(e.$fq,JSON.stringify(i),u)):typeof i[P]=="number"&&(delete i[P],this.P(p)?.set(e.$fq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L($.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L($.PROFILE)),this.F}get I(){return this.H||(this.H=this.L($.APPLICATION)),this.H}J(P){switch(P){case $.APPLICATION:return this.I;case $.PROFILE:return this.G;default:return this.D}}L(P){const p=this.P(P);return p?g(p):Object.create(null)}isNew(P){return this.getBoolean(e.$eq,P)===!0}async flush(P=R.NONE){this.f.fire({reason:P});const p=this.P($.APPLICATION),o=this.P($.PROFILE),u=this.P($.WORKSPACE);switch(P){case R.NONE:await I.Promises.settled([p?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([p?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P($.APPLICATION)?.items??new Map,p=this.P($.PROFILE)?.items??new Map,o=this.P($.WORKSPACE)?.items??new Map;return f(P,p,o,this.Q($.APPLICATION)??"",this.Q($.PROFILE)??"",this.Q($.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,p){return this.w(R.NONE),(0,b.$Jl)(P)?this.R(P,p):this.S(P,p)}M(P,p){return!(P.id===p.id||m(p)&&m(P))}N(P,p,o){this.y(()=>{const u=new Set;for(const[i,n]of P)u.add(i),p.get(i)!==n&&this.u(o,{key:i,external:!0});for(const[i]of p.items)u.has(i)||this.u(o,{key:i,external:!0})})}}e.$iq=l;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$cq(new O.$dq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u($.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u($.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u($.APPLICATION,P)))}P(P){switch(P){case $.APPLICATION:return this.U;case $.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case $.APPLICATION:return"inMemory (application)";case $.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$kq=E;async function f(w,P,p,o,u,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;w.forEach((v,C)=>{t.set(C,v),s.set(C,n(v))});const r=new Map,a=new Map;P.forEach((v,C)=>{r.set(C,v),a.set(C,n(v))});const h=new Map,y=new Map;p.forEach((v,C)=>{h.set(C,v),y.set(C,n(v))}),console.group(o!==u?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const L=[];if(t.forEach((v,C)=>{L.push({key:C,value:v})}),console.table(L),console.groupEnd(),console.log(s),o!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const v=[];r.forEach((C,U)=>{v.push({key:U,value:C})}),console.table(v),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${i})`);const S=[];h.forEach((v,C)=>{S.push({key:C,value:v})}),console.table(S),console.groupEnd(),console.log(y)}}),define(he[118],ue([0,1,3,2,12,27,35,16]),function(ae,e,I,c,T,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sMb=e.$rMb=void 0;let k=class extends c.$Tc{constructor($,d){super(),this.a=new I.$ke,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b($)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(d.onDidInstallExtensions(g=>g.forEach(({local:l,operation:m})=>{l&&m===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension($,d){return this.f($)?(this.a.fire({extensions:[$],source:d}),!0):!1}async disableExtension($,d){return this.c($)?(this.a.fire({extensions:[$],source:d}),!0):!1}getDisabledExtensions(){return this.h(A.$np)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c($){const d=this.getDisabledExtensions();return d.every(g=>!(0,N.$Kp)(g,$))?(d.push($),this.g(d),!0):!1}f($){const d=this.getDisabledExtensions();for(let g=0;g<d.length;g++){const l=d[g];if((0,N.$Kp)(l,$))return d.splice(g,1),this.g(d),!0}return!1}g($){this.j(A.$np,$)}h($){return this.b.get($,O.StorageScope.PROFILE)}j($,d){this.b.set($,d,O.StorageScope.PROFILE)}};e.$rMb=k,e.$rMb=k=ve([x(0,O.$gq),x(1,A.$mp)],k);class b extends c.$Tc{constructor($){super(),this.c=$,this.a=Object.create(null),this.b=this.B(new I.$ke),this.onDidChange=this.b.event,this.B($.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new c.$Sc))(d=>this.f(d)))}get($,d){let g;return d===O.StorageScope.PROFILE?((0,T.$mg)(this.a[$])&&(this.a[$]=this.g($,d)),g=this.a[$]):g=this.g($,d),JSON.parse(g)}set($,d,g){const l=JSON.stringify(d.map(({id:E,uuid:f})=>({id:E,uuid:f})));this.g($,g)!==l&&(g===O.StorageScope.PROFILE&&(d.length?this.a[$]=l:delete this.a[$]),this.h($,d.length?l:void 0,g))}f($){if(!(0,T.$mg)(this.a[$.key])&&this.g($.key,$.scope)!==this.a[$.key]){const g=this.get($.key,$.scope);delete this.a[$.key];const l=this.get($.key,$.scope),m=g.filter(f=>!l.some(w=>(0,N.$Kp)(f,w))),E=l.filter(f=>!g.some(w=>(0,N.$Kp)(w,f)));(m.length||E.length)&&this.b.fire([...m,...E])}}g($,d){return this.c.get($,d,"[]")}h($,d,g){d?this.c.store($,d,g,O.StorageTarget.MACHINE):this.c.remove($,g)}}e.$sMb=b}),define(he[85],ue([0,1,4,3,2,16,35,23,17,10,12]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=void 0,e.$ow=(0,I.$Di)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class extends T.$Tc{static{$=this}static{this.a=512*1024}static b(m){return`extensionKeys/${(0,N.$Op)(m.id)}@${m.version}`}static c(m){const E=d.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(m,E){const f=await m.getInstalled(),w=[];for(const[P,p]of $.f(E)){const o=f.find(u=>(0,N.$Kp)(u.identifier,{id:P}))?.manifest.version;for(const u of p)o!==u&&w.push($.b({id:P,version:u}))}for(const P of w)E.remove(P,A.StorageScope.PROFILE)}static f(m){const E=new Map,f=m.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const w of f){const P=$.c(w);if(P){let p=E.get(P.id.toLowerCase());p||E.set(P.id.toLowerCase(),p=[]),p.push(P.version)}}return E}constructor(m,E,f){super(),this.j=m,this.m=E,this.n=f,this.g=this.B(new c.$ke),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=$.f(m),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new T.$Sc))(w=>this.r(w)))}r(m){if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const E=$.c(m.key);if(E){if(this.j.get(m.key,A.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let f=this.h.get(E.id.toLowerCase());f||this.h.set(E.id.toLowerCase(),f=[]),f.push(E.version),this.g.fire()}return}}s(m){if((0,R.$dg)(m))return m;const E=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,N.$Np)(E,f)}getExtensionState(m,E){const f=this.s(m),w=this.getExtensionStateRaw(m,E);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${E}): ${P}`)}}getExtensionStateRaw(m,E){const f=this.s(m),w=this.j.get(f,E?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return w&&w?.length>$.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${E}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(m,E,f){const w=this.s(m);E===void 0?this.j.remove(w,f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(E),f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(m,E){this.j.store($.b(m),JSON.stringify(E),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(m){const E=this.m.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.j.get($.b(m),A.StorageScope.PROFILE),w=f?JSON.parse(f):void 0;return w&&E?(0,k.$Lb)([...w,...E]):w||E}addToMigrationList(m,E){if(m!==E){const f=this.t.filter(w=>!w.includes(m)&&!w.includes(E));f.push([m,E]),this.t=f}}getSourceExtensionToMigrate(m){const E=this.t.find(([,f])=>m===f);return E?E[0]:void 0}get t(){const m=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(m);if(Array.isArray(E))return E}catch{}return[]}set t(m){m.length?this.j.store("extensionStorage.migrationList",JSON.stringify(m),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$pw=g,e.$pw=g=$=ve([x(0,A.$gq),x(1,O.$rk),x(2,b.$$j)],g)}),define(he[219],ue([0,1,2,27,85,197,117,10,16]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let b=class extends I.$Tc{constructor($,d,g,l,m,E){super(),$.cleanUp(),(0,A.$C7b)($,d,g,l,E),T.$pw.removeOutdatedExtensionVersions($,m)}};e.$kic=b,e.$kic=b=ve([x(0,N.$Wq),x(1,c.$jp),x(2,T.$ow),x(3,c.$pp),x(4,k.$gq),x(5,O.$$j)],b)}),define(he[220],ue([0,1,17,2,20,9,7,23,6,3,13,5,37,35,74,34,16]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=void 0;let f=class extends c.$Tc{constructor(u,i){super(),this.b=u,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==u.scheme))try{const s=(await this.b.readFile((0,T.$eh)(u,n))).value.toString();for(const[r,a]of Object.entries(t.recommendations))(!a.contentPattern||new RegExp(a.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:a.name,configName:t.configName,important:!!a.important,isExtensionPack:!!a.isExtensionPack,whenNotInstalled:a.whenNotInstalled})}catch{}return i}};e.$Cec=f,e.$Cec=f=ve([x(0,N.$$k),x(1,O.$rk)],f);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class p extends f{constructor(u,i,n,t,s,r,a,h){super(a,h),this.r=u,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,h.exeBasedExtensionTips&&Object.entries(h.exeBasedExtensionTips).forEach(([y,L])=>{const S=[],v=[],C=[];Object.entries(L.recommendations).forEach(([U,F])=>{F.important?L.important?S.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):C.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),S.length&&this.g.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:S}),v.length&&this.h.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:v}),C.length&&this.j.set(y,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:C})}),(0,k.$Fh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),i=await this.O(this.h);return[...u,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(u,n),this.n=this.D(i,n)}D(u,i){const n=new Map;u.forEach(h=>n.set(h.extensionId.toLowerCase(),h));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const h of t){const y=n.get(h);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:h,exeName:y.exeName})}for(const h of s){const y=n.get(h);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:h,exeName:y.exeName})}const r=this.L(),a=new Map;for(const h of s){const y=n.get(h);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let L=a.get(y.exeName);L||(L=[],a.set(y.exeName,L)),L.push(y)}}return a}F(){if(this.m.size===0)return;const[u,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(u);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new c.$Uc);t.value=(0,k.$Fh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),i=Date.now()-u,n=7*24*60*60*1e3;if(i<n){const r=this.B(new c.$Uc);r.value=(0,k.$Fh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const a=this.B(new c.$Uc);a.value=(0,k.$Fh)(()=>{a.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const a=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(a(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const a=this.B(new c.$Uc);a.value=(0,k.$Fh)(()=>{a.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const i=await this.u.getInstalled(m.ExtensionType.User),n=u.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,g.$Kp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(P,E.StorageScope.APPLICATION);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(P,u,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,E.StorageScope.APPLICATION,"{}"))}M(u,i){const n=this.L();n[u]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(u,i){const n=[],t=[],s=i.reduce((r,a)=>(r.add(a.identifier.id.toLowerCase()),r),new Set);return u.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(u){const i=[],n=new Map;for(const t of u.keys()){const s=u.get(t);if(!s||!(0,I.$Kb)(s.recommendations))continue;const r=[];$.$j?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(r.push((0,R.$ic)("/usr/local/bin",t)),r.push((0,R.$ic)("/usr/bin",t)),r.push((0,R.$ic)(this.r.fsPath,t)));for(const a of r){let h=n.get(a);if(h===void 0&&(h=await this.b.exists(A.URI.file(a)),n.set(a,h)),h)for(const{extensionId:y,extensionName:L,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:y,extensionName:L,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$Dec=p}),define(he[221],ue([0,1,27,7,23,15,74,57,16,18,220]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;let $=class extends R.$Dec{constructor(g,l,m,E,f,w,P,p){super(g.userHome,f,l,m,E,w,P,p)}};e.$ric=$,e.$ric=$=ve([x(0,A.$Li),x(1,b.$0l),x(2,I.$mp),x(3,k.$gq),x(4,O.$mgc),x(5,N.$k7b),x(6,c.$$k),x(7,T.$rk)],$)}),define(he[49],ue([0,1,14,32,16]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=A;async function A(N,O,k){let b=k&&k.get("storage.serviceMachineId",T.StorageScope.APPLICATION)||null;if(b)return b;try{const $=(await O.readFile(N.serviceMachineIdResource)).value.toString();b=(0,c.$Yg)($)?$:null}catch{b=null}if(!b){b=(0,c.$Zg)();try{await O.writeFile(N.serviceMachineIdResource,I.$Me.fromString(b))}catch{}}return k?.store("storage.serviceMachineId",b,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE),b}}),define(he[222],ue([0,1,49,18,48]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=A;async function A(N,O,k,b,R,$,d){const g={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,T.$Cp)(O,k)&&(0,T.$Ep)(b)===c.TelemetryLevel.USAGE){const l=await(0,I.$mq)(k,R,$);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=d.machineId||l}return g}}),define(he[223],ue([0,1,17,25,8,5,37,12,9,21,15,27,35,34,59,7,10,23,61,222,16,18,54]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0,e.$oq=Q;const i=A.$p?g.TargetPlatform.WEB:(0,$.$fp)(A.$v,N.$dc),n="X-Market-Search-Activity-Id";var t;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...j){return String(j.reduce((W,Y)=>W|Y,0))}var r;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},L={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(W=L){this.d=W}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(W,Y=this.d.pageSize){return new S({...this.d,pageNumber:W,pageSize:Y})}withFilter(W,...Y){const Z=[...this.d.criteria,...Y.length?Y.map(se=>({filterType:W,value:se})):[{filterType:W}]];return new S({...this.d,criteria:Z})}withSortBy(W){return new S({...this.d,sortBy:W})}withSortOrder(W){return new S({...this.d,sortOrder:W})}withFlags(...W){return new S({...this.d,flags:W.reduce((Y,Z)=>Y|Z,0)})}withAssetTypes(...W){return new S({...this.d,assetTypes:W})}withSource(W){return new S({...this.d,source:W})}get raw(){const{criteria:W,pageNumber:Y,pageSize:Z,sortBy:se,sortOrder:ce,flags:me,assetTypes:pe}=this.d;return{filters:[{criteria:W,pageNumber:Y,pageSize:Z,sortBy:se,sortOrder:ce}],assetTypes:pe,flags:me}}get searchText(){const W=this.d.criteria.filter(Y=>Y.filterType===r.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(W=>String(W.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(j,W){const Y=(j||[]).filter(Z=>Z.statisticName===W)[0];return Y?Y.value:0}function C(j){const W="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(Z=>Z.assetType.indexOf(W)===0).reduce((Z,se)=>{const ce=M(j,se.assetType);return ce&&Z.push([se.assetType.substring(W.length),ce]),Z},[])}function U(j){if(j.properties){const W=j.properties.filter(se=>se.key===a.Repository),Y=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=W.filter(se=>Y.test(se.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return M(j,a.Repository)}function F(j){return{uri:`${j.fallbackAssetUri}/${a.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${a.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function M(j,W){return j.files.filter(Z=>Z.assetType===W)[0]?{uri:`${j.assetUri}/${W}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${W}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function G(j,W){const Y=j.properties?j.properties.filter(se=>se.key===W):[],Z=Y.length>0&&Y[0].value;return Z?Z.split(",").map(se=>(0,d.$Op)(se)):[]}function V(j){const W=j.properties?j.properties.filter(Y=>Y.key===h.Engine):[];return W.length>0&&W[0].value||""}function _(j){const W=j.properties?j.properties.filter(Y=>Y.key===h.PreRelease):[];return W.length>0&&W[0].value==="true"}function H(j){const W=j.properties?j.properties.filter(Y=>Y.key===h.ExecutesCode):[];return W.length>0?W[0].value==="true":void 0}function ie(j){const W=j.properties?j.properties.filter(Z=>Z.key===h.EnabledApiProposals):[],Y=W.length>0&&W[0].value||"";return Y?Y.split(","):[]}function B(j){const W=j.properties?j.properties.filter(Z=>Z.key===h.LocalizedLanguages):[],Y=W.length>0&&W[0].value||"";return Y?Y.split(","):[]}function z(j){return j.properties?.find(W=>W.key===h.SponsorLink)?.value}function ee(j){return j.properties?.find(W=>W.key===h.SupportLink)?.value}function ne(j){return j.indexOf("preview")!==-1}function le(j){return j.targetPlatform?(0,$.$ep)(j.targetPlatform):g.TargetPlatform.UNDEFINED}function te(j){const W=(0,I.$Lb)(j.versions.map(le)),Y=!!j.tags?.includes($.$$o),Z=W.indexOf(g.TargetPlatform.WEB);return Y?Z===-1&&W.push(g.TargetPlatform.WEB):Z!==-1&&W.splice(Z,1),W}function Q(j,W){for(let Y=0;Y<j.length;Y++){const Z=j[Y];if(Z.version===j[Y-1]?.version){let se=Y;if(le(Z)===W)for(;se>0&&j[se-1].version===Z.version;)se--;se!==Y&&(j.splice(Y,1),j.splice(se,0,Z))}}return j}function K(j,W,Y){j.telemetryData={index:W,querySource:Y,queryActivityId:j.queryContext?.[n]}}function q(j,W,Y,Z){const se=j.versions[0],ce={manifest:M(W,a.Manifest),readme:M(W,a.Details),changelog:M(W,a.Changelog),license:M(W,a.License),repository:U(W),download:F(W),icon:M(W,a.Icon),signature:M(W,a.Signature),coreTranslations:C(W)};return{type:"gallery",identifier:{id:(0,d.$Pp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:W.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(se),description:j.shortDescription??"",installCount:v(j.statistics,"install"),rating:v(j.statistics,"averagerating"),ratingCount:v(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:Y,assets:ce,properties:{dependencies:G(W,h.Dependency),extensionPack:G(W,h.ExtensionPack),engine:V(W),enabledApiProposals:ie(W),localizedLanguages:B(W),targetPlatform:le(W),isPreReleaseVersion:_(W),executesCode:H(W)},hasPreReleaseVersion:_(se),hasReleaseVersion:!0,preview:ne(j.flags),isSigned:!!ce.signature,queryContext:Z,supportLink:ee(se)}}let D=class{constructor(W,Y,Z,se,ce,me,pe,Ee){this.l=Y,this.n=Z,this.o=se,this.q=ce,this.u=me,this.w=pe,this.x=Ee;const ke=pe.extensionsGallery,be=ke?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=be?ke.servicePPEUrl:ke?.serviceUrl,this.g=be?void 0:ke?.searchUrl,this.h=ke?.controlUrl,this.k=pe.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,P.$nq)(pe.version,pe,this.o,this.x,this.u,W,this.q)}y(W=""){return`${this.d}${W}`}isEnabled(){return!!this.d}async getExtensions(W,Y,Z){const se=c.CancellationToken.isCancellationToken(Y)?{}:Y,ce=c.CancellationToken.isCancellationToken(Y)?Y:Z,me=[],pe=[],Ee=[],ke=[];let be=!0;for(const oe of W){oe.uuid?pe.push(oe.uuid):me.push(oe.id);const de=!!(oe.version||oe.preRelease);Ee.push({id:oe.id,uuid:oe.uuid,includePreRelease:de}),oe.version&&ke.push({id:oe.id,uuid:oe.uuid,version:oe.version}),be=be&&!!oe.hasPreRelease&&!de}if(!pe.length&&!me.length)return[];let we=new S().withPage(1,W.length);pe.length&&(we=we.withFilter(r.ExtensionId,...pe)),me.length&&(we=we.withFilter(r.ExtensionName,...me)),(se.queryAllVersions||be)&&(we=we.withFlags(we.flags,t.IncludeVersions)),se.source&&(we=we.withSource(se.source));const{extensions:Se}=await this.B(we,{targetPlatform:se.targetPlatform??i,includePreRelease:Ee,versions:ke,compatible:!!se.compatible,productVersion:se.productVersion??{version:this.w.version,date:this.w.date}},ce);return se.source&&Se.forEach((oe,de)=>K(oe,de,se.source)),Se}async getCompatibleExtension(W,Y,Z,se={version:this.w.version,date:this.w.date}){if((0,$.$gp)(W.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(W,Y,Z))return W;const ce=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,W.identifier.uuid),{extensions:me}=await this.B(ce,{targetPlatform:Z,compatible:!0,includePreRelease:Y,productVersion:se},c.CancellationToken.None);return me[0]||null}async isExtensionCompatible(W,Y,Z,se={version:this.w.version,date:this.w.date}){if(!(0,$.$hp)(W.properties.targetPlatform,W.allTargetPlatforms,Z)||!Y&&W.properties.isPreReleaseVersion)return!1;let ce=W.properties.engine;if(!ce){const me=await this.getManifest(W,c.CancellationToken.None);if(!me)throw new Error("Manifest was not found");ce=me.engines.vscode}return!(!(0,l.$4p)(ce,se.version,se.date)||!this.z(W.identifier,W.properties.enabledApiProposals))}z(W,Y){return!Y||!this.k.includes(W.id.toLowerCase())?!0:(0,l.$5p)(Y)}async A(W,Y,Z,se,ce,me,pe={version:this.w.version,date:this.w.date}){if(!(0,$.$hp)(le(Y),ce,me)||Z!=="any"&&_(Y)!==(Z==="prerelease"))return!1;if(se)try{const Ee=await this.G(W,Y);if(!(0,l.$4p)(Ee,pe.version,pe.date))return!1}catch(Ee){return this.n.error(`Error while getting the engine for the version ${Y.version}.`,(0,T.$9)(Ee)),!1}return!0}async query(W,Y){let Z=W.text||"";const se=W.pageSize??50;let ce=new S().withPage(1,se);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(be,we,Se)=>(ce=ce.withFilter(r.Category,Se||we),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(be,we,Se)=>(ce=ce.withFilter(r.Tag,Se||we),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(r.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),ce=ce.withFilter(r.SearchText,Z)),ce=ce.withSortBy($.SortBy.NoneOrRelevance)):W.ids?ce=ce.withFilter(r.ExtensionId,...W.ids):W.names?ce=ce.withFilter(r.ExtensionName,...W.names):ce=ce.withSortBy($.SortBy.InstallCount),typeof W.sortBy=="number"&&(ce=ce.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(ce=ce.withSortOrder(W.sortOrder)),W.source&&(ce=ce.withSource(W.source));const me=async(be,we)=>{const{extensions:Se,total:oe}=await this.B(be,{targetPlatform:i,compatible:!1,includePreRelease:!!W.includePreRelease,productVersion:W.productVersion??{version:this.w.version,date:this.w.date}},we);return Se.forEach((de,ge)=>K(de,(be.pageNumber-1)*be.pageSize+ge,W.source)),{extensions:Se,total:oe}},{extensions:pe,total:Ee}=await me(ce,Y),ke=async(be,we)=>{if(we.isCancellationRequested)throw new T.$4;const{extensions:Se}=await me(ce.withPage(be+1),we);return Se};return{firstPage:pe,total:Ee,pageSize:ce.pageSize,getPage:ke}}async B(W,Y,Z){const se=W.flags;W.flags&t.IncludeLatestVersionOnly&&W.flags&t.IncludeVersions&&(W=W.withFlags(W.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(W.flags&t.IncludeLatestVersionOnly)&&!(W.flags&t.IncludeVersions)&&(W=W.withFlags(W.flags,t.IncludeLatestVersionOnly)),Y.versions?.length&&(W=W.withFlags(W.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),W=W.withFlags(W.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ce,total:me,context:pe}=await this.D(W,Z);if(!(W.flags&t.IncludeLatestVersionOnly)){const we=[];for(const Se of ce){const oe=await this.C(Se,Y,pe);oe&&we.push(oe)}return{extensions:we,total:me}}const ke=[],be=new Map;for(let we=0;we<ce.length;we++){const Se=ce[we],oe={id:(0,d.$Pp)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},de=(0,O.$jg)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(Ie=>(0,d.$Kp)(Ie,oe))?.includePreRelease;if(Y.compatible&&(0,$.$gp)(te(Se),Y.targetPlatform))continue;const ge=await this.C(Se,Y,pe);!ge||ge.properties.isPreReleaseVersion&&(!de||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==Y.targetPlatform&&ge.hasPreReleaseVersion?be.set(Se.extensionId,we):ke.push([we,ge])}if(be.size){const we=new u.$ee,Se=new S().withFlags(se&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,be.size).withFilter(r.ExtensionId,...be.keys()),{extensions:oe}=await this.B(Se,Y,Z);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:be.size});for(const de of oe){const ge=be.get(de.identifier.uuid);ke.push([ge,de])}}return{extensions:ke.sort((we,Se)=>we[0]-Se[0]).map(([,we])=>we),total:me}}async C(W,Y,Z){const se={id:(0,d.$Pp)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},ce=Y.versions?.find(ke=>(0,d.$Kp)(ke,se))?.version,me=(0,O.$jg)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(ke=>(0,d.$Kp)(ke,se))?.includePreRelease,pe=te(W),Ee=Q(W.versions,Y.targetPlatform);if(Y.compatible&&(0,$.$gp)(pe,Y.targetPlatform))return null;for(let ke=0;ke<Ee.length;ke++){const be=Ee[ke];if(!(ce&&be.version!==ce)){if(await this.A(se.id,be,me?"any":"release",Y.compatible,pe,Y.targetPlatform,Y.productVersion))return Y.compatible&&!this.z(se,ie(be))?null:q(W,be,pe,Z);if(ce&&be.version===ce)return null}}return ce||Y.compatible?null:q(W,W.versions[0],pe)}async D(W,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,s(t.Unpublished));const Z=await this.j,se=JSON.stringify(W.raw),ce={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},me=new u.$ee;let pe,Ee,ke=0;try{if(pe=await this.l.request({type:"POST",url:this.g&&W.criteria.some(we=>we.filterType===r.SearchText)?this.g:this.y("/extensionquery"),data:se,headers:ce},Y),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:ke};const be=await(0,w.$_p)(pe);if(be){const we=be.results[0],Se=we.extensions,oe=we.resultMetadata&&we.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return ke=oe&&oe.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ke,context:pe.res.headers.activityid?{[n]:pe.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ke}}catch(be){if((0,T.$3)(be))throw Ee=$.ExtensionGalleryErrorCode.Cancelled,be;{const we=(0,T.$9)(be);throw Ee=we.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$kp(we,Ee)}}finally{this.q.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(se.length),duration:me.elapsed(),success:!!pe&&(0,w.$8p)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ee,count:String(ke)})}}async reportStatistic(W,Y,Z,se){if(!this.isEnabled())return;const ce=A.$p?this.y(`/itemName/${W}.${Y}/version/${Z}/statType/${se===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${W}/extensions/${Y}/${Z}/stats?statType=${se}`),me=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:me};try{await this.l.request({type:"POST",url:ce,headers:Ee},c.CancellationToken.None)}catch{}}async download(W,Y,Z){this.n.trace("ExtensionGalleryService#download",W.identifier.id);const se=(0,d.$Sp)(W),ce=new Date().getTime(),me=Z===$.InstallOperation.Install?"install":Z===$.InstallOperation.Update?"update":"",pe=me?{uri:`${W.assets.download.uri}${k.URI.parse(W.assets.download.uri).query?"&":"?"}${me}=true`,fallbackUri:`${W.assets.download.fallbackUri}${k.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${me}=true`}:W.assets.download,Ee=W.queryContext?.[n]?{[n]:W.queryContext[n]}:void 0,ke=await this.F(W.identifier.id,pe,a.VSIX,Ee?{headers:Ee}:void 0);try{await this.u.writeFile(Y,ke.stream)}catch(be){try{await this.u.del(Y)}catch(we){this.n.warn(`Error while deleting the file ${Y.toString()}`,(0,T.$9)(we))}throw new $.$kp((0,T.$9)(be),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...se,duration:new Date().getTime()-ce})}async downloadSignatureArchive(W,Y){if(!W.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",W.identifier.id);const Z=await this.F(W.identifier.id,W.assets.signature,a.Signature);try{await this.u.writeFile(Y,Z.stream)}catch(se){try{await this.u.del(Y)}catch(ce){this.n.warn(`Error while deleting the file ${Y.toString()}`,(0,T.$9)(ce))}throw new $.$kp((0,T.$9)(se),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(W,Y){if(W.assets.readme){const Z=await this.F(W.identifier.id,W.assets.readme,a.Details,{},Y);return await(0,w.$$p)(Z)||""}return""}async getManifest(W,Y){if(W.assets.manifest){const Z=await this.F(W.identifier.id,W.assets.manifest,a.Manifest,{},Y),se=await(0,w.$$p)(Z);return se?JSON.parse(se):null}return null}async E(W,Y,Z){const se=M(Y,a.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},me=await this.F(W,se,a.Manifest,{headers:ce});return await(0,w.$_p)(me)}async getCoreTranslation(W,Y){const Z=W.assets.coreTranslations.filter(se=>se[0]===Y.toUpperCase())[0];if(Z){const se=await this.F(W.identifier.id,Z[1],Z[0]),ce=await(0,w.$$p)(se);return ce?JSON.parse(ce):null}return null}async getChangelog(W,Y){if(W.assets.changelog){const Z=await this.F(W.identifier.id,W.assets.changelog,a.Changelog,{},Y);return await(0,w.$$p)(Z)||""}return""}async getAllCompatibleVersions(W,Y,Z){let se=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);W.uuid?se=se.withFilter(r.ExtensionId,W.uuid):se=se.withFilter(r.ExtensionName,W.id);const{galleryExtensions:ce}=await this.D(se,c.CancellationToken.None);if(!ce.length)return[];const me=te(ce[0]);if((0,$.$gp)(me,Z))return[];const pe=[];await Promise.all(ce[0].versions.map(async be=>{try{await this.A(W.id,be,Y?"any":"release",!0,me,Z)&&this.z(W,ie(be))&&pe.push(be)}catch{}}));const Ee=[],ke=new Set;for(const be of Q(pe,Z))ke.has(be.version)||(ke.add(be.version),Ee.push({version:be.version,date:be.lastUpdated,isPreReleaseVersion:_(be)}));return Ee}async F(W,Y,Z,se={},ce=c.CancellationToken.None){const me=await this.j,pe={type:"GET"},Ee={...me,...se.headers||{}};se={...se,...pe,headers:Ee};const ke=Y.uri,be=Y.fallbackUri,we={...se,url:ke};try{const Se=await this.l.request(we,ce);if(Se.res.statusCode===200)return Se;const oe=await(0,w.$$p)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${oe}`)}catch(Se){if((0,T.$3)(Se))throw Se;const oe=(0,T.$9)(Se);this.q.publicLog2("galleryService:cdnFallback",{extension:W,assetType:Z,message:oe});const de={...se,url:be};return this.l.request(de,ce)}}async G(W,Y){let Z=V(Y);if(!Z){this.q.publicLog2("galleryService:engineFallback",{extension:W,version:Y.version});const se=await this.E(W,Y,c.CancellationToken.None);if(!se)throw new Error("Manifest was not found");Z=se.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const W=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const Y=await(0,w.$_p)(W),Z=[],se={},ce=[],me=[];if(Y){for(const pe of Y.malicious)Z.push({id:pe});if(Y.migrateToPreRelease)for(const[pe,Ee]of Object.entries(Y.migrateToPreRelease))(!Ee.engine||(0,l.$4p)(Ee.engine,this.w.version,this.w.date))&&(se[pe.toLowerCase()]={disallowInstall:!0,extension:{id:Ee.id,displayName:Ee.displayName,autoMigrate:{storage:!!Ee.migrateStorage},preRelease:!0}});if(Y.deprecated)for(const[pe,Ee]of Object.entries(Y.deprecated))Ee&&(se[pe.toLowerCase()]=(0,O.$jg)(Ee)?{}:Ee);if(Y.search)for(const pe of Y.search)ce.push(pe);if(Array.isArray(Y.extensionsEnabledWithPreRelease))for(const pe of Y.extensionsEnabledWithPreRelease)me.push(pe.toLowerCase())}return{malicious:Z,deprecated:se,search:ce,extensionsEnabledWithPreRelease:me}}};D=ve([x(1,w.$6p),x(2,E.$$j),x(3,R.$Ki),x(4,o.$0l),x(5,m.$$k),x(6,f.$rk),x(7,b.$0i)],D);let X=class extends D{constructor(W,Y,Z,se,ce,me,pe,Ee){super(W,Y,Z,se,ce,me,pe,Ee)}};e.$pq=X,e.$pq=X=ve([x(0,p.$gq),x(1,w.$6p),x(2,E.$$j),x(3,R.$Ki),x(4,o.$0l),x(5,m.$$k),x(6,f.$rk),x(7,b.$0i)],X);let J=class extends D{constructor(W,Y,Z,se,ce,me,pe){super(void 0,W,Y,Z,se,ce,me,pe)}};e.$qq=J,e.$qq=J=ve([x(0,w.$6p),x(1,E.$$j),x(2,R.$Ki),x(3,o.$0l),x(4,m.$$k),x(5,f.$rk),x(6,b.$0i)],J)}),define(he[224],ue([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,143,20]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;const o=[I.$gic,I.$hic],u="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends N.$Tc{constructor(a,h,y,L,S,v,C){super(),this.y=a,this.z=h,this.C=y,this.D=v,this.F=C,this.f=new c.$ke,this.onDidTokenFailed=this.f.event,this.g=new c.$ke,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$ke,this.onDidChangeMode=this.h.event,this.n=I.$eic,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(L.createLogger((0,p.$eh)(y.logsHome,`${I.$iic}.log`),{id:I.$iic,name:I.$jic})),this.t=new d.$Ah(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,O.$nk)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{o.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){s(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(h){this.j.error(h)}return this.s}J(){if(!this.u){let a;$.$k?a=this.C.appRoot:a=(0,k.$lc)((0,k.$lc)(this.C.appRoot)),this.u=(0,k.$ic)(a,"bin",`${this.z.tunnelApplicationName}${$.$j?".exe":""}`)}return this.u}async startTunnel(a){if(s(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(h){this.j.error(h)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$eic);try{a&&this.O("uninstallService",["service","uninstall"])}catch(h){this.j.error(h)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",h=!1;const y=(F,M)=>{M?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,m.localize)(11178,null)))},L=this.O("status",["status"],y);this.r=L;try{if(await L,this.r!==L)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(h=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(I.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(I.TunnelStates.connecting((0,m.localize)(11179,null,S.accountLabel,S.providerId)));const M=(V,_)=>{V=V.replaceAll(F,"*".repeat(4)),y(V,_)},G=this.O("login",["user","login","--provider",S.providerId,"--log",(0,O.$nk)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=G;try{if(await G,this.r!==G)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(S),this.G(I.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(I.TunnelStates.connecting((0,m.localize)(11180,null,v))):this.G(I.TunnelStates.connecting((0,m.localize)(11181,null)));const C=["--accept-server-license-terms","--log",(0,O.$nk)(this.j.getLevel())];v?C.push("--name",v):C.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!h&&(U=await this.M(C)===!1),this.N(S,C,U)}async M(a){let h;try{h=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),h=1}if(h!==0){const y=(0,m.localize)(11182,null);return this.j.warn(y),this.G(I.TunnelStates.connecting(y)),!1}return!0}async N(a,h,y){h.push("--parent-process-id",String(process.pid)),this.P()&&h.push("--no-sleep");let L=!1;const S=this.O("tunnel",h,(v,C)=>{C?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(L=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:L};this.G(I.TunnelStates.connected(F,y))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$eic,this.G(I.TunnelStates.disconnected()))})}O(a,h,y=this.I,L){return(0,d.$qh)(S=>new Promise((v,C)=>{S.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this.j.info(`${a} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${h.join(" ")}
`,!1),U=(0,b.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,k.$ic)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{y(`Running tunnel CLI
`,!1);const M=this.J();y(`${a} Spawning: ${M} tunnel ${h.join(" ")}
`,!1),U=(0,b.spawn)(M,["tunnel",...h],{cwd:(0,E.homedir)(),stdio:F,env:{...process.env,...L}})}U.stdout.pipe(new P.$KX(`
`)).on("data",M=>{if(U){const G=M.toString();y(G,!1)}}),U.stderr.pipe(new P.$KX(`
`)).on("data",M=>{if(U){const G=M.toString();y(G,!0)}}),U.on("exit",M=>{U&&(y(`${a} exit(${U.pid}): + ${M} `,!1),U=void 0,v(M||0))}),U.on("error",M=>{U&&(y(`${a} error(${U.pid}): + ${M} `,!0),U=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$hic)}Q(){let a=this.D.getValue(I.$gic)||(0,E.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(u,f.StorageScope.APPLICATION),h=this.F.getBoolean(i,f.StorageScope.APPLICATION,!1);if(a){const y=JSON.parse(a);if(y&&(0,w.$dg)(y.accountLabel)&&(0,w.$dg)(y.sessionId)&&(0,w.$dg)(y.providerId))return{active:!0,session:y,asService:h};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$eic}S(a){if(a.active){const h={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(u,JSON.stringify(h),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(i,a.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(u,f.StorageScope.APPLICATION),this.F.remove(i,f.StorageScope.APPLICATION)}};e.$nic=n,e.$nic=n=ve([x(0,T.$0l),x(1,R.$rk),x(2,A.$Li),x(3,O.$_j),x(4,g.$lic),x(5,l.$0i),x(6,f.$gq)],n);function t(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const s=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&t(r.session,a.session):!0}),define(he[225],ue([0,1,6,2,22,20,70,16,79,19]),function(ae,e,I,c,T,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class R extends O.$iq{constructor(d,g,l,m){super(),this.bb=d,this.cb=g,this.db=l,this.eb=m,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Sc),this.ab=this.hb(this.bb)}fb(){const d=this.B(new k.$2Mb(this.db.getChannel("storage"))),g=this.B(new N.$cq(d));return this.B(g.onDidChangeStorage(l=>this.u(O.StorageScope.APPLICATION,l))),g}gb(d){this.X.clear(),this.W=d;let g;if((0,O.$jq)(d))g=this.U;else{const l=this.X.add(new k.$3Mb(this.db.getChannel("storage"),d));g=this.X.add(new N.$cq(l))}return this.X.add(g.onDidChangeStorage(l=>this.u(O.StorageScope.PROFILE,l))),g}hb(d){this.$.clear(),this.Z=d?.id;let g;if(d){const l=this.$.add(new k.$4Mb(this.db.getChannel("storage"),d));g=this.$.add(new N.$cq(l)),this.$.add(g.onDidChangeStorage(m=>this.u(O.StorageScope.WORKSPACE,m)))}return g}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(d){switch(d){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(d){switch(d){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:T.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$eh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:T.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(d){if(!this.M(this.W,d))return;const g=this.Y,l=g.items;g!==this.U&&await g.close(),this.Y=this.gb(d),await this.Y.init(),this.N(l,this.Y,O.StorageScope.PROFILE)}async S(d,g){const l=this.ab,m=l?.items??new Map;await l?.close(),this.ab=this.hb(d),await this.ab.init(),this.N(m,this.ab,O.StorageScope.WORKSPACE)}hasScope(d){return(0,b.$Jl)(d)?this.W.id===d.id:this.Z===d.id}}e.$sic=R}),define(he[226],ue([0,1,3,2,19,94]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LR=e.$KR=void 0;class N{constructor(b,R){this.a=b,this.b=R}listen(b,R){const $=this.b(b);switch(R){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,d=>({all:d.all.map(g=>(0,A.$Mn)({...g},$)),added:d.added.map(g=>(0,A.$Mn)({...g},$)),removed:d.removed.map(g=>(0,A.$Mn)({...g},$)),updated:d.updated.map(g=>(0,A.$Mn)({...g},$))}))}throw new Error(`Invalid listen ${R}`)}async call(b,R,$){const d=this.b(b);switch(R){case"createProfile":{const g=await this.a.createProfile($[0],$[1],$[2]);return(0,A.$Mn)({...g},d)}case"updateProfile":{let g=(0,T.$Ll)((0,A.$Nn)($[0],d),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,$[1]),(0,A.$Mn)({...g},d)}case"removeProfile":{const g=(0,T.$Ll)((0,A.$Nn)($[0],d),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${R}`)}}e.$KR=N;class O extends c.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,R,$){super(),this.profilesHome=R,this.f=$,this.a=[],this.b=this.B(new I.$ke),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(d=>(0,T.$Ll)(d,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(d=>{const g=d.added.map(E=>(0,T.$Ll)(E,this.profilesHome.scheme)),l=d.removed.map(E=>(0,T.$Ll)(E,this.profilesHome.scheme)),m=d.updated.map(E=>(0,T.$Ll)(E,this.profilesHome.scheme));this.a=d.all.map(E=>(0,T.$Ll)(E,this.profilesHome.scheme)),this.b.fire({added:g,removed:l,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,R,$){const d=await this.f.call("createNamedProfile",[b,R,$]);return(0,T.$Ll)(d,this.profilesHome.scheme)}async createProfile(b,R,$,d){const g=await this.f.call("createProfile",[b,R,$,d]);return(0,T.$Ll)(g,this.profilesHome.scheme)}async createTransientProfile(b){const R=await this.f.call("createTransientProfile",[b]);return(0,T.$Ll)(R,this.profilesHome.scheme)}async setProfileForWorkspace(b,R){await this.f.call("setProfileForWorkspace",[b,R])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,R){const $=await this.f.call("updateProfile",[b,R]);return(0,T.$Ll)($,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$LR=O}),define(he[62],ue([0,1,2,70,4,16,3,79,19]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Mb=e.$7Mb=e.$6Mb=void 0,e.$6Mb=(0,T.$Di)("IUserDataProfileStorageService");let b=class extends I.$Tc{constructor(g,l){super(),this.b=l,g&&(this.a=this.B(new I.$3c))}async readStorageData(g){return this.withProfileScopedStorageService(g,async l=>this.c(l))}async updateStorageData(g,l,m){return this.withProfileScopedStorageService(g,async E=>this.f(E,l,m))}async withProfileScopedStorageService(g,l){if(this.b.hasScope(g))return l(this.b);let m=this.a?.get(g.id);if(!m){m=new $(this.g(g)),this.a?.set(g.id,m);try{await m.initialize()}catch(E){throw this.a?.has(g.id)?this.a.deleteAndDispose(g.id):m.dispose(),E}}try{const E=await l(m);return await m.flush(),E}finally{this.a?.has(g.id)||m.dispose()}}c(g){const l=new Map,m=E=>{for(const f of g.keys(A.StorageScope.PROFILE,E))l.set(f,{value:g.get(f,A.StorageScope.PROFILE),target:E})};return m(A.StorageTarget.USER),m(A.StorageTarget.MACHINE),l}f(g,l,m){g.storeAll(Array.from(l.entries()).map(([E,f])=>({key:E,value:f,scope:A.StorageScope.PROFILE,target:m})),!0)}};e.$7Mb=b,e.$7Mb=b=ve([x(1,A.$gq)],b);class R extends b{constructor(g,l,m,E,f){super(g,E),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new I.$Uc);this.h=this.B(new N.$ke({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(o=>(0,k.$Ll)(o,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(o=>({...o,profile:(0,k.$Ll)(o.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(g){const l=this.j.getChannel("storage");return(0,A.$jq)(g)?new O.$2Mb(l):new O.$3Mb(l,g)}}e.$8Mb=R;class $ extends A.$iq{constructor(g){super({flushInterval:100}),this.U=g}async O(){const g=await this.U,l=new c.$cq(g);return this.B(l.onDidChangeStorage(m=>{this.u(A.StorageScope.PROFILE,m)})),this.B((0,I.$Rc)(()=>{l.close(),l.dispose(),(0,I.$Nc)(g)&&g.dispose()})),this.s=l,this.s.init()}P(g){return g===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(he[227],ue([0,1,16,10,19,56,62]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;let O=class extends N.$8Mb{constructor(b,R,$,d){super(!0,b,R,$,d)}};e.$0hc=O,e.$0hc=O=ve([x(0,A.$Ehc),x(1,T.$Kl),x(2,I.$gq),x(3,c.$$j)],O)}),define(he[40],ue([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cOb=e.$bOb=e.$aOb=e.$_Nb=void 0,e.$9Nb=u,e.$0Nb=i,e.$$Nb=n;function u(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||i(h.syncData)))}function i(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}function n(h,y){return`${(0,b.$8f)(h)}${y.isDefault?"":` (${y.name})`}`}let t=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,L,S,v,C,U,F,M,G,V,_,H){super(),this.syncResource=y,this.collection=L,this.G=S,this.H=v,this.I=C,this.J=U,this.L=F,this.M=M,this.N=G,this.O=V,this.P=_,this.c=null,this.m=p.SyncStatus.Idle,this.n=this.B(new N.$ke),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new N.$ke),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Bh(50)),this.w=this.B(new N.$ke),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,p.$Fnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,p.$1nb),this.y=(0,p.$Gnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,v,this.h),this.j=(0,E.$mq)(v,S,C)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===p.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const L=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,L={}){await this.U(y,!0,this.ob(),L)}async preview(y,L,S={}){return this.U(y,!1,L,S)}async apply(y,L={}){try{this.F={...L};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,L,S,v){try{if(this.F={...v},this.status===p.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===p.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);let C=p.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(y,U);return C=await this.Y(F,U,L,S),C===p.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):C===p.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(C)}}finally{this.F={}}}async replace(y){const L=this.kb(y);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),C=await this.W(v),U=await this.qb({ref:v.ref,syncData:L},S,C,this.ob(),A.CancellationToken.None),F=[];for(const M of U){const G=await this.sb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.sb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);F.push([M,{...G,remoteChange:V!==p.Change.None?V:p.Change.Modified}])}await this.tb(v,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(p.SyncStatus.Idle)}return!0}async W(y){const L=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===L}async X(y,L){if(L){const S=y?y[this.resource]:void 0;if(L.ref===S||S===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(y,L,S,v){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new p.$Nnb((0,$.localize)(11020,null,this.resource,this.pb,y.syncData.version),p.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,L,S,v)}catch(C){if(C instanceof p.$Nnb)switch(C.code){case p.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,L,S,v);case p.UserDataSyncErrorCode.Conflict:case p.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(y,L,S,v)}throw C}}async Z(y,L,S,v){try{const C=await this.W(y),U=!C&&L===null&&this.gb()!==void 0,F=S&&!U;this.c||(this.c=(0,c.$qh)(G=>this.eb(y,L,C,F,v,G)));let M=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const G of M.resourcePreviews)M=await this.accept(G.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:G})=>G===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:S?await this.ab(!1):p.SyncStatus.Syncing}catch(C){throw this.c=null,C}}async merge(y){return await this.$(y,async L=>{const S=await this.rb(L,A.CancellationToken.None);await this.G.writeFile(L.previewResource,T.$Me.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(L,L.previewResource,void 0,A.CancellationToken.None):void 0;return L.acceptResult=v,L.mergeState=S.hasConflicts?p.MergeState.Conflict:v?p.MergeState.Accepted:p.MergeState.Preview,L.localChange=v?v.localChange:S.localChange,L.remoteChange=v?v.remoteChange:S.remoteChange,L}),this.c}async accept(y,L){return await this.$(y,async S=>{const v=await this.sb(S,y,L,A.CancellationToken.None);return S.acceptResult=v,S.mergeState=p.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(y){return await this.$(y,async L=>{const S=await this.rb(L,A.CancellationToken.None);return await this.G.writeFile(L.previewResource,T.$Me.fromString(S.content||"")),L.acceptResult=void 0,L.mergeState=p.MergeState.Preview,L.localChange=S.localChange,L.remoteChange=S.remoteChange,L}),this.c}async $(y,L){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:C,remoteResource:U,previewResource:F})=>this.h.isEqual(C,y)||this.h.isEqual(U,y)||this.h.isEqual(F,y));v!==-1&&(this.c=(0,c.$qh)(async C=>{const U=[...S.resourcePreviews];return U[v]=await L(U[v]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:C})=>C===p.MergeState.Conflict)?this.S(p.SyncStatus.HasConflicts):this.S(p.SyncStatus.Syncing))}async ab(y){if(!this.c)return p.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:S})=>S===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:S})=>S!==p.MergeState.Accepted)?p.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),p.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const L=y.filter(({mergeState:S})=>S===p.MergeState.Conflict);(0,I.$tb)(this.s,L,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const L=this.c?await this.c:null;if(L)for(const S of L.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$pl)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,L,S,v,C,U){const F=await this.qb(y,L,S,C,U),M=[];for(const G of F){const V=G.previewResource.with({scheme:p.$Znb,authority:"accepted"});if(G.localChange===p.Change.None&&G.remoteChange===p.Change.None)M.push({...G,acceptedResource:V,acceptResult:{content:null,localChange:p.Change.None,remoteChange:p.Change.None},mergeState:p.MergeState.Accepted});else{const _=v?await this.rb(G,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(G.previewResource,T.$Me.fromString(_?.content||""));const H=_&&!_.hasConflicts?await this.sb(G,G.previewResource,void 0,U):void 0;M.push({...G,acceptResult:H,mergeState:_?.hasConflicts?p.MergeState.Conflict:H?p.MergeState.Accepted:p.MergeState.Preview,localChange:H?H.localChange:_?_.localChange:G.localChange,remoteChange:H?H.remoteChange:_?_.remoteChange:G.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:L,resourcePreviews:M,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!S&&L.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,C=1;for(;v===void 0&&C++<6;)try{const U=await this.hb();U&&(U.ref===L.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$tl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof p.$Nnb)throw U;this.O.error(U,C)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:L.ref,syncData:v})}catch(U){if(U instanceof p.$Nnb&&U.code===p.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...L,syncData:v}}async fb(y,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:y.ref,version:S,...L};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const L=y?JSON.parse(y):void 0;if(u(L))return L}catch(L){this.O.error(L)}}async ib(y){await this.G.writeFile(this.y,T.$Me.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),L=JSON.parse(y.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(y){y instanceof l.$tl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:L,content:S}=await this.lb(y);let v=null;return S!==null&&(v=this.kb(S)),{ref:L,syncData:v}}kb(y){try{const L=JSON.parse(y);if(i(L))return L}catch(L){this.O.error(L)}throw new p.$Nnb((0,$.localize)(11021,null),p.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const L=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(y,L){const S=await this.j,v={version:this.pb,machineId:S,content:y};try{return L=await this.J.writeResource(this.resource,JSON.stringify(v),L,this.collection,this.F),{ref:L,syncData:v}}catch(C){throw C instanceof p.$Nnb&&C.code===p.UserDataSyncErrorCode.TooLarge&&(C=new p.$Nnb(C.message,C.code,this.resource)),C}}async nb(y){const L={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==p.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(p.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(p.$Anb)}};e.$_Nb=t,e.$_Nb=t=ve([x(2,l.$$k),x(3,g.$Ki),x(4,f.$gq),x(5,p.$Inb),x(6,p.$Jnb),x(7,p.$Snb),x(8,w.$0l),x(9,p.$Xnb),x(10,d.$0i),x(11,P.$Il)],t);let s=class extends t{constructor(y,L,S,v,C,U,F,M,G,V,_,H,ie){super(L,S,v,C,U,F,M,G,V,_,H,ie),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(B=>this.yb(B)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,L,S){try{L?await this.G.writeFile(this.r,T.$Me.fromString(y),S?void 0:L):await this.G.createFile(this.r,T.$Me.fromString(y),{overwrite:S})}catch(v){throw v instanceof l.$tl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$tl&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new p.$Nnb(v.message,p.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$tl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$aOb=s,e.$aOb=s=ve([x(3,l.$$k),x(4,g.$Ki),x(5,f.$gq),x(6,p.$Inb),x(7,p.$Jnb),x(8,p.$Snb),x(9,w.$0l),x(10,p.$Xnb),x(11,d.$0i),x(12,P.$Il)],s);let r=class extends s{constructor(y,L,S,v,C,U,F,M,G,V,_,H,ie,B){super(y,L,S,v,C,U,F,M,G,V,_,ie,B),this.zb=H,this.Bb=void 0}Ab(y,L){const S=[],v=(0,O.$Wn)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,R.$kg)(v)&&L!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$bOb=r,e.$bOb=r=ve([x(3,l.$$k),x(4,g.$Ki),x(5,f.$gq),x(6,p.$Inb),x(7,p.$Jnb),x(8,p.$Snb),x(9,w.$0l),x(10,p.$Xnb),x(11,p.$Wnb),x(12,d.$0i),x(13,P.$Il)],r);let a=class{constructor(y,L,S,v,C,U,F){this.resource=y,this.g=L,this.h=S,this.j=v,this.k=C,this.l=U,this.d=F.extUri,this.f=(0,p.$Gnb)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(L);if(S)try{await this.o({ref:y,syncData:S})}catch(v){this.j.error(v)}}m(y){try{const L=JSON.parse(y);if(i(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,T.$Me.fromString(JSON.stringify(y)))}};e.$cOb=a,e.$cOb=a=ve([x(1,o.$Kl),x(2,g.$Ki),x(3,m.$$j),x(4,l.$$k),x(5,f.$gq),x(6,P.$Il)],a)}),define(he[119],ue([0,1,6,25,8,3,45,2,26,21,15,118,27,35,85,34,7,4,76,10,16,18,28,19,40,206,114,24,62]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=void 0,e.$Hcc=y,e.$Icc=L;async function h(U,F){const M=JSON.parse(U.content);if(U.version===1||U.version===2){const G=(await F.getInstalled(m.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of M)U.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),U.version===2&&G.every(_=>!(0,g.$Kp)(_.identifier,V.identifier))&&(V.installed=!0)}return M}function y(U){return JSON.parse(U.content)}function L(U,F){return U.sort((M,G)=>!M.identifier.uuid&&G.identifier.uuid?-1:M.identifier.uuid&&!G.identifier.uuid?1:(0,k.$xf)(M.identifier.id,G.identifier.id)),F?(0,N.$7n)(U,{}):JSON.stringify(U)}let S=class extends n.$_Nb{constructor(F,M,G,V,_,H,ie,B,z,ee,ne,le,te,Q,K,q,D){super({syncResource:r.SyncResource.Extensions,profile:F},M,V,G,_,H,ie,le,te,ee,ne,K),this.Cb=B,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Znb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Znb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Znb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Znb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,X=>X.some(({local:J})=>!!J)),A.Event.filter(this.Cb.onDidUninstallExtension,X=>!X.error),A.Event.filter(q.onDidChange,X=>X.valueChanges.some(({profile:J,changes:j})=>this.syncResource.profile.id===J.id&&j.some(W=>W.key===d.$np))),Q.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const G=F.syncData?await h(F.syncData,this.Cb):null,V=M?.skippedExtensions??[],_=M?.builtinExtensions??null,H=M?.syncData?await h(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:B}=await this.Bb.getLocalExtensions(this.syncResource.profile);G?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,t.$Gcc)(ie,G,H,V,B,_),ne={local:z,remote:ee,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ee!==null?r.Change.Modified:r.Change.None},le=this.Ob(ie,!1);return[{skippedExtensions:V,builtinExtensions:_,baseResource:this.xb,baseContent:H?this.Ob(H,!1):le,localResource:this.yb,localContent:le,localExtensions:ie,remoteResource:this.zb,remoteExtensions:G,remoteContent:G?this.Ob(G,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await h(F.syncData,this.Cb):null,{localExtensions:G,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:_}=(0,t.$Gcc)(G,M,M,F.skippedExtensions||[],V,F.builtinExtensions||[]);return _!==null}Hb(F,M,G,V){const _=[...M,...G],H=new Set,ie=B=>{H.add(B.id.toLowerCase()),B.uuid&&H.add(B.uuid)};_.forEach(({identifier:B})=>ie(B)),V.forEach(ie);for(const B of F)H.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&H.has(B.identifier.uuid)||_.push(B);return this.Ob(_,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,G,V){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(M),V=(0,t.$Gcc)(F.localExtensions,null,null,F.skippedExtensions,G,F.builtinExtensions),{local:_,remote:H}=V;return{content:F.localContent,local:_,remote:H,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(M),V=F.remoteContent?JSON.parse(F.remoteContent):null;if(V!==null){const _=(0,t.$Gcc)(F.localExtensions,V,F.localExtensions,[],G,F.builtinExtensions),{local:H,remote:ie}=_;return{content:F.remoteContent,local:H,remote:ie,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ie!==null?r.Change.Modified:r.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(F,M,G,V){let{skippedExtensions:_,builtinExtensions:H,localExtensions:ie}=G[0][0];const{local:B,remote:z,localChange:ee,remoteChange:ne}=G[0][1];if(ee===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==r.Change.None&&(await this.nb(JSON.stringify(ie)),_=await this.Bb.updateLocalExtensions(B.added,B.removed,B.updated,_,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(z.all);F=await this.mb(le,V?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(te=>te.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(te=>te.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(te=>te.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(ie,H),await this.fb(F,{skippedExtensions:_,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(le=>le.identifier.id))}.`:""}`))}Nb(F,M){const G=new Set,V=[];for(const _ of F)G.add(_.identifier.id.toLowerCase()),_.installed||V.push(_.identifier);if(M)for(const _ of M)G.has(_.id.toLowerCase())||V.push(_);return V}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return L(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$Jcc=S,e.$Jcc=S=ve([x(2,R.$Ki),x(3,E.$$k),x(4,p.$gq),x(5,r.$Inb),x(6,r.$Jnb),x(7,d.$mp),x(8,s.$XOb),x(9,r.$Xnb),x(10,b.$0i),x(11,r.$Snb),x(12,o.$0l),x(13,l.$ow),x(14,u.$Il),x(15,a.$6Mb),x(16,f.$Ci)],S);let v=class{constructor(F,M,G,V,_,H){this.a=F,this.b=M,this.c=G,this.d=V,this.f=_,this.g=H}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),G=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(_,H)=>{const ie=_.getDisabledExtensions();return M.map(B=>{const{identifier:z,isBuiltin:ee,manifest:ne,preRelease:le,pinned:te,isApplicationScoped:Q}=B,K={identifier:z,preRelease:le,version:ne.version,pinned:!!te};Q&&!(0,m.$sn)(ne)&&(K.isApplicationScoped=Q),ie.some(q=>(0,g.$Kp)(q,z))&&(K.disabled=!0),ee||(K.installed=!0);try{const q=H.getKeysForSync({id:z.id,version:ne.version});if(q){const D=H.getExtensionState(B,!0)||{};K.state=Object.keys(D).reduce((X,J)=>(q.includes(J)&&(X[J]=D[J]),X),{})}}catch(q){this.g.info(`${(0,n.$$Nb)(r.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,T.$9)(q))}return K})}),ignoredExtensions:G}}async updateLocalExtensions(F,M,G,V,_){const H=(0,n.$$Nb)(r.SyncResource.Extensions,_),ie=[],B=new Map,z=[],ee=[],ne=await this.a.getInstalled(void 0,_.extensionsResource);if((F.length||G.length)&&await this.j(_,async(Q,K)=>{await I.Promises.settled([...F,...G].map(async q=>{const D=ne.find(j=>(0,g.$Kp)(j.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,K),Q.getDisabledExtensions().some(W=>(0,g.$Kp)(W,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id),await Q.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id),await Q.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id))),z.push(q.identifier);return}const X=q.pinned?q.version:void 0,J=(await this.c.getExtensions([{...q.identifier,version:X,preRelease:X?void 0:q.preRelease}],c.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:J)&&this.h(q.state,D||J,D?.manifest.version,K),J)try{Q.getDisabledExtensions().some(W=>(0,g.$Kp)(W,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id,J.version),await Q.disableExtension(J.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id,J.version)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id,J.version),await Q.enableExtension(J.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id,J.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||X&&D.manifest.version!==X)&&(await this.a.canInstall(J)?(ie.push({extension:J,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:_.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[d.$_o]:!0,[d.$ap]:d.ExtensionInstallSource.SETTINGS_SYNC}}}),B.set(J.identifier.id.toLowerCase(),q)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,J.displayName||J.identifier.id),ee.push(q)))}catch(j){ee.push(q),this.g.error(j),this.g.info(`${H}: Skipped synchronizing extension`,J.displayName||J.identifier.id)}else ee.push(q),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),M.length){const Q=ne.filter(({identifier:K,isBuiltin:q})=>!q&&M.some(D=>(0,g.$Kp)(K,D)));await I.Promises.settled(Q.map(async K=>{this.g.trace(`${H}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:_.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,K.identifier.id),z.push(K.identifier)}))}const le=await this.a.installGalleryExtensions(ie);for(const{identifier:Q,local:K,error:q,source:D}of le){const X=D;if(K)this.g.info(`${H}: Installed extension.`,Q.id,X.version),z.push(Q);else{const J=B.get(Q.id.toLowerCase());J&&(ee.push(J),this.g.info(`${H}: Skipped synchronizing extension`,X.displayName||X.identifier.id)),q instanceof d.$lp&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleApi,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,X.displayName||X.identifier.id):q&&this.g.error(q)}}const te=[];for(const Q of V)z.some(K=>(0,g.$Kp)(K,Q.identifier))||te.push(Q);for(const Q of ee)te.some(K=>(0,g.$Kp)(K.identifier,Q.identifier))||te.push(Q);return te}h(F,M,G,V){const _=V.getExtensionState(M,!0)||{},H=G?V.getKeysForSync({id:M.identifier.id,version:G}):void 0;H?H.forEach(ie=>{_[ie]=F[ie]}):Object.keys(F).forEach(ie=>_[ie]=F[ie]),V.setExtensionState(M,_,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async G=>{const V=new O.$Sc,_=V.add(this.f.createChild(new w.$Bi([p.$gq,G]))),H=V.add(_.createInstance($.$rMb)),ie=V.add(_.createInstance(l.$pw));try{return await M(H,ie)}finally{V.dispose()}})}};e.$Kcc=v,e.$Kcc=v=ve([x(0,d.$mp),x(1,a.$6Mb),x(2,d.$jp),x(3,s.$XOb),x(4,f.$Ci),x(5,r.$Xnb)],v);let C=class extends n.$cOb{constructor(F,M,G,V,_,H,ie,B){super(r.SyncResource.Extensions,V,_,H,G,ie,B),this.p=F,this.q=M}async t(F){return F.syncData?await h(F.syncData,this.p):null}u(F,M){const G=[],V=[],_=[];for(const H of F){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const ie=M.find(B=>(0,g.$Kp)(B.identifier,H.identifier));ie?(G.push(ie),H.disabled&&_.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&_.push(H.identifier))}return{installedExtensions:G,newExtensions:V,disabledExtensions:_,remoteExtensions:F}}};e.$Lcc=C,e.$Lcc=C=ve([x(0,d.$mp),x(1,s.$XOb),x(2,E.$$k),x(3,i.$Kl),x(4,R.$Ki),x(5,P.$$j),x(6,p.$gq),x(7,u.$Il)],C)}),define(he[120],ue([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,81,210,24,19,62,4]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iOb=e.$hOb=e.$gOb=e.$fOb=void 0,e.$eOb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const C=S.storage?Object.keys(S.storage).sort():[],U={};return C.forEach(F=>U[F]=S.storage[F]),S.storage=U,v?(0,N.$7n)(S,{}):JSON.stringify(S)}const r=1;let a=class extends f.$_Nb{constructor(v,C,U,F,M,G,V,_,H,ie,B,z,ee,ne){super({syncResource:p.SyncResource.GlobalState,profile:v},C,F,_,z,M,G,H,ie,V,B,ee),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:p.$Znb,authority:"base"}),this.xb=this.vb.with({scheme:p.$Znb,authority:"local"}),this.yb=this.vb.with({scheme:p.$Znb,authority:"remote"}),this.zb=this.vb.with({scheme:p.$Znb,authority:"accepted"}),this.Ab=ne.createInstance(h),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(T.Event.any(T.Event.filter(F.onDidFilesChange,le=>le.contains(this.H.argvResource)),T.Event.filter(U.onDidChange,le=>!!(le.targetChanges.some(te=>this.syncResource.profile.id===te.id)||le.valueChanges.some(({profile:te,changes:Q})=>this.syncResource.profile.id===te.id&&Q.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,C,U){const F=v.syncData?JSON.parse(v.syncData.content):null;C=C===null&&U?v:C;const M=C&&C.syncData?JSON.parse(C.syncData.content):null,G=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(M),{local:_,remote:H}=(0,P.$dOb)(G.storage,F?F.storage:null,M?M.storage:null,V,this.O),ie={content:null,local:_,remote:H,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:H.all!==null?p.Change.Modified:p.Change.None},B=s(G,!1);return[{baseResource:this.wb,baseContent:M?s(M,!1):B,localResource:this.xb,localContent:B,localUserData:G,remoteResource:this.yb,remoteContent:F?s(F,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(C===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(C),{remote:M}=(0,P.$dOb)(U.storage,C.storage,C.storage,F,this.O);return M.all!==null}async rb(v,C){return{...v.previewResult,hasConflicts:!1}}async sb(v,C,U,F){if(this.h.isEqual(C,this.xb))return this.Gb(v);if(this.h.isEqual(C,this.yb))return this.Hb(v);if(this.h.isEqual(C,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:p.Change.None,remoteChange:p.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const C=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,P.$dOb)(v.localUserData.storage,C.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:F!==null?p.Change.Modified:p.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:p.Change.None,remoteChange:p.Change.None}}async tb(v,C,U,F){const{localUserData:M}=U[0][0],{local:G,remote:V,localChange:_,remoteChange:H}=U[0][1];if(_===p.Change.None&&H===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),_!==p.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(G,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==p.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:V.all});v=await this.mb(ie,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}C?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const C=await this.db(v);return C&&s(JSON.parse(C),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const C=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[V,_]of C)_.target===l.StorageTarget.USER?U.push(V):_.target===l.StorageTarget.MACHINE&&F.push(V);const M=[...U,...F],G=v?.storage?Object.keys(v.storage).filter(V=>!V.startsWith(n)&&!M.includes(V)&&C.get(V)!==void 0):[];if(!O.$p){const V=[...p.$Enb.map(_=>(0,p.$Rnb)(_)),p.$Qnb];G.push(...V),F.push(...V)}return{user:U,machine:F,unregistered:G}}};e.$fOb=a,e.$fOb=a=ve([x(2,u.$6Mb),x(3,$.$$k),x(4,p.$Inb),x(5,p.$Jnb),x(6,p.$Xnb),x(7,R.$Ki),x(8,p.$Snb),x(9,m.$0l),x(10,b.$0i),x(11,l.$gq),x(12,E.$Il),x(13,i.$Ci)],a);let h=class{constructor(v,C,U,F){this.a=v,this.b=C,this.c=U,this.d=F}async getLocalGlobalState(v){const C={};if(v.isDefault){const F=await this.f(),M=(0,A.$Wn)(F);for(const G of t)M[G]!==void 0&&(C[`${n}${G}`]={version:1,value:M[G]})}const U=await this.c.readStorageData(v);for(const[F,M]of U)M.value&&M.target===l.StorageTarget.USER&&(C[F]={version:1,value:M.value});return{storage:C}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,c.$9)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:C,updated:U},F){const M=(0,f.$$Nb)(p.SyncResource.GlobalState,F),G={},V=new Map,_=await this.c.readStorageData(F),H=(ie,B)=>{for(const z of ie){if(z.startsWith(n)){G[z.substring(n.length)]=B?B[z].value:void 0;continue}if(B){const ee=B[z];ee.value!==_.get(z)?.value&&V.set(z,ee.value)}else _.get(z)!==void 0&&V.set(z,void 0)}};if(H(Object.keys(v),v),H(Object.keys(U),U),H(C),Object.keys(G).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let B=ie;for(const z of Object.keys(G))B=(0,w.edit)(B,[z],G[z],{});ie!==B&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Me.fromString(B)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}V.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,V,l.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...V.keys()]))}};e.$gOb=h,e.$gOb=h=ve([x(0,$.$$k),x(1,R.$Ki),x(2,u.$6Mb),x(3,p.$Xnb)],h);let y=class extends f.$cOb{constructor(v,C,U,F,M,G){super(p.SyncResource.GlobalState,U,F,M,C,v,G)}async o(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(!C){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const M of Object.keys(C.storage))M.startsWith(n)?U[M.substring(n.length)]=C.storage[M].value:this.l.get(M,l.StorageScope.PROFILE)===void 0&&(F[M]=C.storage[M].value);if(Object.keys(U).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const G of Object.keys(U))M=(0,w.edit)(M,[G],U[G],{});await this.k.writeFile(this.h.argvResource,I.$Me.fromString(M))}if(Object.keys(F).length){const M=[];for(const G of Object.keys(F))M.push({key:G,value:F[G],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$hOb=y,e.$hOb=y=ve([x(0,l.$gq),x(1,$.$$k),x(2,o.$Kl),x(3,R.$Ki),x(4,p.$Xnb),x(5,E.$Il)],y);let L=class{constructor(v,C,U,F,M){this.a=v,this.b=C,this.c=U,this.d=F,this.f=M}getSyncStoreType(v){return this.h(v)?.storage[p.$Qnb]?.value}async sync(v){const C=(0,p.$Mnb)((0,k.$Zg)());try{return await this.g(v,C)}catch(U){if(U instanceof p.$Nnb)switch(U.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,C)}throw U}}async g(v,C){const U=await this.a.readResource(p.SyncResource.GlobalState,null,void 0,C),F=this.h(U)||{storage:{}};F.storage[p.$Qnb]={value:v,version:r};const M=await(0,g.$mq)(this.c,this.d,this.b),G={version:r,machineId:M,content:s(F,!1)};await this.a.writeResource(p.SyncResource.GlobalState,JSON.stringify(G),U.ref,void 0,C)}h({content:v}){if(!v)return null;const C=JSON.parse(v);if((0,f.$0Nb)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};e.$iOb=L,e.$iOb=L=ve([x(1,l.$gq),x(2,R.$Ki),x(3,$.$$k),x(4,d.$$j)],L)}),define(he[121],ue([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,207,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0,e.$Ncc=P;function P(u,i,n){try{const t=JSON.parse(u);if(!i)return(0,O.$kg)(t.all)?null:t.all;switch(N.OS){case N.OperatingSystem.Macintosh:return(0,O.$kg)(t.mac)?null:t.mac;case N.OperatingSystem.Linux:return(0,O.$kg)(t.linux)?null:t.linux;case N.OperatingSystem.Windows:return(0,O.$kg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let p=class extends E.$bOb{constructor(i,n,t,s,r,a,h,y,L,S,v,C,U){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},n,y,L,S,t,s,h,C,r,v,a,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$Znb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$Znb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$Znb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$Znb,authority:"accepted"}),this.B(T.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const a=n?this.Ob(n):null,h=await this.vb(),y=await this.Cb();let L=null,S=!1,v=!1,C=!1;if(r){let M=h?h.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new w.$Nnb((0,k.localize)(11018,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==M||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const G=await(0,f.$Mcc)(M,r,a,y,this.zb);G.hasChanges&&(L=G.mergeContent,C=G.hasConflicts,S=C||G.mergeContent!==M,v=C||G.mergeContent!==r)}}else h&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=h.value.toString(),v=!0);const U={content:C?a:L,localChange:S?h?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:v?w.Change.Modified:w.Change.None,hasConflicts:C},F=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),a=await(0,f.$Mcc)(s||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:a,localChange:h,remoteChange:y}=t[0][1];if(h===w.Change.None&&y===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new w.$Nnb((0,k.localize)(11019,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),y!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(a||"[]",i.syncData?.content);i=await this.mb(L,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,A.$Wn)(i.value.toString());if((0,I.$Kb)(n))return!0}}catch(i){if(i.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,N.OS){case N.OperatingSystem.Macintosh:t.mac=i;break;case N.OperatingSystem.Linux:t.linux=i;break;case N.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$Bnb)}};e.$Occ=p,e.$Occ=p=ve([x(2,w.$Inb),x(3,w.$Jnb),x(4,w.$Xnb),x(5,b.$0i),x(6,w.$Snb),x(7,$.$$k),x(8,R.$Ki),x(9,d.$gq),x(10,w.$Wnb),x(11,g.$0l),x(12,l.$Il)],p);let o=class extends E.$cOb{constructor(i,n,t,s,r,a){super(w.SyncResource.Keybindings,n,t,s,i,r,a)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Me.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Wn)(i.value.toString());return!(0,I.$Kb)(n)}catch(i){return i.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$Pcc=o,e.$Pcc=o=ve([x(0,$.$$k),x(1,m.$Kl),x(2,R.$Ki),x(3,w.$Xnb),x(4,d.$gq),x(5,l.$Il)],o)}),define(he[122],ue([0,1,17,14,3,11,21,77,15,27,34,7,16,18,28,19,40,211,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0,e.$Qcc=p;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let o=class extends E.$bOb{constructor(n,t,s,r,a,h,y,L,S,v,C,U,F,M){super(n.settingsResource,{syncResource:w.SyncResource.Settings,profile:n},t,s,r,a,h,y,C,U,L,S,v,M),this.Eb=n,this.Fb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Znb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Znb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Znb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Znb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),a=new O.$No(w.$Anb,this.O);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(w.$Anb)||{}}async qb(n,t,s){const r=await this.vb(),a=await this.Cb(),h=this.Mb(n);t=t===null&&s?n:t;const y=t?this.Mb(t):null,L=await this.Sb();let S=null,v=!1,C=!1,U=!1;if(h){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,f.$MMb)(V,h.settings,y?y.settings:null,L,[],a);S=_.localContent||_.remoteContent,v=_.localContent!==null,C=_.remoteContent!==null,U=_.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),C=!0);const F=r?r.value.toString():null,M=y?.settings??null,G={content:U?M:S,localChange:v?w.Change.Modified:w.Change.None,remoteChange:C?w.Change.Modified:w.Change.None,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:G.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:G.remoteChange,previewResource:this.previewResource,previewResult:G,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",a=await this.Sb(),h=await this.Cb();return(0,f.$MMb)(r||"{}",t.settings,t.settings,a,[],h).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,f.$LMb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const a=await this.Cb(),h=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,f.$LMb)(n.fileContent.value.toString(),"{}",h,a):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,f.$LMb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",h,a):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,f.$LMb)(s,n.fileContent?n.fileContent.value.toString():"{}",h,a):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:a}=s[0][0];let{content:h,localChange:y,remoteChange:L}=s[0][1];if(y===w.Change.None&&L===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),h=h?h.trim():"{}",h=h||"{}",this.Vb(h),y!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),a&&await this.nb(JSON.stringify(this.Ob(a.value.toString()))),await this.wb(h,a,r),await this.P.reloadConfiguration(N.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),L!==w.Change.None){const S=await this.Cb(),v=this.Mb(n),C=await this.Sb(h);h=(0,f.$LMb)(h,v?v.settings:"{}",C,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(h)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,f.$NMb)(n.value.toString())}catch(n){if(n.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,f.$LMb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return p(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(T.Event.any(T.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),T.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,f.$JMb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(R.ExtensionType.System);return(0,I.$Lb)(n.map(t=>(0,w.$znb)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(R.ExtensionType.User,this.Eb.extensionsResource);return(0,I.$Lb)(n.map(t=>(0,w.$znb)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new w.$Nnb((0,A.localize)(11017,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$Rcc=o,e.$Rcc=o=ve([x(2,$.$$k),x(3,k.$Ki),x(4,d.$gq),x(5,w.$Inb),x(6,w.$Jnb),x(7,w.$Xnb),x(8,w.$Wnb),x(9,N.$0i),x(10,w.$Snb),x(11,g.$0l),x(12,b.$mp),x(13,l.$Il)],o);let u=class extends E.$cOb{constructor(n,t,s,r,a,h){super(w.SyncResource.Settings,t,s,r,n,a,h)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,c.$Me.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.$NMb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return p(n)}catch(t){this.j.error(t)}return null}};e.$Scc=u,e.$Scc=u=ve([x(0,$.$$k),x(1,m.$Kl),x(2,k.$Ki),x(3,w.$Xnb),x(4,d.$gq),x(5,l.$Il)],u)}),define(he[123],ue([0,1,14,3,29,21,15,7,16,18,28,19,40,208,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0,e.$Vcc=m;function m(w){return JSON.parse(w.content)}let E=class extends d.$_Nb{constructor(P,p,o,u,i,n,t,s,r,a,h,y){super({syncResource:l.SyncResource.Snippets,profile:P},p,u,o,i,n,t,a,h,s,r,y),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(o.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(P,p,o){const u=await this.Hb(),i=this.Gb(u),n=P.syncData?this.Fb(P.syncData):null;p=p===null&&o?P:p;const t=p&&p.syncData?this.Fb(p.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.$Tcc)(i,n,t);return this.Bb(s,u,n||{},t||{})}async ub(P){const p=P.syncData?this.Fb(P.syncData):null;if(p===null)return!0;const o=await this.Hb(),u=this.Gb(o),i=(0,g.$Tcc)(u,p,p);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,p){return P.previewResult}async sb(P,p,o,u){if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$Znb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$Znb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(p,this.g))return o===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:o,localChange:o===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:o===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(P,p,o,u){const i=o.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,u)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,u)),p?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,p,o,u){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of P.conflicts){const t={content:u[n]??null,hasConflicts:!0,localChange:p[n]?l.Change.Modified:l.Change.Added,remoteChange:o[n]?l.Change.Modified:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}for(const n of Object.keys(p))if(!i.has(n)){const t={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"base"}),baseContent:u[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"remote"}),remoteContent:o[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Znb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$Znb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Znb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Znb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Znb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const p={};for(const o of P)o.fileContent&&(p[this.h.basename(o.localResource)]=o.fileContent);await this.nb(JSON.stringify(this.Gb(p)))}async Db(P,p){for(const{fileContent:o,acceptResult:u,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$Me.fromString(u.content),{overwrite:p}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$Me.fromString(u.content),p?void 0:o),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,p,o){const u=p.syncData?this.Fb(p.syncData):{},i=(0,T.$co)(u);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const a=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[a]:i[a]=n.content}return(0,g.$Ucc)(u,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),p=await this.mb(JSON.stringify(i),o?null:p.ref),this.O.info(`${this.D}: Updated remote snippets`)),p}Fb(P){return m(P)}Gb(P){const p={};for(const o of Object.keys(P))p[o]=P[o].value.toString();return p}async Hb(){const P={};let p;try{p=await this.G.resolve(this.vb)}catch(o){if(o instanceof O.$tl&&o.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return P;throw o}for(const o of p.children||[]){const u=o.resource,i=this.h.extname(u);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,u),t=await this.G.readFile(u);P[n]=t}}return P}};e.$Wcc=E,e.$Wcc=E=ve([x(2,N.$Ki),x(3,O.$$k),x(4,k.$gq),x(5,l.$Inb),x(6,l.$Jnb),x(7,l.$Xnb),x(8,A.$0i),x(9,l.$Snb),x(10,b.$0l),x(11,R.$Il)],E);let f=class extends d.$cOb{constructor(P,p,o,u,i,n){super(l.SyncResource.Snippets,p,o,u,P,i,n)}async o(P){const p=P.syncData?JSON.parse(P.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(p)){const i=p[u];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,u);await this.k.createFile(n,I.$Me.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$Xcc=f,e.$Xcc=f=ve([x(0,O.$$k),x(1,$.$Kl),x(2,N.$Ki),x(3,l.$Xnb),x(4,k.$gq),x(5,R.$Il)],f)}),define(he[124],ue([0,1,14,21,15,7,16,18,28,19,40,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=void 0,e.$Ycc=d;function d(E,f){try{return JSON.parse(E).tasks??null}catch(w){return f.error(w),null}}let g=class extends R.$aOb{constructor(f,w,P,p,o,u,i,n,t,s,r,a){super(f.tasksResource,{syncResource:$.SyncResource.Tasks,profile:f},w,n,t,s,P,p,i,r,o,u,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:$.$Znb,authority:"base"}),this.Cb=this.Ab.with({scheme:$.$Znb,authority:"local"}),this.Db=this.Ab.with({scheme:$.$Znb,authority:"remote"}),this.Eb=this.Ab.with({scheme:$.$Znb,authority:"accepted"})}async qb(f,w,P,p){const o=f.syncData?d(f.syncData.content,this.O):null;w=w===null&&P?f:w;const u=w?.syncData?d(w.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(f.syncData){const y=i?i.value.toString():null;if(!u||u!==y||u!==o){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=m(y,o,u);n=L.content,r=L.hasConflicts,t=L.hasLocalChanged,s=L.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const a={content:r?u:n,localChange:t?i?$.Change.Modified:$.Change.Added:$.Change.None,remoteChange:s?$.Change.Modified:$.Change.None,hasConflicts:r},h=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:u,localResource:this.Cb,localContent:h,localChange:a.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(f){const w=f?.syncData?d(f.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),p=P?P.value.toString():null,o=m(p,w,w);return o.hasLocalChanged||o.hasRemoteChanged}async rb(f,w){return f.previewResult}async sb(f,w,P,p){if(this.h.isEqual(w,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:$.Change.None,remoteChange:$.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:f.remoteContent,localChange:$.Change.Modified,remoteChange:$.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:P,localChange:$.Change.Modified,remoteChange:$.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(f,w,P,p){const{fileContent:o}=P[0][0],{content:u,localChange:i,remoteChange:n}=P[0][1];if(i===$.Change.None&&n===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==$.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),o&&await this.nb(JSON.stringify(this.Kb(o.value.toString()))),u?await this.wb(u,o,p):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==$.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(u));f=await this.mb(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$Zcc=g,e.$Zcc=g=ve([x(2,$.$Inb),x(3,$.$Jnb),x(4,$.$Xnb),x(5,c.$0i),x(6,$.$Snb),x(7,A.$$k),x(8,T.$Ki),x(9,N.$gq),x(10,O.$0l),x(11,k.$Il)],g);let l=class extends R.$cOb{constructor(f,w,P,p,o,u){super($.SyncResource.Tasks,w,P,p,f,o,u),this.c=this.g.defaultProfile.tasksResource}async o(f){const w=f.syncData?d(f.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Me.fromString(w)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$1cc=l,e.$1cc=l=ve([x(0,A.$$k),x(1,b.$Kl),x(2,T.$Ki),x(3,$.$Xnb),x(4,N.$gq),x(5,k.$Il)],l);function m(E,f,w){if(E===null&&f===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==E,p=w!==f;return!P&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!p?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!P?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[125],ue([0,1,45,21,15,7,16,18,28,19,40,209,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0,e.$Iec=l,e.$Jec=m;let g=class extends R.$_Nb{constructor(f,w,P,p,o,u,i,n,t,s,r,a,h){super({syncResource:d.SyncResource.Profiles,profile:f},w,p,o,u,i,n,r,a,t,s,h),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.$Znb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$Znb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$Znb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$Znb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?m(f.syncData):null}async getRemoteSyncedProfiles(f){const w=await this.getLastSyncUserData(),P=await this.X(f,w);return P?.syncData?m(P.syncData):null}async qb(f,w,P){if(!this.vb.isEnabled())throw new d.$Nnb("Cannot sync profiles because they are disabled",d.UserDataSyncErrorCode.LocalError);const p=f.syncData?m(f.syncData):null,o=w?.syncData?m(w.syncData):null,u=this.Db(),{local:i,remote:n}=(0,$.$Gec)(u,p,o,[]),t={local:i,remote:n,content:o?this.Eb(o):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:n!==null?d.Change.Modified:d.Change.None},s=l(u,!1);return[{baseResource:this.baseResource,baseContent:o?this.Eb(o):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.Eb(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const w=f?.syncData?m(f.syncData):null,P=this.Db(),{remote:p}=(0,$.$Gec)(P,w,w,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async rb(f,w){return{...f.previewResult,hasConflicts:!1}}async sb(f,w,P,p){if(this.h.isEqual(w,this.localResource))return this.Ab(f);if(this.h.isEqual(w,this.remoteResource))return this.Bb(f);if(this.h.isEqual(w,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(f){const w=this.Db(),P=(0,$.$Gec)(w,null,null,[]),{local:p,remote:o}=P;return{content:f.localContent,local:p,remote:o,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:o!==null?d.Change.Modified:d.Change.None}}async Bb(f){const w=f.remoteContent?JSON.parse(f.remoteContent):null,P=[],p=[];for(const o of this.Db()){const u=w?.find(i=>i.id===o.id);u&&(P.push({id:o.id,name:o.name,collection:u.collection}),p.push(o))}if(w!==null){const o=(0,$.$Gec)(p,w,P,[]),{local:u,remote:i}=o;return{content:f.remoteContent,local:u,remote:i,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:i!==null?d.Change.Modified:d.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:d.Change.None,remoteChange:d.Change.None}}async tb(f,w,P,p){const{local:o,remote:u,localChange:i,remoteChange:n}=P[0][1];i===d.Change.None&&n===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(u?.added.length??0)-(u?.removed.length??0)>20)throw new d.$Nnb("Too many profiles to sync. Please remove some profiles and try again.",d.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==d.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(o.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(o.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(o.updated.map(async s=>{const r=this.vb.profiles.find(a=>a.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==d.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(u?.added.length??0)<=20;if(r)for(const a of u?.added||[]){const h=await this.J.createCollection(this.F);s.push(h),t.push({id:a.id,name:a.name,collection:h,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of u?.removed||[])t.splice(t.findIndex(({id:h})=>a.id===h),1);for(const a of u?.updated||[]){const h=t.find(({id:y})=>a.id===y);h&&t.splice(t.indexOf(h),1,{...h,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{f=await this.updateRemoteProfiles(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&u?.added.length?` Added: ${JSON.stringify(u.added.map(a=>a.name))}.`:""}${u?.updated.length?` Updated: ${JSON.stringify(u.updated.map(a=>a.name))}.`:""}${u?.removed.length?` Removed: ${JSON.stringify(u.removed.map(a=>a.name))}.`:""}`)}catch(a){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.J.deleteCollection(h,this.F)}throw a}for(const a of u?.removed||[])await this.J.deleteCollection(a.collection,this.F)}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,w){return this.mb(this.Eb(f),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const w=await this.db(f);return w&&(0,I.$7n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$Hec=g,e.$Hec=g=ve([x(2,b.$Kl),x(3,A.$$k),x(4,T.$Ki),x(5,N.$gq),x(6,d.$Inb),x(7,d.$Jnb),x(8,d.$Xnb),x(9,c.$0i),x(10,d.$Snb),x(11,O.$0l),x(12,k.$Il)],g);function l(E,f){const w=[...E].sort((P,p)=>P.name.localeCompare(p.name)).map(P=>({id:P.id,name:P.name}));return f?(0,I.$7n)(w,{}):JSON.stringify(w)}function m(E){return JSON.parse(E.content)}}),define(he[228],ue([0,1,3,2,5,15,16,18,24]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;const b="sync.enable";let R=class extends c.$Tc{constructor(d,g,l,m){super(),this.c=d,this.f=g,this.g=l,this.h=m,this.a=new I.$ke,this.onDidChangeEnablement=this.a.event,this.b=new I.$ke,this.onDidChangeResourceEnablement=this.b.event,this.B(d.onDidChangeValue(N.StorageScope.APPLICATION,void 0,this.B(new c.$Sc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,N.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:d}),this.c.store(b,d,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE))}isResourceEnabled(d){return this.c.getBoolean((0,k.$Rnb)(d),N.StorageScope.APPLICATION,!0)}setResourceEnablement(d,g){if(this.isResourceEnabled(d)!==g){const l=(0,k.$Rnb)(d);this.j(l,g)}}getResourceSyncStateVersion(d){}j(d,g){this.c.store(d,g,N.StorageScope.APPLICATION,T.$p?N.StorageTarget.USER:N.StorageTarget.MACHINE)}m(d){if(b===d.key){this.a.fire(this.isEnabled());return}const g=k.$Enb.filter(l=>(0,k.$Rnb)(l)===d.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.$uec=R,e.$uec=R=ve([x(0,N.$gq),x(1,O.$0l),x(2,A.$Ki),x(3,k.$Hnb)],R)}),define(he[229],ue([0,1,6,14,71,2,20,21,15,7,19,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let d=class extends A.$Tc{constructor(l,m,E,f,w){super(),this.a=l,this.b=m,this.c=E,this.f=f,this.g=w,this.h()}async h(){for(const m of this.g.profiles)for(const E of $.$Enb)try{await this.m(this.j(E,m.isDefault?void 0:m.id))}catch(f){this.f.error(f)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(m){(0,b.$pl)(m)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m);return}if(l.children){for(const m of l.children)if(m.isDirectory&&!$.$Enb.includes(m.name)&&!this.g.profiles.some(E=>E.id===m.name))try{this.f.info("Deleting non existing profile from backup",m.resource.path),await this.b.del(m.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,m,E){const f=this.j(l,m,E);try{const w=await this.b.resolve(f);if(w.children)return w.children.filter(p=>p.isFile&&!p.name.startsWith("lastSync")).sort().reverse().map(p=>({ref:p.name,created:this.n(p)}))}catch(w){if((0,b.$pl)(w)!==b.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,m,E,f){const w=this.j(l,E,f),P=(0,N.$eh)(w,m);try{return(await this.b.readFile(P)).value.toString()}catch(p){return this.f.error(p),null}}async writeResource(l,m,E,f,w){const P=this.j(l,f,w),p=(0,N.$eh)(P,`${(0,T.$2m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(p,c.$Me.fromString(m))}catch(o){this.f.error(o)}}j(l,m,E=this.a.userDataSyncHome){return(0,N.$eh)(E,...m?[m,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const m=await this.b.resolve(l);if(m.children){const E=m.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=E.filter(p=>Date.now()-this.n(p)>f);const P=E.length-w.length;P<10&&(w=w.slice(10-P)),await I.Promises.settled(w.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(m){this.f.error(m)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$Fec=d,e.$Fec=d=ve([x(0,k.$Ki),x(1,b.$$k),x(2,O.$0i),x(3,$.$Xnb),x(4,R.$Kl)],d)}),define(he[86],ue([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$wnb=e.$unb=void 0,e.$vnb=o,e.$unb=(0,b.$Di)("IUserDataSyncMachinesService");const m="sync.currentMachineName",E="Safari",f="Chrome",w="Edge",P="Firefox",p="Android";function o(n){switch(n){case E:case f:case w:case P:case p:case(0,T.$i)(T.Platform.Web):return!0}return!1}function u(){return T.$H?E:T.$F?f:T.$I?w:T.$G?P:T.$J?p:(0,T.$i)(T.$p?T.Platform.Web:T.$v)}let i=class extends c.$Tc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,a,h,y){super(),this.h=r,this.j=a,this.m=h,this.n=y,this.c=this.B(new I.$ke),this.onDidChange=this.c.event,this.g=null,this.f=(0,$.$mq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(a=>({...a,isCurrent:a.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:a})=>a===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:u()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),a=r.machines.filter(({id:h})=>h!==s);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(t,s,r){const a=await this.s(r),h=a.machines.find(({id:y})=>y===t);if(h){h.name=s,await this.t(a);const y=await this.f;t===y&&this.h.store(m,s,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,a]of t){const h=s.machines.find(y=>y.id===r);h&&(h.disabled=a?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(m,d.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${u()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$gf)(r)}\\s#(\\d+)`);let h=0;for(const y of t){const L=a.exec(y.name),S=L?parseInt(L[1]):0;h=S>h?S:h}return`${r} #${h+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,N.localize)(11003,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$wnb=i,e.$wnb=i=l=ve([x(0,O.$Ki),x(1,k.$$k),x(2,d.$gq),x(3,g.$Inb),x(4,g.$Xnb),x(5,R.$rk)],i)}),define(he[230],ue([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",p="sync.storeUrl",o="sync.productQuality";let u=class extends O.$Tc{get n(){const t=this.H.get(p,g.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set n(t){t?this.H.store(p,t.toString(),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(p,g.StorageScope.APPLICATION)}get s(){return this.H.get(o,g.StorageScope.APPLICATION)}set s(t){t?this.H.store(o,t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(o,g.StorageScope.APPLICATION)}constructor(t,s,r,a,h,y,L,S,v,C){super(),this.u=s,this.w=r,this.y=a,this.z=h,this.C=y,this.D=L,this.F=S,this.G=v,this.H=C,this.a=this.B(new O.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.$ke),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Bh(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.$0g)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(h.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(N.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$2m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,g.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),s)this.M(!1);else throw a}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=m.$Nnb.toUserDataSyncError(t);s instanceof m.$Pnb&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===m.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===m.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===m.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===m.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===m.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===m.UserDataSyncErrorCode.UpgradeRequired||s.code===m.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===m.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===m.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===m.UserDataSyncErrorCode.ServiceChanged||s.code===m.UserDataSyncErrorCode.DefaultServiceChanged?k.$p&&s.code===m.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(w,!0,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await(0,I.$Eh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,g.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,g.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Lec=u,e.$Lec=u=ve([x(0,d.$rk),x(1,m.$Hnb),x(2,m.$Inb),x(3,m.$Snb),x(4,m.$Tnb),x(5,m.$Xnb),x(6,E.$tMb),x(7,l.$0l),x(8,f.$unb),x(9,g.$gq)],u);class i extends O.$Tc{static{this.a="Interval"}constructor(t,s,r,a,h,y,L,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=a,this.u=h,this.w=y,this.y=L,this.z=S,this.C=v,this.b=this.B(new O.$Uc),this.c=this.B(new N.$ke),this.onDidStartSync=this.c.event,this.f=this.B(new N.$ke),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,I.$Fh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,I.$qh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(h){if((0,A.$3)(h))return}return this.H(t,s,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$0g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,b.$0g)(s.defaultUrl,t.defaultUrl)||!(0,b.$0g)(s.insidersUrl,t.insidersUrl)||!(0,b.$0g)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let a;try{await this.I(s,r)}catch(h){if(this.y.error(h),a=h,m.$Nnb.toUserDataSyncError(h).code===m.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new m.$Pnb((0,$.localize)(11010,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Pnb((0,$.localize)(11011,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Pnb((0,$.localize)(11012,null),m.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,g.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new m.$Pnb((0,$.localize)(11013,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Pnb((0,$.localize)(11014,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Pnb((0,$.localize)(11015,null),m.UserDataSyncErrorCode.SessionExpired);const a=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=a.find(L=>L.isCurrent);if(h?.disabled)throw new m.$Pnb((0,$.localize)(11016,null),m.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new m.$Pnb((0,T.$oj)(L),L instanceof m.$Nnb?L.code:m.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),!s.isCancellationRequested&&(h||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(he[231],ue([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,a,h,y,L,S,v,C,U){this.e=s,this.f=r,this.g=a,this.h=y,this.i=L,this.j=S,this.k=v,this.l=C,this.n=U,this.d=h.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,b.SyncResource.Profiles);return(0,p.$Jec)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,s);if(r.length){const a=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,s);if(a){const h=this.L(a,b.SyncResource.Profiles);return(0,p.$Jec)(h)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:h,ref:y})=>({created:h,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,a){return(await this.f.getAllResourceRefs(s,r?.collection,a)).map(({created:y,ref:L})=>({created:y,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:L,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),a=r?this.k.profiles.find(h=>h.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const a=this.k.profiles.find(h=>h.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(s,a);case b.SyncResource.Keybindings:return this.u(s,a);case b.SyncResource.Tasks:return this.w(s,a);case b.SyncResource.Snippets:return this.y(s,a);case b.SyncResource.GlobalState:return this.D(s,a);case b.SyncResource.Extensions:return this.A(s,a);case b.SyncResource.Profiles:return this.G(s,a);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,N.$mq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,a,h,y){if(s){const{content:L}=await this.M(r,h,a);return L}return this.f.resolveResourceContent(r,h,a,y)}q(s,r,a){const h=this.L(r,s);switch(s){case b.SyncResource.Settings:return this.t(h,a);case b.SyncResource.Keybindings:return this.v(h,a);case b.SyncResource.Tasks:return this.x(h,a);case b.SyncResource.Snippets:return this.z(h,a);case b.SyncResource.GlobalState:return this.E(h,a);case b.SyncResource.Extensions:return this.B(h,a);case b.SyncResource.Profiles:return this.H(h,a);case b.SyncResource.WorkspaceState:return null}}async r(s,r){const a=this.k.profiles.find(h=>h.id===r);if(!a)return null;switch(s){case b.SyncResource.GlobalState:return this.F(a);case b.SyncResource.Extensions:return this.C(a);case b.SyncResource.Profiles:return this.I(a);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(s,r){const a=this.d.joinPath(s,"settings.json"),h=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}t(s,r){switch(r){case"settings.json":return(0,g.$Qcc)(s.content).settings}return null}u(s,r){const a=this.d.joinPath(s,"keybindings.json"),h=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$Ncc)(s.content,!!this.l.getValue(b.$Bnb),this.g)}return null}w(s,r){const a=this.d.joinPath(s,"tasks.json"),h=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}x(s,r){switch(r){case"tasks.json":return(0,E.$Ycc)(s.content,this.g)}return null}async y(s,r){const a=await this.resolveContent(s);if(a){const h=this.L(a,b.SyncResource.Snippets);if(h){const y=(0,d.$Vcc)(h),L=[];for(const S of Object.keys(y)){const v=this.d.joinPath(s,S),C=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);L.push({resource:v,comparableResource:C})}return L}}return[]}z(s,r){return(0,d.$Vcc)(s)[r]||null}A(s,r){const a=this.d.joinPath(s,"extensions.json"),h=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}B(s,r){switch(r){case"extensions.json":return(0,f.$Icc)((0,f.$Hcc)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(f.$Kcc).getLocalExtensions(s);return(0,f.$Icc)(r,!0)}D(s,r){const a=this.d.joinPath(s,"globalState.json"),h=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:a,comparableResource:h}]}E(s,r){switch(r){case"globalState.json":return(0,w.$eOb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(w.$gOb).getLocalGlobalState(s);return(0,w.$eOb)(r,!0)}G(s,r){const a=this.d.joinPath(s,"profiles.json"),h=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:h}]}H(s,r){switch(r){case"profiles.json":return(0,o.$7n)(JSON.parse(s.content),{})}return null}async I(s){return(0,p.$Iec)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,a=[];return s.location&&(a.push(`scheme:${s.location.scheme}`),a.push(`authority:${s.location.authority}`),a.push((0,u.$kf)(s.location.path,"/"))),a.push(`syncResource:${s.syncResource}`),a.push(`profile:${s.profile}`),s.collection&&a.push(`collection:${s.collection}`),s.ref&&a.push(`ref:${s.ref}`),s.node&&a.push(s.node),this.d.joinPath(I.URI.from({scheme:b.$Znb,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...a)}K(s){if(s.scheme!==b.$Znb)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const a=s.authority===i.b;let h,y;const L=[];let S,v,C,U,F;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?h=M.substring(7):M.startsWith("authority:")?y=M.substring(10):M.startsWith("syncResource:")?S=M.substring(13):M.startsWith("profile:")?v=M.substring(8):M.startsWith("collection:")?C=M.substring(11):M.startsWith("ref:")?U=M.substring(4):S?F=M:L.push(M)}return{remote:a,syncResource:S,profile:v,collection:C,ref:U,node:F,location:h&&y!==void 0?this.d.joinPath(I.URI.from({scheme:h,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...L):void 0}}L(s,r){try{const a=JSON.parse(s);if((0,$.$0Nb)(a))return a}catch(a){this.g.error(a)}throw new b.$Nnb((0,c.localize)(11002,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,a){const h=await this.e.resolveResourceContent(s,r,a);return{ref:r,content:h}}};e.$ofc=n,e.$ofc=n=i=ve([x(0,b.$Inb),x(1,b.$Jnb),x(2,b.$Xnb),x(3,k.$Il),x(4,T.$Ki),x(5,O.$gq),x(6,A.$$k),x(7,R.$Kl),x(8,m.$0i),x(9,P.$Ci)],n)}),define(he[232],ue([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;const s="sync.lastSyncTime";let r=class extends O.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,C,U,F,M,G,V,_,H,ie){super(),this.C=S,this.D=v,this.F=C,this.G=U,this.H=F,this.I=M,this.J=G,this.L=V,this.M=_,this.N=H,this.O=ie,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new N.$ke),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.$ke),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new N.$ke),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new N.$ke),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new N.$ke),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new N.$ke),this.onDidResetLocal=this.w.event,this.y=this.B(new N.$ke),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=C.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,m.StorageScope.APPLICATION,void 0),this.B((0,O.$Rc)(()=>this.cb())),this.B(new c.$Ph(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const C=new Date().getTime(),U=(0,R.$Zg)();try{const V=(0,t.$Mnb)(U);v&&(V["Cache-Control"]="no-cache"),S=await this.D.manifest(S,V)}catch(V){const _=t.$Nnb.toUserDataSyncError(V);throw y(_,U,this.F,this.I),_}const F=!1,M=this;let G;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");G=(0,c.$qh)(V=>M.P(S,!1,U,V)),await G.finally(()=>G=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-C}ms`),M.ab()},stop(){return G?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$Nnb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,R.$Zg)(),C=(0,t.$Mnb)(v);let U;try{U=await this.D.manifest(null,C)}catch(G){const V=t.$Nnb.toUserDataSyncError(G);throw y(V,v,this.F,this.I),V}await this.resetLocal();const F=this,M=new T.$ve;return{id:v,async merge(){return F.P(U,!0,v,M.token)},async apply(){try{try{await F.R(U,v,M.token)}catch(G){if(t.$Nnb.toUserDataSyncError(G).code===t.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,M.token);else throw G}}catch(G){throw F.H.error(G),G}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.ab()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(S,v,C,U){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,v,C,U));const M=F.enabled.find(G=>G.resource===t.SyncResource.Profiles);if(M){const G=await M.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(G,S,v,C,U)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,C,U,F){for(const M of S){if(F.isCancellationRequested)return;const G=this.M.profiles.find(_=>_.id===M.id);if(!G){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const V=this.getOrCreateActiveProfileSynchronizer(G,M);this.n.push(...await this.S(V,v,C,U,F))}for(const[M,G]of this.z.entries())this.M.profiles.some(V=>V.id===G[0].profile.id)||(await G[0].resetLocal(),G[1].dispose(),this.z.delete(M))}async R(S,v,C){const U=this.bb();for(const _ of U){if(C.isCancellationRequested)return;await _.apply(v,C)}const F=U.find(_=>_.profile.isDefault);if(!F)return;const M=F.enabled.find(_=>_.resource===t.SyncResource.Profiles);if(!M)return;const V=(await M.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(_=>U.every(H=>H.profile.id!==_.id));V.length&&await this.Q(V,S,!1,v,C)}async S(S,v,C,U,F){return(await S.sync(v,C,U,F)).map(([G,V])=>({profile:S.profile,syncResource:G,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const C of this.bb())for(const U of C.enabled){const F=await U.resolveContent(S);if(F)return F}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const C=await this.resolveContent(S.uri);C&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(C),!0})}async accept(S,v,C,U){this.db(),await this.X(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(v,C),U&&await F.apply((0,b.$jg)(U)?!1:U.force,(0,t.$Mnb)((0,R.$Zg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,m.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),v=[];for(const U of S){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const C=new O.$Sc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=C.add(this.G.createInstance(a,this.M.defaultProfile,void 0)));const F=U.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!F)return;const G=(await F.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,_]of v)G.includes(_)||(this.H.info(`Removing last sync state for stale profile: ${_}`),this.J.remove(V,m.StorageScope.APPLICATION))}finally{C.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(M=>M.collection),C=await this.D.getAllCollections(),U=C.filter(M=>!v.includes(M));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=S.filter(M=>C.includes(M.collection));if(F.length!==S.length){const M=this.G.createInstance(n.$Hec,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const C=(await this.C.readFile(S)).value.toString(),U=JSON.parse(C);if(U.resources)for(const F in U.resources)for(const M of U.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const M in U.collections[F].resources)for(const G of U.collections[F].resources?.[M]??[])await this.O.writeResource(M,G.content,new Date(G.created*1e3),F,v)}async X(S,v){const C=new O.$Sc;try{const U=this.z.get(S.id);if(U){const _=await this.Y(U[0],v,C);return(0,b.$kg)(_)?null:_}if(S.isDefault){const _=C.add(this.G.createInstance(a,S,void 0)),H=await this.Y(_,v,C);return(0,b.$kg)(H)?null:H}if(this.M.isEnabled())return null;const F=C.add(this.G.createInstance(n.$Hec,S,void 0)),M=await this.D.manifest(null),V=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(_=>_.id===S.id);if(V){const _=C.add(this.G.createInstance(a,S,V.collection)),H=await this.Y(_,v,C);return(0,b.$kg)(H)?null:H}return null}finally{C.dispose()}}async Y(S,v,C){const U=[...S.enabled,...S.disabled.reduce((F,M)=>(M!==t.SyncResource.WorkspaceState&&F.push(C.add(S.createSynchronizer(M))),F),[])];for(const F of U){const M=await v(F);if(!(0,b.$kg)(M))return M}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,I.$tb)(this.j,S,(v,C)=>v.profile.id===C.profile.id&&v.syncResource===C.syncResource&&(0,I.$tb)(v.conflicts,C.conflicts,(U,F)=>(0,k.$0g)(U.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let C=this.z.get(S.id);if(C&&C[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),C[1].dispose(),C=void 0,this.z.delete(S.id)),!C){const U=new O.$Sc,F=U.add(this.G.createInstance(a,S,v?.collection));U.add(F.onDidChangeStatus(M=>this.Z(M))),U.add(F.onDidChangeConflicts(M=>this.$())),U.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(S.id,C=[F,U])}return C[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Kec=r,e.$Kec=r=ve([x(0,g.$$k),x(1,t.$Inb),x(2,t.$Hnb),x(3,l.$Ci),x(4,t.$Xnb),x(5,E.$0l),x(6,m.$gq),x(7,t.$Snb),x(8,f.$Kl),x(9,t.$Unb),x(10,t.$Jnb)],r);let a=class extends O.$Tc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$Enb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,C,U,F,M,G,V,_,H){super(),this.profile=S,this.collection=v,this.r=C,this.t=U,this.u=F,this.w=M,this.y=G,this.z=V,this.C=_,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new N.$ke),this.onDidChangeStatus=this.h.event,this.j=this.B(new N.$ke),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new N.$ke),this.onDidChangeConflicts=this.n.event,this.B(C.onDidChangeResourceEnablement(([ie,B])=>this.F(ie,B))),this.B((0,O.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.$Enb)C.isResourceEnabled(ie)&&this.G(ie)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new O.$Sc,C=v.add(this.createSynchronizer(S));v.add(C.onDidChangeStatus(()=>this.L())),v.add(C.onDidChangeConflicts(()=>this.M())),v.add(C.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([C,U,v])}H(S){const v=this.f.findIndex(([C])=>C.resource===S);if(v!==-1){const[[C,,U]]=this.f.splice(v,1);U.dispose(),this.L(),C.stop().then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(o.$Rcc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(p.$Occ,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(u.$Wcc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$Zcc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$fOb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$Jcc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$Hec,this.profile,this.collection)}}async sync(S,v,C,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],G=(0,t.$Mnb)(C),V=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,_=v?await this.I(V):{};for(const H of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(v){const ie=await H.preview(V,_,G);if(ie)for(const B of ie.resourcePreviews)(B.localChange!==t.Change.None||B.remoteChange!==t.Change.None)&&B.mergeState===t.MergeState.Preview&&await H.merge(B.previewResource)}else await H.sync(V,G)}catch(ie){const B=t.$Nnb.toUserDataSyncError(ie);if(y(B,C,this.w,this.y),h(ie))throw B;this.z.error(ie),this.z.error(`${H.resource}: ${(0,A.$oj)(ie)}`),M.push([H.resource,B])}}return M}finally{this.L()}}async apply(S,v){const C=(0,t.$Mnb)(S);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,C)}catch(F){const M=t.$Nnb.toUserDataSyncError(F);if(y(M,S,this.w,this.y),h(F))throw M;this.z.error(F),this.z.error(`${U.resource}: ${(0,A.$oj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,A.$oj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$Anb),C=this.enabled.find(U=>U instanceof o.$Rcc);if(C){const U=await C.getRemoteUserDataSyncConfiguration(S);return{...v,...U}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,I.$tb)(this.m,S,(v,C)=>v.syncResource===C.syncResource&&(0,I.$tb)(v.conflicts,C.conflicts,(U,F)=>(0,k.$0g)(U.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};a=ve([x(2,t.$Snb),x(3,l.$Ci),x(4,d.$jp),x(5,t.$Hnb),x(6,E.$0l),x(7,t.$Xnb),x(8,f.$Kl),x(9,$.$0i)],a);function h(L){if(L instanceof t.$Nnb)switch(L.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(L,S,v,C){C.publicLog2("sync/error",{code:L.code,serverCode:L instanceof t.$Onb?String(L.serverCode):void 0,url:L instanceof t.$Onb?L.url:void 0,resource:L.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(he[233],ue([0,1,3,2,9,19,24]),function(ae,e,I,c,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0;function O(d,g){return{...d,profile:(0,A.$Ll)(d.profile,g.profilesHome.scheme)}}function k(d){return{created:d.created,uri:T.URI.revive(d.uri)}}class b{constructor(g,l,m){this.c=g,this.d=l,this.f=m,this.a=new Map,this.b=new I.$ke}listen(g,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(g,l,m){try{return await this.g(g,l,m)}catch(E){throw this.f.error(E),E}}async g(g,l,m){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(T.URI.revive(m[0]));case"accept":return this.c.accept(O(m[0],this.d),T.URI.revive(m[1]),m[2],m[3]);case"replace":return this.c.replace(k(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(T.URI.revive(m[0]));case"extractActivityData":return this.c.extractActivityData(T.URI.revive(m[0]),T.URI.revive(m[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),f=m[0],w=this.h(f);switch(m=m.slice(1),E){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h(g){const l=this.a.get(this.j(g));if(!l)throw new Error(`Manual sync taks not found: ${g}`);return l}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.$8hc=b;let R=class extends c.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,l){super(),this.n=l,this.b=N.SyncStatus.Uninitialized,this.c=this.B(new I.$ke),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$ke),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$ke),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$ke),this.onSyncErrors=this.m.event,this.a={call(m,E,f){return g.call(m,E,f).then(null,w=>{throw N.$Nnb.toUserDataSyncError(w)})},listen(m,E){return g.listen(m,E)}},this.a.call("_getInitialData").then(([m,E,f])=>{this.s(m),this.t(E),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.t(m))),this.B(this.a.listen("onSyncErrors")(m=>this.m.fire(m.map(E=>({...E,error:N.$Nnb.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),l=this;return new $(g,{async call(E,f,w){return l.a.call(`manualSync/${E}`,[g,...Array.isArray(f)?f:[f]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,l,m,E){return this.a.call("accept",[g,l,m,E])}resolveContent(g){return this.a.call("resolveContent",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}saveRemoteActivityData(g){return this.a.call("getRemoteActivityData",[g])}extractActivityData(g,l){return this.a.call("extractActivityData",[g,l])}async s(g){this.b=g,this.c.fire(g)}async t(g){this.f=g.map(l=>({syncResource:l.syncResource,profile:(0,A.$Ll)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(m=>({...m,baseResource:T.URI.revive(m.baseResource),localResource:T.URI.revive(m.localResource),remoteResource:T.URI.revive(m.remoteResource),previewResource:T.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}u(g){this.h!==g&&(this.h=g,this.j.fire(g))}};e.$9hc=R,e.$9hc=R=ve([x(1,A.$Kl)],R);class $ extends c.$Tc{constructor(g,l){super(),this.id=g,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(he[126],ue([0,1,6,25,8,3,2,134,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Nb=e.$7Nb=e.$6Nb=e.$5Nb=e.$4Nb=void 0;const o="configurationSync.store",u="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let a=class extends N.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.$Qnb,P.StorageScope.APPLICATION)}set c(C){this.h.store(p.$Qnb,C,P.StorageScope.APPLICATION,k.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(C,U,F){super(),this.f=C,this.g=U,this.h=F,this.a=this.B(new A.$ke),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new N.$Sc);this.B(A.Event.filter(F.onDidChangeValue(P.StorageScope.APPLICATION,p.$Qnb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[o]),this.a.fire()}m(C){if(C&&(C=k.$p&&C.web?{...C,...C.web}:C,(0,R.$dg)(C.url)&&(0,R.$fg)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(U=>Array.isArray(C.authenticationProviders[U].scopes)))){const U=C,F=!!U.canSwitch,M=U.url===U.insidersUrl?"insiders":"stable",G=(F?this.c:void 0)||M,V=G==="insiders"?U.insidersUrl:G==="stable"?U.stableUrl:U.url;return{url:$.URI.parse(V),type:G,defaultType:M,defaultUrl:$.URI.parse(U.url),stableUrl:$.URI.parse(U.stableUrl),insidersUrl:$.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((_,H)=>(_.push({id:H,scopes:U.authenticationProviders[H].scopes}),_),[])}}}};e.$4Nb=a,e.$4Nb=a=ve([x(0,E.$rk),x(1,g.$0i),x(2,P.$gq)],a);let h=class extends a{constructor(C,U,F){super(C,U,F);const M=this.h.get(u,P.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const G=this.f[o];G?this.h.store(u,JSON.stringify(G),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(u,P.StorageScope.APPLICATION)}async switch(C){C!==this.c&&(this.c=C,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$5Nb=h,e.$5Nb=h=ve([x(0,E.$rk),x(1,g.$0i),x(2,P.$gq)],h);let y=class extends N.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(C,U,F,M,G,V,_){super(),this.n=F,this.r=M,this.s=_,this.g=this.B(new A.$ke),this.onTokenFailed=this.g.event,this.h=this.B(new A.$ke),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$ke),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(C),this.c=(0,w.$mq)(G,V,_).then(H=>{const ie={"X-Client-Name":`${U.applicationName}${k.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,N.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(C,U){this.b={token:C,type:U}}t(C){this.a=C?(0,b.$eh)(C,"v1"):void 0}u(){const C=this.s.getNumber(i,P.StorageScope.APPLICATION);C&&Date.now()<C&&this.y(new Date(C))}y(C){this.j?.getTime()!==C?.getTime()&&(this.j=C,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,I.$qh)(U=>(0,I.$Eh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$eh)(this.a,"collection").toString();C={...C},C["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:C},[],c.CancellationToken.None);return(await(0,f.$_p)(F))?.map(({id:M})=>M)||[]}async createCollection(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$eh)(this.a,"collection").toString();C={...C},C["Content-Type"]=O.$9s.text;const F=await this.D(U,{type:"POST",headers:C},[],c.CancellationToken.None),M=await(0,f.$$p)(F);if(!M)throw new p.$Onb("Server did not return the collection id",U,p.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[p.$Knb]);return M}async deleteCollection(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=C?(0,b.$eh)(this.a,"collection",C).toString():(0,b.$eh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],c.CancellationToken.None)}async getAllResourceRefs(C,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,C),M={},G=await this.D(F.toString(),{type:"GET",headers:M},[],c.CancellationToken.None);return(await(0,f.$_p)(G)||[]).map(({url:_,created:H})=>({ref:(0,b.$gh)(F,F.with({path:_})),created:H*1e3}))}async resolveResourceContent(C,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$eh)(this.z(this.a,F,C),U).toString();M={...M},M["Cache-Control"]="no-cache";const V=await this.D(G,{type:"GET",headers:M},[],c.CancellationToken.None);return await(0,f.$$p)(V)}async deleteResource(C,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=U!==null?(0,b.$eh)(this.z(this.a,F,C),U).toString():this.z(this.a,F,C).toString(),G={};await this.D(M,{type:"DELETE",headers:G},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,b.$eh)(this.a,"resource").toString(),U={"Content-Type":O.$9s.text};await this.D(C,{type:"DELETE",headers:U},[],c.CancellationToken.None)}async readResource(C,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$eh)(this.z(this.a,F,C),"latest").toString();M={...M},M["Cache-Control"]="no-cache",U&&(M["If-None-Match"]=U.ref);const V=await this.D(G,{type:"GET",headers:M},[304],c.CancellationToken.None);let _=null;if(V.res.statusCode===304&&(_=U),_===null){const H=V.res.headers.etag;if(!H)throw new p.$Onb("Server did not return the ref",G,p.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[p.$Knb]);const ie=await(0,f.$$p)(V);if(!ie&&V.res.statusCode===304)throw new p.$Onb("Empty response",G,p.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[p.$Knb]);_={ref:H,content:ie}}return _}async writeResource(C,U,F,M,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,M,C).toString();G={...G},G["Content-Type"]=O.$9s.text,F&&(G["If-Match"]=F);const _=await this.D(V,{type:"POST",data:U,headers:G},[],c.CancellationToken.None),H=_.res.headers.etag;if(!H)throw new p.$Onb("Server did not return the ref",V,p.UserDataSyncErrorCode.NoRef,_.res.statusCode,_.res.headers[p.$Knb]);return H}async manifest(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$eh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",C&&(U["If-None-Match"]=C.ref);const M=await this.D(F,{type:"GET",headers:U},[304],c.CancellationToken.None);let G=null;if(M.res.statusCode===304&&(G=C),!G){const _=M.res.headers.etag;if(!_)throw new p.$Onb("Server did not return the ref",F,p.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[p.$Knb]);const H=await(0,f.$$p)(M);if(!H&&M.res.statusCode===304)throw new p.$Onb("Empty response",F,p.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[p.$Knb]);H&&(G={...JSON.parse(H),ref:_})}const V=this.s.get(n,P.StorageScope.APPLICATION);return V&&G&&V!==G.session&&this.C(),G===null&&V&&this.C(),G&&this.s.store(n,G.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),G}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,b.$eh)(this.a,"download").toString(),U={},F=await this.D(C,{type:"GET",headers:U},[],c.CancellationToken.None);if(!(0,f.$8p)(F))throw new p.$Onb("Server returned "+F.res.statusCode,C,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$Knb]);if((0,f.$9p)(F))throw new p.$Onb("Empty response",C,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$Knb]);return F.stream}z(C,U,F){return U?(0,b.$eh)(C,"collection",U,"resource",F):(0,b.$eh)(C,"resource",F)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(C,U,F,M){if(!this.b)throw new p.$Onb("No Auth Token Available",C,p.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new p.$Onb(`${U.type} request '${C}' failed because of too many requests (429).`,C,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const G=await this.c;U.headers={...U.headers||{},...G,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:C,type:U.type,headers:{...U.headers,authorization:void 0}});let V;try{V=await this.f.request(C,U,M)}catch(z){if(!(z instanceof p.$Onb)){let ee=p.UserDataSyncErrorCode.RequestFailed;const ne=(0,T.$9)(z).toLowerCase();ne.includes("xhr timeout")?ee=p.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?ee=p.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?ee=p.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?ee=p.UserDataSyncErrorCode.RequestHeadersNotObject:(0,T.$3)(z)&&(ee=p.UserDataSyncErrorCode.RequestCanceled),z=new p.$Onb(`Connection refused for the request '${C}'.`,C,ee,void 0,void 0)}throw this.r.info("Request failed",C),z}const _=V.res.headers[p.$Knb],H={url:C,status:V.res.statusCode,"execution-id":U.headers[p.$Lnb],"operation-id":_},ie=(0,f.$8p)(V)||V.res.statusCode&&F.includes(V.res.statusCode);let B="";if(ie?this.r.trace("Request succeeded",H):(B=await(0,f.$0p)(V)||"",this.r.info("Request failed",H,B)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire(p.UserDataSyncErrorCode.Unauthorized),new p.$Onb(`${U.type} request '${C}' failed because of Unauthorized (401).`,C,p.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,_);if(V.res.statusCode===403)throw this.g.fire(p.UserDataSyncErrorCode.Forbidden),new p.$Onb(`${U.type} request '${C}' failed because the access is forbidden (403).`,C,p.UserDataSyncErrorCode.Forbidden,V.res.statusCode,_)}if(this.h.fire(),V.res.statusCode===404)throw new p.$Onb(`${U.type} request '${C}' failed because the requested resource is not found (404).`,C,p.UserDataSyncErrorCode.NotFound,V.res.statusCode,_);if(V.res.statusCode===405)throw new p.$Onb(`${U.type} request '${C}' failed because the requested endpoint is not found (405). ${B}`,C,p.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,_);if(V.res.statusCode===409)throw new p.$Onb(`${U.type} request '${C}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,C,p.UserDataSyncErrorCode.Conflict,V.res.statusCode,_);if(V.res.statusCode===410)throw new p.$Onb(`${U.type} request '${C}' failed because the requested resource is not longer available (410).`,C,p.UserDataSyncErrorCode.Gone,V.res.statusCode,_);if(V.res.statusCode===412)throw new p.$Onb(`${U.type} request '${C}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,C,p.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,_);if(V.res.statusCode===413)throw new p.$Onb(`${U.type} request '${C}' failed because of too large payload (413).`,C,p.UserDataSyncErrorCode.TooLarge,V.res.statusCode,_);if(V.res.statusCode===426)throw new p.$Onb(`${U.type} request '${C}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,C,p.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,_);if(V.res.statusCode===429){const z=V.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new p.$Onb(`${U.type} request '${C}' failed because of too many requests (429).`,C,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,_)):new p.$Onb(`${U.type} request '${C}' failed because of too many requests (429).`,C,p.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,_)}if(!ie)throw new p.$Onb("Server returned "+V.res.statusCode,C,p.UserDataSyncErrorCode.Unknown,V.res.statusCode,_);return V}F(C){let U=this.s.get(t,P.StorageScope.APPLICATION);U===void 0&&(U=(0,d.$Zg)(),this.s.store(t,U,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),C["X-Machine-Session-Id"]=U;const F=this.s.get(n,P.StorageScope.APPLICATION);F!==void 0&&(C["X-User-Session-Id"]=F)}};e.$6Nb=y,e.$6Nb=y=ve([x(1,E.$rk),x(2,f.$6p),x(3,p.$Xnb),x(4,l.$Ki),x(5,m.$$k),x(6,P.$gq)],y);let L=class extends y{constructor(C,U,F,M,G,V,_){super(C.userDataSyncStore?.url,U,F,M,G,V,_),this.B(C.onDidChangeUserDataSyncStore(()=>this.t(C.userDataSyncStore?.url)))}};e.$7Nb=L,e.$7Nb=L=ve([x(0,p.$Hnb),x(1,E.$rk),x(2,f.$6p),x(3,p.$Xnb),x(4,l.$Ki),x(5,m.$$k),x(6,P.$gq)],L);class S{constructor(C,U,F,M){this.c=C,this.d=U,this.f=F,this.g=M,this.a=[],this.b=void 0}request(C,U,F){if(this.h()&&this.i(),U.url=C,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.$Onb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,C,p.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(C),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$8Nb=S}),define(he[234],ue([0,1,3,2,9,21,23,16,126]),function(ae,e,I,c,T,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=e.$5hc=e.$4hc=void 0;class b{constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$4hc=b;class R extends c.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new I.$ke),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(m=>{this.a=m,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$5hc=R;class ${constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$6hc=$;let d=class extends k.$4Nb{constructor(l,m,E,f){super(m,E,f),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:T.URI.revive(l.url),type:l.type,defaultUrl:T.URI.revive(l.defaultUrl),insidersUrl:T.URI.revive(l.insidersUrl),stableUrl:T.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$7hc=d,e.$7hc=d=ve([x(1,N.$rk),x(2,A.$0i),x(3,O.$gq)],d)}),define(he[235],ue([0,1,3,57,23,16,18,230,24,82,86]),function(ae,e,I,c,T,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;let $=class extends O.$Lec{constructor(g,l,m,E,f,w,P,p,o,u,i){super(g,l,m,E,f,P,p,o,u,i),this.B(I.Event.debounce(I.Event.any(I.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$qic=$,e.$qic=$=ve([x(0,T.$rk),x(1,k.$Hnb),x(2,k.$Inb),x(3,k.$Snb),x(4,k.$Tnb),x(5,c.$mgc),x(6,k.$Xnb),x(7,b.$tMb),x(8,N.$0l),x(9,R.$unb),x(10,A.$gq)],$)}),define(he[236],ue([0,1,75,22,5,20]),function(ae,e,I,c,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0,e.$Mfc=N,e.$Nfc=O,e.$Ofc=k,e.$Lfc=128/4;function N(b){function R(){let $=b.scheme===c.Schemas.file?(0,A.$5g)(b):b.toString();return T.$l||($=$.toLowerCase()),(0,I.createHash)("md5").update($).digest("hex")}return{id:R(),configPath:b}}function O(b,R){function $(){if(b.scheme!==c.Schemas.file)return(0,I.createHash)("md5").update(b.toString()).digest("hex");if(!R)return;let g;return T.$l?g=R.ino:T.$k?g=R.birthtime.getTime():T.$j&&(typeof R.birthtimeMs=="number"?g=Math.floor(R.birthtimeMs):g=R.birthtime.getTime()),(0,I.createHash)("md5").update(b.fsPath).update(g?String(g):"").digest("hex")}const d=$();if(typeof d=="string")return{id:d,uri:b}}function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[237],ue([0,1,6,8,2,13,30,15,10,79,115,236,57,56,22]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let m=class extends T.$Tc{constructor(f,w,P,p){super(),this.a=f,this.b=w,this.c=P,this.f=p,this.B(new I.$Ph(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await N.Promises.readdir(f),P=new b.$5Mb(this.f.getChannel("storage"));await Promise.all(w.map(async p=>{const o=(0,A.$ic)(f,p);p.length===$.$Lfc||p===R.$Pi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===p)||await P.isUsed(o)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await N.Promises.rm(o))}))}catch(f){(0,c.$Y)(f)}}};e.$Zhc=m,e.$Zhc=m=ve([x(0,O.$Li),x(1,k.$$j),x(2,d.$mgc),x(3,g.$Ehc)],m)}),define(he[127],ue([0,1,75,67,38,245,14,8,3,2,13,5,32,42,69]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$ui=e.$ti=e.$si=void 0,e.$vi=t,e.$wi=s,e.$yi=h,e.$zi=y;const m=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,O.$Y)(U)}},this.socket.on("error",this.a);let C;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,C&&clearTimeout(C)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,C=setTimeout(()=>S.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=C=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,C),S(N.$Me.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=C=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,O.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,O.$Y)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$si=E;var f;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class P extends b.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,C,U){super(),this.f=this.B(new k.$ke),this.g=this.B(new k.$ke),this.h=!1,this.j={state:w.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new p(this,v,C,U,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,O.$Y)(F),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new l.$ni,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+f.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let U=f.MinHeaderByteSize;S.byteLength<126?U+=0:S.byteLength<2**16?U+=2:U+=8;const F=N.$Me.alloc(U),M=v?64:0,G=C&15;if(F.writeUInt8(128|M|G,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let V=1;F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}else{F.writeUInt8(127,1);let V=1;F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(S.byteLength>>>24&255,++V),F.writeUInt8(S.byteLength>>>16&255,++V),F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}this.socket.write(N.$Me.concat([F,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),U=(C&128)>>>7,F=(C&64)>>>6,M=C&15,G=v.readUInt8(1),V=(G&128)>>>7,_=G&127;this.j.state=w.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(V?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),U=(C&128)>>>7;let F=C&127,M=1;F===126?F=v.readUInt8(++M)*2**8+v.readUInt8(++M):F===127&&(F=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let G=0;U&&(G=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=w.ReadBody,this.j.readLen=F,this.j.mask=G,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=w.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ti=P;class p extends b.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Me.alloc(0)}constructor(S,v,C,U,F,M){super(),this.n=S,this.r=F,this.s=M,this.a=this.B(new k.$ke),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$ke),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$ke),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,U,C,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,S);this.s(C,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((C,U)=>{S.write(v),S.flush(F=>C(F))})}acceptFrame(S,v,C){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,C){return new Promise((U,F)=>{S.write(v),C&&S.write(N.$Me.fromByteArray([0,0,255,255])),S.flush(M=>U(M))})}}class o extends b.$Tc{get recordedInflateBytes(){return this.j?N.$Me.concat(this.f):N.$Me.alloc(0)}constructor(S,v,C,U){super(),this.h=S,this.j=v,this.a=this.B(new k.$ke),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(N.$Me.wrap(F))}),C&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=N.$Me.concat(this.g);this.g.length=0,S(v)})}}class u extends b.$Tc{constructor(S,v){super(),this.g=S,this.a=this.B(new k.$ke),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,C),this.f.push(N.$Me.wrap(C))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=N.$Me.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(L,S){if(S===0)return;const v=L.byteLength>>>2;for(let V=0;V<v;V++){const _=L.readUInt32BE(V*4);L.writeUInt32BE(_^S,V*4)}const C=v*4,U=L.byteLength-C,F=S>>>24&255,M=S>>>16&255,G=S>>>8&255;U>=1&&L.writeUInt8(L.readUInt8(C)^F,C),U>=2&&L.writeUInt8(L.readUInt8(C+1)^M,C+1),U>=3&&L.writeUInt8(L.readUInt8(C+2)^G,C+2)}e.$ui=process.env.XDG_RUNTIME_DIR;const n={[$.Platform.Linux]:107,[$.Platform.Mac]:103};function t(){const L=(0,d.$Zg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const S=process.platform!=="darwin"&&e.$ui?e.$ui:(0,T.tmpdir)(),v=(0,R.$ic)(S,`vscode-ipc-${L}.sock`);return r(v),v}function s(L,S,v){const U=(0,I.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${S}-sock`;const F=v.substr(0,4),M=S.substr(0,6);let G;return process.platform!=="darwin"&&e.$ui&&!process.env.VSCODE_PORTABLE?G=(0,R.$ic)(e.$ui,`vscode-${U}-${F}-${M}.sock`):G=(0,R.$ic)(L,`${F}-${M}.sock`),r(G),G}function r(L){const S=n[$.$v];typeof S=="number"&&L.length>=S&&console.warn(`WARNING: IPC handle "${L}" is longer than ${S} chars, try a shorter --user-data-dir`)}class a extends g.$hi{static b(S){const v=k.Event.fromNodeEventEmitter(S,"connection");return k.Event.map(v,C=>({protocol:new l.$oi(new E(C,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(C,"close"))}))}constructor(S){super(a.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$xi=a;function h(L){return new Promise((S,v)=>{const C=(0,c.createServer)();C.on("error",v),C.listen(L,()=>{C.removeListener("error",v),S(new a(C))})})}function y(L,S){return new Promise((v,C)=>{const U=(0,c.createConnection)(L,()=>{U.removeListener("error",C),v(l.$pi.fromSocket(new E(U,`ipc-client${S}`),S))});U.once("error",C)})}}),define(he[238],ue([0,1,67,127,185]),function(ae,e,I,c,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0,I=Pe(I),e.$tic=new class{supports(A){return!0}connect({host:A,port:N},O,k,b){return new Promise((R,$)=>{const d=I.createConnection({host:A,port:N},()=>{d.removeListener("error",$),d.write((0,T.$txb)(O,k,b));const g=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",g),R(new c.$si(d,b)))};d.on("data",g)});d.setNoDelay(!0),d.once("error",$)})}}}),define(he[239],ue([0,1,67,38,147,127,6,2,5,21,10,23,186,106,108,80,14]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.$whc=e.$vhc=void 0,I=Pe(I),c=Pe(c);async function f(u,i,n,t,s){let r;for(let a=3;a&&(r?.dispose(),r=await new w(u,i,n,t,s).waitForReady(),!(s&&T.$3g[s]||!T.$3g[r.tunnelLocalPort]));a--);return r}class w extends O.$Tc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=I.createServer(),this.c=new N.$Ch,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,m.$Kw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,T.$4g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,m.$Iw)(this.tunnelRemoteHost)||(0,m.$Kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,d.$1l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof A.$si?s.socket.destroy():s.end()}),s instanceof A.$si?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Me.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$vhc=w;let P=class extends m.$Nw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,m.$Lw)(i,this.t,k.OS,c.release())}F(i,n,t,s,r,a,h,y){const L=this.D(n,t);if(L)return++L.refcount,L.value;if((0,m.$Ew)(i))return this.G(i,n,t,r,a,h,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$whc=P,e.$whc=P=ve([x(0,g.$Ul),x(1,R.$$j),x(2,l.$Xl),x(3,$.$rk),x(4,b.$0i)],P);let p=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$xhc=p,e.$xhc=p=ve([x(0,g.$Ul),x(1,R.$$j),x(2,l.$Xl),x(3,$.$rk),x(4,b.$0i)],p);let o=class extends O.$Tc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,a,h,y,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${a}.`),!this.a.has(i)){const S=new p(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,a,h,y,L)}};e.$yhc=o,e.$yhc=o=ve([x(0,g.$Ul),x(1,R.$$j),x(2,$.$rk),x(3,l.$Xl),x(4,b.$0i)],o)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[246],ue([0,1,38,43,8,2,22,9,17,3,42,151,179,180,189,171,237,162,163,21,184,97,196,98,191,15,118,223,27,110,187,117,74,7,173,174,73,4,170,76,78,199,10,175,102,23,61,16,109,18,111,112,113,48,202,85,114,24,82,229,234,212,86,228,232,233,126,62,227,213,108,195,80,239,190,203,28,204,5,205,164,182,181,84,218,19,52,178,58,226,201,214,107,231,219,11,176,101,224,217,192,158,57,177,235,221,56,225,106,104,238,156,193,145,133,144]),function(ae,e,I,c,T,A,N,O,k,b,R,$,d,g,l,m,E,f,w,P,p,o,u,i,n,t,s,r,a,h,y,L,S,v,C,U,F,M,G,V,_,H,ie,B,z,ee,ne,le,te,Q,K,q,D,X,J,j,W,Y,Z,se,ce,me,pe,Ee,ke,be,we,Se,oe,de,ge,Ie,Oe,De,Ne,Le,Ue,Be,Ve,Me,qe,ze,We,Te,re,fe,$e,ye,Ae,Ce,je,xe,Je,Ze,He,_e,Ye,nt,at,Lt,Tt,Ct,Nt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends A.$Tc{constructor(Re){super(),this.f=Re,this.a=this.B(new $.$4X(this)),this.b=void 0,this.c=this.B(new b.$ke),this.g()}g(){let Re=!1;const Fe=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,$.$5X)(process.parentPort,ht.$Igc.exit,Fe)}async init(){const Re=await this.h();(0,Y.$Cnb)(),Re.invokeFunction(Fe=>{const Ke=Fe.get(ie.$$j),Ge=Fe.get(Q.$0l),et=Fe.get(fe.$Kl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,A.$Qc)(Re.createInstance(d.$Vhc,this.f.codeCachePath),Re.createInstance(g.$Whc),Re.createInstance(E.$Zhc),Re.createInstance(m.$Yhc),Re.createInstance(l.$Xhc),Re.createInstance(He.$kic),Re.createInstance(xe.$cic)))}async h(){const Re=new V.$Bi,Fe={_serviceBrand:void 0,...z.default};Re.set(ee.$rk,Fe);const Ke=new R.$li(Qe=>Qe==="main"),Ge=new yt.$Fhc(this.a,Ke);Re.set(yt.$Ehc,Ge);const et=this.f.policiesData?new ye.$_gc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$to;Re.set(Ae.$ro,et);const Xe=new Bt.$7m(this.f.args,Fe);Re.set(t.$Li,Xe);const ot=new B.$rs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Qe=>({...Qe,resource:O.URI.revive(Qe.resource)})),Ge.getChannel("logger"));Re.set(ie.$_j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(12142,null)})),$t=this.B(new ie.$gk(ft.getLevel())),tt=this.B(new Ye.$ER(ft,[$t]));Re.set(ie.$$j,tt),this.b=this.B(new nt.$mic(tt)),Re.set(nt.$lic,this.b);const st=this.B(new C.$1q(tt));Re.set(v.$$k,st);const pt=this.B(new U.$rr(tt));st.registerProvider(N.Schemas.file,pt);const dt=new Be.$Ss(st);Re.set(Ue.$Il,dt);const rt=this.B(new Ce.$LR(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Kl,rt);const wt=this.B(new Me.$Dhc(N.Schemas.file,this.B(new qe.$nR(Ge.getChannel(qe.$mR),{pathCaseSensitive:Ve.$l})),N.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(N.Schemas.vscodeUserData,wt);const ct=this.B(new p.$Vo(rt.defaultProfile.settingsResource,st,et,tt));Re.set(P.$0i,ct);const bt=new Mt.$sic(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(le.$gq,bt),this.B((0,A.$Rc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Tt.$bs(Ge.getChannel("request"));Re.set(ne.$6p,It),Re.set(f.$1hc,new F.$Ai(w.$2hc,void 0,!1)),Re.set(We.$XG,new F.$Ai(ze.$bic,void 0,!1));const Rt=new Dt.$Hhc(-1,Ge);Re.set(Nt.$mgc,Rt),Re.set(i.$Zo,new F.$Ai(n.$TR,void 0,!0));const Gt=this.B(new de.$9gc(Rt)),Kt=new R.$li(Qe=>Gt.getActiveClientId().then(mt=>Qe===mt));Re.set(S.$k7b,new Ct.$oic(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,X.$Hp)(Fe,ct);if((0,X.$Cp)(Fe,Xe)){const Qe=new q.$3dc(tt,ot,Xe,Fe);if(lt.push(Qe),!(0,X.$Dp)(Fe,Xe)&&Fe.aiConfig?.ariaKey){const mt=new je.$sR(It,Pt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,A.$Rc)(()=>mt.flush())),lt.push(mt)}gt=new D.$fs({appenders:lt,commonProperties:(0,te.$tp)((0,I.release)(),(0,I.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,X.$Ip)(Xe)},ct,Fe)}else{gt=X.$xp;const Qe=X.$Bp;lt.push(Qe)}this.a.registerChannel("telemetryAppender",new K.$Ngc(lt)),Re.set(Q.$0l,gt);const Jt=new J.$3hc(ct,gt,tt,ot,Xe,Fe);Re.set(Q.$$l,Jt),Re.set($e.$Hq,new F.$Ai(Lt.$DR,void 0,!0)),Re.set(Te.$Lq,new F.$Ai(re.$ahc,void 0,!0)),Re.set(h.$rq,new F.$Ai(h.$tq,void 0,!0)),Re.set(L.$Wq,new F.$Ai(L.$Xq,void 0,!0)),Re.set(a.$jp,new F.$Ai(r.$pq,void 0,!0)),Re.set(a.$qp,new F.$Ai(Ft.$ric,void 0,!1)),Re.set(_.$0r,new F.$Ai(H.$_r,void 0,!1)),Re.set(o.$Rm,new F.$Ai(u.$Zs,void 0,!1)),Re.set(Z.$tMb,new F.$Ai(Z.$uMb,void 0,!0)),Re.set(Y.$Xnb,new F.$Ai(me.$ZOb,void 0,!0)),Re.set(Y.$Wnb,R.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Re.set(a.$pp,new F.$Ai(s.$rMb,void 0,!1)),Re.set(W.$XOb,new F.$Ai(W.$YOb,void 0,!0)),Re.set(j.$ow,new F.$Ai(j.$pw)),Re.set(Y.$Hnb,new F.$Ai(we.$5Nb,void 0,!0)),Re.set(Y.$Inb,new F.$Ai(we.$7Nb,void 0,!0)),Re.set(pe.$unb,new F.$Ai(pe.$wnb,void 0,!0)),Re.set(Y.$Jnb,new F.$Ai(se.$Fec,void 0,!1)),Re.set(Y.$Snb,new F.$Ai(Ee.$uec,void 0,!0)),Re.set(Y.$Tnb,new F.$Ai(ke.$Kec,void 0,!1)),Re.set(Se.$6Mb,new F.$Ai(oe.$0hc,void 0,!0)),Re.set(Y.$Unb,new F.$Ai(Ze.$ofc,void 0,!0)),Re.set(ge.$Xl,new F.$Ai(Ie.$Ahc,void 0,!1));const kt=new vt.$Vl;return Re.set(vt.$Ul,kt),kt.register(jt.RemoteConnectionType.WebSocket,qt.$tic),Re.set(Oe.$Dw,new F.$Ai(De.$yhc)),Re.set(Ne.$$hc,new F.$Ai(Le.$aic)),Re.set(Je.$dic,new F.$Ai(at.$nic)),new G.$ur(Re)}j(Re){const Fe=new y.$vq(Re.get(a.$mp),()=>null);this.a.registerChannel("extensions",Fe);const Ke=R.ProxyChannel.fromService(Re.get(_.$0r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=R.ProxyChannel.fromService(Re.get(o.$Rm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new y.$xq(Re.get(a.$qp));this.a.registerChannel("extensionTipsService",et);const Xe=R.ProxyChannel.fromService(Re.get(f.$1hc),this.q);this.a.registerChannel("checksum",Xe);const ot=R.ProxyChannel.fromService(Re.get(We.$XG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=R.ProxyChannel.fromService(Re.get(pe.$unb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=R.ProxyChannel.fromService(Re.get(Q.$$l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ce.$4hc(Re.get(Z.$tMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ce.$6hc(Re.get(Y.$Hnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$8hc(Re.get(Y.$Tnb),Re.get(fe.$Kl),Re.get(ie.$$j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(M.$Ci).createInstance(Ut.$qic));this.a.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(Y.$Unb),this.q));const rt=R.ProxyChannel.fromService(Re.get(Ne.$$hc),this.q);this.a.registerChannel(Ne.$_hc,rt);const wt=R.ProxyChannel.fromService(Re.get(Je.$dic),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",Fe=>(0,T.$Y)(Fe)),process.on("unhandledRejection",Fe=>(0,T.$Y)(Fe)),(0,T.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,c.$oj)(Fe,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,Fe){Re.publicLog2("profilesInfo",{count:Fe.profiles.length})}async r(Re,Fe){if(Ve.$l){const[Ke,Ge]=await Promise.all([(0,zt.$1g)(Fe.error.bind(Fe)),(0,Et.$LX)(Fe.error.bind(Fe))]),et=(0,Wt.$pX)(),Xe=(0,Et.$MX)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$Kgc.response)return!1;const Fe=(0,k.$Nb)(Re.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$Igc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$Igc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/89690b9d76a88fab676d26651134a1ffa4562732/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
