/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ne=function(be){for(var e=[],v=0,I=be.length;v<I;v++)e[v]=Oe[be[v]];return e};define(Oe[71],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=I,e.$9h=P,e.$0h=O;function v(A){return(T,$,s)=>{let R=null,y=null;if(typeof s.value=="function"?(R="value",y=s.value):typeof s.get=="function"&&(R="get",y=s.get),!y)throw new Error("not supported");s[R]=A(y,$)}}function I(A,T,$){let s=null,R=null;if(typeof $.value=="function"?(s="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(s="get",R=$.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;$[s]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[y]}}function P(A,T,$){return v((s,R)=>{const y=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...S){this[a]||(this[a]=$?$():void 0),clearTimeout(this[y]),T&&(this[a]=T(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{s.apply(this,S),this[a]=$?$():void 0},A)}})}function O(A,T,$){return v((s,R)=>{const y=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...n){if(this[a]||(this[a]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[a]=T(this[a],...n)),this[d])return;const o=this[S]+A;o<=Date.now()?(this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0},o-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function(be,e,v,I){I===void 0&&(I=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(be,I,P)}:function(be,e,v,I){I===void 0&&(I=v),be[I]=e[v]}),Qn=this&&this.__setModuleDefault||(Object.create?function(be,e){Object.defineProperty(be,"default",{enumerable:!0,value:e})}:function(be,e){be.default=e}),We=this&&this.__importStar||function(be){if(be&&be.__esModule)return be;var e={};if(be!=null)for(var v in be)v!=="default"&&Object.prototype.hasOwnProperty.call(be,v)&&Hn(e,be,v);return Qn(e,be),e};define(Oe[135],Ne([1,0,17]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=P,e.$7c=O,e.$8c=A,e.$9c=T,e.$0c=$,e.$$c=s,v=We(v);const I=(S,d)=>S===d;e.$5c=I;function P(S=e.$5c){return(d,n)=>v.$tb(d,n,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function A(){return(S,d)=>S.equals(d)}function T(S,d,n){if(n!==void 0){const o=S;return o==null||d===void 0||d===null?d===o:n(o,d)}else{const o=S;return(c,u)=>c==null||u===void 0||u===null?u===c:o(c,u)}}function $(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let n=0;n<S.length;n++)if(!$(S[n],d[n]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=S,o=d,c=Object.keys(n),u=Object.keys(o),i=new Set(u);if(c.length!==u.length)return!1;for(const r of c)if(!i.has(r)||!$(n[r],o[r]))return!1;return!0}return!1}function s(S){return JSON.stringify(a(S))}let R=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,n=Object.create(null);for(const o of Object.keys(d).sort())n[o]=a(d[o]);return n}else{let d=y.get(S);return d===void 0&&(d=R++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Oe[96],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$jQ=v,e.$kQ=new v("id#")}),define(Oe[136],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Un=A,e.$Vn=y,e.$Wn=a,e.$Xn=S,e.$Yn=d,e.$Zn=n,e.$1n=o,e.$2n=c,e.$3n=u,e.$4n=i,e.$5n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,g=!1){let l=0;const m=t.length;let p="",h=0,E=I.Unknown,D=v.None;function b(L){let W=0,J=0;for(;W<L;){const M=t.charCodeAt(l);if(M>=R._0&&M<=R._9)J=J*16+M-R._0;else if(M>=R.A&&M<=R.F)J=J*16+M-R.A+10;else if(M>=R.a&&M<=R.f)J=J*16+M-R.a+10;else break;l++,W++}return W<L&&(J=-1),J}function k(L){l=L,p="",h=0,E=I.Unknown,D=v.None}function C(){const L=l;if(t.charCodeAt(l)===R._0)l++;else for(l++;l<t.length&&s(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===R.dot)if(l++,l<t.length&&s(t.charCodeAt(l)))for(l++;l<t.length&&s(t.charCodeAt(l));)l++;else return D=v.UnexpectedEndOfNumber,t.substring(L,l);let W=l;if(l<t.length&&(t.charCodeAt(l)===R.E||t.charCodeAt(l)===R.e))if(l++,(l<t.length&&t.charCodeAt(l)===R.plus||t.charCodeAt(l)===R.minus)&&l++,l<t.length&&s(t.charCodeAt(l))){for(l++;l<t.length&&s(t.charCodeAt(l));)l++;W=l}else D=v.UnexpectedEndOfNumber;return t.substring(L,W)}function f(){let L="",W=l;for(;;){if(l>=m){L+=t.substring(W,l),D=v.UnexpectedEndOfString;break}const J=t.charCodeAt(l);if(J===R.doubleQuote){L+=t.substring(W,l),l++;break}if(J===R.backslash){if(L+=t.substring(W,l),l++,l>=m){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case R.doubleQuote:L+='"';break;case R.backslash:L+="\\";break;case R.slash:L+="/";break;case R.b:L+="\b";break;case R.f:L+="\f";break;case R.n:L+=`
`;break;case R.r:L+="\r";break;case R.t:L+="	";break;case R.u:{const K=b(4);K>=0?L+=String.fromCharCode(K):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}W=l;continue}if(J>=0&&J<=31)if($(J)){L+=t.substring(W,l),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;l++}return L}function w(){if(p="",D=v.None,h=l,l>=m)return h=m,E=I.EOF;let L=t.charCodeAt(l);if(T(L)){do l++,p+=String.fromCharCode(L),L=t.charCodeAt(l);while(T(L));return E=I.Trivia}if($(L))return l++,p+=String.fromCharCode(L),L===R.carriageReturn&&t.charCodeAt(l)===R.lineFeed&&(l++,p+=`
`),E=I.LineBreakTrivia;switch(L){case R.openBrace:return l++,E=I.OpenBraceToken;case R.closeBrace:return l++,E=I.CloseBraceToken;case R.openBracket:return l++,E=I.OpenBracketToken;case R.closeBracket:return l++,E=I.CloseBracketToken;case R.colon:return l++,E=I.ColonToken;case R.comma:return l++,E=I.CommaToken;case R.doubleQuote:return l++,p=f(),E=I.StringLiteral;case R.slash:{const W=l-1;if(t.charCodeAt(l+1)===R.slash){for(l+=2;l<m&&!$(t.charCodeAt(l));)l++;return p=t.substring(W,l),E=I.LineCommentTrivia}if(t.charCodeAt(l+1)===R.asterisk){l+=2;const J=m-1;let M=!1;for(;l<J;){if(t.charCodeAt(l)===R.asterisk&&t.charCodeAt(l+1)===R.slash){l+=2,M=!0;break}l++}return M||(l++,D=v.UnexpectedEndOfComment),p=t.substring(W,l),E=I.BlockCommentTrivia}return p+=String.fromCharCode(L),l++,E=I.Unknown}case R.minus:if(p+=String.fromCharCode(L),l++,l===m||!s(t.charCodeAt(l)))return E=I.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return p+=C(),E=I.NumericLiteral;default:for(;l<m&&F(L);)l++,L=t.charCodeAt(l);if(h!==l){switch(p=t.substring(h,l),p){case"true":return E=I.TrueKeyword;case"false":return E=I.FalseKeyword;case"null":return E=I.NullKeyword}return E=I.Unknown}return p+=String.fromCharCode(L),l++,E=I.Unknown}}function F(L){if(T(L)||$(L))return!1;switch(L){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function N(){let L;do L=w();while(L>=I.LineCommentTrivia&&L<=I.Trivia);return L}return{setPosition:k,getPosition:()=>l,scan:g?N:w,getToken:()=>E,getTokenValue:()=>p,getTokenOffset:()=>h,getTokenLength:()=>l-h,getTokenError:()=>D}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function $(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function s(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,g){const l=[],m=new Object;let p;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(b,k,C,f){h.value=b,h.offset=k,h.length=C,h.type=f,h.colonOffset=void 0,p=h}try{i(t,{onObjectBegin:(b,k)=>{if(g<=b)throw m;p=void 0,E=g>b,l.push("")},onObjectProperty:(b,k,C)=>{if(g<k||(D(b,k,C,"property"),l[l.length-1]=b,g<=k+C))throw m},onObjectEnd:(b,k)=>{if(g<=b)throw m;p=void 0,l.pop()},onArrayBegin:(b,k)=>{if(g<=b)throw m;p=void 0,l.push(0)},onArrayEnd:(b,k)=>{if(g<=b)throw m;p=void 0,l.pop()},onLiteralValue:(b,k,C)=>{if(g<k||(D(b,k,C,r(b)),g<=k+C))throw m},onSeparator:(b,k,C)=>{if(g<=k)throw m;if(b===":"&&p&&p.type==="property")p.colonOffset=k,E=!1,p=void 0;else if(b===","){const f=l[l.length-1];typeof f=="number"?l[l.length-1]=f+1:(E=!0,l[l.length-1]=""),p=void 0}}})}catch(b){if(b!==m)throw b}return{path:l,previousNode:p,isAtPropertyKey:E,matches:b=>{let k=0;for(let C=0;k<b.length&&C<l.length;C++)if(b[k]===l[C]||b[k]==="*")k++;else if(b[k]!=="**")return!1;return k===b.length}}}function a(t,g=[],l=O.DEFAULT){let m=null,p=[];const h=[];function E(b){Array.isArray(p)?p.push(b):m!==null&&(p[m]=b)}return i(t,{onObjectBegin:()=>{const b={};E(b),h.push(p),p=b,m=null},onObjectProperty:b=>{m=b},onObjectEnd:()=>{p=h.pop()},onArrayBegin:()=>{const b=[];E(b),h.push(p),p=b,m=null},onArrayEnd:()=>{p=h.pop()},onLiteralValue:E,onError:(b,k,C)=>{g.push({error:b,offset:k,length:C})}},l),p[0]}function S(t,g=[],l=O.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(b){m.type==="property"&&(m.length=b-m.offset,m=m.parent)}function h(b){return m.children.push(b),b}i(t,{onObjectBegin:b=>{m=h({type:"object",offset:b,length:-1,parent:m,children:[]})},onObjectProperty:(b,k,C)=>{m=h({type:"property",offset:k,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:b,offset:k,length:C,parent:m})},onObjectEnd:(b,k)=>{m.length=b+k-m.offset,m=m.parent,p(b+k)},onArrayBegin:(b,k)=>{m=h({type:"array",offset:b,length:-1,parent:m,children:[]})},onArrayEnd:(b,k)=>{m.length=b+k-m.offset,m=m.parent,p(b+k)},onLiteralValue:(b,k,C)=>{h({type:r(b),offset:k,length:C,parent:m,value:b}),p(k+C)},onSeparator:(b,k,C)=>{m.type==="property"&&(b===":"?m.colonOffset=k:b===","&&p(k))},onError:(b,k,C)=>{g.push({error:b,offset:k,length:C})}},l);const D=m.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let l=t;for(const m of g)if(typeof m=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let p=!1;for(const h of l.children)if(Array.isArray(h.children)&&h.children[0].value===m){l=h.children[1],p=!0;break}if(!p)return}else{const p=m;if(l.type!=="array"||p<0||!Array.isArray(l.children)||p>=l.children.length)return;l=l.children[p]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const g=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;g.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&g.push(l)}return g}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const g=Object.create(null);for(const l of t.children){const m=l.children[1];m&&(g[l.children[0].value]=o(m))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,l=!1){return g>=t.offset&&g<t.offset+t.length||l&&g===t.offset+t.length}function u(t,g,l=!1){if(c(t,g,l)){const m=t.children;if(Array.isArray(m))for(let p=0;p<m.length&&m[p].offset<=g;p++){const h=u(m[p],g,l);if(h)return h}return t}}function i(t,g,l=O.DEFAULT){const m=A(t,!1);function p(ae){return ae?()=>ae(m.getTokenOffset(),m.getTokenLength()):()=>!0}function h(ae){return ae?$e=>ae($e,m.getTokenOffset(),m.getTokenLength()):()=>!0}const E=p(g.onObjectBegin),D=h(g.onObjectProperty),b=p(g.onObjectEnd),k=p(g.onArrayBegin),C=p(g.onArrayEnd),f=h(g.onLiteralValue),w=h(g.onSeparator),F=p(g.onComment),N=h(g.onError),L=l&&l.disallowComments,W=l&&l.allowTrailingComma;function J(){for(;;){const ae=m.scan();switch(m.getTokenError()){case v.InvalidUnicode:M(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:M(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:M(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||M(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:M(P.UnexpectedEndOfString);break;case v.InvalidCharacter:M(P.InvalidCharacter);break}switch(ae){case I.LineCommentTrivia:case I.BlockCommentTrivia:L?M(P.InvalidCommentToken):F();break;case I.Unknown:M(P.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return ae}}}function M(ae,$e=[],oe=[]){if(N(ae),$e.length+oe.length>0){let ke=m.getToken();for(;ke!==I.EOF;){if($e.indexOf(ke)!==-1){J();break}else if(oe.indexOf(ke)!==-1)break;ke=J()}}}function K(ae){const $e=m.getTokenValue();return ae?f($e):D($e),J(),!0}function Z(){switch(m.getToken()){case I.NumericLiteral:{let ae=0;try{ae=JSON.parse(m.getTokenValue()),typeof ae!="number"&&(M(P.InvalidNumberFormat),ae=0)}catch{M(P.InvalidNumberFormat)}f(ae);break}case I.NullKeyword:f(null);break;case I.TrueKeyword:f(!0);break;case I.FalseKeyword:f(!1);break;default:return!1}return J(),!0}function ue(){return m.getToken()!==I.StringLiteral?(M(P.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(K(!1),m.getToken()===I.ColonToken?(w(":"),J(),se()||M(P.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):M(P.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function _(){E(),J();let ae=!1;for(;m.getToken()!==I.CloseBraceToken&&m.getToken()!==I.EOF;){if(m.getToken()===I.CommaToken){if(ae||M(P.ValueExpected,[],[]),w(","),J(),m.getToken()===I.CloseBraceToken&&W)break}else ae&&M(P.CommaExpected,[],[]);ue()||M(P.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),ae=!0}return b(),m.getToken()!==I.CloseBraceToken?M(P.CloseBraceExpected,[I.CloseBraceToken],[]):J(),!0}function ge(){k(),J();let ae=!1;for(;m.getToken()!==I.CloseBracketToken&&m.getToken()!==I.EOF;){if(m.getToken()===I.CommaToken){if(ae||M(P.ValueExpected,[],[]),w(","),J(),m.getToken()===I.CloseBracketToken&&W)break}else ae&&M(P.CommaExpected,[],[]);se()||M(P.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),ae=!0}return C(),m.getToken()!==I.CloseBracketToken?M(P.CloseBracketExpected,[I.CloseBracketToken],[]):J(),!0}function se(){switch(m.getToken()){case I.OpenBracketToken:return ge();case I.OpenBraceToken:return _();case I.StringLiteral:return K(!0);default:return Z()}}return J(),m.getToken()===I.EOF?l.allowEmptyContent?!0:(M(P.ValueExpected,[],[]),!1):se()?(m.getToken()!==I.EOF&&M(P.EndOfFileExpected,[],[]),!0):(M(P.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Oe[137],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=v;function v(O){let A=!1;const T=new Map,$=new Map;if(P(O,n=>{if(O===n)return!0;const o=JSON.stringify(n);if(o.length<30)return!0;const c=T.get(o);if(!c){const u={schemas:[n]};return T.set(o,u),$.set(n,u),!0}return c.schemas.push(n),$.set(n,c),A=!0,!1}),T.clear(),!A)return JSON.stringify(O);let R="$defs";for(;O.hasOwnProperty(R);)R+="_";const y=[];function a(n){return JSON.stringify(n,(o,c)=>{if(c!==n){const u=$.get(c);if(u&&u.schemas.length>1)return u.id||(u.id=`_${y.length}`,y.push(u.schemas[0])),{$ref:`#/${R}/${u.id}`}}return c})}const S=a(O),d=[];for(let n=0;n<y.length;n++)d.push(`"_${n}":${a(y[n])}`);return d.length?`${S.substring(0,S.length-1)},"${R}":{${d.join(",")}}}`:S}function I(O){return typeof O=="object"&&O!==null}function P(O,A){if(!O||typeof O!="object")return;const T=(...S)=>{for(const d of S)I(d)&&y.push(d)},$=(...S)=>{for(const d of S)if(I(d))for(const n in d){const o=d[n];I(o)&&y.push(o)}},s=(...S)=>{for(const d of S)if(Array.isArray(d))for(const n of d)I(n)&&y.push(n)},R=S=>{if(Array.isArray(S))for(const d of S)I(d)&&y.push(d);else I(S)&&y.push(S)},y=[O];let a=y.pop();for(;a;)A(a)&&(T(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),$(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),s(a.anyOf,a.allOf,a.oneOf,a.prefixItems),R(a.items)),a=y.pop()}}),function(be,e){typeof define=="function"&&define.amd?define(Oe[138],Ne([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ce,we){for(var he=0;he<we.length;he++){var X=we[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ce,X.key,X)}}function v(ce,we,he){return we&&e(ce.prototype,we),he&&e(ce,he),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function I(ce,we){if(ce){if(typeof ce=="string")return P(ce,we);var he=Object.prototype.toString.call(ce).slice(8,-1);if(he==="Object"&&ce.constructor&&(he=ce.constructor.name),he==="Map"||he==="Set")return Array.from(ce);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return P(ce,we)}}function P(ce,we){(we==null||we>ce.length)&&(we=ce.length);for(var he=0,X=new Array(we);he<we;he++)X[he]=ce[he];return X}function O(ce,we){var he=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(he)return(he=he.call(ce)).next.bind(he);if(Array.isArray(ce)||(he=I(ce))||we&&ce&&typeof ce.length=="number"){he&&(ce=he);var X=0;return function(){return X>=ce.length?{done:!0}:{done:!1,value:ce[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function T(ce){be.defaults=ce}var $=/[&<>"']/,s=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(we){return a[we]};function d(ce,we){if(we){if($.test(ce))return ce.replace(s,S)}else if(R.test(ce))return ce.replace(y,S);return ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ce){return ce.replace(n,function(we,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var c=/(^|[^\[])\^/g;function u(ce,we){ce=typeof ce=="string"?ce:ce.source,we=we||"";var he={replace:function(x,me){return me=me.source||me,me=me.replace(c,"$1"),ce=ce.replace(x,me),he},getRegex:function(){return new RegExp(ce,we)}};return he}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ce,we,he){if(ce){var X;try{X=decodeURIComponent(o(he)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}we&&!r.test(he)&&(he=h(we,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var g={},l=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ce,we){g[" "+ce]||(l.test(ce)?g[" "+ce]=ce+"/":g[" "+ce]=k(ce,"/",!0)),ce=g[" "+ce];var he=ce.indexOf(":")===-1;return we.substring(0,2)==="//"?he?we:ce.replace(m,"$1")+we:we.charAt(0)==="/"?he?we:ce.replace(p,"$1")+we:ce+we}var E={exec:function(){}};function D(ce){for(var we=1,he,X;we<arguments.length;we++){he=arguments[we];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(ce[X]=he[X])}return ce}function b(ce,we){var he=ce.replace(/\|/g,function(me,pe,Ae){for(var Ue=!1,Se=pe;--Se>=0&&Ae[Se]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=he.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>we)X.splice(we);else for(;X.length<we;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function k(ce,we,he){var X=ce.length;if(X===0)return"";for(var x=0;x<X;){var me=ce.charAt(X-x-1);if(me===we&&!he)x++;else if(me!==we&&he)x++;else break}return ce.slice(0,X-x)}function C(ce,we){if(ce.indexOf(we[1])===-1)return-1;for(var he=ce.length,X=0,x=0;x<he;x++)if(ce[x]==="\\")x++;else if(ce[x]===we[0])X++;else if(ce[x]===we[1]&&(X--,X<0))return x;return-1}function f(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ce,we){if(we<1)return"";for(var he="";we>1;)we&1&&(he+=ce),we>>=1,ce+=ce;return he+ce}function F(ce,we,he,X){var x=we.href,me=we.title?d(we.title):null,pe=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){X.state.inLink=!0;var Ae={type:"link",raw:he,href:x,title:me,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Ae}return{type:"image",raw:he,href:x,title:me,text:d(pe)}}function N(ce,we){var he=ce.match(/^(\s+)(?:```)/);if(he===null)return we;var X=he[1];return we.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var pe=me[0];return pe.length>=X.length?x.slice(X.length):x}).join(`
`)}var L=function(){function ce(he){this.options=he||be.defaults}var we=ce.prototype;return we.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(X){var x=this.rules.block.code.exec(X);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:k(me,`
`)}}},we.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var me=x[0],pe=N(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:pe}}},we.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var me=x[2].trim();if(/#$/.test(me)){var pe=k(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},we.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},we.list=function(X){var x=this.rules.block.list.exec(X);if(x){var me,pe,Ae,Ue,Se,Pe,Te,j,B,H,V,ne,fe=x[1].trim(),Ie=fe.length>1,ze={type:"list",raw:"",ordered:Ie,start:Ie?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ie?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ie?fe:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ne=!1,!(!(x=Qe.exec(X))||this.rules.block.hr.test(X)));){if(me=x[0],X=X.substring(me.length),j=x[2].split(`
`,1)[0],B=X.split(`
`,1)[0],this.options.pedantic?(Ue=2,V=j.trimLeft()):(Ue=x[2].search(/[^ ]/),Ue=Ue>4?1:Ue,V=j.slice(Ue),Ue+=x[1].length),Pe=!1,!j&&/^ *$/.test(B)&&(me+=B+`
`,X=X.substring(B.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");X&&(H=X.split(`
`,1)[0],j=H,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(j)||et.test(j)||_e.test(j)||tt.test(X)));){if(j.search(/[^ ]/)>=Ue||!j.trim())V+=`
`+j.slice(Ue);else if(!Pe)V+=`
`+j;else break;!Pe&&!j.trim()&&(Pe=!0),me+=H+`
`,X=X.substring(H.length+1)}ze.loose||(Te?ze.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(V),pe&&(Ae=pe[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:V}),ze.raw+=me}ze.items[ze.items.length-1].raw=me.trimRight(),ze.items[ze.items.length-1].text=V.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(Se=0;Se<rt;Se++){this.lexer.state.top=!1,ze.items[Se].tokens=this.lexer.blockTokens(ze.items[Se].text,[]);var mt=ze.items[Se].tokens.filter(function(st){return st.type==="space"}),ut=mt.every(function(st){for(var ct=st.raw.split(""),ft=0,pt=O(ct),qe;!(qe=pt()).done;){var je=qe.value;if(je===`
`&&(ft+=1),ft>1)return!0}return!1});!ze.loose&&mt.length&&ut&&(ze.loose=!0,ze.items[Se].loose=!0)}return ze}},we.html=function(X){var x=this.rules.block.html.exec(X);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},we.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},we.table=function(X){var x=this.rules.block.table.exec(X);if(x){var me={type:"table",header:b(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var pe=me.align.length,Ae,Ue,Se,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=b(me.rows[Ae],me.header.length).map(function(Te){return{text:Te}});for(pe=me.header.length,Ue=0;Ue<pe;Ue++)me.header[Ue].tokens=this.lexer.inline(me.header[Ue].text);for(pe=me.rows.length,Ue=0;Ue<pe;Ue++)for(Pe=me.rows[Ue],Se=0;Se<Pe.length;Se++)Pe[Se].tokens=this.lexer.inline(Pe[Se].text);return me}}},we.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},we.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},we.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},we.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=k(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=C(x[2],"()");if(Ae>-1){var Ue=x[0].indexOf("!")===0?5:4,Se=Ue+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Se).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);j&&(Pe=j[1],Te=j[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(me)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),F(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(X,x){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return F(me,pe,me[0],this.lexer)}},we.emStrong=function(X,x,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var Ue=pe[0].length-1,Se,Pe,Te=Ue,j=0,B=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*X.length+Ue);(pe=B.exec(x))!=null;)if(Se=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Se){if(Pe=Se.length,pe[3]||pe[4]){Te+=Pe;continue}else if((pe[5]||pe[6])&&Ue%3&&!((Ue+Pe)%3)){j+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+j),Math.min(Ue,Pe)%2){var H=X.slice(1,Ue+pe.index+Pe);return{type:"em",raw:X.slice(0,Ue+pe.index+Pe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var V=X.slice(2,Ue+pe.index+Pe-1);return{type:"strong",raw:X.slice(0,Ue+pe.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},we.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var me=x[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:x[0],text:me}}},we.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},we.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(X,x){var me=this.rules.inline.autolink.exec(X);if(me){var pe,Ae;return me[2]==="@"?(pe=d(this.options.mangle?x(me[1]):me[1]),Ae="mailto:"+pe):(pe=d(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},we.url=function(X,x){var me;if(me=this.rules.inline.url.exec(X)){var pe,Ae;if(me[2]==="@")pe=d(this.options.mangle?x(me[0]):me[0]),Ae="mailto:"+pe;else{var Ue;do Ue=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Ue!==me[0]);pe=d(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},we.inlineText=function(X,x){var me=this.rules.inline.text.exec(X);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:pe=d(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ce}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=u(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=u(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=u(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=u(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=u(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=u(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=D({},W),W.gfm=D({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=u(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=u(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=D({},W.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:u(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=u(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=u(W._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=u(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=u(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=u(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=u(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=u(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=u(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=u(J.reflink).replace("label",J._label).replace("ref",W._label).getRegex(),J.nolink=u(J.nolink).replace("ref",W._label).getRegex(),J.reflinkSearch=u(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=D({},J),J.pedantic=D({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=D({},J.normal,{escape:u(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=u(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=D({},J.gfm,{br:u(J.br).replace("{2,}","*").getRegex(),text:u(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ce){var we="",he,X,x=ce.length;for(he=0;he<x;he++)X=ce.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),we+="&#"+X+";";return we}var Z=function(){function ce(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||be.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:W.normal,inline:J.normal};this.options.pedantic?(X.block=W.pedantic,X.inline=J.pedantic):this.options.gfm&&(X.block=W.gfm,this.options.breaks?X.inline=J.breaks:X.inline=J.gfm),this.tokenizer.rules=X}ce.lex=function(X,x){var me=new ce(x);return me.lex(X)},ce.lexInline=function(X,x){var me=new ce(x);return me.inlineTokens(X)};var we=ce.prototype;return we.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(X,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Te,j,B){return j+"    ".repeat(B.length)});for(var pe,Ae,Ue,Se;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:me},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,j=X.slice(1),B=void 0;me.options.extensions.startBlock.forEach(function(H){B=H.call({lexer:this},j),typeof B=="number"&&B>=0&&(Te=Math.min(Te,B))}),Te<1/0&&Te>=0&&(Ue=X.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(Ue))){Ae=x[x.length-1],Se&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),Se=Ue.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(X){var Pe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},we.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},we.inlineTokens=function(X,x){var me=this;x===void 0&&(x=[]);var pe,Ae,Ue,Se=X,Pe,Te,j;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)B.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Pe.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Te||(j=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return(pe=V.call({lexer:me},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(X,Se,j)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(X,K)){X=X.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,K))){X=X.substring(pe.raw.length),x.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,ne=X.slice(1),fe=void 0;me.options.extensions.startInline.forEach(function(Ie){fe=Ie.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(V=Math.min(V,fe))}),V<1/0&&V>=0&&(Ue=X.substring(0,V+1))}(),pe=this.tokenizer.inlineText(Ue,M)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(j=pe.raw.slice(-1)),Te=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(X){var H="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},v(ce,null,[{key:"rules",get:function(){return{block:W,inline:J}}}]),ce}(),ue=function(){function ce(he){this.options=he||be.defaults}var we=ce.prototype;return we.code=function(X,x,me){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(X,pe);Ae!=null&&Ae!==X&&(me=!0,X=Ae)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+d(pe,!0)+'">'+(me?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:d(X,!0))+`</code></pre>
`},we.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},we.html=function(X){return X},we.heading=function(X,x,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+x+' id="'+Ae+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(X,x,me){var pe=x?"ol":"ul",Ae=x&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+X+"</"+pe+`>
`},we.listitem=function(X){return"<li>"+X+`</li>
`},we.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(X){return"<p>"+X+`</p>
`},we.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},we.tablerow=function(X){return`<tr>
`+X+`</tr>
`},we.tablecell=function(X,x){var me=x.header?"th":"td",pe=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return pe+X+("</"+me+`>
`)},we.strong=function(X){return"<strong>"+X+"</strong>"},we.em=function(X){return"<em>"+X+"</em>"},we.codespan=function(X){return"<code>"+X+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(X){return"<del>"+X+"</del>"},we.link=function(X,x,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<a href="'+d(X)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+me+"</a>",pe},we.image=function(X,x,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<img src="'+X+'" alt="'+me+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},we.text=function(X){return X},ce}(),_=function(){function ce(){}var we=ce.prototype;return we.strong=function(X){return X},we.em=function(X){return X},we.codespan=function(X){return X},we.del=function(X){return X},we.html=function(X){return X},we.text=function(X){return X},we.link=function(X,x,me){return""+me},we.image=function(X,x,me){return""+me},we.br=function(){return""},ce}(),ge=function(){function ce(){this.seen={}}var we=ce.prototype;return we.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(X,x){var me=X,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[X];do pe++,me=X+"-"+pe;while(this.seen.hasOwnProperty(me))}return x||(this.seen[X]=pe,this.seen[me]=0),me},we.slug=function(X,x){x===void 0&&(x={});var me=this.serialize(X);return this.getNextSafeSlug(me,x.dryrun)},ce}(),se=function(){function ce(he){this.options=he||be.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new ge}ce.parse=function(X,x){var me=new ce(x);return me.parse(X)},ce.parseInline=function(X,x){var me=new ce(x);return me.parseInline(X)};var we=ce.prototype;return we.parse=function(X,x){x===void 0&&(x=!0);var me="",pe,Ae,Ue,Se,Pe,Te,j,B,H,V,ne,fe,Ie,ze,Qe,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(V=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){me+=et||"";continue}switch(V.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(V.tokens),V.depth,o(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(B="",j="",Se=V.header.length,Ae=0;Ae<Se;Ae++)j+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(B+=this.renderer.tablerow(j),H="",Se=V.rows.length,Ae=0;Ae<Se;Ae++){for(Te=V.rows[Ae],j="",Pe=Te.length,Ue=0;Ue<Pe;Ue++)j+=this.renderer.tablecell(this.parseInline(Te[Ue].tokens),{header:!1,align:V.align[Ue]});H+=this.renderer.tablerow(j)}me+=this.renderer.table(B,H);continue}case"blockquote":{H=this.parse(V.tokens),me+=this.renderer.blockquote(H);continue}case"list":{for(ne=V.ordered,fe=V.start,Ie=V.loose,Se=V.items.length,H="",Ae=0;Ae<Se;Ae++)Qe=V.items[Ae],_e=Qe.checked,tt=Qe.task,ze="",Qe.task&&(nt=this.renderer.checkbox(_e),Ie?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Qe.tokens,Ie),H+=this.renderer.listitem(ze,tt,_e);me+=this.renderer.list(H,ne,fe);continue}case"html":{me+=this.renderer.html(V.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(H=V.tokens?this.parseInline(V.tokens):V.text;pe+1<rt&&X[pe+1].type==="text";)V=X[++pe],H+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);me+=x?this.renderer.paragraph(H):H;continue}default:{var mt='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},we.parseInline=function(X,x){x=x||this.renderer;var me="",pe,Ae,Ue,Se=X.length;for(pe=0;pe<Se;pe++){if(Ae=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ue=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=Ue||"";continue}switch(Ae.type){case"escape":{me+=x.text(Ae.text);break}case"html":{me+=x.html(Ae.text);break}case"link":{me+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{me+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{me+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{me+=x.codespan(Ae.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{me+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return me},ce}();function ae(ce,we,he){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof we=="function"&&(he=we,we=null),we=D({},ae.defaults,we||{}),f(we),he){var X=we.highlight,x;try{x=Z.lex(ce,we)}catch(Se){return he(Se)}var me=function(Pe){var Te;if(!Pe)try{we.walkTokens&&ae.walkTokens(x,we.walkTokens),Te=se.parse(x,we)}catch(j){Pe=j}return we.highlight=X,Pe?he(Pe):he(null,Te)};if(!X||X.length<3||(delete we.highlight,!x.length))return me();var pe=0;ae.walkTokens(x,function(Se){Se.type==="code"&&(pe++,setTimeout(function(){X(Se.text,Se.lang,function(Pe,Te){if(Pe)return me(Pe);Te!=null&&Te!==Se.text&&(Se.text=Te,Se.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Se.message+"",!0)+"</pre>";throw Se}try{var Ue=Z.lex(ce,we);if(we.walkTokens){if(we.async)return Promise.all(ae.walkTokens(Ue,we.walkTokens)).then(function(){return se.parse(Ue,we)}).catch(Ae);ae.walkTokens(Ue,we.walkTokens)}return se.parse(Ue,we)}catch(Se){Ae(Se)}}ae.options=ae.setOptions=function(ce){return D(ae.defaults,ce),T(ae.defaults),ae},ae.getDefaults=A,ae.defaults=be.defaults,ae.use=function(){for(var ce=arguments.length,we=new Array(ce),he=0;he<ce;he++)we[he]=arguments[he];var X=D.apply(void 0,[{}].concat(we)),x=ae.defaults.extensions||{renderers:{},childTokens:{}},me;we.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var Se=x.renderers?x.renderers[Ue.name]:null;Se?x.renderers[Ue.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),j=0;j<Pe;j++)Te[j]=arguments[j];var B=Ue.renderer.apply(this,Te);return B===!1&&(B=Se.apply(this,Te)),B}:x.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Ue.level]?x[Ue.level].unshift(Ue.tokenizer):x[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?x.startBlock?x.startBlock.push(Ue.start):x.startBlock=[Ue.start]:Ue.level==="inline"&&(x.startInline?x.startInline.push(Ue.start):x.startInline=[Ue.start]))}Ue.childTokens&&(x.childTokens[Ue.name]=Ue.childTokens)})),pe.renderer&&function(){var Ue=ae.defaults.renderer||new ue,Se=function(j){var B=Ue[j];Ue[j]=function(){for(var H=arguments.length,V=new Array(H),ne=0;ne<H;ne++)V[ne]=arguments[ne];var fe=pe.renderer[j].apply(Ue,V);return fe===!1&&(fe=B.apply(Ue,V)),fe}};for(var Pe in pe.renderer)Se(Pe);X.renderer=Ue}(),pe.tokenizer&&function(){var Ue=ae.defaults.tokenizer||new L,Se=function(j){var B=Ue[j];Ue[j]=function(){for(var H=arguments.length,V=new Array(H),ne=0;ne<H;ne++)V[ne]=arguments[ne];var fe=pe.tokenizer[j].apply(Ue,V);return fe===!1&&(fe=B.apply(Ue,V)),fe}};for(var Pe in pe.tokenizer)Se(Pe);X.tokenizer=Ue}(),pe.walkTokens){var Ae=ae.defaults.walkTokens;X.walkTokens=function(Ue){var Se=[];return Se.push(pe.walkTokens.call(this,Ue)),Ae&&(Se=Se.concat(Ae.call(this,Ue))),Se}}me&&(X.extensions=x),ae.setOptions(X)})},ae.walkTokens=function(ce,we){for(var he=[],X=function(){var Ae=me.value;switch(he=he.concat(we.call(ae,Ae)),Ae.type){case"table":{for(var Ue=O(Ae.header),Se;!(Se=Ue()).done;){var Pe=Se.value;he=he.concat(ae.walkTokens(Pe.tokens,we))}for(var Te=O(Ae.rows),j;!(j=Te()).done;)for(var B=j.value,H=O(B),V;!(V=H()).done;){var ne=V.value;he=he.concat(ae.walkTokens(ne.tokens,we))}break}case"list":{he=he.concat(ae.walkTokens(Ae.items,we));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Ae.type]?ae.defaults.extensions.childTokens[Ae.type].forEach(function(fe){he=he.concat(ae.walkTokens(Ae[fe],we))}):Ae.tokens&&(he=he.concat(ae.walkTokens(Ae.tokens,we)))}},x=O(ce),me;!(me=x()).done;)X();return he},ae.parseInline=function(ce,we){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");we=D({},ae.defaults,we||{}),f(we);try{var he=Z.lexInline(ce,we);return we.walkTokens&&ae.walkTokens(he,we.walkTokens),se.parseInline(he,we)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ae.Parser=se,ae.parser=se.parse,ae.Renderer=ue,ae.TextRenderer=_,ae.Lexer=Z,ae.lexer=Z.lex,ae.Tokenizer=L,ae.Slugger=ge,ae.parse=ae;var $e=ae.options,oe=ae.setOptions,ke=ae.use,Le=ae.walkTokens,Y=ae.parseInline,q=ae,te=se.parse,ve=Z.lex;be.Lexer=Z,be.Parser=se,be.Renderer=ue,be.Slugger=ge,be.TextRenderer=_,be.Tokenizer=L,be.getDefaults=A,be.lexer=ve,be.marked=ae,be.options=$e,be.parse=q,be.parseInline=Y,be.parser=te,be.setOptions=oe,be.use=ke,be.walkTokens=Le,Object.defineProperty(be,"__esModule",{value:!0})}),define(Oe[139],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=v;function v(n){const o=O(n);if(o&&o.length>0)return new Uint32Array(o)}let I=0;const P=new Uint32Array(10);function O(n){if(I=0,A(n,y,$.InitialConsonant),I>0||(A(n,a,$.Vowel),I>0)||(A(n,S,$.FinalConsonant),I>0)||(A(n,d,$.CompatibilityJamo),I))return P.subarray(0,I);if(n>=44032&&n<=55203){const o=n-44032,c=o%588,u=Math.floor(o/588),i=Math.floor(c/28),r=c%28-1;if(u<y.length?A(u,y,0):$.InitialConsonant+u-$.CompatibilityJamo<d.length&&A($.InitialConsonant+u,d,$.CompatibilityJamo),i<a.length?A(i,a,0):$.Vowel+i-$.CompatibilityJamo<d.length&&A($.Vowel+i-$.CompatibilityJamo,d,$.CompatibilityJamo),r>=0&&(r<S.length?A(r,S,0):$.FinalConsonant+r-$.CompatibilityJamo<d.length&&A($.FinalConsonant+r-$.CompatibilityJamo,d,$.CompatibilityJamo)),I>0)return P.subarray(0,I)}}function A(n,o,c){n>=c&&n<c+o.length&&T(o[n-c])}function T(n){n!==s.NUL&&(P[I++]=n&255,n>>8&&(P[I++]=n>>8&255),n>>16&&(P[I++]=n>>16&255))}var $;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var s;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(s||(s={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,R.hk,R.ho,R.hl,s.y,s.n,R.nj,R.np,R.nl,s.b,s.m,R.ml,s.l]),S=new Uint16Array([s.r,s.R,R.rt,s.s,R.sw,R.sg,s.e,s.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,s.a,s.q,R.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),d=new Uint16Array([s.r,s.R,R.rt,s.s,R.sw,R.sg,s.e,s.E,s.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,s.a,s.q,s.Q,R.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,R.hk,R.ho,R.hl,s.y,s.n,R.nj,R.np,R.nl,s.b,s.m,R.ml,s.l])}),define(Oe[140],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=v,e.rot=I,e.$Om=T;function v($,s,R){return Math.min(Math.max($,s),R)}function I($,s){return(s+$%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=P;class O{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=O;class A{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const R=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=A;function T($,s,R,y,a,S,d,n){const o=d-R,c=n-y,u=a-R,i=S-y,r=$-R,t=s-y,g=o*o+c*c,l=o*u+c*i,m=o*r+c*t,p=u*u+i*i,h=u*r+i*t,E=1/(g*p-l*l),D=(p*m-l*h)*E,b=(g*h-l*m)*E;return D>=0&&b>=0&&D+b<1}}),define(Oe[141],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=O,e.$bd=a;class v{constructor(d,n,o){this.owner=d,this.debugNameSource=n,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$_c=v;const I=new Map,P=new WeakMap;function O(S,d){const n=P.get(S);if(n)return n;const o=A(S,d);if(o){let c=I.get(o)??0;c++,I.set(o,c);const u=c===1?o:`${o}#${c}`;return P.set(S,u),u}}function A(S,d){const n=P.get(S);if(n)return n;const o=d.owner?R(d.owner)+".":"";let c;const u=d.debugNameSource;if(u!==void 0)if(typeof u=="function"){if(c=u(),c!==void 0)return o+c}else return o+u;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return o+c;if(d.owner!==void 0){const r=T(d.owner,S);if(r!==void 0)return o+r}}function T(S,d){for(const n in S)if(S[n]===d)return n}const $=new Map,s=new WeakMap;function R(S){const d=s.get(S);if(d)return d;const n=y(S);let o=$.get(n)??0;o++,$.set(n,o);const c=o===1?n:`${n}#${o}`;return s.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Oe[142],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Jd=I,e.$Kd=P;let v;function I(n){v=n}function P(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([T(S("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),s(R(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(R(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(R(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,c){console.log(...this.b([$("observable value changed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(o){if(o.size!==0)return s(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(u,i)=>(this.d.get(o).add(u),c.apply(o,[u,i]))}handleDerivedRecomputed(o,c){const u=this.d.get(o);console.log(...this.b([$("derived recomputed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(u),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),u.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.b([$("observable from event triggered"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(u,i)=>(this.d.get(o).add(u),c.apply(o,[u,i]))}handleAutorunTriggered(o){const c=this.d.get(o);console.log(...this.b([$("autorun"),s(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),s(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Ld=O;function A(n){const o=new Array,c=[];let u="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(u+=`%c${t.text}`,o.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(n);const r=[u,...o];return r.push(...c),r}function T(n){return s(n,{color:"black"})}function $(n){return s(d(`${n}: `,10),{color:"black",bold:!0})}function s(n,o={color:"black"}){function c(i){return Object.entries(i).reduce((r,[t,g])=>`${r}${t}:${g};`,"")}const u={color:o.color};return o.strikeThrough&&(u["text-decoration"]="line-through"),o.bold&&(u["font-weight"]="bold"),{text:n,style:c(u)}}function R(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,o):a(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,o){let c="[ ",u=!0;for(const i of n){if(u||(c+=", "),c.length-5>o){c+="...";break}u=!1,c+=`${R(i,o-c.length)}`}return c+=" ]",c}function a(n,o){let c="{ ",u=!0;for(const[i,r]of Object.entries(n)){if(u||(c+=", "),c.length-5>o){c+="...";break}u=!1,c+=`${i}: ${R(r,o-c.length)}`}return c+=" }",c}function S(n,o){let c="";for(let u=1;u<=o;u++)c+=n;return c}function d(n,o){for(;n.length<o;)n+=" ";return n}}),define(Oe[143],Ne([1,0,135,141,142]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=e.$6d=e.$4d=e.$Yd=e.$Xd=void 0,e.$Ud=A,e.$Vd=$,e.$Wd=R,e.$Zd=S,e.$1d=n,e.$2d=o,e.$3d=c,e.$5d=i,e.$7d=t;let O;function A(l){O=l}let T;function $(l){T=l}let s;function R(l){s=l}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,p){const h=p===void 0?void 0:m,E=p===void 0?m:p;return s({owner:h,debugName:()=>{const D=(0,I.$bd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,p){return m.add(O(this,p)),this}keepObserved(m){return m.add(T(this)),this}get a(){return this.get()}}e.$Xd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const p=this.b.size;this.b.add(m),p===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Yd=a;function S(l,m){const p=new u(l,m);try{l(p)}finally{p.finish()}}let d;function n(l){if(d)l(d);else{const m=new u(l,void 0);d=m;try{l(m)}finally{m.finish(),d=void 0}}}async function o(l,m){const p=new u(l,m);try{await l(p)}finally{p.finish()}}function c(l,m,p){l?m(l):S(m,p)}class u{constructor(m,p){this._fn=m,this.b=p,this.a=[],(0,P.$Kd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,I.$bd)(this._fn)}updateObserver(m,p){this.a.push({observer:m,observable:p}),m.beginUpdate(p)}finish(){const m=this.a;for(let p=0;p<m.length;p++){const{observer:h,observable:E}=m[p];h.endUpdate(E)}this.a=null,(0,P.$Kd)()?.handleEndTransaction()}}e.$4d=u;function i(l,m){let p;return typeof l=="string"?p=new I.$_c(void 0,l,void 0):p=new I.$_c(l,void 0,void 0),new r(p,m,v.$5c)}class r extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,p,h){super(),this.e=m,this.g=h,this.d=p}get(){return this.d}set(m,p,h){if(h===void 0&&this.g(this.d,m))return;let E;p||(p=E=new u(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(m),(0,P.$Kd)()?.handleObservableChanged(this,{oldValue:D,newValue:m,change:h,didChange:!0,hadValue:!0});for(const b of this.b)p.updateObserver(b,this),b.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$6d=r;function t(l,m){let p;return typeof l=="string"?p=new I.$_c(void 0,l,void 0):p=new I.$_c(l,void 0,void 0),new g(p,m,v.$5c)}class g extends r{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$8d=g}),function(){function be(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A($){O.push($,Date.now())}function T(){const $=[];for(let s=0;s<O.length;s+=2)$.push({name:O[s],startTime:O[s+1]});return $}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=v(I))}(),define(Oe[144],Ne([1,0,39]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=void 0;const I=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,s,R){this.d($,y=>y._value=s,R)}mutate($,s){this.d($,R=>R._value=s(R._value===I?void 0:R._value))}mutatePath($,s){this.d($,()=>{},R=>s(R))}delete($){const s=this.c($);if(!s)return;let R=s.length-1;const y=s[R].node._value;if(y!==I){for(this.b--,s[R].node._value=I;R>0;R--){const{node:a,part:S}=s[R];if(a.children?.size||a._value!==I)break;s[R-1].node.children.delete(S)}return y}}*deleteRecursive($){const s=this.c($);if(!s)return;const R=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const a=s[y-1];if(a.node.children.delete(s[y].part),a.node.children.size>0||a.node._value!==I)break}for(const y of O(R))y._value!==I&&(this.b--,yield y._value)}find($){let s=this.a;for(const R of $){const y=s.children?.get(R);if(!y)return;s=y}return s._value===I?void 0:s._value}hasKeyOrParent($){let s=this.a;for(const R of $){const y=s.children?.get(R);if(!y)return!1;if(y._value!==I)return!0;s=y}return!1}hasKeyOrChildren($){let s=this.a;for(const R of $){const y=s.children?.get(R);if(!y)return!1;s=y}return!0}hasKey($){let s=this.a;for(const R of $){const y=s.children?.get(R);if(!y)return!1;s=y}return s._value!==I}c($){const s=[{part:"",node:this.a}];let R=0;for(const y of $){const a=s[R].node.children?.get(y);if(!a)return;s.push({part:y,node:a}),R++}return s}d($,s,R){let y=this.a;for(const d of $){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const n=new A;y.children.set(d,n),y=n}else{const n=new A;y.children=new Map([[d,n]]),y=n}R?.(y)}const a=y._value===I?0:1;s(y);const S=y._value===I?0:1;this.b+=S-a}*values(){for(const{_value:$}of O(this.a))$!==I&&(yield $)}}e.$3I=P;function*O(T){const $=[T];for(;$.length>0;){const s=$.pop();if(yield s,s.children)for(const R of s.children.values())$.push(R)}}class A{constructor(){this._value=I}get value(){return this._value===I?void 0:this._value}set value($){this._value=$===void 0?I:$}}}),define(Oe[145],Ne([1,0,48,19]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=T,e.$zr=$,e.$Ar=s,e.$Br=R,e.$Cr=y,e.$Dr=a,e.$Er=S,e.$Fr=d,e.$Gr=n,e.$Hr=o,e.$Ir=h,e.$Jr=E,e.$Kr=D;const P=new v.$T(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(b,k,C=!1){const f=b||"",w=k||"",F=P.value.collator.compare(f,w);return P.value.collatorIsNumeric&&F===0&&f!==w?f<w?-1:1:F}function $(b,k){const C=O.value.collator;return b=b||"",k=k||"",r(C,b,k)}function s(b,k){const C=O.value.collator;return b=b||"",k=k||"",m(b,k)||r(C,b,k)}function R(b,k){const C=O.value.collator;return b=b||"",k=k||"",l(b,k)||r(C,b,k)}function y(b,k){return b=b||"",k=k||"",b===k?0:b<k?-1:1}function a(b,k){const[C,f]=u(b),[w,F]=u(k);let N=P.value.collator.compare(f,F);if(N===0){if(P.value.collatorIsNumeric&&f!==F)return f<F?-1:1;if(N=P.value.collator.compare(C,w),P.value.collatorIsNumeric&&N===0&&C!==w)return C<w?-1:1}return N}function S(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,F=A.value.collator;return r(F,C,f)||r(w,b,k)}function d(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,F=A.value.collator;return r(F,C,f)||m(b,k)||r(w,b,k)}function n(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,F=A.value.collator;return r(F,C,f)||l(b,k)||r(w,b,k)}function o(b,k){b=b||"",k=k||"";const C=i(b).toLowerCase(),f=i(k).toLowerCase();return C!==f?C<f?-1:1:b!==k?b<k?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function u(b,k=!1){const C=b?c.exec(b):[];let f=[C&&C[1]||"",C&&C[3]||""];return k&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const k=b?c.exec(b):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function r(b,k,C){const f=b.compare(k,C);return f!==0?f:k.length!==C.length?k.length<C.length?-1:1:0}function t(b){const k=b.charAt(0);return k.toLocaleUpperCase()!==k}function g(b){const k=b.charAt(0);return k.toLocaleLowerCase()!==k}function l(b,k){return t(b)&&g(k)?-1:g(b)&&t(k)?1:0}function m(b,k){return g(b)&&t(k)?-1:t(b)&&g(k)?1:0}function p(b,k,C=!1){return C||(b=b&&b.toLowerCase(),k=k&&k.toLowerCase()),b===k?0:b<k?-1:1}function h(b,k,C=!1){const f=b.split(I.sep),w=k.split(I.sep),F=f.length-1,N=w.length-1;let L,W;for(let J=0;;J++){if(L=F===J,W=N===J,L&&W)return T(f[J],w[J],C);if(L)return-1;if(W)return 1;const M=p(f[J],w[J],C);if(M!==0)return M}}function E(b,k,C){const f=b.toLowerCase(),w=k.toLowerCase(),F=D(b,k,C);if(F)return F;const N=f.endsWith(C),L=w.endsWith(C);if(N!==L)return N?-1:1;const W=T(f,w);return W!==0?W:f.localeCompare(w)}function D(b,k,C){const f=b.toLowerCase(),w=k.toLowerCase(),F=f.startsWith(C),N=w.startsWith(C);if(F!==N)return F?-1:1;if(F&&N){if(f.length<w.length)return-1;if(f.length>w.length)return 1}return 0}}),define(Oe[72],Ne([1,0,19]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$0s=O,e.$$s=A,e.$_s=T,e.$at=s,e.$9s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const y=(0,v.$nc)(R),a=I[y.toLowerCase()];return a!==void 0?a:A(R)}function A(R){const y=(0,v.$nc)(R);return P[y.toLowerCase()]}function T(R){for(const y in P)if(P[y]===R)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function s(R,y){const a=$.exec(R);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:R}}),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var I in v)(typeof exports=="object"?exports:be)[I]=v[I]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function v(I){if(e[I])return e[I].exports;var P=e[I]={i:I,l:!1,exports:{}};return be[I].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=be,v.c=e,v.d=function(I,P,O){v.o(I,P)||Object.defineProperty(I,P,{enumerable:!0,get:O})},v.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},v.t=function(I,P){if(1&P&&(I=v(I)),8&P||4&P&&typeof I=="object"&&I&&I.__esModule)return I;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:I}),2&P&&typeof I!="string")for(var A in I)v.d(O,A,function(T){return I[T]}.bind(null,A));return O},v.n=function(I){var P=I&&I.__esModule?function(){return I.default}:function(){return I};return v.d(P,"a",P),P},v.o=function(I,P){return Object.prototype.hasOwnProperty.call(I,P)},v.p="",v(v.s=0)}([function(be,e,v){(function(I){var P;e=be.exports=ke,P=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],s=0,R=s++;$[R]="0|[1-9]\\d*";var y=s++;$[y]="[0-9]+";var a=s++;$[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=s++;$[S]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var d=s++;$[d]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var n=s++;$[n]="(?:"+$[R]+"|"+$[a]+")";var o=s++;$[o]="(?:"+$[y]+"|"+$[a]+")";var c=s++;$[c]="(?:-("+$[n]+"(?:\\."+$[n]+")*))";var u=s++;$[u]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var i=s++;$[i]="[0-9A-Za-z-]+";var r=s++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=s++,g="v?"+$[S]+$[c]+"?"+$[r]+"?";$[t]="^"+g+"$";var l="[v=\\s]*"+$[d]+$[u]+"?"+$[r]+"?",m=s++;$[m]="^"+l+"$";var p=s++;$[p]="((?:<|>)?=?)";var h=s++;$[h]=$[y]+"|x|X|\\*";var E=s++;$[E]=$[R]+"|x|X|\\*";var D=s++;$[D]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[c]+")?"+$[r]+"?)?)?";var b=s++;$[b]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[u]+")?"+$[r]+"?)?)?";var k=s++;$[k]="^"+$[p]+"\\s*"+$[D]+"$";var C=s++;$[C]="^"+$[p]+"\\s*"+$[b]+"$";var f=s++;$[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=s++;$[w]="(?:~>?)";var F=s++;$[F]="(\\s*)"+$[w]+"\\s+",T[F]=new RegExp($[F],"g");var N=s++;$[N]="^"+$[w]+$[D]+"$";var L=s++;$[L]="^"+$[w]+$[b]+"$";var W=s++;$[W]="(?:\\^)";var J=s++;$[J]="(\\s*)"+$[W]+"\\s+",T[J]=new RegExp($[J],"g");var M=s++;$[M]="^"+$[W]+$[D]+"$";var K=s++;$[K]="^"+$[W]+$[b]+"$";var Z=s++;$[Z]="^"+$[p]+"\\s*("+l+")$|^$";var ue=s++;$[ue]="^"+$[p]+"\\s*("+g+")$|^$";var _=s++;$[_]="(\\s*)"+$[p]+"\\s*("+l+"|"+$[D]+")",T[_]=new RegExp($[_],"g");var ge=s++;$[ge]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var se=s++;$[se]="^\\s*("+$[b]+")\\s+-\\s+("+$[b]+")\\s*$";var ae=s++;$[ae]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)P($e,$[$e]),T[$e]||(T[$e]=new RegExp($[$e]));function oe(B,H){if(B instanceof ke)return B;if(typeof B!="string"||B.length>O||!(H?T[m]:T[t]).test(B))return null;try{return new ke(B,H)}catch{return null}}function ke(B,H){if(B instanceof ke){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ke))return new ke(B,H);P("SemVer",B,H),this.loose=H;var V=B.trim().match(H?T[m]:T[t]);if(!V)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=oe,e.valid=function(B,H){var V=oe(B,H);return V?V.version:null},e.clean=function(B,H){var V=oe(B.trim().replace(/^[=v]+/,""),H);return V?V.version:null},e.SemVer=ke,ke.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ke.prototype.toString=function(){return this.version},ke.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof ke||(B=new ke(B,this.loose)),this.compareMain(B)||this.comparePre(B)},ke.prototype.compareMain=function(B){return B instanceof ke||(B=new ke(B,this.loose)),Y(this.major,B.major)||Y(this.minor,B.minor)||Y(this.patch,B.patch)},ke.prototype.comparePre=function(B){if(B instanceof ke||(B=new ke(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var V=this.prerelease[H],ne=B.prerelease[H];if(P("prerelease compare",H,V,ne),V===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(V===void 0)return-1;if(V!==ne)return Y(V,ne)}while(++H)},ke.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,V,ne){typeof V=="string"&&(ne=V,V=void 0);try{return new ke(B,V).inc(H,ne).version}catch{return null}},e.diff=function(B,H){if(ce(B,H))return null;var V=oe(B),ne=oe(H);if(V.prerelease.length||ne.prerelease.length){for(var fe in V)if((fe==="major"||fe==="minor"||fe==="patch")&&V[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in V)if((fe==="major"||fe==="minor"||fe==="patch")&&V[fe]!==ne[fe])return fe},e.compareIdentifiers=Y;var Le=/^[0-9]+$/;function Y(B,H){var V=Le.test(B),ne=Le.test(H);return V&&ne&&(B=+B,H=+H),V&&!ne?-1:ne&&!V?1:B<H?-1:B>H?1:0}function q(B,H,V){return new ke(B,V).compare(new ke(H,V))}function te(B,H,V){return q(B,H,V)>0}function ve(B,H,V){return q(B,H,V)<0}function ce(B,H,V){return q(B,H,V)===0}function we(B,H,V){return q(B,H,V)!==0}function he(B,H,V){return q(B,H,V)>=0}function X(B,H,V){return q(B,H,V)<=0}function x(B,H,V,ne){var fe;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),fe=B===V;break;case"!==":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),fe=B!==V;break;case"":case"=":case"==":fe=ce(B,V,ne);break;case"!=":fe=we(B,V,ne);break;case">":fe=te(B,V,ne);break;case">=":fe=he(B,V,ne);break;case"<":fe=ve(B,V,ne);break;case"<=":fe=X(B,V,ne);break;default:throw new TypeError("Invalid operator: "+H)}return fe}function me(B,H){if(B instanceof me){if(B.loose===H)return B;B=B.value}if(!(this instanceof me))return new me(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return Y(H,B)},e.major=function(B,H){return new ke(B,H).major},e.minor=function(B,H){return new ke(B,H).minor},e.patch=function(B,H){return new ke(B,H).patch},e.compare=q,e.compareLoose=function(B,H){return q(B,H,!0)},e.rcompare=function(B,H,V){return q(H,B,V)},e.sort=function(B,H){return B.sort(function(V,ne){return e.compare(V,ne,H)})},e.rsort=function(B,H){return B.sort(function(V,ne){return e.rcompare(V,ne,H)})},e.gt=te,e.lt=ve,e.eq=ce,e.neq=we,e.gte=he,e.lte=X,e.cmp=x,e.Comparator=me;var pe={};function Ae(B,H){if(B instanceof Ae)return B.loose===H?B:new Ae(B.raw,H);if(B instanceof me)return new Ae(B.value,H);if(!(this instanceof Ae))return new Ae(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function Ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function Se(B,H,V,ne,fe,Ie,ze,Qe,_e,tt,nt,et,rt){return((H=Ue(V)?"":Ue(ne)?">="+V+".0.0":Ue(fe)?">="+V+"."+ne+".0":">="+H)+" "+(Qe=Ue(_e)?"":Ue(tt)?"<"+(+_e+1)+".0.0":Ue(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Qe)).trim()}function Pe(B,H){for(var V=0;V<B.length;V++)if(!B[V].test(H))return!1;if(H.prerelease.length){for(V=0;V<B.length;V++)if(P(B[V].semver),B[V].semver!==pe&&B[V].semver.prerelease.length>0){var ne=B[V].semver;if(ne.major===H.major&&ne.minor===H.minor&&ne.patch===H.patch)return!0}return!1}return!0}function Te(B,H,V){try{H=new Ae(H,V)}catch{return!1}return H.test(B)}function j(B,H,V,ne){var fe,Ie,ze,Qe,_e;switch(B=new ke(B,ne),H=new Ae(H,ne),V){case">":fe=te,Ie=X,ze=ve,Qe=">",_e=">=";break;case"<":fe=ve,Ie=he,ze=te,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(B,H,ne))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(mt){mt.semver===pe&&(mt=new me(">=0.0.0")),et=et||mt,rt=rt||mt,fe(mt.semver,et.semver,ne)?et=mt:ze(mt.semver,rt.semver,ne)&&(rt=mt)}),et.operator===Qe||et.operator===_e||(!rt.operator||rt.operator===Qe)&&Ie(B,rt.semver)||rt.operator===_e&&ze(B,rt.semver))return!1}return!0}me.prototype.parse=function(B){var H=this.loose?T[Z]:T[ue],V=B.match(H);if(!V)throw new TypeError("Invalid comparator: "+B);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new ke(V[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===pe||(typeof B=="string"&&(B=new ke(B,this.loose)),x(B,this.operator,this.semver,this.loose))},me.prototype.intersects=function(B,H){if(!(B instanceof me))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(B.value,H),Te(this.value,V,H);if(B.operator==="")return V=new Ae(this.value,H),Te(B.semver,V,H);var ne=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ie=this.semver.version===B.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=x(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=x(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ne||fe||Ie&&ze||Qe||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var V=H?T[se]:T[ge];B=B.replace(V,Se),P("hyphen replace",B),B=B.replace(T[_],"$1$2$3"),P("comparator trim",B,T[_]),B=(B=(B=B.replace(T[F],"$1~")).replace(T[J],"$1^")).split(/\s+/).join(" ");var ne=H?T[Z]:T[ue],fe=B.split(" ").map(function(Ie){return function(ze,Qe){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var mt=rt?T[K]:T[M];return et.replace(mt,function(ut,st,ct,ft,pt){var qe;return P("caret",et,ut,st,ct,ft,pt),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(ft)?qe=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":pt?(P("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+pt+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+pt+" <"+(+st+1)+".0.0"):(P("no pr"),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+" <"+(+st+1)+".0.0"),P("caret return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var mt=rt?T[L]:T[N];return et.replace(mt,function(ut,st,ct,ft,pt){var qe;return P("tilde",et,ut,st,ct,ft,pt),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(ft)?qe=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":pt?(P("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),qe=">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0"):qe=">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0",P("tilde return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var mt=rt?T[C]:T[k];return et.replace(mt,function(ut,st,ct,ft,pt,qe){P("xRange",et,ut,st,ct,ft,pt,qe);var je=Ue(ct),ee=je||Ue(ft),Q=ee||Ue(pt);return st==="="&&Q&&(st=""),je?ut=st===">"||st==="<"?"<0.0.0":"*":st&&Q?(ee&&(ft=0),Q&&(pt=0),st===">"?(st=">=",ee?(ct=+ct+1,ft=0,pt=0):Q&&(ft=+ft+1,pt=0)):st==="<="&&(st="<",ee?ct=+ct+1:ft=+ft+1),ut=st+ct+"."+ft+"."+pt):ee?ut=">="+ct+".0.0 <"+(+ct+1)+".0.0":Q&&(ut=">="+ct+"."+ft+".0 <"+ct+"."+(+ft+1)+".0"),P("xRange return",ut),ut})}(nt,tt)}).join(" ")}(ze,Qe),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ae],"")}(ze,Qe),P("stars",ze),ze}(Ie,H)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ie){return!!Ie.match(ne)})),fe=fe.map(function(Ie){return new me(Ie,H)})},Ae.prototype.intersects=function(B,H){if(!(B instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(ne){return B.set.some(function(fe){return fe.every(function(Ie){return ne.intersects(Ie,H)})})})})},e.toComparators=function(B,H){return new Ae(B,H).set.map(function(V){return V.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new ke(B,this.loose));for(var H=0;H<this.set.length;H++)if(Pe(this.set[H],B))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(B,H,V){var ne=null,fe=null;try{var Ie=new Ae(H,V)}catch{return null}return B.forEach(function(ze){Ie.test(ze)&&(ne&&fe.compare(ze)!==-1||(fe=new ke(ne=ze,V)))}),ne},e.minSatisfying=function(B,H,V){var ne=null,fe=null;try{var Ie=new Ae(H,V)}catch{return null}return B.forEach(function(ze){Ie.test(ze)&&(ne&&fe.compare(ze)!==1||(fe=new ke(ne=ze,V)))}),ne},e.validRange=function(B,H){try{return new Ae(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,V){return j(B,H,"<",V)},e.gtr=function(B,H,V){return j(B,H,">",V)},e.outside=j,e.prerelease=function(B,H){var V=oe(B,H);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(B,H,V){return B=new Ae(B,V),H=new Ae(H,V),B.intersects(H)},e.coerce=function(B){if(B instanceof ke)return B;if(typeof B!="string")return null;var H=B.match(T[f]);return H==null?null:oe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(be,e){var v,I,P=be.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(o){if(v===setTimeout)return setTimeout(o,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{I=typeof clearTimeout=="function"?clearTimeout:A}catch{I=A}})();var $,s=[],R=!1,y=-1;function a(){R&&$&&(R=!1,$.length?s=$.concat(s):y=-1,s.length&&S())}function S(){if(!R){var o=T(a);R=!0;for(var c=s.length;c;){for($=s,s=[];++y<c;)$&&$[y].run();y=-1,c=s.length}$=null,R=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===A||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(o)}}function d(o,c){this.fun=o,this.array=c}function n(){}P.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];s.push(new d(o,c)),s.length!==1||R||T(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=n,P.addListener=n,P.once=n,P.off=n,P.removeListener=n,P.removeAllListeners=n,P.emit=n,P.prependListener=n,P.prependOnceListener=n,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Oe[146],Ne([1,0,6,4]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,n,o,c,u,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,c=c|0,u=u|0,i=i|0,r=r|0),this.rawScrollLeft=c,this.rawScrollTop=r,n<0&&(n=0),c+n>o&&(c=o-n),c<0&&(c=0),u<0&&(u=0),r+u>i&&(r=i-u),r<0&&(r=0),this.width=n,this.scrollWidth=o,this.scrollLeft=c,this.height=u,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const o=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,u=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:u,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$bt=O;class A extends I.$Tc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$ke),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const o=this.g.withScrollDimensions(d,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let c;n?c=new R(this.h.from,o,this.h.startTime,this.h.duration):c=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=c}else{const o=this.g.withScrollPosition(d);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,n)))}}e.$ct=A;class T{constructor(d,n,o){this.scrollLeft=d,this.scrollTop=n,this.isDone=o}}e.$dt=T;function $(S,d){const n=d-S;return function(o){return S+n*a(o)}}function s(S,d,n){return function(o){return o<n?S(o/n):d((o-n)/(1-n))}}class R{constructor(d,n,o,c){this.from=d,this.to=n,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,o){if(Math.abs(d-n)>2.5*o){let u,i;return d<n?(u=d+.75*o,i=n-.75*o):(u=d-.75*o,i=n+.75*o),s($(d,u),$(i,n),.33)}return $(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const o=this.c(n),c=this.d(n);return new T(o,c,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,o){return R.start(d,n,o)}static start(d,n,o){o=o+10;const c=Date.now()-10;return new R(d,n,c,o)}}e.$et=R;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Oe[147],Ne([1,0,13,4]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=P,e.$ye=O,e.$ze=A,e.$Ae=T,e.$Be=s,e.$Ce=R,e.$De=y,e.$Ee=a,e.$Fe=S,e.$Ge=d,e.$He=n,e.$Ie=o,e.$Je=c,e.$Ke=u,e.$Le=i;function P(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new $(r,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const m=l.indexOf(g);m>=0&&l.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(r,t){const g=[];let l;for(;(l=r.read())!==null;)g.push(l);return t(g)}function R(r,t,g){const l=[];let m;for(;(m=r.read())!==null&&l.length<g;)l.push(m);return m===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof m<"u"){const p=m;return m=void 0,p}return r.read()}}}function y(r,t){return new Promise((g,l)=>{const m=[];a(r,{onData:p=>{t&&m.push(p)},onError:p=>{t?l(p):g(void 0)},onEnd:()=>{g(t?t(m):void 0)}})})}function a(r,t,g){r.on("error",l=>{g?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{g?.isCancellationRequested||t.onData(l)})}function S(r,t){return new Promise((g,l)=>{const m=new I.$Sc,p=[],h=b=>{if(p.push(b),p.length>t)return m.dispose(),r.pause(),g({stream:r,buffer:p,ended:!1})},E=b=>(m.dispose(),l(b)),D=()=>(m.dispose(),g({stream:r,buffer:p,ended:!0}));m.add((0,I.$Rc)(()=>r.removeListener("error",E))),r.on("error",E),m.add((0,I.$Rc)(()=>r.removeListener("end",D))),r.on("end",D),m.add((0,I.$Rc)(()=>r.removeListener("data",h))),r.on("data",h)})}function d(r,t){const g=T(t);return g.end(r),g}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function o(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function c(r,t,g){const l=T(g);return a(r,{onData:m=>l.write(t.data(m)),onError:m=>l.error(t.error?t.error(m):m),onEnd:()=>l.end()}),l}function u(r,t,g){let l=!1;return{read:()=>{const m=t.read();return l?m:(l=!0,m!==null?g([r,m]):r)}}}function i(r,t,g){let l=!1;const m=T(g);return a(t,{onData:p=>l?m.write(p):(l=!0,m.write(g([r,p]))),onError:p=>m.error(p),onEnd:()=>{l||(l=!0,m.write(r)),m.end()}}),m}}),define(Oe[22],Ne([1,0,48,147]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=void 0,e.$Ne=s,e.$Oe=R,e.$Pe=y,e.$Qe=a,e.$Re=S,e.$Se=d,e.$Te=n,e.$Ue=o,e.$Ve=c,e.$We=u,e.$Xe=i,e.$Ye=r,e.$Ze=t,e.$1e=g,e.$2e=l,e.$3e=m,e.$4e=p,e.$5e=h,e.$6e=E,e.$7e=k,I=We(I);const P=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let A,T;class ${static alloc(f){return P?new $(Buffer.allocUnsafe(f)):new $(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new $(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(f)):(A||(A=new TextEncoder),new $(A.encode(f)))}static fromByteArray(f){const w=$.alloc(f.length);for(let F=0,N=f.length;F<N;F++)w.buffer[F]=f[F];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let L=0,W=f.length;L<W;L++)w+=f[L].byteLength}const F=$.alloc(w);let N=0;for(let L=0,W=f.length;L<W;L++){const J=f[L];F.set(J,N),N+=J.byteLength}return F}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=$.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,w){return new $(this.buffer.subarray(f,w))}set(f,w){if(f instanceof $)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,w){S(this.buffer,f,w)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,w){n(this.buffer,f,w)}readUInt8(f){return o(this.buffer,f)}writeUInt8(f,w){c(this.buffer,f,w)}indexOf(f,w=0){return s(this.buffer,f instanceof $?f.buffer:f,w)}}e.$Me=$;function s(C,f,w=0){const F=f.byteLength,N=C.byteLength;if(F===0)return 0;if(F===1)return C.indexOf(f[0]);if(F>N-w)return-1;const L=O.value;L.fill(f.length);for(let K=0;K<f.length;K++)L[f[K]]=f.length-K-1;let W=w+f.length-1,J=W,M=-1;for(;W<N;)if(C[W]===f[J]){if(J===0){M=W;break}W--,J--}else W+=Math.max(f.length-J,L[C[W]]),J=f.length-1;return M}function R(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0}function y(C,f,w){C[w+0]=f&255,f=f>>>8,C[w+1]=f&255}function a(C,f){return C[f]*2**24+C[f+1]*2**16+C[f+2]*2**8+C[f+3]}function S(C,f,w){C[w+3]=f,f=f>>>8,C[w+2]=f,f=f>>>8,C[w+1]=f,f=f>>>8,C[w]=f}function d(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0|C[f+2]<<16>>>0|C[f+3]<<24>>>0}function n(C,f,w){C[w+0]=f&255,f=f>>>8,C[w+1]=f&255,f=f>>>8,C[w+2]=f&255,f=f>>>8,C[w+3]=f&255}function o(C,f){return C[f]}function c(C,f,w){C[w]=f}function u(C){return I.$Be(C,f=>$.concat(f))}function i(C){return I.$Ie(C)}function r(C){return I.$De(C,f=>$.concat(f))}async function t(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await r(C.stream)])}function g(C){return I.$Ge(C,f=>$.concat(f))}function l(C){return I.$Je(C,{data:f=>typeof f=="string"?$.fromString(f):$.wrap(f)},f=>$.concat(f))}function m(C){return I.$Ae(f=>$.concat(f),C)}function p(C,f){return I.$Ke(C,f,w=>$.concat(w))}function h(C,f){return I.$Le(C,f,w=>$.concat(w))}function E(C){let f=0,w=0,F=0;const N=new Uint8Array(Math.floor(C.length/4*3)),L=J=>{switch(w){case 3:N[F++]=f|J,w=0;break;case 2:N[F++]=f|J>>>2,f=J<<6,w=3;break;case 1:N[F++]=f|J>>>4,f=J<<4,w=2;break;default:f=J<<2,w=1}};for(let J=0;J<C.length;J++){const M=C.charCodeAt(J);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${C[J]}`)}}const W=F;for(;w>0;)L(0);return $.wrap(N).slice(0,W)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:C},f=!0,w=!1){const F=w?b:D;let N="";const L=C.byteLength%3;let W=0;for(;W<C.byteLength-L;W+=3){const J=C[W+0],M=C[W+1],K=C[W+2];N+=F[J>>>2],N+=F[(J<<4|M>>>4)&63],N+=F[(M<<2|K>>>6)&63],N+=F[K&63]}if(L===1){const J=C[W+0];N+=F[J>>>2],N+=F[J<<4&63],f&&(N+="==")}else if(L===2){const J=C[W+0],M=C[W+1];N+=F[J>>>2],N+=F[(J<<4|M>>>4)&63],N+=F[M<<2&63],f&&(N+="=")}return N}}),define(Oe[148],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0,e.$fe=Symbol("MicrotaskDelay")}),define(Oe[34],Ne([1,0,97]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$4j=P;var I;(function(A){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=T})(I||(e.ThemeColor=I={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(u){const i=T.exec(u.id);if(!i)return $(v.$3j.error);const[,r,t]=i,g=["codicon","codicon-"+r];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=$;function s(u){return $(u).join(" ")}A.asClassName=s;function R(u){return"."+$(u).join(".")}A.asCSSSelector=R;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||I.isThemeColor(u.color))}A.isThemeIcon=y;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(u){const i=a.exec(u);if(!i)return;const[,r]=i;return{id:r}}A.fromString=S;function d(u){return{id:u}}A.fromId=d;function n(u,i){let r=u.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function o(u){const i=u.id.lastIndexOf("~");if(i!==-1)return u.id.substring(i+1)}A.getModifier=o;function c(u,i){return u.id===i.id&&u.color?.id===i.color?.id}A.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Oe[51],Ne([1,0,27,19,20,12,14]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=T,e.$wg=$,e.$xg=s,e.$yg=R,e.$zg=y,e.$Ag=n,e.$Bg=o,e.$Cg=c,e.$Dg=u,e.$Eg=i,e.$Fg=r,e.$Gg=t,e.$Hg=g,e.$Ig=l,e.$Jg=m,e.$Kg=p,e.$Lg=D;function T(b){return b===v.CharCode.Slash||b===v.CharCode.Backslash}function $(b){return b.replace(/[\\/]/g,I.$fc.sep)}function s(b){return b.indexOf("/")===-1&&(b=$(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function R(b,k=I.$fc.sep){if(!b)return"";const C=b.length,f=b.charCodeAt(0);if(T(f)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let F=3;const N=F;for(;F<C&&!T(b.charCodeAt(F));F++);if(N!==F&&!T(b.charCodeAt(F+1))){for(F+=1;F<C;F++)if(T(b.charCodeAt(F)))return b.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(u(f)&&b.charCodeAt(1)===v.CharCode.Colon)return T(b.charCodeAt(2))?b.slice(0,2)+k:b.slice(0,2);let w=b.indexOf("://");if(w!==-1){for(w+=3;w<C;w++)if(T(b.charCodeAt(w)))return b.slice(0,w+1)}return""}function y(b){if(!P.$j||!b||b.length<5)return!1;let k=b.charCodeAt(0);if(k!==v.CharCode.Backslash||(k=b.charCodeAt(1),k!==v.CharCode.Backslash))return!1;let C=2;const f=C;for(;C<b.length&&(k=b.charCodeAt(C),k!==v.CharCode.Backslash);C++);return!(f===C||(k=b.charCodeAt(C+1),isNaN(k)||k===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,k=P.$j){const C=k?a:S;return!(!b||b.length===0||/^\s+$/.test(b)||(C.lastIndex=0,C.test(b))||k&&d.test(b)||b==="."||b===".."||k&&b[b.length-1]==="."||k&&b.length!==b.trim().length||b.length>255)}function o(b,k,C){const f=b===k;return!C||f?f:!b||!k?!1:(0,O.$Ef)(b,k)}function c(b,k,C,f=I.sep){if(b===k)return!0;if(!b||!k||k.length>b.length)return!1;if(C){if(!(0,O.$Ff)(b,k))return!1;if(k.length===b.length)return!0;let F=k.length;return k.charAt(k.length-1)===f&&F--,b.charAt(F)===f}return k.charAt(k.length-1)!==f&&(k+=f),b.indexOf(k)===0}function u(b){return b>=v.CharCode.A&&b<=v.CharCode.Z||b>=v.CharCode.a&&b<=v.CharCode.z}function i(b,k){return P.$j&&b.endsWith(":")&&(b+=I.sep),(0,I.$hc)(b)||(b=(0,I.$ic)(k,b)),b=(0,I.$gc)(b),r(b)}function r(b){return P.$j?(b=(0,O.$mf)(b,I.sep),b.endsWith(":")&&(b+=I.sep)):(b=(0,O.$mf)(b,I.sep),b||(b=I.sep)),b}function t(b){const k=(0,I.$gc)(b);return P.$j?b.length>3?!1:g(k)&&(b.length===2||k.charCodeAt(2)===v.CharCode.Backslash):k===I.$fc.sep}function g(b,k=P.$j){return k?u(b.charCodeAt(0))&&b.charCodeAt(1)===v.CharCode.Colon:!1}function l(b,k=P.$j){return g(b,k)?b[0]:void 0}function m(b,k,C){return k.length>b.length?-1:b===k?0:(C&&(b=b.toLowerCase(),k=k.toLowerCase()),b.indexOf(k))}function p(b){const k=b.split(":");let C,f,w;for(const F of k){const N=Number(F);(0,A.$hg)(N)?f===void 0?f=N:w===void 0&&(w=N):C=C?[C,F].join(":"):F}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,k,C=8){let f="";for(let F=0;F<C;F++){let N;F===0&&P.$j&&!k&&(C===3||C===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let w;return k?w=`${k}-${f}`:w=f,b?(0,I.$ic)(b,w):w}}),define(Oe[149],Ne([1,0,27,28,139,12]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.FuzzyScore=e.$Gk=e.$Fk=void 0,e.or=A,e.$Hk=$,e.$Ik=s,e.$Jk=a,e.$Kk=D,e.$Lk=b,e.$Mk=N,e.$Nk=L,e.$Ok=W,e.$Pk=J,e.$Qk=te,e.$Sk=he,e.$Tk=me,e.$Uk=pe,O=We(O);function A(...Se){return function(Pe,Te){for(let j=0,B=Se.length;j<B;j++){const H=Se[j](Pe,Te);if(H)return H}return null}}e.$Fk=T.bind(void 0,!1),e.$Gk=T.bind(void 0,!0);function T(Se,Pe,Te){if(!Te||Te.length<Pe.length)return null;let j;return Se?j=O.$Ff(Te,Pe):j=Te.indexOf(Pe)===0,j?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(Se,Pe){const Te=Pe.toLowerCase().indexOf(Se.toLowerCase());return Te===-1?null:[{start:Te,end:Te+Se.length}]}function s(Se,Pe){return R(Se.toLowerCase(),Pe.toLowerCase(),0,0)}function R(Se,Pe,Te,j){if(Te===Se.length)return[];if(j===Pe.length)return null;if(Se[Te]===Pe[j]){let B=null;return(B=R(Se,Pe,Te+1,j+1))?t({start:j,end:j+1},B):null}return R(Se,Pe,Te,j+1)}function y(Se){return v.CharCode.a<=Se&&Se<=v.CharCode.z}function a(Se){return v.CharCode.A<=Se&&Se<=v.CharCode.Z}function S(Se){return v.CharCode.Digit0<=Se&&Se<=v.CharCode.Digit9}function d(Se){return Se===v.CharCode.Space||Se===v.CharCode.Tab||Se===v.CharCode.LineFeed||Se===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>n.add(Se.charCodeAt(0)));function o(Se){return d(Se)||n.has(Se)}function c(Se,Pe){return Se===Pe||o(Se)&&o(Pe)}const u=new Map;function i(Se){if(u.has(Se))return u.get(Se);let Pe;const Te=(0,P.$Dk)(Se);return Te&&(Pe=Te),u.set(Se,Pe),Pe}function r(Se){return y(Se)||a(Se)||S(Se)}function t(Se,Pe){return Pe.length===0?Pe=[Se]:Se.end===Pe[0].start?Pe[0].start=Se.start:Pe.unshift(Se),Pe}function g(Se,Pe){for(let Te=Pe;Te<Se.length;Te++){const j=Se.charCodeAt(Te);if(a(j)||S(j)||Te>0&&!r(Se.charCodeAt(Te-1)))return Te}return Se.length}function l(Se,Pe,Te,j){if(Te===Se.length)return[];if(j===Pe.length)return null;if(Se[Te]!==Pe[j].toLowerCase())return null;{let B=null,H=j+1;for(B=l(Se,Pe,Te+1,j+1);!B&&(H=g(Pe,H))<Pe.length;)B=l(Se,Pe,Te+1,H),H++;return B===null?null:t({start:j,end:j+1},B)}}function m(Se){let Pe=0,Te=0,j=0,B=0,H=0;for(let ze=0;ze<Se.length;ze++)H=Se.charCodeAt(ze),a(H)&&Pe++,y(H)&&Te++,r(H)&&j++,S(H)&&B++;const V=Pe/Se.length,ne=Te/Se.length,fe=j/Se.length,Ie=B/Se.length;return{upperPercent:V,lowerPercent:ne,alphaPercent:fe,numericPercent:Ie}}function p(Se){const{upperPercent:Pe,lowerPercent:Te}=Se;return Te===0&&Pe>.6}function h(Se){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:j,numericPercent:B}=Se;return Te>.2&&Pe<.8&&j>.6&&B<.2}function E(Se){let Pe=0,Te=0,j=0,B=0;for(let H=0;H<Se.length;H++)j=Se.charCodeAt(H),a(j)&&Pe++,y(j)&&Te++,d(j)&&B++;return(Pe===0||Te===0)&&B===0?Se.length<=30:Pe<=5}function D(Se,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(Se))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=m(Pe);if(!h(Te)){if(!p(Te))return null;Pe=Pe.toLowerCase()}let j=null,B=0;for(Se=Se.toLowerCase();B<Pe.length&&(j=l(Se,Pe,0,B))===null;)B=g(Pe,B+1);return j}function b(Se,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let j=null,B=0;for(Se=Se.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(j=k(Se,Pe,0,B,Te),j===null);)B=C(Pe,B+1);return j}function k(Se,Pe,Te,j,B){let H=0;if(Te===Se.length)return[];if(j===Pe.length)return null;if(!c(Se.charCodeAt(Te),Pe.charCodeAt(j))){const fe=i(Se.charCodeAt(Te));if(!fe)return null;for(let Ie=0;Ie<fe.length;Ie++)if(!c(fe[Ie],Pe.charCodeAt(j+Ie)))return null;H+=fe.length-1}let V=null,ne=j+H+1;if(V=k(Se,Pe,Te+1,ne,B),!B)for(;!V&&(ne=C(Pe,ne))<Pe.length;)V=k(Se,Pe,Te+1,ne,B),ne++;if(!V)return null;if(Se.charCodeAt(Te)!==Pe.charCodeAt(j)){const fe=i(Se.charCodeAt(Te));if(!fe)return V;for(let Ie=0;Ie<fe.length;Ie++)if(fe[Ie]!==Pe.charCodeAt(j+Ie))return V}return t({start:j,end:j+H+1},V)}function C(Se,Pe){for(let Te=Pe;Te<Se.length;Te++)if(o(Se.charCodeAt(Te))||Te>0&&o(Se.charCodeAt(Te-1)))return Te;return Se.length}const f=A(e.$Gk,D,$),w=A(e.$Gk,D,s),F=new I.$Cc(1e4);function N(Se,Pe,Te=!1){if(typeof Se!="string"||typeof Pe!="string")return null;let j=F.get(Se);j||(j=new RegExp(O.$nf(Se),"i"),F.set(Se,j));const B=j.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Te?w(Se,Pe):f(Se,Pe)}function L(Se,Pe){const Te=he(Se,Se.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?J(Te):null}function W(Se,Pe,Te,j,B,H){const V=Math.min(13,Se.length);for(;Te<V;Te++){const ne=he(Se,Pe,Te,j,B,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,H]}function J(Se){if(typeof Se>"u")return[];const Pe=[],Te=Se[1];for(let j=Se.length-1;j>1;j--){const B=Se[j]+Te,H=Pe[Pe.length-1];H&&H.end===B?H.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const M=128;function K(){const Se=[],Pe=[];for(let Te=0;Te<=M;Te++)Pe[Te]=0;for(let Te=0;Te<=M;Te++)Se.push(Pe.slice(0));return Se}function Z(Se){const Pe=[];for(let Te=0;Te<=Se;Te++)Pe[Te]=0;return Pe}const ue=Z(2*M),_=Z(2*M),ge=K(),se=K(),ae=K(),$e=!1;function oe(Se,Pe,Te,j,B){function H(ne,fe,Ie=" "){for(;ne.length<fe;)ne=Ie+ne;return ne}let V=` |   |${j.split("").map(ne=>H(ne,3)).join("|")}
`;for(let ne=0;ne<=Te;ne++)ne===0?V+=" |":V+=`${Pe[ne-1]}|`,V+=Se[ne].slice(0,B+1).map(fe=>H(fe.toString(),3)).join("|")+`
`;return V}function ke(Se,Pe,Te,j){Se=Se.substr(Pe),Te=Te.substr(j),console.log(oe(se,Se,Se.length,Te,Te.length)),console.log(oe(ae,Se,Se.length,Te,Te.length)),console.log(oe(ge,Se,Se.length,Te,Te.length))}function Le(Se,Pe){if(Pe<0||Pe>=Se.length)return!1;const Te=Se.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Xf(Te)}}function Y(Se,Pe){if(Pe<0||Pe>=Se.length)return!1;switch(Se.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(Se,Pe,Te){return Pe[Se]!==Te[Se]}function te(Se,Pe,Te,j,B,H,V=!1){for(;Pe<Te&&B<H;)Se[Pe]===j[B]&&(V&&(ue[Pe]=B),Pe+=1),B+=1;return Pe===Te}var ve;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ce;(function(Se){Se.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}Se.isDefault=Pe})(ce||(e.FuzzyScore=ce={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Rk=we;function he(Se,Pe,Te,j,B,H,V=we.default){const ne=Se.length>M?M:Se.length,fe=j.length>M?M:j.length;if(Te>=ne||H>=fe||ne-Te>fe-H||!te(Pe,Te,ne,B,H,fe,!0))return;X(ne,fe,Te,H,Pe,B);let Ie=1,ze=1,Qe=Te,_e=H;const tt=[!1];for(Ie=1,Qe=Te;Qe<ne;Ie++,Qe++){const ut=ue[Qe],st=_[Qe],ct=Qe+1<ne?_[Qe+1]:fe;for(ze=ut-H+1,_e=ut;_e<ct;ze++,_e++){let ft=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(ft=x(Se,Pe,Qe,Te,j,B,_e,fe,H,ge[Ie-1][ze-1]===0,tt));let qe=0;ft!==Number.MAX_SAFE_INTEGER&&(pt=!0,qe=ft+se[Ie-1][ze-1]);const je=_e>ut,ee=je?se[Ie][ze-1]+(ge[Ie][ze-1]>0?-5:0):0,Q=_e>ut+1&&ge[Ie][ze-1]>0,Ee=Q?se[Ie][ze-2]+(ge[Ie][ze-2]>0?-5:0):0;if(Q&&(!je||Ee>=ee)&&(!pt||Ee>=qe))se[Ie][ze]=Ee,ae[Ie][ze]=ve.LeftLeft,ge[Ie][ze]=0;else if(je&&(!pt||ee>=qe))se[Ie][ze]=ee,ae[Ie][ze]=ve.Left,ge[Ie][ze]=0;else if(pt)se[Ie][ze]=qe,ae[Ie][ze]=ve.Diag,ge[Ie][ze]=ge[Ie-1][ze-1]+1;else throw new Error("not possible")}}if($e&&ke(Se,Te,j,H),!tt[0]&&!V.firstMatchCanBeWeak)return;Ie--,ze--;const nt=[se[Ie][ze],H];let et=0,rt=0;for(;Ie>=1;){let ut=ze;do{const st=ae[Ie][ut];if(st===ve.LeftLeft)ut=ut-2;else if(st===ve.Left)ut=ut-1;else break}while(ut>=1);et>1&&Pe[Te+Ie-1]===B[H+ze-1]&&!q(ut+H-1,j,B)&&et+1>ge[Ie][ut]&&(ut=ze),ut===ze?et++:et=1,rt||(rt=ut),Ie--,ze=ut-1,nt.push(ze)}fe-H===ne&&V.boostFullMatch&&(nt[0]+=2);const mt=rt-ne;return nt[0]-=mt,nt}function X(Se,Pe,Te,j,B,H){let V=Se-1,ne=Pe-1;for(;V>=Te&&ne>=j;)B[V]===H[ne]&&(_[V]=ne,V--),ne--}function x(Se,Pe,Te,j,B,H,V,ne,fe,Ie,ze){if(Pe[Te]!==H[V])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return V===Te-j?Qe=Se[Te]===B[V]?7:5:q(V,B,H)&&(V===0||!q(V-1,B,H))?(Qe=Se[Te]===B[V]?7:5,_e=!0):Le(H,V)&&(V===0||!Le(H,V-1))?Qe=5:(Le(H,V-1)||Y(H,V-1))&&(Qe=5,_e=!0),Qe>1&&Te===j&&(ze[0]=!0),_e||(_e=q(V,B,H)||Le(H,V-1)||Y(H,V-1)),Te===j?V>fe&&(Qe-=_e?3:5):Ie?Qe+=_e?2:0:Qe+=_e?0:1,V+1===ne&&(Qe-=_e?3:5),Qe}function me(Se,Pe,Te,j,B,H,V){return Ae(Se,Pe,Te,j,B,H,!0,V)}function pe(Se,Pe,Te,j,B,H,V){return Ae(Se,Pe,Te,j,B,H,!1,V)}function Ae(Se,Pe,Te,j,B,H,V,ne){let fe=he(Se,Pe,Te,j,B,H,ne);if(fe&&!V)return fe;if(Se.length>=3){const Ie=Math.min(7,Se.length-1);for(let ze=Te+1;ze<Ie;ze++){const Qe=Ue(Se,ze);if(Qe){const _e=he(Qe,Qe.toLowerCase(),Te,j,B,H,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function Ue(Se,Pe){if(Pe+1>=Se.length)return;const Te=Se[Pe],j=Se[Pe+1];if(Te!==j)return Se.slice(0,Pe)+j+Te+Se.slice(Pe+2)}}),define(Oe[98],Ne([1,0,149,12,34]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=$,e.$Wk=R,e.$Xk=a,e.$Yk=S,e.$Zk=n,e.$1k=o;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function $(c){return c.replace(T,(u,i)=>i?u:`\\${u}`)}const s=new RegExp(`\\\\${A.source}`,"g");function R(c){return c.replace(s,u=>`\\${u}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(c){return c.indexOf(O)===-1?c:c.replace(y,(u,i,r,t)=>r?u:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(u,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(c){d.lastIndex=0;let u="";const i=[];let r=0;for(;;){const t=d.lastIndex,g=d.exec(c),l=c.substring(t,g?.index);if(l.length>0){u+=l;for(let m=0;m<l.length;m++)i.push(r)}if(!g)break;r+=g[0].length}return{text:u,iconOffsets:i}}function o(c,u,i=!1){const{text:r,iconOffsets:t}=u;if(!t||t.length===0)return(0,v.$Mk)(c,r,i);const g=(0,I.$lf)(r," "),l=r.length-g.length,m=(0,v.$Mk)(c,g,i);if(m)for(const p of m){const h=t[p.start+l]+l;p.start+=h,p.end+=h}return m}}),define(Oe[35],Ne([1,0,12]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=We(v);var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const O="error",A="warning",T="warn",$="info",s="ignore";function R(a){return a?v.$Ef(O,a)?P.Error:v.$Ef(A,a)||v.$Ef(T,a)?P.Warning:v.$Ef($,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function y(a){switch(a){case P.Error:return O;case P.Warning:return A;case P.Info:return $;default:return s}}P.toString=y}(I||(I={})),e.default=I}),define(Oe[58],Ne([1,0,17,27,12]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return n-o}value(){return this.b[this.c]}}e.$Fi=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===I.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$yf)(d,this.b,0,d.length,this.c,this.d):(0,P.$Af)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Gi=A;class T{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const o=this.b.charCodeAt(n);if(!(o===I.CharCode.Slash||this.f&&o===I.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===I.CharCode.Slash||this.f&&n===I.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$yf)(d,this.b,0,d.length,this.d,this.e):(0,P.$Af)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Hi=T;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class s{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,P.$zf)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$zf)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,P.$xf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$xf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ii=s;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,n=()=>!1){return new a(new s(d,n))}static forPaths(d=!1){return new a(new T(void 0,!d))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const o=n.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c,d)}else{const o=d.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c[0],c[1])}}set(d,n){const o=this.b.reset(d);let c;this.c||(this.c=new R,this.c.segment=o.value());const u=[];for(c=this.c;;){const r=o.cmp(c.segment);if(r>0)c.left||(c.left=new R,c.left.segment=o.value()),u.push([y.Left,c]),c=c.left;else if(r<0)c.right||(c.right=new R,c.right.segment=o.value()),u.push([y.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new R,c.mid.segment=o.value()),u.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=n,c.key=d;for(let r=u.length-1;r>=0;r--){const t=u[r][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const l=u[r][0],m=u[r+1][0];if(l===y.Right&&m===y.Right)u[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Left)u[r][1]=t.rotateRight();else if(l===y.Right&&m===y.Left)t.right=u[r+1][1]=u[r+1][1].rotateRight(),u[r][1]=t.rotateLeft();else if(l===y.Left&&m===y.Right)t.left=u[r+1][1]=u[r+1][1].rotateLeft(),u[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(u[r-1][0]){case y.Left:u[r-1][1].left=u[r][1];break;case y.Right:u[r-1][1].right=u[r][1];break;case y.Mid:u[r-1][1].mid=u[r][1];break}else this.c=u[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let o=this.c;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const o=this.b.reset(d),c=[];let u=this.c;for(;u;){const i=o.cmp(u.segment);if(i>0)c.push([y.Left,u]),u=u.left;else if(i<0)c.push([y.Right,u]),u=u.right;else if(o.hasNext())o.next(),c.push([y.Mid,u]),u=u.mid;else break}if(u){if(n?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const i=this.f(u.right);if(i.key){const{key:r,value:t,segment:g}=i;this.e(i.key,!1),u.key=r,u.value=t,u.segment=g}}else{const i=u.left??u.right;if(c.length>0){const[r,t]=c[c.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const r=c[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),c[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),c[i][1]=r.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let o=this.c,c;for(;o;){const u=n.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(n.hasNext())n.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(d){return this.g(d,!1)}g(d,n){const o=this.b.reset(d);let c=this.c;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this.h(c.mid):n?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,o]of this)d(o,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Ji=a}),define(Oe[40],Ne([1,0,22,2,36]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=O,e.$_h=A,e.$ai=$;function O(s){return JSON.stringify(s,T)}function A(s){let R=JSON.parse(s);return R=$(R),R}function T(s,R){return R instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function $(s,R=0){if(!s||R>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return I.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Me||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=$(s[y],R+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=$(s[y],R+1))}return s}}),define(Oe[15],Ne([1,0,13,20,12,2,19]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Qg=e.$Pg=e.$Og=e.Schemas=void 0,e.$Mg=$,e.$Ng=s,e.$Rg=y,v=We(v),I=We(I),A=We(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(d,n){return O.URI.isUri(d)?(0,P.$Ef)(d.scheme,n):(0,P.$Ff)(d,n+":")}function s(d,...n){return n.some(o=>$(d,o))}e.$Og="vscode-tkn",e.$Pg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=y(n,o)}getServerRootPath(){return this.f}get g(){return A.$fc.join(this.f,T.vscodeRemoteResource)}set(n,o,c){this.a[n]=o,this.b[n]=c}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$Y(t),n}const o=n.authority;let c=this.a[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const u=this.b[o],i=this.c[o];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Pg}=${encodeURIComponent(i)}`),O.URI.from({scheme:I.$p?this.d:T.vscodeRemoteResource,authority:`${c}:${u}`,path:this.g,query:r})}}e.$Qg=new R;function y(d,n){return A.$fc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Sg="vs/../../extensions",e.$Tg="vs/../../node_modules",e.$Ug="vs/../../node_modules.asar",e.$Vg="vs/../../node_modules.asar.unpacked",e.$Wg="vscode-app";class a{static{this.a=e.$Wg}asBrowserUri(n){const o=this.b(n,be);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Qg.rewrite(n):n.scheme===T.file&&(I.$n||I.$r===`${T.vscodeFileResource}://${a.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||a.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,be);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==a.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return O.URI.isUri(n)?n:O.URI.parse(o.toUrl(n))}}e.$Xg=new a;var S;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function c(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(o);if(t)return n.get(t)}d.getHeadersFromQuery=c;function u(i,r,t){if(!globalThis.crossOriginIsolated)return;const g=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,g):i[o]=g}d.addSearchParam=u})(S||(e.COI=S={}))}),define(Oe[23],Ne([1,0,27,51,15,19,20,12,2]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=void 0,e.$5g=s,e.$nh=y,e.$oh=S,I=We(I),O=We(O);function s(d){return(0,$.$vc)(d,!0)}class R{constructor(n){this.a=n}compare(n,o,c=!1){return n===o?0:(0,T.$xf)(this.getComparisonKey(n,c),this.getComparisonKey(o,c))}isEqual(n,o,c=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,c)===this.getComparisonKey(o,c)}getComparisonKey(n,o=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,o,c=!1){if(n.scheme===o.scheme){if(n.scheme===P.Schemas.file)return I.$Cg(s(n),s(o),this.a(n))&&n.query===o.query&&(c||n.fragment===o.fragment);if((0,e.$jh)(n.authority,o.authority))return I.$Cg(n.path,o.path,this.a(n),"/")&&n.query===o.query&&(c||n.fragment===o.fragment)}return!1}joinPath(n,...o){return $.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.$bh)(n)||n.authority}basename(n){return O.$fc.basename(n.path)}extname(n){return O.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===P.Schemas.file?o=$.URI.file(O.$lc(s(n))).path:(o=O.$fc.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===P.Schemas.file?o=$.URI.file(O.$gc(s(n))).path:o=O.$fc.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.$jh)(n.authority,o.authority))return;if(n.scheme===P.Schemas.file){const i=O.$kc(s(n),s(o));return A.$j?I.$wg(i):i}let c=n.path||"/";const u=o.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(c.length,u.length);i<r&&!(c.charCodeAt(i)!==u.charCodeAt(i)&&c.charAt(i).toLowerCase()!==u.charAt(i).toLowerCase());i++);c=u.substr(0,i)+c.substr(i)}return O.$fc.relative(c,u)}resolvePath(n,o){if(n.scheme===P.Schemas.file){const c=$.URI.file(O.$jc(s(n),o));return n.with({authority:c.authority,path:c.path})}return o=I.$xg(o),n.with({path:O.$fc.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,T.$Ef)(n,o)}hasTrailingPathSeparator(n,o=O.sep){if(n.scheme===P.Schemas.file){const c=s(n);return c.length>I.$yg(c).length&&c[c.length-1]===o}else{const c=n.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=O.sep){return(0,e.$kh)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=O.sep){let c=!1;if(n.scheme===P.Schemas.file){const u=s(n);c=u!==void 0&&u.length===I.$yg(u).length&&u[u.length-1]===o}else{o="/";const u=n.path;c=u.length===1&&u.charCodeAt(u.length-1)===v.CharCode.Slash}return!c&&!(0,e.$kh)(n,o)?n.with({path:n.path+"/"}):n}}e.$6g=R,e.$7g=new R(()=>!1),e.$8g=new R(d=>d.scheme===P.Schemas.file?!A.$l:!0),e.$9g=new R(d=>!0),e.$0g=e.$7g.isEqual.bind(e.$7g),e.$$g=e.$7g.isEqualOrParent.bind(e.$7g),e.$_g=e.$7g.getComparisonKey.bind(e.$7g),e.$ah=e.$7g.basenameOrAuthority.bind(e.$7g),e.$bh=e.$7g.basename.bind(e.$7g),e.$ch=e.$7g.extname.bind(e.$7g),e.$dh=e.$7g.dirname.bind(e.$7g),e.$eh=e.$7g.joinPath.bind(e.$7g),e.$fh=e.$7g.normalizePath.bind(e.$7g),e.$gh=e.$7g.relativePath.bind(e.$7g),e.$hh=e.$7g.resolvePath.bind(e.$7g),e.$ih=e.$7g.isAbsolutePath.bind(e.$7g),e.$jh=e.$7g.isEqualAuthority.bind(e.$7g),e.$kh=e.$7g.hasTrailingPathSeparator.bind(e.$7g),e.$lh=e.$7g.removeTrailingPathSeparator.bind(e.$7g),e.$mh=e.$7g.addTrailingPathSeparator.bind(e.$7g);function y(d,n){const o=[];for(let c=0;c<d.length;c++){const u=n(d[c]);d.some((i,r)=>r===c?!1:(0,e.$$g)(u,n(i)))||o.push(d[c])}return o}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,g]=r.split(":");t&&g&&c.set(t,g)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=n})(a||(e.DataUri=a={}));function S(d,n,o){if(n){let c=d.path;return c&&c[0]!==O.$fc.sep&&(c=O.$fc.sep+c),d.with({scheme:o,authority:n,path:c})}return d.with({scheme:o})}}),define(Oe[10],Ne([1,0,21,13,6,4,23,20,148,48]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$5h=e.$4h=e.$3h=e.$2h=e.Promises=e.$1h=e.$Zh=e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0,e.$ph=R,e.$qh=y,e.$rh=a,e.$sh=S,e.$th=d,e.$uh=n,e.$vh=o,e.$wh=c,e.$Eh=E,e.$Fh=D,e.$Gh=b,e.$Hh=k,e.$Ih=C,e.$Xh=ge,e.$6h=ce;function R(he){return!!he&&typeof he.then=="function"}function y(he){const X=new v.$ve,x=he(X.token),me=new Promise((pe,Ae)=>{const Ue=X.token.onCancellationRequested(()=>{Ue.dispose(),Ae(new I.$4)});Promise.resolve(x).then(Se=>{Ue.dispose(),X.dispose(),pe(Se)},Se=>{Ue.dispose(),X.dispose(),Ae(Se)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Ae){return me.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function a(he,X,x){return new Promise((me,pe)=>{const Ae=X.onCancellationRequested(()=>{Ae.dispose(),me(x)});he.then(me,pe).finally(()=>Ae.dispose())})}function S(he,X){return new Promise((x,me)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),me(new I.$4)});he.then(x,me).finally(()=>pe.dispose())})}async function d(he){let X=-1;const x=he.map((me,pe)=>me.then(Ae=>(X=pe,Ae)));try{return await Promise.race(x)}finally{he.forEach((me,pe)=>{pe!==X&&me.cancel()})}}function n(he,X,x){let me;const pe=setTimeout(()=>{me?.(void 0),x?.()},X);return Promise.race([he.finally(()=>clearTimeout(pe)),new Promise(Ae=>me=Ae)])}function o(he){return new Promise((X,x)=>{const me=he();R(me)?me.then(X,x):X(me)})}function c(){let he,X;return{promise:new Promise((me,pe)=>{he=me,X=pe}),resolve:he,reject:X}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=X(),new Promise((x,me)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$xh=u;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$yh=i;class r{constructor(){this.a=new Map}queue(X,x){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$zh=r;const t=(he,X)=>{let x=!0;const me=setTimeout(()=>{x=!1,X()},he);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},g=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class l{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$fe?g(me):t(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new I.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ah=l;class m{constructor(X){this.a=new l(X),this.b=new u}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Bh=m;class p{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Ch=p;class h extends p{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Dh=h;function E(he,X){return X?new Promise((x,me)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},he),Ae=X.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),me(new I.$4)})}):y(x=>E(he,x))}function D(he,X=0,x){const me=setTimeout(()=>{he(),x&&pe.dispose()},X),pe=(0,O.$Rc)(()=>{clearTimeout(me),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function b(he){const X=[];let x=0;const me=he.length;function pe(){return x<me?he[x++]():null}function Ae(Ue){Ue!=null&&X.push(Ue);const Se=pe();return Se?Se.then(Ae):Promise.resolve(X)}return Promise.resolve(null).then(Ae)}function k(he,X=me=>!!me,x=null){let me=0;const pe=he.length,Ae=()=>{if(me>=pe)return Promise.resolve(x);const Ue=he[me++];return Promise.resolve(Ue()).then(Pe=>X(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function C(he,X=me=>!!me,x=null){if(he.length===0)return Promise.resolve(x);let me=he.length;const pe=()=>{me=-1;for(const Ae of he)Ae.cancel?.()};return new Promise((Ae,Ue)=>{for(const Se of he)Se.then(Pe=>{--me>=0&&X(Pe)?(pe(),Ae(Pe)):me===0&&Ae(x)}).catch(Pe=>{--me>=0&&(pe(),Ue(Pe))})})}class f{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$ke}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:X,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Jh=f;class w extends f{constructor(){super(1)}}e.$Kh=w;class F{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Lh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new oe;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=A.$7g){const me=x.getComparisonKey(X);return this.a.get(me)?.size??0}queueFor(X,x,me=A.$7g){const pe=me.getComparisonKey(X);let Ae=this.a.get(pe);if(!Ae){Ae=new w;const Ue=this.f++,Se=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(Ue,Se),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Mh=N;class L{constructor(X,x){this.b=!1,this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){if(this.b)throw new I.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){if(this.b)throw new I.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$Nh=L;class W{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,me=globalThis){if(this.f)throw new I.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{X()},x);this.d=(0,O.$Rc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Oh=W;class J{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ph=J;class M{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Qh=M;class K extends J{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Rh=K;class Z extends O.$Tc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Sh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Uh=(he,X)=>{(0,T.$C)(()=>{if(x)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Uh=(he,X,x)=>{const me=he.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,he.cancelIdleCallback(me))}}},e.$Th=he=>(0,e.$Uh)(globalThis,he)}();class ue{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Uh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Vh=ue;class _ extends ue{constructor(X){super(globalThis,X)}}e.$Wh=_;async function ge(he,X,x){let me;for(let pe=0;pe<x;pe++)try{return await he()}catch(Ae){me=Ae,await E(X)}throw me}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,me){return this.a={taskId:X,cancel:()=>me?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:me,reject:pe}=c();this.b={run:X,promise:x,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yh=se;class ae{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Zh=ae;var $e;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})($e||($e={}));class oe{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:$e.Resolved,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:$e.Rejected,value:X},x()})}cancel(){return this.error(new I.$4)}}e.$1h=oe;var ke;(function(he){async function X(me){let pe;const Ae=await Promise.all(me.map(Ue=>Ue.then(Se=>Se,Se=>{pe||(pe=Se)})));if(typeof pe<"u")throw pe;return Ae}he.settled=X;function x(me){return new Promise(async(pe,Ae)=>{try{await me(pe,Ae)}catch(Ue){Ae(Ue)}})}he.withAsyncBody=x})(ke||(e.Promises=ke={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new I.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$2h=Le;class Y{constructor(X){this.b=X,this.a=new s.$T(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$3h=Y;var q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(q||(q={}));class te{static fromArray(X){return new te(x=>{x.emitMany(X)})}static fromPromise(X){return new te(async x=>{x.emitMany(await X)})}static fromPromises(X){return new te(async x=>{await Promise.all(X.map(async me=>x.emitOne(await me)))})}static merge(X){return new te(async x=>{await Promise.all(X.map(async me=>{for await(const pe of me)x.emitOne(pe)}))})}static{this.EMPTY=te.fromArray([])}constructor(X,x){this.a=q.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$ke,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,x){return new te(async me=>{for await(const pe of X)me.emitOne(x(pe))})}map(X){return te.map(this,X)}static filter(X,x){return new te(async me=>{for await(const pe of X)x(pe)&&me.emitOne(pe)})}filter(X){return te.filter(this,X)}static coalesce(X){return te.filter(X,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(X){const x=[];for await(const me of X)x.push(me);return x}toPromise(){return te.toPromise(this)}h(X){this.a===q.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===q.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(X){this.a===q.Initial&&(this.a=q.DoneError,this.d=X,this.g.fire())}}e.$4h=te;class ve extends te{constructor(X,x){super(x),this.m=X}cancel(){this.m.cancel()}}e.$5h=ve;function ce(he){const X=new v.$ve,x=he(X.token);return new ve(X,async me=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),me.reject(new I.$4)});try{for await(const Ae of x){if(X.token.isCancellationRequested)return;me.emitOne(Ae)}pe.dispose(),X.dispose()}catch(Ae){pe.dispose(),X.dispose(),me.reject(Ae)}})}class we{constructor(X){this.a=new oe,this.b=new te(pe=>{if(x){pe.reject(x);return}return me&&pe.emitMany(me),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},X);let x,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$7h=we}),define(Oe[41],Ne([1,0,17,10,27,51,28,19,20,12]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=R,e.$wk=n,e.$xk=F,e.$yk=N,e.$zk=L,e.$Ak=W,e.$Bk=J,e.$Ck=ue;function R(){return Object.create(null)}e.$uk="**",e.$vk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(_,ge){switch(_){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${ge?`|${y}${a}+`:""})*?`}}function n(_,ge){if(!_)return[];const se=[];let ae=!1,$e=!1,oe="";for(const ke of _){switch(ke){case ge:if(!ae&&!$e){se.push(oe),oe="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}oe+=ke}return oe&&se.push(oe),se}function o(_){if(!_)return"";let ge="";const se=n(_,e.$vk);if(se.every(ae=>ae===e.$uk))ge=".*";else{let ae=!1;se.forEach(($e,oe)=>{if($e===e.$uk){if(ae)return;ge+=d(2,oe===se.length-1)}else{let ke=!1,Le="",Y=!1,q="";for(const te of $e){if(te!=="}"&&ke){Le+=te;continue}if(Y&&(te!=="]"||!q)){let ve;te==="-"?ve=te:(te==="^"||te==="!")&&!q?ve="^":te===e.$vk?ve="":ve=(0,s.$gf)(te),q+=ve;continue}switch(te){case"{":ke=!0;continue;case"[":Y=!0;continue;case"}":{const ce=`(?:${n(Le,",").map(we=>o(we)).join("|")})`;ge+=ce,ke=!1,Le="";break}case"]":{ge+="["+q+"]",Y=!1,q="";break}case"?":ge+=a;continue;case"*":ge+=d(1);continue;default:ge+=(0,s.$gf)(te)}}oe<se.length-1&&(se[oe+1]!==e.$uk||oe+2<se.length)&&(ge+=y)}ae=$e===e.$uk})}return ge}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new A.$Cc(1e4),m=function(){return!1},p=function(){return null};function h(_,ge){if(!_)return p;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ae=`${se}_${!!ge.trimForExclusions}`;let $e=l.get(ae);if($e)return E($e,_);let oe;return c.test(se)?$e=b(se.substr(4),se):(oe=u.exec(D(se,ge)))?$e=k(oe[1],se):(ge.trimForExclusions?r:i).test(se)?$e=C(se,ge):(oe=t.exec(D(se,ge)))?$e=f(oe[1].substr(1),se,!0):(oe=g.exec(D(se,ge)))?$e=f(oe[1],se,!1):$e=w(se),l.set(ae,$e),E($e,_)}function E(_,ge){if(typeof ge=="string")return _;const se=function(ae,$e){return(0,O.$Cg)(ae,ge.base,!$.$l)?_((0,s.$lf)(ae.substr(ge.base.length),T.sep),$e):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function D(_,ge){return ge.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function b(_,ge){return function(se,ae){return typeof se=="string"&&se.endsWith(_)?ge:null}}function k(_,ge){const se=`/${_}`,ae=`\\${_}`,$e=function(ke,Le){return typeof ke!="string"?null:Le?Le===_?ge:null:ke===_||ke.endsWith(se)||ke.endsWith(ae)?ge:null},oe=[_];return $e.basenames=oe,$e.patterns=[ge],$e.allBasenames=oe,$e}function C(_,ge){const se=Z(_.slice(1,-1).split(",").map(Le=>h(Le,ge)).filter(Le=>Le!==p),_),ae=se.length;if(!ae)return p;if(ae===1)return se[0];const $e=function(Le,Y){for(let q=0,te=se.length;q<te;q++)if(se[q](Le,Y))return _;return null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const ke=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return ke.length&&($e.allPaths=ke),$e}function f(_,ge,se){const ae=T.sep===T.$fc.sep,$e=ae?_:_.replace(S,T.sep),oe=T.sep+$e,ke=T.$fc.sep+_;let Le;return se?Le=function(Y,q){return typeof Y=="string"&&(Y===$e||Y.endsWith(oe)||!ae&&(Y===_||Y.endsWith(ke)))?ge:null}:Le=function(Y,q){return typeof Y=="string"&&(Y===$e||!ae&&Y===_)?ge:null},Le.allPaths=[(se?"*/":"./")+_],Le}function w(_){try{const ge=new RegExp(`^${o(_)}$`);return function(se){return ge.lastIndex=0,typeof se=="string"&&ge.test(se)?_:null}}catch{return p}}function F(_,ge,se){return!_||typeof ge!="string"?!1:N(_)(ge,void 0,se)}function N(_,ge={}){if(!_)return m;if(typeof _=="string"||L(_)){const se=h(_,ge);if(se===p)return m;const ae=function($e,oe){return!!se($e,oe)};return se.allBasenames&&(ae.allBasenames=se.allBasenames),se.allPaths&&(ae.allPaths=se.allPaths),ae}return M(_,ge)}function L(_){const ge=_;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}function W(_){return _.allBasenames||[]}function J(_){return _.allPaths||[]}function M(_,ge){const se=Z(Object.getOwnPropertyNames(_).map(Le=>K(Le,_[Le],ge)).filter(Le=>Le!==p)),ae=se.length;if(!ae)return p;if(!se.some(Le=>!!Le.requiresSiblings)){if(ae===1)return se[0];const Le=function(te,ve){let ce;for(let we=0,he=se.length;we<he;we++){const X=se[we](te,ve);if(typeof X=="string")return X;(0,I.$ph)(X)&&(ce||(ce=[]),ce.push(X))}return ce?(async()=>{for(const we of ce){const he=await we;if(typeof he=="string")return he}return null})():null},Y=se.find(te=>!!te.allBasenames);Y&&(Le.allBasenames=Y.allBasenames);const q=se.reduce((te,ve)=>ve.allPaths?te.concat(ve.allPaths):te,[]);return q.length&&(Le.allPaths=q),Le}const $e=function(Le,Y,q){let te,ve;for(let ce=0,we=se.length;ce<we;ce++){const he=se[ce];he.requiresSiblings&&q&&(Y||(Y=(0,T.$mc)(Le)),te||(te=Y.substr(0,Y.length-(0,T.$nc)(Le).length)));const X=he(Le,Y,te,q);if(typeof X=="string")return X;(0,I.$ph)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ce of ve){const we=await ce;if(typeof we=="string")return we}return null})():null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const ke=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return ke.length&&($e.allPaths=ke),$e}function K(_,ge,se){if(ge===!1)return p;const ae=h(_,se);if(ae===p)return p;if(typeof ge=="boolean")return ae;if(ge){const $e=ge.when;if(typeof $e=="string"){const oe=(ke,Le,Y,q)=>{if(!q||!ae(ke,Le))return null;const te=$e.replace("$(basename)",()=>Y),ve=q(te);return(0,I.$ph)(ve)?ve.then(ce=>ce?_:null):ve?_:null};return oe.requiresSiblings=!0,oe}}return ae}function Z(_,ge){const se=_.filter(Le=>!!Le.basenames);if(se.length<2)return _;const ae=se.reduce((Le,Y)=>{const q=Y.basenames;return q?Le.concat(q):Le},[]);let $e;if(ge){$e=[];for(let Le=0,Y=ae.length;Le<Y;Le++)$e.push(ge)}else $e=se.reduce((Le,Y)=>{const q=Y.patterns;return q?Le.concat(q):Le},[]);const oe=function(Le,Y){if(typeof Le!="string")return null;if(!Y){let te;for(te=Le.length;te>0;te--){const ve=Le.charCodeAt(te-1);if(ve===P.CharCode.Slash||ve===P.CharCode.Backslash)break}Y=Le.substr(te)}const q=ae.indexOf(Y);return q!==-1?$e[q]:null};oe.basenames=ae,oe.patterns=$e,oe.allBasenames=ae;const ke=_.filter(Le=>!Le.basenames);return ke.push(oe),ke}function ue(_,ge){return(0,v.$tb)(_,ge,(se,ae)=>typeof se=="string"&&typeof ae=="string"?se===ae:typeof se!="string"&&typeof ae!="string"?se.base===ae.base&&se.pattern===ae.pattern:!1)}}),define(Oe[59],Ne([1,0,13,98,23,12,2]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.MarkdownStringTextNewlineStyle=void 0,e.$3k=s,e.$4k=R,e.$5k=y,e.$6k=a,e.$7k=S,e.$8k=d,e.$9k=n,e.$0k=o;var T;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(u="",i=!1){if(this.value=u,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(u,i=T.Paragraph){return this.value+=a(this.supportThemeIcons?(0,I.$Vk)(u):u).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,i){return this.value+=`
${S(i,u)}
`,this}appendLink(u,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(u),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(u,i){const r=new RegExp((0,O.$gf)(i),"g");return u.replace(r,(t,g)=>u.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$2k=$;function s(c){return R(c)?!c.value:Array.isArray(c)?c.every(s):!0}function R(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons&&c.supportHtml===u.supportHtml&&(c.baseUri===u.baseUri||!!c.baseUri&&!!u.baseUri&&(0,P.$0g)(A.URI.from(c.baseUri),A.URI.from(u.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,u){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${u}`,c,`${"`".repeat(r)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const u=[],i=c.split("|").map(t=>t.trim());c=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),g=/width=(\d+)/.exec(r),l=t?t[1]:"",m=g?g[1]:"",p=isFinite(parseInt(m)),h=isFinite(parseInt(l));p&&u.push(`width="${m}"`),h&&u.push(`height="${l}"`)}return{href:c,dimensions:u}}}),define(Oe[99],Ne([1,0,17,51,19,20,23,12]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=$,e.$Yw=R,e.$Zw=a,e.$1w=S,e.$2w=c,e.$3w=i,e.$4w=r,e.$5w=t,e.$6w=g,e.$7w=l;function $(p,h){const{os:E,tildify:D,relative:b}=h;if(b){const f=s(p,b,E);if(typeof f=="string")return f}let k=p.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?k=k.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(k=k.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let w;p.scheme!==D.userHome.scheme&&p.path[0]===P.$fc.sep&&p.path[1]!==P.$fc.sep?w=D.userHome.with({path:p.path}).fsPath:w=k,k=a(w,f,E)}return(E===O.OperatingSystem.Windows?P.$ec:P.$fc).normalize(R(k,E===O.OperatingSystem.Windows))}function s(p,h,E){const D=E===O.OperatingSystem.Windows?P.$ec:P.$fc,b=E===O.OperatingSystem.Linux?A.$7g:A.$9g,k=h.getWorkspace(),C=(0,v.$Nb)(k.folders);if(!C)return;p.scheme!==C.uri.scheme&&p.path[0]===P.$fc.sep&&p.path[1]!==P.$fc.sep&&(p=C.uri.with({path:p.path}));const f=h.getWorkspaceFolder(p);if(!f)return;let w;if(b.isEqual(f.uri,p)?w="":w=b.relativePath(f.uri,p)??"",w&&(w=D.normalize(w)),k.folders.length>1&&!h.noPrefix){const F=f.name?f.name:b.basenameOrAuthority(f.uri);w=w?`${F} \u2022 ${w}`:F}return w}function R(p,h=O.$j){return(0,I.$Hg)(p,h)?p.charAt(0).toUpperCase()+p.slice(1):p}let y=Object.create(null);function a(p,h,E=O.OS){if(E===O.OperatingSystem.Windows||!p||!h)return p;let D=y.original===h?y.normalized:void 0;D||(D=h,O.$j&&(D=(0,I.$wg)(D)),D=`${(0,T.$mf)(D,P.$fc.sep)}${P.$fc.sep}`,y={original:h,normalized:D});let b=p;return O.$j&&(b=(0,I.$wg)(b)),(E===O.OperatingSystem.Linux?b.startsWith(D):(0,T.$Ff)(b,D))?`~/${b.substr(D.length)}`:p}function S(p,h){return p.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",n="\\\\",o="~";function c(p,h=P.sep){const E=new Array(p.length);let D=!1;for(let b=0;b<p.length;b++){const k=p[b];if(k===""){E[b]=`.${h}`;continue}if(!k){E[b]=k;continue}D=!0;let C="",f=k;f.indexOf(n)===0?(C=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf(h)===0?(C=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(o)===0&&(C=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length));const w=f.split(h);for(let F=1;D&&F<=w.length;F++)for(let N=w.length-F;D&&N>=0;N--){D=!1;let L=w.slice(N,N+F).join(h);for(let W=0;!D&&W<p.length;W++)if(W!==b&&p[W]&&p[W].indexOf(L)>-1){const J=N+F===w.length,M=N>0&&p[W].indexOf(h)>-1?h+L:L,K=p[W].endsWith(M);D=!J||K}if(!D){let W="";(w[0].endsWith(":")||C!=="")&&(N===1&&(N=0,F++,L=w[0]+h+L),N>0&&(W=w[0]+h),W=C+W),N>0&&(W=W+d+h),W=W+L,N+F<w.length&&(W=W+h+d),E[b]=W}}D&&(E[b]=k)}return E}var u;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function i(p,h=Object.create(null)){const E=[];let D=!1,b="";for(const k of p)if(k==="$"||D&&k==="{")b&&E.push({value:b,type:u.TEXT}),b="",D=!0;else if(k==="}"&&D){const C=h[b];if(typeof C=="string")C.length&&E.push({value:C,type:u.VARIABLE});else if(C){const f=E[E.length-1];(!f||f.type!==u.SEPARATOR)&&E.push({value:C.label,type:u.SEPARATOR})}b="",D=!1}else b+=k;return b&&!D&&E.push({value:b,type:u.TEXT}),E.filter((k,C)=>{if(k.type===u.SEPARATOR){const f=E[C-1],w=E[C+1];return[f,w].every(F=>F&&(F.type===u.VARIABLE||F.type===u.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function r(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):p.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,""):O.$j?p.replace(/&&|&/g,E=>E==="&"?"&&":"&"):p.replace(/&&/g,"_")}function g(p){return p.replace(/&/g,"&&")}function l(p){if(p.endsWith("]")){const h=p.lastIndexOf(" [",p.length-2);if(h!==-1){const E=m(p.substring(0,h)),D=p.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return m(p)}function m(p){const h=p.indexOf("/")!==-1?P.$fc:P.$ec,E=h.basename(p),D=h.dirname(p);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Oe[150],Ne([1,0,22,36,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=void 0,e.$Mn=$,e.$Nn=R,e.$On=y;function O(a){return a.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Kn=A,e.$Ln=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function T(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return S.transformOutgoing(a);for(const n in a)if(Object.hasOwnProperty.call(a,n)){const o=T(a[n],S,d+1);o!==null&&(a[n]=o)}}return null}function $(a,S){const d=T(a,S,0);return d===null?a:d}function s(a,S,d,n){if(!a||n>200)return null;if(typeof a=="object"){if(a.$mid===I.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Me)return null;for(const o in a)if(Object.hasOwnProperty.call(a,o)){const c=s(a[o],S,d,n+1);c!==null&&(a[o]=c)}}return null}function R(a,S){const d=s(a,S,!1,0);return d===null?a:d}function y(a,S){const d=s(a,S,!0,0);return d===null?a:d}}),define(Oe[37],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=I;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(P){return v.test(P)}e.$Zg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,s="";return s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s+="-",s+=A[O[$++]],s+=A[O[$++]],s+="-",s+=A[O[$++]],s+=A[O[$++]],s+="-",s+=A[O[$++]],s+=A[O[$++]],s+="-",s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s+=A[O[$++]],s}}()}),define(Oe[151],Ne([1,0,17,39,37]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=void 0,e.$nu=O,e.$ou=A,e.$qu=s;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,a,S){const d={id:(0,P.$Zg)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return I.Iterable.some(this,([d,n])=>n.asFile())&&S.push("files"),R($(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return $(a)}}e.$pu=T;function $(y){return y.toLowerCase()}function s(y,a){return R($(y),a.map($))}function R(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,n,o]=S;return o==="*"?a.some(c=>c.startsWith(n+"/")):!1}e.$ru=Object.freeze({create:y=>(0,v.$Lb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$ru.split(y).filter(a=>!a.startsWith("#"))})}),define(Oe[152],Ne([1,0,10,6,4,40,14]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=$;var T;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var s;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(s||(e.StorageState=s={}));class R extends P.$Tc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new I.$ne),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Bh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,n)=>this.w(n,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===s.Closed)return;let n=!1;(0,A.$mg)(d)?n=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),n=!0),n&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const n=this.f.get(S);return(0,A.$mg)(n)?d:n}getBoolean(S,d){const n=this.get(S);return(0,A.$mg)(n)?d:n==="true"}getNumber(S,d){const n=this.get(S);return(0,A.$mg)(n)?d:parseInt(n,10)}getObject(S,d){const n=this.get(S);return(0,A.$mg)(n)?d:(0,O.$_h)(n)}async set(S,d,n=!1){if(this.c===s.Closed)return;if((0,A.$mg)(d))return this.delete(S,n);const o=(0,A.$fg)(d)||Array.isArray(d)?(0,O.$$h)(d):String(d);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:n}),this.D()}async delete(S,d=!1){if(!(this.c===s.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===s.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$cq=R;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,n)=>this.a.set(n,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$dq=y}),define(Oe[153],Ne([1,0,27]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$xu=P;var I;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function P(O){let A=0,T=0,$=0,s=I.Unknown;for(let R=0,y=O.length;R<y;R++){const a=O.charCodeAt(R);a===v.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&O.charCodeAt(R+1)===v.CharCode.LineFeed?(s|=I.CRLF,R++):s|=I.Invalid,$=R+1):a===v.CharCode.LineFeed&&(s|=I.LF,A===0&&(T=R),A++,$=R+1)}return A===0&&(T=O.length),[A,T,O.length-$,s]}}),define(Oe[154],Ne([1,0,12,20,22]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$au=R,e.$bu=y,v=We(v),I=We(I),P=We(P);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let s;function R(){return s||(s=I.$E()?A():$()),s}function y(d,n,o){const c=new Uint16Array(d.buffer,n,o);return o>0&&(c[0]===65279||c[0]===65534)?a(d,n,o):A().decode(c)}function a(d,n,o){const c=[];let u=0;for(let i=0;i<o;i++){const r=P.$Oe(d,n);n+=2,c[u++]=String.fromCharCode(r)}return c.join("")}class S{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||v.$If(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let c=0;c<o;c++)this.b[this.d++]=n.charCodeAt(c)}}e.$cu=S}),define(Oe[155],Ne([1,0,22,154]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$eu=A,v=We(v);function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,R,y,a){this.oldPosition=s,this.oldText=R,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,R,y){const a=R.length;v.$Re(s,a,y),y+=4;for(let S=0;S<a;S++)v.$Pe(s,R.charCodeAt(S),y),y+=2;return y}static d(s,R){const y=v.$Qe(s,R);return R+=4,(0,I.$bu)(s,R,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(s,R){return v.$Re(s,this.oldPosition,R),R+=4,v.$Re(s,this.newPosition,R),R+=4,R=O.c(s,this.oldText,R),R=O.c(s,this.newText,R),R}static read(s,R,y){const a=v.$Qe(s,R);R+=4;const S=v.$Qe(s,R);R+=4;const d=O.d(s,R);R+=O.a(d);const n=O.d(s,R);return R+=O.a(n),y.push(new O(a,d,S,n)),R}}e.$du=O;function A($,s){return $===null||$.length===0?s:new T($,s).compress()}class T{constructor(s,R){this.a=s,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,R=0,y=this.n(s),a=this.l(R);for(;s<this.f||R<this.h;){if(y===null){this.k(a),a=this.l(++R);continue}if(a===null){this.m(y),y=this.n(++s);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++R);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++s);continue}if(a.oldPosition<y.newPosition){const[c,u]=T.r(a,y.newPosition-a.oldPosition);this.k(c),a=u;continue}if(y.newPosition<a.oldPosition){const[c,u]=T.q(y,a.oldPosition-y.newPosition);this.m(c),y=u;continue}let n,o;if(a.oldEnd===y.newEnd)n=y,o=a,y=this.n(++s),a=this.l(++R);else if(a.oldEnd<y.newEnd){const[c,u]=T.q(y,a.oldLength);n=c,o=a,y=u,a=this.l(++R)}else{const[c,u]=T.r(a,y.newLength);n=y,o=c,y=this.n(++s),a=u}this.d[this.e++]=new O(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const S=T.s(this.d);return T.t(S)}k(s){this.d[this.e++]=T.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=T.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,R){return new O(R.oldPosition-s,R.oldText,R.newPosition,R.newText)}static p(s,R){return new O(R.oldPosition,R.oldText,R.newPosition+s,R.newText)}static q(s,R){const y=s.newText.substr(0,R),a=s.newText.substr(R);return[new O(s.oldPosition,s.oldText,s.newPosition,y),new O(s.oldEnd,"",s.newPosition+R,a)]}static r(s,R){const y=s.oldText.substr(0,R),a=s.oldText.substr(R);return[new O(s.oldPosition,y,s.newPosition,s.newText),new O(s.oldPosition+R,a,s.newEnd,"")]}static s(s){if(s.length===0)return s;const R=[];let y=0,a=s[0];for(let S=1;S<s.length;S++){const d=s[S];a.oldEnd===d.oldPosition?a=new O(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(R[y++]=a,a=d)}return R[y++]=a,R}static t(s){if(s.length===0)return s;const R=[];let y=0;for(let a=0;a<s.length;a++){const S=s[a];S.oldText!==S.newText&&(R[y++]=S)}return R}}}),define(Oe[156],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0,e.$jt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[157],Ne([1,0,41,19]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=P,e.$vu=O;function P(A,T,$,s,R,y){if(Array.isArray(A)){let a=0;for(const S of A){const d=P(S,T,$,s,R,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof A=="string")return s?A==="*"?5:A===$?10:0:0;if(A){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:n,notebookType:o}=A;if(!s&&!n)return 0;o&&R&&(T=R);let c=0;if(d)if(d===T.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===$)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(o)if(o===y)c=10;else if(o==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let u;if(typeof S=="string"?u=S:u={...S,base:(0,I.$gc)(S.base)},u===T.fsPath||(0,v.$xk)(u,T.fsPath))c=10;else return 0}return c}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Oe[158],Ne([1,0,27,159]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let R=0,y=s.notIn.length;R<y;R++)switch(s.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case I.StandardTokenType.Other:return!0;case I.StandardTokenType.Comment:return this.c;case I.StandardTokenType.String:return this.b;case I.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,R){if(s.getTokenCount()===0)return!0;const y=s.findTokenIndexAtOffset(R-2),a=s.getStandardTokenType(y);return this.isOK(a)}g(s,R){for(let y=s;y<=R;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Uu=O;class A{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of s)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Vu=A;function T($,s,R){$.has(s)?$.get(s).push(R):$.set(s,[R])}}),define(Oe[160],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.NodeColor=e.$$C=void 0,e.$aD=P,e.$bD=O,e.$cD=s,e.$dD=R,e.$eD=y,e.$fD=a,e.$gD=S,e.$hD=d;class v{constructor(o,c){this.piece=o,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$_C)return P(this.right);let o=this;for(;o.parent!==e.$_C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$_C?e.$_C:o.parent}prev(){if(this.left!==e.$_C)return O(this.left);let o=this;for(;o.parent!==e.$_C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$_C?e.$_C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$$C=v;var I;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(I||(e.NodeColor=I={})),e.$_C=new v(null,I.Black),e.$_C.parent=e.$_C,e.$_C.left=e.$_C,e.$_C.right=e.$_C,e.$_C.color=I.Black;function P(n){for(;n.left!==e.$_C;)n=n.left;return n}function O(n){for(;n.right!==e.$_C;)n=n.right;return n}function A(n){return n===e.$_C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$_C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function $(){e.$_C.parent=e.$_C}function s(n,o){const c=o.right;c.size_left+=o.size_left+(o.piece?o.piece.length:0),c.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=c.left,c.left!==e.$_C&&(c.left.parent=o),c.parent=o.parent,o.parent===e.$_C?n.root=c:o.parent.left===o?o.parent.left=c:o.parent.right=c,c.left=o,o.parent=c}function R(n,o){const c=o.left;o.left=c.right,c.right!==e.$_C&&(c.right.parent=o),c.parent=o.parent,o.size_left-=c.size_left+(c.piece?c.piece.length:0),o.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),o.parent===e.$_C?n.root=c:o===o.parent.right?o.parent.right=c:o.parent.left=c,c.right=o,o.parent=c}function y(n,o){let c,u;if(o.left===e.$_C?(u=o,c=u.right):o.right===e.$_C?(u=o,c=u.left):(u=P(o.right),c=u.right),u===n.root){n.root=c,c.color=I.Black,o.detach(),$(),n.root.parent=e.$_C;return}const i=u.color===I.Red;if(u===u.parent.left?u.parent.left=c:u.parent.right=c,u===o?(c.parent=u.parent,d(n,c)):(u.parent===o?c.parent=u:c.parent=u.parent,d(n,c),u.left=o.left,u.right=o.right,u.parent=o.parent,u.color=o.color,o===n.root?n.root=u:o===o.parent.left?o.parent.left=u:o.parent.right=u,u.left!==e.$_C&&(u.left.parent=u),u.right!==e.$_C&&(u.right.parent=u),u.size_left=o.size_left,u.lf_left=o.lf_left,d(n,u)),o.detach(),c.parent.left===c){const t=A(c),g=T(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const l=t-c.parent.size_left,m=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(n,c.parent,l,m)}}if(d(n,c.parent),i){$();return}let r;for(;c!==n.root&&c.color===I.Black;)c===c.parent.left?(r=c.parent.right,r.color===I.Red&&(r.color=I.Black,c.parent.color=I.Red,s(n,c.parent),r=c.parent.right),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,c=c.parent):(r.right.color===I.Black&&(r.left.color=I.Black,r.color=I.Red,R(n,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=I.Black,r.right.color=I.Black,s(n,c.parent),c=n.root)):(r=c.parent.left,r.color===I.Red&&(r.color=I.Black,c.parent.color=I.Red,R(n,c.parent),r=c.parent.left),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,c=c.parent):(r.left.color===I.Black&&(r.right.color=I.Black,r.color=I.Red,s(n,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=I.Black,r.left.color=I.Black,R(n,c.parent),c=n.root));c.color=I.Black,$()}function a(n,o){for(d(n,o);o!==n.root&&o.parent.color===I.Red;)if(o.parent===o.parent.parent.left){const c=o.parent.parent.right;c.color===I.Red?(o.parent.color=I.Black,c.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,s(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,R(n,o.parent.parent))}else{const c=o.parent.parent.left;c.color===I.Red?(o.parent.color=I.Black,c.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,s(n,o.parent.parent))}n.root.color=I.Black}function S(n,o,c,u){for(;o!==n.root&&o!==e.$_C;)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=u),o=o.parent}function d(n,o){let c=0,u=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,c=A(o.left)-o.size_left,u=T(o.left)-o.lf_left,o.size_left+=c,o.lf_left+=u;o!==n.root&&(c!==0||u!==0);)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=u),o=o.parent}}}),define(Oe[100],Ne([1,0,27,101,32,52,160,102]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=e.$rD=e.$qD=void 0,e.$oD=y,e.$pD=a;const $=65535;function s(u){let i;return u[u.length-1]<65536?i=new Uint16Array(u.length):i=new Uint32Array(u.length),i.set(u,0),i}class R{constructor(i,r,t,g,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=g,this.isBasicASCII=l}}function y(u,i=!0){const r=[0];let t=1;for(let g=0,l=u.length;g<l;g++){const m=u.charCodeAt(g);m===v.CharCode.CarriageReturn?g+1<l&&u.charCodeAt(g+1)===v.CharCode.LineFeed?(r[t++]=g+2,g++):r[t++]=g+1:m===v.CharCode.LineFeed&&(r[t++]=g+1)}return i?s(r):r}function a(u,i){u.length=0,u[0]=0;let r=1,t=0,g=0,l=0,m=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(l++,u[r++]=h+2,h++):(t++,u[r++]=h+1):D===v.CharCode.LineFeed?(g++,u[r++]=h+1):m&&D!==v.CharCode.Tab&&(D<32||D>126)&&(m=!1)}const p=new R(s(u),t,g,l,m);return u.length=0,p}class S{constructor(i,r,t,g,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=g,this.length=l}}e.$qD=S;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$rD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$_C&&i.iterate(i.root,t=>(t!==A.$_C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let g=0;g<t.length;g++){const l=t[g];if(l.node.parent===null||l.nodeStartOffset>=i){t[g]=null,r=!0;continue}}if(r){const g=[];for(const l of t)l!==null&&g.push(l);this.b=g}}}class c{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$_C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let g=null;for(let l=0,m=i.length;l<m;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=y(i[l].buffer));const p=new S(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),g=this.S(g,p)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=$,t=r-Math.floor(r/3),g=t*2;let l="",m=0;const p=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if(m<=t||m+D<g)return l+=E,m+=D,!0;const b=l.replace(/\r\n|\r|\n/g,i);return p.push(new d(b,y(b))),l=E,m=D,!0}),m>0){const h=l.replace(/\r\n|\r|\n/g,i);p.push(new d(h,y(h)))}this.create(p,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,g=>{if(g===A.$_C)return!0;const l=this.R(g),m=l.length,p=i.G(r),h=i.G(r+m),E=i.getValueInRange2(p,h);return r+=m,l===E})}getOffsetAt(i,r){let t=0,g=this.root;for(;g!==A.$_C;)if(g.left!==A.$_C&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const l=this.B(g,i-g.lf_left-2);return t+=l+r-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const g=i;for(;r!==A.$_C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const m=this.getOffsetAt(t+1,1),p=g-m;return new I.$Lt(t+1,p+1)}return new I.$Lt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$_C){const l=this.getOffsetAt(t+1,1),m=g-i-l;return new I.$Lt(t+1,m+1)}else r=r.right;return new I.$Lt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,g);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const p=i.node,h=this.a[p.piece.bufferIndex].buffer,E=this.u(p.piece.bufferIndex,p.piece.start);return h.substring(E+i.remainder,E+r.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let m=g.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==A.$_C;){const p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){m+=p.substring(h,h+r.remainder);break}else m+=p.substr(h,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let r=0,t="",g=!1;return this.iterate(this.root,l=>{if(l===A.$_C)return!0;const m=l.piece;let p=m.length;if(p===0)return!0;const h=this.a[m.bufferIndex].buffer,E=this.a[m.bufferIndex].lineStarts,D=m.start.line,b=m.end.line;let k=E[D]+m.start.column;if(g&&(h.charCodeAt(k)===v.CharCode.LineFeed&&(k++,p--),i[r++]=t,t="",g=!1,p===0))return!0;if(D===b)return!this.f&&h.charCodeAt(k+p-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(k,p-1)):t+=h.substr(k,p),!0;t+=this.f?h.substring(k,Math.max(k,E[D+1]-this.e)):h.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let C=D+1;C<b;C++)t=this.f?h.substring(E[C],E[C+1]-this.e):h.substring(E[C],E[C+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&h.charCodeAt(E[b]+m.end.column-1)===v.CharCode.CarriageReturn?(g=!0,m.end.column===0?r--:t=h.substr(E[b],m.end.column-1)):t=h.substr(E[b],m.end.column),!0}),g&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(g)}else{const r=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(g)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$_C)return"";const g=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],g=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=g+r.remainder,m=g+r.node.piece.length;return t.buffer.substring(l,m)}}findMatchesInNode(i,r,t,g,l,m,p,h,E,D,b){const k=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,l),w=this.u(i.piece.bufferIndex,m);let F;const N={line:0,column:0};let L,W;r._wordSeparators?(L=k.buffer.substring(f,w),W=J=>J+f,r.reset(0)):(L=k.buffer,W=J=>J,r.reset(f));do if(F=r.next(L),F){if(W(F.index)>=w)return D;this.s(i,W(F.index)-C,N);const J=this.t(i.piece.bufferIndex,l,N),M=N.line===l.line?N.column-l.column+g:N.column+1,K=M+F[0].length;if(b[D++]=(0,T.$kD)(new P.$Mt(t+J,M,t+J,K),F,h),W(F.index)+F[0].length>=w||D>=E)return D}while(F);return D}findMatchesLineByLine(i,r,t,g){const l=[];let m=0;const p=new T.$nD(r.wordSeparators,r.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const b=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,p,i.startLineNumber,i.startColumn,D,b,r,t,g,m,l),l;let k=i.startLineNumber,C=h.node;for(;C!==E.node;){const w=this.t(C.piece.bufferIndex,D,C.piece.end);if(w>=1){const N=this.a[C.piece.bufferIndex].lineStarts,L=this.u(C.piece.bufferIndex,C.piece.start),W=N[D.line+w],J=k===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(C,p,k,J,D,this.s(C,W-L),r,t,g,m,l),m>=g)return l;k+=w}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return m=this.n(r,p,N,i.endLineNumber,F,m,l,t,g),l}if(m=this.n(r,p,this.getLineContent(k).substr(F),k,F,m,l,t,g),m>=g)return l;k++,h=this.H(k,1),C=h.node,D=this.s(h.node,h.remainder)}if(k===i.endLineNumber){const w=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(w,i.endColumn-1);return m=this.n(r,p,F,i.endLineNumber,w,m,l,t,g),l}const f=k===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(E.node,p,k,f,D,b,r,t,g,m,l),l}n(i,r,t,g,l,m,p,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const k=i.simpleSearch,C=k.length,f=t.length;let w=-C;for(;(w=t.indexOf(k,w+C))!==-1;)if((!D||(0,T.$mD)(D,t,f,w,C))&&(p[m++]=new O.$cw(new P.$Mt(g,w+1+l,g,w+1+C+l),null),m>=E))return m;return m}let b;r.reset(0);do if(b=r.next(t),b&&(p[m++]=(0,T.$kD)(new P.$Mt(g,b.index+1+l,g,b.index+1+b[0].length+l),b,h),m>=E))return m;while(b);return m}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$_C){const{node:g,remainder:l,nodeStartOffset:m}=this.G(i),p=g.piece,h=p.bufferIndex,E=this.s(g,l);if(g.piece.bufferIndex===0&&p.end.line===this.g.line&&p.end.column===this.g.column&&m+p.length===i&&r.length<$){this.F(g,r),this.y();return}if(m===i)this.o(r,g),this.h.validate(i);else if(m+g.piece.length>i){const D=[];let b=new S(p.bufferIndex,E,p.end,this.t(p.bufferIndex,E,p.end),this.u(h,p.end)-this.u(h,E));if(this.K()&&this.M(r)&&this.I(g,l)===10){const w={line:b.start.line+1,column:0};b=new S(b.bufferIndex,w,b.end,this.t(b.bufferIndex,w,b.end),b.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(g,l-1)===13){const w=this.s(g,l-1);this.C(g,w),r="\r"+r,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const k=this.w(r);b.length>0&&this.S(g,b);let C=g;for(let f=0;f<k.length;f++)C=this.S(C,k[f]);this.v(D)}else this.q(r,g)}else{const g=this.w(r);let l=this.T(null,g[0]);for(let m=1;m<g.length;m++)l=this.S(l,g[m])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$_C)return;const t=this.G(i),g=this.G(i+r),l=t.node,m=g.node;if(l===m){const k=this.s(l,t.remainder),C=this.s(l,g.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const f=l.next();(0,A.$eD)(this,l),this.N(f),this.y();return}this.D(l,C),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,k),this.O(l),this.y();return}this.E(l,k,C),this.y();return}const p=[],h=this.s(l,t.remainder);this.C(l,h),this.h.validate(i),l.piece.length===0&&p.push(l);const E=this.s(m,g.remainder);this.D(m,E),m.piece.length===0&&p.push(m);const D=l.next();for(let k=D;k!==A.$_C&&k!==m;k=k.next())p.push(k);const b=l.piece.length===0?l.prev():l;this.v(p),this.O(b),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const m=r.piece,p={line:m.start.line+1,column:0},h=new S(m.bufferIndex,p,m.end,this.t(m.bufferIndex,p,m.end),m.length-1);r.piece=h,i+=`
`,(0,A.$gD)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const g=this.w(i);let l=this.T(r,g[g.length-1]);for(let m=g.length-2;m>=0;m--)l=this.T(l,g[m]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),g=this.S(r,t[0]);let l=g;for(let m=1;m<t.length;m++)l=this.S(l,t[m]);this.N(g)}s(i,r,t){const g=i.piece,l=i.piece.bufferIndex,m=this.a[l].lineStarts,h=m[g.start.line]+g.start.column+r;let E=g.start.line,D=g.end.line,b=0,k=0,C=0;for(;E<=D&&(b=E+(D-E)/2|0,C=m[b],b!==D);)if(k=m[b+1],h<C)D=b-1;else if(h>=k)E=b+1;else break;return t?(t.line=b,t.column=h-C,null):{line:b,column:h-C}}t(i,r,t){if(t.column===0)return t.line-r.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-r.line;const l=g[t.line+1],m=g[t.line]+t.column;if(l>m+1)return t.line-r.line;const p=m-1;return this.a[i].buffer.charCodeAt(p)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$eD)(this,i[r])}w(i){if(i.length>$){const D=[];for(;i.length>$;){const k=i.charCodeAt($-1);let C;k===v.CharCode.CarriageReturn||k>=55296&&k<=56319?(C=i.substring(0,$-1),i=i.substring($-1)):(C=i.substring(0,$),i=i.substring($));const f=y(C);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:C.length-f[f.length-1]},f.length-1,C.length)),this.a.push(new d(C,f))}const b=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,p=l-this.a[0].lineStarts[m],h={line:m,column:p},E=new S(0,g,h,this.t(0,g,h),l-r);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,g="";const l=this.h.get2(i);if(l){t=l.node;const m=this.B(t,i-l.nodeStartLineNumber-1),p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=p.substring(h+m,h+t.piece.length);else{const E=this.B(t,i-l.nodeStartLineNumber);return p.substring(h+m,h+E-r)}}else{let m=0;const p=i;for(;t!==A.$_C;)if(t.left!==A.$_C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:p-(i-1-t.lf_left)}),D.substring(b+h,b+E-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$_C;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const p=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=m.substring(h,h+p-r),g}else{const p=this.u(t.piece.bufferIndex,t.piece.start);g+=m.substr(p,t.piece.length)}t=t.next()}return g}y(){let i=this.root,r=1,t=0;for(;i!==A.$_C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,g=this.s(i,r),l=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const m=this.t(i.piece.bufferIndex,t.start,g);if(m!==l)return{index:m,remainder:0}}return{index:l,remainder:g.column}}B(i,r){if(r<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[l]-g[t.start.line]-t.start.column}C(i,r){const t=i.piece,g=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),m=r,p=this.u(t.bufferIndex,m),h=this.t(t.bufferIndex,t.start,m),E=h-g,D=p-l,b=t.length+D;i.piece=new S(t.bufferIndex,t.start,m,h,b),(0,A.$gD)(this,i,D,E)}D(i,r){const t=i.piece,g=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),m=r,p=this.t(t.bufferIndex,m,t.end),h=this.u(t.bufferIndex,m),E=p-g,D=l-h,b=t.length+D;i.piece=new S(t.bufferIndex,m,t.end,p,b),(0,A.$gD)(this,i,D,E)}E(i,r,t){const g=i.piece,l=g.start,m=g.end,p=g.length,h=g.lineFeedCnt,E=r,D=this.t(g.bufferIndex,g.start,E),b=this.u(g.bufferIndex,r)-this.u(g.bufferIndex,l);i.piece=new S(g.bufferIndex,g.start,E,D,b),(0,A.$gD)(this,i,b-p,D-h);const k=new S(g.bufferIndex,t,m,this.t(g.bufferIndex,t,m),this.u(g.bufferIndex,m)-this.u(g.bufferIndex,t)),C=this.S(i,k);this.N(C)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=r;const l=y(r,!1);for(let C=0;C<l.length;C++)l[C]+=g;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const m=this.a[0].lineStarts.length-1,p=this.a[0].buffer.length-this.a[0].lineStarts[m],h={line:m,column:p},E=i.piece.length+r.length,D=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,h),k=b-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,b,E),this.g=h,(0,A.$gD)(this,i,r.length,k)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;r!==A.$_C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){g+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:g};return this.h.set(l),l}else i-=r.size_left+r.piece.length,g+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,g=0;for(;t!==A.$_C;)if(t.left!==A.$_C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(l+r-1,m),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:g};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$_C;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:m}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$_C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,g=r.start.line,l=t[g]+r.start.column;return g===t.length-1||t[g+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$_C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,p=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,l,p,m),(0,A.$gD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:r.piece.start.line+1,column:0},E=r.piece.length-1,D=this.t(r.piece.bufferIndex,h,r.piece.end);r.piece=new S(r.piece.bufferIndex,h,r.piece.end,D,E),(0,A.$gD)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.w(`\r
`);this.S(i,b[0]);for(let k=0;k<t.length;k++)(0,A.$eD)(this,t[k])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$eD)(this,t);else{const g=t.piece,l={line:g.start.line+1,column:0},m=g.length-1,p=this.t(g.bufferIndex,l,g.end);t.piece=new S(g.bufferIndex,l,g.end,p,m),(0,A.$gD)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$_C)return r(A.$_C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$_C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(g,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,g)}S(i,r){const t=new A.$$C(r,A.NodeColor.Red);if(t.left=A.$_C,t.right=A.$_C,t.parent=A.$_C,t.size_left=0,t.lf_left=0,this.root===A.$_C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$_C)i.right=t,t.parent=i;else{const l=(0,A.$aD)(i.right);l.left=t,t.parent=l}return(0,A.$fD)(this,t),t}T(i,r){const t=new A.$$C(r,A.NodeColor.Red);if(t.left=A.$_C,t.right=A.$_C,t.parent=A.$_C,t.size_left=0,t.lf_left=0,this.root===A.$_C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$_C)i.left=t,t.parent=i;else{const g=(0,A.$bD)(i.left);g.right=t,t.parent=g}return(0,A.$fD)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$sD=c}),define(Oe[161],Ne([1,0,6,12,32,52,100,153,155,4]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=void 0,I=We(I);class R extends s.$Tc{constructor(a,S,d,n,o,c,u){super(),this.m=this.B(new v.$ke),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=n,this.h=o,this.c=new A.$sD(a,d,u)}equals(a){return!(a instanceof R)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,n=this.getPositionAt(a),o=this.getPositionAt(d);return new P.$Mt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),n=this.getOffsetAt(a.endLineNumber,a.endColumn);let o=0;const c=this.n(S),u=this.getEOL();if(c.length!==u.length){const i=c.length-u.length,r=a.endLineNumber-a.startLineNumber;o=i*r}return n-d+o}getCharacterCountInRange(a,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=a.startLineNumber,o=a.endLineNumber;for(let c=n;c<=o;c++){const u=this.getLineContent(c),i=c===n?a.startColumn-1:0,r=c===o?a.endColumn-1:u.length;for(let t=i;t<r;t++)I.$If(u.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(o-n),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=I.$tf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=I.$vf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let n=this.g,o=this.h,c=this.j,u=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];u&&E._isTracked&&(u=!1);const D=E.range;if(E.text){let w=!0;c||(w=!I.$Tf(E.text),c=w),!n&&w&&(n=I.$Sf(E.text)),!o&&w&&(o=I.$Vf(E.text))}let b="",k=0,C=0,f=0;if(E.text){let w;[k,C,f,w]=(0,T.$xu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===N?b=E.text:b=E.text.replace(/\r\n|\r|\n/g,F)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:b,eolCount:k,firstLineLength:C,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),b=i[h+1].range.getStartPosition();if(b.isBeforeOrEqual(D)){if(b.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}u&&(i=this.s(i));const t=d||S?R._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let b=D.startLineNumber;b<=D.endLineNumber;b++){let k="";b===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),I.$tf(k)!==-1)||g.push({lineNumber:b,oldContent:k})}}let l=null;if(d){let h=0;l=[];for(let E=0;E<i.length;E++){const D=i[E],b=t[E],k=this.getValueInRange(D.range),C=D.rangeOffset+h;h+=D.text.length-k.length,l[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:b,text:k,textChange:new $.$du(D.rangeOffset,k,C,D.text)}}r||l.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=c;const m=this.t(i);let p=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),p=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const b=g[h].oldContent,k=this.getLineContent(D);k.length===0||k===b||I.$tf(k)!==-1||p.push(D)}}return this.m.fire(),new O.$gw(l,m,p)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,n=a[a.length-1].range,o=new P.$Mt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let c=d.startLineNumber,u=d.startColumn;const i=[];for(let m=0,p=a.length;m<p;m++){const h=a[m],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Mt(c,u,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,u=E.endColumn}const r=i.join(""),[t,g,l]=(0,T.$xu)(r);return{sortIndex:0,identifier:a[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:g,lastLineLength:l,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(R.w);const S=[];for(let d=0;d<a.length;d++){const n=a[d],o=n.range.startLineNumber,c=n.range.startColumn,u=n.range.endLineNumber,i=n.range.endColumn;if(o===u&&c===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new P.$Mt(o,c,u,i);S.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,n){return this.c.findMatchesLineByLine(a,S,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,n=a.startColumn,[o,c,u]=(0,T.$xu)(S);let i;if(S.length>0){const r=o+1;r===1?i=new P.$Mt(d,n,d,n+c):i=new P.$Mt(d,n,d+r-1,u+1)}else i=new P.$Mt(d,n,d,n);return i}static _getInverseEditRanges(a){const S=[];let d=0,n=0,o=null;for(let c=0,u=a.length;c<u;c++){const i=a[c];let r,t;o?o.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-o.range.endColumn)):(r=d+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const l=i.eolCount+1;l===1?g=new P.$Mt(r,t,r,t+i.firstLineLength):g=new P.$Mt(r,t,r+l-1,i.lastLineLength+1)}else g=new P.$Mt(r,t,r,t);d=g.endLineNumber,n=g.endColumn,S.push(g),o=i}return S}static u(a,S){const d=P.$Mt.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=P.$Mt.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$tD=R}),define(Oe[162],Ne([1,0,27,12,52,100,161]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0,I=We(I);class T{constructor(R,y,a,S,d,n,o,c,u){this.a=R,this.b=y,this.c=a,this.d=S,this.e=d,this.f=n,this.g=o,this.h=c,this.j=u}k(R){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?R===P.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(R){const y=this.k(R),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,n=a.length;d<n;d++){const o=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,O.$oD)(o);a[d]=new O.$rD(o,c)}const S=new A.$tD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&I.$4f(R)&&(this.b=I.$3f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,O.$pD)(this.e,R);this.a.push(new O.$rD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Sf(R)),this.k||(this.k=I.$Vf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,O.$oD)(R.buffer);R.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$uD=$}),define(Oe[103],Ne([1,0,22,20]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdb=$,e.$Rdb=R,I=We(I);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function O(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],n=y[a+1],o=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=o,y[a+2]=n,y[a+3]=d}}function A(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return I.$E()||O(a),v.$Me.wrap(a)}function T(y){const a=y.buffer;if(I.$E()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(y){const a=new Uint32Array(s(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=P.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=P.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return A(a)}function s(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function R(y){const a=T(y);let S=0;const d=a[S++];if(a[S++]===P.Full){const u=a[S++],i=a.subarray(S,S+u);return S+=u,{id:d,type:"full",data:i}}const o=a[S++],c=[];for(let u=0;u<o;u++){const i=a[S++],r=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[u]={start:i,deleteCount:r,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Oe[163],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_=e.$H_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$H_=v;class I{constructor(O){this.identifier=O}}e.$I_=I}),define(Oe[164],Ne([1,0,6,4,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=void 0,e.$nj=R,P=We(P);class O extends I.$Tc{constructor(a,S="",d="",n=!0,o){super(),this.j=this.B(new v.$ke),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$ij=O;class A extends I.$Tc{constructor(){super(...arguments),this.f=this.B(new v.$ke),this.onWillRun=this.f.event,this.m=this.B(new v.$ke),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(n){d=n}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$jj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new T,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$kj=T;class ${get actions(){return this.a}constructor(a,S,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=n,this.a=d}async run(){}}e.$lj=$;class s extends O{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(12992,null),void 0,!1)}}e.$mj=s;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Oe[165],Ne([1,0,9]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=s,e.$1m=R,e.$2m=y;const I=60,P=I*60,O=P*24,A=O*7,T=O*30,$=O*365;function s(a,S,d,n){typeof a!="number"&&(a=a.getTime());const o=Math.round((new Date().getTime()-a)/1e3);if(o<-30)return(0,v.localize)(12929,null,s(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,v.localize)(12930,null);let c;return o<I?(c=o,S?c===1?d?(0,v.localize)(12931,null,c):(0,v.localize)(12932,null,c):d?(0,v.localize)(12933,null,c):(0,v.localize)(12934,null,c):c===1?d?(0,v.localize)(12935,null,c):(0,v.localize)(12936,null,c):d?(0,v.localize)(12937,null,c):(0,v.localize)(12938,null,c)):o<P?(c=Math.floor(o/I),S?c===1?d?(0,v.localize)(12939,null,c):(0,v.localize)(12940,null,c):d?(0,v.localize)(12941,null,c):(0,v.localize)(12942,null,c):c===1?d?(0,v.localize)(12943,null,c):(0,v.localize)(12944,null,c):d?(0,v.localize)(12945,null,c):(0,v.localize)(12946,null,c)):o<O?(c=Math.floor(o/P),S?c===1?d?(0,v.localize)(12947,null,c):(0,v.localize)(12948,null,c):d?(0,v.localize)(12949,null,c):(0,v.localize)(12950,null,c):c===1?d?(0,v.localize)(12951,null,c):(0,v.localize)(12952,null,c):d?(0,v.localize)(12953,null,c):(0,v.localize)(12954,null,c)):o<A?(c=Math.floor(o/O),S?c===1?(0,v.localize)(12955,null,c):(0,v.localize)(12956,null,c):c===1?(0,v.localize)(12957,null,c):(0,v.localize)(12958,null,c)):o<T?(c=Math.floor(o/A),S?c===1?d?(0,v.localize)(12959,null,c):(0,v.localize)(12960,null,c):d?(0,v.localize)(12961,null,c):(0,v.localize)(12962,null,c):c===1?d?(0,v.localize)(12963,null,c):(0,v.localize)(12964,null,c):d?(0,v.localize)(12965,null,c):(0,v.localize)(12966,null,c)):o<$?(c=Math.floor(o/T),S?c===1?d?(0,v.localize)(12967,null,c):(0,v.localize)(12968,null,c):d?(0,v.localize)(12969,null,c):(0,v.localize)(12970,null,c):c===1?d?(0,v.localize)(12971,null,c):(0,v.localize)(12972,null,c):d?(0,v.localize)(12973,null,c):(0,v.localize)(12974,null,c)):(c=Math.floor(o/$),S?c===1?d?(0,v.localize)(12975,null,c):(0,v.localize)(12976,null,c):d?(0,v.localize)(12977,null,c):(0,v.localize)(12978,null,c):c===1?d?(0,v.localize)(12979,null,c):(0,v.localize)(12980,null,c):d?(0,v.localize)(12981,null,c):(0,v.localize)(12982,null,c))}function R(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(12983,null,a):(0,v.localize)(12984,null,a):d<I?S?(0,v.localize)(12985,null,Math.round(a)/1e3):(0,v.localize)(12986,null,Math.round(a)/1e3):d<P?S?(0,v.localize)(12987,null,Math.round(a/(1e3*I))):(0,v.localize)(12988,null,Math.round(a/(1e3*I))):d<O?S?(0,v.localize)(12989,null,Math.round(a/(1e3*P))):(0,v.localize)(12990,null,Math.round(a/(1e3*P))):(0,v.localize)(12991,null,Math.round(a/(1e3*O)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[42],Ne([1,0,17,14,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=$,e.$pj=s,e.$qj=R,v=We(v),I=We(I),P=We(P);function O(y,a){return a&&(y.stack||y.stacktrace)?P.localize(12923,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12924,null,y.message):y.message||P.localize(12925,null)}function $(y=null,a=!1){if(!y)return P.localize(12926,null);if(Array.isArray(y)){const S=v.$Gb(y),d=$(S[0],a);return S.length>1?P.localize(12927,null,d,S.length):d}if(I.$dg(y))return y;if(y.detail){const S=y.detail;if(S.error)return O(S.error,a);if(S.exception)return O(S.exception,a)}return y.stack?O(y,a):y.message?y.message:P.localize(12928,null)}function s(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function R(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Oe[166],Ne([1,0,27,13,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.TokenType=void 0;var O;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...R){switch(R.length){case 1:return(0,P.localize)(11530,null,R[0]);case 2:return(0,P.localize)(11531,null,R[0],R[1]);case 3:return(0,P.localize)(11532,null,R[0],R[1],R[2]);default:return}}const T=(0,P.localize)(11533,null),$=(0,P.localize)(11534,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:a})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=s.b.get(a);S?this.k(S):this.f.push({type:O.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const n=this.c.charCodeAt(y);if(a)a=!1;else if(n===v.CharCode.Slash&&!S){y++;break}else n===v.CharCode.OpenSquareBracket?S=!0:n===v.CharCode.Backslash?a=!0:n===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$yj=s}),define(Oe[104],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Oe[73],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class v{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Ai=v}),define(Oe[60],Ne([1,0,73]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=O,e.$Qs=A;const I=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(T,$,s){$ instanceof v.$Ai||($=new v.$Ai($,[],!!s)),I.push([T,$])}function A(){return I}}),define(Oe[167],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class v{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$sr=v;class I{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(A);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new v(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),$=this.c(A,T);if($)return $}}c(O,A){for(const[T,$]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const s=this.c($,A);if(s)return s;A.delete(T)}}}e.$tr=I}),define(Oe[3],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e._util=void 0,e.$Di=P,e.$Ei=O;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Ci=P("instantiationService");function I(A,T,$){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:$}):(T[v.DI_DEPENDENCIES]=[{id:A,index:$}],T[v.DI_TARGET]=T)}function P(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function($,s,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(T,$,R)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function O(A){return A}}),define(Oe[43],Ne([1,0,14,2,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$0i=void 0,e.$$i=O,e.$_i=A,e.$aj=$,e.$bj=s,e.$cj=R,e.$dj=y,e.$ej=a,e.$fj=d,e.$gj=n,e.$hj=o,v=We(v),e.$0i=(0,P.$Di)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof I.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof I.URI)}var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(c){switch(c){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function R(c,u){const i=Object.create(null);for(const r in c)y(i,r,c[r],u);return i}function y(c,u,i,r){const t=u.split("."),g=t.pop();let l=c;for(let m=0;m<t.length;m++){const p=t[m];let h=l[p];switch(typeof h){case"undefined":h=l[p]=Object.create(null);break;case"object":if(h===null){r(`Ignoring ${u} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:r(`Ignoring ${u} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(h)}`);return}l=h}if(typeof l=="object"&&l!==null)try{l[g]=i}catch{r(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(l)}`)}function a(c,u){const i=u.split(".");S(c,i)}function S(c,u){const i=u.shift();if(u.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const r=c[i];typeof r=="object"&&!Array.isArray(r)&&(S(r,u),Object.keys(r).length===0&&delete c[i])}}function d(c,u,i){function r(l,m){let p=l;for(const h of m){if(typeof p!="object"||p===null)return;p=p[h]}return p}const t=u.split("."),g=r(c,t);return typeof g>"u"?i:g}function n(c,u,i){Object.keys(u).forEach(r=>{r!=="__proto__"&&(r in c?v.$fg(c[r])&&v.$fg(u[r])?n(c[r],u[r],i):i&&(c[r]=u[r]):c[r]=u[r])})}function o(c){return c.replace(/[\[\]]/g,"")}}),define(Oe[31],Ne([1,0,27,20,12,166,3,9,13]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Bj=e.$Aj=e.ContextKeyExprType=void 0,e.$zj=R,e.$Cj=m,e.$Dj=p,e.$Wj=oe;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",I.$k),s.set("isLinux",I.$l),s.set("isWindows",I.$j),s.set("isWeb",I.$p),s.set("isMacNative",I.$k&&!I.$p),s.set("isEdge",I.$I),s.set("isFirefox",I.$G),s.set("isChrome",I.$F),s.set("isSafari",I.$H);function R(Y,q){if(s.get(Y)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(Y,q)}const y=Object.prototype.hasOwnProperty;var a;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(11544,null),n=(0,T.localize)(11545,null),o=(0,T.localize)(11546,null),c=(0,T.localize)(11547,null),u=(0,T.localize)(11548,null),i=(0,T.localize)(11549,null),r=(0,T.localize)(11550,null),t=(0,T.localize)(11551,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=S){this.k=q,this.d=new O.$yj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ve=this.D(),ce=ve.type===O.TokenType.Str?i:void 0;throw this.h.push({message:u,offset:ve.offset,lexeme:O.$yj.getLexeme(ve),additionalInfo:ce}),g.c}return te}catch(te){if(te!==g.c)throw te;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const te=this.o();q.push(te)}return q.length===1?q[0]:l.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const te=this.s();q.push(te)}return q.length===1?q[0]:l.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,c),te?.negate()}case O.TokenType.Str:return this.z(),F.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),l.true();case O.TokenType.False:return this.z(),l.false();case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,c),te}case O.TokenType.Str:{const te=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ce.type!==O.TokenType.RegexStr)throw this.B("REGEX",ce);const we=ce.lexeme,he=we.lastIndexOf("/"),X=he===we.length-1?void 0:this.w(we.substring(he+1));let x;try{x=new RegExp(we.substring(1,he),X)}catch{throw this.B("REGEX",ce)}return K.create(te,x)}switch(ce.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[ce.lexeme];this.z();let he=this.D(),X=0;for(let Ue=0;Ue<ce.lexeme.length;Ue++)ce.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?X++:ce.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==O.TokenType.And&&he.type!==O.TokenType.Or;){switch(he.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<he.lexeme.length;Ue++)he.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?X++:ce.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&X--}if(X<0)break;we.push(O.$yj.getLexeme(he)),this.z(),he=this.D()}const x=we.join(""),me=x.lastIndexOf("/"),pe=me===x.length-1?void 0:this.w(x.substring(me+1));let Ae;try{Ae=new RegExp(x.substring(1,me),pe)}catch{throw this.B("REGEX",ce)}return l.regex(te,Ae)}case O.TokenType.QuotedStr:{const we=ce.lexeme;this.z();let he=null;if(!(0,P.$bf)(we)){const X=we.indexOf("/"),x=we.lastIndexOf("/");if(X!==x&&X>=0){const me=we.slice(X+1,x),pe=we[x+1]==="i"?"i":"";try{he=new RegExp(me,pe)}catch{throw this.B("REGEX",ce)}}}if(he===null)throw this.B("REGEX",ce);return K.create(te,he)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const ce=this.u();return l.notIn(te,ce)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ce=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.equals(te,ce);switch(ce){case"true":return l.has(te);case"false":return l.not(te);default:return l.equals(te,ce)}}case O.TokenType.NotEq:{this.z();const ce=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.notEquals(te,ce);switch(ce){case"true":return l.not(te);case"false":return l.has(te);default:return l.notEquals(te,ce)}}case O.TokenType.Lt:return this.z(),J.create(te,this.u());case O.TokenType.LtEq:return this.z(),M.create(te,this.u());case O.TokenType.Gt:return this.z(),L.create(te,this.u());case O.TokenType.GtEq:return this.z(),W.create(te,this.u());case O.TokenType.In:return this.z(),l.in(te,this.u());default:return l.has(te)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,te){if(this.C(q))return this.z();throw this.B(te,this.D())}B(q,te,ve){const ce=(0,T.localize)(11552,null,q,O.$yj.getLexeme(te)),we=te.offset,he=O.$yj.getLexeme(te);return this.h.push({message:ce,offset:we,lexeme:he,additionalInfo:ve}),g.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Aj=g;class l{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(q){return b.create(q)}static equals(q,te){return k.create(q,te)}static notEquals(q,te){return w.create(q,te)}static regex(q,te){return K.create(q,te)}static in(q,te){return C.create(q,te)}static notIn(q,te){return f.create(q,te)}static not(q){return F.create(q)}static and(...q){return _.create(q,null,!0)}static or(...q){return ge.create(q,null,!0)}static greater(q,te){return L.create(q,te)}static greaterEquals(q,te){return W.create(q,te)}static smaller(q,te){return J.create(q,te)}static smallerEquals(q,te){return M.create(q,te)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Bj=l;function m(Y){const q=new g({regexParsingWithErrorRecovery:!1});return Y.map(te=>(q.parse(te),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(11553,null,ve.additionalInfo):(0,T.localize)(11554,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function p(Y,q){const te=Y?Y.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!te&&!ve?!0:!te||!ve?!1:te.equals(ve)}function h(Y,q){return Y.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Ej=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Fj=D;class b{static create(q,te=null){const ve=s.get(q);return typeof ve=="boolean"?ve?D.INSTANCE:E.INSTANCE:new b(q,te)}constructor(q,te){this.key=q,this.c=te,this.type=a.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Gj=b;class k{static create(q,te,ve=null){if(typeof te=="boolean")return te?b.create(q,ve):F.create(q,ve);const ce=s.get(q);return typeof ce=="boolean"?te===(ce?"true":"false")?D.INSTANCE:E.INSTANCE:new k(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Equals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?D.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Hj=k;class C{static create(q,te){return new C(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(te)?te.includes(ve):typeof ve=="string"&&typeof te=="object"&&te!==null?y.call(te,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ij=C;class f{static create(q,te){return new f(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.NotIn,this.c=C.create(q,te)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Jj=f;class w{static create(q,te,ve=null){if(typeof te=="boolean")return te?F.create(q,ve):b.create(q,ve);const ce=s.get(q);return typeof ce=="boolean"?te===(ce?"true":"false")?E.INSTANCE:D.INSTANCE:new w(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?E.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Kj=w;class F{static create(q,te=null){const ve=s.get(q);return typeof ve=="boolean"?ve?E.INSTANCE:D.INSTANCE:new F(q,te)}constructor(q,te){this.c=q,this.d=te,this.type=a.Not}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Lj=F;function N(Y,q){if(typeof Y=="string"){const te=parseFloat(Y);isNaN(te)||(Y=te)}return typeof Y=="string"||typeof Y=="number"?q(Y):E.INSTANCE}class L{static create(q,te,ve=null){return N(te,ce=>new L(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Greater}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Mj=L;class W{static create(q,te,ve=null){return N(te,ce=>new W(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Nj=W;class J{static create(q,te,ve=null){return N(te,ce=>new J(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Oj=J;class M{static create(q,te,ve=null){return N(te,ce=>new M(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Pj=M;class K{static create(q,te){return new K(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return te<ve?-1:te>ve?1:0}equals(q){if(q.type===this.type){const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&te===ve}return!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Qj=K;class Z{static create(q){return new Z(q)}constructor(q){this.c=q,this.type=a.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Z(this.c.map(q))}negate(){return this.c}}e.$Rj=Z;function ue(Y){let q=null;for(let te=0,ve=Y.length;te<ve;te++){const ce=Y[te].substituteConstants();if(Y[te]!==ce&&q===null){q=[];for(let we=0;we<te;we++)q[we]=Y[we]}q!==null&&(q[te]=ce)}return q===null?Y:q}class _{static create(q,te,ve){return _.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=a.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=h(this.expr[te],q.expr[te]);if(ce!==0)return ce}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=ue(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].evaluate(q))return!1;return!0}static d(q,te,ve){const ce=[];let we=!1;for(const he of q)if(he){if(he.type===a.True){we=!0;continue}if(he.type===a.False)return E.INSTANCE;if(he.type===a.And){ce.push(...he.expr);continue}ce.push(he)}if(ce.length===0&&we)return D.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(h);for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];for(;ce.length>1;){const he=ce[ce.length-1];if(he.type!==a.Or)break;ce.pop();const X=ce.pop(),x=ce.length===0,me=ge.create(he.expr.map(pe=>_.create([pe,X],null,ve)),null,x);me&&(ce.push(me),ce.sort(h))}if(ce.length===1)return ce[0];if(ve){for(let he=0;he<ce.length;he++)for(let X=he+1;X<ce.length;X++)if(ce[he].negate().equals(ce[X]))return E.INSTANCE;if(ce.length===1)return ce[0]}return new _(ce,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new _(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());this.c=ge.create(q,this,!0)}return this.c}}e.$Sj=_;class ge{static create(q,te,ve){return ge.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=a.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=h(this.expr[te],q.expr[te]);if(ce!==0)return ce}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=ue(this.expr);return q===this.expr?this:ge.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(this.expr[te].evaluate(q))return!0;return!1}static d(q,te,ve){let ce=[],we=!1;if(q){for(let he=0,X=q.length;he<X;he++){const x=q[he];if(x){if(x.type===a.False){we=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){ce=ce.concat(x.expr);continue}ce.push(x)}}if(ce.length===0&&we)return E.INSTANCE;ce.sort(h)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];if(ve){for(let he=0;he<ce.length;he++)for(let X=he+1;X<ce.length;X++)if(ce[he].negate().equals(ce[X]))return D.INSTANCE;if(ce.length===1)return ce[0]}return new ge(ce,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new ge(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());for(;q.length>1;){const te=q.shift(),ve=q.shift(),ce=[];for(const we of Le(te))for(const he of Le(ve))ce.push(_.create([we,he],null,!1));q.unshift(ge.create(ce,null,!1))}this.c=ge.create(q,this,!0)}return this.c}}e.$Tj=ge;class se extends b{static{this.d=[]}static all(){return se.d.values()}constructor(q,te,ve){super(q,null),this.f=te,typeof ve=="object"?se.d.push({...ve,key:q}):ve!==!0&&se.d.push({key:q,description:ve,type:te!=null?typeof te:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return k.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Uj=se,e.$Vj=(0,A.$Di)("contextKeyService");function ae(Y,q){return Y<q?-1:Y>q?1:0}function $e(Y,q,te,ve){return Y<te?-1:Y>te?1:q<ve?-1:q>ve?1:0}function oe(Y,q){if(Y.type===a.False||q.type===a.True)return!0;if(Y.type===a.Or)return q.type===a.Or?ke(Y.expr,q.expr):!1;if(q.type===a.Or){for(const te of q.expr)if(oe(Y,te))return!0;return!1}if(Y.type===a.And){if(q.type===a.And)return ke(q.expr,Y.expr);for(const te of Y.expr)if(oe(te,q))return!0;return!1}return Y.equals(q)}function ke(Y,q){let te=0,ve=0;for(;te<Y.length&&ve<q.length;){const ce=Y[te].cmp(q[ve]);if(ce<0)return!1;ce===0&&te++,ve++}return te===Y.length}function Le(Y){return Y.type===a.Or?Y.expr:[Y]}}),define(Oe[168],Ne([1,0,31,3]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$qt=e.AccessibilitySupport=e.$pt=void 0,e.$rt=O,e.$pt=(0,I.$Di)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$qt=new v.$Uj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$st="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[105],Ne([1,0,17,25,20,146,280,156,169,9,168]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=We(v),I=We(I),P=We(P),s=We(s);var y;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(Q,Ee,Je,xe){this.id=Q,this.name=Ee,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,Ee){return o(Q,Ee)}compute(Q,Ee,Je){return Je}}class n{constructor(Q,Ee){this.newValue=Q,this.didChange=Ee}}e.ApplyUpdateResult=n;function o(ee,Q){if(typeof ee!="object"||typeof Q!="object"||!ee||!Q)return new n(Q,ee!==Q);if(Array.isArray(ee)||Array.isArray(Q)){const Je=Array.isArray(ee)&&Array.isArray(Q)&&v.$tb(ee,Q);return new n(Q,!Je)}let Ee=!1;for(const Je in Q)if(Q.hasOwnProperty(Je)){const xe=o(ee[Je],Q[Je]);xe.didChange&&(ee[Je]=xe.newValue,Ee=!0)}return new n(ee,Ee)}class c{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ee){return o(Q,Ee)}validate(Q){return this.defaultValue}}class u{constructor(Q,Ee,Je,xe){this.id=Q,this.name=Ee,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,Ee){return o(Q,Ee)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ee,Je){return Je}}function i(ee,Q){return typeof ee>"u"?Q:ee==="false"?!1:!!ee}class r extends u{constructor(Q,Ee,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(Q,Ee,Je,xe)}validate(Q){return i(Q,this.defaultValue)}}function t(ee,Q,Ee,Je){if(typeof ee>"u")return Q;let xe=parseInt(ee,10);return isNaN(xe)?Q:(xe=Math.max(Ee,xe),xe=Math.min(Je,xe),xe|0)}class g extends u{static clampedInt(Q,Ee,Je,xe){return t(Q,Ee,Je,xe)}constructor(Q,Ee,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(Q,Ee,Je,$t),this.minimum=xe,this.maximum=ht}validate(Q){return g.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function l(ee,Q,Ee,Je){if(typeof ee>"u")return Q;const xe=m.float(ee,Q);return m.clamp(xe,Ee,Je)}class m extends u{static clamp(Q,Ee,Je){return Q<Ee?Ee:Q>Je?Je:Q}static float(Q,Ee){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ee;const Je=parseFloat(Q);return isNaN(Je)?Ee:Je}constructor(Q,Ee,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(Q,Ee,Je,ht),this.validationFn=xe}validate(Q){return this.validationFn(m.float(Q,this.defaultValue))}}class p extends u{static string(Q,Ee){return typeof Q!="string"?Ee:Q}constructor(Q,Ee,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(Q,Ee,Je,xe)}validate(Q){return p.string(Q,this.defaultValue)}}function h(ee,Q,Ee,Je){return typeof ee!="string"?Q:Je&&ee in Je?Je[ee]:Ee.indexOf(ee)===-1?Q:ee}class E extends u{constructor(Q,Ee,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(Q,Ee,Je,ht),this.c=xe}validate(Q){return h(Q,this.defaultValue,this.c)}}class D extends d{constructor(Q,Ee,Je,xe,ht,$t,Nt=void 0){typeof Nt<"u"&&(Nt.type="string",Nt.enum=ht,Nt.default=xe),super(Q,Ee,Je,Nt),this.c=ht,this.d=$t}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function b(ee){switch(ee){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(11720,null),s.localize(11721,null),s.localize(11722,null)],default:"auto",tags:["accessibility"],description:s.localize(11723,null)})}validate(Q){switch(Q){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,Ee,Je){return Je===R.AccessibilitySupport.Unknown?Q.accessibilitySupport:Je}}class C extends d{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(11724,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(11725,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertSpace:i(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function w(ee){switch(ee){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var F;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ee){switch(ee){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function L(ee){switch(ee){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class W extends c{constructor(){super(je.editorClassName)}compute(Q,Ee,Je){const xe=["monaco-editor"];return Ee.get(je.extraEditorClassName)&&xe.push(Ee.get(je.extraEditorClassName)),Q.extraEditorClassName&&xe.push(Q.extraEditorClassName),Ee.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Ee.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Ee.get(je.showUnused)&&xe.push("showUnused"),Ee.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class J extends r{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(11726,null)})}compute(Q,Ee,Je){return Je&&Q.emptySelectionClipboard}}class M extends d{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(11727,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(11728,null),s.localize(11729,null),s.localize(11730,null)],description:s.localize(11731,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(11732,null),s.localize(11733,null),s.localize(11734,null)],description:s.localize(11735,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(11736,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(11737,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(11738,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{cursorMoveOnType:i(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":h(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":h(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ee.loop,this.defaultValue.loop)}}}class K extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",K.OFF,{anyOf:[{type:"boolean",description:s.localize(11739,null)},{type:"string",description:s.localize(11740,null)}],description:s.localize(11741,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?K.OFF:Q==="true"?K.ON:Q:Q?K.ON:K.OFF}}e.EditorFontLigatures=K;class Z extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:s.localize(11742,null)},{type:"string",description:s.localize(11743,null)}],description:s.localize(11744,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?Z.OFF:Q==="true"?Z.TRANSLATE:Q:Q?Z.TRANSLATE:Z.OFF}compute(Q,Ee,Je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class ue extends c{constructor(){super(je.fontInfo)}compute(Q,Ee,Je){return Q.fontInfo}}class _ extends u{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(11745,null)})}validate(Q){const Ee=m.float(Q,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Ee,6,100)}compute(Q,Ee,Je){return Q.fontInfo.fontSize}}class ge extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ge.d,maximum:ge.e,errorMessage:s.localize(11746,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ge.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(11747,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(g.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,ge.d,ge.e))}}class se extends d{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(11748,null),s.localize(11749,null),s.localize(11750,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(11751,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(11752,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(11753,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:s.localize(11754,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:s.localize(11755,null),...Ee},"editor.gotoLocation.multipleReferences":{description:s.localize(11756,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Je,description:s.localize(11757,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Je,description:s.localize(11758,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Je,description:s.localize(11759,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Je,description:s.localize(11760,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Je,description:s.localize(11761,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{multiple:h(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??h(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??h(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??h(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??h(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??h(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends d{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11762,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:s.localize(11763,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(11764,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:s.localize(11765,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(11766,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),delay:g.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:i(Ee.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Ee.above,this.defaultValue.above)}}}var $e;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class oe extends c{constructor(){super(je.layoutInfo)}compute(Q,Ee,Je){return oe.computeLayout(Ee,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ee=Q.height/Q.lineHeight,Je=Math.floor(Q.paddingTop/Q.lineHeight);let xe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(xe=Math.max(xe,Ee-1));const ht=(Je+Q.viewLineCount+xe)/(Q.pixelRatio*Q.height),$t=Math.floor(Q.viewLineCount/ht);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(Q,Ee){const Je=Q.outerWidth,xe=Q.outerHeight,ht=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=Ee.stableMinimapLayoutInput,Nt=$t&&Q.outerHeight===$t.outerHeight&&Q.lineHeight===$t.lineHeight&&Q.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&Q.pixelRatio===$t.pixelRatio&&Q.scrollBeyondLastLine===$t.scrollBeyondLastLine&&Q.paddingTop===$t.paddingTop&&Q.paddingBottom===$t.paddingBottom&&Q.minimap.enabled===$t.minimap.enabled&&Q.minimap.side===$t.minimap.side&&Q.minimap.size===$t.minimap.size&&Q.minimap.showSlider===$t.minimap.showSlider&&Q.minimap.renderCharacters===$t.minimap.renderCharacters&&Q.minimap.maxColumn===$t.minimap.maxColumn&&Q.minimap.scale===$t.minimap.scale&&Q.verticalScrollbarWidth===$t.verticalScrollbarWidth&&Q.isViewportWrapping===$t.isViewportWrapping,Wt=Q.lineHeight,si=Q.typicalHalfwidthCharacterWidth,Yt=Q.scrollBeyondLastLine,hi=Q.minimap.renderCharacters;let Ze=ht>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Vt=Q.minimap.maxColumn,Ht=Q.minimap.size,gt=Q.minimap.side,St=Q.verticalScrollbarWidth,xt=Q.viewLineCount,_t=Q.remainingWidth,jt=Q.isViewportWrapping,wt=hi?2:3;let Rt=Math.floor(ht*xe);const ci=Rt/ht;let Qt=!1,Xe=!1,ei=wt*Ze,ui=Ze/ht,di=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:ii,extraLinesBeforeFirstLine:Bt,extraLinesBeyondLastLine:qt,desiredRatio:li,minimapLineCount:Tt}=oe.computeContainedMinimapLineCount({viewLineCount:xt,scrollBeyondLastLine:Yt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:xe,lineHeight:Wt,pixelRatio:ht});if(xt/Tt>1)Qt=!0,Xe=!0,Ze=1,ei=1,ui=Ze/ht;else{let bt=!1,Kt=Ze+1;if(Ht==="fit"){const yt=Math.ceil((Bt+xt+qt)*ei);jt&&Nt&&_t<=Ee.stableFitRemainingWidth?(bt=!0,Kt=Ee.stableFitMaxMinimapScale):bt=yt>Rt}if(Ht==="fill"||bt){Qt=!0;const yt=Ze;ei=Math.min(Wt*ht,Math.max(1,Math.floor(1/li))),jt&&Nt&&_t<=Ee.stableFitRemainingWidth&&(Kt=Ee.stableFitMaxMinimapScale),Ze=Math.min(Kt,Math.max(1,Math.floor(ei/wt))),Ze>yt&&(di=Math.min(2,Ze/yt)),ui=Ze/ht/di,Rt=Math.ceil(Math.max(ii,Bt+xt+qt)*ei),jt?(Ee.stableMinimapLayoutInput=Q,Ee.stableFitRemainingWidth=_t,Ee.stableFitMaxMinimapScale=Ze):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const kt=Math.floor(Vt*ui),Mt=Math.min(kt,Math.max(0,Math.floor((_t-St-2)*ui/(si+ui)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(ht*Mt);const Ft=At/ht;At=Math.floor(At*di);const oi=hi?$e.Text:$e.Blocks,ti=gt==="left"?0:Je-Mt-St;return{renderMinimap:oi,minimapLeft:ti,minimapWidth:Mt,minimapHeightIsEditorHeight:Qt,minimapIsSampling:Xe,minimapScale:Ze,minimapLineHeight:ei,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:ci}}static computeLayout(Q,Ee){const Je=Ee.outerWidth|0,xe=Ee.outerHeight|0,ht=Ee.lineHeight|0,$t=Ee.lineNumbersDigitCount|0,Nt=Ee.typicalHalfwidthCharacterWidth,Wt=Ee.maxDigitWidth,si=Ee.pixelRatio,Yt=Ee.viewLineCount,hi=Q.get(je.wordWrapOverride2),Ze=hi==="inherit"?Q.get(je.wordWrapOverride1):hi,Vt=Ze==="inherit"?Q.get(je.wordWrap):Ze,Ht=Q.get(je.wordWrapColumn),gt=Ee.isDominatedByLongLines,St=Q.get(je.glyphMargin),xt=Q.get(je.lineNumbers).renderType!==Ue.Off,_t=Q.get(je.lineNumbersMinChars),jt=Q.get(je.scrollBeyondLastLine),wt=Q.get(je.padding),Rt=Q.get(je.minimap),ci=Q.get(je.scrollbar),Qt=ci.verticalScrollbarSize,Xe=ci.verticalHasArrows,ei=ci.arrowSize,ui=ci.horizontalScrollbarSize,di=Q.get(je.folding),kt=Q.get(je.showFoldingControls)!=="never";let Mt=Q.get(je.lineDecorationsWidth);di&&kt&&(Mt+=16);let At=0;if(xt){const Gt=Math.max($t,_t);At=Math.round(Gt*Wt)}let Ft=0;St&&(Ft=ht*Ee.glyphMarginDecorationLaneCount);let oi=0,ti=oi+Ft,ii=ti+At,Bt=ii+Mt;const qt=Je-Ft-At-Mt;let li=!1,Tt=!1,Ct=-1;Ze==="inherit"&&gt?(li=!0,Tt=!0):Vt==="on"||Vt==="bounded"?Tt=!0:Vt==="wordWrapColumn"&&(Ct=Ht);const bt=oe.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Nt,pixelRatio:si,scrollBeyondLastLine:jt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Rt,verticalScrollbarWidth:Qt,viewLineCount:Yt,remainingWidth:qt,isViewportWrapping:Tt},Ee.memory||new S);bt.renderMinimap!==$e.None&&bt.minimapLeft===0&&(oi+=bt.minimapWidth,ti+=bt.minimapWidth,ii+=bt.minimapWidth,Bt+=bt.minimapWidth);const Kt=qt-bt.minimapWidth,yt=Math.max(1,Math.floor((Kt-Qt-2)/Nt)),ai=Xe?ei:0;return Tt&&(Ct=Math.max(1,yt),Vt==="bounded"&&(Ct=Math.min(Ct,Ht))),{width:Je,height:xe,glyphMarginLeft:oi,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:ti,lineNumbersWidth:At,decorationsLeft:ii,decorationsWidth:Mt,contentLeft:Bt,contentWidth:Kt,minimap:bt,viewportColumn:yt,isWordWrapMinified:li,isViewportWrapping:Tt,wrappingColumn:Ct,verticalScrollbarWidth:Qt,horizontalScrollbarHeight:ui,overviewRuler:{top:ai,width:Qt,height:xe-2*ai,right:0}}}}e.EditorLayoutInfoComputer=oe;class ke extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(11767,null),s.localize(11768,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(11769,null)}})}validate(Q){return h(Q,"simple",["simple","advanced"])}compute(Q,Ee,Je){return Ee.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Le;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class Y extends d{constructor(){const Q={enabled:Le.On};super(je.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:Q.enabled,enumDescriptions:[s.localize(11770,null),s.localize(11771,null),s.localize(11772,null)],description:s.localize(11773,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:h(Q.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class q extends d{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11774,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:s.localize(11775,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:s.localize(11776,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:s.localize(11777,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends d{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:s.localize(11778,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(11779,null),s.localize(11780,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11781,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11782,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(11783,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(11784,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:s.localize(11785,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:h(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:i(Ee.padding,this.defaultValue.padding)}}}class ve extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):g.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ee,Je){return Je<0?g.clampedInt(-Je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ce extends m{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>m.clamp(Q,0,150),{markdownDescription:s.localize(11786,null)})}compute(Q,Ee,Je){return Q.fontInfo.lineHeight}}class we extends d{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11787,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:s.localize(11788,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(11789,null),s.localize(11790,null),s.localize(11791,null)],default:Q.size,description:s.localize(11792,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(11793,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(11794,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(11795,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(11796,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(11797,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:s.localize(11798,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:s.localize(11799,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:s.localize(11800,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:s.localize(11801,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),autohide:i(Ee.autohide,this.defaultValue.autohide),size:h(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ee.side,this.defaultValue.side,["right","left"]),showSlider:h(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Ee.scale,1,1,3),maxColumn:g.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Ee.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Ee.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(Ee.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(Ee.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ee){return ee==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11802,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11803,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{top:g.clampedInt(Ee.top,0,0,1e3),bottom:g.clampedInt(Ee.bottom,0,0,1e3)}}}class x extends d{constructor(){const Q={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11804,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(11805,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),cycle:i(Ee.cycle,this.defaultValue.cycle)}}}class me extends c{constructor(){super(je.pixelRatio)}compute(Q,Ee,Je){return Q.pixelRatio}}class pe extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q:this.defaultValue}}class Ae extends d{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(11806,null),s.localize(11807,null),s.localize(11808,null)]}];super(je.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Q.strings,description:s.localize(11809,null)},comments:{anyOf:Ee,default:Q.comments,description:s.localize(11810,null)},other:{anyOf:Ee,default:Q.other,description:s.localize(11811,null)}},default:Q,markdownDescription:s.localize(11812,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const si=Q?"on":"off";return{comments:si,strings:si,other:si}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ee,comments:Je,strings:xe}=Q,ht=["on","inline","off"];let $t,Nt,Wt;return typeof Ee=="boolean"?$t=Ee?"on":"off":$t=h(Ee,this.defaultValue.other,ht),typeof Je=="boolean"?Nt=Je?"on":"off":Nt=h(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?Wt=xe?"on":"off":Wt=h(xe,this.defaultValue.strings,ht),{other:$t,comments:Nt,strings:Wt}}}var Ue;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class Se extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(11813,null),s.localize(11814,null),s.localize(11815,null),s.localize(11816,null)],default:"on",description:s.localize(11817,null)})}validate(Q){let Ee=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ee=Ue.Custom,Je=Q):Q==="interval"?Ee=Ue.Interval:Q==="relative"?Ee=Ue.Relative:Q==="on"?Ee=Ue.On:Ee=Ue.Off),{renderType:Ee,renderFn:Je}}}function Pe(ee){const Q=ee.get(je.renderValidationDecorations);return Q==="editable"?ee.get(je.readOnly):Q!=="on"}class Te extends d{constructor(){const Q=[],Ee={type:"number",description:s.localize(11818,null)};super(je.rulers,"rulers",Q,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:s.localize(11819,null),format:"color-hex"}}}]},default:Q,description:s.localize(11820,null)})}validate(Q){if(Array.isArray(Q)){const Ee=[];for(const Je of Q)if(typeof Je=="number")Ee.push({column:g.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;Ee.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ee.sort((Je,xe)=>Je.column-xe.column),Ee}return this.defaultValue}}class j extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function B(ee,Q){if(typeof ee!="string")return Q;switch(ee){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends d{constructor(){const Q={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11821,null),s.localize(11822,null),s.localize(11823,null)],default:"auto",description:s.localize(11824,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11825,null),s.localize(11826,null),s.localize(11827,null)],default:"auto",description:s.localize(11828,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(11829,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(11830,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(11831,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:s.localize(11832,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q,Je=g.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Ee.vertical,this.defaultValue.vertical),horizontal:B(Ee.horizontal,this.defaultValue.horizontal),useShadows:i(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:g.clampedInt(Ee.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Ee.verticalSliderSize,xe,0,1e3),scrollByPage:i(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(11833,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(11834,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(11835,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(11836,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(11837,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(11838,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(11839,null)}})}applyUpdate(Q,Ee){let Je=!1;Ee.allowedCharacters&&Q&&(I.$go(Q.allowedCharacters,Ee.allowedCharacters)||(Q={...Q,allowedCharacters:Ee.allowedCharacters},Je=!0)),Ee.allowedLocales&&Q&&(I.$go(Q.allowedLocales,Ee.allowedLocales)||(Q={...Q,allowedLocales:Ee.allowedLocales},Je=!0));const xe=super.applyUpdate(Q,Ee);return Je?new n(xe.newValue,!0):xe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{nonBasicASCII:Qe(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ee){if(typeof Q!="object"||!Q)return Ee;const Je={};for(const[xe,ht]of Object.entries(Q))ht===!0&&(Je[xe]=!0);return Je}}class ne extends d{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11840,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11841,null),s.localize(11842,null),s.localize(11843,null)],description:s.localize(11844,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:s.localize(11845,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:s.localize(11846,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),mode:h(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:p.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11847,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11848,null),s.localize(11849,null),s.localize(11850,null)],description:s.localize(11851,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:s.localize(11852,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showToolbar:h(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:p.string(Ee.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ie extends d{constructor(){const Q={enabled:T.$jt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$jt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11853,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:s.localize(11854,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11855,null),s.localize(11856,null),s.localize(11857,null)],default:Q.bracketPairs,description:s.localize(11858,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11859,null),s.localize(11860,null),s.localize(11861,null)],default:Q.bracketPairsHorizontal,description:s.localize(11862,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(11863,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(11864,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(11865,null),s.localize(11866,null),s.localize(11867,null)],default:Q.highlightActiveIndentation,description:s.localize(11868,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{bracketPairs:Qe(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(ee,Q,Ee){const Je=Ee.indexOf(ee);return Je===-1?Q:Ee[Je]}class _e extends d{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(11869,null),s.localize(11870,null)],default:Q.insertMode,description:s.localize(11871,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(11872,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(11873,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(11874,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(11875,null),s.localize(11876,null),s.localize(11877,null),s.localize(11878,null)],default:Q.selectionMode,markdownDescription:s.localize(11879,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(11880,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(11881,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(11882,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(11883,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(11884,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(11885,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(11886,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(11887,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(11888,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(11889,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(11890,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(11891,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(11892,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(11893,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(11894,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(11895,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(11896,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(11897,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(11898,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(11899,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(11900,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(11901,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(11902,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(11903,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(11904,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(11905,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(11906,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(11907,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(11908,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(11909,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(11910,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(11911,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(11912,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(11913,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(11914,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(11915,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(11916,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertMode:h(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ee.preview,this.defaultValue.preview),previewMode:h(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ee.showMethods,this.defaultValue.showMethods),showFunctions:i(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ee.showFields,this.defaultValue.showFields),showVariables:i(Ee.showVariables,this.defaultValue.showVariables),showClasses:i(Ee.showClasses,this.defaultValue.showClasses),showStructs:i(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ee.showModules,this.defaultValue.showModules),showProperties:i(Ee.showProperties,this.defaultValue.showProperties),showEvents:i(Ee.showEvents,this.defaultValue.showEvents),showOperators:i(Ee.showOperators,this.defaultValue.showOperators),showUnits:i(Ee.showUnits,this.defaultValue.showUnits),showValues:i(Ee.showValues,this.defaultValue.showValues),showConstants:i(Ee.showConstants,this.defaultValue.showConstants),showEnums:i(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ee.showKeywords,this.defaultValue.showKeywords),showWords:i(Ee.showWords,this.defaultValue.showWords),showColors:i(Ee.showColors,this.defaultValue.showColors),showFiles:i(Ee.showFiles,this.defaultValue.showFiles),showReferences:i(Ee.showReferences,this.defaultValue.showReferences),showFolders:i(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ee.showUsers,this.defaultValue.showUsers),showIssues:i(Ee.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(11917,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(11918,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const Q=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:s.localize(11919,null),type:"string"},{description:s.localize(11920,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const Ee=[];for(const Je of Q)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&Ee.push(Je)}catch{}return Ee}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(11921,null),s.localize(11922,null),s.localize(11923,null),s.localize(11924,null)],description:s.localize(11925,null),default:"same"}})}validate(Q){switch(Q){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(Q,Ee,Je){return Ee.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?et.None:Je}}class mt extends c{constructor(){super(je.wrappingInfo)}compute(Q,Ee,Je){const xe=Ee.get(je.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class ut extends d{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11926,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(11927,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(11928,null),s.localize(11929,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showDropSelector:h(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11930,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(11931,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(11932,null),s.localize(11933,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:i(Ee.enabled,this.defaultValue.enabled),showPasteSelector:h(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",ft="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?ft:P.$l?pt:ct,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var je;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new r(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(11934,null)})),acceptSuggestionOnEnter:qe(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(11935,null),""],markdownDescription:s.localize(11936,null)})),accessibilitySupport:qe(new k),accessibilityPageSize:qe(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11937,null),tags:["accessibility"]})),ariaLabel:qe(new p(je.ariaLabel,"ariaLabel",s.localize(11938,null))),ariaRequired:qe(new r(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new r(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(11939,null),tags:["accessibility"]})),autoClosingBrackets:qe(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11940,null),s.localize(11941,null),""],description:s.localize(11942,null)})),autoClosingComments:qe(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11943,null),s.localize(11944,null),""],description:s.localize(11945,null)})),autoClosingDelete:qe(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11946,null),""],description:s.localize(11947,null)})),autoClosingOvertype:qe(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11948,null),""],description:s.localize(11949,null)})),autoClosingQuotes:qe(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11950,null),s.localize(11951,null),""],description:s.localize(11952,null)})),autoIndent:qe(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[s.localize(11953,null),s.localize(11954,null),s.localize(11955,null),s.localize(11956,null),s.localize(11957,null)],description:s.localize(11958,null)})),automaticLayout:qe(new r(je.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(11959,null),s.localize(11960,null),s.localize(11961,null),""],description:s.localize(11962,null)})),bracketPairColorization:qe(new Ie),bracketPairGuides:qe(new ze),stickyTabStops:qe(new r(je.stickyTabStops,"stickyTabStops",!1,{description:s.localize(11963,null)})),codeLens:qe(new r(je.codeLens,"codeLens",!0,{description:s.localize(11964,null)})),codeLensFontFamily:qe(new p(je.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(11965,null)})),codeLensFontSize:qe(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(11966,null)})),colorDecorators:qe(new r(je.colorDecorators,"colorDecorators",!0,{description:s.localize(11967,null)})),colorDecoratorActivatedOn:qe(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(11968,null),s.localize(11969,null),s.localize(11970,null)],description:s.localize(11971,null)})),colorDecoratorsLimit:qe(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(11972,null)})),columnSelection:qe(new r(je.columnSelection,"columnSelection",!1,{description:s.localize(11973,null)})),comments:qe(new C),contextmenu:qe(new r(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new r(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(11974,null)})),cursorBlinking:qe(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:s.localize(11975,null)})),cursorSmoothCaretAnimation:qe(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(11976,null),s.localize(11977,null),s.localize(11978,null)],description:s.localize(11979,null)})),cursorStyle:qe(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:s.localize(11980,null)})),cursorSurroundingLines:qe(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11981,null)})),cursorSurroundingLinesStyle:qe(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(11982,null),s.localize(11983,null)],markdownDescription:s.localize(11984,null)})),cursorWidth:qe(new g(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(11985,null)})),disableLayerHinting:qe(new r(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new r(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new r(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new r(je.dragAndDrop,"dragAndDrop",!0,{description:s.localize(11986,null)})),emptySelectionClipboard:qe(new J),dropIntoEditor:qe(new ut),stickyScroll:qe(new q),experimentalWhitespaceRendering:qe(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(11987,null),s.localize(11988,null),s.localize(11989,null)],description:s.localize(11990,null)})),extraEditorClassName:qe(new p(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new m(je.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:s.localize(11991,null)})),find:qe(new M),fixedOverflowWidgets:qe(new r(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new r(je.folding,"folding",!0,{description:s.localize(11992,null)})),foldingStrategy:qe(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(11993,null),s.localize(11994,null)],description:s.localize(11995,null)})),foldingHighlight:qe(new r(je.foldingHighlight,"foldingHighlight",!0,{description:s.localize(11996,null)})),foldingImportsByDefault:qe(new r(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(11997,null)})),foldingMaximumRegions:qe(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(11998,null)})),unfoldOnClickAfterEndOfLine:qe(new r(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(11999,null)})),fontFamily:qe(new p(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(12e3,null)})),fontInfo:qe(new ue),fontLigatures2:qe(new K),fontSize:qe(new _),fontWeight:qe(new ge),fontVariations:qe(new Z),formatOnPaste:qe(new r(je.formatOnPaste,"formatOnPaste",!1,{description:s.localize(12001,null)})),formatOnType:qe(new r(je.formatOnType,"formatOnType",!1,{description:s.localize(12002,null)})),glyphMargin:qe(new r(je.glyphMargin,"glyphMargin",!0,{description:s.localize(12003,null)})),gotoLocation:qe(new se),hideCursorInOverviewRuler:qe(new r(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(12004,null)})),hover:qe(new ae),inDiffEditor:qe(new r(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new m(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>m.clamp(ee,-5,20),{description:s.localize(12005,null)})),lightbulb:qe(new Y),lineDecorationsWidth:qe(new ve),lineHeight:qe(new ce),lineNumbers:qe(new Se),lineNumbersMinChars:qe(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new r(je.linkedEditing,"linkedEditing",!1,{description:s.localize(12006,null)})),links:qe(new r(je.links,"links",!0,{description:s.localize(12007,null)})),matchBrackets:qe(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(12008,null)})),minimap:qe(new we),mouseStyle:qe(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new m(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:s.localize(12009,null)})),mouseWheelZoom:qe(new r(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?s.localize(12010,null):s.localize(12011,null)})),multiCursorMergeOverlapping:qe(new r(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(12012,null)})),multiCursorModifier:qe(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[s.localize(12013,null),s.localize(12014,null)],markdownDescription:s.localize(12015,null)})),multiCursorPaste:qe(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(12016,null),s.localize(12017,null)],markdownDescription:s.localize(12018,null)})),multiCursorLimit:qe(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(12019,null)})),occurrencesHighlight:qe(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(12020,null),s.localize(12021,null),s.localize(12022,null)],markdownDescription:s.localize(12023,null)})),overviewRulerBorder:qe(new r(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(12024,null)})),overviewRulerLanes:qe(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new X),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(12025,null),s.localize(12026,null)],description:s.localize(12027,null)})),placeholder:qe(new pe),definitionLinkOpensInPeek:qe(new r(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(12028,null)})),quickSuggestions:qe(new Ae),quickSuggestionsDelay:qe(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(12029,null)})),readOnly:qe(new r(je.readOnly,"readOnly",!1)),readOnlyMessage:qe(new j),renameOnType:qe(new r(je.renameOnType,"renameOnType",!1,{description:s.localize(12030,null),markdownDeprecationMessage:s.localize(12031,null)})),renderControlCharacters:qe(new r(je.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(12032,null),restricted:!0})),renderFinalNewline:qe(new E(je.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(12033,null)})),renderLineHighlight:qe(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(12034,null)],description:s.localize(12035,null)})),renderLineHighlightOnlyWhenFocus:qe(new r(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(12036,null)})),renderValidationDecorations:qe(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(12037,null),s.localize(12038,null),s.localize(12039,null),""],description:s.localize(12040,null)})),revealHorizontalRightPadding:qe(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new r(je.roundedSelection,"roundedSelection",!0,{description:s.localize(12041,null)})),rulers:qe(new Te),scrollbar:qe(new H),scrollBeyondLastColumn:qe(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(12042,null)})),scrollBeyondLastLine:qe(new r(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(12043,null)})),scrollPredominantAxis:qe(new r(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(12044,null)})),selectionClipboard:qe(new r(je.selectionClipboard,"selectionClipboard",!0,{description:s.localize(12045,null),included:P.$l})),selectionHighlight:qe(new r(je.selectionHighlight,"selectionHighlight",!0,{description:s.localize(12046,null)})),selectOnLineNumbers:qe(new r(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(12047,null),s.localize(12048,null),s.localize(12049,null)],description:s.localize(12050,null)})),showUnused:qe(new r(je.showUnused,"showUnused",!0,{description:s.localize(12051,null)})),showDeprecated:qe(new r(je.showDeprecated,"showDeprecated",!0,{description:s.localize(12052,null)})),inlayHints:qe(new te),snippetSuggestions:qe(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(12053,null),s.localize(12054,null),s.localize(12055,null),s.localize(12056,null)],description:s.localize(12057,null)})),smartSelect:qe(new tt),smoothScrolling:qe(new r(je.smoothScrolling,"smoothScrolling",!1,{description:s.localize(12058,null)})),stopRenderingLineAfter:qe(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new _e),inlineSuggest:qe(new ne),inlineEdit:qe(new fe),inlineCompletionsAccessibilityVerbose:qe(new r(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(12059,null)})),suggestFontSize:qe(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(12060,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(12061,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new r(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(12062,null)})),suggestSelection:qe(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(12063,null),s.localize(12064,null),s.localize(12065,null)],description:s.localize(12066,null)})),tabCompletion:qe(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(12067,null),s.localize(12068,null),s.localize(12069,null)],description:s.localize(12070,null)})),tabIndex:qe(new g(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new V),unusualLineTerminators:qe(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(12071,null),s.localize(12072,null),s.localize(12073,null)],description:s.localize(12074,null)})),useShadowDOM:qe(new r(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new r(je.useTabStops,"useTabStops",!0,{description:s.localize(12075,null)})),wordBreak:qe(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(12076,null),s.localize(12077,null)],description:s.localize(12078,null)})),wordSegmenterLocales:qe(new nt),wordSeparators:qe(new p(je.wordSeparators,"wordSeparators",$.$kt,{description:s.localize(12079,null)})),wordWrap:qe(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(12080,null),s.localize(12081,null),s.localize(12082,null),s.localize(12083,null)],description:s.localize(12084,null)})),wordWrapBreakAfterCharacters:qe(new p(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new p(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new g(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(12085,null)})),wordWrapOverride1:qe(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new W),defaultColorDecorators:qe(new r(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(12086,null)})),pixelRatio:qe(new me),tabFocusMode:qe(new r(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(12087,null)})),layoutInfo:qe(new oe),wrappingInfo:qe(new mt),wrappingIndent:qe(new rt),wrappingStrategy:qe(new ke)}}),define(Oe[106],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=void 0,e.$Ki=(0,v.$Di)("environmentService"),e.$Li=(0,v.$Ei)(e.$Ki)}),define(Oe[29],Ne([1,0,58,19,12,14,2,9,3,20,15,48]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=a,e.$al=o,e.$bl=u,e.$cl=i,e.$dl=r,e.$el=t,e.$fl=g,e.$gl=l,e.$hl=m,e.$il=p,e.$jl=h,e.$ll=b,e.$ml=k,e.$nl=C,e.$ol=f,e.$pl=w,e.$sl=J,e.$El=ge,e.$Fl=se,e.$Hl=$e,e.$$k=(0,$.$Di)("fileService");function a(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function o(oe){const ke=oe;return!!ke&&typeof ke.onDidChange=="function"}var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function u(oe){return!!(oe.capabilities&c.FileReadWrite)}function i(oe){return!!(oe.capabilities&c.FileFolderCopy)}function r(oe){return!!(oe.capabilities&c.FileClone)}function t(oe){return!!(oe.capabilities&c.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&c.FileReadStream)}function l(oe){return u(oe)?!!(oe.capabilities&c.FileAtomicRead):!1}function m(oe){return u(oe)?!!(oe.capabilities&c.FileAtomicWrite):!1}function p(oe){return!!(oe.capabilities&c.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&c.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ke,Le){const Y=new D(ke.toString(),Le);return C(Y,Le),Y}constructor(ke,Le){super(ke),this.code=Le}}e.$kl=D;function b(oe,ke){return D.create(oe,ke)}function k(oe){return oe||b((0,T.localize)(11330,null),E.Unknown)}function C(oe,ke){return oe.name=ke?`${ke} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return E.Unknown;if(oe instanceof D)return oe.code;const ke=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ke)return E.Unknown;switch(ke[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function w(oe){if(oe instanceof M)return oe.fileOperationResult;switch(f(oe)){case E.FileNotFound:return ue.FILE_NOT_FOUND;case E.FileIsADirectory:return ue.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ue.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ue.FILE_WRITE_LOCKED;case E.NoPermissions:return ue.FILE_PERMISSION_DENIED;case E.FileExists:return ue.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ue.FILE_TOO_LARGE;default:return ue.FILE_OTHER_ERROR}}var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ke,Le,Y){this.resource=ke,this.operation=Le,this.target=Y}isOperation(ke){return this.operation===ke}}e.$ql=N;var L;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class W{static{this.a=null}constructor(ke,Le){this.c=Le,this.b=void 0,this.d=new y.$T(()=>{const Y=v.$Ji.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new y.$T(()=>{const Y=v.$Ji.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new y.$T(()=>{const Y=v.$Ji.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ke){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(ke,...Le){return this.h(ke,{includeChildren:!1},...Le)}affects(ke,...Le){return this.h(ke,{includeChildren:!0},...Le)}h(ke,Le,...Y){if(!ke)return!1;const q=Y.length>0;return!!((!q||Y.includes(L.ADDED))&&(this.d.value.get(ke)||Le.includeChildren&&this.d.value.findSuperstr(ke))||(!q||Y.includes(L.UPDATED))&&(this.f.value.get(ke)||Le.includeChildren&&this.f.value.findSuperstr(ke))||(!q||Y.includes(L.DELETED))&&(this.g.value.findSubstr(ke)||Le.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$rl=W;function J(oe,ke,Le){return!oe||!ke||oe===ke||ke.length>oe.length?!1:(ke.charAt(ke.length-1)!==I.sep&&(ke+=I.sep),Le?(0,P.$Ff)(oe,ke):oe.indexOf(ke)===0)}class M extends Error{constructor(ke,Le,Y){super(ke),this.fileOperationResult=Le,this.options=Y}}e.$tl=M;class K extends M{constructor(ke,Le,Y,q){super(ke,Le,q),this.fileOperationResult=Le,this.size=Y}}e.$ul=K;class Z extends M{constructor(ke,Le,Y){super(ke,ue.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Le}}e.$vl=Z;var ue;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var _;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Dl="";function ge(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,ke){if(!ke.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Le=>{const Y=ke.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===oe.scheme&&q.added&&(Y.dispose(),Le())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(ke){return(0,O.$hg)(ke)||(ke=0),ke<ae.KB?(0,T.localize)(11331,null,ke.toFixed(0)):ke<ae.MB?(0,T.localize)(11332,null,(ke/ae.KB).toFixed(2)):ke<ae.GB?(0,T.localize)(11333,null,(ke/ae.MB).toFixed(2)):ke<ae.TB?(0,T.localize)(11334,null,(ke/ae.GB).toFixed(2)):(0,T.localize)(11335,null,(ke/ae.TB).toFixed(2))}}e.$Gl=ae;function $e(oe){const ke=typeof oe=="string"||oe?.scheme===R.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===R.Schemas.file?1024*ae.MB:ke?10*ae.MB:s.$p?50*ae.MB:1024*ae.MB}}),define(Oe[74],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class v{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Bi=v}),define(Oe[170],Ne([1,0,10,13,4,73,167,3,74,171]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const R=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class a{constructor(o=new $.$Bi,c=!1,u,i=R){this.i=o,this.j=c,this.k=u,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ci,this),this._globalGraph=i?u?._globalGraph??new A.$tr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Oc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Nc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,c){this.m();const u=this,i=new class extends a{dispose(){u.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(o,...c){this.m();const u=d.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,I.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,u);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,u.stop()}}createInstance(o,...c){this.m();let u,i;return o instanceof O.$Ai?(u=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(c),u)):(u=d.traceCreation(this.l,o),i=this.o(o,c,u)),u.stop(),i}o(o,c=[],u){const i=T._util.getServiceDependencies(o).sort((g,l)=>g.index-l.index),r=[];for(const g of i){const l=this.s(g.id,u);l||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(o,c.concat(r))}q(o,c){if(this.i.get(o)instanceof O.$Ai)this.i.set(o,c);else if(this.k)this.k.q(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const c=this.i.get(o);return!c&&this.k?this.k.r(o):c}s(o,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const u=this.r(o);return u instanceof O.$Ai?this.u(o,u,c.branch(o,!0)):(c.branch(o,!1),u)}u(o,c,u){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,c,u)}finally{this.t.delete(o)}}v(o,c,u){const i=new A.$tr(l=>l.id.toString());let r=0;const t=[{id:o,desc:c,_trace:u}],g=new Set;for(;t.length;){const l=t.pop();if(!g.has(String(l.id))){if(g.add(String(l.id)),i.lookupOrInsertNode(l),r++>1e3)throw new y(i);for(const m of T._util.getServiceDependencies(l.desc.ctor)){const p=this.r(m.id);if(p||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(m.id)),p instanceof O.$Ai){const h={id:m.id,desc:p,_trace:l._trace.branch(m.id,!0)};i.insertEdge(l,h),t.push(h)}}}}for(;;){const l=i.roots();if(l.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:m}of l){if(this.r(m.id)instanceof O.$Ai){const h=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,h)}i.removeNode(m)}}return this.r(o)}w(o,c,u=[],i,r){if(this.i.get(o)instanceof O.$Ai)return this.x(o,c,u,i,r,this.g);if(this.k)return this.k.w(o,c,u,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(o,c,u=[],i,r,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(o);const l=new Map,m=new v.$Wh(()=>{const p=g.o(c,u,r);for(const[h,E]of l){const D=p[h];if(typeof D=="function")for(const b of E)b.disposable=D.apply(p,b.listener)}return l.clear(),t.add(p),p});return new Proxy(Object.create(null),{get(p,h){if(!m.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let b=l.get(h);return b||(b=new s.$4c,l.set(h,b)),(C,f,w)=>{if(m.isInitialized)return m.value[h](C,f,w);{const F={listener:[C,f,w],disposable:void 0},N=b.push(F);return(0,P.$Rc)(()=>{N(),F.disposable?.dispose()})}}}if(h in p)return p[h];const E=m.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),p[h]=D),D},set(p,h,E){return m.value[h]=E,!0},getPrototypeOf(p){return c.prototype}})}else{const g=this.o(c,u,r);return t.add(g),g}}y(o,c){if(c&&console.warn(o),this.j)throw new Error(o)}}e.$ur=a;var S;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,c){return o?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,c){return o?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(o,c){this.type=o,this.name=c,this.g=Date.now(),this.h=[]}branch(o,c){const u=new d(S.Branch,o.toString());return this.h.push([o,c,u]),u}stop(){const o=Date.now()-this.g;d.f+=o;let c=!1;function u(r,t){const g=[],l=new Array(r+1).join("	");for(const[m,p,h]of t.h)if(p&&h){c=!0,g.push(`${l}CREATES -> ${m}`);const E=u(r+1,h);E&&g.push(E)}else g.push(`${l}uses -> ${m}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||c)&&d.all.add(i.join(`
`))}}e.$vr=d}),define(Oe[11],Ne([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=n,e.log=c,e.$mk=D,e.$nk=b,e.$ok=k,e.$pk=C,v=We(v),e.$$j=(0,S.$Di)("logService"),e.$_j=(0,S.$Di)("loggerService");function d(){return new Date().toISOString()}function n(f){return(0,R.$hg)(f)}var o;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$bk=o.Info;function c(f,w,F){switch(w){case o.Trace:f.trace(F);break;case o.Debug:f.debug(F);break;case o.Info:f.info(F);break;case o.Warning:f.warn(F);break;case o.Error:f.error(F);break;case o.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function u(f,w=!1){let F="";for(let N=0;N<f.length;N++){let L=f[N];if(L instanceof Error&&(L=(0,I.$oj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}F+=(N>0?" ":"")+L}return F}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new P.$ke),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==o.Off&&this.b<=w}}e.$dk=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...F){this.f(o.Trace)&&this.g(o.Trace,u([w,...F],!0))}debug(w,...F){this.f(o.Debug)&&this.g(o.Debug,u([w,...F]))}info(w,...F){this.f(o.Info)&&this.g(o.Info,u([w,...F]))}warn(w,...F){this.f(o.Warning)&&this.g(o.Warning,u([w,...F]))}error(w,...F){if(this.f(o.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(o.Error,u(N))}else this.g(o.Error,u([w,...F]))}flush(){}}e.$ek=r;class t extends i{constructor(w=e.$bk){super(),this.setLevel(w),this.g=!$.$j}trace(w,...F){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}debug(w,...F){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}info(w,...F){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}warn(w,...F){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...F):console.warn(`[main ${d()}]`,w,...F))}error(w,...F){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...F):console.error(`[main ${d()}]`,w,...F))}flush(){}}e.$fk=t;class g extends i{constructor(w=e.$bk,F=!0){super(),this.g=F,this.setLevel(w)}trace(w,...F){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...F):console.log(w,...F))}debug(w,...F){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...F):console.log(w,...F))}info(w,...F){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...F):console.log(w,...F))}warn(w,...F){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...F):console.log(w,...F))}error(w,...F){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...F):console.error(w,...F))}flush(){}}e.$gk=g;class l extends i{constructor(w,F=e.$bk){super(),this.g=w,this.setLevel(F)}trace(w,...F){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(w),...F])}debug(w,...F){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(w),...F])}info(w,...F){this.f(o.Info)&&this.g.log(o.Info,[this.h(w),...F])}warn(w,...F){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(w),...F])}error(w,...F){this.f(o.Error)&&this.g.log(o.Error,[this.h(w),...F])}h(w){return typeof w=="string"?w:(0,I.$oj)(w,this.f(o.Trace))}flush(){}}e.$hk=l;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const F of this.g)F.setLevel(w);super.setLevel(w)}trace(w,...F){for(const N of this.g)N.trace(w,...F)}debug(w,...F){for(const N of this.g)N.debug(w,...F)}info(w,...F){for(const N of this.g)N.info(w,...F)}warn(w,...F){for(const N of this.g)N.warn(w,...F)}error(w,...F){for(const N of this.g)N.error(w,...F)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$ik=m;class p extends A.$Tc{constructor(w,F,N){if(super(),this.h=w,this.j=F,this.b=new T.$zc,this.c=this.B(new P.$ke),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$ke),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$ke),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,R.$dg)(w)?[...this.b.values()].find(F=>F.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,F){const N=this.n(w),L=(0,R.$dg)(w)?w:F?.id??(0,O.$rj)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const J=F?.logLevel==="always"?o.Trace:F?.logLevel;W||(W=this.s(N,J??this.getLogLevel(N)??this.h,{...F,id:L}));const M={logger:W,info:{resource:N,id:L,logLevel:J,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(N,M),W}n(w){return(0,R.$dg)(w)?(0,s.$eh)(this.j,`${w}.log`):w}setLogLevel(w,F){if(y.URI.isUri(w)){const N=w,L=F,W=this.b.get(N);W&&L!==W.info.logLevel&&(W.info.logLevel=L===this.h?void 0:L,W.logger?.setLevel(L),this.b.set(W.info.resource,W),this.f.fire([N,L]))}else{this.h=w;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,F){const N=this.m(w);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(w){let F;return w&&(F=this.b.get(w)?.info.logLevel),F??this.h}registerLogger(w){const F=this.b.get(w.resource);F?F.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const F=this.b.get(w);F&&(F.logger&&F.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=p;class h{constructor(){this.onDidChangeLogLevel=new P.$ke().event}setLevel(w){}getLevel(){return o.Info}trace(w,...F){}debug(w,...F){}info(w,...F){}warn(w,...F){}error(w,...F){}critical(w,...F){}dispose(){}flush(){}}e.$kk=h;class E extends h{}e.$lk=E;function D(f){if(f.verbose)return o.Trace;if(typeof f.logLevel=="string"){const w=C(f.logLevel.toLowerCase());if(w!==void 0)return w}return e.$bk}function b(f){switch(f){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function k(f){switch(f){case o.Trace:return{original:"Trace",value:v.localize(11263,null)};case o.Debug:return{original:"Debug",value:v.localize(11264,null)};case o.Info:return{original:"Info",value:v.localize(11265,null)};case o.Warning:return{original:"Warning",value:v.localize(11266,null)};case o.Error:return{original:"Error",value:v.localize(11267,null)};case o.Off:return{original:"Off",value:v.localize(11268,null)}}}function C(f){switch(f){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$qk=new a.$Uj("logLevel",b(o.Info))}),define(Oe[172],Ne([1,0,4,11]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class P extends v.$Tc{constructor(A,T=[]){super(),this.a=new I.$ik([A,...T]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$ER=P});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[107],Ne([1,0,35,9,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=ri(v);var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function s(d,n){return n-d}$.compare=s;const R=Object.create(null);R[$.Error]=(0,I.localize)(11260,null),R[$.Warning]=(0,I.localize)(11261,null),R[$.Info]=(0,I.localize)(11262,null);function y(d){return R[d]||""}$.toString=y;function a(d){switch(d){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=a;function S(d){switch(d){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=S}(A||(e.MarkerSeverity=A={}));var T;(function($){const s="";function R(a){return y(a,!0)}$.makeKey=R;function y(a,S){const d=[s];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(s),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(s),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(s),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(s),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(s),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(s),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(s),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(s),d.push(s),d.join("\xA6")}$.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Eu=(0,P.$Di)("markerService")});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[173],Ne([1,0,6,35,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$tw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$rw=e.Severity=void 0,e.$sw=T,I=ri(I),e.Severity=I.default,e.$rw=(0,P.$Di)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class s{constructor(){this.progress=new R,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$tw=s;class R{infinite(){}done(){}total(a){}worked(a){}}e.$uw=R}),define(Oe[108],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,v.$Di)("productService"),e.$sk="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(be,e,v,I){var P=arguments.length,O=P<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,v):I,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(be,e,v,I);else for(var T=be.length-1;T>=0;T--)(A=be[T])&&(O=(P<3?A(O):P>3?A(e,v,O):A(e,v))||O);return P>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(be,e){return function(v,I){e(v,I,be)}};define(Oe[76],Ne([1,0,10,21,4,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.ProgressLocation=e.$vw=void 0,e.$vw=(0,O.$Di)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$ww=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$xw=T;class ${get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$yw=$;let s=class extends P.$Tc{constructor(a,S){super(),this.a=new v.$1h,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$zw=s,e.$zw=s=Ge([Ve(1,e.$vw)],s);class R extends P.$Tc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Sc)}start(a){this.stop();const S=++this.a,d=new I.$ve;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>d.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$Aw=R,e.$Bw=(0,O.$Di)("editorProgressService")}),define(Oe[30],Ne([1,0,61,14]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,v=We(v),I=We(I);class P{constructor(){this.a=new Map}add(A,T){v.ok(I.$dg(A)),v.ok(I.$fg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$po=new P}),define(Oe[77],Ne([1,0,6,137,30]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,P=We(P),e.$qo={JSONContribution:"base.contributions.json"};function O($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class A{constructor(){this.b=new v.$ke,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,R){this.a[O(s)]=R,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const R=this.a[s];return R?(0,I.$6j)(R):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new A;P.$po.add(e.$qo.JSONContribution,T)}),define(Oe[53],Ne([1,0,17,6,14,9,43,77,30]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=n,e.$Go=o,e.$Ho=c,e.$Io=i,e.$Jo=r,e.$Ko=t,e.$Lo=g,P=We(P),O=We(O);var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$uo={Configuration:"base.contributions.configuration"};var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const y=$.$po.as(T.$qo.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new I.$ke,this.onDidSchemaChange=this.j.event,this.k=new I.$ke,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11556,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Bo,this.h),this.z()}registerConfiguration(m,p=!0){this.registerConfigurations([m],p)}registerConfigurations(m,p=!0){const h=new Set;this.r(m,p,h),y.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(m){const p=new Set;this.s(m,p),y.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:p})}updateConfigurations({add:m,remove:p}){const h=new Set;this.s(p,h),this.r(m,!1,h),y.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(m){const p=new Set;this.l(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}l(m,p){this.a.push(...m);const h=[];for(const{overrides:E,source:D}of m)for(const b in E){p.add(b);const k=this.b.get(b)??this.b.set(b,{configurationDefaultOverrides:[]}).get(b),C=E[b];if(k.configurationDefaultOverrides.push({value:C,source:D}),e.$Eo.test(b)){const f=this.o(b,C,D,k.configurationDefaultOverrideValue);if(!f)continue;k.configurationDefaultOverrideValue=f,this.n(b,f,D),h.push(...n(b))}else{const f=this.p(b,C,D,k.configurationDefaultOverrideValue);if(!f)continue;k.configurationDefaultOverrideValue=f;const w=this.e[b];w&&(this.A(b,w),this.w(b,w))}}this.q(h)}deregisterDefaultConfigurations(m){const p=new Set;this.m(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}m(m,p){for(const h of m){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of m)for(const D in h){const b=this.b.get(D);if(!b)continue;const k=b.configurationDefaultOverrides.findIndex(C=>E?C.source?.id===E.id:C.value===h[D]);if(k!==-1){if(b.configurationDefaultOverrides.splice(k,1),b.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Eo.test(D)){let C;for(const f of b.configurationDefaultOverrides)C=this.o(D,f.value,f.source,C);C&&!P.$qg(C.value)?(b.configurationDefaultOverrideValue=C,this.n(D,C,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let C;for(const w of b.configurationDefaultOverrides)C=this.p(D,w.value,w.source,C);b.configurationDefaultOverrideValue=C;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}p.add(D)}}this.y()}n(m,p,h){const E={type:"object",default:p.value,description:O.localize(11557,null,(0,A.$hj)(m)),$ref:e.$Bo,defaultDefaultValue:p.value,source:h,defaultValueSource:h};this.e[m]=E,this.c.properties[m]=E}o(m,p,h,E){const D=E?.value||{},b=E?.source??new Map;if(!(b instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(p)){const C=p[k];if(P.$fg(C)&&(P.$kg(D[k])||P.$fg(D[k]))){if(D[k]={...D[k]??{},...C},h)for(const w in C)b.set(`${k}.${w}`,h)}else D[k]=C,h?b.set(k,h):b.delete(k)}return{value:D,source:b}}p(m,p,h,E){const D=this.e[m],b=E?.value??D?.defaultDefaultValue;let k=h;if(P.$fg(p)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.$kg(b)||P.$fg(b)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in p)h&&k.set(`${m}.${f}`,h);p={...P.$fg(b)?b:{},...p}}return{value:p,source:k}}deltaConfiguration(m){let p=!1;const h=new Set;m.removedDefaults&&(this.m(m.removedDefaults,h),p=!0),m.addedDefaults&&(this.l(m.addedDefaults,h),p=!0),m.removedConfigurations&&this.s(m.removedConfigurations,h),m.addedConfigurations&&this.r(m.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const p of m)this.i.add(p);this.y()}r(m,p,h){m.forEach(E=>{this.u(E,p,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s(m,p){const h=E=>{if(E.properties)for(const D in E.properties){p.add(D);const b=this.e[D];b?.policy?.name&&this.f.delete(b.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of m){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(m,p=!0,h,E,D=R.WINDOW,b){D=P.$mg(m.scope)?D:m.scope;const k=m.properties;if(k)for(const f in k){const w=k[f];if(p&&i(f,w)){delete k[f];continue}if(w.source=h,w.defaultDefaultValue=k[f].default,this.A(f,w),e.$Eo.test(f)?w.scope=void 0:(w.scope=P.$mg(w.scope)?D:w.scope,w.restricted=P.$mg(w.restricted)?!!E?.includes(f):w.restricted),k[f].hasOwnProperty("included")&&!k[f].included){this.g[f]=k[f],delete k[f];continue}else this.e[f]=k[f],k[f].policy?.name&&this.f.set(k[f].policy.name,f);!k[f].deprecationMessage&&k[f].markdownDeprecationMessage&&(k[f].deprecationMessage=k[f].markdownDeprecationMessage),b.add(f)}const C=m.allOf;if(C)for(const f of C)this.u(f,p,h,E,D,b)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[p,h]of this.b)h.configurationDefaultOverrideValue&&m.set(p,h.configurationDefaultOverrideValue);return m}v(m){const p=h=>{const E=h.properties;if(E)for(const b in E)this.w(b,E[b]);h.allOf?.forEach(p)};p(m)}w(m,p){switch(e.$vo.properties[m]=p,p.scope){case R.APPLICATION:e.$wo.properties[m]=p;break;case R.MACHINE:e.$xo.properties[m]=p;break;case R.MACHINE_OVERRIDABLE:e.$yo.properties[m]=p;break;case R.WINDOW:e.$zo.properties[m]=p;break;case R.RESOURCE:e.$Ao.properties[m]=p;break;case R.LANGUAGE_OVERRIDABLE:e.$Ao.properties[m]=p,this.h.properties[m]=p;break}}x(m,p){switch(delete e.$vo.properties[m],p.scope){case R.APPLICATION:delete e.$wo.properties[m];break;case R.MACHINE:delete e.$xo.properties[m];break;case R.MACHINE_OVERRIDABLE:delete e.$yo.properties[m];break;case R.WINDOW:delete e.$zo.properties[m];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const p=`[${m}]`,h={type:"object",description:O.localize(11558,null),errorMessage:O.localize(11559,null),$ref:e.$Bo};this.A(p,h),e.$vo.properties[p]=h,e.$wo.properties[p]=h,e.$xo.properties[p]=h,e.$yo.properties[p]=h,e.$zo.properties[p]=h,e.$Ao.properties[p]=h}}z(){const m={type:"object",description:O.localize(11560,null),errorMessage:O.localize(11561,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=m,e.$wo.patternProperties[e.$Do]=m,e.$xo.patternProperties[e.$Do]=m,e.$yo.patternProperties[e.$Do]=m,e.$zo.patternProperties[e.$Do]=m,e.$Ao.patternProperties[e.$Do]=m,this.j.fire()}A(m,p){const h=this.b.get(m)?.configurationDefaultOverrideValue;let E,D;h&&(!p.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),P.$kg(E)&&(E=p.defaultDefaultValue,D=void 0),P.$kg(E)&&(E=c(p.type)),p.default=E,p.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Do=`^(${S})+$`,e.$Eo=new RegExp(e.$Do);function n(l){const m=[];if(e.$Eo.test(l)){let p=d.exec(l);for(;p?.length;){const h=p[1].trim();h&&m.push(h),p=d.exec(l)}}return(0,v.$Lb)(m)}function o(l){return l.reduce((m,p)=>`${m}[${p}]`,"")}function c(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new a;$.$po.add(e.$uo.Configuration,u);function i(l,m){return l.trim()?e.$Eo.test(l)?O.localize(11563,null,l):u.getConfigurationProperties()[l]!==void 0?O.localize(11564,null,l):m.policy?.name&&u.getPolicyConfigurations().get(m.policy?.name)!==void 0?O.localize(11565,null,l,m.policy?.name,u.getPolicyConfigurations().get(m.policy?.name)):null:O.localize(11562,null)}function r(){const l=[],m=u.getConfigurationProperties();for(const p of Object.keys(m))l.push([p,m[p].scope]);return l.push(["launch",R.RESOURCE]),l.push(["task",R.RESOURCE]),l}function t(l){const m={};for(const p of l){const h=p.properties;if(P.$fg(h))for(const E in h)m[E]=h[E];p.allOf&&Object.assign(m,t(p.allOf))}return m}function g(l){switch(l){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(Oe[174],Ne([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=r,v=We(v),P=We(P),T=We(T),$=We($);function d(m){return Object.isFrozen(m)?m:T.$do(m)}class n{static createEmptyModel(p){return new n({},[],[],void 0,p)}constructor(p,h,E,D,b){this.b=p,this.c=h,this.d=E,this.raw=D,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const p=this.raw.map(h=>{if(h instanceof n)return h;const E=new o("",this.f);return E.parseRaw(h),E.configurationModel});this.g=p.reduce((h,E)=>E===h?E:h.merge(E),p[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(p){return p?(0,R.$fj)(this.contents,p):this.contents}inspect(p,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(p))},get override(){return h?d(E.rawConfiguration.getOverrideValue(p,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(p):E.rawConfiguration.getValue(p))},get overrides(){const D=[];for(const{contents:b,identifiers:k,keys:C}of E.rawConfiguration.overrides){const f=new n(b,C,[],void 0,E.f).getValue(p);f!==void 0&&D.push({identifiers:k,value:f})}return D.length?d(D):void 0}}}getOverrideValue(p,h){const E=this.j(h);return E?p?(0,R.$fj)(E,p):E:void 0}getKeysForOverrideIdentifier(p){const h=[];for(const E of this.overrides)E.identifiers.includes(p)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const p=[];for(const h of this.overrides)p.push(...h.identifiers);return v.$Lb(p)}override(p){let h=this.a.get(p);return h||(h=this.h(p),this.a.set(p,h)),h}merge(...p){const h=T.$co(this.contents),E=T.$co(this.overrides),D=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const k of p)if(b.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(h,k.contents);for(const C of k.overrides){const[f]=E.filter(w=>v.$tb(w.identifiers,C.identifiers));f?(this.i(f.contents,C.contents),f.keys.push(...C.keys),f.keys=v.$Lb(f.keys)):E.push(T.$co(C))}for(const C of k.keys)D.indexOf(C)===-1&&D.push(C)}return new n(h,D,E,b.every(k=>k instanceof n)?void 0:b,this.f)}h(p){const h=this.j(p);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let b=this.contents[D];const k=h[D];k&&(typeof b=="object"&&typeof k=="object"?(b=T.$co(b),this.i(b,k)):b=k),E[D]=b}return new n(E,this.keys,this.overrides,void 0,this.f)}i(p,h){for(const E of Object.keys(h)){if(E in p&&$.$fg(p[E])&&$.$fg(h[E])){this.i(p[E],h[E]);continue}p[E]=T.$co(h[E])}}j(p){let h=null,E=null;const D=b=>{b&&(E?this.i(E,b):E=T.$co(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===p?h=b.contents:b.identifiers.includes(p)&&D(b.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(p,h){this.k(p,h,!0)}setValue(p,h){this.k(p,h,!1)}removeValue(p){const h=this.keys.indexOf(p);h!==-1&&(this.keys.splice(h,1),(0,R.$ej)(this.contents,p),y.$Eo.test(p)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Fo)(p))),1))}k(p,h,E){if((0,R.$dj)(this.contents,p,h,D=>this.f.error(D)),E=E||this.keys.indexOf(p)===-1,E&&this.keys.push(p),y.$Eo.test(p)){const D=(0,y.$Fo)(p),b={identifiers:D,keys:Object.keys(this.contents[p]),contents:(0,R.$cj)(this.contents[p],C=>this.f.error(C))},k=this.overrides.findIndex(C=>v.$tb(C.identifiers,D));k!==-1?this.overrides[k]=b:this.overrides.push(b)}}}e.$Mo=n;class o{constructor(p,h){this.f=p,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(p,h){if(!$.$mg(p)){const E=this.h(p);this.parseRaw(E,h)}}reparse(p){this.a&&this.parseRaw(this.a,p)}parseRaw(p,h){this.a=p;const{contents:E,keys:D,overrides:b,restricted:k,hasExcludedProperties:C}=this.i(p,h);this.b=new n(E,D,b,C?[p]:void 0,this.g),this.c=k||[]}h(p){let h={},E=null,D=[];const b=[],k=[];function C(w){Array.isArray(D)?D.push(w):E!==null&&(D[E]=w)}const f={onObjectBegin:()=>{const w={};C(w),b.push(D),D=w,E=null},onObjectProperty:w=>{E=w},onObjectEnd:()=>{D=b.pop()},onArrayBegin:()=>{const w=[];C(w),b.push(D),D=w,E=null},onArrayEnd:()=>{D=b.pop()},onLiteralValue:C,onError:(w,F,N)=>{k.push({error:w,offset:F,length:N})}};if(p)try{P.$4n(p,f),h=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return h}i(p,h){const E=S.$po.as(y.$uo.Configuration).getConfigurationProperties(),D=this.j(p,E,!0,h);p=D.raw;const b=(0,R.$cj)(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),k=Object.keys(p),C=this.l(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:k,overrides:C,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(p,h,E,D){let b=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:p,restricted:[],hasExcludedProperties:b};const k={},C=[];for(const f in p)if(y.$Eo.test(f)&&E){const w=this.j(p[f],h,!1,D);k[f]=w.raw,b=b||w.hasExcludedProperties,C.push(...w.restricted)}else{const w=h[f],F=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&C.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&w?.restricted))?k[f]=p[f]:b=!0}return{raw:k,restricted:C,hasExcludedProperties:b}}l(p,h){const E=[];for(const D of Object.keys(p))if(y.$Eo.test(D)){const b={};for(const k in p[D])b[k]=p[D][k];E.push({identifiers:(0,y.$Fo)(D),keys:Object.keys(b),contents:(0,R.$cj)(b,h)})}return E}}e.$No=o;class c extends O.$Tc{constructor(p,h,E,D,b){super(),this.c=p,this.f=h,this.g=D,this.h=b,this.b=this.B(new I.$ke),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),b),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(a.FileOperation.CREATE)||k.isOperation(a.FileOperation.COPY)||k.isOperation(a.FileOperation.DELETE)||k.isOperation(a.FileOperation.WRITE))&&E.isEqual(k.resource,p)))(()=>this.b.fire()))}async loadConfiguration(){try{const p=await this.g.readFile(this.c);return this.a.parse(p.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(p){return p&&(this.f=p),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=c;class u{constructor(p,h,E,D,b,k,C,f,w,F,N,L,W){this.a=p,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=b,this.f=k,this.g=C,this.h=f,this.i=w,this.j=F,this.k=N,this.l=L,this.m=W}get value(){return d(this.c)}n(p){return p?.value!==void 0||p?.override!==void 0||p?.overrides!==void 0?p:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(p,h,E,D,b,k,C,f,w,F){this.j=p,this.l=h,this.m=E,this.n=D,this.p=b,this.q=k,this.r=C,this.s=f,this.t=w,this.u=F,this.h=null,this.i=new A.$zc,this.v=null}getValue(p,h,E){return this.w(p,h,E).getValue(p)}updateValue(p,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=n.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(p):D.setValue(p,h),E.resource||(this.h=null)}inspect(p,h,E){const D=this.w(p,h,E),b=this.A(h.resource,E),k=h.resource?this.t.get(h.resource)||this.s:this.s,C=new Set;for(const f of D.overrides)for(const w of f.identifiers)D.getOverrideValue(p,w)!==void 0&&C.add(w);return new u(p,h,D.getValue(p),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,b||void 0,k)}keys(p){const h=this.A(void 0,p);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(p){this.j=p,this.h=null,this.i.clear()}updatePolicyConfiguration(p){this.l=p}updateApplicationConfiguration(p){this.m=p,this.h=null,this.i.clear()}updateLocalUserConfiguration(p){this.n=p,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(p){this.p=p,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(p){this.q=p,this.h=null,this.i.clear()}updateFolderConfiguration(p,h){this.r.set(p,h),this.i.delete(p)}deleteFolderConfiguration(p){this.folderConfigurations.delete(p),this.i.delete(p)}compareAndUpdateDefaultConfiguration(p,h){const E=[];if(!h){const{added:D,updated:b,removed:k}=g(this.j,p);h=[...D,...b,...k]}for(const D of h)for(const b of(0,y.$Fo)(D)){const k=this.j.getKeysForOverrideIdentifier(b),C=p.getKeysForOverrideIdentifier(b),f=[...C.filter(w=>k.indexOf(w)===-1),...k.filter(w=>C.indexOf(w)===-1),...k.filter(w=>!T.$go(this.j.override(b).getValue(w),p.override(b).getValue(w)))];E.push([b,f])}return this.updateDefaultConfiguration(p),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(p){const{added:h,updated:E,removed:D}=g(this.l,p),b=[...h,...E,...D];return b.length&&this.updatePolicyConfiguration(p),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.applicationConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateApplicationConfiguration(p),{keys:k,overrides:b}}compareAndUpdateLocalUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.localUserConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateLocalUserConfiguration(p),{keys:k,overrides:b}}compareAndUpdateRemoteUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.remoteUserConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateRemoteUserConfiguration(p),{keys:k,overrides:b}}compareAndUpdateWorkspaceConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.workspaceConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateWorkspaceConfiguration(p),{keys:k,overrides:b}}compareAndUpdateFolderConfiguration(p,h){const E=this.folderConfigurations.get(p),{added:D,updated:b,removed:k,overrides:C}=g(E,h),f=[...D,...b,...k];return(f.length||!E)&&this.updateFolderConfiguration(p,h),{keys:f,overrides:C}}compareAndDeleteFolderConfiguration(p){const h=this.folderConfigurations.get(p);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(p);const{added:E,updated:D,removed:b,overrides:k}=g(h,void 0);return{keys:[...E,...D,...b],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(p,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(p)!==void 0&&(D=D.merge(this.l)),D}x({resource:p},h){let E=this.y();if(h&&p){const D=h.getFolder(p);D&&(E=this.z(D.uri)||E);const b=this.t.get(p);b&&(E=E.merge(b))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(p){let h=this.i.get(p);if(!h){const E=this.y(),D=this.r.get(p);D?(h=E.merge(D),this.i.set(p,h)):h=E}return h}A(p,h){if(h&&p){const E=h.getFolder(p);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((p,h)=>{const{contents:E,overrides:D,keys:b}=this.r.get(h);return p.push([h,{contents:E,overrides:D,keys:b}]),p},[])}}allKeys(){const p=new Set;return this.j.keys.forEach(h=>p.add(h)),this.userConfiguration.keys.forEach(h=>p.add(h)),this.q.keys.forEach(h=>p.add(h)),this.r.forEach(h=>h.keys.forEach(E=>p.add(E))),[...p.values()]}B(){const p=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>p.add(E))),[...p.values()]}D(p){const h=new Set;return this.j.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(p).forEach(D=>h.add(D))),[...h.values()]}static parse(p,h){const E=this.E(p.defaults,h),D=this.E(p.policy,h),b=this.E(p.application,h),k=this.E(p.user,h),C=this.E(p.workspace,h),f=p.folders.reduce((w,F)=>(w.set(s.URI.revive(F[0]),this.E(F[1],h)),w),new A.$zc);return new i(E,D,b,k,n.createEmptyModel(h),C,f,n.createEmptyModel(h),new A.$zc,h)}static E(p,h){return new n(p.contents,p.keys,p.overrides,void 0,h)}}e.$Po=i;function r(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const p=new Set,h=new Map;for(const D of m)D.keys.forEach(b=>p.add(b)),D.overrides.forEach(([b,k])=>{const C=(0,A.$wc)(h,b,new Set);k.forEach(f=>C.add(f))});const E=[];return h.forEach((D,b)=>E.push([b,[...D.values()]])),{keys:[...p.values()],overrides:E}}class t{constructor(p,h,E,D,b){this.change=p,this.f=h,this.g=E,this.h=D,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of p.keys)this.affectedKeys.add(k);for(const[,k]of p.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(p,h){const E=this.a+p,D=this.d.indexOf(E);if(D<0)return!1;const b=D+E.length;if(b>=this.d.length)return!1;const k=this.d.charCodeAt(b);if(k!==this.b&&k!==this.c)return!1;if(h){const C=this.previousConfiguration?this.previousConfiguration.getValue(p,h,this.f?.workspace):void 0,f=this.g.getValue(p,h,this.h);return!T.$go(C,f)}return!0}}e.$Ro=t;function g(m,p){const{added:h,removed:E,updated:D}=l(p?.rawConfiguration,m?.rawConfiguration),b=[],k=m?.getAllOverrideIdentifiers()||[],C=p?.getAllOverrideIdentifiers()||[];if(p){const f=C.filter(w=>!k.includes(w));for(const w of f)b.push([w,p.getKeysForOverrideIdentifier(w)])}if(m){const f=k.filter(w=>!C.includes(w));for(const w of f)b.push([w,m.getKeysForOverrideIdentifier(w)])}if(p&&m){for(const f of k)if(C.includes(f)){const w=l({contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)},{contents:p.getOverrideValue(void 0,f)||{},keys:p.getKeysForOverrideIdentifier(f)});b.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:h,removed:E,updated:D,overrides:b}}function l(m,p){const h=m?p?m.keys.filter(b=>p.keys.indexOf(b)===-1):[...m.keys]:[],E=p?m?p.keys.filter(b=>m.keys.indexOf(b)===-1):[...p.keys]:[],D=[];if(m&&p){for(const b of p.keys)if(m.keys.indexOf(b)!==-1){const k=(0,R.$fj)(p.contents,b),C=(0,R.$fj)(m.contents,b);T.$go(k,C)||D.push(b)}}return{added:h,removed:E,updated:D}}}),define(Oe[109],Ne([1,0,13,3]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=s,e.$Pl=(0,I.$Di)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=O;class A{constructor(y,a){this.host=y,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends v.$ab{static isNotAvailable(y){return y instanceof $&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,a=T.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Sl=$;function s(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(Oe[62],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=I,e.$gn=P,e.$hn=O,e.$in=A;function I($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const s=$.indexOf("+");return s<0?$:$.substr(0,s)}function O($){const{host:s,port:R}=T($);if(typeof R>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:R}}function A($,s){let{host:R,port:y}=T($);return typeof y>"u"&&(y=s),{host:R,port:y}}function T($){const s=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const R=$.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Oe[18],Ne([1,0,12,3,62]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=O,e.$sn=y,e.$tn=a,e.$un=S,e.$vn=d,e.$wn=n,e.$xn=o,v=We(v),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$on=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,i){if(typeof u>"u"||u===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof u=="string"||typeof i=="string"){const r=typeof u=="string"?u:u.value,t=typeof i=="string"?i:i.value;return v.$Ef(r,t)}return u._lower===i._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$pn=$;class s{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const i of u)this.add(i)}add(u){this.c.add($.toKey(u))}delete(u){return this.c.delete($.toKey(u))}has(u){return this.c.has($.toKey(u))}}e.$qn=s;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete($.toKey(u))}get(u){return this.c.get($.toKey(u))}has(u){return this.c.has($.toKey(u))}set(u,i){this.c.set($.toKey(u),i)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=R;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,u){if(u){const i=`onResolveRemoteAuthority:${(0,P.$gn)(u)}`;return!!c.activationEvents?.includes(i)}return!1}function n(c){return c.map(u=>{const[i,r]=u.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function o(c){return c.map(u=>u.split("@")[0])}e.$yn=(0,I.$Di)("IBuiltinExtensionsScannerService")}),define(Oe[110],Ne([1,0,20,9,18,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=T,e.$ep=$,e.$fp=s,e.$gp=R,e.$hp=y,e.$ip=a,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,g){switch(t){case v.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function R(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,g,l){return R(g,l)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===l}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$jp=(0,O.$Di)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class u extends Error{constructor(g,l){super(g),this.code=l,this.name=l}}e.$kp=u;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(g,l){super(g),this.code=l,this.name=l}}e.$lp=r,e.$mp=(0,O.$Di)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,O.$Di)("IGlobalExtensionEnablementService"),e.$qp=(0,O.$Di)("IExtensionTipsService"),e.$rp=(0,I.localize2)(11446,"Extensions"),e.$sp=(0,I.localize2)(11447,"Preferences")}),define(Oe[111],Ne([1,0,13,18]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const $ of A){const s=this.readActivationEvents($);s.length>0&&(T[I.$pn.toKey($.identifier)]=s)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${I.$pn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const $ in A.contributes){const s=this.a.get($);if(!s)continue;const R=A.contributes[$],y=Array.isArray(R)?R:[R];try{s(y,T)}catch(a){(0,v.$Y)(a)}}return T}}e.$VG=P,e.$WG=new P});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[175],Ne([1,0,23,35,9,281,18,104]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=R,e.$Yp=y,e.$Zp=a,e.$1p=S,e.$2p=d,e.$3p=n,e.$4p=o,e.$5p=c,I=ri(I),P=We(P),O=We(O);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function R(r){return r=r.trim(),r==="*"||$.test(r)}function y(r){if(!R(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(r){if(!r)return null;const t=r.majorBase,g=r.majorMustEqual,l=r.minorBase;let m=r.minorMustEqual;const p=r.patchBase;let h=r.patchMustEqual;r.hasCaret&&(t===0||(m=!1),h=!1);let E=0;if(r.preRelease){const D=s.exec(r.preRelease);if(D){const[,b,k,C]=D;E=Date.UTC(Number(b),Number(k)-1,Number(C))}}return{majorBase:t,majorMustEqual:g,minorBase:l,minorMustEqual:m,patchBase:p,patchMustEqual:h,isMinimum:r.hasGreaterEquals,notBefore:E}}function S(r,t,g){let l;typeof r=="string"?l=a(y(r)):l=r;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let p;if(typeof g=="string"?p=a(y(g)):p=g,!l||!p)return!1;const h=l.majorBase,E=l.minorBase,D=l.patchBase;let b=p.majorBase,k=p.minorBase,C=p.patchBase;const f=p.notBefore;let w=p.majorMustEqual,F=p.minorMustEqual,N=p.patchMustEqual;return p.isMinimum?h>b?!0:h<b?!1:E>k?!0:E<k||m&&m<f?!1:D>=C:(h===1&&b===0&&(!w||!F||!N)&&(b=1,k=0,C=0,w=!0,F=!1,N=!1),h<b?!1:h>b?!w:E<k?!1:E>k?!F:D<C?!1:D>C?!N:!(m&&m<f))}function d(r,t,g,l,m,p){const h=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return h.push([I.default.Error,P.localize(11377,null)]),h;if(typeof l.name!="string")return h.push([I.default.Error,P.localize(11378,null,"name")]),h;if(typeof l.version!="string")return h.push([I.default.Error,P.localize(11379,null,"version")]),h;if(!l.engines)return h.push([I.default.Error,P.localize(11380,null,"engines")]),h;if(typeof l.engines.vscode!="string")return h.push([I.default.Error,P.localize(11381,null,"engines.vscode")]),h;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return h.push([I.default.Error,P.localize(11382,null,"extensionDependencies")]),h;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return h.push([I.default.Error,P.localize(11383,null,"activationEvents")]),h;if(typeof l.main>"u"&&typeof l.browser>"u")return h.push([I.default.Error,P.localize(11384,null,"activationEvents","main","browser")]),h}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&h.push([I.default.Warning,P.localize(11385,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return h.push([I.default.Error,P.localize(11386,null,"main")]),h;{const b=(0,v.$eh)(g,l.main);(0,v.$$g)(b,g)||h.push([I.default.Warning,P.localize(11387,null,b.path,g.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return h.push([I.default.Error,P.localize(11388,null,"browser")]),h;{const b=(0,v.$eh)(g,l.browser);(0,v.$$g)(b,g)||h.push([I.default.Warning,P.localize(11389,null,b.path,g.path)])}}if(!O.valid(l.version))return h.push([I.default.Error,P.localize(11390,null)]),h;const E=[];if(!n(r,t,l,m,E))for(const b of E)h.push([I.default.Error,b]);if(p&&l.enabledApiProposals?.length){const b=[];if(!c([...l.enabledApiProposals],b))for(const k of b)h.push([I.default.Error,k])}return h}function n(r,t,g,l,m){return l||typeof g.main>"u"&&typeof g.browser>"u"?!0:u(r,t,g.engines.vscode,m)}function o(r,t,g){return r==="*"||u(t,g,r)}function c(r,t){if(r.length===0)return!0;const g=Array.isArray(t)?t:void 0,l=(g?void 0:t)??T.allApiProposals,m=[],p=(0,A.$wn)(r);for(const{proposalName:h,version:E}of p){const D=l[h];D&&E&&D.version!==E&&m.push(P.localize(11391,null,h))}return g?.push(...m),m.length===0}function u(r,t,g,l=[]){const m=a(y(g));if(!m)return l.push(P.localize(11392,null,g)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return l.push(P.localize(11393,null,g)),!1}else if(!m.majorMustEqual)return l.push(P.localize(11394,null,g)),!1;return S(r,t,m)?!0:(l.push(P.localize(11395,null,r,g)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,g=r.length;t<g;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Oe[176],Ne([1,0,22,13,4,9,53,3,11,30]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=a,e.$9p=S,e.$0p=d,e.$$p=n,e.$_p=o,e.$aq=c,e.$6p=(0,T.$Di)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends P.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11164,null),when:$.$qk.isEqualTo((0,$.$nk)($.LogLevel.Trace)).serialize()})}async c(t,g,l){const m=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${m} - begin`,g.type,new R(g.headers??{}));try{const p=await l();return this.a.trace(`${m} - end`,g.type,p.res.statusCode,p.res.headers),p}catch(p){throw this.a.error(`${m} - error`,g.type,(0,I.$9)(p)),p}}}e.$7p=y;function a(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function S(r){return r.res.statusCode===204}async function d(r){return S(r)?null:(await(0,v.$Ye)(r.stream)).toString()}async function n(r){if(!a(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function o(r){if(!a(r))throw new Error("Server returned "+r.res.statusCode);if(S(r))return null;const g=(await(0,v.$Ye)(r.stream)).toString();try{return JSON.parse(g)}catch(l){throw l.message+=`:
`+g,l}}function c(r){i(r)}let u;function i(r){const t=s.$po.as(A.$uo.Configuration),g=u;u={id:"http",order:15,title:(0,O.localize)(11165,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11166,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11167,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11168,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11169,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11170,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11171,null),(0,O.localize)(11172,null),(0,O.localize)(11173,null),(0,O.localize)(11174,null)],default:"override",description:(0,O.localize)(11175,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11176,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11177,null),restricted:!0}}},t.updateConfigurations({add:[u],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Oe[177],Ne([1,0,20,78,37]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=A,e.$up=T;function O($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,s,R,y,a,S,d,n,o,c){const u=Object.create(null);u["common.machineId"]=S,u["common.sqmId"]=d,u["common.devDeviceId"]=n,u.sessionID=(0,P.$Zg)()+Date.now(),u.commitHash=y,u.version=a,u["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,v.$i)(v.$v),u["common.nodePlatform"]=I.$cc,u["common.nodeArch"]=R,u["common.product"]=c||"desktop",o&&(u["common.msftInternal"]=o);let i=0;const r=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(u["common.snap"]="true");const t=O(s);return t&&(u["common.platformDetail"]=t),u}function T($){const s=I.env.USERDNSDOMAIN;if(!s)return!1;const R=s.toLowerCase();return $.some(y=>R===y)}}),define(Oe[112],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,v.$Di)("telemetryService"),e.$$l=(0,v.$Di)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var I;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Oe[63],Ne([1,0,25,14,62,177,112]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=R,e.$Dp=y,e.$Ep=a,e.$Fp=S,e.$Gp=n,e.$Hp=c,e.$Ip=u,e.$Jp=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$vp=T;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=$,e.$xp=new $;class s{async publicLog(l,m,p){}async publicLogError(l,m,p){}}e.$yp=s,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function R(g,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!g.enableTelemetry)}function y(g,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const l=g.getValue(A.$gm),m=g.getValue(A.$hm);if(g.getValue(A.$im)===!1||m===!1)return A.TelemetryLevel.NONE;switch(l??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(g){const l={},m={},p={};o(g,p);for(let h in p){h=h.length>150?h.substr(h.length-149):h;const E=p[h];typeof E=="number"?m[h]=E:typeof E=="boolean"?m[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),l[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(l[h]=E)}return{properties:l,measurements:m}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(g){if(!g)return"none";const l=(0,P.$gn)(g);return d.has(l)?l:"other"}function o(g,l,m=0,p){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=p?p+h:h;Array.isArray(E)?l[D]=(0,v.$ho)(E):E instanceof Date?l[D]=E.toISOString():(0,I.$fg)(E)?m<2?o(E,l,m+1,D+"."):l[D]=(0,v.$ho)(E):l[D]=E}}function c(g,l){const m=g.msftInternalDomains||[],p=l.getValue("telemetry.internalTesting");return(0,O.$up)(m)||p}function u(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,l){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let m=g;const p=[];for(const b of l)for(;;){const k=b.exec(g);if(!k)break;p.push([k.index,b.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(m="";;){const b=E.exec(g);if(!b)break;const k=p.some(([C,f])=>b.index<f&&C<E.lastIndex);!h.test(b[0])&&!k&&(m+=g.substring(D,b.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&(m+=g.substr(D)),m}function r(g){if(!g)return g;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of l)if(m.regex.test(g))return`<REDACTED: ${m.label}>`;return g}function t(g,l){return(0,v.$eo)(g,m=>{if(m instanceof T||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let p=m.replaceAll("%20"," ");p=i(p,l);for(const h of l)p=p.replace(h,"");return p=r(p),p}})}}),define(Oe[178],Ne([1,0,12,110,18,20,2,13,78,63]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=R,e.$Mp=d,e.$Np=n,e.$Op=o,e.$Pp=c,e.$Qp=u,e.$Rp=i,e.$Sp=r,e.$Up=t,e.$Vp=l;function R(m,p){return m.uuid&&p.uuid?m.uuid===p.uuid:m.id===p.id?!0:(0,v.$zf)(m.id,p.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(p){const h=p.manifest?p.manifest.version:p.version,E=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new a(p.identifier,h,E)}static parse(p){const h=y.exec(p);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(p,h,E=P.TargetPlatform.UNDEFINED){this.identifier=p,this.version=h,this.targetPlatform=E,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof a?R(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.$Lp=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(m){const p=S.exec(m);return p&&p[1]?[o(p[1]),p[2]]:[o(m),void 0]}function n(m,p){return`${m}.${p}`}function o(m){return m.toLowerCase()}function c(m,p){return o(n(m??P.$ln,p))}function u(m,p){const h=[],E=D=>{for(const b of h)if(b.some(k=>R(p(k),p(D))))return b;return null};for(const D of m){const b=E(D);b?b.push(D):h.push([D])}return h}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function r(m){return{id:new s.$vp(m.identifier.id),name:new s.$vp(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Tp=new P.$pn("pprice.better-merge");function t(m,p){const h=[],E=p.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(b=>!R(b.identifier,{id:D}))){const b=m.filter(k=>R(k.identifier,{id:D}));b.length===1&&(h.push(b[0]),E.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g(m,p){if(!O.$l)return!1;let h;try{h=(await m.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await m.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){p.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(m,p){const h=await g(m,p),E=(0,I.$fp)(h?"alpine":O.$v,$.$dc);return p.debug("ComputeTargetPlatform:",E),E}}),define(Oe[179],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=v,e.$Es=I,e.$Fs=P,e.$Gs=O,e.$Hs=A,e.$Is=T;function v($){return[...$.entries()]}function I($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function A($){return Array.from($.entries()).map(s=>[s[0],v(s[1].map),I(s[1].descriptionMap)])}function T($){return new Map($.map(s=>[s[0],{map:P(s[1]),descriptionMap:O(s[2])}]))}}),define(Oe[180],Ne([1,0,3,31,30]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ns=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ms=void 0,e.$ms=new I.$Uj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var s;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ns=(0,v.$Di)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var u;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$os={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const l=this.b(g.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}P.$po.add(e.$os.Backend,new r),e.$ps=(0,v.$Di)("localPtyService"),e.$qs=(0,v.$Di)("terminalLogService")}),define(Oe[181],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oxb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const T=O($=>{const s=typeof $=="string"?$:$.data;let R=this.a.get(P);if(R){R.data.push(s);return}const y=setTimeout(()=>this.flushBuffer(P),A);R={data:[s],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),T.dispose()}},this.a.set(P,R)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Oxb=v}),define(Oe[182],Ne([1,0,10,97,282,34,6,14,2,9,77,30]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.IconFontDefinition=e.IconContribution=e.$yx=void 0,e.$zx=o,e.$Ax=c,y=We(y),e.$yx={IconContribution:"base.contributions.icons"};var a;(function(t){function g(l,m){let p=l.defaults;for(;O.ThemeIcon.isThemeIcon(p);){const h=n.getIcon(p.id);if(!h)return;p=h.defaults}return p}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g(m){return{weight:m.weight,style:m.style,src:m.src.map(p=>({format:p.format,location:p.location.toString()}))}}t.toJSONObject=g;function l(m){const p=h=>(0,T.$dg)(h)?h:void 0;if(m&&Array.isArray(m.src)&&m.src.every(h=>(0,T.$dg)(h.format)&&(0,T.$dg)(h.location)))return{weight:p(m.weight),style:p(m.style),src:m.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}t.fromJSONObject=l})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new A.$ke,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(11096,null)},fontCharacter:{type:"string",description:(0,s.localize)(11097,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,l,m,p){const h=this.b[g];if(h){if(m&&!h.description){h.description=m,this.d.properties[g].markdownDescription=`${m} $(${g})`;const b=this.e.enum.indexOf(g);b!==-1&&(this.e.enumDescriptions[b]=m),this.a.fire()}return h}const E={id:g,description:m,defaults:l,deprecationMessage:p};this.b[g]=E;const D={$ref:"#/definitions/icons"};return p&&(D.deprecationMessage=p),m&&(D.markdownDescription=`${m}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const l=this.e.enum.indexOf(g);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,l){const m=this.f[g];return m||(this.f[g]=l,this.a.fire(),l)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),l=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.b).map(h=>this.b[h]);for(const h of p.filter(E=>!!E.description).sort(g))m.push(`|<i class="${l(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const h of p.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))m.push(`|<i class="${l(h)}"></i>|${h.id}|`);return m.join(`
`)}}const n=new d;y.$po.add(e.$yx.IconContribution,n);function o(t,g,l,m){return n.registerIcon(t,g,l,m)}function c(){return n}function u(){const t=(0,P.$Yj)();for(const g in t){const l="\\"+t[g].toString(16);n.registerIcon(g,{fontCharacter:l})}}u(),e.$Bx="vscode://schemas/icons";const i=y.$po.as(R.$qo.JSONContribution);i.registerSchema(e.$Bx,n.getIconSchema());const r=new v.$Ph(()=>i.notifySchemaChanged(e.$Bx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Cx=o("widget-close",I.$3j.close,(0,s.localize)(11098,null)),e.$Dx=o("goto-previous-location",I.$3j.arrowUp,(0,s.localize)(11099,null)),e.$Ex=o("goto-next-location",I.$3j.arrowDown,(0,s.localize)(11100,null)),e.$Fx=O.ThemeIcon.modify(I.$3j.sync,"spin"),e.$Gx=O.ThemeIcon.modify(I.$3j.loading,"spin")}),define(Oe[183],Ne([1,0,6,4,20,2,43,3,11]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Jw=e.$Hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dw=e.$Cw=void 0,e.$Ew=y,e.$Fw=S,e.$Gw=d,e.$Iw=n,e.$Kw=o,e.$Lw=c,e.$Cw=(0,T.$Di)("tunnelService"),e.$Dw=(0,T.$Di)("sharedTunnelsService");var s;(function(r){r.Http="http",r.Https="https"})(s||(e.TunnelProtocol=s={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var a;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const g of t){const l=g.split("=")[1];if(/^https?:/.exec(l)){const m=S(O.URI.parse(l));if(m)return m}}}e.$Hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Hw.indexOf(r)>=0}e.$Jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(r){return e.$Jw.indexOf(r)>=0}function c(r,t,g,l){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&o(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(m?.length===4&&parseInt(m[1])>=18)return!1}return r<1024}class u{constructor(t,g,l){this.remoteAddress=t,this.localAddress=g,this.b=l,this.a=new v.$ke,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mw=u;let i=class extends I.$Tc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$ke,this.onTunnelOpened=this.a.event,this.b=new v.$ke,this.onTunnelClosed=this.b.event,this.c=new v.$ke,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const l of g){const m=Array.from(l.values());for(const p of m){const h=await p.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,l,m,p){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:l,privacy:m,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(o(t)||n(t))&&(t=e.$Hw[0]);const l=this.D(t,g);if(l)return++l.refcount,l.value}openTunnel(t,g,l,m,p,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${l} on local port ${p}.`);const b=this.g??t;if(!b)return;if(g||(g="localhost"),m||(m=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(b,g,l,m,p,h,E,D);return k?k.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,l),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(C);return(C.tunnelRemoteHost!==g||C.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&C.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const l=g.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,g,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const m=l.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),m}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const l=this.f.get(t);if(l&&l.has(g)){const m=l.get(g);m.refcount=0,await this.y(t,g,m)}}z(t,g,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:l})}async C(t,g){const l=this.f.get(t);if(l){const m=l.get(g),p=m?await m.value:void 0;(!p||typeof p=="string")&&l.delete(g),l.size===0&&this.f.delete(t)}}D(t,g){const l=[t];n(t)?(l.push(...e.$Hw),l.push(...e.$Jw)):o(t)&&l.push(...e.$Jw);const m=l.map(p=>this.f.get(p));for(const p of m){const h=p?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,l,m,p,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${l} on local port ${m}.`);const D=l;this.n.add(D);const b=m===void 0?l:m,k={elevationRequired:p?this.isPortPrivileged(b):!1},C={remoteAddress:{host:g,port:l},localAddressPort:m,privacy:h,public:h?h!==R.Private:void 0,protocol:E},f=t.forwardPort(C,k);return f?(this.z(g,l,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Nw=i,e.$Nw=i=Ge([Ve(0,$.$$j),Ve(1,A.$0i)],i)}),define(Oe[184],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,v.$Di)("IUriIdentityService")}),define(Oe[185],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ow=void 0,e.$Ow=(0,v.$Di)("editSessionIdentityService");var I;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(I||(e.EditSessionIdentityMatch=I={}))}),define(Oe[186],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=I,e.$cN=P,e.$dN=O,e.$eN=A,e.$fN=T;function I($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(s=>I(s.uri))?$.folders[0].uri:void 0;if($.configuration&&I($.configuration))return $.configuration}function O($){return P($)?.scheme}function A($){return P($)?.authority}function T($){return P($)!==void 0}}),define(Oe[49],Ne([1,0,9,19,58,23,2,3,15]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Xi=e.$Wi=e.WorkbenchState=e.$Qi=e.$Pi=e.$Mi=void 0,e.$Ni=s,e.$Oi=R,e.$Ri=y,e.$Si=a,e.$Ti=S,e.$Ui=n,e.$Vi=o,e.$Yi=i,e.$4i=r,e.$5i=t,e.$7i=g,e.$8i=l,e.$9i=m,e.$Mi=(0,T.$Di)("contextService");function s(p){const h=p;return typeof h?.id=="string"&&A.URI.isUri(h.uri)}function R(p){return typeof p?.id=="string"&&!s(p)&&!a(p)}e.$Pi={id:"ext-dev"},e.$Qi={id:"empty-window"};function y(p,h){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,I.$mc)(p)}:h?e.$Pi:e.$Qi;const E=p;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(p){const h=p;return typeof h?.id=="string"&&A.URI.isUri(h.configPath)}function S(p){const h=p;if(h?.uri)return{id:h.id,uri:A.URI.revive(h.uri)};const E=p;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(p?.id)return{id:p.id}}var d;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function o(p){const h=p;return!!(h&&typeof h=="object"&&A.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,b,k){this.h=h,this.j=D,this.k=b,this.l=k,this.c=P.$Ji.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Ji.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Wi=c;class u{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$eh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Xi=u;function i(p){return new u({uri:p,index:0,name:(0,O.$ah)(p)},{uri:p.toString()})}e.$Zi="code-workspace",e.$1i=`.${e.$Zi}`,e.$2i=[{name:(0,v.localize)(10975,null),extensions:[e.$Zi]}],e.$3i="workspace.json";function r(p,h){return O.$8g.isEqualOrParent(p,h.untitledWorkspacesHome)}function t(p){let h;return A.URI.isUri(p)?h=p:h=p.configuration,h?.scheme===$.Schemas.tmp}e.$6i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(p){return p.id===e.$6i}function l(p,h){return!r(p,h)&&!t(p)}function m(p){return(typeof p=="string"?(0,I.$nc)(p):(0,O.$ch)(p))===e.$1i}}),define(Oe[113],Ne([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,37,12,14]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=r,e.$Ll=t,e.$Ml=g;var i;(function(p){p.Settings="settings",p.Keybindings="keybindings",p.Snippets="snippets",p.Tasks="tasks",p.Extensions="extensions",p.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&A.URI.isUri(h.location)&&A.URI.isUri(h.globalStorageHome)&&A.URI.isUri(h.settingsResource)&&A.URI.isUri(h.keybindingsResource)&&A.URI.isUri(h.tasksResource)&&A.URI.isUri(h.snippetsHome)&&A.URI.isUri(h.extensionsResource))}e.$Kl=(0,R.$Di)("IUserDataProfilesService");function t(p,h){return{id:p.id,isDefault:p.isDefault,name:p.name,shortName:p.shortName,icon:p.icon,location:A.URI.revive(p.location).with({scheme:h}),globalStorageHome:A.URI.revive(p.globalStorageHome).with({scheme:h}),settingsResource:A.URI.revive(p.settingsResource).with({scheme:h}),keybindingsResource:A.URI.revive(p.keybindingsResource).with({scheme:h}),tasksResource:A.URI.revive(p.tasksResource).with({scheme:h}),snippetsHome:A.URI.revive(p.snippetsHome).with({scheme:h}),extensionsResource:A.URI.revive(p.extensionsResource).with({scheme:h}),cacheHome:A.URI.revive(p.cacheHome).with({scheme:h}),useDefaultFlags:p.useDefaultFlags,isTransient:p.isTransient}}function g(p,h,E,D,b,k){return{id:p,name:h,location:E,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:k&&b?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.$eh)(E,"globalStorage"),settingsResource:k&&b?.useDefaultFlags?.settings?k.settingsResource:(0,O.$eh)(E,"settings.json"),keybindingsResource:k&&b?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.$eh)(E,"keybindings.json"),tasksResource:k&&b?.useDefaultFlags?.tasks?k.tasksResource:(0,O.$eh)(E,"tasks.json"),snippetsHome:k&&b?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.$eh)(E,"snippets"),extensionsResource:k&&b?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.$eh)(E,"extensions.json"),cacheHome:(0,O.$eh)(D,p),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let l=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,b){super(),this.t=h,this.u=E,this.w=D,this.y=b,this.f=!0,this.h=this.B(new I.$ke),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$ke),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$ke),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$ke),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$zc,workspaces:new S.$zc,emptyWindows:new Map},this.profilesHome=(0,O.$eh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$eh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,u.$dg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(g((0,O.$bh)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},h))}}catch(k){this.y.error(k)}const D=new S.$zc,b=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[C,f]of Object.entries(k.workspaces)){const w=A.URI.parse(C),F=E.find(N=>N.id===f);F&&D.set(w,F)}if(k.emptyWindows)for(const[C,f]of Object.entries(k.emptyWindows)){const w=E.find(F=>F.id===f);w&&b.set(C,w)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:b}}return this.z}D(){const h=g("__default__profile__",(0,T.localize)(11022,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$gf)(E)}\\s(\\d+)`);let b=0;for(const C of this.profiles){const f=D.exec(C.name),w=f?parseInt(f[1]):0;b=w>b?w:b}const k=`${E} ${b+1}`;return this.createProfile((0,v.$rj)((0,o.$Zg)()).toString(16),k,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$rj)((0,o.$Zg)()).toString(16),h,E,D)}async createProfile(h,E,D,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(h,E,D);return b&&await this.setProfileForWorkspace(b,k),k}async F(h,E,D){if(!(0,u.$dg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(E);return b||(b=(async()=>{try{if(this.profiles.find(w=>w.name===E||w.id===h))throw new Error(`Profile with ${E} name already exists`);const C=g(h,E,(0,O.$eh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(C.location);const f=[];return this.j.fire({profile:C,join(w){f.push(w)}}),await n.Promises.settled(f),this.I([C],[],[]),C}finally{this.r.delete(E)}})(),this.r.set(E,b)),b}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(b=>b.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(b=>b.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(b){D.push(b)}});try{await Promise.allSettled(D)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(b){(0,s.$pl)(b)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(b=>b.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Ni)(h)?this.s.folders.get(h.uri):(0,a.$Si)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Ni)(h)?h.uri:(0,a.$Si)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const b=[...this.profiles,...h],k=[],C=this.s.profiles;this.s.profiles=[];for(let f of b){if(f.isDefault||E.some(F=>f.id===F.id))continue;f=D.find(F=>f.id===F.id)??f;const w=C.find(F=>f.id===F.id);if(f.isTransient)this.s.profiles.push(f);else{if(w){for(const[F,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:F},f);break}for(const[F,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:F},f);break}for(const[F,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:F},f);break}}k.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Ni)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Si)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const b=this.G(h);A.URI.isUri(b)?(this.C.workspaces.delete(b),E&&this.C.workspaces.set(b,E)):(this.C.emptyWindows.delete(b),E&&this.C.emptyWindows.set(b,E)),this.M()}}M(){const h={};for(const[D,b]of this.C.workspaces.entries())h[D.toString()]=b.id;const E={};for(const[D,b]of this.C.emptyWindows.entries())E[D.toString()]=b.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[k,C]of Object.entries(h.workspaces)){const f=A.URI.parse(C);E[k]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const b={};if(h.emptyWindows)for(const[k,C]of Object.entries(h.emptyWindows)){const f=A.URI.parse(C);b[k]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:b}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Nl=l,e.$Nl=l=Ge([Ve(0,$.$Ki),Ve(1,s.$$k),Ve(2,d.$Il),Ve(3,y.$$j)],l);class m extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Ol=m}),define(Oe[187],Ne([1,0,10,6,4,64,14,152,3,113]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=S,e.$jq=n,e.$lq=c,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,$.$Di)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(u){const i=u.get(e.$fq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new I.$ne),this.c=this.B(new I.$ne),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$ke),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Ph(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return I.Event.filter(this.b.event,g=>g.scope===i&&(r===void 0||g.key===r),t)}n(){this.j.value=(0,v.$Th)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:g}=r;if(t===e.$fq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,g,l=!1){if((0,A.$mg)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],g=this.J(i);for(const l of Object.keys(g))g[l]===r&&t.push(l);return t}z(i,r,t,g=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$fq,JSON.stringify(l),g)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$fq,JSON.stringify(l),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?S(r):Object.create(null)}isNew(i){return this.getBoolean(e.$eq,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case R.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,s.$Jl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const g=new Set;for(const[l,m]of i)g.add(l),r.get(l)!==m&&this.u(t,{key:l,external:!0});for(const[l]of r.items)g.has(l)||this.u(t,{key:l,external:!0})})}}e.$iq=d;function n(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$cq(new T.$dq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$kq=o;async function c(u,i,r,t,g,l){const m=w=>{try{return JSON.parse(w)}catch{return w}},p=new Map,h=new Map;u.forEach((w,F)=>{p.set(F,w),h.set(F,m(w))});const E=new Map,D=new Map;i.forEach((w,F)=>{E.set(F,w),D.set(F,m(w))});const b=new Map,k=new Map;r.forEach((w,F)=>{b.set(F,w),k.set(F,m(w))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(p.forEach((w,F)=>{C.push({key:F,value:w})}),console.table(C),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const w=[];E.forEach((F,N)=>{w.push({key:N,value:F})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${l})`);const f=[];b.forEach((w,F)=>{f.push({key:F,value:w})}),console.table(f),console.groupEnd(),console.log(k)}}),define(Oe[79],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$6oc=v}),define(Oe[50],Ne([1,0,15,23,29,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new I.$6g($=>{const s=this.b.get($.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,s){s===null?this.b.delete($.scheme):this.b.set($.scheme,s)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$$oc=A,e.$_oc=(0,O.$Di)("IExtHostFileSystemInfo")}),define(Oe[26],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0,e.$uQ=(0,v.$Di)("IExtHostInitDataService")}),define(Oe[188],Ne([1,0,9,11,172,26]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0;let A=class extends P.$ER{constructor($,s,R){const y=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",a=R.remote.isRemote?(0,v.localize)(10775,null):$?(0,v.localize)(10776,null):(0,v.localize)(10777,null);super(s.createLogger(y,{name:a}))}};e.$hrc=A,e.$hrc=A=Ge([Ve(1,I.$_j),Ve(2,O.$uQ)],A)}),define(Oe[189],Ne([1,0,10]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=void 0;class I{constructor(A,T,$){this.h=new Map,this.a=A,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Ph(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of s.values())R.complete()}catch(R){for(const y of s.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let $=this.f[A];return typeof $>"u"&&($=T),$}update(A,T){this.f[A]=T;const $=this.h.get(A);if($!==void 0)return $.p;const s=new v.$1h;return this.h.set(A,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$Qpc=I;class P extends I{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$Rpc=P}),define(Oe[190],Ne([1,0,6,2]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;class P{constructor(A){this.c=A,this.a=new v.$ke,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$ke,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,$,s){const y=this.c.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(T.value,$,s);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(I.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(I.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$Lqc=P}),define(Oe[16],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=e.$eQ=void 0,e.$eQ=(0,v.$Di)("IExtHostRpcService");class I{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$fQ=I}),define(Oe[191],Ne([1,0,18,6,4]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0;class O{#e;constructor(T,$){this.disposables=new P.$Sc,this.a=v.$pn.toKey(T.identifier),this.#e=$,this.onDidChange=I.Event.map(I.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,$){return this.#e.store(this.a,T,$)}delete(T){return this.#e.delete(this.a,T)}}e.$1pc=O}),define(Oe[65],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0,e.$opc=(0,v.$Di)("IURITransformerService");class I{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$ppc=I});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[114],Ne([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$oG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$eG=e.EditorInputCapabilities=e.$dG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=void 0,e.$7F=n,e.$8F=o,e.$9F=c,e.$0F=u,e.$$F=i,e.$_F=r,e.$aG=t,e.$bG=g,e.$cG=l,e.$fG=b,e.$gG=C,e.$hG=f,e.$iG=w,e.$jG=F,e.$kG=N,e.$lG=L,e.$mG=W,e.$nG=_,e.$pG=ae,e.$qG=oe,e.$rG=ke,e.$sG=Le,a=ri(a),e.$2F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$3F={id:"default",displayName:(0,v.localize)(12418,null),providerDisplayName:(0,v.localize)(12419,null)},e.$4F="workbench.editor.sidebysideEditor",e.$5F="workbench.editors.textDiffEditor",e.$6F="workbench.editors.binaryResourceDiffEditor";var S;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function c(Y,q,te){for(const ve of te.visibleEditorPanes)if(ve.group.id===q&&Y.matches(ve.input))return ve.getViewState()}function u(Y){if(b(Y))return!1;const q=Y;return P.URI.isUri(q?.resource)}function i(Y){if(b(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function r(Y){if(b(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(b(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function g(Y){if(b(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function l(Y){if(b(Y))return!1;const q=Y;return P.URI.isUri(q?.base?.resource)&&P.URI.isUri(q?.input1?.resource)&&P.URI.isUri(q?.input2?.resource)&&P.URI.isUri(q?.result?.resource)}var m;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var p;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p||(e.SaveReason=p={}));class h{constructor(){this.a=new Map}registerSource(q,te){let ve=this.a.get(q);return ve||(ve={source:q,label:te},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$dG=new h;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends O.$Tc{}e.$eG=D;function b(Y){return Y instanceof D}function k(Y){const q=Y;return P.URI.isUri(q?.preferredResource)}function C(Y){const q=Y;return b(q?.primary)&&b(q?.secondary)}function f(Y){const q=Y;return b(q?.modified)&&b(q?.original)}function w(Y,q,te,ve,ce){return Le(ve,[(0,y.$nj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12420,null),run:()=>{const we={...te,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,we)}}),(0,y.$nj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12421,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function F(Y){return b(Y?.editor)}function N(Y){const q=Y;return F(Y)&&q?.group!==void 0}function L(Y){const q=Y;return typeof q?.groupId=="number"&&b(q.editor)}function W(Y){return typeof Y?.groupId=="number"}var J;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(J||(e.EditorCloseContext=J={}));var M;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var K;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class Z{getOriginalUri(q,te){if(!q)return;if(l(q))return e.$oG.getOriginalUri(q.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:we}=this.a(q);if(ce&&we){if(te?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===K.ANY)return this.getOriginalUri(ce,{filterByScheme:te.filterByScheme})??this.getOriginalUri(we,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===K.PRIMARY?ce:we}}if(i(q)||r(q)||t(q)||l(q))return;const ve=k(q)?q.preferredResource:q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}a(q){return C(q)||t(q)?{primary:q.primary,secondary:q.secondary}:f(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,te){if(!q)return;if(l(q))return e.$oG.getCanonicalUri(q.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:we}=this.a(q);if(ce&&we){if(te?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===K.ANY)return this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===K.PRIMARY?ce:we}}if(i(q)||r(q)||t(q)||l(q))return;const ve=q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}b(q,te){if(Array.isArray(te)){if(te.some(ve=>q.scheme===ve))return q}else if(te===q.scheme)return q}}var ue;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ue||(e.EditorCloseMethod=ue={}));function _(Y,q,te,ve){if(!Y.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return te===ue.MOUSE||te===ue.KEYBOARD;case"mouse":return te===ue.MOUSE;case"keyboard":return te===ue.KEYBOARD}return!1}e.$oG=new Z;var ge;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const te=this.a=q.get(A.$Ci);for(const[ve,ce]of this.c)this.e(ve,ce,te);this.c.clear()}e(q,te,ve){const ce=ve.createInstance(te);this.d.set(q,ce)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,I.$og)(this.b)}registerEditorSerializer(q,te){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,te,this.a):this.c.set(q,te),(0,O.$Rc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$po.add(e.$2F.EditorFactory,new se);async function ae(Y,q,te){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const ce=P.URI.revive(ve.fileUri);if(!ce){te.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ce)){te.info("Cannot resolve the path because it cannot be handled",ve);return}let he=ve.exists,X=ve.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await q.stat(ce)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(me){te.error(me),he=!1}if(!he&&ve.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ve);return}if(X===$.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ve);return}const x={...ve.options,pinned:!0};return he?{resource:ce,options:x}:{resource:ce,options:x,forceUntitled:!0}}))}var $e;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function oe(Y){const q=Y;if(!q)return!1;const te=q;if(te.modified)return oe(te.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ke(Y){return(0,R.$pj)(Y)}function Le(Y,q,te){const ve=(0,R.$qj)(Y,q);return ve.forceMessage=te?.forceMessage,ve.forceSeverity=te?.forceSeverity,ve.allowDialog=te?.allowDialog,ve}}),define(Oe[192],Ne([1,0,6,9,3,4,28,30,25,97,182]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.$zG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$yG=e.ViewContentGroups=e.$wG=e.ViewContainerLocation=e.Extensions=e.$vG=e.$uG=e.$tG=void 0,e.$xG=S,e.$tG="views",e.$uG=(0,I.localize)(12258,null),e.$vG=(0,R.$zx)("default-view-icon",s.$3j.window,(0,I.localize)(12259,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$wG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$ke),this.onDidRegister=this.c.event,this.f=this.B(new v.$ke),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,m,p){const h=this.get(l.id);if(h)return h;const E=l;return E.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$wc)(this.g,m,[]).push(E),p?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:m}),E}deregisterViewContainer(l){for(const m of this.g.keys()){const p=this.g.get(m),h=p?.indexOf(l);if(h!==-1){p?.splice(h,1),p.length===0&&this.g.delete(m),this.f.fire({viewContainer:l,viewContainerLocation:m});return}}}get(l){return this.all.filter(m=>m.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(p=>p?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(m=>this.getViewContainerLocation(m)===l)}}T.$po.add(y.ViewContainersRegistry,new d);var n;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(n||(e.ViewContentGroups=n={}));function o(g,l){const m=g.group??n.More,p=l.group??n.More;return m!==p?m.localeCompare(p):(g.order??5)-(l.order??5)}class c extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$ke),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$ke),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$ke),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$ke),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(l,m){this.registerViews2([{views:l,viewContainer:m}])}registerViews2(l){l.forEach(({views:m,viewContainer:p})=>this.r(m,p)),this.c.fire(l)}deregisterViews(l,m){const p=this.s(l,m);p.length&&this.f.fire({views:p,viewContainer:m})}moveViews(l,m){for(const p of this.m.keys())if(p!==m){const h=this.s(l,p);h.length&&(this.r(h,m),this.g.fire({views:h,from:p,to:m}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const m of this.j){const p=(this.m.get(m)||[]).filter(h=>h.id===l)[0];if(p)return p}return null}getViewContainer(l){for(const m of this.j)if((this.m.get(m)||[]).filter(h=>h.id===l)[0])return m;return null}registerViewWelcomeContent(l,m){return this.n.add(l,m),this.h.fire(l),(0,O.$Rc)(()=>{this.n.delete(l,m),this.h.fire(l)})}registerViewWelcomeContent2(l,m){const p=new Map;for(const[h,E]of m)this.n.add(l,E),p.set(h,(0,O.$Rc)(()=>{this.n.delete(l,E),this.h.fire(l)}));return this.h.fire(l),p}getViewWelcomeContent(l){const m=[];return this.n.forEach(l,p=>m.push(p)),m.sort(o)}r(l,m){let p=this.m.get(m);p||(p=[],this.m.set(m,p),this.j.push(m));for(const h of l){if(this.getView(h.id)!==null)throw new Error((0,I.localize)(12260,null,h.id));p.push(h)}}s(l,m){const p=this.m.get(m);if(!p)return[];const h=[],E=[];for(const D of p)l.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(m,E):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),h}}T.$po.add(y.ViewsRegistry,new c),e.$yG=(0,P.$Di)("viewDescriptorService");var u;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,m){this.c=!1,this.d=!1,(0,$.$fo)(this,l),this.d=!!m,this.resolve=async p=>{if(m&&!this.c){const h=await m(p);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$zG=r;class t extends Error{constructor(l){super((0,I.localize)(12261,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$AG=t}),define(Oe[193],Ne([1,0,9,31]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=void 0,e.$EG=new I.$Uj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8381,null)}),e.$FG=new I.$Uj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8382,null)}),e.$GG=new I.$Uj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8383,null)}),e.$HG=new I.$Uj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8384,null)}),e.$IG=new I.$Uj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8385,null)}),e.$JG=new I.$Uj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8386,null)}),e.$KG=new I.$Uj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8387,null)}),e.$LG=new I.$Uj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8388,null)}),e.$MG=new I.$Uj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8389,null)}),e.$NG=new I.$Uj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8390,null)}),e.$OG=new I.$Uj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8391,null)}),e.$PG=new I.$Uj("inChat",!1,{type:"boolean",description:(0,v.localize)(8392,null)}),e.$QG=new I.$Uj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8393,null)}),e.$RG=new I.$Uj("chatCursorAtTop",!1),e.$SG=new I.$Uj("chatInputHasAgent",!1),e.$TG=new I.$Uj("chatLocation",void 0),e.$UG=new I.$Uj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8394,null)})}),define(Oe[115],Ne([1,0,283,10,21,6,39,4,40,143,12,31,18,3,11,108,176,187,193]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.ChatAgentLocation=void 0,e.$YH=m,e.$ZH=p;var r;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(r||(e.ChatAgentLocation=r={})),e.$TH=(0,S.$Di)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$ke,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=u.$QG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,C=D.slashCommands;D={...D,get slashCommands(){return C.filter(w=>!w.when||k.f.contextMatchesRules(y.$Bj.deserialize(w.when)))}};const f={data:D};return this.b.set(E,f),(0,T.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const b=this.b.get(E);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return b.data.isDefault&&this.e.set(!0),b.impl=D,this.d.fire(new g(b.data,D)),(0,T.$Rc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const b={data:E,impl:D};return this.b.set(E.id,b),this.d.fire(new g(E,D)),(0,T.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,b){return await this.g.get(E)?.(D,b)??[]}updateAgent(E,D){const b=this.b.get(E);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);b.data.metadata={...b.data.metadata,...D},this.d.fire(new g(b.data,b.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Bj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=A.Iterable.find(this.b.values(),b=>m(b.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(b=>b.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,b,k,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,b,k,C)}async getFollowups(E,D,b,k,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,b,k,C):[]}};e.$UH=t,e.$UH=t=Ge([Ve(0,y.$Vj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,b,k){return this.d.invoke(E,D,b,k)}async provideFollowups(E,D,b,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,b,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$VH=g,e.$WH=(0,S.$Di)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,b,k){if(this.g=D,this.h=b,this.i=k,this.e=(0,s.$5d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const C=k.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{k.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,I.$Eh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$_p)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const b=D.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),b=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&b}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(C=>(0,R.$Ef)(C,C.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$XH=l,e.$XH=l=i=Ge([Ve(0,n.$rk),Ve(1,o.$6p),Ve(2,d.$$j),Ve(3,c.$gq)],l);function m(h){return`${h.extensionId.value}.${h.id}`}function p(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$pn("")),(0,$.$ai)(E)}}),define(Oe[194],Ne([1,0,2,32,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=e.$rH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$pH=O,e.$qH=A;function O(s){return!!s&&typeof s=="object"&&"uri"in s&&s.uri instanceof v.URI&&"version"in s&&typeof s.version=="number"&&"ranges"in s&&Array.isArray(s.ranges)&&s.ranges.every(I.$Mt.isIRange)}function A(s){return!!s&&typeof s=="object"&&"documents"in s&&Array.isArray(s.documents)&&s.documents.every(O)}var T;(function(s){s[s.Down=0]="Down",s[s.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(s){s[s.Action=1]="Action",s[s.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$rH=(0,P.$Di)("IChatService"),e.$sH="accessibility.voice.keywordActivation"}),define(Oe[195],Ne([1,0,6,10,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ztb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$ke,this.o=new v.$ke,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,s,R){const y={command:T};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,P.localize)(7481,null,R,T)};S(d)}},R)}return s&&this.f.set(y.seq,s),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,I.$Eh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,s=this.f.get($.request_seq);s&&(this.f.delete($.request_seq),s($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,s)=>T.set(s,$)),await(0,I.$Eh)(500),T.forEach(($,s)=>{$({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Ztb=O}),define(Oe[80],Ne([1,0,2,9,31,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$MK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$KK=e.MemoryRangeType=e.State=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=void 0,e.$JK=$,e.$LK=R,I=We(I),e.$xJ="workbench.view.debug",e.$yJ="workbench.debug.variablesView",e.$zJ="workbench.debug.watchExpressionsView",e.$AJ="workbench.debug.callStackView",e.$BJ="workbench.debug.loadedScriptsView",e.$CJ="workbench.debug.breakPointsView",e.$DJ="workbench.debug.disassemblyView",e.$EJ="workbench.panel.repl",e.$FJ="workbench.panel.repl.view",e.$GJ=new P.$Uj("debugType",void 0,{type:"string",description:I.localize(7418,null)}),e.$HJ=new P.$Uj("debugConfigurationType",void 0,{type:"string",description:I.localize(7419,null)}),e.$IJ=new P.$Uj("debugState","inactive",{type:"string",description:I.localize(7420,null)}),e.$JJ="debugUx",e.$KJ=new P.$Uj(e.$JJ,"default",{type:"string",description:I.localize(7421,null)}),e.$LJ=new P.$Uj("hasDebugged",!1,{type:"boolean",description:I.localize(7422,null)}),e.$MJ=new P.$Uj("inDebugMode",!1,{type:"boolean",description:I.localize(7423,null)}),e.$NJ=new P.$Uj("inDebugRepl",!1,{type:"boolean",description:I.localize(7424,null)}),e.$OJ=new P.$Uj("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7425,null)}),e.$PJ=new P.$Uj("inBreakpointWidget",!1,{type:"boolean",description:I.localize(7426,null)}),e.$QJ=new P.$Uj("breakpointsFocused",!0,{type:"boolean",description:I.localize(7427,null)}),e.$RJ=new P.$Uj("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(7428,null)}),e.$SJ=new P.$Uj("watchExpressionsExist",!1,{type:"boolean",description:I.localize(7429,null)}),e.$TJ=new P.$Uj("variablesFocused",!0,{type:"boolean",description:I.localize(7430,null)}),e.$UJ=new P.$Uj("expressionSelected",!1,{type:"boolean",description:I.localize(7431,null)}),e.$VJ=new P.$Uj("breakpointInputFocused",!1,{type:"boolean",description:I.localize(7432,null)}),e.$WJ=new P.$Uj("callStackItemType",void 0,{type:"string",description:I.localize(7433,null)}),e.$XJ=new P.$Uj("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(7434,null)}),e.$YJ=new P.$Uj("callStackItemStopped",!1,{type:"boolean",description:I.localize(7435,null)}),e.$ZJ=new P.$Uj("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(7436,null)}),e.$1J=new P.$Uj("watchItemType",void 0,{type:"string",description:I.localize(7437,null)}),e.$2J=new P.$Uj("canViewMemory",void 0,{type:"boolean",description:I.localize(7438,null)}),e.$3J=new P.$Uj("breakpointItemType",void 0,{type:"string",description:I.localize(7439,null)}),e.$4J=new P.$Uj("breakpointItemBytes",void 0,{type:"boolean",description:I.localize(7440,null)}),e.$5J=new P.$Uj("breakpointHasModes",!1,{type:"boolean",description:I.localize(7441,null)}),e.$6J=new P.$Uj("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(7442,null)}),e.$7J=new P.$Uj("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(7443,null)}),e.$8J=new P.$Uj("loadedScriptsItemType",void 0,{type:"string",description:I.localize(7444,null)}),e.$9J=new P.$Uj("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(7445,null)}),e.$0J=new P.$Uj("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(7446,null)}),e.$$J=new P.$Uj("stepBackSupported",!1,{type:"boolean",description:I.localize(7447,null)}),e.$_J=new P.$Uj("restartFrameSupported",!1,{type:"boolean",description:I.localize(7448,null)}),e.$aK=new P.$Uj("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(7449,null)}),e.$bK=new P.$Uj("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(7450,null)}),e.$cK=new P.$Uj("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(7451,null)}),e.$dK=new P.$Uj("breakpointsExist",!1,{type:"boolean",description:I.localize(7452,null)}),e.$eK=new P.$Uj("debuggersAvailable",!1,{type:"boolean",description:I.localize(7453,null)}),e.$fK=new P.$Uj("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(7454,null)}),e.$gK=new P.$Uj("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(7455,null)}),e.$hK=new P.$Uj("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(7456,null)}),e.$iK=new P.$Uj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:I.localize(7457,null)}),e.$jK=new P.$Uj("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(7458,null)}),e.$kK=new P.$Uj("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(7459,null)}),e.$lK=new P.$Uj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(7460,null)}),e.$mK=new P.$Uj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(7461,null)}),e.$nK=new P.$Uj("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(7462,null)}),e.$oK=new P.$Uj("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(7463,null)}),e.$pK=new P.$Uj("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(7464,null)}),e.$qK=new P.$Uj("variableIsReadonly",!1,{type:"boolean",description:I.localize(7465,null)}),e.$rK=new P.$Uj("variableValue",!1,{type:"string",description:I.localize(7466,null)}),e.$sK=new P.$Uj("variableType",!1,{type:"string",description:I.localize(7467,null)}),e.$tK=new P.$Uj("variableInterfaces",!1,{type:"array",description:I.localize(7468,null)}),e.$uK=new P.$Uj("variableName",!1,{type:"string",description:I.localize(7469,null)}),e.$vK=new P.$Uj("variableLanguage",!1,{type:"string",description:I.localize(7470,null)}),e.$wK=new P.$Uj("variableExtensionId",!1,{type:"string",description:I.localize(7471,null)}),e.$xK=new P.$Uj("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(7472,null)}),e.$yK=new P.$Uj("multiSessionRepl",!1,{type:"boolean",description:I.localize(7473,null)}),e.$zK=new P.$Uj("multiSessionDebug",!1,{type:"boolean",description:I.localize(7474,null)}),e.$AK=new P.$Uj("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(7475,null)}),e.$BK=new P.$Uj("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(7476,null)}),e.$CK=new P.$Uj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(7477,null)}),e.$DK=new P.$Uj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(7478,null)});const A=i=>I.localize(7479,null,i);e.$EK=A,e.$FK="editor.contrib.debug",e.$GK="editor.contrib.breakpoint",e.$HK="debug",e.$IK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(7480,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function $(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$KK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$MK=(0,O.$Di)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var c;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(c||(e.IDebugVisualizationTreeItem=c={}));var u;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(u||(e.IDebugVisualization=u={}))}),define(Oe[196],Ne([1,0,12,2,19,25,15,32,21,17]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eI=void 0,e.$5H=y,e.$6H=a,e.$7H=S,e.$8H=d,e.$9H=n,e.$0H=o,e.$$H=c,e.$_H=i,e.$aI=g,e.$bI=l,e.$cI=p,e.$dI=E;const R=/{([^}]+)}/g;function y(b,k,C){return b.replace(R,function(f,w){return k&&w.length>0&&w[0]!=="_"?f:C&&C.hasOwnProperty(w)?C[w]:f})}function a(b){const k={};for(const C of Object.keys(b))C.startsWith("!")||(k[C]=b[C]);return k}function S(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||S(b.parentSession))}function d(b){let k=b.configuration.type;if(k)return k==="vslsShare"&&(k=b.configuration.adapterProxy.configuration.type),(0,v.$Ef)(k,"extensionhost")||(0,v.$Ef)(k,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function o(b,k,C){let f,w=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(b);){const L=N.index+1,W=L+N[0].length;if(L<=k&&W>=C){f=N[0],w=L;break}}if(f){const L=/(\w|\p{L})+/gu;let W=null;for(;(W=L.exec(f))&&!(W.index+1+w+W[0].length>=C););W&&(f=f.substring(0,L.lastIndex))}return f?{start:w,end:w+f.length-1}:{start:0,end:0}}async function c(b,k,C,f){if(b.evaluatableExpressionProvider.has(k)){const w=b.evaluatableExpressionProvider.ordered(k),F=(0,s.$Gb)(await Promise.all(w.map(async N=>{try{return await N.provideEvaluatableExpression(k,C,f??$.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const L=F[0].range;return N||(N=k.getLineContent(C.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const w=k.getLineContent(C.lineNumber),{start:F,end:N}=o(w,C.column,C.column),L=w.substring(F-1,N);return{matchingExpression:L,range:new T.$Mt(C.lineNumber,F,C.lineNumber,F+L.length)}}return null}const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(u))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return I.URI.parse(b.path);if((0,P.$hc)(b.path))return I.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const k=I.URI.revive(b.path);if(k)return k.scheme===A.Schemas.file?k.fsPath:k.toString()}return b.path}function g(b,k){const C=k?r:t,f=(0,O.$co)(b);return m(f,(w,F)=>{w&&F&&(F.path=C(F))}),f}function l(b,k){const C=k?r:t,f=(0,O.$co)(b);return m(f,(w,F)=>{!w&&F&&(F.path=C(F))}),f}function m(b,k){switch(b.type){case"event":{const C=b;switch(C.event){case"output":k(!1,C.body.source);break;case"loadedSource":k(!1,C.body.source);break;case"breakpoint":k(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=b;switch(C.command){case"setBreakpoints":k(!0,C.arguments.source);break;case"breakpointLocations":k(!0,C.arguments.source);break;case"source":k(!0,C.arguments.source);break;case"gotoTargets":k(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(f=>k(!1,f));break;default:break}break}case"response":{const C=b;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(f=>k(!1,f.source));break;case"loadedSources":C.body.sources.forEach(f=>k(!1,f));break;case"scopes":C.body.scopes.forEach(f=>k(!1,f.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(f=>k(!1,f.source));break;case"setBreakpoints":C.body.breakpoints.forEach(f=>k(!1,f.source));break;case"disassemble":C.body?.instructions.forEach(w=>k(!1,w.location));break;default:break}break}}}function p(b){return b.filter(k=>!k.presentation?.hidden).sort((k,C)=>k.presentation?C.presentation?k.presentation.group?C.presentation.group?k.presentation.group!==C.presentation.group?k.presentation.group.localeCompare(C.presentation.group):h(k.presentation.order,C.presentation.order):-1:C.presentation.group?1:h(k.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function h(b,k){return typeof b!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:b-k}async function E(b,k){const C=b.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(C!=="none"&&(await k.saveAll(),C==="allEditorsInActiveGroup")){const f=k.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await k.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const D=(b,k)=>!b||!k?b===k:b.name===k.name&&b.path===k.path&&b.sourceReference===k.sourceReference;e.$eI=D}),define(Oe[197],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.CellExecutionUpdateType=void 0;var I;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(I||(e.CellExecutionUpdateType=I={})),e.$UK=(0,v.$Di)("INotebookExecutionService")}),define(Oe[198],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=e.ProxyKernelState=e.$WK=void 0,e.$WK=100;var I;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(I||(e.ProxyKernelState=I={})),e.$XK=(0,v.$Di)("INotebookKernelService"),e.$YK=(0,v.$Di)("INotebookKernelHistoryService")}),define(Oe[199],Ne([1,0,4,32,52,162,102]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Zb=void 0;class T extends v.$Tc{constructor(s,R,y){super(),this._source=s,this.b=R,this.c=y,this.a=void 0}f(s){const R=s.getLineCount();return new I.$Mt(1,1,R,this.g(s,R))}g(s,R){if(R<1||R>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const s=new O.$uD;s.acceptChunk(this._source);const R=s.finish(!0),{textBuffer:y,disposable:a}=R.create(P.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const R=new O.$uD;R.acceptChunk(s);const y=R.finish(!0),{textBuffer:a,disposable:S}=y.create(P.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(s){const y=new A.$iD(s,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(s){const y=new A.$iD(s,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$5Zb=T}),define(Oe[54],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var I;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(I||(e.TestPosition=I={}));class P{static fromExtHostTestItem(A,T,$=A.parent){if(A._isRoot)return new P([T]);const s=[A.id];for(let R=$;R&&R.id!==T;R=R.parent)s.push(R.id);return s.push(T),new P(s.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new P(A.split(v.Delimiter))}static join(A,T){return new P([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T[A.length]===v.Delimiter&&T.startsWith(A)}static compare(A,T){return A===T?I.IsSame:P.isChild(A,T)?I.IsChild:P.isChild(T,A)?I.IsParent:I.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let $=0;for(;$<A-1;){for(let s=1;s<A;s++){const R=T(s-1),y=T(s);if(R.path[$]!==y.path[$])return $}$++}return $}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return I.Disconnected;return A.d>this.d?I.IsChild:A.d<this.d?I.IsParent:I.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$4I=P}),define(Oe[55],Ne([1,0,2,101,32,54]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$_I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$$I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$0I=e.$9I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$8I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$7I=e.$6I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$5I=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$5I={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$6I=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const s=M=>"runId"in M;e.$7I=s;var R;(function(M){M.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),M.deserialize=(K,Z)=>({range:P.$Mt.lift(Z.range),uri:K.asCanonicalUri(v.URI.revive(Z.uri))})})(R||(e.IRichLocation=R={}));var y;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(y||(e.TestMessageType=y={}));var a;(function(M){M.serialize=K=>({label:K.label,uri:K.uri?.toJSON(),position:K.position?.toJSON()}),M.deserialize=(K,Z)=>({label:Z.label,uri:Z.uri?K.asCanonicalUri(v.URI.revive(Z.uri)):void 0,position:Z.position?I.$Lt.lift(Z.position):void 0})})(a||(e.ITestMessageStackFrame=a={}));var S;(function(M){M.serialize=K=>({message:K.message,type:y.Error,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&R.serialize(K.location),stackTrace:K.stackTrace?.map(a.serialize)}),M.deserialize=(K,Z)=>({message:Z.message,type:y.Error,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&R.deserialize(K,Z.location),stackTrace:Z.stackTrace&&Z.stackTrace.map(ue=>a.deserialize(K,ue))})})(S||(e.ITestErrorMessage=S={}));const d=(M,K)=>`${K?"s":"e"}${M}`;e.$8I=d;var n;(function(M){M.serialize=K=>({message:K.message,type:y.Output,offset:K.offset,length:K.length,location:K.location&&R.serialize(K.location)}),M.deserialize=(K,Z)=>({message:Z.message,type:y.Output,offset:Z.offset,length:Z.length,location:Z.location&&R.deserialize(K,Z.location)})})(n||(e.ITestOutputMessage=n={}));var o;(function(M){M.serialize=K=>K.type===y.Error?S.serialize(K):n.serialize(K),M.deserialize=(K,Z)=>Z.type===y.Error?S.deserialize(K,Z):n.deserialize(K,Z),M.isDiffable=K=>K.type===y.Error&&K.actual!==void 0&&K.expected!==void 0})(o||(e.ITestMessage=o={}));var c;(function(M){M.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),M.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(o.serialize)}),M.deserialize=(K,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(ue=>o.deserialize(K,ue))})})(c||(e.ITestTaskState=c={}));const u="\0",i=(M,K)=>M+u+K;e.$9I=i;const r=M=>{const K=M.indexOf(u);return{ctrlId:M.slice(0,K),tagId:M.slice(K+1)}};e.$0I=r;var t;(function(M){M.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),M.deserialize=(K,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?K.asCanonicalUri(v.URI.revive(Z.uri)):void 0,range:Z.range?P.$Mt.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})(t||(e.ITestItem=t={}));var g;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var l;(function(M){M.serialize=K=>({expand:K.expand,item:t.serialize(K.item)}),M.deserialize=(K,Z)=>({controllerId:O.$4I.root(Z.item.extId),expand:Z.expand,item:t.deserialize(K,Z.item)})})(l||(e.InternalTestItem=l={}));var m;(function(M){M.serialize=K=>{let Z;return K.item&&(Z={},K.item.label!==void 0&&(Z.label=K.item.label),K.item.tags!==void 0&&(Z.tags=K.item.tags),K.item.busy!==void 0&&(Z.busy=K.item.busy),K.item.uri!==void 0&&(Z.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(Z.range=K.item.range?.toJSON()),K.item.description!==void 0&&(Z.description=K.item.description),K.item.error!==void 0&&(Z.error=K.item.error),K.item.sortText!==void 0&&(Z.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Z}},M.deserialize=K=>{let Z;return K.item&&(Z={},K.item.label!==void 0&&(Z.label=K.item.label),K.item.tags!==void 0&&(Z.tags=K.item.tags),K.item.busy!==void 0&&(Z.busy=K.item.busy),K.item.range!==void 0&&(Z.range=K.item.range?P.$Mt.lift(K.item.range):null),K.item.description!==void 0&&(Z.description=K.item.description),K.item.error!==void 0&&(Z.error=K.item.error),K.item.sortText!==void 0&&(Z.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Z}}})(m||(e.ITestItemUpdate=m={}));const p=(M,K)=>{K.expand!==void 0&&(M.expand=K.expand),K.item!==void 0&&(M.item=M.item?Object.assign(M.item,K.item):K.item)};e.$$I=p;var h;(function(M){M.serializeWithoutMessages=K=>({...l.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(c.serializeWithoutMessages)}),M.serialize=K=>({...l.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(c.serialize)}),M.deserialize=(K,Z)=>({...l.deserialize(K,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(ue=>c.deserialize(K,ue)),retired:!0})})(h||(e.TestResultItem=h={}));var E;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(K,Z)=>{K.covered+=Z.covered,K.total+=Z.total}})(E||(e.ICoverageCount=E={}));var D;(function(M){M.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testIds:K.testIds,uri:K.uri.toJSON()}),M.deserialize=(K,Z)=>({id:Z.id,statement:Z.statement,branch:Z.branch,declaration:Z.declaration,testIds:Z.testIds,uri:K.asCanonicalUri(v.URI.revive(Z.uri))}),M.empty=(K,Z)=>({id:K,uri:Z,statement:E.empty()})})(D||(e.IFileCoverage=D={}));function b(M){return{...M,location:M.location?.toJSON()}}function k(M){return M.location=M.location?I.$Lt.isIPosition(M.location)?I.$Lt.lift(M.location):P.$Mt.lift(M.location):void 0,M}e.$_I=3;var C;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(C||(e.DetailType=C={}));var f;(function(M){M.serialize=K=>K.type===C.Declaration?F.serialize(K):N.serialize(K),M.deserialize=K=>K.type===C.Declaration?F.deserialize(K):N.deserialize(K)})(f||(e.CoverageDetails=f={}));var w;(function(M){M.serialize=b,M.deserialize=k})(w||(e.IBranchCoverage=w={}));var F;(function(M){M.serialize=b,M.deserialize=k})(F||(e.IDeclarationCoverage=F={}));var N;(function(M){M.serialize=K=>({...b(K),branches:K.branches?.map(w.serialize)}),M.deserialize=K=>({...k(K),branches:K.branches?.map(w.deserialize)})})(N||(e.IStatementCoverage=N={}));var L;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var W;(function(M){M.deserialize=(K,Z)=>Z.op===L.Add?{op:Z.op,item:l.deserialize(K,Z.item)}:Z.op===L.Update?{op:Z.op,item:m.deserialize(Z.item)}:Z.op===L.DocumentSynced?{op:Z.op,uri:K.asCanonicalUri(v.URI.revive(Z.uri)),docv:Z.docv}:Z,M.serialize=K=>K.op===L.Add?{op:K.op,item:l.serialize(K.item)}:K.op===L.Update?{op:K.op,item:m.serialize(K.item)}:K})(W||(e.TestsDiffOp=W={}));class J{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const Z=this.w();for(const ue of K)switch(ue.op){case L.Add:this.l(l.deserialize(this.k,ue.item),Z);break;case L.Update:this.p(m.deserialize(ue.item),Z);break;case L.Remove:this.q(ue.itemId,Z);break;case L.Retire:this.v(ue.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(ue.amount);break;case L.AddTag:this.c.set(ue.tag.id,ue.tag);break;case L.RemoveTag:this.c.delete(ue.id);break}Z.complete?.()}l(K,Z){const ue=O.$4I.parentId(K.item.extId)?.toString();let _;if(!ue)_=this.x(K),this.g.add(_),this.f.set(K.item.extId,_);else if(this.f.has(ue)){const ge=this.f.get(ue);ge.children.add(K.item.extId),_=this.x(K,ge),this.f.set(K.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return Z.add?.(_),K.expand===g.BusyExpanding&&this.h++,_}p(K,Z){const ue=this.f.get(K.extId);if(ue)return K.expand!==void 0&&(ue.expand===g.BusyExpanding&&this.h--,K.expand===g.BusyExpanding&&this.h++),(0,e.$$I)(ue,K),Z.update?.(ue),ue}q(K,Z){const ue=this.f.get(K);if(!ue)return;const _=O.$4I.parentId(ue.item.extId)?.toString();_?this.f.get(_).children.delete(ue.item.extId):this.g.delete(ue);const ge=[[K]];for(;ge.length;)for(const se of ge.pop()){const ae=this.f.get(se);ae&&(ge.push(ae.children),this.f.delete(se),Z.remove?.(ae,ae!==ue),ae.expand===g.BusyExpanding&&this.h--)}}v(K){}updatePendingRoots(K){this.j+=K}w(){return{}}}e.$aJ=J}),define(Oe[200],Ne([1,0,98,9,55]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$EGb=e.$DGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[P.TestResultState.Errored]:(0,I.localize)(3163,null),[P.TestResultState.Failed]:(0,I.localize)(3164,null),[P.TestResultState.Passed]:(0,I.localize)(3165,null),[P.TestResultState.Queued]:(0,I.localize)(3166,null),[P.TestResultState.Running]:(0,I.localize)(3167,null),[P.TestResultState.Skipped]:(0,I.localize)(3168,null),[P.TestResultState.Unset]:(0,I.localize)(3169,null)},s=(y,a)=>(0,I.localize)(3170,null,(0,v.$Xk)(y),$[a]);e.$DGb=s,e.$EGb={[P.TestRunProfileBitset.Debug]:(0,I.localize)(3171,null),[P.TestRunProfileBitset.Run]:(0,I.localize)(3172,null),[P.TestRunProfileBitset.Coverage]:(0,I.localize)(3173,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Oe[81],Ne([1,0,10,6,4,61,55,54]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.TestItemEventOp=void 0;var $;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const s=(u,i)=>u===i,y=Object.entries({range:(u,i)=>u===i?!0:!u||!i?!1:u.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(u,i)=>!(u.length!==i.length||u.some(r=>!i.includes(r)))}),a=(u,i)=>{let r;for(const[t,g]of y)g(u[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class S extends P.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Ph(()=>this.flushDiff(),200)),this.g=this.B(new I.$ke),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$$I)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$$I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,r-1):g.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case $.RemoveChild:this.O(T.$4I.joinToString(i.fullId,r.id));break;case $.Upsert:this.z(r.item,i);break;case $.Bulk:for(const t of r.ops)this.w(i,t);break;case $.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$dd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$4I.fromExtHostTestItem(i,this.root.id,r?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==r?.actual&&this.s.getChildren(g.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const m=this.s.getChildren(l.actual),p=l.actual,h=a(this.s.toITestItem(p),this.s.toITestItem(i));this.s.getApiFor(p).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=A.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,p.tags,t.toString()),delete h.tags),this.w(l,{op:$.SetProp,update:h})),this.I(i,l,r);for(const[D,b]of m)this.s.getChildren(i).get(b.id)||this.O(T.$4I.joinToString(t,b.id));const E=l.expandLevels;E!==void 0&&queueMicrotask(()=>{l.expand===A.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(l.actual.uri)}C(i,r,t){const g=new Set(r.map(l=>l.id));for(const l of i)g.delete(l.id)||this.D(l);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,A.$9I)(this.s.controllerId,l.id))}}}),g.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$9I)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$9I)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[g,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[g,l]of this.s.getChildren(i.actual)){const m=this.expand(T.$4I.joinToString(i.fullId,l.id),r);(0,v.$ph)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new v.$Ch;return l.open(),l}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Ch,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,v.$ph)(g)?g.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const l of g.actual.tags)this.F(l.id);this.tree.delete(g.fullId.toString());for(const[l,m]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$4I.joinToString(g.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$7P=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$8P=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$9P=n;class o extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$0P=o;const c=(u,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(g,l){for(const m of t.values())g.call(l,m,this)},[Symbol.iterator](){return t.entries()},replace(g){const l=new Map,m=new Set(t.keys()),p={op:$.Bulk,ops:[]};for(const h of g){if(!(h instanceof r))throw new n(h.id);const E=i(h).controllerId;if(E!==u.controllerId)throw new o(h.id,E,u.controllerId);if(l.has(h.id))throw new d(h.id);l.set(h.id,h),m.delete(h.id),p.ops.push({op:$.Upsert,item:h})}for(const h of m.keys())p.ops.push({op:$.RemoveChild,id:h});u.listener?.(p),t=l},add(g){if(!(g instanceof r))throw new n(g.id);t.set(g.id,g),u.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&u.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$$P=c}),define(Oe[116],Ne([1,0,81]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=void 0;const I=new WeakMap,P=(A,T)=>{const $={controllerId:T};return I.set(A,$),$};e.$_P=P;const O=A=>{const T=I.get(A);if(!T)throw new v.$9P(A?.id||"<unknown>");return T};e.$aQ=O}),define(Oe[82],Ne([1,0,27,15,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xDb=e.$wDb=e.$vDb=void 0,e.$yDb=O,e.$zDb=T,e.$vDb="vscode-cdn.net",e.$wDb=`vscode-resource.${e.$vDb}`,e.$xDb=`'self' https://*.${e.$vDb}`;function O($,s){return $.scheme===I.Schemas.http||$.scheme===I.Schemas.https?$:(s&&s.authority&&s.isRemote&&$.scheme===I.Schemas.file&&($=P.URI.from({scheme:I.Schemas.vscodeRemote,authority:s.authority,path:$.path})),P.URI.from({scheme:I.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$wDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,s=>{const R=s.charCodeAt(0);return R>=v.CharCode.a&&R<=v.CharCode.z||R>=v.CharCode.A&&R<=v.CharCode.Z||R>=v.CharCode.Digit0&&R<=v.CharCode.Digit9?s:"-"+R.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(s,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Oe[201],Ne([1,0,6,4,82]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0;class O{constructor(T,$,s){this.d=T,this.e=$,this.f=s,this.a=0,this.b=new I.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,s,R,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,n=new v.$ke,o=new v.$ke,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$yDb)(i,S.f)}get cspSource(){return P.$xDb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return S.d.$postMessage(d,i)}},u=new class{constructor(){this.editor=T,this.line=$,this.height=s,this.webview=c,this.onDidDispose=o.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,$+1,s,R||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:u,onDidReceiveMessage:n}),u}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$mpc=O}),define(Oe[117],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0,e.$GM="__",e.$HM=(0,v.$Di)("IAuthenticationService"),e.$IM=(0,v.$Di)("IAuthenticationExtensionsService")}),define(Oe[202],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=e.VariableKind=e.$5Q=void 0,e.$5Q=(0,v.$Di)("configurationResolverService");var I;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(I||(e.VariableKind=I={}));class P extends Error{constructor(A,T){super(T),this.variable=A}}e.$6Q=P}),define(Oe[203],Ne([1,0,19,78,14,25,20,99,9,202,12]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=void 0,v=We(v),I=We(I),P=We(P),O=We(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,n,o){this.h=new Map,this.a=S,this.b=d,this.g=n,o&&(this.c=o.then(c=>this.i(c)))}i(S){if(A.$j){const d=Object.create(null);return Object.keys(S).forEach(n=>{d[n.toLowerCase()]=S[n]}),d}return S}resolveWithEnvironment(S,d,n){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(S,d){const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,d)}async j(S,d,n,o){const c=O.$co(d);A.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):A.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):A.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,S?S.uri:void 0,c,n,o)}async resolveAnyAsync(S,d,n){return this.j(S,d,n)}async resolveAnyMap(S,d,n){const o=new Map;return{newConfig:await this.j(S,d,n,o),resolvedVariables:o}}resolveWithInteractionReplace(S,d,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,n,o,c){if(P.$dg(n))return this.m(S,d,n,o,c);if(Array.isArray(n))return Promise.all(n.map(u=>this.l(S,d,u,o,c)));if(P.$fg(n)){const u=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(S,d,r,o,c),await this.l(S,d,n[r],o,c)]));for(const[r,t]of i)u[r]=t;return u}return n}m(S,d,n,o,c){return(0,R.$wf)(n,y.VARIABLE_REGEXP,async(u,i)=>{if(i.includes(y.VARIABLE_LHS))return u;let r=await this.o(S,u,i,d,o);return c?.set(i,r),r!==u&&P.$dg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(S,d,r,o,c)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,n,o,c){let u;const i=n.split(":");i.length>1&&(n=i[0],u=i[1]);const r=l=>{const m=this.a.getFilePath();if(m)return(0,T.$Yw)(m);throw new s.$6Q(l,(0,$.localize)(2061,null,d))},t=l=>{const m=r(l);if(this.a.getWorkspaceFolderPathForFile){const p=this.a.getWorkspaceFolderPathForFile();if(p)return(0,T.$Yw)(p)}throw new s.$6Q(l,(0,$.localize)(2062,null,d,v.$mc(m)))},g=l=>{if(u){const m=this.a.getFolderUri(u);if(m)return m;throw new s.$6Q(l,(0,$.localize)(2063,null,d,u))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new s.$6Q(l,(0,$.localize)(2064,null,d)):new s.$6Q(l,(0,$.localize)(2065,null,d))};switch(n){case"env":if(u){if(S.env){const l=S.env[A.$j?u.toLowerCase():u];if(P.$dg(l))return l}return""}throw new s.$6Q(s.VariableKind.Env,(0,$.localize)(2066,null,d));case"config":if(u){const l=this.a.getConfigurationValue(o,u);if(P.$mg(l))throw new s.$6Q(s.VariableKind.Config,(0,$.localize)(2067,null,d,u));if(P.$fg(l))throw new s.$6Q(s.VariableKind.Config,(0,$.localize)(2068,null,d,u));return l}throw new s.$6Q(s.VariableKind.Config,(0,$.localize)(2069,null,d));case"command":return this.p(s.VariableKind.Command,d,u,c,"command");case"input":return this.p(s.VariableKind.Input,d,u,c,"input");case"extensionInstallFolder":if(u){const l=await this.a.getExtension(u);if(!l)throw new s.$6Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2070,null,d,u));return this.n(l.extensionLocation)}throw new s.$6Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2071,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Yw)(this.n(g(s.VariableKind.WorkspaceFolder)));case"cwd":return o||u?(0,T.$Yw)(this.n(g(s.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Yw)(v.$mc(this.n(g(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new s.$6Q(s.VariableKind.UserHome,(0,$.localize)(2072,null,d))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new s.$6Q(s.VariableKind.LineNumber,(0,$.localize)(2073,null,d))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new s.$6Q(s.VariableKind.SelectedText,(0,$.localize)(2074,null,d))}case"file":return r(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$mc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||u?v.$kc(this.n(g(s.VariableKind.RelativeFile)),r(s.VariableKind.RelativeFile)):r(s.VariableKind.RelativeFile);case"relativeFileDirname":{const l=v.$lc(r(s.VariableKind.RelativeFileDirname));if(o||u){const m=v.$kc(this.n(g(s.VariableKind.RelativeFileDirname)),l);return m.length===0?".":m}return l}case"fileDirname":return v.$lc(r(s.VariableKind.FileDirname));case"fileExtname":return v.$nc(r(s.VariableKind.FileExtname));case"fileBasename":return v.$mc(r(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=v.$mc(r(s.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-v.$nc(l).length)}case"fileDirnameBasename":return v.$mc(v.$lc(r(s.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||d}case"execInstallFolder":{const l=this.a.getAppRoot();return l||d}case"pathSeparator":case"/":return v.sep;default:try{const l=u?`${n}:${u}`:n;return this.p(s.VariableKind.Unknown,d,l,c,void 0)}catch{return d}}}}p(S,d,n,o,c){if(n&&o){const u=c===void 0?o[n]:o[c+":"+n];if(typeof u=="string")return u;throw new s.$6Q(S,(0,$.localize)(2075,null,d))}return d}}e.$iR=y}),define(Oe[118],Ne([1,0,3,114]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rE=void 0,e.$sE=s,e.$tE=a,e.$uE=S,e.$rE=(0,v.$Di)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function s(d){const n=d;return(0,I.$fG)(n?.editor)&&(0,I.$fG)(n?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Oe[204],Ne([1,0,3,118]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yE=e.$xE=e.$wE=e.$vE=void 0,e.$zE=P,e.$vE=(0,v.$Di)("editorService"),e.$wE=-1,e.$xE=-2,e.$yE=-3;function P(O){const A=O;return typeof O=="number"||(0,I.$tE)(A)}}),define(Oe[205],Ne([1,0,3,106]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=void 0,e.$2M=(0,v.$Ei)(I.$Ki)}),define(Oe[119],Ne([1,0,18,6,19,4,10]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0,P=We(P);class T{constructor(u,i){this.versionId=u,this.removedDueToLooping=i}}e.$sdc=T;class ${static isHostExtension(u,i,r){if(i.getExtensionDescription(u))return!1;const t=r.getExtensionDescription(u);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(u,i){this.j=u,this.c=new I.$ke,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$rn,this.g=[],this.h=new Map;for(const u of this.e){if(this.f.has(u.identifier)){console.error("Extension `"+u.identifier.value+"` is already registered");continue}this.f.set(u.identifier,u),this.g.push(u);const i=this.j.readActivationEvents(u);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(u)}}set(u){return this.e=u,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(u,i){this.e=o(this.e,i),this.e=this.e.concat(u);const r=$.l(this.e);return this.e=o(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(u){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,p){this.addNode(m),this.addNode(p),this.c.has(m)?this.c.get(m).push(p):this.c.set(m,[p])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,p){const h=i.getArcs(m);for(let E=0;E<h.length;E++)if(!p.has(h[E]))return!1;return!0}getNodes(){return this.e}},r=new v.$rn;for(const m of u)if(r.set(m.identifier,m),m.extensionDependencies)for(const p of m.extensionDependencies)i.addArc(v.$pn.toKey(m.identifier),v.$pn.toKey(p));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const g=i.getNodes().filter(m=>!t.has(m));let l;do{l=!1;for(let m=0;m<g.length;m++){const p=g[m];i.hasOnlyGoodArcs(p,t)&&(g.splice(m,1),m--,t.add(p),l=!0)}}while(l);return g.map(m=>r.get(m))}containsActivationEvent(u){return this.h.has(u)}containsExtension(u){return this.f.has(u)}getExtensionDescriptionsForActivationEvent(u){const i=this.h.get(u);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(u){const i=this.f.get(u);return i||void 0}getExtensionDescriptionByUUID(u){for(const i of this.g)if(i.uuid===u)return i}getExtensionDescriptionByIdOrUUID(u,i){return this.getExtensionDescription(u)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$tdc=$;class s{constructor(u,i){this.versionId=u,this.extensions=i}}e.$udc=s;class R{constructor(u){this.d=new S,this.c=new $(u,[])}async acquireLock(u){const i=await this.d.acquire(u);return new y(this,i)}deltaExtensions(u,i,r){if(!u.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(u){return this.c.containsActivationEvent(u)}containsExtension(u){return this.c.containsExtension(u)}getExtensionDescriptionsForActivationEvent(u){return this.c.getExtensionDescriptionsForActivationEvent(u)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(u){return this.c.getExtensionDescription(u)}getExtensionDescriptionByUUID(u){return this.c.getExtensionDescriptionByUUID(u)}getExtensionDescriptionByIdOrUUID(u,i){return this.c.getExtensionDescriptionByIdOrUUID(u,i)}}e.$vdc=R;class y extends O.$Tc{constructor(u,i){super(),this.f=u,this.c=!1,this.B(i)}isAcquiredFor(u){return!this.c&&this.f===u}}e.$wdc=y;class a{constructor(u){this.name=u;const i=(0,A.$wh)();this.promise=i.promise,this.c=i.resolve}resolve(u){this.c(u)}}class S{constructor(){this.c=[],this.d=!1}async acquire(u){const i=new a(u);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const u=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${u.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};u.resolve((0,O.$Rc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function n(c,u){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,r=u.isBuiltin?d.Builtin:u.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=P.$fc.basename(c.extensionLocation.path),g=P.$fc.basename(u.extensionLocation.path);return t<g?-1:t>g?1:0}function o(c,u){const i=new v.$qn(u);return c.filter(r=>!i.has(r.identifier))}}),define(Oe[83],Ne([1,0,22]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$zn=A,e.$An=T;var I;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(I||(e.UIKind=I={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(s){const R=v.$Me.alloc(1);switch(s){case O.Initialized:R.writeUInt8(1,0);break;case O.Ready:R.writeUInt8(2,0);break;case O.Terminate:R.writeUInt8(3,0);break}return R}function T(s,R){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return R===O.Initialized;case 2:return R===O.Ready;case 3:return R===O.Terminate;default:return!1}}var $;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Oe[66],Ne([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=e.$wQ=e.$vQ=void 0,e.$xQ=o;let d=class extends a.$Tc{constructor(u,i){super(),this.s=u,this.t=i,this.a=this.B(new I.$ke),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new I.$ke),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Ap,name:(0,S.localize)(10770,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$ak)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(u,i,r){const t=this.getTelemetryDetails(),g=new n(i,r,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...l,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(u,i,r){this.f=u,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const i=Object.create(null);switch(i["common.extname"]=`${u.publisher}.${u.name}`,i["common.extversion"]=u.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$gn)((0,s.$Gp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const g=r.filter(l=>!l.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,i){const t=this.r.get(u.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(u.value),!1;let g=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),g=!0);return g}};e.$vQ=d,e.$vQ=d=Ge([Ve(0,A.$uQ),Ve(1,O.$_j)],d);class n{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,i,r,t,g,l,m){this.g=r,this.h=t,this.i=g,this.j=l,this.a=new I.$ke,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(u,i){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let i="properties"in u?u.properties??{}:u;return i=(0,s.$Jp)(i,[]),this.c&&(i=(0,R.$fo)(i,this.c)),this.b||(i=(0,R.$fo)(i,this.j)),"properties"in u?u.properties=i:u=i,u}k(u,i){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(u,i),this.h.trace(u,i))}logUsage(u,i){this.d.isUsageEnabled&&this.k(u,i)}logError(u,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,i);else{const r={name:u.name,message:u.message,stack:u.stack,cause:u.cause},t=(0,s.$Jp)(r,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const u=this,i={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$wQ=n;function o(c){const u=Date.now()-new Date(c).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$yQ=(0,v.$Di)("IExtHostTelemetry")}),define(Oe[24],Ne([1,0,6,2,178,111,18,3]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.ActivationKind=e.$gH=e.$fH=e.$cH=e.ExtensionHostStartup=e.$bH=e.$aH=e.$_G=e.$$G=void 0,e.$dH=a,e.$eH=S,e.$hH=c,e.$iH=u,e.$$G=Object.freeze({identifier:new A.$pn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$_G="extensions.webWorker",e.$aH=(0,T.$Di)("extensionService");class ${constructor(t){this.dependency=t}}e.$bH=$;var s;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,l){this.c=t,this.d=g.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$WG.createActivationEventsMap(this.d)}}set(t,g,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],p=[],h=[],E=[],D=y(this.d),b=y(g),k=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=b.get(N.identifier);if(!L){m.push(N.identifier),D.delete(N.identifier);continue}if(!k(N,L)){m.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const L=D.get(N.identifier);if(!L){p.push(N);continue}if(!k(L,N)){m.push(L.identifier),D.delete(L.identifier);continue}}const C=new A.$qn(this.e),f=new A.$qn(l);for(const N of this.e)f.has(N)||h.push(N);for(const N of l)C.has(N)||E.push(N);const w=O.$WG.createActivationEventsMap(p),F={versionId:t,toRemove:m,toAdd:p,addActivationEvents:w,myToRemove:h,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:l,myToRemove:m,myToAdd:p}=t,h=new A.$qn(g),E=new A.$qn(m);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of l)this.d.push(D);for(const D of p)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$pn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const l=O.$WG.readActivationEvents(g);for(const m of l)t.add(m)}return t}}e.$cH=R;function y(r){const t=new A.$rn;for(const g of r)t.set(g.identifier,g);return t}function a(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function S(r,t){if(!a(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,g,l,m){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=l,this.activationReason=m}}e.$fH=d;class n{constructor(t,g){this.description=t,this.value=g}}e.$gH=n;var o;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function c(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,P.$Pp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function u(r,t){const g=(0,P.$Np)(r.manifest.publisher,r.manifest.name);return{id:g,identifier:new A.$pn(g),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$jH=i}),define(Oe[206],Ne([1,0,13,4,119,18,24,11,10]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=e.$Lpc=e.$Kpc=e.$Jpc=e.$Ipc=void 0,v=We(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(u,i,r,t){this.startup=u,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=t}}e.$Ipc=s;class R{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,i){return u===-1||i===-1?-1:i-u}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jpc=R;class y{constructor(u,i,r,t,g,l){this.activationFailed=u,this.activationFailedError=i,this.activationTimes=r,this.module=t,this.exports=g,this.disposable=l}}e.$Kpc=y;class a extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}e.$Lpc=a;class S extends y{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}e.$Mpc=S;class d extends y{constructor(u){super(!0,u,s.NONE,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}let n=class{constructor(u,i,r,t){this.g=t,this.a=u,this.b=i,this.c=r,this.d=new O.$rn,this.f=Object.create(null)}dispose(){for(const[u,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const u=[];for(const[i,r]of this.d)u.push(r.wait());await Promise.all(u)}isActivated(u){const i=this.d.get(u);return!!(i&&i.value)}getActivatedExtension(u){const i=this.d.get(u);if(!i||!i.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return i.value}async activateByEvent(u,i){if(this.f[u])return;const r=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(r.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,i){const r=this.a.getExtensionDescription(u);if(!r)throw new Error(`Extension '${u.value}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(u){const i=u.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const i=this.a.getExtensionDescription(u.id);if(!i){const g=new Error(`Cannot activate unknown extension '${u.id.value}'`),l=this.k(u,null,[],new d(g));return this.c.onExtensionActivationError(u.id,g,new A.$bH(u.id.value)),l}const r=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const l=this.d.get(g);if(l){r.push(l);continue}if(this.l(g)){r.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:u.reason}));continue}const m=this.a.getExtensionDescription(g);if(m){if(!m.main&&!m.browser)continue;r.push(this.j({id:m.identifier,reason:u.reason}));continue}const p=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${g}'`),E=this.k(u,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new A.$bH(g)),E}return this.k(u,i.displayName,r,null)}k(u,i,r,t){const g=new o(u.id,i,u.reason,r,t,this.c,this.g);return this.d.set(u.id,g),g}l(u){return P.$tdc.isHostExtension(u,this.a,this.b)}m(u){const i=this.b.getExtensionDescription(u);return i?!i.main&&!i.browser:!1}};e.$Npc=n,e.$Npc=n=Ge([Ve(3,T.$$j)],n);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,i,r,t,g,l,m){this.c=u,this.d=i,this.f=r,this.g=t,this.h=g,this.j=l,this.k=m,this.a=new $.$Ch,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const i=this.g[u];if(i.value&&!i.value.activationFailed){this.g.splice(u,1),u--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new d(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const i=new Error;if(u&&u.name&&(i.name=u.name),u&&u.message?i.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(i.stack=u.stack),this.h=new d(i),this.b&&v.$3(u))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};o=Ge([Ve(6,T.$$j)],o)});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[120],Ne([1,0,9,13,35,110,77,30,18,108,111,104]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=void 0,v=We(v),P=ri(P);const a=T.$po.as(A.$qo.JSONContribution);class S{constructor(t,g,l){this.a=t,this.b=g,this.c=l}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$5G=S;class d{static a(t){const g=new $.$qn;for(let l=0,m=t.length;l<m;l++)g.add(t[l].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const l=this.a(t),m=this.a(g),p=g.filter(E=>!l.has(E.description.identifier)),h=t.filter(E=>!m.has(E.description.identifier));return new d(p,h)}constructor(t,g){this.added=t,this.removed=g}}e.$6G=d;class n{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,I.$Y)(t)}}}e.$7G=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1826,null),v.localize(1827,null)]},c="vscode://schemas/vscode-extensions";e.$8G={properties:{engines:{type:"object",description:v.localize(1828,null),properties:{vscode:{type:"string",description:v.localize(1829,null),default:"^1.22.0"}}},publisher:{description:v.localize(1830,null),type:"string"},displayName:{description:v.localize(1831,null),type:"string"},categories:{description:v.localize(1832,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$on},{type:"string",const:"Languages",deprecationMessage:v.localize(1833,null)}]}},galleryBanner:{type:"object",description:v.localize(1834,null),properties:{color:{description:v.localize(1835,null),type:"string"},theme:{description:v.localize(1836,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1837,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1838,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1839,null)},enabledApiProposals:{markdownDescription:v.localize(1840,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(1841,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1842,null)]},activationEvents:{description:v.localize(1843,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1844,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1845,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1846,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1847,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1848,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1849,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1850,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1851,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1852,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1853,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1854,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1855,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1856,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1857,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1858,null)},{label:"onUri",body:"onUri",description:v.localize(1859,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1860,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1861,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1862,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1863,null)},{label:"onRenderer",description:v.localize(1864,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1865,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1866,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1867,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1868,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1869,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1870,null)},{label:"*",description:v.localize(1871,null),body:"*"}]}},badges:{type:"array",description:v.localize(1872,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1873,null)},href:{type:"string",description:v.localize(1874,null)},description:{type:"string",description:v.localize(1875,null)}}}},markdown:{type:"string",description:v.localize(1876,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1877,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1878,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$9o}},extensionPack:{description:v.localize(1879,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$9o}},extensionKind:{description:v.localize(1880,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1881,null)},{body:["workspace"],description:v.localize(1882,null)},{body:["ui","workspace"],description:v.localize(1883,null)},{body:["workspace","ui"],description:v.localize(1884,null)},{body:[],description:v.localize(1885,null)}]},capabilities:{description:v.localize(1886,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1887,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1888,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1889,null),v.localize(1890,null),v.localize(1891,null)]},description:{type:"string",markdownDescription:v.localize(1892,null)}}},untrustedWorkspaces:{description:v.localize(1893,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1894,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1895,null),v.localize(1896,null),v.localize(1897,null)]},restrictedConfigurations:{description:v.localize(1898,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1899,null)}}}}},sponsor:{description:v.localize(1900,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1901,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1902,null),type:"string"},"vscode:uninstall":{description:v.localize(1903,null),type:"string"}}},icon:{type:"string",description:v.localize(1904,null)},l10n:{type:"string",description:v.localize(1905,null)},pricing:{type:"string",markdownDescription:v.localize(1906,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&R.$WG.register(t.extensionPoint,t.activationEventsGenerator),e.$8G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$8G),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$9G=u;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$po.add(i.ExtensionsRegistry,new u),e.$0G=T.$po.as(i.ExtensionsRegistry),a.registerSchema(c,e.$8G),a.registerSchema(s.$sk,{properties:{extensionEnabledApiProposals:{description:v.localize(1907,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Oe[207],Ne([1,0,6,39,4,12,9,18,3,11,24,120]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.ChatMessageRole=void 0;var a;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$kH=(0,$.$Di)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8371,null)}}};e.$lH=y.$0G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8372,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(n,o)=>{for(const c of n)o.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(o,c){this.e=o,this.f=c,this.a=new P.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$ke),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$lH.setHandler(u=>{this.c.clear();for(const r of u){if(!(0,R.$dH)(r.description,"chatProvider")){r.collector.error((0,A.localize)(8373,null));continue}for(const t of I.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(8374,null,t.vendor));continue}if((0,O.$bf)(t.vendor)){r.collector.error((0,A.localize)(8375,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(8376,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const u=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(u)}const c=[];for(const[u,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$pn.equals(r,o.extension)))&&c.push(u);return this.f.trace("[LM] selected language models",o,c),c}registerLanguageModelChat(o,c){if(this.f.trace("[LM] registering language model chat",o,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,c),this.d.fire({added:[{identifier:o,metadata:c.metadata}]}),(0,P.$Rc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,c.metadata))})}async sendChatRequest(o,c,u,i,r){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(u,c,i,r)}computeTokenLength(o,c,u){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(c,u)}};e.$mH=d,e.$mH=d=Ge([Ve(0,R.$aH),Ve(1,s.$$j)],d)}),define(Oe[208],Ne([1,0,9,14,25,120,31,6]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=void 0,v=We(v),I=We(I),P=We(P);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3895,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3896,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3897,null),default:""}}};var s;(function(a){function S(d,n,o){if(!d)return;const c=I.$dg(d.type)?d.type:void 0;if(!c||c.length===0){o.error(v.localize(3898,null));return}const u=[];if(Array.isArray(d.required))for(const i of d.required)I.$dg(i)&&u.push(i);return{extensionId:n.value,taskType:c,required:u,properties:d.properties?P.$co(d.properties):{},when:d.when?A.$Bj.deserialize(d.when):void 0}}a.from=S})(s||(s={}));const R=O.$0G.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:v.localize(3899,null),type:"array",items:$}});class y{constructor(){this.d=new T.$ke,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{R.setHandler((n,o)=>{this.c=void 0;try{for(const c of o.removed){const u=c.value;for(const i of u)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of o.added){const u=c.value;for(const i of u){const r=s.from(i,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=P.$co(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},S.push(n)}this.c={oneOf:S}}return this.c}}e.$RI=new y}),define(Oe[209],Ne([1,0,9,14,23,25,31,208,43]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2I=e.JsonSchemaVersion=e.ExecutionEngine=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VI=e.ShellQuoting=e.$UI=e.$TI=e.$SI=void 0,v=We(v),I=We(I),P=We(P),O=We(O),e.$SI="settings",e.$TI=new A.$Uj("taskRunning",!1,v.localize(3883,null)),e.$UI=v.localize2(3885,"Tasks");var s;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$VI="$customized",function(M){function K(Z){if(!Z)return M.Strong;switch(Z.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=K}(s||(e.ShellQuoting=s={}));var R;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(y||(e.RevealKind=y={})),function(M){function K(Z){switch(Z.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=K}(y||(e.RevealKind=y={}));var a;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(M){function K(Z){switch(Z.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=K}(a||(e.RevealProblemKind=a={}));var S;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(S||(e.PanelKind=S={})),function(M){function K(Z){switch(Z.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=K}(S||(e.PanelKind=S={}));var d;(function(M){M.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(M){function K(ue){switch(ue.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=K;function Z(ue){switch(ue){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=Z}(n||(e.RuntimeType=n={}));var o;(function(M){function K(Z){return I.$dg(Z)?Z:Z.value}M.value=K})(o||(e.CommandString=o={}));var c;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function K(ue){return ue===M.Clean._id||ue===M.Build._id||ue===M.Rebuild._id||ue===M.Test._id}M.is=K;function Z(ue){if(ue!==void 0)return I.$dg(ue)?K(ue)?{_id:ue,isDefault:!1}:void 0:ue}M.from=Z})(c||(e.TaskGroup=c={}));var u;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function K(Z){switch(Z){case M.User:return $.ConfigurationTarget.USER;case M.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=K})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class l{constructor(K,Z,ue,_,ge,se){this._label="",this._id=K,Z&&(this._label=Z),ue&&(this.type=ue),this.runOptions=_,this.configurationProperties=ge,this._source=se}getDefinition(K){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const K={folder:this.d(),id:this._id};return JSON.stringify(K)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,Z=!1){if(K===void 0)return!1;if(I.$dg(K))return K===this._label||K===this.configurationProperties.identifier||Z&&K===this._id;const ue=this.getDefinition(!0);return ue!==void 0&&ue._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this.c===void 0&&(this.c=[]),K&&(this.c=this.c.concat(K))}get taskLoadMessages(){return this.c}}e.$WI=l;class m extends l{constructor(K,Z,ue,_,ge,se,ae,$e){super(K,ue,void 0,ae,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=se,ge&&(this.command=ge)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case n.Shell:Z="shell";break;case n.Process:Z="process";break;case n.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(K){return K instanceof m}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$SI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const K=this.d();if(!K)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ue={type:e.$VI,folder:K,id:Z};return JSON.stringify(ue)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$bh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(K){return new m(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$XI=m;class p extends l{constructor(K,Z,ue,_,ge,se,ae){super(K,ue,_,se,ae,Z),this._source=Z,this.configures=ge}static is(K){return K instanceof p}f(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$bh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$SI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const K=this.d();if(!K)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const ue={type:e.$VI,folder:K,id:Z};return JSON.stringify(ue)}}e.$YI=p;class h extends l{constructor(K,Z,ue,_,ge,se,ae,$e,oe){super(K,ue,_,$e,oe,Z),this.defines=ge,this.hasDefinedMatchers=ae,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof h}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===u.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.d(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(K){return new h(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$ZI=h;class E extends l{constructor(K,Z,ue,_,ge,se){super(K,ue,_,ge,se,Z),this._source=Z}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(K){return new E(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.$1I=E;var D;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(M){M._default=M.Terminal}(D||(e.ExecutionEngine=D={}));var b;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class k{constructor(K){this.c=new Map;for(let Z=0;Z<K.length;Z++)this.c.set(K[Z].uri.toString(),Z)}compare(K,Z){const ue=K.getWorkspaceFolder(),_=Z.getWorkspaceFolder();if(ue&&_){let ge=this.c.get(ue.uri.toString());ge=ge===void 0?0:ge+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,ge===se?K._label.localeCompare(Z._label):ge-se}else return!ue&&_?-1:ue&&!_?1:0}}e.$2I=k;var C;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(C||(e.TaskEventKind=C={}));var f;(function(M){M.SingleRun="singleRun",M.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var F;(function(M){function K($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?f.Background:f.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Z($e,oe,ke){return{...K($e),kind:C.Start,terminalId:oe,resolvedVariables:ke}}M.start=Z;function ue($e,oe,ke){return{...K($e),kind:C.ProcessStarted,terminalId:oe,processId:ke}}M.processStarted=ue;function _($e,oe,ke){return{...K($e),kind:C.ProcessEnded,terminalId:oe,exitCode:ke}}M.processEnded=_;function ge($e,oe,ke){return{...K($e),kind:C.Terminated,exitReason:ke,terminalId:oe}}M.terminated=ge;function se($e,oe,ke){return{...K(oe),kind:$e,terminalId:ke}}M.general=se;function ae(){return{kind:C.Changed}}M.changed=ae})(F||(e.TaskEvent=F={}));var N;(function(M){function K(ue){const _=Object.keys(ue).sort();let ge="";for(const se of _){let ae=ue[se];ae instanceof Object?ae=K(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ge+=se+","+ae+","}return ge}function Z(ue){const ge={_key:K(ue),type:ue.taskType};return Object.assign(ge,ue),ge}M.create=Z})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var W;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var J;(function(M){function K(Z,ue){const _=T.$RI.get(Z.type);if(_===void 0){const $e=O.$co(Z);return delete $e._key,N.create($e)}const ge=Object.create(null);ge.type=_.taskType;const se=new Set;_.required.forEach($e=>se.add($e));const ae=_.properties;for(const $e of Object.keys(ae)){const oe=Z[$e];if(oe!=null)ge[$e]=oe;else if(se.has($e)){const ke=ae[$e];if(ke.default!==void 0)ge[$e]=O.$co(ke.default);else switch(ke.type){case"boolean":ge[$e]=!1;break;case"number":case"integer":ge[$e]=0;break;case"string":ge[$e]="";break;default:ue.error(v.localize(3884,null,JSON.stringify(Z,void 0,0),$e));return}}}return N.create(ge)}M.createTaskIdentifier=K})(J||(e.TaskDefinition=J={}))}),define(Oe[210],Ne([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0;class I{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$xdc=I;class P extends I{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$ydc=P}),define(Oe[38],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Sw=void 0,e.$Tw=P,e.$Uw=O;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Sw=v;const I=[];function P(T){const $=new v(T);return I[$.nid]=$,$}function O(T){return I[T].sid}class A{constructor($){this.value=$}}e.$Vw=A}),define(Oe[5],Ne([1,0,38]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$DN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(I||(e.TextEditorRevealType=I={}));var P;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var s;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$DN=y;var a;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$EN={MainThreadAuthentication:(0,v.$Tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Tw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Tw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Tw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Tw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Tw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Tw)("MainThreadCommands"),MainThreadComments:(0,v.$Tw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Tw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Tw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Tw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Tw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Tw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Tw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Tw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Tw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Tw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Tw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Tw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Tw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Tw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Tw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Tw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Tw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Tw)("MainThreadSCM"),MainThreadSearch:(0,v.$Tw)("MainThreadSearch"),MainThreadShare:(0,v.$Tw)("MainThreadShare"),MainThreadTask:(0,v.$Tw)("MainThreadTask"),MainThreadWindow:(0,v.$Tw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Tw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Tw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Tw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Tw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Tw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Tw)("MainThreadAiEmbeddingVector")},e.$FN={ExtHostCommands:(0,v.$Tw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Tw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Tw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Tw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Tw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Tw)("ExtHostSCM"),ExtHostSearch:(0,v.$Tw)("ExtHostSearch"),ExtHostTask:(0,v.$Tw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Tw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Tw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Tw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Tw)("ExtHostProgress"),ExtHostComments:(0,v.$Tw)("ExtHostComments"),ExtHostSecretState:(0,v.$Tw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Tw)("ExtHostStorage"),ExtHostUrls:(0,v.$Tw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Tw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Tw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Tw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Tw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Tw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Tw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Tw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Tw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Tw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Tw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Tw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Tw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Tw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Tw)("ExtHostLocalization")}}),define(Oe[84],Ne([1,0,3,11,5,16]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=e.$8oc=void 0,P=We(P),e.$8oc=(0,v.$Di)("IExtHostApiDeprecationService");let A=class{constructor($,s){this.c=s,this.a=new Set,this.b=$.getProxy(P.$EN.MainThreadTelemetry)}report($,s,R){const y=this.d($,s);this.a.has(y)||(this.a.add(y),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:$}))}d($,s){return`${$}-${s.identifier.value}`}};e.$9oc=A,e.$9oc=A=Ge([Ve(0,O.$eQ),Ve(1,I.$$j)],A),e.$0oc=Object.freeze(new class{report(T,$,s){}})}),define(Oe[211],Ne([1,0,5]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0;class I{constructor(O){const A=O.getProxy(v.$EN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$kpc=I}),define(Oe[212],Ne([1,0,25,5,26,16]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(I.$EN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const a=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){a.e(R,y,S,arguments)}})}e(R,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(S,this.b)}),this.c&&this.f(R,a,S)}};e.$grc=A,e.$grc=A=Ge([Ve(0,O.$eQ),Ve(1,P.$uQ)],A);const T=1e5;function $(s,R){const y=[];if(s.length)for(let a=0;a<s.length;a++){let S=s[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(R){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$ho)(y);return a.length>T?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Oe[213],Ne([1,0,2,5,24]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0;class O{constructor(T){this.a=T.getProxy(I.$EN.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,P.$eH)(T,"showLocal"),this.a.$showOpenDialog($).then(s=>s?s.map(R=>v.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?v.URI.revive($):void 0)}}e.$mqc=O}),define(Oe[214],Ne([1,0,21,6,4,5]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=void 0;class A{constructor($){this.b=new Map,this.c=new I.$ke,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$EN.MainThreadEmbeddings)}registerEmbeddingsProvider($,s,R){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,s),this.b.set(y,{id:s,provider:R}),(0,P.$Rc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,s,R){R??=v.CancellationToken.None;let y=!1;typeof s=="string"&&(s=[s],y=!0);const a=await this.a.$computeEmbeddings($,s,R);if(a.length!==s.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings($,s,R){const y=this.b.get($);if(!y)return[];const a=await y.provider.provideEmbeddings(s,R);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$pqc=A}),define(Oe[215],Ne([1,0,4,5]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(I.$EN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Gqc=P}),define(Oe[85],Ne([1,0,20,12,2,3,11,5,26,16]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=e.$2pc=void 0;let R=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(T.$EN.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:n,comment:o}=S;if(this.c)return(0,I.$df)(d,n??{});let c=d;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join(""):o}`);const u=this.d.get(a)?.contents[c];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,I.$df)(u??d,n??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),o=JSON.parse(n);S=a.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${n.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(S)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2pc=R,e.$2pc=R=Ge([Ve(0,$.$uQ),Ve(1,s.$eQ),Ve(2,A.$$j)],R),e.$3pc=(0,O.$Di)("IExtHostLocalizationService")}),define(Oe[216],Ne([1,0,11,5,26,16,2,40]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0;let $=class extends v.$jk{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,T.$ai)(S))),this.r=y.getProxy(I.$EN.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(A.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new s(this.r,y,a,S)}};e.$frc=$,e.$frc=$=Ge([Ve(0,O.$eQ),Ve(1,P.$uQ)],$);class s extends v.$ek{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Oe[86],Ne([1,0,5,3,4,16,22]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0,e.$4pc=(0,I.$Di)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$EN.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new P.$Sc;return this.d.set(a,new s(a,S,d)),d.add((0,P.$Rc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(n=>{this.a.$onDidManagedSocketClose(a,n?.stack??n?.message),d.dispose()})),d.add(S.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(a,A.$Me.wrap(n)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$5pc=T,e.$5pc=T=Ge([Ve(0,O.$eQ)],T);class ${constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class s extends P.$Tc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Oe[217],Ne([1,0,5,11,24]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;function O(T){return T&&T.title}let A=class{constructor($,s){this.b=s,this.a=$.getProxy(v.$EN.MainThreadMessageService)}showMessage($,s,R,y,a){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof y=="string"||O(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,P.$eH)($,"resolvers");const n=[];let o=!1;for(let c=0;c<d.length;c++){const u=d[c];if(typeof u=="string")n.push({title:u,handle:c,isCloseAffordance:!1});else if(typeof u=="object"){const{title:i,isCloseAffordance:r}=u;n.push({title:i,isCloseAffordance:!!r,handle:c}),r&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,u):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,u)}return this.a.$showMessage(s,R,S,n).then(c=>{if(typeof c=="number")return d[c]})}};e.$Jqc=A,e.$Jqc=A=Ge([Ve(1,I.$$j)],A)}),define(Oe[218],Ne([1,0,4,14,2,24,5]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=void 0;class T{constructor(s){this.b=new Map,this.a=s.getProxy(A.$EN.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,R,y){if((0,O.$eH)(s,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,s.identifier.value),(0,v.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(s,R,y,a){const S=this.b.get(s);if(!S)throw new Error(`Unknown handler with id: ${s}`);return S.saveProfile(R,y,a)}async $readProfile(s,R,y){const a=this.b.get(s);if(!a)throw new Error(`Unknown handler with id: ${s}`);return a.readProfile((0,I.$dg)(R)?R:P.URI.revive(R),y)}}e.$Sqc=T}),define(Oe[87],Ne([1,0,5,6,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=e.$Ypc=void 0;class O{constructor(T){this.b=new I.$ke,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$EN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,s){return this.a.$setPassword(T,$,s)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$Ypc=O,e.$Zpc=(0,P.$Di)("IExtHostSecretState")}),define(Oe[219],Ne([1,0,21,4,5]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$EN.MainThreadSpeech)}async $createSpeechToTextSession(T,$,s){const R=this.c.get(T);if(!R)return;const y=new I.$Sc,a=new v.$ve;this.d.set($,a);const S=await R.provideSpeechToTextSession(a.token,s?{language:s}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,s){const R=this.c.get(T);if(!R)return;const y=new I.$Sc,a=new v.$ve;this.d.set($,a);const S=await R.provideTextToSpeechSession(a.token,s?{language:s}:void 0);S&&(this.f.set($,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const s=this.c.get(T);if(!s)return;const R=new I.$Sc,y=new v.$ve;this.d.set($,y);const a=await s.provideKeywordRecognitionSession(y.token);a&&(R.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,s){const R=O.a++;return this.c.set(R,s),this.b.$registerProvider(R,$,{extension:T,displayName:T.value}),(0,I.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Zqc=O}),define(Oe[88],Ne([1,0,5,6,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0;class O{constructor(T,$){this.c=$,this.b=new I.$ke,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$EN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,s){const R=await this.a.$initializeExtensionStorage(T,$);let y;return R&&(y=this.d(T,$,R)),y||s}setValue(T,$,s){return this.a.$setValue(T,$,s)}$acceptValue(T,$,s){const R=this.d(T,$,s);R&&this.b.fire({shared:T,key:$,value:R})}d(T,$,s){try{return JSON.parse(s)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${R}`)}}}e.$Opc=O,e.$Ppc=(0,P.$Di)("IExtHostStorage")}),define(Oe[220],Ne([1,0,4,15,2,5]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0;class A{static{this.a=new Set([I.Schemas.http,I.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$EN.MainThreadUriOpeners)}registerExternalUriOpener($,s,R,y){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const a=y.schemes.find(S=>!A.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(s,R),this.b.$registerUriOpener(s,y.schemes,$,y.label),(0,v.$Rc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri($,s,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const a=P.URI.revive(s);return y.canOpenExternalUri(a,R)}async $openUri($,s,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},R)}}e.$_qc=A}),define(Oe[221],Ne([1,0,5,2,4,13,18]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class T{static{this.a=0}constructor(s){this.c=new A.$qn,this.d=new Map,this.b=s.getProxy(v.$EN.MainThreadUrls)}registerUriHandler(s,R){const y=s.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=T.a++;return this.c.add(y),this.d.set(a,R),this.b.$registerUriHandler(a,y,s.displayName||s.name),(0,P.$Rc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(s,R){const y=this.d.get(s);if(!y)return Promise.resolve(void 0);try{y.handleUri(I.URI.revive(R))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(s){return I.URI.revive(await this.b.$createAppUri(s))}}e.$arc=T}),define(Oe[222],Ne([1,0,22,5]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mtb=O,e.$Ntb=T,I=We(I);class P{constructor(){this.buffers=[]}add(s){let R=this.buffers.indexOf(s);return R<0&&(R=this.buffers.length,this.buffers.push(s)),R}}function O($,s){if(s.serializeBuffersForPostMessage){const R=new P,a=JSON.stringify($,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const o=A(n);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:o,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),S=R.buffers.map(d=>{const n=new Uint8Array(d);return v.$Me.wrap(n)});return{message:a,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return I.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return I.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return I.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return I.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return I.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return I.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return I.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return I.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return I.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return I.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return I.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,s){const R=s.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=s.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:o}=n,c=R[o];if(n.view)switch(n.view.type){case I.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse($,y),arrayBuffers:R}}}),define(Oe[67],Ne([1,0,6,4,15,25,2,175,222,82,5]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$zpc=void 0,e.$Apc=a,e.$Cpc=n,e.$Dpc=o,O=We(O),R=We(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,t,g,l,m,p,h){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new v.$ke,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$ke,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=g,this.#n=l,this.#s=m,this.#r=p,this.#l=a(p),this.#d=S(p),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,s.$yDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===P.Schemas.https||r.scheme===P.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$xDb}return s.$xDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$go(this.#o,r)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,$.$Mtb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,p,h,E,D)=>{const b=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,s.$yDb)(b,{isRemote:t,authority:g}).toString();return`${m}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,m,p,h,E,D)=>{const b=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,s.$yDb)(b,{isRemote:t,authority:g}).toString();return`${m}${k}${D}`})}}e.$zpc=y;function a(i){try{const r=(0,T.$Zp)((0,T.$Yp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function S(i){try{const r=(0,T.$Zp)((0,T.$Yp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d extends I.$Tc{constructor(r,t,g,l,m){super(),this.c=t,this.f=g,this.g=l,this.h=m,this.b=new Map,this.a=r.getProxy(R.$EN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,g){const l=this.j(r);if(l){const{message:m}=(0,$.$Ntb)(t,g.value);l._onMessageEmitter.fire(m)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,g){const l=new y(r,this.a,c(t),this.c,this.f,g,this.h);this.b.set(r,l);const m=l._onDidDispose(()=>{m.dispose(),this.deleteWebview(r)});return l}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Bpc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||u(i,r)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function u(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Oe[121],Ne([1,0,6,15,12,2,3,16,5]),function(be,e,v,I,P,O,A,T,$){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=e.$crc=void 0;let R=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$ke,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=a.getProxy($.$EN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.$bf)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,P.$bf)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return O.URI.from(d)}};e.$crc=R,e.$crc=R=s=Ge([Ve(0,T.$eQ)],R),e.$drc=(0,A.$Di)("IExtHostWindow")}),define(Oe[223],Ne([1,0,212,26,16]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtc=void 0;let O=class extends v.$grc{constructor(T,$){super(T,$)}f(T,$,s){$.apply(console,s)}};e.$qtc=O,e.$qtc=O=Ge([Ve(0,P.$eQ),Ve(1,I.$uQ)],O)}),define(Oe[224],Ne([1,0,10,22,21,27,13,6,4,36,150,210,38]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$zdc=u,e.$Adc=i,A=We(A);function d(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const n="$$ref$$",o={[n]:-1};class c{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function u(F,N=null,L=!1){const W=[];return{jsonString:(L?d:JSON.stringify)(F,(M,K)=>{if(typeof K>"u")return o;if(typeof K=="object"){if(K instanceof I.$Me){const Z=W.push(K)-1;return{[n]:Z}}if(N)return N(M,K)}return K}),referencedBuffers:W}}function i(F,N,L){return JSON.parse(F,(W,J)=>{if(J){const M=J[n];if(typeof M=="number")return N[M];if(L&&J.$mid===s.MarshalledId.Uri)return L.transformIncoming(J)}return J})}function r(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,L)=>L&&L.$mid===s.MarshalledId.Uri?F.transformOutgoing(L):L:null}var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var l;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const m=()=>{},p=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends $.$Tc{static{S=p}static{this.a=3*1e3}constructor(N,L=null,W=null){super(),this[S]=!0,this.b=this.B(new T.$ke),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let J=0,M=a.$Sw.count;J<M;J++)this.m[J]=null,this.s[J]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Ph(()=>this.H(),1e3)),this.B(this.c.onMessage(J=>this.L(J)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(A.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,R.$Nn)(N,this.g):N}getProxy(N){const{nid:L,sid:W}=N;return this.s[L]||(this.s[L]=this.J(L,W)),this.s[L]}J(N,L){const W={get:(J,M)=>(typeof M=="string"&&!J[M]&&M.charCodeAt(0)===O.CharCode.DollarSign&&(J[M]=(...K)=>this.U(N,M,K)),M===h?L:J[M])};return new Proxy(Object.create(null),W)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,W=N.length;L<W;L++){const J=N[L];if(!this.m[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,W=b.read(N,0),J=W.readUInt8(),M=W.readUInt32();switch(J){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:K,method:Z,args:ue}=C.deserializeRequestJSONArgs(W);this.g&&(ue=(0,R.$Nn)(ue,this.g)),this.M(L,M,K,Z,ue,J===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:K,method:Z,args:ue}=C.deserializeRequestMixedArgs(W);this.g&&(ue=(0,R.$Nn)(ue,this.g)),this.M(L,M,K,Z,ue,J===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,M,g.LocalSide,"ack"),this.G(M);break}case f.Cancel:{this.N(L,M);break}case f.ReplyOKEmpty:{this.O(L,M,void 0);break}case f.ReplyOKJSON:{let K=C.deserializeReplyOKJSON(W);this.g&&(K=(0,R.$Nn)(K,this.g)),this.O(L,M,K);break}case f.ReplyOKJSONWithBuffers:{const K=C.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(L,M,K);break}case f.ReplyOKVSBuffer:{const K=C.deserializeReplyOKVSBuffer(W);this.O(L,M,K);break}case f.ReplyErrError:{let K=C.deserializeReplyErrError(W);this.g&&(K=(0,R.$Nn)(K,this.g)),this.P(L,M,K);break}case f.ReplyErrEmpty:{this.P(L,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,W,J,M,K){this.f?.logIncoming(N,L,g.OtherSide,`receiveRequest ${(0,a.$Uw)(W)}.${J}(`,M);const Z=String(L);let ue,_;if(K){const se=new P.$ve;M.push(se.token),ue=this.Q(W,J,M),_=()=>se.cancel()}else ue=this.Q(W,J,M),_=m;this.u[Z]=_;const ge=C.serializeAcknowledged(L);this.f?.logOutgoing(ge.byteLength,L,g.OtherSide,"ack"),this.c.send(ge),ue.then(se=>{delete this.u[Z];const ae=C.serializeReplyOK(L,se,this.h);this.f?.logOutgoing(ae.byteLength,L,g.OtherSide,"reply:",se),this.c.send(ae)},se=>{delete this.u[Z];const ae=C.serializeReplyErr(L,se);this.f?.logOutgoing(ae.byteLength,L,g.OtherSide,"replyErr:",se),this.c.send(ae)})}N(N,L){this.f?.logIncoming(N,L,g.OtherSide,"receiveCancel");const W=String(L);this.u[W]?.()}O(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReply:",W);const J=String(L);if(!this.w.hasOwnProperty(J))return;const M=this.w[J];delete this.w[J],M.resolveOk(W)}P(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReplyErr:",W);const J=String(L);if(!this.w.hasOwnProperty(J))return;const M=this.w[J];delete this.w[J];let K;W&&(W.$isError?(K=new Error,K.name=W.name,K.message=W.message,K.stack=W.stack):K=W),M.resolveErr(K)}Q(N,L,W){try{return Promise.resolve(this.S(N,L,W))}catch(J){return Promise.reject(J)}}S(N,L,W){const J=this.m[N];if(!J)throw new Error("Unknown actor "+(0,a.$Uw)(N));const M=J[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,a.$Uw)(N));return M.apply(J,W)}U(N,L,W){if(this.j)return new y.$ydc;let J=null;if(W.length>0&&P.CancellationToken.isCancellationToken(W[W.length-1])&&(J=W.pop()),J&&J.isCancellationRequested)return Promise.reject(A.$5());const M=C.serializeRequestArguments(W,this.h),K=++this.t,Z=String(K),ue=new y.$xdc,_=new $.$Sc;J&&_.add(J.onCancellationRequested(()=>{const se=C.serializeCancel(K);this.f?.logOutgoing(se.byteLength,K,g.LocalSide,"cancel"),this.c.send(C.serializeCancel(K))})),this.w[Z]=new D(ue,_),this.F(K);const ge=C.serializeRequest(K,N,L,M,!!J);return this.f?.logOutgoing(ge.byteLength,K,g.LocalSide,`request: ${(0,a.$Uw)(N)}.${L}(`,W),this.c.send(ge),ue}}e.$Bdc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class b{static alloc(N,L,W){const J=new b(I.$Me.alloc(W+1+4),0);return J.writeUInt8(N),J.writeUInt32(L),J}static read(N,L){return new b(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let W=0,J=N.length;W<J;W++){const M=N[W];switch(L+=1,M.type){case w.String:L+=this.sizeLongString(M.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(M.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let K=0;K<M.buffers.length;++K)L+=this.sizeVSBuffer(M.buffers[K]);break;case w.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,W=N.length;L<W;L++){const J=N[L];switch(J.type){case w.String:this.writeUInt8(w.String),this.writeLongString(J.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(J.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let M=0;M<J.buffers.length;++M)this.writeBuffer(J.buffers[M]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case w.String:L[W]=this.readLongString();break;case w.VSBuffer:L[W]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const M=this.readUInt32(),K=this.readLongString(),Z=[];for(let ue=0;ue<M;++ue)Z.push(this.readVSBuffer());L[W]=new a.$Vw(i(K,Z,null));break}case w.Undefined:L[W]=void 0;break}return L}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class C{static a(N){for(let L=0,W=N.length;L<W;L++)if(N[L]instanceof I.$Me||N[L]instanceof a.$Vw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const W=[];for(let J=0,M=N.length;J<M;J++){const K=N[J];if(K instanceof I.$Me)W[J]={type:w.VSBuffer,value:K};else if(typeof K>"u")W[J]={type:w.Undefined};else if(K instanceof a.$Vw){const{jsonString:Z,referencedBuffers:ue}=u(K.value,L);W[J]={type:w.SerializedObjectWithBuffers,value:I.$Me.fromString(Z),buffers:ue}}else W[J]={type:w.String,value:I.$Me.fromString(r(K,L))}}return{type:k.Mixed,args:W}}return{type:k.Simple,args:r(N,L)}}static serializeRequest(N,L,W,J,M){switch(J.type){case k.Simple:return this.b(N,L,W,J.args,M);case k.Mixed:return this.c(N,L,W,J.args,M)}}static b(N,L,W,J,M){const K=I.$Me.fromString(W),Z=I.$Me.fromString(J);let ue=0;ue+=b.sizeUInt8(),ue+=b.sizeShortString(K),ue+=b.sizeLongString(Z);const _=b.alloc(M?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,ue);return _.writeUInt8(L),_.writeShortString(K),_.writeLongString(Z),_.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),W=N.readShortString(),J=N.readLongString();return{rpcId:L,method:W,args:JSON.parse(J)}}static c(N,L,W,J,M){const K=I.$Me.fromString(W);let Z=0;Z+=b.sizeUInt8(),Z+=b.sizeShortString(K),Z+=b.sizeMixedArray(J);const ue=b.alloc(M?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,Z);return ue.writeUInt8(L),ue.writeShortString(K),ue.writeMixedArray(J),ue.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),W=N.readShortString(),J=N.readMixedArray(),M=new Array(J.length);for(let K=0,Z=J.length;K<Z;K++){const ue=J[K];typeof ue=="string"?M[K]=JSON.parse(ue):M[K]=ue}return{rpcId:L,method:W,args:M}}static serializeAcknowledged(N){return b.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return b.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,L,W){if(typeof L>"u")return this.d(N);if(L instanceof I.$Me)return this.e(N,L);if(L instanceof a.$Vw){const{jsonString:J,referencedBuffers:M}=u(L.value,W,!0);return this.g(N,J,M)}else return this.f(N,d(L,W))}static d(N){return b.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,L){let W=0;W+=b.sizeVSBuffer(L);const J=b.alloc(f.ReplyOKVSBuffer,N,W);return J.writeVSBuffer(L),J.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const W=I.$Me.fromString(L);let J=0;J+=b.sizeLongString(W);const M=b.alloc(f.ReplyOKJSON,N,J);return M.writeLongString(W),M.buffer}static g(N,L,W){const J=I.$Me.fromString(L);let M=0;M+=b.sizeUInt32,M+=b.sizeLongString(J);for(const Z of W)M+=b.sizeVSBuffer(Z);const K=b.alloc(f.ReplyOKJSONWithBuffers,N,M);K.writeUInt32(W.length),K.writeLongString(J);for(const Z of W)K.writeBuffer(Z);return K.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const W=N.readUInt32(),J=N.readLongString(),M=[];for(let K=0;K<W;++K)M.push(N.readVSBuffer());return new a.$Vw(i(J,M,L))}static serializeReplyErr(N,L){const W=L?d(A.$1(L),null):void 0;if(typeof W!="string")return this.h(N);const J=I.$Me.fromString(W);let M=0;M+=b.sizeLongString(J);const K=b.alloc(f.ReplyErrError,N,M);return K.writeLongString(J),K.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return b.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(w||(w={}))}),define(Oe[225],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$stc=void 0;const v=function(O){const A=T=>{globalThis.removeEventListener("message",A);const $=T.data;Object.defineProperties(globalThis,{postMessage:{value(s,R){$.postMessage(s,R)}},onmessage:{get(){return $.onmessage},set(s){$.onmessage=s}}}),$.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class I extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${A}'))`,s=new Blob([$],{type:"application/javascript"}),R=URL.createObjectURL(s),y=new MessageChannel,a=R,S={type:"_newWorker",id:a,port:y.port2,url:R,options:T};O(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),y.port1.start()}}e.$stc=I}),define(Oe[226],Ne([1,0,22,28,15,60,3]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=e.$oL=void 0,e.$pL=R,e.$qL=y,e.$oL=(0,A.$Di)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),s=7;function R(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const n=parseInt(S.fragment.substring(0,d).replace($,""),s),o=(0,v.$6e)(S.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:S.with({scheme:o,fragment:null})}}function y(S,d){const n=d.toString(s),c=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$7e)(v.$Me.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new I.$zc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const n=R(d);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$rL=a,(0,O.$Ps)(e.$oL,a,O.InstantiationType.Delayed)}),define(Oe[89],Ne([1,0,22,41,39,72,15,19,20,31,226]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$IL=e.CellStatusbarAlignment=e.$HL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$EL=e.$DL=e.$BL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AL=e.$zL=e.$yL=e.$xL=e.CellKind=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=void 0,e.$CL=l,e.$FL=h,e.$GL=E,e.$JL=k,e.$KL=f,I=We(I),e.$sL="workbench.editor.notebook",e.$tL="workbench.editor.notebookTextDiffEditor",e.$uL="workbench.editor.interactive",e.$vL="workbench.editor.repl",e.$wL="replNotebook.input.execute";var y;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$xL=["application/json","application/javascript","text/html","image/svg+xml",O.$9s.latex,O.$9s.markdown,"image/png","image/jpeg",O.$9s.text],e.$yL=[O.$9s.latex,O.$9s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$9s.text],e.$zL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AL="_notAvailable";var a;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var c;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var u;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Z){Z.scheme=A.Schemas.vscodeNotebookCell;function ue(oe,ke){return(0,R.$qL)(oe,ke)}Z.generate=ue;function _(oe){return(0,R.$pL)(oe)}Z.parse=_;function ge(oe,ke){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ke??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Z.generateCellOutputUri=ge;function se(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ke=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!ke)return;const Le=ke[1]&&ke[1]!==""?ke[1]:void 0,Y=ke[2];return{outputId:Le,notebook:oe.with({scheme:Y||A.Schemas.file,fragment:null})}}Z.parseCellOutputUri=se;function ae(oe,ke,Le){return Z.generate(oe,ke).with({scheme:Le})}Z.generateCellPropertyUri=ae;function $e(oe,ke){if(oe.scheme===ke)return Z.parse(oe.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=$e})(r||(e.CellUri=r={}));const t=Z=>$.$j?Z.replace(/\//g,"\\"):Z;class g{constructor(ue=[],_=e.$xL){this.e=_,this.d=[...new Set(ue)].map(ge=>({pattern:ge,matches:I.$yk(t(ge))}))}sort(ue){const _=new Map(P.Iterable.map(ue,se=>[se,t(se)]));let ge=[];for(const{matches:se}of this.d)for(const[ae,$e]of _)if(se($e)){ge.push(ae),_.delete(ae);break}return _.size&&(ge=ge.concat([..._.keys()].sort((se,ae)=>this.e.indexOf(se)-this.e.indexOf(ae)))),ge}prioritize(ue,_){const ge=this.f(ue);if(ge===-1){this.d.unshift({pattern:ue,matches:I.$yk(t(ue))});return}const se=new Set(_.map($e=>this.f($e,ge)));se.delete(-1);const ae=Array.from(se).sort();this.d.splice(ge+1,0,...ae.map($e=>this.d[$e]));for(let $e=ae.length-1;$e>=0;$e--)this.d.splice(ae[$e],1)}toArray(){return this.d.map(ue=>ue.pattern)}f(ue,_=this.d.length){const ge=t(ue);for(let se=0;se<_;se++)if(this.d[se].matches(ge))return se;return-1}}e.$BL=g;function l(Z,ue,_,ge=(se,ae)=>se===ae){const se=[];function ae(ke,Le,Y){if(Le===0&&Y.length===0)return;const q=se[se.length-1];q&&q.start+q.deleteCount===ke?(q.deleteCount+=Le,q.toInsert.push(...Y)):se.push({start:ke,deleteCount:Le,toInsert:Y})}let $e=0,oe=0;for(;;){if($e===Z.length){ae($e,0,ue.slice(oe));break}if(oe===ue.length){ae($e,Z.length-$e,[]);break}const ke=Z[$e],Le=ue[oe];if(ge(ke,Le)){$e+=1,oe+=1;continue}_(Le)?(ae($e,1,[]),$e+=1):(ae($e,0,[Le]),oe+=1)}return se}e.$DL=new s.$Uj("notebookEditorCursorAtBoundary","none"),e.$EL=new s.$Uj("notebookEditorCursorAtLineBoundary","none");var m;(function(Z){Z.default="default",Z.option="option"})(m||(e.NotebookEditorPriority=m={}));var p;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(p||(e.NotebookFindScopeType=p={}));function h(Z){const ue=Z;return!!((typeof ue.include=="string"||I.$zk(ue.include))&&(typeof ue.exclude=="string"||I.$zk(ue.exclude)))}function E(Z,ue,_){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ue)>=0||Z.viewType===ue)return!0;if(Z.filenamePattern){const ge=h(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,se=h(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(I.$xk(ge,(0,T.$mc)(_.fsPath).toLowerCase()))return!(se&&I.$xk(se,(0,T.$mc)(_.fsPath).toLowerCase()))}return!1}e.$HL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class b{static{this.d="notebook/"}static create(ue){return`${b.d}${ue}`}static parse(ue){if(ue.startsWith(b.d))return ue.substring(b.d.length)}}e.$IL=b;function k(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const C=new TextDecoder;function f(Z){const ue=[];let _=!1;for(const $e of Z)(ue.length===0||_)&&(ue.push($e),_=!0);let ge=N(ue);const se=v.$Me.concat(ue.map($e=>v.$Me.wrap($e))),ae=K(se);return ge=ge||ae.byteLength!==se.byteLength,{data:ae,didCompression:ge}}e.$LL="\x1B[A";const w=e.$LL.split("").map(Z=>Z.charCodeAt(0)),F=10;function N(Z){let ue=!1;return Z.forEach((_,ge)=>{if(ge===0||_.length<e.$LL.length)return;const se=Z[ge-1],ae=_.subarray(0,e.$LL.length);if(ae[0]===w[0]&&ae[1]===w[1]&&ae[2]===w[2]){const $e=se.lastIndexOf(F);if($e===-1)return;ue=!0,Z[ge-1]=se.subarray(0,$e),Z[ge]=_.subarray(e.$LL.length)}}),ue}function L(Z){let ue=Z;do Z=ue,ue=Z.replace(/[^\n]\x08/gm,"");while(ue.length<Z.length);return Z}function W(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ue=Z.match(/^(.*)\r+/m)[1];let _=Z.match(/\r+(.*)$/m)[1];_=_+ue.slice(_.length,ue.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return Z}const J=8,M=13;function K(Z){return!Z.buffer.includes(J)&&!Z.buffer.includes(M)?Z:v.$Me.fromString(W(L(C.decode(Z.buffer))))}}),define(Oe[7],Ne([1,0,17,13,59,28,72,12,14,2,37,18,29,109,89]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d){"use strict";var n,o,c,u,i,r,t,g,l,m,p,h,E,D,b,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$6P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.LanguageModelChatMessageRole=e.$WP=e.$VP=e.ChatLocation=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$FP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$sP=e.$rP=e.$qP=e.$pP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.TestRunProfileKind=e.TestResultState=e.$iP=e.$hP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$gP=e.NotebookVariablesRequestKind=e.$fP=e.$eP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$dP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.ColorThemeKind=e.$0O=e.$9O=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$8O=e.QuickInputButtonLocation=e.$7O=e.DebugConsoleMode=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$1O=e.$ZO=e.FileChangeType=e.$YO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$XO=e.$WO=e.$VO=e.$UO=e.InlineCompletionTriggerKind=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$HO=e.ConfigurationTarget=e.$GO=e.$FO=e.$EO=e.$DO=e.DocumentPasteTriggerKind=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$wO=e.ViewBadge=e.ProgressLocation=e.$vO=e.$uO=e.TaskScope=e.ShellQuoting=e.$tO=e.$sO=e.$rO=e.TaskPanelKind=e.TaskRevealKind=e.$qO=e.TerminalLocation=e.$pO=e.$oO=e.$nO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$mO=e.$lO=e.$kO=e.$jO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$hO=e.$gO=e.$fO=e.$eO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$dO=e.$cO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.LanguageStatusSeverity=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.CodeActionTriggerKind=e.$3N=e.$2N=e.SymbolTag=e.SymbolKind=e.$1N=e.$ZN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.DiagnosticSeverity=e.DiagnosticTag=e.$TN=e.$SN=e.FileEditType=e.$RN=e.$QN=e.$PN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$ON=e.$NN=e.$MN=e.$JN=e.$IN=e.$HN=e.$GN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$KN=M,e.$LN=K,e.$iO=$t,e.$IO=Mi,e.$oP=Pn;function f(z){return Object.assign(z,{apply:function(...re){if(re.length===0)return Reflect.construct(z,[]);{const De=re.length===1?[]:re[1];return Reflect.construct(z,De,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(z,[]);{const[De,...Ke]=re;return Reflect.construct(z,Ke,De.constructor)}}})}var w;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var F;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=n=class{static from(...U){let re=U;return new n(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$GN=N,e.$GN=N=n=Ge([f],N);let L=o=class{static Min(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let De=1;De<U.length;De++){const Ke=U[De];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let De=1;De<U.length;De++){const Ke=U[De];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(U){if(!U)return!1;if(U instanceof o)return!0;const{line:re,character:De}=U;return typeof re=="number"&&typeof De=="number"}static of(U){if(U instanceof o)return U;if(this.isPosition(U))return new o(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,re){if(U<0)throw(0,I.$6)("line must be non-negative");if(re<0)throw(0,I.$6)("character must be non-negative");this.c=U,this.e=re}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,re=0){if(U===null||re===null)throw(0,I.$6)();let De;return typeof U>"u"?De=0:typeof U=="number"?De=U:(De=typeof U.lineDelta=="number"?U.lineDelta:0,re=typeof U.characterDelta=="number"?U.characterDelta:0),De===0&&re===0?this:new o(this.line+De,this.character+re)}with(U,re=this.character){if(U===null||re===null)throw(0,I.$6)();let De;return typeof U>"u"?De=this.line:typeof U=="number"?De=U:(De=typeof U.line=="number"?U.line:this.line,re=typeof U.character=="number"?U.character:this.character),De===this.line&&re===this.character?this:new o(De,re)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$HN=L,e.$HN=L=o=Ge([f],L);let W=c=class{static isRange(U){return U instanceof c?!0:U?L.isPosition(U.start)&&L.isPosition(U.end):!1}static of(U){if(U instanceof c)return U;if(this.isRange(U))return new c(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,re,De,Ke){let it,dt;if(typeof U=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(it=new L(U,re),dt=new L(De,Ke)):L.isPosition(U)&&L.isPosition(re)&&(it=L.of(U),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(U){return c.isRange(U)?this.contains(U.start)&&this.contains(U.end):L.isPosition(U)?!(L.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const re=L.Max(U.start,this.c),De=L.Min(U.end,this.e);if(!re.isAfter(De))return new c(re,De)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const re=L.Min(U.start,this.c),De=L.Max(U.end,this.end);return new c(re,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,re=this.end){if(U===null||re===null)throw(0,I.$6)();let De;return U?L.isPosition(U)?De=U:(De=U.start||this.start,re=U.end||this.end):De=this.start,De.isEqual(this.c)&&re.isEqual(this.end)?this:new c(De,re)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return M(this)}};e.$IN=W,e.$IN=W=c=Ge([f],W);let J=u=class extends W{static isSelection(U){return U instanceof u?!0:U?W.isRange(U)&&L.isPosition(U.anchor)&&L.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,re,De,Ke){let it,dt;if(typeof U=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(it=new L(U,re),dt=new L(De,Ke)):L.isPosition(U)&&L.isPosition(re)&&(it=L.of(U),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return K(this)}};e.$JN=J,e.$JN=J=u=Ge([f],J);function M(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function K(z){let U=M(z);return z.isEmpty||(z.active.isEqual(z.start)?U=`|${U}`:U=`${U}|`),U}const Z=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,I.$6)("connectionToken")};class ue{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,re,De){if(typeof U!="string"||U.length===0)throw(0,I.$6)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.$6)("port");typeof De<"u"&&Z(De),this.host=U,this.port=Math.round(re),this.connectionToken=De}}e.$MN=ue;class _{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,re){this.makeConnection=U,this.connectionToken=re,typeof re<"u"&&Z(re)}}e.$NN=_;class ge extends Error{static NotAvailable(U,re){return new ge(U,S.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(U){return new ge(U,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,re=S.RemoteAuthorityResolverErrorCode.Unknown,De){super(U),this._message=U,this._code=re,this._detail=De,Object.setPrototypeOf(this,ge.prototype)}}e.$ON=ge;var se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(se||(e.EndOfLine=se={}));var ae;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ae||(e.EnvironmentVariableMutatorType=ae={}));let $e=i=class{static isTextEdit(U){return U instanceof i?!0:U?W.isRange(U)&&typeof U.newText=="string":!1}static replace(U,re){return new i(U,re)}static insert(U,re){return i.replace(new W(U,U),re)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const re=new i(new W(new L(0,0),new L(0,0)),"");return re.newEol=U,re}get range(){return this.c}set range(U){if(U&&!W.isRange(U))throw(0,I.$6)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,I.$6)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,I.$6)("newEol");this.f=U}constructor(U,re){this.c=U,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$PN=$e,e.$PN=$e=i=Ge([f],$e);let oe=r=class{static isNotebookCellEdit(U){return U instanceof r?!0:U?Ei.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,re){return new r(U,re)}static insertCells(U,re){return new r(new Ei(U,U),re)}static deleteCells(U){return new r(U,[])}static updateCellMetadata(U,re){const De=new r(new Ei(U,U),[]);return De.newCellMetadata=re,De}static updateNotebookMetadata(U){const re=new r(new Ei(0,0),[]);return re.newNotebookMetadata=U,re}constructor(U,re){this.range=U,this.newCells=re}};e.$QN=oe,e.$QN=oe=r=Ge([f],oe);class ke{static isSnippetTextEdit(U){return U instanceof ke?!0:U?W.isRange(U.range)&&q.isSnippetString(U.snippet):!1}static replace(U,re){return new ke(U,re)}static insert(U,re){return ke.replace(new W(U,U),re)}constructor(U,re){this.range=U,this.snippet=re}}e.$RN=ke;var Le;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Le||(e.FileEditType=Le={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,re,De,Ke){this.c.push({_type:Le.File,from:U,to:re,options:De,metadata:Ke})}createFile(U,re,De){this.c.push({_type:Le.File,from:void 0,to:U,options:re,metadata:De})}deleteFile(U,re,De){this.c.push({_type:Le.File,from:U,to:void 0,options:re,metadata:De})}e(U,re,De){this.c.push({_type:Le.Cell,metadata:De,uri:U,edit:{editType:d.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}f(U,re,De,Ke){const it=re.start,dt=re.end;(it!==dt||De.length>0)&&this.c.push({_type:Le.CellReplace,uri:U,index:it,count:dt-it,cells:De,metadata:Ke})}g(U,re,De,Ke){this.c.push({_type:Le.Cell,metadata:Ke,uri:U,edit:{editType:d.CellEditType.Metadata,index:re,metadata:De}})}replace(U,re,De,Ke){this.c.push({_type:Le.Text,uri:U,edit:new $e(re,De),metadata:Ke})}insert(U,re,De,Ke){this.replace(U,new W(re,re),De,Ke)}delete(U,re,De){this.replace(U,re,"",De)}has(U){return this.c.some(re=>re._type===Le.Text&&re.uri.toString()===U.toString())}set(U,re){if(re)for(const De of re){if(!De)continue;let Ke,it;Array.isArray(De)?(Ke=De[0],it=De[1]):Ke=De,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,it):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,it):this.f(U,Ke.range,Ke.newCells,it):ke.isSnippetTextEdit(Ke)?this.c.push({_type:Le.Snippet,uri:U,range:Ke.range,edit:Ke.snippet,metadata:it}):this.c.push({_type:Le.Text,uri:U,edit:Ke,metadata:it})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case Le.Text:case Le.Snippet:case Le.Cell:case Le.CellReplace:Ke.uri.toString()===U.toString()&&(this.c[De]=void 0);break}}(0,v.$Hb)(this.c)}}get(U){const re=[];for(const De of this.c)De._type===Le.Text&&De.uri.toString()===U.toString()&&re.push(De.edit);return re}entries(){const U=new O.$zc;for(const re of this.c)if(re._type===Le.Text){let De=U.get(re.uri);De||(De=[re.uri,[]],U.set(re.uri,De)),De[1].push(re.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$SN=Y,e.$SN=Y=Ge([f],Y);let q=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,re=this.e++){if(typeof U=="function"){const De=new t;De.e=this.e,U(De),this.e=De.e,U=De.value}else U=t.c(U);return this.value+="${",this.value+=re,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,re=this.e++){const De=U.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(U,re){if(typeof re=="function"){const De=new t;De.e=this.e,re(De),this.e=De.e,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$TN=q,e.$TN=q=t=Ge([f],q);var te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var ve;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let ce=g=class{static isLocation(U){return U instanceof g?!0:U?W.isRange(U.range)&&s.URI.isUri(U.uri):!1}constructor(U,re){if(this.uri=U,re)if(W.isRange(re))this.range=W.of(re);else if(L.isPosition(re))this.range=new W(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$UN=ce,e.$UN=ce=g=Ge([f],ce);let we=class{static is(U){return U?typeof U.message=="string"&&U.location&&W.isRange(U.location.range)&&s.URI.isUri(U.location.uri):!1}constructor(U,re){this.location=U,this.message=re}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.location.range.isEqual(re.location.range)&&U.location.uri.toString()===re.location.uri.toString()}};e.$VN=we,e.$VN=we=Ge([f],we);let he=class{constructor(U,re,De=ve.Error){if(!W.isRange(U))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=U,this.message=re,this.severity=De}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.severity===re.severity&&U.code===re.code&&U.severity===re.severity&&U.source===re.source&&U.range.isEqual(re.range)&&(0,v.$tb)(U.tags,re.tags)&&(0,v.$tb)(U.relatedInformation,re.relatedInformation,we.isEqual)}};e.$WN=he,e.$WN=he=Ge([f],he);let X=class{constructor(U,re){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=re}};e.$XN=X,e.$XN=X=Ge([f],X);let x=class extends X{constructor(U,re,De,Ke){super(U,re),this.canIncreaseVerbosity=De,this.canDecreaseVerbosity=Ke}};e.$YN=x,e.$YN=x=Ge([f],x);var me;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(me||(e.HoverVerbosityAction=me={}));var pe;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Ae=class{constructor(U,re=pe.Text){this.range=U,this.kind=re}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.$ZN=Ae,e.$ZN=Ae=Ge([f],Ae);let Ue=class{constructor(U,re){this.uri=U,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.$1N=Ue,e.$1N=Ue=Ge([f],Ue);var Se;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Se||(e.SymbolKind=Se={}));var Pe;(function(z){z[z.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Te=l=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,re,De,Ke,it){this.name=U,this.kind=re,this.containerName=it,typeof De=="string"&&(this.containerName=De),Ke instanceof ce?this.location=Ke:De instanceof W&&(this.location=new ce(Ke,De)),l.validate(this)}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};e.$2N=Te,e.$2N=Te=l=Ge([f],Te);let j=m=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(m.validate)}constructor(U,re,De,Ke,it){this.name=U,this.detail=re,this.kind=De,this.range=Ke,this.selectionRange=it,this.children=[],m.validate(this)}};e.$3N=j,e.$3N=j=m=Ge([f],j);var B;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let H=class{constructor(U,re){this.title=U,this.kind=re}};e.$4N=H,e.$4N=H=Ge([f],H);let V=class{static{p=this}static{this.c="."}constructor(U){this.value=U}append(U){return new p(this.value?this.value+p.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+p.c)}};e.$5N=V,e.$5N=V=p=Ge([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let ne=class{constructor(U,re){if(this.range=U,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$6N=ne,e.$6N=ne=Ge([f],ne);class fe{constructor(U,re,De,Ke,it,dt){this.kind=U,this.name=re,this.detail=De,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$7N=fe;class Ie{constructor(U,re){this.fromRanges=re,this.from=U}}e.$8N=Ie;class ze{constructor(U,re){this.fromRanges=re,this.to=U}}e.$9N=ze;var Qe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(U,re){this.range=U,this.command=re}get isResolved(){return!!this.command}};e.$0N=_e,e.$0N=_e=Ge([f],_e);let tt=h=class{#e;static isMarkdownString(U){return U instanceof h?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,re=!1){this.#e=new P.$2k(U,{supportThemeIcons:re})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,re){return this.#e.appendCodeblock(re??"",U),this}};e.$$N=tt,e.$$N=tt=h=Ge([f],tt);let nt=class{constructor(U,re){this.label=U,this.documentation=re}};e.$_N=nt,e.$_N=nt=Ge([f],nt);let et=class{constructor(U,re){this.label=U,this.documentation=re,this.parameters=[]}};e.$aO=et,e.$aO=et=Ge([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$bO=rt,e.$bO=rt=Ge([f],rt);var mt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(mt||(e.SignatureHelpTriggerKind=mt={}));var ut;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ut||(e.InlayHintKind=ut={}));let st=class{constructor(U){this.value=U}};e.$cO=st,e.$cO=st=Ge([f],st);let ct=class{constructor(U,re,De){this.position=U,this.label=re,this.kind=De}};e.$dO=ct,e.$dO=ct=Ge([f],ct);var ft;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft||(e.CompletionTriggerKind=ft={}));var pt;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var qe;(function(z){z[z.Deprecated=1]="Deprecated"})(qe||(e.CompletionItemTag=qe={}));let je=class{constructor(U,re){this.label=U,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$eO=je,e.$eO=je=Ge([f],je);let ee=class{constructor(U=[],re=!1){this.items=U,this.isIncomplete=re}};e.$fO=ee,e.$fO=ee=Ge([f],ee);let Q=class{constructor(U,re,De){this.insertText=U,this.range=re,this.command=De}};e.$gO=Q,e.$gO=Q=Ge([f],Q);let Ee=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$hO=Ee,e.$hO=Ee=Ge([f],Ee);var Je;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(Je||(e.PartialAcceptTriggerKind=Je={}));var xe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function $t(z,U){return`${y.$pn.toKey(z)}.${U}`}var Nt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(Nt||(e.TextEditorLineNumbersStyle=Nt={}));var Wt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var si;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(si||(e.TextEditorRevealType=si={}));var Yt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Yt||(e.TextEditorSelectionChangeKind=Yt={}));var hi;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(hi||(e.TextDocumentChangeReason=hi={}));var Ze;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Ze||(e.DecorationRangeBehavior=Ze={})),function(z){function U(re){switch(re){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Yt||(e.TextEditorSelectionChangeKind=Yt={}));var Vt;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(z){function U(re){switch(re){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(Vt||(e.SyntaxTokenType=Vt={}));let Ht=class{constructor(U,re){if(re&&!s.URI.isUri(re))throw(0,I.$6)("target");if(!W.isRange(U)||U.isEmpty)throw(0,I.$6)("range");this.range=U,this.target=re}};e.$jO=Ht,e.$jO=Ht=Ge([f],Ht);let gt=class{constructor(U,re,De,Ke){this.red=U,this.green=re,this.blue=De,this.alpha=Ke}};e.$kO=gt,e.$kO=gt=Ge([f],gt);let St=class{constructor(U,re){if(re&&!(re instanceof gt))throw(0,I.$6)("color");if(!W.isRange(U)||U.isEmpty)throw(0,I.$6)("range");this.range=U,this.color=re}};e.$lO=St,e.$lO=St=Ge([f],St);let xt=class{constructor(U){if(!U||typeof U!="string")throw(0,I.$6)("label");this.label=U}};e.$mO=xt,e.$mO=xt=Ge([f],xt);var _t;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var jt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(jt||(e.SourceControlInputBoxValidationType=jt={}));var wt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Rt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Rt||(e.TerminalShellExecutionCommandLineConfidence=Rt={}));class ci{constructor(U,re,De){if(this.startIndex=U,this.length=re,this.tooltip=De,typeof U!="number"||U<0)throw(0,I.$6)("startIndex");if(typeof re!="number"||re<1)throw(0,I.$6)("length");if(De!==void 0&&typeof De!="string")throw(0,I.$6)("tooltip")}}e.$nO=ci;class Qt{constructor(U){this.uri=U}}e.$oO=Qt;class Xe{constructor(U){this.terminalCommand=U}}e.$pO=Xe;var ei;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ei||(e.TerminalLocation=ei={}));class ui{constructor(U){if(this.options=U,typeof U!="object")throw(0,I.$6)("options")}}e.$qO=ui;var di;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var kt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Mt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(U){switch(U){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(U,re){if(this.label=re,typeof U!="string"||typeof re!="string")throw(0,I.$6)("name");this.c=U}get id(){return this.c}};e.$rO=Mt,e.$rO=Mt=E=Ge([f],Mt);function At(z){let U="";for(let re=0;re<z.length;re++)U+=z[re].replace(/,/g,",,")+",";return U}let Ft=class{constructor(U,re,De){if(typeof U!="string")throw(0,I.$6)("process");this.e=[],this.c=U,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=De):this.f=re)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,I.$6)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const re of this.e)U.push(re);return At(U)}};e.$sO=Ft,e.$sO=Ft=Ge([f],Ft);let oi=class{constructor(U,re,De){if(this.f=[],Array.isArray(re)){if(!U)throw(0,I.$6)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.$6)("command");this.e=U,this.f=re,this.g=De}else{if(typeof U!="string")throw(0,I.$6)("commandLine");this.c=U,this.g=re}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,I.$6)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.$6)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)U.push(typeof re=="string"?re:re.value);return At(U)}};e.$tO=oi,e.$tO=oi=Ge([f],oi);var ti;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ii;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ii||(e.TaskScope=ii={}));class Bt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,R.$Zg)()}set callback(U){this.c=U}get callback(){return this.c}}e.$uO=Bt;let qt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,re,De,Ke,it,dt){this.k=!1,this.l=this.definition=U;let vt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=De,this.execution=Ke,vt=it,this.k=!0):re===ii.Global||re===ii.Workspace?(this.target=re,this.o=this.name=De,this.w=this.source=Ke,this.execution=it,vt=dt):(this.target=re,this.o=this.name=De,this.w=this.source=Ke,this.execution=it,vt=dt),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(U){this.j=U}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof oi?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$Zg)()}}get definition(){return this.l}set definition(U){if(U==null)throw(0,I.$6)("Kind can't be undefined or null");this.B(),this.l=U}get scope(){return this.m}set target(U){this.B(),this.m=U}get name(){return this.o}set name(U){if(typeof U!="string")throw(0,I.$6)("name");this.B(),this.o=U}get execution(){return this.q}set execution(U){U===null&&(U=void 0),this.B(),this.q=U;const re=this.l.type;(D.g===re||D.e===re||D.f===re||D.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(U){if(Array.isArray(U))this.B(),this.r=U,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.B(),this.u=U}get source(){return this.w}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.$6)("source must be a string of length > 0");this.B(),this.w=U}get group(){return this.x}set group(U){U===null&&(U=void 0),this.B(),this.x=U}get detail(){return this.A}set detail(U){U===null&&(U=void 0),this.A=U}get presentationOptions(){return this.y}set presentationOptions(U){U==null&&(U=Object.create(null)),this.B(),this.y=U}get runOptions(){return this.z}set runOptions(U){U==null&&(U=Object.create(null)),this.B(),this.z=U}};e.$vO=qt,e.$vO=qt=D=Ge([f],qt);var li;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(li||(e.ProgressLocation=li={}));var Tt;(function(z){function U(re){const De=re;return(0,$.$hg)(De.value)?De.tooltip&&!(0,$.$dg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}z.isViewBadge=U})(Tt||(e.ViewBadge=Tt={}));let Ct=b=class{static isTreeItem(U,re){const De=U;if(De.checkboxState!==void 0){const Ke=(0,$.$hg)(De.checkboxState)?De.checkboxState:(0,$.$fg)(De.checkboxState)&&(0,$.$hg)(De.checkboxState.state)?De.checkboxState.state:void 0,it=!(0,$.$hg)(De.checkboxState)&&(0,$.$fg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Kt.Checked&&Ke!==Kt.Unchecked||it!==void 0&&!(0,$.$dg)(it))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(U instanceof b)return!0;if(De.label!==void 0&&!(0,$.$dg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,$.$dg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,$.$dg)(De.iconPath)&&!s.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,$.$dg)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,$.$dg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,$.$dg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,$.$dg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!s.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,$.$dg)(De.tooltip)&&!(De.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<bt.None&&De.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,$.$dg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(U,re=bt.None){this.collapsibleState=re,s.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$wO=Ct,e.$wO=Ct=b=Ge([f],Ct);var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Kt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Kt||(e.TreeItemCheckboxState=Kt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$xO=yt,e.$xO=yt=Ge([f],yt);class ai extends yt{}e.$yO=ai;class Gt extends ai{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$zO=Gt;class Ai{constructor(U,re,De,Ke){this.name=U,this.uri=re,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$AO=Ai;let gi=class{#e=new Map;constructor(U){for(const[re,De]of U??[]){const Ke=this.#e.get(this.#t(re));Ke?Ke.push(De):this.#e.set(this.#t(re),[De])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,re){this.#e.set(this.#t(U),[re])}forEach(U,re){for(const[De,Ke]of this.#e)for(const it of Ke)U.call(re,it,De,this)}*[Symbol.iterator](){for(const[U,re]of this.#e)for(const De of re)yield[U,De]}#t(U){return U.toLowerCase()}};e.$BO=gi,e.$BO=gi=Ge([f],gi);let Si=class{constructor(U,re,De){this.insertText=U,this.title=re,this.kind=De}};e.$CO=Si,e.$CO=Si=Ge([f],Si);var Ut;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Ut||(e.DocumentPasteTriggerKind=Ut={}));class fi{static{this.c="."}constructor(U){this.value=U}append(...U){return new fi((this.value?[this.value,...U]:U).join(fi.c))}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+fi.c)}}e.$DO=fi,fi.Empty=new fi("");class Ni{constructor(U,re,De){this.title=re,this.insertText=U,this.kind=De}}e.$EO=Ni;let It=class{constructor(U,re){this.id=U,this.color=re}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$FO=It,e.$FO=It=Ge([f],It),It.File=new It("file"),It.Folder=new It("folder");let vi=class{constructor(U){this.id=U}};e.$GO=vi,e.$GO=vi=Ge([f],vi);var Ti;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let bi=class{get base(){return this.c}set base(U){this.c=U,this.e=s.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,re){if(typeof U!="string"&&(!U||!s.URI.isUri(U)&&!s.URI.isUri(U.uri)))throw(0,I.$6)("base");if(typeof re!="string")throw(0,I.$6)("pattern");typeof U=="string"?this.baseUri=s.URI.file(U):s.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$HO=bi,e.$HO=bi=Ge([f],bi);const Li=new WeakMap;function Mi(z,U){Li.set(z,U)}let Lt=class{constructor(U,re,De,Ke,it){this.enabled=typeof U=="boolean"?U:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Li.get(this)??(0,R.$Zg)()),this.c}};e.$JO=Lt,e.$JO=Lt=Ge([f],Lt);let ki=class extends Lt{constructor(U,re,De,Ke,it,dt){if(super(re,De,Ke,it,dt),U===null)throw(0,I.$6)("location");this.location=U}};e.$KO=ki,e.$KO=ki=Ge([f],ki);let ye=class extends Lt{constructor(U,re,De,Ke,it,dt){super(re,De,Ke,it,dt),this.functionName=U}};e.$LO=ye,e.$LO=ye=Ge([f],ye);let Re=class extends Lt{constructor(U,re,De,Ke,it,dt,vt,Zt){if(super(Ke,it,dt,vt,Zt),!re)throw(0,I.$6)("dataId");this.label=U,this.dataId=re,this.canPersist=De}};e.$MO=Re,e.$MO=Re=Ge([f],Re);let le=class{constructor(U,re,De){this.command=U,this.args=re||[],this.options=De}};e.$NO=le,e.$NO=le=Ge([f],le);let G=class{constructor(U,re){this.port=U,this.host=re}};e.$OO=G,e.$OO=G=Ge([f],G);let Ce=class{constructor(U){this.path=U}};e.$PO=Ce,e.$PO=Ce=Ge([f],Ce);let Be=class{constructor(U){this.implementation=U}};e.$QO=Be,e.$QO=Be=Ge([f],Be);class Ye{constructor(U,re,De){this.session=U,this.threadId=re,this.frameId=De}}e.$RO=Ye;class He{constructor(U,re){this.session=U,this.threadId=re}}e.$SO=He;let lt=class{constructor(U,re){this.range=U,this.expression=re}};e.$TO=lt,e.$TO=lt=Ge([f],lt);var Pt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Jt=class{constructor(U,re){this.range=U,this.text=re}};e.$UO=Jt,e.$UO=Jt=Ge([f],Jt);let ni=class{constructor(U,re,De=!0){this.range=U,this.variableName=re,this.caseSensitiveLookup=De}};e.$VO=ni,e.$VO=ni=Ge([f],ni);let zt=class{constructor(U,re){this.range=U,this.expression=re}};e.$WO=zt,e.$WO=zt=Ge([f],zt);let Xt=class{constructor(U,re){this.frameId=U,this.stoppedLocation=re}};e.$XO=Xt,e.$XO=Xt=Ge([f],Xt);var _i;(function(z){z[z.AIGenerated=1]="AIGenerated"})(_i||(e.NewSymbolNameTag=_i={}));var Fi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Fi||(e.NewSymbolNameTriggerKind=Fi={}));class qi{constructor(U,re){this.newSymbolName=U,this.tags=re}}e.$YO=qi;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Wi=k=class extends Error{static FileExists(U){return new k(U,a.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(U){return new k(U,a.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(U){return new k(U,a.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(U){return new k(U,a.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(U){return new k(U,a.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(U){return new k(U,a.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(U,re=a.FileSystemProviderErrorCode.Unknown,De){super(s.URI.isUri(U)?U.toString(!0):U),this.code=De?.name??"Unknown",(0,a.$nl)(this,re),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$ZO=Wi,e.$ZO=Wi=k=Ge([f],Wi);let yi=class{constructor(U,re,De){this.start=U,this.end=re,this.kind=De}};e.$1O=yi,e.$1O=yi=Ge([f],yi);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var zi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));var Vi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(U,re=[]){this.tokenTypes=U,this.tokenModifiers=re}}e.$2O=on;function bn(z){return typeof z>"u"||(0,$.$eg)(z)}class Ci{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,U){this.m=!0;for(let re=0,De=U.tokenTypes.length;re<De;re++)this.k.set(U.tokenTypes[re],re);for(let re=0,De=U.tokenModifiers.length;re<De;re++)this.l.set(U.tokenModifiers[re],re)}}push(U,re,De,Ke,it){if(typeof U=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(U,re,De,Ke,it);if(W.isRange(U)&&typeof re=="string"&&bn(De))return this.o(U,re,De);throw(0,I.$6)()}o(U,re,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,it=U.start.character,dt=U.end.character-U.start.character,vt=this.k.get(re);let Zt=0;if(De)for(const $i of De){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Zt|=1<<wi>>>0}this.q(Ke,it,dt,vt,Zt)}q(U,re,De,Ke,it){if(this.f&&(U<this.c||U===this.c&&re<this.e)){this.f=!1;const Zt=this.g.length/5|0;let $i=0,wi=0;for(let Di=0;Di<Zt;Di++){let Ri=this.g[5*Di],Yi=this.g[5*Di+1];Ri===0?(Ri=$i,Yi+=wi):Ri+=$i,this.g[5*Di]=Ri,this.g[5*Di+1]=Yi,$i=Ri,wi=Yi}}let dt=U,vt=re;this.f&&this.j>0&&(dt-=this.c,dt===0&&(vt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=vt,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=it,this.c=U,this.e=re}static r(U){const re=[],De=U.length/5|0;for(let vt=0;vt<De;vt++)re[vt]=vt;re.sort((vt,Zt)=>{const $i=U[5*vt],wi=U[5*Zt];if($i===wi){const Di=U[5*vt+1],Ri=U[5*Zt+1];return Di-Ri}return $i-wi});const Ke=new Uint32Array(U.length);let it=0,dt=0;for(let vt=0;vt<De;vt++){const Zt=5*re[vt],$i=U[Zt+0],wi=U[Zt+1],Di=U[Zt+2],Ri=U[Zt+3],Yi=U[Zt+4],Vn=$i-it,Nr=Vn===0?wi-dt:wi,xi=5*vt;Ke[xi+0]=Vn,Ke[xi+1]=Nr,Ke[xi+2]=Di,Ke[xi+3]=Ri,Ke[xi+4]=Yi,it=$i,dt=wi}return Ke}build(U){return this.f?new Hi(new Uint32Array(this.g),U):new Hi(Ci.r(this.g),U)}}e.$3O=Ci;class Hi{constructor(U,re){this.resultId=re,this.data=U}}e.$4O=Hi;class wn{constructor(U,re,De){this.start=U,this.deleteCount=re,this.data=De}}e.$5O=wn;class vn{constructor(U,re){this.resultId=re,this.edits=U}}e.$6O=vn;var ji;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(ji||(e.DebugConsoleMode=ji={}));class an{constructor(U){this.name=U}}e.$7O=an;var Fe;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Fe||(e.QuickInputButtonLocation=Fe={}));let mi=class{static{this.Back={iconPath:new It("arrow-left")}}constructor(){}};e.$8O=mi,e.$8O=mi=Ge([f],mi);var Qi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var ot;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ot||(e.InputBoxValidationSeverity=ot={}));var Et;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Et||(e.ExtensionKind=Et={}));class yn{static validate(U){if(typeof U.badge=="string"){let re=(0,T.$Of)(U.badge,0);if(re<U.badge.length&&(re+=(0,T.$Of)(U.badge,re)),U.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!It.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,re,De){this.badge=U,this.tooltip=re,this.color=De}}e.$9O=yn;let Ki=class{constructor(U){this.kind=U}};e.$0O=Ki,e.$0O=Ki=Ge([f],Ki);var Gi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Gi||(e.ColorThemeKind=Gi={}));class Ei{static isNotebookRange(U){return U instanceof Ei?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,re){if(U<0)throw(0,I.$6)("start must be positive");if(re<0)throw(0,I.$6)("end must be positive");U<=re?(this.c=U,this.e=re):(this.c=re,this.e=U)}with(U){let re=this.c,De=this.e;return U.start!==void 0&&(re=U.start),U.end!==void 0&&(De=U.end),re===this.c&&De===this.e?this:new Ei(re,De)}}e.$$O=Ei;class Ii{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(re=>Ii.isNotebookCellData(re))}static isNotebookCellData(U){return!0}constructor(U,re,De,Ke,it,dt,vt){this.kind=U,this.value=re,this.languageId=De,this.mime=Ke,this.outputs=it??[],this.metadata=dt,this.executionSummary=vt,Ii.validate(this)}}e.$_O=Ii;class En{constructor(U){this.cells=U}}e.$aP=En;class pi{static isNotebookCellOutputItem(U){return U instanceof pi?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const re={name:U.name,message:U.message,stack:U.stack};return pi.json(re,"application/vnd.code.notebook.error")}static stdout(U){return pi.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return pi.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,re="application/octet-stream"){return new pi(U,re)}static#e=new TextEncoder;static text(U,re=A.$9s.text){const De=pi.#e.encode(String(U));return new pi(De,re)}static json(U,re="text/x-json"){const De=JSON.stringify(U,void 0,"	");return pi.text(De,re)}constructor(U,re){this.data=U,this.mime=re;const De=(0,A.$at)(re,!0);if(!De)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$bP=pi;class Bi{static isNotebookCellOutput(U){return U instanceof Bi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,re=!1){const De=new Set,Ke=new Set;for(let it=0;it<U.length;it++){const dt=U[it],vt=(0,A.$at)(dt.mime);if(!De.has(vt)||(0,d.$JL)(vt)){De.add(vt);continue}Ke.add(it),re&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ke.size===0?U:U.filter((it,dt)=>!Ke.has(dt))}constructor(U,re,De){this.items=Bi.ensureUniqueMimeTypes(U,!0),typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,R.$Zg)(),this.metadata=re??De)}}e.$cP=Bi;var Ji;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Ji||(e.NotebookCellKind=Ji={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var un;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(un||(e.NotebookCellStatusBarAlignment=un={}));var ln;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ln||(e.NotebookEditorRevealType=ln={}));class Dn{constructor(U,re){this.text=U,this.alignment=re}}e.$dP=Dn;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class Sn{constructor(U,re=[]){this.uri=U,this.provides=(0,v.$1b)(re)}}e.$eP=Sn;class kn{constructor(U){this.label=U}}e.$fP=kn;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Xi=class{constructor(U,re){this.label=U,this.timestamp=re}};e.$gP=Xi,e.$gP=Xi=Ge([f],Xi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var ie;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(ie||(e.ExtensionRuntime=ie={}));var de;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(de||(e.StandardTokenType=de={}));class Me{constructor(U,re){this.ranges=U,this.wordPattern=re}}e.$hP=Me;class at{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$iP=at;var Dt;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Dt||(e.TestResultState=Dt={}));var Ot;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ot||(e.TestRunProfileKind=Ot={}));let Pi=class{constructor(U=void 0,re=void 0,De=void 0,Ke=!1,it=!0){this.include=U,this.exclude=re,this.profile=De,this.continuous=Ke,this.preserveFocus=it}};e.$jP=Pi,e.$jP=Pi=Ge([f],Pi);let Zi=C=class{static diff(U,re,De){const Ke=new C(U);return Ke.expectedOutput=re,Ke.actualOutput=De,Ke}constructor(U){this.message=U}};e.$kP=Zi,e.$kP=Zi=C=Ge([f],Zi);let Cn=class{constructor(U){this.id=U}};e.$lP=Cn,e.$lP=Cn=Ge([f],Cn);class Kn{constructor(U,re,De){this.label=U,this.file=re,this.position=De}}e.$mP=Kn;class mn{constructor(U,re){this.covered=U,this.total=re,Pn(this)}}e.$nP=mn;function Pn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class In{static fromDetails(U,re){const De=new mn(0,0),Ke=new mn(0,0),it=new mn(0,0);for(const vt of re)if("branches"in vt){De.total+=1,De.covered+=vt.executed?1:0;for(const Zt of vt.branches)Ke.total+=1,Ke.covered+=Zt.executed?1:0}else it.total+=1,it.covered+=vt.executed?1:0;const dt=new In(U,De,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return dt.detailedCoverage=re,dt}constructor(U,re,De,Ke,it=[]){this.uri=U,this.statementCoverage=re,this.branchCoverage=De,this.declarationCoverage=Ke,this.fromTests=it}}e.$pP=In;class Gn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,De=[]){this.executed=U,this.location=re,this.branches=De}}e.$qP=Gn;class Jn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,De){this.executed=U,this.location=re,this.label=De}}e.$rP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,re,De){this.name=U,this.executed=re,this.location=De}}e.$sP=Xn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var An;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(An||(e.WorkspaceTrustState=An={}));var Tn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Zn{constructor(U,re,De,Ke,it,dt){this.kind=U,this.name=re,this.detail=De,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$tP=Zn;class Yn{constructor(U){this.uri=U}}e.$uP=Yn;class xn{constructor(U,re){this.original=U,this.modified=re}}e.$vP=xn;class _n{constructor(U,re,De,Ke){this.base=U,this.input1=re,this.input2=De,this.result=Ke}}e.$wP=_n;class er{constructor(U,re){this.uri=U,this.viewType=re}}e.$xP=er;class tr{constructor(U){this.viewType=U}}e.$yP=tr;class ir{constructor(U,re){this.uri=U,this.notebookType=re}}e.$zP=ir;class nr{constructor(U,re,De){this.original=U,this.modified=re,this.notebookType=De}}e.$AP=nr;class rr{constructor(){}}e.$BP=rr;class sr{constructor(U,re){this.uri=U,this.inputBoxUri=re}}e.$CP=sr;class or{constructor(){}}e.$DP=or;class ar{constructor(U){this.textDiffs=U}}e.$EP=ar;var On;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(On||(e.InteractiveSessionVoteDirection=On={}));var Nn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Ln;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class cr{constructor(U,re,De){this.id=U,this.label=re,this.values=De}}e.$FP=cr;var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U}}e.$GP=ur;class lr{constructor(U,re){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U,this.vulnerabilities=re}}e.$HP=lr;class hr{constructor(U,re){this.participant=U,this.command=re}}e.$IP=hr;class dr{constructor(U,re,De,Ke){this.title=U,this.message=re,this.data=De,this.buttons=Ke}}e.$JP=dr;class fr{constructor(U,re){this.value=U,this.baseUri=re}}e.$KP=fr;class gr{constructor(U,re){this.value=U,this.title=re}}e.$LP=gr;class mr{constructor(U){this.value=U}}e.$MP=mr;class pr{constructor(U,re){this.value=U,this.task=re}}e.$NP=pr;class $r{constructor(U){if(typeof U!="string"&&U.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof U=="string"?new tt(U):U}}e.$OP=$r;class br{constructor(U){this.value=U}}e.$PP=br;class wr{constructor(U,re){this.value=U,this.iconPath=re}}e.$QP=wr;class vr{constructor(U,re){this.value=U,this.license=re}}e.$RP=vr;class yr{constructor(U,re){this.uri=U,this.edits=Array.isArray(re)?re:[re]}}e.$SP=yr;class Er{constructor(U,re,De,Ke){this.prompt=U,this.command=re,this.references=De,this.participant=Ke}}e.$TP=Er;class Dr{constructor(U,re,De,Ke){this.response=U,this.result=re,this.participant=De,this.command=Ke}}e.$UP=Dr;var Un;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Un||(e.ChatLocation=Un={}));class Sr{constructor(U,re,De){this.document=U,this.selection=re,this.wholeRange=De}}e.$VP=Sr;class kr{constructor(U){this.cell=U}}e.$WP=kr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(U,re,De){this.name=U,this.content=re,this.isError=De??!1}}e.$XP=Cr;class $n{static User(U,re){const De=new $n(pn.User,typeof U=="string"?U:"",re);return De.content2=U,De}static Assistant(U,re){return new $n(pn.Assistant,U,re)}constructor(U,re,De){this.role=U,this.content=re,this.content2=re,this.name=De}}e.$YP=$n;class Ir{constructor(U,re){this.name=U,this.parameters=re}}e.$ZP=Ir;class Pr{constructor(U){this.value=U}}e.$1P=Pr;class Rr{constructor(U){this.content=U}}e.$2P=Rr;class Ar{constructor(U,re){this.content=U,this.name=re}}e.$3P=Ar;class Tr{constructor(U,re){this.content=U,this.name=re}}e.$4P=Tr;class Oi extends Error{static NotFound(U){return new Oi(U,Oi.NotFound.name)}static NoPermissions(U){return new Oi(U,Oi.NoPermissions.name)}static Blocked(U){return new Oi(U,Oi.Blocked.name)}constructor(U,re,De){super(U,{cause:De}),this.name="LanguageModelError",this.code=re??""}}e.$5P=Oi;var zn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(zn||(e.RelatedInformationType=zn={}));var jn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(jn||(e.SpeechToTextStatus=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Bn||(e.TextToSpeechStatus=Bn={}));var qn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Or{constructor(U,re){this.text=U,this.range=re}}e.$6P=Or;var Wn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Wn||(e.InlineEditTriggerKind=Wn={}))}),define(Oe[227],Ne([1,0,5,7]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$EN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(A);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(T,$)??[]}getRelatedInformation(A,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(A,T,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiRelatedInformationProvider(s,T),new I.$GN(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$7oc=P}),define(Oe[90],Ne([1,0,6,5,7,18,117,3,16]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=e.$fpc=void 0,e.$fpc=(0,T.$Di)("IExtHostAuthentication");let s=class{constructor(a){this.b=new Map,this.c=new v.$ke,this.onDidChangeSessions=this.c.event,this.d=new R,this.a=a.getProxy(I.$EN.MainThreadAuthentication)}async getSession(a,S,d,n={}){const o=O.$pn.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const u=a.displayName||a.name;return this.a.$getSession(S,d,o,u,n)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,n){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:n??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,n?.supportsMultipleAccounts??!1),new P.$GN(()=>{o.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const n=this.b.get(a);if(n)return await n.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const n=this.b.get(a);if(n)return await n.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(A.$GM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$gpc=s,e.$gpc=s=Ge([Ve(0,$.$eQ)],s);class R{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const n=S().finally(()=>this.a.delete(a));return this.a.set(a,n),n}}}),define(Oe[122],Ne([1,0,2,5,7,3,16,11,17,12,19,24]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=e.$kqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(I.$EN.MainThreadDecorations)}registerFileDecorationProvider(n,o){const c=a.c++;this.f.set(c,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(c,o.identifier.value);const u=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const r=(0,$.$1b)(i);if(r.length<=a.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,r.length);const t=r.map(m=>({uri:m,rank:(0,s.$hf)(m.path,"/")})),g=(0,$.$yb)(t,(m,p)=>m.rank-p.rank||(0,s.$xf)(m.uri.path,p.uri.path)),l=[];e:for(const m of g){let p;for(const h of m){const E=(0,R.$lc)(h.uri.path);if(p!==E&&(p=E,l.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,l)});return new P.$GN(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(n,o,c){if(!this.f.has(n))return Object.create(null);const u=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(o.map(async t=>{try{const{uri:g,id:l}=t,m=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!m)return;try{P.$9O.validate(m),m.badge&&typeof m.badge!="string"&&(0,y.$eH)(r,"codiconDecoration"),u[l]=[m.propagate,m.tooltip,m.badge,m.color]}catch(p){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${p}`)}}catch(g){this.h.error(g)}})),u}};e.$kqc=S,e.$kqc=S=a=Ge([Ve(0,A.$eQ),Ve(1,T.$$j)],S),e.$lqc=(0,O.$Di)("IExtHostDecorations")}),define(Oe[228],Ne([1,0,13,2,7,5,15,21,12]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class s{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(O.$EN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=s.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let n;d=a.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const c=this.$provideTextDocumentContent(S,o).then(async u=>{if(!u&&typeof u!="string")return;const i=this.d.getDocument(o);if(!i)return;const r=(0,$.$rf)(u);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(o,u)}).catch(v.$Y).finally(()=>{n===c&&(n=void 0)});n=c})}return new P.$GN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(I.URI.revive(a),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$nqc=s}),define(Oe[123],Ne([1,0,61,15,12,284,169,7,17]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0,e.$gQ=R;const s=new Map;function R(d,n){n?s.set(d,n):s.delete(d)}function y(d){return s.get(d)}class a extends O.$nw{constructor(n,o,c,u,i,r,t){super(o,c,u,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,$.$tb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===I.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,c){return n.y(o,c)},[Symbol.for("debug.description")](){return`TextDocument(${n.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const c=this.g,u=o.start.line,i=o.end.line,r=[];r.push(this.f[u].substring(o.start.character));for(let t=u+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,o.end.character)),r.join(c)}t(n){let o;if(n instanceof T.$HN?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),c=this.f[o.index].length;return new T.$HN(o.index,Math.min(o.remainder,c))}w(n){if(!(n instanceof T.$IN))throw new Error("Invalid argument");const o=this.x(n.start),c=this.x(n.end);return o===n.start&&c===n.end?n:new T.$IN(o.line,o.character,c.line,c.character)}x(n){if(!(n instanceof T.$HN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:c}=n,u=!1;if(o<0)o=0,c=0,u=!0;else if(o>=this.f.length)o=this.f.length-1,c=this.f[o].length,u=!0;else{const i=this.f[o].length;c<0?(c=0,u=!0):c>i&&(c=i,u=!0)}return u?new T.$HN(o,c):n}y(n,o){const c=this.x(n);if(!o)o=y(this.m);else if((0,P.$qf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const u=(0,A.$ot)(c.character+1,(0,A.$mt)(o),this.f[c.line],0);if(u)return new T.$IN(c.line,u.startColumn-1,c.line,u.endColumn-1)}}e.$hQ=a;class S{constructor(n,o,c){this.a=n,this.b=o,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$IN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$IN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$iQ=S}),define(Oe[229],Ne([1,0,5,7]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$EN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(A);if(!s)throw new Error("Embedding vector provider not found");const R=await s.provideEmbeddingVector(T,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiEmbeddingVectorProvider(T,s),new I.$GN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$qqc=P}),define(Oe[68],Ne([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=void 0,I=We(I);let d=S=class{constructor(o,c){this.b=new Map,this.c=new R.$Mh,this.a=o.getProxy(v.$EN.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(i){try{let r;const t=u.b.get(i.scheme);return t?(await u.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await u.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===I.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(i){try{const r=u.b.get(i.scheme);return r?(await u.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await u.a.$readdir(i)}catch(r){return S.e(r)}},async createDirectory(i){try{const r=u.b.get(i.scheme);return r&&!r.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(r.impl,r.extUri,i)):await u.a.$mkdir(i)}catch(r){return S.e(r)}},async readFile(i){try{const r=u.b.get(i.scheme);return r?(await u.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await u.a.$readFile(i)).buffer}catch(r){return S.e(r)}},async writeFile(i,r){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(t.impl,t.extUri,t.extUri.dirname(i)),await u.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await u.a.$writeFile(i,O.$Me.wrap(r))}catch(t){return S.e(t)}},async delete(i,r){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await u.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await u.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return S.e(t)}},async rename(i,r,t){try{return await u.a.$rename(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,r,t){try{return await u.a.$copy(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const r=c.getCapabilities(i);if(typeof r=="number")return!(r&I.FileSystemProviderCapabilities.Readonly)}})}async d(o,c,u){const i=[];for(;!c.isEqual(u,c.dirname(u));)try{if(!((await o.stat(u)).type&I.FileType.Directory))throw P.$ZO.FileExists(`Unable to create folder '${u.scheme===a.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(I.$ol(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(c.basename(u)),u=c.dirname(u)}for(let r=i.length-1;r>=0;r--){u=c.joinPath(u,i[r]);try{await o.createDirectory(u)}catch(t){if(I.$ol(t)!==I.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof P.$ZO)throw o;if(o instanceof I.$kl)switch(o.code){case I.FileSystemProviderErrorCode.FileExists:throw P.$ZO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw P.$ZO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ZO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ZO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw P.$ZO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw P.$ZO.Unavailable(o.message);default:throw new P.$ZO(o.message,o.name)}if(!(o instanceof Error))throw new P.$ZO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$ZO.Unavailable(o.message);switch(o.name){case I.FileSystemProviderErrorCode.FileExists:throw P.$ZO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw P.$ZO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ZO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ZO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw P.$ZO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw P.$ZO.Unavailable(o.message);default:throw new P.$ZO(o.message,o.name)}}addFileSystemProvider(o,c,u){return this.b.set(o,{impl:c,extUri:u?.isCaseSensitive?y.$7g:y.$9g,isReadonly:!!u?.isReadonly}),(0,s.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$7g}};e.$vpc=d,e.$vpc=d=S=Ge([Ve(0,T.$eQ),Ve(1,$.$_oc)],d),e.$wpc=(0,A.$Di)("IExtHostConsumerFileSystem")}),define(Oe[91],Ne([1,0,3,26,11,68,2]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,e.$xpc=(0,v.$Di)("IExtensionStoragePaths");let T=class{constructor(s,R,y){this.d=R,this.f=y,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(s){return A.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,R=await this.g(s);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(s){if(this.c)return A.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return A.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ypc=T,e.$ypc=T=Ge([Ve(0,I.$uQ),Ve(1,P.$$j),Ve(2,O.$wpc)],T)}),define(Oe[230],Ne([1,0,7,16,6]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;let O=class{constructor(T){this.a=new v.$0O(v.ColorThemeKind.Dark),this.b=new P.$ke}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$0O($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$8qc=O,e.$8qc=O=Ge([Ve(0,I.$eQ)],O)}),define(Oe[92],Ne([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bGb=e.$aGb=e.TunnelDtoConverter=void 0,O=We(O),a=We(a);class S extends $.$Mw{}var d;(function(o){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=c;function u(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=u})(d||(e.TunnelDtoConverter=d={})),e.$aGb=(0,A.$Di)("IExtHostTunnelService");let n=class extends P.$Tc{constructor(c,u,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.$ke,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(s.$EN.MainThreadTunnelService)}async openTunnel(c,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const i=await this.a.$openTunnel(u,c.displayName);if(i){const r=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,u){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:u}),this.a.$registerPortsAttributesProvider(c,i),new a.$GN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,u,i,r,t){const g=[];for(const m of c){const p=this.r.get(m);if(!p)return[];g.push(...await Promise.all(u.map(async h=>{let E;try{E=await p.provider.providePortAttributes({port:h,pid:i,commandLine:r},t)}catch{E=await p.provider.providePortAttributes(h,i,r,t)}return{providedAttributes:E,port:h}})))}const l=g.filter(m=>!!m.providedAttributes);return l.length>0?l.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,u){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await c.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions,protocol:u.tunnelFeatures.protocol===void 0?!0:u.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,u){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(u?this.w(u):void 0);if(i){this.b=i;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(10766,null),themeIcon:"lock"},{id:"public",label:O.localize(10767,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,u){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(u&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const u=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),i=c.filter((r,t)=>u[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$bGb=n,e.$bGb=n=Ge([Ve(0,y.$eQ),Ve(1,R.$uQ),Ve(2,T.$$j)],n)}),define(Oe[8],Ne([1,0,17,22,151,231,59,28,138,40,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p,h,E,D,b,k,C,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$bQ=ae,e.$cQ=oe,e.$dQ=ke,A=We(A),u=We(u),i=We(i),r=We(r),E=We(E),b=We(b),w=We(w);var F;(function(ye){function Re(G){const{selectionStartLineNumber:Ce,selectionStartColumn:Be,positionLineNumber:Ye,positionColumn:He}=G,lt=new w.$HN(Ce-1,Be-1),Pt=new w.$HN(Ye-1,He-1);return new w.$JN(lt,Pt)}ye.to=Re;function le(G){const{anchor:Ce,active:Be}=G;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}ye.from=le})(F||(e.Selection=F={}));var N;(function(ye){function Re(G){if(!G)return;const{start:Ce,end:Be}=G;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}ye.from=Re;function le(G){if(!G)return;const{startLineNumber:Ce,startColumn:Be,endLineNumber:Ye,endColumn:He}=G;return new w.$IN(Ce-1,Be-1,Ye-1,He-1)}ye.to=le})(N||(e.Range=N={}));var L;(function(ye){function Re(G){return{uri:G.uri,range:N.from(G.range)}}ye.from=Re;function le(G){return new w.$UN(o.URI.revive(G.uri),N.to(G.range))}ye.to=le})(L||(e.Location=L={}));var W;(function(ye){function Re(le){switch(le){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}ye.to=Re})(W||(e.TokenType=W={}));var J;(function(ye){function Re(G){return new w.$HN(G.lineNumber-1,G.column-1)}ye.to=Re;function le(G){return{lineNumber:G.line+1,column:G.character+1}}ye.from=le})(J||(e.Position=J={}));var M;(function(ye){function Re(Ce,Be,Ye){return(0,v.$Gb)((0,v.$1b)(Ce).map(He=>le(He,Be,Ye)))}ye.from=Re;function le(Ce,Be,Ye){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Ye?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:G(Ce.scheme,Be),pattern:xe.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Ye?.isBuiltin}}function G(Ce,Be){return Be&&typeof Ce=="string"?Be.transformOutgoingScheme(Ce):Ce}})(M||(e.DocumentSelector=M={}));var K;(function(ye){function Re(G){switch(G){case w.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}ye.from=Re;function le(G){switch(G){case g.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}ye.to=le})(K||(e.DiagnosticTag=K={}));var Z;(function(ye){function Re(G){let Ce;return G.code&&((0,n.$dg)(G.code)||(0,n.$hg)(G.code)?Ce=String(G.code):Ce={value:String(G.code.value),target:G.code.target}),{...N.from(G.range),message:G.message,source:G.source,code:Ce,severity:_.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(ue.from),tags:Array.isArray(G.tags)?(0,v.$Gb)(G.tags.map(K.from)):void 0}}ye.from=Re;function le(G){const Ce=new w.$WN(N.to(G),G.message,_.to(G.severity));return Ce.source=G.source,Ce.code=(0,n.$dg)(G.code)?G.code:G.code?.value,Ce.relatedInformation=G.relatedInformation&&G.relatedInformation.map(ue.to),Ce.tags=G.tags&&(0,v.$Gb)(G.tags.map(K.to)),Ce}ye.to=le})(Z||(e.Diagnostic=Z={}));var ue;(function(ye){function Re(G){return{...N.from(G.location.range),message:G.message,resource:G.location.uri}}ye.from=Re;function le(G){return new w.$VN(new w.$UN(G.resource,N.to(G)),G.message)}ye.to=le})(ue||(e.DiagnosticRelatedInformation=ue={}));var _;(function(ye){function Re(G){switch(G){case w.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ye.from=Re;function le(G){switch(G){case g.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var ge;(function(ye){function Re(G){return typeof G=="number"&&G>=w.ViewColumn.One?G-1:G===w.ViewColumn.Beside?f.$xE:f.$wE}ye.from=Re;function le(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(ge||(e.ViewColumn=ge={}));function se(ye){return typeof ye.range<"u"}function ae(ye){return ye.length===0?!0:!!se(ye[0])}var $e;(function(ye){function Re(He){return He.map(ye.from)}ye.fromMany=Re;function le(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let lt;if(le(He)){const{language:zt,value:Xt}=He;lt={value:"```"+zt+`
`+Xt+"\n```\n"}}else w.$$N.isMarkdownString(He)?lt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?lt={value:He}:lt={value:""};const Pt=Object.create(null);lt.uris=Pt;const Jt=zt=>{try{let Xt=o.URI.parse(zt,!0);Xt=Xt.with({query:Ce(Xt.query,Pt)}),Pt[zt]=Xt}catch{}return""},ni=new $.marked.Renderer;return ni.link=Jt,ni.image=zt=>typeof zt=="string"?Jt(A.$0k(zt).href):"",(0,$.marked)(lt.value,{renderer:ni}),lt}ye.from=G;function Ce(He,lt){if(!He)return He;let Pt;try{Pt=(0,s.$_h)(He)}catch{}if(!Pt)return He;let Jt=!1;return Pt=(0,y.$eo)(Pt,ni=>{if(o.URI.isUri(ni)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[zt]=ni,Jt=!0,zt}else return}),Jt?JSON.stringify(Pt):He}function Be(He){const lt=new w.$$N(He.value,He.supportThemeIcons);return lt.isTrusted=He.isTrusted,lt.supportHtml=He.supportHtml,lt.baseUri=He.baseUri?o.URI.from(He.baseUri):void 0,lt}ye.to=Be;function Ye(He){if(He)return typeof He=="string"?He:ye.from(He)}ye.fromStrict=Ye})($e||(e.MarkdownString=$e={}));function oe(ye){return ae(ye)?ye.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?$e.fromMany(Re.hoverMessage):Re.hoverMessage?$e.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ye.map(Re=>({range:N.from(Re)}))}function ke(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Le;(function(ye){function Re(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?ke(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Re})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var Y;(function(ye){function Re(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?ke(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Re})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(ye){function Re(le){if(typeof le>"u")return le;switch(le){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Re})(q||(e.DecorationRangeBehavior=q={}));var te;(function(ye){function Re(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?q.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?Y.from(le.light):void 0,dark:le.dark?Y.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?ke(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Le.from(le.before):void 0,after:le.after?Le.from(le.after):void 0}}ye.from=Re})(te||(e.DecorationRenderOptions=te={}));var ve;(function(ye){function Re(G){return{text:G.newText,eol:G.newEol&&je.from(G.newEol),range:N.from(G.range)}}ye.from=Re;function le(G){const Ce=new w.$PN(N.to(G.range),G.text);return Ce.newEol=typeof G.eol>"u"?void 0:je.to(G.eol),Ce}ye.to=le})(ve||(e.TextEdit=ve={}));var ce;(function(ye){function Re(G,Ce){const Be={edits:[]};if(G instanceof w.$SN){const Ye=new T.$Ac;for(const He of G._allEntries())He._type===w.FileEditType.File&&o.URI.isUri(He.to)&&He.from===void 0&&Ye.add(He.to);for(const He of G._allEntries())if(He._type===w.FileEditType.File){let lt;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?lt={type:"base64",value:(0,I.$7e)(I.$Me.wrap(He.options.contents))}:lt={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:lt},metadata:He.metadata})}else He._type===w.FileEditType.Text?Be.edits.push({resource:He.uri,textEdit:ve.from(He.edit),versionId:Ye.has(He.uri)?void 0:Ce?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===w.FileEditType.Snippet?Be.edits.push({resource:He.uri,textEdit:{range:N.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ye.has(He.uri)?void 0:Ce?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===w.FileEditType.Cell?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(He.uri)}):He._type===w.FileEditType.CellReplace&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:b.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(Ze.from)}})}return Be}ye.from=Re;function le(G){const Ce=new w.$SN,Be=new T.$zc;for(const Ye of G.edits)if(Ye.textEdit){const He=Ye,lt=o.URI.revive(He.resource),Pt=N.to(He.textEdit.range),Jt=He.textEdit.text,ni=He.textEdit.insertAsSnippet;let zt;ni?zt=w.$RN.replace(Pt,new w.$TN(Jt)):zt=w.$PN.replace(Pt,Jt);const Xt=Be.get(lt);Xt?Xt.push(zt):Be.set(lt,[zt])}else Ce.renameFile(o.URI.revive(Ye.oldResource),o.URI.revive(Ye.newResource),Ye.options);for(const[Ye,He]of Be)Ce.set(Ye,He);return Ce}ye.to=le})(ce||(e.WorkspaceEdit=ce={}));var we;(function(ye){const Re=Object.create(null);Re[w.SymbolKind.File]=r.SymbolKind.File,Re[w.SymbolKind.Module]=r.SymbolKind.Module,Re[w.SymbolKind.Namespace]=r.SymbolKind.Namespace,Re[w.SymbolKind.Package]=r.SymbolKind.Package,Re[w.SymbolKind.Class]=r.SymbolKind.Class,Re[w.SymbolKind.Method]=r.SymbolKind.Method,Re[w.SymbolKind.Property]=r.SymbolKind.Property,Re[w.SymbolKind.Field]=r.SymbolKind.Field,Re[w.SymbolKind.Constructor]=r.SymbolKind.Constructor,Re[w.SymbolKind.Enum]=r.SymbolKind.Enum,Re[w.SymbolKind.Interface]=r.SymbolKind.Interface,Re[w.SymbolKind.Function]=r.SymbolKind.Function,Re[w.SymbolKind.Variable]=r.SymbolKind.Variable,Re[w.SymbolKind.Constant]=r.SymbolKind.Constant,Re[w.SymbolKind.String]=r.SymbolKind.String,Re[w.SymbolKind.Number]=r.SymbolKind.Number,Re[w.SymbolKind.Boolean]=r.SymbolKind.Boolean,Re[w.SymbolKind.Array]=r.SymbolKind.Array,Re[w.SymbolKind.Object]=r.SymbolKind.Object,Re[w.SymbolKind.Key]=r.SymbolKind.Key,Re[w.SymbolKind.Null]=r.SymbolKind.Null,Re[w.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Re[w.SymbolKind.Struct]=r.SymbolKind.Struct,Re[w.SymbolKind.Event]=r.SymbolKind.Event,Re[w.SymbolKind.Operator]=r.SymbolKind.Operator,Re[w.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ce){return typeof Re[Ce]=="number"?Re[Ce]:r.SymbolKind.Property}ye.from=le;function G(Ce){for(const Be in Re)if(Re[Be]===Ce)return Number(Be);return w.SymbolKind.Property}ye.to=G})(we||(e.SymbolKind=we={}));var he;(function(ye){function Re(G){switch(G){case w.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Re;function le(G){switch(G){case r.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}ye.to=le})(he||(e.SymbolTag=he={}));var X;(function(ye){function Re(G){return{name:G.name,kind:we.from(G.kind),tags:G.tags&&G.tags.map(he.from),containerName:G.containerName,location:Ue.from(G.location)}}ye.from=Re;function le(G){const Ce=new w.$2N(G.name,we.to(G.kind),G.containerName,Ue.to(G.location));return Ce.tags=G.tags&&G.tags.map(he.to),Ce}ye.to=le})(X||(e.WorkspaceSymbol=X={}));var x;(function(ye){function Re(G){const Ce={name:G.name||"!!MISSING: name!!",detail:G.detail,range:N.from(G.range),selectionRange:N.from(G.selectionRange),kind:we.from(G.kind),tags:G.tags?.map(he.from)??[]};return G.children&&(Ce.children=G.children.map(Re)),Ce}ye.from=Re;function le(G){const Ce=new w.$3N(G.name,G.detail,we.to(G.kind),N.to(G.range),N.to(G.selectionRange));return(0,v.$Kb)(G.tags)&&(Ce.tags=G.tags.map(he.to)),G.children&&(Ce.children=G.children.map(le)),Ce}ye.to=le})(x||(e.DocumentSymbol=x={}));var me;(function(ye){function Re(G){const Ce=new w.$7N(we.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),N.to(G.range),N.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ye.to=Re;function le(G,Ce,Be){if(Ce=Ce??G._sessionId,Be=Be??G._itemId,Ce===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Be,name:G.name,detail:G.detail,kind:we.from(G.kind),uri:G.uri,range:N.from(G.range),selectionRange:N.from(G.selectionRange),tags:G.tags?.map(he.from)}}ye.from=le})(me||(e.CallHierarchyItem=me={}));var pe;(function(ye){function Re(le){return new w.$8N(me.to(le.from),le.fromRanges.map(G=>N.to(G)))}ye.to=Re})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(ye){function Re(le){return new w.$9N(me.to(le.to),le.fromRanges.map(G=>N.to(G)))}ye.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Ue;(function(ye){function Re(G){return{range:G.range&&N.from(G.range),uri:G.uri}}ye.from=Re;function le(G){return new w.$UN(o.URI.revive(G.uri),N.to(G.range))}ye.to=le})(Ue||(e.location=Ue={}));var Se;(function(ye){function Re(G){const Ce=G,Be=G;return{originSelectionRange:Ce.originSelectionRange?N.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Be.uri,range:N.from(Ce.targetRange?Ce.targetRange:Be.range),targetSelectionRange:Ce.targetSelectionRange?N.from(Ce.targetSelectionRange):void 0}}ye.from=Re;function le(G){return{targetUri:o.URI.revive(G.uri),targetRange:N.to(G.range),targetSelectionRange:G.targetSelectionRange?N.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?N.to(G.originSelectionRange):void 0}}ye.to=le})(Se||(e.DefinitionLink=Se={}));var Pe;(function(ye){function Re(G){return{range:N.from(G.range),contents:$e.fromMany(G.contents),canIncreaseVerbosity:G.canIncreaseVerbosity,canDecreaseVerbosity:G.canDecreaseVerbosity}}ye.from=Re;function le(G){const Ce=G.contents.map($e.to),Be=N.to(G.range),Ye=G.canIncreaseVerbosity,He=G.canDecreaseVerbosity;return new w.$YN(Ce,Be,Ye,He)}ye.to=le})(Pe||(e.Hover=Pe={}));var Te;(function(ye){function Re(G){return{range:N.from(G.range),expression:G.expression}}ye.from=Re;function le(G){return new w.$TO(N.to(G.range),G.expression)}ye.to=le})(Te||(e.EvaluatableExpression=Te={}));var j;(function(ye){function Re(G){if(G instanceof w.$UO)return{type:"text",range:N.from(G.range),text:G.text};if(G instanceof w.$VO)return{type:"variable",range:N.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof w.$WO)return{type:"expression",range:N.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Re;function le(G){switch(G.type){case"text":return{range:N.to(G.range),text:G.text};case"variable":return{range:N.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:N.to(G.range),expression:G.expression}}}ye.to=le})(j||(e.InlineValue=j={}));var B;(function(ye){function Re(G){return{frameId:G.frameId,stoppedLocation:N.from(G.stoppedLocation)}}ye.from=Re;function le(G){return new w.$XO(G.frameId,N.to(G.stoppedLocation))}ye.to=le})(B||(e.InlineValueContext=B={}));var H;(function(ye){function Re(G){return{range:N.from(G.range),kind:G.kind}}ye.from=Re;function le(G){return new w.$ZN(N.to(G.range),G.kind)}ye.to=le})(H||(e.DocumentHighlight=H={}));var V;(function(ye){function Re(G){return{uri:G.uri,highlights:G.highlights.map(H.from)}}ye.from=Re;function le(G){return new w.$1N(o.URI.revive(G.uri),G.highlights.map(H.to))}ye.to=le})(V||(e.MultiDocumentHighlight=V={}));var ne;(function(ye){function Re(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}ye.to=Re})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ye){function Re(le){return{triggerKind:ne.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Re})(fe||(e.CompletionContext=fe={}));var Ie;(function(ye){function Re(G){switch(G){case w.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Re;function le(G){switch(G){case r.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}ye.to=le})(Ie||(e.CompletionItemTag=Ie={}));var ze;(function(ye){const Re=new Map([[w.CompletionItemKind.Method,r.CompletionItemKind.Method],[w.CompletionItemKind.Function,r.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,r.CompletionItemKind.Field],[w.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[w.CompletionItemKind.Class,r.CompletionItemKind.Class],[w.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[w.CompletionItemKind.Module,r.CompletionItemKind.Module],[w.CompletionItemKind.Property,r.CompletionItemKind.Property],[w.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[w.CompletionItemKind.Value,r.CompletionItemKind.Value],[w.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,r.CompletionItemKind.Text],[w.CompletionItemKind.Color,r.CompletionItemKind.Color],[w.CompletionItemKind.File,r.CompletionItemKind.File],[w.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[w.CompletionItemKind.Event,r.CompletionItemKind.Event],[w.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[w.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(Be){return Re.get(Be)??r.CompletionItemKind.Property}ye.from=le;const G=new Map([[r.CompletionItemKind.Method,w.CompletionItemKind.Method],[r.CompletionItemKind.Function,w.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,w.CompletionItemKind.Field],[r.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[r.CompletionItemKind.Class,w.CompletionItemKind.Class],[r.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[r.CompletionItemKind.Module,w.CompletionItemKind.Module],[r.CompletionItemKind.Property,w.CompletionItemKind.Property],[r.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[r.CompletionItemKind.Value,w.CompletionItemKind.Value],[r.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,w.CompletionItemKind.Text],[r.CompletionItemKind.Color,w.CompletionItemKind.Color],[r.CompletionItemKind.File,w.CompletionItemKind.File],[r.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[r.CompletionItemKind.Event,w.CompletionItemKind.Event],[r.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,w.CompletionItemKind.User],[r.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Ce(Be){return G.get(Be)??w.CompletionItemKind.Property}ye.to=Ce})(ze||(e.CompletionItemKind=ze={}));var Qe;(function(ye){function Re(le,G){const Ce=new w.$eO(le.label);return Ce.insertText=le.insertText,Ce.kind=ze.to(le.kind),Ce.tags=le.tags?.map(Ie.to),Ce.detail=le.detail,Ce.documentation=A.$4k(le.documentation)?$e.to(le.documentation):le.documentation,Ce.sortText=le.sortText,Ce.filterText=le.filterText,Ce.preselect=le.preselect,Ce.commitCharacters=le.commitCharacters,u.$Mt.isIRange(le.range)?Ce.range=N.to(le.range):typeof le.range=="object"&&(Ce.range={inserting:N.to(le.range.insert),replacing:N.to(le.range.replace)}),Ce.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ce.insertText=new w.$TN(le.insertText):(Ce.insertText=le.insertText,Ce.textEdit=Ce.range instanceof w.$IN?new w.$PN(Ce.range,Ce.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ce.additionalTextEdits=le.additionalTextEdits.map(Be=>ve.to(Be))),Ce.command=G&&le.command?G.fromInternal(le.command):void 0,Ce}ye.to=Re})(Qe||(e.CompletionItem=Qe={}));var _e;(function(ye){function Re(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:$e.fromStrict(G.documentation)}}ye.from=Re;function le(G){return{label:G.label,documentation:A.$4k(G.documentation)?$e.to(G.documentation):G.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Re(G){return{label:G.label,documentation:$e.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(_e.from):[],activeParameter:G.activeParameter}}ye.from=Re;function le(G){return{label:G.label,documentation:A.$4k(G.documentation)?$e.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(_e.to):[],activeParameter:G.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Re(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.from):[]}}ye.from=Re;function le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Re(le,G){const Ce=new w.$dO(J.to(G.position),typeof G.label=="string"?G.label:G.label.map(rt.to.bind(void 0,le)),G.kind&&mt.to(G.kind));return Ce.textEdits=G.textEdits&&G.textEdits.map(ve.to),Ce.tooltip=A.$4k(G.tooltip)?$e.to(G.tooltip):G.tooltip,Ce.paddingLeft=G.paddingLeft,Ce.paddingRight=G.paddingRight,Ce}ye.to=Re})(et||(e.InlayHint=et={}));var rt;(function(ye){function Re(le,G){const Ce=new w.$cO(G.label);return Ce.tooltip=A.$4k(G.tooltip)?$e.to(G.tooltip):G.tooltip,r.Command.is(G.command)&&(Ce.command=le.fromInternal(G.command)),G.location&&(Ce.location=Ue.to(G.location)),Ce}ye.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var mt;(function(ye){function Re(G){return G}ye.from=Re;function le(G){return G}ye.to=le})(mt||(e.InlayHintKind=mt={}));var ut;(function(ye){function Re(G){return{range:N.from(G.range),url:G.target,tooltip:G.tooltip}}ye.from=Re;function le(G){let Ce;if(G.url)try{Ce=typeof G.url=="string"?o.URI.parse(G.url,!0):o.URI.revive(G.url)}catch{}const Be=new w.$jO(N.to(G.range),Ce);return Be.tooltip=G.tooltip,Be}ye.to=le})(ut||(e.DocumentLink=ut={}));var st;(function(ye){function Re(G){const Ce=new w.$mO(G.label);return G.textEdit&&(Ce.textEdit=ve.to(G.textEdit)),G.additionalTextEdits&&(Ce.additionalTextEdits=G.additionalTextEdits.map(Be=>ve.to(Be))),Ce}ye.to=Re;function le(G){return{label:G.label,textEdit:G.textEdit?ve.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ce=>ve.from(Ce)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ct;(function(ye){function Re(G){return new w.$kO(G[0],G[1],G[2],G[3])}ye.to=Re;function le(G){return[G.red,G.green,G.blue,G.alpha]}ye.from=le})(ct||(e.Color=ct={}));var ft;(function(ye){function Re(G){return{range:N.from(G.range)}}ye.from=Re;function le(G){return new w.$6N(N.to(G.range))}ye.to=le})(ft||(e.SelectionRange=ft={}));var pt;(function(ye){function Re(le){switch(le){case p.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case p.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case p.SaveReason.FOCUS_CHANGE:case p.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}ye.to=Re})(pt||(e.TextDocumentSaveReason=pt={}));var qe;(function(ye){function Re(G){switch(G){case w.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}ye.from=Re;function le(G){switch(G){case c.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}ye.to=le})(qe||(e.TextEditorLineNumbersStyle=qe={}));var je;(function(ye){function Re(G){if(G===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(G===w.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Re;function le(G){if(G===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(G===t.EndOfLineSequence.LF)return w.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var ee;(function(ye){function Re(le){if(typeof le=="object")return le.viewId;switch(le){case w.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case w.ProgressLocation.Window:return l.ProgressLocation.Window;case w.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Re})(ee||(e.ProgressLocation=ee={}));var Q;(function(ye){function Re(G){const Ce={start:G.start+1,end:G.end+1};return G.kind&&(Ce.kind=Ee.from(G.kind)),Ce}ye.from=Re;function le(G){const Ce={start:G.start-1,end:G.end-1};return G.kind&&(Ce.kind=Ee.to(G.kind)),Ce}ye.to=le})(Q||(e.FoldingRange=Q={}));var Ee;(function(ye){function Re(G){if(G)switch(G){case w.FoldingRangeKind.Comment:return r.$Nu.Comment;case w.FoldingRangeKind.Imports:return r.$Nu.Imports;case w.FoldingRangeKind.Region:return r.$Nu.Region}}ye.from=Re;function le(G){if(G)switch(G.value){case r.$Nu.Comment.value:return w.FoldingRangeKind.Comment;case r.$Nu.Imports.value:return w.FoldingRangeKind.Imports;case r.$Nu.Region.value:return w.FoldingRangeKind.Region}}ye.to=le})(Ee||(e.FoldingRangeKind=Ee={}));var Je;(function(ye){function Re(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?N.from(le.selection):void 0,override:typeof le.override=="boolean"?p.$3F.id:void 0}}ye.from=Re})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Re(Be){return Be instanceof w.$HO?Be.toJSON():typeof Be=="string"?Be:le(Be)||G(Be)?new w.$HO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}ye.from=Re;function le(Be){const Ye=Be;return Ye?o.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function G(Be){const Ye=Be;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ce(Be){return typeof Be=="string"?Be:new w.$HO(o.URI.revive(Be.baseUri),Be.pattern)}ye.to=Ce})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Re(le){if(le){if(Array.isArray(le))return le.map(Re);if(typeof le=="string")return le;{const G=le;return{language:G.language,scheme:G.scheme,pattern:xe.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ye.from=Re})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Re(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Ce=>Array.isArray(Ce)&&Ce.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&o.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ye=>Ye instanceof w.$IN)))}ye.is=Re;function le(G){return{documents:G.documents.map(Ce=>Ce.map(Be=>({uri:o.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ye=>N.from(Ye))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Nt;(function(ye){function Re(G){return{start:G.start,end:G.end}}ye.from=Re;function le(G){return new w.$$O(G.start,G.end)}ye.to=le})(Nt||(e.NotebookRange=Nt={}));var Wt;(function(ye){function Re(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ye.to=Re;function le(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ye.from=le})(Wt||(e.NotebookCellExecutionSummary=Wt={}));var si;(function(ye){function Re(le){if(le===b.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(le===b.NotebookCellExecutionState.Pending)return;if(le===b.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Re})(si||(e.NotebookCellExecutionState=si={}));var Yt;(function(ye){function Re(G){switch(G){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Re;function le(G){switch(G){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}ye.to=le})(Yt||(e.NotebookCellKind=Yt={}));var hi;(function(ye){function Re(G){const Ce={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)w.$_O.validate(Be),Ce.cells.push(Ze.from(Be));return Ce}ye.from=Re;function le(G){const Ce=new w.$aP(G.cells.map(Ze.to));return(0,n.$qg)(G.metadata)||(Ce.metadata=G.metadata),Ce}ye.to=le})(hi||(e.NotebookData=hi={}));var Ze;(function(ye){function Re(G){return{cellKind:Yt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Wt.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ht.from):[]}}ye.from=Re;function le(G){return new w.$_O(Yt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ht.to):void 0,G.metadata,G.internalMetadata?Wt.to(G.internalMetadata):void 0)}ye.to=le})(Ze||(e.NotebookCellData=Ze={}));var Vt;(function(ye){function Re(G){return{mime:G.mime,valueBytes:I.$Me.wrap(G.data)}}ye.from=Re;function le(G){return new w.$bP(G.valueBytes.buffer,G.mime)}ye.to=le})(Vt||(e.NotebookCellOutputItem=Vt={}));var Ht;(function(ye){function Re(G){return{outputId:G.id,items:G.items.map(Vt.from),metadata:G.metadata}}ye.from=Re;function le(G){const Ce=G.items.map(Vt.to);return new w.$cP(Ce,G.outputId,G.metadata)}ye.to=le})(Ht||(e.NotebookCellOutput=Ht={}));var gt;(function(ye){function Re(Ce){return G(Ce)?{include:xe.from(Ce.include)??void 0,exclude:xe.from(Ce.exclude)??void 0}:xe.from(Ce)??void 0}ye.from=Re;function le(Ce){return G(Ce)?{include:xe.to(Ce.include),exclude:xe.to(Ce.exclude)}:xe.to(Ce)}ye.to=le;function G(Ce){const Be=Ce;return Be?!(0,n.$mg)(Be.include)&&!(0,n.$mg)(Be.exclude):!1}})(gt||(e.NotebookExclusiveDocumentPattern=gt={}));var St;(function(ye){function Re(le,G,Ce){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===w.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:G.toInternal(Be,Ce),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Re})(St||(e.NotebookStatusBarItem=St={}));var xt;(function(ye){function Re(le,G,Ce){const Be=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:G.toInternal(Be,Ce),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Re})(xt||(e.NotebookKernelSourceAction=xt={}));var _t;(function(ye){function Re(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Re})(_t||(e.NotebookDocumentContentOptions=_t={}));var jt;(function(ye){function Re(G){return{uri:G.uri,provides:G.provides}}ye.from=Re;function le(G){return new w.$eP(o.URI.revive(G.uri),G.provides)}ye.to=le})(jt||(e.NotebookRendererScript=jt={}));var wt;(function(ye){function Re(G){return{message:$e.fromStrict(G.message)||"",type:C.TestMessageType.Error,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:N.from(G.location.range),uri:G.location.uri},stackTrace:G.stackTrace?.map(Ce=>({label:Ce.label,position:Ce.position&&J.from(Ce.position),uri:Ce.file&&o.URI.revive(Ce.file).toJSON()}))}}ye.from=Re;function le(G){const Ce=new w.$kP(typeof G.message=="string"?G.message:$e.to(G.message));return Ce.actualOutput=G.actual,Ce.expectedOutput=G.expected,Ce.contextValue=G.contextValue,Ce.location=G.location?Ue.to(G.location):void 0,Ce}ye.to=le})(wt||(e.TestMessage=wt={}));var Rt;(function(ye){ye.namespace=C.$9I,ye.denamespace=C.$0I})(Rt||(e.TestTag=Rt={}));var ci;(function(ye){function Re(G){const Ce=(0,m.$aQ)(G).controllerId;return{extId:k.$4I.fromExtHostTestItem(G,Ce).toString(),label:G.label,uri:o.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Rt.namespace(Ce,Be.id)),range:u.$Mt.lift(N.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&$e.fromStrict(G.error)||null}}ye.from=Re;function le(G){return{parent:void 0,error:void 0,id:k.$4I.fromString(G.extId).localId,label:G.label,uri:o.URI.revive(G.uri),tags:(G.tags||[]).map(Ce=>{const{tagId:Be}=Rt.denamespace(Ce);return new w.$lP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ye.toPlain=le})(ci||(e.TestItem=ci={})),function(ye){function Re(G){return{id:G.id}}ye.from=Re;function le(G){return new w.$lP(G.id)}ye.to=le}(Rt||(e.TestTag=Rt={}));var Qt;(function(ye){const Re=(G,Ce)=>{const Be=G.value;if(!Be)return;const Ye={...ci.toPlain(Be.item),parent:Ce,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(lt=>lt.type===C.TestMessageType.Error).map(wt.to)})),children:[]};if(G.children)for(const He of G.children.values()){const lt=Re(He,Ye);lt&&Ye.children.push(lt)}return Ye};function le(G){const Ce=new a.$3I;for(const He of G.items)Ce.insert(k.$4I.fromString(He.item.extId).path,He);const Be=[Ce.nodes],Ye=[];for(;Be.length;)for(const He of Be.pop())He.value?Ye.push(He):He.children&&Be.push(He.children.values());return{completedAt:G.completedAt,results:Ye.map(He=>Re(He)).filter(n.$lg)}}ye.to=le})(Qt||(e.TestResults=Qt={}));var Xe;(function(ye){function Re(Be){return{covered:Be.covered,total:Be.total}}function le(Be){return"line"in Be?J.from(Be):N.from(Be)}function G(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:le(Be.location),type:C.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&le(Ye.location),label:Ye.label})):void 0}:{type:C.DetailType.Declaration,name:Be.name,count:Be.executed,location:le(Be.location)}}ye.fromDetails=G;function Ce(Be,Ye,He){return w.$oP(He.statementCoverage),w.$oP(He.branchCoverage),w.$oP(He.declarationCoverage),{id:Ye,uri:He.uri,statement:Re(He.statementCoverage),branch:He.branchCoverage&&Re(He.branchCoverage),declaration:He.declarationCoverage&&Re(He.declarationCoverage),testIds:He instanceof w.$pP&&He.fromTests.length?He.fromTests.map(lt=>k.$4I.fromExtHostTestItem(lt,Be).toString()):void 0}}ye.fromFile=Ce})(Xe||(e.TestCoverage=Xe={}));var ei;(function(ye){function Re(le){switch(le){case r.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}ye.to=Re})(ei||(e.CodeActionTriggerKind=ei={}));var ui;(function(ye){function Re(G){const Ce=new w.$tP(we.to(G.kind),G.name,G.detail||"",o.URI.revive(G.uri),N.to(G.range),N.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ye.to=Re;function le(G,Ce,Be){if(Ce=Ce??G._sessionId,Be=Be??G._itemId,Ce===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Be,kind:we.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:N.from(G.range),selectionRange:N.from(G.selectionRange),tags:G.tags?.map(he.from)}}ye.from=le})(ui||(e.TypeHierarchyItem=ui={}));var di;(function(ye){function Re(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Re})(di||(e.ViewBadge=di={}));var kt;(function(ye){function Re(Be,Ye,He){const lt=Ye.fileData;return lt?new w.$zO(new w.$AO(lt.name,o.URI.revive(lt.uri),lt.id,(0,O.$cb)(()=>He(lt.id)))):Be===R.$9s.uriList&&Ye.uriListData?new w.$yO(Ce(Ye.uriListData)):new w.$yO(Ye.asString)}ye.to=Re;async function le(Be,Ye){const He=await Ye.asString();if(Be===R.$9s.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const lt=Ye.asFile();return{asString:He,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ye.from=le;function G(Be){return P.$ru.split(Be).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return o.URI.parse(Ye)}catch{}return Ye})}function Ce(Be){return P.$ru.create(Be.map(Ye=>typeof Ye=="string"?Ye:o.URI.revive(Ye)))}})(kt||(e.DataTransferItem=kt={}));var Mt;(function(ye){function Re(G,Ce){const Be=G.items.map(([Ye,He])=>[Ye,kt.to(Ye,He,Ce)]);return new w.$BO(Be)}ye.toDataTransfer=Re;async function le(G){const Ce={items:[]},Be=[];for(const[Ye,He]of G)Be.push((async()=>{Ce.items.push([Ye,await kt.from(Ye,He)])})());return await Promise.all(Be),Ce}ye.from=le})(Mt||(e.DataTransfer=Mt={}));var At;(function(ye){function Re(G,Ce){return{kind:"reply",agentId:G.participant??Ce?.agentId??"",subCommand:G.command??Ce?.command,message:G.prompt,title:G.label}}ye.from=Re;function le(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}ye.to=le})(At||(e.ChatFollowup=At={}));var Ft;(function(ye){function Re(G){switch(G){case E.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}ye.to=Re;function le(G){switch(G){case w.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}ye.from=le})(Ft||(e.LanguageModelChatMessageRole=Ft={}));var oi;(function(ye){function Re(G){let Ce="",Be;G.content.type==="text"?Ce=G.content.value:Be=new w.$XP(G.content.name,G.content.value,G.content.isError);const Ye=Ft.to(G.role),He=new w.$YP(Ye,Ce,G.name);return Be!==void 0&&(He.content2=Be),He}ye.to=Re;function le(G){const Ce=Ft.from(G.role),Be=G.name;let Ye;return G.content2 instanceof w.$XP?Ye={type:"function_result",name:G.content2.name,value:G.content2.content,isError:G.content2.isError}:Ye={type:"text",value:G.content},{role:Ce,name:Be,content:Ye}}ye.from=le})(oi||(e.LanguageModelChatMessage=oi={}));var ti;(function(ye){function Re(G){return{kind:"markdownContent",content:$e.from(G.value)}}ye.from=Re;function le(G){return new w.$GP($e.to(G.content))}ye.to=le})(ti||(e.ChatResponseMarkdownPart=ti={}));var ii;(function(ye){function Re(G){return{kind:"markdownVuln",content:$e.from(G.value),vulnerabilities:G.vulnerabilities}}ye.from=Re;function le(G){return new w.$HP($e.to(G.content),G.vulnerabilities)}ye.to=le})(ii||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ii={}));var Bt;(function(ye){function Re(G){return{kind:"agentDetection",agentId:G.participant,command:G.command}}ye.from=Re;function le(G){return new w.$IP(G.agentId,G.command)}ye.to=le})(Bt||(e.ChatResponseDetectedParticipantPart=Bt={}));var qt;(function(ye){function Re(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data,buttons:le.buttons}}ye.from=Re})(qt||(e.ChatResponseConfirmationPart=qt={}));var li;(function(ye){function Re(G){const{value:Ce,baseUri:Be}=G;function Ye(He,lt){return He.map(Pt=>{const Jt=o.URI.joinPath(lt,Pt.name);return{label:Pt.name,uri:Jt,children:Pt.children&&Ye(Pt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$bh)(Be),uri:Be,children:Ye(Ce,Be)}}}ye.from=Re;function le(G){const Ce=(0,s.$ai)(G.treeData);function Be(lt){return lt.map(Pt=>({name:Pt.label,children:Pt.children&&Be(Pt.children)}))}const Ye=Ce.uri,He=Ce.children?Be(Ce.children):[];return new w.$KP(He,Ye)}ye.to=le})(li||(e.ChatResponseFilesPart=li={}));var Tt;(function(ye){function Re(G){const Ce=Be=>o.URI.isUri(Be);return{kind:"inlineReference",name:G.title,inlineReference:Ce(G.value)?G.value:L.from(G.value)}}ye.from=Re;function le(G){const Ce=(0,s.$ai)(G);return new w.$LP(o.URI.isUri(Ce.inlineReference)?Ce.inlineReference:L.to(Ce.inlineReference),G.name)}ye.to=le})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Ct;(function(ye){function Re(G){return{kind:"progressMessage",content:$e.from(G.value)}}ye.from=Re;function le(G){return new w.$MP(G.content.value)}ye.to=le})(Ct||(e.ChatResponseProgressPart=Ct={}));var bt;(function(ye){function Re(G){return{kind:"warning",content:$e.from(G.value)}}ye.from=Re;function le(G){return new w.$OP(G.content.value)}ye.to=le})(bt||(e.ChatResponseWarningPart=bt={}));var Kt;(function(ye){function Re(le){return{kind:"progressTask",content:$e.from(le.value)}}ye.from=Re})(Kt||(e.ChatTask=Kt={}));var yt;(function(ye){function Re(le){return{kind:"progressTaskResult",content:typeof le=="string"?$e.from(le):void 0}}ye.from=Re})(yt||(e.ChatTaskResult=yt={}));var ai;(function(ye){function Re(G,Ce,Be){return{kind:"command",command:Ce.toInternal(G.value,Be)??{command:G.value.command,title:G.value.title}}}ye.from=Re;function le(G,Ce){return new w.$PP(Ce.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}ye.to=le})(ai||(e.ChatResponseCommandButtonPart=ai={}));var Gt;(function(ye){function Re(G){return{kind:"textEdit",uri:G.uri,edits:G.edits.map(Ce=>ve.from(Ce))}}ye.from=Re;function le(G){return new w.$SP(o.URI.revive(G.uri),G.edits.map(Ce=>ve.to(Ce)))}ye.to=le})(Gt||(e.ChatResponseTextEditPart=Gt={}));var Ai;(function(ye){function Re(G){const Ce=d.ThemeIcon.isThemeIcon(G.iconPath)?G.iconPath:o.URI.isUri(G.iconPath)?{light:o.URI.revive(G.iconPath)}:G.iconPath&&"light"in G.iconPath&&"dark"in G.iconPath&&o.URI.isUri(G.iconPath.light)&&o.URI.isUri(G.iconPath.dark)?{light:o.URI.revive(G.iconPath.light),dark:o.URI.revive(G.iconPath.dark)}:void 0;return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:o.URI.isUri(G.value.value)||!G.value.value?G.value.value:L.from(G.value.value)},iconPath:Ce}:{kind:"reference",reference:o.URI.isUri(G.value)?G.value:L.from(G.value),iconPath:Ce}}ye.from=Re;function le(G){const Ce=(0,s.$ai)(G),Be=Ye=>o.URI.isUri(Ye)?Ye:L.to(Ye);return new w.$QP("variableName"in Ce.reference?{variableName:Ce.reference.variableName,value:Ce.reference.value&&Be(Ce.reference.value)}:Be(Ce.reference))}ye.to=le})(Ai||(e.ChatResponseReferencePart=Ai={}));var gi;(function(ye){function Re(le){return{kind:"codeCitation",value:le.value,license:le.license}}ye.from=Re})(gi||(e.ChatResponseCodeCitationPart=gi={}));var Si;(function(ye){function Re(Ce,Be,Ye){return Ce instanceof w.$GP?ti.from(Ce):Ce instanceof w.$LP?Tt.from(Ce):Ce instanceof w.$QP?Ai.from(Ce):Ce instanceof w.$MP?Ct.from(Ce):Ce instanceof w.$KP?li.from(Ce):Ce instanceof w.$PP?ai.from(Ce,Be,Ye):Ce instanceof w.$SP?Gt.from(Ce):Ce instanceof w.$HP?ii.from(Ce):Ce instanceof w.$IP?Bt.from(Ce):Ce instanceof w.$OP?bt.from(Ce):Ce instanceof w.$JP?qt.from(Ce):Ce instanceof w.$RP?gi.from(Ce):{kind:"markdownContent",content:$e.from("")}}ye.from=Re;function le(Ce,Be){switch(Ce.kind){case"reference":return Ai.to(Ce);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(Ce,Be)}}ye.to=le;function G(Ce,Be){switch(Ce.kind){case"markdownContent":return ti.to(Ce);case"inlineReference":return Tt.to(Ce);case"progressMessage":return;case"treeData":return li.to(Ce);case"command":return ai.to(Ce,Be)}}ye.toContent=G})(Si||(e.ChatResponsePart=Si={}));var Ut;(function(ye){function Re(le,G){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(Ni.to),location:fi.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData,location2:G}}ye.to=Re})(Ut||(e.ChatAgentRequest=Ut={}));var fi;(function(ye){function Re(G){switch(G){case h.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}ye.to=Re;function le(G){switch(G){case w.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}ye.from=le})(fi||(e.ChatLocation=fi={}));var Ni;(function(ye){function Re(le){const G=le.value;if(!G)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,o.$uc)(G)?o.URI.revive(G):G&&typeof G=="object"&&"uri"in G&&"range"in G&&(0,o.$uc)(G.uri)?L.to((0,s.$ai)(G)):G,modelDescription:le.modelDescription}}ye.to=Re})(Ni||(e.ChatAgentValueReference=Ni={}));var It;(function(ye){function Re(le,G,Ce){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:G.toInternal(le.command,Ce)}}ye.from=Re})(It||(e.ChatAgentCompletionItem=It={}));var vi;(function(ye){function Re(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Re})(vi||(e.ChatAgentResult=vi={}));var Ti;(function(ye){function Re(le,G,Ce){if(G.action.kind==="vote")return;const Be=vi.to(le);if(G.action.kind==="command"){const Ye=G.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ce.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Be}}else return G.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(G.action.followup)},result:Be}:G.action.kind==="inlineChat"?{action:{kind:"editor",accepted:G.action.action==="accepted"},result:Be}:{action:G.action,result:Be}}ye.to=Re})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var bi;(function(ye){function Re(le,G,Ce){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:G.toInternal(le,Ce)}ye.from=Re})(bi||(e.TerminalQuickFix=bi={}));var Li;(function(ye){function Re(le){return{kind:Mi.to(le.kind)}}ye.to=Re})(Li||(e.PartialAcceptInfo=Li={}));var Mi;(function(ye){function Re(le){switch(le){case r.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}ye.to=Re})(Mi||(e.PartialAcceptTriggerKind=Mi={}));var Lt;(function(ye){function Re(le,G){return{id:G,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Re})(Lt||(e.DebugTreeItem=Lt={}));var ki;(function(ye){function Re(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Re})(ki||(e.LanguageModelToolDescription=ki={}))}),define(Oe[232],Ne([1,0,5,16,8,38]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;let A=class{constructor($,s){this.a=$.getProxy(v.$EN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>s.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,s,R){const y=new O.$Vw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$hpc=A,e.$hpc=A=Ge([Ve(0,I.$eQ)],A)}),define(Oe[233],Ne([1,0,17,10,42,6,39,4,40,69,14,2,18,5,8,7,115,194,24]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0,d=We(d),n=We(n);class i{constructor(l,m,p,h,E){this.j=l,this.k=m,this.l=p,this.m=h,this.n=E,this.b=s.$ee.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(h){if(l.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const l=this;this.b.reset();const p=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),b={report:k=>{D?.then(C=>{C&&(n.$$N.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(k),C):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(k),C))})}};Promise.all([D,E?.(b)]).then(([k,C])=>{k!==void 0&&C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(C),k)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){m(this.markdown);const E=new n.$GP(h),D=d.ChatResponseMarkdownPart.from(E);return p(D),this},markdownWithVulnerabilities(h,E){m(this.markdown),E&&(0,u.$eH)(l.j,"chatParticipantAdditions");const D=new n.$HP(h,E),b=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return p(b),this},filetree(h,E){m(this.filetree);const D=new n.$KP(h,E),b=d.ChatResponseFilesPart.from(D);return p(b),this},anchor(h,E){m(this.anchor);const D=new n.$LP(h,E),b=d.ChatResponseAnchorPart.from(D);return p(b),this},button(h){m(this.anchor);const E=new n.$PP(h),D=d.ChatResponseCommandButtonPart.from(E,l.m,l.n);return p(D),this},progress(h,E){m(this.progress);const D=new n.$NP(h,E),b=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return p(b,E),this},warning(h){m(this.progress),(0,u.$eH)(l.j,"chatParticipantAdditions");const E=new n.$OP(h),D=d.ChatResponseWarningPart.from(E);return p(D),this},reference(h,E){if(m(this.reference),"variableName"in h&&(0,u.$eH)(l.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const D=l.k.variables.variables.find(b=>b.name===h.variableName);if(D){let b;if(D.references?.length)b=D.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new n.$QP(h,E);b=[d.ChatResponseReferencePart.from(k)]}return b.forEach(k=>p(k)),this}}else{const D=new n.$QP(h,E),b=d.ChatResponseReferencePart.from(D);p(b)}return this},codeCitation(h,E){m(this.codeCitation),(0,u.$eH)(l.j,"chatParticipantAdditions");const D=new n.$RP(h,E),b=d.ChatResponseCodeCitationPart.from(D);p(b)},textEdit(h,E){m(this.textEdit),(0,u.$eH)(l.j,"chatParticipantAdditions");const D=new n.$SP(h,E),b=d.ChatResponseTextEditPart.from(D);return p(b),this},detectedParticipant(h,E){m(this.detectedParticipant),(0,u.$eH)(l.j,"chatParticipantAdditions");const D=new n.$IP(h,E),b=d.ChatResponseDetectedParticipantPart.from(D);return p(b),this},confirmation(h,E,D,b){m(this.confirmation),(0,u.$eH)(l.j,"chatParticipantAdditions");const k=new n.$JP(h,E,D,b),C=d.ChatResponseConfirmationPart.from(k);return p(C),this},push(h){if(m(this.push),(h instanceof n.$SP||h instanceof n.$HP||h instanceof n.$IP||h instanceof n.$OP||h instanceof n.$JP||h instanceof n.$RP)&&(0,u.$eH)(l.j,"chatParticipantAdditions"),h instanceof n.$QP)this.reference(h.value,h.iconPath);else{const E=d.ChatResponsePart.from(h,l.m,l.n);p(E)}return this}}}return this.g}}class r extends T.$Tc{static{this.b=0}constructor(l,m,p,h){super(),this.n=m,this.s=p,this.t=h,this.c=new Map,this.j=this.B(new T.$3c),this.m=this.B(new T.$3c),this.g=l.getProxy(S.$EN.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,m,p){const h=r.b++,E=new t(l,m,this.g,h,p);return this.c.set(h,E),this.g.$registerAgent(h,l.identifier,m,{},void 0),E.apiAgent}createDynamicChatAgent(l,m,p,h){const E=r.b++,D=new t(l,m,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,l.identifier,m,{isSticky:!0},p),D.apiAgent}async $invokeAgent(l,m,p,h){const E=this.c.get(l);if(!E)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);const D=(0,$.$ai)(m);let b=this.j.get(D.sessionId);b||(b=new T.$Sc,this.j.set(D.sessionId,b));const k=new i(E.extension,D,this.g,this.s.converter,b);try{const C=await this.u(D.agentId,p);let f;if(D.locationData?.type===o.ChatAgentLocation.Editor){const F=this.t.getDocument(D.locationData.document);f=new n.$VP(F,d.Selection.to(D.locationData.selection),d.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===o.ChatAgentLocation.Notebook){const F=this.t.getDocument(D.locationData.sessionInputUri);f=new n.$WP(F)}else D.locationData?.type,o.ChatAgentLocation.Terminal;const w=E.invoke(d.ChatAgentRequest.to(D,f),{history:C},k.apiObject,h);return await(0,I.$rh)(Promise.resolve(w).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(L){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${W}`,E.extension),{errorDetails:{message:W},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,u.$eH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),h)}catch(C){return this.n.error(C,E.extension),C instanceof n.$5P&&C.cause&&(C=C.cause),{errorDetails:{message:(0,P.$oj)(C),responseIsIncomplete:!0}}}finally{k.close()}}async u(l,m){const p=[];for(const h of m.history){const E=d.ChatAgentResult.to(h.result),D=l===h.request.agentId?E:{...E,metadata:void 0};p.push(new n.$TP(h.request.message,h.request.command,h.request.variables.variables.map(d.ChatAgentValueReference.to),h.request.agentId));const b=(0,v.$Gb)(h.response.map(k=>d.ChatResponsePart.toContent(k,this.s.converter)));p.push(new n.$UP(b,D,h.request.agentId,h.request.command))}return p}$releaseSession(l){this.j.deleteAndDispose(l)}async $provideFollowups(l,m,p,h,E){const D=this.c.get(m);if(!D)return Promise.resolve([]);const b=(0,$.$ai)(l),k=await this.u(D.id,h),C=d.ChatAgentResult.to(p);return(await D.provideFollowups(C,{history:k},E)).filter(f=>{const w=!f.participant||A.Iterable.some(this.c.values(),F=>F.id===f.participant&&a.$pn.equals(F.extension.identifier,D.extension.identifier));return w||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),w}).map(f=>d.ChatFollowup.from(f,b))}$acceptFeedback(l,m,p,h){const E=this.c.get(l);if(!E)return;const D=d.ChatAgentResult.to(m);let b;switch(p){case c.ChatAgentVoteDirection.Down:b=n.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:b=n.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:b,reportIssue:h}:{result:D,kind:b}))}$acceptAction(l,m,p){const h=this.c.get(l);if(!h||p.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to(m,p,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(l,m,p){const h=this.c.get(l);if(!h)return[];let E=this.m.get(l);return E?E.clear():(E=new T.$Sc,this.m.set(l,E)),(await h.invokeCompletionProvider(m,p)).map(b=>d.ChatAgentCompletionItem.from(b,this.s.converter,E))}async $provideWelcomeMessage(l,m,p){const h=this.c.get(l);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to(m),p)}async $provideSampleQuestions(l,m,p){const h=this.c.get(l);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to(m),p)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$ipc=r;class t{constructor(l,m,p,h,E){this.extension=l,this.id=m,this.w=p,this.x=h,this.y=E,this.m=new O.$ke,this.n=new O.$ke}acceptFeedback(l){this.m.fire(l)}acceptAction(l){this.n.fire(l)}async invokeCompletionProvider(l,m){return this.q?await this.q.provider.provideCompletionItems(l,m)??[]:[]}async provideFollowups(l,m,p){if(!this.b)return[];const h=await this.b.provideFollowups(l,m,p);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(l,m){if(!this.s)return[];const p=await this.s.provideWelcomeMessage(l,m);return p?p.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(l,m){if(!this.s||!this.s.provideSampleQuestions)return[];const p=await this.s.provideSampleQuestions(l,m);return p||[]}get apiAgent(){let l=!1,m=!1;const p=()=>{l||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof n.$FO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,p()},get requestHandler(){return h.y},set requestHandler(E){(0,R.$ng)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,p()},get isDefault(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.d=E,p()},get helpTextPrefix(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.g=E,p()},get helpTextVariablesPrefix(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.j=E,p()},get helpTextPostfix(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.k=E,p()},get isSecondary(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.l=E,p()},get supportIssueReporting(){return(0,u.$eH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,u.$eH)(h.extension,"chatParticipantPrivate"),h.o=E,p()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,u.$eH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,u.$eH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,u.$eH)(h.extension,"defaultChatParticipant"),h.s=E,p()},get welcomeMessageProvider(){return(0,u.$eH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,u.$dH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,p()},get requester(){return h.t},set supportsSlowReferences(E){(0,u.$eH)(h.extension,"chatParticipantPrivate"),h.u=E,p()},get supportsSlowReferences(){return(0,u.$eH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){l=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(l,m,p,h){return this.y(l,m,p,h)}}}),define(Oe[234],Ne([1,0,13,4,34,5,8,7,24]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0,A=We(A),T=We(T);class s{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(O.$EN.MainThreadChatVariables)}async $resolveVariable(a,S,d,n){const o=this.b.get(a);if(o)try{if(o.resolver.resolve2){(0,$.$eH)(o.extension,"chatParticipantAdditions");const c=new R(S,this.c),u=await o.resolver.resolve2(o.data.name,{prompt:d},c.apiObject,n);if(u&&u[0])return u[0].value}else{const c=await o.resolver.resolve(o.data.name,{prompt:d},n);if(c&&c[0])return c[0].value}}catch(c){(0,v.$Z)(c)}}registerVariableResolver(a,S,d,n,o,c,u,i,r){const t=s.a++,g=r?P.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:n,modelDescription:o,icon:g},resolver:u}),this.c.$registerVariable(t,{id:S,name:d,description:n,modelDescription:o,isSlow:c,fullName:i,icon:g}),(0,I.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$jpc=s;class R{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(n){if(a.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,n),o}};const a=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){S(this.progress);const o=new T.$MP(n),c=A.ChatResponseProgressPart.from(o);return d(c),this},reference(n){S(this.reference);const o=new T.$QP(n),c=A.ChatResponseReferencePart.from(o);return d(c),this},push(n){return S(this.push),n instanceof T.$QP?d(A.ChatResponseReferencePart.from(n)):n instanceof T.$MP&&d(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Oe[235],Ne([1,0,10,71,6,4,36,2,93,18,8,7,5,24]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=d,$=We($),R=We(R),y=We(y);function d(n,o,c){const u=n.getProxy(a.$EN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$rn,o.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===A.MarshalledId.CommentController){const k=this.b.get(b.handle);return k?k.value:b}else if(b&&b.$mid===A.MarshalledId.CommentThread){const k=b,C=this.b.get(k.commentControlHandle);if(!C)return k;const f=C.getCommentThread(k.commentThreadHandle);return f?f.value:k}else if(b&&(b.$mid===A.MarshalledId.CommentThreadReply||b.$mid===A.MarshalledId.CommentThreadInstance)){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);return C?b.$mid===A.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:b.text}:b}else if(b&&b.$mid===A.MarshalledId.CommentNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);if(!C)return b;const f=b.commentUniqueId,w=C.getCommentByUniqueId(f);return w||b}else if(b&&b.$mid===A.MarshalledId.CommentThreadNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);if(!C)return b;const f=b.text,w=b.commentUniqueId,F=C.getCommentByUniqueId(w);return F?(typeof F.body=="string"?F.body=f:F.body=new y.$$N(f),F):b}return b}})}createCommentController(b,k,C){const f=i.a++,w=new t(b,f,k,C);this.b.set(w.handle,w);const F=this.c.get(b.identifier)||[];return F.push(w),this.c.set(b.identifier,F),w.value}async $createCommentThreadTemplate(b,k,C,f){const w=this.b.get(b);w&&w.$createCommentThreadTemplate(k,C,f)}async $setActiveComment(b,k){const C=this.b.get(b);C&&C.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(b,k,C){const f=this.b.get(b);f&&f.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(b,k){this.b.get(b)?.$deleteCommentThread(k)}async $provideCommentingRanges(b,k,C){const f=this.b.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=await c.ensureDocumentData(T.URI.revive(k));return(0,v.$vh)(async()=>{const F=await f.commentingRangeProvider.provideCommentingRanges(w.document,C);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(L=>R.Range.from(L)),fileComments:F.fileComments}),N})}$toggleReaction(b,k,C,f,w){const F=this.b.get(b);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,v.$vh)(()=>{const N=F.getCommentThread(k);if(N){const L=N.getCommentByUniqueId(f.uniqueIdInThread);if(F!==void 0&&L&&F.reactionHandler)return F.reactionHandler(L,m(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,S.$eH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,k,C,f,w,F,N,L,W){this.m=k,this.n=C,this.o=f,this.p=w,this.q=F,this.extensionDescription=N,this.r=L,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$ke,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Uc,this.l.value=new O.$Sc,this.n===void 0&&(this.n=`${b}.${this.handle}`),u.$createCommentThread(k,this.handle,this.n,this.o,R.Range.from(this.p),this.q.map(M=>g(this,M,this.k,this.extensionDescription)),N.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{u.$deleteCommentThread(k,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(M){J.range=M},get comments(){return J.comments},set comments(M){J.comments=M},get collapsibleState(){return J.collapsibleState},set collapsibleState(M){J.collapsibleState=M},get canReply(){return J.canReply},set canReply(M){J.canReply=M},get contextValue(){return J.contextValue},set contextValue(M){J.contextValue=M},get label(){return J.label},set label(M){J.label=M},get state(){return J.state},set state(M){J.state=M},reveal:(M,K)=>J.reveal(M,K),hide:()=>J.hide(),dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Sc);const b=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};b("range")&&(k.range=R.Range.from(this.p)),b("label")&&(k.label=this.label),b("contextValue")&&(k.contextValue=this.contextValue??null),b("comments")&&(k.comments=this.q.map(C=>g(this,C,this.k,this.extensionDescription))),b("collapsibleState")&&(k.collapseState=p(this.g)),b("canReply")&&(k.canReply=this.canReply),b("state")&&(k.state=h(this.h)),b("applicability")&&(k.applicability=E(this.h)),b("isTemplate")&&(k.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(b){for(const k of this.k){const C=k[0],f=k[1];if(b===f)return C}}async reveal(b,k){(0,S.$eH)(this.extensionDescription,"commentReveal");let C;b&&b.body!==void 0?C=b:k=k??b;let f=C?this.k.get(C):void 0;f??=this.k.get(this.q[0]);let w=!0,F=!1;return k?.focus===y.CommentThreadFocus.Reply?(F=!0,w=!1):k?.focus===y.CommentThreadFocus.Comment&&(w=!1),u.$revealCommentThread(this.m,this.handle,f,{preserveFocus:w,focusReply:F})}async hide(){return u.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ge([(0,I.$9h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,S.$eH)(this.h,"commentingRangeHint"),u.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$eH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$eH)(this.h,"activeComment"),this.f}constructor(b,k,C,f){this.h=b,this.i=k,this.j=C,this.k=f,this.a=new Map,u.$registerCommentController(this.handle,C,f,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(F){w.options=F},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(F){w.commentingRangeProvider=F},get reactionHandler(){return w.reactionHandler},set reactionHandler(F){w.reactionHandler=F},get activeCommentThread(){return w.activeCommentThread},createCommentThread(F,N,L){return w.createCommentThread(F,N,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(b,k,C){k===void 0&&(0,S.$eH)(this.h,"fileComments");const f=new r(this.id,this.handle,void 0,b,k,C,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const k=this.a.get(b.commentThreadHandle);k&&(this.e=b.uniqueIdInThread?k.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(b,k,C){const f=new r(this.id,this.handle,void 0,T.URI.revive(b),R.Range.to(k),[],this.h,!0,C);return f.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(b,k){const C=this.a.get(b);C&&(C.range=R.Range.to(k))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function g(D,b,k,C){let f=k.get(b);return f||(f=++D.commentHandle,k.set(b,f)),b.state!==void 0&&(0,S.$eH)(C,"commentsDraftState"),b.reactions?.some(w=>w.reactors!==void 0)&&(0,S.$eH)(C,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:R.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(w=>l(w)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function l(D){return{label:D.label,iconPath:D.iconPath?R.$dQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(b=>b.name):D.reactors}}function m(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(b=>({name:b}))}}function p(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(D){let b;if(typeof D=="object"?b=D.resolved:b=D,b!==void 0)switch(b){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(D){let b;if(typeof D=="object"&&(b=D.applicability),b!==void 0)switch(b){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Oe[236],Ne([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,$=We($),y=We(y),a=We(a);class S{constructor(l,m){this.document=l,this.b=m,this.a=1,this.c=new R.$6oc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,m){await this.f(l).undo(),m||this.disposeBackup()}async redo(l,m){await this.f(l).redo(),m||this.disposeBackup()}disposeEdits(l){for(const m of l)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,A.$eh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const m=this.c.get(l,0);if(!m)throw new Error("No edit found");return m}}class d{constructor(){this.a=new Map}get(l,m){return this.a.get(this.b(l,m))}add(l,m,p){const h=this.b(l,m.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${l} resource:${m.uri}`);const E=new S(m,p);return this.a.set(h,E),E}delete(l,m){const p=this.b(l,m.uri);this.a.delete(p)}b(l,m){return`${l}@@@${m}`}}var n;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(l,m,p){return this.b(l,{type:n.Text,extension:m,provider:p})}addCustomProvider(l,m,p){return this.b(l,{type:n.Custom,extension:m,provider:p})}get(l){return this.a.get(l)}b(l,m){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,m),new a.$GN(()=>this.a.delete(l))}}class c{constructor(l,m,p,h,E){this.d=m,this.f=p,this.g=h,this.h=E,this.b=new o,this.c=new d,this.a=l.getProxy(y.$EN.MainThreadCustomEditors)}registerCustomEditorProvider(l,m,p,h){const E=new P.$Sc;return i(p)?(E.add(this.b.addTextProvider(m,l,p)),this.a.$registerTextEditorProvider((0,s.$Cpc)(l),m,h.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,s.$Apc)(l))):(E.add(this.b.addCustomProvider(m,l,p)),u(p)&&E.add(p.onDidChangeCustomDocument(D=>{const b=this.i(m,D.document.uri);if(r(D)){const k=b.addEdit(D);this.a.$onDidEdit(D.document.uri,m,k,D.label)}else this.a.$onContentChange(D.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$Cpc)(l),m,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,s.$Apc)(l))),a.$GN.from(E,new a.$GN(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(l,m,p,h,E){const D=this.b.get(m);if(!D)throw new Error(`No provider found for '${m}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${m}'`);const b=T.URI.revive(l),k=await D.provider.openCustomDocument(b,{backupId:p,untitledDocumentData:h?.buffer},E);let C;return u(D.provider)&&this.f&&(C=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(m,k,C),{editable:u(D.provider)}}async $disposeCustomDocument(l,m){const p=this.b.get(m);if(!p)throw new Error(`No provider found for '${m}'`);if(p.type!==n.Custom)throw new Error(`Invalid provider type for '${m}'`);const h=T.URI.revive(l),{document:E}=this.i(m,h);this.c.delete(m,E),E.dispose()}async $resolveCustomEditor(l,m,p,h,E,D){const b=this.b.get(p);if(!b)throw new Error(`No provider found for '${p}'`);const k=$.ViewColumn.to(E),C=this.g.createNewWebview(m,h.contentOptions,b.extension),f=this.h.createNewWebviewPanel(m,p,h.title,k,h.options,C,h.active),w=T.URI.revive(l);switch(b.type){case n.Custom:{const{document:F}=this.i(p,w);return b.provider.resolveCustomEditor(F,f,D)}case n.Text:{const F=this.d.getDocument(w);return b.provider.resolveCustomTextEditor(F,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,m,p){this.i(m,l).disposeEdits(p)}async $onMoveCustomEditor(l,m,p){const h=this.b.get(p);if(!h)throw new Error(`No provider found for '${p}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const E=this.h.getWebviewPanel(l);if(!E)throw new Error("No webview found");const D=T.URI.revive(m),b=this.d.getDocument(D);await h.provider.moveCustomTextEditor(b,E,v.CancellationToken.None)}async $undo(l,m,p,h){return this.i(m,l).undo(p,h)}async $redo(l,m,p,h){return this.i(m,l).redo(p,h)}async $revert(l,m,p){const h=this.i(m,l);await this.j(m).revertCustomDocument(h.document,p),h.disposeBackup()}async $onSave(l,m,p){const h=this.i(m,l);await this.j(m).saveCustomDocument(h.document,p),h.disposeBackup()}async $onSaveAs(l,m,p,h){const E=this.i(m,l);return this.j(m).saveCustomDocumentAs(E.document,T.URI.revive(p),h)}async $backup(l,m,p){const h=this.i(m,l),D=await this.j(m).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},p);return h.updateBackup(D),D.id}i(l,m){const p=this.c.get(l,T.URI.revive(m));if(!p)throw new Error("No custom document found");return p}j(l){const p=this.b.get(l)?.provider;if(!p||!u(p))throw new Error("Custom document is not editable");return p}}e.$Fpc=c;function u(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function r(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const l=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,I.$rj)(l)+""}}),define(Oe[237],Ne([1,0,9,107,2,5,7,8,6,11,28,50]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0,T=We(T);class S{#e;#t;#i;constructor(o,c,u,i,r,t,g,l){this.d=o,this.e=c,this.f=u,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,u),this.#i=new R.$zc(m=>t.getComparisonKey(m)),this.#e=g,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,c){if(!o){this.clear();return}this.j();let u=[];if(P.URI.isUri(o)){if(!c){this.delete(o);return}this.#i.set(o,c.slice()),u=[o]}else if(Array.isArray(o)){u=[];let t;o=[...o].sort(S.k);for(const g of o){const[l,m]=g;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,u.push(l),this.#i.set(l,[])),m)this.#i.get(l)?.push(...m);else{const p=this.#i.get(l);p&&(p.length=0)}}}if(this.#t.fire(u),!this.#e)return;const i=[];let r=0;for(const t of u){let g=[];const l=this.#i.get(t);if(l)if(l.length>this.g){g=[];const m=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const h of l)if(h.severity===m[p]&&g.push({...T.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:I.MarkerSeverity.Info,message:(0,v.localize)(10783,null,l.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=l.map(m=>({...T.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,g]),r+=g.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,c){this.j();for(const[u,i]of this)o.call(c,u,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const c=this.#i.get(o);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,c){return o[0].toString()<c[0].toString()?-1:o[0].toString()>c[0].toString()?1:0}}e.$apc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(o){const c=new R.$zc;for(const u of o)c.set(u,u);return{uris:Object.freeze(Array.from(c.values()))}}constructor(o,c,u,i){this.j=c,this.k=u,this.l=i,this.g=new Map,this.h=new $.$oe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=o.getProxy(O.$EN.MainThreadDiagnostics)}createDiagnosticCollection(o,c){const{g:u,f:i,h:r,j:t,k:g,l}=this,m=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,E)}dispose(){i.dispose()}};let p;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,p=c;else if(!u.has(c))p=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do p=c+a.c++;while(u.has(p))}return new class extends S{constructor(){super(c,p,a.e,a.d,E=>l.getDocument(E)?.version,g.extUri,m,r),u.set(p,this)}dispose(){super.dispose(),u.delete(p)}}}getDiagnostics(o){if(o)return this.m(o);{const c=new Map,u=[];for(const i of this.g.values())i.forEach((r,t)=>{let g=c.get(r.toString());typeof g>"u"&&(g=u.length,c.set(r.toString(),g),u.push([r,[]])),u[g][1]=u[g][1].concat(...t)});return u}}m(o){let c=[];for(const u of this.g.values())u.has(o)&&(c=c.concat(u.get(o)));return c}$acceptMarkersChange(o){if(!this.n){const c="_generated_mirror",u=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,u),this.n=u}for(const[c,u]of o)this.n.set(P.URI.revive(c),u.map(T.Diagnostic.to))}};e.$bpc=d,e.$bpc=d=a=Ge([Ve(1,s.$$j),Ve(2,y.$_oc)],d)}),define(Oe[238],Ne([1,0,2,13,7,8,171,38]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0;class ${constructor(R,y,a,S={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=a,this.g=S,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,a,S)=>{const n={dispose:this.a.push([y,a,R])};return Array.isArray(S)&&S.push(n),n}}async $participateInSave(R,y){const a=v.URI.revive(R);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(S)break;const c=this.d.getDocument(a),u=await this.h(o,{document:c,reason:O.TextDocumentSaveReason.to(y)});n.push(u)}}finally{clearTimeout(d)}return n}h([R,y,a],S){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,R,y,S).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,a,S){const d=[],n=Date.now(),{document:o,reason:c}=S,{version:u}=o,i=Object.freeze({document:o,reason:c,waitUntil(r){if(Object.isFrozen(d))throw(0,I.$7)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{y.apply(a,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(g),r(l)}).catch(l=>{clearTimeout(g),t(l)})}).then(r=>{const t={edits:[]};for(const g of r)if(Array.isArray(g)&&g.every(l=>l instanceof P.$PN))for(const{newText:l,newEol:m,range:p}of g)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:p&&O.Range.from(p),text:l,eol:m&&O.EndOfLine.from(m)}});if(t.edits.length!==0)return u===o.version?this.f.$tryApplyWorkspaceEdit(new T.$Vw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$oqc=$}),define(Oe[239],Ne([1,0,6,4,2,5,123,8,14,25,7]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0,T=We(T);class y{constructor(S,d){this.a=new v.$ke,this.b=new v.$ke,this.c=new v.$ke,this.d=new v.$ke,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new I.$Sc,this.h=new Map,this.f=S.getProxy(O.$EN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let n=this.h.get(S.toString());return n||(n=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const c=P.URI.revive(o);return(0,$.$og)(this.g.getDocument(c))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),n)),n}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const n=P.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(S){const d=P.URI.revive(S),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(S,d){const n=P.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,n){const o=P.URI.revive(S),c=this.g.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(n),c.onEvents(d);let u;d.isUndoing?u=R.TextDocumentChangeReason.Undo:d.isRedoing&&(u=R.TextDocumentChangeReason.Redo),this.c.fire((0,s.$do)({document:c.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:u}))}setWordDefinitionFor(S,d){(0,A.$gQ)(S,d)}}e.$cpc=y}),define(Oe[70],Ne([1,0,240,6,14,2,3,5,16,8,7]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0,s=We(s),e.$Gpc=(0,A.$Di)("IExtHostEditorTabs");class y{constructor(o,c,u){this.e=u,this.d=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$uP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$vP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$wP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$xP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$yP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$zP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$AP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$BP;case T.TabInputKind.InteractiveEditorInput:return new R.$CP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$DP;case T.TabInputKind.MultiDiffEditorInput:return new R.$EP(this.b.input.diffEditors.map(o=>new R.$vP(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class a{constructor(o,c){this.c=[],this.d="",this.b=o,this.e=c;for(const u of o.tabs)u.isActive&&(this.d=u.id),this.c.push(new y(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return s.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(u=>u.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(u=>u.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===T.TabModelOperationKind.TAB_OPEN){const u=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,u),o.tabDto.isActive&&(this.d=u.tabId),u}else if(o.kind===T.TabModelOperationKind.TAB_CLOSE){const u=this.c.splice(o.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if(o.kind===T.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice(o.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,u),u}const c=this.c.find(u=>u.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new I.$ke,this.c=new I.$ke,this.e=[],this.a=o.getProxy(T.$EN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,c={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(u=>u.apiObject))},get activeTabGroup(){const u=o.d;return(0,P.$og)(o.e.find(r=>r.groupId===u)?.apiObject)},close:async(u,i)=>{const r=Array.isArray(u)?u:[u];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(o){const c=new Set(this.e.map(m=>m.groupId)),u=new Set(o.map(m=>m.groupId)),i=(0,v.$d)(c,u),r=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],g=[];this.e=o.map(m=>{const p=new a(m,()=>this.d);return i.added.includes(p.groupId)?t.push(p.apiObject):g.push(p.apiObject),p});const l=(0,P.$og)(o.find(m=>m.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:g}))}$acceptTabGroupUpdate(o){const c=this.e.find(u=>u.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this.e.find(i=>i.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const u=c.acceptTabOperation(o);switch(o.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g(o){for(const c of this.e)for(const u of c.tabs)if(u.apiObject===o)return u}h(o){return this.e.find(c=>c.apiObject===o)}async i(o,c){const u=[];for(const i of o){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");u.push(r.tabId)}return this.a.$closeTab(u,c)}async j(o,c){const u=[];for(const i of o){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");u.push(r.groupId)}return this.a.$closeGroup(u,c)}};e.$Hpc=S,e.$Hpc=S=Ge([Ve(0,$.$eQ)],S);function d(n){return n.tabs!==void 0}}),define(Oe[241],Ne([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0,P=We(P),T=We(T);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const u=this.a.indexOf(c);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),u=[];let i,r,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const l of c){let m=i?(0,s.$Gf)(i,l):0;for(m===0?r=$.State.Start:r=g;m<l.length;m++)m+1===l.length?(t=g,g=$.State.BeforeColon):g+=1,u.push([r,l.toUpperCase().charCodeAt(m),g]),u.push([r,l.toLowerCase().charCodeAt(m),g]),r=g;i=l,g=t}u.push([$.State.BeforeColon,R.CharCode.Colon,$.State.AfterColon]),u.push([$.State.AfterColon,R.CharCode.Slash,$.State.End]),this.b=new $.$y4(u)}}provideDocumentLinks(c){this.c();const u=[],i=$.$z4.computeLinks({getLineContent(r){return c.lineAt(r-1).text},getLineCount(){return c.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&u.push(t)}return u}}class n{constructor(c,u){this.i=u,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(I.$EN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,u,i,r={}){if(n.j(i),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(u),this.d.add(u),this.c.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$eH)(c,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,S.$4k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,u,g,l).catch(p=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${u}`),console.error(p)});const m=i.onDidChangeFile(p=>{const h=[];for(const E of p){const{uri:D,type:b}=E;if(D.scheme!==u)continue;let k;switch(b){case A.FileChangeType.Changed:k=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:k=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:k=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:k})}this.a.$onFileSystemChange(t,h)});return(0,O.$Rc)(()=>{m.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:u,ctime:i,mtime:r,size:t,permissions:g}=c;return{type:u,ctime:i,mtime:r,size:t,permissions:g}}$stat(c,u){return Promise.resolve(this.l(c).stat(v.URI.revive(u))).then(i=>n.k(i))}$readdir(c,u){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(u)))}$readFile(c,u){return Promise.resolve(this.l(c).readFile(v.URI.revive(u))).then(i=>y.$Me.wrap(i))}$writeFile(c,u,i,r){return Promise.resolve(this.l(c).writeFile(v.URI.revive(u),i.buffer,r))}$delete(c,u,i){return Promise.resolve(this.l(c).delete(v.URI.revive(u),i))}$rename(c,u,i,r){return Promise.resolve(this.l(c).rename(v.URI.revive(u),v.URI.revive(i),r))}$copy(c,u,i,r){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(u),v.URI.revive(i),r))}$mkdir(c,u){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(u)))}$watch(c,u,i,r){const t=this.l(c).watch(v.URI.revive(i),r);this.f.set(u,t)}$unwatch(c,u){const i=this.f.get(u);i&&(i.dispose(),this.f.delete(u))}$open(c,u,i){const r=this.l(c);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(u),i))}$close(c,u){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(u))}$read(c,u,i,r){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Me.alloc(r);return Promise.resolve(t.read(u,i,g.buffer,0,r)).then(l=>g.slice(0,l))}$write(c,u,i,r){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(u,i,r.buffer,0,r.byteLength))}l(c){const u=this.c.get(c);if(!u){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return u}}e.$rqc=n}),define(Oe[242],Ne([1,0,6,41,2,5,8,7,29,48]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0,A=We(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,o,c,u,i){this.a=Math.random(),this.b=new v.$ke,this.c=new v.$ke,this.d=new v.$ke,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,I.$yk)(u),t=typeof u=="string",g=i?.correlate,l=c(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(g&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const p of m.created){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const p of m.changed){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const p of m.deleted){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=T.$GN.from(this.i(d,o,u,i,i?.correlate),this.b,this.c,this.d,l)}i(d,n,o,c,u){const i=T.$GN.from();if(typeof o=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const r=d.getProxy(O.$EN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(I.$uk)||o.pattern.includes(I.$vk))&&(t=!0);let g;return u&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,o.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!u),T.$GN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new s.$T(()=>this.a.created.map(P.URI.revive)),this.c=new s.$T(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$T(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,n,o){this.j=d,this.k=n,this.l=o,this.a=new v.$ke,this.b=new v.$ke,this.c=new v.$ke,this.d=new v.$ke,this.g=new v.$me,this.h=new v.$me,this.i=new v.$me,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,o,c){return new R(this.j,d,n,this.a.event,A.GlobPattern.from(o),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,n){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(o=>P.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(o,c,u)=>{const i=function(t){o.call(c,t)};return i.extension=d,n.event(i,void 0,u)}}async $onWillRunFileOperation(d,n,o,c){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:n.map(u=>({oldUri:P.URI.revive(u.source),newUri:P.URI.revive(u.target)}))},o,c);case $.FileOperation.DELETE:return await this.n(this.i,{files:n.map(u=>P.URI.revive(u.target))},o,c);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:n.map(u=>P.URI.revive(u.target))},o,c)}}async n(d,n,o,c){const u=new Set,i=[];if(await d.fireAsync(n,c,async(t,g)=>{const l=Date.now(),m=await Promise.resolve(t);m instanceof T.$SN&&(i.push([g.extension,m]),u.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-l>o&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(g)}return{edit:r,extensionNames:Array.from(u)}}}e.$sqc=a}),define(Oe[243],Ne([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0,n=We(n),i=We(i),l=We(l);class m{constructor(j,B){this.d=j,this.e=B}async provideDocumentSymbols(j,B){const H=this.d.getDocument(j),V=await this.e.provideDocumentSymbols(H,B);if(!(0,v.$Jb)(V))return V[0]instanceof r.$3N?V.map(i.DocumentSymbol.from):m.f(V)}static f(j){j=j.slice(0).sort((V,ne)=>{let fe=V.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(V.location.range.end)),fe});const B=[],H=[];for(const V of j){const ne={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(ne),B.push(ne);break}const fe=H[H.length-1];if(S.$Mt.containsRange(fe.range,ne.range)&&!S.$Mt.equalsRange(fe.range,ne.range)){fe.children?.push(ne),H.push(ne);break}H.pop()}}return B}}class p{constructor(j,B,H,V,ne,fe){this.f=j,this.g=B,this.h=H,this.j=V,this.k=ne,this.l=fe,this.d=new g.$6oc("CodeLens"),this.e=new Map}async provideCodeLenses(j,B){const H=this.f.getDocument(j),V=await this.h.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const ne=this.d.add(V),fe=new T.$Sc;this.e.set(ne,fe);const Ie={cacheId:ne,lenses:[]};for(let ze=0;ze<V.length;ze++)Ie.lenses.push({cacheId:[ne,ze],range:i.Range.from(V[ze].range),command:this.g.toInternal(V[ze].command,fe)});return Ie}async resolveCodeLens(j,B){const H=j.cacheId&&this.d.get(...j.cacheId);if(!H)return;let V;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?V=H:V=await this.h.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const ne=j.cacheId&&this.e.get(j.cacheId[0]);if(ne){if(!V.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return j.command=this.g.toInternal(V.command,ne),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function h(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(j,B){this.d=j,this.e=B}async provideDefinition(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideDefinition(V,ne,H);return h(fe)}}class D{constructor(j,B){this.d=j,this.e=B}async provideDeclaration(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideDeclaration(V,ne,H);return h(fe)}}class b{constructor(j,B){this.d=j,this.e=B}async provideImplementation(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideImplementation(V,ne,H);return h(fe)}}class k{constructor(j,B){this.d=j,this.e=B}async provideTypeDefinition(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideTypeDefinition(V,ne,H);return h(fe)}}class C{static{this.f=10}constructor(j,B){this.g=j,this.h=B,this.d=0,this.e=new Map}async provideHover(j,B,H,V){const ne=this.g.getDocument(j),fe=i.Position.to(B);let Ie;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};Ie=await this.h.provideHover(ne,fe,V,et)}else Ie=await this.h.provideHover(ne,fe,V);if(!Ie||(0,v.$Jb)(Ie.contents))return;Ie.range||(Ie.range=ne.getWordRangeAtPosition(fe)),Ie.range||(Ie.range=new r.$IN(fe,fe));const ze=i.Hover.from(Ie),Qe=this.d;if(this.e.size===C.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ie),this.d+=1,{...ze,id:Qe}}releaseHover(j){this.e.delete(j)}}class f{constructor(j,B){this.d=j,this.e=B}async provideEvaluatableExpression(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideEvaluatableExpression(V,ne,H);if(fe)return i.EvaluatableExpression.from(fe)}}class w{constructor(j,B){this.d=j,this.e=B}async provideInlineValues(j,B,H,V){const ne=this.d.getDocument(j),fe=await this.e.provideInlineValues(ne,i.Range.to(B),i.InlineValueContext.to(H),V);if(Array.isArray(fe))return fe.map(Ie=>i.InlineValue.from(Ie))}}class F{constructor(j,B){this.d=j,this.e=B}async provideDocumentHighlights(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideDocumentHighlights(V,ne,H);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class N{constructor(j,B){this.d=j,this.e=B}async provideMultiDocumentHighlights(j,B,H,V){const ne=this.d.getDocument(j),fe=H.map(Qe=>this.d.getDocument(Qe)),Ie=i.Position.to(B),ze=await this.e.provideMultiDocumentHighlights(ne,Ie,fe,V);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class L{constructor(j,B){this.d=j,this.e=B}async provideLinkedEditingRanges(j,B,H){const V=this.d.getDocument(j),ne=i.Position.to(B),fe=await this.e.provideLinkedEditingRanges(V,ne,H);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,v.$Gb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class W{constructor(j,B){this.d=j,this.e=B}async provideReferences(j,B,H,V){const ne=this.d.getDocument(j),fe=i.Position.to(B),Ie=await this.e.provideReferences(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.location.from)}}class J{static{this.d=1e3}constructor(j,B,H,V,ne,fe,Ie){this.g=j,this.h=B,this.j=H,this.k=V,this.l=ne,this.m=fe,this.n=Ie,this.e=new g.$6oc("CodeAction"),this.f=new Map}async provideCodeActions(j,B,H,V){const ne=this.g.getDocument(j),fe=d.$Ot.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ie=[];for(const et of this.j.getDiagnostics(j))if(fe.intersection(et.range)&&Ie.push(et)>J.d)break;const ze={diagnostics:Ie,only:H.only?new r.$5N(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(ne,fe,ze,V);if(!(0,v.$Kb)(Qe)||V.isCancellationRequested)return;const _e=this.e.add(Qe),tt=new T.$Sc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Qe.length;et++){const rt=Qe[et];if(rt)if(J.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$dH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$dH)(this.m,"codeActionRanges")?(0,v.$Gb)(mt.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(j,B){const[H,V]=j,ne=this.e.get(H,V);if(!ne||J.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,B)??ne;let Ie;fe.edit&&(Ie=i.WorkspaceEdit.from(fe.edit,void 0));let ze;if(fe.command){const Qe=this.f.get(H);Qe&&(ze=this.h.toInternal(fe.command,Qe))}return{edit:Ie,command:ze}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class M{constructor(j,B,H,V,ne){this.e=j,this.f=B,this.g=H,this.h=V,this.j=ne,this.d=new g.$6oc("DocumentPasteEdit")}async prepareDocumentPaste(j,B,H,V){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(j),fe=B.map(Qe=>i.Range.to(Qe)),Ie=i.DataTransfer.toDataTransfer(H,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(ne,fe,Ie,V),V.isCancellationRequested)return;const ze=Array.from(Ie).filter(([,Qe])=>!(Qe instanceof r.$yO));return i.DataTransfer.from(ze)}async providePasteEdits(j,B,H,V,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ie=this.f.getDocument(B),ze=H.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,j,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ie,ze,Qe,{only:ne.only?new r.$DO(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10779,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,B){const[H,V]=j,ne=this.d.get(H,V);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,B)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,B){this.d=j,this.e=B}async provideDocumentFormattingEdits(j,B,H){const V=this.d.getDocument(j),ne=await this.e.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class Z{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeFormattingEdits(j,B,H,V){const ne=this.d.getDocument(j),fe=i.Range.to(B),Ie=await this.e.provideDocumentRangeFormattingEdits(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,B,H,V){(0,y.$ng)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(j),fe=B.map(i.Range.to),Ie=await this.e.provideDocumentRangesFormattingEdits(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}}class ue{constructor(j,B){this.d=j,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,B,H,V,ne){const fe=this.d.getDocument(j),Ie=i.Position.to(B),ze=await this.e.provideOnTypeFormattingEdits(fe,Ie,H,V,ne);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class _{constructor(j,B){this.e=j,this.f=B,this.d=new g.$6oc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,B){const H=await this.e.provideWorkspaceSymbols(j,B);if(!(0,v.$Kb)(H))return{symbols:[]};const V=this.d.add(H),ne={cacheId:V,symbols:[]};for(let fe=0;fe<H.length;fe++){const Ie=H[fe];if(!Ie||!Ie.name){this.f.warn("INVALID SymbolInformation",Ie);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Ie),cacheId:[V,fe]})}return ne}async resolveWorkspaceSymbol(j,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const H=this.d.get(...j.cacheId);if(H){const V=await this.e.resolveWorkspaceSymbol(H,B);return V&&(0,$.$fo)(j,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class ge{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,B,H){this.d=j,this.e=B,this.f=H}async provideRenameEdits(j,B,H,V){const ne=this.d.getDocument(j),fe=i.Position.to(B);try{const Ie=await this.e.provideRenameEdits(ne,fe,H,V);return Ie?i.WorkspaceEdit.from(Ie):void 0}catch(Ie){const ze=ge.g(Ie);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(j,B,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(j),ne=i.Position.to(B);try{const fe=await this.e.prepareRename(V,ne,H);let Ie,ze;if(r.$IN.isRange(fe)?(Ie=fe,ze=V.getText(fe)):(0,y.$fg)(fe)&&(Ie=fe.range,ze=fe.placeholder),!Ie||!ze)return;if(Ie.start.line>ne.line||Ie.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ie),text:ze}}catch(fe){const Ie=ge.g(fe);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(fe)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(j,B,H){this.e=j,this.f=B,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,B,H,V){const ne=this.e.getDocument(j),fe=i.Range.to(B);try{const Ie=se.d[H],ze=await this.f.provideNewSymbolNames(ne,fe,Ie,V);return ze?ze.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ie){this.g.error(se.h(Ie)??JSON.stringify(Ie,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ae{constructor(j,B){this.resultId=j,this.tokens=B}}class $e{constructor(j,B){this.f=j,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,B,H){const V=this.f.getDocument(j),ne=B!==0?this.d.get(B):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ne.resultId,H):await this.g.provideDocumentSemanticTokens(V,H);return ne&&this.d.delete(B),fe?(fe=$e.h(fe),this.o($e.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return $e.j(j)?$e.k(j)?j:new r.$4O(new Uint32Array(j.data),j.resultId):$e.l(j)?$e.m(j)?j:new r.$6O(j.edits.map(B=>new r.$5O(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const B of j.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(j,B){if(!$e.j(B)||!j||!j.tokens)return B;const H=j.tokens,V=H.length,ne=B.data,fe=ne.length;let Ie=0;const ze=Math.min(V,fe);for(;Ie<ze&&H[Ie]===ne[Ie];)Ie++;if(Ie===V&&Ie===fe)return new r.$6O([],B.resultId);let Qe=0;const _e=ze-Ie;for(;Qe<_e&&H[V-Qe-1]===ne[fe-Qe-1];)Qe++;return new r.$6O([{start:Ie,deleteCount:V-Ie-Qe,data:ne.subarray(Ie,fe-Qe)}],B.resultId)}o(j,B){if($e.j(j)){const H=this.e++;return this.d.set(H,new ae(j.resultId,j.data)),(0,o.$Qdb)({id:H,type:"full",data:j.data})}if($e.l(j)){const H=this.e++;return $e.j(B)?this.d.set(H,new ae(B.resultId,B.data)):this.d.set(H,new ae(j.resultId)),(0,o.$Qdb)({id:H,type:"delta",deltas:(j.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class oe{constructor(j,B){this.d=j,this.e=B}async provideDocumentRangeSemanticTokens(j,B,H){const V=this.d.getDocument(j),ne=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(B),H);return ne?this.f(ne):null}f(j){return(0,o.$Qdb)({id:0,type:"full",data:j.data})}}class ke{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,B,H,V,ne){this.f=j,this.g=B,this.h=H,this.j=V,this.k=ne,this.d=new g.$6oc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,B,H,V){const ne=this.f.getDocument(j),fe=i.Position.to(B),Ie=ne.getWordRangeAtPosition(fe)||new r.$IN(fe,fe),ze=Ie.with({end:fe}),Qe=new s.$ee,_e=await this.h.provideCompletionItems(ne,fe,V,i.CompletionContext.to(H));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$fO(_e):_e,nt=ke.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Sc;this.e.set(nt,et);const rt=[],mt={x:nt,[l.ISuggestResultDtoField.completions]:rt,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ie),insert:i.Range.from(ze)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let ut=0;ut<tt.items.length;ut++){const st=tt.items[ut],ct=this.l(st,[nt,ut],ze,Ie);rt.push(ct)}return mt}async resolveCompletionItem(j,B){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...j);if(!H)return;const V=this.l(H,j),ne=await this.h.resolveCompletionItem(H,B);if(!ne)return;const fe=this.l(ne,j);return(V[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||V[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||V[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,$.$go)(V[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B,H,V){const ne=this.e.get(B[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(j.command,ne),Ie={x:B,[l.ISuggestDataDtoField.label]:j.label,[l.ISuggestDataDtoField.kind]:j.kind!==void 0?i.CompletionItemKind.from(j.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:j.tags&&j.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:j.detail,[l.ISuggestDataDtoField.documentation]:typeof j.documentation>"u"?void 0:i.MarkdownString.fromStrict(j.documentation),[l.ISuggestDataDtoField.sortText]:j.sortText!==j.label?j.sortText:void 0,[l.ISuggestDataDtoField.filterText]:j.filterText!==j.label?j.filterText:void 0,[l.ISuggestDataDtoField.preselect]:j.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:j.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:j.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:j.additionalTextEdits&&j.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ie[l.ISuggestDataDtoField.insertText]=j.textEdit.newText):typeof j.insertText=="string"?Ie[l.ISuggestDataDtoField.insertText]=j.insertText:j.insertText instanceof r.$TN&&(Ie[l.ISuggestDataDtoField.insertText]=j.insertText.value,Ie[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return j.textEdit?ze=j.textEdit.range:j.range&&(ze=j.range),r.$IN.isRange(ze)?Ie[l.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!V?.isEqual(ze.replacing))&&(Ie[l.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ie}}class Le{async provideInlineCompletions(j,B,H,V){}async provideInlineEdits(j,B,H,V){}disposeCompletions(j){}handleDidShowCompletionItem(j,B,H){}handlePartialAccept(j,B,H,V){}}class Y extends Le{constructor(j,B,H,V){super(),this.f=j,this.g=B,this.h=H,this.j=V,this.d=new te,this.e=(0,t.$dH)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$dH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,B,H,V){const ne=this.g.getDocument(j),fe=i.Position.to(B),Ie=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},V);if(!Ie||V.isCancellationRequested)return;const ze=Array.isArray(Ie)?Ie:Ie.items,Qe=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const ut=et.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(j,B,H,V){if(!this.h.provideInlineEdits)return;(0,t.$eH)(this.f,"inlineCompletionsAdditions");const ne=this.g.getDocument(j),fe=i.Range.to(B),Ie=await this.h.provideInlineEdits(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},V);if(!Ie||V.isCancellationRequested)return;const ze=Array.isArray(Ie)?Ie:Ie.items,Qe=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const ut=et.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,B,H){const V=this.d.get(j)?.items[B];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,H)}handlePartialAccept(j,B,H,V){const ne=this.d.get(j)?.items[B];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,H),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(V)))}}class q{async provideInlineEdits(j,B,H){const V=this.f.getDocument(j),ne=await this.g.provideInlineEdit(V,{triggerKind:this.e[B.triggerKind]},H);if(!ne||H.isCancellationRequested)return;let fe;const Ie=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let ze;ne.accepted&&(fe||(fe=new T.$Sc),ze=this.h.toInternal(ne.accepted,fe));let Qe;return ne.rejected&&(fe||(fe=new T.$Sc),Qe=this.h.toInternal(ne.rejected,fe)),{pid:Ie,text:ne.text,range:i.Range.from(ne.range),accepted:ze,rejected:Qe}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,B,H,V){this.f=B,this.g=H,this.h=V,this.d=new te,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const B=this.e++;return this.d.set(B,j),B}disposeReferenceId(j){const B=this.d.get(j);return this.d.delete(j),B}get(j){return this.d.get(j)}}class ve{constructor(j,B){this.e=j,this.f=B,this.d=new g.$6oc("SignatureHelp")}async provideSignatureHelp(j,B,H,V){const ne=this.e.getDocument(j),fe=i.Position.to(B),Ie=this.g(H),ze=await this.f.provideSignatureHelp(ne,fe,V,Ie);if(ze){const Qe=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Qe}}}g(j){let B;if(j.activeSignatureHelp){const H=i.SignatureHelp.to(j.activeSignatureHelp),V=this.d.get(j.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...j,activeSignatureHelp:B}}releaseSignatureHelp(j){this.d.delete(j)}}class ce{constructor(j,B,H,V,ne){this.f=j,this.g=B,this.h=H,this.j=V,this.k=ne,this.d=new g.$6oc("InlayHints"),this.e=new Map}async provideInlayHints(j,B,H){const V=this.f.getDocument(j),ne=i.Range.to(B),fe=await this.h.provideInlayHints(V,ne,H);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(H.isCancellationRequested)return;const Ie=this.d.add(fe);this.e.set(Ie,new T.$Sc);const ze={hints:[],cacheId:Ie};for(let Qe=0;Qe<fe.length;Qe++)this.l(fe[Qe],ne)&&ze.hints.push(this.m(fe[Qe],[Ie,Qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),ze}async resolveInlayHint(j,B){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...j);if(!H)return;const V=await this.h.resolveInlayHint(H,B);if(V&&this.l(V))return this.m(V,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,B){return j.label.length===0||Array.isArray(j.label)&&j.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(B&&!B.contains(j.position))}m(j,B){const H=this.e.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(j.tooltip),position:i.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(i.TextEdit.from),kind:j.kind&&i.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")V.label=j.label;else{const ne=[];V.label=ne;for(const fe of j.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ie={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$UN.isLocation(fe.location)&&(Ie.location=i.location.from(fe.location)),fe.command&&(Ie.command=this.g.toInternal(fe.command,H)),ne.push(Ie)}}return V}}class we{constructor(j,B){this.e=j,this.f=B,this.d=new g.$6oc("DocumentLink")}async provideLinks(j,B){const H=this.e.getDocument(j),V=await this.f.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(we.g).map(i.DocumentLink.from)};{const ne=this.d.add(V),fe={links:[],cacheId:ne};for(let Ie=0;Ie<V.length;Ie++){if(!we.g(V[Ie]))continue;const ze=i.DocumentLink.from(V[Ie]);ze.cacheId=[ne,Ie],fe.links.push(ze)}return fe}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,B){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...j);if(!H)return;const V=await this.f.resolveDocumentLink(H,B);if(!(!V||!we.g(V)))return i.DocumentLink.from(V)}releaseLinks(j){this.d.delete(j)}}class he{constructor(j,B){this.d=j,this.e=B}async provideColors(j,B){const H=this.d.getDocument(j),V=await this.e.provideDocumentColors(H,B);return Array.isArray(V)?V.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(j,B,H){const V=this.d.getDocument(j),ne=i.Range.to(B.range),fe=i.Color.to(B.color),Ie=await this.e.provideColorPresentations(fe,{document:V,range:ne},H);if(Array.isArray(Ie))return Ie.map(i.ColorPresentation.from)}}class X{constructor(j,B){this.d=j,this.e=B}async provideFoldingRanges(j,B,H){const V=this.d.getDocument(j),ne=await this.e.provideFoldingRanges(V,B,H);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class x{constructor(j,B,H){this.d=j,this.e=B,this.f=H}async provideSelectionRanges(j,B,H){const V=this.d.getDocument(j),ne=B.map(i.Position.to),fe=await this.e.provideSelectionRanges(V,ne,H);if(!(0,v.$Kb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let ze=0;ze<ne.length;ze++){const Qe=[];Ie.push(Qe);let _e=ne[ze],tt=fe[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ie}}class me{constructor(j,B){this.f=j,this.g=B,this.d=new A.$jQ(""),this.e=new Map}async prepareSession(j,B,H){const V=this.f.getDocument(j),ne=i.Position.to(B),fe=await this.g.prepareCallHierarchy(V,ne,H);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ie,ze)):[this.h(Ie,fe)]}async provideCallsTo(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(V,H);if(ne)return ne.map(fe=>({from:this.h(j,fe.from),fromRanges:fe.fromRanges.map(Ie=>i.Range.from(Ie))}))}async provideCallsFrom(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(V,H);if(ne)return ne.map(fe=>({to:this.h(j,fe.to),fromRanges:fe.fromRanges.map(Ie=>i.Range.from(Ie))}))}releaseSession(j){this.e.delete(j)}h(j,B){const H=this.e.get(j),V=i.CallHierarchyItem.from(B,j,H.size.toString(36));return H.set(V._itemId,B),V}j(j,B){return this.e.get(j)?.get(B)}}class pe{constructor(j,B){this.f=j,this.g=B,this.d=new A.$jQ(""),this.e=new Map}async prepareSession(j,B,H){const V=this.f.getDocument(j),ne=i.Position.to(B),fe=await this.g.prepareTypeHierarchy(V,ne,H);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ie,ze)):[this.h(Ie,fe)]}async provideSupertypes(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(V,H);if(ne)return ne.map(fe=>this.h(j,fe))}async provideSubtypes(j,B,H){const V=this.j(j,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(V,H);if(ne)return ne.map(fe=>this.h(j,fe))}releaseSession(j){this.e.delete(j)}h(j,B){const H=this.e.get(j),V=i.TypeHierarchyItem.from(B,j,H.size.toString(36));return H.set(V._itemId,B),V}j(j,B){return this.e.get(j)?.get(B)}}class Ae{constructor(j,B,H,V,ne){this.e=j,this.f=B,this.g=H,this.h=V,this.j=ne,this.d=new g.$6oc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,B,H,V,ne){const fe=this.f.getDocument(B),Ie=i.Position.to(H),ze=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(fe,Ie,ze,ne);if(!Qe)return;const _e=(0,v.$1b)(Qe),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10780,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,B){const[H,V]=j,ne=this.d.get(H,V);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,B)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class Ue{constructor(j,B){this.d=j,this.e=B}async provideMappedEdits(j,B,H,V){const ne=a.URI.revive(j),fe=this.d.getDocument(ne),Ie=H.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),ze={documents:Ie,selections:Ie[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(fe,B,ze,V);return Qe?i.WorkspaceEdit.from(Qe):null}}class Se{constructor(j,B){this.adapter=j,this.extension=B}}class Pe{static{this.d=0}constructor(j,B,H,V,ne,fe,Ie,ze){this.g=B,this.h=H,this.j=V,this.k=ne,this.l=fe,this.m=Ie,this.n=ze,this.f=new Map,this.e=j.getProxy(l.$EN.MainThreadLanguageFeatures)}o(j,B){return i.DocumentSelector.from(j,this.g,B)}p(j){return new r.$GN(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Pe.d++}async s(j,B,H,V,ne,fe=!1){const Ie=this.f.get(j);if(!Ie||!(Ie.adapter instanceof B))return V;const ze=Date.now();fe||this.l.trace(`[${Ie.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Ie.adapter,Ie.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ie.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ie.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ie.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(ne)?(0,I.$sh)(Qe,ne):Qe}t(j,B){const H=this.q();return this.f.set(H,new Se(j,B)),H}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,B,H,V){const ne=this.t(new m(this.h,H),j),fe=V&&V.label||Pe.u(j);return this.e.$registerDocumentSymbolProvider(ne,this.o(B,j),fe),this.p(ne)}$provideDocumentSymbols(j,B,H){return this.s(j,m,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(j,B,H){const V=this.q(),ne=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Se(new p(this.h,this.j.converter,H,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(V,this.o(B,j),ne);let fe=this.p(V);if(ne!==void 0){const Ie=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(ne));fe=r.$GN.from(fe,Ie)}return fe}$provideCodeLenses(j,B,H){return this.s(j,p,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(j,B,H){return this.s(j,p,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(j,B){this.s(j,p,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(j,B,H){const V=this.t(new E(this.h,H),j);return this.e.$registerDefinitionSupport(V,this.o(B,j)),this.p(V)}$provideDefinition(j,B,H,V){return this.s(j,E,ne=>ne.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(j,B,H){const V=this.t(new D(this.h,H),j);return this.e.$registerDeclarationSupport(V,this.o(B,j)),this.p(V)}$provideDeclaration(j,B,H,V){return this.s(j,D,ne=>ne.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(j,B,H){const V=this.t(new b(this.h,H),j);return this.e.$registerImplementationSupport(V,this.o(B,j)),this.p(V)}$provideImplementation(j,B,H,V){return this.s(j,b,ne=>ne.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(j,B,H){const V=this.t(new k(this.h,H),j);return this.e.$registerTypeDefinitionSupport(V,this.o(B,j)),this.p(V)}$provideTypeDefinition(j,B,H,V){return this.s(j,k,ne=>ne.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(j,B,H,V){const ne=this.t(new C(this.h,H),j);return this.e.$registerHoverProvider(ne,this.o(B,j)),this.p(ne)}$provideHover(j,B,H,V,ne){return this.s(j,C,fe=>fe.provideHover(a.URI.revive(B),H,V,ne),void 0,ne)}$releaseHover(j,B){this.s(j,C,H=>Promise.resolve(H.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(j,B,H,V){const ne=this.t(new f(this.h,H),j);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(B,j)),this.p(ne)}$provideEvaluatableExpression(j,B,H,V){return this.s(j,f,ne=>ne.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(j,B,H,V){const ne=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new w(this.h,H),j);this.e.$registerInlineValuesProvider(fe,this.o(B,j),ne);let Ie=this.p(fe);if(ne!==void 0){const ze=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ne));Ie=r.$GN.from(Ie,ze)}return Ie}$provideInlineValues(j,B,H,V,ne){return this.s(j,w,fe=>fe.provideInlineValues(a.URI.revive(B),H,V,ne),void 0,ne)}registerDocumentHighlightProvider(j,B,H){const V=this.t(new F(this.h,H),j);return this.e.$registerDocumentHighlightProvider(V,this.o(B,j)),this.p(V)}registerMultiDocumentHighlightProvider(j,B,H){const V=this.t(new N(this.h,H),j);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(B,j)),this.p(V)}$provideDocumentHighlights(j,B,H,V){return this.s(j,F,ne=>ne.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}$provideMultiDocumentHighlights(j,B,H,V,ne){return this.s(j,N,fe=>fe.provideMultiDocumentHighlights(a.URI.revive(B),H,V.map(Ie=>a.URI.revive(Ie)),ne),void 0,ne)}registerLinkedEditingRangeProvider(j,B,H){const V=this.t(new L(this.h,H),j);return this.e.$registerLinkedEditingRangeProvider(V,this.o(B,j)),this.p(V)}$provideLinkedEditingRanges(j,B,H,V){return this.s(j,L,async ne=>{const fe=await ne.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Pe.y(fe.wordPattern):void 0}},void 0,V)}registerReferenceProvider(j,B,H){const V=this.t(new W(this.h,H),j);return this.e.$registerReferenceSupport(V,this.o(B,j)),this.p(V)}$provideReferences(j,B,H,V,ne){return this.s(j,W,fe=>fe.provideReferences(a.URI.revive(B),H,V,ne),void 0,ne)}registerCodeActionProvider(j,B,H,V){const ne=new T.$Sc,fe=this.t(new J(this.h,this.j.converter,this.k,H,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(fe,this.o(B,j),{providedKinds:V?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:V?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this.j.converter.toInternal(Ie.command,ne)}))},Pe.u(j),Pe.w(j),!!H.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(j,B,H,V,ne){return this.s(j,J,fe=>fe.provideCodeActions(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveCodeAction(j,B,H){return this.s(j,J,V=>V.resolveCodeAction(B,H),{},void 0)}$releaseCodeActions(j,B){this.s(j,J,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(j,B,H){const V=this.t(new K(this.h,H),j);return this.e.$registerDocumentFormattingSupport(V,this.o(B,j),j.identifier,j.displayName||j.name),this.p(V)}$provideDocumentFormattingEdits(j,B,H,V){return this.s(j,K,ne=>ne.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(j,B,H){const V=typeof H.provideDocumentRangesFormattingEdits=="function",ne=this.t(new Z(this.h,H),j);return this.e.$registerRangeFormattingSupport(ne,this.o(B,j),j.identifier,j.displayName||j.name,V),this.p(ne)}$provideDocumentRangeFormattingEdits(j,B,H,V,ne){return this.s(j,Z,fe=>fe.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(j,B,H,V,ne){return this.s(j,Z,fe=>fe.provideDocumentRangesFormattingEdits(a.URI.revive(B),H,V,ne),void 0,ne)}registerOnTypeFormattingEditProvider(j,B,H,V){const ne=this.t(new ue(this.h,H),j);return this.e.$registerOnTypeFormattingSupport(ne,this.o(B,j),V,j.identifier),this.p(ne)}$provideOnTypeFormattingEdits(j,B,H,V,ne,fe){return this.s(j,ue,Ie=>Ie.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(j,B){const H=this.t(new _(B,this.l),j);return this.e.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(j,B,H){return this.s(j,_,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(j,B,H){return this.s(j,_,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(j,B){this.s(j,_,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(j,B,H){const V=this.t(new ge(this.h,H,this.l),j);return this.e.$registerRenameSupport(V,this.o(B,j),ge.supportsResolving(H)),this.p(V)}$provideRenameEdits(j,B,H,V,ne){return this.s(j,ge,fe=>fe.provideRenameEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveRenameLocation(j,B,H,V){return this.s(j,ge,ne=>ne.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerNewSymbolNamesProvider(j,B,H){const V=this.t(new se(this.h,H,this.l),j);return this.e.$registerNewSymbolNamesProvider(V,this.o(B,j)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,se,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,B,H,V,ne){return this.s(j,se,fe=>fe.provideNewSymbolNames(a.URI.revive(B),H,V,ne),void 0,ne)}registerDocumentSemanticTokensProvider(j,B,H,V){const ne=this.t(new $e(this.h,H),j),fe=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(B,j),V,fe);let Ie=this.p(ne);if(fe){const ze=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(fe));Ie=r.$GN.from(Ie,ze)}return Ie}$provideDocumentSemanticTokens(j,B,H,V){return this.s(j,$e,ne=>ne.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(j,B){this.s(j,$e,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,B,H,V){const ne=this.t(new oe(this.h,H),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(B,j),V),this.p(ne)}$provideDocumentRangeSemanticTokens(j,B,H,V){return this.s(j,oe,ne=>ne.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(j,B,H,V){const ne=this.t(new ke(this.h,this.j.converter,H,this.m,j),j);return this.e.$registerCompletionsProvider(ne,this.o(B,j),V,ke.supportsResolving(H),j.identifier),this.p(ne)}$provideCompletionItems(j,B,H,V,ne){return this.s(j,ke,fe=>fe.provideCompletionItems(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveCompletionItem(j,B,H){return this.s(j,ke,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(j,B){this.s(j,ke,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(j,B,H,V){const ne=new Y(j,this.h,H,this.j.converter),fe=this.t(ne,j);return this.e.$registerInlineCompletionsSupport(fe,this.o(B,j),ne.supportsHandleEvents,u.$pn.toKey(j.identifier.value),V?.yieldTo?.map(Ie=>u.$pn.toKey(Ie))||[]),this.p(fe)}$provideInlineCompletions(j,B,H,V,ne){return this.s(j,Le,fe=>fe.provideInlineCompletions(a.URI.revive(B),H,V,ne),void 0,ne)}$provideInlineEdits(j,B,H,V,ne){return this.s(j,Le,fe=>fe.provideInlineEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$handleInlineCompletionDidShow(j,B,H,V){this.s(j,Le,async ne=>{ne.handleDidShowCompletionItem(B,H,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,B,H,V,ne){this.s(j,Le,async fe=>{fe.handlePartialAccept(B,H,V,ne)},void 0,void 0)}$freeInlineCompletionsList(j,B){this.s(j,Le,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(j,B,H){const V=new q(j,this.h,H,this.j.converter),ne=this.t(V,j);return this.e.$registerInlineEditProvider(ne,this.o(B,j),j.identifier),this.p(ne)}$provideInlineEdit(j,B,H,V){return this.s(j,q,ne=>ne.provideInlineEdits(a.URI.revive(B),H,V),void 0,V)}$freeInlineEdit(j,B){this.s(j,q,async H=>{H.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(j,B,H,V){const ne=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,fe=this.t(new ve(this.h,H),j);return this.e.$registerSignatureHelpProvider(fe,this.o(B,j),ne),this.p(fe)}$provideSignatureHelp(j,B,H,V,ne){return this.s(j,ve,fe=>fe.provideSignatureHelp(a.URI.revive(B),H,V,ne),void 0,ne)}$releaseSignatureHelp(j,B){this.s(j,ve,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(j,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ce(this.h,this.j.converter,H,this.l,j),j);this.e.$registerInlayHintsProvider(ne,this.o(B,j),typeof H.resolveInlayHint=="function",V,Pe.u(j));let fe=this.p(ne);if(V!==void 0){const Ie=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(V));fe=r.$GN.from(fe,Ie)}return fe}$provideInlayHints(j,B,H,V){return this.s(j,ce,ne=>ne.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(j,B,H){return this.s(j,ce,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(j,B){this.s(j,ce,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(j,B,H){const V=this.t(new we(this.h,H),j);return this.e.$registerDocumentLinkProvider(V,this.o(B,j),typeof H.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(j,B,H){return this.s(j,we,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(j,B,H){return this.s(j,we,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(j,B){this.s(j,we,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(j,B,H){const V=this.t(new he(this.h,H),j);return this.e.$registerDocumentColorProvider(V,this.o(B,j)),this.p(V)}$provideDocumentColors(j,B,H){return this.s(j,he,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(j,B,H,V){return this.s(j,he,ne=>ne.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(j,B,H){const V=this.q(),ne=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Se(new X(this.h,H),j)),this.e.$registerFoldingRangeProvider(V,this.o(B,j),j.identifier,ne);let fe=this.p(V);if(ne!==void 0){const Ie=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=r.$GN.from(fe,Ie)}return fe}$provideFoldingRanges(j,B,H,V){return this.s(j,X,ne=>ne.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(j,B,H){const V=this.t(new x(this.h,H,this.l),j);return this.e.$registerSelectionRangeProvider(V,this.o(B,j)),this.p(V)}$provideSelectionRanges(j,B,H,V){return this.s(j,x,ne=>ne.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(j,B,H){const V=this.t(new me(this.h,H),j);return this.e.$registerCallHierarchyProvider(V,this.o(B,j)),this.p(V)}$prepareCallHierarchy(j,B,H,V){return this.s(j,me,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(j,B,H,V){return this.s(j,me,ne=>ne.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(j,B,H,V){return this.s(j,me,ne=>ne.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(j,B){this.s(j,me,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(j,B,H){const V=this.t(new pe(this.h,H),j);return this.e.$registerTypeHierarchyProvider(V,this.o(B,j)),this.p(V)}$prepareTypeHierarchy(j,B,H,V){return this.s(j,pe,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(j,B,H,V){return this.s(j,pe,ne=>ne.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(j,B,H,V){return this.s(j,pe,ne=>ne.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(j,B){this.s(j,pe,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(j,B,H,V){const ne=this.q();return this.f.set(ne,new Se(new Ae(this.e,this.h,H,ne,j),j)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(B,j),(0,t.$dH)(j,"documentPaste")&&V?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(j,B,H,V,ne,fe){return this.s(j,Ae,Ie=>Promise.resolve(Ie.provideDocumentOnDropEdits(B,a.URI.revive(H),V,ne,fe)),void 0,void 0)}$resolveDropEdit(j,B,H){return this.s(j,Ae,V=>V.resolveDropEdit(B,H),{},void 0)}$releaseDocumentOnDropEdits(j,B){this.s(j,Ae,H=>Promise.resolve(H.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(j,B,H){const V=this.t(new Ue(this.h,H),j);return this.e.$registerMappedEditsProvider(V,this.o(B,j),j.displayName??j.name),this.p(V)}$provideMappedEdits(j,B,H,V,ne){return this.s(j,Ue,fe=>Promise.resolve(fe.provideMappedEdits(B,H,V,ne)),null,ne)}registerDocumentPasteEditProvider(j,B,H,V){const ne=this.q();return this.f.set(ne,new Se(new M(this.e,this.h,H,ne,j),j)),this.e.$registerPasteEditProvider(ne,this.o(B,j),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(j,B,H,V,ne){return this.s(j,M,fe=>fe.prepareDocumentPaste(a.URI.revive(B),H,V,ne),void 0,ne)}$providePasteEdits(j,B,H,V,ne,fe,Ie){return this.s(j,M,ze=>ze.providePasteEdits(B,a.URI.revive(H),V,ne,fe,Ie),void 0,Ie)}$resolvePasteEdit(j,B,H){return this.s(j,M,V=>V.resolvePasteEdit(B,H),{},void 0)}$releasePasteEdits(j,B){this.s(j,M,H=>Promise.resolve(H.releasePasteEdits(B)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Pe.y(j.decreaseIndentPattern),increaseIndentPattern:Pe.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Pe.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Pe.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Pe.y(j.beforeText),afterText:j.afterText?Pe.y(j.afterText):void 0,previousLineText:j.previousLineText?Pe.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Pe.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(B=>r.SyntaxTokenType.toString(B)):void 0}}static E(j){return j.map(Pe.D)}setLanguageConfiguration(j,B,H){const{wordPattern:V}=H;if(V&&(0,R.$qf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(B,V):this.h.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ne=this.q(),fe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Pe.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Pe.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Pe.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Pe.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,B,fe),this.p(ne)}$setWordDefinitions(j){for(const B of j)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$dpc=Pe}),define(Oe[244],Ne([1,0,4,5,8]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,P=We(P);class O{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(I.$EN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const s of $)this.c.set(s.name,s)})}async invokeTool(T,$,s){return await this.b.$invokeTool(T,$,s)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>P.LanguageModelToolDescription.to(T))}async $invokeTool(T,$,s){const R=this.a.get(T);if(!R)throw new Error(`Unknown tool ${T}`);return await R.tool.invoke($,s)}registerTool(T,$,s){return this.a.set($,{extension:T,tool:s}),this.b.$registerTool($),(0,v.$Rc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$Hqc=O}),define(Oe[94],Ne([1,0,10,21,42,13,6,39,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=e.$Wpc=void 0,c=We(c),u=We(u),e.$Wpc=(0,y.$Di)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$7h,this.stream=E??new v.$7h}}class l{constructor(){this.a=new Map,this.b=new v.$7h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$4h.map(h.b.asyncIterable,E=>{if(E instanceof u.$1P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new u.$1P(h.part.value):D=new u.$ZP(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new A.$ke,this.d=new A.$ke,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new R.$rn,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$EN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,b){const k=t.a++;this.f.set(k,{extension:h.identifier,provider:D,languageModelId:E});let C;b.auth&&(C={providerLabel:h.displayName||h.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${R.$pn.toKey(h.identifier)}/${k}/${E}`,{extension:h.identifier,id:E,vendor:b.vendor??R.$pn.toKey(h.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:C,targetExtensions:b.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new R.$pn(w),F,N)});return(0,$.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),f?.dispose()})}async $startChatRequest(h,E,D,b,k,C){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const w=new S.$xw(async N=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof u.$ZP?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof u.$1P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let F;if(f.provider.provideLanguageModelResponse2)F=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(c.LanguageModelChatMessage.to),k,R.$pn.toKey(D),w,C));else{const N=new S.$xw(async L=>{w.report({index:L.index,part:new u.$1P(L.part)})});F=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(c.LanguageModelChatMessage.to),k?.modelOptions??{},R.$pn.toKey(D),N,C))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,D){const b=this.f.get(h);return b?Promise.resolve(b.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new R.$rn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,b]of this.i)b.languageModelId===E&&(b.res.reject(new O.$4),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),b=[],k=this;for(const C of D){const f=this.g.get(C);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let w=f.apiObjects.get(h.identifier);w||(w={id:C,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(C))throw u.$5P.NotFound(C);return k.r(C,F,N??I.CancellationToken.None)},sendRequest(F,N,L){if(!k.g.has(C))throw u.$5P.NotFound(C);return k.l(h,C,F,N??{},L??I.CancellationToken.None)}},Object.freeze(w),f.apiObjects.set(h.identifier,w)),b.push(w)}return b}async l(h,E,D,b,k){const C=this.m(h,D),f=h.identifier,w=this.g.get(E)?.metadata;if(!w||!this.g.has(E))throw u.$5P.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,w)&&(!await this.n(h,{identifier:w.extension,displayName:w.auth.providerLabel},b.justification,!1)||!this.h.get(f)?.has(w.extension)))throw u.$5P.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const F=Math.random()*1e6|0,N=new l;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,F,C,b,k)}catch(L){throw this.i.delete(F),L}return N.apiObject}catch(F){throw F.name===u.$5P.name?F:new u.$5P(`Language model '${E}' errored: ${(0,P.$oj)(F)}`,"Unknown",F)}}m(h,E){const D=[];for(const b of E)b.role===u.LanguageModelChatMessageRole.System&&(0,r.$eH)(h,"languageModelSystem"),b.content2 instanceof u.$XP&&(0,r.$eH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(b));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,O.$2)(E)):D.res.resolve())}async n(h,E,D,b){const k=i.$GM+E.identifier.value;if(await this.k.getSession(h,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=D?(0,s.localize)(10778,null,E.displayName,D):void 0;return await this.k.getSession(h,k,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!R.$pn.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw u.$5P.NotFound(`Language model '${h}' is unknown.`);const k=T.Iterable.find(this.f.values(),C=>C.languageModelId===h);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:b,enabled:k}of h){const C=this.h.get(D)??new R.$qn;if(C.has(b)!==k){k?C.add(b):C.delete(b),this.h.set(D,C);const w={from:D,to:b};E.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=A.Event.signal(A.Event.filter(this.c.event,k=>R.$pn.equals(k.from,h.identifier))),b=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,b)},canSendRequest(k){let C;e:for(const[w,F]of E.g)for(const N of F.apiObjects.values())if(N===k){C=F.metadata;break e}if(!C)return;if(!E.o(h.identifier,C))return!0;const f=E.h.get(h.identifier);if(f)return f.has(C.extension)}}}};e.$Xpc=m,e.$Xpc=m=t=Ge([Ve(0,o.$eQ),Ve(1,a.$$j),Ve(2,n.$fpc)],m)});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[245],Ne([1,0,5,8,7,35,10,4,24]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0,I=We(I),O=ri(O);class s{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$EN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=I.Position.from(a),n=await this.a.$tokensAtPosition(y.uri,d),o={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new P.$IN(a.line,a.character,a.line,a.character)};if(!n)return o;const c={range:I.Range.to(n.range),type:I.TokenType.to(n.type)};return!c.range.contains(a)||S!==y.version?o:c}createLanguageStatusItem(y,a,S){const d=this.f++,n=this.a,o=this.g,c=`${y.identifier.value}/${a}`;if(o.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);o.add(c);const u={selector:S,id:a,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Sc,t=()=>{if(i?.dispose(),!o.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Fh)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:c,name:u.name??y.displayName??y.name,source:y.displayName??y.name,selector:I.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===P.LanguageStatusSeverity.Error?O.default.Error:u.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:u.command&&this.d.toInternal(u.command,r),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},g={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),o.delete(c)},get id(){return u.id},get name(){return u.name},set name(l){u.name=l,t()},get selector(){return u.selector},set selector(l){u.selector=l,t()},get text(){return u.text},set text(l){u.text=l,t()},set text2(l){(0,$.$eH)(y,"languageStatusText"),u.text=l,t()},get text2(){return(0,$.$eH)(y,"languageStatusText"),u.text},get detail(){return u.detail},set detail(l){u.detail=l,t()},get severity(){return u.severity},set severity(l){u.severity=l,t()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(l){u.accessibilityInformation=l,t()},get command(){return u.command},set command(l){u.command=l,t()},get busy(){return u.busy},set busy(l){u.busy=l,t()}};return t(),g}}e.$Iqc=s}),define(Oe[246],Ne([1,0,15,2,8,7,89]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=void 0,P=We(P),A=We(A);class T{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$$O(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=I.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(P.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(P.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===y);if(n&&(a||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(o=>A.$JL(o.mime)))){const o=new Map,c=[];n.items.forEach(u=>{let i;o.has(u.mime)?i=o.get(u.mime):(i=[],o.set(u.mime,i),c.push(u.mime)),i.push(u.data)}),n.items.length=0,c.forEach(u=>{const i=A.$KL(o.get(u));n.items.push({mime:u,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$tqc=$;class s{static{this.a=0}constructor(y,a,S,d,n){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(n=>n.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},n=[];for(const c of y.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),n.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),n.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<n.length;c++){const u=n[c],i=o.get(u.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});o.set(u.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...u}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],n=[],o=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const l=new $(this,this.l,g);return a||n.push($.asModelAddData(g)),l}),r=new T(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)o.push(g.uri),r.deletedItems.push(g.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const n=this.b.splice(y,a);this.b.splice(S,0,...n);const o=[new T(y,a,n.map(c=>c.apiCell),[]),new T(S,0,[],n)];for(const c of o)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$uqc=s}),define(Oe[247],Ne([1,0,6,2,8,7,38]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0;class T{constructor(s,R,y,a={timeout:1500,errors:3}){this.b=s,this.c=R,this.d=y,this.f=a,this.a=new v.$me}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(R,y,a)=>{const S=function(n){R.call(y,n)};return S.extension=s,this.a.event(S,void 0,a)}}async $participateInSave(s,R,y){const a=I.URI.revive(s),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(R)},y,async(o,c)=>{const u=Date.now(),i=await await Promise.resolve(o);Date.now()-u>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$SN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const o of d){const{edits:c}=P.WorkspaceEdit.from(o);n.edits=n.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new A.$Vw(n))}}e.$Kqc=T}),define(Oe[124],Ne([1,0,13,8,7]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0,I=We(I),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,s,R,y,a){this.id=T,this.f=$,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=a}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(P.$$O.isNotebookRange))throw(0,v.$6)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,s){T.f.$tryRevealRange(T.id,I.NotebookRange.from($),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(I.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$vqc=O}),define(Oe[248],Ne([1,0,6,11,8]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0,P=We(P);let O=class{constructor(T,$){this.c=T,this.d=$,this.a=new v.$ke,this.b=new v.$ke,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const s=this.d.getEditorById(T);$.visibleRanges&&s._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&s._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(T[$]))}};e.$Mqc=O,e.$Mqc=O=Ge([Ve(0,I.$$j)],O)}),define(Oe[249],Ne([1,0,6,5,124]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0;class O{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(I.$EN.MainThreadNotebookRenderers)}$postRendererMessage(T,$,s){const R=this.c.getEditorById(T);this.a.get($)?.fire({editor:R.apiEditor,message:s})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,y,a)=>this.d($).event(R,y,a),postMessage:(R,y)=>{P.$vqc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const a=y&&P.$vqc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,$,R)}}}d(T){let $=this.a.get(T);return $||($=new v.$ke({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$Pqc=O}),define(Oe[250],Ne([1,0,8,76,21,71,13]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:n,location:o,cancellable:c}=a,u={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(o),title:n,source:u,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$Z),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new P.$ve,this.c.set(y,d));const n=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let o;try{o=a(new s(this.a,y),S&&d?d.token:P.CancellationToken.None)}catch(c){throw n(y),c}return o.then(c=>n(y),c=>n(y)),o}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$Tqc=T;function $(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class s extends I.$xw{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Ge([(0,O.$0h)(100,(R,y)=>$(R,y),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Oe[251],Ne([1,0,2,5,10,8]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=void 0;class A{static{this.a=0}constructor($,s){this.d=s,this.c=new Map,this.b=$.getProxy(I.$EN.MainThreadQuickDiff)}$provideOriginalResource($,s,R){const y=v.URI.revive(s),a=this.c.get($);return a?(0,P.$vh)(()=>a.provideOriginalResource(y,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,s,R,y){const a=A.a++;return this.c.set(a,s),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from($,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$Uqc=A});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[252],Ne([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=d,R=ri(R);function d(n,o,c){const u=n.getProxy(O.$EN.MainThreadQuickOpen);class i{constructor(D,b){this.e=new Map,this.f=0,this.a=D,this.b=b}showQuickPick(D,b,k,C=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(b),w=++this.f,F=u.$show(w,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},C),N={},L=F.then(()=>N);return Promise.race([L,f]).then(W=>{if(W===N)return;const J=(0,a.$dH)(D,"quickPickItemTooltip");return f.then(M=>{const K=[];for(let Z=0;Z<M.length;Z++){const ue=M[Z];if(typeof ue=="string")K.push({label:ue,handle:Z});else if(ue.kind===T.QuickPickItemKind.Separator)K.push({type:"separator",label:ue.label});else{ue.tooltip&&!J&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const _=ue.iconPath?m(ue.iconPath):void 0;K.push({label:ue.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:J?S.MarkdownString.fromStrict(ue.tooltip):void 0,handle:Z})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=Z=>{k.onDidSelectItem(M[Z])}),u.$setItems(w,K),F.then(Z=>{if(typeof Z=="number")return M[Z];if(Array.isArray(Z))return Z.map(ue=>M[ue])})})}).then(void 0,W=>{if(!(0,$.$3)(W))return u.$setError(w,W),Promise.reject(W)})}$onItemSelected(D){this.c?.(D)}showInput(D,b=v.CancellationToken.None){return this.d=D?.validateInput,u.$input(D,typeof this.d=="function",b).then(void 0,k=>{if(!(0,$.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const b=await this.d(D);if(!b||typeof b=="string")return b;let k;switch(b.severity){case T.InputBoxValidationSeverity.Info:k=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=R.default.Error;break;default:k=b.message?R.default.Error:R.default.Ignore;break}return{content:b.message,severity:k}}async showWorkspaceFolderPick(D,b=v.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(f=>f.uri.toString()===k.uri.toString())}createQuickPick(D){const b=new p(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(D){const b=new h(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(D,b){this.e.get(D)?._fireDidChangeValue(b)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,b){const k=this.e.get(D);k instanceof p&&k._fireDidChangeActive(b)}$onDidChangeSelection(D,b){const k=this.e.get(D);k instanceof p&&k._fireDidChangeSelection(b)}$onDidTriggerButton(D,b){this.e.get(D)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(D,b,k){const C=this.e.get(D);C instanceof p&&C._fireDidTriggerItemButton(b,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,b){this.x=D,this.y=b,this._id=p.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new I.$ke,this.q=new I.$ke,this.r=new I.$ke,this.s=new I.$ke,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const b=(0,a.$dH)(this.x,"quickInputButtonLocation");!b&&D.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((k,C)=>{const f=k===T.$8O.Back?-1:C;this.o.set(f,k)}),this.z({buttons:D.map((k,C)=>({...m(k.iconPath),tooltip:k.tooltip,handle:k===T.$8O.Back?-1:C,location:b?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const b=this.o.get(D);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(D){if(!this.v){for(const b of Object.keys(D)){const k=D[b];this.u[b]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$FO)return{id:E.id};const D=l(E),b=g(E);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof b=="string"?A.URI.file(b):b}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function l(E){return typeof E=="object"&&"dark"in E?E.dark:E}function m(E){const D=t(E);let b,k;return"id"in D?k=y.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:k}}class p extends r{constructor(D,b){super(D,b),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new I.$ke,this.L=[],this.M=new I.$ke,this.N=new I.$ke,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((C,f)=>{this.C.set(f,C),this.D.set(C,f)});const b=(0,a.$dH)(this.x,"quickPickItemTooltip"),k=[];for(let C=0;C<D.length;C++){const f=D[C];if(f.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=f.iconPath?m(f.iconPath):void 0;k.push({handle:C,label:f.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((F,N)=>({...m(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(D){const b=(0,s.$Gb)(D.map(k=>this.C.get(k)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(D){const b=(0,s.$Gb)(D.map(k=>this.C.get(k)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(D,b){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const C=k.buttons[b];C&&this.N.fire({button:C,item:k})}}class h extends r{constructor(D,b){super(D,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(o,c)}}),define(Oe[253],Ne([1,0,2,6,71,4,10,5,17,145,11,18,36,34,8,24,15,20]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=e.$Wqc=void 0;function i(N){return N instanceof v.URI}function r(N,L){return N.scheme===o.Schemas.file&&L.scheme===o.Schemas.file&&c.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function l(N){const L=g(N.icon),W=N.labels?.map(J=>({title:J.title,icon:g(J.icon)}));return{...N,icon:L,labels:W}}function m(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,J=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,s.$Ir)(W,J)}function p(N,L){let W=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(W=m(N,L),W!==0)return W;if(N.light&&L.light)W=m(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(W!==0)return W;if(N.dark&&L.dark)W=m(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return W}function h(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const J=N.arguments[W],M=L.arguments[W];if(J!==M&&!(i(J)&&i(M)&&r(J,M)))return J<M?-1:1}return 0}function E(N,L){let W=(0,s.$Ir)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&L.command)W=h(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(W!==0)return W;if(N.decorations&&L.decorations)W=p(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)W=(0,s.$Ir)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)W=(0,s.$Ir)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return W}function D(N,L){for(let W=0;W<N.length;W++)if(N[W]!==L[W])return!1;return!0}function b(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function k(N,L){return(0,$.$tb)(N,L,b)}class C{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,n.$eH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,n.$eH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,n.$eH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,W,J,M,K){this.k=L,this.m=M,this.n=K,this.d="",this.e=new I.$ke,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=J}showValidationMessage(L,W){(0,n.$eH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,W)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$Wqc=C;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,W,J,M,K,Z,ue){this.s=L,this.t=W,this.u=J,this.v=M,this.w=K,this.multiDiffEditorEnableViewChanges=Z,this.x=ue,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new I.$ke,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new I.$ke,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,W){const J=this.h.get(L);return J?(0,A.$vh)(()=>this.t.executeCommand(J.command,...J.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),J=(0,$.$Cb)(this.p,L,E).map(Z=>{const ue=Z.toInsert.map(_=>{const ge=this.e++;this.g.set(ge,_);const se=_.resourceUri;let ae;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const x=new O.$Sc;ae=this.t.converter.toInternal(_.command,x),this.j.set(ge,x)}else this.h.set(ge,_.command);const $e=(0,n.$dH)(this.x,"scmMultiDiffEditor"),oe=$e?_.multiDiffEditorOriginalUri:void 0,ke=$e?_.multiFileDiffEditorModifiedUri:void 0,Le=t(_.decorations),Y=_.decorations&&t(_.decorations.light)||Le,q=_.decorations&&t(_.decorations.dark)||Le,te=[Y,q],ve=_.decorations&&_.decorations.tooltip||"",ce=_.decorations&&!!_.decorations.strikeThrough,we=_.decorations&&!!_.decorations.faded,he=_.contextValue||"";return{rawResource:[ge,se,te,ve,ce,we,he,ae,oe,ke],handle:ge}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:ue}}),M=J.map(({start:Z,deleteCount:ue,toInsert:_})=>[Z,ue,_.map(ge=>ge.rawResource)]),K=J.reverse();for(const{start:Z,deleteCount:ue,toInsert:_}of K){const ge=_.map(ae=>ae.handle),se=this.o.splice(Z,ue,...ge);for(const ae of se)this.g.delete(ae),this.h.delete(ae),this.j.get(ae)?.dispose(),this.j.delete(ae)}return this.p=L,M}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let W;(0,n.$dH)(this.y,"quickDiffProvider")&&(W=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:W})}get historyProvider(){return(0,n.$eH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,n.$eH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Sc,this.p=L;const W=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,n.$eH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,n.$eH)(this.y,"scmActionButton"),this.q.value=new O.$Sc,this.s=L;const W=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(J=>J.map(M=>this.z.converter.toInternal(M,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&k(this.u,L))return;this.t.value=new O.$Sc,this.u=L;const W=(L||[]).map(J=>this.z.converter.toInternal(J,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(L,W,J,M,K,Z,ue){this.y=L,this.z=M,this.A=K,this.B=Z,this.C=ue,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Uc,this.n=void 0,this.o=new O.$Uc,this.p=void 0,this.q=new O.$Uc,this.t=new O.$Uc,this.u=void 0,this.v=!1,this.w=new I.$ke,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=J;const _=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${K}/scm${this.x}/input`,query:ue?`rootUri=${encodeURIComponent(ue.toString())}`:void 0});this.f=new C(L,W,this.#e,this.x,_),this.#e.$registerSourceControl(this.x,K,Z,ue,_)}createResourceGroup(L,W,J){const M=(0,n.$dH)(this.y,"scmMultiDiffEditor")&&J?.multiDiffEditorEnableViewChanges===!0,K=new f(this.#e,this.z,this.x,L,W,M,this.y),Z=I.Event.once(K.onDidDispose)(()=>this.D.delete(K));return this.D.set(K,Z),this.eventuallyAddResourceGroups(),K}eventuallyAddResourceGroups(){const L=[],W=[];for(const[J,M]of this.D){M.dispose();const K=J.onDidUpdateResourceStates(()=>{this.E.add(J),this.eventuallyUpdateResourceStates()});I.Event.once(J.onDidDispose)(()=>{this.E.delete(J),K.dispose(),this.e.delete(J.handle),this.#e.$unregisterGroup(this.x,J.handle)}),L.push([J.handle,J.id,J.label,J.features,J.multiDiffEditorEnableViewChanges]);const Z=J._takeResourceStateSnapshot();Z.length>0&&W.push([J.handle,Z]),this.e.set(J.handle,J)}this.#e.$registerGroups(this.x,L,W),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(W=>{const J=W._takeResourceStateSnapshot();J.length!==0&&L.push([W.handle,J])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ge([(0,P.$9h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,P.$9h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,W,J,M){this.m=W,this.n=J,this.o=M,this.g=new Map,this.h=new y.$rn,this.j=new I.$ke,this.e=L.getProxy(T.$EN.MainThreadSCM),this.f=L.getProxy(T.$EN.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:K=>{if(K&&K.$mid===a.MarshalledId.ScmResource){const Z=this.g.get(K.sourceControlHandle);if(!Z)return K;const ue=Z.getResourceGroup(K.groupHandle);return ue?ue.getResourceState(K.handle):K}else if(K&&K.$mid===a.MarshalledId.ScmResourceGroup){const Z=this.g.get(K.sourceControlHandle);return Z?Z.getResourceGroup(K.groupHandle):K}else if(K&&K.$mid===a.MarshalledId.ScmProvider){const Z=this.g.get(K.handle);return Z||K}return K}})}createSourceControl(L,W,J,M){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,W,J,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const K=u.d++,Z=new w(L,this.n,this.e,this.m,W,J,M);this.g.set(K,Z);const ue=this.h.get(L.identifier)||[];return ue.push(Z),this.h.set(L.identifier,ue),Z}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const W=this.h.get(L.identifier),J=W&&W[W.length-1];return J&&J.inputBox}$provideOriginalResource(L,W,J){const M=v.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",L,M.toString());const K=this.g.get(L);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$vh)(()=>K.quickDiffProvider.provideOriginalResource(M,J)).then(Z=>Z||null)}$onInputBoxValueChange(L,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const J=this.g.get(L);return J&&J.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(L,W,J,M){this.o.trace("ExtHostSCM#$executeResourceCommand",L,W,J);const K=this.g.get(L);if(!K)return Promise.resolve(void 0);const Z=K.getResourceGroup(W);return Z?Z.$executeResourceCommand(J,M):Promise.resolve(void 0)}$validateInput(L,W,J){this.o.trace("ExtHostSCM#$validateInput",L);const M=this.g.get(L);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.$vh)(()=>M.inputBox.validateInput(W,J)).then(K=>{if(!K)return Promise.resolve(void 0);const Z=d.MarkdownString.fromStrict(K.message);return Z?Promise.resolve([Z,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,W,J,M){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,J,M)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,W,J){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,J)??void 0}async $provideHistoryItems(L,W,J,M){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(W,J,M))?.map(ue=>l(ue))??void 0}async $provideHistoryItems2(L,W,J){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(W,J))?.map(Z=>l(Z))??void 0}async $provideHistoryItemSummary(L,W,J,M){const K=this.g.get(L)?.historyProvider;if(typeof K?.provideHistoryItemSummary!="function")return;const Z=await K.provideHistoryItemSummary(W,J,M);return Z?l(Z):void 0}async $provideHistoryItemChanges(L,W,J,M){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(W,J,M)??void 0}};e.$Xqc=F,e.$Xqc=F=u=Ge([Ve(3,R.$$j)],F)}),define(Oe[254],Ne([1,0,5,8,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0;class O{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(v.$EN.MainThreadShare)}async $provideShare(T,$,s){return await this.c.get(T)?.provideShare({selection:I.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},s)??void 0}registerShareProvider(T,$){const s=O.a++;return this.c.set(s,$),this.b.$registerShareProvider(s,I.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$Yqc=O}),define(Oe[255],Ne([1,0,7,5,9,4,8,14]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=e.$1qc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$GO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$GO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,n,o,c=v.StatusBarAlignment.Left,u){if(this.i=!1,this.k="",this.q=new O.$Sc,this.#e=a,this.#t=S,o&&n){this.c=(0,v.$iO)(n.identifier,o);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,u=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=n,this.f=o,this.g=c,this.h=this.u(u)}u(a){if((0,T.$hg)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!$.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new O.$Sc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,P.localize)(10771,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,n,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$1qc=$;class s{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(10772,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$GN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(a,S){this.e=new Map,this.a=a.getProxy(I.$EN.MainThreadStatusBar),this.b=S,this.c=new s(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,n){return new $(this.a,this.b,this.e,a,S,d,n)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let n;return typeof S=="number"?n=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$GN(()=>{d.dispose(),clearTimeout(n)})}}e.$2qc=R}),define(Oe[125],Ne([1,0,32,116,54,81,55,8,2]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=e.$qQ=void 0,v=We(v),T=We(T);const s=(i,r,t,g)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(m){if(!t(l,m)){const p=l;l=m,i.listener?.(g(m,p))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(g=>t.id===g.id)))},a=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),S=(i,r)=>({range:(()=>{let t;const g=a(l=>({range:v.$Mt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,l)||(t=l,i.listener?.(g(l)))}}})(),label:s(i,r,y.label,a(t=>({label:t}))),description:s(i,void 0,y.description,a(t=>({description:t}))),sortText:s(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:s(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,y.busy,a(t=>({busy:t}))),error:s(i,void 0,y.error,a(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),d=i=>{const r=P.$4I.fromString(i.extId),t=new o(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,A.$0I)(g).tagId})),t},n=i=>{let r;for(const t of i.tests){const g=d(t.item);(0,I.$aQ)(g).parent=r,r=g}return r};e.$qQ=n;class o{constructor(r,t,g,l){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,I.$_P)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof c?void 0:m.parent}},children:{value:(0,O.$$P)(m,I.$aQ,o),enumerable:!0,writable:!1},...S(m,g)})}}e.$rQ=o;class c extends o{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$sQ=c;class u extends O.$7P{constructor(r,t,g){super({controllerId:r,getDocumentVersion:l=>l&&g.getDocument(l)?.version,getApiFor:I.$aQ,getChildren:l=>l.children,root:new c(r,t),toITestItem:T.TestItem.from})}}e.$tQ=u}),define(Oe[33],Ne([1,0,14,7,8,25,5,17,11,40,32,101,2,4,3,16,125,22,38,42,69,63,66,37]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.$AQ=e.$zQ=void 0,I=We(I),P=We(P);let m=class{#e;#t;#i;constructor(k,C,f){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$EN.MainThreadCommands),this.d=C,this.#i=f,this.#t=k.getProxy(A.$EN.MainThreadTelemetry),this.converter=new p(this,w=>{const F=this.c.get(w);return F?.result===E.Void?F:void 0},C),this.f=[{processArgument(w){return(0,s.$ai)(w)}},{processArgument(w){return(0,O.$eo)(w,function(F){if(R.$Mt.isIRange(F))return P.Range.to(F);if(y.$Lt.isIPosition(F))return P.Position.to(F);if(R.$Mt.isIRange(F.range)&&a.URI.isUri(F.uri))return P.location.to(F);if(F instanceof c.$Me)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const C=this.registerCommand(!1,k.id,async(...f)=>{const w=k.args.map((N,L)=>{if(!N.validate(f[L]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return N.convert(f[L])}),F=await this.executeCommand(k.internalId,...w);return k.result.convert(F,f,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new I.$GN(()=>{C.dispose(),this.c.delete(k.id)})}registerCommand(k,C,f,w,F,N){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:f,thisArg:w,metadata:F,extension:N}),k&&this.#e.$registerCommand(C),new I.$GN(()=>{this.b.delete(C)&&k&&this.#e.$unregisterCommand(C)})}executeCommand(k,...C){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,C,!0)}async g(k,C,f){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,C,!1);{let w=!1;const F=(0,O.$eo)(C,function(N){if(N instanceof I.$HN)return P.Position.from(N);if(N instanceof I.$IN)return P.Range.from(N);if(N instanceof I.$UN)return P.location.from(N);if(I.$$O.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,c.$Me.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,c.$Me.wrap(N);if(N instanceof c.$Me)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,w?new u.$Vw(F):F,f);return(0,s.$ai)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,C,!1);throw N}}}async h(k,C,f){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:L}=w;if(L?.args)for(let J=0;J<L.args.length;J++)try{(0,v.$ug)(C[J],L.args[J].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${L.args[J].name}' - ${L.args[J].description}`)}const W=r.$ee.create();try{return await F.apply(N,C)}catch(J){if(k===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...C);M&&(k=M.command)}if(this.d.error(J,k,w.extension?.identifier),!f)throw J;if(w.extension?.identifier){const M=this.#i.onExtensionError(w.extension.identifier,J);this.d.trace("forwarded error to extension?",M,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$oj)(J)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,W.elapsed())}}j(k,C,f){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$vp(C),duration:f})}$executeContributedCommand(k,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const f=this.b.get(k);return f?(C=C.map(w=>this.f.reduce((F,N)=>N.processArgument(F,f.extension?.identifier),w)),this.h(k,C,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(C=>(k&&(C=C.filter(f=>f[0]!=="_")),C))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[C,f]of this.b){const{metadata:w}=f;w&&(k[C]=w)}return Promise.resolve(k)}};e.$zQ=m,e.$zQ=m=Ge([Ve(0,n.$eQ),Ve(1,$.$$j),Ve(2,g.$yQ)],m),e.$AQ=(0,d.$Di)("IExtHostCommands");class p{constructor(k,C,f){this.d=k,this.f=C,this.g=f,this.delegatingCommandId=`__vsc${(0,l.$Zg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,C){if(!k)return;const f={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return f;const w=this.f(k.command);if(w)f.id=w.internalId,f.arguments=w.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),C.add((0,S.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),f.$ident=F,f.id=this.delegatingCommandId,f.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return f}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const C=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$BQ=p;class h{static{this.Uri=new h("uri","Uri of a text document",k=>a.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>I.$HN.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>I.$IN.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>I.$JN.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,C=>Array.isArray(C)&&C.every(f=>k.validate(f)),C=>C.map(f=>k.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof I.$7N,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof I.$tP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof o.$rQ,P.TestItem.from)}constructor(k,C,f,w){this.name=k,this.description=C,this.validate=f,this.convert=w}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,C){return new h(k??this.name,C??this.description,this.validate,this.convert)}}e.$CQ=h;class E{static{this.Void=new E("no result",k=>k)}constructor(k,C){this.description=k,this.convert=C}}e.$DQ=E;class D{constructor(k,C,f,w,F){this.id=k,this.internalId=C,this.description=f,this.args=w,this.result=F}}e.$EQ=D}),define(Oe[256],Ne([1,0,17,15,2,93,103,31,33,8,7]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0,O=We(O),s=We(s),R=We(R);const y=[new $.$EQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of DocumentHighlight-instances.",S(s.DocumentHighlight.to))),new $.$EQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$CQ.Uri],new $.$DQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,v.$Jb)(n))return;class c extends R.$2N{static to(i){const r=new c(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new R.$UN(o[0],s.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=s.Range.to(i.selectionRange),r.children=i.children?i.children.map(c.to):[],r}}return n.map(c.to)})),new $.$EQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$CQ.Uri,new $.$CQ("options","Formatting options",n=>!0,n=>n)],new $.$DQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$EQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$CQ.Uri,$.$CQ.Range,new $.$CQ("options","Formatting options",n=>!0,n=>n)],new $.$DQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$EQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$CQ.Uri,$.$CQ.Position,new $.$CQ("ch","Trigger character",n=>typeof n=="string",n=>n),new $.$CQ("options","Formatting options",n=>!0,n=>n)],new $.$DQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$EQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$EQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$EQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$EQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$EQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Location-instances.",S(s.location.to))),new $.$EQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of Hover-instances.",S(s.Hover.to))),new $.$EQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$CQ.Uri,new $.$CQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>R.$HN.isPosition(o)),n=>n.map(s.Position.from))],new $.$DQ("A promise that resolves to an array of ranges.",n=>n.map(o=>{let c;for(const u of o.reverse())c=new R.$6N(s.Range.to(u),c);return c}))),new $.$EQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$CQ.String.with("query","Search string")],new $.$DQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(s.WorkspaceSymbol.to))),new $.$EQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(s.CallHierarchyItem.to))),new $.$EQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$CQ.CallHierarchyItem],new $.$DQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(s.CallHierarchyIncomingCall.to))),new $.$EQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$CQ.CallHierarchyItem],new $.$DQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(s.CallHierarchyOutgoingCall.to))),new $.$EQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:s.Range.to(n.range),placeholder:n.text}})),new $.$EQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$CQ.Uri,$.$CQ.Position,$.$CQ.String.with("newName","The new symbol name")],new $.$DQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return s.WorkspaceEdit.to(n)}})),new $.$EQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$CQ.Uri,$.$CQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$DQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(s.DocumentLink.to))),new $.$EQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$CQ.Uri],new $.$DQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$2O(n.tokenTypes,n.tokenModifiers)})),new $.$EQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$CQ.Uri],new $.$DQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Rdb)(n);if(o.type==="full")return new R.$4O(o.data,void 0)})),new $.$EQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$CQ.Uri,$.$CQ.Range.optional()],new $.$DQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$2O(n.tokenTypes,n.tokenModifiers)})),new $.$EQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$CQ.Uri,$.$CQ.Range],new $.$DQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$Rdb)(n);if(o.type==="full")return new R.$4O(o.data,void 0)})),new $.$EQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$CQ.Uri,$.$CQ.Position,$.$CQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$CQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$DQ("A promise that resolves to a CompletionList-instance.",(n,o,c)=>{if(!n)return new R.$fO([]);const u=n.suggestions.map(i=>s.CompletionItem.to(i,c));return new R.$fO(u,n.incomplete)})),new $.$EQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$CQ.Uri,$.$CQ.Position,$.$CQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$DQ("A promise that resolves to SignatureHelp.",n=>{if(n)return s.SignatureHelp.to(n)})),new $.$EQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$CQ.Uri,$.$CQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$DQ("A promise that resolves to an array of CodeLens-instances.",(n,o,c)=>S(u=>new R.$0N(s.Range.to(u.range),u.command&&c.fromInternal(u.command)))(n))),new $.$EQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$CQ.Uri,new $.$CQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$IN.isRange(n),n=>R.$JN.isSelection(n)?s.Selection.from(n):s.Range.from(n)),$.$CQ.String.with("kind","Code action kind to return code actions for").optional(),$.$CQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$DQ("A promise that resolves to an array of Command-instances.",(n,o,c)=>S(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(u.command)}else{const i=new R.$4N(u.title,u.kind?new R.$5N(u.kind):void 0);return u.edit&&(i.edit=s.WorkspaceEdit.to(u.edit)),u.command&&(i.command=c.fromInternal(u.command)),i.isPreferred=u.isPreferred,i}})(n))),new $.$EQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$CQ.Uri],new $.$DQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new R.$lO(s.Range.to(o.range),s.Color.to(o.color))):[])),new $.$EQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$CQ("color","The color to show and insert",n=>n instanceof R.$kO,s.Color.from),new $.$CQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:s.Range.from(n.range)}))],new $.$DQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(s.ColorPresentation.to):[])),new $.$EQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$CQ.Uri,$.$CQ.Range],new $.$DQ("A promise that resolves to an array of Inlay objects",(n,o,c)=>n.map(s.InlayHint.to.bind(void 0,c)))),new $.$EQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$CQ.Uri],new $.$DQ("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(s.FoldingRange.to)})),new $.$EQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$DQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>s.NotebookExclusiveDocumentPattern.to(o))})))),new $.$EQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$CQ.Uri,$.$CQ.Range,new $.$CQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$IN,n=>s.InlineValueContext.from(n))],new $.$DQ("A promise that resolves to an array of InlineValue objects",n=>n.map(s.InlineValue.to))),new $.$EQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$CQ("uriOrString","Uri-instance or string (only http/https)",n=>P.URI.isUri(n)||typeof n=="string"&&(0,I.$Ng)(n,I.Schemas.http,I.Schemas.https),n=>n),new $.$CQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional(),$.$CQ.String.with("label","").optional()],$.$DQ.Void),new $.$EQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$CQ.Uri.with("resource","Resource to open"),$.$CQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$CQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional()],$.$DQ.Void),new $.$EQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$CQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$CQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$CQ.String.with("title","Human readable title for the diff editor").optional(),new $.$CQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)]).optional()],$.$DQ.Void),new $.$EQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$CQ.String.with("title","Human readable title for the changes editor"),new $.$CQ("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[c,u,i]=o;if(!P.URI.isUri(c)||!P.URI.isUri(u)&&u!==void 0&&u!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],$.$DQ.Void),new $.$EQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$CQ.Uri,$.$CQ.Position],new $.$DQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$EQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$CQ.TypeHierarchyItem],new $.$DQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$EQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$CQ.TypeHierarchyItem],new $.$DQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$EQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$CQ.TestItem],$.$DQ.Void),new $.$EQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$CQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$DQ.Void),new $.$EQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$CQ.String.with("name","The context key name"),new $.$CQ("value","The context key value",()=>!0,n=>n)],$.$DQ.Void),new $.$EQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$CQ.Uri,$.$CQ.StringArray,new $.$CQ("MappedEditsContext","Mapped Edits Context",n=>s.MappedEditsContext.is(n),n=>s.MappedEditsContext.from(n))],new $.$DQ("A promise that resolves to a workspace edit or null",n=>n?s.WorkspaceEdit.to(n):null)),new $.$EQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$CQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?s.Range.from(n.initialRange):void 0,initialSelection:R.$JN.isSelection(n.initialSelection)?s.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?s.Position.from(n.position):void 0}})],$.$DQ.Void)];class a{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",T.$Cj)}}e.$epc=a;function S(n){return o=>{if(Array.isArray(o))return o.map(n)}}function d(n){if(!Array.isArray(n))return;const o=[];for(const c of n)O.$Ju(c)?o.push(s.DefinitionLink.to(c)):o.push(s.location.to(c));return o}}),define(Oe[257],Ne([1,0,2,33]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0;class P{constructor(A,T,$,s,R){this.a=T,this.b=$,this.c=s;const y=new I.$EQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.$CQ("showOptions","Show Options",a=>!0,a=>a),new I.$CQ("resource","Interactive resource Uri",a=>!0,a=>a),new I.$CQ("controllerId","Notebook controller Id",a=>!0,a=>a),new I.$CQ("title","Interactive editor title",a=>!0,a=>a)],new I.$DQ("Notebook and input URI",a=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,$,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Fqc=P}),define(Oe[258],Ne([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,38,198]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,e.$Oqc=h,S=We(S);let r=class{constructor(D,b,k,C,f){this.m=b,this.n=k,this.o=C,this.q=f,this.b=new T.$zc,this.c=new T.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ke,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$EN.MainThreadNotebookKernels);const w=new a.$EQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$CQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],a.$DQ.Void),F=new a.$EQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$CQ.Uri],new a.$DQ("A promise that resolves to an array of variables",(N,L)=>N.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(F)}createNotebookController(D,b,k,C,f,w){for(const oe of this.j.values())if(oe.controller.id===b&&s.$pn.equals(D.identifier,oe.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${b}`);const L=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${D.identifier}'`);let W=!1;const J=new O.$ke,M=new O.$ke,K={id:h(D.identifier,b),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:C||D.identifier.value,preloads:w?w.map(S.NotebookRendererScript.from):[]};let Z=f??L,ue,_;this.a.$addKernel(F,K).catch(oe=>{console.log(oe),W=!0});let ge=0;const se=()=>{if(W)return;const oe=++ge;Promise.resolve().then(()=>{oe===ge&&this.a.$updateKernel(F,K)})},ae=new T.$zc,$e={get id(){return b},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:J.event,get label(){return K.label},set label(oe){K.label=oe??D.displayName??D.name,se()},get detail(){return K.detail??""},set detail(oe){K.detail=oe,se()},get description(){return K.description??""},set description(oe){K.description=oe,se()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(oe){K.supportedLanguages=oe,se()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){K.supportsExecutionOrder=oe,se()},get rendererScripts(){return K.preloads?K.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(oe){Z=oe??L},get interruptHandler(){return ue},set interruptHandler(oe){ue=oe,K.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,c.$eH)(D,"notebookVariableProvider"),_=oe,K.hasVariableProvider=!!oe,oe?.onDidChangeVariables(ke=>N.a.$variablesUpdated(ke.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(oe){if(W)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,h(D.identifier,this.id))},createNotebookExecution(oe){if((0,c.$eH)(D,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,h(D.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${F}], DISPOSED`),W=!0,this.j.delete(F),J.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(oe,ke){ke===d.NotebookControllerAffinity2.Hidden&&(0,c.$eH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,oe.uri,ke)},onDidReceiveMessage:M.event,postMessage(oe,ke){return(0,c.$eH)(D,"notebookMessaging"),N.a.$postMessage(F,ke&&N.n.getIdByEditor(ke),oe)},asWebviewUri(oe){return(0,c.$eH)(D,"notebookMessaging"),(0,n.$yDb)(oe,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:$e,onDidReceiveMessage:M,onDidChangeSelection:J,associatedNotebooks:ae}),$e}getIdByController(D){for(const[b,k]of this.j)if(k.controller===D)return h(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,b){const k=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,b);const f={dispose:()=>{this.f.delete(k),C.a.$removeKernelDetectionTask(k)}};return this.f.set(k,f),f}registerKernelSourceActionProvider(D,b,k){const C=this.i++,f=typeof k.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,w=this;this.h.set(C,k),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,b);let F;return f!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(C),w.a.$removeKernelSourceActionProvider(C,C),F?.dispose()}}}async $provideKernelSourceActions(D,b){const k=this.h.get(D);if(k){const C=new A.$Sc;return(await k.provideNotebookKernelSourceActions(b)??[]).map(w=>S.NotebookKernelSourceAction.from(w,this.o.converter,C))}return[]}$acceptNotebookAssociation(D,b,k){const C=this.j.get(D);if(C){const f=this.n.getNotebookDocument($.URI.revive(b));k?C.associatedNotebooks.set(f.uri,!0):C.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),k),C.onDidChangeSelection.fire({selected:k,notebook:f.apiNotebook})}}async $executeCells(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(b)),w=[];for(const F of k){const N=f.getCell(F);N&&w.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),w.length),await C.controller.executeHandler.call(C.controller,w,f.apiNotebook,C.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(b));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,f.apiNotebook);else for(const w of k){const F=f.getCell(w);F&&this.b.get(F.uri)?.cancel()}if(C.controller.interruptHandler){const w=this.c.get(f.uri);this.c.delete(f.uri),k.length&&Array.isArray(w)&&w.length&&w.forEach(F=>F.dispose())}}async $provideVariables(D,b,k,C,f,w,F){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument($.URI.revive(k)),W=N.controller.variableProvider;if(!W)return;let J;if(C!==void 0){if(J=this.s[C],!J)return}else this.s={};const M=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,K=W.provideVariables(L.apiNotebook,J,M,w,F);let Z=0;for await(const ue of K){if(F.isCancellationRequested)return;const _={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,interfaces:ue.variable.interfaces,language:ue.variable.language,expression:ue.variable.expression,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[_.id]=ue.variable,this.a.$receiveVariable(b,_),Z++>=i.$WK)return}}$acceptKernelMessageFromRenderer(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getEditorById(b);C.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:k}))}$cellExecutionChanged(D,b,k){const f=this.n.getNotebookDocument($.URI.revive(D)).getCell(b);if(f){const w=k?S.NotebookCellExecutionState.to(k):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:f.apiCell,state:w})}}_createNotebookCellExecution(D,b){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const f=new g(b,C,this.a);this.b.set(C.uri,f);const w=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),w.dispose(),this.b.delete(C.uri))});return f.asApiObject()}_createNotebookExecution(D,b){const k=this.n.getNotebookDocument(D.uri),C=D.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const f=new m(b,k,this.a),w=f.onDidChangeState(()=>{f.state===l.Resolved&&(f.dispose(),w.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[f,w]),f.asApiObject()}};e.$Nqc=r,e.$Nqc=r=Ge([Ve(4,R.$$j)],r);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(D,b,k){super(),this.m=b,this.n=k,this.b=g.a++,this.c=new O.$ke,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$ve),this.h=new p(10,C=>this.s(C)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const b=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new u.$Vw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let b=this.m;if(D&&(b=this.m.notebook.getCellFromApiCell(D)),!b)throw new Error("INVALID cell");return b.handle}y(D){return D.map(b=>{const k=d.$cP.ensureUniqueMimeTypes(b.items,!0);return k===b.items?S.NotebookCellOutput.from(b):S.NotebookCellOutput.from({items:k,id:b.id,metadata:b.metadata})})}async z(D,b,k){const C=this.w(b),f=this.y((0,v.$1b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:C,append:k,outputs:f})}async C(D,b,k){return D=d.$cP.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:b.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,C,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const w=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new u.$Vw({runEndTime:C,lastRunSuccess:k,error:w}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,C){return D.t(),D.z(k,C,!0)},replaceOutput(k,C){return D.t(),D.z(k,C,!1)},appendOutputItems(k,C){return D.t(),D.C(k,C,!0)},replaceOutputItems(k,C){return D.t(),D.C(k,C,!1)}})}}var l;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(l||(l={}));class m extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(D,b,k){super(),this.h=b,this.j=k,this.b=m.a++,this.c=new O.$ke,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new P.$ve),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class p{constructor(D,b){this.f=D,this.g=b,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new I.$1h,this.b=Date.now(),(0,I.$Eh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Oe[56],Ne([1,0,6,5,3,2,16,4,7,9,13,179,21,37,180,181,34,10,8,33,36]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=e.$Upc=e.$Tpc=e.$Spc=void 0,e.$Spc=(0,P.$Di)("IExtHostTerminalService");class t extends T.$Tc{constructor(f,w,F,N){super(),this.u=f,this._id=w,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$ke),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(W,J=!0){L.C(),L.u.$sendText(L._id,W,J)},show(W){L.C(),L.u.$show(L._id,W)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??w?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:o.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(f.location,w?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,w,F,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:o.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(f,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,w){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in f?{viewColumn:u.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,w){this.j=Object.freeze({code:f,reason:w})}setDimensions(f,w){return f===this.f&&w===this.h||f===0||w===0?!1:(this.f=f,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(w=>{w!==f&&(this.b=Promise.resolve(f))})}}e.$Tpc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$ke,this.onProcessData=this.a.event,this.b=new v.$ke,this.d=new v.$ke,this.onDidChangeProperty=this.d.event,this.f=new v.$ke,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,w){this.g.setDimensions?.({columns:f,rows:w})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,m=class extends T.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,w,F){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$ke,this.onDidCloseTerminal=this.H.event,this.I=new v.$ke,this.onDidOpenTerminal=this.I.event,this.J=new v.$ke,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$ke,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$ke,this.onDidChangeTerminalState=this.M.event,this.N=new v.$ke,this.onDidChangeShell=this.N.event,this.O=new v.$ke({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$ke({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(I.$EN.MainThreadTerminalService),this.y=new n.$Oxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const L=W=>{const J=W;return this.getTerminalById(J.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===r.MarshalledId.TerminalContext;W++)N[W]=L(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,w){const F=new t(this.a,(0,S.$Zg)(),f,f.name),N=new g(f.pty);return F.createExtensionTerminal(f.location,w,this.R(f,w).resolvedExtHostIdentifier,D(f.iconPath),b(f.color)).then(L=>{const W=this.S(L,N);this.h[L]=W}),this.f.push(F),F.value}R(f,w){if(w=w||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const F=f.location.parentTerminal;if(F){const N=this.f.find(L=>L.value===F);N&&(w.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?w.location=f.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(f,w){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(w),L=this.S(f,N);this.h[f]=L}async $acceptActiveTerminalChanged(f){const w=this.b;if(f===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(f);F&&(this.b=F,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,w){const F=this.getTerminalById(f);F&&this.O.fire({terminal:F.value,data:w})}async $acceptTerminalDimensions(f,w,F){const N=this.getTerminalById(f);N&&N.setDimensions(w,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,w){const F=this.getTerminalById(f);F&&this.P.fire({terminal:F.value,...w})}async $acceptTerminalMaximumDimensions(f,w,F){this.g.get(f)?.resize(w,F)}async $acceptTerminalTitleChange(f,w){const F=this.getTerminalById(f);F&&(F.name=w)}async $acceptTerminalClosed(f,w,F){const N=this.X(this.f,f);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(w,F),this.H.fire(L.value)}}$acceptTerminalOpened(f,w,F,N){if(w){const J=this.X(this.f,w);if(J!==null){this.f[J]._id=f,this.I.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new t(this.a,f,L,F);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,w){this.getTerminalById(f)?._setProcessId(w)}async $startExtensionTerminal(f,w){const F=this.getTerminalById(f);if(!F)return{message:(0,s.localize)(10769,null,f)};F.isOpen||await new Promise(L=>{const W=this.onDidOpenTerminal(async J=>{J===F.value&&(W.dispose(),L())})});const N=this.g.get(f);N?N.startSendingEvents(w):this.j[f]={initialDimensions:w}}S(f,w){const F=new T.$Sc;F.add(w.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),F.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,w.onProcessData),F.add(w.onProcessExit(L=>this.U(f,L))),this.g.set(f,w);const N=this.j[f];return N&&w instanceof g&&(w.startSendingEvents(N.initialDimensions),delete this.j[f]),F}$acceptProcessAckDataEvent(f,w){this.g.get(f)?.acknowledgeDataEvent(w)}$acceptProcessInput(f,w){this.g.get(f)?.input(w)}$acceptTerminalInteraction(f){const w=this.getTerminalById(f);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(f,w){this.getTerminalById(f)?.setSelection(w)}$acceptProcessResize(f,w,F){try{this.g.get(f)?.resize(w,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,w){this.g.get(f)?.shutdown(w)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new $.$GN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,w,F){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,F),this.a.$registerProfileProvider(w,f.identifier.value),new $.$GN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(f,w,F){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,F),this.a.$registerQuickFixProvider(f,w),new $.$GN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,w){const F=new a.$ve().token;if(F.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const L=await N.provideTerminalQuickFixes(w,F);if(L===null||Array.isArray(L)&&L.length===0)return;const W=new T.$Sc;if(this.w.value=W,!Array.isArray(L))return L?u.TerminalQuickFix.from(L,this.Q.converter,W):void 0;const J=[];for(const M of L){const K=u.TerminalQuickFix.from(M,this.Q.converter,W);K&&J.push(K)}return J}async $createContributedProfileTerminal(f,w){const F=new a.$ve().token;let N=await this.C.get(f)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,w);return}this.createTerminalFromOptions(N.options,w)}}async $provideLinks(f,w){const F=this.getTerminalById(f);if(!F)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new a.$ve;this.G.set(f,L);const W=[],J={terminal:F.value,line:w},M=[];for(const ue of this.z)M.push(c.Promises.withAsyncBody(async _=>{L.token.onCancellationRequested(()=>_({provider:ue,links:[]}));const ge=await ue.provideTerminalLinks(J,L.token)||[];L.token.isCancellationRequested||_({provider:ue,links:ge})}));const K=await Promise.all(M);if(L.token.isCancellationRequested)return[];const Z=new Map;for(const ue of K)ue&&ue.links.length>0&&W.push(...ue.links.map(_=>{const ge={id:l++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return Z.set(ge.id,{provider:ue.provider,link:_}),ge}));return this.F.set(f,Z),W}$activateLink(f,w){const F=this.F.get(f)?.get(w);F&&F.provider.handleTerminalLink(F.link)}U(f,w){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const F=this.h[f];F&&(F.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,w)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const w=this.f.findIndex(F=>F.value===f);return w>=0?w:null}W(f,w){const F=this.X(f,w);return F!==null?f[F]:null}X(f,w){const F=f.findIndex(N=>N._id===w);return F>=0?F:null}getEnvironmentVariableCollection(f){let w=this.n.get(f.identifier.value);return w||(w=this.B(new p),this.Z(f.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(f,w){const F=(0,y.$Ds)(w.map),N=(0,y.$Es)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(f,w.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(f){f.forEach(w=>{const F=w[0],N=this.B(new p(w[1]));this.Z(F,N)})}$acceptDefaultProfile(f,w){const F=this.s;this.s=f,this.u=w,F?.path!==f.path&&this.N.fire(f.path)}Z(f,w){this.n.set(f,w),this.B(w.onDidChangeCollection(()=>{this.Y(f,w)}))}};e.$Upc=m,e.$Upc=m=Ge([Ve(1,i.$AQ),Ve(2,A.$eQ)],m);class p extends T.$Tc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$ke,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const w=this.j(f);let F=this.a.get(w);return F||(F=new h(this,f),this.a.set(w,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(f,w,F,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(f,w,F,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(f,w,F,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(f,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(f,w.scope),N=this.map.get(F),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==w.value||N.type!==w.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const W=this.h(f,w.scope),J={variable:f,...w,options:L};this.map.set(W,J),this.f.fire()}}get(f,w){const F=this.h(f,w),N=this.map.get(F);return N?k(N):void 0}h(f,w){const F=this.j(w);return F.length?`${f}:::${F}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const w=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(f)&&w.set(N.variable,k(N));return w}delete(f,w){const F=this.h(f,w);this.map.delete(F),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[w,F]of this.map)F.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(w);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,w){const F=this.j(w),N=this.descriptionMap.get(F);if(!N||N.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const W={description:L,scope:w};this.descriptionMap.set(F,W),this.f.fire()}}getDescription(f){const w=this.j(f);return this.descriptionMap.get(w)?.description}n(f){const w=this.j(f);this.descriptionMap.delete(w)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,w){this.b=f,this.d=w,this.a=new v.$ke}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,w,F){this.b.replace(f,w,F,this.d)}append(f,w,F){this.b.append(f,w,F,this.d)}prepend(f,w,F){this.b.prepend(f,w,F,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,w){this.b.getVariableMap(this.d).forEach((F,N)=>f.call(w,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends m{constructor(f,w){super(!1,f,w)}createTerminal(f,w,F){throw new R.$$}createTerminalFromOptions(f,w){throw new R.$$}};e.$Vpc=E,e.$Vpc=E=Ge([Ve(0,i.$AQ),Ve(1,A.$eQ)],E);function D(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function b(C){return o.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const f={...C};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Oe[126],Ne([1,0,7,4,3,5,16,56,6,2,10]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=e.$6qc=void 0,e.$6qc=(0,P.$Di)("IExtHostTerminalShellIntegration");let y=class extends I.$Tc{constructor(o,c){super(),this.h=c,this.b=new Map,this.c=new $.$ke,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$ke,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$ke,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$EN.MainThreadTerminalShellIntegration),this.B((0,I.$Rc)(()=>{for(const[u,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const c=this.h.getTerminalById(o);if(!c)return;const u=c.value;let i=this.b.get(o);i||(i=new a(c.value,this.f),this.b.set(o,i),i.store.add(c.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(o,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),c.shellIntegration=i.value),this.c.fire({terminal:u,shellIntegration:i.value})}$shellExecutionStart(o,c,u,i,r){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:c,confidence:u,isTrusted:i};this.b.get(o)?.startShellExecution(t,s.URI.revive(r))}$shellExecutionEnd(o,c,u,i,r){const t={value:c,confidence:u,isTrusted:i};this.b.get(o)?.endShellExecution(t,r)}$shellExecutionData(o,c){this.b.get(o)?.emitData(c)}$cwdChange(o,c){this.b.get(o)?.setCwd(s.URI.revive(c))}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$7qc=y,e.$7qc=y=Ge([Ve(0,A.$eQ),Ve(1,T.$Spc)],y);class a extends I.$Tc{get currentExecution(){return this.a}constructor(o,c){super(),this.j=o,this.m=c,this.b=!1,this.store=this.B(new I.$Sc),this.f=this.B(new $.$ke),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$ke),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$ke),this.onDidRequestEndExecution=this.h.event;const u=this;this.value={get cwd(){return u.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),u.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=u.startShellExecution(g,u.c,!0).value;return u.b=!0,l}}}startShellExecution(o,c,u){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(o,c??this.c);u?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,c){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(o){let c=!1;s.URI.isUri(this.c)?c=!s.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(c=!0),c&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(o,c){this.c=o,this.cwd=c,this.b=!1;const u=this;this.value={get commandLine(){return u.c},get cwd(){return u.cwd},read(){return u.d()}}}d(){if(!this.a){if(this.b)return R.$4h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends I.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Ch);const o=this.a;return new R.$4h(async u=>{this.b.push(u),await o.wait()})}emitData(o){for(const c of this.b)c.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Oe[127],Ne([1,0,61,13,96,8,7]),function(be,e,v,I,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=e.$lQ=void 0,O=We(O);class T{static{this.c=new P.$jQ("TextEditorDecorationType")}constructor(a,S,d){const n=T.c.nextId();a.$registerTextEditorDecorationType(S.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){a.$removeTextEditorDecorationType(n)}})}}e.$lQ=T;class ${constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof A.$HN)d=new A.$IN(a,a);else if(a instanceof A.$IN)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new A.$IN(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof A.$IN)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const n=this.c.validateRange(a);this.g.push({range:n,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,I.$6)("endOfLine");this.h=a}}class s{constructor(a,S,d,n){this.c=a,this.d=S,this._accept(d),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(c){o.n(c)},get indentSize(){return o.g},set indentSize(c){o.p(c)},get insertSpaces(){return o.j},set insertSpaces(c){o.s(c)},get cursorStyle(){return o.k},set cursorStyle(c){o.t(c)},get lineNumbers(){return o.l},set lineNumbers(c){o.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const n=this.m(a.tabSize);n==="auto"?(d=!0,S.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,S.tabSize=n)}if(typeof a.indentSize<"u"){const n=this.o(a.indentSize);n==="tabSize"?(d=!0,S.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,S.indentSize=n)}if(typeof a.insertSpaces<"u"){const n=this.q(a.insertSpaces);n==="auto"?(d=!0,S.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,S.insertSpaces=n)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$mQ=s;class R{constructor(a,S,d,n,o,c,u,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new s(this.j,this.id,c,d),this.e=u,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new I.$8("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$JN))throw(0,I.$6)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$JN)))throw(0,I.$6)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new I.$8("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new I.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new $(n.value,g);return t(l),r.m(l)},insertSnippet(t,g,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!g||Array.isArray(g)&&g.length===0)m=r.c.map(p=>O.Range.from(p));else if(g instanceof A.$HN){const{lineNumber:p,column:h}=O.Position.from(g);m=[{startLineNumber:p,startColumn:h,endLineNumber:p,endColumn:h}]}else if(g instanceof A.$IN)m=[O.Range.from(g)];else{m=[];for(const p of g)if(p instanceof A.$IN)m.push(O.Range.from(p));else{const{lineNumber:h,column:E}=O.Position.from(p);m.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,n.value.version,t.value,m,l)},setDecorations(t,g){const l=g.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$bQ(g))return S.$trySetDecorations(a,t.key,O.$cQ(g));{const m=new Array(4*g.length);for(let p=0,h=g.length;p<h;p++){const E=g[p];m[4*p]=E.start.line+1,m[4*p+1]=E.start.character+1,m[4*p+2]=E.end.line+1,m[4*p+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,m)}}))},revealRange(t,g){r.n(()=>S.$tryRevealRange(a,O.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(o=>o.range);d.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=d.length-1;o<c;o++){const u=d[o].end;if(d[o+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=S.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,n,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$nQ=R}),define(Oe[57],Ne([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,39,48]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0,v=We(v),y=We(y);class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new S.$zc,this.d=new I.$ke,this.e=new I.$ke,this.f=new I.$ke,this.g=new I.$ke,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],g=[],l=[];if(r.removedDocuments)for(const m of r.removedDocuments){const p=O.URI.revive(m),h=this.c.get(p);h?.unref()&&(this.c.delete(p),t.push(h.value))}if(r.addedDocuments)for(const m of r.addedDocuments){const p=O.URI.revive(m.uri);let h=this.c.get(p);if(h&&p.scheme!==d.Schemas.vscodeNotebookCell&&p.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);h||(h=new c(new $.$hQ(this.h.getProxy(T.$EN.MainThreadDocuments),p,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(p,h),g.push(h.value)),h.ref()}if(r.removedEditors)for(const m of r.removedEditors){const p=this.b.get(m);this.b.delete(m),p&&l.push(p)}if(r.addedEditors)for(const m of r.addedEditors){const p=O.URI.revive(m.documentUri);v.ok(this.c.has(p),`document '${p}' does not exist`),v.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const h=this.c.get(p).value,E=new R.$nQ(m.id,this.h.getProxy(T.$EN.MainThreadTextEditors),this.i,new o.$T(()=>h.document),m.selections.map(y.Selection.to),m.options,m.visibleRanges.map(D=>y.Range.to(D)),typeof m.editorPosition=="number"?y.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,E)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,P.$Oc)(t),(0,P.$Oc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(g),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$oQ=u,e.$oQ=u=Ge([Ve(0,s.$eQ),Ve(1,a.$$j)],u),e.$pQ=(0,A.$Di)("IExtHostDocumentsAndEditors")}),define(Oe[95],Ne([1,0,10,22,21,6,231,75,4,36,14,37,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=e.$dqc=e.$cqc=e.$bqc=e.$aqc=void 0,i=We(i);let h=0;const E=new WeakMap;e.$aqc=(0,a.$Di)("IExtHostTesting");let D=class extends $.$Tc{constructor(_,ge,se,ae){super(),this.C=ge,this.D=se,this.F=ae,this.f=this.B(new O.$ke),this.g=new Map,this.w=this.B(new O.$ke),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(d.$EN.MainThreadTesting),this.m=new W(this.h),this.j=new f(this.h,ge),se.registerArgumentProcessor({processArgument:$e=>{switch($e?.$mid){case s.MarshalledId.TestItemContext:{const oe=$e,ke=oe.tests[oe.tests.length-1].item.extId;return this.g.get(g.$4I.root(ke))?.collection.tree.get(ke)?.actual??(0,u.$qQ)($e)}case s.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:ke}=$e,Le=oe.item.extId;return{test:this.g.get(g.$4I.root(Le))?.collection.tree.get(Le)?.actual??(0,u.$qQ)({$mid:s.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(ke)}}default:return $e}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const $e=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=ke=>{const Le=this.g.get(g.$4I.root(ke));if(Le)return g.$4I.isRoot(ke)?Le.controller:Le.collection.tree.get(ke)?.actual};return{include:$e?.include.map(oe).filter(R.$lg)||[],exclude:$e?.exclude.map(oe).filter(R.$lg)||[]}})}createTestController(_,ge,se,ae){if(this.g.has(ge))throw new Error(`Attempt to insert a duplicate controller with ID "${ge}"`);const $e=new $.$Sc,oe=$e.add(new u.$tQ(ge,se,this.F));oe.root.label=se;const ke=new Map,Le=new Set,Y=this.h,q={items:oe.root.children,get label(){return se},set label(ve){se=ve,oe.root.label=ve,Y.$updateController(ge,{label:se})},get refreshHandler(){return ae},set refreshHandler(ve){ae=ve,Y.$updateController(ge,{canRefresh:!!ve})},get id(){return ge},createRunProfile:(ve,ce,we,he,X,x)=>{let me=(0,T.$rj)(ve);for(;ke.has(me);)me++;return new M(this.h,ke,Le,this.w.event,ge,me,ve,ce,we,he,X,x)},createTestItem(ve,ce,we){return new u.$rQ(ge,ve,ce,we)},createTestRun:(ve,ce,we=!0)=>this.j.createTestRun(_,ge,oe,ve,ce,we),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ce=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ce.map(we=>g.$4I.fromExtHostTestItem(we,ge).toString()))}},set resolveHandler(ve){oe.resolveHandler=ve},get resolveHandler(){return oe.resolveHandler},dispose:()=>{$e.dispose()}};Y.$registerTestController(ge,se,!!ae),$e.add((0,$.$Rc)(()=>Y.$unregisterTestController(ge)));const te={controller:q,collection:oe,profiles:ke,extension:_,activeProfiles:Le};return this.g.set(ge,te),$e.add((0,$.$Rc)(()=>this.g.delete(ge))),$e.add(oe.onDidGenerateDiff(ve=>Y.$publishDiff(ge,ve.map(m.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(_,ge=P.CancellationToken.None){const se=w(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.g.get(se.controllerId);if(!ae)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:K[se.kind],targets:[{testIds:_.include?.map($e=>g.$4I.fromExtHostTestItem($e,ae.collection.root.id).toString())??[ae.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map($e=>$e.id)},ge)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ge,se){return(await this.j.getCoverageDetails(_,ge,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ge){this.g.get(_)?.profiles.get(ge)?.configureHandler?.()}$setDefaultRunProfiles(_){const ge=new Map;for(const[se,ae]of Object.entries(_)){const $e=this.g.get(se);if(!$e)continue;const oe=new Map,ke=ae.filter(Y=>!$e.activeProfiles.has(Y)),Le=[...$e.activeProfiles].filter(Y=>!ae.includes(Y));for(const Y of ke)oe.set(Y,!0),$e.activeProfiles.add(Y);for(const Y of Le)oe.set(Y,!1),$e.activeProfiles.delete(Y);oe.size&&ge.set(se,oe)}this.w.fire(ge)}async $refreshTests(_,ge){await this.g.get(_)?.controller.refreshHandler?.(ge)}$publishTestResults(_){this.results=Object.freeze(_.map(ge=>{const se=i.TestResults.to(ge);return E.set(se,ge.id),se}).concat(this.results).sort((ge,se)=>se.completedAt-ge.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ge){const se=this.g.get(g.$4I.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ge<0?1/0:ge),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ge=>m.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ge)))}async $runControllerTests(_,ge){return Promise.all(_.map(se=>this.G(se,!1,ge)))}async $startContinuousRun(_,ge){const se=new P.$ve(ge),ae=await Promise.all(_.map($e=>this.G($e,!0,se.token)));return!ge.isCancellationRequested&&!ae.some($e=>$e.error)&&await new Promise($e=>ge.onCancellationRequested($e)),se.dispose(!0),ae}async $provideTestFollowups(_,ge){const se=this.results.find(oe=>E.get(oe)===_.resultId),ae=se&&Z(g.$4I.fromString(_.extId),se?.results);if(!ae)return[];let $e=[];return await Promise.all([...this.y].map(async oe=>{try{const ke=await oe.provideFollowup(se,ae,_.taskIndex,_.messageIndex,ge);ke&&($e=$e.concat(ke))}catch(ke){this.C.error("Error thrown while providing followup for test message",ke)}})),ge.isCancellationRequested?[]:$e.map(oe=>{const ke=h++;return this.z.set(ke,oe),{title:oe.title,id:ke}})}$disposeTestFollowups(_){for(const ge of _)this.z.delete(ge)}$executeTestFollowup(_){const ge=this.z.get(_);return ge?this.D.executeCommand(ge.command,...ge.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const ge of this.j.trackers){const se=ge.getTaskIdForRun(_);if(se)return{taskId:se,runId:ge.id}}}async G(_,ge,se){const ae=this.g.get(_.controllerId);if(!ae)return{};const{collection:$e,profiles:oe,extension:ke}=ae,Le=oe.get(_.profileId);if(!Le)return{};const Y=_.testIds.map(ce=>$e.tree.get(ce)).filter(R.$lg),q=_.excludeExtIds.map(ce=>ae.collection.tree.get(ce)).filter(R.$lg).filter(ce=>Y.some(we=>we.fullId.compare(ce.fullId)===g.TestPosition.IsChild));if(!Y.length)return{};const te=new r.$jP(Y.some(ce=>ce.actual instanceof u.$sQ)?void 0:Y.map(ce=>ce.actual),q.map(ce=>ce.actual),Le,ge),ve=(0,m.$7I)(_)&&this.j.prepareForMainThreadTestRun(ke,te,F.fromInternal(_,ae.collection),Le,se);try{return await Le.runHandler(te,se),{}}catch(ce){return{error:String(ce)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(ve.onEnd)}}};e.$bqc=D,e.$bqc=D=Ge([Ve(0,c.$eQ),Ve(1,S.$$j),Ve(2,n.$AQ),Ve(3,o.$pQ)],D);const b=1e4;var k;(function(ue){ue[ue.Running=0]="Running",ue[ue.Cancelling=1]="Cancelling",ue[ue.Ended=2]="Ended"})(k||(k={}));class C extends $.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,ge,se,ae,$e,oe){super(),this.z=_,this.C=ge,this.D=se,this.F=ae,this.G=$e,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ke),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$ve(oe));const ke=this.B(new v.$Ph(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>ke.schedule()));const Le=new O.$ke;this.w=Le.event,this.B((0,$.$Rc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(_){for(const[ge,{run:se}]of this.g)if(se===_)return ge}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(_,ge,se){const[,ae]=g.$4I.fromString(_).path,$e=this.y.get(_);if(!$e)return[];const{report:oe,extIds:ke}=$e,Le=this.g.get(ae);if(!Le)throw new Error("unreachable: run task was not found");let Y;if(ge&&oe instanceof r.$pP){const te=ke.indexOf(ge);if(te===-1)return[];Y=oe.fromTests[te]}return await(Y?this.F?.loadDetailedCoverageForTest?.(Le.run,oe,Y,se):this.F?.loadDetailedCoverage?.(Le.run,oe,se))??[]}createRun(_){const ge=this.z.id,se=this.z.controllerId,ae=(0,y.$Zg)(),$e=Y=>(q,...te)=>{if(ke){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Y(q,...te)},oe=(Y,q)=>{const te=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Y.uri&&Y.range){const ve={range:i.Range.from(Y.range),uri:Y.uri};for(const ce of te)ce.location=ce.location||ve}this.C.$appendTestMessagesInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),te)};let ke=!1;const Le={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:Y=>{if(ke)return;const q=Y instanceof r.$pP?Y.fromTests:[];if(q.length){(0,p.$eH)(this.G,"attributableCoverage");for(const ce of q)this.J(ce)}const te=Y.uri.toString(),ve=new g.$4I([ge,ae,te]).toString();this.y.set(ve,{report:Y,extIds:q.map(ce=>g.$4I.fromExtHostTestItem(ce,se).toString())}),this.C.$appendCoverage(ge,ae,i.TestCoverage.fromFile(se,ve,Y))},enqueued:$e(Y=>{this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Queued)}),skipped:$e(Y=>{this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Skipped)}),started:$e(Y=>{this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Running)}),errored:$e((Y,q,te)=>{oe(Y,q),this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Errored,te)}),failed:$e((Y,q,te)=>{oe(Y,q),this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,se).toString(),m.TestResultState.Failed,te)}),passed:$e((Y,q)=>{this.C.$updateTestStateInRun(ge,ae,g.$4I.fromExtHostTestItem(Y,this.z.controllerId).toString(),m.TestResultState.Passed,q)}),appendOutput:(Y,q,te)=>{ke||(te&&this.J(te),this.C.$appendOutputToRun(ge,ae,I.$Me.fromString(Y),q&&i.location.from(q),te&&g.$4I.fromExtHostTestItem(te,se).toString()))},end:()=>{ke||(ke=!0,this.C.$finishedTestRunTask(ge,ae),--this.f||this.I())}};return this.f++,this.g.set(ae,{run:Le}),this.C.$startedTestRunTask(ge,{id:ae,name:_,running:!0}),Le}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(_){if(!(_ instanceof u.$rQ))throw new l.$9P(_.id);if(this.h.has(g.$4I.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const ge=[],se=this.z.colllection.root;for(;;){const ae=i.TestItem.from(_);if(ge.unshift(ae),this.h.has(ae.extId)||(this.h.add(ae.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ge)}dispose(){this.I(),super.dispose()}}class f{get trackers(){return this.c.values()}constructor(_,ge){this.g=_,this.h=ge,this.c=new Map,this.f=new Map}getCoverageDetails(_,ge,se){const ae=g.$4I.root(_);return this.f.get(ae)?.getCoverageDetails(_,ge,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[ge,{id:se}]of this.c)se===_&&this.c.delete(ge)}prepareForMainThreadTestRun(_,ge,se,ae,$e){return this.j(ge,se,ae,_,$e)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,ge,se,ae,$e,oe){const ke=this.c.get(ae);if(ke)return ke.createRun($e);const Le=F.fromPublic(ge,se,ae,oe),Y=w(ae);this.g.$startedExtensionTestRun({controllerId:ge,continuous:!!ae.continuous,profile:Y&&{group:K[Y.kind],id:Y.profileId},exclude:ae.exclude?.map(te=>g.$4I.fromExtHostTestItem(te,se.root.id).toString())??[],id:Le.id,include:ae.include?.map(te=>g.$4I.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:ae.preserveFocus??!0,persist:oe});const q=this.j(ae,Le,ae.profile,_);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),q.createRun($e)}j(_,ge,se,ae,$e){const oe=new C(ge,this.g,this.h,se,ae,$e);return this.c.set(_,oe),this.f.set(oe.id,oe),oe}}e.$cqc=f;const w=ue=>{if(ue.profile){if(!(ue.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ue.profile}};class F{static fromPublic(_,ge,se,ae){return new F(_,(0,y.$Zg)(),ae,ge)}static fromInternal(_,ge){return new F(_.controllerId,_.runId,!0,ge)}constructor(_,ge,se,ae){this.controllerId=_,this.id=ge,this.isPersisted=se,this.colllection=ae}}e.$dqc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const ge=g.$4I.parentId(_.item.extId);if(ge&&this.h.has(ge.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:ge,g:se}=this;return{get added(){return[..._].map(ae=>ae.revived)},get updated(){return[...ge].map(ae=>ae.revived)},get removed(){return[...se].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends m.$aJ{constructor(){super(...arguments),this.y=new O.$ke,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,ge){return{..._,revived:i.TestItem.toPlain(_.item),depth:ge?ge.depth+1:0,children:new Set}}w(){return new N(this.y)}}class W{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ge=>ge.revived)},dispose:(0,A.$cb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new L({asCanonicalUri:ge=>ge});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const J=(ue,_,ge,se)=>{ge?Object.assign(ge,se):_.$updateTestRunConfig(ue.controllerId,ue.profileId,se)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,J(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,J(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),J(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,J(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,J(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return O.Event.chain(this.#i,_=>_.map(ge=>ge.get(this.controllerId)?.get(this.profileId)).filter(R.$lg))}constructor(_,ge,se,ae,$e,oe,ke,Le,Y,q=!1,te=void 0,ve=!1){this.controllerId=$e,this.profileId=oe,this.f=ke,this.kind=Le,this.runHandler=Y,this._tag=te,this.g=ve,this.#e=_,this.#s=ge,this.#t=se,this.#i=ae,ge.set(oe,this);const ce=K[Le];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);q&&se.add(oe),this.#n={profileId:oe,controllerId:$e,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:ke,group:ce,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$eqc=M;const K={[r.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function Z(ue,_){for(let ge=0;ge<ue.path.length;ge++){const se=_.find(ae=>ae.id===ue.path[ge]);if(!se)return;if(ge===ue.path.length-1)return se;_=se.children}}}),define(Oe[259],Ne([1,0,17,6,4,5,127,8,7]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0,v=We(v),T=We(T);class s extends P.$Tc{constructor(y,a){super(),this.m=a,this.a=new I.$ke,this.b=new I.$ke,this.c=new I.$ke,this.f=new I.$ke,this.g=new I.$ke,this.h=new I.$ke,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$EN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:T.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:T.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?T.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,d),o=n&&this.m.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new A.$lQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(T.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:T.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=$.TextEditorSelectionChangeKind.fromValue(a.selections.source),n=a.selections.selections.map(T.Selection.to);this.a.fire({textEditor:S.value,selections:n,kind:d})}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$lpc=s}),define(Oe[260],Ne([1,0,2,3,5,4,7,8,18,36,14]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=e.$9qc=void 0,e.$9qc=(0,I.$Di)("IExtHostTimeline");class y{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$EN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(o,c)=>{if(o&&o.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$pn.equals(c,this.b.get(o.source)?.extension)){const u=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(a(u))?.get(o.handle)}else return;return o}})}async $getTimeline(d,n,o,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(n),o,c)}registerTimelineProvider(d,n,o,c){const u=new O.$Sc,i=this.d(n.id,c,u).bind(this);let r;n.onDidChange&&(r=n.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(g,l,m){l?.resetCache&&(u.clear(),t.get(n.id)?.clear());const p=await n.provideTimeline(g,l,m);if(p==null)return;const h=i(g,l);return{...p,source:n.id,items:p.items.map(h)}},dispose(){for(const g of t.values())g.get(n.id)?.clear();r?.dispose(),u.dispose()}},o)}d(d,n,o){return(c,u)=>{let i;if(u?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=a(c);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...g}=r,l=`${d}|${r.id??r.timestamp}`;i?.set(l,r);let m,p,h;r.iconPath&&(t instanceof A.$FO?h={id:t.id,color:t.color}:v.URI.isUri(t)?(m=t,p=t):{light:m,dark:p}=t);let E;return A.$$N.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,R.$dg)(g.tooltip)?E=g.tooltip:A.$$N.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,R.$dg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:l,source:d,command:r.command?n.toInternal(r.command,o):void 0,icon:m,iconDark:p,themeIcon:h,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,O.$Rc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$0qc=y;function a(S){return S?.toString()}}),define(Oe[261],Ne([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,s=We(s);function c(r,t){if((0,R.$dg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let g;return Array.isArray(r.highlights)&&(g=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),g=g.length?g:void 0),{label:r.label,highlights:g}}}class u extends A.$Tc{constructor(t,g,l){super(),this.f=t,this.g=g,this.h=l,this.a=new Map,this.b=new n.$H_;function m(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:p=>m(p)?this.r(p):Array.isArray(p)&&p.length>0?p.map(h=>m(h)?this.r(h):h):p})}registerTreeDataProvider(t,g,l){const m=this.createTreeView(t,{treeDataProvider:g},l);return{dispose:()=>m.dispose()}}createTreeView(t,g,l){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=g.dragAndDropController?.dropMimeTypes??[],p=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,l),b={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:m,dragMimeTypes:p,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,b),C={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$eH)(l,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$eH)(l,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$4k)(f)&&(0,o.$eH)(l,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&s.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,w)=>D.reveal(f,w),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(C),C}$getChildren(t,g){const l=this.a.get(t);return l?l.getChildren(g):Promise.reject(new T.$AG(t))}async $handleDrop(t,g,l,m,p,h,E,D){const b=this.a.get(t);if(!b)return Promise.reject(new T.$AG(t));const k=a.DataTransfer.toDataTransfer(l,async C=>(await this.f.$resolveDropFileData(t,g,C)).buffer);return E===t&&D&&await this.j(k,b,D,p,h),b.onDrop(k,m,p)}async j(t,g,l,m,p){const h=this.b.removeDragOperationTransfer(p);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(p&&g.handleDrag){const E=g.handleDrag(l,t,m);this.b.addDragOperationTransfer(p,E),await E}return t}async $handleDrag(t,g,l,m){const p=this.a.get(t);if(!p)return Promise.reject(new T.$AG(t));const h=await this.j(new s.$BO,p,g,m,l);if(!(!h||m.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$AG(t);return g.hasResolve}$resolve(t,g,l){const m=this.a.get(t);if(!m)throw new T.$AG(t);return m.resolveTreeItem(g,l)}$setExpanded(t,g,l){const m=this.a.get(t);if(!m)throw new T.$AG(t);m.setExpanded(g,l)}$setSelectionAndFocus(t,g,l){const m=this.a.get(t);if(!m)throw new T.$AG(t);m.setSelectionAndFocus(g,l)}$setVisible(t,g){const l=this.a.get(t);if(!l){if(!g)return;throw new T.$AG(t)}l.setVisible(g)}$changeCheckboxState(t,g){const l=this.a.get(t);if(!l)throw new T.$AG(t);l.setCheckboxState(g)}m(t,g,l){const m=this.B(new i(t,g,this.f,this.g.converter,this.h,l));return this.a.set(t,m),m}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$$qc=u;class i extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$mg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,l,m,p,h){if(super(),this.I=t,this.J=l,this.L=m,this.M=p,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ke),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ke),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ke),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ke),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ke),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ke),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ke),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ve,h.contributes&&h.contributes.views)for(const k in h.contributes.views)for(const C of h.contributes.views[k])C.id===t&&(this.P=C.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const b=O.Event.debounce(this.F.event,(k,C)=>(k||(k={message:!1,elements:[]}),C.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(C.element)?k.elements.push(...C.element):k.elements.push(C.element)),C.message&&(k.message=!0),k),200,!0);this.B(b(({message:k,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(C).then(()=>f())})),k&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(g)),l?l.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const l=(0,R.$mg)(g.select)?!0:g.select,m=(0,R.$mg)(g.focus)?!1:g.focus,p=(0,R.$mg)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:l,focus:m,expand:p})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:l,focus:m,expand:p})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const l=this.getExtensionElement(t);l&&(g?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,g){const l=!(0,y.$tb)(this.s,t);this.s=t;const m=this.t!==g;this.t=g,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async l=>{const m=this.getExtensionElement(l.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);g.forEach(l=>{l.treeItem.checkboxState=l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,g,l){const m=[];for(const p of t){const h=this.getExtensionElement(p);h&&m.push(h)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,g,l),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,l){const m=g?this.getExtensionElement(g):void 0;if(!(!m&&g||!this.g?.handleDrop))return(0,$.$vh)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const m=this.m.get(l);if(m){const p=await this.f.resolveTreeItem(m.extensionItem,l,g)??m.extensionItem;return this.hb(p),m.item.tooltip=this.eb(p.tooltip),m.item.command=this.fb(m.disposableStore,p.command),m.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(l=>this.W(g,l[l.length-1]).then(m=>(l.push(m),l))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$vh)(()=>this.f.getParent(t))}W(t,g){const l=this.m.get(t);return l?Promise.resolve(l):(0,$.$vh)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,g,!0)).then(m=>this.getChildren(g?g.item.handle:void 0).then(()=>{const p=this.getExtensionElement(m);if(p){const h=this.m.get(p);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const l=this.getExtensionElement(t);g=l?this.m.get(l):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$ve(this.Z.token);try{const l=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const p=(0,y.$Gb)(m||[]),h=await Promise.all((0,y.$Gb)(p).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,b)=>D?this.db(p[b],D,l):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new d.$ve,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const g=new Set,l=t.map(p=>this.m.get(p));for(const p of l)if(p&&!g.has(p.item.handle)){let h=p;for(;h&&h.parent&&l.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(p.item.handle)}const m=[];return g.forEach(p=>{const h=this.j.get(p);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&m.push(p)}}),m}bb(t){const g={};return Promise.all(t.map(l=>this.cb(l).then(m=>{m&&(g[l]=m.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const l=this.m.get(g);if(l)return this.rb(g),(0,$.$vh)(()=>this.f.getTreeItem(g)).then(m=>{if(m){const p=this.ib(g,m,l.parent);return this.pb(g,p,l,l.parent),l.dispose(),p}return null})}return Promise.resolve(null)}db(t,g,l){const m=this.ib(t,g,l);if(g.id&&this.j.has(m.item.handle))throw new Error((0,v.localize)(10768,null,g.id));return this.ob(t,m),this.qb(m,l),m}eb(t){return s.$$N.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,l,m;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,l=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:g===s.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:m}}hb(t){if(!s.$wO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,l){this.hb(g);const m=this.B(new A.$Sc),p=this.kb(t,g,l),h=this.lb(g);return{item:{handle:p,parentHandle:l?l.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(m,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,R.$mg)(g.collapsibleState)?s.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:l,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$FO?t.iconPath:void 0}kb(t,{id:g,label:l,resourceUri:m},p,h){if(g)return`${i.b}/${g}`;const E=c(l,this.N),D=p?p.item.handle:i.a;let b=E?E.label:m?(0,I.$bh)(m):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(p)||[];let f,w=0;do{if(f=`${D}/${w}:${b}`,h||!this.j.has(f)||k===f)break;w++}while(w<=C.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$FO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$FO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,l,m){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,g);const p=this.X(m)||[],h=p.filter(E=>E.item.handle===l.item.handle)[0];h&&p.splice(p.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const l of g.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const l of g.children){const m=this.j.get(l.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Oe[262],Ne([1,0,6,4,2,37,8,67,5,7]),function(be,e,v,I,P,O,A,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0,A=We(A),$=We($),s=We(s);class R extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,o,c){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new v.$ke),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$ke),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=o,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#u=c.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends I.$Tc{static c(){return(0,O.$Zg)()}constructor(d,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$EN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,o,c,u={}){const i=typeof c=="object"?c.viewColumn:c,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,T.$Apc)(d),g=y.c();this.f.$createWebviewPanel((0,T.$Cpc)(d),g,n,{title:o,panelOptions:a(u),webviewOptions:(0,T.$Dpc)(d,this.m,u),serializeBuffersForPostMessage:t},r);const l=this.j.createNewWebview(g,u,d);return this.createNewWebviewPanel(g,n,o,i,u,l,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((o,c)=>{const u=d[o],i=d[c];return u.active?1:i.active?-1:+u.visible-+i.visible});for(const o of n){const c=this.getWebviewPanel(o);if(!c)continue;const u=d[o];c._updateViewState({active:u.active,visible:u.visible,viewColumn:A.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Apc)(d)}),new s.$GN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,o,c){const u=this.h.get(n);if(!u)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=u,t=this.j.createNewWebview(d,o.webviewOptions,r),g=this.createNewWebviewPanel(d,n,o.title,c,o.panelOptions,t,o.active);await i.deserializeWebviewPanel(g,o.state)}createNewWebviewPanel(d,n,o,c,u,i,r){const t=new R(d,this.f,i,{viewType:n,title:o,viewColumn:c,panelOptions:u,active:r});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$Epc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Oe[263],Ne([1,0,6,4,67,8,5,7]),function(be,e,v,I,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,A=We(A),T=We(T);class $ extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,n,o){super(),this.#s=!1,this.#u=this.B(new v.$ke),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new v.$ke),this.onDidDispose=this.#l.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$EN.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,P.$Cpc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Apc)(y)}),new T.$GN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,n){const o=this.b.get(a);if(!o)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:u}=o,i=this.d.createNewWebview(y,{},u),r=new $(y,this.a,a,S,i,!0);this.c.set(y,r),await c.resolveWebviewView(r,{state:d},n)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$brc=s}),define(Oe[264],Ne([1,0,6,30,31,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.OutputChannelUpdateMode=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=void 0,e.$MM="text/x-code-output",e.$NM="output",e.$OM="Log",e.$PM="text/x-code-log-output",e.$QM="log",e.$RM="workbench.panel.output",e.$SM=new P.$Uj("inOutput",!1),e.$TM=new P.$Uj("activeLogOutput",!1),e.$UM=new P.$Uj("activeLogOutput.levelSettable",!1),e.$VM=new P.$Uj("activeLogOutput.level",""),e.$WM=new P.$Uj("activeLogOutput.levelIsDefault",!1),e.$XM=new P.$Uj("outputView.scrollLock",!1),e.$YM=(0,O.$Di)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$ZM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$ke,this.onDidRegisterChannel=this.b.event,this.c=new v.$ke,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(R=>s.push(R)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}I.$po.add(e.$ZM.OutputChannels,new T),e.$1M=new P.$Uj("activeOutputChannel","")}),define(Oe[128],Ne([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=e.$Qqc=void 0;class c extends A.$ek{get disposed(){return this.n}constructor(t,g,l,m,p){super(),this.id=t,this.name=g,this.r=l,this.s=m,this.extension=p,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Me.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class u extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,l,m,p,h){this.i=g,this.j=l,this.k=m,this.l=p,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$EN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,l]of this.g)l.visible=g===this.h}createOutputChannel(t,g,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof g=="object"&&g.log,p=(0,S.$dg)(g)?g:void 0;if((0,S.$dg)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([b])=>O.$pn.equals(l.identifier,b))?.[1];E&&(h=(0,A.$pk)(E));const D=m?this.o(t,h,l):this.n(t,p,l);return D.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),m?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,p=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,p,g,l.identifier.value);return new c(E,t,h,this.a,l)}async o(t,g,l){const m=await this.p(l),p=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(m,`${p}.log`),E=`${l.identifier.value}.${p}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:l.identifier.value});return new u(E,t,D,this.a,l)}p(t){let g=this.d.get(t.identifier.value);if(!g){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(l)}catch(m){if((0,d.$ol)(m)!==d.FileSystemProviderErrorCode.FileExists)throw m}return l})())}return g}q(t,g){let l=!1;const m=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(p){m(),g.then(h=>h.append(p))},appendLine(p){m(),g.then(h=>h.appendLine(p))},clear(){m(),g.then(p=>p.clear())},replace(p){m(),g.then(h=>h.replace(p))},show(p,h){m(),g.then(E=>E.show(p,h))},hide(){m(),g.then(p=>p.hide())},dispose(){l=!0,g.then(p=>p.dispose())}}}r(t,g,l){const m=new o.$Sc,p=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},h=m.add(new n.$ke);function E(D){g=D,h.fire(D)}return l.then(D=>{m.add(D),D.logLevel!==g&&E(D.logLevel),m.add(D.onDidChangeLogLevel(b=>E(b)))}),{...this.q(t,l),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...b){p(),l.then(k=>k.trace(D,...b))},debug(D,...b){p(),l.then(k=>k.debug(D,...b))},info(D,...b){p(),l.then(k=>k.info(D,...b))},warn(D,...b){p(),l.then(k=>k.warn(D,...b))},error(D,...b){p(),l.then(k=>k.error(D,...b))},dispose(){m.dispose()}}}};e.$Qqc=i,e.$Qqc=i=Ge([Ve(0,P.$eQ),Ve(1,s.$uQ),Ve(2,$.$wpc),Ve(3,R.$_oc),Ve(4,A.$_j),Ve(5,A.$$j)],i),e.$Rqc=(0,I.$Di)("IExtHostOutputService")}),define(Oe[129],Ne([1,0,3,10]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=void 0,e.$Um=(0,v.$Di)("remoteAgentService"),e.$Vm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,I.$Eh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Oe[265],Ne([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=void 0,e.$aL=Object.freeze({id:"application",order:100,title:(0,v.localize)(12492,null),type:"object"}),e.$bL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12493,null),type:"object"}),e.$cL=Object.freeze({id:"security",scope:I.ConfigurationScope.APPLICATION,title:(0,v.localize)(12494,null),type:"object",order:7}),e.$dL=Object.freeze({id:"problems",title:(0,v.localize)(12495,null),type:"object",order:101}),e.$eL=Object.freeze({id:"window",order:8,title:(0,v.localize)(12496,null),type:"object"}),e.$fL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$ke,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;P.$po.add(e.$fL.ConfigurationMigration,n);let o=class extends T.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const l of g.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(g=>this.g(g,r?.uri))])}async g(r,t){const g=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[m,p]of l){const h=g[m];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(r,m,h.value,t,void 0);for(const b of D??[])E.push([b,[]])}for(const{identifiers:D,value:b}of h.overrides??[])if(b!==void 0){const k=await this.h(r,m,b,t,D);for(const C of k??[])E.push([C,D])}E.length&&await Promise.allSettled(E.map(async([[D,b],k])=>this.a.updateValue(D,b.value,{resource:t,overrideIdentifiers:k},p)))}}async h(r,t,g,l,m){const p=E=>{const b=this.a.inspect(E,{resource:l})[t];if(b)return m?b.overrides?.find(({identifiers:k})=>(0,y.$go)(k,m))?.value:b.value},h=await r.migrateFn(g,p);return Array.isArray(h)?h:[[r.key,h]]}};e.$gL=o,e.$gL=o=Ge([Ve(0,A.$0i),Ve(1,O.$Mi)],o);let c=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new a.$1h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$j&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;P.$po.as(I.$uo.Configuration).registerConfiguration({...e.$cL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12497,null)},default:[],markdownDescription:(0,v.localize)(12498,null),scope:I.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12499,null),scope:I.ConfigurationScope.MACHINE}}})}};e.$hL=c,e.$hL=c=Ge([Ve(0,s.$Um)],c),e.$iL="window.newWindowProfile";let u=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$iL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=P.$po.as(I.$uo.Configuration),t={...e.$eL,properties:{[e.$iL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12500,null)],description:(0,v.localize)(12501,null),scope:I.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$iL);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$iL);if(!r)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$iL,t?.name)}};e.$jL=u,e.$jL=u=Ge([Ve(0,S.$Kl),Ve(1,A.$0i)],u)}),define(Oe[266],Ne([1,0,41,15,19,23,9,265,53,3,30]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$lL=e.$kL=void 0,e.$mL=n,e.$nL=o,v=We(v),e.$kL=(0,s.$Di)("editorResolverService"),e.$lL="workbench.editorAssociations";const y=R.$po.as($.$uo.Configuration),a={...T.$bL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(2008,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function o(c,u){if(new Set([I.Schemas.extension,I.Schemas.webviewPanel,I.Schemas.vscodeWorkspaceTrust,I.Schemas.vscodeSettings]).has(u.scheme))return!1;const t=typeof c=="string"&&c.indexOf(P.$fc.sep)>=0?`${u.scheme}:${u.path}`:(0,O.$bh)(u);return v.$xk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Oe[267],Ne([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(be,e,v,I,P,O,A,T,$,s,R,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0,e.$gN=(0,$.$Di)("pathService");let d=S=class{constructor(o,c,u,i){this.d=o,this.e=c,this.f=u,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??o})()}hasValidBasename(o,c,u){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(o,i,c)):this.h(o,c,u)}h(o,c,u){return o.scheme===I.Schemas.file||o.scheme===I.Schemas.vscodeRemote?(0,v.$Ag)(u??(0,A.$bh)(o),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,c){if(o.remoteAuthority)return I.Schemas.vscodeRemote;const u=(0,s.$dN)(c.getWorkspace());if(u)return u;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:I.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$ec:P.$fc)}async fileURI(o){let c="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(c=o.substring(2),o="/"):(c=o.substring(2,i),o=o.substring(i)||"/")}return T.URI.from({scheme:I.Schemas.file,authority:c,path:o,query:"",fragment:""})}};e.$hN=d,e.$hN=d=S=Ge([Ve(1,a.$Um),Ve(2,y.$2M),Ve(3,R.$Mi)],d)}),define(Oe[130],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$UL=e.$TL=void 0;class v{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new v(0,0)}with(A){return new v(0,0)}}e.$TL=v;class I{constructor(A,T,$,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,T),this.end=new v($,s)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new I(0,0,0,0)}with(A){return new I(0,0,0,0)}}e.$UL=I;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Oe[44],Ne([1,0,17,41,25,51,12,3,19,13,130,10]),function(be,e,v,I,P,O,A,T,$,s,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$gM=e.$_L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$9L=e.$8L=e.$7L=e.$6L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TextSearchCompleteMessageType=void 0,e.$3L=c,e.$4L=u,e.$5L=i,e.$0L=D,e.$$L=b,e.$aM=f,e.$bM=w,e.$cM=F,e.$dM=N,e.$eM=L,e.$fM=W,e.$hM=M,e.$jM=ue,e.$kM=_,I=We(I),P=We(P),O=We(O),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$VL="workbench.view.search",e.$WL="workbench.panel.search",e.$XL="workbench.view.search",e.$YL="search-result",e.$ZL="search.exclude",e.$1L=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$2L=(0,T.$Di)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function c(se){return!!se.preview}function u(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ae){this.resource=ae,this.results=[]}}e.$6L=t;class g{constructor(ae,$e,oe,ke){this.ranges=$e,this.webviewIndex=ke;const Le=Array.isArray($e)?$e:[$e];if(oe&&oe.matchLines===1&&l(Le)){ae=(0,A.$9f)(ae,oe.matchLines);let Y="",q=0,te=0;const ve=Math.floor(oe.charsPerLine/5),ce=[];for(const we of Le){const he=Math.max(we.startColumn-ve,0),X=we.startColumn+oe.charsPerLine;if(he>te+ve+d){const x=a+(he-te)+S;Y+=x+ae.slice(he,X),q+=he-(te+x.length)}else Y+=ae.slice(te,X);ce.push(new p(0,we.startColumn-q,we.endColumn-q)),te=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const Y=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:ae,matches:(0,v.$Zb)($e,q=>new m(q.startLineNumber-Y,q.startColumn,q.endLineNumber-Y,q.endColumn))}}}}e.$7L=g;function l(se){const ae=se[0].startLineNumber;for(const $e of se)if($e.startLineNumber!==ae||$e.endLineNumber!==ae)return!1;return!0}class m{constructor(ae,$e,oe,ke){this.startLineNumber=ae,this.startColumn=$e,this.endLineNumber=oe,this.endColumn=ke}}e.$8L=m;class p extends m{constructor(ae,$e,oe){super(ae,$e,ae,oe)}}e.$9L=p;var h;(function(se){se.List="list",se.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(se,ae=!0){const $e=se&&se.files&&se.files.exclude,oe=ae&&se&&se.search&&se.search.exclude;if(!$e&&!oe)return;if(!$e||!oe)return $e||oe||void 0;let ke=Object.create(null);return ke=P.$fo(ke,P.$co($e)),ke=P.$fo(ke,P.$co(oe),!0),ke}function b(se,ae){return se.excludePattern&&I.$xk(se.excludePattern,ae)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&I.$xk(se.includePattern,ae)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some($e=>{const oe=$e.folder.fsPath;if(O.$Cg(ae,oe)){const ke=$.$kc(oe,ae);return!$e.includePattern||!!I.$xk($e.includePattern,ke)}else return!1}):!1:!0}var k;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class C extends Error{constructor(ae,$e){super(ae),this.code=$e}}e.$_L=C;function f(se){const ae=se.message;if((0,s.$3)(se))return new C(ae,k.canceled);try{const $e=JSON.parse(ae);return new C($e.message,$e.code)}catch{return new C(ae,k.other)}}function w(se){const ae={message:se.message,code:se.code};return new Error(JSON.stringify(ae))}function F(se){return se.type==="error"?!0:se.type==="success"}function N(se){return se.type==="success"}function L(se){return!!se.path}function W(se,ae,$e=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return $e?(0,A.$6f)(oe,ae):I.$xk(ae,oe)}class J{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$gM=J;function M(se,ae){const $e={...se||{},...ae||{}};return Object.keys($e).filter(oe=>{const ke=$e[oe];return typeof ke=="boolean"&&ke})}class K{constructor(ae,$e){this.c=null,this.a={...ae.excludePattern||{},...$e.excludePattern||{}},this.b=I.$yk(this.a);let oe=ae.includePattern;$e.includePattern&&(oe?oe={...oe,...$e.includePattern}:oe=$e.includePattern),oe&&(this.c=I.$yk(oe))}matchesExcludesSync(ae,$e,oe){return!!(this.b&&this.b(ae,$e,oe))}includedInQuerySync(ae,$e,oe){return!(this.b&&this.b(ae,$e,oe)||this.c&&!this.c(ae,$e,oe))}includedInQuery(ae,$e,oe){const ke=this.b(ae,$e,oe),Le=()=>this.c?!!this.c(ae,$e,oe):!0;return(0,y.$ph)(ke)?ke.then(Y=>Y?!1:Le()):Le()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$iM=K;function Z(se){for(const ae in se)if(typeof se[ae]!="boolean")return!0;return!1}function ue(se){if(!se)return;let ae;return $e=>(ae||(ae=(se()||Promise.resolve([])).then(oe=>oe?ge(oe):{})),ae.then(oe=>!!oe[$e]))}function _(se){if(!se)return;let ae;return $e=>{if(!ae){const oe=se();ae=oe?ge(oe):{}}return!!ae[$e]}}function ge(se){const ae={};for(const $e of se)ae[$e]=!0;return ae}}),define(Oe[45],Ne([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,40]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0;function D(L,W,J){return new R.$6g(M=>f(M,J)).isEqual(L,W)}function b(L,W,J){return D(L.uri,W.uri,J)?0:(0,y.$xf)(L.uri.toString(),W.uri.toString())}function k(L,W,J){return L.index!==W.index?L.index<W.index?-1:1:D(L.uri,W.uri,J)?(0,y.$xf)(L.name,W.name):(0,y.$xf)(L.uri.toString(),W.uri.toString())}function C(L,W,J,M){const K=L.slice(0).sort((ue,_)=>J(ue,_,M)),Z=W.slice(0).sort((ue,_)=>J(ue,_,M));return(0,v.$Db)(K,Z,(ue,_)=>J(ue,_,M))}function f(L,W){const J=W.getCapabilities(L.scheme);return!(J&&J&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends u.$Wi{static toExtHostWorkspace(W,J,M,K){if(!W)return{workspace:null,added:[],removed:[]};const{id:Z,name:ue,folders:_,configuration:ge,transient:se,isUntitled:ae}=W,$e=[],oe=J;J?_.forEach((q,te)=>{const ve=a.URI.revive(q.uri),ce=w.o(M||J,ve,K);ce?(ce.name=q.name,ce.index=q.index,$e.push(ce)):$e.push({uri:ve,name:q.name,index:te})}):$e.push(..._.map(({uri:q,name:te,index:ve})=>({uri:a.URI.revive(q),name:te,index:ve}))),$e.sort((q,te)=>q.index<te.index?-1:1);const ke=new w(Z,ue,$e,!!se,ge?a.URI.revive(ge):null,!!ae,q=>f(q,K)),{added:Le,removed:Y}=C(oe?oe.workspaceFolders:[],ke.workspaceFolders,b,K);return{workspace:ke,added:Le,removed:Y}}static o(W,J,M){for(let K=0;K<W.folders.length;K++){const Z=W.workspaceFolders[K];if(D(Z.uri,J,M))return Z}}constructor(W,J,M,K,Z,ue,_){super(W,M.map(ge=>new u.$Xi(ge)),K,Z,_),this.t=J,this.u=ue,this.q=[],this.s=T.$Ji.forUris(_,()=>!0),M.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,J){return J&&this.s.get(W)&&(W=(0,R.$dh)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let F=class{constructor(W,J,M,K,Z){this.c=new O.$ke,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ke,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$me,this.C=new Map,this.h=K,this.s=M,this.t=Z,this.j=new s.$Lm,this.k=new I.$Ch,this.o=W.getProxy(h.$EN.MainThreadWorkspace),this.q=W.getProxy(h.$EN.MainThreadMessageService);const ue=J.workspace;this.l=ue?new w(ue.id,ue.name,[],!!ue.transient,ue.configuration?a.URI.revive(ue.configuration):null,!!ue.isUntitled,_=>f(_,M)):void 0}$initializeWorkspace(W,J){this.v=J,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:$.Schemas.untitled,path:(0,R.$bh)((0,R.$dh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,J,M,...K){const Z=[];if(Array.isArray(K)&&K.forEach(ae=>{a.URI.isUri(ae.uri)&&!Z.some($e=>D($e.uri,ae.uri,this.s))&&Z.push({uri:ae.uri,name:ae.name||(0,R.$ah)(ae.uri)})}),this.n||[J,M].some(ae=>typeof ae!="number"||ae<0)||M===0&&Z.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(J+M>ue.length)return!1;const _=ue.slice(0);_.splice(J,M,...Z.map(ae=>({uri:ae.uri,name:ae.name||(0,R.$ah)(ae.uri),index:void 0})));for(let ae=0;ae<_.length;ae++){const $e=_[ae];if(_.some((oe,ke)=>ke!==ae&&D($e.uri,oe.uri,this.s)))return!1}_.forEach((ae,$e)=>ae.index=$e);const{added:ge,removed:se}=C(ue,_,k,this.s);if(ge.length===0&&se.length===0)return!1;if(this.o){const ae=W.displayName||W.name;this.o.$updateWorkspaceFolders(ae,J,M,Z).then(void 0,$e=>{this.n=void 0;const oe={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(10765,null,ae,$e.toString()),oe,[])})}return this.y(_),!0}getWorkspaceFolder(W,J){if(this.x)return this.x.getWorkspaceFolder(W,J)}async getWorkspaceFolder2(W,J){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,J)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,J){let M,K="";if(typeof W=="string"?(M=a.URI.file(W),K=W):typeof W<"u"&&(M=W,K=W.fsPath),!M)return K;const Z=this.getWorkspaceFolder(M,!0);if(!Z)return K;typeof J>"u"&&this.x&&(J=this.x.folders.length>1);let ue=(0,R.$gh)(Z.uri,M);return J&&Z.name&&(ue=`${Z.name}/${ue}`),ue}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:J,added:M,removed:K}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=J||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:K}))}findFiles(W,J,M,K,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let ue="",_=!0;return J===null?_=!1:J!==void 0&&(typeof J=="string"?ue=J:ue=J.pattern),this.z(W,void 0,{exclude:ue,maxResults:M,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(W,J={},M,K=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,W,J,K)}async z(W,J,M,K=P.CancellationToken.None){if(K&&K.isCancellationRequested)return Promise.resolve([]);const Z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ue={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:Z,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let _;if(W){const{includePattern:ge,folder:se}=N(g.GlobPattern.from(W));_=se,ue.includePattern=ge}else{const{includePattern:ge,folder:se}=N(g.GlobPattern.from(J));_=se,ue.filePattern=ge}return this.o.$startFileSearch(_??null,ue,K).then(ge=>Array.isArray(ge)?ge.map(se=>a.URI.revive(se)):[])}async findTextInFiles(W,J,M,K,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const ue=this.j.getNext(),_=typeof J.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:J.previewOptions,{includePattern:ge,folder:se}=N(g.GlobPattern.from(J.include)),ae=typeof J.exclude=="string"?J.exclude:J.exclude?J.exclude.pattern:void 0,$e={ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles=="boolean"?!J.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof J.useGlobalIgnoreFiles=="boolean"?!J.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof J.useParentIgnoreFiles=="boolean"?!J.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof J.useDefaultExcludes=="boolean"?!J.useDefaultExcludes:!0,fileEncoding:J.encoding,maxResults:J.maxResults,previewOptions:_,afterContext:J.afterContext,beforeContext:J.beforeContext,includePattern:ge,excludePattern:ae},oe=!1;if(this.u[ue]=ke=>{if(oe)return;const Le=a.URI.revive(ke.resource);ke.results.forEach(Y=>{const q=(0,E.$ai)(Y);(0,p.$3L)(q)?M({uri:Le,preview:{text:q.preview.text,matches:(0,v.$Zb)(q.preview.matches,te=>new l.$IN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$Zb)(q.ranges,te=>new l.$IN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):M({uri:Le,text:q.text,lineNumber:q.lineNumber})})},Z.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(W,se??null,$e,ue,Z);return delete this.u[ue],ke||{}}catch(ke){throw delete this.u[ue],ke}}$handleTextSearchResult(W,J){this.u[J]?.(W)}async save(W){const J=await this.o.$save(W,{saveAs:!1});return a.URI.revive(J)}async saveAs(W){const J=await this.o.$save(W,{saveAs:!0});return a.URI.revive(J)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}lookupAuthorization(W){return this.o.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this.o.$lookupKerberosAuthorization(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,J){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,J);const M=this.t.transformOutgoingScheme(W),K=this.A++;return this.o.$registerEditSessionIdentityProvider(K,M),(0,A.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(W,J){this.h.info("Getting edit session identifier for workspaceFolder",W);const M=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const K=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!K),!K)return;const Z=await K.provideEditSessionIdentity(M,J);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(W,J,M,K){this.h.info("Getting edit session identifier for workspaceFolder",W);const Z=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const ue=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!ue),!ue)return;const _=await ue.provideEditSessionIdentityMatch?.(J,M,K);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(W){return(J,M,K)=>{const Z=function(_){J.call(M,_)};return Z.extension=W,this.B.event(Z,void 0,K)}}async $onWillCreateEditSessionIdentity(W,J,M){const K=await this.resolveWorkspaceFolder(a.URI.revive(W));if(K===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:K},J,async(Z,ue)=>{const _=Date.now();await Promise.resolve(Z),Date.now()-_>M&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),J.isCancellationRequested}registerCanonicalUriProvider(W,J){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,J);const M=this.t.transformOutgoingScheme(W),K=this.A++;return this.o.$registerCanonicalUriProvider(K,M),(0,A.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(K)})}async provideCanonicalUri(W,J,M){const K=this.C.get(W.scheme);if(!K)return;const Z=await K.provideCanonicalUri?.(a.URI.revive(W),J,M);if(Z)return Z}async $provideCanonicalUri(W,J,M){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:J},M)}};e.$qpc=F,e.$qpc=F=Ge([Ve(0,t.$eQ),Ve(1,r.$uQ),Ve(2,i.$_oc),Ve(3,o.$$j),Ve(4,m.$opc)],F),e.$rpc=(0,n.$Di)("IExtHostWorkspace");function N(L){let W,J;return L&&(typeof L=="string"?W=L:(W=L.pattern,J=a.URI.revive(L.baseUri))),{includePattern:W,folder:J}}}),define(Oe[46],Ne([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=e.$spc=void 0;function o(m,p){if(p){const h=p.split(".");let E=m;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c(m){return m instanceof n.URI}function u(m){return m&&m.uri instanceof n.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function r(m){return m&&m.uri instanceof n.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(c(m))return{resource:m};if(u(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(r(m))return{resource:m.uri};if(m===null)return{resource:null}}let g=class{constructor(p,h,E){this.a=p.getProxy(O.$EN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Ch,this.e=null}getConfigProvider(){return this.d.wait().then(p=>this.e)}$initializeConfiguration(p){this.e=new l(this.a,this.c,p,this.b),this.d.open()}$acceptConfigurationChanged(p,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(p,h))}};e.$spc=g,e.$spc=g=Ge([Ve(0,S.$eQ),Ve(1,P.$rpc),Ve(2,d.$$j)],g);class l{constructor(p,h,E,D){this.a=new I.$ke,this.b=p,this.f=D,this.c=h,this.e=$.$Po.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(p,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Po.parse(p,this.f),this.d=this.k(p.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(p,h,E){const D=t(h)||{},b=this.g(p?o(this.e.getValue(void 0,D,this.c.workspace),p):this.e.getValue(void 0,D,this.c.workspace));p&&this.h(p,D,E?.identifier);function k(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(f){return typeof o(b,f)<"u"},get:(f,w)=>{this.h(p?`${p}.${f}`:f,D,E?.identifier);let F=o(b,f);if(typeof F>"u")F=w;else{let N;const L=(W,J)=>{if((0,R.$fg)(W)){let M;const K=()=>{N=N||(0,v.$co)(b),M=M||o(N,J)};return new Proxy(W,{get:(Z,ue)=>{if(typeof ue=="string"&&ue.toLowerCase()==="tojson")return K(),()=>M;if(N)return M=M||o(N,J),M[ue];const _=Z[ue];return typeof ue=="string"?L(_,`${J}.${ue}`):_},set:(Z,ue,_)=>(K(),M&&(M[ue]=_),!0),deleteProperty:(Z,ue)=>(K(),M&&delete M[ue],!0),defineProperty:(Z,ue,_)=>(K(),M&&Object.defineProperty(M,ue,_),!0)})}return Array.isArray(W)?(0,v.$co)(W):W};F=L(F,f)}return F},update:(f,w,F,N)=>{f=p?`${p}.${f}`:f;const L=k(F);return w!==void 0?this.b.$updateConfigurationOption(L,f,w,D,N):this.b.$removeConfigurationOption(L,f,D,N)},inspect:f=>{f=p?`${p}.${f}`:f;const w=this.e.inspect(f,D,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$co)(w.policy?.value??w.default?.value),globalValue:(0,v.$co)(w.user?.value??w.application?.value),workspaceValue:(0,v.$co)(w.workspace?.value),workspaceFolderValue:(0,v.$co)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$co)(w.default?.override),globalLanguageValue:(0,v.$co)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$co)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$co)(w.workspaceFolder?.override),languageIds:(0,v.$co)(w.overrideIdentifiers)}}};return typeof b=="object"&&(0,v.$fo)(C,b,!1),Object.freeze(C)}g(p){const h=E=>(0,R.$fg)(E)?new Proxy(E,{get:(D,b)=>h(D[b]),set:(D,b,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(D,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(D,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(p)}h(p,h,E){const D=s.$Eo.test(p)?s.ConfigurationScope.RESOURCE:this.d.get(p),b=E?`[${E.value}] `:"";if(s.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${p}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${p}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(p,h){const E=new $.$Ro(p,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,b)=>E.affectsConfiguration(D,t(b))})}k(p){return p.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$tpc=l,e.$upc=(0,a.$Di)("IExtHostConfiguration")}),define(Oe[131],Ne([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=e.$4qc=e.$3qc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=We(A),o=We(o);var t;(function(N){function L(J){if(J!=null)return J}N.from=L;function W(J){if(J!=null)return J}N.to=W})(t||(t={}));var g;(function(N){function L(J){if(J!=null)return J}N.from=L;function W(J){if(J!=null)return J}N.to=W})(g||(g={}));var l;(function(N){function L(J){if(J!=null)return J}N.from=L;function W(J){if(J!=null)return J}N.to=W})(l||(l={}));var m;(function(N){function L(M){if(M){const K=M;return K&&!!K.process}else return!1}N.is=L;function W(M){if(M==null)return;const K={process:M.process,args:M.args};return M.options&&(K.options=l.from(M.options)),K}N.from=W;function J(M){if(M!=null)return new A.$sO(M.process,M.args,M.options)}N.to=J})(m||(m={}));var p;(function(N){function L(J){if(J!=null)return J}N.from=L;function W(J){if(J!=null)return J}N.to=W})(p||(p={}));var h;(function(N){function L(M){if(M){const K=M;return K&&(!!K.commandLine||!!K.command)}else return!1}N.is=L;function W(M){if(M==null)return;const K={};return M.commandLine!==void 0?K.commandLine=M.commandLine:(K.command=M.command,K.args=M.args),M.options&&(K.options=p.from(M.options)),K}N.from=W;function J(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.$tO(M.commandLine,M.options):new A.$tO(M.command,M.args?M.args:[],M.options)}N.to=J})(h||(h={}));var E;(function(N){function L(M){if(M){const K=M;return K&&K.customExecution==="customExecution"}else return!1}N.is=L;function W(M){return{customExecution:"customExecution"}}N.from=W;function J(M,K){return K.get(M)}N.to=J})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(W,J){let M;return W.scope!==void 0&&typeof W.scope!="number"?M=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&J&&J.workspaceFile?M=J.workspaceFile:M=i.$SI),{id:W._id,workspaceFolder:M}}N.from=L})(D||(e.TaskHandleDTO=D={}));var b;(function(N){function L(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}N.from=L})(b||(b={}));var k;(function(N){function L(M,K){if(M==null)return[];const Z=[];for(const ue of M){const _=W(ue,K);_&&Z.push(_)}return Z}N.fromMany=L;function W(M,K){if(M==null)return;let Z;M.execution instanceof A.$sO?Z=m.from(M.execution):M.execution instanceof A.$tO?Z=h.from(M.execution):M.execution&&M.execution instanceof A.$uO&&(Z=E.from(M.execution));const ue=t.from(M.definition);let _;return M.scope?typeof M.scope=="number"?_=M.scope:_=M.scope.uri:_=A.TaskScope.Workspace,!ue||!_?void 0:{_id:M._id,definition:ue,name:M.name,source:{extensionId:K.identifier.value,label:M.source,scope:_},execution:Z,isBackground:M.isBackground,group:b.from(M.group),presentationOptions:g.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=W;async function J(M,K,Z){if(M==null)return;let ue;m.is(M.execution)?ue=m.to(M.execution):h.is(M.execution)?ue=h.to(M.execution):E.is(M.execution)&&(ue=E.to(M._id,Z));const _=t.to(M.definition);let ge;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ge=M.source.scope:ge=await K.resolveWorkspaceFolder(v.URI.revive(M.source.scope)):ge=A.TaskScope.Workspace),!_||!ge)return;const se=new A.$vO(_,ge,M.name,M.source.label,ue,M.problemMatchers);return M.isBackground!==void 0&&(se.isBackground=M.isBackground),M.group!==void 0&&(se.group=A.$rO.from(M.group._id),se.group&&M.group.isDefault&&(se.group=new A.$rO(se.group.id,se.group.label),M.group.isDefault===!0&&(se.group.isDefault=M.group.isDefault))),M.presentationOptions&&(se.presentationOptions=g.to(M.presentationOptions)),M._id&&(se._id=M._id),M.detail&&(se.detail=M.detail),se}N.to=J})(k||(e.TaskDTO=k={}));var C;(function(N){function L(J){return J}N.from=L;function W(J){if(J)return Object.assign(Object.create(null),J)}N.to=W})(C||(C={}));class f{#e;constructor(L,W,J){this._id=W,this.a=J,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,W,J,M,K,Z,ue,_){this.q=new P.$ke,this.r=new P.$ke,this.s=new P.$ke,this.u=new P.$ke,this.a=L.getProxy(O.$EN.MainThreadTask),this.b=J,this.c=M,this.d=K,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,W,J){if(!J)return new A.$GN(()=>{});const M=this.x();return this.j.set(M,{type:W,provider:J,extension:L}),this.a.$registerTaskProvider(M,W),new A.$GN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(L,W){this.a.$registerTaskSystem(L,W)}fetchTasks(L){return this.a.$fetchTasks(C.from(L)).then(async W=>{const J=[];for(const M of W){const K=await k.to(M,this.b,this.m);K&&J.push(K)}return J})}get taskExecutions(){const L=[];return this.k.forEach(W=>L.push(W)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,W,J){const M=this.m.get(L.id);M&&(this.o.set(L.id,M),this.e.attachPtyToTerminal(W,await M.callback(J))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const W=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const W=await this.z(L.id);this.s.fire({execution:W,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const W=await this.z(L.id);this.u.fire({execution:W,exitCode:L.exitCode})}$provideTasks(L,W){const J=this.j.get(L);if(!J)return Promise.reject(new Error("no handler found"));const M=[],K=(0,I.$vh)(()=>J.provider.provideTasks(R.CancellationToken.None)).then(Z=>this.v(W,M,J,Z));return new Promise(Z=>{K.then(ue=>{Promise.all(M).then(()=>{Z(ue)})})})}async $resolveTask(L,W){const J=this.j.get(L);if(!J)return Promise.reject(new Error("no handler found"));if(W.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${J.type}].`);const M=await k.to(W,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const K=await J.provider.resolveTask(M,R.CancellationToken.None);if(!K)return;this.A(K,J);const Z=k.from(K,J.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Z.execution)&&await this.y(Z,K,!0),await this.w(Z)}x(){return this.h++}async y(L,W,J){const M=await this.a.$createTaskId(L);!J&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,W.execution)),this.m.set(M,W.execution)}async z(L,W){if(typeof L=="string"){const K=this.l.get(L);if(!K)throw new r.$ab("Unexpected: The specified task is missing an execution");return K}const J=this.l.get(L.id);if(J)return J;let M;return W?M=Promise.resolve(new f(this,L.id,W)):M=k.to(L.task,this.b,this.m).then(K=>{if(!K)throw new r.$ab("Unexpected: Task does not exist.");return new f(this,L.id,K)}),this.l.set(L.id,M),M.then(K=>(this.k.set(L.id,K),K))}A(L,W){L._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const J=this.n.values();let M=J.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=J.next()}};e.$3qc=w,e.$3qc=w=Ge([Ve(0,a.$eQ),Ve(1,S.$uQ),Ve(2,T.$rpc),Ve(3,$.$pQ),Ve(4,s.$upc),Ve(5,y.$Spc),Ve(6,c.$$j),Ve(7,u.$8oc)],w);let F=class extends w{constructor(L,W,J,M,K,Z,ue,_){super(L,W,J,M,K,Z,ue,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$i(o.Platform.Web)})}async executeTask(L,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const J=k.from(W,L);if(J===void 0)throw new Error("Task is not valid");if(E.is(J.execution))await this.y(J,W,!1);else throw new r.$$;const M=await this.z(await this.a.$getTaskExecution(J),W);return this.a.$executeTask(J).catch(K=>{throw new Error(K)}),M}v(L,W,J,M){const K=[];if(M)for(const Z of M){if(this.A(Z,J),!Z.definition||!L[Z.definition.type]){const _=Z.source?Z.source:"No task source";this.f.warn(`The task [${_}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=k.from(Z,J.extension);ue&&E.is(ue.execution)?(K.push(ue),W.push(this.y(ue,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:J.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,W,J){}};e.$4qc=F,e.$4qc=F=Ge([Ve(0,a.$eQ),Ve(1,S.$uQ),Ve(2,T.$rpc),Ve(3,$.$pQ),Ve(4,s.$upc),Ve(5,y.$Spc),Ve(6,c.$$j),Ve(7,u.$8oc)],F),e.$5qc=(0,d.$Di)("IExtHostTask")}),define(Oe[268],Ne([1,0,44,32]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=void 0,e.$qM=P,e.$sM=O;function P(A){return"cellResults"in A}e.$rM="rawCell#";function O(A,T){let $=-1;const s=[];let R=[];return A.forEach(a=>{a.range.startLineNumber!==$&&R.length>0&&(s.push([...R]),R=[]),R.push(a),$=a.range.endLineNumber}),R.length>0&&s.push([...R]),s.map(a=>{const S=[],d=a[0].range.startLineNumber,n=a[a.length-1].range.endLineNumber;for(let o=d;o<=n;o++)S.push(T.getLineContent(o));return new v.$7L(S.join(`
`)+`
`,a.map(o=>new I.$Mt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Oe[269],Ne([1,0,9,22,6,4,28,36,12,14,2,29,79,5,33,8,7,38,246,124,25,15,44,199,268,266]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0,y=We(y),n=We(n),o=We(o);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,k,C,f,w,F){this.q=k,this.r=C,this.s=f,this.t=w,this.u=F,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new P.$ke,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$ke,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$ke,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$ke,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$6oc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$EN.MainThreadNotebook),this.c=D.getProxy(S.$EN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$EN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,W=N.cell.handle,M=this.g.get(L)?.getCell(W);if(M)return M.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,W=this.g.get(L);if(W)return W.apiNotebook}return N}}),h.C(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,k]of this.h)if(k.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const k=this.g.get(D);if(!k&&!b)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,b){if(!b)return;const k=b.filenamePattern.map(C=>n.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(b.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:k,priority:b.exclusive?p.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,b,k){const C=h.a++,f=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(C,k),this.b.$registerNotebookCellStatusBarItemProvider(C,f,b);let w;return f!==void 0&&(w=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(f))),new o.$GN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,f),w?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return R.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const k=await this.c.$tryOpenNotebook(D),C=this.g.get(R.URI.revive(k));return(0,s.$og)(C?.apiNotebook)}async showNotebookDocument(D,b){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof b=="object"?k={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:k={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),f=C&&this.h.get(C)?.apiEditor;if(f)return f;throw C?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,k,C){const f=this.f.get(D),w=R.URI.revive(b),F=this.g.get(w);if(!F||!f)return;const N=F.getCellFromIndex(k);if(!N)return;const L=await f.provideCellStatusBarItems(N.apiCell,C);if(!L)return;const W=new O.$Sc,J=this.p.add([W]),K=(Array.isArray(L)?L:[L]).map(Z=>n.NotebookStatusBarItem.from(Z,this.i,W));return{cacheId:J,items:K}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,k,C,f){if((0,$.$bf)(b))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:b,serializer:k,options:C}),this.b.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},b,n.NotebookDocumentContentOptions.from(C),h.w(D,f)),(0,O.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,b,k){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.deserializeNotebook(b.buffer,k);return new c.$Vw(n.NotebookData.from(f))}async $notebookToData(D,b,k){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.serializeNotebook(n.NotebookData.to(b.value),k);return I.$Me.wrap(f)}async $saveNotebook(D,b,k,C,f){const w=R.URI.revive(b),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${w.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(w);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$tl((0,v.localize)(10773,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,r.$ko)(N.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of N.apiNotebook.getCells()){const ue=new o.$_O(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);ue.metadata=(0,r.$ko)(Z.metadata,_=>!(F.options?.transientCellMetadata??{})[_]),L.cells.push(ue)}if(await this.z(w,C),f.isCancellationRequested)throw new Error("canceled");const W=await F.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${w.toString()}`),await this.s.value.writeFile(w,W),this.D(`Finished write versionId: ${k} ${w.toString()}`);const J=this.s.getFileSystemProviderExtUri(w.scheme),M=await this.s.value.stat(w),K={name:J.basename(w),isFile:(M.type&y.FileType.File)!==0,isDirectory:(M.type&y.FileType.Directory)!==0,isSymbolicLink:(M.type&y.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((M.permissions??0)&y.FilePermission.Locked),etag:y.$El({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${w.toString()})`),K}async $searchInNotebooks(D,b,k,C,f){const w=this.y.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const F=new A.$Ac;await(async(M,K,Z)=>{await Promise.all(M.map(async ue=>await Promise.all(ue.filenamePatterns.map(_=>{const ge={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:g.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(ge,K,se=>{se.forEach(ae=>{F.has(ae)||C.some(oe=>ue.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(ke=>(0,p.$nL)(ke,ae)))||F.add(ae)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(k,f,b);const L=new A.$zc;let W=!1;const J=Array.from(F).map(async M=>{const K=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((ge,se)=>ge+se.cellResults.length,0)>b.maxResults){W=!0;return}const Z=[],ue=this.g.get(M);if(ue)ue.apiNotebook.getCells().forEach(se=>Z.push({input:se.document.getText(),outputs:se.outputs.flatMap(ae=>ae.items.map($e=>$e.data.toString()))}));else{const ge=await this.s.value.readFile(M),se=I.$Me.fromString(ge.toString()),ae=await w.deserializeNotebook(se.buffer,f);if(f.isCancellationRequested)return;n.NotebookData.from(ae).cells.forEach(oe=>Z.push({input:oe.source,outputs:oe.outputs.flatMap(ke=>ke.items.map(Le=>Le.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Z.forEach((ge,se)=>{const ae=b.contentPattern.pattern,$e=new l.$5Zb(ge.input,void 0,ge.outputs),oe=$e.findInInputs(ae),ke=$e.findInOutputs(ae),Le=ke.flatMap(Y=>(0,m.$sM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(oe.length>0||ke.length>0){const Y={index:se,contentResults:(0,m.$sM)(oe,$e.inputTextBuffer),webviewResults:Le};K.push(Y)}});const _={resource:M,cellResults:K};L.set(M,_);return}catch{return}});return await Promise.all(J),{limitHit:W,results:[...L.values()]}}async z(D,b){const k=await this.s.value.stat(D);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==y.$Dl&&typeof k.mtime=="number"&&typeof k.size=="number"&&b.mtime<k.mtime&&b.etag!==y.$El({mtime:b.mtime,size:k.size}))throw new y.$tl((0,v.localize)(10774,null),y.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,b,k){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const C=new i.$vqc(b,this.d,D,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this.h.set(b,C)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const C=R.URI.revive(k),f=this.g.get(C);f&&(f.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(f.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===C.toString()&&this.h.delete(w.id)}if(D.value.addedDocuments){const k=[];for(const C of D.value.addedDocuments){const f=R.URI.revive(C.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const w=new u.$uqc(this.c,this.q,this.r,f,C);k.push(...C.cells.map(F=>u.$tqc.asModelAddData(F))),this.g.get(f)?.dispose(),this.g.set(f,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const C=R.URI.revive(k.documentUri),f=this.g.get(C);f&&this.B(f,k.id,k)}const b=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const C=this.h.get(k);C&&(this.h.delete(k),this.k?.id===C.id&&(this.k=void 0),b.push(C))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const k=new Set;this.l.forEach(C=>k.add(C.id));for(const C of this.h.values()){const f=k.has(C.id);C._acceptVisibility(f)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const b=d.$CQ.String.with("notebookType","A notebook type"),k=new d.$EQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$CQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>I.$Me.wrap(f))],new d.$DQ("Notebook Data",f=>n.NotebookData.to(f.value))),C=new d.$EQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$CQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Vw(n.NotebookData.from(f)))],new d.$DQ("Bytes",f=>f.buffer));D.registerApiCommand(k),D.registerApiCommand(C)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Eqc=h}),define(Oe[270],Ne([1,0,19,21,42,41,23,69,44]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0,v=We(v),O=We(O),A=We(A);class s{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$yk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$yk(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,n)=>{const o=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const u=c.toString(),i=v.$mc(u);this.j&&this.j(u,i)||this.v(o,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,o))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{n(new Error((0,P.$oj)(c)))})})}async p(a,S){const d=new I.$ve,n=this.q(a),o=this.r(),c=new $.$iM(this.k,a),u=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$ee.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),g=T.$ee.create();return this.g&&!this.e||(r&&r.forEach(l=>{const m=v.$fc.relative(a.folder.path,l.path);if(u){const p=v.$mc(l.path);this.v(S,{base:a.folder,relativePath:m,basename:p});return}this.s(o,a.folder,m,S)}),this.g&&!this.e)?null:(this.u(o,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,$.$hM)(this.k.includePattern,a.includePattern),d=(0,$.$hM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,n){if(d===this.a){const c=v.$mc(this.a);this.v(n,{base:S,relativePath:this.a,basename:c})}function o(c){const u=v.$mc(c),i=v.$lc(c);let r=a[i];r||(r=a[i]=[],o(i)),r.push({base:S,relativePath:c,basename:u})}o(d)}u({rootEntries:a,pathToEntries:S},d,n){const o=this,c=this.a;function u(i){const r=(0,$.$kM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const l=i[t],{relativePath:m,basename:p}=l;if(d.matchesExcludesSync(m,p,c!==p?r:void 0))continue;const h=S[m];if(h)u(h);else{if(m===c)continue;o.v(n,l)}if(o.e)break}}u(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,n){const o=this.c(a.cacheKey),c=new s(a,S,o&&o.token);let u=0;const i=r=>{u+=r.length,d(r.map(t=>this.d(t)))};return this.e(c,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:r.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new I.$ve),this.b.get(a)}d(a){return a.relativePath?{resource:A.$eh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,n){const o=n.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(u.push(i),S>0&&u.length>=S&&(d(u),u=[]))};let u=[];return a.search(c).then(i=>(u.length&&d(u),o.dispose(),i),i=>(u.length&&d(u),o.dispose(),Promise.reject(i)))}}e.$wqc=R}),define(Oe[271],Ne([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0,e.$jN=b,v=We(v),I=We(I),P=We(P),$=We($),R=We(R),d=We(d);let t=class{constructor(C,f,w,F,N){this.a=C,this.b=f,this.c=w,this.d=F,this.e=N}text(C,f,w={}){C=this.f(C,w);const F=this.a.getValue(),N=f&&f.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(f?.map(c.$Yi),w),type:r.QueryType.Text,contentPattern:C,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(C,f){const w=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const F={...C,wordSeparators:w.editor.wordSeparators};return this.j(C,f)&&(F.isCaseSensitive=!0),this.k(C)&&(F.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),F}file(C,f={}){return{...this.h(C,f),type:r.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(C,f){return C?(C=Array.isArray(C)?C.map(h):h(C),f?this.parseSearchPaths(C):{pattern:l(...Array.isArray(C)?C:[C])}):{}}h(C=[],f={}){const w=this.g(f.includePattern,f.expandPatterns),F=this.g(f.excludePattern,f.expandPatterns),N=C.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(M=>this.q(M,f,F)):C.map(M=>this.r(M,f,F,N))).filter(M=>!!M),W={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const M=v.$Gb(this.c.groups.flatMap(ue=>ue.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const K=M.filter(ue=>(0,r.$$L)(W,ue.fsPath)),Z=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...W,...Z}}const J=f.extraFileResources&&f.extraFileResources.filter(M=>(0,r.$$L)(W,M.fsPath));return W.extraFileResources=J&&J.length?J:void 0,W}i(C){const f=[],w=new A.$zc,F={};let N=!1;return C.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,s.$ih)(L)){const J=this.b.getWorkspaceFolder(L)?.uri??L.with({path:$.$lc(L.fsPath)});let M=w.get(J);M||(N=!0,M={folder:J,includePattern:{}},f.push(M),w.set(J,M));const K=$.$kc(J.fsPath,L.fsPath);(0,y.$og)(M.includePattern)[K.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,F[L.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(C,f){if(f.isSmartCase){if(C.isRegExp){if(R.$7f(C.pattern,!0))return!0}else if(R.$7f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,S.$jD)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const f=Z=>$.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),F=(Array.isArray(C)?C:m(C)).map(Z=>{const ue=this.e.resolvedUserHome;return ue?(0,O.$1w)(Z,ue.scheme===T.Schemas.file?ue.fsPath:ue.path):Z}),N=I.$c(F,Z=>f(Z)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(Z=>R.$mf(Z,"/")).map(Z=>R.$mf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),p(Z))),W={},J=this.m(N.searchPaths||[]);J&&J.length&&(W.searchPaths=J);const M=L.flat(),K=l(...M);return K&&(W.pattern=K),W}l(C,f){return f.disregardExcludeSettings?void 0:(0,r.$0L)(C,!f.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const f=C.flatMap(F=>{let{pathPortion:N,globPortion:L}=g(F);return L&&(L=E(L)),this.n(N).flatMap(J=>this.o(J,L))}),w=new Map;return f.forEach(F=>{const N=F.searchPath.toString(),L=w.get(N);L?F.pattern&&(L.pattern=L.pattern||{},L.pattern[F.pattern]=!0):w.set(N,{searchPath:F.searchPath,pattern:F.pattern?l(F.pattern):void 0})}),Array.from(w.values())}n(C){if($.$hc(C)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:C})}]:[{searchPath:a.URI.file($.$gc(C))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(C=h(C),C.startsWith("../")||C===".."){const F=$.$fc.resolve(f.path,C);return[{searchPath:f.with({path:F})}]}const w=E(C);return[{searchPath:f,pattern:w}]}else{if(C==="./"||C===".\\")return[];{const f=C.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${R.$gf(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$lg);if(F.length)return F.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=C.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:C,W=d.localize(1616,null,L);throw new Error(W)}}}}o(C,f){const w=C.pattern&&f?`${C.pattern}/${f}`:C.pattern||f,F=[{searchPath:C.searchPath,pattern:w}];return w&&!w.endsWith("**")&&F.push({searchPath:C.searchPath,pattern:w+"/**"}),F}q(C,f,w){const F=this.r((0,c.$Yi)(C.searchPath),f,w,!1);return F?{...F,includePattern:C.pattern}:null}r(C,f,w,F){let N;const L=a.URI.isUri(C)?C:C.uri;if(w.searchPaths){const Z=w.searchPaths.filter(ue=>(0,s.$0g)(ue.searchPath,L))[0];if(Z&&!Z.pattern)return null;Z&&(N=Z.pattern)}const W=this.a.getValue({resource:L}),M={...this.l(W,f)||{},...N||{}},K=a.URI.isUri(C)?(0,s.$bh)(C):C.name;return{folder:L,folderName:F?K:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!W.search.followSymlinks}}};e.$iN=t,e.$iN=t=Ge([Ve(0,n.$0i),Ve(1,c.$Mi),Ve(2,u.$rE),Ve(3,o.$$j),Ve(4,i.$gN)],t);function g(k){const C=k.match(/[\*\{\}\(\)\[\]\?]/);if(C){const f=C.index,w=k.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let F=k.substr(0,w.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((w.index||0)+1)}}}return{pathPortion:k}}function l(...k){return k.length?k.reduce((C,f)=>(C[f]=!0,C),Object.create(null)):void 0}function m(k){return P.$wk(k,",").map(C=>C.trim()).filter(C=>!!C.length)}function p(k){return[`**/${k}/**`,`**/${k}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function h(k){return k.replace(/\\/g,"/")}function E(k){return h(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function b(k,C){k=v.$Lb(k,F=>F.toString());const f=[],w=C.getWorkspace();return k&&k.forEach(F=>{let N;if(C.getWorkbenchState()===c.WorkbenchState.FOLDER)N=(0,s.$gh)(w.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const L=C.getWorkspaceFolder(F);if(L){const W=L.name;if(w.folders.filter(M=>M.name===W).length===1){const M=(0,s.$gh)(L.uri,F);M===""?N=`./${L.name}`:N=`./${L.name}/${M}`}else N=F.fsPath}}N&&f.push(D(N))}),f}}),define(Oe[272],Ne([1,0,23,2,21,13,3,271,44,49,10]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uyb=a,e.$vyb=n,v=We(v),O=We(O);const y=7e3;function a(o,c){const u=c.activationEvents;if(!u)return Promise.resolve(void 0);const i=[],r=[];for(const h of u)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||o.forceUsingSearch?r.push(E):i.push(E)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,R.$wh)(),l=h=>g({activationEvent:h}),m=Promise.all(i.map(h=>S(o,h,l))).then(()=>{}),p=d(o,c.identifier,r,l);return Promise.all([m,p]).then(()=>{g(void 0)}),t}async function S(o,c,u){for(const i of o.folders)if(await o.exists(v.$eh(I.URI.revive(i),c))){u(`workspaceContains:${c}`);return}}async function d(o,c,u,i){if(u.length===0)return Promise.resolve(void 0);const r=new P.$ve,t=o.checkExists(o.folders,u,r.token),g=setTimeout(async()=>{r.cancel(),o.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},y);let l=!1;try{l=await t}catch(m){O.$3(m)||O.$Y(m)}r.dispose(),clearTimeout(g),l&&i(`workspaceContains:${u.join(",")}`)}function n(o,c,u,i){const r=o.get(A.$Ci),t=o.get($.$2L),l=r.createInstance(T.$iN).file(c.map(m=>(0,s.$Yi)(I.URI.revive(m))),{_reason:"checkExists",includePattern:u,exists:!0});return t.fileSearch(l,i).then(m=>!!m.limitHit,m=>O.$3(m)?!1:Promise.reject(m))}}),define(Oe[47],Ne([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p,h,E,D,b,k,C,f,w,F,N,L,W,J,M,K){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=e.$9pc=e.$8pc=e.$7pc=e.$6pc=void 0,v=We(v),I=We(I),P=We(P),u=We(u),e.$6pc=(0,m.$Di)("IHostUtils");let ue=Z=class extends T.$Tc{constructor(Y,q,te,ve,ce,we,he,X,x,me,pe,Ae,Ue){super(),this.Y=Ae,this.Z=Ue,this.a=this.B(new f.$ke),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=te,this.f=he,this.j=ve,this.m=ce,this.s=we,this.t=x,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$EN.MainThreadWorkspace),this.z=this.g.getProxy(y.$EN.MainThreadTelemetry),this.C=this.g.getProxy(y.$EN.MainThreadExtensionService),this.D=new A.$Ch,this.F=new A.$Ch,this.G=new A.$Ch,this.H=new A.$Ch,this.I=new ke(this.f.extensions.activationEvents),this.L=new c.$tdc(this.I,this.f.extensions.allExtensions);const Se=new i.$qn(this.f.extensions.myExtensions);this.J=new c.$tdc(this.I,$e(this.L,Se)),M.$u&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$Opc(this.g,this.s),this.N=new F.$Ypc(this.g),this.O=X,this.h=this.q.add(Y.createChild(new D.$Bi([d.$Ppc,this.M],[F.$Zpc,this.N]))),this.P=this.B(new S.$Npc(this.J,this.L,{onExtensionActivationError:(Pe,Te,j)=>{this.C.$onExtensionActivationError(Pe,u.$1(Te),j)},actualActivateExtension:async(Pe,Te)=>{if(c.$tdc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new S.$Mpc;const j=this.J.getExtensionDescription(Pe);return this.fb(j,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){u.$Y(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),u.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const te=this.$();Promise.race([(0,A.$Eh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$pn(q.identifier.value),extensionLocation:s.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const te=this.P.getActivatedExtension(Y);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const te=await this.R.get(q);return s.URI.file(te)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new oe(Y))),this.Q}async db(Y){const q=$.$Ji.forUris(te=>O.$8g.ignorePathCasing(te));return await Promise.all(Y.map(async te=>{if(this.wb(te)){const ve=await this.cb(te.extensionLocation);q.set(ve,te)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const te=this.P.getActivatedExtension(Y);if(!te)return q;try{typeof te.module.deactivate=="function"&&(q=Promise.resolve(te.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{te.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(te=>{const ve=te.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Y,q,"success",ve),te},te=>{throw this.gb(Y,q,"failure"),te})}gb(Y,q,te,ve){const ce=ge(Y,q);this.z.$publicLog2("extensionActivationTimes",{...ce,...ve||{},outcome:te})}hb(Y,q){const te=ge(Y,q);this.z.$publicLog2("activatePlugin",te);const ve=this.wb(Y);if(!ve)return Promise.resolve(new S.$Lpc(S.$Ipc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ce=new T.$Sc,we=new S.$Jpc(q.startup);return Promise.all([this.xb(Y,(0,O.$eh)(Y.extensionLocation,ve),we),this.ib(Y,ce)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Z.jb(this.s,Y.identifier,he[0],he[1],ce,we))).then(he=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),he))}ib(Y,q){const te=this.Z.createLanguageModelAccessInformation(Y),ve=q.add(new t.$Rpc(Y,this.M)),ce=q.add(new t.$Qpc(Y.identifier.value,!1,this.M)),we=q.add(new N.$1pc(Y,this.N)),he=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,X=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ve.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const x=this;let me,pe;const Ae=(0,o.$dH)(Y,"ipc")?this.f.messagePorts?.get(i.$pn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:ce,secrets:we,subscriptions:[],get languageModelAccessInformation(){return te},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Ue){return I.$ic(Y.extensionLocation.fsPath,Ue)},get storagePath(){return x.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return x.O.globalValue(Y).fsPath},get logPath(){return I.$ic(x.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return s.URI.joinPath(x.f.logsLocation,Y.identifier.value)},get storageUri(){return x.O.workspaceValue(Y)},get globalStorageUri(){return x.O.globalValue(Y)},get extensionMode(){return he},get extension(){return me===void 0&&(me=new ae(x,Y.identifier,Y,X,!1)),me},get extensionRuntime(){return(0,o.$eH)(Y,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!pe){if(!Ae)return;const Ue=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",Se=>Se.data));Ae.start(),pe={onDidReceiveMessage:Ue,postMessage:Ae.postMessage.bind(Ae)}}return pe}})})}static jb(Y,q,te,ve,ce,we){return te=te||{activate:void 0,deactivate:void 0},this.kb(Y,q,te,ve,we).then(he=>new S.$Kpc(!1,null,we.build(),te,he,(0,T.$Rc)(()=>{ce.dispose(),(0,T.$Oc)(ve.subscriptions)})))}static kb(Y,q,te,ve,ce){if(typeof te.activate=="function")try{ce.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const we=typeof global=="object"?global:self,he=te.activate.apply(we,[ve]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(he).then(X=>(ce.activateResolveStop(),X))}catch(we){return Promise.reject(we)}else return Promise.resolve(te)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,te=>{this.s.error(te)})}mb(Y,q=0){const ve=Date.now();(0,M.$C)(()=>{for(let ce=q;ce<Y.length;ce+=1){const we=Y[ce];for(const he of we.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,ce);break}else this.lb(we,he)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(q)this.mb(te);else for(const ve of te)if(ve.activationEvents)for(const ce of ve.activationEvents)ce==="onStartupFinished"&&this.lb(ve,ce)})}ob(){const Y=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const q=this.j.workspace?this.j.workspace.folders:[],te=this.pb(q),ve=this.rb(),ce=Promise.all([ve,Y,te]).then(()=>{});return Promise.race([ce,(0,A.$Eh)(1e4)]).then(()=>{this.nb()}),ce}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(we=>we.uri),forceUsingSearch:te||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,he,X)=>this.y.$checkExists(we,he,X)},ce=await(0,w.$uyb)(ve,q);if(ce)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ce.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(v.localize(10781,null));const te=await this.xb(null,q,new S.$Jpc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(10782,null,q.toString()));return new Promise((ve,ce)=>{const we=(x,me)=>{x?(M.$u&&this.s.error("Test runner called back with error",x),ce(x)):(M.$u&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},he=(0,O.$5g)(q),X=te.run(he,we);X&&X.then&&X.then(()=>{M.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(x=>{M.$u&&this.s.error("Test runner finished with error",x),ce(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Eh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,T.$Rc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new g.$ON("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(Y,q){const te=J.$ee.create(!1),ve=()=>`[resolveAuthority(${(0,l.$Tl)(Y)},${q})][${te.elapsed()}ms] `,ce=B=>this.s.info(`${ve()}${B}`),we=B=>this.s.warn(`${ve()}${B}`),he=(B,H=void 0)=>this.s.error(`${ve()}${B}`,H),X=B=>{if(B instanceof g.$ON)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},x=async B=>{ce(`activating resolver for ${B}...`);const{resolver:H,authorityPrefix:V}=await this.ub(B);if(!H)throw he(`no resolver for ${V}`),new g.$ON(`No remote extension installed to resolve ${V}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:V,remoteAuthority:B}},me=Y.split(/@|%40/g).reverse();ce(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(x)).catch(async B=>{if(!(B instanceof g.$ON)||B._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return we(`resolving nested authorities failed: ${B.message}`),[await x(Y)]})}catch(B){return X(B)}const Ae=new A.$Oh;Ae.cancelAndSet(()=>ce("waiting..."),1e3);let Ue,Se;for(const[B,{authorityPrefix:H,resolver:V,remoteAuthority:ne}]of pe.entries())try{if(B===pe.length-1)ce("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),Ue=await V.resolve(ne,{resolveAttempt:q,execServer:Se}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$NN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(ce(`invoking resolveExecServer() for ${ne}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Se=await V.resolveExecServer?.(ne,{resolveAttempt:q,execServer:Se}),!Se)throw new g.$ON(`Exec server was not available for ${ne}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(fe){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),he("returned an error",fe),Ae.dispose(),X(fe)}Ae.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${g.$NN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let j;if(g.$NN.isManagedResolvedAuthority(Ue)){const B=q;this.Y.setFactory(B,Ue.makeConnection),j={authority:Y,connectTo:new l.$Ql(B),connectionToken:Ue.connectionToken}}else j={authority:Y,connectTo:new l.$Rl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:j,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Tl)(Y)})`);const{resolver:te}=await this.ub(Y);if(!te)return null;const ve=s.URI.revive(q);if(typeof te.getCanonicalURI>"u")return ve;const ce=await(0,A.$vh)(()=>te.getCanonicalURI(ve));return ce||ve}async $startExtensionHost(Y){Y.toAdd.forEach(we=>we.extensionLocation=s.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,Y),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),M.$u&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===o.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(Y,!1)):this.G.wait().then(te=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(we=>we.extensionLocation=s.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,Y),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),M.$u&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=r.$Me.alloc(Y),te=Math.random()%256;for(let ve=0;ve<Y;ve++)q.writeUInt8(te,ve);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$7pc=ue,e.$7pc=ue=Z=Ge([Ve(0,m.$Ci),Ve(1,e.$6pc),Ve(2,E.$eQ),Ve(3,n.$rpc),Ve(4,a.$upc),Ve(5,R.$$j),Ve(6,p.$uQ),Ve(7,h.$xpc),Ve(8,b.$aGb),Ve(9,k.$Spc),Ve(10,W.$3pc),Ve(11,K.$4pc),Ve(12,C.$Wpc)],ue);function _(Le,Y,q,te){Le.addActivationEvents(te.addActivationEvents);const ve=new c.$tdc(Le,Y.getAllExtensionDescriptions());ve.deltaExtensions(te.toAdd,te.toRemove);const ce=new i.$qn(q.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of te.myToRemove)ce.delete(he);for(const he of te.myToAdd)ce.add(he);const we=$e(ve,ce);return{globalRegistry:ve,myExtensions:we}}function ge(Le,Y){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$8pc=(0,m.$Di)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(Y,q,te,ve,ce){this.#e=Y,this.#t=q,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=I.$gc((0,O.$5g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ve,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9pc=ae;function $e(Le,Y){return Le.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class oe{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$0pc=oe;class ke{constructor(Y){this.a=new i.$rn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Oe[273],Ne([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0,v=We(v);let n=class{constructor(r,t,g,l,m,p,h){this.c=r,this.d=t,this.e=g,this.f=l,this.g=m,this.h=p,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(u,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$irc=n,e.$irc=n=Ge([Ve(2,R.$Ci),Ve(3,O.$upc),Ve(4,y.$8pc),Ve(5,s.$uQ),Ve(6,a.$$j)],n);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,S.$gf)(this.c(r.environment.appRoot.fsPath)),g="[a-z0-9_.-]",l=`@${g}+\\/${g}+|${g}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,g,l,m]=t,p=d.a.get(l);if(p!==void 0)return console.warn(`${l} as been renamed to ${p}, please update your imports`),g+p+m}c(r){return r.replace(/\\/g,"/")}};o=d=Ge([Ve(0,s.$uQ)],o);class c{constructor(r,t,g,l,m){this.c=r,this.d=t,this.e=g,this.f=l,this.g=m,this.nodeModuleName="vscode",this.a=new T.$rn}load(r,t){const g=this.d.findSubstr(t);if(g){let l=this.a.get(g.identifier);return l||(l=this.c(g,this.e,this.f),this.a.set(g.identifier,l)),l}if(!this.b){let l="";this.d.forEach((m,p)=>l+=`	${p} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(A.$$G,this.e,this.f)}return this.b}}let u=class{constructor(r,t,g){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(P.$EN.MainThreadTelemetry);const l=g.getProxy(P.$EN.MainThreadWindow);this.c=(m,p)=>{const h=I.URI.parse(m);return p?this.g(m,p):h.scheme==="http"||h.scheme==="https"?l.$openUri(h,m,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?l.$openUri(h,m,{}):this.g(m,p)}}load(r,t,g){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=g(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};u=Ge([Ve(2,$.$eQ)],u)}),define(Oe[132],Ne([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=e.$$pc=void 0,P=We(P),O=We(O),e.$$pc=(0,A.$Di)("IExtHostVariableResolverProvider");class d extends a.$iR{constructor(c,u,i,r,t,g,l){function m(){if(i){const p=i.activeEditor();if(p)return p.document.uri;const h=r.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof R.$vP||h.input instanceof R.$AP)return h.input.modified;if(h.input instanceof R.$uP||h.input instanceof R.$zP||h.input instanceof R.$xP)return h.input.uri}}}super({getFolderUri:p=>{const h=g.folders.filter(E=>E.name===p);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(p,h)=>t.getConfiguration(void 0,p).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=m();if(p)return P.$gc(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const p=m();if(p){const h=u.getWorkspaceFolder(p);if(h)return P.$gc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const p=i.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(i){const p=i.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>c.getExtension(p)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(O.env))}}let n=class extends I.$Tc{constructor(c,u,i,r,t){super(),this.b=c,this.c=u,this.g=i,this.h=r,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async p=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$_pc=n,e.$_pc=n=Ge([Ve(0,s.$8pc),Ve(1,y.$rpc),Ve(2,T.$pQ),Ve(3,S.$upc),Ve(4,$.$Gpc)],n)}),define(Oe[133],Ne([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=e.$iqc=e.$hqc=e.$gqc=e.$fqc=void 0,t=We(t),e.$fqc=(0,T.$Di)("IExtHostDebugService");let m=class extends O.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,f,w,F,N,L,W,J){super(),this.Y=f,this.Z=w,this.$=F,this.ab=N,this.bb=L,this.cb=W,this.db=J,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new I.$ke),this.z=this.B(new I.$ke),this.C=this.B(new I.$ke),this.F=this.B(new I.$ke),this.u=C.getProxy($.$EN.MainThreadDebugService),this.I=this.B(new I.$ke),this.L=this.B(new I.$ke),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(K=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(C,f){const w=this.gb(f);if(!w)return;const F=await this.Q.get(C)?.getTreeItem?.(w);return F?this.eb(C,F):void 0}registerDebugVisualizationTree(C,f,w){const F=A.$pn.toKey(C.identifier),N=this.ub(F,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,w),this.u.$registerDebugVisualizerTree(N,!!w.editItem),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(C,f){const w=this.S.get(f)?.item;return w?(await this.Q.get(C)?.getChildren?.(w))?.map(N=>this.eb(C,N))||[]:[]}async $editVisualizerTreeItem(C,f){const w=this.S.get(C);if(!w)return;const F=await this.Q.get(w.provider)?.editItem?.(w.item,f);return this.eb(w.provider,F||w.item)}$disposeVisualizedTree(C){const f=this.S.get(C);if(!f)return;const w=[f.children];for(const F of w)if(F)for(const N of F)w.push(this.S.get(N)?.children),this.S.delete(N)}eb(C,f){let w=this.R.get(f);return w||(w=this.O++,this.R.set(f,w),this.S.set(w,{provider:C,item:f})),t.DebugTreeItem.from(f,w)}asDebugSourceUri(C,f){const w=C;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let F=`debug:${encodeURIComponent(w.path||"")}`,N="?";return f&&(F+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),F+=`${N}ref=${w.sourceReference}`,P.URI.parse(F)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const f=[];for(const w of C.getAllExtensionDescriptions())if(w.contributes){const F=w.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,o.$9H)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(f=>C.push(f)),C}async $resolveDebugVisualizer(C,f){const w=this.W.get(C);if(!w)throw new Error(`No debug visualizer found with id '${C}'`);let{v:F,provider:N,extensionId:L}=w;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,f)||F,w.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,F.visualization)}async $executeDebugVisualizerCommand(C){const f=this.W.get(C);if(!f)throw new Error(`No debug visualizer found with id '${C}'`);const w=f.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(C){const f=this.w.get(C.sessionId);return f&&{session:f.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,f,w,F){const N=this.gb(w),L=this.ub(C,f),W=this.P.get(L);if(!N||!W)return[];const J=await W.provideDebugVisualization(N,F);return J?J.map(M=>{const K=++this.X;this.W.set(K,{v:M,provider:W,extensionId:C});const Z=M.iconPath?this.wb(M.iconPath):void 0;return{id:K,name:M.name,iconClass:Z?.iconClass,iconPath:Z?.iconPath,visualization:this.vb(C,M.visualization)}}):[]}$disposeDebugVisualizers(C){for(const f of C)this.W.delete(f)}registerDebugVisualizationProvider(C,f,w){if(!C.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const F=A.$pn.toKey(C.identifier),N=this.ub(F,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,w),this.u.$registerDebugVisualizer(F,f),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizer(F,f),this.P.delete(f)})}addBreakpoints(C){const f=C.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(f,[],[]);const w=[],F=new Map;for(const N of f)if(N instanceof a.$KO){let L=F.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),L),w.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$LO&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(C){const f=C.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const w=f.filter(L=>L instanceof a.$KO).map(L=>L.id),F=f.filter(L=>L instanceof a.$LO).map(L=>L.id),N=f.filter(L=>L instanceof a.$MO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,F,N)}startDebugging(C,f,w){const F=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(C?C.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,f,w){if(!f)return new a.$GN(()=>{});const F=this.f++;return this.g.push({type:C,handle:F,provider:f}),this.u.$registerDebugConfigurationProvider(C,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,F),new a.$GN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(C,f,w){if(!w)return new a.$GN(()=>{});if(!this.nb(C,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:f,handle:F,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(f,F),new a.$GN(()=>{this.j=this.j.filter(N=>N.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(C,f){if(!f)return new a.$GN(()=>{});const w=this.m++;return this.n.push({type:C,handle:w,factory:f}),new a.$GN(()=>{this.n=this.n.filter(F=>F.factory!==f)})}async $runInTerminal(C,f){return Promise.resolve(void 0)}async $substituteVariables(C,f){let w;const F=await this.tb(C);return F&&(w={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,f)}hb(C,f){if(C.type==="implementation")return new D(C.implementation)}ib(){}async $startDASession(C,f){const w=this,F=await this.sb(f);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const L=this.jb(N),W=this.hb(L,F);if(!W)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const J=W;return this.M.set(C,J),this.ob(F).then(M=>(M&&this.N.set(C,M),J.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const Z=K,ue={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(Z.arguments.value);ue.body={signature:_},J.sendResponse(ue)}else throw new Error("no signer")}catch(_){ue.success=!1,ue.message=_.message,J.sendResponse(ue)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(K),K=(0,o.$bI)(K,!0),w.u.$acceptDAMessage(C,K)}),J.onError(K=>{M&&M.onError&&M.onError(K),this.u.$acceptDAError(C,K.name,K.message,K.stack)}),J.onExit(K=>{M&&M.onExit&&M.onExit(K??void 0,void 0),this.u.$acceptDAExit(C,K??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),J.startSession()))})}$sendDAMessage(C,f){f=(0,o.$aI)(f,!1);const w=this.N.get(C);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f),this.M.get(C)?.sendMessage(f)}$stopDASession(C){const f=this.N.get(C);this.N.delete(C),f&&f.onWillStopSession&&f.onWillStopSession();const w=this.M.get(C);return this.M.delete(C),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const f=[],w=[],F=[];if(C.added)for(const N of C.added){const L=N.id;if(L&&!this.H.has(L)){let W;if(N.type==="function")W=new a.$LO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")W=new a.$MO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const J=P.URI.revive(N.uri);W=new a.$KO(new a.$UN(J,new a.$HN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$IO)(W,L),this.H.set(L,W),f.push(W)}}if(C.removed)for(const N of C.removed){const L=this.H.get(N);L&&(this.H.delete(N),w.push(L))}if(C.changed){for(const N of C.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof a.$LO&&N.type==="function"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.functionName=N.functionName}else if(L instanceof a.$KO&&N.type==="source"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.location=new a.$UN(P.URI.revive(N.uri),new a.$HN(N.line,N.character))}F.push(L)}}}this.rb(f,w,F)}async $acceptStackFrameFocus(C){let f;if(C){const w=await this.sb(C.sessionId);C.kind==="thread"?f=new a.$SO(w.api,C.threadId):f=new a.$RO(w.api,C.threadId,C.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(C,f,w){return(0,v.$vh)(async()=>{const F=this.mb(C);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return F.provideDebugConfigurations(N,w)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(C,f,w,F){return(0,v.$vh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return N.resolveDebugConfiguration(L,w,F)})}$resolveDebugConfigurationWithSubstitutedVariables(C,f,w,F){return(0,v.$vh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(L,w,F)})}async $provideDebugAdapter(C,f){const w=this.lb(C);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(f);return this.pb(w,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(C){const f=await this.sb(C);this.y.fire(f.api)}async $acceptDebugSessionTerminated(C){const f=await this.sb(C);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,f){(await this.sb(C))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(C,f){const F={session:(await this.sb(C)).api,event:f.event,body:f.body};this.F.fire(F)}jb(C){if(C instanceof a.$NO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof a.$OO)return{type:"server",port:C.port,host:C.host};if(C instanceof a.$PO)return{type:"pipeServer",path:C.path};if(C instanceof a.$QO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const f=this.j.filter(w=>w.type===C);if(f.length>0)return f[0].factory}lb(C){const f=this.j.filter(w=>w.handle===C);if(f.length>0)return f[0].factory}mb(C){const f=this.g.filter(w=>w.handle===C);if(f.length>0)return f[0].provider}nb(C,f){if(C.contributes){const w=C.contributes.debuggers;if(w&&w.length>0){for(const F of w)if(F.label&&F.type&&F.type===f)return!0}}return!1}ob(C){const w=C.configuration.type,F=this.n.filter(N=>N.type===w||N.type==="*").map(N=>(0,v.$vh)(()=>N.factory.createDebugAdapterTracker(C.api)).then(L=>L,L=>null));return Promise.race([Promise.all(F).then(N=>{const L=(0,g.$Gb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(C,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new a.$OO(w));if(C){const N=await this.Z.getExtensionRegistry();return(0,v.$vh)(()=>C.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(L=>{if(L)return L})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,F))}qb(C,f){}rb(C,f,w){(C.length>0||f.length>0||w.length>0)&&this.I.fire(Object.freeze({added:C,removed:f,changed:w}))}async sb(C){if(C)if(typeof C=="string"){const f=this.w.get(C);if(f)return f}else{let f=this.w.get(C.id);if(!f){const w=await this.tb(C.folderUri),F=C.parent?this.w.get(C.parent):void 0;f=new p(this.u,C.id,C.type,C.name,w,C.configuration,F?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(C){if(C){const f=P.URI.revive(C);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(C,f){return`${C}\0${f}`}vb(C,f){if(f){if("title"in f&&"command"in f)return{type:n.DebugVisualizationType.Command};if("treeId"in f)return{type:n.DebugVisualizationType.Tree,id:`${C}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const f=this.xb(C);let w,F;return"id"in f?F=i.ThemeIcon.asClassName(f):w=f,{iconPath:w,iconClass:F}}xb(C){if(C instanceof a.$FO)return{id:C.id};const f=typeof C=="object"&&"dark"in C?C.dark:C,w=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof w=="string"?P.URI.file(w):w}}};e.$gqc=m,e.$gqc=m=Ge([Ve(0,y.$eQ),Ve(1,S.$rpc),Ve(2,R.$8pc),Ve(3,c.$upc),Ve(4,s.$Gpc),Ve(5,u.$$pc),Ve(6,r.$AQ),Ve(7,l.$aqc)],m);class p{constructor(C,f,w,F,N,L,W){this.f=C,this.g=f,this.h=w,this.j=F,this.k=N,this.l=L,this.m=W}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(f){C.j=f,C.f.$setDebugSessionName(C.g,f)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(f,w){return C.f.$customDebugAdapterRequest(C.g,f,w)},getDebugProtocolBreakpoint(f){return C.f.$getDebugProtocolBreakpoint(C.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$hqc=p;class h{constructor(C){this.value=Object.freeze({append(f){C.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$iqc=h;class E{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(f=>f.onError?f.onError(C):void 0)}onExit(C,f){this.d.forEach(w=>w.onExit?w.onExit(C,f):void 0)}}class D extends d.$Ztb{constructor(C){super(),this.h=C,C.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends m{constructor(C,f,w,F,N,L,W,J){super(C,f,w,F,N,L,W,J)}};e.$jqc=b,e.$jqc=b=Ge([Ve(0,y.$eQ),Ve(1,S.$rpc),Ve(2,R.$8pc),Ve(3,c.$upc),Ve(4,s.$Gpc),Ve(5,u.$$pc),Ve(6,r.$AQ),Ve(7,l.$aqc)],b)}),define(Oe[274],Ne([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=e.$jrc=void 0,v=We(v),I=We(I);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$$j),g=i.get(a.$eQ).getProxy(O.$EN.MainThreadErrors);v.setUnexpectedErrorHandler(l=>{r.error(l);const m=v.$1(l);g.$onUnexpectedError(m)})}static async installFullHandler(i){const r=i.get(T.$$j),t=i.get(a.$eQ),g=i.get(d.$8pc),l=i.get(n.$yQ),m=t.getProxy(O.$EN.MainThreadExtensionService),p=t.getProxy(O.$EN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(C,f){if(E.has(C))return E.get(C).stack;let w="",F,N;for(const W of f)w+=`
	at ${W.toString()}`,N=W.getFileName(),!F&&N&&(F=h.findSubstr(P.URI.file(N)));const L=`${C.name||"Error"}: ${C.message||""}${w}`;return E.set(C,{extensionIdentifier:F?.identifier,stack:L}),L}const b=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(C){if(C===D||!C||C[b]){k=C||D;return}k=function(f,w){return D(f,w),C.call(Error,f,w)},Object.assign(k,{[b]:!0})}}),v.setUnexpectedErrorHandler(C=>{r.error(C);const f=v.$1(C),w=E.get(C);if(!w?.extensionIdentifier){p.$onUnexpectedError(f);return}m.$onExtensionRuntimeError(w.extensionIdentifier,f);const F=l.onExtensionError(w.extensionIdentifier,C);r.trace("forwarded error to extension?",F,w)})}}e.$jrc=o;class c{constructor(i,r,t,g,l){this.a=t,this.b=new A.$Bdc(i,null,g),r=c.e(r,this.b);const m=new s.$Bi(...(0,$.$Qs)());m.set(R.$uQ,{_serviceBrand:void 0,...r,messagePorts:l}),m.set(a.$eQ,new a.$fQ(this.b)),m.set(S.$opc,new S.$ppc(g)),m.set(d.$6pc,t);const p=new y.$ur(m,!0);p.invokeFunction(o.installEarlyHandler),this.d=p.invokeFunction(h=>h.get(T.$$j)),I.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=p.invokeFunction(h=>h.get(d.$8pc)),this.c.initialize(),p.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$EN.MainThreadExtensionService);return P.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(r.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(r.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$krc=c}),define(Oe[275],Ne([1,0,17,10,21,42,15,19,23,2,44]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=e.$yqc=e.$xqc=void 0,e.$zqc=n,T=We(T),$=We($);class y{constructor(u,i,r){this.d=u,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(u,i){const r=this.g.folderQueries||[],t=new P.$ve(i);return new Promise((g,l)=>{this.a=new S(u);let m=!1;const p=(h,E)=>{if(!m&&!this.b){const D=this.h(h);n(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,m=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const b=this.h(h);this.c+=b,(b>0||!n(h))&&this.a.add(h,E)}};Promise.all(r.map((h,E)=>this.k(h,D=>p(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$oj)(h);l(new Error(E))})})}h(u){return n(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}j(u,i){const r=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:u.preview.text},uri:u.uri}}async k(u,i,r){const t=new R.$iM(this.g,u),g=[],l={report:h=>{if(!this.l(h))return;const E=u.folder.scheme===A.Schemas.file?(0,R.$jM)(()=>this.e.readdir($.$dh(h.uri))):void 0,D=$.$gh(u.folder,h.uri);if(D){const b=t.includedInQuery(D,T.$mc(D),E);(0,I.$ph)(b)?g.push(b.then(k=>{k&&i(h)})):b&&i(h)}}},m=this.n(u);let p;return this.d.query.type===R.QueryType.aiText?p=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,m,l,r):p=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),m,l,r),g.length&&await Promise.all(g),p}l(u){if(n(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(u){const i=(0,R.$hM)(this.g.includePattern,u.includePattern),r=(0,R.$hM)(this.g.excludePattern,u.excludePattern),t={folder:s.URI.from(u.folder),excludes:r,includes:i,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.e.toCanonicalName(u.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$1L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$xqc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(u){this.e=u,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(u,i){this.d&&(this.b!==i||!$.$0g(this.c,u.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:u.uri,results:[]}),this.d.results.push(d(u))}f(){const u=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,u)}flush(){this.f(),this.a.flush()}g(u){this.e(u)}}e.$yqc=S;function d(c){return n(c)?{preview:{matches:(0,v.$Zb)(c.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:c.preview.text},ranges:(0,v.$Zb)(c.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function n(c){return!!c.preview}class o{static{this.a=4e3}static{this.b=50}constructor(u,i){this.g=u,this.h=i,this.c=0,this.d=[],this.e=0}addItem(u,i){u&&this.j(u,i)}addItems(u,i){u&&this.k(u,i)}j(u,i){this.d.push(u),this.e+=i,this.l()}k(u,i){this.d=this.d.concat(u),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Aqc=o}),define(Oe[134],Ne([1,0,4,5,3,270,16,65,11,2,275]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=e.$Bqc=void 0,e.$Dqc=a,e.$Bqc=(0,P.$Di)("IExtHostSearch");let y=class{constructor(n,o,c){this.n=n,this.o=o,this.q=c,this.c=this.n.getProxy(I.$EN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$wqc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const c=this.d++;return this.e.set(c,o),this.c.$registerTextSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.g.delete(n),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const c=this.d++;return this.h.set(c,o),this.c.$registerAITextSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.i.delete(n),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const c=this.d++;return this.j.set(c,o),this.c.$registerFileSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.k.delete(n),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(n,o,c,u){const i=a(c),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,o,t.map(g=>g.resource))},u);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,c){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,c,u){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=a(c);return this.t(r,i).search(g=>this.c.$handleTextMatch(n,o,g),u)}$provideAITextSearchResults(n,o,c,u){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=a(c);return this.v(r,i).search(g=>this.c.$handleTextMatch(n,o,g),u)}$enableExtensionHostSearch(){}t(n,o){return new R.$xqc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(n,o){return new R.$xqc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Cqc=y,e.$Cqc=y=Ge([Ve(0,A.$eQ),Ve(1,T.$opc),Ve(2,$.$$j)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>s.URI.revive(n))}}function S(d){return{...d,folder:s.URI.revive(d.folder)}}});var ri=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[276],Ne([1,0,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p,h,E,D,b,k,C,f,w,F,N,L,W,J,M,K,Z,ue,_,ge,se,ae,$e,oe,ke,Le,Y,q,te,ve,ce,we,he,X,x,me,pe,Ae,Ue,Se,Pe,Te,j,B,H,V,ne,fe,Ie,ze,Qe,_e,tt,nt,et,rt,mt,ut,st,ct,ft,pt,qe,je,ee,Q,Ee,Je,xe,ht,$t,Nt,Wt,si,Yt,hi,Ze,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=Ht,I=We(I),T=ri(T),y=We(y),d=We(d),ee=We(ee),Q=We(Q);function Ht(gt){const St=gt.get(ke.$uQ),xt=gt.get(oe.$_oc),_t=gt.get(ae.$wpc),jt=gt.get(ge.$8pc),wt=gt.get(si.$rpc),Rt=gt.get(rt.$yQ),ci=gt.get(C.$upc),Qt=gt.get(Je.$opc),Xe=gt.get(V.$eQ),ei=gt.get(tt.$Ppc),ui=gt.get(nt.$xpc),di=gt.get(n.$_j),kt=gt.get(n.$$j),Mt=gt.get(je.$aGb),At=gt.get(g.$8oc),Ft=gt.get(Wt.$drc),oi=gt.get(Ie.$Zpc),ti=gt.get(Z.$Gpc),ii=gt.get(he.$4pc),Bt=gt.get(l.$fpc),qt=gt.get(ve.$Wpc);Xe.set(i.$FN.ExtHostFileSystemInfo,xt),Xe.set(i.$FN.ExtHostLogLevelServiceShape,di),Xe.set(i.$FN.ExtHostWorkspace,wt),Xe.set(i.$FN.ExtHostConfiguration,ci),Xe.set(i.$FN.ExtHostExtensionService,jt),Xe.set(i.$FN.ExtHostStorage,ei),Xe.set(i.$FN.ExtHostTunnelService,Mt),Xe.set(i.$FN.ExtHostWindow,Ft),Xe.set(i.$FN.ExtHostSecretState,oi),Xe.set(i.$FN.ExtHostTelemetry,Rt),Xe.set(i.$FN.ExtHostEditorTabs,ti),Xe.set(i.$FN.ExtHostManagedSockets,ii),Xe.set(i.$FN.ExtHostAuthentication,Bt),Xe.set(i.$FN.ExtHostChatProvider,qt);const li=Xe.set(i.$FN.ExtHostDecorations,gt.get(F.$lqc)),Tt=Xe.set(i.$FN.ExtHostDocumentsAndEditors,gt.get(K.$pQ)),Ct=Xe.set(i.$FN.ExtHostCommands,gt.get(b.$AQ)),bt=Xe.set(i.$FN.ExtHostTerminalService,gt.get(mt.$Spc)),Kt=Xe.set(i.$FN.ExtHostTerminalShellIntegration,gt.get(ut.$6qc)),yt=Xe.set(i.$FN.ExtHostDebugService,gt.get(w.$fqc)),ai=Xe.set(i.$FN.ExtHostSearch,gt.get(fe.$Bqc)),Gt=Xe.set(i.$FN.ExtHostTask,gt.get(et.$5qc)),Ai=Xe.set(i.$FN.ExtHostOutputService,gt.get(Pe.$Rqc)),gi=Xe.set(i.$FN.ExtHostLocalization,gt.get(we.$3pc)),Si=Xe.set(i.$FN.ExtHostUrls,new xe.$arc(Xe)),Ut=Xe.set(i.$FN.ExtHostDocuments,new M.$cpc(Xe,Tt)),fi=Xe.set(i.$FN.ExtHostDocumentContentProviders,new W.$nqc(Xe,Tt,kt)),Ni=Xe.set(i.$FN.ExtHostDocumentSaveParticipant,new J.$oqc(kt,Ut,Xe.getProxy(i.$EN.MainThreadBulkEdits))),It=Xe.set(i.$FN.ExtHostNotebook,new x.$Eqc(Xe,Ct,Tt,Ut,_t,ai,kt)),vi=Xe.set(i.$FN.ExtHostNotebookDocuments,new pe.$Lqc(It)),Ti=Xe.set(i.$FN.ExtHostNotebookEditors,new Ae.$Mqc(kt,It)),bi=Xe.set(i.$FN.ExtHostNotebookKernels,new Ue.$Nqc(Xe,St,It,Ct,kt)),Li=Xe.set(i.$FN.ExtHostNotebookRenderers,new Se.$Pqc(Xe,It)),Mi=Xe.set(i.$FN.ExtHostNotebookDocumentSaveParticipant,new me.$Kqc(kt,It,Xe.getProxy(i.$EN.MainThreadBulkEdits))),Lt=Xe.set(i.$FN.ExtHostEditors,new ct.$lpc(Xe,Tt)),ki=Xe.set(i.$FN.ExtHostTreeViews,new qe.$$qc(Xe.getProxy(i.$EN.MainThreadTreeViews),Ct,kt)),ye=Xe.set(i.$FN.ExtHostEditorInsets,new D.$mpc(Xe.getProxy(i.$EN.MainThreadEditorInsets),Lt,St.remote)),Re=Xe.set(i.$FN.ExtHostDiagnostics,new N.$bpc(Xe,kt,xt,Tt)),le=Xe.set(i.$FN.ExtHostLanguages,new ce.$Iqc(Xe,Ut,Ct.converter,Qt)),G=Xe.set(i.$FN.ExtHostLanguageFeatures,new q.$dpc(Xe,Qt,Ut,Ct,Re,kt,At,Rt)),Ce=Xe.set(i.$FN.ExtHostFileSystem,new se.$rqc(Xe,G)),Be=Xe.set(i.$FN.ExtHostFileSystemEventService,new $e.$sqc(Xe,kt,Tt)),Ye=Xe.set(i.$FN.ExtHostQuickOpen,(0,H.$Vqc)(Xe,wt,Ct)),He=Xe.set(i.$FN.ExtHostSCM,new ne.$Xqc(Xe,Ct,Ut,kt)),lt=Xe.set(i.$FN.ExtHostQuickDiff,new B.$Uqc(Xe,Qt)),Pt=Xe.set(i.$FN.ExtHostShare,new ze.$Yqc(Xe,Qt)),Jt=Xe.set(i.$FN.ExtHostComments,(0,k.$npc)(Xe,Ct,Ut)),ni=Xe.set(i.$FN.ExtHostProgress,new j.$Tqc(Xe.getProxy(i.$EN.MainThreadProgress))),zt=Xe.set(i.$FN.ExtHostLabelService,new Y.$Gqc(Xe)),Xt=Xe.set(i.$FN.ExtHostTheming,new ft.$8qc(Xe)),_i=Xe.set(i.$FN.ExtHostTimeline,new pt.$0qc(Xe,Ct)),Fi=Xe.set(i.$FN.ExtHostWebviews,new ht.$Bpc(Xe,St.remote,wt,kt,At)),qi=Xe.set(i.$FN.ExtHostWebviewPanels,new $t.$Epc(Xe,Fi,wt)),en=Xe.set(i.$FN.ExtHostCustomEditors,new f.$Fpc(Xe,Ut,ui,Fi,qi)),Wi=Xe.set(i.$FN.ExtHostWebviewViews,new Nt.$brc(Xe,Fi)),yi=Xe.set(i.$FN.ExtHostTesting,gt.get(st.$aqc)),tn=Xe.set(i.$FN.ExtHostUriOpeners,new Ee.$_qc(Xe)),nn=Xe.set(i.$FN.ExtHostProfileContentHandlers,new Te.$Sqc(Xe));Xe.set(i.$FN.ExtHostInteractive,new Le.$Fqc(Xe,It,Tt,Ct,kt));const Ui=Xe.set(i.$FN.ExtHostChatAgents2,new p.$ipc(Xe,kt,Ct,Ut)),rn=Xe.set(i.$FN.ExtHostChatVariables,new h.$jpc(Xe)),zi=Xe.set(i.$FN.ExtHostLanguageModelTools,new te.$Hqc(Xe)),Vi=Xe.set(i.$FN.ExtHostAiRelatedInformation,new r.$7oc(Xe)),sn=Xe.set(i.$FN.ExtHostAiEmbeddingVector,new _.$qqc(Xe)),on=Xe.set(i.$FN.ExtHostStatusBar,new _e.$2qc(Xe,Ct.converter)),bn=Xe.set(i.$FN.ExtHostSpeech,new Qe.$Zqc(Xe)),Ci=Xe.set(i.$FN.ExtHostEmbeddings,new ue.$pqc(Xe)),Hi=Object.values(i.$FN);Xe.assertRegistered(Hi);const wn=new m.$hpc(Xe,Tt),vn=new E.$kpc(Xe),ji=new X.$Jqc(Xe,kt),an=new L.$mqc(Xe);return t.$epc.register(Ct),function(Fe,mi,Qi){function ot(ie){return(de,Me,at)=>{const Dt=ie(Ot=>{try{de.call(Me,Ot)}catch(Pi){I.$Z(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Rt.onExtensionError(Fe.identifier,Pi)}});return at?.push(Dt),Dt}}const Et=function(){let ie=!Fe.isUnderDevelopment;function de(){ie||(kt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")de();else{const Dt=at;typeof Dt.scheme>"u"&&de(),typeof Dt.exclusive=="boolean"&&(0,Ze.$eH)(Fe,"documentFiltersExclusive")}return at}}(),yn={getSession(ie,de,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ze.$eH)(Fe,"authLearnMore"),Me?.account&&(0,Ze.$eH)(Fe,"authGetSessions"),Bt.getSession(Fe,ie,de,Me)},getAccounts(ie){return(0,Ze.$eH)(Fe,"authGetSessions"),Bt.getAccounts(ie)},async hasSession(ie,de){return(0,Ze.$eH)(Fe,"authSession"),!!await Bt.getSession(Fe,ie,de,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(ie,de,Me,at){return Bt.registerAuthenticationProvider(ie,de,Me,at)}},Ki={registerCommand(ie,de,Me){return Ct.registerCommand(!0,ie,de,Me,void 0,Fe)},registerTextEditorCommand(ie,de,Me){return Ct.registerCommand(!0,ie,(...at)=>{const Dt=Lt.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Dt.edit(Ot=>{de.apply(Me,[Dt,Ot,...at])}).then(Ot=>{Ot||kt.warn("Edits from command "+ie+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+ie,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ie,de,Me)=>((0,Ze.$eH)(Fe,"diffCommand"),Ct.registerCommand(!0,ie,async(...at)=>{const Dt=Tt.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(Dt.id);de.apply(Me,[Ot,...at])},void 0,void 0,Fe)),executeCommand(ie,...de){return Ct.executeCommand(ie,...de)},getCommands(ie=!1){return Ct.getCommands(ie)}},Gi={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$eH)(Fe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$eH)(Fe,"telemetry"),ot(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$xQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,de){return rt.$wQ.validateSender(ie),Rt.instantiateLogger(Fe,ie,de)},openExternal(ie,de){return Ft.openUri(ie,{allowTunneling:!!St.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===St.environment.appUriScheme)return Si.createAppUri(ie);try{return await Ft.asExternalUri(ie,{allowTunneling:!!St.remote.authority})}catch(de){if((0,A.$Mg)(ie,A.Schemas.http)||(0,A.$Mg)(ie,A.Schemas.https))return ie;throw de}},get remoteName(){return(0,o.$gn)(St.remote.authority)},get remoteAuthority(){return(0,Ze.$eH)(Fe,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$eH)(Fe,"resolvers"),St.quality},get appCommit(){return(0,Ze.$eH)(Fe,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Gi);const Ei={createTestController(ie,de,Me){return yi.createTestController(Fe,ie,de,Me)},createTestObserver(){return(0,Ze.$eH)(Fe,"testObserver"),yi.createTestObserver()},runTests(ie){return(0,Ze.$eH)(Fe,"testObserver"),yi.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ze.$eH)(Fe,"testObserver"),yi.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ze.$eH)(Fe,"testObserver"),ot(yi.onResultsChanged)},get testResults(){return(0,Ze.$eH)(Fe,"testObserver"),yi.results}},Ii=St.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,En={getExtension(ie,de){(0,Ze.$dH)(Fe,"extensionsAny")||(de=!1);const Me=mi.mine.getExtensionDescription(ie);if(Me)return new ge.$9pc(jt,Fe.identifier,Me,Ii,!1);if(de){const at=mi.all.getExtensionDescription(ie);if(at)return new ge.$9pc(jt,Fe.identifier,at,Ii,!0)}},get all(){const ie=[];for(const de of mi.mine.getAllExtensionDescriptions())ie.push(new ge.$9pc(jt,Fe.identifier,de,Ii,!1));return ie},get allAcrossExtensionHosts(){(0,Ze.$eH)(Fe,"extensionsAny");const ie=new S.$qn(mi.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),de=[];for(const Me of mi.all.getAllExtensionDescriptions()){const at=!ie.has(Me.identifier);de.push(new ge.$9pc(jt,Fe.identifier,Me,Ii,at))}return de},get onDidChange(){return(0,Ze.$dH)(Fe,"extensionsAny")?ot(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ot(mi.mine.onDidChange)}},pi={createDiagnosticCollection(ie){return Re.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return ot(Re.onDidChangeDiagnostics)},getDiagnostics:ie=>Re.getDiagnostics(ie),getLanguages(){return le.getLanguages()},setTextDocumentLanguage(ie,de){return le.changeLanguage(ie.uri,de)},match(ie,de){const Me=ee.LanguageSelector.from(ie);let at;return(0,R.$vu)(Me)&&(at=It.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===de))?.apiNotebook),(0,R.$uu)(Me,de.uri,de.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,de,Me){return G.registerCodeActionProvider(Fe,Et(ie),de,Me)},registerDocumentPasteEditProvider(ie,de,Me){return(0,Ze.$eH)(Fe,"documentPaste"),G.registerDocumentPasteEditProvider(Fe,Et(ie),de,Me)},registerCodeLensProvider(ie,de){return G.registerCodeLensProvider(Fe,Et(ie),de)},registerDefinitionProvider(ie,de){return G.registerDefinitionProvider(Fe,Et(ie),de)},registerDeclarationProvider(ie,de){return G.registerDeclarationProvider(Fe,Et(ie),de)},registerImplementationProvider(ie,de){return G.registerImplementationProvider(Fe,Et(ie),de)},registerTypeDefinitionProvider(ie,de){return G.registerTypeDefinitionProvider(Fe,Et(ie),de)},registerHoverProvider(ie,de){return G.registerHoverProvider(Fe,Et(ie),de,Fe.identifier)},registerEvaluatableExpressionProvider(ie,de){return G.registerEvaluatableExpressionProvider(Fe,Et(ie),de,Fe.identifier)},registerInlineValuesProvider(ie,de){return G.registerInlineValuesProvider(Fe,Et(ie),de,Fe.identifier)},registerDocumentHighlightProvider(ie,de){return G.registerDocumentHighlightProvider(Fe,Et(ie),de)},registerMultiDocumentHighlightProvider(ie,de){return G.registerMultiDocumentHighlightProvider(Fe,Et(ie),de)},registerLinkedEditingRangeProvider(ie,de){return G.registerLinkedEditingRangeProvider(Fe,Et(ie),de)},registerReferenceProvider(ie,de){return G.registerReferenceProvider(Fe,Et(ie),de)},registerRenameProvider(ie,de){return G.registerRenameProvider(Fe,Et(ie),de)},registerNewSymbolNamesProvider(ie,de){return(0,Ze.$eH)(Fe,"newSymbolNamesProvider"),G.registerNewSymbolNamesProvider(Fe,Et(ie),de)},registerDocumentSymbolProvider(ie,de,Me){return G.registerDocumentSymbolProvider(Fe,Et(ie),de,Me)},registerWorkspaceSymbolProvider(ie){return G.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,de){return G.registerDocumentFormattingEditProvider(Fe,Et(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return G.registerDocumentRangeFormattingEditProvider(Fe,Et(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Me,...at){return G.registerOnTypeFormattingEditProvider(Fe,Et(ie),de,[Me].concat(at))},registerDocumentSemanticTokensProvider(ie,de,Me){return G.registerDocumentSemanticTokensProvider(Fe,Et(ie),de,Me)},registerDocumentRangeSemanticTokensProvider(ie,de,Me){return G.registerDocumentRangeSemanticTokensProvider(Fe,Et(ie),de,Me)},registerSignatureHelpProvider(ie,de,Me,...at){return typeof Me=="object"?G.registerSignatureHelpProvider(Fe,Et(ie),de,Me):G.registerSignatureHelpProvider(Fe,Et(ie),de,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ie,de,...Me){return G.registerCompletionItemProvider(Fe,Et(ie),de,Me)},registerInlineCompletionItemProvider(ie,de,Me){return de.handleDidShowCompletionItem&&(0,Ze.$eH)(Fe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$eH)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ze.$eH)(Fe,"inlineCompletionsAdditions"),G.registerInlineCompletionsProvider(Fe,Et(ie),de,Me)},registerInlineEditProvider(ie,de){return(0,Ze.$eH)(Fe,"inlineEdit"),G.registerInlineEditProvider(Fe,Et(ie),de)},registerDocumentLinkProvider(ie,de){return G.registerDocumentLinkProvider(Fe,Et(ie),de)},registerColorProvider(ie,de){return G.registerColorProvider(Fe,Et(ie),de)},registerFoldingRangeProvider(ie,de){return G.registerFoldingRangeProvider(Fe,Et(ie),de)},registerSelectionRangeProvider(ie,de){return G.registerSelectionRangeProvider(Fe,ie,de)},registerCallHierarchyProvider(ie,de){return G.registerCallHierarchyProvider(Fe,ie,de)},registerTypeHierarchyProvider(ie,de){return G.registerTypeHierarchyProvider(Fe,ie,de)},setLanguageConfiguration:(ie,de)=>G.setLanguageConfiguration(Fe,ie,de),getTokenInformationAtPosition(ie,de){return(0,Ze.$eH)(Fe,"tokenInformation"),le.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return G.registerInlayHintsProvider(Fe,ie,de)},createLanguageStatusItem(ie,de){return le.createLanguageStatusItem(Fe,ie,de)},registerDocumentDropEditProvider(ie,de,Me){return G.registerDocumentOnDropEditProvider(Fe,ie,de,(0,Ze.$dH)(Fe,"documentPaste")?Me:void 0)}},Bi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,de,Me){$.URI.isUri(ie)&&ie.scheme===A.Schemas.vscodeRemote&&!ie.authority&&At.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await($.URI.isUri(ie)?Promise.resolve(Ji.openTextDocument(ie)):Promise.resolve(ie));return Lt.showTextDocument(at,de,Me)},createTextEditorDecorationType(ie){return Lt.createTextEditorDecorationType(Fe,ie)},onDidChangeActiveTextEditor(ie,de,Me){return ot(Lt.onDidChangeActiveTextEditor)(ie,de,Me)},onDidChangeVisibleTextEditors(ie,de,Me){return ot(Lt.onDidChangeVisibleTextEditors)(ie,de,Me)},onDidChangeTextEditorSelection(ie,de,Me){return ot(Lt.onDidChangeTextEditorSelection)(ie,de,Me)},onDidChangeTextEditorOptions(ie,de,Me){return ot(Lt.onDidChangeTextEditorOptions)(ie,de,Me)},onDidChangeTextEditorVisibleRanges(ie,de,Me){return ot(Lt.onDidChangeTextEditorVisibleRanges)(ie,de,Me)},onDidChangeTextEditorViewColumn(ie,de,Me){return ot(Lt.onDidChangeTextEditorViewColumn)(ie,de,Me)},onDidCloseTerminal(ie,de,Me){return ot(bt.onDidCloseTerminal)(ie,de,Me)},onDidOpenTerminal(ie,de,Me){return ot(bt.onDidOpenTerminal)(ie,de,Me)},onDidChangeActiveTerminal(ie,de,Me){return ot(bt.onDidChangeActiveTerminal)(ie,de,Me)},onDidChangeTerminalDimensions(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ie,de,Me)},onDidChangeTerminalState(ie,de,Me){return ot(bt.onDidChangeTerminalState)(ie,de,Me)},onDidWriteTerminalData(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ie,de,Me)},onDidExecuteTerminalCommand(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ie,de,Me)},onDidChangeTerminalShellIntegration(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalShellIntegration"),ot(Kt.onDidChangeTerminalShellIntegration)(ie,de,Me)},onDidStartTerminalShellExecution(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalShellIntegration"),ot(Kt.onDidStartTerminalShellExecution)(ie,de,Me)},onDidEndTerminalShellExecution(ie,de,Me){return(0,Ze.$eH)(Fe,"terminalShellIntegration"),ot(Kt.onDidEndTerminalShellExecution)(ie,de,Me)},get state(){return Ft.getState()},onDidChangeWindowState(ie,de,Me){return ot(Ft.onDidChangeWindowState)(ie,de,Me)},showInformationMessage(ie,...de){return ji.showMessage(Fe,T.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return ji.showMessage(Fe,T.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return ji.showMessage(Fe,T.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Me){return Ye.showQuickPick(Fe,ie,de,Me)},showWorkspaceFolderPick(ie){return Ye.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Ye.showInput(ie,de)},showOpenDialog(ie){return an.showOpenDialog(Fe,ie)},showSaveDialog(ie){return an.showSaveDialog(ie)},createStatusBarItem(ie,de,Me){let at,Dt,Ot;return typeof ie=="string"?(at=ie,Dt=de,Ot=Me):(Dt=ie,Ot=de),on.createStatusBarEntry(Fe,at,Dt,Ot)},setStatusBarMessage(ie,de){return on.setStatusBarMessage(ie,de)},withScmProgress(ie){return At.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),ni.withProgress(Fe,{location:Q.ProgressLocation.SourceControl},(de,Me)=>ie({report(at){}}))},withProgress(ie,de){return ni.withProgress(Fe,ie,de)},createOutputChannel(ie,de){return Ai.createOutputChannel(ie,de,Fe)},createWebviewPanel(ie,de,Me,at){return qi.createWebviewPanel(Fe,ie,de,Me,at)},createWebviewTextEditorInset(ie,de,Me,at){return(0,Ze.$eH)(Fe,"editorInsets"),ye.createWebviewEditorInset(ie,de,Me,at,Fe)},createTerminal(ie,de,Me){return typeof ie=="object"?"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie):bt.createTerminal(ie,de,Me)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return bt.registerProfileProvider(Fe,ie,de)},registerTerminalQuickFixProvider(ie,de){return(0,Ze.$eH)(Fe,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ie,Fe.identifier.value,de)},registerTreeDataProvider(ie,de){return ki.registerTreeDataProvider(ie,de,Fe)},createTreeView(ie,de){return ki.createTreeView(ie,de,Fe)},registerWebviewPanelSerializer:(ie,de)=>qi.registerWebviewPanelSerializer(Fe,ie,de),registerCustomEditorProvider:(ie,de,Me={})=>en.registerCustomEditorProvider(Fe,ie,de,Me),registerFileDecorationProvider(ie){return li.registerFileDecorationProvider(ie,Fe)},registerUriHandler(ie){return Si.registerUriHandler(Fe,ie)},createQuickPick(){return Ye.createQuickPick(Fe)},createInputBox(){return Ye.createInputBox(Fe)},get activeColorTheme(){return Xt.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Me){return ot(Xt.onDidChangeActiveColorTheme)(ie,de,Me)},registerWebviewViewProvider(ie,de,Me){return Wi.registerWebviewViewProvider(Fe,ie,de,Me?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Me){return ot(It.onDidChangeActiveNotebookEditor)(ie,de,Me)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,de,Me){return ot(Ti.onDidChangeNotebookEditorSelection)(ie,de,Me)},onDidChangeNotebookEditorVisibleRanges(ie,de,Me){return ot(Ti.onDidChangeNotebookEditorVisibleRanges)(ie,de,Me)},showNotebookDocument(ie,de){return It.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Me){return(0,Ze.$eH)(Fe,"externalUriOpener"),tn.registerExternalUriOpener(Fe.identifier,ie,de,Me)},registerProfileContentHandler(ie,de){return(0,Ze.$eH)(Fe,"profileContentHandlers"),nn.registerProfileContentHandler(Fe,ie,de)},registerQuickDiffProvider(ie,de,Me,at){return(0,Ze.$eH)(Fe,"quickDiffProvider"),lt.registerQuickDiffProvider(Et(ie),de,Me,at)},get tabGroups(){return ti.tabGroups},registerShareProvider(ie,de){return(0,Ze.$eH)(Fe,"shareProvider"),Pt.registerShareProvider(Et(ie),de)}},Ji={get rootPath(){return At.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ie){throw new I.$8("rootPath")},getWorkspaceFolder(ie){return wt.getWorkspaceFolder(ie)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ie){throw new I.$8("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ie){throw new I.$8("workspaceFile")},updateWorkspaceFolders:(ie,de,...Me)=>wt.updateWorkspaceFolders(Fe,ie,de||0,...Me),onDidChangeWorkspaceFolders:function(ie,de,Me){return ot(wt.onDidChangeWorkspace)(ie,de,Me)},asRelativePath:(ie,de)=>wt.getRelativePath(ie,de),findFiles:(ie,de,Me,at)=>wt.findFiles(ie,de,Me,Fe.identifier,at),findFiles2:(ie,de,Me)=>((0,Ze.$eH)(Fe,"findFiles2"),wt.findFiles2(ie,de,Fe.identifier,Me)),findTextInFiles:(ie,de,Me,at)=>{(0,Ze.$eH)(Fe,"findTextInFiles");let Dt,Ot;return typeof de=="object"?(Dt=de,Ot=Me):(Dt={},Ot=de,at=Me),wt.findTextInFiles(ie,Dt||{},Ot,Fe.identifier,at)},save:ie=>wt.save(ie),saveAs:ie=>wt.saveAs(ie),saveAll:ie=>wt.saveAll(ie),applyEdit(ie,de){return wn.applyWorkspaceEdit(ie,Fe,de)},createFileSystemWatcher:(ie,de,Me,at)=>{let Dt;return typeof de=="boolean"?Dt={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:de&&((0,Ze.$eH)(Fe,"createFileSystemWatcher"),Dt={...de,correlate:!0}),Be.createFileSystemWatcher(wt,Fe,ie,Dt)},get textDocuments(){return Ut.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new I.$8("textDocuments")},openTextDocument(ie){let de;const Me=ie;if(typeof ie=="string")de=Promise.resolve($.URI.file(ie));else if($.URI.isUri(ie))de=Promise.resolve(ie);else if(!Me||typeof Me=="object")de=Ut.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Ut.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ie,de,Me)=>ot(Ut.onDidAddDocument)(ie,de,Me),onDidCloseTextDocument:(ie,de,Me)=>ot(Ut.onDidRemoveDocument)(ie,de,Me),onDidChangeTextDocument:(ie,de,Me)=>ot(Ut.onDidChangeDocument)(ie,de,Me),onDidSaveTextDocument:(ie,de,Me)=>ot(Ut.onDidSaveDocument)(ie,de,Me),onWillSaveTextDocument:(ie,de,Me)=>ot(Ni.getOnWillSaveTextDocumentEvent(Fe))(ie,de,Me),get notebookDocuments(){return It.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Me;if($.URI.isUri(ie))Me=ie,await It.openNotebookDocument(ie);else if(typeof ie=="string")Me=$.URI.revive(await It.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ie,de,Me){return ot(vi.onDidSaveNotebookDocument)(ie,de,Me)},onDidChangeNotebookDocument(ie,de,Me){return ot(vi.onDidChangeNotebookDocument)(ie,de,Me)},onWillSaveNotebookDocument(ie,de,Me){return ot(Mi.getOnWillSaveNotebookDocumentEvent(Fe))(ie,de,Me)},get onDidOpenNotebookDocument(){return ot(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,de,Me,at){return It.registerNotebookSerializer(Fe,ie,de,Me,(0,Ze.$dH)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,de,Me)=>ot(Qi.onDidChangeConfiguration)(ie,de,Me),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,Qi.getConfiguration(ie,de,Fe)},registerTextDocumentContentProvider(ie,de){return fi.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(At.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Fe,ie,de)),registerFileSystemProvider(ie,de,Me){return(0,O.$Qc)(Ce.registerFileSystemProvider(Fe,ie,de,Me),_t.addFileSystemProvider(ie,de,Me))},get fs(){return _t.value},registerFileSearchProvider:(ie,de)=>((0,Ze.$eH)(Fe,"fileSearchProvider"),ai.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,Ze.$eH)(Fe,"textSearchProvider"),ai.registerTextSearchProvider(ie,de)),registerAITextSearchProvider:(ie,de)=>((0,Ze.$eH)(Fe,"aiTextSearchProvider"),(0,Ze.$eH)(Fe,"textSearchProvider"),ai.registerAITextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,Ze.$eH)(Fe,"resolvers"),jt.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,Ze.$eH)(Fe,"resolvers"),zt.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ze.$eH)(Fe,"resolvers"),jt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,de,Me)=>ot(Be.onDidCreateFile)(ie,de,Me),onDidDeleteFiles:(ie,de,Me)=>ot(Be.onDidDeleteFile)(ie,de,Me),onDidRenameFiles:(ie,de,Me)=>ot(Be.onDidRenameFile)(ie,de,Me),onWillCreateFiles:(ie,de,Me)=>ot(Be.getOnWillCreateFileEvent(Fe))(ie,de,Me),onWillDeleteFiles:(ie,de,Me)=>ot(Be.getOnWillDeleteFileEvent(Fe))(ie,de,Me),onWillRenameFiles:(ie,de,Me)=>ot(Be.getOnWillRenameFileEvent(Fe))(ie,de,Me),openTunnel:ie=>((0,Ze.$eH)(Fe,"tunnels"),Mt.openTunnel(Fe,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ze.$eH)(Fe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(ie,de,Me)=>((0,Ze.$eH)(Fe,"tunnels"),ot(Mt.onDidChangeTunnels)(ie,de,Me)),registerPortAttributesProvider:(ie,de)=>((0,Ze.$eH)(Fe,"portsAttributes"),Mt.registerPortsAttributesProvider(ie,de)),registerTunnelProvider:(ie,de)=>((0,Ze.$eH)(Fe,"tunnelFactory"),Mt.registerTunnelProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,Ze.$eH)(Fe,"timeline"),_i.registerTimelineProvider(ie,de,Fe.identifier,Ct.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ie=>((0,Ze.$eH)(Fe,"workspaceTrust"),wt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Me)=>ot(wt.onDidGrantWorkspaceTrust)(ie,de,Me),registerEditSessionIdentityProvider:(ie,de)=>((0,Ze.$eH)(Fe,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ie,de)),onWillCreateEditSessionIdentity:(ie,de,Me)=>((0,Ze.$eH)(Fe,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Fe))(ie,de,Me)),registerCanonicalUriProvider:(ie,de)=>((0,Ze.$eH)(Fe,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ie,de)),getCanonicalUri:(ie,de,Me)=>((0,Ze.$eH)(Fe,"canonicalUriProvider"),wt.provideCanonicalUri(ie,de,Me))},cn={get inputBox(){return At.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),He.getLastInputBox(Fe)},createSourceControl(ie,de,Me){return He.createSourceControl(Fe,ie,de,Me)}},un={createCommentController(ie,de){return Jt.createCommentController(Fe,ie,de)}},ln={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(ie,de){return(0,Ze.$eH)(Fe,"debugVisualization"),yt.registerDebugVisualizationProvider(Fe,ie,de)},registerDebugVisualizationTreeProvider(ie,de){return(0,Ze.$eH)(Fe,"debugVisualization"),yt.registerDebugVisualizationTree(Fe,ie,de)},onDidStartDebugSession(ie,de,Me){return ot(yt.onDidStartDebugSession)(ie,de,Me)},onDidTerminateDebugSession(ie,de,Me){return ot(yt.onDidTerminateDebugSession)(ie,de,Me)},onDidChangeActiveDebugSession(ie,de,Me){return ot(yt.onDidChangeActiveDebugSession)(ie,de,Me)},onDidReceiveDebugSessionCustomEvent(ie,de,Me){return ot(yt.onDidReceiveDebugSessionCustomEvent)(ie,de,Me)},onDidChangeBreakpoints(ie,de,Me){return ot(yt.onDidChangeBreakpoints)(ie,de,Me)},onDidChangeActiveStackItem(ie,de,Me){return ot(yt.onDidChangeActiveStackItem)(ie,de,Me)},registerDebugConfigurationProvider(ie,de,Me){return yt.registerDebugConfigurationProvider(ie,de,Me||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return yt.registerDebugAdapterDescriptorFactory(Fe,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return yt.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Me){return!Me||typeof Me=="object"&&"configuration"in Me?yt.startDebugging(ie,de,{parentSession:Me}):yt.startDebugging(ie,de,Me||{})},stopDebugging(ie){return yt.stopDebugging(ie)},addBreakpoints(ie){return yt.addBreakpoints(ie)},removeBreakpoints(ie){return yt.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return yt.asDebugSourceUri(ie,de)}},Dn={registerTaskProvider:(ie,de)=>Gt.registerTaskProvider(Fe,ie,de),fetchTasks:ie=>Gt.fetchTasks(ie),executeTask:ie=>Gt.executeTask(Fe,ie),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ie,de,Me)=>ot(Gt.onDidStartTask)(ie,de,Me),onDidEndTask:(ie,de,Me)=>ot(Gt.onDidEndTask)(ie,de,Me),onDidStartTaskProcess:(ie,de,Me)=>ot(Gt.onDidStartTaskProcess)(ie,de,Me),onDidEndTaskProcess:(ie,de,Me)=>ot(Gt.onDidEndTaskProcess)(ie,de,Me)},hn={createNotebookController(ie,de,Me,at,Dt){return bi.createNotebookController(Fe,ie,de,Me,at,(0,Ze.$dH)(Fe,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>It.registerNotebookCellStatusBarItemProvider(Fe,ie,de),createRendererMessaging(ie){return Li.createRendererMessaging(Fe,ie)},createNotebookControllerDetectionTask(ie){return(0,Ze.$eH)(Fe,"notebookKernelSource"),bi.createNotebookControllerDetectionTask(Fe,ie)},registerKernelSourceActionProvider(ie,de){return(0,Ze.$eH)(Fe,"notebookKernelSource"),bi.registerKernelSourceActionProvider(Fe,ie,de)},onDidChangeNotebookCellExecutionState(ie,de,Me){return(0,Ze.$eH)(Fe,"notebookCellExecutionState"),ot(bi.onDidChangeNotebookCellExecutionState)(ie,de,Me)}},dn={t(...ie){if(typeof ie[0]=="string"){const de=ie.shift(),Me=!ie||typeof ie[0]!="object"?ie:ie[0];return gi.getMessage(Fe.identifier.value,{message:de,args:Me})}return gi.getMessage(Fe.identifier.value,ie[0])},get bundle(){return gi.getBundle(Fe.identifier.value)},get uri(){return gi.getBundleUri(Fe.identifier.value)}},Sn={_version:1,transferActiveChat(ie){return(0,Ze.$eH)(Fe,"interactive"),Ui.transferActiveChat(ie)}},kn={getRelatedInformation(ie,de){return(0,Ze.$eH)(Fe,"aiRelatedInformation"),Vi.getRelatedInformation(Fe,ie,de)},registerRelatedInformationProvider(ie,de){return(0,Ze.$eH)(Fe,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(Fe,ie,de)},registerEmbeddingVectorProvider(ie,de){return(0,Ze.$eH)(Fe,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Fe,ie,de)}},fn={_version:1,registerChatResponseProvider(ie,de,Me){return(0,Ze.$eH)(Fe,"chatProvider"),qt.registerLanguageModel(Fe,ie,de,Me)},registerChatVariableResolver(ie,de,Me,at,Dt,Ot,Pi,Zi){return(0,Ze.$eH)(Fe,"chatVariableResolver"),rn.registerVariableResolver(Fe,ie,de,Me,at,Dt,Ot,Pi,Zi?.id)},registerMappedEditsProvider(ie,de){return(0,Ze.$eH)(Fe,"mappedEditsProvider"),G.registerMappedEditsProvider(Fe,ie,de)},createChatParticipant(ie,de){return Ui.createChatAgent(Fe,ie,de)},createDynamicChatParticipant(ie,de,Me){return(0,Ze.$eH)(Fe,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Fe,ie,de,Me)}},Xi={selectChatModels:ie=>qt.selectLanguageModels(Fe,ie??{}),onDidChangeChatModels:(ie,de,Me)=>qt.onDidChangeProviders(ie,de,Me),registerChatModelProvider:(ie,de,Me)=>((0,Ze.$eH)(Fe,"chatProvider"),qt.registerLanguageModel(Fe,ie,de,Me)),get embeddingModels(){return(0,Ze.$eH)(Fe,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ie,de,Me)=>((0,Ze.$eH)(Fe,"embeddings"),Ci.onDidChange(ie,de,Me)),registerEmbeddingsProvider(ie,de){return(0,Ze.$eH)(Fe,"embeddings"),Ci.registerEmbeddingsProvider(Fe,ie,de)},async computeEmbeddings(ie,de,Me){return(0,Ze.$eH)(Fe,"embeddings"),Ci.computeEmbeddings(ie,de,Me)},registerTool(ie,de){return(0,Ze.$eH)(Fe,"lmTools"),zi.registerTool(Fe,ie,de)},invokeTool(ie,de,Me){return(0,Ze.$eH)(Fe,"lmTools"),zi.invokeTool(ie,de,Me)},get tools(){return(0,Ze.$eH)(Fe,"lmTools"),zi.tools}},gn={registerSpeechProvider(ie,de){return(0,Ze.$eH)(Fe,"speech"),bn.registerProvider(Fe.identifier,ie,de)}};return{version:St.version,ai:kn,authentication:yn,commands:Ki,comments:un,chat:fn,debug:ln,env:Gi,extensions:En,interactive:Sn,l10n:dn,languages:pi,lm:Xi,notebooks:hn,scm:cn,speech:gn,tasks:Dn,tests:Ei,window:Bi,workspace:Ji,Breakpoint:Q.$JO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$FP,CallHierarchyIncomingCall:Q.$8N,CallHierarchyItem:Q.$7N,CallHierarchyOutgoingCall:Q.$9N,CancellationError:I.$4,CancellationTokenSource:v.$ve,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$4N,CodeActionKind:Q.$5N,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$0N,Color:Q.$kO,ColorInformation:Q.$lO,ColorPresentation:Q.$mO,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CommentThreadFocus:Q.CommentThreadFocus,CompletionItem:Q.$eO,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$fO,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$uO,DebugAdapterExecutable:Q.$NO,DebugAdapterInlineImplementation:Q.$QO,DebugAdapterNamedPipeServer:Q.$PO,DebugAdapterServer:Q.$OO,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$7O,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$WN,DiagnosticRelatedInformation:Q.$VN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$GN,DocumentHighlight:Q.$ZN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$1N,DocumentLink:Q.$jO,DocumentSymbol:Q.$3N,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$TO,InlineValueText:Q.$UO,InlineValueVariableLookup:Q.$VO,InlineValueEvaluatableExpression:Q.$WO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:P.$ke,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$9O,FileDecoration2:Q.$9O,FileSystemError:Q.$ZO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:Q.$1O,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$LO,InlineCompletionItem:Q.$gO,InlineCompletionList:Q.$hO,Hover:Q.$XN,VerboseHover:Q.$YN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$UN,MarkdownString:Q.$$N,OverviewRulerLane:a.OverviewRulerLane,ParameterInformation:Q.$_N,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$HN,ProcessExecution:Q.$sO,ProgressLocation:Q.ProgressLocation,QuickInputButtonLocation:Q.QuickInputButtonLocation,QuickInputButtons:Q.$8O,Range:Q.$IN,RelativePattern:Q.$HO,Selection:Q.$JN,SelectionRange:Q.$6N,SemanticTokens:Q.$4O,SemanticTokensBuilder:Q.$3O,SemanticTokensEdit:Q.$5O,SemanticTokensEdits:Q.$6O,SemanticTokensLegend:Q.$2O,ShellExecution:Q.$tO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$bO,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$aO,SnippetString:Q.$TN,SourceBreakpoint:Q.$KO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$2N,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$vO,TaskGroup:Q.$rO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$nO,TerminalQuickFixTerminalCommand:Q.$pO,TerminalQuickFixOpener:Q.$oO,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$qO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$PN,SnippetTextEdit:Q.$RN,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$GO,ThemeIcon:Q.$FO,TreeItem:Q.$wO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$tP,UIKind:hi.UIKind,Uri:$.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$SN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$CO,DocumentDropOrPasteEditKind:Q.$DO,DocumentPasteEdit:Q.$EO,InlayHint:Q.$dO,InlayHintLabelPart:Q.$cO,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$ON,ResolvedAuthority:Q.$MN,ManagedResolvedAuthority:Q.$NN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$gP,NotebookRange:Q.$$O,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$_O,NotebookData:Q.$aP,NotebookRendererScript:Q.$eP,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$cP,NotebookCellOutputItem:Q.$bP,NotebookCellStatusBarItem:Q.$dP,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$QN,NotebookKernelSourceAction:Q.$fP,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$iP,LinkedEditingRanges:Q.$hP,TestResultState:Q.TestResultState,TestRunRequest:Q.$jP,TestMessage:Q.$kP,TestMessage2:Q.$kP,TestMessageStackFrame:Q.$mP,TestTag:Q.$lP,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Q.$BO,DataTransferItem:Q.$xO,TestCoverageCount:Q.$nP,FileCoverage:Q.$pP,FileCoverage2:Q.$pP,StatementCoverage:Q.$qP,BranchCoverage:Q.$rP,DeclarationCoverage:Q.$sP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$uP,TabInputTextDiff:Q.$vP,TabInputTextMerge:Q.$wP,TabInputCustom:Q.$xP,TabInputNotebook:Q.$zP,TabInputNotebookDiff:Q.$AP,TabInputWebview:Q.$yP,TabInputTerminal:Q.$BP,TabInputInteractiveWindow:Q.$CP,TabInputChat:Q.$DP,TabInputTextMultiDiff:Q.$EP,TelemetryTrustedValue:c.$vp,LogLevel:n.LogLevel,EditSessionIdentityMatch:u.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$RO,DebugThread:Q.$SO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$GP,ChatResponseFileTreePart:Q.$KP,ChatResponseAnchorPart:Q.$LP,ChatResponseProgressPart:Q.$MP,ChatResponseProgressPart2:Q.$NP,ChatResponseReferencePart:Q.$QP,ChatResponseCodeCitationPart:Q.$RP,ChatResponseWarningPart:Q.$OP,ChatResponseTextEditPart:Q.$SP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$HP,ChatResponseCommandButtonPart:Q.$PP,ChatResponseDetectedParticipantPart:Q.$IP,ChatResponseConfirmationPart:Q.$JP,ChatRequestTurn:Q.$TP,ChatResponseTurn:Q.$UP,ChatLocation:Q.ChatLocation,ChatRequestEditorData:Q.$VP,ChatRequestNotebookData:Q.$WP,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$YP,LanguageModelChatMessageFunctionResultPart:Q.$XP,LanguageModelChatResponseTextPart:Q.$1P,LanguageModelChatResponseFunctionUsePart:Q.$ZP,LanguageModelError:Q.$5P,NewSymbolName:Q.$YO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$6P,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Oe[277],Ne([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(be,e,v,I,P,O,A,T,$,s,R,y,a,S,d,n,o,c,u,i,r,t,g,l,m,p,h,E,D,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Ps)(p.$3pc,p.$2pc,v.InstantiationType.Delayed),(0,v.$Ps)(l.$_j,g.$frc,v.InstantiationType.Delayed),(0,v.$Ps)(n.$8oc,n.$9oc,v.InstantiationType.Delayed),(0,v.$Ps)(T.$AQ,T.$zQ,v.InstantiationType.Eager),(0,v.$Ps)(E.$fpc,E.$gpc,v.InstantiationType.Eager),(0,v.$Ps)(D.$Wpc,D.$Xpc,v.InstantiationType.Eager),(0,v.$Ps)(A.$upc,A.$spc,v.InstantiationType.Eager),(0,v.$Ps)(c.$wpc,c.$vpc,v.InstantiationType.Eager),(0,v.$Ps)(k.$aqc,k.$bqc,v.InstantiationType.Eager),(0,v.$Ps)(y.$fqc,y.$jqc,v.InstantiationType.Eager),(0,v.$Ps)(O.$lqc,O.$kqc,v.InstantiationType.Eager),(0,v.$Ps)($.$pQ,$.$oQ,v.InstantiationType.Eager),(0,v.$Ps)(h.$4pc,h.$5pc,v.InstantiationType.Eager),(0,v.$Ps)(u.$_oc,u.$$oc,v.InstantiationType.Eager),(0,v.$Ps)(I.$Rqc,I.$Qqc,v.InstantiationType.Delayed),(0,v.$Ps)(a.$Bqc,a.$Cqc,v.InstantiationType.Eager),(0,v.$Ps)(S.$Ppc,S.$Opc,v.InstantiationType.Eager),(0,v.$Ps)(R.$5qc,R.$4qc,v.InstantiationType.Eager),(0,v.$Ps)(s.$Spc,s.$Vpc,v.InstantiationType.Eager),(0,v.$Ps)(b.$6qc,b.$7qc,v.InstantiationType.Eager),(0,v.$Ps)(d.$aGb,d.$bGb,v.InstantiationType.Eager),(0,v.$Ps)(o.$drc,o.$crc,v.InstantiationType.Eager),(0,v.$Ps)(P.$rpc,P.$qpc,v.InstantiationType.Eager),(0,v.$Ps)(i.$Zpc,i.$Ypc,v.InstantiationType.Eager),(0,v.$Ps)(r.$yQ,r.$vQ,v.InstantiationType.Eager),(0,v.$Ps)(t.$Gpc,t.$Hpc,v.InstantiationType.Eager),(0,v.$Ps)(m.$$pc,m.$_pc,v.InstantiationType.Eager)}),define(Oe[278],Ne([1,0,276,47,2,273,7,10,223]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rtc=void 0;class s extends O.$irc{j(){}getModule(S,d){for(const n of this.b){const o=n(S);if(o){S=o;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends I.$7pc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$qtc);const S=this.h.invokeFunction(v.$erc);this.r=this.h.createInstance(s,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,n){d=d.with({path:y(d.path,".js")});const o=S?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=P.URI.revive(await this.C.$asBrowserUri(d)),u=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),u.status!==200)throw new Error(u.statusText);const i=await u.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(o?`Loading code for extension ${o} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const l={},m={exports:l},p=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),g(m,l,p),m.exports!==l?m.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Eh)(10)}}e.$rtc=R;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Oe[279],Ne([1,0,73,60,11,47,188,91,278]),function(be,e,v,I,P,O,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Ps)(P.$$j,new v.$Ai(A.$hrc,[!0],!0)),(0,I.$Ps)(O.$8pc,$.$rtc,I.InstantiationType.Eager),(0,I.$Ps)(T.$xpc,T.$ypc,I.InstantiationType.Eager)}),define(Oe[287],Ne([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(be,e,v,I,P,O,A,T,$,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=We(T),$=We($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function n(g){self.fetch=async function(l,m){return l instanceof Request||S(String(l))&&(l=(await g(R.URI.parse(String(l)))).toString(!0)),d(l,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,m,p,h,E){(async()=>(S(m.toString())&&(m=(await g(R.URI.parse(m.toString()))).toString(!0)),super.open(l,m,p??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(l,m){if(/^file:/i.test(l.toString()))l=s.$Xg.uriToBrowserUri(R.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(k){function C(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const f=fetch.bind(self);self.fetch=function(F,N){return F instanceof Request?f(F,N):f(C(F),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,N,L,W,J){return super.open(F,C(N),L??!0,W,J)}};const w=importScripts.bind(self);self.importScripts=(...F)=>{w(...F.map(C))},w(k)}.toString()}('${l}'))`;m=m||{},m.name=`${name} -> ${m.name||T.$mc(l.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,m)}}else self.Worker=class extends A.$stc{constructor(g,l){super(a,g,{name:T.$mc(g.toString()),...l})}};const o=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const l=new MessageChannel,m=new I.$ke;let p=!1;a(l.port2,[l.port2]),l.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Me.wrap(new Uint8Array(E,0,E.byteLength));if((0,P.$An)(D,P.MessageType.Terminate)){p=!0,i("received terminate message from renderer");return}m.fire(D)},this.protocol={onMessage:m.event,send:h=>{if(!p){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);l.port1.postMessage(E,[E])}}}}}function u(g){return new Promise(l=>{const m=g.onMessage(p=>{m.dispose();const h=JSON.parse(p.toString());g.send((0,P.$zn)(P.MessageType.Initialized)),l({protocol:g,initData:h})});g.send((0,P.$zn)(P.MessageType.Ready))})}let i=g=>y();function r(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(l){r(l)&&u(g.protocol).then(m=>{$.mark("code/extHost/didWaitForInitData");const p=new O.$krc(m.protocol,m.initData,o,null,l.data);n(h=>p.asBrowserUri(h)),i=h=>p.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/89690b9d76a88fab676d26651134a1ffa4562732/core/vs/workbench/api/worker/extensionHostWorker.js.map
